/*
 ***********************************************************************************************************************
 *
 *  Copyright (c) 2019 Advanced Micro Devices, Inc. All Rights Reserved.
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in all
 *  copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 *
 **********************************************************************************************************************/

#pragma once

constexpr unsigned int ATC_ATS_CNTL__CREDITS_ATS_RPB_MASK       = 0x00003f00L;
constexpr unsigned int ATC_ATS_CNTL__DISABLE_ATC_MASK           = 0x00000001L;
constexpr unsigned int ATC_ATS_CNTL__DISABLE_PASID_MASK         = 0x00000004L;
constexpr unsigned int ATC_ATS_CNTL__DISABLE_PRI_MASK           = 0x00000002L;
constexpr unsigned int ATC_ATS_CNTL__INVALIDATION_LOG_KEEP_ORDER_MASK = 0x00100000L;
constexpr unsigned int ATC_ATS_CNTL__TRANS_EXE_RETURN_MASK      = 0x00c00000L;
constexpr unsigned int ATC_ATS_CNTL__TRANS_LOG_KEEP_ORDER_MASK  = 0x00200000L;
constexpr unsigned int ATC_ATS_DEFAULT_PAGE_LOW__DEFAULT_PAGE_MASK = 0xffffffffL;
constexpr unsigned int ATC_ATS_FAULT_CNTL__FAULT_CRASH_TABLE_MASK = 0x1ff00000L;
constexpr unsigned int ATC_ATS_FAULT_CNTL__FAULT_INTERRUPT_TABLE_MASK = 0x0007fc00L;
constexpr unsigned int ATC_ATS_FAULT_CNTL__FAULT_REGISTER_LOG_MASK = 0x000001ffL;
constexpr unsigned int ATC_ATS_FAULT_STATUS_ADDR__PAGE_ADDR_MASK = 0xffffffffL;
constexpr unsigned int ATC_ATS_FAULT_STATUS_INFO2__MMHUB_INV_VMID_MASK = 0x00003e00L;
constexpr unsigned int ATC_ATS_FAULT_STATUS_INFO2__VF_MASK      = 0x00000001L;
constexpr unsigned int ATC_ATS_FAULT_STATUS_INFO__EXTRA_INFO2_MASK = 0x00010000L;
constexpr unsigned int ATC_ATS_FAULT_STATUS_INFO__EXTRA_INFO_MASK = 0x00008000L;
constexpr unsigned int ATC_ATS_FAULT_STATUS_INFO__FAULT_TYPE_MASK = 0x000001ffL;
constexpr unsigned int ATC_ATS_FAULT_STATUS_INFO__INVALIDATION_MASK = 0x00020000L;
constexpr unsigned int ATC_ATS_FAULT_STATUS_INFO__PAGE_ADDR_HIGH_MASK = 0x0f000000L;
constexpr unsigned int ATC_ATS_FAULT_STATUS_INFO__PAGE_REQUEST_MASK = 0x00040000L;
constexpr unsigned int ATC_ATS_FAULT_STATUS_INFO__STATUS_MASK   = 0x00f80000L;
constexpr unsigned int ATC_ATS_FAULT_STATUS_INFO__VMID_MASK     = 0x00007c00L;
constexpr unsigned int ATC_ATS_GFX_ATCL2_STATUS__POWERED_DOWN_MASK = 0x00000001L;
constexpr unsigned int ATC_ATS_MMHUB_ATCL2_STATUS__POWERED_DOWN_MASK = 0x00000001L;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__ATS_INV_CFG_MODE_MASK = 0x00000006L;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__ATS_INV_HALT_THRESHOLD_MASK = 0x00000078L;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__ATS_INV_SELF_ACTIVATE_MASK = 0x00000001L;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_GFX_RDY_MODE_MASK = 0x00004000L;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_GFX_SDPVDCI_ORIGDATACKENRCV_MASK = 0x02000000L;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_GFX_SDPVDCI_ORIGDATACKEN_MASK = 0x01000000L;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_GFX_SDPVDCI_RDRSPCKENRCV_MASK = 0x00020000L;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_GFX_SDPVDCI_RDRSPCKEN_MASK = 0x00010000L;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_GFX_SDPVDCI_RDRSPDATACKENRCV_MASK = 0x00080000L;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_GFX_SDPVDCI_RDRSPDATACKEN_MASK = 0x00040000L;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_GFX_SDPVDCI_REQCKENRCV_MASK = 0x00800000L;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_GFX_SDPVDCI_REQCKEN_MASK = 0x00400000L;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_GFX_SDPVDCI_WRRSPCKENRCV_MASK = 0x00200000L;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_GFX_SDPVDCI_WRRSPCKEN_MASK = 0x00100000L;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_MMHUB_RDY_MODE_MASK = 0x00008000L;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_TRANS_HALT_THRESHOLD_MASK = 0x00001e00L;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_TRANS_PASSIVE_MODE_MASK = 0x00002000L;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_TRANS_QUICK_COMACK_MASK = 0x00000100L;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_TRANS_SELF_ACTIVATE_MASK = 0x00000080L;
constexpr unsigned int ATC_ATS_STATUS__BUSY_MASK                = 0x00000001L;
constexpr unsigned int ATC_ATS_STATUS__CRASHED_MASK             = 0x00000002L;
constexpr unsigned int ATC_ATS_STATUS__DEADLOCK_DETECTION_MASK  = 0x00000004L;
constexpr unsigned int ATC_ATS_STATUS__FLUSH_INVALIDATION_OUTSTANDING_MASK = 0x00000038L;
constexpr unsigned int ATC_ATS_STATUS__NONFLUSH_INVALIDATION_OUTSTANDING_MASK = 0x000001c0L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID0_MASK = 0x00000001L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID1_MASK = 0x00000002L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID2_MASK = 0x00000004L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID3_MASK = 0x00000008L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID4_MASK = 0x00000010L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID5_MASK = 0x00000020L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID6_MASK = 0x00000040L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID7_MASK = 0x00000080L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID8_MASK = 0x00000100L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID9_MASK = 0x00000200L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID10_MASK = 0x00000400L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID11_MASK = 0x00000800L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID12_MASK = 0x00001000L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID13_MASK = 0x00002000L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID14_MASK = 0x00004000L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID15_MASK = 0x00008000L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID0_MASK = 0x00000001L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID1_MASK = 0x00000002L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID2_MASK = 0x00000004L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID3_MASK = 0x00000008L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID4_MASK = 0x00000010L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID5_MASK = 0x00000020L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID6_MASK = 0x00000040L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID7_MASK = 0x00000080L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID8_MASK = 0x00000100L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID9_MASK = 0x00000200L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID10_MASK = 0x00000400L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID11_MASK = 0x00000800L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID12_MASK = 0x00001000L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID13_MASK = 0x00002000L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID14_MASK = 0x00004000L;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID15_MASK = 0x00008000L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID0_OUTSTANDING_MASK = 0x00000001L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID1_OUTSTANDING_MASK = 0x00000002L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID2_OUTSTANDING_MASK = 0x00000004L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID3_OUTSTANDING_MASK = 0x00000008L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID4_OUTSTANDING_MASK = 0x00000010L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID5_OUTSTANDING_MASK = 0x00000020L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID6_OUTSTANDING_MASK = 0x00000040L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID7_OUTSTANDING_MASK = 0x00000080L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID8_OUTSTANDING_MASK = 0x00000100L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID9_OUTSTANDING_MASK = 0x00000200L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID10_OUTSTANDING_MASK = 0x00000400L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID11_OUTSTANDING_MASK = 0x00000800L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID12_OUTSTANDING_MASK = 0x00001000L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID13_OUTSTANDING_MASK = 0x00002000L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID14_OUTSTANDING_MASK = 0x00004000L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID15_OUTSTANDING_MASK = 0x00008000L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID16_OUTSTANDING_MASK = 0x00010000L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID17_OUTSTANDING_MASK = 0x00020000L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID18_OUTSTANDING_MASK = 0x00040000L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID19_OUTSTANDING_MASK = 0x00080000L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID20_OUTSTANDING_MASK = 0x00100000L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID21_OUTSTANDING_MASK = 0x00200000L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID22_OUTSTANDING_MASK = 0x00400000L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID23_OUTSTANDING_MASK = 0x00800000L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID24_OUTSTANDING_MASK = 0x01000000L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID25_OUTSTANDING_MASK = 0x02000000L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID26_OUTSTANDING_MASK = 0x04000000L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID27_OUTSTANDING_MASK = 0x08000000L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID28_OUTSTANDING_MASK = 0x10000000L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID29_OUTSTANDING_MASK = 0x20000000L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID30_OUTSTANDING_MASK = 0x40000000L;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID31_OUTSTANDING_MASK = 0x80000000L;
constexpr unsigned int ATC_PERFCOUNTER0_CFG__CLEAR_MASK         = 0x20000000L;
constexpr unsigned int ATC_PERFCOUNTER0_CFG__ENABLE_MASK        = 0x10000000L;
constexpr unsigned int ATC_PERFCOUNTER0_CFG__PERF_MODE_MASK     = 0x0f000000L;
constexpr unsigned int ATC_PERFCOUNTER0_CFG__PERF_SEL_END_MASK  = 0x0000ff00L;
constexpr unsigned int ATC_PERFCOUNTER0_CFG__PERF_SEL_MASK      = 0x000000ffL;
constexpr unsigned int ATC_PERFCOUNTER1_CFG__CLEAR_MASK         = 0x20000000L;
constexpr unsigned int ATC_PERFCOUNTER1_CFG__ENABLE_MASK        = 0x10000000L;
constexpr unsigned int ATC_PERFCOUNTER1_CFG__PERF_MODE_MASK     = 0x0f000000L;
constexpr unsigned int ATC_PERFCOUNTER1_CFG__PERF_SEL_END_MASK  = 0x0000ff00L;
constexpr unsigned int ATC_PERFCOUNTER1_CFG__PERF_SEL_MASK      = 0x000000ffL;
constexpr unsigned int ATC_PERFCOUNTER2_CFG__CLEAR_MASK         = 0x20000000L;
constexpr unsigned int ATC_PERFCOUNTER2_CFG__ENABLE_MASK        = 0x10000000L;
constexpr unsigned int ATC_PERFCOUNTER2_CFG__PERF_MODE_MASK     = 0x0f000000L;
constexpr unsigned int ATC_PERFCOUNTER2_CFG__PERF_SEL_END_MASK  = 0x0000ff00L;
constexpr unsigned int ATC_PERFCOUNTER2_CFG__PERF_SEL_MASK      = 0x000000ffL;
constexpr unsigned int ATC_PERFCOUNTER3_CFG__CLEAR_MASK         = 0x20000000L;
constexpr unsigned int ATC_PERFCOUNTER3_CFG__ENABLE_MASK        = 0x10000000L;
constexpr unsigned int ATC_PERFCOUNTER3_CFG__PERF_MODE_MASK     = 0x0f000000L;
constexpr unsigned int ATC_PERFCOUNTER3_CFG__PERF_SEL_END_MASK  = 0x0000ff00L;
constexpr unsigned int ATC_PERFCOUNTER3_CFG__PERF_SEL_MASK      = 0x000000ffL;
constexpr unsigned int ATC_PERFCOUNTER_HI__COMPARE_VALUE_MASK   = 0xffff0000L;
constexpr unsigned int ATC_PERFCOUNTER_HI__COUNTER_HI_MASK      = 0x0000ffffL;
constexpr unsigned int ATC_PERFCOUNTER_LO__COUNTER_LO_MASK      = 0xffffffffL;
constexpr unsigned int ATC_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL_MASK = 0x02000000L;
constexpr unsigned int ATC_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY_MASK = 0x01000000L;
constexpr unsigned int ATC_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT_MASK = 0x0000000fL;
constexpr unsigned int ATC_PERFCOUNTER_RSLT_CNTL__START_TRIGGER_MASK = 0x0000ff00L;
constexpr unsigned int ATC_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE_MASK = 0x04000000L;
constexpr unsigned int ATC_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER_MASK = 0x00ff0000L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID0_MASK     = 0x00000001L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID1_MASK     = 0x00000002L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID2_MASK     = 0x00000004L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID3_MASK     = 0x00000008L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID4_MASK     = 0x00000010L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID5_MASK     = 0x00000020L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID6_MASK     = 0x00000040L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID7_MASK     = 0x00000080L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID8_MASK     = 0x00000100L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID9_MASK     = 0x00000200L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID10_MASK    = 0x00000400L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID11_MASK    = 0x00000800L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID12_MASK    = 0x00001000L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID13_MASK    = 0x00002000L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID14_MASK    = 0x00004000L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID15_MASK    = 0x00008000L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID16_MASK    = 0x00010000L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID17_MASK    = 0x00020000L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID18_MASK    = 0x00040000L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID19_MASK    = 0x00080000L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID20_MASK    = 0x00100000L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID21_MASK    = 0x00200000L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID22_MASK    = 0x00400000L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID23_MASK    = 0x00800000L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID24_MASK    = 0x01000000L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID25_MASK    = 0x02000000L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID26_MASK    = 0x04000000L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID27_MASK    = 0x08000000L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID28_MASK    = 0x10000000L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID29_MASK    = 0x20000000L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID30_MASK    = 0x40000000L;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID31_MASK    = 0x80000000L;
constexpr unsigned int ATC_VMID0_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID0_PASID_MAPPING__PASID_MASK      = 0x0000ffffL;
constexpr unsigned int ATC_VMID0_PASID_MAPPING__VALID_MASK      = 0x80000000L;
constexpr unsigned int ATC_VMID1_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID1_PASID_MAPPING__PASID_MASK      = 0x0000ffffL;
constexpr unsigned int ATC_VMID1_PASID_MAPPING__VALID_MASK      = 0x80000000L;
constexpr unsigned int ATC_VMID2_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID2_PASID_MAPPING__PASID_MASK      = 0x0000ffffL;
constexpr unsigned int ATC_VMID2_PASID_MAPPING__VALID_MASK      = 0x80000000L;
constexpr unsigned int ATC_VMID3_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID3_PASID_MAPPING__PASID_MASK      = 0x0000ffffL;
constexpr unsigned int ATC_VMID3_PASID_MAPPING__VALID_MASK      = 0x80000000L;
constexpr unsigned int ATC_VMID4_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID4_PASID_MAPPING__PASID_MASK      = 0x0000ffffL;
constexpr unsigned int ATC_VMID4_PASID_MAPPING__VALID_MASK      = 0x80000000L;
constexpr unsigned int ATC_VMID5_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID5_PASID_MAPPING__PASID_MASK      = 0x0000ffffL;
constexpr unsigned int ATC_VMID5_PASID_MAPPING__VALID_MASK      = 0x80000000L;
constexpr unsigned int ATC_VMID6_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID6_PASID_MAPPING__PASID_MASK      = 0x0000ffffL;
constexpr unsigned int ATC_VMID6_PASID_MAPPING__VALID_MASK      = 0x80000000L;
constexpr unsigned int ATC_VMID7_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID7_PASID_MAPPING__PASID_MASK      = 0x0000ffffL;
constexpr unsigned int ATC_VMID7_PASID_MAPPING__VALID_MASK      = 0x80000000L;
constexpr unsigned int ATC_VMID8_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID8_PASID_MAPPING__PASID_MASK      = 0x0000ffffL;
constexpr unsigned int ATC_VMID8_PASID_MAPPING__VALID_MASK      = 0x80000000L;
constexpr unsigned int ATC_VMID9_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID9_PASID_MAPPING__PASID_MASK      = 0x0000ffffL;
constexpr unsigned int ATC_VMID9_PASID_MAPPING__VALID_MASK      = 0x80000000L;
constexpr unsigned int ATC_VMID10_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID10_PASID_MAPPING__PASID_MASK     = 0x0000ffffL;
constexpr unsigned int ATC_VMID10_PASID_MAPPING__VALID_MASK     = 0x80000000L;
constexpr unsigned int ATC_VMID11_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID11_PASID_MAPPING__PASID_MASK     = 0x0000ffffL;
constexpr unsigned int ATC_VMID11_PASID_MAPPING__VALID_MASK     = 0x80000000L;
constexpr unsigned int ATC_VMID12_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID12_PASID_MAPPING__PASID_MASK     = 0x0000ffffL;
constexpr unsigned int ATC_VMID12_PASID_MAPPING__VALID_MASK     = 0x80000000L;
constexpr unsigned int ATC_VMID13_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID13_PASID_MAPPING__PASID_MASK     = 0x0000ffffL;
constexpr unsigned int ATC_VMID13_PASID_MAPPING__VALID_MASK     = 0x80000000L;
constexpr unsigned int ATC_VMID14_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID14_PASID_MAPPING__PASID_MASK     = 0x0000ffffL;
constexpr unsigned int ATC_VMID14_PASID_MAPPING__VALID_MASK     = 0x80000000L;
constexpr unsigned int ATC_VMID15_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID15_PASID_MAPPING__PASID_MASK     = 0x0000ffffL;
constexpr unsigned int ATC_VMID15_PASID_MAPPING__VALID_MASK     = 0x80000000L;
constexpr unsigned int ATC_VMID16_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID16_PASID_MAPPING__PASID_MASK     = 0x0000ffffL;
constexpr unsigned int ATC_VMID16_PASID_MAPPING__VALID_MASK     = 0x80000000L;
constexpr unsigned int ATC_VMID17_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID17_PASID_MAPPING__PASID_MASK     = 0x0000ffffL;
constexpr unsigned int ATC_VMID17_PASID_MAPPING__VALID_MASK     = 0x80000000L;
constexpr unsigned int ATC_VMID18_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID18_PASID_MAPPING__PASID_MASK     = 0x0000ffffL;
constexpr unsigned int ATC_VMID18_PASID_MAPPING__VALID_MASK     = 0x80000000L;
constexpr unsigned int ATC_VMID19_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID19_PASID_MAPPING__PASID_MASK     = 0x0000ffffL;
constexpr unsigned int ATC_VMID19_PASID_MAPPING__VALID_MASK     = 0x80000000L;
constexpr unsigned int ATC_VMID20_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID20_PASID_MAPPING__PASID_MASK     = 0x0000ffffL;
constexpr unsigned int ATC_VMID20_PASID_MAPPING__VALID_MASK     = 0x80000000L;
constexpr unsigned int ATC_VMID21_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID21_PASID_MAPPING__PASID_MASK     = 0x0000ffffL;
constexpr unsigned int ATC_VMID21_PASID_MAPPING__VALID_MASK     = 0x80000000L;
constexpr unsigned int ATC_VMID22_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID22_PASID_MAPPING__PASID_MASK     = 0x0000ffffL;
constexpr unsigned int ATC_VMID22_PASID_MAPPING__VALID_MASK     = 0x80000000L;
constexpr unsigned int ATC_VMID23_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID23_PASID_MAPPING__PASID_MASK     = 0x0000ffffL;
constexpr unsigned int ATC_VMID23_PASID_MAPPING__VALID_MASK     = 0x80000000L;
constexpr unsigned int ATC_VMID24_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID24_PASID_MAPPING__PASID_MASK     = 0x0000ffffL;
constexpr unsigned int ATC_VMID24_PASID_MAPPING__VALID_MASK     = 0x80000000L;
constexpr unsigned int ATC_VMID25_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID25_PASID_MAPPING__PASID_MASK     = 0x0000ffffL;
constexpr unsigned int ATC_VMID25_PASID_MAPPING__VALID_MASK     = 0x80000000L;
constexpr unsigned int ATC_VMID26_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID26_PASID_MAPPING__PASID_MASK     = 0x0000ffffL;
constexpr unsigned int ATC_VMID26_PASID_MAPPING__VALID_MASK     = 0x80000000L;
constexpr unsigned int ATC_VMID27_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID27_PASID_MAPPING__PASID_MASK     = 0x0000ffffL;
constexpr unsigned int ATC_VMID27_PASID_MAPPING__VALID_MASK     = 0x80000000L;
constexpr unsigned int ATC_VMID28_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID28_PASID_MAPPING__PASID_MASK     = 0x0000ffffL;
constexpr unsigned int ATC_VMID28_PASID_MAPPING__VALID_MASK     = 0x80000000L;
constexpr unsigned int ATC_VMID29_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID29_PASID_MAPPING__PASID_MASK     = 0x0000ffffL;
constexpr unsigned int ATC_VMID29_PASID_MAPPING__VALID_MASK     = 0x80000000L;
constexpr unsigned int ATC_VMID30_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID30_PASID_MAPPING__PASID_MASK     = 0x0000ffffL;
constexpr unsigned int ATC_VMID30_PASID_MAPPING__VALID_MASK     = 0x80000000L;
constexpr unsigned int ATC_VMID31_PASID_MAPPING__NO_INVALIDATION_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID31_PASID_MAPPING__PASID_MASK     = 0x0000ffffL;
constexpr unsigned int ATC_VMID31_PASID_MAPPING__VALID_MASK     = 0x80000000L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID0_REMAPPING_FINISHED_MASK = 0x00000001L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID1_REMAPPING_FINISHED_MASK = 0x00000002L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID2_REMAPPING_FINISHED_MASK = 0x00000004L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID3_REMAPPING_FINISHED_MASK = 0x00000008L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID4_REMAPPING_FINISHED_MASK = 0x00000010L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID5_REMAPPING_FINISHED_MASK = 0x00000020L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID6_REMAPPING_FINISHED_MASK = 0x00000040L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID7_REMAPPING_FINISHED_MASK = 0x00000080L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID8_REMAPPING_FINISHED_MASK = 0x00000100L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID9_REMAPPING_FINISHED_MASK = 0x00000200L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID10_REMAPPING_FINISHED_MASK = 0x00000400L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID11_REMAPPING_FINISHED_MASK = 0x00000800L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID12_REMAPPING_FINISHED_MASK = 0x00001000L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID13_REMAPPING_FINISHED_MASK = 0x00002000L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID14_REMAPPING_FINISHED_MASK = 0x00004000L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID15_REMAPPING_FINISHED_MASK = 0x00008000L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID16_REMAPPING_FINISHED_MASK = 0x00010000L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID17_REMAPPING_FINISHED_MASK = 0x00020000L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID18_REMAPPING_FINISHED_MASK = 0x00040000L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID19_REMAPPING_FINISHED_MASK = 0x00080000L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID20_REMAPPING_FINISHED_MASK = 0x00100000L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID21_REMAPPING_FINISHED_MASK = 0x00200000L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID22_REMAPPING_FINISHED_MASK = 0x00400000L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID23_REMAPPING_FINISHED_MASK = 0x00800000L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID24_REMAPPING_FINISHED_MASK = 0x01000000L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID25_REMAPPING_FINISHED_MASK = 0x02000000L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID26_REMAPPING_FINISHED_MASK = 0x04000000L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID27_REMAPPING_FINISHED_MASK = 0x08000000L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID28_REMAPPING_FINISHED_MASK = 0x10000000L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID29_REMAPPING_FINISHED_MASK = 0x20000000L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID30_REMAPPING_FINISHED_MASK = 0x40000000L;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID31_REMAPPING_FINISHED_MASK = 0x80000000L;
constexpr unsigned int ATS_IH_CREDIT__CREDIT_VALUE_MASK         = 0x00000003L;
constexpr unsigned int ATS_IH_CREDIT__IH_CLIENT_ID_MASK         = 0x00ff0000L;
constexpr unsigned int BCI_DEBUG_READ__DATA_MASK                = 0x00ffffffL;
constexpr unsigned int CB_BLEND0_CONTROL__ALPHA_COMB_FCN_MASK   = 0x00e00000L;
constexpr unsigned int CB_BLEND0_CONTROL__ALPHA_DESTBLEND_MASK  = 0x1f000000L;
constexpr unsigned int CB_BLEND0_CONTROL__ALPHA_SRCBLEND_MASK   = 0x001f0000L;
constexpr unsigned int CB_BLEND0_CONTROL__COLOR_COMB_FCN_MASK   = 0x000000e0L;
constexpr unsigned int CB_BLEND0_CONTROL__COLOR_DESTBLEND_MASK  = 0x00001f00L;
constexpr unsigned int CB_BLEND0_CONTROL__COLOR_SRCBLEND_MASK   = 0x0000001fL;
constexpr unsigned int CB_BLEND0_CONTROL__DISABLE_ROP3_MASK     = 0x80000000L;
constexpr unsigned int CB_BLEND0_CONTROL__ENABLE_MASK           = 0x40000000L;
constexpr unsigned int CB_BLEND0_CONTROL__SEPARATE_ALPHA_BLEND_MASK = 0x20000000L;
constexpr unsigned int CB_BLEND1_CONTROL__ALPHA_COMB_FCN_MASK   = 0x00e00000L;
constexpr unsigned int CB_BLEND1_CONTROL__ALPHA_DESTBLEND_MASK  = 0x1f000000L;
constexpr unsigned int CB_BLEND1_CONTROL__ALPHA_SRCBLEND_MASK   = 0x001f0000L;
constexpr unsigned int CB_BLEND1_CONTROL__COLOR_COMB_FCN_MASK   = 0x000000e0L;
constexpr unsigned int CB_BLEND1_CONTROL__COLOR_DESTBLEND_MASK  = 0x00001f00L;
constexpr unsigned int CB_BLEND1_CONTROL__COLOR_SRCBLEND_MASK   = 0x0000001fL;
constexpr unsigned int CB_BLEND1_CONTROL__DISABLE_ROP3_MASK     = 0x80000000L;
constexpr unsigned int CB_BLEND1_CONTROL__ENABLE_MASK           = 0x40000000L;
constexpr unsigned int CB_BLEND1_CONTROL__SEPARATE_ALPHA_BLEND_MASK = 0x20000000L;
constexpr unsigned int CB_BLEND2_CONTROL__ALPHA_COMB_FCN_MASK   = 0x00e00000L;
constexpr unsigned int CB_BLEND2_CONTROL__ALPHA_DESTBLEND_MASK  = 0x1f000000L;
constexpr unsigned int CB_BLEND2_CONTROL__ALPHA_SRCBLEND_MASK   = 0x001f0000L;
constexpr unsigned int CB_BLEND2_CONTROL__COLOR_COMB_FCN_MASK   = 0x000000e0L;
constexpr unsigned int CB_BLEND2_CONTROL__COLOR_DESTBLEND_MASK  = 0x00001f00L;
constexpr unsigned int CB_BLEND2_CONTROL__COLOR_SRCBLEND_MASK   = 0x0000001fL;
constexpr unsigned int CB_BLEND2_CONTROL__DISABLE_ROP3_MASK     = 0x80000000L;
constexpr unsigned int CB_BLEND2_CONTROL__ENABLE_MASK           = 0x40000000L;
constexpr unsigned int CB_BLEND2_CONTROL__SEPARATE_ALPHA_BLEND_MASK = 0x20000000L;
constexpr unsigned int CB_BLEND3_CONTROL__ALPHA_COMB_FCN_MASK   = 0x00e00000L;
constexpr unsigned int CB_BLEND3_CONTROL__ALPHA_DESTBLEND_MASK  = 0x1f000000L;
constexpr unsigned int CB_BLEND3_CONTROL__ALPHA_SRCBLEND_MASK   = 0x001f0000L;
constexpr unsigned int CB_BLEND3_CONTROL__COLOR_COMB_FCN_MASK   = 0x000000e0L;
constexpr unsigned int CB_BLEND3_CONTROL__COLOR_DESTBLEND_MASK  = 0x00001f00L;
constexpr unsigned int CB_BLEND3_CONTROL__COLOR_SRCBLEND_MASK   = 0x0000001fL;
constexpr unsigned int CB_BLEND3_CONTROL__DISABLE_ROP3_MASK     = 0x80000000L;
constexpr unsigned int CB_BLEND3_CONTROL__ENABLE_MASK           = 0x40000000L;
constexpr unsigned int CB_BLEND3_CONTROL__SEPARATE_ALPHA_BLEND_MASK = 0x20000000L;
constexpr unsigned int CB_BLEND4_CONTROL__ALPHA_COMB_FCN_MASK   = 0x00e00000L;
constexpr unsigned int CB_BLEND4_CONTROL__ALPHA_DESTBLEND_MASK  = 0x1f000000L;
constexpr unsigned int CB_BLEND4_CONTROL__ALPHA_SRCBLEND_MASK   = 0x001f0000L;
constexpr unsigned int CB_BLEND4_CONTROL__COLOR_COMB_FCN_MASK   = 0x000000e0L;
constexpr unsigned int CB_BLEND4_CONTROL__COLOR_DESTBLEND_MASK  = 0x00001f00L;
constexpr unsigned int CB_BLEND4_CONTROL__COLOR_SRCBLEND_MASK   = 0x0000001fL;
constexpr unsigned int CB_BLEND4_CONTROL__DISABLE_ROP3_MASK     = 0x80000000L;
constexpr unsigned int CB_BLEND4_CONTROL__ENABLE_MASK           = 0x40000000L;
constexpr unsigned int CB_BLEND4_CONTROL__SEPARATE_ALPHA_BLEND_MASK = 0x20000000L;
constexpr unsigned int CB_BLEND5_CONTROL__ALPHA_COMB_FCN_MASK   = 0x00e00000L;
constexpr unsigned int CB_BLEND5_CONTROL__ALPHA_DESTBLEND_MASK  = 0x1f000000L;
constexpr unsigned int CB_BLEND5_CONTROL__ALPHA_SRCBLEND_MASK   = 0x001f0000L;
constexpr unsigned int CB_BLEND5_CONTROL__COLOR_COMB_FCN_MASK   = 0x000000e0L;
constexpr unsigned int CB_BLEND5_CONTROL__COLOR_DESTBLEND_MASK  = 0x00001f00L;
constexpr unsigned int CB_BLEND5_CONTROL__COLOR_SRCBLEND_MASK   = 0x0000001fL;
constexpr unsigned int CB_BLEND5_CONTROL__DISABLE_ROP3_MASK     = 0x80000000L;
constexpr unsigned int CB_BLEND5_CONTROL__ENABLE_MASK           = 0x40000000L;
constexpr unsigned int CB_BLEND5_CONTROL__SEPARATE_ALPHA_BLEND_MASK = 0x20000000L;
constexpr unsigned int CB_BLEND6_CONTROL__ALPHA_COMB_FCN_MASK   = 0x00e00000L;
constexpr unsigned int CB_BLEND6_CONTROL__ALPHA_DESTBLEND_MASK  = 0x1f000000L;
constexpr unsigned int CB_BLEND6_CONTROL__ALPHA_SRCBLEND_MASK   = 0x001f0000L;
constexpr unsigned int CB_BLEND6_CONTROL__COLOR_COMB_FCN_MASK   = 0x000000e0L;
constexpr unsigned int CB_BLEND6_CONTROL__COLOR_DESTBLEND_MASK  = 0x00001f00L;
constexpr unsigned int CB_BLEND6_CONTROL__COLOR_SRCBLEND_MASK   = 0x0000001fL;
constexpr unsigned int CB_BLEND6_CONTROL__DISABLE_ROP3_MASK     = 0x80000000L;
constexpr unsigned int CB_BLEND6_CONTROL__ENABLE_MASK           = 0x40000000L;
constexpr unsigned int CB_BLEND6_CONTROL__SEPARATE_ALPHA_BLEND_MASK = 0x20000000L;
constexpr unsigned int CB_BLEND7_CONTROL__ALPHA_COMB_FCN_MASK   = 0x00e00000L;
constexpr unsigned int CB_BLEND7_CONTROL__ALPHA_DESTBLEND_MASK  = 0x1f000000L;
constexpr unsigned int CB_BLEND7_CONTROL__ALPHA_SRCBLEND_MASK   = 0x001f0000L;
constexpr unsigned int CB_BLEND7_CONTROL__COLOR_COMB_FCN_MASK   = 0x000000e0L;
constexpr unsigned int CB_BLEND7_CONTROL__COLOR_DESTBLEND_MASK  = 0x00001f00L;
constexpr unsigned int CB_BLEND7_CONTROL__COLOR_SRCBLEND_MASK   = 0x0000001fL;
constexpr unsigned int CB_BLEND7_CONTROL__DISABLE_ROP3_MASK     = 0x80000000L;
constexpr unsigned int CB_BLEND7_CONTROL__ENABLE_MASK           = 0x40000000L;
constexpr unsigned int CB_BLEND7_CONTROL__SEPARATE_ALPHA_BLEND_MASK = 0x20000000L;
constexpr unsigned int CB_BLEND_ALPHA__BLEND_ALPHA_MASK         = 0xffffffffL;
constexpr unsigned int CB_BLEND_BLUE__BLEND_BLUE_MASK           = 0xffffffffL;
constexpr unsigned int CB_BLEND_GREEN__BLEND_GREEN_MASK         = 0xffffffffL;
constexpr unsigned int CB_BLEND_RED__BLEND_RED_MASK             = 0xffffffffL;
constexpr unsigned int CB_CGTT_SCLK_CTRL__OFF_HYSTERESIS_MASK   = 0x00000ff0L;
constexpr unsigned int CB_CGTT_SCLK_CTRL__ON_DELAY_MASK         = 0x0000000fL;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_OVERRIDE0_MASK   = 0x80000000L;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_OVERRIDE1_MASK   = 0x40000000L;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_OVERRIDE2_MASK   = 0x20000000L;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_OVERRIDE3_MASK   = 0x10000000L;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_OVERRIDE4_MASK   = 0x08000000L;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_OVERRIDE5_MASK   = 0x04000000L;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_OVERRIDE6_MASK   = 0x02000000L;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_OVERRIDE7_MASK   = 0x01000000L;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE0_MASK = 0x00800000L;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE1_MASK = 0x00400000L;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE2_MASK = 0x00200000L;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE3_MASK = 0x00100000L;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE4_MASK = 0x00080000L;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE5_MASK = 0x00040000L;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE6_MASK = 0x00020000L;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE7_MASK = 0x00010000L;
constexpr unsigned int CB_COLOR0_ATTRIB2__MAX_MIP_MASK          = 0xf0000000L;
constexpr unsigned int CB_COLOR0_ATTRIB2__MIP0_HEIGHT_MASK      = 0x00003fffL;
constexpr unsigned int CB_COLOR0_ATTRIB2__MIP0_WIDTH_MASK       = 0x0fffc000L;
constexpr unsigned int CB_COLOR0_ATTRIB__FORCE_DST_ALPHA_1_MASK = 0x00020000L;
constexpr unsigned int CB_COLOR0_ATTRIB__NUM_FRAGMENTS_MASK     = 0x00018000L;
constexpr unsigned int CB_COLOR0_ATTRIB__NUM_SAMPLES_MASK       = 0x00007000L;
constexpr unsigned int CB_COLOR0_BASE_EXT__BASE_256B_MASK       = 0x000000ffL;
constexpr unsigned int CB_COLOR0_BASE__BASE_256B_MASK           = 0xffffffffL;
constexpr unsigned int CB_COLOR0_CLEAR_WORD0__CLEAR_WORD0_MASK  = 0xffffffffL;
constexpr unsigned int CB_COLOR0_CLEAR_WORD1__CLEAR_WORD1_MASK  = 0xffffffffL;
constexpr unsigned int CB_COLOR0_CMASK_BASE_EXT__BASE_256B_MASK = 0x000000ffL;
constexpr unsigned int CB_COLOR0_CMASK__BASE_256B_MASK          = 0xffffffffL;
constexpr unsigned int CB_COLOR0_DCC_BASE_EXT__BASE_256B_MASK   = 0x000000ffL;
constexpr unsigned int CB_COLOR0_DCC_BASE__BASE_256B_MASK       = 0xffffffffL;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__COLOR_TRANSFORM_MASK = 0x00000180L;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__INDEPENDENT_64B_BLOCKS_MASK = 0x00000200L;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__KEY_CLEAR_ENABLE_MASK = 0x00000002L;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__LOSSY_ALPHA_PRECISION_MASK = 0x0003c000L;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__LOSSY_RGB_PRECISION_MASK = 0x00003c00L;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE_MASK = 0x00000060L;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE_MASK = 0x0000000cL;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__MIN_COMPRESSED_BLOCK_SIZE_MASK = 0x00000010L;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE_MASK = 0x00000001L;
constexpr unsigned int CB_COLOR0_FMASK_BASE_EXT__BASE_256B_MASK = 0x000000ffL;
constexpr unsigned int CB_COLOR0_FMASK__BASE_256B_MASK          = 0xffffffffL;
constexpr unsigned int CB_COLOR0_INFO__BLEND_BYPASS_MASK        = 0x00010000L;
constexpr unsigned int CB_COLOR0_INFO__BLEND_CLAMP_MASK         = 0x00008000L;
constexpr unsigned int CB_COLOR0_INFO__BLEND_OPT_DISCARD_PIXEL_MASK = 0x03800000L;
constexpr unsigned int CB_COLOR0_INFO__BLEND_OPT_DONT_RD_DST_MASK = 0x00700000L;
constexpr unsigned int CB_COLOR0_INFO__CMASK_ADDR_TYPE_MASK     = 0x60000000L;
constexpr unsigned int CB_COLOR0_INFO__COMPRESSION_MASK         = 0x00004000L;
constexpr unsigned int CB_COLOR0_INFO__COMP_SWAP_MASK           = 0x00001800L;
constexpr unsigned int CB_COLOR0_INFO__DCC_ENABLE_MASK          = 0x10000000L;
constexpr unsigned int CB_COLOR0_INFO__ENDIAN_MASK              = 0x00000003L;
constexpr unsigned int CB_COLOR0_INFO__FAST_CLEAR_MASK          = 0x00002000L;
constexpr unsigned int CB_COLOR0_INFO__FMASK_COMPRESSION_DISABLE_MASK = 0x04000000L;
constexpr unsigned int CB_COLOR0_INFO__FMASK_COMPRESS_1FRAG_ONLY_MASK = 0x08000000L;
constexpr unsigned int CB_COLOR0_INFO__FORMAT_MASK              = 0x0000007cL;
constexpr unsigned int CB_COLOR0_INFO__NUMBER_TYPE_MASK         = 0x00000700L;
constexpr unsigned int CB_COLOR0_INFO__ROUND_MODE_MASK          = 0x00040000L;
constexpr unsigned int CB_COLOR0_INFO__SIMPLE_FLOAT_MASK        = 0x00020000L;
constexpr unsigned int CB_COLOR1_ATTRIB2__MAX_MIP_MASK          = 0xf0000000L;
constexpr unsigned int CB_COLOR1_ATTRIB2__MIP0_HEIGHT_MASK      = 0x00003fffL;
constexpr unsigned int CB_COLOR1_ATTRIB2__MIP0_WIDTH_MASK       = 0x0fffc000L;
constexpr unsigned int CB_COLOR1_ATTRIB__FORCE_DST_ALPHA_1_MASK = 0x00020000L;
constexpr unsigned int CB_COLOR1_ATTRIB__NUM_FRAGMENTS_MASK     = 0x00018000L;
constexpr unsigned int CB_COLOR1_ATTRIB__NUM_SAMPLES_MASK       = 0x00007000L;
constexpr unsigned int CB_COLOR1_BASE_EXT__BASE_256B_MASK       = 0x000000ffL;
constexpr unsigned int CB_COLOR1_BASE__BASE_256B_MASK           = 0xffffffffL;
constexpr unsigned int CB_COLOR1_CLEAR_WORD0__CLEAR_WORD0_MASK  = 0xffffffffL;
constexpr unsigned int CB_COLOR1_CLEAR_WORD1__CLEAR_WORD1_MASK  = 0xffffffffL;
constexpr unsigned int CB_COLOR1_CMASK_BASE_EXT__BASE_256B_MASK = 0x000000ffL;
constexpr unsigned int CB_COLOR1_CMASK__BASE_256B_MASK          = 0xffffffffL;
constexpr unsigned int CB_COLOR1_DCC_BASE_EXT__BASE_256B_MASK   = 0x000000ffL;
constexpr unsigned int CB_COLOR1_DCC_BASE__BASE_256B_MASK       = 0xffffffffL;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__COLOR_TRANSFORM_MASK = 0x00000180L;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__INDEPENDENT_64B_BLOCKS_MASK = 0x00000200L;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__KEY_CLEAR_ENABLE_MASK = 0x00000002L;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__LOSSY_ALPHA_PRECISION_MASK = 0x0003c000L;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__LOSSY_RGB_PRECISION_MASK = 0x00003c00L;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE_MASK = 0x00000060L;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE_MASK = 0x0000000cL;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__MIN_COMPRESSED_BLOCK_SIZE_MASK = 0x00000010L;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE_MASK = 0x00000001L;
constexpr unsigned int CB_COLOR1_FMASK_BASE_EXT__BASE_256B_MASK = 0x000000ffL;
constexpr unsigned int CB_COLOR1_FMASK__BASE_256B_MASK          = 0xffffffffL;
constexpr unsigned int CB_COLOR1_INFO__BLEND_BYPASS_MASK        = 0x00010000L;
constexpr unsigned int CB_COLOR1_INFO__BLEND_CLAMP_MASK         = 0x00008000L;
constexpr unsigned int CB_COLOR1_INFO__BLEND_OPT_DISCARD_PIXEL_MASK = 0x03800000L;
constexpr unsigned int CB_COLOR1_INFO__BLEND_OPT_DONT_RD_DST_MASK = 0x00700000L;
constexpr unsigned int CB_COLOR1_INFO__CMASK_ADDR_TYPE_MASK     = 0x60000000L;
constexpr unsigned int CB_COLOR1_INFO__COMPRESSION_MASK         = 0x00004000L;
constexpr unsigned int CB_COLOR1_INFO__COMP_SWAP_MASK           = 0x00001800L;
constexpr unsigned int CB_COLOR1_INFO__DCC_ENABLE_MASK          = 0x10000000L;
constexpr unsigned int CB_COLOR1_INFO__ENDIAN_MASK              = 0x00000003L;
constexpr unsigned int CB_COLOR1_INFO__FAST_CLEAR_MASK          = 0x00002000L;
constexpr unsigned int CB_COLOR1_INFO__FMASK_COMPRESSION_DISABLE_MASK = 0x04000000L;
constexpr unsigned int CB_COLOR1_INFO__FMASK_COMPRESS_1FRAG_ONLY_MASK = 0x08000000L;
constexpr unsigned int CB_COLOR1_INFO__FORMAT_MASK              = 0x0000007cL;
constexpr unsigned int CB_COLOR1_INFO__NUMBER_TYPE_MASK         = 0x00000700L;
constexpr unsigned int CB_COLOR1_INFO__ROUND_MODE_MASK          = 0x00040000L;
constexpr unsigned int CB_COLOR1_INFO__SIMPLE_FLOAT_MASK        = 0x00020000L;
constexpr unsigned int CB_COLOR2_ATTRIB2__MAX_MIP_MASK          = 0xf0000000L;
constexpr unsigned int CB_COLOR2_ATTRIB2__MIP0_HEIGHT_MASK      = 0x00003fffL;
constexpr unsigned int CB_COLOR2_ATTRIB2__MIP0_WIDTH_MASK       = 0x0fffc000L;
constexpr unsigned int CB_COLOR2_ATTRIB__FORCE_DST_ALPHA_1_MASK = 0x00020000L;
constexpr unsigned int CB_COLOR2_ATTRIB__NUM_FRAGMENTS_MASK     = 0x00018000L;
constexpr unsigned int CB_COLOR2_ATTRIB__NUM_SAMPLES_MASK       = 0x00007000L;
constexpr unsigned int CB_COLOR2_BASE_EXT__BASE_256B_MASK       = 0x000000ffL;
constexpr unsigned int CB_COLOR2_BASE__BASE_256B_MASK           = 0xffffffffL;
constexpr unsigned int CB_COLOR2_CLEAR_WORD0__CLEAR_WORD0_MASK  = 0xffffffffL;
constexpr unsigned int CB_COLOR2_CLEAR_WORD1__CLEAR_WORD1_MASK  = 0xffffffffL;
constexpr unsigned int CB_COLOR2_CMASK_BASE_EXT__BASE_256B_MASK = 0x000000ffL;
constexpr unsigned int CB_COLOR2_CMASK__BASE_256B_MASK          = 0xffffffffL;
constexpr unsigned int CB_COLOR2_DCC_BASE_EXT__BASE_256B_MASK   = 0x000000ffL;
constexpr unsigned int CB_COLOR2_DCC_BASE__BASE_256B_MASK       = 0xffffffffL;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__COLOR_TRANSFORM_MASK = 0x00000180L;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__INDEPENDENT_64B_BLOCKS_MASK = 0x00000200L;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__KEY_CLEAR_ENABLE_MASK = 0x00000002L;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__LOSSY_ALPHA_PRECISION_MASK = 0x0003c000L;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__LOSSY_RGB_PRECISION_MASK = 0x00003c00L;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE_MASK = 0x00000060L;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE_MASK = 0x0000000cL;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__MIN_COMPRESSED_BLOCK_SIZE_MASK = 0x00000010L;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE_MASK = 0x00000001L;
constexpr unsigned int CB_COLOR2_FMASK_BASE_EXT__BASE_256B_MASK = 0x000000ffL;
constexpr unsigned int CB_COLOR2_FMASK__BASE_256B_MASK          = 0xffffffffL;
constexpr unsigned int CB_COLOR2_INFO__BLEND_BYPASS_MASK        = 0x00010000L;
constexpr unsigned int CB_COLOR2_INFO__BLEND_CLAMP_MASK         = 0x00008000L;
constexpr unsigned int CB_COLOR2_INFO__BLEND_OPT_DISCARD_PIXEL_MASK = 0x03800000L;
constexpr unsigned int CB_COLOR2_INFO__BLEND_OPT_DONT_RD_DST_MASK = 0x00700000L;
constexpr unsigned int CB_COLOR2_INFO__CMASK_ADDR_TYPE_MASK     = 0x60000000L;
constexpr unsigned int CB_COLOR2_INFO__COMPRESSION_MASK         = 0x00004000L;
constexpr unsigned int CB_COLOR2_INFO__COMP_SWAP_MASK           = 0x00001800L;
constexpr unsigned int CB_COLOR2_INFO__DCC_ENABLE_MASK          = 0x10000000L;
constexpr unsigned int CB_COLOR2_INFO__ENDIAN_MASK              = 0x00000003L;
constexpr unsigned int CB_COLOR2_INFO__FAST_CLEAR_MASK          = 0x00002000L;
constexpr unsigned int CB_COLOR2_INFO__FMASK_COMPRESSION_DISABLE_MASK = 0x04000000L;
constexpr unsigned int CB_COLOR2_INFO__FMASK_COMPRESS_1FRAG_ONLY_MASK = 0x08000000L;
constexpr unsigned int CB_COLOR2_INFO__FORMAT_MASK              = 0x0000007cL;
constexpr unsigned int CB_COLOR2_INFO__NUMBER_TYPE_MASK         = 0x00000700L;
constexpr unsigned int CB_COLOR2_INFO__ROUND_MODE_MASK          = 0x00040000L;
constexpr unsigned int CB_COLOR2_INFO__SIMPLE_FLOAT_MASK        = 0x00020000L;
constexpr unsigned int CB_COLOR3_ATTRIB2__MAX_MIP_MASK          = 0xf0000000L;
constexpr unsigned int CB_COLOR3_ATTRIB2__MIP0_HEIGHT_MASK      = 0x00003fffL;
constexpr unsigned int CB_COLOR3_ATTRIB2__MIP0_WIDTH_MASK       = 0x0fffc000L;
constexpr unsigned int CB_COLOR3_ATTRIB__FORCE_DST_ALPHA_1_MASK = 0x00020000L;
constexpr unsigned int CB_COLOR3_ATTRIB__NUM_FRAGMENTS_MASK     = 0x00018000L;
constexpr unsigned int CB_COLOR3_ATTRIB__NUM_SAMPLES_MASK       = 0x00007000L;
constexpr unsigned int CB_COLOR3_BASE_EXT__BASE_256B_MASK       = 0x000000ffL;
constexpr unsigned int CB_COLOR3_BASE__BASE_256B_MASK           = 0xffffffffL;
constexpr unsigned int CB_COLOR3_CLEAR_WORD0__CLEAR_WORD0_MASK  = 0xffffffffL;
constexpr unsigned int CB_COLOR3_CLEAR_WORD1__CLEAR_WORD1_MASK  = 0xffffffffL;
constexpr unsigned int CB_COLOR3_CMASK_BASE_EXT__BASE_256B_MASK = 0x000000ffL;
constexpr unsigned int CB_COLOR3_CMASK__BASE_256B_MASK          = 0xffffffffL;
constexpr unsigned int CB_COLOR3_DCC_BASE_EXT__BASE_256B_MASK   = 0x000000ffL;
constexpr unsigned int CB_COLOR3_DCC_BASE__BASE_256B_MASK       = 0xffffffffL;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__COLOR_TRANSFORM_MASK = 0x00000180L;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__INDEPENDENT_64B_BLOCKS_MASK = 0x00000200L;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__KEY_CLEAR_ENABLE_MASK = 0x00000002L;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__LOSSY_ALPHA_PRECISION_MASK = 0x0003c000L;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__LOSSY_RGB_PRECISION_MASK = 0x00003c00L;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE_MASK = 0x00000060L;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE_MASK = 0x0000000cL;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__MIN_COMPRESSED_BLOCK_SIZE_MASK = 0x00000010L;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE_MASK = 0x00000001L;
constexpr unsigned int CB_COLOR3_FMASK_BASE_EXT__BASE_256B_MASK = 0x000000ffL;
constexpr unsigned int CB_COLOR3_FMASK__BASE_256B_MASK          = 0xffffffffL;
constexpr unsigned int CB_COLOR3_INFO__BLEND_BYPASS_MASK        = 0x00010000L;
constexpr unsigned int CB_COLOR3_INFO__BLEND_CLAMP_MASK         = 0x00008000L;
constexpr unsigned int CB_COLOR3_INFO__BLEND_OPT_DISCARD_PIXEL_MASK = 0x03800000L;
constexpr unsigned int CB_COLOR3_INFO__BLEND_OPT_DONT_RD_DST_MASK = 0x00700000L;
constexpr unsigned int CB_COLOR3_INFO__CMASK_ADDR_TYPE_MASK     = 0x60000000L;
constexpr unsigned int CB_COLOR3_INFO__COMPRESSION_MASK         = 0x00004000L;
constexpr unsigned int CB_COLOR3_INFO__COMP_SWAP_MASK           = 0x00001800L;
constexpr unsigned int CB_COLOR3_INFO__DCC_ENABLE_MASK          = 0x10000000L;
constexpr unsigned int CB_COLOR3_INFO__ENDIAN_MASK              = 0x00000003L;
constexpr unsigned int CB_COLOR3_INFO__FAST_CLEAR_MASK          = 0x00002000L;
constexpr unsigned int CB_COLOR3_INFO__FMASK_COMPRESSION_DISABLE_MASK = 0x04000000L;
constexpr unsigned int CB_COLOR3_INFO__FMASK_COMPRESS_1FRAG_ONLY_MASK = 0x08000000L;
constexpr unsigned int CB_COLOR3_INFO__FORMAT_MASK              = 0x0000007cL;
constexpr unsigned int CB_COLOR3_INFO__NUMBER_TYPE_MASK         = 0x00000700L;
constexpr unsigned int CB_COLOR3_INFO__ROUND_MODE_MASK          = 0x00040000L;
constexpr unsigned int CB_COLOR3_INFO__SIMPLE_FLOAT_MASK        = 0x00020000L;
constexpr unsigned int CB_COLOR4_ATTRIB2__MAX_MIP_MASK          = 0xf0000000L;
constexpr unsigned int CB_COLOR4_ATTRIB2__MIP0_HEIGHT_MASK      = 0x00003fffL;
constexpr unsigned int CB_COLOR4_ATTRIB2__MIP0_WIDTH_MASK       = 0x0fffc000L;
constexpr unsigned int CB_COLOR4_ATTRIB__FORCE_DST_ALPHA_1_MASK = 0x00020000L;
constexpr unsigned int CB_COLOR4_ATTRIB__NUM_FRAGMENTS_MASK     = 0x00018000L;
constexpr unsigned int CB_COLOR4_ATTRIB__NUM_SAMPLES_MASK       = 0x00007000L;
constexpr unsigned int CB_COLOR4_BASE_EXT__BASE_256B_MASK       = 0x000000ffL;
constexpr unsigned int CB_COLOR4_BASE__BASE_256B_MASK           = 0xffffffffL;
constexpr unsigned int CB_COLOR4_CLEAR_WORD0__CLEAR_WORD0_MASK  = 0xffffffffL;
constexpr unsigned int CB_COLOR4_CLEAR_WORD1__CLEAR_WORD1_MASK  = 0xffffffffL;
constexpr unsigned int CB_COLOR4_CMASK_BASE_EXT__BASE_256B_MASK = 0x000000ffL;
constexpr unsigned int CB_COLOR4_CMASK__BASE_256B_MASK          = 0xffffffffL;
constexpr unsigned int CB_COLOR4_DCC_BASE_EXT__BASE_256B_MASK   = 0x000000ffL;
constexpr unsigned int CB_COLOR4_DCC_BASE__BASE_256B_MASK       = 0xffffffffL;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__COLOR_TRANSFORM_MASK = 0x00000180L;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__INDEPENDENT_64B_BLOCKS_MASK = 0x00000200L;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__KEY_CLEAR_ENABLE_MASK = 0x00000002L;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__LOSSY_ALPHA_PRECISION_MASK = 0x0003c000L;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__LOSSY_RGB_PRECISION_MASK = 0x00003c00L;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE_MASK = 0x00000060L;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE_MASK = 0x0000000cL;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__MIN_COMPRESSED_BLOCK_SIZE_MASK = 0x00000010L;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE_MASK = 0x00000001L;
constexpr unsigned int CB_COLOR4_FMASK_BASE_EXT__BASE_256B_MASK = 0x000000ffL;
constexpr unsigned int CB_COLOR4_FMASK__BASE_256B_MASK          = 0xffffffffL;
constexpr unsigned int CB_COLOR4_INFO__BLEND_BYPASS_MASK        = 0x00010000L;
constexpr unsigned int CB_COLOR4_INFO__BLEND_CLAMP_MASK         = 0x00008000L;
constexpr unsigned int CB_COLOR4_INFO__BLEND_OPT_DISCARD_PIXEL_MASK = 0x03800000L;
constexpr unsigned int CB_COLOR4_INFO__BLEND_OPT_DONT_RD_DST_MASK = 0x00700000L;
constexpr unsigned int CB_COLOR4_INFO__CMASK_ADDR_TYPE_MASK     = 0x60000000L;
constexpr unsigned int CB_COLOR4_INFO__COMPRESSION_MASK         = 0x00004000L;
constexpr unsigned int CB_COLOR4_INFO__COMP_SWAP_MASK           = 0x00001800L;
constexpr unsigned int CB_COLOR4_INFO__DCC_ENABLE_MASK          = 0x10000000L;
constexpr unsigned int CB_COLOR4_INFO__ENDIAN_MASK              = 0x00000003L;
constexpr unsigned int CB_COLOR4_INFO__FAST_CLEAR_MASK          = 0x00002000L;
constexpr unsigned int CB_COLOR4_INFO__FMASK_COMPRESSION_DISABLE_MASK = 0x04000000L;
constexpr unsigned int CB_COLOR4_INFO__FMASK_COMPRESS_1FRAG_ONLY_MASK = 0x08000000L;
constexpr unsigned int CB_COLOR4_INFO__FORMAT_MASK              = 0x0000007cL;
constexpr unsigned int CB_COLOR4_INFO__NUMBER_TYPE_MASK         = 0x00000700L;
constexpr unsigned int CB_COLOR4_INFO__ROUND_MODE_MASK          = 0x00040000L;
constexpr unsigned int CB_COLOR4_INFO__SIMPLE_FLOAT_MASK        = 0x00020000L;
constexpr unsigned int CB_COLOR5_ATTRIB2__MAX_MIP_MASK          = 0xf0000000L;
constexpr unsigned int CB_COLOR5_ATTRIB2__MIP0_HEIGHT_MASK      = 0x00003fffL;
constexpr unsigned int CB_COLOR5_ATTRIB2__MIP0_WIDTH_MASK       = 0x0fffc000L;
constexpr unsigned int CB_COLOR5_ATTRIB__FORCE_DST_ALPHA_1_MASK = 0x00020000L;
constexpr unsigned int CB_COLOR5_ATTRIB__NUM_FRAGMENTS_MASK     = 0x00018000L;
constexpr unsigned int CB_COLOR5_ATTRIB__NUM_SAMPLES_MASK       = 0x00007000L;
constexpr unsigned int CB_COLOR5_BASE_EXT__BASE_256B_MASK       = 0x000000ffL;
constexpr unsigned int CB_COLOR5_BASE__BASE_256B_MASK           = 0xffffffffL;
constexpr unsigned int CB_COLOR5_CLEAR_WORD0__CLEAR_WORD0_MASK  = 0xffffffffL;
constexpr unsigned int CB_COLOR5_CLEAR_WORD1__CLEAR_WORD1_MASK  = 0xffffffffL;
constexpr unsigned int CB_COLOR5_CMASK_BASE_EXT__BASE_256B_MASK = 0x000000ffL;
constexpr unsigned int CB_COLOR5_CMASK__BASE_256B_MASK          = 0xffffffffL;
constexpr unsigned int CB_COLOR5_DCC_BASE_EXT__BASE_256B_MASK   = 0x000000ffL;
constexpr unsigned int CB_COLOR5_DCC_BASE__BASE_256B_MASK       = 0xffffffffL;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__COLOR_TRANSFORM_MASK = 0x00000180L;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__INDEPENDENT_64B_BLOCKS_MASK = 0x00000200L;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__KEY_CLEAR_ENABLE_MASK = 0x00000002L;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__LOSSY_ALPHA_PRECISION_MASK = 0x0003c000L;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__LOSSY_RGB_PRECISION_MASK = 0x00003c00L;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE_MASK = 0x00000060L;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE_MASK = 0x0000000cL;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__MIN_COMPRESSED_BLOCK_SIZE_MASK = 0x00000010L;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE_MASK = 0x00000001L;
constexpr unsigned int CB_COLOR5_FMASK_BASE_EXT__BASE_256B_MASK = 0x000000ffL;
constexpr unsigned int CB_COLOR5_FMASK__BASE_256B_MASK          = 0xffffffffL;
constexpr unsigned int CB_COLOR5_INFO__BLEND_BYPASS_MASK        = 0x00010000L;
constexpr unsigned int CB_COLOR5_INFO__BLEND_CLAMP_MASK         = 0x00008000L;
constexpr unsigned int CB_COLOR5_INFO__BLEND_OPT_DISCARD_PIXEL_MASK = 0x03800000L;
constexpr unsigned int CB_COLOR5_INFO__BLEND_OPT_DONT_RD_DST_MASK = 0x00700000L;
constexpr unsigned int CB_COLOR5_INFO__CMASK_ADDR_TYPE_MASK     = 0x60000000L;
constexpr unsigned int CB_COLOR5_INFO__COMPRESSION_MASK         = 0x00004000L;
constexpr unsigned int CB_COLOR5_INFO__COMP_SWAP_MASK           = 0x00001800L;
constexpr unsigned int CB_COLOR5_INFO__DCC_ENABLE_MASK          = 0x10000000L;
constexpr unsigned int CB_COLOR5_INFO__ENDIAN_MASK              = 0x00000003L;
constexpr unsigned int CB_COLOR5_INFO__FAST_CLEAR_MASK          = 0x00002000L;
constexpr unsigned int CB_COLOR5_INFO__FMASK_COMPRESSION_DISABLE_MASK = 0x04000000L;
constexpr unsigned int CB_COLOR5_INFO__FMASK_COMPRESS_1FRAG_ONLY_MASK = 0x08000000L;
constexpr unsigned int CB_COLOR5_INFO__FORMAT_MASK              = 0x0000007cL;
constexpr unsigned int CB_COLOR5_INFO__NUMBER_TYPE_MASK         = 0x00000700L;
constexpr unsigned int CB_COLOR5_INFO__ROUND_MODE_MASK          = 0x00040000L;
constexpr unsigned int CB_COLOR5_INFO__SIMPLE_FLOAT_MASK        = 0x00020000L;
constexpr unsigned int CB_COLOR6_ATTRIB2__MAX_MIP_MASK          = 0xf0000000L;
constexpr unsigned int CB_COLOR6_ATTRIB2__MIP0_HEIGHT_MASK      = 0x00003fffL;
constexpr unsigned int CB_COLOR6_ATTRIB2__MIP0_WIDTH_MASK       = 0x0fffc000L;
constexpr unsigned int CB_COLOR6_ATTRIB__FORCE_DST_ALPHA_1_MASK = 0x00020000L;
constexpr unsigned int CB_COLOR6_ATTRIB__NUM_FRAGMENTS_MASK     = 0x00018000L;
constexpr unsigned int CB_COLOR6_ATTRIB__NUM_SAMPLES_MASK       = 0x00007000L;
constexpr unsigned int CB_COLOR6_BASE_EXT__BASE_256B_MASK       = 0x000000ffL;
constexpr unsigned int CB_COLOR6_BASE__BASE_256B_MASK           = 0xffffffffL;
constexpr unsigned int CB_COLOR6_CLEAR_WORD0__CLEAR_WORD0_MASK  = 0xffffffffL;
constexpr unsigned int CB_COLOR6_CLEAR_WORD1__CLEAR_WORD1_MASK  = 0xffffffffL;
constexpr unsigned int CB_COLOR6_CMASK_BASE_EXT__BASE_256B_MASK = 0x000000ffL;
constexpr unsigned int CB_COLOR6_CMASK__BASE_256B_MASK          = 0xffffffffL;
constexpr unsigned int CB_COLOR6_DCC_BASE_EXT__BASE_256B_MASK   = 0x000000ffL;
constexpr unsigned int CB_COLOR6_DCC_BASE__BASE_256B_MASK       = 0xffffffffL;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__COLOR_TRANSFORM_MASK = 0x00000180L;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__INDEPENDENT_64B_BLOCKS_MASK = 0x00000200L;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__KEY_CLEAR_ENABLE_MASK = 0x00000002L;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__LOSSY_ALPHA_PRECISION_MASK = 0x0003c000L;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__LOSSY_RGB_PRECISION_MASK = 0x00003c00L;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE_MASK = 0x00000060L;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE_MASK = 0x0000000cL;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__MIN_COMPRESSED_BLOCK_SIZE_MASK = 0x00000010L;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE_MASK = 0x00000001L;
constexpr unsigned int CB_COLOR6_FMASK_BASE_EXT__BASE_256B_MASK = 0x000000ffL;
constexpr unsigned int CB_COLOR6_FMASK__BASE_256B_MASK          = 0xffffffffL;
constexpr unsigned int CB_COLOR6_INFO__BLEND_BYPASS_MASK        = 0x00010000L;
constexpr unsigned int CB_COLOR6_INFO__BLEND_CLAMP_MASK         = 0x00008000L;
constexpr unsigned int CB_COLOR6_INFO__BLEND_OPT_DISCARD_PIXEL_MASK = 0x03800000L;
constexpr unsigned int CB_COLOR6_INFO__BLEND_OPT_DONT_RD_DST_MASK = 0x00700000L;
constexpr unsigned int CB_COLOR6_INFO__CMASK_ADDR_TYPE_MASK     = 0x60000000L;
constexpr unsigned int CB_COLOR6_INFO__COMPRESSION_MASK         = 0x00004000L;
constexpr unsigned int CB_COLOR6_INFO__COMP_SWAP_MASK           = 0x00001800L;
constexpr unsigned int CB_COLOR6_INFO__DCC_ENABLE_MASK          = 0x10000000L;
constexpr unsigned int CB_COLOR6_INFO__ENDIAN_MASK              = 0x00000003L;
constexpr unsigned int CB_COLOR6_INFO__FAST_CLEAR_MASK          = 0x00002000L;
constexpr unsigned int CB_COLOR6_INFO__FMASK_COMPRESSION_DISABLE_MASK = 0x04000000L;
constexpr unsigned int CB_COLOR6_INFO__FMASK_COMPRESS_1FRAG_ONLY_MASK = 0x08000000L;
constexpr unsigned int CB_COLOR6_INFO__FORMAT_MASK              = 0x0000007cL;
constexpr unsigned int CB_COLOR6_INFO__NUMBER_TYPE_MASK         = 0x00000700L;
constexpr unsigned int CB_COLOR6_INFO__ROUND_MODE_MASK          = 0x00040000L;
constexpr unsigned int CB_COLOR6_INFO__SIMPLE_FLOAT_MASK        = 0x00020000L;
constexpr unsigned int CB_COLOR7_ATTRIB2__MAX_MIP_MASK          = 0xf0000000L;
constexpr unsigned int CB_COLOR7_ATTRIB2__MIP0_HEIGHT_MASK      = 0x00003fffL;
constexpr unsigned int CB_COLOR7_ATTRIB2__MIP0_WIDTH_MASK       = 0x0fffc000L;
constexpr unsigned int CB_COLOR7_ATTRIB__FORCE_DST_ALPHA_1_MASK = 0x00020000L;
constexpr unsigned int CB_COLOR7_ATTRIB__NUM_FRAGMENTS_MASK     = 0x00018000L;
constexpr unsigned int CB_COLOR7_ATTRIB__NUM_SAMPLES_MASK       = 0x00007000L;
constexpr unsigned int CB_COLOR7_BASE_EXT__BASE_256B_MASK       = 0x000000ffL;
constexpr unsigned int CB_COLOR7_BASE__BASE_256B_MASK           = 0xffffffffL;
constexpr unsigned int CB_COLOR7_CLEAR_WORD0__CLEAR_WORD0_MASK  = 0xffffffffL;
constexpr unsigned int CB_COLOR7_CLEAR_WORD1__CLEAR_WORD1_MASK  = 0xffffffffL;
constexpr unsigned int CB_COLOR7_CMASK_BASE_EXT__BASE_256B_MASK = 0x000000ffL;
constexpr unsigned int CB_COLOR7_CMASK__BASE_256B_MASK          = 0xffffffffL;
constexpr unsigned int CB_COLOR7_DCC_BASE_EXT__BASE_256B_MASK   = 0x000000ffL;
constexpr unsigned int CB_COLOR7_DCC_BASE__BASE_256B_MASK       = 0xffffffffL;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__COLOR_TRANSFORM_MASK = 0x00000180L;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__INDEPENDENT_64B_BLOCKS_MASK = 0x00000200L;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__KEY_CLEAR_ENABLE_MASK = 0x00000002L;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__LOSSY_ALPHA_PRECISION_MASK = 0x0003c000L;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__LOSSY_RGB_PRECISION_MASK = 0x00003c00L;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE_MASK = 0x00000060L;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE_MASK = 0x0000000cL;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__MIN_COMPRESSED_BLOCK_SIZE_MASK = 0x00000010L;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE_MASK = 0x00000001L;
constexpr unsigned int CB_COLOR7_FMASK_BASE_EXT__BASE_256B_MASK = 0x000000ffL;
constexpr unsigned int CB_COLOR7_FMASK__BASE_256B_MASK          = 0xffffffffL;
constexpr unsigned int CB_COLOR7_INFO__BLEND_BYPASS_MASK        = 0x00010000L;
constexpr unsigned int CB_COLOR7_INFO__BLEND_CLAMP_MASK         = 0x00008000L;
constexpr unsigned int CB_COLOR7_INFO__BLEND_OPT_DISCARD_PIXEL_MASK = 0x03800000L;
constexpr unsigned int CB_COLOR7_INFO__BLEND_OPT_DONT_RD_DST_MASK = 0x00700000L;
constexpr unsigned int CB_COLOR7_INFO__CMASK_ADDR_TYPE_MASK     = 0x60000000L;
constexpr unsigned int CB_COLOR7_INFO__COMPRESSION_MASK         = 0x00004000L;
constexpr unsigned int CB_COLOR7_INFO__COMP_SWAP_MASK           = 0x00001800L;
constexpr unsigned int CB_COLOR7_INFO__DCC_ENABLE_MASK          = 0x10000000L;
constexpr unsigned int CB_COLOR7_INFO__ENDIAN_MASK              = 0x00000003L;
constexpr unsigned int CB_COLOR7_INFO__FAST_CLEAR_MASK          = 0x00002000L;
constexpr unsigned int CB_COLOR7_INFO__FMASK_COMPRESSION_DISABLE_MASK = 0x04000000L;
constexpr unsigned int CB_COLOR7_INFO__FMASK_COMPRESS_1FRAG_ONLY_MASK = 0x08000000L;
constexpr unsigned int CB_COLOR7_INFO__FORMAT_MASK              = 0x0000007cL;
constexpr unsigned int CB_COLOR7_INFO__NUMBER_TYPE_MASK         = 0x00000700L;
constexpr unsigned int CB_COLOR7_INFO__ROUND_MODE_MASK          = 0x00040000L;
constexpr unsigned int CB_COLOR7_INFO__SIMPLE_FLOAT_MASK        = 0x00020000L;
constexpr unsigned int CB_COLOR_CONTROL__DEGAMMA_ENABLE_MASK    = 0x00000008L;
constexpr unsigned int CB_COLOR_CONTROL__DISABLE_DUAL_QUAD_MASK = 0x00000001L;
constexpr unsigned int CB_COLOR_CONTROL__MODE_MASK              = 0x00000070L;
constexpr unsigned int CB_COLOR_CONTROL__ROP3_MASK              = 0x00ff0000L;
constexpr unsigned int CB_DCC_CONFIG__FC_RDLAT_KEYID_FIFO_DEPTH_MASK = 0x0000ff00L;
constexpr unsigned int CB_DCC_CONFIG__OVERWRITE_COMBINER_CC_POP_DISABLE_MASK = 0x00000040L;
constexpr unsigned int CB_DCC_CONFIG__OVERWRITE_COMBINER_DEPTH_MASK = 0x0000001fL;
constexpr unsigned int CB_DCC_CONFIG__OVERWRITE_COMBINER_DISABLE_MASK = 0x00000020L;
constexpr unsigned int CB_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE_MASK = 0x00000001L;
constexpr unsigned int CB_DCC_CONTROL__OVERWRITE_COMBINER_WATERMARK_MASK = 0x0000007cL;
constexpr unsigned int CB_HW_CONTROL_1__CM_CACHE_NUM_TAGS_MASK  = 0x0000001fL;
constexpr unsigned int CB_HW_CONTROL_2__CC_EVEN_ODD_FIFO_DEPTH_MASK = 0x000000ffL;
constexpr unsigned int CB_HW_CONTROL_2__FC_RDLAT_QUAD_FIFO_DEPTH_MASK = 0x007f8000L;
constexpr unsigned int CB_HW_CONTROL_2__FC_RDLAT_TILE_FIFO_DEPTH_MASK = 0x00007f00L;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_BLENDER_CLOCK_GATING_MASK = 0x04000000L;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_CC_CACHE_OVWR_STATUS_ACCUM_MASK = 0x00000020L;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_CC_CACHE_PANIC_GATING_MASK = 0x00000080L;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_CMASK_LAST_QUAD_INSERTION_MASK = 0x00000800L;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_EARLY_WRACKS_CC_MASK = 0x00020000L;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_EARLY_WRACKS_CM_MASK = 0x00100000L;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_EARLY_WRACKS_DC_MASK = 0x00080000L;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_EARLY_WRACKS_FC_MASK = 0x00040000L;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_FAST_CLEAR_FETCH_OPT_MASK = 0x00000004L;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_NACK_COLOR_RD_WR_OPT_MASK = 0x02000000L;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_NACK_PROCESSING_CC_MASK = 0x00200000L;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_NACK_PROCESSING_CM_MASK = 0x01000000L;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_NACK_PROCESSING_DC_MASK = 0x00800000L;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_NACK_PROCESSING_FC_MASK = 0x00400000L;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_OC_FIXES_OF_BUG_522542_MASK = 0x00004000L;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_OVERWRITE_COMBINER_CAM_CLR_MASK = 0x00000010L;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_QUAD_MARKER_DROP_STOP_MASK = 0x00000008L;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_ROP3_FIXES_OF_BUG_511967_MASK = 0x00001000L;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_ROP3_FIXES_OF_BUG_520657_MASK = 0x00002000L;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_SHADER_BLEND_OPTS_MASK = 0x00000400L;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_SLOW_MODE_EMPTY_HALF_QUAD_KILL_MASK = 0x00000001L;
constexpr unsigned int CB_HW_CONTROL_3__FORCE_RMI_CLKEN_HIGH_MASK = 0x00010000L;
constexpr unsigned int CB_HW_CONTROL_3__FORCE_RMI_LAST_HIGH_MASK = 0x00008000L;
constexpr unsigned int CB_HW_CONTROL_3__RAM_ADDRESS_CONFLICTS_DISALLOWED_MASK = 0x00000002L;
constexpr unsigned int CB_HW_CONTROL_3__SPLIT_ALL_FAST_MODE_TRANSFERS_MASK = 0x00000200L;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_BYPASS_MASK = 0x02000000L;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_DISCARD_PIXEL_MASK = 0x04000000L;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_DONT_RD_DST_MASK = 0x01000000L;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_RESULT_EQ_DEST_MASK = 0x00200000L;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_WHEN_DISABLED_SRCALPHA_IS_USED_MASK = 0x08000000L;
constexpr unsigned int CB_HW_CONTROL__DISABLE_CC_IB_SERIALIZER_STATE_OPT_MASK = 0x40000000L;
constexpr unsigned int CB_HW_CONTROL__DISABLE_FULL_WRITE_MASK_MASK = 0x00400000L;
constexpr unsigned int CB_HW_CONTROL__DISABLE_INTNORM_LE11BPC_CLAMPING_MASK = 0x00040000L;
constexpr unsigned int CB_HW_CONTROL__DISABLE_PIXEL_IN_QUAD_FIX_FOR_LINEAR_SURFACE_MASK = 0x80000000L;
constexpr unsigned int CB_HW_CONTROL__DISABLE_RESOLVE_OPT_FOR_SINGLE_FRAG_MASK = 0x00800000L;
constexpr unsigned int CB_HW_CONTROL__FORCE_ALWAYS_TOGGLE_MASK  = 0x00100000L;
constexpr unsigned int CB_HW_CONTROL__FORCE_NEEDS_DST_MASK      = 0x00080000L;
constexpr unsigned int CB_HW_CONTROL__PRIORITIZE_FC_EVICT_OVER_FOP_RD_ON_BANK_CONFLICT_MASK = 0x20000000L;
constexpr unsigned int CB_HW_CONTROL__PRIORITIZE_FC_WR_OVER_FC_RD_ON_CMASK_CONFLICT_MASK = 0x10000000L;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__BREAK_GROUP_AGE_MASK = 0x000003c0L;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__IGNORE_URGENT_AGE_MASK = 0x0000003cL;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__MODE_MASK          = 0x00000003L;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__SCALE_AGE_MASK     = 0x03800000L;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__SCALE_WEIGHT_MASK  = 0x1c000000L;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__SEND_LASTS_WITHIN_GROUPS_MASK = 0x20000000L;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__WEIGHT_CC_MASK     = 0x00000c00L;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__WEIGHT_CM_MASK     = 0x0000c000L;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__WEIGHT_DC_MASK     = 0x00030000L;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__WEIGHT_DECAY_NOREQS_MASK = 0x00300000L;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__WEIGHT_DECAY_REQS_MASK = 0x000c0000L;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__WEIGHT_FC_MASK     = 0x00003000L;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__WEIGHT_IGNORE_NUM_TIDS_MASK = 0x00400000L;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__BREAK_GROUP_AGE_MASK = 0x000003c0L;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__IGNORE_URGENT_AGE_MASK = 0x0000003cL;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__MODE_MASK          = 0x00000003L;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__SCALE_AGE_MASK     = 0x03800000L;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__SCALE_WEIGHT_MASK  = 0x1c000000L;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__SEND_LASTS_WITHIN_GROUPS_MASK = 0x20000000L;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__WEIGHT_CC_MASK     = 0x00000c00L;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__WEIGHT_CM_MASK     = 0x0000c000L;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__WEIGHT_DC_MASK     = 0x00030000L;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__WEIGHT_DECAY_NOREQS_MASK = 0x00300000L;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__WEIGHT_DECAY_REQS_MASK = 0x000c0000L;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__WEIGHT_FC_MASK     = 0x00003000L;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__WEIGHT_IGNORE_BYTE_MASK_MASK = 0x00400000L;
constexpr unsigned int CB_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int CB_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int CB_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
constexpr unsigned int CB_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
constexpr unsigned int CB_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK  = 0x000001ffL;
constexpr unsigned int CB_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK  = 0x0007fc00L;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__CNTR_MODE_MASK   = 0x00f00000L;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__PERF_MODE1_MASK  = 0x0f000000L;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__PERF_MODE_MASK   = 0xf0000000L;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__PERF_SEL1_MASK   = 0x0007fc00L;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__PERF_SEL_MASK    = 0x000001ffL;
constexpr unsigned int CB_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int CB_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int CB_PERFCOUNTER1_SELECT__PERF_MODE_MASK   = 0xf0000000L;
constexpr unsigned int CB_PERFCOUNTER1_SELECT__PERF_SEL_MASK    = 0x000001ffL;
constexpr unsigned int CB_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int CB_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int CB_PERFCOUNTER2_SELECT__PERF_MODE_MASK   = 0xf0000000L;
constexpr unsigned int CB_PERFCOUNTER2_SELECT__PERF_SEL_MASK    = 0x000001ffL;
constexpr unsigned int CB_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int CB_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int CB_PERFCOUNTER3_SELECT__PERF_MODE_MASK   = 0xf0000000L;
constexpr unsigned int CB_PERFCOUNTER3_SELECT__PERF_SEL_MASK    = 0x000001ffL;
constexpr unsigned int CB_PERFCOUNTER_FILTER__CLEAR_FILTER_ENABLE_MASK = 0x00000400L;
constexpr unsigned int CB_PERFCOUNTER_FILTER__CLEAR_FILTER_SEL_MASK = 0x00000800L;
constexpr unsigned int CB_PERFCOUNTER_FILTER__FORMAT_FILTER_ENABLE_MASK = 0x00000010L;
constexpr unsigned int CB_PERFCOUNTER_FILTER__FORMAT_FILTER_SEL_MASK = 0x000003e0L;
constexpr unsigned int CB_PERFCOUNTER_FILTER__MRT_FILTER_ENABLE_MASK = 0x00001000L;
constexpr unsigned int CB_PERFCOUNTER_FILTER__MRT_FILTER_SEL_MASK = 0x0000e000L;
constexpr unsigned int CB_PERFCOUNTER_FILTER__NUM_FRAGMENTS_FILTER_ENABLE_MASK = 0x00200000L;
constexpr unsigned int CB_PERFCOUNTER_FILTER__NUM_FRAGMENTS_FILTER_SEL_MASK = 0x00c00000L;
constexpr unsigned int CB_PERFCOUNTER_FILTER__NUM_SAMPLES_FILTER_ENABLE_MASK = 0x00020000L;
constexpr unsigned int CB_PERFCOUNTER_FILTER__NUM_SAMPLES_FILTER_SEL_MASK = 0x001c0000L;
constexpr unsigned int CB_PERFCOUNTER_FILTER__OP_FILTER_ENABLE_MASK = 0x00000001L;
constexpr unsigned int CB_PERFCOUNTER_FILTER__OP_FILTER_SEL_MASK = 0x0000000eL;
constexpr unsigned int CB_SHADER_MASK__OUTPUT0_ENABLE_MASK      = 0x0000000fL;
constexpr unsigned int CB_SHADER_MASK__OUTPUT1_ENABLE_MASK      = 0x000000f0L;
constexpr unsigned int CB_SHADER_MASK__OUTPUT2_ENABLE_MASK      = 0x00000f00L;
constexpr unsigned int CB_SHADER_MASK__OUTPUT3_ENABLE_MASK      = 0x0000f000L;
constexpr unsigned int CB_SHADER_MASK__OUTPUT4_ENABLE_MASK      = 0x000f0000L;
constexpr unsigned int CB_SHADER_MASK__OUTPUT5_ENABLE_MASK      = 0x00f00000L;
constexpr unsigned int CB_SHADER_MASK__OUTPUT6_ENABLE_MASK      = 0x0f000000L;
constexpr unsigned int CB_SHADER_MASK__OUTPUT7_ENABLE_MASK      = 0xf0000000L;
constexpr unsigned int CB_TARGET_MASK__TARGET0_ENABLE_MASK      = 0x0000000fL;
constexpr unsigned int CB_TARGET_MASK__TARGET1_ENABLE_MASK      = 0x000000f0L;
constexpr unsigned int CB_TARGET_MASK__TARGET2_ENABLE_MASK      = 0x00000f00L;
constexpr unsigned int CB_TARGET_MASK__TARGET3_ENABLE_MASK      = 0x0000f000L;
constexpr unsigned int CB_TARGET_MASK__TARGET4_ENABLE_MASK      = 0x000f0000L;
constexpr unsigned int CB_TARGET_MASK__TARGET5_ENABLE_MASK      = 0x00f00000L;
constexpr unsigned int CB_TARGET_MASK__TARGET6_ENABLE_MASK      = 0x0f000000L;
constexpr unsigned int CB_TARGET_MASK__TARGET7_ENABLE_MASK      = 0xf0000000L;
constexpr unsigned int CC_RB_BACKEND_DISABLE__BACKEND_DISABLE_MASK = 0x00ff0000L;
constexpr unsigned int CC_RB_DAISY_CHAIN__RB_0_MASK             = 0x0000000fL;
constexpr unsigned int CC_RB_DAISY_CHAIN__RB_1_MASK             = 0x000000f0L;
constexpr unsigned int CC_RB_DAISY_CHAIN__RB_2_MASK             = 0x00000f00L;
constexpr unsigned int CC_RB_DAISY_CHAIN__RB_3_MASK             = 0x0000f000L;
constexpr unsigned int CC_RB_DAISY_CHAIN__RB_4_MASK             = 0x000f0000L;
constexpr unsigned int CC_RB_DAISY_CHAIN__RB_5_MASK             = 0x00f00000L;
constexpr unsigned int CC_RB_DAISY_CHAIN__RB_6_MASK             = 0x0f000000L;
constexpr unsigned int CC_RB_DAISY_CHAIN__RB_7_MASK             = 0xf0000000L;
constexpr unsigned int CC_RB_REDUNDANCY__EN_REDUNDANCY0_MASK    = 0x00001000L;
constexpr unsigned int CC_RB_REDUNDANCY__EN_REDUNDANCY1_MASK    = 0x00100000L;
constexpr unsigned int CC_RB_REDUNDANCY__FAILED_RB0_MASK        = 0x00000f00L;
constexpr unsigned int CC_RB_REDUNDANCY__FAILED_RB1_MASK        = 0x000f0000L;
constexpr unsigned int COHER_DEST_BASE_0__DEST_BASE_256B_MASK   = 0xffffffffL;
constexpr unsigned int COHER_DEST_BASE_1__DEST_BASE_256B_MASK   = 0xffffffffL;
constexpr unsigned int COHER_DEST_BASE_2__DEST_BASE_256B_MASK   = 0xffffffffL;
constexpr unsigned int COHER_DEST_BASE_3__DEST_BASE_256B_MASK   = 0xffffffffL;
constexpr unsigned int COHER_DEST_BASE_HI_0__DEST_BASE_HI_256B_MASK = 0x000000ffL;
constexpr unsigned int COHER_DEST_BASE_HI_1__DEST_BASE_HI_256B_MASK = 0x000000ffL;
constexpr unsigned int COHER_DEST_BASE_HI_2__DEST_BASE_HI_256B_MASK = 0x000000ffL;
constexpr unsigned int COHER_DEST_BASE_HI_3__DEST_BASE_HI_256B_MASK = 0x000000ffL;
constexpr unsigned int COMPUTE_DIM_X__SIZE_MASK                 = 0xffffffffL;
constexpr unsigned int COMPUTE_DIM_Y__SIZE_MASK                 = 0xffffffffL;
constexpr unsigned int COMPUTE_DIM_Z__SIZE_MASK                 = 0xffffffffL;
constexpr unsigned int COMPUTE_DISPATCH_ID__DISPATCH_ID_MASK    = 0xffffffffL;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__COMPUTE_SHADER_EN_MASK = 0x00000001L;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__FORCE_START_AT_000_MASK = 0x00000004L;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__ORDERED_APPEND_ENBL_MASK = 0x00000008L;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__ORDERED_APPEND_MODE_MASK = 0x00000010L;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__ORDER_MODE_MASK = 0x00000040L;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__PARTIAL_TG_EN_MASK = 0x00000002L;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__RESERVED_MASK = 0x00001000L;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__RESTORE_MASK = 0x00004000L;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__SCALAR_L1_INV_VOL_MASK = 0x00000400L;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__USE_THREAD_DIMENSIONS_MASK = 0x00000020L;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__VECTOR_L1_INV_VOL_MASK = 0x00000800L;
constexpr unsigned int COMPUTE_DISPATCH_PKT_ADDR_HI__DATA_MASK  = 0x000000ffL;
constexpr unsigned int COMPUTE_DISPATCH_PKT_ADDR_LO__DATA_MASK  = 0xffffffffL;
constexpr unsigned int COMPUTE_DISPATCH_SCRATCH_BASE_HI__DATA_MASK = 0x000000ffL;
constexpr unsigned int COMPUTE_DISPATCH_SCRATCH_BASE_LO__DATA_MASK = 0xffffffffL;
constexpr unsigned int COMPUTE_MISC_RESERVED__RESERVED2_MASK    = 0x00000004L;
constexpr unsigned int COMPUTE_MISC_RESERVED__RESERVED3_MASK    = 0x00000008L;
constexpr unsigned int COMPUTE_MISC_RESERVED__RESERVED4_MASK    = 0x00000010L;
constexpr unsigned int COMPUTE_MISC_RESERVED__SEND_SEID_MASK    = 0x00000003L;
constexpr unsigned int COMPUTE_MISC_RESERVED__WAVE_ID_BASE_MASK = 0x0001ffe0L;
constexpr unsigned int COMPUTE_NOWHERE__DATA_MASK               = 0xffffffffL;
constexpr unsigned int COMPUTE_NUM_THREAD_X__NUM_THREAD_FULL_MASK = 0x0000ffffL;
constexpr unsigned int COMPUTE_NUM_THREAD_X__NUM_THREAD_PARTIAL_MASK = 0xffff0000L;
constexpr unsigned int COMPUTE_NUM_THREAD_Y__NUM_THREAD_FULL_MASK = 0x0000ffffL;
constexpr unsigned int COMPUTE_NUM_THREAD_Y__NUM_THREAD_PARTIAL_MASK = 0xffff0000L;
constexpr unsigned int COMPUTE_NUM_THREAD_Z__NUM_THREAD_FULL_MASK = 0x0000ffffL;
constexpr unsigned int COMPUTE_NUM_THREAD_Z__NUM_THREAD_PARTIAL_MASK = 0xffff0000L;
constexpr unsigned int COMPUTE_PERFCOUNT_ENABLE__PERFCOUNT_ENABLE_MASK = 0x00000001L;
constexpr unsigned int COMPUTE_PGM_HI__DATA_MASK                = 0x000000ffL;
constexpr unsigned int COMPUTE_PGM_LO__DATA_MASK                = 0xffffffffL;
constexpr unsigned int COMPUTE_PGM_RSRC1__BULKY_MASK            = 0x01000000L;
constexpr unsigned int COMPUTE_PGM_RSRC1__CDBG_USER_MASK        = 0x02000000L;
constexpr unsigned int COMPUTE_PGM_RSRC1__DEBUG_MODE_MASK       = 0x00400000L;
constexpr unsigned int COMPUTE_PGM_RSRC1__DX10_CLAMP_MASK       = 0x00200000L;
constexpr unsigned int COMPUTE_PGM_RSRC1__FLOAT_MODE_MASK       = 0x000ff000L;
constexpr unsigned int COMPUTE_PGM_RSRC1__FP16_OVFL_MASK        = 0x04000000L;
constexpr unsigned int COMPUTE_PGM_RSRC1__IEEE_MODE_MASK        = 0x00800000L;
constexpr unsigned int COMPUTE_PGM_RSRC1__PRIORITY_MASK         = 0x00000c00L;
constexpr unsigned int COMPUTE_PGM_RSRC1__PRIV_MASK             = 0x00100000L;
constexpr unsigned int COMPUTE_PGM_RSRC1__SGPRS_MASK            = 0x000003c0L;
constexpr unsigned int COMPUTE_PGM_RSRC1__VGPRS_MASK            = 0x0000003fL;
constexpr unsigned int COMPUTE_PGM_RSRC2__EXCP_EN_MASK          = 0x7f000000L;
constexpr unsigned int COMPUTE_PGM_RSRC2__EXCP_EN_MSB_MASK      = 0x00006000L;
constexpr unsigned int COMPUTE_PGM_RSRC2__LDS_SIZE_MASK         = 0x00ff8000L;
constexpr unsigned int COMPUTE_PGM_RSRC2__SCRATCH_EN_MASK       = 0x00000001L;
constexpr unsigned int COMPUTE_PGM_RSRC2__TGID_X_EN_MASK        = 0x00000080L;
constexpr unsigned int COMPUTE_PGM_RSRC2__TGID_Y_EN_MASK        = 0x00000100L;
constexpr unsigned int COMPUTE_PGM_RSRC2__TGID_Z_EN_MASK        = 0x00000200L;
constexpr unsigned int COMPUTE_PGM_RSRC2__TG_SIZE_EN_MASK       = 0x00000400L;
constexpr unsigned int COMPUTE_PGM_RSRC2__TIDIG_COMP_CNT_MASK   = 0x00001800L;
constexpr unsigned int COMPUTE_PGM_RSRC2__TRAP_PRESENT_MASK     = 0x00000040L;
constexpr unsigned int COMPUTE_PGM_RSRC2__USER_SGPR_MASK        = 0x0000003eL;
constexpr unsigned int COMPUTE_PIPELINESTAT_ENABLE__PIPELINESTAT_ENABLE_MASK = 0x00000001L;
constexpr unsigned int COMPUTE_RELAUNCH__IS_EVENT_MASK          = 0x40000000L;
constexpr unsigned int COMPUTE_RELAUNCH__IS_STATE_MASK          = 0x80000000L;
constexpr unsigned int COMPUTE_RELAUNCH__PAYLOAD_MASK           = 0x3fffffffL;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__CU_GROUP_COUNT_MASK = 0x07000000L;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__FORCE_SIMD_DIST_MASK = 0x00800000L;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__LOCK_THRESHOLD_MASK = 0x003f0000L;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__SIMD_DEST_CNTL_MASK = 0x00400000L;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__TG_PER_CU_MASK  = 0x0000f000L;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__WAVES_PER_SH_MASK = 0x000003ffL;
constexpr unsigned int COMPUTE_RESTART_X__RESTART_MASK          = 0xffffffffL;
constexpr unsigned int COMPUTE_RESTART_Y__RESTART_MASK          = 0xffffffffL;
constexpr unsigned int COMPUTE_RESTART_Z__RESTART_MASK          = 0xffffffffL;
constexpr unsigned int COMPUTE_START_X__START_MASK              = 0xffffffffL;
constexpr unsigned int COMPUTE_START_Y__START_MASK              = 0xffffffffL;
constexpr unsigned int COMPUTE_START_Z__START_MASK              = 0xffffffffL;
constexpr unsigned int COMPUTE_THREADGROUP_ID__THREADGROUP_ID_MASK = 0xffffffffL;
constexpr unsigned int COMPUTE_THREAD_TRACE_ENABLE__THREAD_TRACE_ENABLE_MASK = 0x00000001L;
constexpr unsigned int COMPUTE_TMPRING_SIZE__WAVESIZE_MASK      = 0x01fff000L;
constexpr unsigned int COMPUTE_TMPRING_SIZE__WAVES_MASK         = 0x00000fffL;
constexpr unsigned int COMPUTE_USER_DATA_0__DATA_MASK           = 0xffffffffL;
constexpr unsigned int COMPUTE_USER_DATA_1__DATA_MASK           = 0xffffffffL;
constexpr unsigned int COMPUTE_USER_DATA_2__DATA_MASK           = 0xffffffffL;
constexpr unsigned int COMPUTE_USER_DATA_3__DATA_MASK           = 0xffffffffL;
constexpr unsigned int COMPUTE_USER_DATA_4__DATA_MASK           = 0xffffffffL;
constexpr unsigned int COMPUTE_USER_DATA_5__DATA_MASK           = 0xffffffffL;
constexpr unsigned int COMPUTE_USER_DATA_6__DATA_MASK           = 0xffffffffL;
constexpr unsigned int COMPUTE_USER_DATA_7__DATA_MASK           = 0xffffffffL;
constexpr unsigned int COMPUTE_USER_DATA_8__DATA_MASK           = 0xffffffffL;
constexpr unsigned int COMPUTE_USER_DATA_9__DATA_MASK           = 0xffffffffL;
constexpr unsigned int COMPUTE_USER_DATA_10__DATA_MASK          = 0xffffffffL;
constexpr unsigned int COMPUTE_USER_DATA_11__DATA_MASK          = 0xffffffffL;
constexpr unsigned int COMPUTE_USER_DATA_12__DATA_MASK          = 0xffffffffL;
constexpr unsigned int COMPUTE_USER_DATA_13__DATA_MASK          = 0xffffffffL;
constexpr unsigned int COMPUTE_USER_DATA_14__DATA_MASK          = 0xffffffffL;
constexpr unsigned int COMPUTE_USER_DATA_15__DATA_MASK          = 0xffffffffL;
constexpr unsigned int COMPUTE_VMID__DATA_MASK                  = 0x0000000fL;
constexpr unsigned int COMPUTE_WAVE_RESTORE_ADDR_HI__ADDR_MASK  = 0x0000ffffL;
constexpr unsigned int COMPUTE_WAVE_RESTORE_ADDR_LO__ADDR_MASK  = 0xffffffffL;
constexpr unsigned int CPC_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int CPC_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__CNTR_MODE2_MASK = 0xf0000000L;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__CNTR_MODE3_MASK = 0x0f000000L;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT__CNTR_MODE0_MASK = 0xf0000000L;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT__CNTR_MODE1_MASK = 0x0f000000L;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT__SPM_MODE_MASK   = 0x00f00000L;
constexpr unsigned int CPC_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int CPC_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int CPC_PERFCOUNTER1_SELECT__CNTR_MODE0_MASK = 0xf0000000L;
constexpr unsigned int CPC_PERFCOUNTER1_SELECT__CNTR_MODE1_MASK = 0x0f000000L;
constexpr unsigned int CPC_PERFCOUNTER1_SELECT__SPM_MODE_MASK   = 0x00f00000L;
constexpr unsigned int CPF_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int CPF_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__CNTR_MODE2_MASK = 0xf0000000L;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__CNTR_MODE3_MASK = 0x0f000000L;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT__CNTR_MODE0_MASK = 0xf0000000L;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT__CNTR_MODE1_MASK = 0x0f000000L;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT__SPM_MODE_MASK   = 0x00f00000L;
constexpr unsigned int CPF_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int CPF_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int CPF_PERFCOUNTER1_SELECT__CNTR_MODE0_MASK = 0xf0000000L;
constexpr unsigned int CPF_PERFCOUNTER1_SELECT__CNTR_MODE1_MASK = 0x0f000000L;
constexpr unsigned int CPF_PERFCOUNTER1_SELECT__SPM_MODE_MASK   = 0x00f00000L;
constexpr unsigned int CPG_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int CPG_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__CNTR_MODE2_MASK = 0xf0000000L;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__CNTR_MODE3_MASK = 0x0f000000L;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT__CNTR_MODE0_MASK = 0xf0000000L;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT__CNTR_MODE1_MASK = 0x0f000000L;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT__SPM_MODE_MASK   = 0x00f00000L;
constexpr unsigned int CPG_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int CPG_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int CPG_PERFCOUNTER1_SELECT__CNTR_MODE0_MASK = 0xf0000000L;
constexpr unsigned int CPG_PERFCOUNTER1_SELECT__CNTR_MODE1_MASK = 0x0f000000L;
constexpr unsigned int CPG_PERFCOUNTER1_SELECT__SPM_MODE_MASK   = 0x00f00000L;
constexpr unsigned int CP_APPEND_ADDR_HI__COMMAND_MASK          = 0xe0000000L;
constexpr unsigned int CP_APPEND_ADDR_HI__CS_PS_SEL_MASK        = 0x00010000L;
constexpr unsigned int CP_APPEND_ADDR_HI__MEM_ADDR_HI_MASK      = 0x0000ffffL;
constexpr unsigned int CP_APPEND_ADDR_LO__MEM_ADDR_LO_MASK      = 0xfffffffcL;
constexpr unsigned int CP_APPEND_DATA_HI__DATA_MASK             = 0xffffffffL;
constexpr unsigned int CP_APPEND_DATA_LO__DATA_MASK             = 0xffffffffL;
constexpr unsigned int CP_APPEND_LAST_CS_FENCE_HI__LAST_FENCE_MASK = 0xffffffffL;
constexpr unsigned int CP_APPEND_LAST_CS_FENCE_LO__LAST_FENCE_MASK = 0xffffffffL;
constexpr unsigned int CP_APPEND_LAST_PS_FENCE_HI__LAST_FENCE_MASK = 0xffffffffL;
constexpr unsigned int CP_APPEND_LAST_PS_FENCE_LO__LAST_FENCE_MASK = 0xffffffffL;
constexpr unsigned int CP_AQL_SMM_STATUS__AQL_QUEUE_SMM_MASK    = 0xffffffffL;
constexpr unsigned int CP_ATOMIC_PREOP_HI__ATOMIC_PREOP_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_ATOMIC_PREOP_LO__ATOMIC_PREOP_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_BUSY_STAT__CE_PARSING_PACKETS_MASK    = 0x00400000L;
constexpr unsigned int CP_BUSY_STAT__COHER_CNT_NEQ_ZERO_MASK    = 0x00000040L;
constexpr unsigned int CP_BUSY_STAT__EOP_DONE_BUSY_MASK         = 0x00040000L;
constexpr unsigned int CP_BUSY_STAT__GFX_CONTEXT_BUSY_MASK      = 0x00008000L;
constexpr unsigned int CP_BUSY_STAT__ME_PARSER_BUSY_MASK        = 0x00020000L;
constexpr unsigned int CP_BUSY_STAT__ME_PARSING_PACKETS_MASK    = 0x00000100L;
constexpr unsigned int CP_BUSY_STAT__PFP_PARSING_PACKETS_MASK   = 0x00000080L;
constexpr unsigned int CP_BUSY_STAT__PIPE_STATS_BUSY_MASK       = 0x00100000L;
constexpr unsigned int CP_BUSY_STAT__RCIU_CE_BUSY_MASK          = 0x00200000L;
constexpr unsigned int CP_BUSY_STAT__RCIU_ME_BUSY_MASK          = 0x00000400L;
constexpr unsigned int CP_BUSY_STAT__RCIU_PFP_BUSY_MASK         = 0x00000200L;
constexpr unsigned int CP_BUSY_STAT__REG_BUS_FIFO_BUSY_MASK     = 0x00000001L;
constexpr unsigned int CP_BUSY_STAT__SEM_CMDFIFO_NOT_EMPTY_MASK = 0x00001000L;
constexpr unsigned int CP_BUSY_STAT__SEM_FAILED_AND_HOLDING_MASK = 0x00002000L;
constexpr unsigned int CP_BUSY_STAT__SEM_POLLING_FOR_PASS_MASK  = 0x00004000L;
constexpr unsigned int CP_BUSY_STAT__STRM_OUT_BUSY_MASK         = 0x00080000L;
constexpr unsigned int CP_CE_COMPARE_COUNT__COMPARE_COUNT_MASK  = 0xffffffffL;
constexpr unsigned int CP_CE_COMPLETION_STATUS__STATUS_MASK     = 0x00000003L;
constexpr unsigned int CP_CE_COUNTER__CONST_ENGINE_COUNT_MASK   = 0xffffffffL;
constexpr unsigned int CP_CE_DE_COUNT__DRAW_ENGINE_COUNT_MASK   = 0xffffffffL;
constexpr unsigned int CP_CE_HEADER_DUMP__CE_HEADER_DUMP_MASK   = 0xffffffffL;
constexpr unsigned int CP_CE_IB1_BASE_HI__IB1_BASE_HI_MASK      = 0x0000ffffL;
constexpr unsigned int CP_CE_IB1_BASE_LO__IB1_BASE_LO_MASK      = 0xfffffffcL;
constexpr unsigned int CP_CE_IB1_BUFSZ__IB1_BUFSZ_MASK          = 0x000fffffL;
constexpr unsigned int CP_CE_IB1_CMD_BUFSZ__IB1_CMD_REQSZ_MASK  = 0x000fffffL;
constexpr unsigned int CP_CE_IB1_OFFSET__IB1_OFFSET_MASK        = 0x000fffffL;
constexpr unsigned int CP_CE_IB2_BASE_HI__IB2_BASE_HI_MASK      = 0x0000ffffL;
constexpr unsigned int CP_CE_IB2_BASE_LO__IB2_BASE_LO_MASK      = 0xfffffffcL;
constexpr unsigned int CP_CE_IB2_BUFSZ__IB2_BUFSZ_MASK          = 0x000fffffL;
constexpr unsigned int CP_CE_IB2_CMD_BUFSZ__IB2_CMD_REQSZ_MASK  = 0x000fffffL;
constexpr unsigned int CP_CE_IB2_OFFSET__IB2_OFFSET_MASK        = 0x000fffffL;
constexpr unsigned int CP_CE_INIT_BASE_HI__INIT_BASE_HI_MASK    = 0x0000ffffL;
constexpr unsigned int CP_CE_INIT_BASE_LO__INIT_BASE_LO_MASK    = 0xffffffe0L;
constexpr unsigned int CP_CE_INIT_BUFSZ__INIT_BUFSZ_MASK        = 0x00000fffL;
constexpr unsigned int CP_CE_INIT_CMD_BUFSZ__INIT_CMD_REQSZ_MASK = 0x00000fffL;
constexpr unsigned int CP_CE_INSTR_PNTR__INSTR_PNTR_MASK        = 0x0000ffffL;
constexpr unsigned int CP_CE_METADATA_BASE_ADDR_HI__ADDR_HI_MASK = 0x0000ffffL;
constexpr unsigned int CP_CE_METADATA_BASE_ADDR__ADDR_LO_MASK   = 0xffffffffL;
constexpr unsigned int CP_CMD_DATA__CMD_DATA_MASK               = 0xffffffffL;
constexpr unsigned int CP_CMD_INDEX__CMD_INDEX_MASK             = 0x000007ffL;
constexpr unsigned int CP_CMD_INDEX__CMD_ME_SEL_MASK            = 0x00003000L;
constexpr unsigned int CP_CMD_INDEX__CMD_QUEUE_SEL_MASK         = 0x00070000L;
constexpr unsigned int CP_CNTX_STAT__ACTIVE_GFX_CONTEXTS_MASK   = 0x0ff00000L;
constexpr unsigned int CP_CNTX_STAT__ACTIVE_HP3D_CONTEXTS_MASK  = 0x000000ffL;
constexpr unsigned int CP_CNTX_STAT__CURRENT_GFX_CONTEXT_MASK   = 0x70000000L;
constexpr unsigned int CP_CNTX_STAT__CURRENT_HP3D_CONTEXT_MASK  = 0x00000700L;
constexpr unsigned int CP_COHER_BASE_HI__COHER_BASE_HI_256B_MASK = 0x000000ffL;
constexpr unsigned int CP_COHER_BASE__COHER_BASE_256B_MASK      = 0xffffffffL;
constexpr unsigned int CP_COHER_CNTL__CB_ACTION_ENA_MASK        = 0x02000000L;
constexpr unsigned int CP_COHER_CNTL__DB_ACTION_ENA_MASK        = 0x04000000L;
constexpr unsigned int CP_COHER_CNTL__SH_ICACHE_ACTION_ENA_MASK = 0x20000000L;
constexpr unsigned int CP_COHER_CNTL__SH_KCACHE_ACTION_ENA_MASK = 0x08000000L;
constexpr unsigned int CP_COHER_CNTL__SH_KCACHE_VOL_ACTION_ENA_MASK = 0x10000000L;
constexpr unsigned int CP_COHER_CNTL__SH_KCACHE_WB_ACTION_ENA_MASK = 0x40000000L;
constexpr unsigned int CP_COHER_CNTL__TCL1_ACTION_ENA_MASK      = 0x00400000L;
constexpr unsigned int CP_COHER_CNTL__TCL1_VOL_ACTION_ENA_MASK  = 0x00008000L;
constexpr unsigned int CP_COHER_CNTL__TC_ACTION_ENA_MASK        = 0x00800000L;
constexpr unsigned int CP_COHER_CNTL__TC_INV_METADATA_ACTION_ENA_MASK = 0x00000020L;
constexpr unsigned int CP_COHER_CNTL__TC_NC_ACTION_ENA_MASK     = 0x00000008L;
constexpr unsigned int CP_COHER_CNTL__TC_WB_ACTION_ENA_MASK     = 0x00040000L;
constexpr unsigned int CP_COHER_CNTL__TC_WC_ACTION_ENA_MASK     = 0x00000010L;
constexpr unsigned int CP_COHER_SIZE_HI__COHER_SIZE_HI_256B_MASK = 0x000000ffL;
constexpr unsigned int CP_COHER_SIZE__COHER_SIZE_256B_MASK      = 0xffffffffL;
constexpr unsigned int CP_COHER_START_DELAY__START_DELAY_COUNT_MASK = 0x0000003fL;
constexpr unsigned int CP_COHER_STATUS__MEID_MASK               = 0x03000000L;
constexpr unsigned int CP_COHER_STATUS__STATUS_MASK             = 0x80000000L;
constexpr unsigned int CP_CONTEXT_CNTL__ME0PIPE0_MAX_PIPE_CNTX_MASK = 0x00000070L;
constexpr unsigned int CP_CONTEXT_CNTL__ME0PIPE1_MAX_PIPE_CNTX_MASK = 0x00700000L;
constexpr unsigned int CP_CSF_STAT__BUFFER_REQUEST_COUNT_MASK   = 0x0001ff00L;
constexpr unsigned int CP_DEVICE_ID__DEVICE_ID_MASK             = 0x000000ffL;
constexpr unsigned int CP_DE_CE_COUNT__CONST_ENGINE_COUNT_MASK  = 0xffffffffL;
constexpr unsigned int CP_DE_DE_COUNT__DRAW_ENGINE_COUNT_MASK   = 0xffffffffL;
constexpr unsigned int CP_DE_LAST_INVAL_COUNT__LAST_INVAL_COUNT_MASK = 0xffffffffL;
constexpr unsigned int CP_DFY_ADDR_HI__ADDR_HI_MASK             = 0xffffffffL;
constexpr unsigned int CP_DFY_ADDR_LO__ADDR_LO_MASK             = 0xffffffe0L;
constexpr unsigned int CP_DFY_CMD__OFFSET_MASK                  = 0x000001ffL;
constexpr unsigned int CP_DFY_CMD__SIZE_MASK                    = 0xffff0000L;
constexpr unsigned int CP_DFY_CNTL__ENABLE_MASK                 = 0x80000000L;
constexpr unsigned int CP_DFY_CNTL__LFSR_RESET_MASK             = 0x10000000L;
constexpr unsigned int CP_DFY_CNTL__MODE_MASK                   = 0x60000000L;
constexpr unsigned int CP_DFY_CNTL__TPI_SDP_SEL_MASK            = 0x04000000L;
constexpr unsigned int CP_DFY_DATA_0__DATA_MASK                 = 0xffffffffL;
constexpr unsigned int CP_DFY_DATA_1__DATA_MASK                 = 0xffffffffL;
constexpr unsigned int CP_DFY_DATA_2__DATA_MASK                 = 0xffffffffL;
constexpr unsigned int CP_DFY_DATA_3__DATA_MASK                 = 0xffffffffL;
constexpr unsigned int CP_DFY_DATA_4__DATA_MASK                 = 0xffffffffL;
constexpr unsigned int CP_DFY_DATA_5__DATA_MASK                 = 0xffffffffL;
constexpr unsigned int CP_DFY_DATA_6__DATA_MASK                 = 0xffffffffL;
constexpr unsigned int CP_DFY_DATA_7__DATA_MASK                 = 0xffffffffL;
constexpr unsigned int CP_DFY_DATA_8__DATA_MASK                 = 0xffffffffL;
constexpr unsigned int CP_DFY_DATA_9__DATA_MASK                 = 0xffffffffL;
constexpr unsigned int CP_DFY_DATA_10__DATA_MASK                = 0xffffffffL;
constexpr unsigned int CP_DFY_DATA_11__DATA_MASK                = 0xffffffffL;
constexpr unsigned int CP_DFY_DATA_12__DATA_MASK                = 0xffffffffL;
constexpr unsigned int CP_DFY_DATA_13__DATA_MASK                = 0xffffffffL;
constexpr unsigned int CP_DFY_DATA_14__DATA_MASK                = 0xffffffffL;
constexpr unsigned int CP_DFY_DATA_15__DATA_MASK                = 0xffffffffL;
constexpr unsigned int CP_DFY_STAT__BURST_COUNT_MASK            = 0x0000ffffL;
constexpr unsigned int CP_DFY_STAT__BUSY_MASK                   = 0x80000000L;
constexpr unsigned int CP_DFY_STAT__TAGS_PENDING_MASK           = 0x07ff0000L;
constexpr unsigned int CP_DISPATCH_INDR_ADDR_HI__ADDR_HI_MASK   = 0x0000ffffL;
constexpr unsigned int CP_DISPATCH_INDR_ADDR__ADDR_LO_MASK      = 0xffffffffL;
constexpr unsigned int CP_DMA_CNTL__MIN_AVAILSZ_MASK            = 0x00000030L;
constexpr unsigned int CP_DMA_CNTL__PIO_COUNT_MASK              = 0xc0000000L;
constexpr unsigned int CP_DMA_CNTL__PIO_FIFO_EMPTY_MASK         = 0x10000000L;
constexpr unsigned int CP_DMA_CNTL__PIO_FIFO_FULL_MASK          = 0x20000000L;
constexpr unsigned int CP_DMA_CNTL__UTCL1_FAULT_CONTROL_MASK    = 0x00000001L;
constexpr unsigned int CP_DMA_ME_COMMAND__BYTE_COUNT_MASK       = 0x03ffffffL;
constexpr unsigned int CP_DMA_ME_COMMAND__DAIC_MASK             = 0x20000000L;
constexpr unsigned int CP_DMA_ME_COMMAND__DAS_MASK              = 0x08000000L;
constexpr unsigned int CP_DMA_ME_COMMAND__DIS_WC_MASK           = 0x80000000L;
constexpr unsigned int CP_DMA_ME_COMMAND__RAW_WAIT_MASK         = 0x40000000L;
constexpr unsigned int CP_DMA_ME_COMMAND__SAIC_MASK             = 0x10000000L;
constexpr unsigned int CP_DMA_ME_COMMAND__SAS_MASK              = 0x04000000L;
constexpr unsigned int CP_DMA_ME_CONTROL__DST_SELECT_MASK       = 0x00300000L;
constexpr unsigned int CP_DMA_ME_CONTROL__MEMLOG_CLEAR_MASK     = 0x00000400L;
constexpr unsigned int CP_DMA_ME_CONTROL__SRC_SELECT_MASK       = 0x60000000L;
constexpr unsigned int CP_DMA_ME_DST_ADDR_HI__DST_ADDR_HI_MASK  = 0x0000ffffL;
constexpr unsigned int CP_DMA_ME_DST_ADDR__DST_ADDR_MASK        = 0xffffffffL;
constexpr unsigned int CP_DMA_ME_SRC_ADDR_HI__SRC_ADDR_HI_MASK  = 0x0000ffffL;
constexpr unsigned int CP_DMA_ME_SRC_ADDR__SRC_ADDR_MASK        = 0xffffffffL;
constexpr unsigned int CP_DMA_PFP_COMMAND__BYTE_COUNT_MASK      = 0x03ffffffL;
constexpr unsigned int CP_DMA_PFP_COMMAND__DAIC_MASK            = 0x20000000L;
constexpr unsigned int CP_DMA_PFP_COMMAND__DAS_MASK             = 0x08000000L;
constexpr unsigned int CP_DMA_PFP_COMMAND__DIS_WC_MASK          = 0x80000000L;
constexpr unsigned int CP_DMA_PFP_COMMAND__RAW_WAIT_MASK        = 0x40000000L;
constexpr unsigned int CP_DMA_PFP_COMMAND__SAIC_MASK            = 0x10000000L;
constexpr unsigned int CP_DMA_PFP_COMMAND__SAS_MASK             = 0x04000000L;
constexpr unsigned int CP_DMA_PFP_CONTROL__DST_SELECT_MASK      = 0x00300000L;
constexpr unsigned int CP_DMA_PFP_CONTROL__MEMLOG_CLEAR_MASK    = 0x00000400L;
constexpr unsigned int CP_DMA_PFP_CONTROL__SRC_SELECT_MASK      = 0x60000000L;
constexpr unsigned int CP_DMA_PFP_DST_ADDR_HI__DST_ADDR_HI_MASK = 0x0000ffffL;
constexpr unsigned int CP_DMA_PFP_DST_ADDR__DST_ADDR_MASK       = 0xffffffffL;
constexpr unsigned int CP_DMA_PFP_SRC_ADDR_HI__SRC_ADDR_HI_MASK = 0x0000ffffL;
constexpr unsigned int CP_DMA_PFP_SRC_ADDR__SRC_ADDR_MASK       = 0xffffffffL;
constexpr unsigned int CP_DMA_PIO_COMMAND__BYTE_COUNT_MASK      = 0x03ffffffL;
constexpr unsigned int CP_DMA_PIO_COMMAND__DAIC_MASK            = 0x20000000L;
constexpr unsigned int CP_DMA_PIO_COMMAND__DAS_MASK             = 0x08000000L;
constexpr unsigned int CP_DMA_PIO_COMMAND__DIS_WC_MASK          = 0x80000000L;
constexpr unsigned int CP_DMA_PIO_COMMAND__RAW_WAIT_MASK        = 0x40000000L;
constexpr unsigned int CP_DMA_PIO_COMMAND__SAIC_MASK            = 0x10000000L;
constexpr unsigned int CP_DMA_PIO_COMMAND__SAS_MASK             = 0x04000000L;
constexpr unsigned int CP_DMA_READ_TAGS__DMA_READ_TAG_MASK      = 0x03ffffffL;
constexpr unsigned int CP_DMA_READ_TAGS__DMA_READ_TAG_VALID_MASK = 0x10000000L;
constexpr unsigned int CP_DRAW_INDX_INDR_ADDR_HI__ADDR_HI_MASK  = 0x0000ffffL;
constexpr unsigned int CP_DRAW_INDX_INDR_ADDR__ADDR_LO_MASK     = 0xffffffffL;
constexpr unsigned int CP_DRAW_OBJECT_COUNTER__COUNT_MASK       = 0x0000ffffL;
constexpr unsigned int CP_DRAW_OBJECT__OBJECT_MASK              = 0xffffffffL;
constexpr unsigned int CP_DRAW_WINDOW_CNTL__DISABLE_DRAW_WINDOW_HI_MASK = 0x00000004L;
constexpr unsigned int CP_DRAW_WINDOW_CNTL__DISABLE_DRAW_WINDOW_LO_MAX_MASK = 0x00000001L;
constexpr unsigned int CP_DRAW_WINDOW_CNTL__DISABLE_DRAW_WINDOW_LO_MIN_MASK = 0x00000002L;
constexpr unsigned int CP_DRAW_WINDOW_CNTL__MODE_MASK           = 0x00000100L;
constexpr unsigned int CP_DRAW_WINDOW_HI__WINDOW_HI_MASK        = 0xffffffffL;
constexpr unsigned int CP_DRAW_WINDOW_LO__MAX_MASK              = 0xffff0000L;
constexpr unsigned int CP_DRAW_WINDOW_LO__MIN_MASK              = 0x0000ffffL;
constexpr unsigned int CP_DRAW_WINDOW_MASK_HI__WINDOW_MASK_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_ECC_FIRSTOCCURRENCE_RING0__OBSOLETE_MASK = 0xffffffffL;
constexpr unsigned int CP_ECC_FIRSTOCCURRENCE_RING1__OBSOLETE_MASK = 0xffffffffL;
constexpr unsigned int CP_ECC_FIRSTOCCURRENCE_RING2__OBSOLETE_MASK = 0xffffffffL;
constexpr unsigned int CP_ECC_FIRSTOCCURRENCE__CLIENT_MASK      = 0x000000f0L;
constexpr unsigned int CP_ECC_FIRSTOCCURRENCE__INTERFACE_MASK   = 0x00000003L;
constexpr unsigned int CP_ECC_FIRSTOCCURRENCE__ME_MASK          = 0x00000300L;
constexpr unsigned int CP_ECC_FIRSTOCCURRENCE__PIPE_MASK        = 0x00000c00L;
constexpr unsigned int CP_ECC_FIRSTOCCURRENCE__QUEUE_MASK       = 0x00007000L;
constexpr unsigned int CP_ECC_FIRSTOCCURRENCE__VMID_MASK        = 0x000f0000L;
constexpr unsigned int CP_EOPQ_WAIT_TIME__SCALE_COUNT_MASK      = 0x0003fc00L;
constexpr unsigned int CP_EOPQ_WAIT_TIME__WAIT_TIME_MASK        = 0x000003ffL;
constexpr unsigned int CP_EOP_DONE_ADDR_HI__ADDR_HI_MASK        = 0x0000ffffL;
constexpr unsigned int CP_EOP_DONE_ADDR_LO__ADDR_LO_MASK        = 0xfffffffcL;
constexpr unsigned int CP_EOP_DONE_CNTX_ID__CNTX_ID_MASK        = 0xffffffffL;
constexpr unsigned int CP_EOP_DONE_DATA_CNTL__DATA_SEL_MASK     = 0xe0000000L;
constexpr unsigned int CP_EOP_DONE_DATA_CNTL__DST_SEL_MASK      = 0x00030000L;
constexpr unsigned int CP_EOP_DONE_DATA_CNTL__INT_SEL_MASK      = 0x07000000L;
constexpr unsigned int CP_EOP_DONE_DATA_HI__DATA_HI_MASK        = 0xffffffffL;
constexpr unsigned int CP_EOP_DONE_DATA_LO__DATA_LO_MASK        = 0xffffffffL;
constexpr unsigned int CP_EOP_DONE_EVENT_CNTL__EXECUTE_MASK     = 0x10000000L;
constexpr unsigned int CP_EOP_LAST_FENCE_HI__LAST_FENCE_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_EOP_LAST_FENCE_LO__LAST_FENCE_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_FATAL_ERROR__CPF_FATAL_ERROR_MASK     = 0x00000001L;
constexpr unsigned int CP_FATAL_ERROR__CPG_FATAL_ERROR_MASK     = 0x00000002L;
constexpr unsigned int CP_FATAL_ERROR__CPG_TAG_FATAL_ERROR_EN_MASK = 0x00000010L;
constexpr unsigned int CP_FATAL_ERROR__DIS_CPG_FATAL_ERROR_MASK = 0x00000008L;
constexpr unsigned int CP_FATAL_ERROR__GFX_HALT_PROC_MASK       = 0x00000004L;
constexpr unsigned int CP_GFX_ERROR__APPEND_UTCL1_ERROR_MASK    = 0x00008000L;
constexpr unsigned int CP_GFX_ERROR__C1_FETCHER_UTCL1_ERROR_MASK = 0x10000000L;
constexpr unsigned int CP_GFX_ERROR__C2_FETCHER_UTCL1_ERROR_MASK = 0x20000000L;
constexpr unsigned int CP_GFX_ERROR__CE_DMA_UTCL1_ERROR_MASK    = 0x00010000L;
constexpr unsigned int CP_GFX_ERROR__CE_INIT_UTCL1_ERROR_MASK   = 0x80000000L;
constexpr unsigned int CP_GFX_ERROR__CE_TC_UTCL1_ERROR_MASK     = 0x00400000L;
constexpr unsigned int CP_GFX_ERROR__DMA_DST_UTCL1_ERROR_MASK   = 0x00080000L;
constexpr unsigned int CP_GFX_ERROR__DMA_SRC_UTCL1_ERROR_MASK   = 0x00040000L;
constexpr unsigned int CP_GFX_ERROR__EDC_ERROR_ID_MASK          = 0x0000000fL;
constexpr unsigned int CP_GFX_ERROR__I1_FETCHER_UTCL1_ERROR_MASK = 0x04000000L;
constexpr unsigned int CP_GFX_ERROR__I2_FETCHER_UTCL1_ERROR_MASK = 0x08000000L;
constexpr unsigned int CP_GFX_ERROR__ME_TC_UTCL1_ERROR_MASK     = 0x00200000L;
constexpr unsigned int CP_GFX_ERROR__PFP_TC_UTCL1_ERROR_MASK    = 0x00100000L;
constexpr unsigned int CP_GFX_ERROR__PFP_VGTDMA_UTCL1_ERROR_MASK = 0x00020000L;
constexpr unsigned int CP_GFX_ERROR__PRT_LOD_UTCL1_ERROR_MASK   = 0x00800000L;
constexpr unsigned int CP_GFX_ERROR__QU_EOP_UTCL1_ERROR_MASK    = 0x00000200L;
constexpr unsigned int CP_GFX_ERROR__QU_PIPE_UTCL1_ERROR_MASK   = 0x00000400L;
constexpr unsigned int CP_GFX_ERROR__QU_READ_UTCL1_ERROR_MASK   = 0x00000800L;
constexpr unsigned int CP_GFX_ERROR__QU_STRM_UTCL1_ERROR_MASK   = 0x00000100L;
constexpr unsigned int CP_GFX_ERROR__RB_FETCHER_UTCL1_ERROR_MASK = 0x02000000L;
constexpr unsigned int CP_GFX_ERROR__RDPTR_RPT_UTCL1_ERROR_MASK = 0x01000000L;
constexpr unsigned int CP_GFX_ERROR__SEM_UTCL1_ERROR_MASK       = 0x00000080L;
constexpr unsigned int CP_GFX_ERROR__SHADOW_UTCL1_ERROR_MASK    = 0x00004000L;
constexpr unsigned int CP_GFX_ERROR__ST_FETCHER_UTCL1_ERROR_MASK = 0x40000000L;
constexpr unsigned int CP_GFX_ERROR__SUA_ERROR_MASK             = 0x00000010L;
constexpr unsigned int CP_GFX_ERROR__SYNC_MEMRD_UTCL1_ERROR_MASK = 0x00001000L;
constexpr unsigned int CP_GFX_ERROR__SYNC_MEMWR_UTCL1_ERROR_MASK = 0x00002000L;
constexpr unsigned int CP_GFX_MQD_BASE_ADDR_HI__BASE_ADDR_HI_MASK = 0x0000ffffL;
constexpr unsigned int CP_GFX_MQD_BASE_ADDR__BASE_ADDR_MASK     = 0xfffffffcL;
constexpr unsigned int CP_GFX_MQD_CONTROL__EXE_DISABLE_MASK     = 0x00800000L;
constexpr unsigned int CP_GFX_MQD_CONTROL__PRIV_STATE_MASK      = 0x00000100L;
constexpr unsigned int CP_GFX_MQD_CONTROL__VMID_MASK            = 0x0000000fL;
constexpr unsigned int CP_GRBM_FREE_COUNT__FREE_COUNT_GDS_MASK  = 0x00003f00L;
constexpr unsigned int CP_GRBM_FREE_COUNT__FREE_COUNT_MASK      = 0x0000003fL;
constexpr unsigned int CP_GRBM_FREE_COUNT__FREE_COUNT_PFP_MASK  = 0x003f0000L;
constexpr unsigned int CP_HPD_ROQ_OFFSETS__IQ_OFFSET_MASK       = 0x00000007L;
constexpr unsigned int CP_HPD_ROQ_OFFSETS__PQ_OFFSET_MASK       = 0x00003f00L;
constexpr unsigned int CP_HPD_STATUS0__FETCHING_MQD_MASK        = 0x00010000L;
constexpr unsigned int CP_HPD_STATUS0__FORCE_QUEUE_MASK         = 0x80000000L;
constexpr unsigned int CP_HPD_STATUS0__FORCE_QUEUE_STATE_MASK   = 0x01f00000L;
constexpr unsigned int CP_HPD_STATUS0__MAPPED_QUEUE_MASK        = 0x000000e0L;
constexpr unsigned int CP_HPD_STATUS0__PEND_TXFER_SIZE_IQ_MASK  = 0x00040000L;
constexpr unsigned int CP_HPD_STATUS0__PEND_TXFER_SIZE_PQIB_MASK = 0x00020000L;
constexpr unsigned int CP_HPD_STATUS0__QUEUE_AVAILABLE_MASK     = 0x0000ff00L;
constexpr unsigned int CP_HPD_STATUS0__QUEUE_STATE_MASK         = 0x0000001fL;
constexpr unsigned int CP_HPD_UTCL1_CNTL__SELECT_MASK           = 0x0000000fL;
constexpr unsigned int CP_HPD_UTCL1_ERROR_ADDR__ADDR_MASK       = 0xfffff000L;
constexpr unsigned int CP_HPD_UTCL1_ERROR__ADDR_HI_MASK         = 0x0000ffffL;
constexpr unsigned int CP_HPD_UTCL1_ERROR__TYPE_MASK            = 0x00010000L;
constexpr unsigned int CP_HPD_UTCL1_ERROR__VMID_MASK            = 0x00f00000L;
constexpr unsigned int CP_HQD_ACTIVE__ACTIVE_MASK               = 0x00000001L;
constexpr unsigned int CP_HQD_ACTIVE__BUSY_GATE_MASK            = 0x00000002L;
constexpr unsigned int CP_HQD_AQL_CONTROL__CONTROL0_EN_MASK     = 0x00008000L;
constexpr unsigned int CP_HQD_AQL_CONTROL__CONTROL0_MASK        = 0x00007fffL;
constexpr unsigned int CP_HQD_AQL_CONTROL__CONTROL1_EN_MASK     = 0x80000000L;
constexpr unsigned int CP_HQD_AQL_CONTROL__CONTROL1_MASK        = 0x7fff0000L;
constexpr unsigned int CP_HQD_ATOMIC0_PREOP_HI__ATOMIC0_PREOP_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_HQD_ATOMIC0_PREOP_LO__ATOMIC0_PREOP_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_HQD_ATOMIC1_PREOP_HI__ATOMIC1_PREOP_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_HQD_ATOMIC1_PREOP_LO__ATOMIC1_PREOP_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_HQD_CNTL_STACK_OFFSET__OFFSET_MASK    = 0x00007ffcL;
constexpr unsigned int CP_HQD_CNTL_STACK_SIZE__SIZE_MASK        = 0x00007000L;
constexpr unsigned int CP_HQD_CTX_SAVE_BASE_ADDR_HI__ADDR_HI_MASK = 0x0000ffffL;
constexpr unsigned int CP_HQD_CTX_SAVE_BASE_ADDR_LO__ADDR_MASK  = 0xfffff000L;
constexpr unsigned int CP_HQD_CTX_SAVE_CONTROL__EXE_DISABLE_MASK = 0x00800000L;
constexpr unsigned int CP_HQD_CTX_SAVE_SIZE__SIZE_MASK          = 0x01fff000L;
constexpr unsigned int CP_HQD_DEQUEUE_REQUEST__DEQUEUE_INT_MASK = 0x00000100L;
constexpr unsigned int CP_HQD_DEQUEUE_REQUEST__DEQUEUE_REQ_EN_MASK = 0x00000400L;
constexpr unsigned int CP_HQD_DEQUEUE_REQUEST__IQ_REQ_PEND_EN_MASK = 0x00000200L;
constexpr unsigned int CP_HQD_DEQUEUE_REQUEST__IQ_REQ_PEND_MASK = 0x00000010L;
constexpr unsigned int CP_HQD_DMA_OFFLOAD__DMA_OFFLOAD_MASK     = 0x00000001L;
constexpr unsigned int CP_HQD_EOP_BASE_ADDR_HI__BASE_ADDR_HI_MASK = 0x000000ffL;
constexpr unsigned int CP_HQD_EOP_BASE_ADDR__BASE_ADDR_MASK     = 0xffffffffL;
constexpr unsigned int CP_HQD_EOP_CONTROL__EOP_SIZE_MASK        = 0x0000003fL;
constexpr unsigned int CP_HQD_EOP_CONTROL__EXE_DISABLE_MASK     = 0x00800000L;
constexpr unsigned int CP_HQD_EOP_CONTROL__HALT_FETCHER_EN_MASK = 0x00400000L;
constexpr unsigned int CP_HQD_EOP_CONTROL__HALT_FETCHER_MASK    = 0x00200000L;
constexpr unsigned int CP_HQD_EOP_CONTROL__PEND_SIG_SEM_MASK    = 0x80000000L;
constexpr unsigned int CP_HQD_EOP_CONTROL__PROCESSING_EOPIB_MASK = 0x00002000L;
constexpr unsigned int CP_HQD_EOP_CONTROL__PROCESSING_EOP_MASK  = 0x00000100L;
constexpr unsigned int CP_HQD_EOP_CONTROL__PROCESS_EOPIB_EN_MASK = 0x00004000L;
constexpr unsigned int CP_HQD_EOP_CONTROL__PROCESS_EOP_EN_MASK  = 0x00001000L;
constexpr unsigned int CP_HQD_EOP_CONTROL__SIG_SEM_RESULT_MASK  = 0x60000000L;
constexpr unsigned int CP_HQD_EOP_EVENTS__CS_PARTIAL_FLUSH_PEND_MASK = 0x00010000L;
constexpr unsigned int CP_HQD_EOP_EVENTS__EVENT_COUNT_MASK      = 0x00000fffL;
constexpr unsigned int CP_HQD_EOP_RPTR__DEQUEUE_PEND_MASK       = 0x20000000L;
constexpr unsigned int CP_HQD_EOP_RPTR__INIT_FETCHER_MASK       = 0x80000000L;
constexpr unsigned int CP_HQD_EOP_RPTR__RESET_FETCHER_MASK      = 0x10000000L;
constexpr unsigned int CP_HQD_EOP_RPTR__RPTR_EQ_CSMD_WPTR_MASK  = 0x40000000L;
constexpr unsigned int CP_HQD_EOP_RPTR__RPTR_MASK               = 0x00001fffL;
constexpr unsigned int CP_HQD_EOP_WPTR_MEM__WPTR_MASK           = 0x00001fffL;
constexpr unsigned int CP_HQD_EOP_WPTR__EOP_AVAIL_MASK          = 0x1fff0000L;
constexpr unsigned int CP_HQD_EOP_WPTR__EOP_EMPTY_MASK          = 0x00008000L;
constexpr unsigned int CP_HQD_EOP_WPTR__WPTR_MASK               = 0x00001fffL;
constexpr unsigned int CP_HQD_ERROR__AQL_ERROR_MASK             = 0x00000020L;
constexpr unsigned int CP_HQD_ERROR__DMA_DST_UTCL1_ERROR_MASK   = 0x00010000L;
constexpr unsigned int CP_HQD_ERROR__DMA_SRC_UTCL1_ERROR_MASK   = 0x00008000L;
constexpr unsigned int CP_HQD_ERROR__EDC_ERROR_ID_MASK          = 0x0000000fL;
constexpr unsigned int CP_HQD_ERROR__EOP_UTCL1_ERROR_MASK       = 0x00000400L;
constexpr unsigned int CP_HQD_ERROR__IB_UTCL1_ERROR_MASK        = 0x00000200L;
constexpr unsigned int CP_HQD_ERROR__IQ_UTCL1_ERROR_MASK        = 0x00000800L;
constexpr unsigned int CP_HQD_ERROR__PQ_UTCL1_ERROR_MASK        = 0x00000100L;
constexpr unsigned int CP_HQD_ERROR__QU_UTCL1_ERROR_MASK        = 0x00040000L;
constexpr unsigned int CP_HQD_ERROR__RRPT_UTCL1_ERROR_MASK      = 0x00001000L;
constexpr unsigned int CP_HQD_ERROR__SEM_UTCL1_ERROR_MASK       = 0x00004000L;
constexpr unsigned int CP_HQD_ERROR__SR_UTCL1_ERROR_MASK        = 0x00020000L;
constexpr unsigned int CP_HQD_ERROR__SUA_ERROR_MASK             = 0x00000010L;
constexpr unsigned int CP_HQD_ERROR__TC_UTCL1_ERROR_MASK        = 0x00080000L;
constexpr unsigned int CP_HQD_ERROR__WPP_UTCL1_ERROR_MASK       = 0x00002000L;
constexpr unsigned int CP_HQD_GFX_CONTROL__DB_UPDATED_MSG_EN_MASK = 0x00008000L;
constexpr unsigned int CP_HQD_GFX_CONTROL__MESSAGE_MASK         = 0x0000000fL;
constexpr unsigned int CP_HQD_GFX_CONTROL__MISC_MASK            = 0x00007ff0L;
constexpr unsigned int CP_HQD_GFX_STATUS__STATUS_MASK           = 0x0000ffffL;
constexpr unsigned int CP_HQD_HQ_CONTROL0__CONTROL_MASK         = 0xffffffffL;
constexpr unsigned int CP_HQD_HQ_CONTROL1__CONTROL_MASK         = 0xffffffffL;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__SCHEDULER_MASK     = 0xffffffffL;
constexpr unsigned int CP_HQD_HQ_SCHEDULER1__SCHEDULER_MASK     = 0xffffffffL;
constexpr unsigned int CP_HQD_HQ_STATUS0__DB_UPDATED_MSG_EN_MASK = 0x80000000L;
constexpr unsigned int CP_HQD_HQ_STATUS0__DEQUEUE_RETRY_CNT_MASK = 0x0000000cL;
constexpr unsigned int CP_HQD_HQ_STATUS0__DEQUEUE_STATUS_MASK   = 0x00000003L;
constexpr unsigned int CP_HQD_HQ_STATUS0__PG_ACTIVATED_MASK     = 0x00000200L;
constexpr unsigned int CP_HQD_HQ_STATUS0__QUEUE_IDLE_MASK       = 0x40000000L;
constexpr unsigned int CP_HQD_HQ_STATUS0__RSVR_29_10_MASK       = 0x3ffffc00L;
constexpr unsigned int CP_HQD_HQ_STATUS0__RSV_6_4_MASK          = 0x00000070L;
constexpr unsigned int CP_HQD_HQ_STATUS0__SCRATCH_RAM_INIT_MASK = 0x00000080L;
constexpr unsigned int CP_HQD_HQ_STATUS0__TCL2_DIRTY_MASK       = 0x00000100L;
constexpr unsigned int CP_HQD_HQ_STATUS1__STATUS_MASK           = 0xffffffffL;
constexpr unsigned int CP_HQD_IB_BASE_ADDR_HI__IB_BASE_ADDR_HI_MASK = 0x0000ffffL;
constexpr unsigned int CP_HQD_IB_BASE_ADDR__IB_BASE_ADDR_MASK   = 0xfffffffcL;
constexpr unsigned int CP_HQD_IB_CONTROL__IB_EXE_DISABLE_MASK   = 0x00800000L;
constexpr unsigned int CP_HQD_IB_CONTROL__IB_SIZE_MASK          = 0x000fffffL;
constexpr unsigned int CP_HQD_IB_CONTROL__MIN_IB_AVAIL_SIZE_MASK = 0x00300000L;
constexpr unsigned int CP_HQD_IB_CONTROL__PROCESSING_IB_MASK    = 0x80000000L;
constexpr unsigned int CP_HQD_IB_RPTR__CONSUMED_OFFSET_MASK     = 0x000fffffL;
constexpr unsigned int CP_HQD_IQ_RPTR__OFFSET_MASK              = 0x0000003fL;
constexpr unsigned int CP_HQD_IQ_TIMER__ACTIVE_MASK             = 0x80000000L;
constexpr unsigned int CP_HQD_IQ_TIMER__CLOCK_COUNT_MASK        = 0x0000c000L;
constexpr unsigned int CP_HQD_IQ_TIMER__EXE_DISABLE_MASK        = 0x00800000L;
constexpr unsigned int CP_HQD_IQ_TIMER__IMMEDIATE_EXPIRE_MASK   = 0x00000800L;
constexpr unsigned int CP_HQD_IQ_TIMER__INTERRUPT_SIZE_MASK     = 0x003f0000L;
constexpr unsigned int CP_HQD_IQ_TIMER__INTERRUPT_TYPE_MASK     = 0x00003000L;
constexpr unsigned int CP_HQD_IQ_TIMER__PROCESSING_IQ_MASK      = 0x40000000L;
constexpr unsigned int CP_HQD_IQ_TIMER__PROCESS_IQ_EN_MASK      = 0x20000000L;
constexpr unsigned int CP_HQD_IQ_TIMER__QUANTUM_TIMER_MASK      = 0x00400000L;
constexpr unsigned int CP_HQD_IQ_TIMER__REARM_TIMER_MASK        = 0x10000000L;
constexpr unsigned int CP_HQD_IQ_TIMER__RETRY_TYPE_MASK         = 0x00000700L;
constexpr unsigned int CP_HQD_IQ_TIMER__WAIT_TIME_MASK          = 0x000000ffL;
constexpr unsigned int CP_HQD_MSG_TYPE__ACTION_MASK             = 0x00000007L;
constexpr unsigned int CP_HQD_MSG_TYPE__SAVE_STATE_MASK         = 0x00000070L;
constexpr unsigned int CP_HQD_OFFLOAD__AQL_OFFLOAD_EN_MASK      = 0x00000008L;
constexpr unsigned int CP_HQD_OFFLOAD__AQL_OFFLOAD_MASK         = 0x00000004L;
constexpr unsigned int CP_HQD_OFFLOAD__DMA_OFFLOAD_EN_MASK      = 0x00000002L;
constexpr unsigned int CP_HQD_OFFLOAD__DMA_OFFLOAD_MASK         = 0x00000001L;
constexpr unsigned int CP_HQD_OFFLOAD__EOP_OFFLOAD_EN_MASK      = 0x00000020L;
constexpr unsigned int CP_HQD_OFFLOAD__EOP_OFFLOAD_MASK         = 0x00000010L;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__CACHE_FULL_PACKET_EN_MASK = 0x08000000L;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__DISP_ACTIVE_MASK = 0x80000000L;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__EOP_SWITCH_QOS_EN_MASK = 0x01000000L;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__IB_SWITCH_QOS_EN_MASK = 0x00800000L;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__IQ_SWITCH_QOS_EN_MASK = 0x00400000L;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__PQ_SWITCH_QOS_EN_MASK = 0x02000000L;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__PRELOAD_REQ_MASK = 0x00000001L;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__PRELOAD_SIZE_MASK = 0x0003ff00L;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__QSWITCH_MODE_MASK = 0x40000000L;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__RELAUNCH_WAVES_MASK = 0x20000000L;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__RESTORE_ACTIVE_MASK = 0x10000000L;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__TC_OFFLOAD_QOS_EN_MASK = 0x04000000L;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__WPP_SWITCH_QOS_EN_MASK = 0x00200000L;
constexpr unsigned int CP_HQD_PIPE_PRIORITY__PIPE_PRIORITY_MASK = 0x00000003L;
constexpr unsigned int CP_HQD_PQ_BASE_HI__ADDR_HI_MASK          = 0x000000ffL;
constexpr unsigned int CP_HQD_PQ_BASE__ADDR_MASK                = 0xffffffffL;
constexpr unsigned int CP_HQD_PQ_CONTROL__EXE_DISABLE_MASK      = 0x00800000L;
constexpr unsigned int CP_HQD_PQ_CONTROL__KMD_QUEUE_MASK        = 0x80000000L;
constexpr unsigned int CP_HQD_PQ_CONTROL__MIN_AVAIL_SIZE_MASK   = 0x00300000L;
constexpr unsigned int CP_HQD_PQ_CONTROL__NO_UPDATE_RPTR_MASK   = 0x08000000L;
constexpr unsigned int CP_HQD_PQ_CONTROL__PQ_EMPTY_MASK         = 0x00008000L;
constexpr unsigned int CP_HQD_PQ_CONTROL__PRIV_STATE_MASK       = 0x40000000L;
constexpr unsigned int CP_HQD_PQ_CONTROL__QUEUE_FULL_EN_MASK    = 0x00004000L;
constexpr unsigned int CP_HQD_PQ_CONTROL__QUEUE_SIZE_MASK       = 0x0000003fL;
constexpr unsigned int CP_HQD_PQ_CONTROL__RPTR_BLOCK_SIZE_MASK  = 0x00003f00L;
constexpr unsigned int CP_HQD_PQ_CONTROL__RPTR_CARRY_MASK       = 0x00000080L;
constexpr unsigned int CP_HQD_PQ_CONTROL__UNORD_DISPATCH_MASK   = 0x10000000L;
constexpr unsigned int CP_HQD_PQ_CONTROL__WPTR_CARRY_MASK       = 0x00000040L;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_BIF_DROP_MASK = 0x00000002L;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_EN_MASK = 0x40000000L;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_HIT_MASK = 0x80000000L;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_MODE_MASK = 0x00000001L;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_OFFSET_MASK = 0x0ffffffcL;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_SCHD_HIT_MASK = 0x20000000L;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_SOURCE_MASK = 0x10000000L;
constexpr unsigned int CP_HQD_PQ_RPTR_REPORT_ADDR_HI__RPTR_REPORT_ADDR_HI_MASK = 0x0000ffffL;
constexpr unsigned int CP_HQD_PQ_RPTR_REPORT_ADDR__RPTR_REPORT_ADDR_MASK = 0xfffffffcL;
constexpr unsigned int CP_HQD_PQ_RPTR__CONSUMED_OFFSET_MASK     = 0xffffffffL;
constexpr unsigned int CP_HQD_PQ_WPTR_HI__DATA_MASK             = 0xffffffffL;
constexpr unsigned int CP_HQD_PQ_WPTR_LO__OFFSET_MASK           = 0xffffffffL;
constexpr unsigned int CP_HQD_PQ_WPTR_POLL_ADDR_HI__WPTR_ADDR_HI_MASK = 0x0000ffffL;
constexpr unsigned int CP_HQD_PQ_WPTR_POLL_ADDR__WPTR_ADDR_MASK = 0xfffffff8L;
constexpr unsigned int CP_HQD_QUANTUM__QUANTUM_ACTIVE_MASK      = 0x80000000L;
constexpr unsigned int CP_HQD_QUANTUM__QUANTUM_DURATION_MASK    = 0x00003f00L;
constexpr unsigned int CP_HQD_QUANTUM__QUANTUM_EN_MASK          = 0x00000001L;
constexpr unsigned int CP_HQD_QUANTUM__QUANTUM_SCALE_MASK       = 0x00000010L;
constexpr unsigned int CP_HQD_QUEUE_PRIORITY__PRIORITY_LEVEL_MASK = 0x0000000fL;
constexpr unsigned int CP_HQD_SEMA_CMD__RESULT_MASK             = 0x00000006L;
constexpr unsigned int CP_HQD_SEMA_CMD__RETRY_MASK              = 0x00000001L;
constexpr unsigned int CP_HQD_VMID__IB_VMID_MASK                = 0x00000f00L;
constexpr unsigned int CP_HQD_VMID__VMID_MASK                   = 0x0000000fL;
constexpr unsigned int CP_HQD_VMID__VQID_MASK                   = 0x03ff0000L;
constexpr unsigned int CP_HQD_WG_STATE_OFFSET__OFFSET_MASK      = 0x01fffffcL;
constexpr unsigned int CP_IB1_BASE_HI__IB1_BASE_HI_MASK         = 0x0000ffffL;
constexpr unsigned int CP_IB1_BASE_LO__IB1_BASE_LO_MASK         = 0xfffffffcL;
constexpr unsigned int CP_IB1_BUFSZ__IB1_BUFSZ_MASK             = 0x000fffffL;
constexpr unsigned int CP_IB1_CMD_BUFSZ__IB1_CMD_REQSZ_MASK     = 0x000fffffL;
constexpr unsigned int CP_IB1_OFFSET__IB1_OFFSET_MASK           = 0x000fffffL;
constexpr unsigned int CP_IB1_PREAMBLE_BEGIN__IB1_PREAMBLE_BEGIN_MASK = 0x000fffffL;
constexpr unsigned int CP_IB1_PREAMBLE_END__IB1_PREAMBLE_END_MASK = 0x000fffffL;
constexpr unsigned int CP_IB2_BASE_HI__IB2_BASE_HI_MASK         = 0x0000ffffL;
constexpr unsigned int CP_IB2_BASE_LO__IB2_BASE_LO_MASK         = 0xfffffffcL;
constexpr unsigned int CP_IB2_BUFSZ__IB2_BUFSZ_MASK             = 0x000fffffL;
constexpr unsigned int CP_IB2_CMD_BUFSZ__IB2_CMD_REQSZ_MASK     = 0x000fffffL;
constexpr unsigned int CP_IB2_OFFSET__IB2_OFFSET_MASK           = 0x000fffffL;
constexpr unsigned int CP_IB2_PREAMBLE_BEGIN__IB2_PREAMBLE_BEGIN_MASK = 0x000fffffL;
constexpr unsigned int CP_IB2_PREAMBLE_END__IB2_PREAMBLE_END_MASK = 0x000fffffL;
constexpr unsigned int CP_INDEX_BASE_ADDR_HI__ADDR_HI_MASK      = 0x0000ffffL;
constexpr unsigned int CP_INDEX_BASE_ADDR__ADDR_LO_MASK         = 0xffffffffL;
constexpr unsigned int CP_INDEX_TYPE__INDEX_TYPE_MASK           = 0x00000003L;
constexpr unsigned int CP_INT_CNTL_RING0__CMP_BUSY_INT_ENABLE_MASK = 0x00040000L;
constexpr unsigned int CP_INT_CNTL_RING0__CNTX_BUSY_INT_ENABLE_MASK = 0x00080000L;
constexpr unsigned int CP_INT_CNTL_RING0__CNTX_EMPTY_INT_ENABLE_MASK = 0x00100000L;
constexpr unsigned int CP_INT_CNTL_RING0__CP_ECC_ERROR_INT_ENABLE_MASK = 0x00004000L;
constexpr unsigned int CP_INT_CNTL_RING0__CP_VM_DOORBELL_WR_INT_ENABLE_MASK = 0x00000800L;
constexpr unsigned int CP_INT_CNTL_RING0__GENERIC0_INT_ENABLE_MASK = 0x80000000L;
constexpr unsigned int CP_INT_CNTL_RING0__GENERIC1_INT_ENABLE_MASK = 0x40000000L;
constexpr unsigned int CP_INT_CNTL_RING0__GENERIC2_INT_ENABLE_MASK = 0x20000000L;
constexpr unsigned int CP_INT_CNTL_RING0__GFX_IDLE_INT_ENABLE_MASK = 0x00200000L;
constexpr unsigned int CP_INT_CNTL_RING0__GPF_INT_ENABLE_MASK   = 0x00010000L;
constexpr unsigned int CP_INT_CNTL_RING0__OPCODE_ERROR_INT_ENABLE_MASK = 0x01000000L;
constexpr unsigned int CP_INT_CNTL_RING0__PRIV_INSTR_INT_ENABLE_MASK = 0x00400000L;
constexpr unsigned int CP_INT_CNTL_RING0__PRIV_REG_INT_ENABLE_MASK = 0x00800000L;
constexpr unsigned int CP_INT_CNTL_RING0__RESERVED_BIT_ERROR_INT_ENABLE_MASK = 0x08000000L;
constexpr unsigned int CP_INT_CNTL_RING0__TIME_STAMP_INT_ENABLE_MASK = 0x04000000L;
constexpr unsigned int CP_INT_CNTL_RING0__WRM_POLL_TIMEOUT_INT_ENABLE_MASK = 0x00020000L;
constexpr unsigned int CP_INT_CNTL_RING1__CMP_BUSY_INT_ENABLE_MASK = 0x00040000L;
constexpr unsigned int CP_INT_CNTL_RING1__CNTX_BUSY_INT_ENABLE_MASK = 0x00080000L;
constexpr unsigned int CP_INT_CNTL_RING1__CNTX_EMPTY_INT_ENABLE_MASK = 0x00100000L;
constexpr unsigned int CP_INT_CNTL_RING1__CP_ECC_ERROR_INT_ENABLE_MASK = 0x00004000L;
constexpr unsigned int CP_INT_CNTL_RING1__CP_VM_DOORBELL_WR_INT_ENABLE_MASK = 0x00000800L;
constexpr unsigned int CP_INT_CNTL_RING1__GENERIC0_INT_ENABLE_MASK = 0x80000000L;
constexpr unsigned int CP_INT_CNTL_RING1__GENERIC1_INT_ENABLE_MASK = 0x40000000L;
constexpr unsigned int CP_INT_CNTL_RING1__GENERIC2_INT_ENABLE_MASK = 0x20000000L;
constexpr unsigned int CP_INT_CNTL_RING1__GFX_IDLE_INT_ENABLE_MASK = 0x00200000L;
constexpr unsigned int CP_INT_CNTL_RING1__GPF_INT_ENABLE_MASK   = 0x00010000L;
constexpr unsigned int CP_INT_CNTL_RING1__OPCODE_ERROR_INT_ENABLE_MASK = 0x01000000L;
constexpr unsigned int CP_INT_CNTL_RING1__PRIV_INSTR_INT_ENABLE_MASK = 0x00400000L;
constexpr unsigned int CP_INT_CNTL_RING1__PRIV_REG_INT_ENABLE_MASK = 0x00800000L;
constexpr unsigned int CP_INT_CNTL_RING1__RESERVED_BIT_ERROR_INT_ENABLE_MASK = 0x08000000L;
constexpr unsigned int CP_INT_CNTL_RING1__TIME_STAMP_INT_ENABLE_MASK = 0x04000000L;
constexpr unsigned int CP_INT_CNTL_RING1__WRM_POLL_TIMEOUT_INT_ENABLE_MASK = 0x00020000L;
constexpr unsigned int CP_INT_CNTL_RING2__CMP_BUSY_INT_ENABLE_MASK = 0x00040000L;
constexpr unsigned int CP_INT_CNTL_RING2__CNTX_BUSY_INT_ENABLE_MASK = 0x00080000L;
constexpr unsigned int CP_INT_CNTL_RING2__CNTX_EMPTY_INT_ENABLE_MASK = 0x00100000L;
constexpr unsigned int CP_INT_CNTL_RING2__CP_ECC_ERROR_INT_ENABLE_MASK = 0x00004000L;
constexpr unsigned int CP_INT_CNTL_RING2__CP_VM_DOORBELL_WR_INT_ENABLE_MASK = 0x00000800L;
constexpr unsigned int CP_INT_CNTL_RING2__GENERIC0_INT_ENABLE_MASK = 0x80000000L;
constexpr unsigned int CP_INT_CNTL_RING2__GENERIC1_INT_ENABLE_MASK = 0x40000000L;
constexpr unsigned int CP_INT_CNTL_RING2__GENERIC2_INT_ENABLE_MASK = 0x20000000L;
constexpr unsigned int CP_INT_CNTL_RING2__GFX_IDLE_INT_ENABLE_MASK = 0x00200000L;
constexpr unsigned int CP_INT_CNTL_RING2__GPF_INT_ENABLE_MASK   = 0x00010000L;
constexpr unsigned int CP_INT_CNTL_RING2__OPCODE_ERROR_INT_ENABLE_MASK = 0x01000000L;
constexpr unsigned int CP_INT_CNTL_RING2__PRIV_INSTR_INT_ENABLE_MASK = 0x00400000L;
constexpr unsigned int CP_INT_CNTL_RING2__PRIV_REG_INT_ENABLE_MASK = 0x00800000L;
constexpr unsigned int CP_INT_CNTL_RING2__RESERVED_BIT_ERROR_INT_ENABLE_MASK = 0x08000000L;
constexpr unsigned int CP_INT_CNTL_RING2__TIME_STAMP_INT_ENABLE_MASK = 0x04000000L;
constexpr unsigned int CP_INT_CNTL_RING2__WRM_POLL_TIMEOUT_INT_ENABLE_MASK = 0x00020000L;
constexpr unsigned int CP_INT_CNTL__CMP_BUSY_INT_ENABLE_MASK    = 0x00040000L;
constexpr unsigned int CP_INT_CNTL__CNTX_BUSY_INT_ENABLE_MASK   = 0x00080000L;
constexpr unsigned int CP_INT_CNTL__CNTX_EMPTY_INT_ENABLE_MASK  = 0x00100000L;
constexpr unsigned int CP_INT_CNTL__CP_ECC_ERROR_INT_ENABLE_MASK = 0x00004000L;
constexpr unsigned int CP_INT_CNTL__CP_VM_DOORBELL_WR_INT_ENABLE_MASK = 0x00000800L;
constexpr unsigned int CP_INT_CNTL__GENERIC0_INT_ENABLE_MASK    = 0x80000000L;
constexpr unsigned int CP_INT_CNTL__GENERIC1_INT_ENABLE_MASK    = 0x40000000L;
constexpr unsigned int CP_INT_CNTL__GENERIC2_INT_ENABLE_MASK    = 0x20000000L;
constexpr unsigned int CP_INT_CNTL__GFX_IDLE_INT_ENABLE_MASK    = 0x00200000L;
constexpr unsigned int CP_INT_CNTL__GPF_INT_ENABLE_MASK         = 0x00010000L;
constexpr unsigned int CP_INT_CNTL__OPCODE_ERROR_INT_ENABLE_MASK = 0x01000000L;
constexpr unsigned int CP_INT_CNTL__PRIV_INSTR_INT_ENABLE_MASK  = 0x00400000L;
constexpr unsigned int CP_INT_CNTL__PRIV_REG_INT_ENABLE_MASK    = 0x00800000L;
constexpr unsigned int CP_INT_CNTL__RESERVED_BIT_ERROR_INT_ENABLE_MASK = 0x08000000L;
constexpr unsigned int CP_INT_CNTL__TIME_STAMP_INT_ENABLE_MASK  = 0x04000000L;
constexpr unsigned int CP_INT_CNTL__WRM_POLL_TIMEOUT_INT_ENABLE_MASK = 0x00020000L;
constexpr unsigned int CP_INT_STATUS_RING0__CMP_BUSY_INT_STAT_MASK = 0x00040000L;
constexpr unsigned int CP_INT_STATUS_RING0__CNTX_EMPTY_INT_STAT_MASK = 0x00100000L;
constexpr unsigned int CP_INT_STATUS_RING0__CP_ECC_ERROR_INT_STAT_MASK = 0x00004000L;
constexpr unsigned int CP_INT_STATUS_RING0__CP_VM_DOORBELL_WR_INT_STAT_MASK = 0x00000800L;
constexpr unsigned int CP_INT_STATUS_RING0__GCNTX_BUSY_INT_STAT_MASK = 0x00080000L;
constexpr unsigned int CP_INT_STATUS_RING0__GENERIC0_INT_STAT_MASK = 0x80000000L;
constexpr unsigned int CP_INT_STATUS_RING0__GENERIC1_INT_STAT_MASK = 0x40000000L;
constexpr unsigned int CP_INT_STATUS_RING0__GENERIC2_INT_STAT_MASK = 0x20000000L;
constexpr unsigned int CP_INT_STATUS_RING0__GFX_IDLE_INT_STAT_MASK = 0x00200000L;
constexpr unsigned int CP_INT_STATUS_RING0__GPF_INT_STAT_MASK   = 0x00010000L;
constexpr unsigned int CP_INT_STATUS_RING0__OPCODE_ERROR_INT_STAT_MASK = 0x01000000L;
constexpr unsigned int CP_INT_STATUS_RING0__PRIV_INSTR_INT_STAT_MASK = 0x00400000L;
constexpr unsigned int CP_INT_STATUS_RING0__PRIV_REG_INT_STAT_MASK = 0x00800000L;
constexpr unsigned int CP_INT_STATUS_RING0__RESERVED_BIT_ERROR_INT_STAT_MASK = 0x08000000L;
constexpr unsigned int CP_INT_STATUS_RING0__TIME_STAMP_INT_STAT_MASK = 0x04000000L;
constexpr unsigned int CP_INT_STATUS_RING0__WRM_POLL_TIMEOUT_INT_STAT_MASK = 0x00020000L;
constexpr unsigned int CP_INT_STATUS_RING1__CMP_BUSY_INT_STAT_MASK = 0x00040000L;
constexpr unsigned int CP_INT_STATUS_RING1__CNTX_BUSY_INT_STAT_MASK = 0x00080000L;
constexpr unsigned int CP_INT_STATUS_RING1__CNTX_EMPTY_INT_STAT_MASK = 0x00100000L;
constexpr unsigned int CP_INT_STATUS_RING1__CP_ECC_ERROR_INT_STAT_MASK = 0x00004000L;
constexpr unsigned int CP_INT_STATUS_RING1__CP_VM_DOORBELL_WR_INT_STAT_MASK = 0x00000800L;
constexpr unsigned int CP_INT_STATUS_RING1__GENERIC0_INT_STAT_MASK = 0x80000000L;
constexpr unsigned int CP_INT_STATUS_RING1__GENERIC1_INT_STAT_MASK = 0x40000000L;
constexpr unsigned int CP_INT_STATUS_RING1__GENERIC2_INT_STAT_MASK = 0x20000000L;
constexpr unsigned int CP_INT_STATUS_RING1__GFX_IDLE_INT_STAT_MASK = 0x00200000L;
constexpr unsigned int CP_INT_STATUS_RING1__GPF_INT_STAT_MASK   = 0x00010000L;
constexpr unsigned int CP_INT_STATUS_RING1__OPCODE_ERROR_INT_STAT_MASK = 0x01000000L;
constexpr unsigned int CP_INT_STATUS_RING1__PRIV_INSTR_INT_STAT_MASK = 0x00400000L;
constexpr unsigned int CP_INT_STATUS_RING1__PRIV_REG_INT_STAT_MASK = 0x00800000L;
constexpr unsigned int CP_INT_STATUS_RING1__RESERVED_BIT_ERROR_INT_STAT_MASK = 0x08000000L;
constexpr unsigned int CP_INT_STATUS_RING1__TIME_STAMP_INT_STAT_MASK = 0x04000000L;
constexpr unsigned int CP_INT_STATUS_RING1__WRM_POLL_TIMEOUT_INT_STAT_MASK = 0x00020000L;
constexpr unsigned int CP_INT_STATUS_RING2__CMP_BUSY_INT_STAT_MASK = 0x00040000L;
constexpr unsigned int CP_INT_STATUS_RING2__CNTX_BUSY_INT_STAT_MASK = 0x00080000L;
constexpr unsigned int CP_INT_STATUS_RING2__CNTX_EMPTY_INT_STAT_MASK = 0x00100000L;
constexpr unsigned int CP_INT_STATUS_RING2__CP_ECC_ERROR_INT_STAT_MASK = 0x00004000L;
constexpr unsigned int CP_INT_STATUS_RING2__CP_VM_DOORBELL_WR_INT_STAT_MASK = 0x00000800L;
constexpr unsigned int CP_INT_STATUS_RING2__GENERIC0_INT_STAT_MASK = 0x80000000L;
constexpr unsigned int CP_INT_STATUS_RING2__GENERIC1_INT_STAT_MASK = 0x40000000L;
constexpr unsigned int CP_INT_STATUS_RING2__GENERIC2_INT_STAT_MASK = 0x20000000L;
constexpr unsigned int CP_INT_STATUS_RING2__GFX_IDLE_INT_STAT_MASK = 0x00200000L;
constexpr unsigned int CP_INT_STATUS_RING2__GPF_INT_STAT_MASK   = 0x00010000L;
constexpr unsigned int CP_INT_STATUS_RING2__OPCODE_ERROR_INT_STAT_MASK = 0x01000000L;
constexpr unsigned int CP_INT_STATUS_RING2__PRIV_INSTR_INT_STAT_MASK = 0x00400000L;
constexpr unsigned int CP_INT_STATUS_RING2__PRIV_REG_INT_STAT_MASK = 0x00800000L;
constexpr unsigned int CP_INT_STATUS_RING2__RESERVED_BIT_ERROR_INT_STAT_MASK = 0x08000000L;
constexpr unsigned int CP_INT_STATUS_RING2__TIME_STAMP_INT_STAT_MASK = 0x04000000L;
constexpr unsigned int CP_INT_STATUS_RING2__WRM_POLL_TIMEOUT_INT_STAT_MASK = 0x00020000L;
constexpr unsigned int CP_INT_STATUS__CMP_BUSY_INT_STAT_MASK    = 0x00040000L;
constexpr unsigned int CP_INT_STATUS__CNTX_BUSY_INT_STAT_MASK   = 0x00080000L;
constexpr unsigned int CP_INT_STATUS__CNTX_EMPTY_INT_STAT_MASK  = 0x00100000L;
constexpr unsigned int CP_INT_STATUS__CP_ECC_ERROR_INT_STAT_MASK = 0x00004000L;
constexpr unsigned int CP_INT_STATUS__CP_VM_DOORBELL_WR_INT_STAT_MASK = 0x00000800L;
constexpr unsigned int CP_INT_STATUS__GENERIC0_INT_STAT_MASK    = 0x80000000L;
constexpr unsigned int CP_INT_STATUS__GENERIC1_INT_STAT_MASK    = 0x40000000L;
constexpr unsigned int CP_INT_STATUS__GENERIC2_INT_STAT_MASK    = 0x20000000L;
constexpr unsigned int CP_INT_STATUS__GFX_IDLE_INT_STAT_MASK    = 0x00200000L;
constexpr unsigned int CP_INT_STATUS__GPF_INT_STAT_MASK         = 0x00010000L;
constexpr unsigned int CP_INT_STATUS__OPCODE_ERROR_INT_STAT_MASK = 0x01000000L;
constexpr unsigned int CP_INT_STATUS__PRIV_INSTR_INT_STAT_MASK  = 0x00400000L;
constexpr unsigned int CP_INT_STATUS__PRIV_REG_INT_STAT_MASK    = 0x00800000L;
constexpr unsigned int CP_INT_STATUS__RESERVED_BIT_ERROR_INT_STAT_MASK = 0x08000000L;
constexpr unsigned int CP_INT_STATUS__TIME_STAMP_INT_STAT_MASK  = 0x04000000L;
constexpr unsigned int CP_INT_STATUS__WRM_POLL_TIMEOUT_INT_STAT_MASK = 0x00020000L;
constexpr unsigned int CP_INT_STAT_DEBUG__CMP_BUSY_INT_ASSERTED_MASK = 0x00040000L;
constexpr unsigned int CP_INT_STAT_DEBUG__CNTX_BUSY_INT_ASSERTED_MASK = 0x00080000L;
constexpr unsigned int CP_INT_STAT_DEBUG__CNTX_EMPTY_INT_ASSERTED_MASK = 0x00100000L;
constexpr unsigned int CP_INT_STAT_DEBUG__CP_ECC_ERROR_INT_ASSERTED_MASK = 0x00004000L;
constexpr unsigned int CP_INT_STAT_DEBUG__CP_VM_DOORBELL_WR_INT_ASSERTED_MASK = 0x00000800L;
constexpr unsigned int CP_INT_STAT_DEBUG__GENERIC0_INT_ASSERTED_MASK = 0x80000000L;
constexpr unsigned int CP_INT_STAT_DEBUG__GENERIC1_INT_ASSERTED_MASK = 0x40000000L;
constexpr unsigned int CP_INT_STAT_DEBUG__GENERIC2_INT_ASSERTED_MASK = 0x20000000L;
constexpr unsigned int CP_INT_STAT_DEBUG__GFX_IDLE_INT_ASSERTED_MASK = 0x00200000L;
constexpr unsigned int CP_INT_STAT_DEBUG__GPF_INT_ASSERTED_MASK = 0x00010000L;
constexpr unsigned int CP_INT_STAT_DEBUG__OPCODE_ERROR_INT_ASSERTED_MASK = 0x01000000L;
constexpr unsigned int CP_INT_STAT_DEBUG__PRIV_INSTR_INT_ASSERTED_MASK = 0x00400000L;
constexpr unsigned int CP_INT_STAT_DEBUG__PRIV_REG_INT_ASSERTED_MASK = 0x00800000L;
constexpr unsigned int CP_INT_STAT_DEBUG__RESERVED_BIT_ERROR_INT_ASSERTED_MASK = 0x08000000L;
constexpr unsigned int CP_INT_STAT_DEBUG__TIME_STAMP_INT_ASSERTED_MASK = 0x04000000L;
constexpr unsigned int CP_INT_STAT_DEBUG__WRM_POLL_TIMEOUT_INT_ASSERTED_MASK = 0x00020000L;
constexpr unsigned int CP_IQ_WAIT_TIME1__ATOMIC_OFFLOAD_MASK    = 0x0000ff00L;
constexpr unsigned int CP_IQ_WAIT_TIME1__GWS_MASK               = 0xff000000L;
constexpr unsigned int CP_IQ_WAIT_TIME1__IB_OFFLOAD_MASK        = 0x000000ffL;
constexpr unsigned int CP_IQ_WAIT_TIME1__WRM_OFFLOAD_MASK       = 0x00ff0000L;
constexpr unsigned int CP_IQ_WAIT_TIME2__DEQ_RETRY_MASK         = 0xff000000L;
constexpr unsigned int CP_IQ_WAIT_TIME2__QUE_SLEEP_MASK         = 0x000000ffL;
constexpr unsigned int CP_IQ_WAIT_TIME2__SCH_WAVE_MASK          = 0x0000ff00L;
constexpr unsigned int CP_IQ_WAIT_TIME2__SEM_REARM_MASK         = 0x00ff0000L;
constexpr unsigned int CP_MAX_CONTEXT__MAX_CONTEXT_MASK         = 0x00000007L;
constexpr unsigned int CP_ME0_PIPE0_PRIORITY__PRIORITY_MASK     = 0x00000003L;
constexpr unsigned int CP_ME0_PIPE0_VMID__VMID_MASK             = 0x0000000fL;
constexpr unsigned int CP_ME0_PIPE1_PRIORITY__PRIORITY_MASK     = 0x00000003L;
constexpr unsigned int CP_ME0_PIPE1_VMID__VMID_MASK             = 0x0000000fL;
constexpr unsigned int CP_ME0_PIPE2_PRIORITY__PRIORITY_MASK     = 0x00000003L;
constexpr unsigned int CP_ME0_PIPE_PRIORITY_CNTS__PRIORITY1_CNT_MASK = 0x000000ffL;
constexpr unsigned int CP_ME0_PIPE_PRIORITY_CNTS__PRIORITY2A_CNT_MASK = 0x0000ff00L;
constexpr unsigned int CP_ME0_PIPE_PRIORITY_CNTS__PRIORITY2B_CNT_MASK = 0x00ff0000L;
constexpr unsigned int CP_ME0_PIPE_PRIORITY_CNTS__PRIORITY3_CNT_MASK = 0xff000000L;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__CMP_QUERY_STATUS_INT_ASSERTED_MASK = 0x00001000L;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__CP_ECC_ERROR_INT_ASSERTED_MASK = 0x00004000L;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__DEQUEUE_REQUEST_INT_ASSERTED_MASK = 0x00002000L;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__GENERIC0_INT_ASSERTED_MASK = 0x80000000L;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__GENERIC1_INT_ASSERTED_MASK = 0x40000000L;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__GENERIC2_INT_ASSERTED_MASK = 0x20000000L;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__GPF_INT_ASSERTED_MASK = 0x00010000L;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__OPCODE_ERROR_INT_ASSERTED_MASK = 0x01000000L;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__PRIV_REG_INT_ASSERTED_MASK = 0x00800000L;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__RESERVED_BIT_ERROR_INT_ASSERTED_MASK = 0x08000000L;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__SUA_VIOLATION_INT_STATUS_MASK = 0x00008000L;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__TIME_STAMP_INT_ASSERTED_MASK = 0x04000000L;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__WRM_POLL_TIMEOUT_INT_ASSERTED_MASK = 0x00020000L;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__CMP_QUERY_STATUS_INT_ENABLE_MASK = 0x00001000L;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__CP_ECC_ERROR_INT_ENABLE_MASK = 0x00004000L;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__DEQUEUE_REQUEST_INT_ENABLE_MASK = 0x00002000L;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__GENERIC0_INT_ENABLE_MASK = 0x80000000L;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__GENERIC1_INT_ENABLE_MASK = 0x40000000L;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__GENERIC2_INT_ENABLE_MASK = 0x20000000L;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__GPF_INT_ENABLE_MASK = 0x00010000L;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__OPCODE_ERROR_INT_ENABLE_MASK = 0x01000000L;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__PRIV_REG_INT_ENABLE_MASK = 0x00800000L;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__RESERVED_BIT_ERROR_INT_ENABLE_MASK = 0x08000000L;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__SUA_VIOLATION_INT_ENABLE_MASK = 0x00008000L;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__TIME_STAMP_INT_ENABLE_MASK = 0x04000000L;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__WRM_POLL_TIMEOUT_INT_ENABLE_MASK = 0x00020000L;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__CMP_QUERY_STATUS_INT_STATUS_MASK = 0x00001000L;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__CP_ECC_ERROR_INT_STATUS_MASK = 0x00004000L;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__DEQUEUE_REQUEST_INT_STATUS_MASK = 0x00002000L;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__GENERIC0_INT_STATUS_MASK = 0x80000000L;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__GENERIC1_INT_STATUS_MASK = 0x40000000L;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__GENERIC2_INT_STATUS_MASK = 0x20000000L;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__GPF_INT_STATUS_MASK = 0x00010000L;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__OPCODE_ERROR_INT_STATUS_MASK = 0x01000000L;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__PRIV_REG_INT_STATUS_MASK = 0x00800000L;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__RESERVED_BIT_ERROR_INT_STATUS_MASK = 0x08000000L;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__SUA_VIOLATION_INT_STATUS_MASK = 0x00008000L;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__TIME_STAMP_INT_STATUS_MASK = 0x04000000L;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__WRM_POLL_TIMEOUT_INT_STATUS_MASK = 0x00020000L;
constexpr unsigned int CP_ME1_PIPE0_PRIORITY__PRIORITY_MASK     = 0x00000003L;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__CMP_QUERY_STATUS_INT_ENABLE_MASK = 0x00001000L;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__CP_ECC_ERROR_INT_ENABLE_MASK = 0x00004000L;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__DEQUEUE_REQUEST_INT_ENABLE_MASK = 0x00002000L;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__GENERIC0_INT_ENABLE_MASK = 0x80000000L;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__GENERIC1_INT_ENABLE_MASK = 0x40000000L;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__GENERIC2_INT_ENABLE_MASK = 0x20000000L;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__GPF_INT_ENABLE_MASK = 0x00010000L;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__OPCODE_ERROR_INT_ENABLE_MASK = 0x01000000L;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__PRIV_REG_INT_ENABLE_MASK = 0x00800000L;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__RESERVED_BIT_ERROR_INT_ENABLE_MASK = 0x08000000L;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__SUA_VIOLATION_INT_ENABLE_MASK = 0x00008000L;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__TIME_STAMP_INT_ENABLE_MASK = 0x04000000L;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__WRM_POLL_TIMEOUT_INT_ENABLE_MASK = 0x00020000L;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__CMP_QUERY_STATUS_INT_STATUS_MASK = 0x00001000L;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__CP_ECC_ERROR_INT_STATUS_MASK = 0x00004000L;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__DEQUEUE_REQUEST_INT_STATUS_MASK = 0x00002000L;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__GENERIC0_INT_STATUS_MASK = 0x80000000L;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__GENERIC1_INT_STATUS_MASK = 0x40000000L;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__GENERIC2_INT_STATUS_MASK = 0x20000000L;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__GPF_INT_STATUS_MASK = 0x00010000L;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__OPCODE_ERROR_INT_STATUS_MASK = 0x01000000L;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__PRIV_REG_INT_STATUS_MASK = 0x00800000L;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__RESERVED_BIT_ERROR_INT_STATUS_MASK = 0x08000000L;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__SUA_VIOLATION_INT_STATUS_MASK = 0x00008000L;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__TIME_STAMP_INT_STATUS_MASK = 0x04000000L;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__WRM_POLL_TIMEOUT_INT_STATUS_MASK = 0x00020000L;
constexpr unsigned int CP_ME1_PIPE1_PRIORITY__PRIORITY_MASK     = 0x00000003L;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__CMP_QUERY_STATUS_INT_ENABLE_MASK = 0x00001000L;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__CP_ECC_ERROR_INT_ENABLE_MASK = 0x00004000L;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__DEQUEUE_REQUEST_INT_ENABLE_MASK = 0x00002000L;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__GENERIC0_INT_ENABLE_MASK = 0x80000000L;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__GENERIC1_INT_ENABLE_MASK = 0x40000000L;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__GENERIC2_INT_ENABLE_MASK = 0x20000000L;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__GPF_INT_ENABLE_MASK = 0x00010000L;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__OPCODE_ERROR_INT_ENABLE_MASK = 0x01000000L;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__PRIV_REG_INT_ENABLE_MASK = 0x00800000L;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__RESERVED_BIT_ERROR_INT_ENABLE_MASK = 0x08000000L;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__SUA_VIOLATION_INT_ENABLE_MASK = 0x00008000L;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__TIME_STAMP_INT_ENABLE_MASK = 0x04000000L;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__WRM_POLL_TIMEOUT_INT_ENABLE_MASK = 0x00020000L;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__CMP_QUERY_STATUS_INT_STATUS_MASK = 0x00001000L;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__CP_ECC_ERROR_INT_STATUS_MASK = 0x00004000L;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__DEQUEUE_REQUEST_INT_STATUS_MASK = 0x00002000L;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__GENERIC0_INT_STATUS_MASK = 0x80000000L;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__GENERIC1_INT_STATUS_MASK = 0x40000000L;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__GENERIC2_INT_STATUS_MASK = 0x20000000L;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__GPF_INT_STATUS_MASK = 0x00010000L;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__OPCODE_ERROR_INT_STATUS_MASK = 0x01000000L;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__PRIV_REG_INT_STATUS_MASK = 0x00800000L;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__RESERVED_BIT_ERROR_INT_STATUS_MASK = 0x08000000L;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__SUA_VIOLATION_INT_STATUS_MASK = 0x00008000L;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__TIME_STAMP_INT_STATUS_MASK = 0x04000000L;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__WRM_POLL_TIMEOUT_INT_STATUS_MASK = 0x00020000L;
constexpr unsigned int CP_ME1_PIPE2_PRIORITY__PRIORITY_MASK     = 0x00000003L;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__CMP_QUERY_STATUS_INT_ENABLE_MASK = 0x00001000L;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__CP_ECC_ERROR_INT_ENABLE_MASK = 0x00004000L;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__DEQUEUE_REQUEST_INT_ENABLE_MASK = 0x00002000L;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__GENERIC0_INT_ENABLE_MASK = 0x80000000L;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__GENERIC1_INT_ENABLE_MASK = 0x40000000L;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__GENERIC2_INT_ENABLE_MASK = 0x20000000L;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__GPF_INT_ENABLE_MASK = 0x00010000L;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__OPCODE_ERROR_INT_ENABLE_MASK = 0x01000000L;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__PRIV_REG_INT_ENABLE_MASK = 0x00800000L;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__RESERVED_BIT_ERROR_INT_ENABLE_MASK = 0x08000000L;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__SUA_VIOLATION_INT_ENABLE_MASK = 0x00008000L;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__TIME_STAMP_INT_ENABLE_MASK = 0x04000000L;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__WRM_POLL_TIMEOUT_INT_ENABLE_MASK = 0x00020000L;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__CMP_QUERY_STATUS_INT_STATUS_MASK = 0x00001000L;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__CP_ECC_ERROR_INT_STATUS_MASK = 0x00004000L;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__DEQUEUE_REQUEST_INT_STATUS_MASK = 0x00002000L;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__GENERIC0_INT_STATUS_MASK = 0x80000000L;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__GENERIC1_INT_STATUS_MASK = 0x40000000L;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__GENERIC2_INT_STATUS_MASK = 0x20000000L;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__GPF_INT_STATUS_MASK = 0x00010000L;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__OPCODE_ERROR_INT_STATUS_MASK = 0x01000000L;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__PRIV_REG_INT_STATUS_MASK = 0x00800000L;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__RESERVED_BIT_ERROR_INT_STATUS_MASK = 0x08000000L;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__SUA_VIOLATION_INT_STATUS_MASK = 0x00008000L;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__TIME_STAMP_INT_STATUS_MASK = 0x04000000L;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__WRM_POLL_TIMEOUT_INT_STATUS_MASK = 0x00020000L;
constexpr unsigned int CP_ME1_PIPE3_PRIORITY__PRIORITY_MASK     = 0x00000003L;
constexpr unsigned int CP_ME1_PIPE_PRIORITY_CNTS__PRIORITY1_CNT_MASK = 0x000000ffL;
constexpr unsigned int CP_ME1_PIPE_PRIORITY_CNTS__PRIORITY2A_CNT_MASK = 0x0000ff00L;
constexpr unsigned int CP_ME1_PIPE_PRIORITY_CNTS__PRIORITY2B_CNT_MASK = 0x00ff0000L;
constexpr unsigned int CP_ME1_PIPE_PRIORITY_CNTS__PRIORITY3_CNT_MASK = 0xff000000L;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__CMP_QUERY_STATUS_INT_ASSERTED_MASK = 0x00001000L;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__CP_ECC_ERROR_INT_ASSERTED_MASK = 0x00004000L;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__DEQUEUE_REQUEST_INT_ASSERTED_MASK = 0x00002000L;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__GENERIC0_INT_ASSERTED_MASK = 0x80000000L;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__GENERIC1_INT_ASSERTED_MASK = 0x40000000L;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__GENERIC2_INT_ASSERTED_MASK = 0x20000000L;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__GPF_INT_ASSERTED_MASK = 0x00010000L;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__OPCODE_ERROR_INT_ASSERTED_MASK = 0x01000000L;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__PRIV_REG_INT_ASSERTED_MASK = 0x00800000L;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__RESERVED_BIT_ERROR_INT_ASSERTED_MASK = 0x08000000L;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__SUA_VIOLATION_INT_STATUS_MASK = 0x00008000L;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__TIME_STAMP_INT_ASSERTED_MASK = 0x04000000L;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__WRM_POLL_TIMEOUT_INT_ASSERTED_MASK = 0x00020000L;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__CMP_QUERY_STATUS_INT_ENABLE_MASK = 0x00001000L;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__CP_ECC_ERROR_INT_ENABLE_MASK = 0x00004000L;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__DEQUEUE_REQUEST_INT_ENABLE_MASK = 0x00002000L;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__GENERIC0_INT_ENABLE_MASK = 0x80000000L;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__GENERIC1_INT_ENABLE_MASK = 0x40000000L;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__GENERIC2_INT_ENABLE_MASK = 0x20000000L;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__GPF_INT_ENABLE_MASK = 0x00010000L;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__OPCODE_ERROR_INT_ENABLE_MASK = 0x01000000L;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__PRIV_REG_INT_ENABLE_MASK = 0x00800000L;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__RESERVED_BIT_ERROR_INT_ENABLE_MASK = 0x08000000L;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__SUA_VIOLATION_INT_ENABLE_MASK = 0x00008000L;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__TIME_STAMP_INT_ENABLE_MASK = 0x04000000L;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__WRM_POLL_TIMEOUT_INT_ENABLE_MASK = 0x00020000L;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__CMP_QUERY_STATUS_INT_STATUS_MASK = 0x00001000L;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__CP_ECC_ERROR_INT_STATUS_MASK = 0x00004000L;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__DEQUEUE_REQUEST_INT_STATUS_MASK = 0x00002000L;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__GENERIC0_INT_STATUS_MASK = 0x80000000L;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__GENERIC1_INT_STATUS_MASK = 0x40000000L;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__GENERIC2_INT_STATUS_MASK = 0x20000000L;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__GPF_INT_STATUS_MASK = 0x00010000L;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__OPCODE_ERROR_INT_STATUS_MASK = 0x01000000L;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__PRIV_REG_INT_STATUS_MASK = 0x00800000L;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__RESERVED_BIT_ERROR_INT_STATUS_MASK = 0x08000000L;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__SUA_VIOLATION_INT_STATUS_MASK = 0x00008000L;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__TIME_STAMP_INT_STATUS_MASK = 0x04000000L;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__WRM_POLL_TIMEOUT_INT_STATUS_MASK = 0x00020000L;
constexpr unsigned int CP_ME2_PIPE0_PRIORITY__PRIORITY_MASK     = 0x00000003L;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__CMP_QUERY_STATUS_INT_ENABLE_MASK = 0x00001000L;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__CP_ECC_ERROR_INT_ENABLE_MASK = 0x00004000L;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__DEQUEUE_REQUEST_INT_ENABLE_MASK = 0x00002000L;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__GENERIC0_INT_ENABLE_MASK = 0x80000000L;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__GENERIC1_INT_ENABLE_MASK = 0x40000000L;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__GENERIC2_INT_ENABLE_MASK = 0x20000000L;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__GPF_INT_ENABLE_MASK = 0x00010000L;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__OPCODE_ERROR_INT_ENABLE_MASK = 0x01000000L;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__PRIV_REG_INT_ENABLE_MASK = 0x00800000L;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__RESERVED_BIT_ERROR_INT_ENABLE_MASK = 0x08000000L;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__SUA_VIOLATION_INT_ENABLE_MASK = 0x00008000L;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__TIME_STAMP_INT_ENABLE_MASK = 0x04000000L;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__WRM_POLL_TIMEOUT_INT_ENABLE_MASK = 0x00020000L;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__CMP_QUERY_STATUS_INT_STATUS_MASK = 0x00001000L;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__CP_ECC_ERROR_INT_STATUS_MASK = 0x00004000L;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__DEQUEUE_REQUEST_INT_STATUS_MASK = 0x00002000L;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__GENERIC0_INT_STATUS_MASK = 0x80000000L;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__GENERIC1_INT_STATUS_MASK = 0x40000000L;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__GENERIC2_INT_STATUS_MASK = 0x20000000L;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__GPF_INT_STATUS_MASK = 0x00010000L;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__OPCODE_ERROR_INT_STATUS_MASK = 0x01000000L;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__PRIV_REG_INT_STATUS_MASK = 0x00800000L;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__RESERVED_BIT_ERROR_INT_STATUS_MASK = 0x08000000L;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__SUA_VIOLATION_INT_STATUS_MASK = 0x00008000L;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__TIME_STAMP_INT_STATUS_MASK = 0x04000000L;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__WRM_POLL_TIMEOUT_INT_STATUS_MASK = 0x00020000L;
constexpr unsigned int CP_ME2_PIPE1_PRIORITY__PRIORITY_MASK     = 0x00000003L;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__CMP_QUERY_STATUS_INT_ENABLE_MASK = 0x00001000L;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__CP_ECC_ERROR_INT_ENABLE_MASK = 0x00004000L;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__DEQUEUE_REQUEST_INT_ENABLE_MASK = 0x00002000L;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__GENERIC0_INT_ENABLE_MASK = 0x80000000L;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__GENERIC1_INT_ENABLE_MASK = 0x40000000L;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__GENERIC2_INT_ENABLE_MASK = 0x20000000L;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__GPF_INT_ENABLE_MASK = 0x00010000L;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__OPCODE_ERROR_INT_ENABLE_MASK = 0x01000000L;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__PRIV_REG_INT_ENABLE_MASK = 0x00800000L;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__RESERVED_BIT_ERROR_INT_ENABLE_MASK = 0x08000000L;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__SUA_VIOLATION_INT_ENABLE_MASK = 0x00008000L;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__TIME_STAMP_INT_ENABLE_MASK = 0x04000000L;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__WRM_POLL_TIMEOUT_INT_ENABLE_MASK = 0x00020000L;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__CMP_QUERY_STATUS_INT_STATUS_MASK = 0x00001000L;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__CP_ECC_ERROR_INT_STATUS_MASK = 0x00004000L;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__DEQUEUE_REQUEST_INT_STATUS_MASK = 0x00002000L;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__GENERIC0_INT_STATUS_MASK = 0x80000000L;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__GENERIC1_INT_STATUS_MASK = 0x40000000L;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__GENERIC2_INT_STATUS_MASK = 0x20000000L;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__GPF_INT_STATUS_MASK = 0x00010000L;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__OPCODE_ERROR_INT_STATUS_MASK = 0x01000000L;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__PRIV_REG_INT_STATUS_MASK = 0x00800000L;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__RESERVED_BIT_ERROR_INT_STATUS_MASK = 0x08000000L;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__SUA_VIOLATION_INT_STATUS_MASK = 0x00008000L;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__TIME_STAMP_INT_STATUS_MASK = 0x04000000L;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__WRM_POLL_TIMEOUT_INT_STATUS_MASK = 0x00020000L;
constexpr unsigned int CP_ME2_PIPE2_PRIORITY__PRIORITY_MASK     = 0x00000003L;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__CMP_QUERY_STATUS_INT_ENABLE_MASK = 0x00001000L;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__CP_ECC_ERROR_INT_ENABLE_MASK = 0x00004000L;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__DEQUEUE_REQUEST_INT_ENABLE_MASK = 0x00002000L;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__GENERIC0_INT_ENABLE_MASK = 0x80000000L;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__GENERIC1_INT_ENABLE_MASK = 0x40000000L;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__GENERIC2_INT_ENABLE_MASK = 0x20000000L;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__GPF_INT_ENABLE_MASK = 0x00010000L;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__OPCODE_ERROR_INT_ENABLE_MASK = 0x01000000L;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__PRIV_REG_INT_ENABLE_MASK = 0x00800000L;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__RESERVED_BIT_ERROR_INT_ENABLE_MASK = 0x08000000L;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__SUA_VIOLATION_INT_ENABLE_MASK = 0x00008000L;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__TIME_STAMP_INT_ENABLE_MASK = 0x04000000L;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__WRM_POLL_TIMEOUT_INT_ENABLE_MASK = 0x00020000L;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__CMP_QUERY_STATUS_INT_STATUS_MASK = 0x00001000L;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__CP_ECC_ERROR_INT_STATUS_MASK = 0x00004000L;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__DEQUEUE_REQUEST_INT_STATUS_MASK = 0x00002000L;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__GENERIC0_INT_STATUS_MASK = 0x80000000L;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__GENERIC1_INT_STATUS_MASK = 0x40000000L;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__GENERIC2_INT_STATUS_MASK = 0x20000000L;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__GPF_INT_STATUS_MASK = 0x00010000L;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__OPCODE_ERROR_INT_STATUS_MASK = 0x01000000L;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__PRIV_REG_INT_STATUS_MASK = 0x00800000L;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__RESERVED_BIT_ERROR_INT_STATUS_MASK = 0x08000000L;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__SUA_VIOLATION_INT_STATUS_MASK = 0x00008000L;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__TIME_STAMP_INT_STATUS_MASK = 0x04000000L;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__WRM_POLL_TIMEOUT_INT_STATUS_MASK = 0x00020000L;
constexpr unsigned int CP_ME2_PIPE3_PRIORITY__PRIORITY_MASK     = 0x00000003L;
constexpr unsigned int CP_ME2_PIPE_PRIORITY_CNTS__PRIORITY1_CNT_MASK = 0x000000ffL;
constexpr unsigned int CP_ME2_PIPE_PRIORITY_CNTS__PRIORITY2A_CNT_MASK = 0x0000ff00L;
constexpr unsigned int CP_ME2_PIPE_PRIORITY_CNTS__PRIORITY2B_CNT_MASK = 0x00ff0000L;
constexpr unsigned int CP_ME2_PIPE_PRIORITY_CNTS__PRIORITY3_CNT_MASK = 0xff000000L;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__EDC_DMA_FED_INT_MASK = 0x00000100L;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__EDC_GDS_FED_INT_MASK = 0x00000010L;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__EDC_ROQ_FED_INT_MASK = 0x00000001L;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__EDC_SCRATCH_FED_INT_MASK = 0x00000020L;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__EDC_SR_MEM_FED_INT_MASK = 0x00002000L;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__EDC_TC_FED_INT_MASK = 0x00000008L;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__FATAL_EDC_ERROR_INT_MASK = 0x00008000L;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__GPF_INT_CPC_MASK  = 0x00001000L;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__GPF_INT_CPF_MASK  = 0x00000400L;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__GPF_INT_DMA_MASK  = 0x00000800L;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__IQ_TIMER_INT_MASK = 0x00000200L;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__PRIV_REG_INT_MASK = 0x00000002L;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__QUEUE_MESSAGE_INT_MASK = 0x00004000L;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__RESERVED_BIT_ERR_INT_MASK = 0x00000004L;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__SUA_VIOLATION_INT_MASK = 0x00000080L;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__WAVE_RESTORE_INT_MASK = 0x00000040L;
constexpr unsigned int CP_MEC1_F32_INT_DIS__EDC_DMA_FED_INT_MASK = 0x00000100L;
constexpr unsigned int CP_MEC1_F32_INT_DIS__EDC_GDS_FED_INT_MASK = 0x00000010L;
constexpr unsigned int CP_MEC1_F32_INT_DIS__EDC_ROQ_FED_INT_MASK = 0x00000001L;
constexpr unsigned int CP_MEC1_F32_INT_DIS__EDC_SCRATCH_FED_INT_MASK = 0x00000020L;
constexpr unsigned int CP_MEC1_F32_INT_DIS__EDC_SR_MEM_FED_INT_MASK = 0x00002000L;
constexpr unsigned int CP_MEC1_F32_INT_DIS__EDC_TC_FED_INT_MASK = 0x00000008L;
constexpr unsigned int CP_MEC1_F32_INT_DIS__FATAL_EDC_ERROR_INT_MASK = 0x00008000L;
constexpr unsigned int CP_MEC1_F32_INT_DIS__GPF_INT_CPC_MASK    = 0x00001000L;
constexpr unsigned int CP_MEC1_F32_INT_DIS__GPF_INT_CPF_MASK    = 0x00000400L;
constexpr unsigned int CP_MEC1_F32_INT_DIS__GPF_INT_DMA_MASK    = 0x00000800L;
constexpr unsigned int CP_MEC1_F32_INT_DIS__IQ_TIMER_INT_MASK   = 0x00000200L;
constexpr unsigned int CP_MEC1_F32_INT_DIS__PRIV_REG_INT_MASK   = 0x00000002L;
constexpr unsigned int CP_MEC1_F32_INT_DIS__QUEUE_MESSAGE_INT_MASK = 0x00004000L;
constexpr unsigned int CP_MEC1_F32_INT_DIS__RESERVED_BIT_ERR_INT_MASK = 0x00000004L;
constexpr unsigned int CP_MEC1_F32_INT_DIS__SUA_VIOLATION_INT_MASK = 0x00000080L;
constexpr unsigned int CP_MEC1_F32_INT_DIS__WAVE_RESTORE_INT_MASK = 0x00000040L;
constexpr unsigned int CP_MEC1_INSTR_PNTR__INSTR_PNTR_MASK      = 0x0000ffffL;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__EDC_DMA_FED_INT_MASK = 0x00000100L;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__EDC_GDS_FED_INT_MASK = 0x00000010L;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__EDC_ROQ_FED_INT_MASK = 0x00000001L;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__EDC_SCRATCH_FED_INT_MASK = 0x00000020L;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__EDC_SR_MEM_FED_INT_MASK = 0x00002000L;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__EDC_TC_FED_INT_MASK = 0x00000008L;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__FATAL_EDC_ERROR_INT_MASK = 0x00008000L;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__GPF_INT_CPC_MASK  = 0x00001000L;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__GPF_INT_CPF_MASK  = 0x00000400L;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__GPF_INT_DMA_MASK  = 0x00000800L;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__IQ_TIMER_INT_MASK = 0x00000200L;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__PRIV_REG_INT_MASK = 0x00000002L;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__QUEUE_MESSAGE_INT_MASK = 0x00004000L;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__RESERVED_BIT_ERR_INT_MASK = 0x00000004L;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__SUA_VIOLATION_INT_MASK = 0x00000080L;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__WAVE_RESTORE_INT_MASK = 0x00000040L;
constexpr unsigned int CP_MEC2_F32_INT_DIS__EDC_DMA_FED_INT_MASK = 0x00000100L;
constexpr unsigned int CP_MEC2_F32_INT_DIS__EDC_GDS_FED_INT_MASK = 0x00000010L;
constexpr unsigned int CP_MEC2_F32_INT_DIS__EDC_ROQ_FED_INT_MASK = 0x00000001L;
constexpr unsigned int CP_MEC2_F32_INT_DIS__EDC_SCRATCH_FED_INT_MASK = 0x00000020L;
constexpr unsigned int CP_MEC2_F32_INT_DIS__EDC_SR_MEM_FED_INT_MASK = 0x00002000L;
constexpr unsigned int CP_MEC2_F32_INT_DIS__EDC_TC_FED_INT_MASK = 0x00000008L;
constexpr unsigned int CP_MEC2_F32_INT_DIS__FATAL_EDC_ERROR_INT_MASK = 0x00008000L;
constexpr unsigned int CP_MEC2_F32_INT_DIS__GPF_INT_CPC_MASK    = 0x00001000L;
constexpr unsigned int CP_MEC2_F32_INT_DIS__GPF_INT_CPF_MASK    = 0x00000400L;
constexpr unsigned int CP_MEC2_F32_INT_DIS__GPF_INT_DMA_MASK    = 0x00000800L;
constexpr unsigned int CP_MEC2_F32_INT_DIS__IQ_TIMER_INT_MASK   = 0x00000200L;
constexpr unsigned int CP_MEC2_F32_INT_DIS__PRIV_REG_INT_MASK   = 0x00000002L;
constexpr unsigned int CP_MEC2_F32_INT_DIS__QUEUE_MESSAGE_INT_MASK = 0x00004000L;
constexpr unsigned int CP_MEC2_F32_INT_DIS__RESERVED_BIT_ERR_INT_MASK = 0x00000004L;
constexpr unsigned int CP_MEC2_F32_INT_DIS__SUA_VIOLATION_INT_MASK = 0x00000080L;
constexpr unsigned int CP_MEC2_F32_INT_DIS__WAVE_RESTORE_INT_MASK = 0x00000040L;
constexpr unsigned int CP_MEC2_INSTR_PNTR__INSTR_PNTR_MASK      = 0x0000ffffL;
constexpr unsigned int CP_MEC_CNTL__MEC_ME1_HALT_MASK           = 0x40000000L;
constexpr unsigned int CP_MEC_CNTL__MEC_ME1_PIPE0_RESET_MASK    = 0x00010000L;
constexpr unsigned int CP_MEC_CNTL__MEC_ME1_PIPE1_RESET_MASK    = 0x00020000L;
constexpr unsigned int CP_MEC_CNTL__MEC_ME1_PIPE2_RESET_MASK    = 0x00040000L;
constexpr unsigned int CP_MEC_CNTL__MEC_ME1_PIPE3_RESET_MASK    = 0x00080000L;
constexpr unsigned int CP_MEC_CNTL__MEC_ME1_STEP_MASK           = 0x80000000L;
constexpr unsigned int CP_MEC_CNTL__MEC_ME2_HALT_MASK           = 0x10000000L;
constexpr unsigned int CP_MEC_CNTL__MEC_ME2_PIPE0_RESET_MASK    = 0x00100000L;
constexpr unsigned int CP_MEC_CNTL__MEC_ME2_PIPE1_RESET_MASK    = 0x00200000L;
constexpr unsigned int CP_MEC_CNTL__MEC_ME2_STEP_MASK           = 0x20000000L;
constexpr unsigned int CP_MEC_ME1_HEADER_DUMP__HEADER_DUMP_MASK = 0xffffffffL;
constexpr unsigned int CP_MEC_ME2_HEADER_DUMP__HEADER_DUMP_MASK = 0xffffffffL;
constexpr unsigned int CP_MEM_SLP_CNTL__CP_LS_DS_BUSY_OVERRIDE_MASK = 0x00000080L;
constexpr unsigned int CP_MEM_SLP_CNTL__CP_MEM_DS_EN_MASK       = 0x00000002L;
constexpr unsigned int CP_MEM_SLP_CNTL__CP_MEM_LS_EN_MASK       = 0x00000001L;
constexpr unsigned int CP_MEM_SLP_CNTL__CP_MEM_LS_OFF_DELAY_MASK = 0x00ff0000L;
constexpr unsigned int CP_MEM_SLP_CNTL__CP_MEM_LS_ON_DELAY_MASK = 0x0000ff00L;
constexpr unsigned int CP_MEM_SLP_CNTL__RESERVED1_MASK          = 0xff000000L;
constexpr unsigned int CP_MEM_SLP_CNTL__RESERVED_MASK           = 0x0000007cL;
constexpr unsigned int CP_MEQ_AVAIL__MEQ_CNT_MASK               = 0x000003ffL;
constexpr unsigned int CP_MEQ_STAT__MEQ_RPTR_MASK               = 0x000003ffL;
constexpr unsigned int CP_MEQ_STAT__MEQ_WPTR_MASK               = 0x03ff0000L;
constexpr unsigned int CP_MEQ_STQ_THRESHOLD__STQ_START_MASK     = 0x000000ffL;
constexpr unsigned int CP_MEQ_THRESHOLDS__MEQ1_START_MASK       = 0x000000ffL;
constexpr unsigned int CP_MEQ_THRESHOLDS__MEQ2_START_MASK       = 0x0000ff00L;
constexpr unsigned int CP_ME_ATOMIC_PREOP_HI__ATOMIC_PREOP_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_ME_ATOMIC_PREOP_LO__ATOMIC_PREOP_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_ME_CNTL__CE_HALT_MASK                 = 0x01000000L;
constexpr unsigned int CP_ME_CNTL__CE_INVALIDATE_ICACHE_MASK    = 0x00000010L;
constexpr unsigned int CP_ME_CNTL__CE_PIPE0_RESET_MASK          = 0x00010000L;
constexpr unsigned int CP_ME_CNTL__CE_PIPE1_RESET_MASK          = 0x00020000L;
constexpr unsigned int CP_ME_CNTL__CE_STEP_MASK                 = 0x02000000L;
constexpr unsigned int CP_ME_CNTL__ME_HALT_MASK                 = 0x10000000L;
constexpr unsigned int CP_ME_CNTL__ME_INVALIDATE_ICACHE_MASK    = 0x00000100L;
constexpr unsigned int CP_ME_CNTL__ME_PIPE0_RESET_MASK          = 0x00100000L;
constexpr unsigned int CP_ME_CNTL__ME_PIPE1_RESET_MASK          = 0x00200000L;
constexpr unsigned int CP_ME_CNTL__ME_STEP_MASK                 = 0x20000000L;
constexpr unsigned int CP_ME_CNTL__PFP_HALT_MASK                = 0x04000000L;
constexpr unsigned int CP_ME_CNTL__PFP_INVALIDATE_ICACHE_MASK   = 0x00000040L;
constexpr unsigned int CP_ME_CNTL__PFP_PIPE0_RESET_MASK         = 0x00040000L;
constexpr unsigned int CP_ME_CNTL__PFP_PIPE1_RESET_MASK         = 0x00080000L;
constexpr unsigned int CP_ME_CNTL__PFP_STEP_MASK                = 0x08000000L;
constexpr unsigned int CP_ME_COHER_BASE_HI__COHER_BASE_HI_256B_MASK = 0x000000ffL;
constexpr unsigned int CP_ME_COHER_BASE__COHER_BASE_256B_MASK   = 0xffffffffL;
constexpr unsigned int CP_ME_COHER_CNTL__CB0_DEST_BASE_ENA_MASK = 0x00000040L;
constexpr unsigned int CP_ME_COHER_CNTL__CB1_DEST_BASE_ENA_MASK = 0x00000080L;
constexpr unsigned int CP_ME_COHER_CNTL__CB2_DEST_BASE_ENA_MASK = 0x00000100L;
constexpr unsigned int CP_ME_COHER_CNTL__CB3_DEST_BASE_ENA_MASK = 0x00000200L;
constexpr unsigned int CP_ME_COHER_CNTL__CB4_DEST_BASE_ENA_MASK = 0x00000400L;
constexpr unsigned int CP_ME_COHER_CNTL__CB5_DEST_BASE_ENA_MASK = 0x00000800L;
constexpr unsigned int CP_ME_COHER_CNTL__CB6_DEST_BASE_ENA_MASK = 0x00001000L;
constexpr unsigned int CP_ME_COHER_CNTL__CB7_DEST_BASE_ENA_MASK = 0x00002000L;
constexpr unsigned int CP_ME_COHER_CNTL__DB_DEST_BASE_ENA_MASK  = 0x00004000L;
constexpr unsigned int CP_ME_COHER_CNTL__DEST_BASE_0_ENA_MASK   = 0x00000001L;
constexpr unsigned int CP_ME_COHER_CNTL__DEST_BASE_1_ENA_MASK   = 0x00000002L;
constexpr unsigned int CP_ME_COHER_CNTL__DEST_BASE_2_ENA_MASK   = 0x00080000L;
constexpr unsigned int CP_ME_COHER_CNTL__DEST_BASE_3_ENA_MASK   = 0x00200000L;
constexpr unsigned int CP_ME_COHER_SIZE_HI__COHER_SIZE_HI_256B_MASK = 0x000000ffL;
constexpr unsigned int CP_ME_COHER_SIZE__COHER_SIZE_256B_MASK   = 0xffffffffL;
constexpr unsigned int CP_ME_COHER_STATUS__MATCHING_GFX_CNTX_MASK = 0x000000ffL;
constexpr unsigned int CP_ME_COHER_STATUS__STATUS_MASK          = 0x80000000L;
constexpr unsigned int CP_ME_HEADER_DUMP__ME_HEADER_DUMP_MASK   = 0xffffffffL;
constexpr unsigned int CP_ME_INSTR_PNTR__INSTR_PNTR_MASK        = 0x0000ffffL;
constexpr unsigned int CP_ME_MC_RADDR_HI__ME_MC_RADDR_HI_MASK   = 0x0000ffffL;
constexpr unsigned int CP_ME_MC_RADDR_LO__ME_MC_RADDR_LO_MASK   = 0xfffffffcL;
constexpr unsigned int CP_ME_MC_WADDR_HI__ME_MC_WADDR_HI_MASK   = 0x0000ffffL;
constexpr unsigned int CP_ME_MC_WADDR_LO__ME_MC_WADDR_LO_MASK   = 0xfffffffcL;
constexpr unsigned int CP_ME_MC_WDATA_HI__ME_MC_WDATA_HI_MASK   = 0xffffffffL;
constexpr unsigned int CP_ME_MC_WDATA_LO__ME_MC_WDATA_LO_MASK   = 0xffffffffL;
constexpr unsigned int CP_ME_PREEMPTION__OBSOLETE_MASK          = 0x00000001L;
constexpr unsigned int CP_ME_RAM_DATA__ME_RAM_DATA_MASK         = 0xffffffffL;
constexpr unsigned int CP_MQD_BASE_ADDR_HI__BASE_ADDR_HI_MASK   = 0x0000ffffL;
constexpr unsigned int CP_MQD_BASE_ADDR__BASE_ADDR_MASK         = 0xfffffffcL;
constexpr unsigned int CP_MQD_CONTROL__EXE_DISABLE_MASK         = 0x00800000L;
constexpr unsigned int CP_MQD_CONTROL__PRIV_STATE_MASK          = 0x00000100L;
constexpr unsigned int CP_MQD_CONTROL__PROCESSING_MQD_EN_MASK   = 0x00002000L;
constexpr unsigned int CP_MQD_CONTROL__PROCESSING_MQD_MASK      = 0x00001000L;
constexpr unsigned int CP_MQD_CONTROL__VMID_MASK                = 0x0000000fL;
constexpr unsigned int CP_NUM_PRIM_NEEDED_COUNT0_HI__NUM_PRIM_NEEDED_CNT0_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_NUM_PRIM_NEEDED_COUNT0_LO__NUM_PRIM_NEEDED_CNT0_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_NUM_PRIM_NEEDED_COUNT1_HI__NUM_PRIM_NEEDED_CNT1_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_NUM_PRIM_NEEDED_COUNT1_LO__NUM_PRIM_NEEDED_CNT1_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_NUM_PRIM_NEEDED_COUNT2_HI__NUM_PRIM_NEEDED_CNT2_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_NUM_PRIM_NEEDED_COUNT2_LO__NUM_PRIM_NEEDED_CNT2_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_NUM_PRIM_NEEDED_COUNT3_HI__NUM_PRIM_NEEDED_CNT3_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_NUM_PRIM_NEEDED_COUNT3_LO__NUM_PRIM_NEEDED_CNT3_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_NUM_PRIM_WRITTEN_COUNT0_HI__NUM_PRIM_WRITTEN_CNT0_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_NUM_PRIM_WRITTEN_COUNT0_LO__NUM_PRIM_WRITTEN_CNT0_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_NUM_PRIM_WRITTEN_COUNT1_HI__NUM_PRIM_WRITTEN_CNT1_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_NUM_PRIM_WRITTEN_COUNT1_LO__NUM_PRIM_WRITTEN_CNT1_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_NUM_PRIM_WRITTEN_COUNT2_HI__NUM_PRIM_WRITTEN_CNT2_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_NUM_PRIM_WRITTEN_COUNT2_LO__NUM_PRIM_WRITTEN_CNT2_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_NUM_PRIM_WRITTEN_COUNT3_HI__NUM_PRIM_WRITTEN_CNT3_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_NUM_PRIM_WRITTEN_COUNT3_LO__NUM_PRIM_WRITTEN_CNT3_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_PA_CINVOC_COUNT_HI__CINVOC_COUNT_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_PA_CINVOC_COUNT_LO__CINVOC_COUNT_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_PA_CPRIM_COUNT_HI__CPRIM_COUNT_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_PA_CPRIM_COUNT_LO__CPRIM_COUNT_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_PERFMON_CNTL__PERFMON_ENABLE_MODE_MASK = 0x00000300L;
constexpr unsigned int CP_PERFMON_CNTL__PERFMON_SAMPLE_ENABLE_MASK = 0x00000400L;
constexpr unsigned int CP_PERFMON_CNTL__PERFMON_STATE_MASK      = 0x0000000fL;
constexpr unsigned int CP_PERFMON_CNTL__SPM_PERFMON_STATE_MASK  = 0x000000f0L;
constexpr unsigned int CP_PERFMON_CNTX_CNTL__PERFMON_ENABLE_MASK = 0x80000000L;
constexpr unsigned int CP_PFP_ATOMIC_PREOP_HI__ATOMIC_PREOP_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_PFP_ATOMIC_PREOP_LO__ATOMIC_PREOP_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_PFP_COMPLETION_STATUS__STATUS_MASK    = 0x00000003L;
constexpr unsigned int CP_PFP_F32_INTERRUPT__PRIV_REG_INT_MASK  = 0x00000002L;
constexpr unsigned int CP_PFP_F32_INTERRUPT__RESERVED_BIT_ERR_INT_MASK = 0x00000004L;
constexpr unsigned int CP_PFP_HEADER_DUMP__PFP_HEADER_DUMP_MASK = 0xffffffffL;
constexpr unsigned int CP_PFP_IB_CONTROL__IB_EN_MASK            = 0x000000ffL;
constexpr unsigned int CP_PFP_INSTR_PNTR__INSTR_PNTR_MASK       = 0x0000ffffL;
constexpr unsigned int CP_PFP_LOAD_CONTROL__CNTX_REG_EN_MASK    = 0x00000002L;
constexpr unsigned int CP_PFP_LOAD_CONTROL__CONFIG_REG_EN_MASK  = 0x00000001L;
constexpr unsigned int CP_PFP_LOAD_CONTROL__SH_CS_REG_EN_MASK   = 0x01000000L;
constexpr unsigned int CP_PFP_LOAD_CONTROL__SH_GFX_REG_EN_MASK  = 0x00010000L;
constexpr unsigned int CP_PFP_METADATA_BASE_ADDR_HI__ADDR_HI_MASK = 0x0000ffffL;
constexpr unsigned int CP_PFP_METADATA_BASE_ADDR__ADDR_LO_MASK  = 0xffffffffL;
constexpr unsigned int CP_PIPEID__PIPE_ID_MASK                  = 0x00000003L;
constexpr unsigned int CP_PIPE_STATS_ADDR_HI__PIPE_STATS_ADDR_HI_MASK = 0x0000ffffL;
constexpr unsigned int CP_PIPE_STATS_ADDR_LO__PIPE_STATS_ADDR_LO_MASK = 0xfffffffcL;
constexpr unsigned int CP_PQ_STATUS__DOORBELL_ENABLE_MASK       = 0x00000002L;
constexpr unsigned int CP_PQ_STATUS__DOORBELL_UPDATED_MASK      = 0x00000001L;
constexpr unsigned int CP_PQ_WPTR_POLL_CNTL1__QUEUE_MASK_MASK   = 0xffffffffL;
constexpr unsigned int CP_PQ_WPTR_POLL_CNTL__DISABLE_PEND_REQ_ONE_SHOT_MASK = 0x20000000L;
constexpr unsigned int CP_PQ_WPTR_POLL_CNTL__EN_MASK            = 0x80000000L;
constexpr unsigned int CP_PQ_WPTR_POLL_CNTL__PERIOD_MASK        = 0x000000ffL;
constexpr unsigned int CP_PQ_WPTR_POLL_CNTL__POLL_ACTIVE_MASK   = 0x40000000L;
constexpr unsigned int CP_PRED_NOT_VISIBLE__NOT_VISIBLE_MASK    = 0x00000001L;
constexpr unsigned int CP_PWR_CNTL__CMP_CLK_HALT_ME1_PIPE0_MASK = 0x00000100L;
constexpr unsigned int CP_PWR_CNTL__CMP_CLK_HALT_ME1_PIPE1_MASK = 0x00000200L;
constexpr unsigned int CP_PWR_CNTL__CMP_CLK_HALT_ME1_PIPE2_MASK = 0x00000400L;
constexpr unsigned int CP_PWR_CNTL__CMP_CLK_HALT_ME1_PIPE3_MASK = 0x00000800L;
constexpr unsigned int CP_PWR_CNTL__CMP_CLK_HALT_ME2_PIPE0_MASK = 0x00010000L;
constexpr unsigned int CP_PWR_CNTL__CMP_CLK_HALT_ME2_PIPE1_MASK = 0x00020000L;
constexpr unsigned int CP_PWR_CNTL__CMP_CLK_HALT_ME2_PIPE2_MASK = 0x00040000L;
constexpr unsigned int CP_PWR_CNTL__CMP_CLK_HALT_ME2_PIPE3_MASK = 0x00080000L;
constexpr unsigned int CP_PWR_CNTL__GFX_CLK_HALT_ME0_PIPE0_MASK = 0x00000001L;
constexpr unsigned int CP_PWR_CNTL__GFX_CLK_HALT_ME0_PIPE1_MASK = 0x00000002L;
constexpr unsigned int CP_QUEUE_THRESHOLDS__ROQ_IB1_START_MASK  = 0x0000003fL;
constexpr unsigned int CP_QUEUE_THRESHOLDS__ROQ_IB2_START_MASK  = 0x00003f00L;
constexpr unsigned int CP_RB0_ACTIVE__ACTIVE_MASK               = 0x00000001L;
constexpr unsigned int CP_RB0_BASE_HI__RB_BASE_HI_MASK          = 0x000000ffL;
constexpr unsigned int CP_RB0_BASE__RB_BASE_MASK                = 0xffffffffL;
constexpr unsigned int CP_RB0_BUFSZ_MASK__DATA_MASK             = 0x000fffffL;
constexpr unsigned int CP_RB0_CNTL__MIN_AVAILSZ_MASK            = 0x00300000L;
constexpr unsigned int CP_RB0_CNTL__MIN_IB_AVAILSZ_MASK         = 0x00c00000L;
constexpr unsigned int CP_RB0_CNTL__RB_BLKSZ_MASK               = 0x00003f00L;
constexpr unsigned int CP_RB0_CNTL__RB_BUFSZ_MASK               = 0x0000003fL;
constexpr unsigned int CP_RB0_CNTL__RB_NO_UPDATE_MASK           = 0x08000000L;
constexpr unsigned int CP_RB0_CNTL__RB_RPTR_WR_ENA_MASK         = 0x80000000L;
constexpr unsigned int CP_RB0_RPTR_ADDR_HI__RB_RPTR_ADDR_HI_MASK = 0x0000ffffL;
constexpr unsigned int CP_RB0_RPTR_ADDR__RB_RPTR_ADDR_MASK      = 0xfffffffcL;
constexpr unsigned int CP_RB0_RPTR__RB_RPTR_MASK                = 0x000fffffL;
constexpr unsigned int CP_RB0_WPTR_HI__RB_WPTR_MASK             = 0xffffffffL;
constexpr unsigned int CP_RB0_WPTR__RB_WPTR_MASK                = 0xffffffffL;
constexpr unsigned int CP_RB1_BASE_HI__RB_BASE_HI_MASK          = 0x000000ffL;
constexpr unsigned int CP_RB1_BASE__RB_BASE_MASK                = 0xffffffffL;
constexpr unsigned int CP_RB1_CNTL__MIN_AVAILSZ_MASK            = 0x00300000L;
constexpr unsigned int CP_RB1_CNTL__MIN_IB_AVAILSZ_MASK         = 0x00c00000L;
constexpr unsigned int CP_RB1_CNTL__RB_BLKSZ_MASK               = 0x00003f00L;
constexpr unsigned int CP_RB1_CNTL__RB_BUFSZ_MASK               = 0x0000003fL;
constexpr unsigned int CP_RB1_CNTL__RB_NO_UPDATE_MASK           = 0x08000000L;
constexpr unsigned int CP_RB1_CNTL__RB_RPTR_WR_ENA_MASK         = 0x80000000L;
constexpr unsigned int CP_RB1_RPTR_ADDR_HI__RB_RPTR_ADDR_HI_MASK = 0x0000ffffL;
constexpr unsigned int CP_RB1_RPTR_ADDR__RB_RPTR_ADDR_MASK      = 0xfffffffcL;
constexpr unsigned int CP_RB1_RPTR__RB_RPTR_MASK                = 0x000fffffL;
constexpr unsigned int CP_RB1_WPTR_HI__RB_WPTR_MASK             = 0xffffffffL;
constexpr unsigned int CP_RB1_WPTR__RB_WPTR_MASK                = 0xffffffffL;
constexpr unsigned int CP_RB2_BASE__RB_BASE_MASK                = 0xffffffffL;
constexpr unsigned int CP_RB2_CNTL__MIN_AVAILSZ_MASK            = 0x00300000L;
constexpr unsigned int CP_RB2_CNTL__MIN_IB_AVAILSZ_MASK         = 0x00c00000L;
constexpr unsigned int CP_RB2_CNTL__RB_BLKSZ_MASK               = 0x00003f00L;
constexpr unsigned int CP_RB2_CNTL__RB_BUFSZ_MASK               = 0x0000003fL;
constexpr unsigned int CP_RB2_CNTL__RB_NO_UPDATE_MASK           = 0x08000000L;
constexpr unsigned int CP_RB2_CNTL__RB_RPTR_WR_ENA_MASK         = 0x80000000L;
constexpr unsigned int CP_RB2_RPTR_ADDR_HI__RB_RPTR_ADDR_HI_MASK = 0x0000ffffL;
constexpr unsigned int CP_RB2_RPTR_ADDR__RB_RPTR_ADDR_MASK      = 0xfffffffcL;
constexpr unsigned int CP_RB2_RPTR__RB_RPTR_MASK                = 0x000fffffL;
constexpr unsigned int CP_RB2_WPTR__RB_WPTR_MASK                = 0x000fffffL;
constexpr unsigned int CP_RB_ACTIVE__ACTIVE_MASK                = 0x00000001L;
constexpr unsigned int CP_RB_BASE__RB_BASE_MASK                 = 0xffffffffL;
constexpr unsigned int CP_RB_BUFSZ_MASK__DATA_MASK              = 0x000fffffL;
constexpr unsigned int CP_RB_CNTL__MIN_AVAILSZ_MASK             = 0x00300000L;
constexpr unsigned int CP_RB_CNTL__MIN_IB_AVAILSZ_MASK          = 0x00c00000L;
constexpr unsigned int CP_RB_CNTL__RB_BLKSZ_MASK                = 0x00003f00L;
constexpr unsigned int CP_RB_CNTL__RB_BUFSZ_MASK                = 0x0000003fL;
constexpr unsigned int CP_RB_CNTL__RB_NO_UPDATE_MASK            = 0x08000000L;
constexpr unsigned int CP_RB_CNTL__RB_RPTR_WR_ENA_MASK          = 0x80000000L;
constexpr unsigned int CP_RB_DOORBELL_CLEAR__MAPPED_QUEUE_MASK  = 0x00000007L;
constexpr unsigned int CP_RB_DOORBELL_CLEAR__MAPPED_QUE_DOORBELL_EN_CLEAR_MASK = 0x00000100L;
constexpr unsigned int CP_RB_DOORBELL_CLEAR__MAPPED_QUE_DOORBELL_HIT_CLEAR_MASK = 0x00000200L;
constexpr unsigned int CP_RB_DOORBELL_CLEAR__MASTER_DOORBELL_EN_CLEAR_MASK = 0x00000400L;
constexpr unsigned int CP_RB_DOORBELL_CLEAR__MASTER_DOORBELL_HIT_CLEAR_MASK = 0x00000800L;
constexpr unsigned int CP_RB_DOORBELL_CLEAR__QUEUES_DOORBELL_EN_CLEAR_MASK = 0x00001000L;
constexpr unsigned int CP_RB_DOORBELL_CLEAR__QUEUES_DOORBELL_HIT_CLEAR_MASK = 0x00002000L;
constexpr unsigned int CP_RB_DOORBELL_CONTROL__DOORBELL_BIF_DROP_MASK = 0x00000002L;
constexpr unsigned int CP_RB_DOORBELL_CONTROL__DOORBELL_EN_MASK = 0x40000000L;
constexpr unsigned int CP_RB_DOORBELL_CONTROL__DOORBELL_HIT_MASK = 0x80000000L;
constexpr unsigned int CP_RB_DOORBELL_CONTROL__DOORBELL_OFFSET_MASK = 0x0ffffffcL;
constexpr unsigned int CP_RB_OFFSET__RB_OFFSET_MASK             = 0x000fffffL;
constexpr unsigned int CP_RB_RPTR_ADDR_HI__RB_RPTR_ADDR_HI_MASK = 0x0000ffffL;
constexpr unsigned int CP_RB_RPTR_ADDR__RB_RPTR_ADDR_MASK       = 0xfffffffcL;
constexpr unsigned int CP_RB_RPTR_WR__RB_RPTR_WR_MASK           = 0x000fffffL;
constexpr unsigned int CP_RB_RPTR__RB_RPTR_MASK                 = 0x000fffffL;
constexpr unsigned int CP_RB_STATUS__DOORBELL_ENABLE_MASK       = 0x00000002L;
constexpr unsigned int CP_RB_STATUS__DOORBELL_UPDATED_MASK      = 0x00000001L;
constexpr unsigned int CP_RB_VMID__RB0_VMID_MASK                = 0x0000000fL;
constexpr unsigned int CP_RB_VMID__RB1_VMID_MASK                = 0x00000f00L;
constexpr unsigned int CP_RB_VMID__RB2_VMID_MASK                = 0x000f0000L;
constexpr unsigned int CP_RB_WPTR_DELAY__PRE_WRITE_LIMIT_MASK   = 0xf0000000L;
constexpr unsigned int CP_RB_WPTR_DELAY__PRE_WRITE_TIMER_MASK   = 0x0fffffffL;
constexpr unsigned int CP_RB_WPTR_HI__RB_WPTR_MASK              = 0xffffffffL;
constexpr unsigned int CP_RB_WPTR_POLL_ADDR_HI__RB_WPTR_POLL_ADDR_HI_MASK = 0x0000ffffL;
constexpr unsigned int CP_RB_WPTR_POLL_ADDR_LO__RB_WPTR_POLL_ADDR_LO_MASK = 0xfffffffcL;
constexpr unsigned int CP_RB_WPTR_POLL_CNTL__IDLE_POLL_COUNT_MASK = 0xffff0000L;
constexpr unsigned int CP_RB_WPTR_POLL_CNTL__POLL_FREQUENCY_MASK = 0x0000ffffL;
constexpr unsigned int CP_RB_WPTR__RB_WPTR_MASK                 = 0xffffffffL;
constexpr unsigned int CP_RING0_PRIORITY__PRIORITY_MASK         = 0x00000003L;
constexpr unsigned int CP_RING1_PRIORITY__PRIORITY_MASK         = 0x00000003L;
constexpr unsigned int CP_RING2_PRIORITY__PRIORITY_MASK         = 0x00000003L;
constexpr unsigned int CP_RINGID__RINGID_MASK                   = 0x00000003L;
constexpr unsigned int CP_RING_PRIORITY_CNTS__PRIORITY1_CNT_MASK = 0x000000ffL;
constexpr unsigned int CP_RING_PRIORITY_CNTS__PRIORITY2A_CNT_MASK = 0x0000ff00L;
constexpr unsigned int CP_RING_PRIORITY_CNTS__PRIORITY2B_CNT_MASK = 0x00ff0000L;
constexpr unsigned int CP_RING_PRIORITY_CNTS__PRIORITY3_CNT_MASK = 0xff000000L;
constexpr unsigned int CP_ROQ_THRESHOLDS__IB1_START_MASK        = 0x000000ffL;
constexpr unsigned int CP_ROQ_THRESHOLDS__IB2_START_MASK        = 0x0000ff00L;
constexpr unsigned int CP_SAMPLE_STATUS__DISP_INDIRECT_ACTIVE_MASK = 0x00000080L;
constexpr unsigned int CP_SAMPLE_STATUS__DRAW_INDIRECT_ACTIVE_MASK = 0x00000040L;
constexpr unsigned int CP_SAMPLE_STATUS__PIPELINE_ACTIVE_MASK   = 0x00000004L;
constexpr unsigned int CP_SAMPLE_STATUS__SCREEN_EXT_ACTIVE_MASK = 0x00000020L;
constexpr unsigned int CP_SAMPLE_STATUS__STIPPLE_ACTIVE_MASK    = 0x00000008L;
constexpr unsigned int CP_SAMPLE_STATUS__STREAMOUT_ACTIVE_MASK  = 0x00000002L;
constexpr unsigned int CP_SAMPLE_STATUS__VGT_BUFFERS_ACTIVE_MASK = 0x00000010L;
constexpr unsigned int CP_SAMPLE_STATUS__Z_PASS_ACITVE_MASK     = 0x00000001L;
constexpr unsigned int CP_SCRATCH_DATA__SCRATCH_DATA_MASK       = 0xffffffffL;
constexpr unsigned int CP_SC_PSINVOC_COUNT0_HI__PSINVOC_COUNT0_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_SC_PSINVOC_COUNT0_LO__PSINVOC_COUNT0_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_SC_PSINVOC_COUNT1_HI__OBSOLETE_MASK   = 0xffffffffL;
constexpr unsigned int CP_SC_PSINVOC_COUNT1_LO__OBSOLETE_MASK   = 0xffffffffL;
constexpr unsigned int CP_SD_CNTL__CPC_EN_MASK                  = 0x00000004L;
constexpr unsigned int CP_SD_CNTL__CPF_EN_MASK                  = 0x00000001L;
constexpr unsigned int CP_SD_CNTL__CPG_EN_MASK                  = 0x00000002L;
constexpr unsigned int CP_SD_CNTL__EA_EN_MASK                   = 0x00000200L;
constexpr unsigned int CP_SD_CNTL__RLC_EN_MASK                  = 0x00000008L;
constexpr unsigned int CP_SD_CNTL__SPI_EN_MASK                  = 0x00000010L;
constexpr unsigned int CP_SEM_WAIT_TIMER__SEM_WAIT_TIMER_MASK   = 0xffffffffL;
constexpr unsigned int CP_SIG_SEM_ADDR_HI__SEM_ADDR_HI_MASK     = 0x0000ffffL;
constexpr unsigned int CP_SIG_SEM_ADDR_HI__SEM_CLIENT_CODE_MASK = 0x03000000L;
constexpr unsigned int CP_SIG_SEM_ADDR_HI__SEM_SELECT_MASK      = 0xe0000000L;
constexpr unsigned int CP_SIG_SEM_ADDR_HI__SEM_SIGNAL_TYPE_MASK = 0x00100000L;
constexpr unsigned int CP_SIG_SEM_ADDR_HI__SEM_USE_MAILBOX_MASK = 0x00010000L;
constexpr unsigned int CP_SIG_SEM_ADDR_LO__SEM_ADDR_LO_MASK     = 0xfffffff8L;
constexpr unsigned int CP_SOFT_RESET_CNTL__CMP_HQD_QUEUE_DOORBELL_RESET_MASK = 0x00000010L;
constexpr unsigned int CP_SOFT_RESET_CNTL__CMP_HQD_REG_RESET_MASK = 0x00000004L;
constexpr unsigned int CP_SOFT_RESET_CNTL__CMP_INTR_REG_RESET_MASK = 0x00000008L;
constexpr unsigned int CP_SOFT_RESET_CNTL__CMP_ONLY_SOFT_RESET_MASK = 0x00000001L;
constexpr unsigned int CP_SOFT_RESET_CNTL__GFX_INTR_REG_RESET_MASK = 0x00000040L;
constexpr unsigned int CP_SOFT_RESET_CNTL__GFX_ONLY_SOFT_RESET_MASK = 0x00000002L;
constexpr unsigned int CP_SOFT_RESET_CNTL__GFX_RB_DOORBELL_RESET_MASK = 0x00000020L;
constexpr unsigned int CP_STALLED_STAT1__ME_HAS_ACTIVE_CE_BUFFER_FLAG_MASK = 0x00000400L;
constexpr unsigned int CP_STALLED_STAT1__ME_HAS_ACTIVE_DE_BUFFER_FLAG_MASK = 0x00000800L;
constexpr unsigned int CP_STALLED_STAT1__ME_STALLED_ON_ATOMIC_RTN_DATA_MASK = 0x00002000L;
constexpr unsigned int CP_STALLED_STAT1__ME_STALLED_ON_TC_WR_CONFIRM_MASK = 0x00001000L;
constexpr unsigned int CP_STALLED_STAT1__ME_WAITING_ON_REG_READ_DATA_MASK = 0x00008000L;
constexpr unsigned int CP_STALLED_STAT1__ME_WAITING_ON_TC_READ_DATA_MASK = 0x00004000L;
constexpr unsigned int CP_STALLED_STAT1__RBIU_TO_DMA_NOT_RDY_TO_RCV_MASK = 0x00000001L;
constexpr unsigned int CP_STALLED_STAT1__RCIU_HALTED_BY_REG_VIOLATION_MASK = 0x20000000L;
constexpr unsigned int CP_STALLED_STAT1__RCIU_STALLED_ON_APPEND_READ_MASK = 0x10000000L;
constexpr unsigned int CP_STALLED_STAT1__RCIU_STALLED_ON_DMA_READ_MASK = 0x08000000L;
constexpr unsigned int CP_STALLED_STAT1__RCIU_STALLED_ON_ME_READ_MASK = 0x04000000L;
constexpr unsigned int CP_STALLED_STAT1__RCIU_WAITING_ON_GDS_FREE_MASK = 0x00800000L;
constexpr unsigned int CP_STALLED_STAT1__RCIU_WAITING_ON_GRBM_FREE_MASK = 0x01000000L;
constexpr unsigned int CP_STALLED_STAT1__RCIU_WAITING_ON_VGT_FREE_MASK = 0x02000000L;
constexpr unsigned int CP_STALLED_STAT2__APPEND_ACTIVE_PARTITION_MASK = 0x10000000L;
constexpr unsigned int CP_STALLED_STAT2__APPEND_RDY_WAIT_ON_CS_DONE_MASK = 0x02000000L;
constexpr unsigned int CP_STALLED_STAT2__APPEND_RDY_WAIT_ON_PS_DONE_MASK = 0x04000000L;
constexpr unsigned int CP_STALLED_STAT2__APPEND_WAITING_TO_SEND_MEMWRITE_MASK = 0x20000000L;
constexpr unsigned int CP_STALLED_STAT2__APPEND_WAIT_ON_WR_CONFIRM_MASK = 0x08000000L;
constexpr unsigned int CP_STALLED_STAT2__GFX_CNTX_NOT_AVAIL_TO_ME_MASK = 0x00000800L;
constexpr unsigned int CP_STALLED_STAT2__MEQ_TO_ME_NOT_RDY_TO_RCV_MASK = 0x00010000L;
constexpr unsigned int CP_STALLED_STAT2__ME_RCIU_NOT_RDY_TO_RCV_MASK = 0x00001000L;
constexpr unsigned int CP_STALLED_STAT2__ME_TO_CONST_NOT_RDY_TO_RCV_MASK = 0x00002000L;
constexpr unsigned int CP_STALLED_STAT2__ME_WAITING_DATA_FROM_PFP_MASK = 0x00004000L;
constexpr unsigned int CP_STALLED_STAT2__ME_WAITING_DATA_FROM_STQ_MASK = 0x00040000L;
constexpr unsigned int CP_STALLED_STAT2__ME_WAITING_ON_PARTIAL_FLUSH_MASK = 0x00008000L;
constexpr unsigned int CP_STALLED_STAT2__ME_WAIT_ON_AVAIL_BUFFER_MASK = 0x00000400L;
constexpr unsigned int CP_STALLED_STAT2__ME_WAIT_ON_CE_COUNTER_MASK = 0x00000200L;
constexpr unsigned int CP_STALLED_STAT2__PFP_RCIU_READ_PENDING_MASK = 0x00000020L;
constexpr unsigned int CP_STALLED_STAT2__PFP_STALLED_ON_ATOMIC_RTN_DATA_MASK = 0x00100000L;
constexpr unsigned int CP_STALLED_STAT2__PFP_STALLED_ON_TC_WR_CONFIRM_MASK = 0x00080000L;
constexpr unsigned int CP_STALLED_STAT2__PFP_TO_CSF_NOT_RDY_TO_RCV_MASK = 0x00000001L;
constexpr unsigned int CP_STALLED_STAT2__PFP_TO_MEQ_NOT_RDY_TO_RCV_MASK = 0x00000002L;
constexpr unsigned int CP_STALLED_STAT2__PFP_TO_RCIU_NOT_RDY_TO_RCV_MASK = 0x00000004L;
constexpr unsigned int CP_STALLED_STAT2__PFP_TO_VGT_WRITES_PENDING_MASK = 0x00000010L;
constexpr unsigned int CP_STALLED_STAT2__PFP_WAITING_ON_BUFFER_DATA_MASK = 0x00000100L;
constexpr unsigned int CP_STALLED_STAT2__PIPE_STATS_WR_DATA_PENDING_MASK = 0x01000000L;
constexpr unsigned int CP_STALLED_STAT2__STQ_TO_ME_NOT_RDY_TO_RCV_MASK = 0x00020000L;
constexpr unsigned int CP_STALLED_STAT2__STRMO_WR_OF_PRIM_DATA_PENDING_MASK = 0x00800000L;
constexpr unsigned int CP_STALLED_STAT2__SURF_SYNC_NEEDS_ALL_CLEAN_MASK = 0x80000000L;
constexpr unsigned int CP_STALLED_STAT2__SURF_SYNC_NEEDS_IDLE_CNTXS_MASK = 0x40000000L;
constexpr unsigned int CP_STALLED_STAT3__CE_STALLED_ON_ATOMIC_RTN_DATA_MASK = 0x00020000L;
constexpr unsigned int CP_STALLED_STAT3__CE_STALLED_ON_TC_WR_CONFIRM_MASK = 0x00010000L;
constexpr unsigned int CP_STALLED_STAT3__CE_TO_CSF_NOT_RDY_TO_RCV_MASK = 0x00000001L;
constexpr unsigned int CP_STALLED_STAT3__CE_TO_INC_FIFO_NOT_RDY_TO_RCV_MASK = 0x00000040L;
constexpr unsigned int CP_STALLED_STAT3__CE_TO_RAM_DUMP_NOT_RDY_MASK = 0x00000010L;
constexpr unsigned int CP_STALLED_STAT3__CE_TO_RAM_INIT_FETCHER_NOT_RDY_TO_RCV_MASK = 0x00000002L;
constexpr unsigned int CP_STALLED_STAT3__CE_TO_RAM_INIT_NOT_RDY_MASK = 0x00000008L;
constexpr unsigned int CP_STALLED_STAT3__CE_TO_RAM_WRITE_NOT_RDY_MASK = 0x00000020L;
constexpr unsigned int CP_STALLED_STAT3__CE_TO_WR_FIFO_NOT_RDY_TO_RCV_MASK = 0x00000080L;
constexpr unsigned int CP_STALLED_STAT3__CE_WAITING_ON_BUFFER_DATA_MASK = 0x00000400L;
constexpr unsigned int CP_STALLED_STAT3__CE_WAITING_ON_CE_BUFFER_FLAG_MASK = 0x00000800L;
constexpr unsigned int CP_STALLED_STAT3__CE_WAITING_ON_DATA_FROM_RAM_INIT_FETCHER_MASK = 0x00000004L;
constexpr unsigned int CP_STALLED_STAT3__CE_WAITING_ON_DE_COUNTER_MASK = 0x00001000L;
constexpr unsigned int CP_STALLED_STAT3__CE_WAITING_ON_DE_COUNTER_UNDERFLOW_MASK = 0x00002000L;
constexpr unsigned int CP_STALLED_STAT3__TCIU_WAITING_ON_FREE_MASK = 0x00004000L;
constexpr unsigned int CP_STALLED_STAT3__TCIU_WAITING_ON_TAGS_MASK = 0x00008000L;
constexpr unsigned int CP_STALLED_STAT3__UTCL1_WAITING_ON_TRANS_MASK = 0x00100000L;
constexpr unsigned int CP_STALLED_STAT3__UTCL2IU_WAITING_ON_FREE_MASK = 0x00040000L;
constexpr unsigned int CP_STALLED_STAT3__UTCL2IU_WAITING_ON_TAGS_MASK = 0x00080000L;
constexpr unsigned int CP_STAT__CE_BUSY_MASK                    = 0x04000000L;
constexpr unsigned int CP_STAT__CP_BUSY_MASK                    = 0x80000000L;
constexpr unsigned int CP_STAT__DC_BUSY_MASK                    = 0x00002000L;
constexpr unsigned int CP_STAT__DMA_BUSY_MASK                   = 0x00400000L;
constexpr unsigned int CP_STAT__INTERRUPT_BUSY_MASK             = 0x00100000L;
constexpr unsigned int CP_STAT__MEQ_BUSY_MASK                   = 0x00010000L;
constexpr unsigned int CP_STAT__ME_BUSY_MASK                    = 0x00020000L;
constexpr unsigned int CP_STAT__PFP_BUSY_MASK                   = 0x00008000L;
constexpr unsigned int CP_STAT__QUERY_BUSY_MASK                 = 0x00040000L;
constexpr unsigned int CP_STAT__RCIU_BUSY_MASK                  = 0x00800000L;
constexpr unsigned int CP_STAT__ROQ_CE_INDIRECT1_BUSY_MASK      = 0x20000000L;
constexpr unsigned int CP_STAT__ROQ_CE_INDIRECT2_BUSY_MASK      = 0x40000000L;
constexpr unsigned int CP_STAT__ROQ_CE_RING_BUSY_MASK           = 0x10000000L;
constexpr unsigned int CP_STAT__ROQ_INDIRECT1_BUSY_MASK         = 0x00000400L;
constexpr unsigned int CP_STAT__ROQ_INDIRECT2_BUSY_MASK         = 0x00000800L;
constexpr unsigned int CP_STAT__ROQ_RING_BUSY_MASK              = 0x00000200L;
constexpr unsigned int CP_STAT__ROQ_STATE_BUSY_MASK             = 0x00001000L;
constexpr unsigned int CP_STAT__SCRATCH_RAM_BUSY_MASK           = 0x01000000L;
constexpr unsigned int CP_STAT__SEMAPHORE_BUSY_MASK             = 0x00080000L;
constexpr unsigned int CP_STAT__SURFACE_SYNC_BUSY_MASK          = 0x00200000L;
constexpr unsigned int CP_STAT__TCIU_BUSY_MASK                  = 0x08000000L;
constexpr unsigned int CP_STAT__UTCL2IU_BUSY_MASK               = 0x00004000L;
constexpr unsigned int CP_STQ_AVAIL__STQ_CNT_MASK               = 0x000001ffL;
constexpr unsigned int CP_STQ_STAT__STQ_RPTR_MASK               = 0x000003ffL;
constexpr unsigned int CP_STQ_THRESHOLDS__STQ0_START_MASK       = 0x000000ffL;
constexpr unsigned int CP_STQ_THRESHOLDS__STQ1_START_MASK       = 0x0000ff00L;
constexpr unsigned int CP_STQ_THRESHOLDS__STQ2_START_MASK       = 0x00ff0000L;
constexpr unsigned int CP_STQ_WR_STAT__STQ_WPTR_MASK            = 0x000003ffL;
constexpr unsigned int CP_STREAM_OUT_ADDR_HI__STREAM_OUT_ADDR_HI_MASK = 0x0000ffffL;
constexpr unsigned int CP_STREAM_OUT_ADDR_LO__STREAM_OUT_ADDR_LO_MASK = 0xfffffffcL;
constexpr unsigned int CP_STRMOUT_CNTL__OFFSET_UPDATE_DONE_MASK = 0x00000001L;
constexpr unsigned int CP_ST_BASE_HI__ST_BASE_HI_MASK           = 0x0000ffffL;
constexpr unsigned int CP_ST_BASE_LO__ST_BASE_LO_MASK           = 0xfffffffcL;
constexpr unsigned int CP_ST_BUFSZ__ST_BUFSZ_MASK               = 0x000fffffL;
constexpr unsigned int CP_ST_CMD_BUFSZ__ST_CMD_REQSZ_MASK       = 0x000fffffL;
constexpr unsigned int CP_VGT_CSINVOC_COUNT_HI__CSINVOC_COUNT_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_VGT_CSINVOC_COUNT_LO__CSINVOC_COUNT_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_VGT_DSINVOC_COUNT_HI__DSINVOC_COUNT_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_VGT_DSINVOC_COUNT_LO__DSINVOC_COUNT_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_VGT_GSINVOC_COUNT_HI__GSINVOC_COUNT_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_VGT_GSINVOC_COUNT_LO__GSINVOC_COUNT_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_VGT_GSPRIM_COUNT_HI__GSPRIM_COUNT_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_VGT_GSPRIM_COUNT_LO__GSPRIM_COUNT_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_VGT_HSINVOC_COUNT_HI__HSINVOC_COUNT_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_VGT_HSINVOC_COUNT_LO__HSINVOC_COUNT_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_VGT_IAPRIM_COUNT_HI__IAPRIM_COUNT_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_VGT_IAPRIM_COUNT_LO__IAPRIM_COUNT_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_VGT_IAVERT_COUNT_HI__IAVERT_COUNT_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_VGT_IAVERT_COUNT_LO__IAVERT_COUNT_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_VGT_VSINVOC_COUNT_HI__VSINVOC_COUNT_HI_MASK = 0xffffffffL;
constexpr unsigned int CP_VGT_VSINVOC_COUNT_LO__VSINVOC_COUNT_LO_MASK = 0xffffffffL;
constexpr unsigned int CP_VIRT_STATUS__VIRT_STATUS_MASK         = 0xffffffffL;
constexpr unsigned int CP_VMID_PREEMPT__PREEMPT_REQUEST_MASK    = 0x0000ffffL;
constexpr unsigned int CP_VMID_PREEMPT__VIRT_COMMAND_MASK       = 0x000f0000L;
constexpr unsigned int CP_VMID_RESET__RESET_REQUEST_MASK        = 0x0000ffffL;
constexpr unsigned int CP_VMID_STATUS__PREEMPT_CE_STATUS_MASK   = 0xffff0000L;
constexpr unsigned int CP_VMID_STATUS__PREEMPT_DE_STATUS_MASK   = 0x0000ffffL;
constexpr unsigned int CP_VMID__VMID_MASK                       = 0x0000000fL;
constexpr unsigned int CP_WAIT_REG_MEM_TIMEOUT__WAIT_REG_MEM_TIMEOUT_MASK = 0xffffffffL;
constexpr unsigned int CP_WAIT_SEM_ADDR_HI__SEM_ADDR_HI_MASK    = 0x0000ffffL;
constexpr unsigned int CP_WAIT_SEM_ADDR_HI__SEM_CLIENT_CODE_MASK = 0x03000000L;
constexpr unsigned int CP_WAIT_SEM_ADDR_HI__SEM_SELECT_MASK     = 0xe0000000L;
constexpr unsigned int CP_WAIT_SEM_ADDR_HI__SEM_SIGNAL_TYPE_MASK = 0x00100000L;
constexpr unsigned int CP_WAIT_SEM_ADDR_HI__SEM_USE_MAILBOX_MASK = 0x00010000L;
constexpr unsigned int CP_WAIT_SEM_ADDR_LO__SEM_ADDR_LO_MASK    = 0xfffffff8L;
constexpr unsigned int CSPRIV_CONNECT__DOORBELL_OFFSET_MASK     = 0x0000ffffL;
constexpr unsigned int CSPRIV_CONNECT__QSWITCH_MODE_MASK        = 0x02000000L;
constexpr unsigned int CSPRIV_CONNECT__QUEUE_ID_MASK            = 0x00e00000L;
constexpr unsigned int CSPRIV_CONNECT__RELAUNCH_WAVES_MASK      = 0x01000000L;
constexpr unsigned int CSPRIV_CONNECT__VMID_MASK                = 0x3c000000L;
constexpr unsigned int CS_COPY_STATE__SRC_STATE_ID_MASK         = 0x00000007L;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_ENABLE_MASK = 0x00000001L;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_OFFSET0_MASK = 0x00000300L;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_OFFSET1_MASK = 0x00000c00L;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_OFFSET2_MASK = 0x00003000L;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_OFFSET3_MASK = 0x0000c000L;
constexpr unsigned int DB_ALPHA_TO_MASK__OFFSET_ROUND_MASK      = 0x00010000L;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__OFF_HYSTERESIS_MASK  = 0x00000ff0L;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__ON_DELAY_MASK        = 0x0000000fL;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__RESERVED_MASK        = 0x0000f000L;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE0_MASK  = 0x80000000L;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE1_MASK  = 0x40000000L;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE2_MASK  = 0x20000000L;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE3_MASK  = 0x10000000L;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE4_MASK  = 0x08000000L;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE5_MASK  = 0x04000000L;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE6_MASK  = 0x02000000L;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE7_MASK  = 0x01000000L;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_STALL_OVERRIDE0_MASK = 0x00800000L;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_STALL_OVERRIDE1_MASK = 0x00400000L;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_STALL_OVERRIDE2_MASK = 0x00200000L;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_STALL_OVERRIDE3_MASK = 0x00100000L;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_STALL_OVERRIDE4_MASK = 0x00080000L;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_STALL_OVERRIDE5_MASK = 0x00040000L;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_STALL_OVERRIDE6_MASK = 0x00020000L;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_STALL_OVERRIDE7_MASK = 0x00010000L;
constexpr unsigned int DB_COUNT_CONTROL__DBFAIL_ENABLE_MASK     = 0x00f00000L;
constexpr unsigned int DB_COUNT_CONTROL__PERFECT_ZPASS_COUNTS_MASK = 0x00000002L;
constexpr unsigned int DB_COUNT_CONTROL__SAMPLE_RATE_MASK       = 0x00000070L;
constexpr unsigned int DB_COUNT_CONTROL__SFAIL_ENABLE_MASK      = 0x000f0000L;
constexpr unsigned int DB_COUNT_CONTROL__SLICE_EVEN_ENABLE_MASK = 0x0f000000L;
constexpr unsigned int DB_COUNT_CONTROL__SLICE_ODD_ENABLE_MASK  = 0xf0000000L;
constexpr unsigned int DB_COUNT_CONTROL__ZFAIL_ENABLE_MASK      = 0x0000f000L;
constexpr unsigned int DB_COUNT_CONTROL__ZPASS_ENABLE_MASK      = 0x00000f00L;
constexpr unsigned int DB_COUNT_CONTROL__ZPASS_INCREMENT_DISABLE_MASK = 0x00000001L;
constexpr unsigned int DB_CREDIT_LIMIT__DB_CB_LQUAD_CREDITS_MASK = 0x00001c00L;
constexpr unsigned int DB_CREDIT_LIMIT__DB_CB_TILE_CREDITS_MASK = 0x7f000000L;
constexpr unsigned int DB_CREDIT_LIMIT__DB_SC_QUAD_CREDITS_MASK = 0x000003e0L;
constexpr unsigned int DB_CREDIT_LIMIT__DB_SC_TILE_CREDITS_MASK = 0x0000001fL;
constexpr unsigned int DB_DEBUG2__ALLOW_COMPZ_BYTE_MASKING_MASK = 0x00000001L;
constexpr unsigned int DB_DEBUG2__CLK_OFF_DELAY_MASK            = 0x00003e00L;
constexpr unsigned int DB_DEBUG2__DISABLE_DTT_DATA_FORWARDING_MASK = 0x00040000L;
constexpr unsigned int DB_DEBUG2__DISABLE_NULL_EOT_FORWARDING_MASK = 0x00020000L;
constexpr unsigned int DB_DEBUG2__DISABLE_PREZL_FIFO_STALL_MASK = 0x00000020L;
constexpr unsigned int DB_DEBUG2__DISABLE_PREZL_FIFO_STALL_REZ_MASK = 0x00000040L;
constexpr unsigned int DB_DEBUG2__DISABLE_PREZL_VIEWPORT_STALL_MASK = 0x20000000L;
constexpr unsigned int DB_DEBUG2__DISABLE_QUAD_COHERENCY_STALL_MASK = 0x00080000L;
constexpr unsigned int DB_DEBUG2__DISABLE_SINGLE_STENCIL_QUAD_SUMM_MASK = 0x40000000L;
constexpr unsigned int DB_DEBUG2__DISABLE_TC_MASK_L0_CACHE_MASK = 0x00000004L;
constexpr unsigned int DB_DEBUG2__DISABLE_TC_ZRANGE_L0_CACHE_MASK = 0x00000002L;
constexpr unsigned int DB_DEBUG2__DISABLE_WRITE_STALL_ON_RDWR_CONFLICT_MASK = 0x80000000L;
constexpr unsigned int DB_DEBUG2__DTR_PREZ_STALLS_FOR_ETF_ROOM_MASK = 0x00000010L;
constexpr unsigned int DB_DEBUG2__DTR_ROUND_ROBIN_ARB_MASK      = 0x00000008L;
constexpr unsigned int DB_DEBUG2__ENABLE_PREZ_OF_REZ_SUMM_MASK  = 0x10000000L;
constexpr unsigned int DB_DEBUG2__ENABLE_VIEWPORT_STALL_ON_ALL_MASK = 0x00000080L;
constexpr unsigned int DB_DEBUG2__OPTIMIZE_HIZ_MATCHES_FB_DISABLE_MASK = 0x00000100L;
constexpr unsigned int DB_DEBUG3__DISABLE_CLEAR_ZRANGE_CORRECTION_MASK = 0x00000001L;
constexpr unsigned int DB_DEBUG3__DISABLE_DI_DT_STALL_MASK      = 0x02000000L;
constexpr unsigned int DB_DEBUG3__DISABLE_EQAA_A2M_PERF_OPT_MASK = 0x01000000L;
constexpr unsigned int DB_DEBUG3__DISABLE_HIZ_ON_VPORT_CLAMP_MASK = 0x00000010L;
constexpr unsigned int DB_DEBUG3__DISABLE_HZ_TC_WRITE_COMBINE_MASK = 0x00100000L;
constexpr unsigned int DB_DEBUG3__DISABLE_OP_DF_BYPASS_MASK     = 0x00002000L;
constexpr unsigned int DB_DEBUG3__DISABLE_OP_DF_DIRECT_FEEDBACK_MASK = 0x00008000L;
constexpr unsigned int DB_DEBUG3__DISABLE_OP_DF_WRITE_COMBINE_MASK = 0x00004000L;
constexpr unsigned int DB_DEBUG3__DISABLE_OP_S_DATA_FORWARDING_MASK = 0x00040000L;
constexpr unsigned int DB_DEBUG3__DISABLE_OP_Z_DATA_FORWARDING_MASK = 0x00001000L;
constexpr unsigned int DB_DEBUG3__DISABLE_OVERRASTERIZATION_FIX_MASK = 0x08000000L;
constexpr unsigned int DB_DEBUG3__DISABLE_RAM_READ_SUPPRESION_ON_FWD_MASK = 0x00800000L;
constexpr unsigned int DB_DEBUG3__DISABLE_RECOMP_TO_1ZPLANE_WITHOUT_FASTOP_MASK = 0x00000400L;
constexpr unsigned int DB_DEBUG3__DISABLE_REDUNDANT_PLANE_FLUSHES_OPT_MASK = 0x00000200L;
constexpr unsigned int DB_DEBUG3__DISABLE_TCP_CAM_BYPASS_MASK   = 0x00000080L;
constexpr unsigned int DB_DEBUG3__DISABLE_TC_UPDATE_WRITE_COMBINE_MASK = 0x00080000L;
constexpr unsigned int DB_DEBUG3__DISABLE_TL_SSO_NULL_SUPPRESSION_MASK = 0x00000008L;
constexpr unsigned int DB_DEBUG3__DISABLE_ZCMP_DIRTY_SUPPRESSION_MASK = 0x00000100L;
constexpr unsigned int DB_DEBUG3__DONT_INSERT_CONTEXT_SUSPEND_MASK = 0x10000000L;
constexpr unsigned int DB_DEBUG3__ENABLE_DB_PROCESS_RESET_MASK  = 0x04000000L;
constexpr unsigned int DB_DEBUG3__ENABLE_INCOHERENT_EQAA_READS_MASK = 0x00000800L;
constexpr unsigned int DB_DEBUG3__ENABLE_RECOMP_ZDIRTY_SUPPRESSION_OPT_MASK = 0x00200000L;
constexpr unsigned int DB_DEBUG3__ENABLE_TC_MA_ROUND_ROBIN_ARB_MASK = 0x00400000L;
constexpr unsigned int DB_DEBUG3__EQAA_INTERPOLATE_COMP_Z_MASK  = 0x00000020L;
constexpr unsigned int DB_DEBUG3__EQAA_INTERPOLATE_SRC_Z_MASK   = 0x00000040L;
constexpr unsigned int DB_DEBUG3__FORCE_DB_IS_GOOD_MASK         = 0x00000004L;
constexpr unsigned int DB_DEBUG3__SLOW_PREZ_TO_A2M_OMASK_RATE_MASK = 0x00020000L;
constexpr unsigned int DB_DEBUG4__DFSM_CONVERT_PASSTHROUGH_TO_BYPASS_MASK = 0x00000100L;
constexpr unsigned int DB_DEBUG4__DISABLE_DTT_FAST_HTILENACK_LOOKUP_MASK = 0x00002000L;
constexpr unsigned int DB_DEBUG4__DISABLE_PREZ_POSTZ_DTILE_CONFLICT_STALL_MASK = 0x00000008L;
constexpr unsigned int DB_DEBUG4__DISABLE_QC_STENCIL_MASK_SUMMATION_MASK = 0x00000002L;
constexpr unsigned int DB_DEBUG4__DISABLE_QC_Z_MASK_SUMMATION_MASK = 0x00000001L;
constexpr unsigned int DB_DEBUG4__DISABLE_RESCHECK_MEMCOHER_OPTIMIZATION_MASK = 0x00004000L;
constexpr unsigned int DB_DEBUG4__DISABLE_RESUMM_TO_SINGLE_STENCIL_MASK = 0x00000004L;
constexpr unsigned int DB_DEBUG4__DISABLE_UNMAPPED_H_INDICATOR_MASK = 0x00000800L;
constexpr unsigned int DB_DEBUG4__DISABLE_UNMAPPED_S_INDICATOR_MASK = 0x00000400L;
constexpr unsigned int DB_DEBUG4__DISABLE_UNMAPPED_Z_INDICATOR_MASK = 0x00000200L;
constexpr unsigned int DB_DEBUG__DEBUG_DEPTH_COMPRESS_DISABLE_MASK = 0x00000002L;
constexpr unsigned int DB_DEBUG__DEBUG_FAST_STENCIL_DISABLE_MASK = 0x00008000L;
constexpr unsigned int DB_DEBUG__DEBUG_FAST_Z_DISABLE_MASK      = 0x00004000L;
constexpr unsigned int DB_DEBUG__DEBUG_FORCE_DEPTH_READ_MASK    = 0x00000040L;
constexpr unsigned int DB_DEBUG__DEBUG_FORCE_FULL_Z_RANGE_MASK  = 0x00180000L;
constexpr unsigned int DB_DEBUG__DEBUG_FORCE_HIS_ENABLE0_MASK   = 0x00000c00L;
constexpr unsigned int DB_DEBUG__DEBUG_FORCE_HIS_ENABLE1_MASK   = 0x00003000L;
constexpr unsigned int DB_DEBUG__DEBUG_FORCE_HIZ_ENABLE_MASK    = 0x00000300L;
constexpr unsigned int DB_DEBUG__DEBUG_FORCE_STENCIL_READ_MASK  = 0x00000080L;
constexpr unsigned int DB_DEBUG__DEBUG_NOOP_CULL_DISABLE_MASK   = 0x00010000L;
constexpr unsigned int DB_DEBUG__DEBUG_STENCIL_COMPRESS_DISABLE_MASK = 0x00000001L;
constexpr unsigned int DB_DEBUG__DECOMPRESS_AFTER_N_ZPLANES_MASK = 0x0f000000L;
constexpr unsigned int DB_DEBUG__DEPTH_CACHE_FORCE_MISS_MASK    = 0x00040000L;
constexpr unsigned int DB_DEBUG__DISABLE_DEPTH_SURFACE_SYNC_MASK = 0x40000000L;
constexpr unsigned int DB_DEBUG__DISABLE_HTILE_SURFACE_SYNC_MASK = 0x80000000L;
constexpr unsigned int DB_DEBUG__DISABLE_SUMM_SQUADS_MASK       = 0x00020000L;
constexpr unsigned int DB_DEBUG__DISABLE_VPORT_ZPLANE_OPTIMIZATION_MASK = 0x00800000L;
constexpr unsigned int DB_DEBUG__FETCH_FULL_STENCIL_TILE_MASK   = 0x00000008L;
constexpr unsigned int DB_DEBUG__FETCH_FULL_Z_TILE_MASK         = 0x00000004L;
constexpr unsigned int DB_DEBUG__FORCE_MISS_IF_NOT_INFLIGHT_MASK = 0x20000000L;
constexpr unsigned int DB_DEBUG__FORCE_Z_MODE_MASK              = 0x00000030L;
constexpr unsigned int DB_DEBUG__NEVER_FREE_Z_ONLY_MASK         = 0x00200000L;
constexpr unsigned int DB_DEBUG__ONE_FREE_IN_FLIGHT_MASK        = 0x10000000L;
constexpr unsigned int DB_DEBUG__ZPASS_COUNTS_LOOK_AT_PIPE_STAT_EVENTS_MASK = 0x00400000L;
constexpr unsigned int DB_DEPTH_BOUNDS_MAX__MAX_MASK            = 0xffffffffL;
constexpr unsigned int DB_DEPTH_BOUNDS_MIN__MIN_MASK            = 0xffffffffL;
constexpr unsigned int DB_DEPTH_CLEAR__DEPTH_CLEAR_MASK         = 0xffffffffL;
constexpr unsigned int DB_DEPTH_CONTROL__BACKFACE_ENABLE_MASK   = 0x00000080L;
constexpr unsigned int DB_DEPTH_CONTROL__DEPTH_BOUNDS_ENABLE_MASK = 0x00000008L;
constexpr unsigned int DB_DEPTH_CONTROL__DISABLE_COLOR_WRITES_ON_DEPTH_PASS_MASK = 0x80000000L;
constexpr unsigned int DB_DEPTH_CONTROL__ENABLE_COLOR_WRITES_ON_DEPTH_FAIL_MASK = 0x40000000L;
constexpr unsigned int DB_DEPTH_CONTROL__STENCILFUNC_BF_MASK    = 0x00700000L;
constexpr unsigned int DB_DEPTH_CONTROL__STENCILFUNC_MASK       = 0x00000700L;
constexpr unsigned int DB_DEPTH_CONTROL__STENCIL_ENABLE_MASK    = 0x00000001L;
constexpr unsigned int DB_DEPTH_CONTROL__ZFUNC_MASK             = 0x00000070L;
constexpr unsigned int DB_DEPTH_CONTROL__Z_ENABLE_MASK          = 0x00000002L;
constexpr unsigned int DB_DEPTH_CONTROL__Z_WRITE_ENABLE_MASK    = 0x00000004L;
constexpr unsigned int DB_DEPTH_VIEW__MIPID_MASK                = 0x3c000000L;
constexpr unsigned int DB_DEPTH_VIEW__SLICE_MAX_MASK            = 0x00ffe000L;
constexpr unsigned int DB_DEPTH_VIEW__SLICE_START_MASK          = 0x000007ffL;
constexpr unsigned int DB_DEPTH_VIEW__STENCIL_READ_ONLY_MASK    = 0x02000000L;
constexpr unsigned int DB_DEPTH_VIEW__Z_READ_ONLY_MASK          = 0x01000000L;
constexpr unsigned int DB_DFSM_CONFIG__BYPASS_DFSM_MASK         = 0x00000001L;
constexpr unsigned int DB_DFSM_CONFIG__DISABLE_POPS_MASK        = 0x00000004L;
constexpr unsigned int DB_DFSM_CONFIG__DISABLE_PUNCHOUT_MASK    = 0x00000002L;
constexpr unsigned int DB_DFSM_CONFIG__FORCE_FLUSH_MASK         = 0x00000008L;
constexpr unsigned int DB_DFSM_CONTROL__DISALLOW_OVERFLOW_MASK  = 0x00000008L;
constexpr unsigned int DB_DFSM_CONTROL__POPS_DRAIN_PS_ON_OVERLAP_MASK = 0x00000004L;
constexpr unsigned int DB_DFSM_CONTROL__PUNCHOUT_MODE_MASK      = 0x00000003L;
constexpr unsigned int DB_DFSM_FLUSH_AUX_EVENT__EVENT_A_MASK    = 0x000000ffL;
constexpr unsigned int DB_DFSM_FLUSH_AUX_EVENT__EVENT_B_MASK    = 0x0000ff00L;
constexpr unsigned int DB_DFSM_FLUSH_AUX_EVENT__EVENT_C_MASK    = 0x00ff0000L;
constexpr unsigned int DB_DFSM_FLUSH_AUX_EVENT__EVENT_D_MASK    = 0xff000000L;
constexpr unsigned int DB_DFSM_FLUSH_ENABLE__AUX_EVENTS_MASK    = 0xf0000000L;
constexpr unsigned int DB_DFSM_FLUSH_ENABLE__AUX_FORCE_PASSTHRU_MASK = 0x0f000000L;
constexpr unsigned int DB_DFSM_PRIMS_IN_FLIGHT__HIGH_WATERMARK_MASK = 0x0000ffffL;
constexpr unsigned int DB_DFSM_TILES_IN_FLIGHT__HIGH_WATERMARK_MASK = 0x0000ffffL;
constexpr unsigned int DB_DFSM_WATCHDOG__TIMER_TARGET_MASK      = 0xffffffffL;
constexpr unsigned int DB_EQAA__ALPHA_TO_MASK_EQAA_DISABLE_MASK = 0x00200000L;
constexpr unsigned int DB_EQAA__ALPHA_TO_MASK_NUM_SAMPLES_MASK  = 0x00007000L;
constexpr unsigned int DB_EQAA__ENABLE_POSTZ_OVERRASTERIZATION_MASK = 0x08000000L;
constexpr unsigned int DB_EQAA__HIGH_QUALITY_INTERSECTIONS_MASK = 0x00010000L;
constexpr unsigned int DB_EQAA__INCOHERENT_EQAA_READS_MASK      = 0x00020000L;
constexpr unsigned int DB_EQAA__INTERPOLATE_COMP_Z_MASK         = 0x00040000L;
constexpr unsigned int DB_EQAA__INTERPOLATE_SRC_Z_MASK          = 0x00080000L;
constexpr unsigned int DB_EQAA__MASK_EXPORT_NUM_SAMPLES_MASK    = 0x00000700L;
constexpr unsigned int DB_EQAA__MAX_ANCHOR_SAMPLES_MASK         = 0x00000007L;
constexpr unsigned int DB_EQAA__OVERRASTERIZATION_AMOUNT_MASK   = 0x07000000L;
constexpr unsigned int DB_EQAA__PS_ITER_SAMPLES_MASK            = 0x00000070L;
constexpr unsigned int DB_EQAA__STATIC_ANCHOR_ASSOCIATIONS_MASK = 0x00100000L;
constexpr unsigned int DB_EXCEPTION_CONTROL__EARLY_Z_PANIC_DISABLE_MASK = 0x00000001L;
constexpr unsigned int DB_EXCEPTION_CONTROL__LATE_Z_PANIC_DISABLE_MASK = 0x00000002L;
constexpr unsigned int DB_EXCEPTION_CONTROL__RE_Z_PANIC_DISABLE_MASK = 0x00000004L;
constexpr unsigned int DB_FIFO_DEPTH2__EQUAD_FIFO_DEPTH_MASK    = 0x000000ffL;
constexpr unsigned int DB_FIFO_DEPTH2__LTILE_OP_FIFO_DEPTH_MASK = 0xfe000000L;
constexpr unsigned int DB_HTILE_DATA_BASE_HI__BASE_HI_MASK      = 0x000000ffL;
constexpr unsigned int DB_HTILE_DATA_BASE__BASE_256B_MASK       = 0xffffffffL;
constexpr unsigned int DB_HTILE_SURFACE__DST_OUTSIDE_ZERO_TO_ONE_MASK = 0x00010000L;
constexpr unsigned int DB_HTILE_SURFACE__FULL_CACHE_MASK        = 0x00000002L;
constexpr unsigned int DB_HTILE_SURFACE__PIPE_ALIGNED_MASK      = 0x00040000L;
constexpr unsigned int DB_MEM_ARB_WATERMARKS__CLIENT0_WATERMARK_MASK = 0x00000007L;
constexpr unsigned int DB_MEM_ARB_WATERMARKS__CLIENT1_WATERMARK_MASK = 0x00000700L;
constexpr unsigned int DB_MEM_ARB_WATERMARKS__CLIENT2_WATERMARK_MASK = 0x00070000L;
constexpr unsigned int DB_MEM_ARB_WATERMARKS__CLIENT3_WATERMARK_MASK = 0x07000000L;
constexpr unsigned int DB_OCCLUSION_COUNT0_HI__COUNT_HI_MASK    = 0x7fffffffL;
constexpr unsigned int DB_OCCLUSION_COUNT0_LOW__COUNT_LOW_MASK  = 0xffffffffL;
constexpr unsigned int DB_OCCLUSION_COUNT1_HI__COUNT_HI_MASK    = 0x7fffffffL;
constexpr unsigned int DB_OCCLUSION_COUNT1_LOW__COUNT_LOW_MASK  = 0xffffffffL;
constexpr unsigned int DB_OCCLUSION_COUNT2_HI__COUNT_HI_MASK    = 0x7fffffffL;
constexpr unsigned int DB_OCCLUSION_COUNT2_LOW__COUNT_LOW_MASK  = 0xffffffffL;
constexpr unsigned int DB_OCCLUSION_COUNT3_HI__COUNT_HI_MASK    = 0x7fffffffL;
constexpr unsigned int DB_OCCLUSION_COUNT3_LOW__COUNT_LOW_MASK  = 0xffffffffL;
constexpr unsigned int DB_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int DB_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int DB_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
constexpr unsigned int DB_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
constexpr unsigned int DB_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK  = 0x000003ffL;
constexpr unsigned int DB_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK  = 0x000ffc00L;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__CNTR_MODE_MASK   = 0x00f00000L;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__PERF_MODE1_MASK  = 0x0f000000L;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__PERF_MODE_MASK   = 0xf0000000L;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__PERF_SEL1_MASK   = 0x000ffc00L;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__PERF_SEL_MASK    = 0x000003ffL;
constexpr unsigned int DB_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int DB_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int DB_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
constexpr unsigned int DB_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
constexpr unsigned int DB_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK  = 0x000003ffL;
constexpr unsigned int DB_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK  = 0x000ffc00L;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__CNTR_MODE_MASK   = 0x00f00000L;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__PERF_MODE1_MASK  = 0x0f000000L;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__PERF_MODE_MASK   = 0xf0000000L;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__PERF_SEL1_MASK   = 0x000ffc00L;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__PERF_SEL_MASK    = 0x000003ffL;
constexpr unsigned int DB_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int DB_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__CNTR_MODE_MASK   = 0x00f00000L;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__PERF_MODE1_MASK  = 0x0f000000L;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__PERF_MODE_MASK   = 0xf0000000L;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__PERF_SEL1_MASK   = 0x000ffc00L;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__PERF_SEL_MASK    = 0x000003ffL;
constexpr unsigned int DB_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int DB_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__CNTR_MODE_MASK   = 0x00f00000L;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__PERF_MODE1_MASK  = 0x0f000000L;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__PERF_MODE_MASK   = 0xf0000000L;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__PERF_SEL1_MASK   = 0x000ffc00L;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__PERF_SEL_MASK    = 0x000003ffL;
constexpr unsigned int DB_PRELOAD_CONTROL__MAX_X_MASK           = 0x00ff0000L;
constexpr unsigned int DB_PRELOAD_CONTROL__MAX_Y_MASK           = 0xff000000L;
constexpr unsigned int DB_PRELOAD_CONTROL__START_X_MASK         = 0x000000ffL;
constexpr unsigned int DB_PRELOAD_CONTROL__START_Y_MASK         = 0x0000ff00L;
constexpr unsigned int DB_READ_DEBUG_3__DEBUG_DATA_MASK         = 0xffffffffL;
constexpr unsigned int DB_READ_DEBUG_4__DEBUG_DATA_MASK         = 0xffffffffL;
constexpr unsigned int DB_READ_DEBUG_5__DEBUG_DATA_MASK         = 0xffffffffL;
constexpr unsigned int DB_READ_DEBUG_6__DEBUG_DATA_MASK         = 0xffffffffL;
constexpr unsigned int DB_READ_DEBUG_7__DEBUG_DATA_MASK         = 0xffffffffL;
constexpr unsigned int DB_READ_DEBUG_8__DEBUG_DATA_MASK         = 0xffffffffL;
constexpr unsigned int DB_READ_DEBUG_9__DEBUG_DATA_MASK         = 0xffffffffL;
constexpr unsigned int DB_READ_DEBUG_A__DEBUG_DATA_MASK         = 0xffffffffL;
constexpr unsigned int DB_READ_DEBUG_B__DEBUG_DATA_MASK         = 0xffffffffL;
constexpr unsigned int DB_READ_DEBUG_C__DEBUG_DATA_MASK         = 0xffffffffL;
constexpr unsigned int DB_READ_DEBUG_D__DEBUG_DATA_MASK         = 0xffffffffL;
constexpr unsigned int DB_READ_DEBUG_E__DEBUG_DATA_MASK         = 0xffffffffL;
constexpr unsigned int DB_READ_DEBUG_F__DEBUG_DATA_MASK         = 0xffffffffL;
constexpr unsigned int DB_RENDER_CONTROL__COPY_CENTROID_MASK    = 0x00000080L;
constexpr unsigned int DB_RENDER_CONTROL__COPY_SAMPLE_MASK      = 0x00000f00L;
constexpr unsigned int DB_RENDER_CONTROL__DECOMPRESS_ENABLE_MASK = 0x00001000L;
constexpr unsigned int DB_RENDER_CONTROL__DEPTH_CLEAR_ENABLE_MASK = 0x00000001L;
constexpr unsigned int DB_RENDER_CONTROL__DEPTH_COMPRESS_DISABLE_MASK = 0x00000040L;
constexpr unsigned int DB_RENDER_CONTROL__DEPTH_COPY_MASK       = 0x00000004L;
constexpr unsigned int DB_RENDER_CONTROL__RESUMMARIZE_ENABLE_MASK = 0x00000010L;
constexpr unsigned int DB_RENDER_CONTROL__STENCIL_CLEAR_ENABLE_MASK = 0x00000002L;
constexpr unsigned int DB_RENDER_CONTROL__STENCIL_COMPRESS_DISABLE_MASK = 0x00000020L;
constexpr unsigned int DB_RENDER_CONTROL__STENCIL_COPY_MASK     = 0x00000008L;
constexpr unsigned int DB_RENDER_OVERRIDE2__ALLOW_PARTIAL_RES_HIER_KILL_MASK = 0x02000000L;
constexpr unsigned int DB_RENDER_OVERRIDE2__DECOMPRESS_Z_ON_FLUSH_MASK = 0x00000100L;
constexpr unsigned int DB_RENDER_OVERRIDE2__DEPTH_BOUNDS_HIER_DEPTH_DISABLE_MASK = 0x00000400L;
constexpr unsigned int DB_RENDER_OVERRIDE2__DISABLE_COLOR_ON_VALIDATION_MASK = 0x00000080L;
constexpr unsigned int DB_RENDER_OVERRIDE2__DISABLE_FAST_PASS_MASK = 0x00800000L;
constexpr unsigned int DB_RENDER_OVERRIDE2__DISABLE_REG_SNOOP_MASK = 0x00000200L;
constexpr unsigned int DB_RENDER_OVERRIDE2__DISABLE_SMEM_EXPCLEAR_OPTIMIZATION_MASK = 0x00000040L;
constexpr unsigned int DB_RENDER_OVERRIDE2__DISABLE_ZMASK_EXPCLEAR_OPTIMIZATION_MASK = 0x00000020L;
constexpr unsigned int DB_RENDER_OVERRIDE2__HIS_SFUNC_BF_MASK   = 0x001c0000L;
constexpr unsigned int DB_RENDER_OVERRIDE2__HIS_SFUNC_FF_MASK   = 0x00038000L;
constexpr unsigned int DB_RENDER_OVERRIDE2__HIZ_ZFUNC_MASK      = 0x00007000L;
constexpr unsigned int DB_RENDER_OVERRIDE2__PARTIAL_SQUAD_LAUNCH_CONTROL_MASK = 0x00000003L;
constexpr unsigned int DB_RENDER_OVERRIDE2__PARTIAL_SQUAD_LAUNCH_COUNTDOWN_MASK = 0x0000001cL;
constexpr unsigned int DB_RENDER_OVERRIDE2__PRESERVE_SRESULTS_MASK = 0x00400000L;
constexpr unsigned int DB_RENDER_OVERRIDE2__PRESERVE_ZRANGE_MASK = 0x00200000L;
constexpr unsigned int DB_RENDER_OVERRIDE2__SEPARATE_HIZS_FUNC_ENABLE_MASK = 0x00000800L;
constexpr unsigned int DB_RENDER_OVERRIDE__DISABLE_FULLY_COVERED_MASK = 0x00040000L;
constexpr unsigned int DB_RENDER_OVERRIDE__DISABLE_TILE_RATE_TILES_MASK = 0x04000000L;
constexpr unsigned int DB_RENDER_OVERRIDE__DISABLE_VIEWPORT_CLAMP_MASK = 0x00010000L;
constexpr unsigned int DB_RENDER_OVERRIDE__FAST_STENCIL_DISABLE_MASK = 0x00000100L;
constexpr unsigned int DB_RENDER_OVERRIDE__FAST_Z_DISABLE_MASK  = 0x00000080L;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_COLOR_KILL_MASK = 0x00000400L;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_FULL_Z_RANGE_MASK = 0x00006000L;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_HIS_ENABLE0_MASK = 0x0000000cL;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_HIS_ENABLE1_MASK = 0x00000030L;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_HIZ_ENABLE_MASK = 0x00000003L;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_QC_SMASK_CONFLICT_MASK = 0x00008000L;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_SHADER_Z_ORDER_MASK = 0x00000040L;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_STENCIL_DIRTY_MASK = 0x10000000L;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_STENCIL_READ_MASK = 0x00001000L;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_STENCIL_VALID_MASK = 0x40000000L;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_Z_DIRTY_MASK   = 0x08000000L;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_Z_LIMIT_SUMM_MASK = 0x00180000L;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_Z_READ_MASK    = 0x00000800L;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_Z_VALID_MASK   = 0x20000000L;
constexpr unsigned int DB_RENDER_OVERRIDE__IGNORE_SC_ZRANGE_MASK = 0x00020000L;
constexpr unsigned int DB_RENDER_OVERRIDE__MAX_TILES_IN_DTT_MASK = 0x03e00000L;
constexpr unsigned int DB_RENDER_OVERRIDE__NOOP_CULL_DISABLE_MASK = 0x00000200L;
constexpr unsigned int DB_RENDER_OVERRIDE__PRESERVE_COMPRESSION_MASK = 0x80000000L;
constexpr unsigned int DB_RING_CONTROL__COUNTER_CONTROL_MASK    = 0x00000003L;
constexpr unsigned int DB_SHADER_CONTROL__ALPHA_TO_MASK_DISABLE_MASK = 0x00000800L;
constexpr unsigned int DB_SHADER_CONTROL__CONSERVATIVE_Z_EXPORT_MASK = 0x00006000L;
constexpr unsigned int DB_SHADER_CONTROL__COVERAGE_TO_MASK_ENABLE_MASK = 0x00000080L;
constexpr unsigned int DB_SHADER_CONTROL__DEPTH_BEFORE_SHADER_MASK = 0x00001000L;
constexpr unsigned int DB_SHADER_CONTROL__DUAL_QUAD_DISABLE_MASK = 0x00008000L;
constexpr unsigned int DB_SHADER_CONTROL__EXEC_IF_OVERLAPPED_MASK = 0x00020000L;
constexpr unsigned int DB_SHADER_CONTROL__EXEC_ON_HIER_FAIL_MASK = 0x00000200L;
constexpr unsigned int DB_SHADER_CONTROL__EXEC_ON_NOOP_MASK     = 0x00000400L;
constexpr unsigned int DB_SHADER_CONTROL__KILL_ENABLE_MASK      = 0x00000040L;
constexpr unsigned int DB_SHADER_CONTROL__MASK_EXPORT_ENABLE_MASK = 0x00000100L;
constexpr unsigned int DB_SHADER_CONTROL__POPS_OVERLAP_NUM_SAMPLES_MASK = 0x00700000L;
constexpr unsigned int DB_SHADER_CONTROL__PRIMITIVE_ORDERED_PIXEL_SHADER_MASK = 0x00010000L;
constexpr unsigned int DB_SHADER_CONTROL__STENCIL_OP_VAL_EXPORT_ENABLE_MASK = 0x00000004L;
constexpr unsigned int DB_SHADER_CONTROL__STENCIL_TEST_VAL_EXPORT_ENABLE_MASK = 0x00000002L;
constexpr unsigned int DB_SHADER_CONTROL__Z_EXPORT_ENABLE_MASK  = 0x00000001L;
constexpr unsigned int DB_SHADER_CONTROL__Z_ORDER_MASK          = 0x00000030L;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE0__COMPAREFUNC0_MASK = 0x00000007L;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE0__COMPAREMASK0_MASK = 0x000ff000L;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE0__COMPAREVALUE0_MASK = 0x00000ff0L;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE0__ENABLE0_MASK = 0x01000000L;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE1__COMPAREFUNC1_MASK = 0x00000007L;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE1__COMPAREMASK1_MASK = 0x000ff000L;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE1__COMPAREVALUE1_MASK = 0x00000ff0L;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE1__ENABLE1_MASK = 0x01000000L;
constexpr unsigned int DB_STENCILREFMASK_BF__STENCILMASK_BF_MASK = 0x0000ff00L;
constexpr unsigned int DB_STENCILREFMASK_BF__STENCILOPVAL_BF_MASK = 0xff000000L;
constexpr unsigned int DB_STENCILREFMASK_BF__STENCILTESTVAL_BF_MASK = 0x000000ffL;
constexpr unsigned int DB_STENCILREFMASK_BF__STENCILWRITEMASK_BF_MASK = 0x00ff0000L;
constexpr unsigned int DB_STENCILREFMASK__STENCILMASK_MASK      = 0x0000ff00L;
constexpr unsigned int DB_STENCILREFMASK__STENCILOPVAL_MASK     = 0xff000000L;
constexpr unsigned int DB_STENCILREFMASK__STENCILTESTVAL_MASK   = 0x000000ffL;
constexpr unsigned int DB_STENCILREFMASK__STENCILWRITEMASK_MASK = 0x00ff0000L;
constexpr unsigned int DB_STENCIL_CLEAR__CLEAR_MASK             = 0x000000ffL;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILFAIL_BF_MASK  = 0x0000f000L;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILFAIL_MASK     = 0x0000000fL;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILZFAIL_BF_MASK = 0x00f00000L;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILZFAIL_MASK    = 0x00000f00L;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILZPASS_BF_MASK = 0x000f0000L;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILZPASS_MASK    = 0x000000f0L;
constexpr unsigned int DB_STENCIL_INFO__ALLOW_EXPCLEAR_MASK     = 0x08000000L;
constexpr unsigned int DB_STENCIL_INFO__FORMAT_MASK             = 0x00000001L;
constexpr unsigned int DB_STENCIL_INFO__PARTIALLY_RESIDENT_MASK = 0x00001000L;
constexpr unsigned int DB_STENCIL_INFO__SW_MODE_MASK            = 0x000001f0L;
constexpr unsigned int DB_STENCIL_INFO__TILE_STENCIL_DISABLE_MASK = 0x20000000L;
constexpr unsigned int DB_STENCIL_READ_BASE_HI__BASE_HI_MASK    = 0x000000ffL;
constexpr unsigned int DB_STENCIL_READ_BASE__BASE_256B_MASK     = 0xffffffffL;
constexpr unsigned int DB_STENCIL_WRITE_BASE_HI__BASE_HI_MASK   = 0x000000ffL;
constexpr unsigned int DB_STENCIL_WRITE_BASE__BASE_256B_MASK    = 0xffffffffL;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA1_X_MASK         = 0x00000003L;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA1_Y_MASK         = 0x0000000cL;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA2_X_MASK         = 0x00000030L;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA2_Y_MASK         = 0x000000c0L;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA4_X_MASK         = 0x00000300L;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA4_Y_MASK         = 0x00000c00L;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA8_X_MASK         = 0x00003000L;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA8_Y_MASK         = 0x0000c000L;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA16_X_MASK        = 0x00030000L;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA16_Y_MASK        = 0x000c0000L;
constexpr unsigned int DB_ZPASS_COUNT_HI__COUNT_HI_MASK         = 0x7fffffffL;
constexpr unsigned int DB_ZPASS_COUNT_LOW__COUNT_LOW_MASK       = 0xffffffffL;
constexpr unsigned int DB_Z_INFO__ALLOW_EXPCLEAR_MASK           = 0x08000000L;
constexpr unsigned int DB_Z_INFO__DECOMPRESS_ON_N_ZPLANES_MASK  = 0x07800000L;
constexpr unsigned int DB_Z_INFO__FORMAT_MASK                   = 0x00000003L;
constexpr unsigned int DB_Z_INFO__MAXMIP_MASK                   = 0x000f0000L;
constexpr unsigned int DB_Z_INFO__NUM_SAMPLES_MASK              = 0x0000000cL;
constexpr unsigned int DB_Z_INFO__PARTIALLY_RESIDENT_MASK       = 0x00001000L;
constexpr unsigned int DB_Z_INFO__READ_SIZE_MASK                = 0x10000000L;
constexpr unsigned int DB_Z_INFO__SW_MODE_MASK                  = 0x000001f0L;
constexpr unsigned int DB_Z_INFO__TILE_SURFACE_ENABLE_MASK      = 0x20000000L;
constexpr unsigned int DB_Z_INFO__ZRANGE_PRECISION_MASK         = 0x80000000L;
constexpr unsigned int DB_Z_READ_BASE_HI__BASE_HI_MASK          = 0x000000ffL;
constexpr unsigned int DB_Z_READ_BASE__BASE_256B_MASK           = 0xffffffffL;
constexpr unsigned int DB_Z_WRITE_BASE_HI__BASE_HI_MASK         = 0x000000ffL;
constexpr unsigned int DB_Z_WRITE_BASE__BASE_256B_MASK          = 0xffffffffL;
constexpr unsigned int DEBUG_DATA__DEBUG_DATA_MASK              = 0xffffffffL;
constexpr unsigned int DEBUG_INDEX__DEBUG_INDEX_MASK            = 0x0003ffffL;
constexpr unsigned int GB_ADDR_CONFIG_READ__MAX_COMPRESSED_FRAGS_MASK = 0x000000c0L;
constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_PIPES_MASK      = 0x00000007L;
constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_RB_PER_SE_MASK  = 0x0c000000L;
constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_SHADER_ENGINES_MASK = 0x00180000L;
constexpr unsigned int GB_ADDR_CONFIG_READ__PIPE_INTERLEAVE_SIZE_MASK = 0x00000038L;
constexpr unsigned int GB_ADDR_CONFIG__MAX_COMPRESSED_FRAGS_MASK = 0x000000c0L;
constexpr unsigned int GB_ADDR_CONFIG__NUM_PIPES_MASK           = 0x00000007L;
constexpr unsigned int GB_ADDR_CONFIG__NUM_RB_PER_SE_MASK       = 0x0c000000L;
constexpr unsigned int GB_ADDR_CONFIG__NUM_SHADER_ENGINES_MASK  = 0x00180000L;
constexpr unsigned int GB_ADDR_CONFIG__PIPE_INTERLEAVE_SIZE_MASK = 0x00000038L;
constexpr unsigned int GB_BACKEND_MAP__BACKEND_MAP_MASK         = 0xffffffffL;
constexpr unsigned int GB_EDC_MODE__BYPASS_MASK                 = 0x80000000L;
constexpr unsigned int GB_EDC_MODE__COUNT_FED_OUT_MASK          = 0x00010000L;
constexpr unsigned int GB_EDC_MODE__DED_MODE_MASK               = 0x00300000L;
constexpr unsigned int GB_EDC_MODE__FORCE_SEC_ON_DED_MASK       = 0x00008000L;
constexpr unsigned int GB_EDC_MODE__GATE_FUE_MASK               = 0x00020000L;
constexpr unsigned int GB_EDC_MODE__PROP_FED_MASK               = 0x20000000L;
constexpr unsigned int GB_GPU_ID__GPU_ID_MASK                   = 0x0000000fL;
constexpr unsigned int GCEA_PERFCOUNTER0_CFG__CLEAR_MASK        = 0x20000000L;
constexpr unsigned int GCEA_PERFCOUNTER0_CFG__ENABLE_MASK       = 0x10000000L;
constexpr unsigned int GCEA_PERFCOUNTER0_CFG__PERF_MODE_MASK    = 0x0f000000L;
constexpr unsigned int GCEA_PERFCOUNTER0_CFG__PERF_SEL_END_MASK = 0x0000ff00L;
constexpr unsigned int GCEA_PERFCOUNTER0_CFG__PERF_SEL_MASK     = 0x000000ffL;
constexpr unsigned int GCEA_PERFCOUNTER1_CFG__CLEAR_MASK        = 0x20000000L;
constexpr unsigned int GCEA_PERFCOUNTER1_CFG__ENABLE_MASK       = 0x10000000L;
constexpr unsigned int GCEA_PERFCOUNTER1_CFG__PERF_MODE_MASK    = 0x0f000000L;
constexpr unsigned int GCEA_PERFCOUNTER1_CFG__PERF_SEL_END_MASK = 0x0000ff00L;
constexpr unsigned int GCEA_PERFCOUNTER1_CFG__PERF_SEL_MASK     = 0x000000ffL;
constexpr unsigned int GCEA_PERFCOUNTER_HI__COMPARE_VALUE_MASK  = 0xffff0000L;
constexpr unsigned int GCEA_PERFCOUNTER_HI__COUNTER_HI_MASK     = 0x0000ffffL;
constexpr unsigned int GCEA_PERFCOUNTER_LO__COUNTER_LO_MASK     = 0xffffffffL;
constexpr unsigned int GCEA_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL_MASK = 0x02000000L;
constexpr unsigned int GCEA_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY_MASK = 0x01000000L;
constexpr unsigned int GCEA_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT_MASK = 0x0000000fL;
constexpr unsigned int GCEA_PERFCOUNTER_RSLT_CNTL__START_TRIGGER_MASK = 0x0000ff00L;
constexpr unsigned int GCEA_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE_MASK = 0x04000000L;
constexpr unsigned int GCEA_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER_MASK = 0x00ff0000L;
constexpr unsigned int GC_CAC_ACC_BCI0__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_CB0__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_CB1__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_CB2__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_CB3__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_CP0__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_CP1__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_CP2__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_CU0__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_DB0__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_DB1__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_DB2__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_DB3__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_EA0__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_EA1__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_EA2__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_EA3__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_EA4__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_EA5__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_GDS0__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_GDS1__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_GDS2__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_GDS3__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_LDS0__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_LDS1__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_LDS2__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_LDS3__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_PA0__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_PA1__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_PC0__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_RMI0__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_SC0__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_SPI0__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_SPI1__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_SPI2__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_SPI3__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_SPI4__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_SPI5__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_SQ0_LOWER__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_SQ0_UPPER__ACCUMULATOR_39_32_MASK = 0x000000ffL;
constexpr unsigned int GC_CAC_ACC_SQ1_LOWER__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_SQ1_UPPER__ACCUMULATOR_39_32_MASK = 0x000000ffL;
constexpr unsigned int GC_CAC_ACC_SQ2_LOWER__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_SQ2_UPPER__ACCUMULATOR_39_32_MASK = 0x000000ffL;
constexpr unsigned int GC_CAC_ACC_SQ3_LOWER__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_SQ3_UPPER__ACCUMULATOR_39_32_MASK = 0x000000ffL;
constexpr unsigned int GC_CAC_ACC_SQ4_LOWER__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_SQ4_UPPER__ACCUMULATOR_39_32_MASK = 0x000000ffL;
constexpr unsigned int GC_CAC_ACC_SQ5_LOWER__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_SQ5_UPPER__ACCUMULATOR_39_32_MASK = 0x000000ffL;
constexpr unsigned int GC_CAC_ACC_SQ6_LOWER__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_SQ6_UPPER__ACCUMULATOR_39_32_MASK = 0x000000ffL;
constexpr unsigned int GC_CAC_ACC_SQ7_LOWER__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_SQ7_UPPER__ACCUMULATOR_39_32_MASK = 0x000000ffL;
constexpr unsigned int GC_CAC_ACC_SQ8_LOWER__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_SQ8_UPPER__ACCUMULATOR_39_32_MASK = 0x000000ffL;
constexpr unsigned int GC_CAC_ACC_SX0__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_SXRB0__ACCUMULATOR_31_0_MASK  = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_TA0__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_TCP0__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_TCP1__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_TCP2__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_TCP3__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_TCP4__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_TD0__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_TD1__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_TD2__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_TD3__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_TD4__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_TD5__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_ATCL20__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_ATCL21__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_ATCL22__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_ATCL23__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_ATCL24__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_ROUTER0__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_ROUTER1__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_ROUTER2__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_ROUTER3__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_ROUTER4__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_ROUTER5__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_ROUTER6__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_ROUTER7__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_ROUTER8__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_ROUTER9__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_VML20__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_VML21__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_VML22__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_VML23__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_VML24__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_WALKER0__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_WALKER1__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_WALKER2__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_WALKER3__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_ACC_UTCL2_WALKER4__ACCUMULATOR_31_0_MASK = 0xffffffffL;
constexpr unsigned int GC_CAC_AGGR_LOWER__AGGR_31_0_MASK        = 0xffffffffL;
constexpr unsigned int GC_CAC_AGGR_UPPER__AGGR_63_32_MASK       = 0xffffffffL;
constexpr unsigned int GC_CAC_CGTT_CLK_CTRL__OFF_HYSTERESIS_MASK = 0x00000ff0L;
constexpr unsigned int GC_CAC_CGTT_CLK_CTRL__ON_DELAY_MASK      = 0x0000000fL;
constexpr unsigned int GC_CAC_CGTT_CLK_CTRL__SOFT_OVERRIDE_DYN_MASK = 0x40000000L;
constexpr unsigned int GC_CAC_CGTT_CLK_CTRL__SOFT_OVERRIDE_REG_MASK = 0x80000000L;
constexpr unsigned int GC_CAC_CNTL__CAC_THRESHOLD_MASK          = 0x0001fffeL;
constexpr unsigned int GC_CAC_CTRL_1__CAC_WINDOW_MASK           = 0x00ffffffL;
constexpr unsigned int GC_CAC_CTRL_1__TDP_WINDOW_MASK           = 0xff000000L;
constexpr unsigned int GC_CAC_CTRL_2__CAC_ENABLE_MASK           = 0x00000001L;
constexpr unsigned int GC_CAC_CTRL_2__CAC_SOFT_CTRL_ENABLE_MASK = 0x00000002L;
constexpr unsigned int GC_CAC_IND_DATA__GC_CAC_IND_DATA_MASK    = 0xffffffffL;
constexpr unsigned int GC_CAC_IND_INDEX__GC_CAC_IND_ADDR_MASK   = 0xffffffffL;
constexpr unsigned int GC_CAC_OVRD_CP__OVRRD_SELECT_MASK        = 0x00000007L;
constexpr unsigned int GC_CAC_OVRD_CP__OVRRD_VALUE_MASK         = 0x00000038L;
constexpr unsigned int GC_CAC_OVRD_CU__OVRRD_SELECT_MASK        = 0x00000001L;
constexpr unsigned int GC_CAC_OVRD_CU__OVRRD_VALUE_MASK         = 0x00000002L;
constexpr unsigned int GC_CAC_OVRD_EA__OVRRD_SELECT_MASK        = 0x0000003fL;
constexpr unsigned int GC_CAC_OVRD_EA__OVRRD_VALUE_MASK         = 0x00000fc0L;
constexpr unsigned int GC_CAC_OVRD_PC__OVRRD_SELECT_MASK        = 0x00000001L;
constexpr unsigned int GC_CAC_OVRD_PC__OVRRD_VALUE_MASK         = 0x00000002L;
constexpr unsigned int GC_CAC_OVRD_SPI__OVRRD_SELECT_MASK       = 0x0000003fL;
constexpr unsigned int GC_CAC_OVRD_SPI__OVRRD_VALUE_MASK        = 0x00000fc0L;
constexpr unsigned int GC_CAC_OVRD_SXRB__OVRRD_SELECT_MASK      = 0x00000001L;
constexpr unsigned int GC_CAC_OVRD_SXRB__OVRRD_VALUE_MASK       = 0x00000002L;
constexpr unsigned int GC_CAC_OVRD_SX__OVRRD_SELECT_MASK        = 0x00000001L;
constexpr unsigned int GC_CAC_OVRD_SX__OVRRD_VALUE_MASK         = 0x00000002L;
constexpr unsigned int GC_CAC_OVRD_TA__OVRRD_SELECT_MASK        = 0x00000001L;
constexpr unsigned int GC_CAC_OVRD_TA__OVRRD_VALUE_MASK         = 0x00000002L;
constexpr unsigned int GC_CAC_OVRD_UTCL2_ATCL2__OVRRD_SELECT_MASK = 0x0000001fL;
constexpr unsigned int GC_CAC_OVRD_UTCL2_ATCL2__OVRRD_VALUE_MASK = 0x000003e0L;
constexpr unsigned int GC_CAC_OVRD_UTCL2_ROUTER__OVRRD_SELECT_MASK = 0x000003ffL;
constexpr unsigned int GC_CAC_OVRD_UTCL2_ROUTER__OVRRD_VALUE_MASK = 0x000ffc00L;
constexpr unsigned int GC_CAC_OVRD_UTCL2_VML2__OVRRD_SELECT_MASK = 0x0000001fL;
constexpr unsigned int GC_CAC_OVRD_UTCL2_VML2__OVRRD_VALUE_MASK = 0x000003e0L;
constexpr unsigned int GC_CAC_OVRD_UTCL2_WALKER__OVRRD_SELECT_MASK = 0x0000001fL;
constexpr unsigned int GC_CAC_OVRD_UTCL2_WALKER__OVRRD_VALUE_MASK = 0x000003e0L;
constexpr unsigned int GC_CAC_OVR_SEL__CAC_OVR_SEL_MASK         = 0xffffffffL;
constexpr unsigned int GC_CAC_OVR_VAL__CAC_OVR_VAL_MASK         = 0xffffffffL;
constexpr unsigned int GC_CAC_SOFT_CTRL__SOFT_SNAP_MASK         = 0x00000001L;
constexpr unsigned int GC_CAC_WEIGHT_BCI_0__WEIGHT_BCI_SIG0_MASK = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_CB_0__WEIGHT_CB_SIG0_MASK  = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_CB_0__WEIGHT_CB_SIG1_MASK  = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_CB_1__WEIGHT_CB_SIG2_MASK  = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_CB_1__WEIGHT_CB_SIG3_MASK  = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_CP_0__WEIGHT_CP_SIG0_MASK  = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_CP_0__WEIGHT_CP_SIG1_MASK  = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_CP_1__WEIGHT_CP_SIG2_MASK  = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_CU_0__WEIGHT_CU_SIG0_MASK  = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_DB_0__WEIGHT_DB_SIG0_MASK  = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_DB_0__WEIGHT_DB_SIG1_MASK  = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_DB_1__WEIGHT_DB_SIG2_MASK  = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_DB_1__WEIGHT_DB_SIG3_MASK  = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_EA_0__WEIGHT_EA_SIG0_MASK  = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_EA_0__WEIGHT_EA_SIG1_MASK  = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_EA_1__WEIGHT_EA_SIG2_MASK  = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_EA_1__WEIGHT_EA_SIG3_MASK  = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_EA_2__WEIGHT_EA_SIG4_MASK  = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_EA_2__WEIGHT_EA_SIG5_MASK  = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_LDS_0__WEIGHT_LDS_SIG0_MASK = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_LDS_0__WEIGHT_LDS_SIG1_MASK = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_LDS_1__WEIGHT_LDS_SIG2_MASK = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_LDS_1__WEIGHT_LDS_SIG3_MASK = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_PA_0__WEIGHT_PA_SIG0_MASK  = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_PA_0__WEIGHT_PA_SIG1_MASK  = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_PC_0__WEIGHT_PC_SIG0_MASK  = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_RMI_0__WEIGHT_RMI_SIG0_MASK = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_SC_0__WEIGHT_SC_SIG0_MASK  = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_SPI_0__WEIGHT_SPI_SIG0_MASK = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_SPI_0__WEIGHT_SPI_SIG1_MASK = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_SPI_1__WEIGHT_SPI_SIG2_MASK = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_SPI_1__WEIGHT_SPI_SIG3_MASK = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_SPI_2__WEIGHT_SPI_SIG4_MASK = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_SPI_2__WEIGHT_SPI_SIG5_MASK = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_SQ_0__WEIGHT_SQ_SIG0_MASK  = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_SQ_0__WEIGHT_SQ_SIG1_MASK  = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_SQ_1__WEIGHT_SQ_SIG2_MASK  = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_SQ_1__WEIGHT_SQ_SIG3_MASK  = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_SQ_2__WEIGHT_SQ_SIG4_MASK  = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_SQ_2__WEIGHT_SQ_SIG5_MASK  = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_SXRB_0__WEIGHT_SXRB_SIG0_MASK = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_SX_0__WEIGHT_SX_SIG0_MASK  = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_TA_0__WEIGHT_TA_SIG0_MASK  = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_TD_0__WEIGHT_TD_SIG0_MASK  = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_TD_0__WEIGHT_TD_SIG1_MASK  = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_TD_1__WEIGHT_TD_SIG2_MASK  = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_TD_1__WEIGHT_TD_SIG3_MASK  = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_TD_2__WEIGHT_TD_SIG4_MASK  = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_TD_2__WEIGHT_TD_SIG5_MASK  = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ATCL2_0__WEIGHT_UTCL2_ATCL2_SIG0_MASK = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ATCL2_0__WEIGHT_UTCL2_ATCL2_SIG1_MASK = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ATCL2_1__WEIGHT_UTCL2_ATCL2_SIG2_MASK = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ATCL2_1__WEIGHT_UTCL2_ATCL2_SIG3_MASK = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ATCL2_2__WEIGHT_UTCL2_ATCL2_SIG4_MASK = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ROUTER_0__WEIGHT_UTCL2_ROUTER_SIG0_MASK = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ROUTER_0__WEIGHT_UTCL2_ROUTER_SIG1_MASK = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ROUTER_1__WEIGHT_UTCL2_ROUTER_SIG2_MASK = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ROUTER_1__WEIGHT_UTCL2_ROUTER_SIG3_MASK = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ROUTER_2__WEIGHT_UTCL2_ROUTER_SIG4_MASK = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ROUTER_2__WEIGHT_UTCL2_ROUTER_SIG5_MASK = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ROUTER_3__WEIGHT_UTCL2_ROUTER_SIG6_MASK = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ROUTER_3__WEIGHT_UTCL2_ROUTER_SIG7_MASK = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ROUTER_4__WEIGHT_UTCL2_ROUTER_SIG8_MASK = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ROUTER_4__WEIGHT_UTCL2_ROUTER_SIG9_MASK = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_VML2_0__WEIGHT_UTCL2_VML2_SIG0_MASK = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_VML2_0__WEIGHT_UTCL2_VML2_SIG1_MASK = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_VML2_1__WEIGHT_UTCL2_VML2_SIG2_MASK = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_VML2_1__WEIGHT_UTCL2_VML2_SIG3_MASK = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_VML2_2__WEIGHT_UTCL2_VML2_SIG4_MASK = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_WALKER_0__WEIGHT_UTCL2_WALKER_SIG0_MASK = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_WALKER_0__WEIGHT_UTCL2_WALKER_SIG1_MASK = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_WALKER_1__WEIGHT_UTCL2_WALKER_SIG2_MASK = 0x0000ffffL;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_WALKER_1__WEIGHT_UTCL2_WALKER_SIG3_MASK = 0xffff0000L;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_WALKER_2__WEIGHT_UTCL2_WALKER_SIG4_MASK = 0x0000ffffL;
constexpr unsigned int GC_EDC_CTRL__EDC_ALLOW_WRITE_PWRDELTA_MASK = 0x00000200L;
constexpr unsigned int GC_EDC_CTRL__EDC_CLK_EN_OVERRIDE_MASK    = 0x00000004L;
constexpr unsigned int GC_EDC_CTRL__EDC_EN_MASK                 = 0x00000001L;
constexpr unsigned int GC_EDC_CTRL__EDC_FORCE_STALL_MASK        = 0x00000008L;
constexpr unsigned int GC_EDC_CTRL__EDC_SW_RST_MASK             = 0x00000002L;
constexpr unsigned int GC_EDC_CTRL__EDC_TRIGGER_THROTTLE_LOWBIT_MASK = 0x000001f0L;
constexpr unsigned int GC_EDC_OVERFLOW__EDC_ROLLING_POWER_DELTA_OVERFLOW_MASK = 0x00000001L;
constexpr unsigned int GC_EDC_OVERFLOW__EDC_THROTTLE_LEVEL_OVERFLOW_COUNTER_MASK = 0x0001fffeL;
constexpr unsigned int GC_EDC_ROLLING_POWER_DELTA__EDC_ROLLING_POWER_DELTA_MASK = 0xffffffffL;
constexpr unsigned int GC_EDC_STATUS__EDC_THROTTLE_LEVEL_MASK   = 0x00000007L;
constexpr unsigned int GC_EDC_THRESHOLD__EDC_THRESHOLD_MASK     = 0xffffffffL;
constexpr unsigned int GC_USER_RB_BACKEND_DISABLE__BACKEND_DISABLE_MASK = 0x00ff0000L;
constexpr unsigned int GC_USER_RB_REDUNDANCY__EN_REDUNDANCY0_MASK = 0x00001000L;
constexpr unsigned int GC_USER_RB_REDUNDANCY__EN_REDUNDANCY1_MASK = 0x00100000L;
constexpr unsigned int GC_USER_RB_REDUNDANCY__FAILED_RB0_MASK   = 0x00000f00L;
constexpr unsigned int GC_USER_RB_REDUNDANCY__FAILED_RB1_MASK   = 0x000f0000L;
constexpr unsigned int GC_USER_SHADER_RATE_CONFIG__DPFP_RATE_MASK = 0x00000006L;
constexpr unsigned int GC_USER_SHADER_RATE_CONFIG__SQC_BALANCE_DISABLE_MASK = 0x00000008L;
constexpr unsigned int GDS_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int GDS_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int GDS_PERFCOUNTER0_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
constexpr unsigned int GDS_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int GDS_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int GDS_PERFCOUNTER1_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
constexpr unsigned int GDS_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int GDS_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int GDS_PERFCOUNTER2_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
constexpr unsigned int GDS_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int GDS_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int GDS_PERFCOUNTER3_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
constexpr unsigned int GFX_COPY_STATE__SRC_STATE_ID_MASK        = 0x00000007L;
constexpr unsigned int GFX_PIPE_CONTROL__CONTEXT_SUSPEND_EN_MASK = 0x00010000L;
constexpr unsigned int GFX_PIPE_CONTROL__HYSTERESIS_CNT_MASK    = 0x00001fffL;
constexpr unsigned int GFX_PIPE_CONTROL__RESERVED_MASK          = 0x0000e000L;
constexpr unsigned int GRBM_CAM_DATA__CAM_ADDR_MASK             = 0x0000ffffL;
constexpr unsigned int GRBM_CAM_DATA__CAM_REMAPADDR_MASK        = 0xffff0000L;
constexpr unsigned int GRBM_CGTT_CLK_CNTL__OFF_HYSTERESIS_MASK  = 0x00000ff0L;
constexpr unsigned int GRBM_CGTT_CLK_CNTL__ON_DELAY_MASK        = 0x0000000fL;
constexpr unsigned int GRBM_CGTT_CLK_CNTL__SOFT_OVERRIDE_DYN_MASK = 0x40000000L;
constexpr unsigned int GRBM_CGTT_CLK_CNTL__SOFT_STALL_OVERRIDE0_MASK = 0x00800000L;
constexpr unsigned int GRBM_CGTT_CLK_CNTL__SOFT_STALL_OVERRIDE1_MASK = 0x00400000L;
constexpr unsigned int GRBM_CGTT_CLK_CNTL__SOFT_STALL_OVERRIDE2_MASK = 0x00200000L;
constexpr unsigned int GRBM_CGTT_CLK_CNTL__SOFT_STALL_OVERRIDE3_MASK = 0x00100000L;
constexpr unsigned int GRBM_CGTT_CLK_CNTL__SOFT_STALL_OVERRIDE4_MASK = 0x00080000L;
constexpr unsigned int GRBM_CGTT_CLK_CNTL__SOFT_STALL_OVERRIDE5_MASK = 0x00040000L;
constexpr unsigned int GRBM_CGTT_CLK_CNTL__SOFT_STALL_OVERRIDE6_MASK = 0x00020000L;
constexpr unsigned int GRBM_CGTT_CLK_CNTL__SOFT_STALL_OVERRIDE7_MASK = 0x00010000L;
constexpr unsigned int GRBM_CHIP_REVISION__CHIP_REVISION_MASK   = 0x000000ffL;
constexpr unsigned int GRBM_CNTL__READ_TIMEOUT_MASK             = 0x000000ffL;
constexpr unsigned int GRBM_CNTL__REPORT_LAST_RDERR_MASK        = 0x80000000L;
constexpr unsigned int GRBM_DEBUG_DATA__DATA_MASK               = 0xffffffffL;
constexpr unsigned int GRBM_DSM_BYPASS__BYPASS_BITS_MASK        = 0x00000003L;
constexpr unsigned int GRBM_DSM_BYPASS__BYPASS_EN_MASK          = 0x00000004L;
constexpr unsigned int GRBM_GFX_CLKEN_CNTL__POST_DELAY_CNT_MASK = 0x00001f00L;
constexpr unsigned int GRBM_GFX_CLKEN_CNTL__PREFIX_DELAY_CNT_MASK = 0x0000000fL;
constexpr unsigned int GRBM_GFX_CNTL_SR_DATA__MEID_MASK         = 0x0000000cL;
constexpr unsigned int GRBM_GFX_CNTL_SR_DATA__PIPEID_MASK       = 0x00000003L;
constexpr unsigned int GRBM_GFX_CNTL_SR_DATA__QUEUEID_MASK      = 0x00000700L;
constexpr unsigned int GRBM_GFX_CNTL_SR_DATA__VMID_MASK         = 0x000000f0L;
constexpr unsigned int GRBM_GFX_CNTL_SR_SELECT__INDEX_MASK      = 0x00000007L;
constexpr unsigned int GRBM_GFX_CNTL__MEID_MASK                 = 0x0000000cL;
constexpr unsigned int GRBM_GFX_CNTL__PIPEID_MASK               = 0x00000003L;
constexpr unsigned int GRBM_GFX_CNTL__QUEUEID_MASK              = 0x00000700L;
constexpr unsigned int GRBM_GFX_CNTL__VMID_MASK                 = 0x000000f0L;
constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__INSTANCE_BROADCAST_WRITES_MASK = 0x40000000L;
constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__INSTANCE_INDEX_MASK = 0x000000ffL;
constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SE_BROADCAST_WRITES_MASK = 0x80000000L;
constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SE_INDEX_MASK    = 0x00ff0000L;
constexpr unsigned int GRBM_GFX_INDEX_SR_SELECT__INDEX_MASK     = 0x00000007L;
constexpr unsigned int GRBM_GFX_INDEX__INSTANCE_BROADCAST_WRITES_MASK = 0x40000000L;
constexpr unsigned int GRBM_GFX_INDEX__INSTANCE_INDEX_MASK      = 0x000000ffL;
constexpr unsigned int GRBM_GFX_INDEX__SE_BROADCAST_WRITES_MASK = 0x80000000L;
constexpr unsigned int GRBM_GFX_INDEX__SE_INDEX_MASK            = 0x00ff0000L;
constexpr unsigned int GRBM_HYP_CAM_DATA__CAM_ADDR_MASK         = 0x0000ffffL;
constexpr unsigned int GRBM_HYP_CAM_DATA__CAM_REMAPADDR_MASK    = 0xffff0000L;
constexpr unsigned int GRBM_IH_CREDIT__CREDIT_VALUE_MASK        = 0x00000003L;
constexpr unsigned int GRBM_IH_CREDIT__IH_CLIENT_ID_MASK        = 0x00ff0000L;
constexpr unsigned int GRBM_INT_CNTL__GUI_IDLE_INT_ENABLE_MASK  = 0x00080000L;
constexpr unsigned int GRBM_INT_CNTL__RDERR_INT_ENABLE_MASK     = 0x00000001L;
constexpr unsigned int GRBM_IOV_ERROR__IOV_ADDR_MASK            = 0x000ffffcL;
constexpr unsigned int GRBM_IOV_ERROR__IOV_ERROR_MASK           = 0x80000000L;
constexpr unsigned int GRBM_IOV_ERROR__IOV_OP_MASK              = 0x08000000L;
constexpr unsigned int GRBM_IOV_ERROR__IOV_VFID_MASK            = 0x03f00000L;
constexpr unsigned int GRBM_IOV_ERROR__IOV_VF_MASK              = 0x04000000L;
constexpr unsigned int GRBM_NOWHERE__DATA_MASK                  = 0xffffffffL;
constexpr unsigned int GRBM_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int GRBM_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__BCI_BUSY_USER_DEFINED_MASK_MASK = 0x02000000L;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__CB_BUSY_USER_DEFINED_MASK_MASK = 0x00200000L;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__CB_CLEAN_USER_DEFINED_MASK_MASK = 0x00000800L;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__CP_BUSY_USER_DEFINED_MASK_MASK = 0x00400000L;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__DB_BUSY_USER_DEFINED_MASK_MASK = 0x00100000L;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__DB_CLEAN_USER_DEFINED_MASK_MASK = 0x00000400L;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__EA_BUSY_USER_DEFINED_MASK_MASK = 0x40000000L;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__GDS_BUSY_USER_DEFINED_MASK_MASK = 0x01000000L;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__GRBM_BUSY_USER_DEFINED_MASK_MASK = 0x00080000L;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__PA_BUSY_USER_DEFINED_MASK_MASK = 0x00040000L;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__PERF_SEL_MASK  = 0x0000003fL;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__RLC_BUSY_USER_DEFINED_MASK_MASK = 0x04000000L;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__RMI_BUSY_USER_DEFINED_MASK_MASK = 0x80000000L;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__SC_BUSY_USER_DEFINED_MASK_MASK = 0x00020000L;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__SPI_BUSY_USER_DEFINED_MASK_MASK = 0x00010000L;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__SX_BUSY_USER_DEFINED_MASK_MASK = 0x00004000L;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__TA_BUSY_USER_DEFINED_MASK_MASK = 0x00002000L;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__UTCL2_BUSY_USER_DEFINED_MASK_MASK = 0x20000000L;
constexpr unsigned int GRBM_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int GRBM_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__BCI_BUSY_USER_DEFINED_MASK_MASK = 0x02000000L;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__CB_BUSY_USER_DEFINED_MASK_MASK = 0x00200000L;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__CB_CLEAN_USER_DEFINED_MASK_MASK = 0x00000800L;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__CP_BUSY_USER_DEFINED_MASK_MASK = 0x00400000L;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__DB_BUSY_USER_DEFINED_MASK_MASK = 0x00100000L;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__DB_CLEAN_USER_DEFINED_MASK_MASK = 0x00000400L;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__EA_BUSY_USER_DEFINED_MASK_MASK = 0x40000000L;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__GDS_BUSY_USER_DEFINED_MASK_MASK = 0x01000000L;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__GRBM_BUSY_USER_DEFINED_MASK_MASK = 0x00080000L;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__PA_BUSY_USER_DEFINED_MASK_MASK = 0x00040000L;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__PERF_SEL_MASK  = 0x0000003fL;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__RLC_BUSY_USER_DEFINED_MASK_MASK = 0x04000000L;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__RMI_BUSY_USER_DEFINED_MASK_MASK = 0x80000000L;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__SC_BUSY_USER_DEFINED_MASK_MASK = 0x00020000L;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__SPI_BUSY_USER_DEFINED_MASK_MASK = 0x00010000L;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__SX_BUSY_USER_DEFINED_MASK_MASK = 0x00004000L;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__TA_BUSY_USER_DEFINED_MASK_MASK = 0x00002000L;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__UTCL2_BUSY_USER_DEFINED_MASK_MASK = 0x20000000L;
constexpr unsigned int GRBM_PWR_CNTL2__PWR_GFX3D_REQUEST_HALT_MASK = 0x00100000L;
constexpr unsigned int GRBM_PWR_CNTL2__PWR_REQUEST_HALT_MASK    = 0x00010000L;
constexpr unsigned int GRBM_PWR_CNTL__ALL_REQ_EN_MASK           = 0x00008000L;
constexpr unsigned int GRBM_PWR_CNTL__ALL_REQ_TYPE_MASK         = 0x00000003L;
constexpr unsigned int GRBM_PWR_CNTL__ALL_RSP_TYPE_MASK         = 0x00000030L;
constexpr unsigned int GRBM_PWR_CNTL__GFX_REQ_EN_MASK           = 0x00004000L;
constexpr unsigned int GRBM_PWR_CNTL__GFX_REQ_TYPE_MASK         = 0x0000000cL;
constexpr unsigned int GRBM_PWR_CNTL__GFX_RSP_TYPE_MASK         = 0x000000c0L;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_GDS_DMA_MASK = 0x00080000L;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_ME0PIPE0_CF_MASK = 0x00100000L;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_ME0PIPE0_PF_MASK = 0x00200000L;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_ME0PIPE1_CF_MASK = 0x00400000L;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_ME0PIPE1_PF_MASK = 0x00800000L;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_ME1PIPE0_MASK = 0x01000000L;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_ME1PIPE1_MASK = 0x02000000L;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_ME1PIPE2_MASK = 0x04000000L;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_ME1PIPE3_MASK = 0x08000000L;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_ME2PIPE0_MASK = 0x10000000L;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_ME2PIPE1_MASK = 0x20000000L;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_ME2PIPE2_MASK = 0x40000000L;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_ME2PIPE3_MASK = 0x80000000L;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_RLC_MASK = 0x00040000L;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_RSMU_MASK = 0x00020000L;
constexpr unsigned int GRBM_READ_ERROR__READ_ADDRESS_MASK       = 0x0003fffcL;
constexpr unsigned int GRBM_READ_ERROR__READ_ERROR_MASK         = 0x80000000L;
constexpr unsigned int GRBM_READ_ERROR__READ_MEID_MASK          = 0x00c00000L;
constexpr unsigned int GRBM_READ_ERROR__READ_PIPEID_MASK        = 0x00300000L;
constexpr unsigned int GRBM_SCRATCH_REG0__SCRATCH_REG0_MASK     = 0xffffffffL;
constexpr unsigned int GRBM_SCRATCH_REG1__SCRATCH_REG1_MASK     = 0xffffffffL;
constexpr unsigned int GRBM_SCRATCH_REG2__SCRATCH_REG2_MASK     = 0xffffffffL;
constexpr unsigned int GRBM_SCRATCH_REG3__SCRATCH_REG3_MASK     = 0xffffffffL;
constexpr unsigned int GRBM_SCRATCH_REG4__SCRATCH_REG4_MASK     = 0xffffffffL;
constexpr unsigned int GRBM_SCRATCH_REG5__SCRATCH_REG5_MASK     = 0xffffffffL;
constexpr unsigned int GRBM_SCRATCH_REG6__SCRATCH_REG6_MASK     = 0xffffffffL;
constexpr unsigned int GRBM_SCRATCH_REG7__SCRATCH_REG7_MASK     = 0xffffffffL;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__BCI_BUSY_USER_DEFINED_MASK_MASK = 0x00200000L;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__CB_BUSY_USER_DEFINED_MASK_MASK = 0x00040000L;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__CB_CLEAN_USER_DEFINED_MASK_MASK = 0x00000800L;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__DB_BUSY_USER_DEFINED_MASK_MASK = 0x00020000L;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__DB_CLEAN_USER_DEFINED_MASK_MASK = 0x00000400L;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__PA_BUSY_USER_DEFINED_MASK_MASK = 0x00100000L;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__PERF_SEL_MASK = 0x0000003fL;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__RMI_BUSY_USER_DEFINED_MASK_MASK = 0x00400000L;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__SC_BUSY_USER_DEFINED_MASK_MASK = 0x00010000L;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__SPI_BUSY_USER_DEFINED_MASK_MASK = 0x00008000L;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__SX_BUSY_USER_DEFINED_MASK_MASK = 0x00002000L;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__TA_BUSY_USER_DEFINED_MASK_MASK = 0x00001000L;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__BCI_BUSY_USER_DEFINED_MASK_MASK = 0x00200000L;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__CB_BUSY_USER_DEFINED_MASK_MASK = 0x00040000L;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__CB_CLEAN_USER_DEFINED_MASK_MASK = 0x00000800L;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__DB_BUSY_USER_DEFINED_MASK_MASK = 0x00020000L;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__DB_CLEAN_USER_DEFINED_MASK_MASK = 0x00000400L;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__PA_BUSY_USER_DEFINED_MASK_MASK = 0x00100000L;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__PERF_SEL_MASK = 0x0000003fL;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__RMI_BUSY_USER_DEFINED_MASK_MASK = 0x00400000L;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__SC_BUSY_USER_DEFINED_MASK_MASK = 0x00010000L;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__SPI_BUSY_USER_DEFINED_MASK_MASK = 0x00008000L;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__SX_BUSY_USER_DEFINED_MASK_MASK = 0x00002000L;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__TA_BUSY_USER_DEFINED_MASK_MASK = 0x00001000L;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__BCI_BUSY_USER_DEFINED_MASK_MASK = 0x00200000L;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__CB_BUSY_USER_DEFINED_MASK_MASK = 0x00040000L;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__CB_CLEAN_USER_DEFINED_MASK_MASK = 0x00000800L;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__DB_BUSY_USER_DEFINED_MASK_MASK = 0x00020000L;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__DB_CLEAN_USER_DEFINED_MASK_MASK = 0x00000400L;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__PA_BUSY_USER_DEFINED_MASK_MASK = 0x00100000L;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__PERF_SEL_MASK = 0x0000003fL;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__RMI_BUSY_USER_DEFINED_MASK_MASK = 0x00400000L;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__SC_BUSY_USER_DEFINED_MASK_MASK = 0x00010000L;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__SPI_BUSY_USER_DEFINED_MASK_MASK = 0x00008000L;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__SX_BUSY_USER_DEFINED_MASK_MASK = 0x00002000L;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__TA_BUSY_USER_DEFINED_MASK_MASK = 0x00001000L;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__BCI_BUSY_USER_DEFINED_MASK_MASK = 0x00200000L;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__CB_BUSY_USER_DEFINED_MASK_MASK = 0x00040000L;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__CB_CLEAN_USER_DEFINED_MASK_MASK = 0x00000800L;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__DB_BUSY_USER_DEFINED_MASK_MASK = 0x00020000L;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__DB_CLEAN_USER_DEFINED_MASK_MASK = 0x00000400L;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__PA_BUSY_USER_DEFINED_MASK_MASK = 0x00100000L;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__PERF_SEL_MASK = 0x0000003fL;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__RMI_BUSY_USER_DEFINED_MASK_MASK = 0x00400000L;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__SC_BUSY_USER_DEFINED_MASK_MASK = 0x00010000L;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__SPI_BUSY_USER_DEFINED_MASK_MASK = 0x00008000L;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__SX_BUSY_USER_DEFINED_MASK_MASK = 0x00002000L;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__TA_BUSY_USER_DEFINED_MASK_MASK = 0x00001000L;
constexpr unsigned int GRBM_SKEW_CNTL__SKEW_COUNT_MASK          = 0x00000fc0L;
constexpr unsigned int GRBM_SKEW_CNTL__SKEW_TOP_THRESHOLD_MASK  = 0x0000003fL;
constexpr unsigned int GRBM_SOFT_RESET__SOFT_RESET_CAC_MASK     = 0x00100000L;
constexpr unsigned int GRBM_SOFT_RESET__SOFT_RESET_CPAXI_MASK   = 0x00200000L;
constexpr unsigned int GRBM_SOFT_RESET__SOFT_RESET_CPC_MASK     = 0x00040000L;
constexpr unsigned int GRBM_SOFT_RESET__SOFT_RESET_CPF_MASK     = 0x00020000L;
constexpr unsigned int GRBM_SOFT_RESET__SOFT_RESET_CPG_MASK     = 0x00080000L;
constexpr unsigned int GRBM_SOFT_RESET__SOFT_RESET_CP_MASK      = 0x00000001L;
constexpr unsigned int GRBM_SOFT_RESET__SOFT_RESET_EA_MASK      = 0x00400000L;
constexpr unsigned int GRBM_SOFT_RESET__SOFT_RESET_GFX_MASK     = 0x00010000L;
constexpr unsigned int GRBM_SOFT_RESET__SOFT_RESET_RLC_MASK     = 0x00000004L;
constexpr unsigned int GRBM_STATUS2__CPAXI_BUSY_MASK            = 0x80000000L;
constexpr unsigned int GRBM_STATUS2__CPC_BUSY_MASK              = 0x20000000L;
constexpr unsigned int GRBM_STATUS2__CPF_BUSY_MASK              = 0x10000000L;
constexpr unsigned int GRBM_STATUS2__CPG_BUSY_MASK              = 0x40000000L;
constexpr unsigned int GRBM_STATUS2__EA_BUSY_MASK               = 0x00010000L;
constexpr unsigned int GRBM_STATUS2__EA_LINK_BUSY_MASK          = 0x00100000L;
constexpr unsigned int GRBM_STATUS2__ME0PIPE1_CF_RQ_PENDING_MASK = 0x00000010L;
constexpr unsigned int GRBM_STATUS2__ME0PIPE1_CMDFIFO_AVAIL_MASK = 0x0000000fL;
constexpr unsigned int GRBM_STATUS2__ME0PIPE1_PF_RQ_PENDING_MASK = 0x00000020L;
constexpr unsigned int GRBM_STATUS2__ME1PIPE0_RQ_PENDING_MASK   = 0x00000040L;
constexpr unsigned int GRBM_STATUS2__ME1PIPE1_RQ_PENDING_MASK   = 0x00000080L;
constexpr unsigned int GRBM_STATUS2__ME1PIPE2_RQ_PENDING_MASK   = 0x00000100L;
constexpr unsigned int GRBM_STATUS2__ME1PIPE3_RQ_PENDING_MASK   = 0x00000200L;
constexpr unsigned int GRBM_STATUS2__ME2PIPE0_RQ_PENDING_MASK   = 0x00000400L;
constexpr unsigned int GRBM_STATUS2__ME2PIPE1_RQ_PENDING_MASK   = 0x00000800L;
constexpr unsigned int GRBM_STATUS2__ME2PIPE2_RQ_PENDING_MASK   = 0x00001000L;
constexpr unsigned int GRBM_STATUS2__ME2PIPE3_RQ_PENDING_MASK   = 0x00002000L;
constexpr unsigned int GRBM_STATUS2__RLC_RQ_PENDING_MASK        = 0x00004000L;
constexpr unsigned int GRBM_STATUS2__RMI_BUSY_MASK              = 0x00020000L;
constexpr unsigned int GRBM_STATUS2__UTCL2_BUSY_MASK            = 0x00008000L;
constexpr unsigned int GRBM_STATUS2__UTCL2_RQ_PENDING_MASK      = 0x00040000L;
constexpr unsigned int GRBM_STATUS_SE0__BCI_BUSY_MASK           = 0x00400000L;
constexpr unsigned int GRBM_STATUS_SE0__CB_BUSY_MASK            = 0x80000000L;
constexpr unsigned int GRBM_STATUS_SE0__CB_CLEAN_MASK           = 0x00000004L;
constexpr unsigned int GRBM_STATUS_SE0__DB_BUSY_MASK            = 0x40000000L;
constexpr unsigned int GRBM_STATUS_SE0__DB_CLEAN_MASK           = 0x00000002L;
constexpr unsigned int GRBM_STATUS_SE0__PA_BUSY_MASK            = 0x01000000L;
constexpr unsigned int GRBM_STATUS_SE0__RMI_BUSY_MASK           = 0x00200000L;
constexpr unsigned int GRBM_STATUS_SE0__SC_BUSY_MASK            = 0x20000000L;
constexpr unsigned int GRBM_STATUS_SE0__SPI_BUSY_MASK           = 0x08000000L;
constexpr unsigned int GRBM_STATUS_SE0__SX_BUSY_MASK            = 0x04000000L;
constexpr unsigned int GRBM_STATUS_SE0__TA_BUSY_MASK            = 0x02000000L;
constexpr unsigned int GRBM_STATUS_SE1__BCI_BUSY_MASK           = 0x00400000L;
constexpr unsigned int GRBM_STATUS_SE1__CB_BUSY_MASK            = 0x80000000L;
constexpr unsigned int GRBM_STATUS_SE1__CB_CLEAN_MASK           = 0x00000004L;
constexpr unsigned int GRBM_STATUS_SE1__DB_BUSY_MASK            = 0x40000000L;
constexpr unsigned int GRBM_STATUS_SE1__DB_CLEAN_MASK           = 0x00000002L;
constexpr unsigned int GRBM_STATUS_SE1__PA_BUSY_MASK            = 0x01000000L;
constexpr unsigned int GRBM_STATUS_SE1__RMI_BUSY_MASK           = 0x00200000L;
constexpr unsigned int GRBM_STATUS_SE1__SC_BUSY_MASK            = 0x20000000L;
constexpr unsigned int GRBM_STATUS_SE1__SPI_BUSY_MASK           = 0x08000000L;
constexpr unsigned int GRBM_STATUS_SE1__SX_BUSY_MASK            = 0x04000000L;
constexpr unsigned int GRBM_STATUS_SE1__TA_BUSY_MASK            = 0x02000000L;
constexpr unsigned int GRBM_STATUS_SE2__BCI_BUSY_MASK           = 0x00400000L;
constexpr unsigned int GRBM_STATUS_SE2__CB_BUSY_MASK            = 0x80000000L;
constexpr unsigned int GRBM_STATUS_SE2__CB_CLEAN_MASK           = 0x00000004L;
constexpr unsigned int GRBM_STATUS_SE2__DB_BUSY_MASK            = 0x40000000L;
constexpr unsigned int GRBM_STATUS_SE2__DB_CLEAN_MASK           = 0x00000002L;
constexpr unsigned int GRBM_STATUS_SE2__PA_BUSY_MASK            = 0x01000000L;
constexpr unsigned int GRBM_STATUS_SE2__RMI_BUSY_MASK           = 0x00200000L;
constexpr unsigned int GRBM_STATUS_SE2__SC_BUSY_MASK            = 0x20000000L;
constexpr unsigned int GRBM_STATUS_SE2__SPI_BUSY_MASK           = 0x08000000L;
constexpr unsigned int GRBM_STATUS_SE2__SX_BUSY_MASK            = 0x04000000L;
constexpr unsigned int GRBM_STATUS_SE2__TA_BUSY_MASK            = 0x02000000L;
constexpr unsigned int GRBM_STATUS_SE3__BCI_BUSY_MASK           = 0x00400000L;
constexpr unsigned int GRBM_STATUS_SE3__CB_BUSY_MASK            = 0x80000000L;
constexpr unsigned int GRBM_STATUS_SE3__CB_CLEAN_MASK           = 0x00000004L;
constexpr unsigned int GRBM_STATUS_SE3__DB_BUSY_MASK            = 0x40000000L;
constexpr unsigned int GRBM_STATUS_SE3__DB_CLEAN_MASK           = 0x00000002L;
constexpr unsigned int GRBM_STATUS_SE3__PA_BUSY_MASK            = 0x01000000L;
constexpr unsigned int GRBM_STATUS_SE3__RMI_BUSY_MASK           = 0x00200000L;
constexpr unsigned int GRBM_STATUS_SE3__SC_BUSY_MASK            = 0x20000000L;
constexpr unsigned int GRBM_STATUS_SE3__SPI_BUSY_MASK           = 0x08000000L;
constexpr unsigned int GRBM_STATUS_SE3__SX_BUSY_MASK            = 0x04000000L;
constexpr unsigned int GRBM_STATUS_SE3__TA_BUSY_MASK            = 0x02000000L;
constexpr unsigned int GRBM_STATUS__BCI_BUSY_MASK               = 0x00800000L;
constexpr unsigned int GRBM_STATUS__CB_BUSY_MASK                = 0x40000000L;
constexpr unsigned int GRBM_STATUS__CB_CLEAN_MASK               = 0x00002000L;
constexpr unsigned int GRBM_STATUS__CP_BUSY_MASK                = 0x20000000L;
constexpr unsigned int GRBM_STATUS__CP_COHERENCY_BUSY_MASK      = 0x10000000L;
constexpr unsigned int GRBM_STATUS__DB_BUSY_MASK                = 0x04000000L;
constexpr unsigned int GRBM_STATUS__DB_CLEAN_MASK               = 0x00001000L;
constexpr unsigned int GRBM_STATUS__GDS_BUSY_MASK               = 0x00008000L;
constexpr unsigned int GRBM_STATUS__GDS_DMA_RQ_PENDING_MASK     = 0x00000200L;
constexpr unsigned int GRBM_STATUS__GUI_ACTIVE_MASK             = 0x80000000L;
constexpr unsigned int GRBM_STATUS__ME0PIPE0_CF_RQ_PENDING_MASK = 0x00000080L;
constexpr unsigned int GRBM_STATUS__ME0PIPE0_CMDFIFO_AVAIL_MASK = 0x0000000fL;
constexpr unsigned int GRBM_STATUS__ME0PIPE0_PF_RQ_PENDING_MASK = 0x00000100L;
constexpr unsigned int GRBM_STATUS__PA_BUSY_MASK                = 0x02000000L;
constexpr unsigned int GRBM_STATUS__RSMU_RQ_PENDING_MASK        = 0x00000020L;
constexpr unsigned int GRBM_STATUS__SC_BUSY_MASK                = 0x01000000L;
constexpr unsigned int GRBM_STATUS__SPI_BUSY_MASK               = 0x00400000L;
constexpr unsigned int GRBM_STATUS__SX_BUSY_MASK                = 0x00100000L;
constexpr unsigned int GRBM_STATUS__TA_BUSY_MASK                = 0x00004000L;
constexpr unsigned int GRBM_TRAP_ADDR_MSK__DATA_MASK            = 0x0003ffffL;
constexpr unsigned int GRBM_TRAP_ADDR__DATA_MASK                = 0x0003ffffL;
constexpr unsigned int GRBM_TRAP_OP__RW_MASK                    = 0x00000001L;
constexpr unsigned int GRBM_TRAP_WD_MSK__DATA_MASK              = 0xffffffffL;
constexpr unsigned int GRBM_TRAP_WD__DATA_MASK                  = 0xffffffffL;
constexpr unsigned int GRBM_UTCL2_INVAL_RANGE_END__DATA_MASK    = 0x0003ffffL;
constexpr unsigned int GRBM_UTCL2_INVAL_RANGE_START__DATA_MASK  = 0x0003ffffL;
constexpr unsigned int GRBM_WAIT_IDLE_CLOCKS__WAIT_IDLE_CLOCKS_MASK = 0x000000ffL;
constexpr unsigned int GRBM_WRITE_ERROR__WRITE_ERROR_MASK       = 0x80000000L;
constexpr unsigned int GRBM_WRITE_ERROR__WRITE_MEID_MASK        = 0x00c00000L;
constexpr unsigned int GRBM_WRITE_ERROR__WRITE_PIPEID_MASK      = 0x00300000L;
constexpr unsigned int GRBM_WRITE_ERROR__WRITE_REQUESTER_RLC_MASK = 0x00000001L;
constexpr unsigned int GRBM_WRITE_ERROR__WRITE_REQUESTER_RSMU_MASK = 0x00000002L;
constexpr unsigned int GRBM_WRITE_ERROR__WRITE_SSRCID_MASK      = 0x0000001cL;
constexpr unsigned int GRBM_WRITE_ERROR__WRITE_VF_MASK          = 0x00001000L;
constexpr unsigned int GRBM_WRITE_ERROR__WRITE_VMID_MASK        = 0x0001e000L;
constexpr unsigned int IA_ENHANCE__MISC_MASK                    = 0xffffffffL;
constexpr unsigned int IA_MULTI_VGT_PARAM__PARTIAL_ES_WAVE_ON_MASK = 0x00040000L;
constexpr unsigned int IA_MULTI_VGT_PARAM__PARTIAL_VS_WAVE_ON_MASK = 0x00010000L;
constexpr unsigned int IA_MULTI_VGT_PARAM__PRIMGROUP_SIZE_MASK  = 0x0000ffffL;
constexpr unsigned int IA_MULTI_VGT_PARAM__SWITCH_ON_EOI_MASK   = 0x00080000L;
constexpr unsigned int IA_MULTI_VGT_PARAM__SWITCH_ON_EOP_MASK   = 0x00020000L;
constexpr unsigned int IA_MULTI_VGT_PARAM__WD_SWITCH_ON_EOP_MASK = 0x00100000L;
constexpr unsigned int IA_UTCL1_CNTL__BYPASS_MASK               = 0x02000000L;
constexpr unsigned int IA_UTCL1_CNTL__DROP_MODE_MASK            = 0x01000000L;
constexpr unsigned int IA_UTCL1_CNTL__FORCE_SNOOP_MASK          = 0x10000000L;
constexpr unsigned int IA_UTCL1_CNTL__FRAG_LIMIT_MODE_MASK      = 0x08000000L;
constexpr unsigned int IA_UTCL1_CNTL__INVALIDATE_MASK           = 0x04000000L;
constexpr unsigned int IA_UTCL1_CNTL__VMID_RESET_MODE_MASK      = 0x00800000L;
constexpr unsigned int IA_UTCL1_CNTL__XNACK_REDO_TIMER_CNT_MASK = 0x000fffffL;
constexpr unsigned int IA_UTCL1_STATUS__FAULT_DETECTED_MASK     = 0x00000001L;
constexpr unsigned int IA_UTCL1_STATUS__FAULT_UTCL1ID_MASK      = 0x00003f00L;
constexpr unsigned int IA_UTCL1_STATUS__PRT_DETECTED_MASK       = 0x00000004L;
constexpr unsigned int IA_UTCL1_STATUS__PRT_UTCL1ID_MASK        = 0x3f000000L;
constexpr unsigned int IA_UTCL1_STATUS__RETRY_DETECTED_MASK     = 0x00000002L;
constexpr unsigned int IA_UTCL1_STATUS__RETRY_UTCL1ID_MASK      = 0x003f0000L;
constexpr unsigned int LDS_CONFIG__ADDR_OUT_OF_RANGE_REPORTING_MASK = 0x00000001L;
constexpr unsigned int PA_CL_CLIP_CNTL__BOUNDARY_EDGE_FLAG_ENA_MASK = 0x00040000L;
constexpr unsigned int PA_CL_CLIP_CNTL__CLIP_DISABLE_MASK       = 0x00010000L;
constexpr unsigned int PA_CL_CLIP_CNTL__DIS_CLIP_ERR_DETECT_MASK = 0x00100000L;
constexpr unsigned int PA_CL_CLIP_CNTL__DX_CLIP_SPACE_DEF_MASK  = 0x00080000L;
constexpr unsigned int PA_CL_CLIP_CNTL__DX_LINEAR_ATTR_CLIP_ENA_MASK = 0x01000000L;
constexpr unsigned int PA_CL_CLIP_CNTL__DX_RASTERIZATION_KILL_MASK = 0x00400000L;
constexpr unsigned int PA_CL_CLIP_CNTL__PS_UCP_MODE_MASK        = 0x0000c000L;
constexpr unsigned int PA_CL_CLIP_CNTL__PS_UCP_Y_SCALE_NEG_MASK = 0x00002000L;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_CULL_ONLY_ENA_MASK  = 0x00020000L;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_0_MASK          = 0x00000001L;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_1_MASK          = 0x00000002L;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_2_MASK          = 0x00000004L;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_3_MASK          = 0x00000008L;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_4_MASK          = 0x00000010L;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_5_MASK          = 0x00000020L;
constexpr unsigned int PA_CL_CLIP_CNTL__VTE_VPORT_PROVOKE_DISABLE_MASK = 0x02000000L;
constexpr unsigned int PA_CL_CLIP_CNTL__VTX_KILL_OR_MASK        = 0x00200000L;
constexpr unsigned int PA_CL_CLIP_CNTL__ZCLIP_FAR_DISABLE_MASK  = 0x08000000L;
constexpr unsigned int PA_CL_CLIP_CNTL__ZCLIP_NEAR_DISABLE_MASK = 0x04000000L;
constexpr unsigned int PA_CL_ENHANCE__CLIPPED_PRIM_SEQ_STALL_MASK = 0x00000008L;
constexpr unsigned int PA_CL_ENHANCE__CLIP_VTX_REORDER_ENA_MASK = 0x00000001L;
constexpr unsigned int PA_CL_ENHANCE__ECO_SPARE0_MASK           = 0x80000000L;
constexpr unsigned int PA_CL_ENHANCE__ECO_SPARE1_MASK           = 0x40000000L;
constexpr unsigned int PA_CL_ENHANCE__IGNORE_PIPELINE_RESET_MASK = 0x00000040L;
constexpr unsigned int PA_CL_ENHANCE__KILL_INNER_EDGE_FLAGS_MASK = 0x00000080L;
constexpr unsigned int PA_CL_ENHANCE__NGG_BYPASS_PRIM_FILTER_MASK = 0x00000800L;
constexpr unsigned int PA_CL_ENHANCE__NGG_PA_TO_ALL_SC_MASK     = 0x00000100L;
constexpr unsigned int PA_CL_ENHANCE__NGG_PRIM_INDICES_FIFO_DEPTH_MASK = 0x0001c000L;
constexpr unsigned int PA_CL_ENHANCE__NGG_SIDEBAND_MEMORY_DEPTH_MASK = 0x00003000L;
constexpr unsigned int PA_CL_ENHANCE__NUM_CLIP_SEQ_MASK         = 0x00000006L;
constexpr unsigned int PA_CL_ENHANCE__TC_LATENCY_TIME_STAMP_RESOLUTION_MASK = 0x00000600L;
constexpr unsigned int PA_CL_ENHANCE__VE_NAN_PROC_DISABLE_MASK  = 0x00000010L;
constexpr unsigned int PA_CL_ENHANCE__XTRA_DEBUG_REG_SEL_MASK   = 0x00000020L;
constexpr unsigned int PA_CL_GB_HORZ_CLIP_ADJ__DATA_REGISTER_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_GB_HORZ_DISC_ADJ__DATA_REGISTER_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_GB_VERT_CLIP_ADJ__DATA_REGISTER_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_GB_VERT_DISC_ADJ__DATA_REGISTER_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_CLIP_DIST_INF_DISCARD_MASK = 0x00004000L;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_W_INF_RETAIN_MASK  = 0x00002000L;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_W_NAN_TO_INF_MASK  = 0x00001000L;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_XY_INF_RETAIN_MASK = 0x00000200L;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_XY_NAN_TO_INF_MASK = 0x00000100L;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_Z_INF_RETAIN_MASK  = 0x00000800L;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_Z_NAN_TO_INF_MASK  = 0x00000400L;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_0XNANINF_IS_0_MASK = 0x00000008L;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_NO_OUTPUT_NEG_0_MASK = 0x00100000L;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_W_INF_DISCARD_MASK = 0x00000004L;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_W_NAN_RETAIN_MASK = 0x00000040L;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_W_RECIP_NAN_IS_0_MASK = 0x00000080L;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_XY_INF_DISCARD_MASK = 0x00000001L;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_XY_NAN_RETAIN_MASK = 0x00000010L;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_Z_INF_DISCARD_MASK = 0x00000002L;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_Z_NAN_RETAIN_MASK = 0x00000020L;
constexpr unsigned int PA_CL_NGG_CNTL__INDEX_BUF_EDGE_FLAG_ENA_MASK = 0x00000002L;
constexpr unsigned int PA_CL_NGG_CNTL__VERTEX_REUSE_OFF_MASK    = 0x00000001L;
constexpr unsigned int PA_CL_POINT_CULL_RAD__DATA_REGISTER_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_POINT_SIZE__DATA_REGISTER_MASK     = 0xffffffffL;
constexpr unsigned int PA_CL_POINT_X_RAD__DATA_REGISTER_MASK    = 0xffffffffL;
constexpr unsigned int PA_CL_POINT_Y_RAD__DATA_REGISTER_MASK    = 0xffffffffL;
constexpr unsigned int PA_CL_RESET_DEBUG__CL_TRIV_DISC_DISABLE_MASK = 0x00000001L;
constexpr unsigned int PA_CL_UCP_0_W__DATA_REGISTER_MASK        = 0xffffffffL;
constexpr unsigned int PA_CL_UCP_0_X__DATA_REGISTER_MASK        = 0xffffffffL;
constexpr unsigned int PA_CL_UCP_0_Y__DATA_REGISTER_MASK        = 0xffffffffL;
constexpr unsigned int PA_CL_UCP_0_Z__DATA_REGISTER_MASK        = 0xffffffffL;
constexpr unsigned int PA_CL_UCP_1_W__DATA_REGISTER_MASK        = 0xffffffffL;
constexpr unsigned int PA_CL_UCP_1_X__DATA_REGISTER_MASK        = 0xffffffffL;
constexpr unsigned int PA_CL_UCP_1_Y__DATA_REGISTER_MASK        = 0xffffffffL;
constexpr unsigned int PA_CL_UCP_1_Z__DATA_REGISTER_MASK        = 0xffffffffL;
constexpr unsigned int PA_CL_UCP_2_W__DATA_REGISTER_MASK        = 0xffffffffL;
constexpr unsigned int PA_CL_UCP_2_X__DATA_REGISTER_MASK        = 0xffffffffL;
constexpr unsigned int PA_CL_UCP_2_Y__DATA_REGISTER_MASK        = 0xffffffffL;
constexpr unsigned int PA_CL_UCP_2_Z__DATA_REGISTER_MASK        = 0xffffffffL;
constexpr unsigned int PA_CL_UCP_3_W__DATA_REGISTER_MASK        = 0xffffffffL;
constexpr unsigned int PA_CL_UCP_3_X__DATA_REGISTER_MASK        = 0xffffffffL;
constexpr unsigned int PA_CL_UCP_3_Y__DATA_REGISTER_MASK        = 0xffffffffL;
constexpr unsigned int PA_CL_UCP_3_Z__DATA_REGISTER_MASK        = 0xffffffffL;
constexpr unsigned int PA_CL_UCP_4_W__DATA_REGISTER_MASK        = 0xffffffffL;
constexpr unsigned int PA_CL_UCP_4_X__DATA_REGISTER_MASK        = 0xffffffffL;
constexpr unsigned int PA_CL_UCP_4_Y__DATA_REGISTER_MASK        = 0xffffffffL;
constexpr unsigned int PA_CL_UCP_4_Z__DATA_REGISTER_MASK        = 0xffffffffL;
constexpr unsigned int PA_CL_UCP_5_W__DATA_REGISTER_MASK        = 0xffffffffL;
constexpr unsigned int PA_CL_UCP_5_X__DATA_REGISTER_MASK        = 0xffffffffL;
constexpr unsigned int PA_CL_UCP_5_Y__DATA_REGISTER_MASK        = 0xffffffffL;
constexpr unsigned int PA_CL_UCP_5_Z__DATA_REGISTER_MASK        = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XOFFSET_1__VPORT_XOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XOFFSET_2__VPORT_XOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XOFFSET_3__VPORT_XOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XOFFSET_4__VPORT_XOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XOFFSET_5__VPORT_XOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XOFFSET_6__VPORT_XOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XOFFSET_7__VPORT_XOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XOFFSET_8__VPORT_XOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XOFFSET_9__VPORT_XOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XOFFSET_10__VPORT_XOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XOFFSET_11__VPORT_XOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XOFFSET_12__VPORT_XOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XOFFSET_13__VPORT_XOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XOFFSET_14__VPORT_XOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XOFFSET_15__VPORT_XOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XOFFSET__VPORT_XOFFSET_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XSCALE_1__VPORT_XSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XSCALE_2__VPORT_XSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XSCALE_3__VPORT_XSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XSCALE_4__VPORT_XSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XSCALE_5__VPORT_XSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XSCALE_6__VPORT_XSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XSCALE_7__VPORT_XSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XSCALE_8__VPORT_XSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XSCALE_9__VPORT_XSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XSCALE_10__VPORT_XSCALE_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XSCALE_11__VPORT_XSCALE_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XSCALE_12__VPORT_XSCALE_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XSCALE_13__VPORT_XSCALE_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XSCALE_14__VPORT_XSCALE_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XSCALE_15__VPORT_XSCALE_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_XSCALE__VPORT_XSCALE_MASK    = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YOFFSET_1__VPORT_YOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YOFFSET_2__VPORT_YOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YOFFSET_3__VPORT_YOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YOFFSET_4__VPORT_YOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YOFFSET_5__VPORT_YOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YOFFSET_6__VPORT_YOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YOFFSET_7__VPORT_YOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YOFFSET_8__VPORT_YOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YOFFSET_9__VPORT_YOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YOFFSET_10__VPORT_YOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YOFFSET_11__VPORT_YOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YOFFSET_12__VPORT_YOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YOFFSET_13__VPORT_YOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YOFFSET_14__VPORT_YOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YOFFSET_15__VPORT_YOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YOFFSET__VPORT_YOFFSET_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YSCALE_1__VPORT_YSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YSCALE_2__VPORT_YSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YSCALE_3__VPORT_YSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YSCALE_4__VPORT_YSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YSCALE_5__VPORT_YSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YSCALE_6__VPORT_YSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YSCALE_7__VPORT_YSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YSCALE_8__VPORT_YSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YSCALE_9__VPORT_YSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YSCALE_10__VPORT_YSCALE_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YSCALE_11__VPORT_YSCALE_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YSCALE_12__VPORT_YSCALE_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YSCALE_13__VPORT_YSCALE_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YSCALE_14__VPORT_YSCALE_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YSCALE_15__VPORT_YSCALE_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_YSCALE__VPORT_YSCALE_MASK    = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_1__VPORT_ZOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_2__VPORT_ZOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_3__VPORT_ZOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_4__VPORT_ZOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_5__VPORT_ZOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_6__VPORT_ZOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_7__VPORT_ZOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_8__VPORT_ZOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_9__VPORT_ZOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_10__VPORT_ZOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_11__VPORT_ZOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_12__VPORT_ZOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_13__VPORT_ZOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_14__VPORT_ZOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_15__VPORT_ZOFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZOFFSET__VPORT_ZOFFSET_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZSCALE_1__VPORT_ZSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZSCALE_2__VPORT_ZSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZSCALE_3__VPORT_ZSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZSCALE_4__VPORT_ZSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZSCALE_5__VPORT_ZSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZSCALE_6__VPORT_ZSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZSCALE_7__VPORT_ZSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZSCALE_8__VPORT_ZSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZSCALE_9__VPORT_ZSCALE_MASK  = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZSCALE_10__VPORT_ZSCALE_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZSCALE_11__VPORT_ZSCALE_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZSCALE_12__VPORT_ZSCALE_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZSCALE_13__VPORT_ZSCALE_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZSCALE_14__VPORT_ZSCALE_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZSCALE_15__VPORT_ZSCALE_MASK = 0xffffffffL;
constexpr unsigned int PA_CL_VPORT_ZSCALE__VPORT_ZSCALE_MASK    = 0xffffffffL;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_0_MASK  = 0x00000001L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_1_MASK  = 0x00000002L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_2_MASK  = 0x00000004L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_3_MASK  = 0x00000008L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_4_MASK  = 0x00000010L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_5_MASK  = 0x00000020L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_6_MASK  = 0x00000040L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_7_MASK  = 0x00000080L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_0_MASK  = 0x00000100L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_1_MASK  = 0x00000200L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_2_MASK  = 0x00000400L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_3_MASK  = 0x00000800L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_4_MASK  = 0x00001000L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_5_MASK  = 0x00002000L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_6_MASK  = 0x00004000L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_7_MASK  = 0x00008000L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_EDGE_FLAG_MASK = 0x00020000L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_GS_CUT_FLAG_MASK = 0x02000000L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_KILL_FLAG_MASK = 0x00100000L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_POINT_SIZE_MASK = 0x00010000L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_RENDER_TARGET_INDX_MASK = 0x00040000L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_VIEWPORT_INDX_MASK = 0x00080000L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__VS_OUT_CCDIST0_VEC_ENA_MASK = 0x00400000L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__VS_OUT_CCDIST1_VEC_ENA_MASK = 0x00800000L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__VS_OUT_MISC_SIDE_BUS_ENA_MASK = 0x01000000L;
constexpr unsigned int PA_CL_VS_OUT_CNTL__VS_OUT_MISC_VEC_ENA_MASK = 0x00200000L;
constexpr unsigned int PA_CL_VTE_CNTL__PERFCOUNTER_REF_MASK     = 0x00000800L;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_X_OFFSET_ENA_MASK  = 0x00000002L;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_X_SCALE_ENA_MASK   = 0x00000001L;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_Y_OFFSET_ENA_MASK  = 0x00000008L;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_Y_SCALE_ENA_MASK   = 0x00000004L;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_Z_OFFSET_ENA_MASK  = 0x00000020L;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_Z_SCALE_ENA_MASK   = 0x00000010L;
constexpr unsigned int PA_CL_VTE_CNTL__VTX_W0_FMT_MASK          = 0x00000400L;
constexpr unsigned int PA_CL_VTE_CNTL__VTX_XY_FMT_MASK          = 0x00000100L;
constexpr unsigned int PA_CL_VTE_CNTL__VTX_Z_FMT_MASK           = 0x00000200L;
constexpr unsigned int PA_SC_AA_CONFIG__AA_MASK_CENTROID_DTMN_MASK = 0x00000010L;
constexpr unsigned int PA_SC_AA_CONFIG__COVERAGE_TO_SHADER_SELECT_MASK = 0x0c000000L;
constexpr unsigned int PA_SC_AA_CONFIG__DETAIL_TO_EXPOSED_MODE_MASK = 0x03000000L;
constexpr unsigned int PA_SC_AA_CONFIG__MAX_SAMPLE_DIST_MASK    = 0x0001e000L;
constexpr unsigned int PA_SC_AA_CONFIG__MSAA_EXPOSED_SAMPLES_MASK = 0x00700000L;
constexpr unsigned int PA_SC_AA_CONFIG__MSAA_NUM_SAMPLES_MASK   = 0x00000007L;
constexpr unsigned int PA_SC_AA_MASK_X0Y0_X1Y0__AA_MASK_X0Y0_MASK = 0x0000ffffL;
constexpr unsigned int PA_SC_AA_MASK_X0Y0_X1Y0__AA_MASK_X1Y0_MASK = 0xffff0000L;
constexpr unsigned int PA_SC_AA_MASK_X0Y1_X1Y1__AA_MASK_X0Y1_MASK = 0x0000ffffL;
constexpr unsigned int PA_SC_AA_MASK_X0Y1_X1Y1__AA_MASK_X1Y1_MASK = 0xffff0000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S0_X_MASK = 0x0000000fL;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S0_Y_MASK = 0x000000f0L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S1_X_MASK = 0x00000f00L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S1_Y_MASK = 0x0000f000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S2_X_MASK = 0x000f0000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S2_Y_MASK = 0x00f00000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S3_X_MASK = 0x0f000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S3_Y_MASK = 0xf0000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S4_X_MASK = 0x0000000fL;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S4_Y_MASK = 0x000000f0L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S5_X_MASK = 0x00000f00L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S5_Y_MASK = 0x0000f000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S6_X_MASK = 0x000f0000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S6_Y_MASK = 0x00f00000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S7_X_MASK = 0x0f000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S7_Y_MASK = 0xf0000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S8_X_MASK = 0x0000000fL;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S8_Y_MASK = 0x000000f0L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S9_X_MASK = 0x00000f00L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S9_Y_MASK = 0x0000f000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S10_X_MASK = 0x000f0000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S10_Y_MASK = 0x00f00000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S11_X_MASK = 0x0f000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S11_Y_MASK = 0xf0000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S12_X_MASK = 0x0000000fL;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S12_Y_MASK = 0x000000f0L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S13_X_MASK = 0x00000f00L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S13_Y_MASK = 0x0000f000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S14_X_MASK = 0x000f0000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S14_Y_MASK = 0x00f00000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S15_X_MASK = 0x0f000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S15_Y_MASK = 0xf0000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S0_X_MASK = 0x0000000fL;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S0_Y_MASK = 0x000000f0L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S1_X_MASK = 0x00000f00L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S1_Y_MASK = 0x0000f000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S2_X_MASK = 0x000f0000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S2_Y_MASK = 0x00f00000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S3_X_MASK = 0x0f000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S3_Y_MASK = 0xf0000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S4_X_MASK = 0x0000000fL;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S4_Y_MASK = 0x000000f0L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S5_X_MASK = 0x00000f00L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S5_Y_MASK = 0x0000f000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S6_X_MASK = 0x000f0000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S6_Y_MASK = 0x00f00000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S7_X_MASK = 0x0f000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S7_Y_MASK = 0xf0000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S8_X_MASK = 0x0000000fL;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S8_Y_MASK = 0x000000f0L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S9_X_MASK = 0x00000f00L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S9_Y_MASK = 0x0000f000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S10_X_MASK = 0x000f0000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S10_Y_MASK = 0x00f00000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S11_X_MASK = 0x0f000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S11_Y_MASK = 0xf0000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S12_X_MASK = 0x0000000fL;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S12_Y_MASK = 0x000000f0L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S13_X_MASK = 0x00000f00L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S13_Y_MASK = 0x0000f000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S14_X_MASK = 0x000f0000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S14_Y_MASK = 0x00f00000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S15_X_MASK = 0x0f000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S15_Y_MASK = 0xf0000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S0_X_MASK = 0x0000000fL;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S0_Y_MASK = 0x000000f0L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S1_X_MASK = 0x00000f00L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S1_Y_MASK = 0x0000f000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S2_X_MASK = 0x000f0000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S2_Y_MASK = 0x00f00000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S3_X_MASK = 0x0f000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S3_Y_MASK = 0xf0000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S4_X_MASK = 0x0000000fL;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S4_Y_MASK = 0x000000f0L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S5_X_MASK = 0x00000f00L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S5_Y_MASK = 0x0000f000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S6_X_MASK = 0x000f0000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S6_Y_MASK = 0x00f00000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S7_X_MASK = 0x0f000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S7_Y_MASK = 0xf0000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S8_X_MASK = 0x0000000fL;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S8_Y_MASK = 0x000000f0L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S9_X_MASK = 0x00000f00L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S9_Y_MASK = 0x0000f000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S10_X_MASK = 0x000f0000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S10_Y_MASK = 0x00f00000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S11_X_MASK = 0x0f000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S11_Y_MASK = 0xf0000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S12_X_MASK = 0x0000000fL;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S12_Y_MASK = 0x000000f0L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S13_X_MASK = 0x00000f00L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S13_Y_MASK = 0x0000f000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S14_X_MASK = 0x000f0000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S14_Y_MASK = 0x00f00000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S15_X_MASK = 0x0f000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S15_Y_MASK = 0xf0000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S0_X_MASK = 0x0000000fL;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S0_Y_MASK = 0x000000f0L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S1_X_MASK = 0x00000f00L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S1_Y_MASK = 0x0000f000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S2_X_MASK = 0x000f0000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S2_Y_MASK = 0x00f00000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S3_X_MASK = 0x0f000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S3_Y_MASK = 0xf0000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S4_X_MASK = 0x0000000fL;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S4_Y_MASK = 0x000000f0L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S5_X_MASK = 0x00000f00L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S5_Y_MASK = 0x0000f000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S6_X_MASK = 0x000f0000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S6_Y_MASK = 0x00f00000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S7_X_MASK = 0x0f000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S7_Y_MASK = 0xf0000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S8_X_MASK = 0x0000000fL;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S8_Y_MASK = 0x000000f0L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S9_X_MASK = 0x00000f00L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S9_Y_MASK = 0x0000f000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S10_X_MASK = 0x000f0000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S10_Y_MASK = 0x00f00000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S11_X_MASK = 0x0f000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S11_Y_MASK = 0xf0000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S12_X_MASK = 0x0000000fL;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S12_Y_MASK = 0x000000f0L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S13_X_MASK = 0x00000f00L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S13_Y_MASK = 0x0000f000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S14_X_MASK = 0x000f0000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S14_Y_MASK = 0x00f00000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S15_X_MASK = 0x0f000000L;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S15_Y_MASK = 0xf0000000L;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BINNING_MODE_MASK   = 0x00000003L;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_SIZE_X_EXTEND_MASK = 0x00000070L;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_SIZE_X_MASK     = 0x00000004L;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_SIZE_Y_EXTEND_MASK = 0x00000380L;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_SIZE_Y_MASK     = 0x00000008L;
constexpr unsigned int PA_SC_BINNER_CNTL_0__CONTEXT_STATES_PER_BIN_MASK = 0x00001c00L;
constexpr unsigned int PA_SC_BINNER_CNTL_0__DISABLE_START_OF_PRIM_MASK = 0x00040000L;
constexpr unsigned int PA_SC_BINNER_CNTL_0__FPOVS_PER_BATCH_MASK = 0x07f80000L;
constexpr unsigned int PA_SC_BINNER_CNTL_0__OPTIMAL_BIN_SELECTION_MASK = 0x08000000L;
constexpr unsigned int PA_SC_BINNER_CNTL_0__PERSISTENT_STATES_PER_BIN_MASK = 0x0003e000L;
constexpr unsigned int PA_SC_BINNER_CNTL_1__MAX_ALLOC_COUNT_MASK = 0x0000ffffL;
constexpr unsigned int PA_SC_BINNER_CNTL_1__MAX_PRIM_PER_BATCH_MASK = 0xffff0000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__BREAK_BATCH_MASK = 0x30000000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__CACHE_FLUSH_MASK = 0x00003000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__CACHE_FLUSH_TS_MASK = 0x00000300L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__CONTEXT_DONE_MASK = 0x00000c00L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__CS_PARTIAL_FLUSH_MASK = 0x0000c000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__END_OF_PIPE_IB_END_MASK = 0x03000000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__END_OF_PIPE_INCR_DE_MASK = 0x00c00000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__RESERVED_0_MASK = 0x00000003L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__RESERVED_9_MASK = 0x000c0000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__RST_PIX_CNT_MASK = 0x0c000000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__SAMPLE_STREAMOUTSTATS1_MASK = 0x0000000cL;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__SAMPLE_STREAMOUTSTATS2_MASK = 0x00000030L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__SAMPLE_STREAMOUTSTATS3_MASK = 0x000000c0L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__VGT_STREAMOUT_RESET_MASK = 0x00300000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__VGT_STREAMOUT_SYNC_MASK = 0x00030000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__VS_PARTIAL_FLUSH_MASK = 0xc0000000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__CACHE_FLUSH_AND_INV_EVENT_MASK = 0x00003000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__CACHE_FLUSH_AND_INV_TS_EVENT_MASK = 0x00000300L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__FLUSH_DFSM_MASK = 0x00000030L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__FLUSH_ES_OUTPUT_MASK = 0x03000000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__FLUSH_HS_OUTPUT_MASK = 0x0000000cL;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PERFCOUNTER_SAMPLE_MASK = 0x00c00000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PERFCOUNTER_START_MASK = 0x0000c000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PERFCOUNTER_STOP_MASK = 0x00030000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PIPELINESTAT_START_MASK = 0x000c0000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PIPELINESTAT_STOP_MASK = 0x00300000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PS_PARTIAL_FLUSH_MASK = 0x00000003L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__RESET_TO_LOWEST_VGT_MASK = 0x000000c0L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__SAMPLE_PIPELINESTAT_MASK = 0x30000000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__SO_VGTSTREAMOUT_FLUSH_MASK = 0xc0000000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__ZPASS_DONE_MASK = 0x00000c00L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__BLOCK_CONTEXT_DONE_MASK = 0x00000030L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__BOTTOM_OF_PIPE_TS_MASK = 0x00030000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__CS_DONE_MASK  = 0xc0000000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__DB_CACHE_FLUSH_AND_INV_MASK = 0x00300000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__FLUSH_AND_INV_CB_DATA_TS_MASK = 0x0c000000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__FLUSH_AND_INV_CB_META_MASK = 0x30000000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__FLUSH_AND_INV_DB_DATA_TS_MASK = 0x00c00000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__FLUSH_AND_INV_DB_META_MASK = 0x03000000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__RESET_VTX_CNT_MASK = 0x0000000cL;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__SAMPLE_STREAMOUTSTATS_MASK = 0x00000003L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__SC_SEND_DB_VPZ_MASK = 0x0000c000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__SQ_NON_EVENT_MASK = 0x00003000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__TGID_ROLLOVER_MASK = 0x00000c00L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__VGT_FLUSH_MASK = 0x00000300L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__CONTEXT_SUSPEND_MASK = 0x00c00000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__ENABLE_LEGACY_PIPELINE_MASK = 0x30000000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__ENABLE_NGG_PIPELINE_MASK = 0x0c000000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__FLUSH_AND_INV_CB_PIXEL_DATA_MASK = 0x0000000cL;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__OFFCHIP_HS_DEALLOC_MASK = 0x03000000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__PIXEL_PIPE_STAT_CONTROL_MASK = 0x00030000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__PIXEL_PIPE_STAT_DUMP_MASK = 0x000c0000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__PIXEL_PIPE_STAT_RESET_MASK = 0x00300000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__PS_DONE_MASK  = 0x00000003L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_FINISH_MASK = 0x0000c000L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_MARKER_MASK = 0x00000c00L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_START_MASK = 0x000000c0L;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_STOP_MASK = 0x00000300L;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_0__BATCH_HIST_NUM_CONTEXT_THRESHOLD_MASK = 0x03800000L;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_0__BATCH_HIST_NUM_PRIMS_THRESHOLD_MASK = 0x000ffc00L;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_0__BIN_HIST_NUM_CONTEXT_THRESHOLD_MASK = 0x00700000L;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_0__BIN_HIST_NUM_PRIMS_THRESHOLD_MASK = 0x000003ffL;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_1__BATCH_HIST_NUM_PERSISTENT_STATE_THRESHOLD_MASK = 0x000003e0L;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_1__BATCH_HIST_NUM_TRIV_REJECTED_PRIMS_THRESHOLD_MASK = 0x03fffc00L;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_1__BIN_HIST_NUM_PERSISTENT_STATE_THRESHOLD_MASK = 0x0000001fL;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_2__BATCH_HIST_NUM_COLUMNS_PER_ROW_THRESHOLD_MASK = 0x003ff800L;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_2__BATCH_HIST_NUM_ROWS_PER_PRIM_THRESHOLD_MASK = 0x000007ffL;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_3__BATCH_HIST_NUM_PS_WAVE_BREAKS_THRESHOLD_MASK = 0xffffffffL;
constexpr unsigned int PA_SC_BINNER_TIMEOUT_COUNTER__THRESHOLD_MASK = 0xffffffffL;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_0_MASK = 0x0000000fL;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_1_MASK = 0x000000f0L;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_2_MASK = 0x00000f00L;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_3_MASK = 0x0000f000L;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_4_MASK = 0x000f0000L;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_5_MASK = 0x00f00000L;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_6_MASK = 0x0f000000L;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_7_MASK = 0xf0000000L;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_8_MASK = 0x0000000fL;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_9_MASK = 0x000000f0L;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_10_MASK = 0x00000f00L;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_11_MASK = 0x0000f000L;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_12_MASK = 0x000f0000L;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_13_MASK = 0x00f00000L;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_14_MASK = 0x0f000000L;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_15_MASK = 0xf0000000L;
constexpr unsigned int PA_SC_CLIPRECT_0_BR__BR_X_MASK           = 0x00007fffL;
constexpr unsigned int PA_SC_CLIPRECT_0_BR__BR_Y_MASK           = 0x7fff0000L;
constexpr unsigned int PA_SC_CLIPRECT_0_TL__TL_X_MASK           = 0x00007fffL;
constexpr unsigned int PA_SC_CLIPRECT_0_TL__TL_Y_MASK           = 0x7fff0000L;
constexpr unsigned int PA_SC_CLIPRECT_1_BR__BR_X_MASK           = 0x00007fffL;
constexpr unsigned int PA_SC_CLIPRECT_1_BR__BR_Y_MASK           = 0x7fff0000L;
constexpr unsigned int PA_SC_CLIPRECT_1_TL__TL_X_MASK           = 0x00007fffL;
constexpr unsigned int PA_SC_CLIPRECT_1_TL__TL_Y_MASK           = 0x7fff0000L;
constexpr unsigned int PA_SC_CLIPRECT_2_BR__BR_X_MASK           = 0x00007fffL;
constexpr unsigned int PA_SC_CLIPRECT_2_BR__BR_Y_MASK           = 0x7fff0000L;
constexpr unsigned int PA_SC_CLIPRECT_2_TL__TL_X_MASK           = 0x00007fffL;
constexpr unsigned int PA_SC_CLIPRECT_2_TL__TL_Y_MASK           = 0x7fff0000L;
constexpr unsigned int PA_SC_CLIPRECT_3_BR__BR_X_MASK           = 0x00007fffL;
constexpr unsigned int PA_SC_CLIPRECT_3_BR__BR_Y_MASK           = 0x7fff0000L;
constexpr unsigned int PA_SC_CLIPRECT_3_TL__TL_X_MASK           = 0x00007fffL;
constexpr unsigned int PA_SC_CLIPRECT_3_TL__TL_Y_MASK           = 0x7fff0000L;
constexpr unsigned int PA_SC_CLIPRECT_RULE__CLIP_RULE_MASK      = 0x0000ffffL;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__CENTROID_SAMPLE_OVERRIDE_MASK = 0x01000000L;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__COVERAGE_AA_MASK_ENABLE_MASK = 0x00200000L;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__DEGENERATE_OVERRIDE_INNER_TO_NORMAL_DISABLE_MASK = 0x00008000L;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__INNER_UNCERTAINTY_EDGERULE_OVERRIDE_MASK = 0x00080000L;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__NULL_SQUAD_AA_MASK_ENABLE_MASK = 0x00100000L;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OUTER_UNCERTAINTY_EDGERULE_OVERRIDE_MASK = 0x00040000L;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OVERRIDE_OVER_RAST_INNER_TO_NORMAL_MASK = 0x00002000L;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OVERRIDE_UNDER_RAST_INNER_TO_NORMAL_MASK = 0x00004000L;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OVER_RAST_ENABLE_MASK = 0x00000001L;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OVER_RAST_SAMPLE_SELECT_MASK = 0x0000001eL;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__PBB_UNCERTAINTY_REGION_ENABLE_MASK = 0x00000400L;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__POSTZ_AA_MASK_ENABLE_MASK = 0x00800000L;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__PREZ_AA_MASK_ENABLE_MASK = 0x00400000L;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNCERTAINTY_REGION_MODE_MASK = 0x00030000L;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNDER_RAST_ENABLE_MASK = 0x00000020L;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNDER_RAST_SAMPLE_SELECT_MASK = 0x000003c0L;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__ZMM_TRI_EXTENT_MASK = 0x00000800L;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__ZMM_TRI_OFFSET_MASK = 0x00001000L;
constexpr unsigned int PA_SC_DEBUG_DATA__DATA_MASK              = 0xffffffffL;
constexpr unsigned int PA_SC_DSM_CNTL__FORCE_EOV_REZ_0_MASK     = 0x00000001L;
constexpr unsigned int PA_SC_DSM_CNTL__FORCE_EOV_REZ_1_MASK     = 0x00000002L;
constexpr unsigned int PA_SC_EDGERULE__ER_LINE_BT_MASK          = 0xf0000000L;
constexpr unsigned int PA_SC_EDGERULE__ER_LINE_LR_MASK          = 0x0003f000L;
constexpr unsigned int PA_SC_EDGERULE__ER_LINE_RL_MASK          = 0x00fc0000L;
constexpr unsigned int PA_SC_EDGERULE__ER_LINE_TB_MASK          = 0x0f000000L;
constexpr unsigned int PA_SC_EDGERULE__ER_POINT_MASK            = 0x000000f0L;
constexpr unsigned int PA_SC_EDGERULE__ER_RECT_MASK             = 0x00000f00L;
constexpr unsigned int PA_SC_EDGERULE__ER_TRI_MASK              = 0x0000000fL;
constexpr unsigned int PA_SC_ENHANCE_1__BYPASS_PBB_MASK         = 0x00000010L;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_FORCE_SOP_ALL_EVENTS_MASK = 0x00080000L;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PACKER_ODC_ENHANCE_MASK = 0x00010000L;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PBB_BINNING_CLK_OPTIMIZATION_MASK = 0x00400000L;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PBB_CLK_OPTIMIZATION_MASK = 0x00100000L;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PBB_SCISSOR_CLK_OPTIMIZATION_MASK = 0x00200000L;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PBB_SCISSOR_OPT_MASK = 0x00000400L;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_BINNING_MASK = 0x00000008L;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_DB_TILE_INTF_FINE_CLOCK_GATE_MASK = 0x00004000L;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_PIPELINE_RESET_LEGACY_MODE_TRANSITION_MASK = 0x00008000L;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_PROCESS_RESET_PBB_MASK = 0x00000200L;
constexpr unsigned int PA_SC_ENHANCE_1__ECO_SPARE0_MASK         = 0x00000020L;
constexpr unsigned int PA_SC_ENHANCE_1__ECO_SPARE1_MASK         = 0x00000040L;
constexpr unsigned int PA_SC_ENHANCE_1__ECO_SPARE2_MASK         = 0x00000080L;
constexpr unsigned int PA_SC_ENHANCE_1__ECO_SPARE3_MASK         = 0x00000100L;
constexpr unsigned int PA_SC_ENHANCE_1__ENABLE_DFSM_FLUSH_EVENT_TO_FLUSH_POPS_CAM_MASK = 0x00000800L;
constexpr unsigned int PA_SC_ENHANCE_1__OPTIMAL_BIN_SELECTION_MASK = 0x00040000L;
constexpr unsigned int PA_SC_ENHANCE_1__REALIGN_DQUADS_OVERRIDE_ENABLE_MASK = 0x00000001L;
constexpr unsigned int PA_SC_ENHANCE_1__REALIGN_DQUADS_OVERRIDE_MASK = 0x00000006L;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_AA_MASK_FULL_FIX_MASK = 0x00000004L;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_DUALGRAD_PERF_OPTIMIZATION_MASK = 0x00000080L;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_EOP_LINE_STIPPLE_RESET_MASK = 0x04000000L;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_EOV_ALL_CTRL_ONLY_COMBINATIONS_MASK = 0x00001000L;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OOO_NO_EOPG_SKEW_DESIRED_FIFO_IS_CURRENT_FIFO_MASK = 0x00800000L;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_DESIRED_FIFO_EMPTY_SWITCHING_MASK = 0x00080000L;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_EMPTY_SWITCHING_HYSTERYSIS_MASK = 0x00200000L;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_EOP_SYNC_NULL_PRIMS_LAST_MASK = 0x00010000L;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_PA_SC_GUIDANCE_MASK = 0x00004000L;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_SELECTED_FIFO_EMPTY_SWITCHING_MASK = 0x00100000L;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_THRESHOLD_SWITCHING_MASK = 0x00020000L;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_PA_SC_GUIDANCE_MASK = 0x00000800L;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SCISSOR_FIX_MASK  = 0x00000020L;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SC_DB_TILE_FIX_MASK = 0x00000002L;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SC_PROCESS_RESET_PRIM_MASK = 0x00000100L;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SC_PROCESS_RESET_SUPERTILE_MASK = 0x00000200L;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SC_PROCESS_RESET_TILE_MASK = 0x00000400L;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_VPZ_EOP_LINE_STIPPLE_RESET_MASK = 0x08000000L;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_1XMSAA_SAMPLE_LOCATIONS_MASK = 0x00000008L;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_1XMSAA_SAMPLE_LOC_CENTROID_MASK = 0x00000010L;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_MULTICYCLE_BUBBLE_FREEZE_MASK = 0x00002000L;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_OUT_OF_ORDER_DESIRED_FIFO_IS_NEXT_FEID_MASK = 0x00400000L;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_OUT_OF_ORDER_POLY_MODE_MASK = 0x00008000L;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_OUT_OF_ORDER_THRESHOLD_SWITCH_AT_EOPG_ONLY_MASK = 0x00040000L;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_PA_SC_OUT_OF_ORDER_MASK = 0x00000001L;
constexpr unsigned int PA_SC_ENHANCE__IOO_DISABLE_SCAN_UNSELECTED_FIFOS_FOR_DUAL_GFX_RING_CHANGE_MASK = 0x10000000L;
constexpr unsigned int PA_SC_ENHANCE__OOO_DISABLE_EOPG_SKEW_THRESHOLD_SWITCHING_MASK = 0x02000000L;
constexpr unsigned int PA_SC_ENHANCE__OOO_DISABLE_EOP_ON_FIRST_LIVE_PRIM_HIT_MASK = 0x01000000L;
constexpr unsigned int PA_SC_ENHANCE__OOO_USE_ABSOLUTE_FIFO_COUNT_IN_THRESHOLD_SWITCHING_MASK = 0x20000000L;
constexpr unsigned int PA_SC_ENHANCE__SEND_UNLIT_STILES_TO_PACKER_MASK = 0x00000040L;
constexpr unsigned int PA_SC_FIFO_DEPTH_CNTL__DEPTH_MASK        = 0x000003ffL;
constexpr unsigned int PA_SC_FIFO_SIZE__SC_BACKEND_PRIM_FIFO_SIZE_MASK = 0x00007fc0L;
constexpr unsigned int PA_SC_FIFO_SIZE__SC_EARLYZ_TILE_FIFO_SIZE_MASK = 0xffe00000L;
constexpr unsigned int PA_SC_FIFO_SIZE__SC_FRONTEND_PRIM_FIFO_SIZE_MASK = 0x0000003fL;
constexpr unsigned int PA_SC_FIFO_SIZE__SC_HIZ_TILE_FIFO_SIZE_MASK = 0x001f8000L;
constexpr unsigned int PA_SC_FORCE_EOV_MAX_CNTS__FORCE_EOV_MAX_CLK_CNT_MASK = 0x0000ffffL;
constexpr unsigned int PA_SC_FORCE_EOV_MAX_CNTS__FORCE_EOV_MAX_REZ_CNT_MASK = 0xffff0000L;
constexpr unsigned int PA_SC_GENERIC_SCISSOR_BR__BR_X_MASK      = 0x00007fffL;
constexpr unsigned int PA_SC_GENERIC_SCISSOR_BR__BR_Y_MASK      = 0x7fff0000L;
constexpr unsigned int PA_SC_GENERIC_SCISSOR_TL__TL_X_MASK      = 0x00007fffL;
constexpr unsigned int PA_SC_GENERIC_SCISSOR_TL__TL_Y_MASK      = 0x7fff0000L;
constexpr unsigned int PA_SC_GENERIC_SCISSOR_TL__WINDOW_OFFSET_DISABLE_MASK = 0x80000000L;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_COUNT__COUNT_MASK = 0x0000ffffL;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_HV_EN__ENABLE_HV_PRE_SHADER_MASK = 0x00000001L;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_HV_EN__FORCE_PRE_SHADER_ALL_PIXELS_MASK = 0x00000002L;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_HV_LOCK__DISABLE_NON_PRIV_WRITES_MASK = 0x00000001L;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_H__X_COORD_MASK   = 0x00003fffL;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_OCCURRENCE__COUNT_MASK = 0x0000ffffL;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_V__Y_COORD_MASK   = 0x00003fffL;
constexpr unsigned int PA_SC_IF_FIFO_SIZE__SC_BCI_IF_FIFO_SIZE_MASK = 0x00fc0000L;
constexpr unsigned int PA_SC_IF_FIFO_SIZE__SC_DB_QUAD_IF_FIFO_SIZE_MASK = 0x00000fc0L;
constexpr unsigned int PA_SC_IF_FIFO_SIZE__SC_DB_TILE_IF_FIFO_SIZE_MASK = 0x0000003fL;
constexpr unsigned int PA_SC_IF_FIFO_SIZE__SC_SPI_IF_FIFO_SIZE_MASK = 0x0003f000L;
constexpr unsigned int PA_SC_LINE_CNTL__DX10_DIAMOND_TEST_ENA_MASK = 0x00001000L;
constexpr unsigned int PA_SC_LINE_CNTL__EXPAND_LINE_WIDTH_MASK  = 0x00000200L;
constexpr unsigned int PA_SC_LINE_CNTL__LAST_PIXEL_MASK         = 0x00000400L;
constexpr unsigned int PA_SC_LINE_CNTL__PERPENDICULAR_ENDCAP_ENA_MASK = 0x00000800L;
constexpr unsigned int PA_SC_LINE_STIPPLE_STATE__CURRENT_COUNT_MASK = 0x0000ff00L;
constexpr unsigned int PA_SC_LINE_STIPPLE_STATE__CURRENT_PTR_MASK = 0x0000000fL;
constexpr unsigned int PA_SC_LINE_STIPPLE__AUTO_RESET_CNTL_MASK = 0x60000000L;
constexpr unsigned int PA_SC_LINE_STIPPLE__LINE_PATTERN_MASK    = 0x0000ffffL;
constexpr unsigned int PA_SC_LINE_STIPPLE__PATTERN_BIT_ORDER_MASK = 0x10000000L;
constexpr unsigned int PA_SC_LINE_STIPPLE__REPEAT_COUNT_MASK    = 0x00ff0000L;
constexpr unsigned int PA_SC_MODE_CNTL_0__ALTERNATE_RBS_PER_TILE_MASK = 0x00000020L;
constexpr unsigned int PA_SC_MODE_CNTL_0__COARSE_TILE_STARTS_ON_EVEN_RB_MASK = 0x00000040L;
constexpr unsigned int PA_SC_MODE_CNTL_0__LINE_STIPPLE_ENABLE_MASK = 0x00000004L;
constexpr unsigned int PA_SC_MODE_CNTL_0__MSAA_ENABLE_MASK      = 0x00000001L;
constexpr unsigned int PA_SC_MODE_CNTL_0__SEND_UNLIT_STILES_TO_PKR_MASK = 0x00000008L;
constexpr unsigned int PA_SC_MODE_CNTL_0__VPORT_SCISSOR_ENABLE_MASK = 0x00000002L;
constexpr unsigned int PA_SC_MODE_CNTL_1__FORCE_EOV_CNTDWN_ENABLE_MASK = 0x02000000L;
constexpr unsigned int PA_SC_MODE_CNTL_1__FORCE_EOV_REZ_ENABLE_MASK = 0x04000000L;
constexpr unsigned int PA_SC_MODE_CNTL_1__GPU_ID_OVERRIDE_ENABLE_MASK = 0x00080000L;
constexpr unsigned int PA_SC_MODE_CNTL_1__GPU_ID_OVERRIDE_MASK  = 0x00f00000L;
constexpr unsigned int PA_SC_MODE_CNTL_1__KILL_PIX_POST_DETAIL_MASK_MASK = 0x00008000L;
constexpr unsigned int PA_SC_MODE_CNTL_1__KILL_PIX_POST_HI_Z_MASK = 0x00004000L;
constexpr unsigned int PA_SC_MODE_CNTL_1__MULTI_GPU_PRIM_DISCARD_ENABLE_MASK = 0x01000000L;
constexpr unsigned int PA_SC_MODE_CNTL_1__MULTI_GPU_SUPERTILE_ENABLE_MASK = 0x00040000L;
constexpr unsigned int PA_SC_MODE_CNTL_1__MULTI_SHADER_ENGINE_PRIM_DISCARD_ENABLE_MASK = 0x00020000L;
constexpr unsigned int PA_SC_MODE_CNTL_1__OUT_OF_ORDER_PRIMITIVE_ENABLE_MASK = 0x08000000L;
constexpr unsigned int PA_SC_MODE_CNTL_1__OUT_OF_ORDER_WATER_MARK_MASK = 0x70000000L;
constexpr unsigned int PA_SC_MODE_CNTL_1__PS_ITER_SAMPLE_MASK   = 0x00010000L;
constexpr unsigned int PA_SC_MODE_CNTL_1__SUPERTILE_WALK_ORDER_ENABLE_MASK = 0x00000080L;
constexpr unsigned int PA_SC_MODE_CNTL_1__TILE_COVER_DISABLE_MASK = 0x00000200L;
constexpr unsigned int PA_SC_MODE_CNTL_1__TILE_COVER_NO_SCISSOR_MASK = 0x00000400L;
constexpr unsigned int PA_SC_MODE_CNTL_1__TILE_WALK_ORDER_ENABLE_MASK = 0x00000100L;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_ALIGN8_PRIM_FITS_ST_MASK = 0x00000004L;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_ALIGNMENT_MASK   = 0x00000002L;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_FENCE_ENABLE_MASK = 0x00000008L;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_FENCE_SIZE_MASK  = 0x00000070L;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_SIZE_MASK        = 0x00000001L;
constexpr unsigned int PA_SC_MODE_CNTL_1__ZMM_LINE_EXTENT_MASK  = 0x00000800L;
constexpr unsigned int PA_SC_MODE_CNTL_1__ZMM_LINE_OFFSET_MASK  = 0x00001000L;
constexpr unsigned int PA_SC_MODE_CNTL_1__ZMM_RECT_EXTENT_MASK  = 0x00002000L;
constexpr unsigned int PA_SC_NGG_MODE_CNTL__MAX_DEALLOCS_IN_WAVE_MASK = 0x000007ffL;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_COUNT__COUNT_MASK  = 0x0000ffffL;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_HV_EN__ENABLE_HV_PRE_SHADER_MASK = 0x00000001L;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_HV_EN__FORCE_PRE_SHADER_ALL_PIXELS_MASK = 0x00000002L;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_HV_LOCK__DISABLE_NON_PRIV_WRITES_MASK = 0x00000001L;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_H__X_COORD_MASK    = 0x00003fffL;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_OCCURRENCE__COUNT_MASK = 0x0000ffffL;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_V__Y_COORD_MASK    = 0x00003fffL;
constexpr unsigned int PA_SC_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int PA_SC_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__CNTR_MODE_MASK = 0x00f00000L;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__PERF_SEL1_MASK = 0x000ffc00L;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__PERF_SEL_MASK = 0x000003ffL;
constexpr unsigned int PA_SC_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int PA_SC_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int PA_SC_PERFCOUNTER1_SELECT__PERF_SEL_MASK = 0x000003ffL;
constexpr unsigned int PA_SC_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int PA_SC_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int PA_SC_PERFCOUNTER2_SELECT__PERF_SEL_MASK = 0x000003ffL;
constexpr unsigned int PA_SC_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int PA_SC_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int PA_SC_PERFCOUNTER3_SELECT__PERF_SEL_MASK = 0x000003ffL;
constexpr unsigned int PA_SC_PERFCOUNTER4_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int PA_SC_PERFCOUNTER4_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int PA_SC_PERFCOUNTER4_SELECT__PERF_SEL_MASK = 0x000003ffL;
constexpr unsigned int PA_SC_PERFCOUNTER5_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int PA_SC_PERFCOUNTER5_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int PA_SC_PERFCOUNTER5_SELECT__PERF_SEL_MASK = 0x000003ffL;
constexpr unsigned int PA_SC_PERFCOUNTER6_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int PA_SC_PERFCOUNTER6_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int PA_SC_PERFCOUNTER6_SELECT__PERF_SEL_MASK = 0x000003ffL;
constexpr unsigned int PA_SC_PERFCOUNTER7_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int PA_SC_PERFCOUNTER7_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int PA_SC_PERFCOUNTER7_SELECT__PERF_SEL_MASK = 0x000003ffL;
constexpr unsigned int PA_SC_PKR_WAVE_TABLE_CNTL__SIZE_MASK     = 0x0000003fL;
constexpr unsigned int PA_SC_RASTER_CONFIG_1__SE_PAIR_MAP_MASK  = 0x00000003L;
constexpr unsigned int PA_SC_RASTER_CONFIG__PKR_MAP_MASK        = 0x00000300L;
constexpr unsigned int PA_SC_RASTER_CONFIG__PKR_XSEL2_MASK      = 0x0000c000L;
constexpr unsigned int PA_SC_RASTER_CONFIG__PKR_XSEL_MASK       = 0x00000c00L;
constexpr unsigned int PA_SC_RASTER_CONFIG__PKR_YSEL_MASK       = 0x00003000L;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_MAP_PKR0_MASK    = 0x00000003L;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_MAP_PKR1_MASK    = 0x0000000cL;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_XSEL2_MASK       = 0x00000030L;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_XSEL_MASK        = 0x00000040L;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_YSEL_MASK        = 0x00000080L;
constexpr unsigned int PA_SC_RASTER_CONFIG__SC_MAP_MASK         = 0x00030000L;
constexpr unsigned int PA_SC_RASTER_CONFIG__SC_XSEL_MASK        = 0x000c0000L;
constexpr unsigned int PA_SC_RASTER_CONFIG__SC_YSEL_MASK        = 0x00300000L;
constexpr unsigned int PA_SC_RASTER_CONFIG__SE_MAP_MASK         = 0x03000000L;
constexpr unsigned int PA_SC_SCREEN_EXTENT_CONTROL__SLICE_EVEN_ENABLE_MASK = 0x00000003L;
constexpr unsigned int PA_SC_SCREEN_EXTENT_CONTROL__SLICE_ODD_ENABLE_MASK = 0x0000000cL;
constexpr unsigned int PA_SC_SCREEN_EXTENT_MAX_0__X_MASK        = 0x0000ffffL;
constexpr unsigned int PA_SC_SCREEN_EXTENT_MAX_0__Y_MASK        = 0xffff0000L;
constexpr unsigned int PA_SC_SCREEN_EXTENT_MAX_1__X_MASK        = 0x0000ffffL;
constexpr unsigned int PA_SC_SCREEN_EXTENT_MAX_1__Y_MASK        = 0xffff0000L;
constexpr unsigned int PA_SC_SCREEN_EXTENT_MIN_0__X_MASK        = 0x0000ffffL;
constexpr unsigned int PA_SC_SCREEN_EXTENT_MIN_0__Y_MASK        = 0xffff0000L;
constexpr unsigned int PA_SC_SCREEN_EXTENT_MIN_1__X_MASK        = 0x0000ffffL;
constexpr unsigned int PA_SC_SCREEN_EXTENT_MIN_1__Y_MASK        = 0xffff0000L;
constexpr unsigned int PA_SC_SCREEN_SCISSOR_BR__BR_X_MASK       = 0x0000ffffL;
constexpr unsigned int PA_SC_SCREEN_SCISSOR_BR__BR_Y_MASK       = 0xffff0000L;
constexpr unsigned int PA_SC_SCREEN_SCISSOR_TL__TL_X_MASK       = 0x0000ffffL;
constexpr unsigned int PA_SC_SCREEN_SCISSOR_TL__TL_Y_MASK       = 0xffff0000L;
constexpr unsigned int PA_SC_SHADER_CONTROL__LOAD_COLLISION_WAVEID_MASK = 0x00000004L;
constexpr unsigned int PA_SC_SHADER_CONTROL__LOAD_INTRAWAVE_COLLISION_MASK = 0x00000008L;
constexpr unsigned int PA_SC_SHADER_CONTROL__REALIGN_DQUADS_AFTER_N_WAVES_MASK = 0x00000003L;
constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__ONE_RB_MODE_ENABLE_MASK = 0x00000001L;
constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__RB_SELECT_MASK = 0x00000060L;
constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__SE_SELECT_MASK = 0x00000006L;
constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__ENABLE_MASK = 0x00000001L;
constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__NUM_RB_PER_SE_MASK = 0x00000060L;
constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__NUM_SE_MASK = 0x00000006L;
constexpr unsigned int PA_SC_TRAP_SCREEN_COUNT__COUNT_MASK      = 0x0000ffffL;
constexpr unsigned int PA_SC_TRAP_SCREEN_HV_EN__ENABLE_HV_PRE_SHADER_MASK = 0x00000001L;
constexpr unsigned int PA_SC_TRAP_SCREEN_HV_EN__FORCE_PRE_SHADER_ALL_PIXELS_MASK = 0x00000002L;
constexpr unsigned int PA_SC_TRAP_SCREEN_HV_LOCK__DISABLE_NON_PRIV_WRITES_MASK = 0x00000001L;
constexpr unsigned int PA_SC_TRAP_SCREEN_H__X_COORD_MASK        = 0x00003fffL;
constexpr unsigned int PA_SC_TRAP_SCREEN_OCCURRENCE__COUNT_MASK = 0x0000ffffL;
constexpr unsigned int PA_SC_TRAP_SCREEN_V__Y_COORD_MASK        = 0x00003fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_0_BR__BR_X_MASK      = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_0_BR__BR_Y_MASK      = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_0_TL__TL_X_MASK      = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_0_TL__TL_Y_MASK      = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_0_TL__WINDOW_OFFSET_DISABLE_MASK = 0x80000000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_1_BR__BR_X_MASK      = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_1_BR__BR_Y_MASK      = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_1_TL__TL_X_MASK      = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_1_TL__TL_Y_MASK      = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_1_TL__WINDOW_OFFSET_DISABLE_MASK = 0x80000000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_2_BR__BR_X_MASK      = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_2_BR__BR_Y_MASK      = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_2_TL__TL_X_MASK      = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_2_TL__TL_Y_MASK      = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_2_TL__WINDOW_OFFSET_DISABLE_MASK = 0x80000000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_3_BR__BR_X_MASK      = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_3_BR__BR_Y_MASK      = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_3_TL__TL_X_MASK      = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_3_TL__TL_Y_MASK      = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_3_TL__WINDOW_OFFSET_DISABLE_MASK = 0x80000000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_4_BR__BR_X_MASK      = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_4_BR__BR_Y_MASK      = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_4_TL__TL_X_MASK      = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_4_TL__TL_Y_MASK      = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_4_TL__WINDOW_OFFSET_DISABLE_MASK = 0x80000000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_5_BR__BR_X_MASK      = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_5_BR__BR_Y_MASK      = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_5_TL__TL_X_MASK      = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_5_TL__TL_Y_MASK      = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_5_TL__WINDOW_OFFSET_DISABLE_MASK = 0x80000000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_6_BR__BR_X_MASK      = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_6_BR__BR_Y_MASK      = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_6_TL__TL_X_MASK      = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_6_TL__TL_Y_MASK      = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_6_TL__WINDOW_OFFSET_DISABLE_MASK = 0x80000000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_7_BR__BR_X_MASK      = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_7_BR__BR_Y_MASK      = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_7_TL__TL_X_MASK      = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_7_TL__TL_Y_MASK      = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_7_TL__WINDOW_OFFSET_DISABLE_MASK = 0x80000000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_8_BR__BR_X_MASK      = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_8_BR__BR_Y_MASK      = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_8_TL__TL_X_MASK      = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_8_TL__TL_Y_MASK      = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_8_TL__WINDOW_OFFSET_DISABLE_MASK = 0x80000000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_9_BR__BR_X_MASK      = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_9_BR__BR_Y_MASK      = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_9_TL__TL_X_MASK      = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_9_TL__TL_Y_MASK      = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_9_TL__WINDOW_OFFSET_DISABLE_MASK = 0x80000000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_10_BR__BR_X_MASK     = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_10_BR__BR_Y_MASK     = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_10_TL__TL_X_MASK     = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_10_TL__TL_Y_MASK     = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_10_TL__WINDOW_OFFSET_DISABLE_MASK = 0x80000000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_11_BR__BR_X_MASK     = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_11_BR__BR_Y_MASK     = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_11_TL__TL_X_MASK     = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_11_TL__TL_Y_MASK     = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_11_TL__WINDOW_OFFSET_DISABLE_MASK = 0x80000000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_12_BR__BR_X_MASK     = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_12_BR__BR_Y_MASK     = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_12_TL__TL_X_MASK     = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_12_TL__TL_Y_MASK     = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_12_TL__WINDOW_OFFSET_DISABLE_MASK = 0x80000000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_13_BR__BR_X_MASK     = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_13_BR__BR_Y_MASK     = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_13_TL__TL_X_MASK     = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_13_TL__TL_Y_MASK     = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_13_TL__WINDOW_OFFSET_DISABLE_MASK = 0x80000000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_14_BR__BR_X_MASK     = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_14_BR__BR_Y_MASK     = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_14_TL__TL_X_MASK     = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_14_TL__TL_Y_MASK     = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_14_TL__WINDOW_OFFSET_DISABLE_MASK = 0x80000000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_15_BR__BR_X_MASK     = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_15_BR__BR_Y_MASK     = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_15_TL__TL_X_MASK     = 0x00007fffL;
constexpr unsigned int PA_SC_VPORT_SCISSOR_15_TL__TL_Y_MASK     = 0x7fff0000L;
constexpr unsigned int PA_SC_VPORT_SCISSOR_15_TL__WINDOW_OFFSET_DISABLE_MASK = 0x80000000L;
constexpr unsigned int PA_SC_VPORT_ZMAX_0__VPORT_ZMAX_MASK      = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMAX_1__VPORT_ZMAX_MASK      = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMAX_2__VPORT_ZMAX_MASK      = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMAX_3__VPORT_ZMAX_MASK      = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMAX_4__VPORT_ZMAX_MASK      = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMAX_5__VPORT_ZMAX_MASK      = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMAX_6__VPORT_ZMAX_MASK      = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMAX_7__VPORT_ZMAX_MASK      = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMAX_8__VPORT_ZMAX_MASK      = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMAX_9__VPORT_ZMAX_MASK      = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMAX_10__VPORT_ZMAX_MASK     = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMAX_11__VPORT_ZMAX_MASK     = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMAX_12__VPORT_ZMAX_MASK     = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMAX_13__VPORT_ZMAX_MASK     = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMAX_14__VPORT_ZMAX_MASK     = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMAX_15__VPORT_ZMAX_MASK     = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMIN_0__VPORT_ZMIN_MASK      = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMIN_1__VPORT_ZMIN_MASK      = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMIN_2__VPORT_ZMIN_MASK      = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMIN_3__VPORT_ZMIN_MASK      = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMIN_4__VPORT_ZMIN_MASK      = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMIN_5__VPORT_ZMIN_MASK      = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMIN_6__VPORT_ZMIN_MASK      = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMIN_7__VPORT_ZMIN_MASK      = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMIN_8__VPORT_ZMIN_MASK      = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMIN_9__VPORT_ZMIN_MASK      = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMIN_10__VPORT_ZMIN_MASK     = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMIN_11__VPORT_ZMIN_MASK     = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMIN_12__VPORT_ZMIN_MASK     = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMIN_13__VPORT_ZMIN_MASK     = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMIN_14__VPORT_ZMIN_MASK     = 0xffffffffL;
constexpr unsigned int PA_SC_VPORT_ZMIN_15__VPORT_ZMIN_MASK     = 0xffffffffL;
constexpr unsigned int PA_SC_WINDOW_OFFSET__WINDOW_X_OFFSET_MASK = 0x0000ffffL;
constexpr unsigned int PA_SC_WINDOW_OFFSET__WINDOW_Y_OFFSET_MASK = 0xffff0000L;
constexpr unsigned int PA_SC_WINDOW_SCISSOR_BR__BR_X_MASK       = 0x00007fffL;
constexpr unsigned int PA_SC_WINDOW_SCISSOR_BR__BR_Y_MASK       = 0x7fff0000L;
constexpr unsigned int PA_SC_WINDOW_SCISSOR_TL__TL_X_MASK       = 0x00007fffL;
constexpr unsigned int PA_SC_WINDOW_SCISSOR_TL__TL_Y_MASK       = 0x7fff0000L;
constexpr unsigned int PA_SC_WINDOW_SCISSOR_TL__WINDOW_OFFSET_DISABLE_MASK = 0x80000000L;
constexpr unsigned int PA_SIDEBAND_REQUEST_DELAYS__INITIAL_DELAY_MASK = 0xffff0000L;
constexpr unsigned int PA_SIDEBAND_REQUEST_DELAYS__RETRY_DELAY_MASK = 0x0000ffffL;
constexpr unsigned int PA_SU_CNTL_STATUS__SU_BUSY_MASK          = 0x80000000L;
constexpr unsigned int PA_SU_DEBUG_DATA__DATA_MASK              = 0xffffffffL;
constexpr unsigned int PA_SU_HARDWARE_SCREEN_OFFSET__HW_SCREEN_OFFSET_X_MASK = 0x000001ffL;
constexpr unsigned int PA_SU_HARDWARE_SCREEN_OFFSET__HW_SCREEN_OFFSET_Y_MASK = 0x01ff0000L;
constexpr unsigned int PA_SU_LINE_CNTL__WIDTH_MASK              = 0x0000ffffL;
constexpr unsigned int PA_SU_LINE_STIPPLE_CNTL__DIAMOND_ADJUST_MASK = 0x00000010L;
constexpr unsigned int PA_SU_LINE_STIPPLE_CNTL__EXPAND_FULL_LENGTH_MASK = 0x00000004L;
constexpr unsigned int PA_SU_LINE_STIPPLE_CNTL__FRACTIONAL_ACCUM_MASK = 0x00000008L;
constexpr unsigned int PA_SU_LINE_STIPPLE_CNTL__LINE_STIPPLE_RESET_MASK = 0x00000003L;
constexpr unsigned int PA_SU_LINE_STIPPLE_SCALE__LINE_STIPPLE_SCALE_MASK = 0xffffffffL;
constexpr unsigned int PA_SU_LINE_STIPPLE_VALUE__LINE_STIPPLE_VALUE_MASK = 0x00ffffffL;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__DISCARD_0_AREA_LINES_MASK = 0x00000002L;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__DISCARD_0_AREA_POINTS_MASK = 0x00000004L;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__DISCARD_0_AREA_RECTANGLES_MASK = 0x00000008L;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__DISCARD_0_AREA_TRIANGLES_MASK = 0x00000001L;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__USE_PROVOKING_ZW_MASK = 0x00000010L;
constexpr unsigned int PA_SU_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__CNTR_MODE_MASK = 0x00f00000L;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__PERF_SEL1_MASK = 0x000ffc00L;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__PERF_SEL_MASK = 0x000003ffL;
constexpr unsigned int PA_SU_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__CNTR_MODE_MASK = 0x00f00000L;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__PERF_SEL1_MASK = 0x000ffc00L;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__PERF_SEL_MASK = 0x000003ffL;
constexpr unsigned int PA_SU_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__CNTR_MODE_MASK = 0x00f00000L;
constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__PERF_SEL_MASK = 0x000003ffL;
constexpr unsigned int PA_SU_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__CNTR_MODE_MASK = 0x00f00000L;
constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__PERF_SEL_MASK = 0x000003ffL;
constexpr unsigned int PA_SU_POINT_MINMAX__MAX_SIZE_MASK        = 0xffff0000L;
constexpr unsigned int PA_SU_POINT_MINMAX__MIN_SIZE_MASK        = 0x0000ffffL;
constexpr unsigned int PA_SU_POINT_SIZE__HEIGHT_MASK            = 0x0000ffffL;
constexpr unsigned int PA_SU_POINT_SIZE__WIDTH_MASK             = 0xffff0000L;
constexpr unsigned int PA_SU_POLY_OFFSET_BACK_OFFSET__OFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_SU_POLY_OFFSET_BACK_SCALE__SCALE_MASK = 0xffffffffL;
constexpr unsigned int PA_SU_POLY_OFFSET_CLAMP__CLAMP_MASK      = 0xffffffffL;
constexpr unsigned int PA_SU_POLY_OFFSET_DB_FMT_CNTL__POLY_OFFSET_DB_IS_FLOAT_FMT_MASK = 0x00000100L;
constexpr unsigned int PA_SU_POLY_OFFSET_DB_FMT_CNTL__POLY_OFFSET_NEG_NUM_DB_BITS_MASK = 0x000000ffL;
constexpr unsigned int PA_SU_POLY_OFFSET_FRONT_OFFSET__OFFSET_MASK = 0xffffffffL;
constexpr unsigned int PA_SU_POLY_OFFSET_FRONT_SCALE__SCALE_MASK = 0xffffffffL;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__LINE_EXPAND_ENA_MASK = 0x00000020L;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__LINE_FILTER_DISABLE_MASK = 0x00000002L;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__POINT_EXPAND_ENA_MASK = 0x00000040L;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__POINT_FILTER_DISABLE_MASK = 0x00000004L;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__PRIM_EXPAND_CONSTANT_MASK = 0x0000ff00L;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__RECTANGLE_EXPAND_ENA_MASK = 0x00000080L;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__RECTANGLE_FILTER_DISABLE_MASK = 0x00000008L;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__TRIANGLE_EXPAND_ENA_MASK = 0x00000010L;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__TRIANGLE_FILTER_DISABLE_MASK = 0x00000001L;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__XMAX_RIGHT_EXCLUSION_MASK = 0x40000000L;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__YMAX_BOTTOM_EXCLUSION_MASK = 0x80000000L;
constexpr unsigned int PA_SU_SC_MODE_CNTL__CULL_BACK_MASK       = 0x00000002L;
constexpr unsigned int PA_SU_SC_MODE_CNTL__CULL_FRONT_MASK      = 0x00000001L;
constexpr unsigned int PA_SU_SC_MODE_CNTL__FACE_MASK            = 0x00000004L;
constexpr unsigned int PA_SU_SC_MODE_CNTL__MULTI_PRIM_IB_ENA_MASK = 0x00200000L;
constexpr unsigned int PA_SU_SC_MODE_CNTL__NEW_QUAD_DECOMPOSITION_MASK = 0x00800000L;
constexpr unsigned int PA_SU_SC_MODE_CNTL__PERSP_CORR_DIS_MASK  = 0x00100000L;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLYMODE_BACK_PTYPE_MASK = 0x00000700L;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLYMODE_FRONT_PTYPE_MASK = 0x000000e0L;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLY_MODE_MASK       = 0x00000018L;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLY_OFFSET_BACK_ENABLE_MASK = 0x00001000L;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLY_OFFSET_FRONT_ENABLE_MASK = 0x00000800L;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLY_OFFSET_PARA_ENABLE_MASK = 0x00002000L;
constexpr unsigned int PA_SU_SC_MODE_CNTL__PROVOKING_VTX_LAST_MASK = 0x00080000L;
constexpr unsigned int PA_SU_SC_MODE_CNTL__RIGHT_TRIANGLE_ALTERNATE_GRADIENT_REF_MASK = 0x00400000L;
constexpr unsigned int PA_SU_SC_MODE_CNTL__VTX_WINDOW_OFFSET_ENABLE_MASK = 0x00010000L;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__LINE_FILTER_DISABLE_MASK = 0x00000004L;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__POINT_FILTER_DISABLE_MASK = 0x00000008L;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__RECTANGLE_FILTER_DISABLE_MASK = 0x00000010L;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__SMALL_PRIM_FILTER_ENABLE_MASK = 0x00000001L;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__TRIANGLE_FILTER_DISABLE_MASK = 0x00000002L;
constexpr unsigned int PA_SU_VTX_CNTL__PIX_CENTER_MASK          = 0x00000001L;
constexpr unsigned int PA_SU_VTX_CNTL__QUANT_MODE_MASK          = 0x00000038L;
constexpr unsigned int PA_SU_VTX_CNTL__ROUND_MODE_MASK          = 0x00000006L;
constexpr unsigned int port_a_addr__Index_MASK                  = 0x000000ffL;
constexpr unsigned int port_a_addr__ReadEnable_MASK             = 0x80000000L;
constexpr unsigned int port_a_addr__Reserved_MASK               = 0x7fffff00L;
constexpr unsigned int port_a_data_hi__Data_MASK                = 0xffffffffL;
constexpr unsigned int port_a_data_lo__Data_MASK                = 0xffffffffL;
constexpr unsigned int port_b_addr__Index_MASK                  = 0x000000ffL;
constexpr unsigned int port_b_addr__ReadEnable_MASK             = 0x80000000L;
constexpr unsigned int port_b_addr__Reserved_MASK               = 0x7fffff00L;
constexpr unsigned int port_b_data_hi__Data_MASK                = 0xffffffffL;
constexpr unsigned int port_b_data_lo__Data_MASK                = 0xffffffffL;
constexpr unsigned int port_c_addr__Index_MASK                  = 0x000000ffL;
constexpr unsigned int port_c_addr__ReadEnable_MASK             = 0x80000000L;
constexpr unsigned int port_c_addr__Reserved_MASK               = 0x7fffff00L;
constexpr unsigned int port_c_data_hi__Data_MASK                = 0xffffffffL;
constexpr unsigned int port_c_data_lo__Data_MASK                = 0xffffffffL;
constexpr unsigned int port_d_addr__Index_MASK                  = 0x000000ffL;
constexpr unsigned int port_d_addr__ReadEnable_MASK             = 0x80000000L;
constexpr unsigned int port_d_addr__Reserved_MASK               = 0x7fffff00L;
constexpr unsigned int port_d_data_hi__Data_MASK                = 0xffffffffL;
constexpr unsigned int port_d_data_lo__Data_MASK                = 0xffffffffL;
constexpr unsigned int RLC_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int RLC_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int RLC_PERFCOUNTER0_SELECT__PERFCOUNTER_SELECT_MASK = 0x000000ffL;
constexpr unsigned int RLC_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int RLC_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int RLC_PERFCOUNTER1_SELECT__PERFCOUNTER_SELECT_MASK = 0x000000ffL;
constexpr unsigned int RLC_PERFMON_CLK_CNTL__PERFMON_CLOCK_STATE_MASK = 0x00000001L;
constexpr unsigned int RLC_PERFMON_CNTL__PERFMON_SAMPLE_ENABLE_MASK = 0x00000400L;
constexpr unsigned int RLC_PERFMON_CNTL__PERFMON_STATE_MASK     = 0x00000007L;
constexpr unsigned int RLC_SPM_DEBUG_SELECT__SELECT_MASK        = 0x000000ffL;
constexpr unsigned int RLC_SPM_GLOBAL_MUXSEL_DATA__PERFMON_SEL_DATA_MASK = 0xffffffffL;
constexpr unsigned int RLC_SPM_INT_CNTL__RESERVED_MASK          = 0xfffffffeL;
constexpr unsigned int RLC_SPM_INT_CNTL__RLC_SPM_INT_CNTL_MASK  = 0x00000001L;
constexpr unsigned int RLC_SPM_INT_STATUS__RESERVED_MASK        = 0xfffffffeL;
constexpr unsigned int RLC_SPM_INT_STATUS__RLC_SPM_INT_STATUS_MASK = 0x00000001L;
constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_VMID_MASK       = 0x0000000fL;
constexpr unsigned int RLC_SPM_PERFMON_CNTL__PERFMON_RING_MODE_MASK = 0x00003000L;
constexpr unsigned int RLC_SPM_PERFMON_CNTL__PERFMON_SAMPLE_INTERVAL_MASK = 0xffff0000L;
constexpr unsigned int RLC_SPM_PERFMON_CNTL__RESERVED_MASK      = 0x0000c000L;
constexpr unsigned int RLC_SPM_PERFMON_RING_BASE_HI__RESERVED_MASK = 0xffff0000L;
constexpr unsigned int RLC_SPM_PERFMON_RING_BASE_HI__RING_BASE_HI_MASK = 0x0000ffffL;
constexpr unsigned int RLC_SPM_PERFMON_RING_BASE_LO__RING_BASE_LO_MASK = 0xffffffffL;
constexpr unsigned int RLC_SPM_PERFMON_RING_SIZE__RING_BASE_SIZE_MASK = 0xffffffffL;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__GLOBAL_NUM_LINE_MASK = 0x0000f800L;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__PERFMON_SEGMENT_SIZE_MASK = 0x000000ffL;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__RESERVED1_MASK = 0x00000700L;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__RESERVED_MASK = 0x80000000L;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__SE0_NUM_LINE_MASK = 0x001f0000L;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__SE1_NUM_LINE_MASK = 0x03e00000L;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__SE2_NUM_LINE_MASK = 0x7c000000L;
constexpr unsigned int RLC_SPM_RING_RDPTR__PERFMON_RING_RDPTR_MASK = 0xffffffffL;
constexpr unsigned int RLC_SPM_SE_MUXSEL_DATA__PERFMON_SEL_DATA_MASK = 0xffffffffL;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__BYPASS_MASK          = 0x02000000L;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__DROP_MODE_MASK       = 0x01000000L;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__FORCE_SNOOP_MASK     = 0x10000000L;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__FRAG_LIMIT_MODE_MASK = 0x08000000L;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__INVALIDATE_MASK      = 0x04000000L;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__RESERVED_MASK        = 0xc0000000L;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__XNACK_REDO_TIMER_CNT_MASK = 0x000fffffL;
constexpr unsigned int RLC_SPM_UTCL1_ERROR_1__Translated_ReqErrorAddr_MSB_MASK = 0x000003c0L;
constexpr unsigned int RLC_SPM_UTCL1_ERROR_1__Translated_ReqErrorVmid_MASK = 0x0000003cL;
constexpr unsigned int RLC_SPM_UTCL1_ERROR_1__Translated_ReqError_MASK = 0x00000003L;
constexpr unsigned int RLC_SPM_UTCL1_ERROR_2__Translated_ReqErrorAddr_LSB_MASK = 0xffffffffL;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__OFF_HYSTERESIS_MASK  = 0x00000ff0L;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__ON_DELAY_MASK        = 0x0000000fL;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_OVERRIDE0_MASK  = 0x80000000L;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_OVERRIDE1_MASK  = 0x40000000L;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_OVERRIDE2_MASK  = 0x20000000L;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_OVERRIDE3_MASK  = 0x10000000L;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_OVERRIDE4_MASK  = 0x08000000L;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_OVERRIDE5_MASK  = 0x04000000L;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_OVERRIDE6_MASK  = 0x02000000L;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE0_MASK = 0x00800000L;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE1_MASK = 0x00400000L;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE2_MASK = 0x00200000L;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE3_MASK = 0x00100000L;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE4_MASK = 0x00080000L;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE5_MASK = 0x00040000L;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE6_MASK = 0x00020000L;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE7_MASK = 0x00010000L;
constexpr unsigned int RMI_CLOCK_CNTRL__DYN_CLK_CMN_BUSY_MASK_MASK = 0x000003e0L;
constexpr unsigned int RMI_CLOCK_CNTRL__DYN_CLK_CMN_WAKEUP_MASK_MASK = 0x000f8000L;
constexpr unsigned int RMI_CLOCK_CNTRL__DYN_CLK_RB0_BUSY_MASK_MASK = 0x0000001fL;
constexpr unsigned int RMI_CLOCK_CNTRL__DYN_CLK_RB0_WAKEUP_MASK_MASK = 0x00007c00L;
constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB0_BREAK_LOB_ON_IDLEIN_MASK = 0x00000002L;
constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB0_MODE_MASK     = 0x0000c000L;
constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB0_STALL_MASK    = 0x00000001L;
constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB0_STALL_TIMER_OVERRIDE_MASK = 0x00000030L;
constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB0_STALL_TIMER_START_VALUE_MASK = 0x00003fc0L;
constexpr unsigned int RMI_GENERAL_CNTL1__EARLY_WRACK_DISABLE_FOR_LOOPBACK_MASK = 0x00000100L;
constexpr unsigned int RMI_GENERAL_CNTL1__EARLY_WRACK_ENABLE_PER_MTYPE_MASK = 0x0000000fL;
constexpr unsigned int RMI_GENERAL_CNTL1__TCIW0_64B_RD_STALL_MODE_MASK = 0x00000030L;
constexpr unsigned int RMI_GENERAL_CNTL__BURST_DISABLE_MASK     = 0x00000001L;
constexpr unsigned int RMI_GENERAL_CNTL__LOOPBACK_DIS_BY_REQ_TYPE_MASK = 0x01e00000L;
constexpr unsigned int RMI_GENERAL_CNTL__RB0_HARVEST_EN_MASK    = 0x00080000L;
constexpr unsigned int RMI_GENERAL_CNTL__SKID_FIFO_0_OVERFLOW_ERROR_MASK_MASK = 0x04000000L;
constexpr unsigned int RMI_GENERAL_CNTL__SKID_FIFO_0_UNDERFLOW_ERROR_MASK_MASK = 0x08000000L;
constexpr unsigned int RMI_GENERAL_CNTL__SKID_FIFO_FREESPACE_IS_ZERO_ERROR_MASK_MASK = 0x40000000L;
constexpr unsigned int RMI_GENERAL_CNTL__VMID_BYPASS_ENABLE_MASK = 0x0001fffeL;
constexpr unsigned int RMI_GENERAL_CNTL__XBAR_MUX_CONFIG_MASK   = 0x00060000L;
constexpr unsigned int RMI_GENERAL_CNTL__XBAR_MUX_CONFIG_UPDATE_MASK = 0x02000000L;
constexpr unsigned int RMI_GENERAL_STATUS__GENERAL_RMI_ERRORS_COMBINED_MASK = 0x00000001L;
constexpr unsigned int RMI_GENERAL_STATUS__RDREQ_CONSUMER_FIFO_0_BUSY_MASK = 0x00001000L;
constexpr unsigned int RMI_GENERAL_STATUS__RMI_SCOREBOARD_BUSY_MASK = 0x00000080L;
constexpr unsigned int RMI_GENERAL_STATUS__RMI_UTCL1_BUSY_MASK  = 0x00000040L;
constexpr unsigned int RMI_GENERAL_STATUS__RMI_XBAR_BUSY_MASK   = 0x00000020L;
constexpr unsigned int RMI_GENERAL_STATUS__RMI_XNACK_BUSY_MASK  = 0x00100000L;
constexpr unsigned int RMI_GENERAL_STATUS__SKID_FIFO_0_OVERFLOW_ERROR_MASK = 0x00000002L;
constexpr unsigned int RMI_GENERAL_STATUS__SKID_FIFO_0_UNDERFLOW_ERROR_MASK = 0x00000004L;
constexpr unsigned int RMI_GENERAL_STATUS__SKID_FIFO_FREESPACE_IS_ZERO_ERROR_MASK = 0x80000000L;
constexpr unsigned int RMI_GENERAL_STATUS__TCIW0_PRT_FIFO_BUSY_MASK = 0x00000100L;
constexpr unsigned int RMI_GENERAL_STATUS__TCIW_FRMTR0_BUSY_MASK = 0x00000200L;
constexpr unsigned int RMI_GENERAL_STATUS__TCIW_RTN_FRMTR0_BUSY_MASK = 0x00000400L;
constexpr unsigned int RMI_GENERAL_STATUS__UTC_PROBE0_BUSY_MASK = 0x00080000L;
constexpr unsigned int RMI_GENERAL_STATUS__WRREQ_CONSUMER_FIFO_0_BUSY_MASK = 0x00000800L;
constexpr unsigned int RMI_GENERAL_STATUS__XNACK_FIFO_EMPTY_MASK = 0x20000000L;
constexpr unsigned int RMI_GENERAL_STATUS__XNACK_FIFO_FULL_MASK = 0x40000000L;
constexpr unsigned int RMI_GENERAL_STATUS__XNACK_FIFO_NUM_USED_MASK = 0x1fe00000L;
constexpr unsigned int RMI_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int RMI_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK = 0x000001ffL;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK = 0x0007fc00L;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__PERF_MODE1_MASK = 0x0f000000L;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__PERF_MODE_MASK  = 0xf0000000L;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__PERF_SEL1_MASK  = 0x0007fc00L;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__PERF_SEL_MASK   = 0x000001ffL;
constexpr unsigned int RMI_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int RMI_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int RMI_PERFCOUNTER1_SELECT__PERF_MODE_MASK  = 0xf0000000L;
constexpr unsigned int RMI_PERFCOUNTER1_SELECT__PERF_SEL_MASK   = 0x000001ffL;
constexpr unsigned int RMI_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int RMI_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK = 0x000001ffL;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK = 0x0007fc00L;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__PERF_MODE1_MASK = 0x0f000000L;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__PERF_MODE_MASK  = 0xf0000000L;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__PERF_SEL1_MASK  = 0x0007fc00L;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__PERF_SEL_MASK   = 0x000001ffL;
constexpr unsigned int RMI_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int RMI_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int RMI_PERFCOUNTER3_SELECT__PERF_MODE_MASK  = 0xf0000000L;
constexpr unsigned int RMI_PERFCOUNTER3_SELECT__PERF_SEL_MASK   = 0x000001ffL;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__EVENT_BASED_PERF_EN_SEL_MASK = 0x0000000cL;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_CNTR_SPM_SEL_MASK = 0x04000000L;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_COUNTER_BURST_LENGTH_THRESHOLD_MASK = 0x01f80000L;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_COUNTER_CID_MASK = 0x00003c00L;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_COUNTER_VMID_MASK = 0x0007c000L;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_EVENT_WINDOW_MASK0_MASK = 0x000000c0L;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_SOFT_RESET_MASK = 0x02000000L;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__TC_PERF_EN_SEL_MASK = 0x00000030L;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__TRANS_BASED_PERF_EN_SEL_MASK = 0x00000003L;
constexpr unsigned int RMI_PROBE_POP_LOGIC_CNTL__EXT_LAT_FIFO_0_MAX_DEPTH_MASK = 0x0000007fL;
constexpr unsigned int RMI_PROBE_POP_LOGIC_CNTL__REDUCE_MAX_XLAT_CHAIN_SIZE_BY_2_MASK = 0x00000300L;
constexpr unsigned int RMI_PROBE_POP_LOGIC_CNTL__XLAT_COMBINE0_DIS_MASK = 0x00000080L;
constexpr unsigned int RMI_SCOREBOARD_CNTL__COMPLETE_RB0_FLUSH_MASK = 0x00000001L;
constexpr unsigned int RMI_SCOREBOARD_CNTL__FORCE_VMID_INVAL_DONE_EN_MASK = 0x00000100L;
constexpr unsigned int RMI_SCOREBOARD_CNTL__FORCE_VMID_INVAL_DONE_TIMER_START_VALUE_MASK = 0x001ffe00L;
constexpr unsigned int RMI_SCOREBOARD_CNTL__REQ_IN_RE_EN_AFTER_FLUSH_RB0_MASK = 0x00000002L;
constexpr unsigned int RMI_SCOREBOARD_CNTL__TIME_STAMP_FLUSH_RB0_MASK = 0x00000080L;
constexpr unsigned int RMI_SCOREBOARD_CNTL__VMID_INVAL_FLUSH_TYPE_OVERRIDE_EN_MASK = 0x00000020L;
constexpr unsigned int RMI_SCOREBOARD_CNTL__VMID_INVAL_FLUSH_TYPE_OVERRIDE_VALUE_MASK = 0x00000040L;
constexpr unsigned int RMI_SCOREBOARD_STATUS0__CP_VMID_INV_DONE_MASK = 0x00080000L;
constexpr unsigned int RMI_SCOREBOARD_STATUS0__CP_VMID_INV_FLUSH_TYPE_MASK = 0x00100000L;
constexpr unsigned int RMI_SCOREBOARD_STATUS0__CP_VMID_INV_IN_PROG_MASK = 0x00000002L;
constexpr unsigned int RMI_SCOREBOARD_STATUS0__CP_VMID_INV_REQ_VMID_MASK = 0x0003fffcL;
constexpr unsigned int RMI_SCOREBOARD_STATUS0__CP_VMID_INV_UTC_DONE_MASK = 0x00040000L;
constexpr unsigned int RMI_SCOREBOARD_STATUS0__CURRENT_SESSION_ID_MASK = 0x00000001L;
constexpr unsigned int RMI_SCOREBOARD_STATUS0__FORCE_VMID_INV_DONE_MASK = 0x00200000L;
constexpr unsigned int RMI_SCOREBOARD_STATUS1__COM_FLUSH_IN_PROG_RB0_MASK = 0x40000000L;
constexpr unsigned int RMI_SCOREBOARD_STATUS1__MULTI_VMID_INVAL_FROM_CP_DETECTED_MASK = 0x00004000L;
constexpr unsigned int RMI_SCOREBOARD_STATUS1__RUNNING_CNT_OVERFLOW_RB0_MASK = 0x00002000L;
constexpr unsigned int RMI_SCOREBOARD_STATUS1__RUNNING_CNT_RB0_MASK = 0x00000fffL;
constexpr unsigned int RMI_SCOREBOARD_STATUS1__RUNNING_CNT_UNDERFLOW_RB0_MASK = 0x00001000L;
constexpr unsigned int RMI_SCOREBOARD_STATUS2__COM_FLUSH_DONE_RB0_MASK = 0x08000000L;
constexpr unsigned int RMI_SCOREBOARD_STATUS2__SNAPSHOT_CNT_RB0_MASK = 0x00000fffL;
constexpr unsigned int RMI_SCOREBOARD_STATUS2__SNAPSHOT_CNT_UNDERFLOW_RB0_MASK = 0x00001000L;
constexpr unsigned int RMI_SCOREBOARD_STATUS2__TIME_STAMP_FLUSH_DONE_RB0_MASK = 0x40000000L;
constexpr unsigned int RMI_SCOREBOARD_STATUS2__TIME_STAMP_FLUSH_IN_PROG_RB0_MASK = 0x10000000L;
constexpr unsigned int RMI_SPARE_1__SPARE_BIT_9_MASK            = 0x00000002L;
constexpr unsigned int RMI_SPARE_1__SPARE_BIT_10_MASK           = 0x00000004L;
constexpr unsigned int RMI_SPARE_1__SPARE_BIT_11_MASK           = 0x00000008L;
constexpr unsigned int RMI_SPARE_1__SPARE_BIT_12_MASK           = 0x00000010L;
constexpr unsigned int RMI_SPARE_1__SPARE_BIT_13_MASK           = 0x00000020L;
constexpr unsigned int RMI_SPARE_1__SPARE_BIT_14_MASK           = 0x00000040L;
constexpr unsigned int RMI_SPARE_1__SPARE_BIT_15_MASK           = 0x00000080L;
constexpr unsigned int RMI_SPARE_1__SPARE_BIT_16_1_MASK         = 0xffff0000L;
constexpr unsigned int RMI_SPARE_2__SPARE_BIT_8_2_MASK          = 0x00ff0000L;
constexpr unsigned int RMI_SPARE_2__SPARE_BIT_8_3_MASK          = 0xff000000L;
constexpr unsigned int RMI_SPARE__RMI_ARBITER_STALL_TIMER_ENABLED_ALLOW_STREAMING_MASK = 0x00000001L;
constexpr unsigned int RMI_SPARE__SPARE_BIT_7_MASK              = 0x00000080L;
constexpr unsigned int RMI_SUBBLOCK_STATUS0__TCIW0_INFLIGHT_CNT_MASK = 0x0ffc0000L;
constexpr unsigned int RMI_SUBBLOCK_STATUS0__UTC_EXT_LAT_HID_FIFO_EMPTY_PROBE0_MASK = 0x00000100L;
constexpr unsigned int RMI_SUBBLOCK_STATUS0__UTC_EXT_LAT_HID_FIFO_FULL_PROBE0_MASK = 0x00000080L;
constexpr unsigned int RMI_SUBBLOCK_STATUS0__UTC_EXT_LAT_HID_FIFO_NUM_USED_PROBE0_MASK = 0x0000007fL;
constexpr unsigned int RMI_SUBBLOCK_STATUS1__SKID_FIFO_0_FREE_SPACE_MASK = 0x000003ffL;
constexpr unsigned int RMI_SUBBLOCK_STATUS2__PRT_FIFO_0_NUM_USED_MASK = 0x000001ffL;
constexpr unsigned int RMI_SUBBLOCK_STATUS3__SKID_FIFO_0_FREE_SPACE_TOTAL_MASK = 0x000003ffL;
constexpr unsigned int RMI_TCIW_FORMATTER0_CNTL__ALL_FAULT_RET0_DATA_MASK = 0x80000000L;
constexpr unsigned int RMI_TCIW_FORMATTER0_CNTL__RMI_IN0_REORDER_DIS_MASK = 0x20000000L;
constexpr unsigned int RMI_TCIW_FORMATTER0_CNTL__SKID_FIFO_0_FREE_SPACE_DELTA_MASK = 0x07f80000L;
constexpr unsigned int RMI_TCIW_FORMATTER0_CNTL__SKID_FIFO_0_FREE_SPACE_DELTA_UPDATE_MASK = 0x08000000L;
constexpr unsigned int RMI_TCIW_FORMATTER0_CNTL__TCIW0_MAX_ALLOWED_INFLIGHT_REQ_MASK = 0x0007fe00L;
constexpr unsigned int RMI_TCIW_FORMATTER0_CNTL__TCIW0_REQ_SAFE_MODE_MASK = 0x10000000L;
constexpr unsigned int RMI_TCIW_FORMATTER0_CNTL__WR_COMBINE0_DIS_AT_LAST_OF_BURST_MASK = 0x40000000L;
constexpr unsigned int RMI_TCIW_FORMATTER0_CNTL__WR_COMBINE0_DIS_OVERRIDE_MASK = 0x00000001L;
constexpr unsigned int RMI_TCIW_FORMATTER0_CNTL__WR_COMBINE0_TIME_OUT_WINDOW_MASK = 0x000001feL;
constexpr unsigned int RMI_UTCL1_CNTL1__CLIENTID_MASK           = 0x0000ff80L;
constexpr unsigned int RMI_UTCL1_CNTL1__CLIENT_INVALIDATE_ALL_VMID_MASK = 0x02000000L;
constexpr unsigned int RMI_UTCL1_CNTL1__ENABLE_LFIFO_PRI_ARB_MASK = 0x00040000L;
constexpr unsigned int RMI_UTCL1_CNTL1__ENABLE_PUSH_LFIFO_MASK  = 0x00020000L;
constexpr unsigned int RMI_UTCL1_CNTL1__FORCE_4K_L2_RESP_MASK   = 0x00000001L;
constexpr unsigned int RMI_UTCL1_CNTL1__FORCE_IN_ORDER_MASK     = 0x08000000L;
constexpr unsigned int RMI_UTCL1_CNTL1__FORCE_MISS_MASK         = 0x04000000L;
constexpr unsigned int RMI_UTCL1_CNTL1__GPUVM_64K_DEF_MASK      = 0x00000002L;
constexpr unsigned int RMI_UTCL1_CNTL1__GPUVM_PERM_MODE_MASK    = 0x00000004L;
constexpr unsigned int RMI_UTCL1_CNTL1__REDUCE_CACHE_SIZE_BY_2_MASK = 0xc0000000L;
constexpr unsigned int RMI_UTCL1_CNTL1__REDUCE_FIFO_DEPTH_BY_2_MASK = 0x30000000L;
constexpr unsigned int RMI_UTCL1_CNTL1__REG_INV_ALL_VMID_MASK   = 0x00800000L;
constexpr unsigned int RMI_UTCL1_CNTL1__REG_INV_TOGGLE_MASK     = 0x01000000L;
constexpr unsigned int RMI_UTCL1_CNTL1__REG_INV_VMID_MASK       = 0x00780000L;
constexpr unsigned int RMI_UTCL1_CNTL1__RESP_FAULT_MODE_MASK    = 0x00000060L;
constexpr unsigned int RMI_UTCL1_CNTL1__RESP_MODE_MASK          = 0x00000018L;
constexpr unsigned int RMI_UTCL1_CNTL1__USERVM_DIS_MASK         = 0x00010000L;
constexpr unsigned int RMI_UTCL1_CNTL2__DIS_EDC_MASK            = 0x00000800L;
constexpr unsigned int RMI_UTCL1_CNTL2__FORCE_GPUVM_INV_ACK_MASK = 0x00008000L;
constexpr unsigned int RMI_UTCL1_CNTL2__FORCE_SNOOP_MASK        = 0x00004000L;
constexpr unsigned int RMI_UTCL1_CNTL2__GPUVM_INV_MODE_MASK     = 0x00001000L;
constexpr unsigned int RMI_UTCL1_CNTL2__LINE_VALID_MASK         = 0x00000400L;
constexpr unsigned int RMI_UTCL1_CNTL2__MTYPE_OVRD_DIS_MASK     = 0x00000200L;
constexpr unsigned int RMI_UTCL1_CNTL2__SHOOTDOWN_OPT_MASK      = 0x00002000L;
constexpr unsigned int RMI_UTCL1_CNTL2__UTCL1_ARB_BURST_MODE_MASK = 0x00030000L;
constexpr unsigned int RMI_UTCL1_CNTL2__UTCL1_DIS_DUAL_L2_REQ_MASK = 0x02000000L;
constexpr unsigned int RMI_UTCL1_CNTL2__UTCL1_ENABLE_PERF_EVENT_RD_WR_MASK = 0x00040000L;
constexpr unsigned int RMI_UTCL1_CNTL2__UTCL1_ENABLE_PERF_EVENT_VMID_MASK = 0x00100000L;
constexpr unsigned int RMI_UTCL1_CNTL2__UTCL1_FORCE_FRAG_2M_TO_64K_MASK = 0x04000000L;
constexpr unsigned int RMI_UTCL1_CNTL2__UTCL1_PERF_EVENT_RD_WR_MASK = 0x00080000L;
constexpr unsigned int RMI_UTCL1_CNTL2__UTCL1_PERF_EVENT_VMID_MASK = 0x01e00000L;
constexpr unsigned int RMI_UTCL1_CNTL2__UTC_SPARE_MASK          = 0x000000ffL;
constexpr unsigned int RMI_UTCL1_STATUS__FAULT_DETECTED_MASK    = 0x00000001L;
constexpr unsigned int RMI_UTCL1_STATUS__PRT_DETECTED_MASK      = 0x00000004L;
constexpr unsigned int RMI_UTCL1_STATUS__RETRY_DETECTED_MASK    = 0x00000002L;
constexpr unsigned int RMI_UTC_XNACK_N_MISC_CNTL__CP_VMID_RESET_REQUEST_DISABLE_MASK = 0x00002000L;
constexpr unsigned int RMI_UTC_XNACK_N_MISC_CNTL__IND_XNACK_TIMER_START_VALUE_MASK = 0x00000f00L;
constexpr unsigned int RMI_UTC_XNACK_N_MISC_CNTL__MASTER_XNACK_TIMER_INC_MASK = 0x000000ffL;
constexpr unsigned int RMI_UTC_XNACK_N_MISC_CNTL__UTCL1_PERM_MODE_MASK = 0x00001000L;
constexpr unsigned int RMI_XBAR_ARBITER_CONFIG_1__XBAR_ARB_ROUND_ROBIN_WEIGHT_RB0_RD_MASK = 0x000000ffL;
constexpr unsigned int RMI_XBAR_ARBITER_CONFIG_1__XBAR_ARB_ROUND_ROBIN_WEIGHT_RB0_WR_MASK = 0x0000ff00L;
constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB0_BREAK_LOB_ON_IDLEIN_MASK = 0x00000010L;
constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB0_BREAK_LOB_ON_WEIGHTEDRR_MASK = 0x00000004L;
constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB0_MODE_MASK = 0x00000003L;
constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB0_STALL_MASK = 0x00000008L;
constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB0_STALL_TIMER_OVERRIDE_MASK = 0x000000c0L;
constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB0_STALL_TIMER_START_VALUE_MASK = 0x0000ff00L;
constexpr unsigned int RMI_XBAR_CONFIG__ARBITER_DIS_MASK        = 0x00000080L;
constexpr unsigned int RMI_XBAR_CONFIG__XBAR_EN_IN_RB0_MASK     = 0x00002000L;
constexpr unsigned int RMI_XBAR_CONFIG__XBAR_EN_IN_REQ_MASK     = 0x00000f00L;
constexpr unsigned int RMI_XBAR_CONFIG__XBAR_EN_IN_REQ_OVERRIDE_MASK = 0x00001000L;
constexpr unsigned int RMI_XBAR_CONFIG__XBAR_MUX_CONFIG_CB_DB_OVERRIDE_MASK = 0x00000040L;
constexpr unsigned int RMI_XBAR_CONFIG__XBAR_MUX_CONFIG_OVERRIDE_MASK = 0x00000003L;
constexpr unsigned int RMI_XBAR_CONFIG__XBAR_MUX_CONFIG_REQ_TYPE_OVERRIDE_MASK = 0x0000003cL;
constexpr unsigned int RMI_XNACK_DEBUG__XNACK_PER_VMID_MASK     = 0x0000ffffL;
constexpr unsigned int RPB_ARB_CNTL2__ATC_PAGE_SWITCH_NUM_MASK  = 0x00ff0000L;
constexpr unsigned int RPB_ARB_CNTL2__ATOMIC_SWITCH_NUM_MASK    = 0x0000ff00L;
constexpr unsigned int RPB_ARB_CNTL2__P2P_SWITCH_NUM_MASK       = 0x000000ffL;
constexpr unsigned int RPB_ARB_CNTL__ARB_MODE_MASK              = 0x01000000L;
constexpr unsigned int RPB_ARB_CNTL__ATC_TR_SWITCH_NUM_MASK     = 0x00ff0000L;
constexpr unsigned int RPB_ARB_CNTL__RD_SWITCH_NUM_MASK         = 0x000000ffL;
constexpr unsigned int RPB_ARB_CNTL__SWITCH_NUM_MODE_MASK       = 0x02000000L;
constexpr unsigned int RPB_ARB_CNTL__WR_SWITCH_NUM_MASK         = 0x0000ff00L;
constexpr unsigned int RPB_ATS_CNTL__ATCPAGE_SWITCH_NUM_MASK    = 0x00780000L;
constexpr unsigned int RPB_ATS_CNTL__PAGE_MIN_LATENCY_ENABLE_MASK = 0x00000001L;
constexpr unsigned int RPB_ATS_CNTL__SWITCH_THRESHOLD_MASK      = 0x0000007cL;
constexpr unsigned int RPB_ATS_CNTL__TIME_SLICE_MASK            = 0x00007f80L;
constexpr unsigned int RPB_ATS_CNTL__TR_MIN_LATENCY_ENABLE_MASK = 0x00000002L;
constexpr unsigned int RPB_ATS_CNTL__WR_AT_MASK                 = 0x01800000L;
constexpr unsigned int RPB_BIF_CNTL__VC0_SWITCH_NUM_MASK        = 0x000000ffL;
constexpr unsigned int RPB_BIF_CNTL__VC1_SWITCH_NUM_MASK        = 0x0000ff00L;
constexpr unsigned int RPB_BLOCKLEVEL_CONF__XPB_BLOCKLEVEL_OVERRIDE_MASK = 0x00000003L;
constexpr unsigned int RPB_CID_QUEUE_EX_DATA__READ_ENTRIES_MASK = 0xffff0000L;
constexpr unsigned int RPB_CID_QUEUE_EX_DATA__WRITE_ENTRIES_MASK = 0x0000ffffL;
constexpr unsigned int RPB_CID_QUEUE_EX__OFFSET_MASK            = 0x000001feL;
constexpr unsigned int RPB_CID_QUEUE_EX__START_MASK             = 0x00000001L;
constexpr unsigned int RPB_CID_QUEUE_RD__CLIENT_ID_HIGH_MASK    = 0x000007e0L;
constexpr unsigned int RPB_CID_QUEUE_RD__CLIENT_ID_LOW_MASK     = 0x0000001fL;
constexpr unsigned int RPB_CID_QUEUE_RD__READ_QUEUE_MASK        = 0x0001c000L;
constexpr unsigned int RPB_CID_QUEUE_RD__WRITE_QUEUE_MASK       = 0x00003800L;
constexpr unsigned int RPB_CID_QUEUE_WR__CLIENT_ID_HIGH_MASK    = 0x000007e0L;
constexpr unsigned int RPB_CID_QUEUE_WR__CLIENT_ID_LOW_MASK     = 0x0000001fL;
constexpr unsigned int RPB_CID_QUEUE_WR__READ_QUEUE_MASK        = 0x00038000L;
constexpr unsigned int RPB_CID_QUEUE_WR__UPDATE_MASK            = 0x00040000L;
constexpr unsigned int RPB_CID_QUEUE_WR__UPDATE_MODE_MASK       = 0x00000800L;
constexpr unsigned int RPB_CID_QUEUE_WR__WRITE_QUEUE_MASK       = 0x00007000L;
constexpr unsigned int RPB_DEINTRLV_COMBINE_CNTL__WC_CHAINED_BREAK_EN_MASK = 0x00000010L;
constexpr unsigned int RPB_DEINTRLV_COMBINE_CNTL__WC_CHAINED_FLUSH_TIMER_MASK = 0x0000000fL;
constexpr unsigned int RPB_DEINTRLV_COMBINE_CNTL__WC_HANDLE_CHECK_DISABLE_MASK = 0x00000020L;
constexpr unsigned int RPB_EFF_CNTL__RD_LAZY_TIMER_MASK         = 0x0000ff00L;
constexpr unsigned int RPB_EFF_CNTL__WR_LAZY_TIMER_MASK         = 0x000000ffL;
constexpr unsigned int RPB_PASSPW_CONF__XPB_PASSPW_OVERRIDE_MASK = 0x00000001L;
constexpr unsigned int RPB_PASSPW_CONF__XPB_RSPPASSPW_OVERRIDE_MASK = 0x00000002L;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__CLEAR_MASK         = 0x20000000L;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__ENABLE_MASK        = 0x10000000L;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__PERF_MODE_MASK     = 0x0f000000L;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__PERF_SEL_END_MASK  = 0x0000ff00L;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__PERF_SEL_MASK      = 0x000000ffL;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__CLEAR_MASK         = 0x20000000L;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__ENABLE_MASK        = 0x10000000L;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__PERF_MODE_MASK     = 0x0f000000L;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__PERF_SEL_END_MASK  = 0x0000ff00L;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__PERF_SEL_MASK      = 0x000000ffL;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__CLEAR_MASK         = 0x20000000L;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__ENABLE_MASK        = 0x10000000L;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__PERF_MODE_MASK     = 0x0f000000L;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__PERF_SEL_END_MASK  = 0x0000ff00L;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__PERF_SEL_MASK      = 0x000000ffL;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__CLEAR_MASK         = 0x20000000L;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__ENABLE_MASK        = 0x10000000L;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__PERF_MODE_MASK     = 0x0f000000L;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__PERF_SEL_END_MASK  = 0x0000ff00L;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__PERF_SEL_MASK      = 0x000000ffL;
constexpr unsigned int RPB_PERFCOUNTER_HI__COMPARE_VALUE_MASK   = 0xffff0000L;
constexpr unsigned int RPB_PERFCOUNTER_HI__COUNTER_HI_MASK      = 0x0000ffffL;
constexpr unsigned int RPB_PERFCOUNTER_LO__COUNTER_LO_MASK      = 0xffffffffL;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL_MASK = 0x02000000L;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY_MASK = 0x01000000L;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT_MASK = 0x0000000fL;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__START_TRIGGER_MASK = 0x0000ff00L;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE_MASK = 0x04000000L;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER_MASK = 0x00ff0000L;
constexpr unsigned int RPB_PERF_COUNTER_CNTL__PERF_COUNTER_SELECT_MASK = 0x00000003L;
constexpr unsigned int RPB_RD_QUEUE_CNTL2__Q4_PATTERN_MASK_HIGH_MASK = 0x000007e0L;
constexpr unsigned int RPB_RD_QUEUE_CNTL2__Q4_PATTERN_MASK_LOW_MASK = 0x0000001fL;
constexpr unsigned int RPB_RD_QUEUE_CNTL2__Q5_PATTERN_MASK_HIGH_MASK = 0x003f0000L;
constexpr unsigned int RPB_RD_QUEUE_CNTL2__Q5_PATTERN_MASK_LOW_MASK = 0x0000f800L;
constexpr unsigned int RPB_RD_QUEUE_CNTL__ARB_MODE_MASK         = 0x00000001L;
constexpr unsigned int RPB_RD_QUEUE_CNTL__Q4_PATTERN_HIGH_MASK  = 0x0000fc00L;
constexpr unsigned int RPB_RD_QUEUE_CNTL__Q4_PATTERN_LOW_MASK   = 0x000003e0L;
constexpr unsigned int RPB_RD_QUEUE_CNTL__Q4_SHARED_MASK        = 0x00000002L;
constexpr unsigned int RPB_RD_QUEUE_CNTL__Q4_UNITID_EA_MODE_MASK = 0x00000008L;
constexpr unsigned int RPB_RD_QUEUE_CNTL__Q5_PATTERN_HIGH_MASK  = 0x07e00000L;
constexpr unsigned int RPB_RD_QUEUE_CNTL__Q5_PATTERN_LOW_MASK   = 0x001f0000L;
constexpr unsigned int RPB_RD_QUEUE_CNTL__Q5_SHARED_MASK        = 0x00000004L;
constexpr unsigned int RPB_RD_QUEUE_CNTL__Q5_UNITID_EA_MODE_MASK = 0x00000010L;
constexpr unsigned int RPB_RD_SWITCH_CNTL__QUEUE0_SWITCH_NUM_MASK = 0x0000007fL;
constexpr unsigned int RPB_RD_SWITCH_CNTL__QUEUE1_SWITCH_NUM_MASK = 0x00003f80L;
constexpr unsigned int RPB_RD_SWITCH_CNTL__QUEUE2_SWITCH_NUM_MASK = 0x001fc000L;
constexpr unsigned int RPB_RD_SWITCH_CNTL__QUEUE3_SWITCH_NUM_MASK = 0x0fe00000L;
constexpr unsigned int RPB_RD_SWITCH_CNTL__SWITCH_NUM_MODE_MASK = 0x10000000L;
constexpr unsigned int RPB_SDPPORT_CNTL__DF_SDPVDCI_RDRSPCKENRCV_MASK = 0x00800000L;
constexpr unsigned int RPB_SDPPORT_CNTL__DF_SDPVDCI_RDRSPCKEN_MASK = 0x00400000L;
constexpr unsigned int RPB_SDPPORT_CNTL__DF_SDPVDCI_RDRSPDATACKENRCV_MASK = 0x02000000L;
constexpr unsigned int RPB_SDPPORT_CNTL__DF_SDPVDCI_RDRSPDATACKEN_MASK = 0x01000000L;
constexpr unsigned int RPB_SDPPORT_CNTL__DF_SDPVDCI_WRRSPCKENRCV_MASK = 0x08000000L;
constexpr unsigned int RPB_SDPPORT_CNTL__DF_SDPVDCI_WRRSPCKEN_MASK = 0x04000000L;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_DMA_CFG_MODE_MASK = 0x00000006L;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_DMA_ENABLE_DISRUPT_FULLDIS_MASK = 0x00000020L;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_DMA_ENABLE_REISSUE_CREDIT_MASK = 0x00000008L;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_DMA_ENABLE_SATURATE_COUNTER_MASK = 0x00000010L;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_DMA_HALT_THRESHOLD_MASK = 0x000003c0L;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_DMA_SELF_ACTIVATE_MASK = 0x00000001L;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_HST_CFG_MODE_MASK = 0x00001800L;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_HST_ENABLE_DISRUPT_FULLDIS_MASK = 0x00008000L;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_HST_ENABLE_REISSUE_CREDIT_MASK = 0x00002000L;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_HST_ENABLE_SATURATE_COUNTER_MASK = 0x00004000L;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_HST_HALT_THRESHOLD_MASK = 0x000f0000L;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_HST_PASSIVE_MODE_MASK = 0x00100000L;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_HST_QUICK_COMACK_MASK = 0x00200000L;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_HST_SELF_ACTIVATE_MASK = 0x00000400L;
constexpr unsigned int RPB_SWITCH_CNTL2__RD_QUEUE4_SWITCH_NUM_MASK = 0x0000007fL;
constexpr unsigned int RPB_SWITCH_CNTL2__RD_QUEUE5_SWITCH_NUM_MASK = 0x00003f80L;
constexpr unsigned int RPB_SWITCH_CNTL2__WR_QUEUE4_SWITCH_NUM_MASK = 0x001fc000L;
constexpr unsigned int RPB_SWITCH_CNTL2__WR_QUEUE5_SWITCH_NUM_MASK = 0x0fe00000L;
constexpr unsigned int RPB_VC_SWITCH_RDWR__MODE_MASK            = 0x00000003L;
constexpr unsigned int RPB_VC_SWITCH_RDWR__NUM_RD_MASK          = 0x000003fcL;
constexpr unsigned int RPB_VC_SWITCH_RDWR__NUM_WR_MASK          = 0x0003fc00L;
constexpr unsigned int RPB_WR_QUEUE_CNTL2__Q4_PATTERN_MASK_HIGH_MASK = 0x000007e0L;
constexpr unsigned int RPB_WR_QUEUE_CNTL2__Q4_PATTERN_MASK_LOW_MASK = 0x0000001fL;
constexpr unsigned int RPB_WR_QUEUE_CNTL2__Q5_PATTERN_MASK_HIGH_MASK = 0x003f0000L;
constexpr unsigned int RPB_WR_QUEUE_CNTL2__Q5_PATTERN_MASK_LOW_MASK = 0x0000f800L;
constexpr unsigned int RPB_WR_QUEUE_CNTL__ARB_MODE_MASK         = 0x00000001L;
constexpr unsigned int RPB_WR_QUEUE_CNTL__Q4_PATTERN_HIGH_MASK  = 0x0000fc00L;
constexpr unsigned int RPB_WR_QUEUE_CNTL__Q4_PATTERN_LOW_MASK   = 0x000003e0L;
constexpr unsigned int RPB_WR_QUEUE_CNTL__Q4_SHARED_MASK        = 0x00000002L;
constexpr unsigned int RPB_WR_QUEUE_CNTL__Q4_UNITID_EA_MODE_MASK = 0x00000008L;
constexpr unsigned int RPB_WR_QUEUE_CNTL__Q5_PATTERN_HIGH_MASK  = 0x07e00000L;
constexpr unsigned int RPB_WR_QUEUE_CNTL__Q5_PATTERN_LOW_MASK   = 0x001f0000L;
constexpr unsigned int RPB_WR_QUEUE_CNTL__Q5_SHARED_MASK        = 0x00000004L;
constexpr unsigned int RPB_WR_QUEUE_CNTL__Q5_UNITID_EA_MODE_MASK = 0x00000010L;
constexpr unsigned int RPB_WR_SWITCH_CNTL__QUEUE0_SWITCH_NUM_MASK = 0x0000007fL;
constexpr unsigned int RPB_WR_SWITCH_CNTL__QUEUE1_SWITCH_NUM_MASK = 0x00003f80L;
constexpr unsigned int RPB_WR_SWITCH_CNTL__QUEUE2_SWITCH_NUM_MASK = 0x001fc000L;
constexpr unsigned int RPB_WR_SWITCH_CNTL__QUEUE3_SWITCH_NUM_MASK = 0x0fe00000L;
constexpr unsigned int RPB_WR_SWITCH_CNTL__SWITCH_NUM_MODE_MASK = 0x10000000L;
constexpr unsigned int SCRATCH_ADDR__OBSOLETE_ADDR_MASK         = 0xffffffffL;
constexpr unsigned int SCRATCH_REG0__SCRATCH_REG0_MASK          = 0xffffffffL;
constexpr unsigned int SCRATCH_REG1__SCRATCH_REG1_MASK          = 0xffffffffL;
constexpr unsigned int SCRATCH_REG2__SCRATCH_REG2_MASK          = 0xffffffffL;
constexpr unsigned int SCRATCH_REG3__SCRATCH_REG3_MASK          = 0xffffffffL;
constexpr unsigned int SCRATCH_REG4__SCRATCH_REG4_MASK          = 0xffffffffL;
constexpr unsigned int SCRATCH_REG5__SCRATCH_REG5_MASK          = 0xffffffffL;
constexpr unsigned int SCRATCH_REG6__SCRATCH_REG6_MASK          = 0xffffffffL;
constexpr unsigned int SCRATCH_REG7__SCRATCH_REG7_MASK          = 0xffffffffL;
constexpr unsigned int SCRATCH_UMSK__OBSOLETE_SWAP_MASK         = 0x00030000L;
constexpr unsigned int SCRATCH_UMSK__OBSOLETE_UMSK_MASK         = 0x000000ffL;
constexpr unsigned int SH_MEM_BASES__PRIVATE_BASE_MASK          = 0x0000ffffL;
constexpr unsigned int SH_MEM_BASES__SHARED_BASE_MASK           = 0xffff0000L;
constexpr unsigned int SH_MEM_CONFIG__ADDRESS_MODE_MASK         = 0x00000001L;
constexpr unsigned int SPIS_DEBUG_READ__DATA_MASK               = 0xffffffffL;
constexpr unsigned int SPI_ARB_CNTL_0__EXP_ARB_COL_WT_MASK      = 0x0000000fL;
constexpr unsigned int SPI_ARB_CNTL_0__EXP_ARB_GDS_WT_MASK      = 0x00000f00L;
constexpr unsigned int SPI_ARB_CNTL_0__EXP_ARB_POS_WT_MASK      = 0x000000f0L;
constexpr unsigned int SPI_ARB_CYCLES_0__TS0_DURATION_MASK      = 0x0000ffffL;
constexpr unsigned int SPI_ARB_CYCLES_0__TS1_DURATION_MASK      = 0xffff0000L;
constexpr unsigned int SPI_ARB_CYCLES_1__TS2_DURATION_MASK      = 0x0000ffffL;
constexpr unsigned int SPI_ARB_CYCLES_1__TS3_DURATION_MASK      = 0xffff0000L;
constexpr unsigned int SPI_ARB_PRIORITY__PIPE_ORDER_TS0_MASK    = 0x00000007L;
constexpr unsigned int SPI_ARB_PRIORITY__PIPE_ORDER_TS1_MASK    = 0x00000038L;
constexpr unsigned int SPI_ARB_PRIORITY__PIPE_ORDER_TS2_MASK    = 0x000001c0L;
constexpr unsigned int SPI_ARB_PRIORITY__PIPE_ORDER_TS3_MASK    = 0x00000e00L;
constexpr unsigned int SPI_ARB_PRIORITY__TS0_DUR_MULT_MASK      = 0x00003000L;
constexpr unsigned int SPI_ARB_PRIORITY__TS1_DUR_MULT_MASK      = 0x0000c000L;
constexpr unsigned int SPI_ARB_PRIORITY__TS2_DUR_MULT_MASK      = 0x00030000L;
constexpr unsigned int SPI_ARB_PRIORITY__TS3_DUR_MULT_MASK      = 0x000c0000L;
constexpr unsigned int SPI_BARYC_CNTL__FRONT_FACE_ALL_BITS_MASK = 0x01000000L;
constexpr unsigned int SPI_BARYC_CNTL__LINEAR_CENTER_CNTL_MASK  = 0x00000100L;
constexpr unsigned int SPI_BARYC_CNTL__LINEAR_CENTROID_CNTL_MASK = 0x00001000L;
constexpr unsigned int SPI_BARYC_CNTL__PERSP_CENTER_CNTL_MASK   = 0x00000001L;
constexpr unsigned int SPI_BARYC_CNTL__PERSP_CENTROID_CNTL_MASK = 0x00000010L;
constexpr unsigned int SPI_BARYC_CNTL__POS_FLOAT_LOCATION_MASK  = 0x00030000L;
constexpr unsigned int SPI_BARYC_CNTL__POS_FLOAT_ULC_MASK       = 0x00100000L;
constexpr unsigned int SPI_COMPUTE_QUEUE_RESET__RESET_MASK      = 0x00000001L;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE__DONE_INTERRUPT_EN_MASK = 0x00000004L;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE__GDS_INTERRUPT_EN_MASK = 0x00000002L;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE__GDS_REQ_BUSY_MASK = 0x40000000L;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE__INITIATE_MASK   = 0x00000001L;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE__SAVE_BUSY_MASK  = 0x80000000L;
constexpr unsigned int SPI_CONFIG_CNTL_1__CRC_SIMD_ID_WADDR_DISABLE_MASK = 0x00000100L;
constexpr unsigned int SPI_CONFIG_CNTL_1__CSC_PWR_SAVE_DISABLE_MASK = 0x00004000L;
constexpr unsigned int SPI_CONFIG_CNTL_1__CSG_PWR_SAVE_DISABLE_MASK = 0x00008000L;
constexpr unsigned int SPI_CONFIG_CNTL_1__INTERP_ONE_PRIM_PER_ROW_MASK = 0x00000010L;
constexpr unsigned int SPI_CONFIG_CNTL_1__LBPW_CU_CHK_CNT_MASK  = 0x00003c00L;
constexpr unsigned int SPI_CONFIG_CNTL_1__LBPW_CU_CHK_MODE_MASK = 0x00000200L;
constexpr unsigned int SPI_CONFIG_CNTL_1__PC_LIMIT_STRICT_MASK  = 0x00000080L;
constexpr unsigned int SPI_CONFIG_CNTL_1__VTX_DONE_DELAY_MASK   = 0x0000000fL;
constexpr unsigned int SPI_CONFIG_CNTL_2__CONTEXT_SAVE_WAIT_GDS_GRANT_CYCLE_OVHD_MASK = 0x000000f0L;
constexpr unsigned int SPI_CONFIG_CNTL_2__CONTEXT_SAVE_WAIT_GDS_REQUEST_CYCLE_OVHD_MASK = 0x0000000fL;
constexpr unsigned int SPI_CONFIG_CNTL__ALLOC_ARB_LRU_ENA_MASK  = 0x10000000L;
constexpr unsigned int SPI_CONFIG_CNTL__ENABLE_SQG_BOP_EVENTS_MASK = 0x02000000L;
constexpr unsigned int SPI_CONFIG_CNTL__ENABLE_SQG_TOP_EVENTS_MASK = 0x01000000L;
constexpr unsigned int SPI_CONFIG_CNTL__EXP_ARB_LRU_ENA_MASK    = 0x20000000L;
constexpr unsigned int SPI_CONFIG_CNTL__EXP_PRIORITY_ORDER_MASK = 0x00e00000L;
constexpr unsigned int SPI_CONFIG_CNTL__GPR_WRITE_PRIORITY_MASK = 0x001fffffL;
constexpr unsigned int SPI_CONFIG_CNTL__PS_PKR_PRIORITY_CNTL_MASK = 0xc0000000L;
constexpr unsigned int SPI_CONFIG_CNTL__TTRACE_STALL_ALL_MASK   = 0x08000000L;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_0__COUNT_MASK    = 0x000007ffL;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_0__EVENTS_MASK   = 0x07ff0000L;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_1__COUNT_MASK    = 0x000007ffL;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_1__EVENTS_MASK   = 0x07ff0000L;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_2__COUNT_MASK    = 0x000007ffL;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_2__EVENTS_MASK   = 0x07ff0000L;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_3__COUNT_MASK    = 0x000007ffL;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_3__EVENTS_MASK   = 0x07ff0000L;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_STATUS__ACTIVE_MASK    = 0xffffffffL;
constexpr unsigned int SPI_DEBUG_READ__DATA_MASK                = 0xffffffffL;
constexpr unsigned int SPI_DSM_CNTL2__SPI_SR_MEM_ENABLE_ERROR_INJECT_MASK = 0x00000003L;
constexpr unsigned int SPI_DSM_CNTL2__SPI_SR_MEM_SELECT_INJECT_DELAY_MASK = 0x00000004L;
constexpr unsigned int SPI_DSM_CNTL__SPI_SR_MEM_DSM_IRRITATOR_DATA_MASK = 0x00000003L;
constexpr unsigned int SPI_DSM_CNTL__SPI_SR_MEM_ENABLE_SINGLE_WRITE_MASK = 0x00000004L;
constexpr unsigned int SPI_EDC_CNT__SPI_SR_MEM_SED_COUNT_MASK   = 0x00000003L;
constexpr unsigned int SPI_GFX_CNTL__RESET_COUNTS_MASK          = 0x00000001L;
constexpr unsigned int SPI_INTERP_CONTROL_0__FLAT_SHADE_ENA_MASK = 0x00000001L;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_ENA_MASK = 0x00000002L;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_OVRD_W_MASK = 0x00003800L;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_OVRD_X_MASK = 0x0000001cL;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_OVRD_Y_MASK = 0x000000e0L;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_OVRD_Z_MASK = 0x00000700L;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_TOP_1_MASK = 0x00004000L;
constexpr unsigned int SPI_LB_CTR_CTRL__CLEAR_ON_READ_MASK      = 0x00000008L;
constexpr unsigned int SPI_LB_CTR_CTRL__LOAD_MASK               = 0x00000001L;
constexpr unsigned int SPI_LB_CTR_CTRL__RESET_COUNTS_MASK       = 0x00000010L;
constexpr unsigned int SPI_LB_CTR_CTRL__WAVES_SELECT_MASK       = 0x00000006L;
constexpr unsigned int SPI_LB_DATA_REG__CNT_DATA_MASK           = 0xffffffffL;
constexpr unsigned int SPI_LB_DATA_WAVES__COUNT0_MASK           = 0x0000ffffL;
constexpr unsigned int SPI_LB_DATA_WAVES__COUNT1_MASK           = 0xffff0000L;
constexpr unsigned int SPI_P0_TRAP_SCREEN_GPR_MIN__SGPR_MIN_MASK = 0x000003c0L;
constexpr unsigned int SPI_P0_TRAP_SCREEN_GPR_MIN__VGPR_MIN_MASK = 0x0000003fL;
constexpr unsigned int SPI_P0_TRAP_SCREEN_PSBA_HI__MEM_BASE_MASK = 0x000000ffL;
constexpr unsigned int SPI_P0_TRAP_SCREEN_PSBA_LO__MEM_BASE_MASK = 0xffffffffL;
constexpr unsigned int SPI_P0_TRAP_SCREEN_PSMA_HI__MEM_BASE_MASK = 0x000000ffL;
constexpr unsigned int SPI_P0_TRAP_SCREEN_PSMA_LO__MEM_BASE_MASK = 0xffffffffL;
constexpr unsigned int SPI_P1_TRAP_SCREEN_GPR_MIN__SGPR_MIN_MASK = 0x000003c0L;
constexpr unsigned int SPI_P1_TRAP_SCREEN_GPR_MIN__VGPR_MIN_MASK = 0x0000003fL;
constexpr unsigned int SPI_P1_TRAP_SCREEN_PSBA_HI__MEM_BASE_MASK = 0x000000ffL;
constexpr unsigned int SPI_P1_TRAP_SCREEN_PSBA_LO__MEM_BASE_MASK = 0xffffffffL;
constexpr unsigned int SPI_P1_TRAP_SCREEN_PSMA_HI__MEM_BASE_MASK = 0x000000ffL;
constexpr unsigned int SPI_P1_TRAP_SCREEN_PSMA_LO__MEM_BASE_MASK = 0xffffffffL;
constexpr unsigned int SPI_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int SPI_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__PERF_MODE1_MASK = 0x0f000000L;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__PERF_MODE_MASK  = 0xf0000000L;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__PERF_SEL_MASK   = 0x000003ffL;
constexpr unsigned int SPI_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int SPI_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__PERF_MODE1_MASK = 0x0f000000L;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__PERF_MODE_MASK  = 0xf0000000L;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__PERF_SEL_MASK   = 0x000003ffL;
constexpr unsigned int SPI_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int SPI_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__PERF_MODE1_MASK = 0x0f000000L;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__PERF_MODE_MASK  = 0xf0000000L;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__PERF_SEL_MASK   = 0x000003ffL;
constexpr unsigned int SPI_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int SPI_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__PERF_MODE1_MASK = 0x0f000000L;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__PERF_MODE_MASK  = 0xf0000000L;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__PERF_SEL_MASK   = 0x000003ffL;
constexpr unsigned int SPI_PERFCOUNTER4_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int SPI_PERFCOUNTER4_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int SPI_PERFCOUNTER5_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int SPI_PERFCOUNTER5_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN0_MAX_MASK      = 0x000000f0L;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN0_MIN_MASK      = 0x0000000fL;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN1_MAX_MASK      = 0x0000f000L;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN1_MIN_MASK      = 0x00000f00L;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN2_MAX_MASK      = 0x00f00000L;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN2_MIN_MASK      = 0x000f0000L;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN3_MAX_MASK      = 0xf0000000L;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN3_MIN_MASK      = 0x0f000000L;
constexpr unsigned int SPI_PS_INPUT_ADDR__ANCILLARY_ENA_MASK    = 0x00002000L;
constexpr unsigned int SPI_PS_INPUT_ADDR__FRONT_FACE_ENA_MASK   = 0x00001000L;
constexpr unsigned int SPI_PS_INPUT_ADDR__LINEAR_CENTER_ENA_MASK = 0x00000020L;
constexpr unsigned int SPI_PS_INPUT_ADDR__LINEAR_CENTROID_ENA_MASK = 0x00000040L;
constexpr unsigned int SPI_PS_INPUT_ADDR__LINEAR_SAMPLE_ENA_MASK = 0x00000010L;
constexpr unsigned int SPI_PS_INPUT_ADDR__LINE_STIPPLE_TEX_ENA_MASK = 0x00000080L;
constexpr unsigned int SPI_PS_INPUT_ADDR__PERSP_CENTER_ENA_MASK = 0x00000002L;
constexpr unsigned int SPI_PS_INPUT_ADDR__PERSP_CENTROID_ENA_MASK = 0x00000004L;
constexpr unsigned int SPI_PS_INPUT_ADDR__PERSP_PULL_MODEL_ENA_MASK = 0x00000008L;
constexpr unsigned int SPI_PS_INPUT_ADDR__PERSP_SAMPLE_ENA_MASK = 0x00000001L;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_FIXED_PT_ENA_MASK = 0x00008000L;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_W_FLOAT_ENA_MASK  = 0x00000800L;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_X_FLOAT_ENA_MASK  = 0x00000100L;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_Y_FLOAT_ENA_MASK  = 0x00000200L;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_Z_FLOAT_ENA_MASK  = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_ADDR__SAMPLE_COVERAGE_ENA_MASK = 0x00004000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__ATTR0_VALID_MASK    = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__ATTR1_VALID_MASK    = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__CYL_WRAP_MASK       = 0x0001e000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__DEFAULT_VAL_MASK    = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__DUP_MASK            = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__FLAT_SHADE_MASK     = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__OFFSET_MASK         = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__PT_SPRITE_TEX_ATTR1_MASK = 0x00800000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__PT_SPRITE_TEX_MASK  = 0x00020000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__ATTR0_VALID_MASK    = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__ATTR1_VALID_MASK    = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__CYL_WRAP_MASK       = 0x0001e000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__DEFAULT_VAL_MASK    = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__DUP_MASK            = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__FLAT_SHADE_MASK     = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__OFFSET_MASK         = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__PT_SPRITE_TEX_ATTR1_MASK = 0x00800000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__PT_SPRITE_TEX_MASK  = 0x00020000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__ATTR0_VALID_MASK    = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__ATTR1_VALID_MASK    = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__CYL_WRAP_MASK       = 0x0001e000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__DEFAULT_VAL_MASK    = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__DUP_MASK            = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__FLAT_SHADE_MASK     = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__OFFSET_MASK         = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__PT_SPRITE_TEX_ATTR1_MASK = 0x00800000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__PT_SPRITE_TEX_MASK  = 0x00020000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__ATTR0_VALID_MASK    = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__ATTR1_VALID_MASK    = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__CYL_WRAP_MASK       = 0x0001e000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__DEFAULT_VAL_MASK    = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__DUP_MASK            = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__FLAT_SHADE_MASK     = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__OFFSET_MASK         = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__PT_SPRITE_TEX_ATTR1_MASK = 0x00800000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__PT_SPRITE_TEX_MASK  = 0x00020000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__ATTR0_VALID_MASK    = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__ATTR1_VALID_MASK    = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__CYL_WRAP_MASK       = 0x0001e000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__DEFAULT_VAL_MASK    = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__DUP_MASK            = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__FLAT_SHADE_MASK     = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__OFFSET_MASK         = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__PT_SPRITE_TEX_ATTR1_MASK = 0x00800000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__PT_SPRITE_TEX_MASK  = 0x00020000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__ATTR0_VALID_MASK    = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__ATTR1_VALID_MASK    = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__CYL_WRAP_MASK       = 0x0001e000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__DEFAULT_VAL_MASK    = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__DUP_MASK            = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__FLAT_SHADE_MASK     = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__OFFSET_MASK         = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__PT_SPRITE_TEX_ATTR1_MASK = 0x00800000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__PT_SPRITE_TEX_MASK  = 0x00020000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__ATTR0_VALID_MASK    = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__ATTR1_VALID_MASK    = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__CYL_WRAP_MASK       = 0x0001e000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__DEFAULT_VAL_MASK    = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__DUP_MASK            = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__FLAT_SHADE_MASK     = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__OFFSET_MASK         = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__PT_SPRITE_TEX_ATTR1_MASK = 0x00800000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__PT_SPRITE_TEX_MASK  = 0x00020000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__ATTR0_VALID_MASK    = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__ATTR1_VALID_MASK    = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__CYL_WRAP_MASK       = 0x0001e000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__DEFAULT_VAL_MASK    = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__DUP_MASK            = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__FLAT_SHADE_MASK     = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__OFFSET_MASK         = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__PT_SPRITE_TEX_ATTR1_MASK = 0x00800000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__PT_SPRITE_TEX_MASK  = 0x00020000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__ATTR0_VALID_MASK    = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__ATTR1_VALID_MASK    = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__CYL_WRAP_MASK       = 0x0001e000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__DEFAULT_VAL_MASK    = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__DUP_MASK            = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__FLAT_SHADE_MASK     = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__OFFSET_MASK         = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__PT_SPRITE_TEX_ATTR1_MASK = 0x00800000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__PT_SPRITE_TEX_MASK  = 0x00020000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__ATTR0_VALID_MASK    = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__ATTR1_VALID_MASK    = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__CYL_WRAP_MASK       = 0x0001e000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__DEFAULT_VAL_MASK    = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__DUP_MASK            = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__FLAT_SHADE_MASK     = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__OFFSET_MASK         = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__PT_SPRITE_TEX_ATTR1_MASK = 0x00800000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__PT_SPRITE_TEX_MASK  = 0x00020000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__ATTR0_VALID_MASK   = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__ATTR1_VALID_MASK   = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__CYL_WRAP_MASK      = 0x0001e000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__DEFAULT_VAL_MASK   = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__DUP_MASK           = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__FLAT_SHADE_MASK    = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__OFFSET_MASK        = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__PT_SPRITE_TEX_ATTR1_MASK = 0x00800000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__PT_SPRITE_TEX_MASK = 0x00020000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__ATTR0_VALID_MASK   = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__ATTR1_VALID_MASK   = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__CYL_WRAP_MASK      = 0x0001e000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__DEFAULT_VAL_MASK   = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__DUP_MASK           = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__FLAT_SHADE_MASK    = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__OFFSET_MASK        = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__PT_SPRITE_TEX_ATTR1_MASK = 0x00800000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__PT_SPRITE_TEX_MASK = 0x00020000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__ATTR0_VALID_MASK   = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__ATTR1_VALID_MASK   = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__CYL_WRAP_MASK      = 0x0001e000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__DEFAULT_VAL_MASK   = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__DUP_MASK           = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__FLAT_SHADE_MASK    = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__OFFSET_MASK        = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__PT_SPRITE_TEX_ATTR1_MASK = 0x00800000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__PT_SPRITE_TEX_MASK = 0x00020000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__ATTR0_VALID_MASK   = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__ATTR1_VALID_MASK   = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__CYL_WRAP_MASK      = 0x0001e000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__DEFAULT_VAL_MASK   = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__DUP_MASK           = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__FLAT_SHADE_MASK    = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__OFFSET_MASK        = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__PT_SPRITE_TEX_ATTR1_MASK = 0x00800000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__PT_SPRITE_TEX_MASK = 0x00020000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__ATTR0_VALID_MASK   = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__ATTR1_VALID_MASK   = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__CYL_WRAP_MASK      = 0x0001e000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__DEFAULT_VAL_MASK   = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__DUP_MASK           = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__FLAT_SHADE_MASK    = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__OFFSET_MASK        = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__PT_SPRITE_TEX_ATTR1_MASK = 0x00800000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__PT_SPRITE_TEX_MASK = 0x00020000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__ATTR0_VALID_MASK   = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__ATTR1_VALID_MASK   = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__CYL_WRAP_MASK      = 0x0001e000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__DEFAULT_VAL_MASK   = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__DUP_MASK           = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__FLAT_SHADE_MASK    = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__OFFSET_MASK        = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__PT_SPRITE_TEX_ATTR1_MASK = 0x00800000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__PT_SPRITE_TEX_MASK = 0x00020000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__ATTR0_VALID_MASK   = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__ATTR1_VALID_MASK   = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__CYL_WRAP_MASK      = 0x0001e000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__DEFAULT_VAL_MASK   = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__DUP_MASK           = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__FLAT_SHADE_MASK    = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__OFFSET_MASK        = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__PT_SPRITE_TEX_ATTR1_MASK = 0x00800000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__PT_SPRITE_TEX_MASK = 0x00020000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__ATTR0_VALID_MASK   = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__ATTR1_VALID_MASK   = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__CYL_WRAP_MASK      = 0x0001e000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__DEFAULT_VAL_MASK   = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__DUP_MASK           = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__FLAT_SHADE_MASK    = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__OFFSET_MASK        = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__PT_SPRITE_TEX_ATTR1_MASK = 0x00800000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__PT_SPRITE_TEX_MASK = 0x00020000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__ATTR0_VALID_MASK   = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__ATTR1_VALID_MASK   = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__CYL_WRAP_MASK      = 0x0001e000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__DEFAULT_VAL_MASK   = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__DUP_MASK           = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__FLAT_SHADE_MASK    = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__OFFSET_MASK        = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__PT_SPRITE_TEX_ATTR1_MASK = 0x00800000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__PT_SPRITE_TEX_MASK = 0x00020000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__ATTR0_VALID_MASK   = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__ATTR1_VALID_MASK   = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__CYL_WRAP_MASK      = 0x0001e000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__DEFAULT_VAL_MASK   = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__DUP_MASK           = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__FLAT_SHADE_MASK    = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__OFFSET_MASK        = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__PT_SPRITE_TEX_ATTR1_MASK = 0x00800000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__PT_SPRITE_TEX_MASK = 0x00020000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__ATTR0_VALID_MASK   = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__ATTR1_VALID_MASK   = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__DEFAULT_VAL_MASK   = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__DUP_MASK           = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__FLAT_SHADE_MASK    = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__OFFSET_MASK        = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__ATTR0_VALID_MASK   = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__ATTR1_VALID_MASK   = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__DEFAULT_VAL_MASK   = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__DUP_MASK           = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__FLAT_SHADE_MASK    = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__OFFSET_MASK        = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__ATTR0_VALID_MASK   = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__ATTR1_VALID_MASK   = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__DEFAULT_VAL_MASK   = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__DUP_MASK           = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__FLAT_SHADE_MASK    = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__OFFSET_MASK        = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__ATTR0_VALID_MASK   = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__ATTR1_VALID_MASK   = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__DEFAULT_VAL_MASK   = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__DUP_MASK           = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__FLAT_SHADE_MASK    = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__OFFSET_MASK        = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__ATTR0_VALID_MASK   = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__ATTR1_VALID_MASK   = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__DEFAULT_VAL_MASK   = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__DUP_MASK           = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__FLAT_SHADE_MASK    = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__OFFSET_MASK        = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__ATTR0_VALID_MASK   = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__ATTR1_VALID_MASK   = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__DEFAULT_VAL_MASK   = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__DUP_MASK           = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__FLAT_SHADE_MASK    = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__OFFSET_MASK        = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__ATTR0_VALID_MASK   = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__ATTR1_VALID_MASK   = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__DEFAULT_VAL_MASK   = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__DUP_MASK           = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__FLAT_SHADE_MASK    = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__OFFSET_MASK        = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__ATTR0_VALID_MASK   = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__ATTR1_VALID_MASK   = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__DEFAULT_VAL_MASK   = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__DUP_MASK           = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__FLAT_SHADE_MASK    = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__OFFSET_MASK        = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__ATTR0_VALID_MASK   = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__ATTR1_VALID_MASK   = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__DEFAULT_VAL_MASK   = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__DUP_MASK           = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__FLAT_SHADE_MASK    = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__OFFSET_MASK        = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__ATTR0_VALID_MASK   = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__ATTR1_VALID_MASK   = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__DEFAULT_VAL_MASK   = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__DUP_MASK           = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__FLAT_SHADE_MASK    = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__OFFSET_MASK        = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__ATTR0_VALID_MASK   = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__ATTR1_VALID_MASK   = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__DEFAULT_VAL_MASK   = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__DUP_MASK           = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__FLAT_SHADE_MASK    = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__OFFSET_MASK        = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__ATTR0_VALID_MASK   = 0x01000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__ATTR1_VALID_MASK   = 0x02000000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__DEFAULT_VAL_ATTR1_MASK = 0x00600000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__DEFAULT_VAL_MASK   = 0x00000300L;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__DUP_MASK           = 0x00040000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__FLAT_SHADE_MASK    = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__FP16_INTERP_MODE_MASK = 0x00080000L;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__OFFSET_MASK        = 0x0000003fL;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__USE_DEFAULT_ATTR1_MASK = 0x00100000L;
constexpr unsigned int SPI_PS_INPUT_ENA__ANCILLARY_ENA_MASK     = 0x00002000L;
constexpr unsigned int SPI_PS_INPUT_ENA__FRONT_FACE_ENA_MASK    = 0x00001000L;
constexpr unsigned int SPI_PS_INPUT_ENA__LINEAR_CENTER_ENA_MASK = 0x00000020L;
constexpr unsigned int SPI_PS_INPUT_ENA__LINEAR_CENTROID_ENA_MASK = 0x00000040L;
constexpr unsigned int SPI_PS_INPUT_ENA__LINEAR_SAMPLE_ENA_MASK = 0x00000010L;
constexpr unsigned int SPI_PS_INPUT_ENA__LINE_STIPPLE_TEX_ENA_MASK = 0x00000080L;
constexpr unsigned int SPI_PS_INPUT_ENA__PERSP_CENTER_ENA_MASK  = 0x00000002L;
constexpr unsigned int SPI_PS_INPUT_ENA__PERSP_CENTROID_ENA_MASK = 0x00000004L;
constexpr unsigned int SPI_PS_INPUT_ENA__PERSP_PULL_MODEL_ENA_MASK = 0x00000008L;
constexpr unsigned int SPI_PS_INPUT_ENA__PERSP_SAMPLE_ENA_MASK  = 0x00000001L;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_FIXED_PT_ENA_MASK  = 0x00008000L;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_W_FLOAT_ENA_MASK   = 0x00000800L;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_X_FLOAT_ENA_MASK   = 0x00000100L;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_Y_FLOAT_ENA_MASK   = 0x00000200L;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_Z_FLOAT_ENA_MASK   = 0x00000400L;
constexpr unsigned int SPI_PS_INPUT_ENA__SAMPLE_COVERAGE_ENA_MASK = 0x00004000L;
constexpr unsigned int SPI_PS_IN_CONTROL__BC_OPTIMIZE_DISABLE_MASK = 0x00004000L;
constexpr unsigned int SPI_PS_IN_CONTROL__LATE_PC_DEALLOC_MASK  = 0x00000100L;
constexpr unsigned int SPI_PS_IN_CONTROL__NUM_INTERP_MASK       = 0x0000003fL;
constexpr unsigned int SPI_PS_IN_CONTROL__OFFCHIP_PARAM_EN_MASK = 0x00000080L;
constexpr unsigned int SPI_PS_IN_CONTROL__PARAM_GEN_MASK        = 0x00000040L;
constexpr unsigned int SPI_PS_MAX_WAVE_ID__MAX_COLLISION_WAVE_ID_MASK = 0x03ff0000L;
constexpr unsigned int SPI_PS_MAX_WAVE_ID__MAX_WAVE_ID_MASK     = 0x00000fffL;
constexpr unsigned int SPI_RESET_DEBUG__DISABLE_GFX_RESET_ALL_VMID_MASK = 0x00000004L;
constexpr unsigned int SPI_RESET_DEBUG__DISABLE_GFX_RESET_MASK  = 0x00000001L;
constexpr unsigned int SPI_RESET_DEBUG__DISABLE_GFX_RESET_PER_VMID_MASK = 0x00000002L;
constexpr unsigned int SPI_RESET_DEBUG__DISABLE_GFX_RESET_PRIORITY_MASK = 0x00000010L;
constexpr unsigned int SPI_RESET_DEBUG__DISABLE_GFX_RESET_RESOURCE_MASK = 0x00000008L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__BARRIERS_MASK = 0x00078000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__LDS_MASK      = 0x00000f00L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__SGPR_MASK     = 0x000000f0L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__VGPR_MASK     = 0x0000000fL;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__WAVES_MASK    = 0x00007000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__BARRIERS_MASK = 0x00078000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__LDS_MASK      = 0x00000f00L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__SGPR_MASK     = 0x000000f0L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__VGPR_MASK     = 0x0000000fL;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__WAVES_MASK    = 0x00007000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__BARRIERS_MASK = 0x00078000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__LDS_MASK      = 0x00000f00L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__SGPR_MASK     = 0x000000f0L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__VGPR_MASK     = 0x0000000fL;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__WAVES_MASK    = 0x00007000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__BARRIERS_MASK = 0x00078000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__LDS_MASK      = 0x00000f00L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__SGPR_MASK     = 0x000000f0L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__VGPR_MASK     = 0x0000000fL;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__WAVES_MASK    = 0x00007000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__BARRIERS_MASK = 0x00078000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__LDS_MASK      = 0x00000f00L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__SGPR_MASK     = 0x000000f0L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__VGPR_MASK     = 0x0000000fL;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__WAVES_MASK    = 0x00007000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__BARRIERS_MASK = 0x00078000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__LDS_MASK      = 0x00000f00L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__SGPR_MASK     = 0x000000f0L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__VGPR_MASK     = 0x0000000fL;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__WAVES_MASK    = 0x00007000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__BARRIERS_MASK = 0x00078000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__LDS_MASK      = 0x00000f00L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__SGPR_MASK     = 0x000000f0L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__VGPR_MASK     = 0x0000000fL;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__WAVES_MASK    = 0x00007000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__BARRIERS_MASK = 0x00078000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__LDS_MASK      = 0x00000f00L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__SGPR_MASK     = 0x000000f0L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__VGPR_MASK     = 0x0000000fL;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__WAVES_MASK    = 0x00007000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__BARRIERS_MASK = 0x00078000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__LDS_MASK      = 0x00000f00L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__SGPR_MASK     = 0x000000f0L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__VGPR_MASK     = 0x0000000fL;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__WAVES_MASK    = 0x00007000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__BARRIERS_MASK = 0x00078000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__LDS_MASK      = 0x00000f00L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__SGPR_MASK     = 0x000000f0L;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__VGPR_MASK     = 0x0000000fL;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__WAVES_MASK    = 0x00007000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_0__EN_MASK    = 0x00000001L;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_0__QUEUE_MASK_MASK = 0x00ff0000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_0__TYPE_MASK_MASK = 0x0000fffeL;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_1__EN_MASK    = 0x00000001L;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_1__QUEUE_MASK_MASK = 0x00ff0000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_1__TYPE_MASK_MASK = 0x0000fffeL;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_2__EN_MASK    = 0x00000001L;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_2__QUEUE_MASK_MASK = 0x00ff0000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_2__TYPE_MASK_MASK = 0x0000fffeL;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_3__EN_MASK    = 0x00000001L;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_3__QUEUE_MASK_MASK = 0x00ff0000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_3__TYPE_MASK_MASK = 0x0000fffeL;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_4__EN_MASK    = 0x00000001L;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_4__QUEUE_MASK_MASK = 0x00ff0000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_4__TYPE_MASK_MASK = 0x0000fffeL;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_5__EN_MASK    = 0x00000001L;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_5__QUEUE_MASK_MASK = 0x00ff0000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_5__TYPE_MASK_MASK = 0x0000fffeL;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_6__EN_MASK    = 0x00000001L;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_6__QUEUE_MASK_MASK = 0x00ff0000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_6__TYPE_MASK_MASK = 0x0000fffeL;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_7__EN_MASK    = 0x00000001L;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_7__QUEUE_MASK_MASK = 0x00ff0000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_7__TYPE_MASK_MASK = 0x0000fffeL;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_8__EN_MASK    = 0x00000001L;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_8__QUEUE_MASK_MASK = 0x00ff0000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_8__TYPE_MASK_MASK = 0x0000fffeL;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_9__EN_MASK    = 0x00000001L;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_9__QUEUE_MASK_MASK = 0x00ff0000L;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_9__TYPE_MASK_MASK = 0x0000fffeL;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL0_EXPORT_FORMAT_MASK = 0x0000000fL;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL1_EXPORT_FORMAT_MASK = 0x000000f0L;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL2_EXPORT_FORMAT_MASK = 0x00000f00L;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL3_EXPORT_FORMAT_MASK = 0x0000f000L;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL4_EXPORT_FORMAT_MASK = 0x000f0000L;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL5_EXPORT_FORMAT_MASK = 0x00f00000L;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL6_EXPORT_FORMAT_MASK = 0x0f000000L;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL7_EXPORT_FORMAT_MASK = 0xf0000000L;
constexpr unsigned int SPI_SHADER_LATE_ALLOC_VS__LIMIT_MASK     = 0x0000003fL;
constexpr unsigned int SPI_SHADER_PGM_HI_ES__MEM_BASE_MASK      = 0x000000ffL;
constexpr unsigned int SPI_SHADER_PGM_HI_GS__MEM_BASE_MASK      = 0x000000ffL;
constexpr unsigned int SPI_SHADER_PGM_HI_HS__MEM_BASE_MASK      = 0x000000ffL;
constexpr unsigned int SPI_SHADER_PGM_HI_LS__MEM_BASE_MASK      = 0x000000ffL;
constexpr unsigned int SPI_SHADER_PGM_HI_PS__MEM_BASE_MASK      = 0x000000ffL;
constexpr unsigned int SPI_SHADER_PGM_HI_VS__MEM_BASE_MASK      = 0x000000ffL;
constexpr unsigned int SPI_SHADER_PGM_LO_ES__MEM_BASE_MASK      = 0xffffffffL;
constexpr unsigned int SPI_SHADER_PGM_LO_GS__MEM_BASE_MASK      = 0xffffffffL;
constexpr unsigned int SPI_SHADER_PGM_LO_HS__MEM_BASE_MASK      = 0xffffffffL;
constexpr unsigned int SPI_SHADER_PGM_LO_LS__MEM_BASE_MASK      = 0xffffffffL;
constexpr unsigned int SPI_SHADER_PGM_LO_PS__MEM_BASE_MASK      = 0xffffffffL;
constexpr unsigned int SPI_SHADER_PGM_LO_VS__MEM_BASE_MASK      = 0xffffffffL;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__CDBG_USER_MASK  = 0x10000000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__CU_GROUP_ENABLE_MASK = 0x01000000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__DEBUG_MODE_MASK = 0x00400000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__DX10_CLAMP_MASK = 0x00200000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__FLOAT_MODE_MASK = 0x000ff000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__FP16_OVFL_MASK  = 0x80000000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__GS_VGPR_COMP_CNT_MASK = 0x60000000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__IEEE_MODE_MASK  = 0x00800000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__PRIORITY_MASK   = 0x00000c00L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__PRIV_MASK       = 0x00100000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__SGPRS_MASK      = 0x000003c0L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__VGPRS_MASK      = 0x0000003fL;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__CDBG_USER_MASK  = 0x08000000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__DEBUG_MODE_MASK = 0x00400000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__DX10_CLAMP_MASK = 0x00200000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__FLOAT_MODE_MASK = 0x000ff000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__FP16_OVFL_MASK  = 0x40000000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__IEEE_MODE_MASK  = 0x00800000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__LS_VGPR_COMP_CNT_MASK = 0x30000000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__PRIORITY_MASK   = 0x00000c00L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__PRIV_MASK       = 0x00100000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__SGPRS_MASK      = 0x000003c0L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__VGPRS_MASK      = 0x0000003fL;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__CDBG_USER_MASK  = 0x10000000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__CU_GROUP_DISABLE_MASK = 0x01000000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__DEBUG_MODE_MASK = 0x00400000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__DX10_CLAMP_MASK = 0x00200000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__FLOAT_MODE_MASK = 0x000ff000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__FP16_OVFL_MASK  = 0x20000000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__IEEE_MODE_MASK  = 0x00800000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__PRIORITY_MASK   = 0x00000c00L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__PRIV_MASK       = 0x00100000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__SGPRS_MASK      = 0x000003c0L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__VGPRS_MASK      = 0x0000003fL;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__CDBG_USER_MASK  = 0x40000000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__CU_GROUP_ENABLE_MASK = 0x04000000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__DEBUG_MODE_MASK = 0x00400000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__DX10_CLAMP_MASK = 0x00200000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__FLOAT_MODE_MASK = 0x000ff000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__FP16_OVFL_MASK  = 0x80000000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__IEEE_MODE_MASK  = 0x00800000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__PRIORITY_MASK   = 0x00000c00L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__PRIV_MASK       = 0x00100000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__SGPRS_MASK      = 0x000003c0L;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__VGPRS_MASK      = 0x0000003fL;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__VGPR_COMP_CNT_MASK = 0x03000000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__EXCP_EN_MASK = 0x0000ff80L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__LDS_SIZE_MASK = 0x07f80000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__OC_LDS_EN_MASK = 0x00040000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__SCRATCH_EN_MASK = 0x00000001L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__SKIP_USGPR0_MASK = 0x08000000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__TRAP_PRESENT_MASK = 0x00000040L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__USER_SGPR_MASK = 0x0000003eL;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__USER_SGPR_MSB_MASK = 0x10000000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__VGPR_COMP_CNT_MASK = 0x00030000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__ES_VGPR_COMP_CNT_MASK = 0x00030000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__EXCP_EN_MASK    = 0x0000ff80L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__LDS_SIZE_MASK   = 0x07f80000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__OC_LDS_EN_MASK  = 0x00040000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__SCRATCH_EN_MASK = 0x00000001L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__TRAP_PRESENT_MASK = 0x00000040L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__USER_SGPR_MASK  = 0x0000003eL;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__SCRATCH_EN_MASK = 0x00000001L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__TRAP_PRESENT_MASK = 0x00000040L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__USER_SGPR_MASK  = 0x0000003eL;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__EXCP_EN_MASK    = 0x01ff0000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__EXTRA_LDS_SIZE_MASK = 0x0000ff00L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__LOAD_COLLISION_WAVEID_MASK = 0x02000000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__LOAD_INTRAWAVE_COLLISION_MASK = 0x04000000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__SCRATCH_EN_MASK = 0x00000001L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__TRAP_PRESENT_MASK = 0x00000040L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__USER_SGPR_MASK  = 0x0000003eL;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__WAVE_CNT_EN_MASK = 0x00000080L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__EXCP_EN_MASK    = 0x003fe000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__OC_LDS_EN_MASK  = 0x00000080L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__PC_BASE_EN_MASK = 0x00400000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__SCRATCH_EN_MASK = 0x00000001L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__SO_BASE0_EN_MASK = 0x00000100L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__SO_BASE1_EN_MASK = 0x00000200L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__SO_BASE2_EN_MASK = 0x00000400L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__SO_BASE3_EN_MASK = 0x00000800L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__SO_EN_MASK      = 0x00001000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__TRAP_PRESENT_MASK = 0x00000040L;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__USER_SGPR_MASK  = 0x0000003eL;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_GS__CU_EN_MASK      = 0x0000ffffL;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_GS__LOCK_LOW_THRESHOLD_MASK = 0x03c00000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_GS__WAVE_LIMIT_MASK = 0x003f0000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_HS__CU_EN_MASK      = 0xffff0000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_HS__LOCK_LOW_THRESHOLD_MASK = 0x000003c0L;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_HS__WAVE_LIMIT_MASK = 0x0000003fL;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_PS__CU_EN_MASK      = 0x0000ffffL;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_PS__LOCK_LOW_THRESHOLD_MASK = 0x03c00000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_PS__WAVE_LIMIT_MASK = 0x003f0000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_VS__CU_EN_MASK      = 0x0000ffffL;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_VS__LOCK_LOW_THRESHOLD_MASK = 0x03c00000L;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_VS__WAVE_LIMIT_MASK = 0x003f0000L;
constexpr unsigned int SPI_SHADER_POS_FORMAT__POS0_EXPORT_FORMAT_MASK = 0x0000000fL;
constexpr unsigned int SPI_SHADER_POS_FORMAT__POS1_EXPORT_FORMAT_MASK = 0x000000f0L;
constexpr unsigned int SPI_SHADER_POS_FORMAT__POS2_EXPORT_FORMAT_MASK = 0x00000f00L;
constexpr unsigned int SPI_SHADER_POS_FORMAT__POS3_EXPORT_FORMAT_MASK = 0x0000f000L;
constexpr unsigned int SPI_SHADER_USER_DATA_ADDR_HI_GS__MEM_BASE_MASK = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_ADDR_HI_HS__MEM_BASE_MASK = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_ADDR_LO_GS__MEM_BASE_MASK = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_ADDR_LO_HS__MEM_BASE_MASK = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_0__DATA_MASK     = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_1__DATA_MASK     = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_2__DATA_MASK     = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_3__DATA_MASK     = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_4__DATA_MASK     = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_5__DATA_MASK     = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_6__DATA_MASK     = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_7__DATA_MASK     = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_8__DATA_MASK     = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_9__DATA_MASK     = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_10__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_11__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_12__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_13__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_14__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_15__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_16__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_17__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_18__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_19__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_20__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_21__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_22__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_23__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_24__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_25__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_26__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_27__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_28__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_29__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_30__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_31__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_0__DATA_MASK     = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_1__DATA_MASK     = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_2__DATA_MASK     = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_3__DATA_MASK     = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_4__DATA_MASK     = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_5__DATA_MASK     = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_6__DATA_MASK     = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_7__DATA_MASK     = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_8__DATA_MASK     = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_9__DATA_MASK     = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_10__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_11__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_12__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_13__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_14__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_15__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_16__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_17__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_18__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_19__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_20__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_21__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_22__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_23__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_24__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_25__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_26__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_27__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_28__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_29__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_30__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_31__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SPI_SHADER_Z_FORMAT__Z_EXPORT_FORMAT_MASK = 0x0000000fL;
constexpr unsigned int SPI_SX_EXPORT_BUFFER_SIZES__COLOR_BUFFER_SIZE_MASK = 0x0000ffffL;
constexpr unsigned int SPI_SX_EXPORT_BUFFER_SIZES__POSITION_BUFFER_SIZE_MASK = 0xffff0000L;
constexpr unsigned int SPI_SX_SCOREBOARD_BUFFER_SIZES__COLOR_SCOREBOARD_SIZE_MASK = 0x0000ffffL;
constexpr unsigned int SPI_SX_SCOREBOARD_BUFFER_SIZES__POSITION_SCOREBOARD_SIZE_MASK = 0xffff0000L;
constexpr unsigned int SPI_TMPRING_SIZE__WAVESIZE_MASK          = 0x01fff000L;
constexpr unsigned int SPI_TMPRING_SIZE__WAVES_MASK             = 0x00000fffL;
constexpr unsigned int SPI_VS_OUT_CONFIG__VS_EXPORT_COUNT_MASK  = 0x0000003eL;
constexpr unsigned int SPI_VS_OUT_CONFIG__VS_HALF_PACK_MASK     = 0x00000040L;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS0__VALUE_MASK     = 0x0000007fL;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS1__VALUE_MASK     = 0x0000007fL;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS2__VALUE_MASK     = 0x0000007fL;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS3__VALUE_MASK     = 0x0000007fL;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__GS_GRP_VALUE_MASK = 0x07c00000L;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__HS_GRP_VALUE_MASK = 0x0001f000L;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__VALUE_MASK     = 0x0000007fL;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_HP3D__GS_GRP_VALUE_MASK = 0x07c00000L;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_HP3D__HS_GRP_VALUE_MASK = 0x0001f000L;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_HP3D__VALUE_MASK    = 0x0000007fL;
constexpr unsigned int SPI_WF_LIFETIME_CNTL__EN_MASK            = 0x00000010L;
constexpr unsigned int SPI_WF_LIFETIME_CNTL__SAMPLE_PERIOD_MASK = 0x0000000fL;
constexpr unsigned int SPI_WF_LIFETIME_DEBUG__OVERRIDE_EN_MASK  = 0x80000000L;
constexpr unsigned int SPI_WF_LIFETIME_DEBUG__START_VALUE_MASK  = 0x7fffffffL;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_0__EN_WARN_MASK    = 0x80000000L;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_0__MAX_CNT_MASK    = 0x7fffffffL;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_1__EN_WARN_MASK    = 0x80000000L;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_1__MAX_CNT_MASK    = 0x7fffffffL;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_2__EN_WARN_MASK    = 0x80000000L;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_2__MAX_CNT_MASK    = 0x7fffffffL;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_3__EN_WARN_MASK    = 0x80000000L;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_3__MAX_CNT_MASK    = 0x7fffffffL;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_4__EN_WARN_MASK    = 0x80000000L;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_4__MAX_CNT_MASK    = 0x7fffffffL;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_5__EN_WARN_MASK    = 0x80000000L;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_5__MAX_CNT_MASK    = 0x7fffffffL;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_0__INT_SENT_MASK  = 0x80000000L;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_0__MAX_CNT_MASK   = 0x7fffffffL;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_1__INT_SENT_MASK  = 0x80000000L;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_1__MAX_CNT_MASK   = 0x7fffffffL;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_2__INT_SENT_MASK  = 0x80000000L;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_2__MAX_CNT_MASK   = 0x7fffffffL;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_4__INT_SENT_MASK  = 0x80000000L;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_4__MAX_CNT_MASK   = 0x7fffffffL;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_6__INT_SENT_MASK  = 0x80000000L;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_6__MAX_CNT_MASK   = 0x7fffffffL;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_7__INT_SENT_MASK  = 0x80000000L;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_7__MAX_CNT_MASK   = 0x7fffffffL;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_8__INT_SENT_MASK  = 0x80000000L;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_8__MAX_CNT_MASK   = 0x7fffffffL;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_9__INT_SENT_MASK  = 0x80000000L;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_9__MAX_CNT_MASK   = 0x7fffffffL;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_11__INT_SENT_MASK = 0x80000000L;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_11__MAX_CNT_MASK  = 0x7fffffffL;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_13__INT_SENT_MASK = 0x80000000L;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_13__MAX_CNT_MASK  = 0x7fffffffL;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_14__INT_SENT_MASK = 0x80000000L;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_14__MAX_CNT_MASK  = 0x7fffffffL;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_15__INT_SENT_MASK = 0x80000000L;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_15__MAX_CNT_MASK  = 0x7fffffffL;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_16__INT_SENT_MASK = 0x80000000L;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_16__MAX_CNT_MASK  = 0x7fffffffL;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_17__INT_SENT_MASK = 0x80000000L;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_17__MAX_CNT_MASK  = 0x7fffffffL;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_18__INT_SENT_MASK = 0x80000000L;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_18__MAX_CNT_MASK  = 0x7fffffffL;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_19__INT_SENT_MASK = 0x80000000L;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_19__MAX_CNT_MASK  = 0x7fffffffL;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_20__INT_SENT_MASK = 0x80000000L;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_20__MAX_CNT_MASK  = 0x7fffffffL;
constexpr unsigned int SQC_CACHES__COMPLETE_MASK                = 0x00010000L;
constexpr unsigned int SQC_CACHES__INVALIDATE_MASK              = 0x00000004L;
constexpr unsigned int SQC_CACHES__TARGET_DATA_MASK             = 0x00000002L;
constexpr unsigned int SQC_CACHES__TARGET_INST_MASK             = 0x00000001L;
constexpr unsigned int SQC_CONFIG__DATA_CACHE_SIZE_MASK         = 0x0000000cL;
constexpr unsigned int SQC_CONFIG__EVICT_LRU_MASK               = 0x00003000L;
constexpr unsigned int SQC_CONFIG__FORCE_1_BANK_MASK            = 0x00008000L;
constexpr unsigned int SQC_CONFIG__FORCE_2_BANK_MASK            = 0x00004000L;
constexpr unsigned int SQC_CONFIG__FORCE_ALWAYS_MISS_MASK       = 0x00000080L;
constexpr unsigned int SQC_CONFIG__FORCE_IN_ORDER_MASK          = 0x00000100L;
constexpr unsigned int SQC_CONFIG__HIT_FIFO_DEPTH_MASK          = 0x00000040L;
constexpr unsigned int SQC_CONFIG__IDENTITY_HASH_SET_MASK       = 0x00000400L;
constexpr unsigned int SQC_CONFIG__INST_CACHE_SIZE_MASK         = 0x00000003L;
constexpr unsigned int SQC_CONFIG__LS_DISABLE_CLOCKS_MASK       = 0x00ff0000L;
constexpr unsigned int SQC_CONFIG__MISS_FIFO_DEPTH_MASK         = 0x00000030L;
constexpr unsigned int SQC_CONFIG__PER_VMID_INV_DISABLE_MASK    = 0x00000800L;
constexpr unsigned int SQ_CMD__CHECK_VMID_MASK                  = 0x00000080L;
constexpr unsigned int SQ_CMD__DATA_MASK                        = 0x00000f00L;
constexpr unsigned int SQ_CMD__MODE_MASK                        = 0x00000070L;
constexpr unsigned int SQ_CMD__QUEUE_ID_MASK                    = 0x07000000L;
constexpr unsigned int SQ_CMD__VM_ID_MASK                       = 0xf0000000L;
constexpr unsigned int SQ_CONFIG__DISABLE_SP_REDUNDANT_THREAD_GATING_MASK = 0x20000000L;
constexpr unsigned int SQ_CONFIG__ENABLE_HIPRIO_ON_EXP_RDY_VS_MASK = 0x00040000L;
constexpr unsigned int SQ_CONFIG__PRIO_VAL_ON_EXP_RDY_VS_MASK   = 0x00180000L;
constexpr unsigned int SQ_DEBUG_CTRL_LOCAL__UNUSED_MASK         = 0x000000ffL;
constexpr unsigned int SQ_DEBUG_STS_GLOBAL__BUSY_MASK           = 0x00000001L;
constexpr unsigned int SQ_DEBUG_STS_LOCAL__BUSY_MASK            = 0x00000001L;
constexpr unsigned int SQ_DEBUG_STS_LOCAL__WAVE_LEVEL_MASK      = 0x000003f0L;
constexpr unsigned int SQ_DSM_CNTL2__LDS_D_ENABLE_ERROR_INJECT_MASK = 0x00000018L;
constexpr unsigned int SQ_DSM_CNTL2__LDS_D_SELECT_INJECT_DELAY_MASK = 0x00000020L;
constexpr unsigned int SQ_DSM_CNTL2__LDS_INJECT_DELAY_MASK      = 0x000fc000L;
constexpr unsigned int SQ_DSM_CNTL2__LDS_I_ENABLE_ERROR_INJECT_MASK = 0x000000c0L;
constexpr unsigned int SQ_DSM_CNTL2__LDS_I_SELECT_INJECT_DELAY_MASK = 0x00000100L;
constexpr unsigned int SQ_DSM_CNTL2__SGPR_ENABLE_ERROR_INJECT_MASK = 0x00000003L;
constexpr unsigned int SQ_DSM_CNTL2__SGPR_SELECT_INJECT_DELAY_MASK = 0x00000004L;
constexpr unsigned int SQ_DSM_CNTL2__SP_ENABLE_ERROR_INJECT_MASK = 0x00000600L;
constexpr unsigned int SQ_DSM_CNTL2__SP_INJECT_DELAY_MASK       = 0x03f00000L;
constexpr unsigned int SQ_DSM_CNTL2__SP_SELECT_INJECT_DELAY_MASK = 0x00000800L;
constexpr unsigned int SQ_DSM_CNTL2__SQ_INJECT_DELAY_MASK       = 0xfc000000L;
constexpr unsigned int SQ_DSM_CNTL__LDS_ENABLE_SINGLE_WRITE01_MASK = 0x00040000L;
constexpr unsigned int SQ_DSM_CNTL__LDS_ENABLE_SINGLE_WRITE23_MASK = 0x00200000L;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_LDS_IRRITATOR_DATA0_MASK = 0x00010000L;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_LDS_IRRITATOR_DATA1_MASK = 0x00020000L;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_LDS_IRRITATOR_DATA2_MASK = 0x00080000L;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_LDS_IRRITATOR_DATA3_MASK = 0x00100000L;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_SGPR_IRRITATOR_DATA0_MASK = 0x00000100L;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_SGPR_IRRITATOR_DATA1_MASK = 0x00000200L;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_SP_IRRITATOR_DATA0_MASK = 0x01000000L;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_SP_IRRITATOR_DATA1_MASK = 0x02000000L;
constexpr unsigned int SQ_DSM_CNTL__SGPR_ENABLE_SINGLE_WRITE_MASK = 0x00000400L;
constexpr unsigned int SQ_DSM_CNTL__SPI_BACKPRESSURE_0_MASK     = 0x00000004L;
constexpr unsigned int SQ_DSM_CNTL__SPI_BACKPRESSURE_1_MASK     = 0x00000008L;
constexpr unsigned int SQ_DSM_CNTL__SP_ENABLE_SINGLE_WRITE_MASK = 0x04000000L;
constexpr unsigned int SQ_DSM_CNTL__WAVEFRONT_STALL_0_MASK      = 0x00000001L;
constexpr unsigned int SQ_DSM_CNTL__WAVEFRONT_STALL_1_MASK      = 0x00000002L;
constexpr unsigned int SQ_EDC_CNT__LDS_D_DED_COUNT_MASK         = 0x0000000cL;
constexpr unsigned int SQ_EDC_CNT__LDS_D_SEC_COUNT_MASK         = 0x00000003L;
constexpr unsigned int SQ_EDC_CNT__LDS_I_DED_COUNT_MASK         = 0x000000c0L;
constexpr unsigned int SQ_EDC_CNT__LDS_I_SEC_COUNT_MASK         = 0x00000030L;
constexpr unsigned int SQ_EDC_CNT__SGPR_DED_COUNT_MASK          = 0x00000c00L;
constexpr unsigned int SQ_EDC_CNT__SGPR_SEC_COUNT_MASK          = 0x00000300L;
constexpr unsigned int SQ_EDC_CNT__VGPR0_DED_COUNT_MASK         = 0x0000c000L;
constexpr unsigned int SQ_EDC_CNT__VGPR0_SEC_COUNT_MASK         = 0x00003000L;
constexpr unsigned int SQ_EDC_CNT__VGPR1_DED_COUNT_MASK         = 0x000c0000L;
constexpr unsigned int SQ_EDC_CNT__VGPR1_SEC_COUNT_MASK         = 0x00030000L;
constexpr unsigned int SQ_EDC_CNT__VGPR2_DED_COUNT_MASK         = 0x00c00000L;
constexpr unsigned int SQ_EDC_CNT__VGPR2_SEC_COUNT_MASK         = 0x00300000L;
constexpr unsigned int SQ_EDC_CNT__VGPR3_DED_COUNT_MASK         = 0x0c000000L;
constexpr unsigned int SQ_EDC_CNT__VGPR3_SEC_COUNT_MASK         = 0x03000000L;
constexpr unsigned int SQ_EDC_FUE_CNTL__BLOCK_FUE_FLAGS_MASK    = 0x0000ffffL;
constexpr unsigned int SQ_EDC_FUE_CNTL__FUE_INTERRUPT_ENABLES_MASK = 0xffff0000L;
constexpr unsigned int SQ_FIFO_SIZES__INTERRUPT_FIFO_SIZE_MASK  = 0x0000000fL;
constexpr unsigned int SQ_FIFO_SIZES__VMEM_DATA_FIFO_SIZE_MASK  = 0x000c0000L;
constexpr unsigned int SQ_IND_DATA__DATA_MASK                   = 0xffffffffL;
constexpr unsigned int SQ_IND_INDEX__INDEX_MASK                 = 0xffff0000L;
constexpr unsigned int SQ_INTERRUPT_AUTO_MASK__MASK_MASK        = 0x00ffffffL;
constexpr unsigned int SQ_INTERRUPT_MSG_CTRL__STALL_MASK        = 0x00000001L;
constexpr unsigned int SQ_LB_CTR_CTRL__CLEAR_MASK               = 0x00000004L;
constexpr unsigned int SQ_LB_CTR_CTRL__LOAD_MASK                = 0x00000002L;
constexpr unsigned int SQ_LB_CTR_CTRL__START_MASK               = 0x00000001L;
constexpr unsigned int SQ_LB_DATA0__DATA_MASK                   = 0xffffffffL;
constexpr unsigned int SQ_LB_DATA1__DATA_MASK                   = 0xffffffffL;
constexpr unsigned int SQ_LB_DATA2__DATA_MASK                   = 0xffffffffL;
constexpr unsigned int SQ_LB_DATA3__DATA_MASK                   = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER0_SELECT__PERF_MODE_MASK   = 0xf0000000L;
constexpr unsigned int SQ_PERFCOUNTER0_SELECT__PERF_SEL_MASK    = 0x000001ffL;
constexpr unsigned int SQ_PERFCOUNTER0_SELECT__SPM_MODE_MASK    = 0x00f00000L;
constexpr unsigned int SQ_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER1_SELECT__PERF_MODE_MASK   = 0xf0000000L;
constexpr unsigned int SQ_PERFCOUNTER1_SELECT__PERF_SEL_MASK    = 0x000001ffL;
constexpr unsigned int SQ_PERFCOUNTER1_SELECT__SPM_MODE_MASK    = 0x00f00000L;
constexpr unsigned int SQ_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER2_SELECT__PERF_MODE_MASK   = 0xf0000000L;
constexpr unsigned int SQ_PERFCOUNTER2_SELECT__PERF_SEL_MASK    = 0x000001ffL;
constexpr unsigned int SQ_PERFCOUNTER2_SELECT__SPM_MODE_MASK    = 0x00f00000L;
constexpr unsigned int SQ_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER3_SELECT__PERF_MODE_MASK   = 0xf0000000L;
constexpr unsigned int SQ_PERFCOUNTER3_SELECT__PERF_SEL_MASK    = 0x000001ffL;
constexpr unsigned int SQ_PERFCOUNTER3_SELECT__SPM_MODE_MASK    = 0x00f00000L;
constexpr unsigned int SQ_PERFCOUNTER4_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER4_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER4_SELECT__PERF_MODE_MASK   = 0xf0000000L;
constexpr unsigned int SQ_PERFCOUNTER4_SELECT__PERF_SEL_MASK    = 0x000001ffL;
constexpr unsigned int SQ_PERFCOUNTER4_SELECT__SPM_MODE_MASK    = 0x00f00000L;
constexpr unsigned int SQ_PERFCOUNTER5_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER5_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER5_SELECT__PERF_MODE_MASK   = 0xf0000000L;
constexpr unsigned int SQ_PERFCOUNTER5_SELECT__PERF_SEL_MASK    = 0x000001ffL;
constexpr unsigned int SQ_PERFCOUNTER5_SELECT__SPM_MODE_MASK    = 0x00f00000L;
constexpr unsigned int SQ_PERFCOUNTER6_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER6_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER6_SELECT__PERF_MODE_MASK   = 0xf0000000L;
constexpr unsigned int SQ_PERFCOUNTER6_SELECT__PERF_SEL_MASK    = 0x000001ffL;
constexpr unsigned int SQ_PERFCOUNTER6_SELECT__SPM_MODE_MASK    = 0x00f00000L;
constexpr unsigned int SQ_PERFCOUNTER7_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER7_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER7_SELECT__PERF_MODE_MASK   = 0xf0000000L;
constexpr unsigned int SQ_PERFCOUNTER7_SELECT__PERF_SEL_MASK    = 0x000001ffL;
constexpr unsigned int SQ_PERFCOUNTER7_SELECT__SPM_MODE_MASK    = 0x00f00000L;
constexpr unsigned int SQ_PERFCOUNTER8_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER8_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER8_SELECT__PERF_MODE_MASK   = 0xf0000000L;
constexpr unsigned int SQ_PERFCOUNTER8_SELECT__PERF_SEL_MASK    = 0x000001ffL;
constexpr unsigned int SQ_PERFCOUNTER8_SELECT__SPM_MODE_MASK    = 0x00f00000L;
constexpr unsigned int SQ_PERFCOUNTER9_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER9_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER9_SELECT__PERF_MODE_MASK   = 0xf0000000L;
constexpr unsigned int SQ_PERFCOUNTER9_SELECT__PERF_SEL_MASK    = 0x000001ffL;
constexpr unsigned int SQ_PERFCOUNTER9_SELECT__SPM_MODE_MASK    = 0x00f00000L;
constexpr unsigned int SQ_PERFCOUNTER10_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER10_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER10_SELECT__PERF_MODE_MASK  = 0xf0000000L;
constexpr unsigned int SQ_PERFCOUNTER10_SELECT__PERF_SEL_MASK   = 0x000001ffL;
constexpr unsigned int SQ_PERFCOUNTER10_SELECT__SPM_MODE_MASK   = 0x00f00000L;
constexpr unsigned int SQ_PERFCOUNTER11_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER11_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER11_SELECT__PERF_MODE_MASK  = 0xf0000000L;
constexpr unsigned int SQ_PERFCOUNTER11_SELECT__PERF_SEL_MASK   = 0x000001ffL;
constexpr unsigned int SQ_PERFCOUNTER11_SELECT__SPM_MODE_MASK   = 0x00f00000L;
constexpr unsigned int SQ_PERFCOUNTER12_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER12_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER12_SELECT__PERF_MODE_MASK  = 0xf0000000L;
constexpr unsigned int SQ_PERFCOUNTER12_SELECT__PERF_SEL_MASK   = 0x000001ffL;
constexpr unsigned int SQ_PERFCOUNTER12_SELECT__SPM_MODE_MASK   = 0x00f00000L;
constexpr unsigned int SQ_PERFCOUNTER13_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER13_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER13_SELECT__PERF_MODE_MASK  = 0xf0000000L;
constexpr unsigned int SQ_PERFCOUNTER13_SELECT__PERF_SEL_MASK   = 0x000001ffL;
constexpr unsigned int SQ_PERFCOUNTER13_SELECT__SPM_MODE_MASK   = 0x00f00000L;
constexpr unsigned int SQ_PERFCOUNTER14_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER14_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER14_SELECT__PERF_MODE_MASK  = 0xf0000000L;
constexpr unsigned int SQ_PERFCOUNTER14_SELECT__PERF_SEL_MASK   = 0x000001ffL;
constexpr unsigned int SQ_PERFCOUNTER14_SELECT__SPM_MODE_MASK   = 0x00f00000L;
constexpr unsigned int SQ_PERFCOUNTER15_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER15_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int SQ_PERFCOUNTER15_SELECT__PERF_MODE_MASK  = 0xf0000000L;
constexpr unsigned int SQ_PERFCOUNTER15_SELECT__PERF_SEL_MASK   = 0x000001ffL;
constexpr unsigned int SQ_PERFCOUNTER15_SELECT__SPM_MODE_MASK   = 0x00f00000L;
constexpr unsigned int SQ_PERFCOUNTER_CTRL2__FORCE_EN_MASK      = 0x00000001L;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__CS_EN_MASK          = 0x00000040L;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__DISABLE_FLUSH_MASK  = 0x00002000L;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__ES_EN_MASK          = 0x00000008L;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__GS_EN_MASK          = 0x00000004L;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__HS_EN_MASK          = 0x00000010L;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__LS_EN_MASK          = 0x00000020L;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__PS_EN_MASK          = 0x00000001L;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__VS_EN_MASK          = 0x00000002L;
constexpr unsigned int SQ_RANDOM_WAVE_PRI__RET_MASK             = 0x0000007fL;
constexpr unsigned int SQ_RANDOM_WAVE_PRI__RUI_MASK             = 0x00000380L;
constexpr unsigned int SQ_SHADER_TBA_HI__ADDR_HI_MASK           = 0x000000ffL;
constexpr unsigned int SQ_SHADER_TBA_LO__ADDR_LO_MASK           = 0xffffffffL;
constexpr unsigned int SQ_SHADER_TMA_HI__ADDR_HI_MASK           = 0x000000ffL;
constexpr unsigned int SQ_SHADER_TMA_LO__ADDR_LO_MASK           = 0xffffffffL;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_0__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_1__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_2__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_3__DATA_MASK    = 0xffffffffL;
constexpr unsigned int SQ_TIME_HI__TIME_MASK                    = 0xffffffffL;
constexpr unsigned int SQ_TIME_LO__TIME_MASK                    = 0xffffffffL;
constexpr unsigned int SQ_WREXEC_EXEC_HI__ADDR_HI_MASK          = 0x0000ffffL;
constexpr unsigned int SQ_WREXEC_EXEC_HI__FIRST_WAVE_MASK       = 0x04000000L;
constexpr unsigned int SQ_WREXEC_EXEC_HI__MSB_MASK              = 0x80000000L;
constexpr unsigned int SQ_WREXEC_EXEC_HI__MTYPE_MASK            = 0x70000000L;
constexpr unsigned int SQ_WREXEC_EXEC_LO__ADDR_LO_MASK          = 0xffffffffL;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT0_ALPHA_OPT_DISABLE_MASK = 0x00000002L;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT0_COLOR_OPT_DISABLE_MASK = 0x00000001L;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT1_ALPHA_OPT_DISABLE_MASK = 0x00000020L;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT1_COLOR_OPT_DISABLE_MASK = 0x00000010L;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT2_ALPHA_OPT_DISABLE_MASK = 0x00000200L;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT2_COLOR_OPT_DISABLE_MASK = 0x00000100L;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT3_ALPHA_OPT_DISABLE_MASK = 0x00002000L;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT3_COLOR_OPT_DISABLE_MASK = 0x00001000L;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT4_ALPHA_OPT_DISABLE_MASK = 0x00020000L;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT4_COLOR_OPT_DISABLE_MASK = 0x00010000L;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT5_ALPHA_OPT_DISABLE_MASK = 0x00200000L;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT5_COLOR_OPT_DISABLE_MASK = 0x00100000L;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT6_ALPHA_OPT_DISABLE_MASK = 0x02000000L;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT6_COLOR_OPT_DISABLE_MASK = 0x01000000L;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT7_ALPHA_OPT_DISABLE_MASK = 0x20000000L;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT7_COLOR_OPT_DISABLE_MASK = 0x10000000L;
constexpr unsigned int SX_BLEND_OPT_CONTROL__PIXEN_ZERO_OPT_DISABLE_MASK = 0x80000000L;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT0_EPSILON_MASK  = 0x0000000fL;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT1_EPSILON_MASK  = 0x000000f0L;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT2_EPSILON_MASK  = 0x00000f00L;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT3_EPSILON_MASK  = 0x0000f000L;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT4_EPSILON_MASK  = 0x000f0000L;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT5_EPSILON_MASK  = 0x00f00000L;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT6_EPSILON_MASK  = 0x0f000000L;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT7_EPSILON_MASK  = 0xf0000000L;
constexpr unsigned int SX_DEBUG_1__DISABLE_BLEND_OPT_BYPASS_MASK = 0x00000200L;
constexpr unsigned int SX_DEBUG_1__DISABLE_BLEND_OPT_DISCARD_PIXEL_MASK = 0x00000400L;
constexpr unsigned int SX_DEBUG_1__DISABLE_BLEND_OPT_DONT_RD_DST_MASK = 0x00000100L;
constexpr unsigned int SX_DEBUG_1__DISABLE_PIX_EN_ZERO_OPT_MASK = 0x00001000L;
constexpr unsigned int SX_DEBUG_1__DISABLE_QUAD_PAIR_OPT_MASK   = 0x00000800L;
constexpr unsigned int SX_DEBUG_1__SX_DB_QUAD_CREDIT_MASK       = 0x0000007fL;
constexpr unsigned int SX_MRT0_BLEND_OPT__ALPHA_COMB_FCN_MASK   = 0x07000000L;
constexpr unsigned int SX_MRT0_BLEND_OPT__ALPHA_DST_OPT_MASK    = 0x00700000L;
constexpr unsigned int SX_MRT0_BLEND_OPT__ALPHA_SRC_OPT_MASK    = 0x00070000L;
constexpr unsigned int SX_MRT0_BLEND_OPT__COLOR_COMB_FCN_MASK   = 0x00000700L;
constexpr unsigned int SX_MRT0_BLEND_OPT__COLOR_DST_OPT_MASK    = 0x00000070L;
constexpr unsigned int SX_MRT0_BLEND_OPT__COLOR_SRC_OPT_MASK    = 0x00000007L;
constexpr unsigned int SX_MRT1_BLEND_OPT__ALPHA_COMB_FCN_MASK   = 0x07000000L;
constexpr unsigned int SX_MRT1_BLEND_OPT__ALPHA_DST_OPT_MASK    = 0x00700000L;
constexpr unsigned int SX_MRT1_BLEND_OPT__ALPHA_SRC_OPT_MASK    = 0x00070000L;
constexpr unsigned int SX_MRT1_BLEND_OPT__COLOR_COMB_FCN_MASK   = 0x00000700L;
constexpr unsigned int SX_MRT1_BLEND_OPT__COLOR_DST_OPT_MASK    = 0x00000070L;
constexpr unsigned int SX_MRT1_BLEND_OPT__COLOR_SRC_OPT_MASK    = 0x00000007L;
constexpr unsigned int SX_MRT2_BLEND_OPT__ALPHA_COMB_FCN_MASK   = 0x07000000L;
constexpr unsigned int SX_MRT2_BLEND_OPT__ALPHA_DST_OPT_MASK    = 0x00700000L;
constexpr unsigned int SX_MRT2_BLEND_OPT__ALPHA_SRC_OPT_MASK    = 0x00070000L;
constexpr unsigned int SX_MRT2_BLEND_OPT__COLOR_COMB_FCN_MASK   = 0x00000700L;
constexpr unsigned int SX_MRT2_BLEND_OPT__COLOR_DST_OPT_MASK    = 0x00000070L;
constexpr unsigned int SX_MRT2_BLEND_OPT__COLOR_SRC_OPT_MASK    = 0x00000007L;
constexpr unsigned int SX_MRT3_BLEND_OPT__ALPHA_COMB_FCN_MASK   = 0x07000000L;
constexpr unsigned int SX_MRT3_BLEND_OPT__ALPHA_DST_OPT_MASK    = 0x00700000L;
constexpr unsigned int SX_MRT3_BLEND_OPT__ALPHA_SRC_OPT_MASK    = 0x00070000L;
constexpr unsigned int SX_MRT3_BLEND_OPT__COLOR_COMB_FCN_MASK   = 0x00000700L;
constexpr unsigned int SX_MRT3_BLEND_OPT__COLOR_DST_OPT_MASK    = 0x00000070L;
constexpr unsigned int SX_MRT3_BLEND_OPT__COLOR_SRC_OPT_MASK    = 0x00000007L;
constexpr unsigned int SX_MRT4_BLEND_OPT__ALPHA_COMB_FCN_MASK   = 0x07000000L;
constexpr unsigned int SX_MRT4_BLEND_OPT__ALPHA_DST_OPT_MASK    = 0x00700000L;
constexpr unsigned int SX_MRT4_BLEND_OPT__ALPHA_SRC_OPT_MASK    = 0x00070000L;
constexpr unsigned int SX_MRT4_BLEND_OPT__COLOR_COMB_FCN_MASK   = 0x00000700L;
constexpr unsigned int SX_MRT4_BLEND_OPT__COLOR_DST_OPT_MASK    = 0x00000070L;
constexpr unsigned int SX_MRT4_BLEND_OPT__COLOR_SRC_OPT_MASK    = 0x00000007L;
constexpr unsigned int SX_MRT5_BLEND_OPT__ALPHA_COMB_FCN_MASK   = 0x07000000L;
constexpr unsigned int SX_MRT5_BLEND_OPT__ALPHA_DST_OPT_MASK    = 0x00700000L;
constexpr unsigned int SX_MRT5_BLEND_OPT__ALPHA_SRC_OPT_MASK    = 0x00070000L;
constexpr unsigned int SX_MRT5_BLEND_OPT__COLOR_COMB_FCN_MASK   = 0x00000700L;
constexpr unsigned int SX_MRT5_BLEND_OPT__COLOR_DST_OPT_MASK    = 0x00000070L;
constexpr unsigned int SX_MRT5_BLEND_OPT__COLOR_SRC_OPT_MASK    = 0x00000007L;
constexpr unsigned int SX_MRT6_BLEND_OPT__ALPHA_COMB_FCN_MASK   = 0x07000000L;
constexpr unsigned int SX_MRT6_BLEND_OPT__ALPHA_DST_OPT_MASK    = 0x00700000L;
constexpr unsigned int SX_MRT6_BLEND_OPT__ALPHA_SRC_OPT_MASK    = 0x00070000L;
constexpr unsigned int SX_MRT6_BLEND_OPT__COLOR_COMB_FCN_MASK   = 0x00000700L;
constexpr unsigned int SX_MRT6_BLEND_OPT__COLOR_DST_OPT_MASK    = 0x00000070L;
constexpr unsigned int SX_MRT6_BLEND_OPT__COLOR_SRC_OPT_MASK    = 0x00000007L;
constexpr unsigned int SX_MRT7_BLEND_OPT__ALPHA_COMB_FCN_MASK   = 0x07000000L;
constexpr unsigned int SX_MRT7_BLEND_OPT__ALPHA_DST_OPT_MASK    = 0x00700000L;
constexpr unsigned int SX_MRT7_BLEND_OPT__ALPHA_SRC_OPT_MASK    = 0x00070000L;
constexpr unsigned int SX_MRT7_BLEND_OPT__COLOR_COMB_FCN_MASK   = 0x00000700L;
constexpr unsigned int SX_MRT7_BLEND_OPT__COLOR_DST_OPT_MASK    = 0x00000070L;
constexpr unsigned int SX_MRT7_BLEND_OPT__COLOR_SRC_OPT_MASK    = 0x00000007L;
constexpr unsigned int SX_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int SX_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int SX_PERFCOUNTER0_SELECT__CNTR_MODE_MASK   = 0x00f00000L;
constexpr unsigned int SX_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int SX_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int SX_PERFCOUNTER1_SELECT__CNTR_MODE_MASK   = 0x00f00000L;
constexpr unsigned int SX_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int SX_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int SX_PERFCOUNTER2_SELECT__CNTR_MODE_MASK   = 0x00f00000L;
constexpr unsigned int SX_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int SX_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int SX_PERFCOUNTER3_SELECT__CNTR_MODE_MASK   = 0x00f00000L;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT0_MASK             = 0x0000000fL;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT1_MASK             = 0x000000f0L;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT2_MASK             = 0x00000f00L;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT3_MASK             = 0x0000f000L;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT4_MASK             = 0x000f0000L;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT5_MASK             = 0x00f00000L;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT6_MASK             = 0x0f000000L;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT7_MASK             = 0xf0000000L;
constexpr unsigned int TA_BC_BASE_ADDR_HI__ADDRESS_MASK         = 0x000000ffL;
constexpr unsigned int TA_BC_BASE_ADDR__ADDRESS_MASK            = 0xffffffffL;
constexpr unsigned int TA_CGTT_CTRL__OFF_HYSTERESIS_MASK        = 0x00000ff0L;
constexpr unsigned int TA_CGTT_CTRL__ON_DELAY_MASK              = 0x0000000fL;
constexpr unsigned int TA_CGTT_CTRL__SOFT_OVERRIDE0_MASK        = 0x80000000L;
constexpr unsigned int TA_CGTT_CTRL__SOFT_OVERRIDE1_MASK        = 0x40000000L;
constexpr unsigned int TA_CGTT_CTRL__SOFT_OVERRIDE2_MASK        = 0x20000000L;
constexpr unsigned int TA_CGTT_CTRL__SOFT_OVERRIDE3_MASK        = 0x10000000L;
constexpr unsigned int TA_CGTT_CTRL__SOFT_OVERRIDE4_MASK        = 0x08000000L;
constexpr unsigned int TA_CGTT_CTRL__SOFT_OVERRIDE5_MASK        = 0x04000000L;
constexpr unsigned int TA_CGTT_CTRL__SOFT_OVERRIDE6_MASK        = 0x02000000L;
constexpr unsigned int TA_CGTT_CTRL__SOFT_OVERRIDE7_MASK        = 0x01000000L;
constexpr unsigned int TA_CGTT_CTRL__SOFT_STALL_OVERRIDE0_MASK  = 0x00800000L;
constexpr unsigned int TA_CGTT_CTRL__SOFT_STALL_OVERRIDE1_MASK  = 0x00400000L;
constexpr unsigned int TA_CGTT_CTRL__SOFT_STALL_OVERRIDE2_MASK  = 0x00200000L;
constexpr unsigned int TA_CGTT_CTRL__SOFT_STALL_OVERRIDE3_MASK  = 0x00100000L;
constexpr unsigned int TA_CGTT_CTRL__SOFT_STALL_OVERRIDE4_MASK  = 0x00080000L;
constexpr unsigned int TA_CGTT_CTRL__SOFT_STALL_OVERRIDE5_MASK  = 0x00040000L;
constexpr unsigned int TA_CGTT_CTRL__SOFT_STALL_OVERRIDE6_MASK  = 0x00020000L;
constexpr unsigned int TA_CGTT_CTRL__SOFT_STALL_OVERRIDE7_MASK  = 0x00010000L;
constexpr unsigned int TA_CNTL_AUX__ANISO_ERROR_FP_VBIAS_MASK   = 0x00001000L;
constexpr unsigned int TA_CNTL_AUX__ANISO_HALF_THRESH_MASK      = 0x00000c00L;
constexpr unsigned int TA_CNTL_AUX__ANISO_RATIO_LUT_MASK        = 0x00020000L;
constexpr unsigned int TA_CNTL_AUX__ANISO_STEP_MASK             = 0x00004000L;
constexpr unsigned int TA_CNTL_AUX__ANISO_STEP_ORDER_MASK       = 0x00002000L;
constexpr unsigned int TA_CNTL_AUX__ANISO_TAP_MASK              = 0x00040000L;
constexpr unsigned int TA_CNTL_AUX__ANISO_WEIGHT_MODE_MASK      = 0x00010000L;
constexpr unsigned int TA_CNTL_AUX__ARRAY_ROUND_MODE_MASK       = 0xc0000000L;
constexpr unsigned int TA_CNTL_AUX__CUBEMAP_SLICE_CLAMP_MASK    = 0x10000000L;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_DFMT_NFMT_DISABLE_MASK = 0x04000000L;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_MISC_DISABLE_MASK = 0x00400000L;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_OPCODE_STRICT_DISABLE_MASK = 0x00200000L;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_RESERVED_DISABLE_MASK = 0x00100000L;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_SAMPLER_MSAA_DISABLE_MASK = 0x01000000L;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_SAMPLE_C_DFMT_DISABLE_MASK = 0x00800000L;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_WRITEOP_READFMT_DISABLE_MASK = 0x02000000L;
constexpr unsigned int TA_CNTL_AUX__DISABLE_DWORD_X2_COALESCE_MASK = 0x08000000L;
constexpr unsigned int TA_CNTL_AUX__DISABLE_GATHER4_BC_SWIZZLE_MASK = 0x00000080L;
constexpr unsigned int TA_CNTL_AUX__GATHERH_DST_SEL_MASK        = 0x00000040L;
constexpr unsigned int TA_CNTL_AUX__MINMAG_UNNORM_MASK          = 0x00008000L;
constexpr unsigned int TA_CNTL_AUX__SCOAL_DSWIZZLE_N_MASK       = 0x00000001L;
constexpr unsigned int TA_CNTL_AUX__TFAULT_EN_OVERRIDE_MASK     = 0x00000020L;
constexpr unsigned int TA_CNTL_AUX__TRUNC_SMALL_NEG_MASK        = 0x20000000L;
constexpr unsigned int TA_CNTL__ALIGNER_CREDIT_MASK             = 0x001f0000L;
constexpr unsigned int TA_CNTL__TD_FIFO_CREDIT_MASK             = 0xffc00000L;
constexpr unsigned int TA_CS_BC_BASE_ADDR_HI__ADDRESS_MASK      = 0x000000ffL;
constexpr unsigned int TA_CS_BC_BASE_ADDR__ADDRESS_MASK         = 0xffffffffL;
constexpr unsigned int TA_DEBUG_DATA__DATA_MASK                 = 0xffffffffL;
constexpr unsigned int TA_DEBUG_INDEX__INDEX_MASK               = 0x0000001fL;
constexpr unsigned int TA_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int TA_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int TA_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
constexpr unsigned int TA_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
constexpr unsigned int TA_PERFCOUNTER0_SELECT__CNTR_MODE_MASK   = 0x00f00000L;
constexpr unsigned int TA_PERFCOUNTER0_SELECT__PERF_MODE1_MASK  = 0x0f000000L;
constexpr unsigned int TA_PERFCOUNTER0_SELECT__PERF_MODE_MASK   = 0xf0000000L;
constexpr unsigned int TA_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int TA_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int TA_PERFCOUNTER1_SELECT__CNTR_MODE_MASK   = 0x00f00000L;
constexpr unsigned int TA_PERFCOUNTER1_SELECT__PERF_MODE_MASK   = 0xf0000000L;
constexpr unsigned int TA_RESERVED_010C__Unused_MASK            = 0xffffffffL;
constexpr unsigned int TA_SCRATCH__SCRATCH_MASK                 = 0xffffffffL;
constexpr unsigned int TA_STATUS__AL_BUSY_MASK                  = 0x40000000L;
constexpr unsigned int TA_STATUS__BUSY_MASK                     = 0x80000000L;
constexpr unsigned int TA_STATUS__FA_BUSY_MASK                  = 0x20000000L;
constexpr unsigned int TA_STATUS__FA_LFIFO_EMPTYB_MASK          = 0x00200000L;
constexpr unsigned int TA_STATUS__FA_PFIFO_EMPTYB_MASK          = 0x00100000L;
constexpr unsigned int TA_STATUS__FA_SFIFO_EMPTYB_MASK          = 0x00400000L;
constexpr unsigned int TA_STATUS__FG_BUSY_MASK                  = 0x02000000L;
constexpr unsigned int TA_STATUS__FG_LFIFO_EMPTYB_MASK          = 0x00002000L;
constexpr unsigned int TA_STATUS__FG_PFIFO_EMPTYB_MASK          = 0x00001000L;
constexpr unsigned int TA_STATUS__FG_SFIFO_EMPTYB_MASK          = 0x00004000L;
constexpr unsigned int TA_STATUS__FL_BUSY_MASK                  = 0x08000000L;
constexpr unsigned int TA_STATUS__FL_LFIFO_EMPTYB_MASK          = 0x00020000L;
constexpr unsigned int TA_STATUS__FL_PFIFO_EMPTYB_MASK          = 0x00010000L;
constexpr unsigned int TA_STATUS__FL_SFIFO_EMPTYB_MASK          = 0x00040000L;
constexpr unsigned int TA_STATUS__IN_BUSY_MASK                  = 0x01000000L;
constexpr unsigned int TA_STATUS__LA_BUSY_MASK                  = 0x04000000L;
constexpr unsigned int TA_STATUS__TA_BUSY_MASK                  = 0x10000000L;
constexpr unsigned int TCI_CNTL_1__REQ_FIFO_DEPTH_MASK          = 0x00ff0000L;
constexpr unsigned int TCI_CNTL_1__WBINVL1_NUM_CYCLES_MASK      = 0x0000ffffL;
constexpr unsigned int TCI_CNTL_1__WDATA_RAM_DEPTH_MASK         = 0xff000000L;
constexpr unsigned int TCI_CNTL_2__L1_INVAL_ON_WBINVL2_MASK     = 0x00000001L;
constexpr unsigned int TCI_CNTL_2__TCA_MAX_CREDIT_MASK          = 0x000001feL;
constexpr unsigned int TCI_STATUS__TCI_BUSY_MASK                = 0x00000001L;
constexpr unsigned int TCP_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int TCP_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__PERF_MODE1_MASK = 0x0f000000L;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__PERF_MODE_MASK  = 0xf0000000L;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__PERF_SEL_MASK   = 0x000003ffL;
constexpr unsigned int TCP_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int TCP_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__PERF_MODE1_MASK = 0x0f000000L;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__PERF_MODE_MASK  = 0xf0000000L;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__PERF_SEL_MASK   = 0x000003ffL;
constexpr unsigned int TCP_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int TCP_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int TCP_PERFCOUNTER2_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
constexpr unsigned int TCP_PERFCOUNTER2_SELECT__PERF_MODE_MASK  = 0xf0000000L;
constexpr unsigned int TCP_PERFCOUNTER2_SELECT__PERF_SEL_MASK   = 0x000003ffL;
constexpr unsigned int TCP_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
constexpr unsigned int TCP_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
constexpr unsigned int TCP_PERFCOUNTER3_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
constexpr unsigned int TCP_PERFCOUNTER3_SELECT__PERF_MODE_MASK  = 0xf0000000L;
constexpr unsigned int TCP_PERFCOUNTER3_SELECT__PERF_SEL_MASK   = 0x000003ffL;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__BUFFER_MASK   = 0x00000001L;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__DATA_FORMAT_MASK = 0x00000008L;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__DIM_MASK      = 0x00000004L;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__FLAT_MASK     = 0x00000002L;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__NUM_FORMAT_MASK = 0x00000010L;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__NUM_SAMPLES_MASK = 0x00000040L;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__OPCODE_TYPE_MASK = 0x00000080L;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__SW_MODE_MASK  = 0x00000020L;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__BUFFER_MASK      = 0x00000001L;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__DIM_MASK         = 0x0000001cL;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__FLAT_MASK        = 0x00000002L;
constexpr unsigned int TD_CGTT_CTRL__OFF_HYSTERESIS_MASK        = 0x00000ff0L;
constexpr unsigned int TD_CGTT_CTRL__ON_DELAY_MASK              = 0x0000000fL;
constexpr unsigned int TD_CGTT_CTRL__SOFT_OVERRIDE0_MASK        = 0x80000000L;
constexpr unsigned int TD_CGTT_CTRL__SOFT_OVERRIDE1_MASK        = 0x40000000L;
constexpr unsigned int TD_CGTT_CTRL__SOFT_OVERRIDE2_MASK        = 0x20000000L;
constexpr unsigned int TD_CGTT_CTRL__SOFT_OVERRIDE3_MASK        = 0x10000000L;
constexpr unsigned int TD_CGTT_CTRL__SOFT_OVERRIDE4_MASK        = 0x08000000L;
constexpr unsigned int TD_CGTT_CTRL__SOFT_OVERRIDE5_MASK        = 0x04000000L;
constexpr unsigned int TD_CGTT_CTRL__SOFT_OVERRIDE6_MASK        = 0x02000000L;
constexpr unsigned int TD_CGTT_CTRL__SOFT_OVERRIDE7_MASK        = 0x01000000L;
constexpr unsigned int TD_CGTT_CTRL__SOFT_STALL_OVERRIDE0_MASK  = 0x00800000L;
constexpr unsigned int TD_CGTT_CTRL__SOFT_STALL_OVERRIDE1_MASK  = 0x00400000L;
constexpr unsigned int TD_CGTT_CTRL__SOFT_STALL_OVERRIDE2_MASK  = 0x00200000L;
constexpr unsigned int TD_CGTT_CTRL__SOFT_STALL_OVERRIDE3_MASK  = 0x00100000L;
constexpr unsigned int TD_CGTT_CTRL__SOFT_STALL_OVERRIDE4_MASK  = 0x00080000L;
constexpr unsigned int TD_CGTT_CTRL__SOFT_STALL_OVERRIDE5_MASK  = 0x00040000L;
constexpr unsigned int TD_CGTT_CTRL__SOFT_STALL_OVERRIDE6_MASK  = 0x00020000L;
constexpr unsigned int TD_CGTT_CTRL__SOFT_STALL_OVERRIDE7_MASK  = 0x00010000L;
constexpr unsigned int TD_CNTL__DISABLE_2BIT_SIGNED_FORMAT_MASK = 0x00800000L;
constexpr unsigned int TD_CNTL__DISABLE_POWER_THROTTLE_MASK     = 0x00100000L;
constexpr unsigned int TD_CNTL__ENABLE_ROUND_TO_ZERO_MASK       = 0x00200000L;
constexpr unsigned int TD_CNTL__EXTEND_LDS_STALL_MASK           = 0x00000600L;
constexpr unsigned int TD_CNTL__GATHER4_DX9_MODE_MASK           = 0x00080000L;
constexpr unsigned int TD_CNTL__GATHER4_FLOAT_MODE_MASK         = 0x00010000L;
constexpr unsigned int TD_CNTL__LDS_STALL_PHASE_ADJUST_MASK     = 0x00001800L;
constexpr unsigned int TD_CNTL__LD_FLOAT_MODE_MASK              = 0x00040000L;
constexpr unsigned int TD_CNTL__PAD_STALL_EN_MASK               = 0x00000100L;
constexpr unsigned int TD_CNTL__PRECISION_COMPATIBILITY_MASK    = 0x00008000L;
constexpr unsigned int TD_CNTL__SYNC_PHASE_SH_MASK              = 0x00000003L;
constexpr unsigned int TD_CNTL__SYNC_PHASE_VC_SMX_MASK          = 0x00000030L;
constexpr unsigned int TD_DEBUG_DATA__DATA_MASK                 = 0xffffffffL;
constexpr unsigned int TD_DSM_CNTL2__TD_CS_FIFO_ENABLE_ERROR_INJECT_MASK = 0x000000c0L;
constexpr unsigned int TD_DSM_CNTL2__TD_CS_FIFO_SELECT_INJECT_DELAY_MASK = 0x00000100L;
constexpr unsigned int TD_DSM_CNTL2__TD_INJECT_DELAY_MASK       = 0xfc000000L;
constexpr unsigned int TD_DSM_CNTL2__TD_SS_FIFO_HI_ENABLE_ERROR_INJECT_MASK = 0x00000018L;
constexpr unsigned int TD_DSM_CNTL2__TD_SS_FIFO_HI_SELECT_INJECT_DELAY_MASK = 0x00000020L;
constexpr unsigned int TD_DSM_CNTL2__TD_SS_FIFO_LO_ENABLE_ERROR_INJECT_MASK = 0x00000003L;
constexpr unsigned int TD_DSM_CNTL2__TD_SS_FIFO_LO_SELECT_INJECT_DELAY_MASK = 0x00000004L;
constexpr unsigned int TD_DSM_CNTL__TD_CS_FIFO_DSM_IRRITATOR_DATA_MASK = 0x000000c0L;
constexpr unsigned int TD_DSM_CNTL__TD_CS_FIFO_ENABLE_SINGLE_WRITE_MASK = 0x00000100L;
constexpr unsigned int TD_DSM_CNTL__TD_SS_FIFO_HI_DSM_IRRITATOR_DATA_MASK = 0x00000018L;
constexpr unsigned int TD_DSM_CNTL__TD_SS_FIFO_HI_ENABLE_SINGLE_WRITE_MASK = 0x00000020L;
constexpr unsigned int TD_DSM_CNTL__TD_SS_FIFO_LO_DSM_IRRITATOR_DATA_MASK = 0x00000003L;
constexpr unsigned int TD_DSM_CNTL__TD_SS_FIFO_LO_ENABLE_SINGLE_WRITE_MASK = 0x00000004L;
constexpr unsigned int TD_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int TD_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int TD_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
constexpr unsigned int TD_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
constexpr unsigned int TD_PERFCOUNTER0_SELECT__CNTR_MODE_MASK   = 0x00f00000L;
constexpr unsigned int TD_PERFCOUNTER0_SELECT__PERF_MODE1_MASK  = 0x0f000000L;
constexpr unsigned int TD_PERFCOUNTER0_SELECT__PERF_MODE_MASK   = 0xf0000000L;
constexpr unsigned int TD_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
constexpr unsigned int TD_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
constexpr unsigned int TD_PERFCOUNTER1_SELECT__CNTR_MODE_MASK   = 0x00f00000L;
constexpr unsigned int TD_PERFCOUNTER1_SELECT__PERF_MODE_MASK   = 0xf0000000L;
constexpr unsigned int TD_SCRATCH__SCRATCH_MASK                 = 0xffffffffL;
constexpr unsigned int TD_STATUS__BUSY_MASK                     = 0x80000000L;
constexpr unsigned int VGT_CACHE_INVALIDATION__AUTO_INVLD_EN_MASK = 0x000000c0L;
constexpr unsigned int VGT_CACHE_INVALIDATION__CACHE_INVALIDATION_MASK = 0x00000003L;
constexpr unsigned int VGT_CACHE_INVALIDATION__DIS_INSTANCING_OPT_MASK = 0x00000010L;
constexpr unsigned int VGT_CACHE_INVALIDATION__DIS_RANGE_FULL_INVLD_MASK = 0x00000800L;
constexpr unsigned int VGT_CACHE_INVALIDATION__ENABLE_PING_PONG_EOI_MASK = 0x20000000L;
constexpr unsigned int VGT_CACHE_INVALIDATION__ENABLE_PING_PONG_MASK = 0x00200000L;
constexpr unsigned int VGT_CACHE_INVALIDATION__EN_WAVE_MERGE_MASK = 0x10000000L;
constexpr unsigned int VGT_CACHE_INVALIDATION__ES_LIMIT_MASK    = 0x001f0000L;
constexpr unsigned int VGT_CACHE_INVALIDATION__GS_LATE_ALLOC_EN_MASK = 0x00001000L;
constexpr unsigned int VGT_CACHE_INVALIDATION__OPT_FLOW_CNTL_1_MASK = 0x01c00000L;
constexpr unsigned int VGT_CACHE_INVALIDATION__OPT_FLOW_CNTL_2_MASK = 0x0e000000L;
constexpr unsigned int VGT_CACHE_INVALIDATION__STREAMOUT_FULL_FLUSH_MASK = 0x00002000L;
constexpr unsigned int VGT_CACHE_INVALIDATION__USE_GS_DONE_MASK = 0x00000200L;
constexpr unsigned int VGT_CACHE_INVALIDATION__VS_NO_EXTRA_BUFFER_MASK = 0x00000020L;
constexpr unsigned int VGT_DMA_BASE_HI__BASE_ADDR_MASK          = 0x0000ffffL;
constexpr unsigned int VGT_DMA_BASE__BASE_ADDR_MASK             = 0xffffffffL;
constexpr unsigned int VGT_DMA_CONTROL__IA_SWITCH_ON_EOP_MASK   = 0x00020000L;
constexpr unsigned int VGT_DMA_CONTROL__PRIMGROUP_SIZE_MASK     = 0x0000ffffL;
constexpr unsigned int VGT_DMA_CONTROL__SWITCH_ON_EOI_MASK      = 0x00080000L;
constexpr unsigned int VGT_DMA_CONTROL__WD_SWITCH_ON_EOP_MASK   = 0x00100000L;
constexpr unsigned int VGT_DMA_EVENT_INITIATOR__ADDRESS_HI_MASK = 0x07fffc00L;
constexpr unsigned int VGT_DMA_EVENT_INITIATOR__EVENT_TYPE_MASK = 0x0000003fL;
constexpr unsigned int VGT_DMA_EVENT_INITIATOR__EXTENDED_EVENT_MASK = 0x08000000L;
constexpr unsigned int VGT_DMA_INDEX_TYPE__BUF_TYPE_MASK        = 0x00000030L;
constexpr unsigned int VGT_DMA_INDEX_TYPE__INDEX_TYPE_MASK      = 0x00000003L;
constexpr unsigned int VGT_DMA_INDEX_TYPE__NOT_EOP_MASK         = 0x00000200L;
constexpr unsigned int VGT_DMA_INDEX_TYPE__REQ_PATH_MASK        = 0x00000400L;
constexpr unsigned int VGT_DMA_INDEX_TYPE__SWAP_MODE_MASK       = 0x0000000cL;
constexpr unsigned int VGT_DMA_LS_HS_CONFIG__HS_NUM_INPUT_CP_MASK = 0x00003f00L;
constexpr unsigned int VGT_DMA_MAX_SIZE__MAX_SIZE_MASK          = 0xffffffffL;
constexpr unsigned int VGT_DMA_NUM_INSTANCES__NUM_INSTANCES_MASK = 0xffffffffL;
constexpr unsigned int VGT_DMA_PRIMITIVE_TYPE__PRIM_TYPE_MASK   = 0x0000003fL;
constexpr unsigned int VGT_DMA_REQ_FIFO_DEPTH__DMA_REQ_FIFO_DEPTH_MASK = 0x0000003fL;
constexpr unsigned int VGT_DMA_SIZE__NUM_INDICES_MASK           = 0xffffffffL;
constexpr unsigned int VGT_DRAW_INITIATOR__MAJOR_MODE_MASK      = 0x0000000cL;
constexpr unsigned int VGT_DRAW_INITIATOR__NOT_EOP_MASK         = 0x00000020L;
constexpr unsigned int VGT_DRAW_INITIATOR__REG_RT_INDEX_MASK    = 0xe0000000L;
constexpr unsigned int VGT_DRAW_INITIATOR__SOURCE_SELECT_MASK   = 0x00000003L;
constexpr unsigned int VGT_DRAW_INITIATOR__SPRITE_EN_R6XX_MASK  = 0x00000010L;
constexpr unsigned int VGT_DRAW_INITIATOR__USE_OPAQUE_MASK      = 0x00000040L;
constexpr unsigned int VGT_DRAW_INIT_FIFO_DEPTH__DRAW_INIT_FIFO_DEPTH_MASK = 0x0000003fL;
constexpr unsigned int VGT_DRAW_PAYLOAD_CNTL__EN_REG_RT_INDEX_MASK = 0x00000002L;
constexpr unsigned int VGT_ENHANCE__MISC_MASK                   = 0xffffffffL;
constexpr unsigned int VGT_ESGS_RING_ITEMSIZE__ITEMSIZE_MASK    = 0x00007fffL;
constexpr unsigned int VGT_ES_PER_GS__ES_PER_GS_MASK            = 0x000007ffL;
constexpr unsigned int VGT_EVENT_ADDRESS_REG__ADDRESS_LOW_MASK  = 0x0fffffffL;
constexpr unsigned int VGT_EVENT_INITIATOR__ADDRESS_HI_MASK     = 0x07fffc00L;
constexpr unsigned int VGT_EVENT_INITIATOR__EVENT_TYPE_MASK     = 0x0000003fL;
constexpr unsigned int VGT_EVENT_INITIATOR__EXTENDED_EVENT_MASK = 0x08000000L;
constexpr unsigned int VGT_FIFO_DEPTHS__CLIPP_FIFO_DEPTH_MASK   = 0x003fff00L;
constexpr unsigned int VGT_FIFO_DEPTHS__RESERVED_0_MASK         = 0x00000080L;
constexpr unsigned int VGT_FIFO_DEPTHS__VS_DEALLOC_TBL_DEPTH_MASK = 0x0000007fL;
constexpr unsigned int VGT_GROUP_DECR__DECR_MASK                = 0x0000000fL;
constexpr unsigned int VGT_GROUP_FIRST_DECR__FIRST_DECR_MASK    = 0x0000000fL;
constexpr unsigned int VGT_GROUP_PRIM_TYPE__PRIM_ORDER_MASK     = 0x00070000L;
constexpr unsigned int VGT_GROUP_PRIM_TYPE__PRIM_TYPE_MASK      = 0x0000001fL;
constexpr unsigned int VGT_GROUP_PRIM_TYPE__RETAIN_ORDER_MASK   = 0x00004000L;
constexpr unsigned int VGT_GROUP_PRIM_TYPE__RETAIN_QUADS_MASK   = 0x00008000L;
constexpr unsigned int VGT_GROUP_VECT_0_CNTL__COMP_W_EN_MASK    = 0x00000008L;
constexpr unsigned int VGT_GROUP_VECT_0_CNTL__COMP_X_EN_MASK    = 0x00000001L;
constexpr unsigned int VGT_GROUP_VECT_0_CNTL__COMP_Y_EN_MASK    = 0x00000002L;
constexpr unsigned int VGT_GROUP_VECT_0_CNTL__COMP_Z_EN_MASK    = 0x00000004L;
constexpr unsigned int VGT_GROUP_VECT_0_CNTL__SHIFT_MASK        = 0x00ff0000L;
constexpr unsigned int VGT_GROUP_VECT_0_CNTL__STRIDE_MASK       = 0x0000ff00L;
constexpr unsigned int VGT_GROUP_VECT_0_FMT_CNTL__W_CONV_MASK   = 0x0f000000L;
constexpr unsigned int VGT_GROUP_VECT_0_FMT_CNTL__W_OFFSET_MASK = 0xf0000000L;
constexpr unsigned int VGT_GROUP_VECT_0_FMT_CNTL__X_CONV_MASK   = 0x0000000fL;
constexpr unsigned int VGT_GROUP_VECT_0_FMT_CNTL__X_OFFSET_MASK = 0x000000f0L;
constexpr unsigned int VGT_GROUP_VECT_0_FMT_CNTL__Y_CONV_MASK   = 0x00000f00L;
constexpr unsigned int VGT_GROUP_VECT_0_FMT_CNTL__Y_OFFSET_MASK = 0x0000f000L;
constexpr unsigned int VGT_GROUP_VECT_0_FMT_CNTL__Z_CONV_MASK   = 0x000f0000L;
constexpr unsigned int VGT_GROUP_VECT_0_FMT_CNTL__Z_OFFSET_MASK = 0x00f00000L;
constexpr unsigned int VGT_GROUP_VECT_1_CNTL__COMP_W_EN_MASK    = 0x00000008L;
constexpr unsigned int VGT_GROUP_VECT_1_CNTL__COMP_X_EN_MASK    = 0x00000001L;
constexpr unsigned int VGT_GROUP_VECT_1_CNTL__COMP_Y_EN_MASK    = 0x00000002L;
constexpr unsigned int VGT_GROUP_VECT_1_CNTL__COMP_Z_EN_MASK    = 0x00000004L;
constexpr unsigned int VGT_GROUP_VECT_1_CNTL__SHIFT_MASK        = 0x00ff0000L;
constexpr unsigned int VGT_GROUP_VECT_1_CNTL__STRIDE_MASK       = 0x0000ff00L;
constexpr unsigned int VGT_GROUP_VECT_1_FMT_CNTL__W_CONV_MASK   = 0x0f000000L;
constexpr unsigned int VGT_GROUP_VECT_1_FMT_CNTL__W_OFFSET_MASK = 0xf0000000L;
constexpr unsigned int VGT_GROUP_VECT_1_FMT_CNTL__X_CONV_MASK   = 0x0000000fL;
constexpr unsigned int VGT_GROUP_VECT_1_FMT_CNTL__X_OFFSET_MASK = 0x000000f0L;
constexpr unsigned int VGT_GROUP_VECT_1_FMT_CNTL__Y_CONV_MASK   = 0x00000f00L;
constexpr unsigned int VGT_GROUP_VECT_1_FMT_CNTL__Y_OFFSET_MASK = 0x0000f000L;
constexpr unsigned int VGT_GROUP_VECT_1_FMT_CNTL__Z_CONV_MASK   = 0x000f0000L;
constexpr unsigned int VGT_GROUP_VECT_1_FMT_CNTL__Z_OFFSET_MASK = 0x00f00000L;
constexpr unsigned int VGT_GSVS_RING_ITEMSIZE__ITEMSIZE_MASK    = 0x00007fffL;
constexpr unsigned int VGT_GSVS_RING_OFFSET_1__OFFSET_MASK      = 0x00007fffL;
constexpr unsigned int VGT_GSVS_RING_OFFSET_2__OFFSET_MASK      = 0x00007fffL;
constexpr unsigned int VGT_GSVS_RING_OFFSET_3__OFFSET_MASK      = 0x00007fffL;
constexpr unsigned int VGT_GSVS_RING_SIZE__MEM_SIZE_MASK        = 0xffffffffL;
constexpr unsigned int VGT_GS_INSTANCE_CNT__CNT_MASK            = 0x000001fcL;
constexpr unsigned int VGT_GS_INSTANCE_CNT__ENABLE_MASK         = 0x00000001L;
constexpr unsigned int VGT_GS_MAX_VERT_OUT__MAX_VERT_OUT_MASK   = 0x000007ffL;
constexpr unsigned int VGT_GS_MAX_WAVE_ID__MAX_WAVE_ID_MASK     = 0x00000fffL;
constexpr unsigned int VGT_GS_MODE__CUT_MODE_MASK               = 0x00000030L;
constexpr unsigned int VGT_GS_MODE__ES_PASSTHRU_MASK            = 0x00002000L;
constexpr unsigned int VGT_GS_MODE__ES_WRITE_OPTIMIZE_MASK      = 0x00080000L;
constexpr unsigned int VGT_GS_MODE__GS_C_PACK_EN_MASK           = 0x00000800L;
constexpr unsigned int VGT_GS_MODE__GS_WRITE_OPTIMIZE_MASK      = 0x00100000L;
constexpr unsigned int VGT_GS_MODE__MODE_MASK                   = 0x00000007L;
constexpr unsigned int VGT_GS_MODE__ONCHIP_MASK                 = 0x00600000L;
constexpr unsigned int VGT_GS_MODE__PARTIAL_THD_AT_EOI_MASK     = 0x00020000L;
constexpr unsigned int VGT_GS_MODE__RESERVED_0_MASK             = 0x00000008L;
constexpr unsigned int VGT_GS_MODE__RESERVED_1_MASK             = 0x000007c0L;
constexpr unsigned int VGT_GS_MODE__RESERVED_2_MASK             = 0x00001000L;
constexpr unsigned int VGT_GS_MODE__SUPPRESS_CUTS_MASK          = 0x00040000L;
constexpr unsigned int VGT_GS_ONCHIP_CNTL__ES_VERTS_PER_SUBGRP_MASK = 0x000007ffL;
constexpr unsigned int VGT_GS_ONCHIP_CNTL__GS_INST_PRIMS_IN_SUBGRP_MASK = 0xffc00000L;
constexpr unsigned int VGT_GS_ONCHIP_CNTL__GS_PRIMS_PER_SUBGRP_MASK = 0x003ff800L;
constexpr unsigned int VGT_GS_OUT_PRIM_TYPE__OUTPRIM_TYPE_1_MASK = 0x00003f00L;
constexpr unsigned int VGT_GS_OUT_PRIM_TYPE__OUTPRIM_TYPE_2_MASK = 0x003f0000L;
constexpr unsigned int VGT_GS_OUT_PRIM_TYPE__OUTPRIM_TYPE_3_MASK = 0x0fc00000L;
constexpr unsigned int VGT_GS_OUT_PRIM_TYPE__OUTPRIM_TYPE_MASK  = 0x0000003fL;
constexpr unsigned int VGT_GS_OUT_PRIM_TYPE__UNIQUE_TYPE_PER_STREAM_MASK = 0x80000000L;
constexpr unsigned int VGT_GS_PER_ES__GS_PER_ES_MASK            = 0x000007ffL;
constexpr unsigned int VGT_GS_PER_VS__GS_PER_VS_MASK            = 0x0000000fL;
constexpr unsigned int VGT_GS_VERTEX_REUSE__VERT_REUSE_MASK     = 0x0000001fL;
constexpr unsigned int VGT_GS_VERT_ITEMSIZE_1__ITEMSIZE_MASK    = 0x00007fffL;
constexpr unsigned int VGT_GS_VERT_ITEMSIZE_2__ITEMSIZE_MASK    = 0x00007fffL;
constexpr unsigned int VGT_GS_VERT_ITEMSIZE_3__ITEMSIZE_MASK    = 0x00007fffL;
constexpr unsigned int VGT_GS_VERT_ITEMSIZE__ITEMSIZE_MASK      = 0x00007fffL;
constexpr unsigned int VGT_HOS_CNTL__TESS_MODE_MASK             = 0x00000003L;
constexpr unsigned int VGT_HOS_MAX_TESS_LEVEL__MAX_TESS_MASK    = 0xffffffffL;
constexpr unsigned int VGT_HOS_MIN_TESS_LEVEL__MIN_TESS_MASK    = 0xffffffffL;
constexpr unsigned int VGT_HOS_REUSE_DEPTH__REUSE_DEPTH_MASK    = 0x000000ffL;
constexpr unsigned int VGT_IMMED_DATA__DATA_MASK                = 0xffffffffL;
constexpr unsigned int VGT_INDEX_TYPE__INDEX_TYPE_MASK          = 0x00000003L;
constexpr unsigned int VGT_INDX_OFFSET__INDX_OFFSET_MASK        = 0xffffffffL;
constexpr unsigned int VGT_INSTANCE_BASE_ID__INSTANCE_BASE_ID_MASK = 0xffffffffL;
constexpr unsigned int VGT_INSTANCE_STEP_RATE_0__STEP_RATE_MASK = 0xffffffffL;
constexpr unsigned int VGT_INSTANCE_STEP_RATE_1__STEP_RATE_MASK = 0xffffffffL;
constexpr unsigned int VGT_LAST_COPY_STATE__DST_STATE_ID_MASK   = 0x00070000L;
constexpr unsigned int VGT_LAST_COPY_STATE__SRC_STATE_ID_MASK   = 0x00000007L;
constexpr unsigned int VGT_LS_HS_CONFIG__HS_NUM_INPUT_CP_MASK   = 0x00003f00L;
constexpr unsigned int VGT_LS_HS_CONFIG__HS_NUM_OUTPUT_CP_MASK  = 0x000fc000L;
constexpr unsigned int VGT_LS_HS_CONFIG__NUM_PATCHES_MASK       = 0x000000ffL;
constexpr unsigned int VGT_MAX_VTX_INDX__MAX_INDX_MASK          = 0xffffffffL;
constexpr unsigned int VGT_MC_LAT_CNTL__MC_TIME_STAMP_RES_MASK  = 0x0000000fL;
constexpr unsigned int VGT_MIN_VTX_INDX__MIN_INDX_MASK          = 0xffffffffL;
constexpr unsigned int VGT_MULTI_PRIM_IB_RESET_EN__MATCH_ALL_BITS_MASK = 0x00000002L;
constexpr unsigned int VGT_MULTI_PRIM_IB_RESET_EN__RESET_EN_MASK = 0x00000001L;
constexpr unsigned int VGT_MULTI_PRIM_IB_RESET_INDX__RESET_INDX_MASK = 0xffffffffL;
constexpr unsigned int VGT_NUM_INDICES__NUM_INDICES_MASK        = 0xffffffffL;
constexpr unsigned int VGT_NUM_INSTANCES__NUM_INSTANCES_MASK    = 0xffffffffL;
constexpr unsigned int VGT_OUTPUT_PATH_CNTL__PATH_SELECT_MASK   = 0x00000007L;
constexpr unsigned int VGT_OUT_DEALLOC_CNTL__DEALLOC_DIST_MASK  = 0x0000007fL;
constexpr unsigned int VGT_PRIMITIVEID_EN__DISABLE_RESET_ON_EOI_MASK = 0x00000002L;
constexpr unsigned int VGT_PRIMITIVEID_EN__NGG_DISABLE_PROVOK_REUSE_MASK = 0x00000004L;
constexpr unsigned int VGT_PRIMITIVEID_EN__PRIMITIVEID_EN_MASK  = 0x00000001L;
constexpr unsigned int VGT_PRIMITIVEID_RESET__VALUE_MASK        = 0xffffffffL;
constexpr unsigned int VGT_PRIMITIVE_TYPE__PRIM_TYPE_MASK       = 0x0000003fL;
constexpr unsigned int VGT_RESET_DEBUG__GS_DISABLE_MASK         = 0x00000001L;
constexpr unsigned int VGT_RESET_DEBUG__TESS_DISABLE_MASK       = 0x00000002L;
constexpr unsigned int VGT_RESET_DEBUG__WD_DISABLE_MASK         = 0x00000004L;
constexpr unsigned int VGT_REUSE_OFF__REUSE_OFF_MASK            = 0x00000001L;
constexpr unsigned int VGT_SHADER_STAGES_EN__ES_EN_MASK         = 0x00000018L;
constexpr unsigned int VGT_SHADER_STAGES_EN__GS_EN_MASK         = 0x00000020L;
constexpr unsigned int VGT_SHADER_STAGES_EN__HS_EN_MASK         = 0x00000004L;
constexpr unsigned int VGT_SHADER_STAGES_EN__LS_EN_MASK         = 0x00000003L;
constexpr unsigned int VGT_SHADER_STAGES_EN__MAX_PRIMGRP_IN_WAVE_MASK = 0x00078000L;
constexpr unsigned int VGT_SHADER_STAGES_EN__ORDERED_ID_MODE_MASK = 0x00004000L;
constexpr unsigned int VGT_SHADER_STAGES_EN__PRIMGEN_EN_MASK    = 0x00002000L;
constexpr unsigned int VGT_SHADER_STAGES_EN__VS_EN_MASK         = 0x000000c0L;
constexpr unsigned int VGT_SHADER_STAGES_EN__VS_WAVE_ID_EN_MASK = 0x00001000L;
constexpr unsigned int VGT_STRMOUT_BUFFER_CONFIG__STREAM_0_BUFFER_EN_MASK = 0x0000000fL;
constexpr unsigned int VGT_STRMOUT_BUFFER_CONFIG__STREAM_1_BUFFER_EN_MASK = 0x000000f0L;
constexpr unsigned int VGT_STRMOUT_BUFFER_CONFIG__STREAM_2_BUFFER_EN_MASK = 0x00000f00L;
constexpr unsigned int VGT_STRMOUT_BUFFER_CONFIG__STREAM_3_BUFFER_EN_MASK = 0x0000f000L;
constexpr unsigned int VGT_STRMOUT_BUFFER_FILLED_SIZE_0__SIZE_MASK = 0xffffffffL;
constexpr unsigned int VGT_STRMOUT_BUFFER_FILLED_SIZE_1__SIZE_MASK = 0xffffffffL;
constexpr unsigned int VGT_STRMOUT_BUFFER_FILLED_SIZE_2__SIZE_MASK = 0xffffffffL;
constexpr unsigned int VGT_STRMOUT_BUFFER_FILLED_SIZE_3__SIZE_MASK = 0xffffffffL;
constexpr unsigned int VGT_STRMOUT_BUFFER_OFFSET_0__OFFSET_MASK = 0xffffffffL;
constexpr unsigned int VGT_STRMOUT_BUFFER_OFFSET_1__OFFSET_MASK = 0xffffffffL;
constexpr unsigned int VGT_STRMOUT_BUFFER_OFFSET_2__OFFSET_MASK = 0xffffffffL;
constexpr unsigned int VGT_STRMOUT_BUFFER_OFFSET_3__OFFSET_MASK = 0xffffffffL;
constexpr unsigned int VGT_STRMOUT_BUFFER_SIZE_0__SIZE_MASK     = 0xffffffffL;
constexpr unsigned int VGT_STRMOUT_BUFFER_SIZE_1__SIZE_MASK     = 0xffffffffL;
constexpr unsigned int VGT_STRMOUT_BUFFER_SIZE_2__SIZE_MASK     = 0xffffffffL;
constexpr unsigned int VGT_STRMOUT_BUFFER_SIZE_3__SIZE_MASK     = 0xffffffffL;
constexpr unsigned int VGT_STRMOUT_CONFIG__EN_PRIMS_NEEDED_CNT_MASK = 0x00000080L;
constexpr unsigned int VGT_STRMOUT_CONFIG__RAST_STREAM_MASK     = 0x00000070L;
constexpr unsigned int VGT_STRMOUT_CONFIG__RAST_STREAM_MASK_MASK = 0x00000f00L;
constexpr unsigned int VGT_STRMOUT_CONFIG__STREAMOUT_0_EN_MASK  = 0x00000001L;
constexpr unsigned int VGT_STRMOUT_CONFIG__STREAMOUT_1_EN_MASK  = 0x00000002L;
constexpr unsigned int VGT_STRMOUT_CONFIG__STREAMOUT_2_EN_MASK  = 0x00000004L;
constexpr unsigned int VGT_STRMOUT_CONFIG__STREAMOUT_3_EN_MASK  = 0x00000008L;
constexpr unsigned int VGT_STRMOUT_CONFIG__USE_RAST_STREAM_MASK_MASK = 0x80000000L;
constexpr unsigned int VGT_STRMOUT_DELAY__SE0_WD_DELAY_MASK     = 0x00000700L;
constexpr unsigned int VGT_STRMOUT_DELAY__SE1_WD_DELAY_MASK     = 0x00003800L;
constexpr unsigned int VGT_STRMOUT_DELAY__SE2_WD_DELAY_MASK     = 0x0001c000L;
constexpr unsigned int VGT_STRMOUT_DELAY__SE3_WD_DELAY_MASK     = 0x000e0000L;
constexpr unsigned int VGT_STRMOUT_DELAY__SKIP_DELAY_MASK       = 0x000000ffL;
constexpr unsigned int VGT_STRMOUT_DRAW_OPAQUE_BUFFER_FILLED_SIZE__SIZE_MASK = 0xffffffffL;
constexpr unsigned int VGT_STRMOUT_DRAW_OPAQUE_OFFSET__OFFSET_MASK = 0xffffffffL;
constexpr unsigned int VGT_STRMOUT_DRAW_OPAQUE_VERTEX_STRIDE__VERTEX_STRIDE_MASK = 0x000001ffL;
constexpr unsigned int VGT_STRMOUT_VTX_STRIDE_0__STRIDE_MASK    = 0x000003ffL;
constexpr unsigned int VGT_STRMOUT_VTX_STRIDE_1__STRIDE_MASK    = 0x000003ffL;
constexpr unsigned int VGT_STRMOUT_VTX_STRIDE_2__STRIDE_MASK    = 0x000003ffL;
constexpr unsigned int VGT_STRMOUT_VTX_STRIDE_3__STRIDE_MASK    = 0x000003ffL;
constexpr unsigned int VGT_SYS_CONFIG__ADC_EVENT_FILTER_DISABLE_MASK = 0x00000080L;
constexpr unsigned int VGT_SYS_CONFIG__DUAL_CORE_EN_MASK        = 0x00000001L;
constexpr unsigned int VGT_SYS_CONFIG__MAX_LS_HS_THDGRP_MASK    = 0x0000007eL;
constexpr unsigned int VGT_TESS_DISTRIBUTION__ACCUM_ISOLINE_MASK = 0x000000ffL;
constexpr unsigned int VGT_TESS_DISTRIBUTION__ACCUM_QUAD_MASK   = 0x00ff0000L;
constexpr unsigned int VGT_TESS_DISTRIBUTION__ACCUM_TRI_MASK    = 0x0000ff00L;
constexpr unsigned int VGT_TESS_DISTRIBUTION__DONUT_SPLIT_MASK  = 0x1f000000L;
constexpr unsigned int VGT_TESS_DISTRIBUTION__TRAP_SPLIT_MASK   = 0xe0000000L;
constexpr unsigned int VGT_TF_MEMORY_BASE_HI__BASE_HI_MASK      = 0x000000ffL;
constexpr unsigned int VGT_TF_MEMORY_BASE__BASE_MASK            = 0xffffffffL;
constexpr unsigned int VGT_TF_PARAM__DEPRECATED_MASK            = 0x00000200L;
constexpr unsigned int VGT_TF_PARAM__DISABLE_DONUTS_MASK        = 0x00004000L;
constexpr unsigned int VGT_TF_PARAM__DISTRIBUTION_MODE_MASK     = 0x00060000L;
constexpr unsigned int VGT_TF_PARAM__PARTITIONING_MASK          = 0x0000001cL;
constexpr unsigned int VGT_TF_PARAM__RESERVED_REDUC_AXIS_MASK   = 0x00000100L;
constexpr unsigned int VGT_TF_PARAM__TOPOLOGY_MASK              = 0x000000e0L;
constexpr unsigned int VGT_TF_PARAM__TYPE_MASK                  = 0x00000003L;
constexpr unsigned int VGT_TF_RING_SIZE__SIZE_MASK              = 0x0000ffffL;
constexpr unsigned int VGT_VERTEX_REUSE_BLOCK_CNTL__VTX_REUSE_DEPTH_MASK = 0x000000ffL;
constexpr unsigned int VGT_VS_MAX_WAVE_ID__MAX_WAVE_ID_MASK     = 0x00000fffL;
constexpr unsigned int VGT_VTX_CNT_EN__VTX_CNT_EN_MASK          = 0x00000001L;
constexpr unsigned int WD_BUF_RESOURCE_1__INDEX_BUF_SIZE_MASK   = 0xffff0000L;
constexpr unsigned int WD_BUF_RESOURCE_1__POS_BUF_SIZE_MASK     = 0x0000ffffL;
constexpr unsigned int WD_BUF_RESOURCE_2__ADDR_MODE_MASK        = 0x00008000L;
constexpr unsigned int WD_BUF_RESOURCE_2__CNTL_SB_BUF_SIZE_MASK = 0xffff0000L;
constexpr unsigned int WD_BUF_RESOURCE_2__PARAM_BUF_SIZE_MASK   = 0x00001fffL;
constexpr unsigned int WD_CNTL_SB_BUF_BASE_HI__BASE_HI_MASK     = 0x000000ffL;
constexpr unsigned int WD_CNTL_SB_BUF_BASE__BASE_MASK           = 0xffffffffL;
constexpr unsigned int WD_ENHANCE__MISC_MASK                    = 0xffffffffL;
constexpr unsigned int WD_INDEX_BUF_BASE_HI__BASE_HI_MASK       = 0x000000ffL;
constexpr unsigned int WD_INDEX_BUF_BASE__BASE_MASK             = 0xffffffffL;
constexpr unsigned int WD_POS_BUF_BASE_HI__BASE_HI_MASK         = 0x000000ffL;
constexpr unsigned int WD_POS_BUF_BASE__BASE_MASK               = 0xffffffffL;
constexpr unsigned int WD_QOS__DRAW_STALL_MASK                  = 0x00000001L;
constexpr unsigned int WD_UTCL1_CNTL__BYPASS_MASK               = 0x02000000L;
constexpr unsigned int WD_UTCL1_CNTL__DROP_MODE_MASK            = 0x01000000L;
constexpr unsigned int WD_UTCL1_CNTL__FORCE_SNOOP_MASK          = 0x10000000L;
constexpr unsigned int WD_UTCL1_CNTL__FRAG_LIMIT_MODE_MASK      = 0x08000000L;
constexpr unsigned int WD_UTCL1_CNTL__INVALIDATE_MASK           = 0x04000000L;
constexpr unsigned int WD_UTCL1_CNTL__VMID_RESET_MODE_MASK      = 0x00800000L;
constexpr unsigned int WD_UTCL1_CNTL__XNACK_REDO_TIMER_CNT_MASK = 0x000fffffL;
constexpr unsigned int WD_UTCL1_STATUS__FAULT_DETECTED_MASK     = 0x00000001L;
constexpr unsigned int WD_UTCL1_STATUS__FAULT_UTCL1ID_MASK      = 0x00003f00L;
constexpr unsigned int WD_UTCL1_STATUS__PRT_DETECTED_MASK       = 0x00000004L;
constexpr unsigned int WD_UTCL1_STATUS__PRT_UTCL1ID_MASK        = 0x3f000000L;
constexpr unsigned int WD_UTCL1_STATUS__RETRY_DETECTED_MASK     = 0x00000002L;
constexpr unsigned int WD_UTCL1_STATUS__RETRY_UTCL1ID_MASK      = 0x003f0000L;

namespace Apu09Plus
{
    constexpr unsigned int RPB_EA_QUEUE_WR__EA_NUMBER_MASK          = 0x0000001fL;
    constexpr unsigned int RPB_EA_QUEUE_WR__READ_QUEUE_MASK         = 0x00000700L;
    constexpr unsigned int RPB_EA_QUEUE_WR__UPDATE_MASK             = 0x00000800L;
    constexpr unsigned int RPB_EA_QUEUE_WR__WRITE_QUEUE_MASK        = 0x000000e0L;
} // namespace Apu09Plus

namespace Apu09_1xPlus
{
    constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_DATA__data_MASK    = 0x000000ffL;
    constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_DATA__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeRearmAccum_MASK = 0x00000004L;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeResetPerfMonitors_MASK = 0x00000001L;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeStartAccumulation_MASK = 0x00000002L;
    constexpr unsigned int RLC_SPM_ACCUM_DATARAM_ADDR__addr_MASK    = 0x0000007fL;
    constexpr unsigned int RLC_SPM_ACCUM_DATARAM_ADDR__RESERVED_MASK = 0xffffff80L;
    constexpr unsigned int RLC_SPM_ACCUM_DATARAM_DATA__data_MASK    = 0xffffffffL;
    constexpr unsigned int RLC_SPM_ACCUM_DATARAM_WRCOUNT__DataRamWrCount_MASK = 0x0007ffffL;
    constexpr unsigned int RLC_SPM_ACCUM_DATARAM_WRCOUNT__RESERVED_MASK = 0xfff80000L;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__EnableAccum_MASK     = 0x00000001L;
    constexpr unsigned int RLC_SPM_ACCUM_SAMPLES_REQUESTED__SamplesRequested_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__AccumArmed_MASK    = 0x00000800L;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__AccumDone_MASK     = 0x00000100L;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__AccumOverflow_MASK = 0x00000400L;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__AllFifosEmpty_MASK = 0x00004000L;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__FinalSequenceInProgress_MASK = 0x00002000L;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__FSMIsIdle_MASK     = 0x00008000L;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__NumbSamplesCompleted_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__SequenceInProgress_MASK = 0x00001000L;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__SpmDone_MASK       = 0x00000200L;
    constexpr unsigned int RLC_SPM_ACCUM_THRESHOLD__Threshold_MASK  = 0x0000ffffL;
    constexpr unsigned int SPI_SHADER_PGM_CHKSUM_GS__CHECKSUM_MASK  = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_PGM_CHKSUM_HS__CHECKSUM_MASK  = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_PGM_CHKSUM_PS__CHECKSUM_MASK  = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_PGM_CHKSUM_VS__CHECKSUM_MASK  = 0xffffffffL;
} // namespace Apu09_1xPlus

namespace Gfx09
{
    constexpr unsigned int ATC_ATS_FAULT_STATUS_INFO2__VFID_MASK    = 0x0000001eL;
    constexpr unsigned int ATC_L2_PERFCOUNTER0_CFG__CLEAR_MASK      = 0x20000000L;
    constexpr unsigned int ATC_L2_PERFCOUNTER0_CFG__ENABLE_MASK     = 0x10000000L;
    constexpr unsigned int ATC_L2_PERFCOUNTER0_CFG__PERF_MODE_MASK  = 0x0f000000L;
    constexpr unsigned int ATC_L2_PERFCOUNTER0_CFG__PERF_SEL_END_MASK = 0x0000ff00L;
    constexpr unsigned int ATC_L2_PERFCOUNTER0_CFG__PERF_SEL_MASK   = 0x000000ffL;
    constexpr unsigned int ATC_L2_PERFCOUNTER1_CFG__CLEAR_MASK      = 0x20000000L;
    constexpr unsigned int ATC_L2_PERFCOUNTER1_CFG__ENABLE_MASK     = 0x10000000L;
    constexpr unsigned int ATC_L2_PERFCOUNTER1_CFG__PERF_MODE_MASK  = 0x0f000000L;
    constexpr unsigned int ATC_L2_PERFCOUNTER1_CFG__PERF_SEL_END_MASK = 0x0000ff00L;
    constexpr unsigned int ATC_L2_PERFCOUNTER1_CFG__PERF_SEL_MASK   = 0x000000ffL;
    constexpr unsigned int ATC_L2_PERFCOUNTER_HI__COMPARE_VALUE_MASK = 0xffff0000L;
    constexpr unsigned int ATC_L2_PERFCOUNTER_HI__COUNTER_HI_MASK   = 0x0000ffffL;
    constexpr unsigned int ATC_L2_PERFCOUNTER_LO__COUNTER_LO_MASK   = 0xffffffffL;
    constexpr unsigned int ATC_L2_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL_MASK = 0x02000000L;
    constexpr unsigned int ATC_L2_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY_MASK = 0x01000000L;
    constexpr unsigned int ATC_L2_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT_MASK = 0x0000000fL;
    constexpr unsigned int ATC_L2_PERFCOUNTER_RSLT_CNTL__START_TRIGGER_MASK = 0x0000ff00L;
    constexpr unsigned int ATC_L2_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE_MASK = 0x04000000L;
    constexpr unsigned int ATC_L2_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER_MASK = 0x00ff0000L;
    constexpr unsigned int CB_COLOR0_ATTRIB__COLOR_SW_MODE_MASK     = 0x007c0000L;
    constexpr unsigned int CB_COLOR0_ATTRIB__FMASK_SW_MODE_MASK     = 0x0f800000L;
    constexpr unsigned int CB_COLOR0_ATTRIB__META_LINEAR_MASK       = 0x00000800L;
    constexpr unsigned int CB_COLOR0_ATTRIB__MIP0_DEPTH_MASK        = 0x000007ffL;
    constexpr unsigned int CB_COLOR0_ATTRIB__PIPE_ALIGNED_MASK      = 0x80000000L;
    constexpr unsigned int CB_COLOR0_ATTRIB__RB_ALIGNED_MASK        = 0x40000000L;
    constexpr unsigned int CB_COLOR0_ATTRIB__RESOURCE_TYPE_MASK     = 0x30000000L;
    constexpr unsigned int CB_COLOR0_VIEW__MIP_LEVEL_MASK           = 0x0f000000L;
    constexpr unsigned int CB_COLOR0_VIEW__SLICE_MAX_MASK           = 0x00ffe000L;
    constexpr unsigned int CB_COLOR0_VIEW__SLICE_START_MASK         = 0x000007ffL;
    constexpr unsigned int CB_COLOR1_ATTRIB__COLOR_SW_MODE_MASK     = 0x007c0000L;
    constexpr unsigned int CB_COLOR1_ATTRIB__FMASK_SW_MODE_MASK     = 0x0f800000L;
    constexpr unsigned int CB_COLOR1_ATTRIB__META_LINEAR_MASK       = 0x00000800L;
    constexpr unsigned int CB_COLOR1_ATTRIB__MIP0_DEPTH_MASK        = 0x000007ffL;
    constexpr unsigned int CB_COLOR1_ATTRIB__PIPE_ALIGNED_MASK      = 0x80000000L;
    constexpr unsigned int CB_COLOR1_ATTRIB__RB_ALIGNED_MASK        = 0x40000000L;
    constexpr unsigned int CB_COLOR1_ATTRIB__RESOURCE_TYPE_MASK     = 0x30000000L;
    constexpr unsigned int CB_COLOR1_VIEW__MIP_LEVEL_MASK           = 0x0f000000L;
    constexpr unsigned int CB_COLOR1_VIEW__SLICE_MAX_MASK           = 0x00ffe000L;
    constexpr unsigned int CB_COLOR1_VIEW__SLICE_START_MASK         = 0x000007ffL;
    constexpr unsigned int CB_COLOR2_ATTRIB__COLOR_SW_MODE_MASK     = 0x007c0000L;
    constexpr unsigned int CB_COLOR2_ATTRIB__FMASK_SW_MODE_MASK     = 0x0f800000L;
    constexpr unsigned int CB_COLOR2_ATTRIB__META_LINEAR_MASK       = 0x00000800L;
    constexpr unsigned int CB_COLOR2_ATTRIB__MIP0_DEPTH_MASK        = 0x000007ffL;
    constexpr unsigned int CB_COLOR2_ATTRIB__PIPE_ALIGNED_MASK      = 0x80000000L;
    constexpr unsigned int CB_COLOR2_ATTRIB__RB_ALIGNED_MASK        = 0x40000000L;
    constexpr unsigned int CB_COLOR2_ATTRIB__RESOURCE_TYPE_MASK     = 0x30000000L;
    constexpr unsigned int CB_COLOR2_VIEW__MIP_LEVEL_MASK           = 0x0f000000L;
    constexpr unsigned int CB_COLOR2_VIEW__SLICE_MAX_MASK           = 0x00ffe000L;
    constexpr unsigned int CB_COLOR2_VIEW__SLICE_START_MASK         = 0x000007ffL;
    constexpr unsigned int CB_COLOR3_ATTRIB__COLOR_SW_MODE_MASK     = 0x007c0000L;
    constexpr unsigned int CB_COLOR3_ATTRIB__FMASK_SW_MODE_MASK     = 0x0f800000L;
    constexpr unsigned int CB_COLOR3_ATTRIB__META_LINEAR_MASK       = 0x00000800L;
    constexpr unsigned int CB_COLOR3_ATTRIB__MIP0_DEPTH_MASK        = 0x000007ffL;
    constexpr unsigned int CB_COLOR3_ATTRIB__PIPE_ALIGNED_MASK      = 0x80000000L;
    constexpr unsigned int CB_COLOR3_ATTRIB__RB_ALIGNED_MASK        = 0x40000000L;
    constexpr unsigned int CB_COLOR3_ATTRIB__RESOURCE_TYPE_MASK     = 0x30000000L;
    constexpr unsigned int CB_COLOR3_VIEW__MIP_LEVEL_MASK           = 0x0f000000L;
    constexpr unsigned int CB_COLOR3_VIEW__SLICE_MAX_MASK           = 0x00ffe000L;
    constexpr unsigned int CB_COLOR3_VIEW__SLICE_START_MASK         = 0x000007ffL;
    constexpr unsigned int CB_COLOR4_ATTRIB__COLOR_SW_MODE_MASK     = 0x007c0000L;
    constexpr unsigned int CB_COLOR4_ATTRIB__FMASK_SW_MODE_MASK     = 0x0f800000L;
    constexpr unsigned int CB_COLOR4_ATTRIB__META_LINEAR_MASK       = 0x00000800L;
    constexpr unsigned int CB_COLOR4_ATTRIB__MIP0_DEPTH_MASK        = 0x000007ffL;
    constexpr unsigned int CB_COLOR4_ATTRIB__PIPE_ALIGNED_MASK      = 0x80000000L;
    constexpr unsigned int CB_COLOR4_ATTRIB__RB_ALIGNED_MASK        = 0x40000000L;
    constexpr unsigned int CB_COLOR4_ATTRIB__RESOURCE_TYPE_MASK     = 0x30000000L;
    constexpr unsigned int CB_COLOR4_VIEW__MIP_LEVEL_MASK           = 0x0f000000L;
    constexpr unsigned int CB_COLOR4_VIEW__SLICE_MAX_MASK           = 0x00ffe000L;
    constexpr unsigned int CB_COLOR4_VIEW__SLICE_START_MASK         = 0x000007ffL;
    constexpr unsigned int CB_COLOR5_ATTRIB__COLOR_SW_MODE_MASK     = 0x007c0000L;
    constexpr unsigned int CB_COLOR5_ATTRIB__FMASK_SW_MODE_MASK     = 0x0f800000L;
    constexpr unsigned int CB_COLOR5_ATTRIB__META_LINEAR_MASK       = 0x00000800L;
    constexpr unsigned int CB_COLOR5_ATTRIB__MIP0_DEPTH_MASK        = 0x000007ffL;
    constexpr unsigned int CB_COLOR5_ATTRIB__PIPE_ALIGNED_MASK      = 0x80000000L;
    constexpr unsigned int CB_COLOR5_ATTRIB__RB_ALIGNED_MASK        = 0x40000000L;
    constexpr unsigned int CB_COLOR5_ATTRIB__RESOURCE_TYPE_MASK     = 0x30000000L;
    constexpr unsigned int CB_COLOR5_VIEW__MIP_LEVEL_MASK           = 0x0f000000L;
    constexpr unsigned int CB_COLOR5_VIEW__SLICE_MAX_MASK           = 0x00ffe000L;
    constexpr unsigned int CB_COLOR5_VIEW__SLICE_START_MASK         = 0x000007ffL;
    constexpr unsigned int CB_COLOR6_ATTRIB__COLOR_SW_MODE_MASK     = 0x007c0000L;
    constexpr unsigned int CB_COLOR6_ATTRIB__FMASK_SW_MODE_MASK     = 0x0f800000L;
    constexpr unsigned int CB_COLOR6_ATTRIB__META_LINEAR_MASK       = 0x00000800L;
    constexpr unsigned int CB_COLOR6_ATTRIB__MIP0_DEPTH_MASK        = 0x000007ffL;
    constexpr unsigned int CB_COLOR6_ATTRIB__PIPE_ALIGNED_MASK      = 0x80000000L;
    constexpr unsigned int CB_COLOR6_ATTRIB__RB_ALIGNED_MASK        = 0x40000000L;
    constexpr unsigned int CB_COLOR6_ATTRIB__RESOURCE_TYPE_MASK     = 0x30000000L;
    constexpr unsigned int CB_COLOR6_VIEW__MIP_LEVEL_MASK           = 0x0f000000L;
    constexpr unsigned int CB_COLOR6_VIEW__SLICE_MAX_MASK           = 0x00ffe000L;
    constexpr unsigned int CB_COLOR6_VIEW__SLICE_START_MASK         = 0x000007ffL;
    constexpr unsigned int CB_COLOR7_ATTRIB__COLOR_SW_MODE_MASK     = 0x007c0000L;
    constexpr unsigned int CB_COLOR7_ATTRIB__FMASK_SW_MODE_MASK     = 0x0f800000L;
    constexpr unsigned int CB_COLOR7_ATTRIB__META_LINEAR_MASK       = 0x00000800L;
    constexpr unsigned int CB_COLOR7_ATTRIB__MIP0_DEPTH_MASK        = 0x000007ffL;
    constexpr unsigned int CB_COLOR7_ATTRIB__PIPE_ALIGNED_MASK      = 0x80000000L;
    constexpr unsigned int CB_COLOR7_ATTRIB__RB_ALIGNED_MASK        = 0x40000000L;
    constexpr unsigned int CB_COLOR7_ATTRIB__RESOURCE_TYPE_MASK     = 0x30000000L;
    constexpr unsigned int CB_COLOR7_VIEW__MIP_LEVEL_MASK           = 0x0f000000L;
    constexpr unsigned int CB_COLOR7_VIEW__SLICE_MAX_MASK           = 0x00ffe000L;
    constexpr unsigned int CB_COLOR7_VIEW__SLICE_START_MASK         = 0x000007ffL;
    constexpr unsigned int CB_DCC_CONFIG__DCC_CACHE_EVICT_POINT_MASK = 0x0f000000L;
    constexpr unsigned int CB_DCC_CONFIG__DCC_CACHE_NUM_TAGS_MASK   = 0xf0000000L;
    constexpr unsigned int CB_DCC_CONFIG__READ_RETURN_SKID_FIFO_DEPTH_MASK = 0x007f0000L;
    constexpr unsigned int CB_DCC_CONTROL__OVERWRITE_COMBINER_MRT_SHARING_DISABLE_MASK = 0x00000002L;
    constexpr unsigned int CB_HW_CONTROL_1__CC_CACHE_NUM_TAGS_MASK  = 0x0001f800L;
    constexpr unsigned int CB_HW_CONTROL_1__CM_TILE_FIFO_DEPTH_MASK = 0x03fe0000L;
    constexpr unsigned int CB_HW_CONTROL_1__FC_CACHE_NUM_TAGS_MASK  = 0x000007e0L;
    constexpr unsigned int CB_HW_CONTROL_1__RMI_CREDITS_MASK        = 0xfc000000L;
    constexpr unsigned int CB_HW_CONTROL_2__CHICKEN_BITS_MASK       = 0xf0000000L;
    constexpr unsigned int CB_HW_CONTROL_2__DRR_ASSUMED_FIFO_DEPTH_DIV8_MASK = 0x0f000000L;
    constexpr unsigned int CB_HW_CONTROL_3__COLOR_CACHE_PREFETCH_NUM_CLS_MASK = 0x30000000L;
    constexpr unsigned int CB_HW_CONTROL_3__DISABLE_CC_CACHE_OVWR_KEY_MOD_MASK = 0x00000040L;
    constexpr unsigned int CB_HW_CONTROL_3__DISABLE_DUALSRC_WITH_OBJPRIMID_FIX_MASK = 0x08000000L;
    constexpr unsigned int CB_HW_CONTROL_3__DISABLE_OVERWRITE_COMBINER_TARGET_MASK_VALIDATION_MASK = 0x00000100L;
    constexpr unsigned int CB_HW_CONTROL__ALLOW_MRT_WITH_DUAL_SOURCE_MASK = 0x00010000L;
    constexpr unsigned int CB_HW_CONTROL__CC_CACHE_EVICT_POINT_MASK = 0x0000f000L;
    constexpr unsigned int CB_HW_CONTROL__CM_CACHE_EVICT_POINT_MASK = 0x0000000fL;
    constexpr unsigned int CB_HW_CONTROL__FC_CACHE_EVICT_POINT_MASK = 0x000003c0L;
    constexpr unsigned int CB_MRT0_EPITCH__EPITCH_MASK              = 0x0000ffffL;
    constexpr unsigned int CB_MRT1_EPITCH__EPITCH_MASK              = 0x0000ffffL;
    constexpr unsigned int CB_MRT2_EPITCH__EPITCH_MASK              = 0x0000ffffL;
    constexpr unsigned int CB_MRT3_EPITCH__EPITCH_MASK              = 0x0000ffffL;
    constexpr unsigned int CB_MRT4_EPITCH__EPITCH_MASK              = 0x0000ffffL;
    constexpr unsigned int CB_MRT5_EPITCH__EPITCH_MASK              = 0x0000ffffL;
    constexpr unsigned int CB_MRT6_EPITCH__EPITCH_MASK              = 0x0000ffffL;
    constexpr unsigned int CB_MRT7_EPITCH__EPITCH_MASK              = 0x0000ffffL;
    constexpr unsigned int COMPUTE_PGM_RSRC2__SKIP_USGPR0_MASK      = 0x80000000L;
    constexpr unsigned int COMPUTE_RESOURCE_LIMITS__SIMD_DISABLE_MASK = 0x78000000L;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE0__SH0_CU_EN_MASK = 0x0000ffffL;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE0__SH1_CU_EN_MASK = 0xffff0000L;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE1__SH0_CU_EN_MASK = 0x0000ffffL;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE1__SH1_CU_EN_MASK = 0xffff0000L;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE2__SH0_CU_EN_MASK = 0x0000ffffL;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE2__SH1_CU_EN_MASK = 0xffff0000L;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE3__SH0_CU_EN_MASK = 0x0000ffffL;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE3__SH1_CU_EN_MASK = 0xffff0000L;
    constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__CNTR_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__CNTR_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int CPC_PERFCOUNTER0_SELECT__CNTR_SEL0_MASK  = 0x000003ffL;
    constexpr unsigned int CPC_PERFCOUNTER0_SELECT__CNTR_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int CPC_PERFCOUNTER1_SELECT__CNTR_SEL0_MASK  = 0x000003ffL;
    constexpr unsigned int CPC_PERFCOUNTER1_SELECT__CNTR_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__CNTR_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__CNTR_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int CPF_PERFCOUNTER0_SELECT__CNTR_SEL0_MASK  = 0x000003ffL;
    constexpr unsigned int CPF_PERFCOUNTER0_SELECT__CNTR_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int CPF_PERFCOUNTER1_SELECT__CNTR_SEL0_MASK  = 0x000003ffL;
    constexpr unsigned int CPF_PERFCOUNTER1_SELECT__CNTR_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__CNTR_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__CNTR_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int CPG_PERFCOUNTER0_SELECT__CNTR_SEL0_MASK  = 0x000003ffL;
    constexpr unsigned int CPG_PERFCOUNTER0_SELECT__CNTR_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int CPG_PERFCOUNTER1_SELECT__CNTR_SEL0_MASK  = 0x000003ffL;
    constexpr unsigned int CPG_PERFCOUNTER1_SELECT__CNTR_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int CP_APPEND_ADDR_HI__CACHE_POLICY_MASK     = 0x02000000L;
    constexpr unsigned int CP_CEQ1_AVAIL__CEQ_CNT_IB1_MASK          = 0x07ff0000L;
    constexpr unsigned int CP_CEQ1_AVAIL__CEQ_CNT_RING_MASK         = 0x000007ffL;
    constexpr unsigned int CP_CEQ2_AVAIL__CEQ_CNT_IB2_MASK          = 0x000007ffL;
    constexpr unsigned int CP_CE_INTR_ROUTINE_START__IR_START_MASK  = 0x000007ffL;
    constexpr unsigned int CP_CE_PRGRM_CNTR_START__IP_START_MASK    = 0x000007ffL;
    constexpr unsigned int CP_CE_RB_OFFSET__RB_OFFSET_MASK          = 0x000fffffL;
    constexpr unsigned int CP_CE_ROQ_IB1_STAT__CEQ_RPTR_INDIRECT1_MASK = 0x000003ffL;
    constexpr unsigned int CP_CE_ROQ_IB1_STAT__CEQ_WPTR_INDIRECT1_MASK = 0x03ff0000L;
    constexpr unsigned int CP_CE_ROQ_IB2_STAT__CEQ_RPTR_INDIRECT2_MASK = 0x000003ffL;
    constexpr unsigned int CP_CE_ROQ_IB2_STAT__CEQ_WPTR_INDIRECT2_MASK = 0x03ff0000L;
    constexpr unsigned int CP_CE_ROQ_RB_STAT__CEQ_RPTR_PRIMARY_MASK = 0x000003ffL;
    constexpr unsigned int CP_CE_ROQ_RB_STAT__CEQ_WPTR_PRIMARY_MASK = 0x03ff0000L;
    constexpr unsigned int CP_CONTEXT_CNTL__ME0PIPE0_MAX_WD_CNTX_MASK = 0x00000007L;
    constexpr unsigned int CP_CONTEXT_CNTL__ME0PIPE1_MAX_WD_CNTX_MASK = 0x00070000L;
    constexpr unsigned int CP_DFY_CNTL__MTYPE_MASK                  = 0x0000000cL;
    constexpr unsigned int CP_DFY_CNTL__POLICY_MASK                 = 0x00000001L;
    constexpr unsigned int CP_DMA_CNTL__BUFFER_DEPTH_MASK           = 0x000f0000L;
    constexpr unsigned int CP_DMA_ME_CONTROL__DST_CACHE_POLICY_MASK = 0x02000000L;
    constexpr unsigned int CP_DMA_ME_CONTROL__SRC_CACHE_POLICY_MASK = 0x00002000L;
    constexpr unsigned int CP_DMA_PFP_CONTROL__DST_CACHE_POLICY_MASK = 0x02000000L;
    constexpr unsigned int CP_DMA_PFP_CONTROL__SRC_CACHE_POLICY_MASK = 0x00002000L;
    constexpr unsigned int CP_EOP_DONE_EVENT_CNTL__CACHE_POLICY_MASK = 0x02000000L;
    constexpr unsigned int CP_EOP_DONE_EVENT_CNTL__WBINV_ACTION_ENA_MASK = 0x0003f000L;
    constexpr unsigned int CP_EOP_DONE_EVENT_CNTL__WBINV_TC_OP_MASK = 0x0000007fL;
    constexpr unsigned int CP_GFX_ERROR__RSVD1_ERROR_MASK           = 0x00000020L;
    constexpr unsigned int CP_GFX_ERROR__RSVD2_ERROR_MASK           = 0x00000040L;
    constexpr unsigned int CP_GFX_MQD_CONTROL__CACHE_POLICY_MASK    = 0x01000000L;
    constexpr unsigned int CP_HPD_ROQ_OFFSETS__IB_OFFSET_MASK       = 0x003f0000L;
    constexpr unsigned int CP_HQD_CTX_SAVE_CONTROL__POLICY_MASK     = 0x00000008L;
    constexpr unsigned int CP_HQD_DEQUEUE_REQUEST__DEQUEUE_REQ_MASK = 0x00000007L;
    constexpr unsigned int CP_HQD_EOP_CONTROL__CACHE_POLICY_MASK    = 0x01000000L;
    constexpr unsigned int CP_HQD_IB_CONTROL__IB_CACHE_POLICY_MASK  = 0x01000000L;
    constexpr unsigned int CP_HQD_IQ_TIMER__CACHE_POLICY_MASK       = 0x01000000L;
    constexpr unsigned int CP_HQD_IQ_TIMER__QUEUE_TYPE_MASK         = 0x02000000L;
    constexpr unsigned int CP_HQD_PQ_CONTROL__CACHE_POLICY_MASK     = 0x01000000L;
    constexpr unsigned int CP_HQD_PQ_CONTROL__ENDIAN_SWAP_MASK      = 0x00060000L;
    constexpr unsigned int CP_HQD_PQ_CONTROL__ROQ_PQ_IB_FLIP_MASK   = 0x20000000L;
    constexpr unsigned int CP_HQD_PQ_CONTROL__SLOT_BASED_WPTR_MASK  = 0x06000000L;
    constexpr unsigned int CP_HQD_PQ_CONTROL__WPP_CLAMP_EN_MASK     = 0x00010000L;
    constexpr unsigned int CP_MEC1_INTR_ROUTINE_START__IR_START_MASK = 0x0000ffffL;
    constexpr unsigned int CP_MEC1_PRGRM_CNTR_START__IP_START_MASK  = 0x0000ffffL;
    constexpr unsigned int CP_MEC2_INTR_ROUTINE_START__IR_START_MASK = 0x0000ffffL;
    constexpr unsigned int CP_MEC2_PRGRM_CNTR_START__IP_START_MASK  = 0x0000ffffL;
    constexpr unsigned int CP_MEC_CNTL__MEC_INVALIDATE_ICACHE_MASK  = 0x00000010L;
    constexpr unsigned int CP_MEC_DOORBELL_RANGE_LOWER__DOORBELL_RANGE_LOWER_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_MEC_DOORBELL_RANGE_UPPER__DOORBELL_RANGE_UPPER_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_ME_INTR_ROUTINE_START__IR_START_MASK  = 0x00000fffL;
    constexpr unsigned int CP_ME_MC_RADDR_HI__CACHE_POLICY_MASK     = 0x00400000L;
    constexpr unsigned int CP_ME_MC_WADDR_HI__CACHE_POLICY_MASK     = 0x00400000L;
    constexpr unsigned int CP_ME_PRGRM_CNTR_START__IP_START_MASK    = 0x00000fffL;
    constexpr unsigned int CP_ME_RAM_RADDR__ME_RAM_RADDR_MASK       = 0x00001fffL;
    constexpr unsigned int CP_ME_RAM_WADDR__ME_RAM_WADDR_MASK       = 0x00001fffL;
    constexpr unsigned int CP_MQD_CONTROL__CACHE_POLICY_MASK        = 0x01000000L;
    constexpr unsigned int CP_PFP_INTR_ROUTINE_START__IR_START_MASK = 0x00001fffL;
    constexpr unsigned int CP_PFP_PRGRM_CNTR_START__IP_START_MASK   = 0x00001fffL;
    constexpr unsigned int CP_PIPE_STATS_CONTROL__CACHE_POLICY_MASK = 0x02000000L;
    constexpr unsigned int CP_RB0_CNTL__BUF_SWAP_MASK               = 0x00060000L;
    constexpr unsigned int CP_RB0_CNTL__CACHE_POLICY_MASK           = 0x01000000L;
    constexpr unsigned int CP_RB1_CNTL__CACHE_POLICY_MASK           = 0x01000000L;
    constexpr unsigned int CP_RB2_CNTL__CACHE_POLICY_MASK           = 0x01000000L;
    constexpr unsigned int CP_RB_CNTL__CACHE_POLICY_MASK            = 0x01000000L;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_0__DOORBELL_EN_MASK = 0x40000000L;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_0__DOORBELL_HIT_MASK = 0x80000000L;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_0__DOORBELL_OFFSET_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_1__DOORBELL_EN_MASK = 0x40000000L;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_1__DOORBELL_HIT_MASK = 0x80000000L;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_1__DOORBELL_OFFSET_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_2__DOORBELL_EN_MASK = 0x40000000L;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_2__DOORBELL_HIT_MASK = 0x80000000L;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_2__DOORBELL_OFFSET_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_3__DOORBELL_EN_MASK = 0x40000000L;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_3__DOORBELL_HIT_MASK = 0x80000000L;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_3__DOORBELL_OFFSET_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_4__DOORBELL_EN_MASK = 0x40000000L;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_4__DOORBELL_HIT_MASK = 0x80000000L;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_4__DOORBELL_OFFSET_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_5__DOORBELL_EN_MASK = 0x40000000L;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_5__DOORBELL_HIT_MASK = 0x80000000L;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_5__DOORBELL_OFFSET_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_6__DOORBELL_EN_MASK = 0x40000000L;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_6__DOORBELL_HIT_MASK = 0x80000000L;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_6__DOORBELL_OFFSET_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_7__DOORBELL_EN_MASK = 0x40000000L;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_7__DOORBELL_HIT_MASK = 0x80000000L;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_7__DOORBELL_OFFSET_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_RB_DOORBELL_RANGE_LOWER__DOORBELL_RANGE_LOWER_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_RB_DOORBELL_RANGE_UPPER__DOORBELL_RANGE_UPPER_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_ROQ1_THRESHOLDS__R0_IB1_START_MASK    = 0x00ff0000L;
    constexpr unsigned int CP_ROQ1_THRESHOLDS__R1_IB1_START_MASK    = 0xff000000L;
    constexpr unsigned int CP_ROQ1_THRESHOLDS__RB1_START_MASK       = 0x000000ffL;
    constexpr unsigned int CP_ROQ1_THRESHOLDS__RB2_START_MASK       = 0x0000ff00L;
    constexpr unsigned int CP_ROQ2_AVAIL__ROQ_CNT_IB2_MASK          = 0x000007ffL;
    constexpr unsigned int CP_ROQ2_THRESHOLDS__R0_IB2_START_MASK    = 0x0000ff00L;
    constexpr unsigned int CP_ROQ2_THRESHOLDS__R1_IB2_START_MASK    = 0x00ff0000L;
    constexpr unsigned int CP_ROQ2_THRESHOLDS__R2_IB1_START_MASK    = 0x000000ffL;
    constexpr unsigned int CP_ROQ2_THRESHOLDS__R2_IB2_START_MASK    = 0xff000000L;
    constexpr unsigned int CP_ROQ_AVAIL__ROQ_CNT_IB1_MASK           = 0x07ff0000L;
    constexpr unsigned int CP_ROQ_AVAIL__ROQ_CNT_RING_MASK          = 0x000007ffL;
    constexpr unsigned int CP_ROQ_IB1_STAT__ROQ_RPTR_INDIRECT1_MASK = 0x000003ffL;
    constexpr unsigned int CP_ROQ_IB1_STAT__ROQ_WPTR_INDIRECT1_MASK = 0x03ff0000L;
    constexpr unsigned int CP_ROQ_IB2_STAT__ROQ_RPTR_INDIRECT2_MASK = 0x000003ffL;
    constexpr unsigned int CP_ROQ_IB2_STAT__ROQ_WPTR_INDIRECT2_MASK = 0x03ff0000L;
    constexpr unsigned int CP_ROQ_RB_STAT__ROQ_RPTR_PRIMARY_MASK    = 0x000003ffL;
    constexpr unsigned int CP_ROQ_RB_STAT__ROQ_WPTR_PRIMARY_MASK    = 0x03ff0000L;
    constexpr unsigned int CP_SCRATCH_INDEX__SCRATCH_INDEX_MASK     = 0x000000ffL;
    constexpr unsigned int CP_SD_CNTL__IA_EN_MASK                   = 0x00000040L;
    constexpr unsigned int CP_SD_CNTL__PA_EN_MASK                   = 0x00000080L;
    constexpr unsigned int CP_SD_CNTL__RMI_EN_MASK                  = 0x00000100L;
    constexpr unsigned int CP_SD_CNTL__WD_EN_MASK                   = 0x00000020L;
    constexpr unsigned int CP_SIG_SEM_ADDR_LO__SEM_ADDR_SWAP_MASK   = 0x00000003L;
    constexpr unsigned int CP_STALLED_STAT1__RBIU_TO_MEMWR_NOT_RDY_TO_RCV_MASK = 0x00000010L;
    constexpr unsigned int CP_STALLED_STAT1__RBIU_TO_SEM_NOT_RDY_TO_RCV_MASK = 0x00000004L;
    constexpr unsigned int CP_STALLED_STAT2__EOPD_FIFO_NEEDS_SC_EOP_DONE_MASK = 0x00200000L;
    constexpr unsigned int CP_STALLED_STAT2__EOPD_FIFO_NEEDS_WR_CONFIRM_MASK = 0x00400000L;
    constexpr unsigned int CP_STREAM_OUT_CONTROL__CACHE_POLICY_MASK = 0x02000000L;
    constexpr unsigned int CP_WAIT_SEM_ADDR_LO__SEM_ADDR_SWAP_MASK  = 0x00000003L;
    constexpr unsigned int DB_DEBUG2__DISABLE_TILE_COVERED_FOR_PS_ITER_MASK = 0x00004000L;
    constexpr unsigned int DB_DEBUG2__ENABLE_SUBTILE_GROUPING_MASK  = 0x00008000L;
    constexpr unsigned int DB_DEBUG2__RESERVED_MASK                 = 0x00010000L;
    constexpr unsigned int DB_DEBUG3__ALLOW_RF2P_RW_COLLISION_MASK  = 0x00010000L;
    constexpr unsigned int DB_DEBUG3__DISABLE_4XAA_2P_DELAYED_WRITE_MASK = 0x40000000L;
    constexpr unsigned int DB_DEBUG3__DISABLE_4XAA_2P_INTERLEAVED_PMASK_MASK = 0x80000000L;
    constexpr unsigned int DB_DEBUG3__DONT_DELETE_CONTEXT_SUSPEND_MASK = 0x20000000L;
    constexpr unsigned int DB_DEBUG3__ROUND_ZRANGE_CORRECTION_MASK  = 0x00000002L;
    constexpr unsigned int DB_DEBUG4__ALWAYS_ON_RMI_CLK_EN_MASK     = 0x00000080L;
    constexpr unsigned int DB_DEBUG4__DISABLE_4XAA_2P_ZD_HOLDOFF_MASK = 0x00000010L;
    constexpr unsigned int DB_DEBUG4__DISABLE_DYNAMIC_RAM_LIGHT_SLEEP_MODE_MASK = 0x00010000L;
    constexpr unsigned int DB_DEBUG4__DISABLE_HIZ_Q1_TS_COLLISION_DETECT_MASK = 0x00020000L;
    constexpr unsigned int DB_DEBUG4__DISABLE_HIZ_Q2_TS_COLLISION_DETECT_MASK = 0x00040000L;
    constexpr unsigned int DB_DEBUG4__DISABLE_SEPARATE_DFSM_CLK_MASK = 0x00001000L;
    constexpr unsigned int DB_DEBUG4__DISABLE_TS_WRITE_L0_MASK      = 0x00008000L;
    constexpr unsigned int DB_DEBUG4__ENABLE_A2M_DQUAD_OPTIMIZATION_MASK = 0x00000020L;
    constexpr unsigned int DB_DEBUG4__ENABLE_DBCB_SLOW_FORMAT_COLLAPSE_MASK = 0x00000040L;
    constexpr unsigned int DB_DEPTH_SIZE__X_MAX_MASK                = 0x00003fffL;
    constexpr unsigned int DB_DEPTH_SIZE__Y_MAX_MASK                = 0x3fff0000L;
    constexpr unsigned int DB_DFSM_CONFIG__MIDDLE_PIPE_MAX_DEPTH_MASK = 0x00007f00L;
    constexpr unsigned int DB_DFSM_FLUSH_ENABLE__PRIMARY_EVENTS_MASK = 0x000003ffL;
    constexpr unsigned int DB_DFSM_PRIMS_IN_FLIGHT__HARD_LIMIT_MASK = 0xffff0000L;
    constexpr unsigned int DB_DFSM_TILES_IN_FLIGHT__HARD_LIMIT_MASK = 0xffff0000L;
    constexpr unsigned int DB_DFSM_WATERMARK__DFSM_HIGH_WATERMARK_MASK = 0x0000ffffL;
    constexpr unsigned int DB_DFSM_WATERMARK__POPS_HIGH_WATERMARK_MASK = 0xffff0000L;
    constexpr unsigned int DB_FIFO_DEPTH1__DB_RMI_RDREQ_CREDITS_MASK = 0x0000001fL;
    constexpr unsigned int DB_FIFO_DEPTH1__DB_RMI_WRREQ_CREDITS_MASK = 0x000003e0L;
    constexpr unsigned int DB_FIFO_DEPTH1__LTILE_PROBE_FIFO_DEPTH_MASK = 0x1fe00000L;
    constexpr unsigned int DB_FIFO_DEPTH1__MCC_DEPTH_MASK           = 0x0000fc00L;
    constexpr unsigned int DB_FIFO_DEPTH1__QC_DEPTH_MASK            = 0x001f0000L;
    constexpr unsigned int DB_FIFO_DEPTH2__ETILE_OP_FIFO_DEPTH_MASK = 0x00007f00L;
    constexpr unsigned int DB_FIFO_DEPTH2__LQUAD_FIFO_DEPTH_MASK    = 0x01ff8000L;
    constexpr unsigned int DB_FREE_CACHELINES__FREE_DTILE_DEPTH_MASK = 0x0000007fL;
    constexpr unsigned int DB_FREE_CACHELINES__FREE_HTILE_DEPTH_MASK = 0x00f00000L;
    constexpr unsigned int DB_FREE_CACHELINES__FREE_PLANE_DEPTH_MASK = 0x00003f80L;
    constexpr unsigned int DB_FREE_CACHELINES__FREE_Z_DEPTH_MASK    = 0x000fc000L;
    constexpr unsigned int DB_FREE_CACHELINES__QUAD_READ_REQS_MASK  = 0xff000000L;
    constexpr unsigned int DB_HTILE_SURFACE__HTILE_USES_PRELOAD_WIN_MASK = 0x00000004L;
    constexpr unsigned int DB_HTILE_SURFACE__PREFETCH_HEIGHT_MASK   = 0x0000fc00L;
    constexpr unsigned int DB_HTILE_SURFACE__PREFETCH_WIDTH_MASK    = 0x000003f0L;
    constexpr unsigned int DB_HTILE_SURFACE__PRELOAD_MASK           = 0x00000008L;
    constexpr unsigned int DB_HTILE_SURFACE__RB_ALIGNED_MASK        = 0x00080000L;
    constexpr unsigned int DB_RMI_CACHE_POLICY__CC_RD_MASK          = 0x00010000L;
    constexpr unsigned int DB_RMI_CACHE_POLICY__CC_WR_MASK          = 0x01000000L;
    constexpr unsigned int DB_RMI_CACHE_POLICY__CMASK_RD_MASK       = 0x00040000L;
    constexpr unsigned int DB_RMI_CACHE_POLICY__CMASK_WR_MASK       = 0x04000000L;
    constexpr unsigned int DB_RMI_CACHE_POLICY__DCC_RD_MASK         = 0x00080000L;
    constexpr unsigned int DB_RMI_CACHE_POLICY__DCC_WR_MASK         = 0x08000000L;
    constexpr unsigned int DB_RMI_CACHE_POLICY__FMASK_RD_MASK       = 0x00020000L;
    constexpr unsigned int DB_RMI_CACHE_POLICY__FMASK_WR_MASK       = 0x02000000L;
    constexpr unsigned int DB_RMI_CACHE_POLICY__HTILE_RD_MASK       = 0x00000004L;
    constexpr unsigned int DB_RMI_CACHE_POLICY__HTILE_WR_MASK       = 0x00000400L;
    constexpr unsigned int DB_RMI_CACHE_POLICY__S_RD_MASK           = 0x00000002L;
    constexpr unsigned int DB_RMI_CACHE_POLICY__S_WR_MASK           = 0x00000200L;
    constexpr unsigned int DB_RMI_CACHE_POLICY__ZPCPSD_WR_MASK      = 0x00000800L;
    constexpr unsigned int DB_RMI_CACHE_POLICY__Z_RD_MASK           = 0x00000001L;
    constexpr unsigned int DB_RMI_CACHE_POLICY__Z_WR_MASK           = 0x00000100L;
    constexpr unsigned int DB_STENCIL_INFO2__EPITCH_MASK            = 0x0000ffffL;
    constexpr unsigned int DB_STENCIL_INFO__CLEAR_DISALLOWED_MASK   = 0x40000000L;
    constexpr unsigned int DB_STENCIL_INFO__FAULT_BEHAVIOR_MASK     = 0x00006000L;
    constexpr unsigned int DB_STENCIL_INFO__ITERATE_FLUSH_MASK      = 0x00008000L;
    constexpr unsigned int DB_WATERMARKS__AUTO_FLUSH_HTILE_MASK     = 0x40000000L;
    constexpr unsigned int DB_WATERMARKS__AUTO_FLUSH_QUAD_MASK      = 0x80000000L;
    constexpr unsigned int DB_WATERMARKS__DEPTH_CACHELINE_FREE_MASK = 0x0ff00000L;
    constexpr unsigned int DB_WATERMARKS__DEPTH_FLUSH_MASK          = 0x000007e0L;
    constexpr unsigned int DB_WATERMARKS__DEPTH_FREE_MASK           = 0x0000001fL;
    constexpr unsigned int DB_WATERMARKS__DEPTH_PENDING_FREE_MASK   = 0x000f8000L;
    constexpr unsigned int DB_WATERMARKS__FORCE_SUMMARIZE_MASK      = 0x00007800L;
    constexpr unsigned int DB_Z_INFO2__EPITCH_MASK                  = 0x0000ffffL;
    constexpr unsigned int DB_Z_INFO__CLEAR_DISALLOWED_MASK         = 0x40000000L;
    constexpr unsigned int DB_Z_INFO__FAULT_BEHAVIOR_MASK           = 0x00006000L;
    constexpr unsigned int DB_Z_INFO__ITERATE_FLUSH_MASK            = 0x00008000L;
    constexpr unsigned int GB_ADDR_CONFIG_READ__BANK_INTERLEAVE_SIZE_MASK = 0x00000700L;
    constexpr unsigned int GB_ADDR_CONFIG_READ__MULTI_GPU_TILE_SIZE_MASK = 0x03000000L;
    constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_BANKS_MASK      = 0x00007000L;
    constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_GPUS_MASK       = 0x00e00000L;
    constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_LOWER_PIPES_MASK = 0x40000000L;
    constexpr unsigned int GB_ADDR_CONFIG_READ__ROW_SIZE_MASK       = 0x30000000L;
    constexpr unsigned int GB_ADDR_CONFIG_READ__SE_ENABLE_MASK      = 0x80000000L;
    constexpr unsigned int GB_ADDR_CONFIG_READ__SHADER_ENGINE_TILE_SIZE_MASK = 0x00070000L;
    constexpr unsigned int GB_ADDR_CONFIG__BANK_INTERLEAVE_SIZE_MASK = 0x00000700L;
    constexpr unsigned int GB_ADDR_CONFIG__MULTI_GPU_TILE_SIZE_MASK = 0x03000000L;
    constexpr unsigned int GB_ADDR_CONFIG__NUM_BANKS_MASK           = 0x00007000L;
    constexpr unsigned int GB_ADDR_CONFIG__NUM_GPUS_MASK            = 0x00e00000L;
    constexpr unsigned int GB_ADDR_CONFIG__NUM_LOWER_PIPES_MASK     = 0x40000000L;
    constexpr unsigned int GB_ADDR_CONFIG__ROW_SIZE_MASK            = 0x30000000L;
    constexpr unsigned int GB_ADDR_CONFIG__SE_ENABLE_MASK           = 0x80000000L;
    constexpr unsigned int GB_ADDR_CONFIG__SHADER_ENGINE_TILE_SIZE_MASK = 0x00070000L;
    constexpr unsigned int GB_MACROTILE_MODE0__BANK_HEIGHT_MASK     = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE0__BANK_WIDTH_MASK      = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE0__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE0__NUM_BANKS_MASK       = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE1__BANK_HEIGHT_MASK     = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE1__BANK_WIDTH_MASK      = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE1__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE1__NUM_BANKS_MASK       = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE2__BANK_HEIGHT_MASK     = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE2__BANK_WIDTH_MASK      = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE2__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE2__NUM_BANKS_MASK       = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE3__BANK_HEIGHT_MASK     = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE3__BANK_WIDTH_MASK      = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE3__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE3__NUM_BANKS_MASK       = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE4__BANK_HEIGHT_MASK     = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE4__BANK_WIDTH_MASK      = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE4__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE4__NUM_BANKS_MASK       = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE5__BANK_HEIGHT_MASK     = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE5__BANK_WIDTH_MASK      = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE5__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE5__NUM_BANKS_MASK       = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE6__BANK_HEIGHT_MASK     = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE6__BANK_WIDTH_MASK      = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE6__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE6__NUM_BANKS_MASK       = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE7__BANK_HEIGHT_MASK     = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE7__BANK_WIDTH_MASK      = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE7__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE7__NUM_BANKS_MASK       = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE8__BANK_HEIGHT_MASK     = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE8__BANK_WIDTH_MASK      = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE8__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE8__NUM_BANKS_MASK       = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE9__BANK_HEIGHT_MASK     = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE9__BANK_WIDTH_MASK      = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE9__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE9__NUM_BANKS_MASK       = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE10__BANK_HEIGHT_MASK    = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE10__BANK_WIDTH_MASK     = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE10__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE10__NUM_BANKS_MASK      = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE11__BANK_HEIGHT_MASK    = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE11__BANK_WIDTH_MASK     = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE11__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE11__NUM_BANKS_MASK      = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE12__BANK_HEIGHT_MASK    = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE12__BANK_WIDTH_MASK     = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE12__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE12__NUM_BANKS_MASK      = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE13__BANK_HEIGHT_MASK    = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE13__BANK_WIDTH_MASK     = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE13__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE13__NUM_BANKS_MASK      = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE14__BANK_HEIGHT_MASK    = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE14__BANK_WIDTH_MASK     = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE14__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE14__NUM_BANKS_MASK      = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE15__BANK_HEIGHT_MASK    = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE15__BANK_WIDTH_MASK     = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE15__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE15__NUM_BANKS_MASK      = 0x000000c0L;
    constexpr unsigned int GB_TILE_MODE0__ARRAY_MODE_MASK           = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE0__MICRO_TILE_MODE_NEW_MASK  = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE0__PIPE_CONFIG_MASK          = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE0__SAMPLE_SPLIT_MASK         = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE0__TILE_SPLIT_MASK           = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE1__ARRAY_MODE_MASK           = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE1__MICRO_TILE_MODE_NEW_MASK  = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE1__PIPE_CONFIG_MASK          = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE1__SAMPLE_SPLIT_MASK         = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE1__TILE_SPLIT_MASK           = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE2__ARRAY_MODE_MASK           = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE2__MICRO_TILE_MODE_NEW_MASK  = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE2__PIPE_CONFIG_MASK          = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE2__SAMPLE_SPLIT_MASK         = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE2__TILE_SPLIT_MASK           = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE3__ARRAY_MODE_MASK           = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE3__MICRO_TILE_MODE_NEW_MASK  = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE3__PIPE_CONFIG_MASK          = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE3__SAMPLE_SPLIT_MASK         = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE3__TILE_SPLIT_MASK           = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE4__ARRAY_MODE_MASK           = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE4__MICRO_TILE_MODE_NEW_MASK  = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE4__PIPE_CONFIG_MASK          = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE4__SAMPLE_SPLIT_MASK         = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE4__TILE_SPLIT_MASK           = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE5__ARRAY_MODE_MASK           = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE5__MICRO_TILE_MODE_NEW_MASK  = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE5__PIPE_CONFIG_MASK          = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE5__SAMPLE_SPLIT_MASK         = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE5__TILE_SPLIT_MASK           = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE6__ARRAY_MODE_MASK           = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE6__MICRO_TILE_MODE_NEW_MASK  = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE6__PIPE_CONFIG_MASK          = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE6__SAMPLE_SPLIT_MASK         = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE6__TILE_SPLIT_MASK           = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE7__ARRAY_MODE_MASK           = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE7__MICRO_TILE_MODE_NEW_MASK  = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE7__PIPE_CONFIG_MASK          = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE7__SAMPLE_SPLIT_MASK         = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE7__TILE_SPLIT_MASK           = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE8__ARRAY_MODE_MASK           = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE8__MICRO_TILE_MODE_NEW_MASK  = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE8__PIPE_CONFIG_MASK          = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE8__SAMPLE_SPLIT_MASK         = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE8__TILE_SPLIT_MASK           = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE9__ARRAY_MODE_MASK           = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE9__MICRO_TILE_MODE_NEW_MASK  = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE9__PIPE_CONFIG_MASK          = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE9__SAMPLE_SPLIT_MASK         = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE9__TILE_SPLIT_MASK           = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE10__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE10__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE10__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE10__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE10__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE11__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE11__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE11__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE11__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE11__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE12__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE12__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE12__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE12__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE12__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE13__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE13__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE13__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE13__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE13__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE14__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE14__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE14__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE14__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE14__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE15__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE15__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE15__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE15__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE15__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE16__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE16__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE16__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE16__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE16__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE17__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE17__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE17__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE17__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE17__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE18__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE18__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE18__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE18__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE18__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE19__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE19__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE19__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE19__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE19__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE20__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE20__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE20__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE20__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE20__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE21__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE21__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE21__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE21__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE21__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE22__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE22__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE22__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE22__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE22__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE23__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE23__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE23__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE23__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE23__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE24__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE24__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE24__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE24__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE24__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE25__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE25__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE25__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE25__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE25__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE26__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE26__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE26__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE26__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE26__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE27__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE27__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE27__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE27__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE27__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE28__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE28__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE28__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE28__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE28__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE29__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE29__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE29__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE29__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE29__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE30__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE30__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE30__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE30__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE30__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE31__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE31__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE31__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE31__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE31__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GC_CAC_ACC_CU1__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU2__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_IA0__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_SXRB1__ACCUMULATOR_31_0_MASK  = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_TCC0__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_TCC1__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_TCC2__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_TCC3__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_TCC4__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_VGT0__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_VGT1__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_VGT2__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_WD0__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
    constexpr unsigned int GC_CAC_CNTL__CAC_BLOCK_ID_MASK           = 0x007e0000L;
    constexpr unsigned int GC_CAC_CNTL__CAC_SIGNAL_ID_MASK          = 0x7f800000L;
    constexpr unsigned int GC_CAC_OVRD_CB__OVRRD_SELECT_MASK        = 0x0000000fL;
    constexpr unsigned int GC_CAC_OVRD_CB__OVRRD_VALUE_MASK         = 0x000000f0L;
    constexpr unsigned int GC_CAC_OVRD_DB__OVRRD_SELECT_MASK        = 0x0000000fL;
    constexpr unsigned int GC_CAC_OVRD_DB__OVRRD_VALUE_MASK         = 0x000000f0L;
    constexpr unsigned int GC_CAC_OVRD_GDS__OVRRD_SELECT_MASK       = 0x0000000fL;
    constexpr unsigned int GC_CAC_OVRD_GDS__OVRRD_VALUE_MASK        = 0x000000f0L;
    constexpr unsigned int GC_CAC_OVRD_IA__OVRRD_SELECT_MASK        = 0x00000001L;
    constexpr unsigned int GC_CAC_OVRD_IA__OVRRD_VALUE_MASK         = 0x00000002L;
    constexpr unsigned int GC_CAC_OVRD_LDS__OVRRD_SELECT_MASK       = 0x0000000fL;
    constexpr unsigned int GC_CAC_OVRD_LDS__OVRRD_VALUE_MASK        = 0x000000f0L;
    constexpr unsigned int GC_CAC_OVRD_PA__OVRRD_SELECT_MASK        = 0x00000003L;
    constexpr unsigned int GC_CAC_OVRD_PA__OVRRD_VALUE_MASK         = 0x0000000cL;
    constexpr unsigned int GC_CAC_OVRD_RMI__OVRRD_SELECT_MASK       = 0x00000001L;
    constexpr unsigned int GC_CAC_OVRD_RMI__OVRRD_VALUE_MASK        = 0x00000002L;
    constexpr unsigned int GC_CAC_OVRD_SC__OVRRD_SELECT_MASK        = 0x00000001L;
    constexpr unsigned int GC_CAC_OVRD_SC__OVRRD_VALUE_MASK         = 0x00000002L;
    constexpr unsigned int GC_CAC_OVRD_SQ__OVRRD_SELECT_MASK        = 0x000001ffL;
    constexpr unsigned int GC_CAC_OVRD_SQ__OVRRD_VALUE_MASK         = 0x0003fe00L;
    constexpr unsigned int GC_CAC_OVRD_TCC__OVRRD_SELECT_MASK       = 0x0000001fL;
    constexpr unsigned int GC_CAC_OVRD_TCC__OVRRD_VALUE_MASK        = 0x000003e0L;
    constexpr unsigned int GC_CAC_OVRD_TCP__OVRRD_SELECT_MASK       = 0x0000001fL;
    constexpr unsigned int GC_CAC_OVRD_TCP__OVRRD_VALUE_MASK        = 0x000003e0L;
    constexpr unsigned int GC_CAC_OVRD_TD__OVRRD_SELECT_MASK        = 0x0000003fL;
    constexpr unsigned int GC_CAC_OVRD_TD__OVRRD_VALUE_MASK         = 0x00000fc0L;
    constexpr unsigned int GC_CAC_OVRD_VGT__OVRRD_SELECT_MASK       = 0x00000007L;
    constexpr unsigned int GC_CAC_OVRD_VGT__OVRRD_VALUE_MASK        = 0x00000038L;
    constexpr unsigned int GC_CAC_OVRD_WD__OVRRD_SELECT_MASK        = 0x00000001L;
    constexpr unsigned int GC_CAC_OVRD_WD__OVRRD_VALUE_MASK         = 0x00000002L;
    constexpr unsigned int GC_CAC_WEIGHT_IA_0__WEIGHT_IA_SIG0_MASK  = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_SQ_3__WEIGHT_SQ_SIG6_MASK  = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_SQ_3__WEIGHT_SQ_SIG7_MASK  = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_SQ_4__WEIGHT_SQ_SIG8_MASK  = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_VGT_0__WEIGHT_VGT_SIG0_MASK = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_VGT_0__WEIGHT_VGT_SIG1_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_VGT_1__WEIGHT_VGT_SIG2_MASK = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_WD_0__WEIGHT_WD_SIG0_MASK  = 0x0000ffffL;
    constexpr unsigned int GC_DIDT_CTRL0__DIDT_CLK_EN_OVERRIDE_MASK = 0x00000010L;
    constexpr unsigned int GC_DIDT_CTRL0__DIDT_CTRL_EN_MASK         = 0x00000001L;
    constexpr unsigned int GC_DIDT_CTRL0__DIDT_SW_RST_MASK          = 0x00000008L;
    constexpr unsigned int GC_DIDT_CTRL0__DIDT_TRIGGER_THROTTLE_LOWBIT_MASK = 0x000001e0L;
    constexpr unsigned int GC_DIDT_CTRL0__PHASE_OFFSET_MASK         = 0x00000006L;
    constexpr unsigned int GC_DIDT_CTRL1__MAX_POWER_MASK            = 0xffff0000L;
    constexpr unsigned int GC_DIDT_CTRL1__MIN_POWER_MASK            = 0x0000ffffL;
    constexpr unsigned int GC_DIDT_CTRL2__LONG_TERM_INTERVAL_RATIO_MASK = 0x78000000L;
    constexpr unsigned int GC_DIDT_CTRL2__MAX_POWER_DELTA_MASK      = 0x00003fffL;
    constexpr unsigned int GC_DIDT_CTRL2__SHORT_TERM_INTERVAL_SIZE_MASK = 0x03ff0000L;
    constexpr unsigned int GC_DIDT_DROOP_CTRL__DIDT_DROOP_LEVEL_EN_MASK = 0x00000001L;
    constexpr unsigned int GC_DIDT_DROOP_CTRL__DIDT_DROOP_LEVEL_INDEX_MASK = 0x00078000L;
    constexpr unsigned int GC_DIDT_DROOP_CTRL__DIDT_DROOP_LEVEL_OVERFLOW_MASK = 0x80000000L;
    constexpr unsigned int GC_DIDT_DROOP_CTRL__DIDT_DROOP_THRESHOLD_MASK = 0x00007ffeL;
    constexpr unsigned int GC_DIDT_DROOP_CTRL__DIDT_LEVEL_SEL_MASK  = 0x00080000L;
    constexpr unsigned int GC_DIDT_WEIGHT__DB_WEIGHT_MASK           = 0x0000ff00L;
    constexpr unsigned int GC_DIDT_WEIGHT__SQ_WEIGHT_MASK           = 0x000000ffL;
    constexpr unsigned int GC_DIDT_WEIGHT__TCP_WEIGHT_MASK          = 0xff000000L;
    constexpr unsigned int GC_DIDT_WEIGHT__TD_WEIGHT_MASK           = 0x00ff0000L;
    constexpr unsigned int GC_EDC_DROOP_CTRL__AVG_PSM_SEL_MASK      = 0x00100000L;
    constexpr unsigned int GC_EDC_DROOP_CTRL__EDC_DROOP_LEVEL_EN_MASK = 0x00000001L;
    constexpr unsigned int GC_EDC_DROOP_CTRL__EDC_DROOP_LEVEL_INDEX_MASK = 0x000f8000L;
    constexpr unsigned int GC_EDC_DROOP_CTRL__EDC_DROOP_THRESHOLD_MASK = 0x00007ffeL;
    constexpr unsigned int GC_EDC_DROOP_CTRL__EDC_LEVEL_SEL_MASK    = 0x00200000L;
    constexpr unsigned int GC_EDC_OVERFLOW__EDC_DROOP_LEVEL_OVERFLOW_MASK = 0x00020000L;
    constexpr unsigned int GC_EDC_OVERFLOW__PSM_COUNTER_MASK        = 0xfffc0000L;
    constexpr unsigned int GC_EDC_STATUS__EDC_ROLLING_DROOP_DELTA_MASK = 0x03fffff8L;
    constexpr unsigned int GC_USER_PRIM_CONFIG__INACTIVE_IA_MASK    = 0x00030000L;
    constexpr unsigned int GC_USER_PRIM_CONFIG__INACTIVE_VGT_PA_MASK = 0x0f000000L;
    constexpr unsigned int GC_USER_SHADER_ARRAY_CONFIG__INACTIVE_CUS_MASK = 0xffff0000L;
    constexpr unsigned int GC_USER_SHADER_RATE_CONFIG__HALF_LDS_MASK = 0x00000010L;
    constexpr unsigned int GRBM_CAM_INDEX__CAM_INDEX_MASK           = 0x00000007L;
    constexpr unsigned int GRBM_CHICKEN_BITS__DISABLE_CP_VMID_RESET_REQ_MASK = 0x00000001L;
    constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SH_BROADCAST_WRITES_MASK = 0x20000000L;
    constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SH_INDEX_MASK    = 0x0000ff00L;
    constexpr unsigned int GRBM_GFX_INDEX__SH_BROADCAST_WRITES_MASK = 0x20000000L;
    constexpr unsigned int GRBM_GFX_INDEX__SH_INDEX_MASK            = 0x0000ff00L;
    constexpr unsigned int GRBM_HYP_CAM_INDEX__CAM_INDEX_MASK       = 0x00000007L;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__IA_BUSY_USER_DEFINED_MASK_MASK = 0x00800000L;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__TC_BUSY_USER_DEFINED_MASK_MASK = 0x08000000L;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__VGT_BUSY_USER_DEFINED_MASK_MASK = 0x00001000L;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__WD_BUSY_USER_DEFINED_MASK_MASK = 0x10000000L;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__IA_BUSY_USER_DEFINED_MASK_MASK = 0x00800000L;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__TC_BUSY_USER_DEFINED_MASK_MASK = 0x08000000L;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__VGT_BUSY_USER_DEFINED_MASK_MASK = 0x00001000L;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__WD_BUSY_USER_DEFINED_MASK_MASK = 0x10000000L;
    constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_CPF_MASK = 0x00010000L;
    constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__VGT_BUSY_USER_DEFINED_MASK_MASK = 0x00080000L;
    constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__VGT_BUSY_USER_DEFINED_MASK_MASK = 0x00080000L;
    constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__VGT_BUSY_USER_DEFINED_MASK_MASK = 0x00080000L;
    constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__VGT_BUSY_USER_DEFINED_MASK_MASK = 0x00080000L;
    constexpr unsigned int GRBM_STATUS2__CPF_RQ_PENDING_MASK        = 0x00080000L;
    constexpr unsigned int GRBM_STATUS2__RLC_BUSY_MASK              = 0x01000000L;
    constexpr unsigned int GRBM_STATUS2__TCC_CC_RESIDENT_MASK       = 0x04000000L;
    constexpr unsigned int GRBM_STATUS2__TC_BUSY_MASK               = 0x02000000L;
    constexpr unsigned int GRBM_STATUS_SE0__VGT_BUSY_MASK           = 0x00800000L;
    constexpr unsigned int GRBM_STATUS_SE1__VGT_BUSY_MASK           = 0x00800000L;
    constexpr unsigned int GRBM_STATUS_SE2__VGT_BUSY_MASK           = 0x00800000L;
    constexpr unsigned int GRBM_STATUS_SE3__VGT_BUSY_MASK           = 0x00800000L;
    constexpr unsigned int GRBM_STATUS__IA_BUSY_MASK                = 0x00080000L;
    constexpr unsigned int GRBM_STATUS__IA_BUSY_NO_DMA_MASK         = 0x00040000L;
    constexpr unsigned int GRBM_STATUS__VGT_BUSY_MASK               = 0x00020000L;
    constexpr unsigned int GRBM_STATUS__WD_BUSY_MASK                = 0x00200000L;
    constexpr unsigned int GRBM_STATUS__WD_BUSY_NO_DMA_MASK         = 0x00010000L;
    constexpr unsigned int GRBM_WRITE_ERROR__WRITE_VFID_MASK        = 0x000001e0L;
    constexpr unsigned int IA_CNTL_STATUS__IA_ADC_BUSY_MASK         = 0x00000010L;
    constexpr unsigned int IA_CNTL_STATUS__IA_BUSY_MASK             = 0x00000001L;
    constexpr unsigned int IA_CNTL_STATUS__IA_DMA_BUSY_MASK         = 0x00000002L;
    constexpr unsigned int IA_CNTL_STATUS__IA_DMA_REQ_BUSY_MASK     = 0x00000004L;
    constexpr unsigned int IA_CNTL_STATUS__IA_GRP_BUSY_MASK         = 0x00000008L;
    constexpr unsigned int IA_DEBUG_DATA__DATA_MASK                 = 0xffffffffL;
    constexpr unsigned int IA_DEBUG_REG0__ia_busy_MASK              = 0x00000004L;
    constexpr unsigned int IA_DEBUG_REG0__sclk_core_vld_MASK        = 0x20000000L;
    constexpr unsigned int IA_DEBUG_REG0__sclk_reg_vld_MASK         = 0x10000000L;
    constexpr unsigned int IA_DEBUG_REG1__dma_data_fifo_full_MASK   = 0x00008000L;
    constexpr unsigned int IA_MULTI_VGT_PARAM__EN_INST_OPT_ADV_MASK = 0x00400000L;
    constexpr unsigned int IA_MULTI_VGT_PARAM__EN_INST_OPT_BASIC_MASK = 0x00200000L;
    constexpr unsigned int IA_MULTI_VGT_PARAM__HW_USE_ONLY_MASK     = 0x00800000L;
    constexpr unsigned int IA_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
    constexpr unsigned int IA_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK  = 0x000003ffL;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK  = 0x000ffc00L;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT__CNTR_MODE_MASK   = 0x00f00000L;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT__PERF_MODE1_MASK  = 0x0f000000L;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT__PERF_MODE_MASK   = 0xf0000000L;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT__PERF_SEL1_MASK   = 0x000ffc00L;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT__PERF_SEL_MASK    = 0x000003ffL;
    constexpr unsigned int IA_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
    constexpr unsigned int IA_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
    constexpr unsigned int IA_PERFCOUNTER1_SELECT__PERF_MODE_MASK   = 0xf0000000L;
    constexpr unsigned int IA_PERFCOUNTER1_SELECT__PERF_SEL_MASK    = 0x000000ffL;
    constexpr unsigned int IA_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
    constexpr unsigned int IA_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
    constexpr unsigned int IA_PERFCOUNTER2_SELECT__PERF_MODE_MASK   = 0xf0000000L;
    constexpr unsigned int IA_PERFCOUNTER2_SELECT__PERF_SEL_MASK    = 0x000000ffL;
    constexpr unsigned int IA_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
    constexpr unsigned int IA_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
    constexpr unsigned int IA_PERFCOUNTER3_SELECT__PERF_MODE_MASK   = 0xf0000000L;
    constexpr unsigned int IA_PERFCOUNTER3_SELECT__PERF_SEL_MASK    = 0x000000ffL;
    constexpr unsigned int IA_UTCL1_CNTL__FORCE_SD_VMID_DIRTY_MASK  = 0x20000000L;
    constexpr unsigned int MC_MEM_POWER_LS__LS_HOLD_MASK            = 0x00000fc0L;
    constexpr unsigned int MC_MEM_POWER_LS__LS_SETUP_MASK           = 0x0000003fL;
    constexpr unsigned int MC_SHARED_VIRT_RESET_REQ__PF_MASK        = 0x80000000L;
    constexpr unsigned int MC_SHARED_VIRT_RESET_REQ__VF_MASK        = 0x0000ffffL;
    constexpr unsigned int MC_VM_AGP_BASE__AGP_BASE_MASK            = 0x00ffffffL;
    constexpr unsigned int MC_VM_AGP_BOT__AGP_BOT_MASK              = 0x00ffffffL;
    constexpr unsigned int MC_VM_AGP_TOP__AGP_TOP_MASK              = 0x00ffffffL;
    constexpr unsigned int MC_VM_APT_CNTL__DIRECT_SYSTEM_EN_MASK    = 0x00000002L;
    constexpr unsigned int MC_VM_APT_CNTL__FORCE_MTYPE_UC_MASK      = 0x00000001L;
    constexpr unsigned int MC_VM_CACHEABLE_DRAM_ADDRESS_END__ADDRESS_MASK = 0x000fffffL;
    constexpr unsigned int MC_VM_CACHEABLE_DRAM_ADDRESS_START__ADDRESS_MASK = 0x000fffffL;
    constexpr unsigned int MC_VM_FB_LOCATION_BASE__FB_BASE_MASK     = 0x00ffffffL;
    constexpr unsigned int MC_VM_FB_LOCATION_TOP__FB_TOP_MASK       = 0x00ffffffL;
    constexpr unsigned int MC_VM_FB_OFFSET__FB_OFFSET_MASK          = 0x00ffffffL;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF0__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF0__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF1__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF1__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF2__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF2__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF3__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF3__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF4__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF4__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF5__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF5__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF6__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF6__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF7__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF7__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF8__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF8__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF9__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF9__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF10__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF10__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF11__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF11__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF12__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF12__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF13__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF13__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF14__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF14__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF15__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF15__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER0_CFG__CLEAR_MASK    = 0x20000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER0_CFG__ENABLE_MASK   = 0x10000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER0_CFG__PERF_MODE_MASK = 0x0f000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER0_CFG__PERF_SEL_END_MASK = 0x0000ff00L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER0_CFG__PERF_SEL_MASK = 0x000000ffL;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER1_CFG__CLEAR_MASK    = 0x20000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER1_CFG__ENABLE_MASK   = 0x10000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER1_CFG__PERF_MODE_MASK = 0x0f000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER1_CFG__PERF_SEL_END_MASK = 0x0000ff00L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER1_CFG__PERF_SEL_MASK = 0x000000ffL;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER2_CFG__CLEAR_MASK    = 0x20000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER2_CFG__ENABLE_MASK   = 0x10000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER2_CFG__PERF_MODE_MASK = 0x0f000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER2_CFG__PERF_SEL_END_MASK = 0x0000ff00L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER2_CFG__PERF_SEL_MASK = 0x000000ffL;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER3_CFG__CLEAR_MASK    = 0x20000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER3_CFG__ENABLE_MASK   = 0x10000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER3_CFG__PERF_MODE_MASK = 0x0f000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER3_CFG__PERF_SEL_END_MASK = 0x0000ff00L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER3_CFG__PERF_SEL_MASK = 0x000000ffL;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER4_CFG__CLEAR_MASK    = 0x20000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER4_CFG__ENABLE_MASK   = 0x10000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER4_CFG__PERF_MODE_MASK = 0x0f000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER4_CFG__PERF_SEL_END_MASK = 0x0000ff00L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER4_CFG__PERF_SEL_MASK = 0x000000ffL;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER5_CFG__CLEAR_MASK    = 0x20000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER5_CFG__ENABLE_MASK   = 0x10000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER5_CFG__PERF_MODE_MASK = 0x0f000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER5_CFG__PERF_SEL_END_MASK = 0x0000ff00L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER5_CFG__PERF_SEL_MASK = 0x000000ffL;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER6_CFG__CLEAR_MASK    = 0x20000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER6_CFG__ENABLE_MASK   = 0x10000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER6_CFG__PERF_MODE_MASK = 0x0f000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER6_CFG__PERF_SEL_END_MASK = 0x0000ff00L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER6_CFG__PERF_SEL_MASK = 0x000000ffL;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER7_CFG__CLEAR_MASK    = 0x20000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER7_CFG__ENABLE_MASK   = 0x10000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER7_CFG__PERF_MODE_MASK = 0x0f000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER7_CFG__PERF_SEL_END_MASK = 0x0000ff00L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER7_CFG__PERF_SEL_MASK = 0x000000ffL;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_HI__COMPARE_VALUE_MASK = 0xffff0000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_HI__COUNTER_HI_MASK = 0x0000ffffL;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_LO__COUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL_MASK = 0x02000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY_MASK = 0x01000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT_MASK = 0x0000000fL;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_RSLT_CNTL__START_TRIGGER_MASK = 0x0000ff00L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE_MASK = 0x04000000L;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER_MASK = 0x00ff0000L;
    constexpr unsigned int MC_VM_LOCAL_HBM_ADDRESS_END__ADDRESS_MASK = 0x000fffffL;
    constexpr unsigned int MC_VM_LOCAL_HBM_ADDRESS_LOCK_CNTL__LOCK_MASK = 0x00000001L;
    constexpr unsigned int MC_VM_LOCAL_HBM_ADDRESS_START__ADDRESS_MASK = 0x000fffffL;
    constexpr unsigned int MC_VM_MARC_BASE_HI_0__MARC_BASE_HI_0_MASK = 0x000fffffL;
    constexpr unsigned int MC_VM_MARC_BASE_HI_1__MARC_BASE_HI_1_MASK = 0x000fffffL;
    constexpr unsigned int MC_VM_MARC_BASE_HI_2__MARC_BASE_HI_2_MASK = 0x000fffffL;
    constexpr unsigned int MC_VM_MARC_BASE_HI_3__MARC_BASE_HI_3_MASK = 0x000fffffL;
    constexpr unsigned int MC_VM_MARC_BASE_LO_0__MARC_BASE_LO_0_MASK = 0xfffff000L;
    constexpr unsigned int MC_VM_MARC_BASE_LO_1__MARC_BASE_LO_1_MASK = 0xfffff000L;
    constexpr unsigned int MC_VM_MARC_BASE_LO_2__MARC_BASE_LO_2_MASK = 0xfffff000L;
    constexpr unsigned int MC_VM_MARC_BASE_LO_3__MARC_BASE_LO_3_MASK = 0xfffff000L;
    constexpr unsigned int MC_VM_MARC_LEN_HI_0__MARC_LEN_HI_0_MASK  = 0x000fffffL;
    constexpr unsigned int MC_VM_MARC_LEN_HI_1__MARC_LEN_HI_1_MASK  = 0x000fffffL;
    constexpr unsigned int MC_VM_MARC_LEN_HI_2__MARC_LEN_HI_2_MASK  = 0x000fffffL;
    constexpr unsigned int MC_VM_MARC_LEN_HI_3__MARC_LEN_HI_3_MASK  = 0x000fffffL;
    constexpr unsigned int MC_VM_MARC_LEN_LO_0__MARC_LEN_LO_0_MASK  = 0xfffff000L;
    constexpr unsigned int MC_VM_MARC_LEN_LO_1__MARC_LEN_LO_1_MASK  = 0xfffff000L;
    constexpr unsigned int MC_VM_MARC_LEN_LO_2__MARC_LEN_LO_2_MASK  = 0xfffff000L;
    constexpr unsigned int MC_VM_MARC_LEN_LO_3__MARC_LEN_LO_3_MASK  = 0xfffff000L;
    constexpr unsigned int MC_VM_MARC_RELOC_HI_0__MARC_RELOC_HI_0_MASK = 0x000fffffL;
    constexpr unsigned int MC_VM_MARC_RELOC_HI_1__MARC_RELOC_HI_1_MASK = 0x000fffffL;
    constexpr unsigned int MC_VM_MARC_RELOC_HI_2__MARC_RELOC_HI_2_MASK = 0x000fffffL;
    constexpr unsigned int MC_VM_MARC_RELOC_HI_3__MARC_RELOC_HI_3_MASK = 0x000fffffL;
    constexpr unsigned int MC_VM_MARC_RELOC_LO_0__MARC_ENABLE_0_MASK = 0x00000001L;
    constexpr unsigned int MC_VM_MARC_RELOC_LO_0__MARC_READONLY_0_MASK = 0x00000002L;
    constexpr unsigned int MC_VM_MARC_RELOC_LO_0__MARC_RELOC_LO_0_MASK = 0xfffff000L;
    constexpr unsigned int MC_VM_MARC_RELOC_LO_1__MARC_ENABLE_1_MASK = 0x00000001L;
    constexpr unsigned int MC_VM_MARC_RELOC_LO_1__MARC_READONLY_1_MASK = 0x00000002L;
    constexpr unsigned int MC_VM_MARC_RELOC_LO_1__MARC_RELOC_LO_1_MASK = 0xfffff000L;
    constexpr unsigned int MC_VM_MARC_RELOC_LO_2__MARC_ENABLE_2_MASK = 0x00000001L;
    constexpr unsigned int MC_VM_MARC_RELOC_LO_2__MARC_READONLY_2_MASK = 0x00000002L;
    constexpr unsigned int MC_VM_MARC_RELOC_LO_2__MARC_RELOC_LO_2_MASK = 0xfffff000L;
    constexpr unsigned int MC_VM_MARC_RELOC_LO_3__MARC_ENABLE_3_MASK = 0x00000001L;
    constexpr unsigned int MC_VM_MARC_RELOC_LO_3__MARC_READONLY_3_MASK = 0x00000002L;
    constexpr unsigned int MC_VM_MARC_RELOC_LO_3__MARC_RELOC_LO_3_MASK = 0xfffff000L;
    constexpr unsigned int MC_VM_MX_L1_TLB_CNTL__ATC_EN_MASK        = 0x00002000L;
    constexpr unsigned int MC_VM_MX_L1_TLB_CNTL__ECO_BITS_MASK      = 0x00000780L;
    constexpr unsigned int MC_VM_MX_L1_TLB_CNTL__ENABLE_ADVANCED_DRIVER_MODEL_MASK = 0x00000040L;
    constexpr unsigned int MC_VM_MX_L1_TLB_CNTL__ENABLE_L1_TLB_MASK = 0x00000001L;
    constexpr unsigned int MC_VM_MX_L1_TLB_CNTL__MTYPE_MASK         = 0x00001800L;
    constexpr unsigned int MC_VM_MX_L1_TLB_CNTL__SYSTEM_ACCESS_MODE_MASK = 0x00000018L;
    constexpr unsigned int MC_VM_MX_L1_TLB_CNTL__SYSTEM_APERTURE_UNMAPPED_ACCESS_MASK = 0x00000020L;
    constexpr unsigned int MC_VM_NB_LOWER_TOP_OF_DRAM2__ENABLE_MASK = 0x00000001L;
    constexpr unsigned int MC_VM_NB_LOWER_TOP_OF_DRAM2__LOWER_TOM2_MASK = 0xff800000L;
    constexpr unsigned int MC_VM_NB_MMIOBASE__MMIOBASE_MASK         = 0xffffffffL;
    constexpr unsigned int MC_VM_NB_MMIOLIMIT__MMIOLIMIT_MASK       = 0xffffffffL;
    constexpr unsigned int MC_VM_NB_PCI_ARB__VGA_HOLE_MASK          = 0x00000008L;
    constexpr unsigned int MC_VM_NB_PCI_CTRL__MMIOENABLE_MASK       = 0x00800000L;
    constexpr unsigned int MC_VM_NB_TOP_OF_DRAM_SLOT1__TOP_OF_DRAM_MASK = 0xff800000L;
    constexpr unsigned int MC_VM_NB_UPPER_TOP_OF_DRAM2__UPPER_TOM2_MASK = 0x00000fffL;
    constexpr unsigned int MC_VM_STEERING__DEFAULT_STEERING_MASK    = 0x00000003L;
    constexpr unsigned int MC_VM_SYSTEM_APERTURE_DEFAULT_ADDR_LSB__PHYSICAL_PAGE_NUMBER_LSB_MASK = 0xffffffffL;
    constexpr unsigned int MC_VM_SYSTEM_APERTURE_DEFAULT_ADDR_MSB__PHYSICAL_PAGE_NUMBER_MSB_MASK = 0x0000000fL;
    constexpr unsigned int MC_VM_SYSTEM_APERTURE_HIGH_ADDR__LOGICAL_ADDR_MASK = 0x3fffffffL;
    constexpr unsigned int MC_VM_SYSTEM_APERTURE_LOW_ADDR__LOGICAL_ADDR_MASK = 0x3fffffffL;
    constexpr unsigned int PA_CL_CNTL_STATUS__UTC_FAULT_DETECTED_MASK = 0x00000001L;
    constexpr unsigned int PA_CL_CNTL_STATUS__UTC_PRT_DETECTED_MASK = 0x00000004L;
    constexpr unsigned int PA_CL_CNTL_STATUS__UTC_RETRY_DETECTED_MASK = 0x00000002L;
    constexpr unsigned int PA_CL_ENHANCE__ECO_SPARE2_MASK           = 0x20000000L;
    constexpr unsigned int PA_CL_ENHANCE__ECO_SPARE3_MASK           = 0x10000000L;
    constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_LINE_WIDTH_MASK = 0x04000000L;
    constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_SHD_OBJPRIM_ID_MASK = 0x08000000L;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__FLUSH_GS_OUTPUT_MASK = 0x0c000000L;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__CS_CONTEXT_DONE_MASK = 0x000000c0L;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__FLUSH_SX_TS_MASK = 0x000c0000L;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__RESERVED_63_MASK = 0xc0000000L;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__SX_CB_RAT_ACK_REQUEST_MASK = 0x00000030L;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_FLUSH_MASK = 0x00003000L;
    constexpr unsigned int PA_SC_ENHANCE_1__ALLOW_SCALE_LINE_WIDTH_PAD_WITH_BINNING_MASK = 0x00020000L;
    constexpr unsigned int PA_SC_ENHANCE_1__DEBUG_PIXEL_PICKER_XY_UNPACK_MASK = 0x00001000L;
    constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PACKER_GRAD_FDCE_ENHANCE_MASK = 0x00002000L;
    constexpr unsigned int PA_SC_FOV_WINDOW_LR__LEFT_EYE_FOV_LEFT_MASK = 0x000000ffL;
    constexpr unsigned int PA_SC_FOV_WINDOW_LR__LEFT_EYE_FOV_RIGHT_MASK = 0x0000ff00L;
    constexpr unsigned int PA_SC_FOV_WINDOW_LR__RIGHT_EYE_FOV_LEFT_MASK = 0x00ff0000L;
    constexpr unsigned int PA_SC_FOV_WINDOW_LR__RIGHT_EYE_FOV_RIGHT_MASK = 0xff000000L;
    constexpr unsigned int PA_SC_FOV_WINDOW_TB__FOV_BOT_MASK        = 0x0000ff00L;
    constexpr unsigned int PA_SC_FOV_WINDOW_TB__FOV_TOP_MASK        = 0x000000ffL;
    constexpr unsigned int PA_SC_HORIZ_GRID__BOT_HALF_MASK          = 0x00ff0000L;
    constexpr unsigned int PA_SC_HORIZ_GRID__BOT_QTR_MASK           = 0xff000000L;
    constexpr unsigned int PA_SC_HORIZ_GRID__TOP_HALF_MASK          = 0x0000ff00L;
    constexpr unsigned int PA_SC_HORIZ_GRID__TOP_QTR_MASK           = 0x000000ffL;
    constexpr unsigned int PA_SC_LEFT_VERT_GRID__LEFT_HALF_MASK     = 0x0000ff00L;
    constexpr unsigned int PA_SC_LEFT_VERT_GRID__LEFT_QTR_MASK      = 0x000000ffL;
    constexpr unsigned int PA_SC_LEFT_VERT_GRID__RIGHT_HALF_MASK    = 0x00ff0000L;
    constexpr unsigned int PA_SC_LEFT_VERT_GRID__RIGHT_QTR_MASK     = 0xff000000L;
    constexpr unsigned int PA_SC_MODE_CNTL_0__SCALE_LINE_WIDTH_PAD_MASK = 0x00000010L;
    constexpr unsigned int PA_SC_RASTER_CONFIG_1__SE_PAIR_XSEL_MASK = 0x0000001cL;
    constexpr unsigned int PA_SC_RASTER_CONFIG_1__SE_PAIR_YSEL_MASK = 0x000000e0L;
    constexpr unsigned int PA_SC_RASTER_CONFIG__SE_XSEL_MASK        = 0x1c000000L;
    constexpr unsigned int PA_SC_RASTER_CONFIG__SE_YSEL_MASK        = 0xe0000000L;
    constexpr unsigned int PA_SC_RIGHT_VERT_GRID__LEFT_HALF_MASK    = 0x0000ff00L;
    constexpr unsigned int PA_SC_RIGHT_VERT_GRID__LEFT_QTR_MASK     = 0x000000ffL;
    constexpr unsigned int PA_SC_RIGHT_VERT_GRID__RIGHT_HALF_MASK   = 0x00ff0000L;
    constexpr unsigned int PA_SC_RIGHT_VERT_GRID__RIGHT_QTR_MASK    = 0xff000000L;
    constexpr unsigned int PA_SU_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0x0000ffffL;
    constexpr unsigned int PA_SU_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0x0000ffffL;
    constexpr unsigned int PA_SU_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK = 0x0000ffffL;
    constexpr unsigned int PA_SU_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK = 0x0000ffffL;
    constexpr unsigned int PA_UTCL1_CNTL1__CLIENTID_MASK            = 0x0000ff80L;
    constexpr unsigned int PA_UTCL1_CNTL1__ENABLE_LFIFO_PRI_ARB_MASK = 0x00040000L;
    constexpr unsigned int PA_UTCL1_CNTL1__ENABLE_PUSH_LFIFO_MASK   = 0x00020000L;
    constexpr unsigned int PA_UTCL1_CNTL1__FORCE_4K_L2_RESP_MASK    = 0x00000001L;
    constexpr unsigned int PA_UTCL1_CNTL1__FORCE_IN_ORDER_MASK      = 0x08000000L;
    constexpr unsigned int PA_UTCL1_CNTL1__FORCE_MISS_MASK          = 0x04000000L;
    constexpr unsigned int PA_UTCL1_CNTL1__GPUVM_64K_DEFAULT_MASK   = 0x00000002L;
    constexpr unsigned int PA_UTCL1_CNTL1__GPUVM_PERM_MODE_MASK     = 0x00000004L;
    constexpr unsigned int PA_UTCL1_CNTL1__INVALIDATE_ALL_VMID_MASK = 0x02000000L;
    constexpr unsigned int PA_UTCL1_CNTL1__REDUCE_CACHE_SIZE_BY_2_MASK = 0xc0000000L;
    constexpr unsigned int PA_UTCL1_CNTL1__REDUCE_FIFO_DEPTH_BY_2_MASK = 0x30000000L;
    constexpr unsigned int PA_UTCL1_CNTL1__REG_INV_ALL_VMID_MASK    = 0x00800000L;
    constexpr unsigned int PA_UTCL1_CNTL1__REG_INV_TOGGLE_MASK      = 0x01000000L;
    constexpr unsigned int PA_UTCL1_CNTL1__REG_INV_VMID_MASK        = 0x00780000L;
    constexpr unsigned int PA_UTCL1_CNTL1__RESP_FAULT_MODE_MASK     = 0x00000060L;
    constexpr unsigned int PA_UTCL1_CNTL1__RESP_MODE_MASK           = 0x00000018L;
    constexpr unsigned int PA_UTCL1_CNTL1__SPARE_MASK               = 0x00010000L;
    constexpr unsigned int PA_UTCL1_CNTL2__ENABLE_PERF_EVENT_RD_WR_MASK = 0x00040000L;
    constexpr unsigned int PA_UTCL1_CNTL2__ENABLE_PERF_EVENT_VMID_MASK = 0x00100000L;
    constexpr unsigned int PA_UTCL1_CNTL2__ENABLE_SHOOTDOWN_OPT_MASK = 0x00002000L;
    constexpr unsigned int PA_UTCL1_CNTL2__FORCE_FRAG_2M_TO_64K_MASK = 0x04000000L;
    constexpr unsigned int PA_UTCL1_CNTL2__FORCE_GPUVM_INV_ACK_MASK = 0x00008000L;
    constexpr unsigned int PA_UTCL1_CNTL2__FORCE_SNOOP_MASK         = 0x00004000L;
    constexpr unsigned int PA_UTCL1_CNTL2__GPUVM_INV_MODE_MASK      = 0x00001000L;
    constexpr unsigned int PA_UTCL1_CNTL2__LINE_VALID_MASK          = 0x00000400L;
    constexpr unsigned int PA_UTCL1_CNTL2__MTYPE_OVRD_DIS_MASK      = 0x00000200L;
    constexpr unsigned int PA_UTCL1_CNTL2__PERF_EVENT_RD_WR_MASK    = 0x00080000L;
    constexpr unsigned int PA_UTCL1_CNTL2__PERF_EVENT_VMID_MASK     = 0x01e00000L;
    constexpr unsigned int PA_UTCL1_CNTL2__RESERVED_MASK            = 0xf8000000L;
    constexpr unsigned int PA_UTCL1_CNTL2__SPARE1_MASK              = 0x000000ffL;
    constexpr unsigned int PA_UTCL1_CNTL2__SPARE2_MASK              = 0x00000100L;
    constexpr unsigned int PA_UTCL1_CNTL2__SPARE3_MASK              = 0x00000800L;
    constexpr unsigned int PA_UTCL1_CNTL2__SPARE4_MASK              = 0x00030000L;
    constexpr unsigned int PA_UTCL1_CNTL2__SPARE5_MASK              = 0x02000000L;
    constexpr unsigned int RLC_SPM_CB_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_CB_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_CPC_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_CPC_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_CPF_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_CPF_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_CPG_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_CPG_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_DB_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_DB_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA_MASK                 = 0xffffffffL;
    constexpr unsigned int RLC_SPM_GDS_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_GDS_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_GLOBAL_MUXSEL_ADDR__PERFMON_SEL_ADDR_MASK = 0xffffffffL;
    constexpr unsigned int RLC_SPM_IA_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_IA_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_MC_CNTL__RESERVED_MASK           = 0xfffffc00L;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_FED_MASK        = 0x00000040L;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_MTYPE_MASK      = 0x00000300L;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_MTYPE_OVER_MASK = 0x00000080L;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_PERF_CNTR_MASK  = 0x00000020L;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_POLICY_MASK     = 0x00000010L;
    constexpr unsigned int RLC_SPM_PA_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_PA_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_RMI_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_RMI_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_SC_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_SC_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_SEGMENT_THRESHOLD__NUM_SEGMENT_THRESHOLD_MASK = 0xffffffffL;
    constexpr unsigned int RLC_SPM_SE_MUXSEL_ADDR__PERFMON_SEL_ADDR_MASK = 0xffffffffL;
    constexpr unsigned int RLC_SPM_SPI_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_SPI_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_SQG_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_SQG_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_SX_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_SX_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_TA_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_TA_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_TCA_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_TCA_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_TCC_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_TCC_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_TCP_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_TCP_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_TD_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_TD_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_UTCL1_CNTL__FORCE_SD_VMID_DIRTY_MASK = 0x20000000L;
    constexpr unsigned int RLC_SPM_VGT_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_VGT_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RMI_GENERAL_CNTL1__POLICY_OVERRIDE_MASK  = 0x00000400L;
    constexpr unsigned int RMI_GENERAL_CNTL1__POLICY_OVERRIDE_VALUE_MASK = 0x00000200L;
    constexpr unsigned int RMI_GENERAL_CNTL1__UTCL1_PROBE0_RR_ARB_BURST_HINT_EN_MASK = 0x00000800L;
    constexpr unsigned int RMI_SPARE_1__SPARE_BIT_8_1_MASK          = 0x0000ff00L;
    constexpr unsigned int RMI_SPARE_1__SPARE_BIT_8_MASK            = 0x00000001L;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_4_0_MASK          = 0x00000f00L;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_4_1_MASK          = 0x0000f000L;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_16_MASK           = 0x00000001L;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_17_MASK           = 0x00000002L;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_18_MASK           = 0x00000004L;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_19_MASK           = 0x00000008L;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_20_MASK           = 0x00000010L;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_21_MASK           = 0x00000020L;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_22_MASK           = 0x00000040L;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_23_MASK           = 0x00000080L;
    constexpr unsigned int RMI_SPARE__SPARE_BIT_1_MASK              = 0x00000002L;
    constexpr unsigned int RMI_SPARE__SPARE_BIT_2_MASK              = 0x00000004L;
    constexpr unsigned int RMI_SPARE__SPARE_BIT_3_MASK              = 0x00000008L;
    constexpr unsigned int RMI_SPARE__SPARE_BIT_4_MASK              = 0x00000010L;
    constexpr unsigned int RMI_SPARE__SPARE_BIT_5_MASK              = 0x00000020L;
    constexpr unsigned int RMI_SPARE__SPARE_BIT_6_MASK              = 0x00000040L;
    constexpr unsigned int RMI_SPARE__SPARE_BIT_8_0_MASK            = 0x0000ff00L;
    constexpr unsigned int RMI_SPARE__SPARE_BIT_16_0_MASK           = 0xffff0000L;
    constexpr unsigned int SDMA0_PERFCOUNTER0_RESULT__PERF_COUNT_MASK = 0xffffffffL;
    constexpr unsigned int SDMA0_PERFCOUNTER1_RESULT__PERF_COUNT_MASK = 0xffffffffL;
    constexpr unsigned int SDMA0_PERFCOUNTER_TAG_DELAY_RANGE__RANGE_HIGH_MASK = 0x0fffc000L;
    constexpr unsigned int SDMA0_PERFCOUNTER_TAG_DELAY_RANGE__RANGE_LOW_MASK = 0x00003fffL;
    constexpr unsigned int SDMA0_PERFCOUNTER_TAG_DELAY_RANGE__SELECT_RW_MASK = 0x10000000L;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_CLEAR0_MASK     = 0x00000002L;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_CLEAR1_MASK     = 0x00000800L;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_ENABLE0_MASK    = 0x00000001L;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_ENABLE1_MASK    = 0x00000400L;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_SEL0_MASK       = 0x000003fcL;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_SEL1_MASK       = 0x000ff000L;
    constexpr unsigned int SDMA_PGFSM_CONFIG__FSM_ADDR_MASK         = 0x000000ffL;
    constexpr unsigned int SDMA_PGFSM_CONFIG__P1_SELECT_MASK        = 0x00000400L;
    constexpr unsigned int SDMA_PGFSM_CONFIG__P2_SELECT_MASK        = 0x00000800L;
    constexpr unsigned int SDMA_PGFSM_CONFIG__POWER_DOWN_MASK       = 0x00000100L;
    constexpr unsigned int SDMA_PGFSM_CONFIG__POWER_UP_MASK         = 0x00000200L;
    constexpr unsigned int SDMA_PGFSM_CONFIG__READ_MASK             = 0x00002000L;
    constexpr unsigned int SDMA_PGFSM_CONFIG__REG_ADDR_MASK         = 0xf0000000L;
    constexpr unsigned int SDMA_PGFSM_CONFIG__SRBM_OVERRIDE_MASK    = 0x08000000L;
    constexpr unsigned int SDMA_PGFSM_CONFIG__WRITE_MASK            = 0x00001000L;
    constexpr unsigned int SDMA_PGFSM_READ__VALUE_MASK              = 0x00ffffffL;
    constexpr unsigned int SDMA_PGFSM_WRITE__VALUE_MASK             = 0xffffffffL;
    constexpr unsigned int SDMA_POWER_GATING__PG_CNTL_STATUS_MASK   = 0x00000030L;
    constexpr unsigned int SDMA_POWER_GATING__SDMA0_POWER_OFF_CONDITION_MASK = 0x00000001L;
    constexpr unsigned int SDMA_POWER_GATING__SDMA0_POWER_OFF_REQ_MASK = 0x00000004L;
    constexpr unsigned int SDMA_POWER_GATING__SDMA0_POWER_ON_CONDITION_MASK = 0x00000002L;
    constexpr unsigned int SDMA_POWER_GATING__SDMA0_POWER_ON_REQ_MASK = 0x00000008L;
    constexpr unsigned int SH_MEM_CONFIG__ALIGNMENT_MODE_MASK       = 0x00000018L;
    constexpr unsigned int SH_MEM_CONFIG__PRIVATE_NV_MASK           = 0x00002000L;
    constexpr unsigned int SH_MEM_CONFIG__RETRY_DISABLE_MASK        = 0x00001000L;
    constexpr unsigned int SPI_CONFIG_CNTL_1__BATON_RESET_DISABLE_MASK = 0x00000020L;
    constexpr unsigned int SPI_CONFIG_CNTL_1__PC_LIMIT_ENABLE_MASK  = 0x00000040L;
    constexpr unsigned int SPI_CONFIG_CNTL_1__PC_LIMIT_SIZE_MASK    = 0xffff0000L;
    constexpr unsigned int SPI_CONFIG_CNTL__RSRC_MGMT_RESET_MASK    = 0x04000000L;
    constexpr unsigned int SPI_CONFIG_PS_CU_EN__ENABLE_MASK         = 0x00000001L;
    constexpr unsigned int SPI_CONFIG_PS_CU_EN__PKR0_CU_EN_MASK     = 0x0000fffeL;
    constexpr unsigned int SPI_CONFIG_PS_CU_EN__PKR1_CU_EN_MASK     = 0xffff0000L;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_4__COUNT_MASK    = 0x000007ffL;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_4__EVENTS_MASK   = 0x07ff0000L;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_5__COUNT_MASK    = 0x000007ffL;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_5__EVENTS_MASK   = 0x07ff0000L;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_6__COUNT_MASK    = 0x000007ffL;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_6__EVENTS_MASK   = 0x07ff0000L;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_7__COUNT_MASK    = 0x000007ffL;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_7__EVENTS_MASK   = 0x07ff0000L;
    constexpr unsigned int SPI_DSM_CNTL2__SPI_SR_MEM_INJECT_DELAY_MASK = 0x000003f0L;
    constexpr unsigned int SPI_DSM_CNTL2__UNUSED_MASK               = 0xfffffc00L;
    constexpr unsigned int SPI_DSM_CNTL__UNUSED_MASK                = 0xfffffff8L;
    constexpr unsigned int SPI_LB_CU_MASK__CU_MASK_MASK             = 0x0000ffffL;
    constexpr unsigned int SPI_LB_DATA_PERCU_WAVE_CS__ACTIVE_MASK   = 0x0000ffffL;
    constexpr unsigned int SPI_LB_DATA_PERCU_WAVE_HSGS__CU_USED_GS_MASK = 0xffff0000L;
    constexpr unsigned int SPI_LB_DATA_PERCU_WAVE_HSGS__CU_USED_HS_MASK = 0x0000ffffL;
    constexpr unsigned int SPI_LB_DATA_PERCU_WAVE_VSPS__CU_USED_PS_MASK = 0xffff0000L;
    constexpr unsigned int SPI_LB_DATA_PERCU_WAVE_VSPS__CU_USED_VS_MASK = 0x0000ffffL;
    constexpr unsigned int SPI_PERFCOUNTER4_SELECT__PERF_SEL_MASK   = 0x000000ffL;
    constexpr unsigned int SPI_PERFCOUNTER5_SELECT__PERF_SEL_MASK   = 0x000000ffL;
    constexpr unsigned int SPI_PG_ENABLE_STATIC_CU_MASK__CU_MASK_MASK = 0x0000ffffL;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__BARRIERS_MASK = 0x00078000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__LDS_MASK     = 0x00000f00L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__SGPR_MASK    = 0x000000f0L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__VGPR_MASK    = 0x0000000fL;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__WAVES_MASK   = 0x00007000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__BARRIERS_MASK = 0x00078000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__LDS_MASK     = 0x00000f00L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__SGPR_MASK    = 0x000000f0L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__VGPR_MASK    = 0x0000000fL;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__WAVES_MASK   = 0x00007000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__BARRIERS_MASK = 0x00078000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__LDS_MASK     = 0x00000f00L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__SGPR_MASK    = 0x000000f0L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__VGPR_MASK    = 0x0000000fL;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__WAVES_MASK   = 0x00007000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__BARRIERS_MASK = 0x00078000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__LDS_MASK     = 0x00000f00L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__SGPR_MASK    = 0x000000f0L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__VGPR_MASK    = 0x0000000fL;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__WAVES_MASK   = 0x00007000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__BARRIERS_MASK = 0x00078000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__LDS_MASK     = 0x00000f00L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__SGPR_MASK    = 0x000000f0L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__VGPR_MASK    = 0x0000000fL;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__WAVES_MASK   = 0x00007000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__BARRIERS_MASK = 0x00078000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__LDS_MASK     = 0x00000f00L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__SGPR_MASK    = 0x000000f0L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__VGPR_MASK    = 0x0000000fL;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__WAVES_MASK   = 0x00007000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_0__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_1__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_2__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_3__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_4__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_5__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_6__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_7__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_8__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_9__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__EN_MASK   = 0x00000001L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__QUEUE_MASK_MASK = 0x00ff0000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__TYPE_MASK_MASK = 0x0000fffeL;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__EN_MASK   = 0x00000001L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__QUEUE_MASK_MASK = 0x00ff0000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__TYPE_MASK_MASK = 0x0000fffeL;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__EN_MASK   = 0x00000001L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__QUEUE_MASK_MASK = 0x00ff0000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__TYPE_MASK_MASK = 0x0000fffeL;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__EN_MASK   = 0x00000001L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__QUEUE_MASK_MASK = 0x00ff0000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__TYPE_MASK_MASK = 0x0000fffeL;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__EN_MASK   = 0x00000001L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__QUEUE_MASK_MASK = 0x00ff0000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__TYPE_MASK_MASK = 0x0000fffeL;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__EN_MASK   = 0x00000001L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__QUEUE_MASK_MASK = 0x00ff0000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__TYPE_MASK_MASK = 0x0000fffeL;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__SKIP_USGPR0_MASK = 0x08000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__USER_SGPR_MSB_MASK = 0x10000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__EXCP_EN_MASK    = 0x0000ff80L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__LDS_SIZE_MASK   = 0x01ff0000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__SKIP_USGPR0_MASK = 0x08000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__USER_SGPR_MSB_MASK = 0x10000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__SKIP_USGPR0_MASK = 0x08000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__USER_SGPR_MSB_MASK = 0x10000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__DISPATCH_DRAW_EN_MASK = 0x01000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__SKIP_USGPR0_MASK = 0x08000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__USER_SGPR_MSB_MASK = 0x10000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_GS__SIMD_DISABLE_MASK = 0x3c000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_HS__SIMD_DISABLE_MASK = 0x00003c00L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_PS__SIMD_DISABLE_MASK = 0x3c000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_VS__SIMD_DISABLE_MASK = 0x3c000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__GROUP_FIFO_DEPTH_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__SPI_SHADER_LATE_ALLOC_GS_MASK = 0x00003f80L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC4_HS__GROUP_FIFO_DEPTH_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_0__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_1__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_2__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_3__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_4__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_5__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_6__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_7__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_8__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_9__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_10__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_11__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_12__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_13__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_14__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_15__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_16__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_17__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_18__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_19__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_20__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_21__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_22__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_23__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_24__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_25__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_26__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_27__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_28__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_29__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_30__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_31__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_0__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_1__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_2__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_3__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_4__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_5__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_6__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_7__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_8__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_9__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_10__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_11__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_12__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_13__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_14__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_15__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_16__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_17__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_18__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_19__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_20__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_21__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_22__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_23__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_24__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_25__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_26__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_27__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_28__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_29__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_30__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_31__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_0__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_1__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_2__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_3__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_4__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_5__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_6__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_7__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_8__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_9__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_10__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_11__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_12__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_13__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_14__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_15__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_16__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_17__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_18__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_19__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_20__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_21__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_22__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_23__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_24__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_25__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_26__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_27__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_28__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_29__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_30__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_31__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_START_PHASE__SGPR_START_PHASE_MASK   = 0x0000000cL;
    constexpr unsigned int SPI_START_PHASE__VGPR_START_PHASE_MASK   = 0x00000003L;
    constexpr unsigned int SPI_START_PHASE__WAVE_START_PHASE_MASK   = 0x00000030L;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS4__VALUE_MASK     = 0x0000007fL;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS5__VALUE_MASK     = 0x0000007fL;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS6__VALUE_MASK     = 0x0000007fL;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS7__VALUE_MASK     = 0x0000007fL;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__ES_GRP_VALUE_MASK = 0x003e0000L;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__LS_GRP_VALUE_MASK = 0x00000f80L;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_6__EN_WARN_MASK    = 0x80000000L;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_6__MAX_CNT_MASK    = 0x7fffffffL;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_7__EN_WARN_MASK    = 0x80000000L;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_7__MAX_CNT_MASK    = 0x7fffffffL;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_8__EN_WARN_MASK    = 0x80000000L;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_8__MAX_CNT_MASK    = 0x7fffffffL;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_9__EN_WARN_MASK    = 0x80000000L;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_9__MAX_CNT_MASK    = 0x7fffffffL;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_3__INT_SENT_MASK  = 0x80000000L;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_3__MAX_CNT_MASK   = 0x7fffffffL;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_5__INT_SENT_MASK  = 0x80000000L;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_5__MAX_CNT_MASK   = 0x7fffffffL;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_10__INT_SENT_MASK = 0x80000000L;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_10__MAX_CNT_MASK  = 0x7fffffffL;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_12__INT_SENT_MASK = 0x80000000L;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_12__MAX_CNT_MASK  = 0x7fffffffL;
    constexpr unsigned int SQC_CACHES__VOL_MASK                     = 0x00000010L;
    constexpr unsigned int SQC_CACHES__WRITEBACK_MASK               = 0x00000008L;
    constexpr unsigned int SQC_CONFIG__IDENTITY_HASH_BANK_MASK      = 0x00000200L;
    constexpr unsigned int SQC_CONFIG__INST_PRF_COUNT_MASK          = 0x03000000L;
    constexpr unsigned int SQC_CONFIG__INST_PRF_FILTER_DIS_MASK     = 0x04000000L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__CLIENTID_MASK    = 0x0000ff80L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__CLIENT_INVALIDATE_ALL_VMID_MASK = 0x02000000L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__ENABLE_LFIFO_PRI_ARB_MASK = 0x00040000L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__ENABLE_PUSH_LFIFO_MASK = 0x00020000L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__FORCE_4K_L2_RESP_MASK = 0x00000001L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__FORCE_IN_ORDER_MASK = 0x08000000L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__FORCE_MISS_MASK  = 0x04000000L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__GPUVM_64K_DEF_MASK = 0x00000002L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__GPUVM_PERM_MODE_MASK = 0x00000004L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__REDUCE_CACHE_SIZE_BY_2_MASK = 0xc0000000L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__REDUCE_FIFO_DEPTH_BY_2_MASK = 0x30000000L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__REG_INVALIDATE_ALL_VMID_MASK = 0x00800000L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__REG_INVALIDATE_TOGGLE_MASK = 0x01000000L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__REG_INVALIDATE_VMID_MASK = 0x00780000L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__RESP_FAULT_MODE_MASK = 0x00000060L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__RESP_MODE_MASK   = 0x00000018L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__ARB_BURST_MODE_MASK = 0x00030000L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__DIS_EDC_MASK     = 0x00000800L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__ENABLE_PERF_EVENT_RD_WR_MASK = 0x00040000L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__ENABLE_PERF_EVENT_VMID_MASK = 0x00100000L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__FORCE_FRAG_2M_TO_64K_MASK = 0x04000000L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__FORCE_GPUVM_INV_ACK_MASK = 0x00008000L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__FORCE_SNOOP_MASK = 0x00004000L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__GPUVM_INV_MODE_MASK = 0x00001000L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__LFIFO_SCAN_DISABLE_MASK = 0x00000100L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__LINE_VALID_MASK  = 0x00000400L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__MTYPE_OVRD_DIS_MASK = 0x00000200L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__PERF_EVENT_RD_WR_MASK = 0x00080000L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__PERF_EVENT_VMID_MASK = 0x01e00000L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__SHOOTDOWN_OPT_MASK = 0x00002000L;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__SPARE_MASK       = 0x000000ffL;
    constexpr unsigned int SQC_DCACHE_UTCL1_STATUS__FAULT_DETECTED_MASK = 0x00000001L;
    constexpr unsigned int SQC_DCACHE_UTCL1_STATUS__PRT_DETECTED_MASK = 0x00000004L;
    constexpr unsigned int SQC_DCACHE_UTCL1_STATUS__RETRY_DETECTED_MASK = 0x00000002L;
    constexpr unsigned int SQC_DSM_CNTL2A__DATA_BANK_RAM_ENABLE_ERROR_INJECT_MASK = 0x03000000L;
    constexpr unsigned int SQC_DSM_CNTL2A__DATA_BANK_RAM_SELECT_INJECT_DELAY_MASK = 0x04000000L;
    constexpr unsigned int SQC_DSM_CNTL2A__DATA_DIRTY_BIT_RAM_ENABLE_ERROR_INJECT_MASK = 0x00600000L;
    constexpr unsigned int SQC_DSM_CNTL2A__DATA_DIRTY_BIT_RAM_SELECT_INJECT_DELAY_MASK = 0x00800000L;
    constexpr unsigned int SQC_DSM_CNTL2A__DATA_HIT_FIFO_ENABLE_ERROR_INJECT_MASK = 0x00018000L;
    constexpr unsigned int SQC_DSM_CNTL2A__DATA_HIT_FIFO_SELECT_INJECT_DELAY_MASK = 0x00020000L;
    constexpr unsigned int SQC_DSM_CNTL2A__DATA_MISS_FIFO_ENABLE_ERROR_INJECT_MASK = 0x000c0000L;
    constexpr unsigned int SQC_DSM_CNTL2A__DATA_MISS_FIFO_SELECT_INJECT_DELAY_MASK = 0x00100000L;
    constexpr unsigned int SQC_DSM_CNTL2A__DATA_TAG_RAM_ENABLE_ERROR_INJECT_MASK = 0x00003000L;
    constexpr unsigned int SQC_DSM_CNTL2A__DATA_TAG_RAM_SELECT_INJECT_DELAY_MASK = 0x00004000L;
    constexpr unsigned int SQC_DSM_CNTL2A__INST_BANK_RAM_ENABLE_ERROR_INJECT_MASK = 0x00000600L;
    constexpr unsigned int SQC_DSM_CNTL2A__INST_BANK_RAM_SELECT_INJECT_DELAY_MASK = 0x00000800L;
    constexpr unsigned int SQC_DSM_CNTL2A__INST_MISS_FIFO_ENABLE_ERROR_INJECT_MASK = 0x000000c0L;
    constexpr unsigned int SQC_DSM_CNTL2A__INST_MISS_FIFO_SELECT_INJECT_DELAY_MASK = 0x00000100L;
    constexpr unsigned int SQC_DSM_CNTL2A__INST_TAG_RAM_ENABLE_ERROR_INJECT_MASK = 0x00000003L;
    constexpr unsigned int SQC_DSM_CNTL2A__INST_TAG_RAM_SELECT_INJECT_DELAY_MASK = 0x00000004L;
    constexpr unsigned int SQC_DSM_CNTL2A__INST_UTCL1_MISS_FIFO_ENABLE_ERROR_INJECT_MASK = 0x00000018L;
    constexpr unsigned int SQC_DSM_CNTL2A__INST_UTCL1_MISS_FIFO_SELECT_INJECT_DELAY_MASK = 0x00000020L;
    constexpr unsigned int SQC_DSM_CNTL2B__DATA_BANK_RAM_ENABLE_ERROR_INJECT_MASK = 0x03000000L;
    constexpr unsigned int SQC_DSM_CNTL2B__DATA_BANK_RAM_SELECT_INJECT_DELAY_MASK = 0x04000000L;
    constexpr unsigned int SQC_DSM_CNTL2B__DATA_DIRTY_BIT_RAM_ENABLE_ERROR_INJECT_MASK = 0x00600000L;
    constexpr unsigned int SQC_DSM_CNTL2B__DATA_DIRTY_BIT_RAM_SELECT_INJECT_DELAY_MASK = 0x00800000L;
    constexpr unsigned int SQC_DSM_CNTL2B__DATA_HIT_FIFO_ENABLE_ERROR_INJECT_MASK = 0x00018000L;
    constexpr unsigned int SQC_DSM_CNTL2B__DATA_HIT_FIFO_SELECT_INJECT_DELAY_MASK = 0x00020000L;
    constexpr unsigned int SQC_DSM_CNTL2B__DATA_MISS_FIFO_ENABLE_ERROR_INJECT_MASK = 0x000c0000L;
    constexpr unsigned int SQC_DSM_CNTL2B__DATA_MISS_FIFO_SELECT_INJECT_DELAY_MASK = 0x00100000L;
    constexpr unsigned int SQC_DSM_CNTL2B__DATA_TAG_RAM_ENABLE_ERROR_INJECT_MASK = 0x00003000L;
    constexpr unsigned int SQC_DSM_CNTL2B__DATA_TAG_RAM_SELECT_INJECT_DELAY_MASK = 0x00004000L;
    constexpr unsigned int SQC_DSM_CNTL2B__INST_BANK_RAM_ENABLE_ERROR_INJECT_MASK = 0x00000600L;
    constexpr unsigned int SQC_DSM_CNTL2B__INST_BANK_RAM_SELECT_INJECT_DELAY_MASK = 0x00000800L;
    constexpr unsigned int SQC_DSM_CNTL2B__INST_MISS_FIFO_ENABLE_ERROR_INJECT_MASK = 0x000000c0L;
    constexpr unsigned int SQC_DSM_CNTL2B__INST_MISS_FIFO_SELECT_INJECT_DELAY_MASK = 0x00000100L;
    constexpr unsigned int SQC_DSM_CNTL2B__INST_TAG_RAM_ENABLE_ERROR_INJECT_MASK = 0x00000003L;
    constexpr unsigned int SQC_DSM_CNTL2B__INST_TAG_RAM_SELECT_INJECT_DELAY_MASK = 0x00000004L;
    constexpr unsigned int SQC_DSM_CNTL2B__INST_UTCL1_MISS_FIFO_ENABLE_ERROR_INJECT_MASK = 0x00000018L;
    constexpr unsigned int SQC_DSM_CNTL2B__INST_UTCL1_MISS_FIFO_SELECT_INJECT_DELAY_MASK = 0x00000020L;
    constexpr unsigned int SQC_DSM_CNTL2__DATA_CU0_UTCL1_LFIFO_ENABLE_ERROR_INJECT_MASK = 0x000000c0L;
    constexpr unsigned int SQC_DSM_CNTL2__DATA_CU0_UTCL1_LFIFO_SELECT_INJECT_DELAY_MASK = 0x00000100L;
    constexpr unsigned int SQC_DSM_CNTL2__DATA_CU0_WRITE_DATA_BUF_ENABLE_ERROR_INJECT_MASK = 0x00000018L;
    constexpr unsigned int SQC_DSM_CNTL2__DATA_CU0_WRITE_DATA_BUF_SELECT_INJECT_DELAY_MASK = 0x00000020L;
    constexpr unsigned int SQC_DSM_CNTL2__DATA_CU1_UTCL1_LFIFO_ENABLE_ERROR_INJECT_MASK = 0x00003000L;
    constexpr unsigned int SQC_DSM_CNTL2__DATA_CU1_UTCL1_LFIFO_SELECT_INJECT_DELAY_MASK = 0x00004000L;
    constexpr unsigned int SQC_DSM_CNTL2__DATA_CU1_WRITE_DATA_BUF_ENABLE_ERROR_INJECT_MASK = 0x00000600L;
    constexpr unsigned int SQC_DSM_CNTL2__DATA_CU1_WRITE_DATA_BUF_SELECT_INJECT_DELAY_MASK = 0x00000800L;
    constexpr unsigned int SQC_DSM_CNTL2__DATA_CU2_UTCL1_LFIFO_ENABLE_ERROR_INJECT_MASK = 0x000c0000L;
    constexpr unsigned int SQC_DSM_CNTL2__DATA_CU2_UTCL1_LFIFO_SELECT_INJECT_DELAY_MASK = 0x00100000L;
    constexpr unsigned int SQC_DSM_CNTL2__DATA_CU2_WRITE_DATA_BUF_ENABLE_ERROR_INJECT_MASK = 0x00018000L;
    constexpr unsigned int SQC_DSM_CNTL2__DATA_CU2_WRITE_DATA_BUF_SELECT_INJECT_DELAY_MASK = 0x00020000L;
    constexpr unsigned int SQC_DSM_CNTL2__INJECT_DELAY_MASK         = 0xfc000000L;
    constexpr unsigned int SQC_DSM_CNTL2__INST_UTCL1_LFIFO_ENABLE_ERROR_INJECT_MASK = 0x00000003L;
    constexpr unsigned int SQC_DSM_CNTL2__INST_UTCL1_LFIFO_SELECT_INJECT_DELAY_MASK = 0x00000004L;
    constexpr unsigned int SQC_DSM_CNTLA__DATA_BANK_RAM_DSM_IRRITATOR_DATA_MASK = 0x03000000L;
    constexpr unsigned int SQC_DSM_CNTLA__DATA_BANK_RAM_ENABLE_SINGLE_WRITE_MASK = 0x04000000L;
    constexpr unsigned int SQC_DSM_CNTLA__DATA_DIRTY_BIT_RAM_DSM_IRRITATOR_DATA_MASK = 0x00600000L;
    constexpr unsigned int SQC_DSM_CNTLA__DATA_DIRTY_BIT_RAM_ENABLE_SINGLE_WRITE_MASK = 0x00800000L;
    constexpr unsigned int SQC_DSM_CNTLA__DATA_HIT_FIFO_DSM_IRRITATOR_DATA_MASK = 0x00018000L;
    constexpr unsigned int SQC_DSM_CNTLA__DATA_HIT_FIFO_ENABLE_SINGLE_WRITE_MASK = 0x00020000L;
    constexpr unsigned int SQC_DSM_CNTLA__DATA_MISS_FIFO_DSM_IRRITATOR_DATA_MASK = 0x000c0000L;
    constexpr unsigned int SQC_DSM_CNTLA__DATA_MISS_FIFO_ENABLE_SINGLE_WRITE_MASK = 0x00100000L;
    constexpr unsigned int SQC_DSM_CNTLA__DATA_TAG_RAM_DSM_IRRITATOR_DATA_MASK = 0x00003000L;
    constexpr unsigned int SQC_DSM_CNTLA__DATA_TAG_RAM_ENABLE_SINGLE_WRITE_MASK = 0x00004000L;
    constexpr unsigned int SQC_DSM_CNTLA__INST_BANK_RAM_DSM_IRRITATOR_DATA_MASK = 0x00000600L;
    constexpr unsigned int SQC_DSM_CNTLA__INST_BANK_RAM_ENABLE_SINGLE_WRITE_MASK = 0x00000800L;
    constexpr unsigned int SQC_DSM_CNTLA__INST_MISS_FIFO_DSM_IRRITATOR_DATA_MASK = 0x000000c0L;
    constexpr unsigned int SQC_DSM_CNTLA__INST_MISS_FIFO_ENABLE_SINGLE_WRITE_MASK = 0x00000100L;
    constexpr unsigned int SQC_DSM_CNTLA__INST_TAG_RAM_DSM_IRRITATOR_DATA_MASK = 0x00000003L;
    constexpr unsigned int SQC_DSM_CNTLA__INST_TAG_RAM_ENABLE_SINGLE_WRITE_MASK = 0x00000004L;
    constexpr unsigned int SQC_DSM_CNTLA__INST_UTCL1_MISS_FIFO_DSM_IRRITATOR_DATA_MASK = 0x00000018L;
    constexpr unsigned int SQC_DSM_CNTLA__INST_UTCL1_MISS_FIFO_ENABLE_SINGLE_WRITE_MASK = 0x00000020L;
    constexpr unsigned int SQC_DSM_CNTLB__DATA_BANK_RAM_DSM_IRRITATOR_DATA_MASK = 0x03000000L;
    constexpr unsigned int SQC_DSM_CNTLB__DATA_BANK_RAM_ENABLE_SINGLE_WRITE_MASK = 0x04000000L;
    constexpr unsigned int SQC_DSM_CNTLB__DATA_DIRTY_BIT_RAM_DSM_IRRITATOR_DATA_MASK = 0x00600000L;
    constexpr unsigned int SQC_DSM_CNTLB__DATA_DIRTY_BIT_RAM_ENABLE_SINGLE_WRITE_MASK = 0x00800000L;
    constexpr unsigned int SQC_DSM_CNTLB__DATA_HIT_FIFO_DSM_IRRITATOR_DATA_MASK = 0x00018000L;
    constexpr unsigned int SQC_DSM_CNTLB__DATA_HIT_FIFO_ENABLE_SINGLE_WRITE_MASK = 0x00020000L;
    constexpr unsigned int SQC_DSM_CNTLB__DATA_MISS_FIFO_DSM_IRRITATOR_DATA_MASK = 0x000c0000L;
    constexpr unsigned int SQC_DSM_CNTLB__DATA_MISS_FIFO_ENABLE_SINGLE_WRITE_MASK = 0x00100000L;
    constexpr unsigned int SQC_DSM_CNTLB__DATA_TAG_RAM_DSM_IRRITATOR_DATA_MASK = 0x00003000L;
    constexpr unsigned int SQC_DSM_CNTLB__DATA_TAG_RAM_ENABLE_SINGLE_WRITE_MASK = 0x00004000L;
    constexpr unsigned int SQC_DSM_CNTLB__INST_BANK_RAM_DSM_IRRITATOR_DATA_MASK = 0x00000600L;
    constexpr unsigned int SQC_DSM_CNTLB__INST_BANK_RAM_ENABLE_SINGLE_WRITE_MASK = 0x00000800L;
    constexpr unsigned int SQC_DSM_CNTLB__INST_MISS_FIFO_DSM_IRRITATOR_DATA_MASK = 0x000000c0L;
    constexpr unsigned int SQC_DSM_CNTLB__INST_MISS_FIFO_ENABLE_SINGLE_WRITE_MASK = 0x00000100L;
    constexpr unsigned int SQC_DSM_CNTLB__INST_TAG_RAM_DSM_IRRITATOR_DATA_MASK = 0x00000003L;
    constexpr unsigned int SQC_DSM_CNTLB__INST_TAG_RAM_ENABLE_SINGLE_WRITE_MASK = 0x00000004L;
    constexpr unsigned int SQC_DSM_CNTLB__INST_UTCL1_MISS_FIFO_DSM_IRRITATOR_DATA_MASK = 0x00000018L;
    constexpr unsigned int SQC_DSM_CNTLB__INST_UTCL1_MISS_FIFO_ENABLE_SINGLE_WRITE_MASK = 0x00000020L;
    constexpr unsigned int SQC_DSM_CNTL__DATA_CU0_UTCL1_LFIFO_DSM_IRRITATOR_DATA_MASK = 0x000000c0L;
    constexpr unsigned int SQC_DSM_CNTL__DATA_CU0_UTCL1_LFIFO_ENABLE_SINGLE_WRITE_MASK = 0x00000100L;
    constexpr unsigned int SQC_DSM_CNTL__DATA_CU0_WRITE_DATA_BUF_DSM_IRRITATOR_DATA_MASK = 0x00000018L;
    constexpr unsigned int SQC_DSM_CNTL__DATA_CU0_WRITE_DATA_BUF_ENABLE_SINGLE_WRITE_MASK = 0x00000020L;
    constexpr unsigned int SQC_DSM_CNTL__DATA_CU1_UTCL1_LFIFO_DSM_IRRITATOR_DATA_MASK = 0x00003000L;
    constexpr unsigned int SQC_DSM_CNTL__DATA_CU1_UTCL1_LFIFO_ENABLE_SINGLE_WRITE_MASK = 0x00004000L;
    constexpr unsigned int SQC_DSM_CNTL__DATA_CU1_WRITE_DATA_BUF_DSM_IRRITATOR_DATA_MASK = 0x00000600L;
    constexpr unsigned int SQC_DSM_CNTL__DATA_CU1_WRITE_DATA_BUF_ENABLE_SINGLE_WRITE_MASK = 0x00000800L;
    constexpr unsigned int SQC_DSM_CNTL__DATA_CU2_UTCL1_LFIFO_DSM_IRRITATOR_DATA_MASK = 0x000c0000L;
    constexpr unsigned int SQC_DSM_CNTL__DATA_CU2_UTCL1_LFIFO_ENABLE_SINGLE_WRITE_MASK = 0x00100000L;
    constexpr unsigned int SQC_DSM_CNTL__DATA_CU2_WRITE_DATA_BUF_DSM_IRRITATOR_DATA_MASK = 0x00018000L;
    constexpr unsigned int SQC_DSM_CNTL__DATA_CU2_WRITE_DATA_BUF_ENABLE_SINGLE_WRITE_MASK = 0x00020000L;
    constexpr unsigned int SQC_DSM_CNTL__INST_UTCL1_LFIFO_DSM_IRRITATOR_DATA_MASK = 0x00000003L;
    constexpr unsigned int SQC_DSM_CNTL__INST_UTCL1_LFIFO_ENABLE_SINGLE_WRITE_MASK = 0x00000004L;
    constexpr unsigned int SQC_EDC_CNT2__DATA_BANKA_BANK_RAM_DED_COUNT_MASK = 0x0000c000L;
    constexpr unsigned int SQC_EDC_CNT2__DATA_BANKA_BANK_RAM_SEC_COUNT_MASK = 0x00003000L;
    constexpr unsigned int SQC_EDC_CNT2__DATA_BANKA_DIRTY_BIT_RAM_SED_COUNT_MASK = 0x03000000L;
    constexpr unsigned int SQC_EDC_CNT2__DATA_BANKA_HIT_FIFO_SED_COUNT_MASK = 0x00300000L;
    constexpr unsigned int SQC_EDC_CNT2__DATA_BANKA_MISS_FIFO_SED_COUNT_MASK = 0x00c00000L;
    constexpr unsigned int SQC_EDC_CNT2__DATA_BANKA_TAG_RAM_DED_COUNT_MASK = 0x00000c00L;
    constexpr unsigned int SQC_EDC_CNT2__DATA_BANKA_TAG_RAM_SEC_COUNT_MASK = 0x00000300L;
    constexpr unsigned int SQC_EDC_CNT2__INST_BANKA_BANK_RAM_DED_COUNT_MASK = 0x000000c0L;
    constexpr unsigned int SQC_EDC_CNT2__INST_BANKA_BANK_RAM_SEC_COUNT_MASK = 0x00000030L;
    constexpr unsigned int SQC_EDC_CNT2__INST_BANKA_MISS_FIFO_SED_COUNT_MASK = 0x000c0000L;
    constexpr unsigned int SQC_EDC_CNT2__INST_BANKA_TAG_RAM_DED_COUNT_MASK = 0x0000000cL;
    constexpr unsigned int SQC_EDC_CNT2__INST_BANKA_TAG_RAM_SEC_COUNT_MASK = 0x00000003L;
    constexpr unsigned int SQC_EDC_CNT2__INST_BANKA_UTCL1_MISS_FIFO_SED_COUNT_MASK = 0x00030000L;
    constexpr unsigned int SQC_EDC_CNT2__INST_UTCL1_LFIFO_DED_COUNT_MASK = 0x30000000L;
    constexpr unsigned int SQC_EDC_CNT2__INST_UTCL1_LFIFO_SEC_COUNT_MASK = 0x0c000000L;
    constexpr unsigned int SQC_EDC_CNT3__DATA_BANKB_BANK_RAM_DED_COUNT_MASK = 0x0000c000L;
    constexpr unsigned int SQC_EDC_CNT3__DATA_BANKB_BANK_RAM_SEC_COUNT_MASK = 0x00003000L;
    constexpr unsigned int SQC_EDC_CNT3__DATA_BANKB_DIRTY_BIT_RAM_SED_COUNT_MASK = 0x03000000L;
    constexpr unsigned int SQC_EDC_CNT3__DATA_BANKB_HIT_FIFO_SED_COUNT_MASK = 0x00300000L;
    constexpr unsigned int SQC_EDC_CNT3__DATA_BANKB_MISS_FIFO_SED_COUNT_MASK = 0x00c00000L;
    constexpr unsigned int SQC_EDC_CNT3__DATA_BANKB_TAG_RAM_DED_COUNT_MASK = 0x00000c00L;
    constexpr unsigned int SQC_EDC_CNT3__DATA_BANKB_TAG_RAM_SEC_COUNT_MASK = 0x00000300L;
    constexpr unsigned int SQC_EDC_CNT3__INST_BANKB_BANK_RAM_DED_COUNT_MASK = 0x000000c0L;
    constexpr unsigned int SQC_EDC_CNT3__INST_BANKB_BANK_RAM_SEC_COUNT_MASK = 0x00000030L;
    constexpr unsigned int SQC_EDC_CNT3__INST_BANKB_MISS_FIFO_SED_COUNT_MASK = 0x000c0000L;
    constexpr unsigned int SQC_EDC_CNT3__INST_BANKB_TAG_RAM_DED_COUNT_MASK = 0x0000000cL;
    constexpr unsigned int SQC_EDC_CNT3__INST_BANKB_TAG_RAM_SEC_COUNT_MASK = 0x00000003L;
    constexpr unsigned int SQC_EDC_CNT3__INST_BANKB_UTCL1_MISS_FIFO_SED_COUNT_MASK = 0x00030000L;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU0_UTCL1_LFIFO_DED_COUNT_MASK = 0x000000c0L;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU0_UTCL1_LFIFO_SEC_COUNT_MASK = 0x00000030L;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU0_WRITE_DATA_BUF_DED_COUNT_MASK = 0x0000000cL;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU0_WRITE_DATA_BUF_SEC_COUNT_MASK = 0x00000003L;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU1_UTCL1_LFIFO_DED_COUNT_MASK = 0x0000c000L;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU1_UTCL1_LFIFO_SEC_COUNT_MASK = 0x00003000L;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU1_WRITE_DATA_BUF_DED_COUNT_MASK = 0x00000c00L;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU1_WRITE_DATA_BUF_SEC_COUNT_MASK = 0x00000300L;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU2_UTCL1_LFIFO_DED_COUNT_MASK = 0x00c00000L;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU2_UTCL1_LFIFO_SEC_COUNT_MASK = 0x00300000L;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU2_WRITE_DATA_BUF_DED_COUNT_MASK = 0x000c0000L;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU2_WRITE_DATA_BUF_SEC_COUNT_MASK = 0x00030000L;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU3_UTCL1_LFIFO_DED_COUNT_MASK = 0xc0000000L;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU3_UTCL1_LFIFO_SEC_COUNT_MASK = 0x30000000L;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU3_WRITE_DATA_BUF_DED_COUNT_MASK = 0x0c000000L;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU3_WRITE_DATA_BUF_SEC_COUNT_MASK = 0x03000000L;
    constexpr unsigned int SQC_EDC_FUE_CNTL__BLOCK_FUE_FLAGS_MASK   = 0x0000ffffL;
    constexpr unsigned int SQC_EDC_FUE_CNTL__FUE_INTERRUPT_ENABLES_MASK = 0xffff0000L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__CLIENTID_MASK    = 0x0000ff80L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__CLIENT_INVALIDATE_ALL_VMID_MASK = 0x02000000L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__ENABLE_LFIFO_PRI_ARB_MASK = 0x00040000L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__ENABLE_PUSH_LFIFO_MASK = 0x00020000L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__FORCE_4K_L2_RESP_MASK = 0x00000001L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__FORCE_IN_ORDER_MASK = 0x08000000L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__FORCE_MISS_MASK  = 0x04000000L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__GPUVM_64K_DEF_MASK = 0x00000002L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__GPUVM_PERM_MODE_MASK = 0x00000004L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__REDUCE_CACHE_SIZE_BY_2_MASK = 0xc0000000L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__REDUCE_FIFO_DEPTH_BY_2_MASK = 0x30000000L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__REG_INVALIDATE_ALL_VMID_MASK = 0x00800000L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__REG_INVALIDATE_TOGGLE_MASK = 0x01000000L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__REG_INVALIDATE_VMID_MASK = 0x00780000L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__RESP_FAULT_MODE_MASK = 0x00000060L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__RESP_MODE_MASK   = 0x00000018L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__ARB_BURST_MODE_MASK = 0x00030000L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__DIS_EDC_MASK     = 0x00000800L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__ENABLE_PERF_EVENT_RD_WR_MASK = 0x00040000L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__ENABLE_PERF_EVENT_VMID_MASK = 0x00100000L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__FORCE_FRAG_2M_TO_64K_MASK = 0x04000000L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__FORCE_GPUVM_INV_ACK_MASK = 0x00008000L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__FORCE_SNOOP_MASK = 0x00004000L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__GPUVM_INV_MODE_MASK = 0x00001000L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__LFIFO_SCAN_DISABLE_MASK = 0x00000100L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__LINE_VALID_MASK  = 0x00000400L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__MTYPE_OVRD_DIS_MASK = 0x00000200L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__PERF_EVENT_RD_WR_MASK = 0x00080000L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__PERF_EVENT_VMID_MASK = 0x01e00000L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__SHOOTDOWN_OPT_MASK = 0x00002000L;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__SPARE_MASK       = 0x000000ffL;
    constexpr unsigned int SQC_ICACHE_UTCL1_STATUS__FAULT_DETECTED_MASK = 0x00000001L;
    constexpr unsigned int SQC_ICACHE_UTCL1_STATUS__PRT_DETECTED_MASK = 0x00000004L;
    constexpr unsigned int SQC_ICACHE_UTCL1_STATUS__RETRY_DETECTED_MASK = 0x00000002L;
    constexpr unsigned int SQC_WRITEBACK__DIRTY_MASK                = 0x00000002L;
    constexpr unsigned int SQC_WRITEBACK__DWB_MASK                  = 0x00000001L;
    constexpr unsigned int SQ_ALU_CLK_CTRL__FORCE_CU_ON_SH0_MASK    = 0x0000ffffL;
    constexpr unsigned int SQ_ALU_CLK_CTRL__FORCE_CU_ON_SH1_MASK    = 0xffff0000L;
    constexpr unsigned int SQ_BUF_RSRC_WORD0__BASE_ADDRESS_MASK     = 0xffffffffL;
    constexpr unsigned int SQ_BUF_RSRC_WORD1__BASE_ADDRESS_HI_MASK  = 0x0000ffffL;
    constexpr unsigned int SQ_BUF_RSRC_WORD1__CACHE_SWIZZLE_MASK    = 0x40000000L;
    constexpr unsigned int SQ_BUF_RSRC_WORD1__STRIDE_MASK           = 0x3fff0000L;
    constexpr unsigned int SQ_BUF_RSRC_WORD1__SWIZZLE_ENABLE_MASK   = 0x80000000L;
    constexpr unsigned int SQ_BUF_RSRC_WORD2__NUM_RECORDS_MASK      = 0xffffffffL;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__ADD_TID_ENABLE_MASK   = 0x00800000L;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__DATA_FORMAT_MASK      = 0x00078000L;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__DST_SEL_W_MASK        = 0x00000e00L;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__DST_SEL_X_MASK        = 0x00000007L;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__DST_SEL_Y_MASK        = 0x00000038L;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__DST_SEL_Z_MASK        = 0x000001c0L;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__INDEX_STRIDE_MASK     = 0x00600000L;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__NUM_FORMAT_MASK       = 0x00007000L;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__NV_MASK               = 0x08000000L;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__TYPE_MASK             = 0xc0000000L;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__USER_VM_ENABLE_MASK   = 0x00080000L;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__USER_VM_MODE_MASK     = 0x00100000L;
    constexpr unsigned int SQ_CMD_TIMESTAMP__TIMESTAMP_MASK         = 0x000000ffL;
    constexpr unsigned int SQ_CMD__CMD_MASK                         = 0x00000007L;
    constexpr unsigned int SQ_CMD__SIMD_ID_MASK                     = 0x00300000L;
    constexpr unsigned int SQ_CMD__WAVE_ID_MASK                     = 0x000f0000L;
    constexpr unsigned int SQ_CONFIG__DEBUG_EN_MASK                 = 0x00000100L;
    constexpr unsigned int SQ_CONFIG__DEBUG_ONE_INST_CLAUSE_MASK    = 0x00000400L;
    constexpr unsigned int SQ_CONFIG__DEBUG_SINGLE_MEMOP_MASK       = 0x00000200L;
    constexpr unsigned int SQ_CONFIG__DISABLE_FLAT_SOFT_CLAUSE_MASK = 0x40000000L;
    constexpr unsigned int SQ_CONFIG__DISABLE_MIMG_SOFT_CLAUSE_MASK = 0x80000000L;
    constexpr unsigned int SQ_CONFIG__DISABLE_SMEM_SOFT_CLAUSE_MASK = 0x00020000L;
    constexpr unsigned int SQ_CONFIG__DISABLE_SP_VGPR_WRITE_SKIP_MASK = 0x10000000L;
    constexpr unsigned int SQ_CONFIG__DISABLE_VMEM_SOFT_CLAUSE_MASK = 0x00010000L;
    constexpr unsigned int SQ_CONFIG__DUA_FLAT_LDS_PINGPONG_DISABLE_MASK = 0x00008000L;
    constexpr unsigned int SQ_CONFIG__DUA_FLAT_LOCK_ENABLE_MASK     = 0x00002000L;
    constexpr unsigned int SQ_CONFIG__DUA_LDS_BYPASS_DISABLE_MASK   = 0x00004000L;
    constexpr unsigned int SQ_CONFIG__EARLY_TA_DONE_DISABLE_MASK    = 0x00001000L;
    constexpr unsigned int SQ_CONFIG__OVERRIDE_ALU_BUSY_MASK        = 0x00000080L;
    constexpr unsigned int SQ_CONFIG__OVERRIDE_LDS_IDX_BUSY_MASK    = 0x00000800L;
    constexpr unsigned int SQ_CONFIG__REPLAY_SLEEP_CNT_MASK         = 0x0fe00000L;
    constexpr unsigned int SQ_DS_0__ENCODING_MASK                   = 0xfc000000L;
    constexpr unsigned int SQ_DS_0__GDS_MASK                        = 0x00010000L;
    constexpr unsigned int SQ_DS_0__OFFSET0_MASK                    = 0x000000ffL;
    constexpr unsigned int SQ_DS_0__OFFSET1_MASK                    = 0x0000ff00L;
    constexpr unsigned int SQ_DS_0__OP_MASK                         = 0x01fe0000L;
    constexpr unsigned int SQ_DS_1__ADDR_MASK                       = 0x000000ffL;
    constexpr unsigned int SQ_DS_1__DATA0_MASK                      = 0x0000ff00L;
    constexpr unsigned int SQ_DS_1__DATA1_MASK                      = 0x00ff0000L;
    constexpr unsigned int SQ_DS_1__VDST_MASK                       = 0xff000000L;
    constexpr unsigned int SQ_EDC_DED_CNT__LDS_DED_MASK             = 0x000000ffL;
    constexpr unsigned int SQ_EDC_DED_CNT__SGPR_DED_MASK            = 0x0000ff00L;
    constexpr unsigned int SQ_EDC_DED_CNT__VGPR_DED_MASK            = 0x00ff0000L;
    constexpr unsigned int SQ_EDC_INFO__SIMD_ID_MASK                = 0x00000030L;
    constexpr unsigned int SQ_EDC_INFO__SOURCE_MASK                 = 0x000001c0L;
    constexpr unsigned int SQ_EDC_INFO__VM_ID_MASK                  = 0x00001e00L;
    constexpr unsigned int SQ_EDC_INFO__WAVE_ID_MASK                = 0x0000000fL;
    constexpr unsigned int SQ_EDC_SEC_CNT__LDS_SEC_MASK             = 0x000000ffL;
    constexpr unsigned int SQ_EDC_SEC_CNT__SGPR_SEC_MASK            = 0x0000ff00L;
    constexpr unsigned int SQ_EDC_SEC_CNT__VGPR_SEC_MASK            = 0x00ff0000L;
    constexpr unsigned int SQ_EXP_0__COMPR_MASK                     = 0x00000400L;
    constexpr unsigned int SQ_EXP_0__DONE_MASK                      = 0x00000800L;
    constexpr unsigned int SQ_EXP_0__ENCODING_MASK                  = 0xfc000000L;
    constexpr unsigned int SQ_EXP_0__EN_MASK                        = 0x0000000fL;
    constexpr unsigned int SQ_EXP_0__TGT_MASK                       = 0x000003f0L;
    constexpr unsigned int SQ_EXP_0__VM_MASK                        = 0x00001000L;
    constexpr unsigned int SQ_EXP_1__VSRC0_MASK                     = 0x000000ffL;
    constexpr unsigned int SQ_EXP_1__VSRC1_MASK                     = 0x0000ff00L;
    constexpr unsigned int SQ_EXP_1__VSRC2_MASK                     = 0x00ff0000L;
    constexpr unsigned int SQ_EXP_1__VSRC3_MASK                     = 0xff000000L;
    constexpr unsigned int SQ_FIFO_SIZES__EXPORT_BUF_SIZE_MASK      = 0x00030000L;
    constexpr unsigned int SQ_FIFO_SIZES__TTRACE_FIFO_SIZE_MASK     = 0x00000f00L;
    constexpr unsigned int SQ_FLAT_0__ENCODING_MASK                 = 0xfc000000L;
    constexpr unsigned int SQ_FLAT_0__GLC_MASK                      = 0x00010000L;
    constexpr unsigned int SQ_FLAT_0__LDS_MASK                      = 0x00002000L;
    constexpr unsigned int SQ_FLAT_0__OFFSET_MASK                   = 0x00000fffL;
    constexpr unsigned int SQ_FLAT_0__OP_MASK                       = 0x01fc0000L;
    constexpr unsigned int SQ_FLAT_0__SEG_MASK                      = 0x0000c000L;
    constexpr unsigned int SQ_FLAT_0__SLC_MASK                      = 0x00020000L;
    constexpr unsigned int SQ_FLAT_1__ADDR_MASK                     = 0x000000ffL;
    constexpr unsigned int SQ_FLAT_1__DATA_MASK                     = 0x0000ff00L;
    constexpr unsigned int SQ_FLAT_1__NV_MASK                       = 0x00800000L;
    constexpr unsigned int SQ_FLAT_1__SADDR_MASK                    = 0x007f0000L;
    constexpr unsigned int SQ_FLAT_1__VDST_MASK                     = 0xff000000L;
    constexpr unsigned int SQ_FLAT_SCRATCH_WORD0__SIZE_MASK         = 0x0007ffffL;
    constexpr unsigned int SQ_FLAT_SCRATCH_WORD1__OFFSET_MASK       = 0x00ffffffL;
    constexpr unsigned int SQ_GLBL_0__ENCODING_MASK                 = 0xfc000000L;
    constexpr unsigned int SQ_GLBL_0__GLC_MASK                      = 0x00010000L;
    constexpr unsigned int SQ_GLBL_0__LDS_MASK                      = 0x00002000L;
    constexpr unsigned int SQ_GLBL_0__OFFSET_MASK                   = 0x00001fffL;
    constexpr unsigned int SQ_GLBL_0__OP_MASK                       = 0x01fc0000L;
    constexpr unsigned int SQ_GLBL_0__SEG_MASK                      = 0x0000c000L;
    constexpr unsigned int SQ_GLBL_0__SLC_MASK                      = 0x00020000L;
    constexpr unsigned int SQ_GLBL_1__ADDR_MASK                     = 0x000000ffL;
    constexpr unsigned int SQ_GLBL_1__DATA_MASK                     = 0x0000ff00L;
    constexpr unsigned int SQ_GLBL_1__NV_MASK                       = 0x00800000L;
    constexpr unsigned int SQ_GLBL_1__SADDR_MASK                    = 0x007f0000L;
    constexpr unsigned int SQ_GLBL_1__VDST_MASK                     = 0xff000000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD0__BASE_ADDRESS_MASK     = 0xffffffffL;
    constexpr unsigned int SQ_IMG_RSRC_WORD1__BASE_ADDRESS_HI_MASK  = 0x000000ffL;
    constexpr unsigned int SQ_IMG_RSRC_WORD1__DATA_FORMAT_MASK      = 0x03f00000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD1__META_DIRECT_MASK      = 0x80000000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD1__MIN_LOD_MASK          = 0x000fff00L;
    constexpr unsigned int SQ_IMG_RSRC_WORD1__NUM_FORMAT_MASK       = 0x3c000000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD1__NV_MASK               = 0x40000000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD2__HEIGHT_MASK           = 0x0fffc000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD2__PERF_MOD_MASK         = 0x70000000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD2__WIDTH_MASK            = 0x00003fffL;
    constexpr unsigned int SQ_IMG_RSRC_WORD3__BASE_LEVEL_MASK       = 0x0000f000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD3__DST_SEL_W_MASK        = 0x00000e00L;
    constexpr unsigned int SQ_IMG_RSRC_WORD3__DST_SEL_X_MASK        = 0x00000007L;
    constexpr unsigned int SQ_IMG_RSRC_WORD3__DST_SEL_Y_MASK        = 0x00000038L;
    constexpr unsigned int SQ_IMG_RSRC_WORD3__DST_SEL_Z_MASK        = 0x000001c0L;
    constexpr unsigned int SQ_IMG_RSRC_WORD3__LAST_LEVEL_MASK       = 0x000f0000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD3__SW_MODE_MASK          = 0x01f00000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD3__TYPE_MASK             = 0xf0000000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD4__BC_SWIZZLE_MASK       = 0xe0000000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD4__DEPTH_MASK            = 0x00001fffL;
    constexpr unsigned int SQ_IMG_RSRC_WORD4__PITCH_MASK            = 0x1fffe000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD5__ARRAY_PITCH_MASK      = 0x0001e000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD5__BASE_ARRAY_MASK       = 0x00001fffL;
    constexpr unsigned int SQ_IMG_RSRC_WORD5__MAX_MIP_MASK          = 0xf0000000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD5__META_DATA_ADDRESS_MASK = 0x01fe0000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD5__META_LINEAR_MASK      = 0x02000000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD5__META_PIPE_ALIGNED_MASK = 0x04000000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD5__META_RB_ALIGNED_MASK  = 0x08000000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD6__ALPHA_IS_ON_MSB_MASK  = 0x00400000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD6__COLOR_TRANSFORM_MASK  = 0x00800000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD6__COMPRESSION_EN_MASK   = 0x00200000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD6__COUNTER_BANK_ID_MASK  = 0x000ff000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD6__LOD_HDW_CNT_EN_MASK   = 0x00100000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD6__LOST_ALPHA_BITS_MASK  = 0x0f000000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD6__LOST_COLOR_BITS_MASK  = 0xf0000000L;
    constexpr unsigned int SQ_IMG_RSRC_WORD6__MIN_LOD_WARN_MASK     = 0x00000fffL;
    constexpr unsigned int SQ_IMG_RSRC_WORD7__META_DATA_ADDRESS_MASK = 0xffffffffL;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__ANISO_BIAS_MASK       = 0x07e00000L;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__ANISO_THRESHOLD_MASK  = 0x00070000L;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__CLAMP_X_MASK          = 0x00000007L;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__CLAMP_Y_MASK          = 0x00000038L;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__CLAMP_Z_MASK          = 0x000001c0L;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__COMPAT_MODE_MASK      = 0x80000000L;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__DEPTH_COMPARE_FUNC_MASK = 0x00007000L;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__DISABLE_CUBE_WRAP_MASK = 0x10000000L;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__FILTER_MODE_MASK      = 0x60000000L;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__FORCE_DEGAMMA_MASK    = 0x00100000L;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__FORCE_UNNORMALIZED_MASK = 0x00008000L;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__MAX_ANISO_RATIO_MASK  = 0x00000e00L;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__MC_COORD_TRUNC_MASK   = 0x00080000L;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__TRUNC_COORD_MASK      = 0x08000000L;
    constexpr unsigned int SQ_IMG_SAMP_WORD1__MAX_LOD_MASK          = 0x00fff000L;
    constexpr unsigned int SQ_IMG_SAMP_WORD1__MIN_LOD_MASK          = 0x00000fffL;
    constexpr unsigned int SQ_IMG_SAMP_WORD1__PERF_MIP_MASK         = 0x0f000000L;
    constexpr unsigned int SQ_IMG_SAMP_WORD1__PERF_Z_MASK           = 0xf0000000L;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__ANISO_OVERRIDE_MASK   = 0x80000000L;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__BLEND_ZERO_PRT_MASK   = 0x20000000L;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__FILTER_PREC_FIX_MASK  = 0x40000000L;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__LOD_BIAS_MASK         = 0x00003fffL;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__LOD_BIAS_SEC_MASK     = 0x000fc000L;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__MIP_FILTER_MASK       = 0x0c000000L;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__MIP_POINT_PRECLAMP_MASK = 0x10000000L;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__XY_MAG_FILTER_MASK    = 0x00300000L;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__XY_MIN_FILTER_MASK    = 0x00c00000L;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__Z_FILTER_MASK         = 0x03000000L;
    constexpr unsigned int SQ_IMG_SAMP_WORD3__BORDER_COLOR_PTR_MASK = 0x00000fffL;
    constexpr unsigned int SQ_IMG_SAMP_WORD3__BORDER_COLOR_TYPE_MASK = 0xc0000000L;
    constexpr unsigned int SQ_IMG_SAMP_WORD3__SKIP_DEGAMMA_MASK     = 0x00001000L;
    constexpr unsigned int SQ_IND_INDEX__AUTO_INCR_MASK             = 0x00001000L;
    constexpr unsigned int SQ_IND_INDEX__FORCE_READ_MASK            = 0x00002000L;
    constexpr unsigned int SQ_IND_INDEX__READ_TIMEOUT_MASK          = 0x00004000L;
    constexpr unsigned int SQ_IND_INDEX__SIMD_ID_MASK               = 0x00000030L;
    constexpr unsigned int SQ_IND_INDEX__THREAD_ID_MASK             = 0x00000fc0L;
    constexpr unsigned int SQ_IND_INDEX__UNINDEXED_MASK             = 0x00008000L;
    constexpr unsigned int SQ_IND_INDEX__WAVE_ID_MASK               = 0x0000000fL;
    constexpr unsigned int SQ_INST__ENCODING_MASK                   = 0xffffffffL;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__CMD_TIMESTAMP_MASK = 0x00000010L;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__ENCODING_MASK = 0x0c000000L;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__HOST_CMD_OVERFLOW_MASK = 0x00000020L;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__HOST_REG_OVERFLOW_MASK = 0x00000040L;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__IMMED_OVERFLOW_MASK = 0x00000080L;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__REG_TIMESTAMP_MASK = 0x00000008L;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__SE_ID_MASK = 0x03000000L;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__THREAD_TRACE_BUF_FULL_MASK = 0x00000004L;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__THREAD_TRACE_MASK = 0x00000001L;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__THREAD_TRACE_UTC_ERROR_MASK = 0x00000100L;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__WLT_MASK   = 0x00000002L;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_HI__ENCODING_MASK = 0x00000c00L;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_HI__SE_ID_MASK    = 0x00000300L;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__CMD_TIMESTAMP_MASK = 0x00000010L;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__HOST_CMD_OVERFLOW_MASK = 0x00000020L;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__HOST_REG_OVERFLOW_MASK = 0x00000040L;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__IMMED_OVERFLOW_MASK = 0x00000080L;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__REG_TIMESTAMP_MASK = 0x00000008L;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__THREAD_TRACE_BUF_FULL_MASK = 0x00000004L;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__THREAD_TRACE_MASK = 0x00000001L;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__THREAD_TRACE_UTC_ERROR_MASK = 0x00000100L;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__WLT_MASK      = 0x00000002L;
    constexpr unsigned int SQ_INTERRUPT_WORD_CMN_CTXID__ENCODING_MASK = 0x0c000000L;
    constexpr unsigned int SQ_INTERRUPT_WORD_CMN_CTXID__SE_ID_MASK  = 0x03000000L;
    constexpr unsigned int SQ_INTERRUPT_WORD_CMN_HI__ENCODING_MASK  = 0x00000c00L;
    constexpr unsigned int SQ_INTERRUPT_WORD_CMN_HI__SE_ID_MASK     = 0x00000300L;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_CTXID__CU_ID_MASK = 0x00f00000L;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_CTXID__DATA_MASK  = 0x00000fffL;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_CTXID__ENCODING_MASK = 0x0c000000L;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_CTXID__PRIV_MASK  = 0x00002000L;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_CTXID__SE_ID_MASK = 0x03000000L;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_CTXID__SH_ID_MASK = 0x00001000L;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_CTXID__SIMD_ID_MASK = 0x000c0000L;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_CTXID__WAVE_ID_MASK = 0x0003c000L;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_HI__CU_ID_MASK    = 0x0000000fL;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_HI__ENCODING_MASK = 0x00000c00L;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_HI__SE_ID_MASK    = 0x00000300L;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_HI__VM_ID_MASK    = 0x000000f0L;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_LO__DATA_MASK     = 0x00ffffffL;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_LO__PRIV_MASK     = 0x02000000L;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_LO__SH_ID_MASK    = 0x01000000L;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_LO__SIMD_ID_MASK  = 0xc0000000L;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_LO__WAVE_ID_MASK  = 0x3c000000L;
    constexpr unsigned int SQ_LB_CTR0_CU__SH0_MASK_MASK             = 0x0000ffffL;
    constexpr unsigned int SQ_LB_CTR0_CU__SH1_MASK_MASK             = 0xffff0000L;
    constexpr unsigned int SQ_LB_CTR1_CU__SH0_MASK_MASK             = 0x0000ffffL;
    constexpr unsigned int SQ_LB_CTR1_CU__SH1_MASK_MASK             = 0xffff0000L;
    constexpr unsigned int SQ_LB_CTR2_CU__SH0_MASK_MASK             = 0x0000ffffL;
    constexpr unsigned int SQ_LB_CTR2_CU__SH1_MASK_MASK             = 0xffff0000L;
    constexpr unsigned int SQ_LB_CTR3_CU__SH0_MASK_MASK             = 0x0000ffffL;
    constexpr unsigned int SQ_LB_CTR3_CU__SH1_MASK_MASK             = 0xffff0000L;
    constexpr unsigned int SQ_LB_CTR_SEL__SEL0_MASK                 = 0x0000000fL;
    constexpr unsigned int SQ_LB_CTR_SEL__SEL1_MASK                 = 0x000000f0L;
    constexpr unsigned int SQ_LB_CTR_SEL__SEL2_MASK                 = 0x00000f00L;
    constexpr unsigned int SQ_LB_CTR_SEL__SEL3_MASK                 = 0x0000f000L;
    constexpr unsigned int SQ_LDS_CLK_CTRL__FORCE_CU_ON_SH0_MASK    = 0x0000ffffL;
    constexpr unsigned int SQ_LDS_CLK_CTRL__FORCE_CU_ON_SH1_MASK    = 0xffff0000L;
    constexpr unsigned int SQ_M0_GPR_IDX_WORD__INDEX_MASK           = 0x000000ffL;
    constexpr unsigned int SQ_M0_GPR_IDX_WORD__VDST_REL_MASK        = 0x00008000L;
    constexpr unsigned int SQ_M0_GPR_IDX_WORD__VSRC0_REL_MASK       = 0x00001000L;
    constexpr unsigned int SQ_M0_GPR_IDX_WORD__VSRC1_REL_MASK       = 0x00002000L;
    constexpr unsigned int SQ_M0_GPR_IDX_WORD__VSRC2_REL_MASK       = 0x00004000L;
    constexpr unsigned int SQ_MIMG_0__A16_MASK                      = 0x00008000L;
    constexpr unsigned int SQ_MIMG_0__DA_MASK                       = 0x00004000L;
    constexpr unsigned int SQ_MIMG_0__DMASK_MASK                    = 0x00000f00L;
    constexpr unsigned int SQ_MIMG_0__ENCODING_MASK                 = 0xfc000000L;
    constexpr unsigned int SQ_MIMG_0__GLC_MASK                      = 0x00002000L;
    constexpr unsigned int SQ_MIMG_0__LWE_MASK                      = 0x00020000L;
    constexpr unsigned int SQ_MIMG_0__OPM_MASK                      = 0x00000001L;
    constexpr unsigned int SQ_MIMG_0__OP_MASK                       = 0x01fc0000L;
    constexpr unsigned int SQ_MIMG_0__SLC_MASK                      = 0x02000000L;
    constexpr unsigned int SQ_MIMG_0__TFE_MASK                      = 0x00010000L;
    constexpr unsigned int SQ_MIMG_0__UNORM_MASK                    = 0x00001000L;
    constexpr unsigned int SQ_MIMG_1__D16_MASK                      = 0x80000000L;
    constexpr unsigned int SQ_MIMG_1__SRSRC_MASK                    = 0x001f0000L;
    constexpr unsigned int SQ_MIMG_1__SSAMP_MASK                    = 0x03e00000L;
    constexpr unsigned int SQ_MIMG_1__VADDR_MASK                    = 0x000000ffL;
    constexpr unsigned int SQ_MIMG_1__VDATA_MASK                    = 0x0000ff00L;
    constexpr unsigned int SQ_MTBUF_0__DFMT_MASK                    = 0x00780000L;
    constexpr unsigned int SQ_MTBUF_0__ENCODING_MASK                = 0xfc000000L;
    constexpr unsigned int SQ_MTBUF_0__GLC_MASK                     = 0x00004000L;
    constexpr unsigned int SQ_MTBUF_0__IDXEN_MASK                   = 0x00002000L;
    constexpr unsigned int SQ_MTBUF_0__NFMT_MASK                    = 0x03800000L;
    constexpr unsigned int SQ_MTBUF_0__OFFEN_MASK                   = 0x00001000L;
    constexpr unsigned int SQ_MTBUF_0__OFFSET_MASK                  = 0x00000fffL;
    constexpr unsigned int SQ_MTBUF_0__OP_MASK                      = 0x00078000L;
    constexpr unsigned int SQ_MTBUF_1__SLC_MASK                     = 0x00400000L;
    constexpr unsigned int SQ_MTBUF_1__SOFFSET_MASK                 = 0xff000000L;
    constexpr unsigned int SQ_MTBUF_1__SRSRC_MASK                   = 0x001f0000L;
    constexpr unsigned int SQ_MTBUF_1__TFE_MASK                     = 0x00800000L;
    constexpr unsigned int SQ_MTBUF_1__VADDR_MASK                   = 0x000000ffL;
    constexpr unsigned int SQ_MTBUF_1__VDATA_MASK                   = 0x0000ff00L;
    constexpr unsigned int SQ_MUBUF_0__ENCODING_MASK                = 0xfc000000L;
    constexpr unsigned int SQ_MUBUF_0__GLC_MASK                     = 0x00004000L;
    constexpr unsigned int SQ_MUBUF_0__IDXEN_MASK                   = 0x00002000L;
    constexpr unsigned int SQ_MUBUF_0__LDS_MASK                     = 0x00010000L;
    constexpr unsigned int SQ_MUBUF_0__OFFEN_MASK                   = 0x00001000L;
    constexpr unsigned int SQ_MUBUF_0__OFFSET_MASK                  = 0x00000fffL;
    constexpr unsigned int SQ_MUBUF_0__OP_MASK                      = 0x01fc0000L;
    constexpr unsigned int SQ_MUBUF_0__SLC_MASK                     = 0x00020000L;
    constexpr unsigned int SQ_MUBUF_1__SOFFSET_MASK                 = 0xff000000L;
    constexpr unsigned int SQ_MUBUF_1__SRSRC_MASK                   = 0x001f0000L;
    constexpr unsigned int SQ_MUBUF_1__TFE_MASK                     = 0x00800000L;
    constexpr unsigned int SQ_MUBUF_1__VADDR_MASK                   = 0x000000ffL;
    constexpr unsigned int SQ_MUBUF_1__VDATA_MASK                   = 0x0000ff00L;
    constexpr unsigned int SQ_PERFCOUNTER0_SELECT__SIMD_MASK_MASK   = 0x0f000000L;
    constexpr unsigned int SQ_PERFCOUNTER0_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER0_SELECT__SQC_CLIENT_MASK_MASK = 0x000f0000L;
    constexpr unsigned int SQ_PERFCOUNTER1_SELECT__SIMD_MASK_MASK   = 0x0f000000L;
    constexpr unsigned int SQ_PERFCOUNTER1_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER1_SELECT__SQC_CLIENT_MASK_MASK = 0x000f0000L;
    constexpr unsigned int SQ_PERFCOUNTER2_SELECT__SIMD_MASK_MASK   = 0x0f000000L;
    constexpr unsigned int SQ_PERFCOUNTER2_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER2_SELECT__SQC_CLIENT_MASK_MASK = 0x000f0000L;
    constexpr unsigned int SQ_PERFCOUNTER3_SELECT__SIMD_MASK_MASK   = 0x0f000000L;
    constexpr unsigned int SQ_PERFCOUNTER3_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER3_SELECT__SQC_CLIENT_MASK_MASK = 0x000f0000L;
    constexpr unsigned int SQ_PERFCOUNTER4_SELECT__SIMD_MASK_MASK   = 0x0f000000L;
    constexpr unsigned int SQ_PERFCOUNTER4_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER4_SELECT__SQC_CLIENT_MASK_MASK = 0x000f0000L;
    constexpr unsigned int SQ_PERFCOUNTER5_SELECT__SIMD_MASK_MASK   = 0x0f000000L;
    constexpr unsigned int SQ_PERFCOUNTER5_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER5_SELECT__SQC_CLIENT_MASK_MASK = 0x000f0000L;
    constexpr unsigned int SQ_PERFCOUNTER6_SELECT__SIMD_MASK_MASK   = 0x0f000000L;
    constexpr unsigned int SQ_PERFCOUNTER6_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER6_SELECT__SQC_CLIENT_MASK_MASK = 0x000f0000L;
    constexpr unsigned int SQ_PERFCOUNTER7_SELECT__SIMD_MASK_MASK   = 0x0f000000L;
    constexpr unsigned int SQ_PERFCOUNTER7_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER7_SELECT__SQC_CLIENT_MASK_MASK = 0x000f0000L;
    constexpr unsigned int SQ_PERFCOUNTER8_SELECT__SIMD_MASK_MASK   = 0x0f000000L;
    constexpr unsigned int SQ_PERFCOUNTER8_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER8_SELECT__SQC_CLIENT_MASK_MASK = 0x000f0000L;
    constexpr unsigned int SQ_PERFCOUNTER9_SELECT__SIMD_MASK_MASK   = 0x0f000000L;
    constexpr unsigned int SQ_PERFCOUNTER9_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER9_SELECT__SQC_CLIENT_MASK_MASK = 0x000f0000L;
    constexpr unsigned int SQ_PERFCOUNTER10_SELECT__SIMD_MASK_MASK  = 0x0f000000L;
    constexpr unsigned int SQ_PERFCOUNTER10_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER10_SELECT__SQC_CLIENT_MASK_MASK = 0x000f0000L;
    constexpr unsigned int SQ_PERFCOUNTER11_SELECT__SIMD_MASK_MASK  = 0x0f000000L;
    constexpr unsigned int SQ_PERFCOUNTER11_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER11_SELECT__SQC_CLIENT_MASK_MASK = 0x000f0000L;
    constexpr unsigned int SQ_PERFCOUNTER12_SELECT__SIMD_MASK_MASK  = 0x0f000000L;
    constexpr unsigned int SQ_PERFCOUNTER12_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER12_SELECT__SQC_CLIENT_MASK_MASK = 0x000f0000L;
    constexpr unsigned int SQ_PERFCOUNTER13_SELECT__SIMD_MASK_MASK  = 0x0f000000L;
    constexpr unsigned int SQ_PERFCOUNTER13_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER13_SELECT__SQC_CLIENT_MASK_MASK = 0x000f0000L;
    constexpr unsigned int SQ_PERFCOUNTER14_SELECT__SIMD_MASK_MASK  = 0x0f000000L;
    constexpr unsigned int SQ_PERFCOUNTER14_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER14_SELECT__SQC_CLIENT_MASK_MASK = 0x000f0000L;
    constexpr unsigned int SQ_PERFCOUNTER15_SELECT__SIMD_MASK_MASK  = 0x0f000000L;
    constexpr unsigned int SQ_PERFCOUNTER15_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER15_SELECT__SQC_CLIENT_MASK_MASK = 0x000f0000L;
    constexpr unsigned int SQ_PERFCOUNTER_CTRL__CNTR_RATE_MASK      = 0x00001f00L;
    constexpr unsigned int SQ_PERFCOUNTER_MASK__SH0_MASK_MASK       = 0x0000ffffL;
    constexpr unsigned int SQ_PERFCOUNTER_MASK__SH1_MASK_MASK       = 0xffff0000L;
    constexpr unsigned int SQ_POWER_THROTTLE2__LONG_TERM_INTERVAL_RATIO_MASK = 0x78000000L;
    constexpr unsigned int SQ_POWER_THROTTLE2__MAX_POWER_DELTA_MASK = 0x00003fffL;
    constexpr unsigned int SQ_POWER_THROTTLE2__SHORT_TERM_INTERVAL_SIZE_MASK = 0x03ff0000L;
    constexpr unsigned int SQ_POWER_THROTTLE2__USE_REF_CLOCK_MASK   = 0x80000000L;
    constexpr unsigned int SQ_POWER_THROTTLE__MAX_POWER_MASK        = 0x3fff0000L;
    constexpr unsigned int SQ_POWER_THROTTLE__MIN_POWER_MASK        = 0x00003fffL;
    constexpr unsigned int SQ_POWER_THROTTLE__PHASE_OFFSET_MASK     = 0xc0000000L;
    constexpr unsigned int SQ_RANDOM_WAVE_PRI__RNG_MASK             = 0x007ffc00L;
    constexpr unsigned int SQ_REG_CREDITS__CMD_CREDITS_MASK         = 0x00000f00L;
    constexpr unsigned int SQ_REG_CREDITS__CMD_OVERFLOW_MASK        = 0x80000000L;
    constexpr unsigned int SQ_REG_CREDITS__IMMED_OVERFLOW_MASK      = 0x40000000L;
    constexpr unsigned int SQ_REG_CREDITS__REG_BUSY_MASK            = 0x10000000L;
    constexpr unsigned int SQ_REG_CREDITS__SRBM_CREDITS_MASK        = 0x0000003fL;
    constexpr unsigned int SQ_REG_CREDITS__SRBM_OVERFLOW_MASK       = 0x20000000L;
    constexpr unsigned int SQ_REG_TIMESTAMP__TIMESTAMP_MASK         = 0x000000ffL;
    constexpr unsigned int SQ_RUNTIME_CONFIG__ENABLE_TEX_ARB_OLDEST_MASK = 0x00000001L;
    constexpr unsigned int SQ_SCRATCH_0__ENCODING_MASK              = 0xfc000000L;
    constexpr unsigned int SQ_SCRATCH_0__GLC_MASK                   = 0x00010000L;
    constexpr unsigned int SQ_SCRATCH_0__LDS_MASK                   = 0x00002000L;
    constexpr unsigned int SQ_SCRATCH_0__OFFSET_MASK                = 0x00001fffL;
    constexpr unsigned int SQ_SCRATCH_0__OP_MASK                    = 0x01fc0000L;
    constexpr unsigned int SQ_SCRATCH_0__SEG_MASK                   = 0x0000c000L;
    constexpr unsigned int SQ_SCRATCH_0__SLC_MASK                   = 0x00020000L;
    constexpr unsigned int SQ_SCRATCH_1__ADDR_MASK                  = 0x000000ffL;
    constexpr unsigned int SQ_SCRATCH_1__DATA_MASK                  = 0x0000ff00L;
    constexpr unsigned int SQ_SCRATCH_1__NV_MASK                    = 0x00800000L;
    constexpr unsigned int SQ_SCRATCH_1__SADDR_MASK                 = 0x007f0000L;
    constexpr unsigned int SQ_SCRATCH_1__VDST_MASK                  = 0xff000000L;
    constexpr unsigned int SQ_SMEM_0__ENCODING_MASK                 = 0xfc000000L;
    constexpr unsigned int SQ_SMEM_0__GLC_MASK                      = 0x00010000L;
    constexpr unsigned int SQ_SMEM_0__IMM_MASK                      = 0x00020000L;
    constexpr unsigned int SQ_SMEM_0__NV_MASK                       = 0x00008000L;
    constexpr unsigned int SQ_SMEM_0__OP_MASK                       = 0x03fc0000L;
    constexpr unsigned int SQ_SMEM_0__SBASE_MASK                    = 0x0000003fL;
    constexpr unsigned int SQ_SMEM_0__SDATA_MASK                    = 0x00001fc0L;
    constexpr unsigned int SQ_SMEM_0__SOFFSET_EN_MASK               = 0x00004000L;
    constexpr unsigned int SQ_SMEM_1__OFFSET_MASK                   = 0x001fffffL;
    constexpr unsigned int SQ_SMEM_1__SOFFSET_MASK                  = 0xfe000000L;
    constexpr unsigned int SQ_SOP1__ENCODING_MASK                   = 0xff800000L;
    constexpr unsigned int SQ_SOP1__OP_MASK                         = 0x0000ff00L;
    constexpr unsigned int SQ_SOP1__SDST_MASK                       = 0x007f0000L;
    constexpr unsigned int SQ_SOP1__SSRC0_MASK                      = 0x000000ffL;
    constexpr unsigned int SQ_SOP2__ENCODING_MASK                   = 0xc0000000L;
    constexpr unsigned int SQ_SOP2__OP_MASK                         = 0x3f800000L;
    constexpr unsigned int SQ_SOP2__SDST_MASK                       = 0x007f0000L;
    constexpr unsigned int SQ_SOP2__SSRC0_MASK                      = 0x000000ffL;
    constexpr unsigned int SQ_SOP2__SSRC1_MASK                      = 0x0000ff00L;
    constexpr unsigned int SQ_SOPC__ENCODING_MASK                   = 0xff800000L;
    constexpr unsigned int SQ_SOPC__OP_MASK                         = 0x007f0000L;
    constexpr unsigned int SQ_SOPC__SSRC0_MASK                      = 0x000000ffL;
    constexpr unsigned int SQ_SOPC__SSRC1_MASK                      = 0x0000ff00L;
    constexpr unsigned int SQ_SOPK__ENCODING_MASK                   = 0xf0000000L;
    constexpr unsigned int SQ_SOPK__OP_MASK                         = 0x0f800000L;
    constexpr unsigned int SQ_SOPK__SDST_MASK                       = 0x007f0000L;
    constexpr unsigned int SQ_SOPK__SIMM16_MASK                     = 0x0000ffffL;
    constexpr unsigned int SQ_SOPP__ENCODING_MASK                   = 0xff800000L;
    constexpr unsigned int SQ_SOPP__OP_MASK                         = 0x007f0000L;
    constexpr unsigned int SQ_SOPP__SIMM16_MASK                     = 0x0000ffffL;
    constexpr unsigned int SQ_TEX_CLK_CTRL__FORCE_CU_ON_SH0_MASK    = 0x0000ffffL;
    constexpr unsigned int SQ_TEX_CLK_CTRL__FORCE_CU_ON_SH1_MASK    = 0xffff0000L;
    constexpr unsigned int SQ_THREAD_TRACE_BASE2__ADDR_HI_MASK      = 0x0000000fL;
    constexpr unsigned int SQ_THREAD_TRACE_BASE__ADDR_MASK          = 0xffffffffL;
    constexpr unsigned int SQ_THREAD_TRACE_CNTR__CNTR_MASK          = 0xffffffffL;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__RESET_BUFFER_MASK  = 0x80000000L;
    constexpr unsigned int SQ_THREAD_TRACE_HIWATER__HIWATER_MASK    = 0x00000007L;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__CU_SEL_MASK        = 0x0000001fL;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__REG_STALL_EN_MASK  = 0x00000080L;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__SH_SEL_MASK        = 0x00000020L;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__SIMD_EN_MASK       = 0x00000f00L;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__SPI_STALL_EN_MASK  = 0x00004000L;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__SQ_STALL_EN_MASK   = 0x00008000L;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__VM_ID_MASK_MASK    = 0x00003000L;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__AUTOFLUSH_EN_MASK  = 0x02000000L;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__CAPTURE_MODE_MASK  = 0x01800000L;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__INTERRUPT_EN_MASK  = 0x40000000L;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__ISSUE_MASK_MASK    = 0x18000000L;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__MASK_CS_MASK       = 0x001c0000L;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__MASK_ES_MASK       = 0x00000e00L;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__MASK_GS_MASK       = 0x000001c0L;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__MASK_HS_MASK       = 0x00007000L;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__MASK_LS_MASK       = 0x00038000L;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__MASK_PS_MASK       = 0x00000007L;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__MASK_VS_MASK       = 0x00000038L;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__MODE_MASK          = 0x00600000L;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__TC_PERF_EN_MASK    = 0x04000000L;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__TEST_MODE_MASK     = 0x20000000L;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__WRAP_MASK          = 0x80000000L;
    constexpr unsigned int SQ_THREAD_TRACE_PERF_MASK__SH0_MASK_MASK = 0x0000ffffL;
    constexpr unsigned int SQ_THREAD_TRACE_PERF_MASK__SH1_MASK_MASK = 0xffff0000L;
    constexpr unsigned int SQ_THREAD_TRACE_SIZE__SIZE_MASK          = 0x003fffffL;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__BUSY_MASK        = 0x40000000L;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__FINISH_DONE_MASK = 0x03ff0000L;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__FINISH_PENDING_MASK = 0x000003ffL;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__FULL_MASK        = 0x80000000L;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__NEW_BUF_MASK     = 0x20000000L;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__UTC_ERROR_MASK   = 0x10000000L;
    constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK2__INST_MASK_MASK = 0xffffffffL;
    constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__REG_DROP_ON_STALL_MASK = 0x01000000L;
    constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__REG_MASK_MASK = 0x00ff0000L;
    constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__TOKEN_MASK_MASK = 0x0000ffffL;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_CMN__TIME_DELTA_MASK = 0x00000010L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_CMN__TOKEN_TYPE_MASK = 0x0000000fL;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_EVENT__EVENT_TYPE_MASK = 0x0000fc00L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_EVENT__SH_ID_MASK   = 0x00000020L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_EVENT__STAGE_MASK   = 0x000001c0L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_EVENT__TIME_DELTA_MASK = 0x00000010L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_EVENT__TOKEN_TYPE_MASK = 0x0000000fL;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_PC_1_OF_2__PC_LO_MASK = 0xffff0000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_PC_1_OF_2__SIMD_ID_MASK = 0x00000600L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_PC_1_OF_2__TIME_DELTA_MASK = 0x00000010L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_PC_1_OF_2__TOKEN_TYPE_MASK = 0x0000000fL;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_PC_1_OF_2__TRAP_ERROR_MASK = 0x00008000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_PC_1_OF_2__WAVE_ID_MASK = 0x000001e0L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_PC_2_OF_2__PC_HI_MASK = 0x00ffffffL;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_USERDATA_1_OF_2__CU_ID_MASK = 0x000003c0L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_USERDATA_1_OF_2__DATA_LO_MASK = 0xffff0000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_USERDATA_1_OF_2__SH_ID_MASK = 0x00000020L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_USERDATA_1_OF_2__SIMD_ID_MASK = 0x0000c000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_USERDATA_1_OF_2__TIME_DELTA_MASK = 0x00000010L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_USERDATA_1_OF_2__TOKEN_TYPE_MASK = 0x0000000fL;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_USERDATA_1_OF_2__WAVE_ID_MASK = 0x00003c00L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_USERDATA_2_OF_2__DATA_HI_MASK = 0x0000ffffL;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST__INST_TYPE_MASK = 0x0000f800L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST__SIMD_ID_MASK  = 0x00000600L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST__TIME_DELTA_MASK = 0x00000010L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST__TOKEN_TYPE_MASK = 0x0000000fL;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST__WAVE_ID_MASK  = 0x000001e0L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST0_MASK   = 0x00000300L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST1_MASK   = 0x00000c00L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST2_MASK   = 0x00003000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST3_MASK   = 0x0000c000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST4_MASK   = 0x00030000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST5_MASK   = 0x000c0000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST6_MASK   = 0x00300000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST7_MASK   = 0x00c00000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST8_MASK   = 0x03000000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST9_MASK   = 0x0c000000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__SIMD_ID_MASK = 0x00000060L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__TIME_DELTA_MASK = 0x00000010L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__TOKEN_TYPE_MASK = 0x0000000fL;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_MISC__MISC_TOKEN_TYPE_MASK = 0x0000e000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_MISC__SH_ID_MASK    = 0x00001000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_MISC__TIME_DELTA_MASK = 0x00000ff0L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_MISC__TOKEN_TYPE_MASK = 0x0000000fL;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_1_OF_2__CNTR0_MASK = 0x01fff000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_1_OF_2__CNTR1_LO_MASK = 0xfe000000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_1_OF_2__CNTR_BANK_MASK = 0x00000c00L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_1_OF_2__CU_ID_MASK = 0x000003c0L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_1_OF_2__SH_ID_MASK = 0x00000020L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_1_OF_2__TIME_DELTA_MASK = 0x00000010L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_1_OF_2__TOKEN_TYPE_MASK = 0x0000000fL;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_2_OF_2__CNTR1_HI_MASK = 0x0000003fL;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_2_OF_2__CNTR2_MASK = 0x0007ffc0L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_2_OF_2__CNTR3_MASK = 0xfff80000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__ME_ID_MASK = 0x00000180L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__PIPE_ID_MASK = 0x00000060L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__REG_ADDR_MASK = 0xffff0000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__REG_DROPPED_PREV_MASK = 0x00000200L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__REG_OP_MASK = 0x00008000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__REG_PRIV_MASK = 0x00004000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__REG_TYPE_MASK = 0x00001c00L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__TIME_DELTA_MASK = 0x00000010L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__TOKEN_TYPE_MASK = 0x0000000fL;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_2_OF_2__DATA_MASK = 0xffffffffL;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_CS_1_OF_2__DATA_LO_MASK = 0xffff0000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_CS_1_OF_2__ME_ID_MASK = 0x00000180L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_CS_1_OF_2__PIPE_ID_MASK = 0x00000060L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_CS_1_OF_2__REG_ADDR_MASK = 0x0000fe00L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_CS_1_OF_2__TIME_DELTA_MASK = 0x00000010L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_CS_1_OF_2__TOKEN_TYPE_MASK = 0x0000000fL;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_CS_2_OF_2__DATA_HI_MASK = 0x0000ffffL;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_TIMESTAMP_1_OF_2__TIME_LO_MASK = 0xffff0000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_TIMESTAMP_1_OF_2__TOKEN_TYPE_MASK = 0x0000000fL;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_TIMESTAMP_2_OF_2__TIME_HI_MASK = 0xffffffffL;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__COUNT_MASK = 0x1fc00000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__CU_ID_MASK = 0x000003c0L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__DISPATCHER_MASK = 0x001f0000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__SH_ID_MASK = 0x00000020L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__SIMD_ID_MASK = 0x0000c000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__TG_ID_MASK = 0xe0000000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__TIME_DELTA_MASK = 0x00000010L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__TOKEN_TYPE_MASK = 0x0000000fL;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__VS_NO_ALLOC_OR_GROUPED_MASK = 0x00200000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__WAVE_ID_MASK = 0x00003c00L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE__CU_ID_MASK    = 0x000003c0L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE__SH_ID_MASK    = 0x00000020L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE__SIMD_ID_MASK  = 0x0000c000L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE__TIME_DELTA_MASK = 0x00000010L;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE__TOKEN_TYPE_MASK = 0x0000000fL;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE__WAVE_ID_MASK  = 0x00003c00L;
    constexpr unsigned int SQ_THREAD_TRACE_WPTR__READ_OFFSET_MASK   = 0xc0000000L;
    constexpr unsigned int SQ_THREAD_TRACE_WPTR__WPTR_MASK          = 0x3fffffffL;
    constexpr unsigned int SQ_UTCL1_CNTL1__CLIENTID_MASK            = 0x0000ff80L;
    constexpr unsigned int SQ_UTCL1_CNTL1__ENABLE_LFIFO_PRI_ARB_MASK = 0x00040000L;
    constexpr unsigned int SQ_UTCL1_CNTL1__ENABLE_PUSH_LFIFO_MASK   = 0x00020000L;
    constexpr unsigned int SQ_UTCL1_CNTL1__FORCE_4K_L2_RESP_MASK    = 0x00000001L;
    constexpr unsigned int SQ_UTCL1_CNTL1__FORCE_IN_ORDER_MASK      = 0x08000000L;
    constexpr unsigned int SQ_UTCL1_CNTL1__FORCE_MISS_MASK          = 0x04000000L;
    constexpr unsigned int SQ_UTCL1_CNTL1__GPUVM_64K_DEF_MASK       = 0x00000002L;
    constexpr unsigned int SQ_UTCL1_CNTL1__GPUVM_PERM_MODE_MASK     = 0x00000004L;
    constexpr unsigned int SQ_UTCL1_CNTL1__REDUCE_CACHE_SIZE_BY_2_MASK = 0xc0000000L;
    constexpr unsigned int SQ_UTCL1_CNTL1__REDUCE_FIFO_DEPTH_BY_2_MASK = 0x30000000L;
    constexpr unsigned int SQ_UTCL1_CNTL1__REG_INVALIDATE_ALL_MASK  = 0x02000000L;
    constexpr unsigned int SQ_UTCL1_CNTL1__REG_INVALIDATE_ALL_VMID_MASK = 0x00800000L;
    constexpr unsigned int SQ_UTCL1_CNTL1__REG_INVALIDATE_TOGGLE_MASK = 0x01000000L;
    constexpr unsigned int SQ_UTCL1_CNTL1__REG_INVALIDATE_VMID_MASK = 0x00780000L;
    constexpr unsigned int SQ_UTCL1_CNTL1__RESP_FAULT_MODE_MASK     = 0x00000060L;
    constexpr unsigned int SQ_UTCL1_CNTL1__RESP_MODE_MASK           = 0x00000018L;
    constexpr unsigned int SQ_UTCL1_CNTL1__USERVM_DIS_MASK          = 0x00010000L;
    constexpr unsigned int SQ_UTCL1_CNTL2__DIS_EDC_MASK             = 0x00000800L;
    constexpr unsigned int SQ_UTCL1_CNTL2__FORCE_FRAG_2M_TO_64K_MASK = 0x04000000L;
    constexpr unsigned int SQ_UTCL1_CNTL2__FORCE_GPUVM_INV_ACK_MASK = 0x00008000L;
    constexpr unsigned int SQ_UTCL1_CNTL2__FORCE_SNOOP_MASK         = 0x00004000L;
    constexpr unsigned int SQ_UTCL1_CNTL2__GPUVM_INV_MODE_MASK      = 0x00001000L;
    constexpr unsigned int SQ_UTCL1_CNTL2__LFIFO_SCAN_DISABLE_MASK  = 0x00000100L;
    constexpr unsigned int SQ_UTCL1_CNTL2__LINE_VALID_MASK          = 0x00000400L;
    constexpr unsigned int SQ_UTCL1_CNTL2__MTYPE_OVRD_DIS_MASK      = 0x00000200L;
    constexpr unsigned int SQ_UTCL1_CNTL2__PREFETCH_PAGE_MASK       = 0xf0000000L;
    constexpr unsigned int SQ_UTCL1_CNTL2__RETRY_TIMER_MASK         = 0x007f0000L;
    constexpr unsigned int SQ_UTCL1_CNTL2__SHOOTDOWN_OPT_MASK       = 0x00002000L;
    constexpr unsigned int SQ_UTCL1_CNTL2__SPARE_MASK               = 0x000000ffL;
    constexpr unsigned int SQ_UTCL1_STATUS__FAULT_DETECTED_MASK     = 0x00000001L;
    constexpr unsigned int SQ_UTCL1_STATUS__PRT_DETECTED_MASK       = 0x00000004L;
    constexpr unsigned int SQ_UTCL1_STATUS__RESERVED_MASK           = 0x0000fff8L;
    constexpr unsigned int SQ_UTCL1_STATUS__RETRY_DETECTED_MASK     = 0x00000002L;
    constexpr unsigned int SQ_UTCL1_STATUS__UNUSED_MASK             = 0xffff0000L;
    constexpr unsigned int SQ_VINTRP__ATTRCHAN_MASK                 = 0x00000300L;
    constexpr unsigned int SQ_VINTRP__ATTR_MASK                     = 0x0000fc00L;
    constexpr unsigned int SQ_VINTRP__ENCODING_MASK                 = 0xfc000000L;
    constexpr unsigned int SQ_VINTRP__OP_MASK                       = 0x00030000L;
    constexpr unsigned int SQ_VINTRP__VDST_MASK                     = 0x03fc0000L;
    constexpr unsigned int SQ_VINTRP__VSRC_MASK                     = 0x000000ffL;
    constexpr unsigned int SQ_VOP1__ENCODING_MASK                   = 0xfe000000L;
    constexpr unsigned int SQ_VOP1__OP_MASK                         = 0x0001fe00L;
    constexpr unsigned int SQ_VOP1__SRC0_MASK                       = 0x000001ffL;
    constexpr unsigned int SQ_VOP1__VDST_MASK                       = 0x01fe0000L;
    constexpr unsigned int SQ_VOP2__ENCODING_MASK                   = 0x80000000L;
    constexpr unsigned int SQ_VOP2__OP_MASK                         = 0x7e000000L;
    constexpr unsigned int SQ_VOP2__SRC0_MASK                       = 0x000001ffL;
    constexpr unsigned int SQ_VOP2__VDST_MASK                       = 0x01fe0000L;
    constexpr unsigned int SQ_VOP2__VSRC1_MASK                      = 0x0001fe00L;
    constexpr unsigned int SQ_VOP3P_0__CLAMP_MASK                   = 0x00008000L;
    constexpr unsigned int SQ_VOP3P_0__ENCODING_MASK                = 0xff800000L;
    constexpr unsigned int SQ_VOP3P_0__NEG_HI_MASK                  = 0x00000700L;
    constexpr unsigned int SQ_VOP3P_0__OP_MASK                      = 0x007f0000L;
    constexpr unsigned int SQ_VOP3P_0__OP_SEL_HI_2_MASK             = 0x00004000L;
    constexpr unsigned int SQ_VOP3P_0__OP_SEL_MASK                  = 0x00003800L;
    constexpr unsigned int SQ_VOP3P_0__VDST_MASK                    = 0x000000ffL;
    constexpr unsigned int SQ_VOP3P_1__NEG_MASK                     = 0xe0000000L;
    constexpr unsigned int SQ_VOP3P_1__OP_SEL_HI_MASK               = 0x18000000L;
    constexpr unsigned int SQ_VOP3P_1__SRC0_MASK                    = 0x000001ffL;
    constexpr unsigned int SQ_VOP3P_1__SRC1_MASK                    = 0x0003fe00L;
    constexpr unsigned int SQ_VOP3P_1__SRC2_MASK                    = 0x07fc0000L;
    constexpr unsigned int SQ_VOP3_0_SDST_ENC__CLAMP_MASK           = 0x00008000L;
    constexpr unsigned int SQ_VOP3_0_SDST_ENC__ENCODING_MASK        = 0xfc000000L;
    constexpr unsigned int SQ_VOP3_0_SDST_ENC__OP_MASK              = 0x03ff0000L;
    constexpr unsigned int SQ_VOP3_0_SDST_ENC__SDST_MASK            = 0x00007f00L;
    constexpr unsigned int SQ_VOP3_0_SDST_ENC__VDST_MASK            = 0x000000ffL;
    constexpr unsigned int SQ_VOP3_0__ABS_MASK                      = 0x00000700L;
    constexpr unsigned int SQ_VOP3_0__CLAMP_MASK                    = 0x00008000L;
    constexpr unsigned int SQ_VOP3_0__ENCODING_MASK                 = 0xfc000000L;
    constexpr unsigned int SQ_VOP3_0__OP_MASK                       = 0x03ff0000L;
    constexpr unsigned int SQ_VOP3_0__OP_SEL_MASK                   = 0x00007800L;
    constexpr unsigned int SQ_VOP3_0__VDST_MASK                     = 0x000000ffL;
    constexpr unsigned int SQ_VOP3_1__NEG_MASK                      = 0xe0000000L;
    constexpr unsigned int SQ_VOP3_1__OMOD_MASK                     = 0x18000000L;
    constexpr unsigned int SQ_VOP3_1__SRC0_MASK                     = 0x000001ffL;
    constexpr unsigned int SQ_VOP3_1__SRC1_MASK                     = 0x0003fe00L;
    constexpr unsigned int SQ_VOP3_1__SRC2_MASK                     = 0x07fc0000L;
    constexpr unsigned int SQ_VOPC__ENCODING_MASK                   = 0xfe000000L;
    constexpr unsigned int SQ_VOPC__OP_MASK                         = 0x01fe0000L;
    constexpr unsigned int SQ_VOPC__SRC0_MASK                       = 0x000001ffL;
    constexpr unsigned int SQ_VOPC__VSRC1_MASK                      = 0x0001fe00L;
    constexpr unsigned int SQ_VOP_DPP__BANK_MASK_MASK               = 0x0f000000L;
    constexpr unsigned int SQ_VOP_DPP__BOUND_CTRL_MASK              = 0x00080000L;
    constexpr unsigned int SQ_VOP_DPP__DPP_CTRL_MASK                = 0x0001ff00L;
    constexpr unsigned int SQ_VOP_DPP__ROW_MASK_MASK                = 0xf0000000L;
    constexpr unsigned int SQ_VOP_DPP__SRC0_ABS_MASK                = 0x00200000L;
    constexpr unsigned int SQ_VOP_DPP__SRC0_MASK                    = 0x000000ffL;
    constexpr unsigned int SQ_VOP_DPP__SRC0_NEG_MASK                = 0x00100000L;
    constexpr unsigned int SQ_VOP_DPP__SRC1_ABS_MASK                = 0x00800000L;
    constexpr unsigned int SQ_VOP_DPP__SRC1_NEG_MASK                = 0x00400000L;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__S0_MASK            = 0x00800000L;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__S1_MASK            = 0x80000000L;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SDST_MASK          = 0x00007f00L;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SD_MASK            = 0x00008000L;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC0_ABS_MASK      = 0x00200000L;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC0_MASK          = 0x000000ffL;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC0_NEG_MASK      = 0x00100000L;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC0_SEL_MASK      = 0x00070000L;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC0_SEXT_MASK     = 0x00080000L;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC1_ABS_MASK      = 0x20000000L;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC1_NEG_MASK      = 0x10000000L;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC1_SEL_MASK      = 0x07000000L;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC1_SEXT_MASK     = 0x08000000L;
    constexpr unsigned int SQ_VOP_SDWA__CLAMP_MASK                  = 0x00002000L;
    constexpr unsigned int SQ_VOP_SDWA__DST_SEL_MASK                = 0x00000700L;
    constexpr unsigned int SQ_VOP_SDWA__DST_UNUSED_MASK             = 0x00001800L;
    constexpr unsigned int SQ_VOP_SDWA__OMOD_MASK                   = 0x0000c000L;
    constexpr unsigned int SQ_VOP_SDWA__S0_MASK                     = 0x00800000L;
    constexpr unsigned int SQ_VOP_SDWA__S1_MASK                     = 0x80000000L;
    constexpr unsigned int SQ_VOP_SDWA__SRC0_ABS_MASK               = 0x00200000L;
    constexpr unsigned int SQ_VOP_SDWA__SRC0_MASK                   = 0x000000ffL;
    constexpr unsigned int SQ_VOP_SDWA__SRC0_NEG_MASK               = 0x00100000L;
    constexpr unsigned int SQ_VOP_SDWA__SRC0_SEL_MASK               = 0x00070000L;
    constexpr unsigned int SQ_VOP_SDWA__SRC0_SEXT_MASK              = 0x00080000L;
    constexpr unsigned int SQ_VOP_SDWA__SRC1_ABS_MASK               = 0x20000000L;
    constexpr unsigned int SQ_VOP_SDWA__SRC1_NEG_MASK               = 0x10000000L;
    constexpr unsigned int SQ_VOP_SDWA__SRC1_SEL_MASK               = 0x07000000L;
    constexpr unsigned int SQ_VOP_SDWA__SRC1_SEXT_MASK              = 0x08000000L;
    constexpr unsigned int SQ_WREXEC_EXEC_HI__ATC_MASK              = 0x08000000L;
    constexpr unsigned int SX_DEBUG_1__DEBUG_DATA_MASK              = 0xffffc000L;
    constexpr unsigned int TA_CNTL_AUX__ANISO_MIP_ADJ_MODE_MASK     = 0x00080000L;
    constexpr unsigned int TA_CNTL_AUX__NONIMG_ANISO_BYPASS_MASK    = 0x00000200L;
    constexpr unsigned int TA_CNTL_AUX__RESERVED_MASK               = 0x0000000eL;
    constexpr unsigned int TA_CNTL__FX_XNACK_CREDIT_MASK            = 0x0000007fL;
    constexpr unsigned int TA_CNTL__SQ_XNACK_CREDIT_MASK            = 0x00001e00L;
    constexpr unsigned int TA_CNTL__TC_DATA_CREDIT_MASK             = 0x0000e000L;
    constexpr unsigned int TA_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK  = 0x000000ffL;
    constexpr unsigned int TA_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK  = 0x0003fc00L;
    constexpr unsigned int TA_PERFCOUNTER0_SELECT__PERF_SEL1_MASK   = 0x0003fc00L;
    constexpr unsigned int TA_PERFCOUNTER0_SELECT__PERF_SEL_MASK    = 0x000000ffL;
    constexpr unsigned int TA_PERFCOUNTER1_SELECT__PERF_SEL_MASK    = 0x000000ffL;
    constexpr unsigned int TCA_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int TCA_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0x0f000000L;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0xf0000000L;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int TCA_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int TCA_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK = 0x0f000000L;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK = 0xf0000000L;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int TCA_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int TCA_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int TCA_PERFCOUNTER2_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
    constexpr unsigned int TCA_PERFCOUNTER2_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int TCA_PERFCOUNTER2_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int TCA_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int TCA_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int TCA_PERFCOUNTER3_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
    constexpr unsigned int TCA_PERFCOUNTER3_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int TCA_PERFCOUNTER3_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int TCC_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int TCC_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0x0f000000L;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0xf0000000L;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int TCC_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int TCC_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK = 0x0f000000L;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK = 0xf0000000L;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int TCC_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int TCC_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int TCC_PERFCOUNTER2_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
    constexpr unsigned int TCC_PERFCOUNTER2_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int TCC_PERFCOUNTER2_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int TCC_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int TCC_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int TCC_PERFCOUNTER3_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
    constexpr unsigned int TCC_PERFCOUNTER3_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int TCC_PERFCOUNTER3_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__ADDR_MODE_MASK = 0x00000800L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__COMPRESSION_ENABLE_MASK = 0x00000400L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__GLC_MASK      = 0x00000100L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__SLC_MASK      = 0x00000200L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__ADDR_MODE_MASK   = 0x70000000L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__COMPRESSION_ENABLE_MASK = 0x08000000L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__DATA_FORMAT_MASK = 0x000007e0L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__GLC_MASK         = 0x02000000L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__NUM_FORMAT_MASK  = 0x00007800L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__NUM_SAMPLES_MASK = 0x00300000L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__OPCODE_TYPE_MASK = 0x01c00000L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__SLC_MASK         = 0x04000000L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__SW_MODE_MASK     = 0x000f8000L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_0_MASK    = 0x00000003L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_1_MASK    = 0x0000000cL;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_2_MASK    = 0x00000030L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_3_MASK    = 0x000000c0L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_4_MASK    = 0x00000300L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_5_MASK    = 0x00000c00L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_6_MASK    = 0x00003000L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_7_MASK    = 0x0000c000L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_8_MASK    = 0x00030000L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_9_MASK    = 0x000c0000L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_10_MASK   = 0x00300000L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_11_MASK   = 0x00c00000L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_12_MASK   = 0x03000000L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_13_MASK   = 0x0c000000L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_14_MASK   = 0x30000000L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_15_MASK   = 0xc0000000L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_16_MASK   = 0x00000003L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_17_MASK   = 0x0000000cL;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_18_MASK   = 0x00000030L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_19_MASK   = 0x000000c0L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_20_MASK   = 0x00000300L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_21_MASK   = 0x00000c00L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_22_MASK   = 0x00003000L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_23_MASK   = 0x0000c000L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_24_MASK   = 0x00030000L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_25_MASK   = 0x000c0000L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_26_MASK   = 0x00300000L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_27_MASK   = 0x00c00000L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_28_MASK   = 0x03000000L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_29_MASK   = 0x0c000000L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_30_MASK   = 0x30000000L;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_31_MASK   = 0xc0000000L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_0_MASK    = 0x00000001L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_1_MASK    = 0x00000002L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_2_MASK    = 0x00000004L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_3_MASK    = 0x00000008L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_4_MASK    = 0x00000010L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_5_MASK    = 0x00000020L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_6_MASK    = 0x00000040L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_7_MASK    = 0x00000080L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_8_MASK    = 0x00000100L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_9_MASK    = 0x00000200L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_10_MASK   = 0x00000400L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_11_MASK   = 0x00000800L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_12_MASK   = 0x00001000L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_13_MASK   = 0x00002000L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_14_MASK   = 0x00004000L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_15_MASK   = 0x00008000L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_16_MASK   = 0x00010000L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_17_MASK   = 0x00020000L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_18_MASK   = 0x00040000L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_19_MASK   = 0x00080000L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_20_MASK   = 0x00100000L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_21_MASK   = 0x00200000L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_22_MASK   = 0x00400000L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_23_MASK   = 0x00800000L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_24_MASK   = 0x01000000L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_25_MASK   = 0x02000000L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_26_MASK   = 0x04000000L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_27_MASK   = 0x08000000L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_28_MASK   = 0x10000000L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_29_MASK   = 0x20000000L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_30_MASK   = 0x40000000L;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_31_MASK   = 0x80000000L;
    constexpr unsigned int TC_CFG_L1_VOLATILE__VOL_MASK             = 0x0000000fL;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_0_MASK   = 0x00000003L;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_1_MASK   = 0x0000000cL;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_2_MASK   = 0x00000030L;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_3_MASK   = 0x000000c0L;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_4_MASK   = 0x00000300L;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_5_MASK   = 0x00000c00L;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_6_MASK   = 0x00003000L;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_7_MASK   = 0x0000c000L;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_8_MASK   = 0x00030000L;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_9_MASK   = 0x000c0000L;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_10_MASK  = 0x00300000L;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_11_MASK  = 0x00c00000L;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_12_MASK  = 0x03000000L;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_13_MASK  = 0x0c000000L;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_14_MASK  = 0x30000000L;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_15_MASK  = 0xc0000000L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_0_MASK    = 0x00000003L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_1_MASK    = 0x0000000cL;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_2_MASK    = 0x00000030L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_3_MASK    = 0x000000c0L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_4_MASK    = 0x00000300L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_5_MASK    = 0x00000c00L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_6_MASK    = 0x00003000L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_7_MASK    = 0x0000c000L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_8_MASK    = 0x00030000L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_9_MASK    = 0x000c0000L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_10_MASK   = 0x00300000L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_11_MASK   = 0x00c00000L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_12_MASK   = 0x03000000L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_13_MASK   = 0x0c000000L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_14_MASK   = 0x30000000L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_15_MASK   = 0xc0000000L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_16_MASK   = 0x00000003L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_17_MASK   = 0x0000000cL;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_18_MASK   = 0x00000030L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_19_MASK   = 0x000000c0L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_20_MASK   = 0x00000300L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_21_MASK   = 0x00000c00L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_22_MASK   = 0x00003000L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_23_MASK   = 0x0000c000L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_24_MASK   = 0x00030000L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_25_MASK   = 0x000c0000L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_26_MASK   = 0x00300000L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_27_MASK   = 0x00c00000L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_28_MASK   = 0x03000000L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_29_MASK   = 0x0c000000L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_30_MASK   = 0x30000000L;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_31_MASK   = 0xc0000000L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_0_MASK   = 0x00000003L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_1_MASK   = 0x0000000cL;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_2_MASK   = 0x00000030L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_3_MASK   = 0x000000c0L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_4_MASK   = 0x00000300L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_5_MASK   = 0x00000c00L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_6_MASK   = 0x00003000L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_7_MASK   = 0x0000c000L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_8_MASK   = 0x00030000L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_9_MASK   = 0x000c0000L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_10_MASK  = 0x00300000L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_11_MASK  = 0x00c00000L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_12_MASK  = 0x03000000L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_13_MASK  = 0x0c000000L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_14_MASK  = 0x30000000L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_15_MASK  = 0xc0000000L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_16_MASK  = 0x00000003L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_17_MASK  = 0x0000000cL;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_18_MASK  = 0x00000030L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_19_MASK  = 0x000000c0L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_20_MASK  = 0x00000300L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_21_MASK  = 0x00000c00L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_22_MASK  = 0x00003000L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_23_MASK  = 0x0000c000L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_24_MASK  = 0x00030000L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_25_MASK  = 0x000c0000L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_26_MASK  = 0x00300000L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_27_MASK  = 0x00c00000L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_28_MASK  = 0x03000000L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_29_MASK  = 0x0c000000L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_30_MASK  = 0x30000000L;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_31_MASK  = 0xc0000000L;
    constexpr unsigned int TC_CFG_L2_VOLATILE__VOL_MASK             = 0x0000000fL;
    constexpr unsigned int TD_CNTL__DISABLE_MM_QNAN_COMPARE_RESULT_MASK = 0x01000000L;
    constexpr unsigned int TD_DEBUG_INDEX__INDEX_MASK               = 0x0000001fL;
    constexpr unsigned int TD_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK  = 0x000000ffL;
    constexpr unsigned int TD_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK  = 0x0003fc00L;
    constexpr unsigned int TD_PERFCOUNTER0_SELECT__PERF_SEL1_MASK   = 0x0003fc00L;
    constexpr unsigned int TD_PERFCOUNTER0_SELECT__PERF_SEL_MASK    = 0x000000ffL;
    constexpr unsigned int TD_PERFCOUNTER1_SELECT__PERF_SEL_MASK    = 0x000000ffL;
    constexpr unsigned int UTCL2_CGTT_CLK_CTRL__MGLS_OVERRIDE_MASK  = 0x00008000L;
    constexpr unsigned int UTCL2_CGTT_CLK_CTRL__OFF_HYSTERESIS_MASK = 0x00000ff0L;
    constexpr unsigned int UTCL2_CGTT_CLK_CTRL__ON_DELAY_MASK       = 0x0000000fL;
    constexpr unsigned int UTCL2_CGTT_CLK_CTRL__SOFT_OVERRIDE_EXTRA_MASK = 0x00007000L;
    constexpr unsigned int UTCL2_CGTT_CLK_CTRL__SOFT_OVERRIDE_MASK  = 0xff000000L;
    constexpr unsigned int UTCL2_CGTT_CLK_CTRL__SOFT_STALL_OVERRIDE_MASK = 0x00ff0000L;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_BUSY_MASK           = 0x00000001L;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_GS_BUSY_MASK        = 0x00000080L;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_HS_BUSY_MASK        = 0x00000100L;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_OUT_BUSY_MASK       = 0x00000004L;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_OUT_INDX_BUSY_MASK  = 0x00000002L;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_PI_BUSY_MASK        = 0x00000040L;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_PRIMGEN_BUSY_MASK   = 0x00000400L;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_PT_BUSY_MASK        = 0x00000008L;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_TE11_BUSY_MASK      = 0x00000200L;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_TE_BUSY_MASK        = 0x00000010L;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_VR_BUSY_MASK        = 0x00000020L;
    constexpr unsigned int VGT_DEBUG_DATA__DATA_MASK                = 0xffffffffL;
    constexpr unsigned int VGT_DEBUG_REG0__gog_busy_MASK            = 0x00010000L;
    constexpr unsigned int VGT_DEBUG_REG0__gs_busy_MASK             = 0x00001000L;
    constexpr unsigned int VGT_DEBUG_REG0__sclk_core_vld_MASK       = 0x20000000L;
    constexpr unsigned int VGT_DEBUG_REG0__sclk_gs_vld_MASK         = 0x40000000L;
    constexpr unsigned int VGT_DEBUG_REG0__vgt_busy_MASK            = 0x00000004L;
    constexpr unsigned int VGT_DEBUG_REG11__gs_issue_rtr_MASK       = 0x00010000L;
    constexpr unsigned int VGT_DEBUG_REG15__output_fifo_full_MASK   = 0x00000008L;
    constexpr unsigned int VGT_DEBUG_REG16__gog_busy_MASK           = 0x00000001L;
    constexpr unsigned int VGT_DISPATCH_DRAW_INDEX__MATCH_INDEX_MASK = 0xffffffffL;
    constexpr unsigned int VGT_DMA_CONTROL__EN_INST_OPT_ADV_MASK    = 0x00400000L;
    constexpr unsigned int VGT_DMA_CONTROL__EN_INST_OPT_BASIC_MASK  = 0x00200000L;
    constexpr unsigned int VGT_DMA_CONTROL__HW_USE_ONLY_MASK        = 0x00800000L;
    constexpr unsigned int VGT_DMA_DATA_FIFO_DEPTH__DMA2DRAW_FIFO_DEPTH_MASK = 0x0007fe00L;
    constexpr unsigned int VGT_DMA_DATA_FIFO_DEPTH__DMA_DATA_FIFO_DEPTH_MASK = 0x000001ffL;
    constexpr unsigned int VGT_DMA_INDEX_TYPE__PRIMGEN_EN_MASK      = 0x00000100L;
    constexpr unsigned int VGT_DMA_INDEX_TYPE__RDREQ_POLICY_MASK    = 0x00000040L;
    constexpr unsigned int VGT_DRAW_INITIATOR__GRBM_SKEW_NO_DEC_MASK = 0x00000100L;
    constexpr unsigned int VGT_DRAW_INITIATOR__UNROLLED_INST_MASK   = 0x00000080L;
    constexpr unsigned int VGT_FIFO_DEPTHS__HSINPUT_FIFO_DEPTH_MASK = 0x0fc00000L;
    constexpr unsigned int VGT_GS_MAX_PRIMS_PER_SUBGROUP__MAX_PRIMS_PER_SUBGROUP_MASK = 0x0000ffffL;
    constexpr unsigned int VGT_GS_MODE__RESERVED_3_MASK             = 0x00004000L;
    constexpr unsigned int VGT_GS_MODE__RESERVED_4_MASK             = 0x00008000L;
    constexpr unsigned int VGT_GS_MODE__RESERVED_5_MASK             = 0x00010000L;
    constexpr unsigned int VGT_HS_OFFCHIP_PARAM__OFFCHIP_BUFFERING_MASK = 0x000001ffL;
    constexpr unsigned int VGT_HS_OFFCHIP_PARAM__OFFCHIP_GRANULARITY_MASK = 0x00000600L;
    constexpr unsigned int VGT_INDEX_TYPE__PRIMGEN_EN_MASK          = 0x00000100L;
    constexpr unsigned int VGT_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int VGT_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int VGT_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int VGT_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int VGT_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int VGT_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int VGT_PERFCOUNTER2_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int VGT_PERFCOUNTER2_SELECT__PERF_SEL_MASK   = 0x000000ffL;
    constexpr unsigned int VGT_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int VGT_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int VGT_PERFCOUNTER3_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int VGT_PERFCOUNTER3_SELECT__PERF_SEL_MASK   = 0x000000ffL;
    constexpr unsigned int VGT_PERFCOUNTER_SEID_MASK__PERF_SEID_IGNORE_MASK_MASK = 0x000000ffL;
    constexpr unsigned int VGT_SHADER_STAGES_EN__DISPATCH_DRAW_EN_MASK = 0x00000200L;
    constexpr unsigned int VGT_SHADER_STAGES_EN__DIS_DEALLOC_ACCUM_0_MASK = 0x00000400L;
    constexpr unsigned int VGT_SHADER_STAGES_EN__DIS_DEALLOC_ACCUM_1_MASK = 0x00000800L;
    constexpr unsigned int VGT_TF_PARAM__RDREQ_POLICY_MASK          = 0x00008000L;
    constexpr unsigned int VGT_VTX_VECT_EJECT_REG__PRIM_COUNT_MASK  = 0x0000007fL;
    constexpr unsigned int WD_CNTL_STATUS__WD_ADC_BUSY_MASK         = 0x00000008L;
    constexpr unsigned int WD_CNTL_STATUS__WD_BUSY_MASK             = 0x00000001L;
    constexpr unsigned int WD_CNTL_STATUS__WD_SPL_DI_BUSY_MASK      = 0x00000004L;
    constexpr unsigned int WD_CNTL_STATUS__WD_SPL_DMA_BUSY_MASK     = 0x00000002L;
    constexpr unsigned int WD_DEBUG_DATA__DATA_MASK                 = 0xffffffffL;
    constexpr unsigned int WD_DEBUG_REG0__sclk_core_vld_MASK        = 0x40000000L;
    constexpr unsigned int WD_DEBUG_REG0__sclk_input_vld_MASK       = 0x20000000L;
    constexpr unsigned int WD_DEBUG_REG0__sclk_reg_vld_MASK         = 0x10000000L;
    constexpr unsigned int WD_DEBUG_REG0__wd_busy_MASK              = 0x00000004L;
    constexpr unsigned int WD_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
    constexpr unsigned int WD_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
    constexpr unsigned int WD_PERFCOUNTER0_SELECT__PERF_MODE_MASK   = 0xf0000000L;
    constexpr unsigned int WD_PERFCOUNTER0_SELECT__PERF_SEL_MASK    = 0x000000ffL;
    constexpr unsigned int WD_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
    constexpr unsigned int WD_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
    constexpr unsigned int WD_PERFCOUNTER1_SELECT__PERF_MODE_MASK   = 0xf0000000L;
    constexpr unsigned int WD_PERFCOUNTER1_SELECT__PERF_SEL_MASK    = 0x000000ffL;
    constexpr unsigned int WD_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
    constexpr unsigned int WD_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
    constexpr unsigned int WD_PERFCOUNTER2_SELECT__PERF_MODE_MASK   = 0xf0000000L;
    constexpr unsigned int WD_PERFCOUNTER2_SELECT__PERF_SEL_MASK    = 0x000000ffL;
    constexpr unsigned int WD_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
    constexpr unsigned int WD_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
    constexpr unsigned int WD_PERFCOUNTER3_SELECT__PERF_MODE_MASK   = 0xf0000000L;
    constexpr unsigned int WD_PERFCOUNTER3_SELECT__PERF_SEL_MASK    = 0x000000ffL;
    constexpr unsigned int WD_UTCL1_CNTL__FORCE_SD_VMID_DIRTY_MASK  = 0x20000000L;
} // namespace Gfx09

namespace Gfx09_0
{
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_alloc_opco_error_MASK = 0x00000004L;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_dealloc_opco_error_MASK = 0x00000008L;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_dec_error_MASK = 0x00000002L;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_error_ds_address_MASK = 0x003fff00L;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_wrap_opco_error_MASK = 0x00000010L;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_write_dis_MASK = 0x00000001L;
    constexpr unsigned int alloc_DEBUG_DATA__Reserved0_MASK         = 0x000000e0L;
    constexpr unsigned int alloc_DEBUG_DATA__Reserved1_MASK         = 0xffc00000L;
    constexpr unsigned int CP_PRT_LOD_STATS_CNTL0__BU_SIZE_MASK     = 0xffffffffL;
    constexpr unsigned int CP_PRT_LOD_STATS_CNTL1__BASE_LO_MASK     = 0xffffffffL;
    constexpr unsigned int CP_PRT_LOD_STATS_CNTL2__BASE_HI_MASK     = 0x000003ffL;
    constexpr unsigned int CP_PRT_LOD_STATS_CNTL3__CACHE_POLICY_MASK = 0x10000000L;
    constexpr unsigned int CP_PRT_LOD_STATS_CNTL3__INTERVAL_MASK    = 0x000003fcL;
    constexpr unsigned int CP_PRT_LOD_STATS_CNTL3__MC_VMID_MASK     = 0x07800000L;
    constexpr unsigned int CP_PRT_LOD_STATS_CNTL3__REPORT_AND_RESET_MASK = 0x00080000L;
    constexpr unsigned int CP_PRT_LOD_STATS_CNTL3__RESET_CNT_MASK   = 0x0003fc00L;
    constexpr unsigned int CP_PRT_LOD_STATS_CNTL3__RESET_FORCE_MASK = 0x00040000L;
    constexpr unsigned int DB_DEBUG4__DB_EXTRA_DEBUG4_MASK          = 0xfff80000L;
    constexpr unsigned int GC_CAC_ACC_CU5__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU6__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU7__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU8__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU9__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU10__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_SQ0_UPPER__UNUSED_0_MASK      = 0xffffff00L;
    constexpr unsigned int GC_CAC_ACC_SQ1_UPPER__UNUSED_0_MASK      = 0xffffff00L;
    constexpr unsigned int GC_CAC_ACC_SQ2_UPPER__UNUSED_0_MASK      = 0xffffff00L;
    constexpr unsigned int GC_CAC_ACC_SQ3_UPPER__UNUSED_0_MASK      = 0xffffff00L;
    constexpr unsigned int GC_CAC_ACC_SQ4_UPPER__UNUSED_0_MASK      = 0xffffff00L;
    constexpr unsigned int GC_CAC_ACC_SQ5_UPPER__UNUSED_0_MASK      = 0xffffff00L;
    constexpr unsigned int GC_CAC_ACC_SQ6_UPPER__UNUSED_0_MASK      = 0xffffff00L;
    constexpr unsigned int GC_CAC_ACC_SQ7_UPPER__UNUSED_0_MASK      = 0xffffff00L;
    constexpr unsigned int GC_CAC_ACC_SQ8_UPPER__UNUSED_0_MASK      = 0xffffff00L;
    constexpr unsigned int GC_CAC_CNTL__CAC_ENABLE_MASK             = 0x00000001L;
    constexpr unsigned int GC_CAC_CNTL__UNUSED_0_MASK               = 0x80000000L;
    constexpr unsigned int GC_CAC_CTRL_2__UNUSED_0_MASK             = 0xfffffffcL;
    constexpr unsigned int GC_CAC_SOFT_CTRL__UNUSED_MASK            = 0xfffffffeL;
    constexpr unsigned int GC_CAC_WEIGHT_CP_1__UNUSED_0_MASK        = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_CU_0__WEIGHT_CU_SIG1_MASK  = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_CU_1__WEIGHT_CU_SIG2_MASK  = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_CU_1__WEIGHT_CU_SIG3_MASK  = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_CU_2__WEIGHT_CU_SIG4_MASK  = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_CU_2__WEIGHT_CU_SIG5_MASK  = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_CU_3__WEIGHT_CU_SIG6_MASK  = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_CU_3__WEIGHT_CU_SIG7_MASK  = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_CU_4__WEIGHT_CU_SIG8_MASK  = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_CU_4__WEIGHT_CU_SIG9_MASK  = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_CU_5__WEIGHT_CU_SIG10_MASK = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_CU_5__WEIGHT_CU_SIG11_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_IA_0__UNUSED_0_MASK        = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_PC_0__UNUSED_0_MASK        = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_RMI_0__UNUSED_MASK         = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_SC_0__UNUSED_0_MASK        = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_SQ_4__UNUSED_0_MASK        = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_SXRB_0__WEIGHT_SXRB_SIG1_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_SX_0__UNUSED_0_MASK        = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_TA_0__UNUSED_0_MASK        = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ATCL2_2__WEIGHT_UTCL2_ATCL2_SIG5_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_UTCL2_VML2_2__WEIGHT_UTCL2_VML2_SIG5_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_UTCL2_WALKER_2__WEIGHT_UTCL2_WALKER_SIG5_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_VGT_1__UNUSED_0_MASK       = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_WD_0__UNUSED_0_MASK        = 0xffff0000L;
    constexpr unsigned int GC_DIDT_CTRL2__UNUSED_0_MASK             = 0x0000c000L;
    constexpr unsigned int GC_DIDT_CTRL2__UNUSED_1_MASK             = 0x04000000L;
    constexpr unsigned int GC_DIDT_CTRL2__UNUSED_2_MASK             = 0x80000000L;
    constexpr unsigned int GC_EDC_CTRL__UNUSED_0_MASK               = 0xfffffc00L;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT1__PERFCOUNTER_SELECT2_MASK = 0x000003ffL;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT1__PERFCOUNTER_SELECT3_MASK = 0x000ffc00L;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT__PERFCOUNTER_SELECT1_MASK = 0x000ffc00L;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT__PERFCOUNTER_SELECT_MASK = 0x000003ffL;
    constexpr unsigned int GDS_PERFCOUNTER1_SELECT__PERFCOUNTER_SELECT1_MASK = 0x000ffc00L;
    constexpr unsigned int GDS_PERFCOUNTER1_SELECT__PERFCOUNTER_SELECT_MASK = 0x000003ffL;
    constexpr unsigned int GDS_PERFCOUNTER2_SELECT__PERFCOUNTER_SELECT1_MASK = 0x000ffc00L;
    constexpr unsigned int GDS_PERFCOUNTER2_SELECT__PERFCOUNTER_SELECT_MASK = 0x000003ffL;
    constexpr unsigned int GDS_PERFCOUNTER3_SELECT__PERFCOUNTER_SELECT1_MASK = 0x000ffc00L;
    constexpr unsigned int GDS_PERFCOUNTER3_SELECT__PERFCOUNTER_SELECT_MASK = 0x000003ffL;
    constexpr unsigned int gws_DEBUG_DATA__credit_cnt_MASK          = 0x00010000L;
    constexpr unsigned int gws_DEBUG_DATA__cur_reso_5to0_MASK       = 0x000001f8L;
    constexpr unsigned int gws_DEBUG_DATA__cur_reso_count_MASK      = 0x00008000L;
    constexpr unsigned int gws_DEBUG_DATA__Reserved0_MASK           = 0xff000000L;
    constexpr unsigned int oa_wc0_DEBUG_DATA__credit_cnt_MASK       = 0x00000002L;
    constexpr unsigned int oa_wc0_DEBUG_DATA__req_MASK              = 0x0007ff00L;
    constexpr unsigned int oa_wc0_DEBUG_DATA__Reserved0_MASK        = 0xfff80000L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy0_MASK      = 0x00000800L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy1_MASK      = 0x00001000L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy2_MASK      = 0x00002000L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy3_MASK      = 0x00004000L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy4_MASK      = 0x00008000L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy5_MASK      = 0x00010000L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy6_MASK      = 0x00020000L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy7_MASK      = 0x00040000L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy_MASK       = 0x00000001L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe1_busy_MASK       = 0x00000002L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe2_busy_MASK       = 0x00000004L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe3_busy_MASK       = 0x00000008L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe4_busy_MASK       = 0x00000010L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe5_busy_MASK       = 0x00000020L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe6_busy_MASK       = 0x00000040L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe7_busy_MASK       = 0x00000080L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe8_busy_MASK       = 0x00000100L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe9_busy_MASK       = 0x00000200L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__Pipe10_busy_MASK      = 0x00000400L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__Reserved0_MASK        = 0xfff80000L;
    constexpr unsigned int ord_app_DEBUG_DATA__fifo_busy_MASK       = 0x00000001L;
    constexpr unsigned int ord_app_DEBUG_DATA__ord_busy_MASK        = 0x00000002L;
    constexpr unsigned int ord_app_DEBUG_DATA__Reserved0_MASK       = 0x00000008L;
    constexpr unsigned int ord_app_DEBUG_DATA__Reserved1_MASK       = 0xfffff000L;
    constexpr unsigned int ord_app_DEBUG_DATA__sh0_cmd_fifo_empty_MASK = 0x00000010L;
    constexpr unsigned int ord_app_DEBUG_DATA__sh0_data_fifo_empty_MASK = 0x00000100L;
    constexpr unsigned int ord_app_DEBUG_DATA__sh1_cmd_fifo_empty_MASK = 0x00000020L;
    constexpr unsigned int ord_app_DEBUG_DATA__sh1_data_fifo_empty_MASK = 0x00000200L;
    constexpr unsigned int ord_app_DEBUG_DATA__sh2_cmd_fifo_empty_MASK = 0x00000040L;
    constexpr unsigned int ord_app_DEBUG_DATA__sh2_data_fifo_empty_MASK = 0x00000400L;
    constexpr unsigned int ord_app_DEBUG_DATA__sh3_cmd_fifo_empty_MASK = 0x00000080L;
    constexpr unsigned int ord_app_DEBUG_DATA__sh3_data_fifo_empty_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG00_0__ccgen_to_clipcc_fifo_empty_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG00_0__ccgen_to_clipcc_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG00_0__clipcode_fifo_fifo_empty_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG00_0__clipcode_fifo_full_MASK    = 0x00004000L;
    constexpr unsigned int PA_DEBUG00_0__clip_ga_bc_fifo_write_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG00_0__clip_to_ga_fifo_full_MASK  = 0x00000010L;
    constexpr unsigned int PA_DEBUG00_0__clip_to_ga_fifo_write_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG00_0__clip_to_outsm_fifo_empty_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG00_0__clip_to_outsm_fifo_full_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG00_0__clip_to_outsm_fifo_write_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG00_0__primic_to_clprim_fifo_empty_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG00_0__primic_to_clprim_fifo_full_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG00_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG00_0__su_clip_baryc_free_MASK    = 0x00000006L;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clipp_fifo_empty_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clipp_fifo_full_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clipp_fifo_write_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clips_fifo_empty_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clips_fifo_full_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG00_0__vte_out_clip_fifo_fifo_empty_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG00_0__vte_out_clip_fifo_fifo_full_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG00_0__vte_out_orig_fifo_fifo_empty_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG00_0__vte_out_orig_fifo_fifo_full_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG00_0__vte_out_orig_fifo_fifo_write_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG00_1__available_positions_MASK   = 0x00001fc0L;
    constexpr unsigned int PA_DEBUG00_1__ccgen_to_clipcc_fifo_full_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG00_1__ccgen_to_clipcc_write_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG00_1__current_state_MASK         = 0x00006000L;
    constexpr unsigned int PA_DEBUG00_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG00_1__statevar_bits_vs_out_ccdist0_vec_ena_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG00_1__statevar_bits_vs_out_ccdist1_vec_ena_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG00_1__sx0_receive_fifo_empty_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG00_1__sx0_receive_fifo_full_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG00_1__sx0_receive_fifo_write_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG00_1__vertex_fifo_empty_MASK     = 0x00008000L;
    constexpr unsigned int PA_DEBUG00_1__vertex_fifo_entriesavailable_MASK = 0x0000000fL;
    constexpr unsigned int PA_DEBUG00_1__vertex_fifo_full_MASK      = 0x00010000L;
    constexpr unsigned int PA_DEBUG00_1__vgt_to_ccgen_fifo_empty_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG00_1__vgt_to_ccgen_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG01_0__clip_extra_bc_valid_MASK   = 0x00000007L;
    constexpr unsigned int PA_DEBUG01_0__clip_ga_bc_fifo_write_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG01_0__clip_to_ga_fifo_write_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG01_0__clip_to_outsm_deallocate_slot_MASK = 0x00000e00L;
    constexpr unsigned int PA_DEBUG01_0__clip_to_outsm_null_primitive_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG01_0__clip_to_outsm_vertex_deallocate_MASK = 0x000001c0L;
    constexpr unsigned int PA_DEBUG01_0__clip_vert_vte_valid_MASK   = 0x00000020L;
    constexpr unsigned int PA_DEBUG01_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_fifo_fifo_advanceread_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_fifo_fifo_empty_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_rd_extra_bc_valid_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_rd_vertex_store_indx_MASK = 0x000c0000L;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_rd_vte_naninf_kill_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG01_0__vte_positions_vte_clip_vte_naninf_kill_0_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG01_0__vte_positions_vte_clip_vte_naninf_kill_1_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG01_0__vte_positions_vte_clip_vte_naninf_kill_2_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG01_1__ALWAYS_ZERO_MASK           = 0x000000ffL;
    constexpr unsigned int PA_DEBUG01_1__clip_extra_bc_valid_MASK   = 0x00000700L;
    constexpr unsigned int PA_DEBUG01_1__clip_ga_bc_fifo_write_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG01_1__clip_to_ga_fifo_write_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG01_1__clip_to_outsm_vertex_deallocate_MASK = 0x0000c000L;
    constexpr unsigned int PA_DEBUG01_1__clip_vert_vte_valid_MASK   = 0x00003800L;
    constexpr unsigned int PA_DEBUG01_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_fifo_fifo_advanceread_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_fifo_fifo_empty_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_rd_extra_bc_valid_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_rd_vertex_store_indx_MASK = 0x000c0000L;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_rd_vte_naninf_kill_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG02_0__clip_ga_bc_fifo_full_MASK  = 0x00040000L;
    constexpr unsigned int PA_DEBUG02_0__clip_ga_bc_fifo_write_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_clipga_extra_bc_coords_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_clipga_vte_naninf_kill_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_ga_fifo_full_MASK  = 0x00080000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_ga_fifo_write_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_clipped_prim_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_end_of_packet_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_fifo_advanceread_MASK = 0x40000000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_fifo_empty_MASK = 0x80000000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_first_prim_of_slot_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_null_primitive_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_vertex_store_indx_0_MASK = 0x00000f00L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_vertex_store_indx_1_MASK = 0x000000f0L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_vertex_store_indx_2_MASK = 0x0000000fL;
    constexpr unsigned int PA_DEBUG02_1__clip_extra_bc_valid_MASK   = 0x00000007L;
    constexpr unsigned int PA_DEBUG02_1__clip_ga_bc_fifo_full_MASK  = 0x00040000L;
    constexpr unsigned int PA_DEBUG02_1__clip_ga_bc_fifo_write_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_ga_fifo_full_MASK  = 0x00080000L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_ga_fifo_write_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_clipped_prim_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_clip_seq_indx_MASK = 0x000000c0L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_fifo_advanceread_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_fifo_empty_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_null_primitive_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_vertex_store_indx_1_MASK = 0x0000f000L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_vertex_store_indx_2_MASK = 0x00000f00L;
    constexpr unsigned int PA_DEBUG02_1__clip_vert_vte_valid_MASK   = 0x00000038L;
    constexpr unsigned int PA_DEBUG02_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_clip_code_or_MASK = 0x0000003fL;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_clip_primitive_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_deallocate_slot_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_end_of_packet_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_event_id_MASK = 0x00000fc0L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_first_prim_of_slot_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_state_var_indx_MASK = 0x00007000L;
    constexpr unsigned int PA_DEBUG03_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_clip_code_or_MASK = 0x00003fffL;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_deallocate_slot_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_end_of_packet_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_event_id_MASK = 0x0000c000L;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_first_prim_of_slot_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG03_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_param_cache_indx_0_MASK = 0x00000007L;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_vertex_store_indx_0_MASK = 0x001f8000L;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_vertex_store_indx_1_MASK = 0x00007e00L;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_vertex_store_indx_2_MASK = 0x000001f8L;
    constexpr unsigned int PA_DEBUG04_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_param_cache_indx_0_MASK = 0x000007ffL;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_vertex_store_indx_0_MASK = 0x001f0000L;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_vertex_store_indx_2_MASK = 0x0000f800L;
    constexpr unsigned int PA_DEBUG04_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_clip_code_or_MASK = 0x0000003fL;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_clip_primitive_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_deallocate_slot_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_end_of_packet_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_event_id_MASK = 0x00000fc0L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_first_prim_of_slot_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_state_var_indx_MASK = 0x00007000L;
    constexpr unsigned int PA_DEBUG05_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_clip_code_or_MASK = 0x00003fffL;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_deallocate_slot_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_end_of_packet_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_event_id_MASK = 0x0000c000L;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_first_prim_of_slot_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG05_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_param_cache_indx_0_MASK = 0x00000007L;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_vertex_store_indx_0_MASK = 0x001f8000L;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_vertex_store_indx_1_MASK = 0x00007e00L;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_vertex_store_indx_2_MASK = 0x000001f8L;
    constexpr unsigned int PA_DEBUG06_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_param_cache_indx_0_MASK = 0x000007ffL;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_vertex_store_indx_0_MASK = 0x001f0000L;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_vertex_store_indx_2_MASK = 0x0000f800L;
    constexpr unsigned int PA_DEBUG06_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_clip_code_or_MASK = 0x0000003fL;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_clip_primitive_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_deallocate_slot_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_end_of_packet_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_event_id_MASK = 0x00000fc0L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_first_prim_of_slot_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_state_var_indx_MASK = 0x00007000L;
    constexpr unsigned int PA_DEBUG07_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_clip_code_or_MASK = 0x00003fffL;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_deallocate_slot_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_end_of_packet_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_event_id_MASK = 0x0000c000L;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_first_prim_of_slot_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG07_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_param_cache_indx_0_MASK = 0x00000007L;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_vertex_store_indx_0_MASK = 0x001f8000L;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_vertex_store_indx_1_MASK = 0x00007e00L;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_vertex_store_indx_2_MASK = 0x000001f8L;
    constexpr unsigned int PA_DEBUG08_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_param_cache_indx_0_MASK = 0x000007ffL;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_vertex_store_indx_0_MASK = 0x001f0000L;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_vertex_store_indx_2_MASK = 0x0000f800L;
    constexpr unsigned int PA_DEBUG08_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_clip_code_or_MASK = 0x0000003fL;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_clip_primitive_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_deallocate_slot_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_end_of_packet_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_event_id_MASK = 0x00000fc0L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_first_prim_of_slot_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_state_var_indx_MASK = 0x00007000L;
    constexpr unsigned int PA_DEBUG09_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_clip_code_or_MASK = 0x00003fffL;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_deallocate_slot_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_end_of_packet_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_event_id_MASK = 0x0000c000L;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_first_prim_of_slot_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG09_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_param_cache_indx_0_MASK = 0x00000007L;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_vertex_store_indx_0_MASK = 0x001f8000L;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_vertex_store_indx_1_MASK = 0x00007e00L;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_vertex_store_indx_2_MASK = 0x000001f8L;
    constexpr unsigned int PA_DEBUG10_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_param_cache_indx_0_MASK = 0x000007ffL;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_vertex_store_indx_0_MASK = 0x001f0000L;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_vertex_store_indx_2_MASK = 0x0000f800L;
    constexpr unsigned int PA_DEBUG11_0__clipsm0_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x0000f000L;
    constexpr unsigned int PA_DEBUG11_0__clipsm0_clip_to_clipga_prim_valid_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG11_0__clipsm0_inc_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG11_0__clipsm1_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00000f00L;
    constexpr unsigned int PA_DEBUG11_0__clipsm1_clip_to_clipga_prim_valid_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG11_0__clipsm1_inc_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG11_0__clipsm2_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x000000f0L;
    constexpr unsigned int PA_DEBUG11_0__clipsm2_clip_to_clipga_prim_valid_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG11_0__clipsm2_inc_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG11_0__clipsm3_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x0000000fL;
    constexpr unsigned int PA_DEBUG11_0__clipsm3_clip_to_clipga_prim_valid_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG11_0__clipsm3_inc_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG11_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm0_clip_to_clipga_clip_primitive_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG11_1__clipsm0_clip_to_clipga_event_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG11_1__clipsm0_clip_to_clipga_prim_valid_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm0_inc_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm1_clip_to_clipga_clip_primitive_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG11_1__clipsm1_clip_to_clipga_event_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG11_1__clipsm1_clip_to_clipga_prim_valid_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm1_inc_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_clip_to_clipga_clip_primitive_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x0000f000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_clip_to_clipga_event_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_clip_to_clipga_prim_valid_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_inc_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_clip_to_clipga_clip_primitive_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00000f00L;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_clip_to_clipga_event_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_clip_to_clipga_prim_valid_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_inc_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG11_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG12_0__clipsm0_clprim_to_clip_clip_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG12_0__clipsm0_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG12_0__clipsm1_clprim_to_clip_clip_primitive_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG12_0__clipsm1_clprim_to_clip_prim_valid_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG12_0__clipsm2_clprim_to_clip_clip_primitive_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG12_0__clipsm2_clprim_to_clip_prim_valid_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG12_0__clipsm3_clprim_to_clip_clip_primitive_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG12_0__clipsm3_clprim_to_clip_prim_valid_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_available_clip_verts_MASK = 0x000003e0L;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_available_vte_out_clip_MASK = 0x0000001fL;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_seq_indx_load_MASK = 0x0000c000L;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_seq_indx_out_MASK = 0x00000c00L;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_seq_indx_vert_MASK = 0x00003000L;
    constexpr unsigned int PA_DEBUG12_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG12_1__ALWAYS_ZERO_MASK           = 0x000000ffL;
    constexpr unsigned int PA_DEBUG12_1__clipsm0_clprim_to_clip_clip_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG12_1__clipsm0_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG12_1__clipsm1_clprim_to_clip_clip_primitive_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG12_1__clipsm1_clprim_to_clip_prim_valid_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG12_1__clipsm2_clprim_to_clip_clip_primitive_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG12_1__clipsm2_clprim_to_clip_prim_valid_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG12_1__clipsm3_clprim_to_clip_clip_primitive_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG12_1__clipsm3_clprim_to_clip_prim_valid_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG12_1__clip_priority_available_clip_verts_MASK = 0x0000e000L;
    constexpr unsigned int PA_DEBUG12_1__clip_priority_available_vte_out_clip_MASK = 0x00001f00L;
    constexpr unsigned int PA_DEBUG12_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG13_0__ccgen_to_clipcc_fifo_empty_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG13_0__clipcc_vertex_store_indx_MASK = 0x00000030L;
    constexpr unsigned int PA_DEBUG13_0__clipcode_fifo_fifo_empty_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG13_0__clip_priority_seq_indx_out_cnt_MASK = 0x00001e00L;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_fifo_advanceread_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_fifo_contents_MASK = 0x001f0000L;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_fifo_full_MASK   = 0x00200000L;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_fifo_write_MASK  = 0x00800000L;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_rd_clipsm_wait_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_rd_orig_vertices_MASK = 0x00006000L;
    constexpr unsigned int PA_DEBUG13_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG13_0__vertval_bits_vertex_cc_next_valid_MASK = 0x0000000fL;
    constexpr unsigned int PA_DEBUG13_0__vte_out_orig_fifo_fifo_empty_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG13_1__clipcc_vertex_store_indx_MASK = 0x00003000L;
    constexpr unsigned int PA_DEBUG13_1__clipcode_fifo_fifo_empty_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG13_1__clprim_clip_primitive_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG13_1__clprim_cull_primitive_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG13_1__clprim_in_back_state_var_indx_MASK = 0x00000007L;
    constexpr unsigned int PA_DEBUG13_1__outsm_clr_fifo_advanceread_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG13_1__outsm_clr_fifo_contents_MASK = 0x001f0000L;
    constexpr unsigned int PA_DEBUG13_1__outsm_clr_fifo_full_MASK   = 0x00200000L;
    constexpr unsigned int PA_DEBUG13_1__outsm_clr_fifo_write_MASK  = 0x00800000L;
    constexpr unsigned int PA_DEBUG13_1__point_clip_candidate_MASK  = 0x00000008L;
    constexpr unsigned int PA_DEBUG13_1__prim_back_valid_MASK       = 0x00000080L;
    constexpr unsigned int PA_DEBUG13_1__prim_nan_kill_MASK         = 0x00000010L;
    constexpr unsigned int PA_DEBUG13_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG13_1__vertval_bits_vertex_cc_next_valid_MASK = 0x00000f00L;
    constexpr unsigned int PA_DEBUG13_1__vte_out_orig_fifo_fifo_empty_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_deallocate_slot_MASK = 0x0000e000L;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_end_of_packet_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_event_id_MASK = 0x003f0000L;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_event_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_first_prim_of_slot_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_vertex_store_indx_0_MASK = 0x000003f0L;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_vertex_store_indx_1_MASK = 0x0000000fL;
    constexpr unsigned int PA_DEBUG14_0__outputclprimtoclip_null_primitive_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG14_0__prim_back_valid_MASK       = 0x00800000L;
    constexpr unsigned int PA_DEBUG14_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_event_id_MASK = 0x003f0000L;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_event_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_vertex_store_indx_0_MASK = 0x0000f000L;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_vertex_store_indx_1_MASK = 0x00000fc0L;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_vertex_store_indx_2_MASK = 0x0000003fL;
    constexpr unsigned int PA_DEBUG14_1__prim_back_valid_MASK       = 0x00800000L;
    constexpr unsigned int PA_DEBUG14_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG15_0__primic_to_clprim_fifo_vertex_store_indx_0_MASK = 0x007c0000L;
    constexpr unsigned int PA_DEBUG15_0__primic_to_clprim_fifo_vertex_store_indx_1_MASK = 0x0003e000L;
    constexpr unsigned int PA_DEBUG15_0__primic_to_clprim_fifo_vertex_store_indx_2_MASK = 0x00001f00L;
    constexpr unsigned int PA_DEBUG15_0__primic_to_clprim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG15_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG15_0__vertval_bits_vertex_vertex_store_msb_MASK = 0x000000ffL;
    constexpr unsigned int PA_DEBUG15_1__primic_to_clprim_fifo_vertex_store_indx_0_MASK = 0x007c0000L;
    constexpr unsigned int PA_DEBUG15_1__primic_to_clprim_fifo_vertex_store_indx_1_MASK = 0x00030000L;
    constexpr unsigned int PA_DEBUG15_1__primic_to_clprim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG15_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG15_1__vertval_bits_vertex_vertex_store_msb_MASK = 0x0000ffffL;
    constexpr unsigned int PA_DEBUG16_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG16_0__sm0_clip_to_clipga_clip_to_outsm_cnt_eq0_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG16_0__sm0_clip_to_outsm_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG16_0__sm0_clip_vert_cnt_MASK     = 0x0000001fL;
    constexpr unsigned int PA_DEBUG16_0__sm0_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG16_0__sm0_current_state_MASK     = 0x0007f000L;
    constexpr unsigned int PA_DEBUG16_0__sm0_highest_priority_seq_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG16_0__sm0_inv_to_clip_data_valid_0_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG16_0__sm0_inv_to_clip_data_valid_1_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG16_0__sm0_outputcliptoga_0_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG16_0__sm0_vertex_clip_cnt_MASK   = 0x000003e0L;
    constexpr unsigned int PA_DEBUG16_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG16_1__sm0_clip_to_clipga_clip_to_outsm_cnt_eq0_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG16_1__sm0_clip_to_outsm_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG16_1__sm0_clip_vert_cnt_MASK     = 0x00001f00L;
    constexpr unsigned int PA_DEBUG16_1__sm0_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG16_1__sm0_current_state_MASK     = 0x00070000L;
    constexpr unsigned int PA_DEBUG16_1__sm0_highest_priority_seq_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG16_1__sm0_outputcliptoga_0_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG16_1__sm0_prim_end_state_MASK    = 0x0000007fL;
    constexpr unsigned int PA_DEBUG16_1__sm0_ps_expand_MASK         = 0x00000080L;
    constexpr unsigned int PA_DEBUG16_1__sm0_vertex_clip_cnt_MASK   = 0x0000e000L;
    constexpr unsigned int PA_DEBUG17_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG17_0__sm1_clip_to_clipga_clip_to_outsm_cnt_eq0_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG17_0__sm1_clip_to_outsm_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG17_0__sm1_clip_vert_cnt_MASK     = 0x0000001fL;
    constexpr unsigned int PA_DEBUG17_0__sm1_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG17_0__sm1_current_state_MASK     = 0x0007f000L;
    constexpr unsigned int PA_DEBUG17_0__sm1_highest_priority_seq_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG17_0__sm1_inv_to_clip_data_valid_0_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG17_0__sm1_inv_to_clip_data_valid_1_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG17_0__sm1_outputcliptoga_0_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG17_0__sm1_vertex_clip_cnt_MASK   = 0x000003e0L;
    constexpr unsigned int PA_DEBUG17_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG17_1__sm1_clip_to_clipga_clip_to_outsm_cnt_eq0_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG17_1__sm1_clip_to_outsm_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG17_1__sm1_clip_vert_cnt_MASK     = 0x00001f00L;
    constexpr unsigned int PA_DEBUG17_1__sm1_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG17_1__sm1_current_state_MASK     = 0x00070000L;
    constexpr unsigned int PA_DEBUG17_1__sm1_highest_priority_seq_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG17_1__sm1_outputcliptoga_0_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG17_1__sm1_prim_end_state_MASK    = 0x0000007fL;
    constexpr unsigned int PA_DEBUG17_1__sm1_ps_expand_MASK         = 0x00000080L;
    constexpr unsigned int PA_DEBUG17_1__sm1_vertex_clip_cnt_MASK   = 0x0000e000L;
    constexpr unsigned int PA_DEBUG18_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG18_0__sm2_clip_to_clipga_clip_to_outsm_cnt_eq0_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG18_0__sm2_clip_to_outsm_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG18_0__sm2_clip_vert_cnt_MASK     = 0x0000001fL;
    constexpr unsigned int PA_DEBUG18_0__sm2_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG18_0__sm2_current_state_MASK     = 0x0007f000L;
    constexpr unsigned int PA_DEBUG18_0__sm2_highest_priority_seq_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG18_0__sm2_inv_to_clip_data_valid_0_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG18_0__sm2_inv_to_clip_data_valid_1_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG18_0__sm2_outputcliptoga_0_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG18_0__sm2_vertex_clip_cnt_MASK   = 0x000003e0L;
    constexpr unsigned int PA_DEBUG18_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG18_1__sm2_clip_to_clipga_clip_to_outsm_cnt_eq0_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG18_1__sm2_clip_to_outsm_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG18_1__sm2_clip_vert_cnt_MASK     = 0x00001f00L;
    constexpr unsigned int PA_DEBUG18_1__sm2_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG18_1__sm2_current_state_MASK     = 0x00070000L;
    constexpr unsigned int PA_DEBUG18_1__sm2_highest_priority_seq_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG18_1__sm2_outputcliptoga_0_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG18_1__sm2_prim_end_state_MASK    = 0x0000007fL;
    constexpr unsigned int PA_DEBUG18_1__sm2_ps_expand_MASK         = 0x00000080L;
    constexpr unsigned int PA_DEBUG18_1__sm2_vertex_clip_cnt_MASK   = 0x0000e000L;
    constexpr unsigned int PA_DEBUG19_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG19_0__sm3_clip_to_clipga_clip_to_outsm_cnt_eq0_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG19_0__sm3_clip_to_outsm_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG19_0__sm3_clip_vert_cnt_MASK     = 0x0000001fL;
    constexpr unsigned int PA_DEBUG19_0__sm3_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG19_0__sm3_current_state_MASK     = 0x0007f000L;
    constexpr unsigned int PA_DEBUG19_0__sm3_highest_priority_seq_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG19_0__sm3_inv_to_clip_data_valid_0_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG19_0__sm3_inv_to_clip_data_valid_1_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG19_0__sm3_outputcliptoga_0_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG19_0__sm3_vertex_clip_cnt_MASK   = 0x000003e0L;
    constexpr unsigned int PA_DEBUG19_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG19_1__sm3_clip_to_clipga_clip_to_outsm_cnt_eq0_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG19_1__sm3_clip_to_outsm_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG19_1__sm3_clip_vert_cnt_MASK     = 0x00001f00L;
    constexpr unsigned int PA_DEBUG19_1__sm3_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG19_1__sm3_current_state_MASK     = 0x00070000L;
    constexpr unsigned int PA_DEBUG19_1__sm3_highest_priority_seq_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG19_1__sm3_outputcliptoga_0_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG19_1__sm3_prim_end_state_MASK    = 0x0000007fL;
    constexpr unsigned int PA_DEBUG19_1__sm3_ps_expand_MASK         = 0x00000080L;
    constexpr unsigned int PA_DEBUG19_1__sm3_vertex_clip_cnt_MASK   = 0x0000e000L;
    constexpr unsigned int PA_DEBUG20_0__point_address_MASK         = 0x00000001L;
    constexpr unsigned int PA_DEBUG20_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_advance_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_aux_inc_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_aux_sel_MASK = 0x000c0000L;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_pci_MASK     = 0x0003ff00L;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_req_mask_MASK = 0x000000f0L;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_sp_id_MASK   = 0x00300000L;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_state_var_indx_MASK = 0x0000000eL;
    constexpr unsigned int PA_DEBUG20_1__point_address_MASK         = 0x000001c0L;
    constexpr unsigned int PA_DEBUG20_1__position_address_MASK      = 0x0000003fL;
    constexpr unsigned int PA_DEBUG20_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_advance_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_aux_inc_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_aux_sel_MASK = 0x000c0000L;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_pci_MASK     = 0x00030000L;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_req_mask_MASK = 0x0000f000L;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_sp_id_MASK   = 0x00300000L;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_state_var_indx_MASK = 0x00000e00L;
    constexpr unsigned int PA_DEBUG21_0__aux_sel_MASK               = 0x00003000L;
    constexpr unsigned int PA_DEBUG21_0__pasx_req_cnt_0_MASK        = 0x00f00000L;
    constexpr unsigned int PA_DEBUG21_0__pasx_req_cnt_1_MASK        = 0x000f0000L;
    constexpr unsigned int PA_DEBUG21_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG21_0__statevar_bits_disable_sp_MASK = 0x00000f00L;
    constexpr unsigned int PA_DEBUG21_0__statevar_bits_vs_out_misc_vec_ena_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG21_0__sx_pending_fifo_contents_MASK = 0x0000007cL;
    constexpr unsigned int PA_DEBUG21_0__sx_receive_indx_MASK       = 0x00000003L;
    constexpr unsigned int PA_DEBUG21_0__sx_to_pa_empty_0_MASK      = 0x00008000L;
    constexpr unsigned int PA_DEBUG21_0__sx_to_pa_empty_1_MASK      = 0x00004000L;
    constexpr unsigned int PA_DEBUG21_1__available_positions_MASK   = 0x0000007fL;
    constexpr unsigned int PA_DEBUG21_1__pasx_req_cnt_0_MASK        = 0x00f00000L;
    constexpr unsigned int PA_DEBUG21_1__pasx_req_cnt_1_MASK        = 0x000f0000L;
    constexpr unsigned int PA_DEBUG21_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG21_1__statevar_bits_vs_out_misc_vec_ena_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG21_1__sx_pending_fifo_contents_MASK = 0x00007c00L;
    constexpr unsigned int PA_DEBUG21_1__sx_receive_indx_MASK       = 0x00000380L;
    constexpr unsigned int PA_DEBUG22_0__req_active_verts_loaded_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG22_0__req_active_verts_MASK      = 0x00007f00L;
    constexpr unsigned int PA_DEBUG22_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG22_0__su_aux_MASK                = 0x00000001L;
    constexpr unsigned int PA_DEBUG22_0__sx_request_indx_MASK       = 0x0000007eL;
    constexpr unsigned int PA_DEBUG22_0__vgt_to_ccgen_active_verts_MASK = 0x00fc0000L;
    constexpr unsigned int PA_DEBUG22_0__vgt_to_ccgen_state_var_indx_MASK = 0x00038000L;
    constexpr unsigned int PA_DEBUG22_1__param_cache_base_MASK      = 0x0000007fL;
    constexpr unsigned int PA_DEBUG22_1__req_active_verts_loaded_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG22_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG22_1__su_aux_MASK                = 0x00000180L;
    constexpr unsigned int PA_DEBUG22_1__sx_request_indx_MASK       = 0x00007e00L;
    constexpr unsigned int PA_DEBUG22_1__vgt_to_ccgen_active_verts_MASK = 0x00fc0000L;
    constexpr unsigned int PA_DEBUG22_1__vgt_to_ccgen_state_var_indx_MASK = 0x00030000L;
    constexpr unsigned int PA_DEBUG23_0__ALWAYS_ZERO_MASK           = 0x000000c0L;
    constexpr unsigned int PA_DEBUG23_0__event_id_gated_1to0_MASK   = 0x00c00000L;
    constexpr unsigned int PA_DEBUG23_0__geom_busy_MASK             = 0x00200000L;
    constexpr unsigned int PA_DEBUG23_0__geom_enable_MASK           = 0x00008000L;
    constexpr unsigned int PA_DEBUG23_0__ge_stallb_MASK             = 0x00004000L;
    constexpr unsigned int PA_DEBUG23_0__pfifo_busy_MASK            = 0x00080000L;
    constexpr unsigned int PA_DEBUG23_0__pmode_state_MASK           = 0x00003f00L;
    constexpr unsigned int PA_DEBUG23_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG23_0__su_baryc_cntl_state_MASK   = 0x00000003L;
    constexpr unsigned int PA_DEBUG23_0__su_clip_baryc_free_MASK    = 0x00030000L;
    constexpr unsigned int PA_DEBUG23_0__su_clip_rtr_MASK           = 0x00040000L;
    constexpr unsigned int PA_DEBUG23_0__su_cntl_busy_MASK          = 0x00100000L;
    constexpr unsigned int PA_DEBUG23_0__su_cntl_state_MASK         = 0x0000003cL;
    constexpr unsigned int PA_DEBUG24_0__cl_dyn_sclk_vld_MASK       = 0x00000080L;
    constexpr unsigned int PA_DEBUG24_0__event_gated_MASK           = 0x00000010L;
    constexpr unsigned int PA_DEBUG24_0__event_id_gated_5to2_MASK   = 0x0000000fL;
    constexpr unsigned int PA_DEBUG24_0__pmode_prim_gated_MASK      = 0x00000020L;
    constexpr unsigned int PA_DEBUG24_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG24_0__su_dyn_sclk_vld_MASK       = 0x00000040L;
    constexpr unsigned int PA_DEBUG24_0__y_sort0_gated_23_8_MASK    = 0x00ffff00L;
    constexpr unsigned int PA_DEBUG25_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG25_0__x_sort0_gated_23_8_MASK    = 0x0000ffffL;
    constexpr unsigned int PA_DEBUG25_0__y_sort1_gated_15_8_MASK    = 0x00ff0000L;
    constexpr unsigned int PA_DEBUG26_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG26_0__x_sort1_gated_23_8_MASK    = 0x00ffff00L;
    constexpr unsigned int PA_DEBUG26_0__y_sort1_gated_23_16_MASK   = 0x000000ffL;
    constexpr unsigned int PA_DEBUG27_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG27_0__x_sort2_gated_15_8_MASK    = 0x00ff0000L;
    constexpr unsigned int PA_DEBUG27_0__y_sort2_gated_23_8_MASK    = 0x0000ffffL;
    constexpr unsigned int PA_DEBUG28_0__attr_indx_sort0_gated_MASK = 0x003fff00L;
    constexpr unsigned int PA_DEBUG28_0__backfacing_gated_MASK      = 0x00800000L;
    constexpr unsigned int PA_DEBUG28_0__null_prim_gated_MASK       = 0x00400000L;
    constexpr unsigned int PA_DEBUG28_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG28_0__x_sort2_gated_23to16_MASK  = 0x000000ffL;
    constexpr unsigned int PA_DEBUG29_0__attr_indx_sort2_gated_7to0_MASK = 0x00ff0000L;
    constexpr unsigned int PA_DEBUG29_0__clipped_gated_MASK         = 0x00000008L;
    constexpr unsigned int PA_DEBUG29_0__dealloc_slot_gated_MASK    = 0x00000070L;
    constexpr unsigned int PA_DEBUG29_0__diamond_rule_gated_MASK    = 0x00000300L;
    constexpr unsigned int PA_DEBUG29_0__eop_gated_MASK             = 0x00008000L;
    constexpr unsigned int PA_DEBUG29_0__fpov_gated_MASK            = 0x00006000L;
    constexpr unsigned int PA_DEBUG29_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG29_0__st_indx_gated_MASK         = 0x00000007L;
    constexpr unsigned int PA_DEBUG29_0__type_gated_MASK            = 0x00001c00L;
    constexpr unsigned int PA_DEBUG29_0__xmajor_gated_MASK          = 0x00000080L;
    constexpr unsigned int PA_DEBUG30_0__attr_indx_sort1_gated_MASK = 0x000fffc0L;
    constexpr unsigned int PA_DEBUG30_0__attr_indx_sort2_gated_13to8_MASK = 0x0000003fL;
    constexpr unsigned int PA_DEBUG30_0__pa_reg_sclk_vld_MASK       = 0x00800000L;
    constexpr unsigned int PA_DEBUG30_0__provoking_vtx_gated_MASK   = 0x00300000L;
    constexpr unsigned int PA_DEBUG30_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG30_0__valid_prim_gated_MASK      = 0x00400000L;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm0_clprim_to_clip_prim_valid_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm1_clprim_to_clip_prim_valid_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm2_clprim_to_clip_prim_valid_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm3_clprim_to_clip_prim_valid_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm_clip_to_outsm_fifo_write_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_outsm_clr_fifo_not_empty_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_primic_to_clprim_valid_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_MASK          = 0x00000100L;
    constexpr unsigned int PA_DEBUG31_0__PA0_SC0_send_q_MASK        = 0x00000008L;
    constexpr unsigned int PA_DEBUG31_0__PA0_SC1_send_q_MASK        = 0x00000010L;
    constexpr unsigned int PA_DEBUG31_0__PA_PA_pascDataOut_send0_q_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG31_0__PA_PA_pascDataOut_send1_q_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG31_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_geom_busy_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_hold_busy_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_pfifo_busy_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_su_cntl_busy_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_valid_prim_gated_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG31_0__su_busy_MASK               = 0x00000200L;
    constexpr unsigned int PA_DEBUG31_0__VGT_PA_clipp_send_q_MASK   = 0x00000004L;
    constexpr unsigned int PA_DEBUG31_0__VGT_PA_clips_send_q_MASK   = 0x00000002L;
    constexpr unsigned int PA_DEBUG31_0__VGT_PA_clipv_send_q_MASK   = 0x00000001L;
    constexpr unsigned int PA_DEBUG31_0__vte_busy_debug_ib_busy_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG31_0__vte_busy_debug_veu_busy_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG31_0__vte_busy_MASK              = 0x00000080L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_ccgen_to_clipcc_fifo_busy_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_ccgen_to_clipcc_fifo_write_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipcode_fifo_fifo_busy_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipcode_fifo_fifo_write_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipsm0_current_state_not_empty_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipsm1_current_state_not_empty_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipsm2_current_state_not_empty_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipsm3_current_state_not_empty_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clip_to_ga_bc_busy_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clip_to_ga_fifo_write_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clip_to_outsm_fifo_busy_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clip_to_outsm_fifo_write_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_next_prim_back_valid_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_primic_to_clprim_fifo_not_empty_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_primic_to_clprim_fifo_write_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_prim_back_valid_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_sx_pending_fifo_not_empty_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vgt_to_clipp_fifo_busy_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vgt_to_clipp_fifo_write_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vgt_to_clips_fifo_busy_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vte_out_clip_fifo_fifo_busy_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vte_out_clip_fifo_fifo_write_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vte_out_orig_fifo_fifo_busy_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vte_out_orig_fifo_fifo_write_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG32_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG33_0__clipper_busy_debug_vgt_to_clips_fifo_write_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG33_0__PA_SE3SC_freeze_MASK       = 0x00000010L;
    constexpr unsigned int PA_DEBUG33_0__Reserved0_MASK             = 0xffffffe0L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_busy_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_rtr_in_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_rtr_out_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_rts_in_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_rts_out_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_iclient_send_valid_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_iutcl1_send_ready_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_oclient_send_ready_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_outcl1_send_type_MASK = 0x00600000L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_outcl1_send_valid_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_outcl1_send_vmid_MASK = 0x001e0000L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_tag_MASK = 0x000000ffL;
    constexpr unsigned int PA_DEBUG34_0__Reserved0_MASK             = 0xff800000L;
    constexpr unsigned int PA_DEBUG34_1__ngg_utcl1_debug00_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_busy_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_empty_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_full_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_read_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_write_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_iclient_send_valid_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_iutcl1_send_ready_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_oclient_send_ready_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_outcl1_send_type_MASK = 0x00600000L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_outcl1_send_valid_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_outcl1_send_vmid_MASK = 0x001e0000L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_tag_MASK = 0x000000ffL;
    constexpr unsigned int PA_DEBUG35_0__Reserved0_MASK             = 0xff800000L;
    constexpr unsigned int PA_DEBUG35_1__ngg_utcl1_debug01_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_busy_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_empty_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_full_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_read_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_write_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_iclient_send_valid_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_iutcl1_send_ready_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_oclient_send_ready_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_outcl1_send_type_MASK = 0x00600000L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_outcl1_send_valid_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_outcl1_send_vmid_MASK = 0x001e0000L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_tag_MASK = 0x000000ffL;
    constexpr unsigned int PA_DEBUG36_0__Reserved0_MASK             = 0xff800000L;
    constexpr unsigned int PA_DEBUG36_1__ngg_utcl1_debug02_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_busy_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_drop_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_io_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_mtype_MASK = 0x00003800L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_perf_cntr_en_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_rd_tmz_encr_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_snoop_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_space_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_tag_MASK = 0x03fc0000L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_vmid_MASK = 0x0003c000L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_rtr_in_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_rtr_out_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_rts_in_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_rts_out_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG37_0__Reserved0_MASK             = 0xfc000000L;
    constexpr unsigned int PA_DEBUG37_1__ngg_utcl1_debug03_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_busy_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_drop_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_io_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_mtype_MASK = 0x00003800L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_perf_cntr_en_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_rd_tmz_encr_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_snoop_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_space_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_tag_MASK = 0x03fc0000L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_vmid_MASK = 0x0003c000L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_rtr_in_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_rtr_out_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_rts_in_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_rts_out_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG38_0__Reserved0_MASK             = 0xfc000000L;
    constexpr unsigned int PA_DEBUG38_1__ngg_utcl1_debug04_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_busy_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_drop_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_io_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_mtype_MASK = 0x00003800L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_perf_cntr_en_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_rd_tmz_encr_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_snoop_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_space_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_tag_MASK = 0x03fc0000L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_vmid_MASK = 0x0003c000L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_rtr_in_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_rtr_out_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_rts_in_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_rts_out_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG39_0__Reserved0_MASK             = 0xfc000000L;
    constexpr unsigned int PA_DEBUG39_1__ngg_utcl1_debug05_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG40_0__ngg_debug_tc_request_arbiter_current_client_count_MASK = 0x00000003L;
    constexpr unsigned int PA_DEBUG40_0__ngg_debug_tc_request_arbiter_istream0_client_rts_MASK = 0x80000000L;
    constexpr unsigned int PA_DEBUG40_0__ngg_debug_tc_request_arbiter_istream0_client_tag_MASK = 0x3fc00000L;
    constexpr unsigned int PA_DEBUG40_0__ngg_debug_tc_request_arbiter_ostream0_client_rtr_MASK = 0x40000000L;
    constexpr unsigned int PA_DEBUG40_1__ngg_utcl1_debug06_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_credits_MASK = 0x0000007cL;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_credit_count_overflow_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_credit_count_underflow_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_data_rd_ptr_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_data_wr_ptr_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_irdreq_free_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_irdret_vld_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_irts_in_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_obusy_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_ooutstanding_tc_requests_exist_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_ordreq_clken_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_ordreq_send_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_ortr_in_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_outstanding_tc_requests_MASK = 0x1ff80000L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_reg_valid0_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_reg_valid1_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG41_0__Reserved0_MASK             = 0xe0000000L;
    constexpr unsigned int PA_DEBUG41_1__ngg_utcl1_debug07_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_current_dword_pointer_MASK = 0x00000f00L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_current_sideband_event_bit_set_MASK = 0x01000000L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_current_sideband_is_object_id_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_current_state_MASK = 0x00000038L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_have_available_sideband_tokens_MASK = 0x02000000L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_itc_return_empty_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_pending_subgroup_count_not_zero_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_pending_subgroup_count_range_MASK = 0x0001f000L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_sideband_tokens_not_max_value_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_sideband_tokens_overflow_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_sideband_tokens_underflow_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_valid_dword_count_MASK = 0x003e0000L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_wait_counter_busy_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG42_0__Reserved0_MASK             = 0xfc000000L;
    constexpr unsigned int PA_DEBUG42_1__ngg_utcl1_debug08_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_current_state_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_osideband_active_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_ovmid_MASK = 0x0000000fL;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_sideband_pop_bit_fifo_busy_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_sideband_pop_bit_fifo_empty_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_sideband_pop_bit_fifo_full_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_vmid_fifo_busy_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_vmid_fifo_empty_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_vmid_fifo_full_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG43_0__Reserved0_MASK             = 0xfffff000L;
    constexpr unsigned int PA_DEBUG43_1__ngg_utcl1_debug09_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents0_MASK = 0x00000ff0L;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents0_overflow_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents0_underflow_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents1_MASK = 0x000ff000L;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents1_overflow_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents1_underflow_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG44_0__Reserved0_MASK             = 0xfff00000L;
    constexpr unsigned int PA_DEBUG44_1__ngg_utcl1_debug10_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_current_fetch_state_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_current_receive_finalt_dword_pointer_MASK = 0x07800000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_current_receive_first_dword_pointer_MASK = 0x00780000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_current_receive_state_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_final_receive_cacheline_this_subgroup_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_final_receive_dword_of_subgroup_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_have_available_index_tokens_MASK = 0x20000000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_receive_fifo_busy_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_receive_fifo_empty_MASK = 0x08000000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_receive_fifo_full_MASK = 0x10000000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_tokens_MASK = 0x000000fcL;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_tokens_overflow_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_tokens_underflow_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_prim_indices_fifo_busy_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_sideband_data_context_id_bits_MASK = 0x00007000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_sideband_data_eop_bit_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_sideband_data_event_bit_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG45_0__Reserved0_MASK             = 0xc0000000L;
    constexpr unsigned int PA_DEBUG45_1__ngg_utcl1_debug11_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_active_pos_req_fosg_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_another_pos_fetch_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_current_state_MASK = 0x00018000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_end_prev_diff_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_end_start_diff_MASK = 0x02000000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_have_available_position_tokens_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_ifetch_to_primic_p_fifo_full_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_ifetch_to_primic_s_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_ipa_to_wd_dealloc_index_full_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_iposreq_to_posrtn_s_fifo_full_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_iposreq_to_posrtn_v_fifo_full_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_packer_object_id_valid_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_packer_sideband_valid_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_position_tokens_overflow_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_position_tokens_underflow_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_prev_pos_cacheline_valid_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_prev_select_end_cacheline_address_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_busy_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_final_prim_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_first_prim_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_miss_count_MASK = 0x00000180L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_null_prim_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_prim_valid_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_start_prev_diff_MASK = 0x01000000L;
    constexpr unsigned int PA_DEBUG46_0__Reserved0_MASK             = 0xfc000000L;
    constexpr unsigned int PA_DEBUG46_1__ngg_utcl1_debug12_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_current_state_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_iinput_sideband_valid_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_eop_bit_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_event_bit_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_event_id_MASK = 0x0001f800L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_event_second_cycle_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_state_id_MASK = 0x00380000L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_stream_id_MASK = 0x00000300L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_output_prim_empty_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_prim_fifo_busy_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_prim_fifo_full_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_sideband_fifo_busy_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_sideband_fifo_empty_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_sideband_fifo_full_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG47_0__Reserved0_MASK             = 0xffc00000L;
    constexpr unsigned int PA_DEBUG47_1__ngg_utcl1_debug13_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_active_pos_return_cache_pos_index_MASK = 0x0000c000L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_active_pos_return_first_vert_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_active_pos_return_state_MASK = 0x00000600L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_cache_pos_index_MASK = 0x00001800L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_ifetch_to_sxif_fifo_full_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_ipa_to_wd_dealloc_position_full_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_itc_return_empty_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_oposreq_to_posrtn_s_fifo_full_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_oposreq_to_posrtn_v_fifo_full_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_posreq_to_posrtn_s_fifo_busy_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_posreq_to_posrtn_s_fifo_empty_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_posreq_to_posrtn_v_fifo_busy_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_posreq_to_posrtn_v_fifo_empty_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG48_0__Reserved0_MASK             = 0xffff0000L;
    constexpr unsigned int PA_DEBUG48_1__ngg_utcl1_debug14_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_crawler_busy_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_memreg0_busy_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_memreg1_busy_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_memreg2_busy_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_oreturn_empty_stream0_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_oreturn_empty_stream1_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_oreturn_empty_stream2_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_return_data_read_reg_full_stream0_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_return_data_read_reg_full_stream1_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_return_data_read_reg_full_stream2_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG49_0__Reserved0_MASK             = 0xfffffc00L;
    constexpr unsigned int PA_DEBUG49_1__ngg_utcl1_debug15_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_encountered_error_writing_to_busy_location_stream0_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_encountered_error_writing_to_busy_location_stream1_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_encountered_error_writing_to_busy_location_stream2_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_memory_data_valid_stream0_count_MASK = 0x000001f8L;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_memory_data_valid_stream1_count_MASK = 0x00007e00L;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_memory_data_valid_stream2_count_MASK = 0x007f8000L;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_obusy_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG50_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG50_1__ngg_utcl1_debug16_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_amount_MASK = 0x0000ffe0L;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_fifo_busy_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_index_full_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_position_full_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_state_var_index_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_type_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_pa_to_wd_dealloc_fifo_empty_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_pa_to_wd_dealloc_fifo_read_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG51_0__Reserved0_MASK             = 0xfff00000L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_all_clean_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_current_state_MASK = 0x000e0000L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iindex_requester_idle_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iindex_utcl1_return_busy_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iindex_utcl1_send_busy_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_ioutstanding_tc_requests_exist_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iposition_requester_idle_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iposition_utcl1_return_busy_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iposition_utcl1_send_busy_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_isideband_requester_idle_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_isideband_utcl1_return_busy_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_isideband_utcl1_send_busy_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iutcl1_busy_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_oclean_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_vmid_count_MASK = 0x0000f000L;
    constexpr unsigned int PA_DEBUG52_0__Reserved0_MASK             = 0xfff00000L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_index_tokens_overflow_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_index_tokens_underflow_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_position_tokens_overflow_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_position_tokens_underflow_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sbmem_contents0_overflow_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sbmem_contents0_underflow_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sbmem_contents1_overflow_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sbmem_contents1_underflow_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sideband_tokens_overflow_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sideband_tokens_underflow_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_tc_credit_count_overflow_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_tc_credit_count_underflow_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_writing_to_busy_location_stream0_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_writing_to_busy_location_stream1_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_writing_to_busy_location_stream2_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG53_0__Reserved0_MASK             = 0xffff8000L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_index_receive_fifo_full_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_pa_to_wd_dealloc_index_full_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_pa_to_wd_dealloc_position_full_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_posreq_to_posrtn_s_fifo_full_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_posreq_to_posrtn_v_fifo_full_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_prim_fifo_full_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_prim_indices_fifo_full_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_return_data_full_stream0_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_return_data_full_stream1_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_return_data_full_stream2_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_sbmem_full_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_sideband_fifo_full_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_sideband_pop_bit_fifo_full_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_vmid_fifo_full_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG54_0__Reserved0_MASK             = 0xffffc000L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_index_receive_fifo_empty_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_pa_to_wd_dealloc_fifo_empty_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_posreq_to_posrtn_s_fifo_empty_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_posreq_to_posrtn_v_fifo_empty_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_prim_fifo_empty_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_prim_indices_fifo_empty_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_return_data_empty_stream0_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_return_data_empty_stream1_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_return_data_empty_stream2_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_sbmem_empty_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_sideband_fifo_empty_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_sideband_pop_bit_fifo_empty_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_vmid_fifo_empty_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG55_0__Reserved0_MASK             = 0xffffe000L;
    constexpr unsigned int PA_SC_ENHANCE_1__RSVD_MASK               = 0xff800000L;
    constexpr unsigned int rbuf_DEBUG_DATA__pixel_addr_mask_MASK    = 0x0001fffcL;
    constexpr unsigned int rbuf_DEBUG_DATA__Reserved0_MASK          = 0xff000000L;
    constexpr unsigned int SX_DEBUG_1__PC_CFG_MASK                  = 0x00002000L;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERFCOUNTER_SELECT2_MASK = 0x000003ffL;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERFCOUNTER_SELECT3_MASK = 0x000ffc00L;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERFCOUNTER_SELECT1_MASK = 0x000ffc00L;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERFCOUNTER_SELECT_MASK = 0x000003ffL;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERFCOUNTER_SELECT2_MASK = 0x000003ffL;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERFCOUNTER_SELECT3_MASK = 0x000ffc00L;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERFCOUNTER_SELECT1_MASK = 0x000ffc00L;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERFCOUNTER_SELECT_MASK = 0x000003ffL;
    constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERFCOUNTER_SELECT1_MASK = 0x000ffc00L;
    constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERFCOUNTER_SELECT_MASK = 0x000003ffL;
    constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERFCOUNTER_SELECT1_MASK = 0x000ffc00L;
    constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERFCOUNTER_SELECT_MASK = 0x000003ffL;
    constexpr unsigned int TA_PERFCOUNTER1_SELECT__PERF_MODE1_MASK  = 0x0f000000L;
    constexpr unsigned int TA_PERFCOUNTER1_SELECT__PERF_SEL1_MASK   = 0x0003fc00L;
    constexpr unsigned int TD_PERFCOUNTER1_SELECT__PERF_MODE1_MASK  = 0x0f000000L;
    constexpr unsigned int TD_PERFCOUNTER1_SELECT__PERF_SEL1_MASK   = 0x0003fc00L;
    constexpr unsigned int VGT_SHADER_STAGES_EN__GS_FAST_LAUNCH_MASK = 0x00080000L;
    constexpr unsigned int wbuf_DEBUG_DATA__cstate_3to0_MASK        = 0x0001e000L;
    constexpr unsigned int wbuf_DEBUG_DATA__Reserved0_MASK          = 0x0000003fL;
    constexpr unsigned int wbuf_DEBUG_DATA__Reserved1_MASK          = 0xffc00000L;
    constexpr unsigned int wbuf_DEBUG_DATA__wr_pixel_ptr_nxt_MASK   = 0x00000f80L;
    constexpr unsigned int WD_DEBUG_REG0__SPARE2_MASK               = 0x00001000L;
} // namespace Gfx09_0

namespace Gfx09_1x
{
    constexpr unsigned int DB_DEBUG2__DISABLE_VR_OBJ_PRIM_ID_MASK   = 0x04000000L;
    constexpr unsigned int DB_DEBUG2__DISABLE_VR_PS_INVOKE_MASK     = 0x08000000L;
    constexpr unsigned int DB_DEBUG4__FULL_TILE_CACHE_EVICT_ON_HALF_FULL_MASK = 0x80000000L;
    constexpr unsigned int GC_DIDT_DROOP_CTRL1__DIDT_DROOP_DELTA_THRESHOLD_MASK = 0x00007ffeL;
    constexpr unsigned int GC_DIDT_DROOP_CTRL1__DIDT_DROOP_LEVEL_RELEASE_EN_MASK = 0x00000001L;
    constexpr unsigned int LDS_CONFIG__DISABLE_RAM_CLOCK_GATING_MASK = 0x00000004L;
    constexpr unsigned int MC_SHARED_ACTIVE_FCN_ID__VFID_MASK       = 0x0000000fL;
    constexpr unsigned int MC_SHARED_ACTIVE_FCN_ID__VF_MASK         = 0x80000000L;
    constexpr unsigned int PA_SC_ENHANCE_1__RSVD_MASK               = 0x80000000L;
    constexpr unsigned int RLC_SPM_PERFMON_SAMPLE_DELAY_MAX__PERFMON_MAX_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_PERFMON_SAMPLE_DELAY_MAX__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int SPI_DEBUG_CNTL_2__SPI_SPARE_MASK         = 0xffffffffL;
    constexpr unsigned int SX_DEBUG_1__DISABLE_SX_DB_FGCG_MASK      = 0x00002000L;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK  = 0x000003ffL;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK  = 0x000ffc00L;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERF_MODE1_MASK  = 0x0f000000L;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERF_MODE_MASK   = 0xf0000000L;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERF_SEL1_MASK   = 0x000ffc00L;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERF_SEL_MASK    = 0x000003ffL;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK  = 0x000003ffL;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK  = 0x000ffc00L;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERF_MODE1_MASK  = 0x0f000000L;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERF_MODE_MASK   = 0xf0000000L;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERF_SEL1_MASK   = 0x000ffc00L;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERF_SEL_MASK    = 0x000003ffL;
    constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERF_MODE_MASK   = 0xf0000000L;
    constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERF_SEL_MASK    = 0x000003ffL;
    constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERF_MODE_MASK   = 0xf0000000L;
    constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERF_SEL_MASK    = 0x000003ffL;
    constexpr unsigned int VGT_DEBUG_REG0__pg_busy_MASK             = 0x00000800L;
    constexpr unsigned int VGT_DEBUG_REG30__pg_busy_MASK            = 0x00000010L;
    constexpr unsigned int VGT_DEBUG_REG30__pg_noif_busy_MASK       = 0x00000020L;
    constexpr unsigned int VGT_DEBUG_REG30__pg_spi_interface_busy_MASK = 0x00000040L;
    constexpr unsigned int VGT_DEBUG_REG30__pg_te_prim_fifo_busy_MASK = 0x00000080L;
    constexpr unsigned int WD_DEBUG_REG0__wd_ngg_busy_MASK          = 0x00001000L;
    constexpr unsigned int WD_DEBUG_REG22__csbm_tcarb_tag_MASK      = 0x01ff8000L;
    constexpr unsigned int WD_DEBUG_REG22__eop_p3_MASK              = 0x04000000L;
    constexpr unsigned int WD_DEBUG_REG22__is_event_p3_MASK         = 0x02000000L;
    constexpr unsigned int WD_DEBUG_REG22__null_p3_MASK             = 0x08000000L;
    constexpr unsigned int WD_DEBUG_REG22__state_id_p3_MASK         = 0x70000000L;
    constexpr unsigned int WD_DEBUG_REG22__wd_csbm_sm_gds_data_MASK = 0x00003000L;
    constexpr unsigned int WD_DEBUG_REG22__wd_csbm_sm_spi_grant_ordered_id_MASK = 0x00000fffL;
    constexpr unsigned int WD_DEBUG_REG22__wd_ngg_csbm_dma_busy_MASK = 0x00004000L;
    constexpr unsigned int WD_DEBUG_REG22__wd_ngg_csbm_no_dma_busy_MASK = 0x80000000L;
} // namespace Gfx09_1x

namespace Gfx09_1xPlus
{
    constexpr unsigned int CB_COLOR0_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG_MASK = 0x00040000L;
    constexpr unsigned int CB_COLOR0_DCC_CONTROL__ENABLE_CONSTANT_ENCODE_REG_WRITE_MASK = 0x00080000L;
    constexpr unsigned int CB_COLOR1_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG_MASK = 0x00040000L;
    constexpr unsigned int CB_COLOR1_DCC_CONTROL__ENABLE_CONSTANT_ENCODE_REG_WRITE_MASK = 0x00080000L;
    constexpr unsigned int CB_COLOR2_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG_MASK = 0x00040000L;
    constexpr unsigned int CB_COLOR2_DCC_CONTROL__ENABLE_CONSTANT_ENCODE_REG_WRITE_MASK = 0x00080000L;
    constexpr unsigned int CB_COLOR3_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG_MASK = 0x00040000L;
    constexpr unsigned int CB_COLOR3_DCC_CONTROL__ENABLE_CONSTANT_ENCODE_REG_WRITE_MASK = 0x00080000L;
    constexpr unsigned int CB_COLOR4_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG_MASK = 0x00040000L;
    constexpr unsigned int CB_COLOR4_DCC_CONTROL__ENABLE_CONSTANT_ENCODE_REG_WRITE_MASK = 0x00080000L;
    constexpr unsigned int CB_COLOR5_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG_MASK = 0x00040000L;
    constexpr unsigned int CB_COLOR5_DCC_CONTROL__ENABLE_CONSTANT_ENCODE_REG_WRITE_MASK = 0x00080000L;
    constexpr unsigned int CB_COLOR6_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG_MASK = 0x00040000L;
    constexpr unsigned int CB_COLOR6_DCC_CONTROL__ENABLE_CONSTANT_ENCODE_REG_WRITE_MASK = 0x00080000L;
    constexpr unsigned int CB_COLOR7_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG_MASK = 0x00040000L;
    constexpr unsigned int CB_COLOR7_DCC_CONTROL__ENABLE_CONSTANT_ENCODE_REG_WRITE_MASK = 0x00080000L;
    constexpr unsigned int CB_DCC_CONFIG__DISABLE_CONSTANT_ENCODE_MASK = 0x00000080L;
    constexpr unsigned int CB_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_AC01_MASK = 0x00000100L;
    constexpr unsigned int CB_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG_MASK = 0x00000400L;
    constexpr unsigned int CB_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_SINGLE_MASK = 0x00000200L;
    constexpr unsigned int CB_DCC_CONTROL__DISABLE_ELIMFC_SKIP_OF_AC01_MASK = 0x00001000L;
    constexpr unsigned int CB_DCC_CONTROL__DISABLE_ELIMFC_SKIP_OF_SINGLE_MASK = 0x00002000L;
    constexpr unsigned int CB_DCC_CONTROL__ENABLE_ELIMFC_SKIP_OF_REG_MASK = 0x00004000L;
    constexpr unsigned int COMPUTE_DISPATCH_END__DATA_MASK          = 0xffffffffL;
    constexpr unsigned int COMPUTE_SHADER_CHKSUM__CHECKSUM_MASK     = 0xffffffffL;
    constexpr unsigned int GC_CAC_CTRL_2__GC_LCAC_ENABLE_MASK       = 0x00000004L;
    constexpr unsigned int GC_CAC_CTRL_2__SE_LCAC_ENABLE_MASK       = 0x00000008L;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int GDS_PERFCOUNTER1_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int GDS_PERFCOUNTER1_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int GDS_PERFCOUNTER1_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int GDS_PERFCOUNTER1_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int GDS_PERFCOUNTER2_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int GDS_PERFCOUNTER2_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int GDS_PERFCOUNTER2_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int GDS_PERFCOUNTER2_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int GDS_PERFCOUNTER3_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int GDS_PERFCOUNTER3_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int GDS_PERFCOUNTER3_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int GDS_PERFCOUNTER3_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int GRBM_FENCE_RANGE0__END_MASK              = 0xffff0000L;
    constexpr unsigned int GRBM_FENCE_RANGE0__START_MASK            = 0x0000ffffL;
    constexpr unsigned int GRBM_FENCE_RANGE1__END_MASK              = 0xffff0000L;
    constexpr unsigned int GRBM_FENCE_RANGE1__START_MASK            = 0x0000ffffL;
    constexpr unsigned int PA_CL_CLIP_CNTL__ZCLIP_PROG_NEAR_ENA_MASK = 0x10000000L;
    constexpr unsigned int PA_CL_ENHANCE__NO_SWITCH_TO_LEGACY_AFTER_VMID_RESET_MASK = 0x00080000L;
    constexpr unsigned int PA_CL_ENHANCE__OUTPUT_SWITCH_TO_LEGACY_EVENT_MASK = 0x00040000L;
    constexpr unsigned int PA_CL_ENHANCE__POLY_INNER_EDGE_FLAG_DISABLE_MASK = 0x00100000L;
    constexpr unsigned int PA_CL_ENHANCE__PROG_NEAR_CLIP_PLANE_ENABLE_MASK = 0x00020000L;
    constexpr unsigned int PA_CL_ENHANCE__TC_REQUEST_PERF_CNTR_ENABLE_MASK = 0x00200000L;
    constexpr unsigned int PA_CL_PROG_NEAR_CLIP_Z__DATA_REGISTER_MASK = 0xffffffffL;
    constexpr unsigned int PA_SC_BINNER_CNTL_0__FLUSH_ON_BINNING_TRANSITION_MASK = 0x10000000L;
    constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_INTF_CG_MASK    = 0x00800000L;
    constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_QUAD_PROC_FDCE_ENHANCE_MASK = 0x08000000L;
    constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_PS_PA_ARBITER_FIX_1_MASK = 0x20000000L;
    constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_PS_PA_ARBITER_FIX_MASK = 0x10000000L;
    constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SHADER_PROFILING_FOR_POWER_MASK = 0x02000000L;
    constexpr unsigned int PA_SC_ENHANCE_1__FLUSH_ON_BINNING_TRANSITION_MASK = 0x04000000L;
    constexpr unsigned int PA_SC_ENHANCE_1__IOO_DISABLE_EOP_ON_FIRST_LIVE_PRIM_HIT_MASK = 0x01000000L;
    constexpr unsigned int PA_SC_ENHANCE_1__PASS_VPZ_EVENT_TO_SPI_MASK = 0x40000000L;
    constexpr unsigned int PA_SC_LINE_CNTL__EXTRA_DX_DY_PRECISION_MASK = 0x00002000L;
    constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__SC_1XMSAA_COMPATIBLE_DISABLE_MASK = 0x00000040L;
    constexpr unsigned int RPB_RD_SWITCH_CNTL__WEIGHT_ADJUST_STEP_MASK = 0xc0000000L;
    constexpr unsigned int RPB_RD_SWITCH_CNTL__WORKLOAD_ADJUST_EN_MASK = 0x20000000L;
    constexpr unsigned int RPB_WR_SWITCH_CNTL__WEIGHT_ADJUST_STEP_MASK = 0xc0000000L;
    constexpr unsigned int RPB_WR_SWITCH_CNTL__WORKLOAD_ADJUST_EN_MASK = 0x20000000L;
    constexpr unsigned int SPI_WAVE_LIMIT_CNTL__GS_WAVE_GRAN_MASK   = 0x00000030L;
    constexpr unsigned int SPI_WAVE_LIMIT_CNTL__HS_WAVE_GRAN_MASK   = 0x000000c0L;
    constexpr unsigned int SPI_WAVE_LIMIT_CNTL__PS_WAVE_GRAN_MASK   = 0x00000003L;
    constexpr unsigned int SPI_WAVE_LIMIT_CNTL__VS_WAVE_GRAN_MASK   = 0x0000000cL;
    constexpr unsigned int VGT_SHADER_STAGES_EN__GS_FAST_LAUNCH_MASK = 0x00180000L;
} // namespace Gfx09_1xPlus

namespace Gfx10
{
    constexpr unsigned int ATC_ATS_FAULT_STATUS_INFO2__VFID_MASK    = 0x0000003eL;
    constexpr unsigned int CB_CACHE_EVICT_POINTS__CC_CACHE_EVICT_POINT_MASK = 0xff000000L;
    constexpr unsigned int CB_CACHE_EVICT_POINTS__CM_CACHE_EVICT_POINT_MASK = 0x000000ffL;
    constexpr unsigned int CB_CACHE_EVICT_POINTS__DCC_CACHE_EVICT_POINT_MASK = 0x00ff0000L;
    constexpr unsigned int CB_CACHE_EVICT_POINTS__FC_CACHE_EVICT_POINT_MASK = 0x0000ff00L;
    constexpr unsigned int CB_COLOR0_ATTRIB3__COLOR_SW_MODE_MASK    = 0x0007c000L;
    constexpr unsigned int CB_COLOR0_ATTRIB3__FMASK_SW_MODE_MASK    = 0x00f80000L;
    constexpr unsigned int CB_COLOR0_ATTRIB3__META_LINEAR_MASK      = 0x00002000L;
    constexpr unsigned int CB_COLOR0_ATTRIB3__MIP0_DEPTH_MASK       = 0x00001fffL;
    constexpr unsigned int CB_COLOR0_ATTRIB3__RESOURCE_LEVEL_MASK   = 0x38000000L;
    constexpr unsigned int CB_COLOR0_ATTRIB3__RESOURCE_TYPE_MASK    = 0x03000000L;
    constexpr unsigned int CB_COLOR0_ATTRIB__DISABLE_FMASK_NOFETCH_OPT_MASK = 0x00040000L;
    constexpr unsigned int CB_COLOR0_ATTRIB__FMASK_BANK_HEIGHT_MASK = 0x00000c00L;
    constexpr unsigned int CB_COLOR0_ATTRIB__FMASK_TILE_MODE_INDEX_MASK = 0x000003e0L;
    constexpr unsigned int CB_COLOR0_ATTRIB__LIMIT_COLOR_FETCH_TO_256B_MAX_MASK = 0x00080000L;
    constexpr unsigned int CB_COLOR0_ATTRIB__TILE_MODE_INDEX_MASK   = 0x0000001fL;
    constexpr unsigned int CB_COLOR0_CMASK_SLICE__TILE_MAX_MASK     = 0x00003fffL;
    constexpr unsigned int CB_COLOR0_DCC_CONTROL__INDEPENDENT_128B_BLOCKS_MASK = 0x00100000L;
    constexpr unsigned int CB_COLOR0_FMASK_SLICE__TILE_MAX_MASK     = 0x003fffffL;
    constexpr unsigned int CB_COLOR0_INFO__CMASK_IS_LINEAR_MASK     = 0x00080000L;
    constexpr unsigned int CB_COLOR0_INFO__LINEAR_GENERAL_MASK      = 0x00000080L;
    constexpr unsigned int CB_COLOR0_PITCH__FMASK_TILE_MAX_MASK     = 0x7ff00000L;
    constexpr unsigned int CB_COLOR0_PITCH__TILE_MAX_MASK           = 0x000007ffL;
    constexpr unsigned int CB_COLOR0_SLICE__TILE_MAX_MASK           = 0x003fffffL;
    constexpr unsigned int CB_COLOR0_VIEW__MIP_LEVEL_MASK           = 0x3c000000L;
    constexpr unsigned int CB_COLOR0_VIEW__SLICE_MAX_MASK           = 0x03ffe000L;
    constexpr unsigned int CB_COLOR0_VIEW__SLICE_START_MASK         = 0x00001fffL;
    constexpr unsigned int CB_COLOR1_ATTRIB3__COLOR_SW_MODE_MASK    = 0x0007c000L;
    constexpr unsigned int CB_COLOR1_ATTRIB3__FMASK_SW_MODE_MASK    = 0x00f80000L;
    constexpr unsigned int CB_COLOR1_ATTRIB3__META_LINEAR_MASK      = 0x00002000L;
    constexpr unsigned int CB_COLOR1_ATTRIB3__MIP0_DEPTH_MASK       = 0x00001fffL;
    constexpr unsigned int CB_COLOR1_ATTRIB3__RESOURCE_LEVEL_MASK   = 0x38000000L;
    constexpr unsigned int CB_COLOR1_ATTRIB3__RESOURCE_TYPE_MASK    = 0x03000000L;
    constexpr unsigned int CB_COLOR1_ATTRIB__DISABLE_FMASK_NOFETCH_OPT_MASK = 0x00040000L;
    constexpr unsigned int CB_COLOR1_ATTRIB__FMASK_BANK_HEIGHT_MASK = 0x00000c00L;
    constexpr unsigned int CB_COLOR1_ATTRIB__FMASK_TILE_MODE_INDEX_MASK = 0x000003e0L;
    constexpr unsigned int CB_COLOR1_ATTRIB__LIMIT_COLOR_FETCH_TO_256B_MAX_MASK = 0x00080000L;
    constexpr unsigned int CB_COLOR1_ATTRIB__TILE_MODE_INDEX_MASK   = 0x0000001fL;
    constexpr unsigned int CB_COLOR1_CMASK_SLICE__TILE_MAX_MASK     = 0x00003fffL;
    constexpr unsigned int CB_COLOR1_DCC_CONTROL__INDEPENDENT_128B_BLOCKS_MASK = 0x00100000L;
    constexpr unsigned int CB_COLOR1_FMASK_SLICE__TILE_MAX_MASK     = 0x003fffffL;
    constexpr unsigned int CB_COLOR1_INFO__CMASK_IS_LINEAR_MASK     = 0x00080000L;
    constexpr unsigned int CB_COLOR1_INFO__LINEAR_GENERAL_MASK      = 0x00000080L;
    constexpr unsigned int CB_COLOR1_PITCH__FMASK_TILE_MAX_MASK     = 0x7ff00000L;
    constexpr unsigned int CB_COLOR1_PITCH__TILE_MAX_MASK           = 0x000007ffL;
    constexpr unsigned int CB_COLOR1_SLICE__TILE_MAX_MASK           = 0x003fffffL;
    constexpr unsigned int CB_COLOR1_VIEW__MIP_LEVEL_MASK           = 0x3c000000L;
    constexpr unsigned int CB_COLOR1_VIEW__SLICE_MAX_MASK           = 0x03ffe000L;
    constexpr unsigned int CB_COLOR1_VIEW__SLICE_START_MASK         = 0x00001fffL;
    constexpr unsigned int CB_COLOR2_ATTRIB3__COLOR_SW_MODE_MASK    = 0x0007c000L;
    constexpr unsigned int CB_COLOR2_ATTRIB3__FMASK_SW_MODE_MASK    = 0x00f80000L;
    constexpr unsigned int CB_COLOR2_ATTRIB3__META_LINEAR_MASK      = 0x00002000L;
    constexpr unsigned int CB_COLOR2_ATTRIB3__MIP0_DEPTH_MASK       = 0x00001fffL;
    constexpr unsigned int CB_COLOR2_ATTRIB3__RESOURCE_LEVEL_MASK   = 0x38000000L;
    constexpr unsigned int CB_COLOR2_ATTRIB3__RESOURCE_TYPE_MASK    = 0x03000000L;
    constexpr unsigned int CB_COLOR2_ATTRIB__DISABLE_FMASK_NOFETCH_OPT_MASK = 0x00040000L;
    constexpr unsigned int CB_COLOR2_ATTRIB__FMASK_BANK_HEIGHT_MASK = 0x00000c00L;
    constexpr unsigned int CB_COLOR2_ATTRIB__FMASK_TILE_MODE_INDEX_MASK = 0x000003e0L;
    constexpr unsigned int CB_COLOR2_ATTRIB__LIMIT_COLOR_FETCH_TO_256B_MAX_MASK = 0x00080000L;
    constexpr unsigned int CB_COLOR2_ATTRIB__TILE_MODE_INDEX_MASK   = 0x0000001fL;
    constexpr unsigned int CB_COLOR2_CMASK_SLICE__TILE_MAX_MASK     = 0x00003fffL;
    constexpr unsigned int CB_COLOR2_DCC_CONTROL__INDEPENDENT_128B_BLOCKS_MASK = 0x00100000L;
    constexpr unsigned int CB_COLOR2_FMASK_SLICE__TILE_MAX_MASK     = 0x003fffffL;
    constexpr unsigned int CB_COLOR2_INFO__CMASK_IS_LINEAR_MASK     = 0x00080000L;
    constexpr unsigned int CB_COLOR2_INFO__LINEAR_GENERAL_MASK      = 0x00000080L;
    constexpr unsigned int CB_COLOR2_PITCH__FMASK_TILE_MAX_MASK     = 0x7ff00000L;
    constexpr unsigned int CB_COLOR2_PITCH__TILE_MAX_MASK           = 0x000007ffL;
    constexpr unsigned int CB_COLOR2_SLICE__TILE_MAX_MASK           = 0x003fffffL;
    constexpr unsigned int CB_COLOR2_VIEW__MIP_LEVEL_MASK           = 0x3c000000L;
    constexpr unsigned int CB_COLOR2_VIEW__SLICE_MAX_MASK           = 0x03ffe000L;
    constexpr unsigned int CB_COLOR2_VIEW__SLICE_START_MASK         = 0x00001fffL;
    constexpr unsigned int CB_COLOR3_ATTRIB3__COLOR_SW_MODE_MASK    = 0x0007c000L;
    constexpr unsigned int CB_COLOR3_ATTRIB3__FMASK_SW_MODE_MASK    = 0x00f80000L;
    constexpr unsigned int CB_COLOR3_ATTRIB3__META_LINEAR_MASK      = 0x00002000L;
    constexpr unsigned int CB_COLOR3_ATTRIB3__MIP0_DEPTH_MASK       = 0x00001fffL;
    constexpr unsigned int CB_COLOR3_ATTRIB3__RESOURCE_LEVEL_MASK   = 0x38000000L;
    constexpr unsigned int CB_COLOR3_ATTRIB3__RESOURCE_TYPE_MASK    = 0x03000000L;
    constexpr unsigned int CB_COLOR3_ATTRIB__DISABLE_FMASK_NOFETCH_OPT_MASK = 0x00040000L;
    constexpr unsigned int CB_COLOR3_ATTRIB__FMASK_BANK_HEIGHT_MASK = 0x00000c00L;
    constexpr unsigned int CB_COLOR3_ATTRIB__FMASK_TILE_MODE_INDEX_MASK = 0x000003e0L;
    constexpr unsigned int CB_COLOR3_ATTRIB__LIMIT_COLOR_FETCH_TO_256B_MAX_MASK = 0x00080000L;
    constexpr unsigned int CB_COLOR3_ATTRIB__TILE_MODE_INDEX_MASK   = 0x0000001fL;
    constexpr unsigned int CB_COLOR3_CMASK_SLICE__TILE_MAX_MASK     = 0x00003fffL;
    constexpr unsigned int CB_COLOR3_DCC_CONTROL__INDEPENDENT_128B_BLOCKS_MASK = 0x00100000L;
    constexpr unsigned int CB_COLOR3_FMASK_SLICE__TILE_MAX_MASK     = 0x003fffffL;
    constexpr unsigned int CB_COLOR3_INFO__CMASK_IS_LINEAR_MASK     = 0x00080000L;
    constexpr unsigned int CB_COLOR3_INFO__LINEAR_GENERAL_MASK      = 0x00000080L;
    constexpr unsigned int CB_COLOR3_PITCH__FMASK_TILE_MAX_MASK     = 0x7ff00000L;
    constexpr unsigned int CB_COLOR3_PITCH__TILE_MAX_MASK           = 0x000007ffL;
    constexpr unsigned int CB_COLOR3_SLICE__TILE_MAX_MASK           = 0x003fffffL;
    constexpr unsigned int CB_COLOR3_VIEW__MIP_LEVEL_MASK           = 0x3c000000L;
    constexpr unsigned int CB_COLOR3_VIEW__SLICE_MAX_MASK           = 0x03ffe000L;
    constexpr unsigned int CB_COLOR3_VIEW__SLICE_START_MASK         = 0x00001fffL;
    constexpr unsigned int CB_COLOR4_ATTRIB3__COLOR_SW_MODE_MASK    = 0x0007c000L;
    constexpr unsigned int CB_COLOR4_ATTRIB3__FMASK_SW_MODE_MASK    = 0x00f80000L;
    constexpr unsigned int CB_COLOR4_ATTRIB3__META_LINEAR_MASK      = 0x00002000L;
    constexpr unsigned int CB_COLOR4_ATTRIB3__MIP0_DEPTH_MASK       = 0x00001fffL;
    constexpr unsigned int CB_COLOR4_ATTRIB3__RESOURCE_LEVEL_MASK   = 0x38000000L;
    constexpr unsigned int CB_COLOR4_ATTRIB3__RESOURCE_TYPE_MASK    = 0x03000000L;
    constexpr unsigned int CB_COLOR4_ATTRIB__DISABLE_FMASK_NOFETCH_OPT_MASK = 0x00040000L;
    constexpr unsigned int CB_COLOR4_ATTRIB__FMASK_BANK_HEIGHT_MASK = 0x00000c00L;
    constexpr unsigned int CB_COLOR4_ATTRIB__FMASK_TILE_MODE_INDEX_MASK = 0x000003e0L;
    constexpr unsigned int CB_COLOR4_ATTRIB__LIMIT_COLOR_FETCH_TO_256B_MAX_MASK = 0x00080000L;
    constexpr unsigned int CB_COLOR4_ATTRIB__TILE_MODE_INDEX_MASK   = 0x0000001fL;
    constexpr unsigned int CB_COLOR4_CMASK_SLICE__TILE_MAX_MASK     = 0x00003fffL;
    constexpr unsigned int CB_COLOR4_DCC_CONTROL__INDEPENDENT_128B_BLOCKS_MASK = 0x00100000L;
    constexpr unsigned int CB_COLOR4_FMASK_SLICE__TILE_MAX_MASK     = 0x003fffffL;
    constexpr unsigned int CB_COLOR4_INFO__CMASK_IS_LINEAR_MASK     = 0x00080000L;
    constexpr unsigned int CB_COLOR4_INFO__LINEAR_GENERAL_MASK      = 0x00000080L;
    constexpr unsigned int CB_COLOR4_PITCH__FMASK_TILE_MAX_MASK     = 0x7ff00000L;
    constexpr unsigned int CB_COLOR4_PITCH__TILE_MAX_MASK           = 0x000007ffL;
    constexpr unsigned int CB_COLOR4_SLICE__TILE_MAX_MASK           = 0x003fffffL;
    constexpr unsigned int CB_COLOR4_VIEW__MIP_LEVEL_MASK           = 0x3c000000L;
    constexpr unsigned int CB_COLOR4_VIEW__SLICE_MAX_MASK           = 0x03ffe000L;
    constexpr unsigned int CB_COLOR4_VIEW__SLICE_START_MASK         = 0x00001fffL;
    constexpr unsigned int CB_COLOR5_ATTRIB3__COLOR_SW_MODE_MASK    = 0x0007c000L;
    constexpr unsigned int CB_COLOR5_ATTRIB3__FMASK_SW_MODE_MASK    = 0x00f80000L;
    constexpr unsigned int CB_COLOR5_ATTRIB3__META_LINEAR_MASK      = 0x00002000L;
    constexpr unsigned int CB_COLOR5_ATTRIB3__MIP0_DEPTH_MASK       = 0x00001fffL;
    constexpr unsigned int CB_COLOR5_ATTRIB3__RESOURCE_LEVEL_MASK   = 0x38000000L;
    constexpr unsigned int CB_COLOR5_ATTRIB3__RESOURCE_TYPE_MASK    = 0x03000000L;
    constexpr unsigned int CB_COLOR5_ATTRIB__DISABLE_FMASK_NOFETCH_OPT_MASK = 0x00040000L;
    constexpr unsigned int CB_COLOR5_ATTRIB__FMASK_BANK_HEIGHT_MASK = 0x00000c00L;
    constexpr unsigned int CB_COLOR5_ATTRIB__FMASK_TILE_MODE_INDEX_MASK = 0x000003e0L;
    constexpr unsigned int CB_COLOR5_ATTRIB__LIMIT_COLOR_FETCH_TO_256B_MAX_MASK = 0x00080000L;
    constexpr unsigned int CB_COLOR5_ATTRIB__TILE_MODE_INDEX_MASK   = 0x0000001fL;
    constexpr unsigned int CB_COLOR5_CMASK_SLICE__TILE_MAX_MASK     = 0x00003fffL;
    constexpr unsigned int CB_COLOR5_DCC_CONTROL__INDEPENDENT_128B_BLOCKS_MASK = 0x00100000L;
    constexpr unsigned int CB_COLOR5_FMASK_SLICE__TILE_MAX_MASK     = 0x003fffffL;
    constexpr unsigned int CB_COLOR5_INFO__CMASK_IS_LINEAR_MASK     = 0x00080000L;
    constexpr unsigned int CB_COLOR5_INFO__LINEAR_GENERAL_MASK      = 0x00000080L;
    constexpr unsigned int CB_COLOR5_PITCH__FMASK_TILE_MAX_MASK     = 0x7ff00000L;
    constexpr unsigned int CB_COLOR5_PITCH__TILE_MAX_MASK           = 0x000007ffL;
    constexpr unsigned int CB_COLOR5_SLICE__TILE_MAX_MASK           = 0x003fffffL;
    constexpr unsigned int CB_COLOR5_VIEW__MIP_LEVEL_MASK           = 0x3c000000L;
    constexpr unsigned int CB_COLOR5_VIEW__SLICE_MAX_MASK           = 0x03ffe000L;
    constexpr unsigned int CB_COLOR5_VIEW__SLICE_START_MASK         = 0x00001fffL;
    constexpr unsigned int CB_COLOR6_ATTRIB3__COLOR_SW_MODE_MASK    = 0x0007c000L;
    constexpr unsigned int CB_COLOR6_ATTRIB3__FMASK_SW_MODE_MASK    = 0x00f80000L;
    constexpr unsigned int CB_COLOR6_ATTRIB3__META_LINEAR_MASK      = 0x00002000L;
    constexpr unsigned int CB_COLOR6_ATTRIB3__MIP0_DEPTH_MASK       = 0x00001fffL;
    constexpr unsigned int CB_COLOR6_ATTRIB3__RESOURCE_LEVEL_MASK   = 0x38000000L;
    constexpr unsigned int CB_COLOR6_ATTRIB3__RESOURCE_TYPE_MASK    = 0x03000000L;
    constexpr unsigned int CB_COLOR6_ATTRIB__DISABLE_FMASK_NOFETCH_OPT_MASK = 0x00040000L;
    constexpr unsigned int CB_COLOR6_ATTRIB__FMASK_BANK_HEIGHT_MASK = 0x00000c00L;
    constexpr unsigned int CB_COLOR6_ATTRIB__FMASK_TILE_MODE_INDEX_MASK = 0x000003e0L;
    constexpr unsigned int CB_COLOR6_ATTRIB__LIMIT_COLOR_FETCH_TO_256B_MAX_MASK = 0x00080000L;
    constexpr unsigned int CB_COLOR6_ATTRIB__TILE_MODE_INDEX_MASK   = 0x0000001fL;
    constexpr unsigned int CB_COLOR6_CMASK_SLICE__TILE_MAX_MASK     = 0x00003fffL;
    constexpr unsigned int CB_COLOR6_DCC_CONTROL__INDEPENDENT_128B_BLOCKS_MASK = 0x00100000L;
    constexpr unsigned int CB_COLOR6_FMASK_SLICE__TILE_MAX_MASK     = 0x003fffffL;
    constexpr unsigned int CB_COLOR6_INFO__CMASK_IS_LINEAR_MASK     = 0x00080000L;
    constexpr unsigned int CB_COLOR6_INFO__LINEAR_GENERAL_MASK      = 0x00000080L;
    constexpr unsigned int CB_COLOR6_PITCH__FMASK_TILE_MAX_MASK     = 0x7ff00000L;
    constexpr unsigned int CB_COLOR6_PITCH__TILE_MAX_MASK           = 0x000007ffL;
    constexpr unsigned int CB_COLOR6_SLICE__TILE_MAX_MASK           = 0x003fffffL;
    constexpr unsigned int CB_COLOR6_VIEW__MIP_LEVEL_MASK           = 0x3c000000L;
    constexpr unsigned int CB_COLOR6_VIEW__SLICE_MAX_MASK           = 0x03ffe000L;
    constexpr unsigned int CB_COLOR6_VIEW__SLICE_START_MASK         = 0x00001fffL;
    constexpr unsigned int CB_COLOR7_ATTRIB3__COLOR_SW_MODE_MASK    = 0x0007c000L;
    constexpr unsigned int CB_COLOR7_ATTRIB3__FMASK_SW_MODE_MASK    = 0x00f80000L;
    constexpr unsigned int CB_COLOR7_ATTRIB3__META_LINEAR_MASK      = 0x00002000L;
    constexpr unsigned int CB_COLOR7_ATTRIB3__MIP0_DEPTH_MASK       = 0x00001fffL;
    constexpr unsigned int CB_COLOR7_ATTRIB3__RESOURCE_LEVEL_MASK   = 0x38000000L;
    constexpr unsigned int CB_COLOR7_ATTRIB3__RESOURCE_TYPE_MASK    = 0x03000000L;
    constexpr unsigned int CB_COLOR7_ATTRIB__DISABLE_FMASK_NOFETCH_OPT_MASK = 0x00040000L;
    constexpr unsigned int CB_COLOR7_ATTRIB__FMASK_BANK_HEIGHT_MASK = 0x00000c00L;
    constexpr unsigned int CB_COLOR7_ATTRIB__FMASK_TILE_MODE_INDEX_MASK = 0x000003e0L;
    constexpr unsigned int CB_COLOR7_ATTRIB__LIMIT_COLOR_FETCH_TO_256B_MAX_MASK = 0x00080000L;
    constexpr unsigned int CB_COLOR7_ATTRIB__TILE_MODE_INDEX_MASK   = 0x0000001fL;
    constexpr unsigned int CB_COLOR7_CMASK_SLICE__TILE_MAX_MASK     = 0x00003fffL;
    constexpr unsigned int CB_COLOR7_DCC_CONTROL__INDEPENDENT_128B_BLOCKS_MASK = 0x00100000L;
    constexpr unsigned int CB_COLOR7_FMASK_SLICE__TILE_MAX_MASK     = 0x003fffffL;
    constexpr unsigned int CB_COLOR7_INFO__CMASK_IS_LINEAR_MASK     = 0x00080000L;
    constexpr unsigned int CB_COLOR7_INFO__LINEAR_GENERAL_MASK      = 0x00000080L;
    constexpr unsigned int CB_COLOR7_PITCH__FMASK_TILE_MAX_MASK     = 0x7ff00000L;
    constexpr unsigned int CB_COLOR7_PITCH__TILE_MAX_MASK           = 0x000007ffL;
    constexpr unsigned int CB_COLOR7_SLICE__TILE_MAX_MASK           = 0x003fffffL;
    constexpr unsigned int CB_COLOR7_VIEW__MIP_LEVEL_MASK           = 0x3c000000L;
    constexpr unsigned int CB_COLOR7_VIEW__SLICE_MAX_MASK           = 0x03ffe000L;
    constexpr unsigned int CB_COLOR7_VIEW__SLICE_START_MASK         = 0x00001fffL;
    constexpr unsigned int CB_COVERAGE_OUT_CONTROL__COVERAGE_OUT_CHANNEL_MASK = 0x00000030L;
    constexpr unsigned int CB_COVERAGE_OUT_CONTROL__COVERAGE_OUT_ENABLE_MASK = 0x00000001L;
    constexpr unsigned int CB_COVERAGE_OUT_CONTROL__COVERAGE_OUT_MRT_MASK = 0x0000000eL;
    constexpr unsigned int CB_COVERAGE_OUT_CONTROL__COVERAGE_OUT_SAMPLES_MASK = 0x00000f00L;
    constexpr unsigned int CB_DCC_CONFIG__READ_RETURN_SKID_FIFO_DEPTH_MASK = 0x01ff0000L;
    constexpr unsigned int CB_HW_CONTROL_2__CHICKEN_BITS_MASK       = 0xc0000000L;
    constexpr unsigned int CB_HW_CONTROL_2__DRR_ASSUMED_FIFO_DEPTH_DIV8_MASK = 0x3f000000L;
    constexpr unsigned int CB_HW_CONTROL_3__DISABLE_FMASK_NOFETCH_OPT_BC_MASK = 0x80000000L;
    constexpr unsigned int CB_HW_CONTROL_3__DISABLE_FMASK_NOFETCH_OPT_MASK = 0x40000000L;
    constexpr unsigned int CB_HW_CONTROL_4__COLOR_CACHE_FETCH_NUM_CLS_LOG2_MASK = 0x00000007L;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_BC_COLOR_CACHE_PREFETCH_MASK = 0x00004000L;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_CMASK_CLOCK_GATING_MASK = 0x00000040L;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_COLOR_CLOCK_GATING_MASK = 0x00000100L;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_FMASK_CLOCK_GATING_MASK = 0x00000080L;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_KEYXFR_HIT_RETURNS_MASK = 0x00002000L;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_MA_WAIT_FOR_LAST_MASK = 0x00008000L;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_QSB_AA_MODE_MASK = 0x00000200L;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_QSB_FRAG_GT0_MASK = 0x00000800L;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_QSB_SPECULATIVE_MASK = 0x00010000L;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_QSB_WAIT_FOR_SCORE_MASK = 0x00000400L;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_USE_OF_QUAD_SCOREBOARD_MASK = 0x00000020L;
    constexpr unsigned int CB_HW_CONTROL_4__FC_QSB_FIFO_DEPTH_MASK  = 0xff000000L;
    constexpr unsigned int CB_HW_CONTROL_4__FMASK_CACHE_FETCH_NUM_CLS_LOG2_MASK = 0x00000018L;
    constexpr unsigned int CB_HW_CONTROL_4__QSB_WAIT_FOR_SCORE_MASK = 0x003e0000L;
    constexpr unsigned int CB_HW_CONTROL_4__REVERSE_KEYXFR_RD_PRIORITY_MASK = 0x00001000L;
    constexpr unsigned int CB_HW_CONTROL__ALLOW_MRT_WITH_DUAL_SOURCE_MASK = 0x00000001L;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__CMASK_RD_POLICY_MASK = 0x00030000L;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__CMASK_WR_POLICY_MASK = 0x00000003L;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__COLOR_RD_POLICY_MASK = 0x00c00000L;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__COLOR_WR_POLICY_MASK = 0x000000c0L;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__DCC_RD_POLICY_MASK = 0x00300000L;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__DCC_WR_POLICY_MASK = 0x00000030L;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__FMASK_RD_POLICY_MASK = 0x000c0000L;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__FMASK_WR_POLICY_MASK = 0x0000000cL;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__VOLAT_MASK  = 0x80000000L;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__CMASK_RD_POLICY_MASK = 0x00030000L;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__CMASK_WR_POLICY_MASK = 0x00000003L;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__COLOR_RD_POLICY_MASK = 0x00c00000L;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__COLOR_WR_POLICY_MASK = 0x000000c0L;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__DCC_RD_POLICY_MASK = 0x00300000L;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__DCC_WR_POLICY_MASK = 0x00000030L;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__FMASK_RD_POLICY_MASK = 0x000c0000L;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__FMASK_WR_POLICY_MASK = 0x0000000cL;
    constexpr unsigned int CB_STUTTER_CONTROL_CMASK_RDLAT__THRESHOLD_MASK = 0x000000ffL;
    constexpr unsigned int CB_STUTTER_CONTROL_CMASK_RDLAT__TIMEOUT_MASK = 0x0000ff00L;
    constexpr unsigned int CB_STUTTER_CONTROL_COLOR_RDLAT__THRESHOLD_MASK = 0x000000ffL;
    constexpr unsigned int CB_STUTTER_CONTROL_COLOR_RDLAT__TIMEOUT_MASK = 0x0000ff00L;
    constexpr unsigned int CB_STUTTER_CONTROL_FMASK_RDLAT__THRESHOLD_MASK = 0x000000ffL;
    constexpr unsigned int CB_STUTTER_CONTROL_FMASK_RDLAT__TIMEOUT_MASK = 0x0000ff00L;
    constexpr unsigned int CC_RMI_REDUNDANCY__REPAIR_EN_IN_0_MASK   = 0x00000002L;
    constexpr unsigned int CC_RMI_REDUNDANCY__REPAIR_EN_IN_1_MASK   = 0x00000004L;
    constexpr unsigned int CC_RMI_REDUNDANCY__REPAIR_ID_SWAP_MASK   = 0x00000010L;
    constexpr unsigned int CC_RMI_REDUNDANCY__REPAIR_RMI_OVERRIDE_MASK = 0x00000008L;
    constexpr unsigned int CHA_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int CHA_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0x0f000000L;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0xf0000000L;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int CHA_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int CHA_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int CHA_PERFCOUNTER1_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
    constexpr unsigned int CHA_PERFCOUNTER1_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int CHA_PERFCOUNTER1_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int CHA_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int CHA_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int CHA_PERFCOUNTER2_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
    constexpr unsigned int CHA_PERFCOUNTER2_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int CHA_PERFCOUNTER2_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int CHA_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int CHA_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int CHA_PERFCOUNTER3_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
    constexpr unsigned int CHA_PERFCOUNTER3_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int CHA_PERFCOUNTER3_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int CHC_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int CHC_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0x0f000000L;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0xf0000000L;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int CHC_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int CHC_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int CHC_PERFCOUNTER1_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
    constexpr unsigned int CHC_PERFCOUNTER1_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int CHC_PERFCOUNTER1_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int CHC_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int CHC_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int CHC_PERFCOUNTER2_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
    constexpr unsigned int CHC_PERFCOUNTER2_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int CHC_PERFCOUNTER2_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int CHC_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int CHC_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int CHC_PERFCOUNTER3_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
    constexpr unsigned int CHC_PERFCOUNTER3_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int CHC_PERFCOUNTER3_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int CH_ARB_STATUS__REQ_ARB_BUSY_MASK         = 0x00000001L;
    constexpr unsigned int CH_ARB_STATUS__RET_ARB_BUSY_MASK         = 0x00000002L;
    constexpr unsigned int CH_DRAM_BURST_CTRL__BURST_DISABLE_MASK   = 0x00000008L;
    constexpr unsigned int CH_DRAM_BURST_CTRL__GATHER_64B_IO_BURST_DISABLE_MASK = 0x00000020L;
    constexpr unsigned int CH_DRAM_BURST_CTRL__GATHER_64B_MEMORY_BURST_DISABLE_MASK = 0x00000010L;
    constexpr unsigned int CH_DRAM_BURST_CTRL__MAX_DRAM_BURST_MASK  = 0x00000007L;
    constexpr unsigned int CH_DRAM_BURST_MASK__DRAM_BURST_ADDR_MASK_MASK = 0x000000ffL;
    constexpr unsigned int CH_PIPE_STEER__PIPE0_MASK                = 0x00000003L;
    constexpr unsigned int CH_PIPE_STEER__PIPE1_MASK                = 0x0000000cL;
    constexpr unsigned int CH_PIPE_STEER__PIPE2_MASK                = 0x00000030L;
    constexpr unsigned int CH_PIPE_STEER__PIPE3_MASK                = 0x000000c0L;
    constexpr unsigned int COMPUTE_DDID_INDEX__INDEX_MASK           = 0x000007ffL;
    constexpr unsigned int COMPUTE_DESTINATION_EN_SE0__CU_EN_MASK   = 0xffffffffL;
    constexpr unsigned int COMPUTE_DESTINATION_EN_SE1__CU_EN_MASK   = 0xffffffffL;
    constexpr unsigned int COMPUTE_DESTINATION_EN_SE2__CU_EN_MASK   = 0xffffffffL;
    constexpr unsigned int COMPUTE_DESTINATION_EN_SE3__CU_EN_MASK   = 0xffffffffL;
    constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__CS_W32_EN_MASK = 0x00008000L;
    constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__TUNNEL_ENABLE_MASK = 0x00002000L;
    constexpr unsigned int COMPUTE_DISPATCH_TUNNEL__IMMEDIATE_MASK  = 0x00000400L;
    constexpr unsigned int COMPUTE_DISPATCH_TUNNEL__OFF_DELAY_MASK  = 0x000003ffL;
    constexpr unsigned int COMPUTE_PGM_RSRC1__FWD_PROGRESS_MASK     = 0x80000000L;
    constexpr unsigned int COMPUTE_PGM_RSRC1__MEM_ORDERED_MASK      = 0x40000000L;
    constexpr unsigned int COMPUTE_PGM_RSRC1__WGP_MODE_MASK         = 0x20000000L;
    constexpr unsigned int COMPUTE_PGM_RSRC3__SHARED_VGPR_CNT_MASK  = 0x0000000fL;
    constexpr unsigned int COMPUTE_REQ_CTRL__ALLOCATION_RATE_THROTTLING_THRESHOLD_MASK = 0x000e0000L;
    constexpr unsigned int COMPUTE_REQ_CTRL__DEDICATED_PREALLOCATION_BUFFER_LIMIT_MASK = 0x07f00000L;
    constexpr unsigned int COMPUTE_REQ_CTRL__GLOBAL_SCANNING_EN_MASK = 0x00010000L;
    constexpr unsigned int COMPUTE_REQ_CTRL__HARD_LOCK_HYSTERESIS_MASK = 0x00000200L;
    constexpr unsigned int COMPUTE_REQ_CTRL__HARD_LOCK_LOW_THRESHOLD_MASK = 0x00007c00L;
    constexpr unsigned int COMPUTE_REQ_CTRL__NUMBER_OF_REQUESTS_PER_CU_MASK = 0x0000001eL;
    constexpr unsigned int COMPUTE_REQ_CTRL__PRODUCER_REQUEST_LOCKOUT_MASK = 0x00008000L;
    constexpr unsigned int COMPUTE_REQ_CTRL__SOFT_GROUPING_ALLOCATION_TIMEOUT_MASK = 0x000001e0L;
    constexpr unsigned int COMPUTE_REQ_CTRL__SOFT_GROUPING_EN_MASK  = 0x00000001L;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE0__SA0_CU_EN_MASK = 0x0000ffffL;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE0__SA1_CU_EN_MASK = 0xffff0000L;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE1__SA0_CU_EN_MASK = 0x0000ffffL;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE1__SA1_CU_EN_MASK = 0xffff0000L;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE2__SA0_CU_EN_MASK = 0x0000ffffL;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE2__SA1_CU_EN_MASK = 0xffff0000L;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE3__SA0_CU_EN_MASK = 0x0000ffffL;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE3__SA1_CU_EN_MASK = 0xffff0000L;
    constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int CPC_PERFCOUNTER0_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int CPC_PERFCOUNTER0_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int CPC_PERFCOUNTER1_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int CPC_PERFCOUNTER1_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int CPF_PERFCOUNTER0_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int CPF_PERFCOUNTER0_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int CPF_PERFCOUNTER1_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int CPF_PERFCOUNTER1_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int CPG_PERFCOUNTER0_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int CPG_PERFCOUNTER0_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int CPG_PERFCOUNTER1_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int CPG_PERFCOUNTER1_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int CP_APPEND_ADDR_HI__CACHE_POLICY_MASK     = 0x06000000L;
    constexpr unsigned int CP_APPEND_CMD_ADDR_HI__ADDR_HI_MASK      = 0x0000ffffL;
    constexpr unsigned int CP_APPEND_CMD_ADDR_HI__RSVD_MASK         = 0xffff0000L;
    constexpr unsigned int CP_APPEND_CMD_ADDR_LO__ADDR_LO_MASK      = 0xfffffffcL;
    constexpr unsigned int CP_APPEND_CMD_ADDR_LO__RSVD_MASK         = 0x00000003L;
    constexpr unsigned int CP_APPEND_DATA__DATA_MASK                = 0xffffffffL;
    constexpr unsigned int CP_APPEND_DDID_CNT__DATA_MASK            = 0x000000ffL;
    constexpr unsigned int CP_APPEND_LAST_CS_FENCE__LAST_FENCE_MASK = 0xffffffffL;
    constexpr unsigned int CP_APPEND_LAST_PS_FENCE__LAST_FENCE_MASK = 0xffffffffL;
    constexpr unsigned int CP_CEQ1_AVAIL__CEQ_CNT_IB1_MASK          = 0x0fff0000L;
    constexpr unsigned int CP_CEQ1_AVAIL__CEQ_CNT_RING_MASK         = 0x00000fffL;
    constexpr unsigned int CP_CEQ2_AVAIL__CEQ_CNT_DB_MASK           = 0x0fff0000L;
    constexpr unsigned int CP_CEQ2_AVAIL__CEQ_CNT_IB2_MASK          = 0x00000fffL;
    constexpr unsigned int CP_CE_DB_BASE_HI__DB_BASE_HI_MASK        = 0x0000ffffL;
    constexpr unsigned int CP_CE_DB_BASE_LO__DB_BASE_LO_MASK        = 0xfffffffcL;
    constexpr unsigned int CP_CE_DB_BUFSZ__DB_BUFSZ_MASK            = 0x000fffffL;
    constexpr unsigned int CP_CE_DB_CMD_BUFSZ__DB_CMD_REQSZ_MASK    = 0x000fffffL;
    constexpr unsigned int CP_CE_IC_BASE_CNTL__ADDRESS_CLAMP_MASK   = 0x00000010L;
    constexpr unsigned int CP_CE_IC_BASE_CNTL__CACHE_POLICY_MASK    = 0x03000000L;
    constexpr unsigned int CP_CE_IC_BASE_CNTL__EXE_DISABLE_MASK     = 0x00800000L;
    constexpr unsigned int CP_CE_IC_BASE_CNTL__VMID_MASK            = 0x0000000fL;
    constexpr unsigned int CP_CE_IC_BASE_HI__IC_BASE_HI_MASK        = 0x0000ffffL;
    constexpr unsigned int CP_CE_IC_BASE_LO__IC_BASE_LO_MASK        = 0xfffff000L;
    constexpr unsigned int CP_CE_IC_OP_CNTL__ICACHE_PRIMED_MASK     = 0x00000020L;
    constexpr unsigned int CP_CE_IC_OP_CNTL__INVALIDATE_CACHE_COMPLETE_MASK = 0x00000002L;
    constexpr unsigned int CP_CE_IC_OP_CNTL__INVALIDATE_CACHE_MASK  = 0x00000001L;
    constexpr unsigned int CP_CE_IC_OP_CNTL__PRIME_ICACHE_MASK      = 0x00000010L;
    constexpr unsigned int CP_CE_INTR_ROUTINE_START__IR_START_MASK  = 0x000fffffL;
    constexpr unsigned int CP_CE_PRGRM_CNTR_START__IP_START_MASK    = 0x000fffffL;
    constexpr unsigned int CP_CE_ROQ_DB_STAT__CEQ_RPTR_DB_MASK      = 0x00000fffL;
    constexpr unsigned int CP_CE_ROQ_DB_STAT__CEQ_WPTR_DB_MASK      = 0x0fff0000L;
    constexpr unsigned int CP_CE_ROQ_IB1_STAT__CEQ_RPTR_INDIRECT1_MASK = 0x00000fffL;
    constexpr unsigned int CP_CE_ROQ_IB1_STAT__CEQ_WPTR_INDIRECT1_MASK = 0x0fff0000L;
    constexpr unsigned int CP_CE_ROQ_IB2_STAT__CEQ_RPTR_INDIRECT2_MASK = 0x00000fffL;
    constexpr unsigned int CP_CE_ROQ_IB2_STAT__CEQ_WPTR_INDIRECT2_MASK = 0x0fff0000L;
    constexpr unsigned int CP_CE_ROQ_RB_STAT__CEQ_RPTR_PRIMARY_MASK = 0x00000fffL;
    constexpr unsigned int CP_CE_ROQ_RB_STAT__CEQ_WPTR_PRIMARY_MASK = 0x0fff0000L;
    constexpr unsigned int CP_CONTEXT_CNTL__ME0PIPE0_MAX_GE_CNTX_MASK = 0x00000007L;
    constexpr unsigned int CP_CONTEXT_CNTL__ME0PIPE1_MAX_GE_CNTX_MASK = 0x00070000L;
    constexpr unsigned int CP_DB_BASE_HI__DB_BASE_HI_MASK           = 0x0000ffffL;
    constexpr unsigned int CP_DB_BASE_LO__DB_BASE_LO_MASK           = 0xfffffffcL;
    constexpr unsigned int CP_DB_BUFSZ__DB_BUFSZ_MASK               = 0x000fffffL;
    constexpr unsigned int CP_DB_CMD_BUFSZ__DB_CMD_REQSZ_MASK       = 0x000fffffL;
    constexpr unsigned int CP_DDID_BASE_ADDR_HI__BASE_ADDR_HI_MASK  = 0x0000ffffL;
    constexpr unsigned int CP_DDID_BASE_ADDR_LO__BASE_ADDR_LO_MASK  = 0xffffffc0L;
    constexpr unsigned int CP_DDID_CNTL__ENABLE_MASK                = 0x80000000L;
    constexpr unsigned int CP_DDID_CNTL__MODE_MASK                  = 0x40000000L;
    constexpr unsigned int CP_DDID_CNTL__POLICY_MASK                = 0x30000000L;
    constexpr unsigned int CP_DDID_CNTL__SIZE_MASK                  = 0x00010000L;
    constexpr unsigned int CP_DDID_CNTL__THRESHOLD_MASK             = 0x000000ffL;
    constexpr unsigned int CP_DDID_CNTL__VMID_MASK                  = 0x00f00000L;
    constexpr unsigned int CP_DDID_CNTL__VMID_SEL_MASK              = 0x01000000L;
    constexpr unsigned int CP_DEBUG_2__DC_DISABLE_BROADCAST_MASK    = 0x20000000L;
    constexpr unsigned int CP_DEBUG_2__DC_FORCE_CLK_EN_MASK         = 0x10000000L;
    constexpr unsigned int CP_DEBUG_2__DC_INTERLEAVE_WG_SIZE_CNST_MASK = 0x07fe0000L;
    constexpr unsigned int CP_DEBUG_2__NOT_EOP_HW_DETECT_DISABLE_MASK = 0x40000000L;
    constexpr unsigned int CP_DEBUG_2__PFP_DDID_HW_DETECT_DISABLE_MASK = 0x80000000L;
    constexpr unsigned int CP_DFY_CNTL__MTYPE_MASK                  = 0x00007000L;
    constexpr unsigned int CP_DFY_CNTL__POLICY_MASK                 = 0x00000300L;
    constexpr unsigned int CP_DFY_CNTL__REPEATER_FGCG_DISABLE_MASK  = 0x02000000L;
    constexpr unsigned int CP_DFY_CNTL__VOL_MASK                    = 0x00000400L;
    constexpr unsigned int CP_DMA_CNTL__BUFFER_DEPTH_MASK           = 0x01ff0000L;
    constexpr unsigned int CP_DMA_CNTL__WATCH_CONTROL_MASK          = 0x00000002L;
    constexpr unsigned int CP_DMA_ME_CMD_ADDR_HI__ADDR_HI_MASK      = 0x0000ffffL;
    constexpr unsigned int CP_DMA_ME_CMD_ADDR_HI__RSVD_MASK         = 0xffff0000L;
    constexpr unsigned int CP_DMA_ME_CMD_ADDR_LO__ADDR_LO_MASK      = 0xfffffffcL;
    constexpr unsigned int CP_DMA_ME_CMD_ADDR_LO__RSVD_MASK         = 0x00000003L;
    constexpr unsigned int CP_DMA_ME_CONTROL__DST_CACHE_POLICY_MASK = 0x06000000L;
    constexpr unsigned int CP_DMA_ME_CONTROL__DST_VOLATLE_MASK      = 0x08000000L;
    constexpr unsigned int CP_DMA_ME_CONTROL__SRC_CACHE_POLICY_MASK = 0x00006000L;
    constexpr unsigned int CP_DMA_ME_CONTROL__SRC_VOLATLE_MASK      = 0x00008000L;
    constexpr unsigned int CP_DMA_PFP_CMD_ADDR_HI__ADDR_HI_MASK     = 0x0000ffffL;
    constexpr unsigned int CP_DMA_PFP_CMD_ADDR_HI__RSVD_MASK        = 0xffff0000L;
    constexpr unsigned int CP_DMA_PFP_CMD_ADDR_LO__ADDR_LO_MASK     = 0xfffffffcL;
    constexpr unsigned int CP_DMA_PFP_CMD_ADDR_LO__RSVD_MASK        = 0x00000003L;
    constexpr unsigned int CP_DMA_PFP_CONTROL__DST_CACHE_POLICY_MASK = 0x06000000L;
    constexpr unsigned int CP_DMA_PFP_CONTROL__DST_VOLATLE_MASK     = 0x08000000L;
    constexpr unsigned int CP_DMA_PFP_CONTROL__SRC_CACHE_POLICY_MASK = 0x00006000L;
    constexpr unsigned int CP_DMA_PFP_CONTROL__SRC_VOLATLE_MASK     = 0x00008000L;
    constexpr unsigned int CP_DMA_WATCH0_ADDR_HI__ADDR_HI_MASK      = 0x0000ffffL;
    constexpr unsigned int CP_DMA_WATCH0_ADDR_HI__RSVD_MASK         = 0xffff0000L;
    constexpr unsigned int CP_DMA_WATCH0_ADDR_LO__ADDR_LO_MASK      = 0xffffff80L;
    constexpr unsigned int CP_DMA_WATCH0_ADDR_LO__RSVD_MASK         = 0x0000007fL;
    constexpr unsigned int CP_DMA_WATCH0_CNTL__ANY_VMID_MASK        = 0x00000400L;
    constexpr unsigned int CP_DMA_WATCH0_CNTL__RSVD1_MASK           = 0x000000f0L;
    constexpr unsigned int CP_DMA_WATCH0_CNTL__RSVD2_MASK           = 0xfffff800L;
    constexpr unsigned int CP_DMA_WATCH0_CNTL__VMID_MASK            = 0x0000000fL;
    constexpr unsigned int CP_DMA_WATCH0_CNTL__WATCH_READS_MASK     = 0x00000100L;
    constexpr unsigned int CP_DMA_WATCH0_CNTL__WATCH_WRITES_MASK    = 0x00000200L;
    constexpr unsigned int CP_DMA_WATCH0_MASK__MASK_MASK            = 0xffffff80L;
    constexpr unsigned int CP_DMA_WATCH0_MASK__RSVD_MASK            = 0x0000007fL;
    constexpr unsigned int CP_DMA_WATCH1_ADDR_HI__ADDR_HI_MASK      = 0x0000ffffL;
    constexpr unsigned int CP_DMA_WATCH1_ADDR_HI__RSVD_MASK         = 0xffff0000L;
    constexpr unsigned int CP_DMA_WATCH1_ADDR_LO__ADDR_LO_MASK      = 0xffffff80L;
    constexpr unsigned int CP_DMA_WATCH1_ADDR_LO__RSVD_MASK         = 0x0000007fL;
    constexpr unsigned int CP_DMA_WATCH1_CNTL__ANY_VMID_MASK        = 0x00000400L;
    constexpr unsigned int CP_DMA_WATCH1_CNTL__RSVD1_MASK           = 0x000000f0L;
    constexpr unsigned int CP_DMA_WATCH1_CNTL__RSVD2_MASK           = 0xfffff800L;
    constexpr unsigned int CP_DMA_WATCH1_CNTL__VMID_MASK            = 0x0000000fL;
    constexpr unsigned int CP_DMA_WATCH1_CNTL__WATCH_READS_MASK     = 0x00000100L;
    constexpr unsigned int CP_DMA_WATCH1_CNTL__WATCH_WRITES_MASK    = 0x00000200L;
    constexpr unsigned int CP_DMA_WATCH1_MASK__MASK_MASK            = 0xffffff80L;
    constexpr unsigned int CP_DMA_WATCH1_MASK__RSVD_MASK            = 0x0000007fL;
    constexpr unsigned int CP_DMA_WATCH2_ADDR_HI__ADDR_HI_MASK      = 0x0000ffffL;
    constexpr unsigned int CP_DMA_WATCH2_ADDR_HI__RSVD_MASK         = 0xffff0000L;
    constexpr unsigned int CP_DMA_WATCH2_ADDR_LO__ADDR_LO_MASK      = 0xffffff80L;
    constexpr unsigned int CP_DMA_WATCH2_ADDR_LO__RSVD_MASK         = 0x0000007fL;
    constexpr unsigned int CP_DMA_WATCH2_CNTL__ANY_VMID_MASK        = 0x00000400L;
    constexpr unsigned int CP_DMA_WATCH2_CNTL__RSVD1_MASK           = 0x000000f0L;
    constexpr unsigned int CP_DMA_WATCH2_CNTL__RSVD2_MASK           = 0xfffff800L;
    constexpr unsigned int CP_DMA_WATCH2_CNTL__VMID_MASK            = 0x0000000fL;
    constexpr unsigned int CP_DMA_WATCH2_CNTL__WATCH_READS_MASK     = 0x00000100L;
    constexpr unsigned int CP_DMA_WATCH2_CNTL__WATCH_WRITES_MASK    = 0x00000200L;
    constexpr unsigned int CP_DMA_WATCH2_MASK__MASK_MASK            = 0xffffff80L;
    constexpr unsigned int CP_DMA_WATCH2_MASK__RSVD_MASK            = 0x0000007fL;
    constexpr unsigned int CP_DMA_WATCH3_ADDR_HI__ADDR_HI_MASK      = 0x0000ffffL;
    constexpr unsigned int CP_DMA_WATCH3_ADDR_HI__RSVD_MASK         = 0xffff0000L;
    constexpr unsigned int CP_DMA_WATCH3_ADDR_LO__ADDR_LO_MASK      = 0xffffff80L;
    constexpr unsigned int CP_DMA_WATCH3_ADDR_LO__RSVD_MASK         = 0x0000007fL;
    constexpr unsigned int CP_DMA_WATCH3_CNTL__ANY_VMID_MASK        = 0x00000400L;
    constexpr unsigned int CP_DMA_WATCH3_CNTL__RSVD1_MASK           = 0x000000f0L;
    constexpr unsigned int CP_DMA_WATCH3_CNTL__RSVD2_MASK           = 0xfffff800L;
    constexpr unsigned int CP_DMA_WATCH3_CNTL__VMID_MASK            = 0x0000000fL;
    constexpr unsigned int CP_DMA_WATCH3_CNTL__WATCH_READS_MASK     = 0x00000100L;
    constexpr unsigned int CP_DMA_WATCH3_CNTL__WATCH_WRITES_MASK    = 0x00000200L;
    constexpr unsigned int CP_DMA_WATCH3_MASK__MASK_MASK            = 0xffffff80L;
    constexpr unsigned int CP_DMA_WATCH3_MASK__RSVD_MASK            = 0x0000007fL;
    constexpr unsigned int CP_DMA_WATCH_STAT_ADDR_HI__ADDR_HI_MASK  = 0x0000ffffL;
    constexpr unsigned int CP_DMA_WATCH_STAT_ADDR_LO__ADDR_LO_MASK  = 0xfffffffcL;
    constexpr unsigned int CP_DMA_WATCH_STAT__CLIENT_ID_MASK        = 0x00000700L;
    constexpr unsigned int CP_DMA_WATCH_STAT__PIPE_MASK             = 0x00003000L;
    constexpr unsigned int CP_DMA_WATCH_STAT__RD_WR_MASK            = 0x00100000L;
    constexpr unsigned int CP_DMA_WATCH_STAT__TRAP_FLAG_MASK        = 0x80000000L;
    constexpr unsigned int CP_DMA_WATCH_STAT__VMID_MASK             = 0x0000000fL;
    constexpr unsigned int CP_DMA_WATCH_STAT__WATCH_ID_MASK         = 0x00030000L;
    constexpr unsigned int CP_EOP_DONE_EVENT_CNTL__CACHE_POLICY_MASK = 0x06000000L;
    constexpr unsigned int CP_EOP_DONE_EVENT_CNTL__EOP_VOLATILE_MASK = 0x08000000L;
    constexpr unsigned int CP_EOP_DONE_EVENT_CNTL__GCR_CNTL_MASK    = 0x00fff000L;
    constexpr unsigned int CP_FETCHER_SOURCE__ME_SRC_MASK           = 0x00000001L;
    constexpr unsigned int CP_GFX_DDID_DELTA_RPT_COUNT__COUNT_MASK  = 0x000000ffL;
    constexpr unsigned int CP_GFX_DDID_INFLIGHT_COUNT__COUNT_MASK   = 0x0000ffffL;
    constexpr unsigned int CP_GFX_DDID_RPTR__COUNT_MASK             = 0x0000ffffL;
    constexpr unsigned int CP_GFX_DDID_WPTR__COUNT_MASK             = 0x0000ffffL;
    constexpr unsigned int CP_GFX_ERROR__CE_DATA_FETCHER_UTCL1_ERROR_MASK = 0x00000020L;
    constexpr unsigned int CP_GFX_ERROR__DATA_FETCHER_UTCL1_ERROR_MASK = 0x00000040L;
    constexpr unsigned int CP_GFX_HPD_CONTROL0__PIPE_HOLDING_MASK   = 0x00000010L;
    constexpr unsigned int CP_GFX_HPD_CONTROL0__SUSPEND_ENABLE_MASK = 0x00000001L;
    constexpr unsigned int CP_GFX_HPD_OSPRE_FENCE_ADDR_HI__ADDR_HI_MASK = 0x0000ffffL;
    constexpr unsigned int CP_GFX_HPD_OSPRE_FENCE_ADDR_HI__RSVD_MASK = 0xffff0000L;
    constexpr unsigned int CP_GFX_HPD_OSPRE_FENCE_ADDR_LO__ADDR_LO_MASK = 0xfffffffcL;
    constexpr unsigned int CP_GFX_HPD_OSPRE_FENCE_DATA_HI__DATA_HI_MASK = 0xffffffffL;
    constexpr unsigned int CP_GFX_HPD_OSPRE_FENCE_DATA_LO__DATA_LO_MASK = 0xffffffffL;
    constexpr unsigned int CP_GFX_HPD_STATUS0__FORCE_QUEUE_MASK     = 0x80000000L;
    constexpr unsigned int CP_GFX_HPD_STATUS0__FORCE_QUEUE_STATE_MASK = 0x01f00000L;
    constexpr unsigned int CP_GFX_HPD_STATUS0__MAPPED_QUEUE_MASK    = 0x000000e0L;
    constexpr unsigned int CP_GFX_HPD_STATUS0__QUEUE_AVAILABLE_MASK = 0x0000ff00L;
    constexpr unsigned int CP_GFX_HPD_STATUS0__QUEUE_STATE_MASK     = 0x0000001fL;
    constexpr unsigned int CP_GFX_HPD_STATUS0__SUSPEND_REQ_MASK     = 0x10000000L;
    constexpr unsigned int CP_GFX_HQD_ACTIVE__ACTIVE_MASK           = 0x00000001L;
    constexpr unsigned int CP_GFX_HQD_BASE_HI__RB_BASE_HI_MASK      = 0x000000ffL;
    constexpr unsigned int CP_GFX_HQD_BASE__RB_BASE_MASK            = 0xffffffffL;
    constexpr unsigned int CP_GFX_HQD_CNTL__BUF_SWAP_MASK           = 0x00030000L;
    constexpr unsigned int CP_GFX_HQD_CNTL__CACHE_POLICY_MASK       = 0x03000000L;
    constexpr unsigned int CP_GFX_HQD_CNTL__MIN_AVAILSZ_MASK        = 0x00300000L;
    constexpr unsigned int CP_GFX_HQD_CNTL__MIN_IB_AVAILSZ_MASK     = 0x00c00000L;
    constexpr unsigned int CP_GFX_HQD_CNTL__RB_BLKSZ_MASK           = 0x00003f00L;
    constexpr unsigned int CP_GFX_HQD_CNTL__RB_BUFSZ_MASK           = 0x0000003fL;
    constexpr unsigned int CP_GFX_HQD_CNTL__RB_EXE_MASK             = 0x10000000L;
    constexpr unsigned int CP_GFX_HQD_CNTL__RB_NO_UPDATE_MASK       = 0x08000000L;
    constexpr unsigned int CP_GFX_HQD_CNTL__RB_RPTR_WR_ENA_MASK     = 0x80000000L;
    constexpr unsigned int CP_GFX_HQD_CNTL__RB_VOLATILE_MASK        = 0x04000000L;
    constexpr unsigned int CP_GFX_HQD_CSMD_RPTR__RB_RPTR_MASK       = 0x000fffffL;
    constexpr unsigned int CP_GFX_HQD_DEQUEUE_REQUEST__DEQUEUE_REQ_EN_MASK = 0x00000400L;
    constexpr unsigned int CP_GFX_HQD_DEQUEUE_REQUEST__DEQUEUE_REQ_MASK = 0x00000001L;
    constexpr unsigned int CP_GFX_HQD_DEQUEUE_REQUEST__IQ_REQ_PEND_EN_MASK = 0x00000200L;
    constexpr unsigned int CP_GFX_HQD_DEQUEUE_REQUEST__IQ_REQ_PEND_MASK = 0x00000010L;
    constexpr unsigned int CP_GFX_HQD_HQ_CONTROL0__COMMAND_MASK     = 0x0000000fL;
    constexpr unsigned int CP_GFX_HQD_HQ_STATUS0__DEQUEUE_STATUS_MASK = 0x00000001L;
    constexpr unsigned int CP_GFX_HQD_HQ_STATUS0__OS_PREEMPT_STATUS_MASK = 0x00000030L;
    constexpr unsigned int CP_GFX_HQD_HQ_STATUS0__PREEMPT_ACK_MASK  = 0x00000040L;
    constexpr unsigned int CP_GFX_HQD_HQ_STATUS0__QUEUE_IDLE_MASK   = 0x40000000L;
    constexpr unsigned int CP_GFX_HQD_MAPPED__MAPPED_MASK           = 0x00000001L;
    constexpr unsigned int CP_GFX_HQD_OFFSET__DISABLE_RB_OFFSET_MASK = 0x80000000L;
    constexpr unsigned int CP_GFX_HQD_OFFSET__RB_OFFSET_MASK        = 0x000fffffL;
    constexpr unsigned int CP_GFX_HQD_QUANTUM__QUANTUM_ACTIVE_MASK  = 0x80000000L;
    constexpr unsigned int CP_GFX_HQD_QUANTUM__QUANTUM_DURATION_MASK = 0x0000ff00L;
    constexpr unsigned int CP_GFX_HQD_QUANTUM__QUANTUM_EN_MASK      = 0x00000001L;
    constexpr unsigned int CP_GFX_HQD_QUANTUM__QUANTUM_SCALE_MASK   = 0x00000018L;
    constexpr unsigned int CP_GFX_HQD_QUE_MGR_CONTROL__CONTROL_MASK = 0x00ffffffL;
    constexpr unsigned int CP_GFX_HQD_RPTR_ADDR_HI__RB_RPTR_ADDR_HI_MASK = 0x0000ffffL;
    constexpr unsigned int CP_GFX_HQD_RPTR_ADDR__RB_RPTR_ADDR_MASK  = 0xfffffffcL;
    constexpr unsigned int CP_GFX_HQD_RPTR__RB_RPTR_MASK            = 0x000fffffL;
    constexpr unsigned int CP_GFX_HQD_VMID__VMID_MASK               = 0x0000000fL;
    constexpr unsigned int CP_GFX_HQD_WPTR_HI__RB_WPTR_MASK         = 0xffffffffL;
    constexpr unsigned int CP_GFX_HQD_WPTR__RB_WPTR_MASK            = 0xffffffffL;
    constexpr unsigned int CP_GFX_INDEX_MUTEX__CLIENTID_MASK        = 0x0000000eL;
    constexpr unsigned int CP_GFX_INDEX_MUTEX__REQUEST_MASK         = 0x00000001L;
    constexpr unsigned int CP_GFX_MQD_BASE_ADDR_HI__APP_VMID_MASK   = 0xf0000000L;
    constexpr unsigned int CP_GFX_MQD_CONTROL__CACHE_POLICY_MASK    = 0x03000000L;
    constexpr unsigned int CP_GFX_MQD_CONTROL__PROCESSING_MQD_EN_MASK = 0x00002000L;
    constexpr unsigned int CP_GFX_MQD_CONTROL__PROCESSING_MQD_MASK  = 0x00001000L;
    constexpr unsigned int CP_GFX_QUEUE_INDEX__PIPE_ID_MASK         = 0x00000030L;
    constexpr unsigned int CP_GFX_QUEUE_INDEX__QUEUE_ACCESS_MASK    = 0x00000001L;
    constexpr unsigned int CP_GFX_QUEUE_INDEX__QUEUE_ID_MASK        = 0x00000700L;
    constexpr unsigned int CP_HPD_MES_ROQ_OFFSETS__IB_OFFSET_MASK   = 0x007f0000L;
    constexpr unsigned int CP_HPD_MES_ROQ_OFFSETS__IQ_OFFSET_MASK   = 0x00000007L;
    constexpr unsigned int CP_HPD_MES_ROQ_OFFSETS__PQ_OFFSET_MASK   = 0x00003f00L;
    constexpr unsigned int CP_HPD_ROQ_OFFSETS__IB_OFFSET_MASK       = 0x007f0000L;
    constexpr unsigned int CP_HPD_STATUS0__ENABLE_OFFLOAD_CHECK_MASK = 0x30000000L;
    constexpr unsigned int CP_HPD_STATUS0__FREEZE_QUEUE_STATE_MASK  = 0x40000000L;
    constexpr unsigned int CP_HPD_STATUS0__MASTER_QUEUE_IDLE_DIS_MASK = 0x08000000L;
    constexpr unsigned int CP_HQD_CTX_SAVE_CONTROL__POLICY_MASK     = 0x00000018L;
    constexpr unsigned int CP_HQD_DDID_DELTA_RPT_COUNT__COUNT_MASK  = 0x000000ffL;
    constexpr unsigned int CP_HQD_DDID_INFLIGHT_COUNT__COUNT_MASK   = 0x0000ffffL;
    constexpr unsigned int CP_HQD_DDID_RPTR__RPTR_MASK              = 0x000007ffL;
    constexpr unsigned int CP_HQD_DDID_WPTR__WPTR_MASK              = 0x000007ffL;
    constexpr unsigned int CP_HQD_DEQUEUE_REQUEST__DEQUEUE_REQ_MASK = 0x0000000fL;
    constexpr unsigned int CP_HQD_DEQUEUE_STATUS__DEQUEUE_STAT_EN_MASK = 0x00000400L;
    constexpr unsigned int CP_HQD_DEQUEUE_STATUS__DEQUEUE_STAT_MASK = 0x0000000fL;
    constexpr unsigned int CP_HQD_DEQUEUE_STATUS__SUSPEND_REQ_PEND_EN_MASK = 0x00000200L;
    constexpr unsigned int CP_HQD_DEQUEUE_STATUS__SUSPEND_REQ_PEND_MASK = 0x00000010L;
    constexpr unsigned int CP_HQD_EOP_CONTROL__CACHE_POLICY_MASK    = 0x03000000L;
    constexpr unsigned int CP_HQD_EOP_CONTROL__EOP_VOLATILE_MASK    = 0x04000000L;
    constexpr unsigned int CP_HQD_IB_CONTROL__IB_CACHE_POLICY_MASK  = 0x03000000L;
    constexpr unsigned int CP_HQD_IB_CONTROL__IB_VOLATILE_MASK      = 0x04000000L;
    constexpr unsigned int CP_HQD_IQ_TIMER__CACHE_POLICY_MASK       = 0x03000000L;
    constexpr unsigned int CP_HQD_IQ_TIMER__IQ_VOLATILE_MASK        = 0x04000000L;
    constexpr unsigned int CP_HQD_IQ_TIMER__QUEUE_TYPE_MASK         = 0x08000000L;
    constexpr unsigned int CP_HQD_PERSISTENT_STATE__SUSPEND_STATUS_MASK = 0x00000080L;
    constexpr unsigned int CP_HQD_PERSISTENT_STATE__WPP_CLAMP_EN_MASK = 0x00100000L;
    constexpr unsigned int CP_HQD_PQ_CONTROL__CACHE_POLICY_MASK     = 0x03000000L;
    constexpr unsigned int CP_HQD_PQ_CONTROL__PQ_VOLATILE_MASK      = 0x04000000L;
    constexpr unsigned int CP_HQD_PQ_CONTROL__SLOT_BASED_WPTR_MASK  = 0x000c0000L;
    constexpr unsigned int CP_HQD_PQ_CONTROL__TUNNEL_DISPATCH_MASK  = 0x20000000L;
    constexpr unsigned int CP_HQD_SEMA_CMD__MESSAGE_EN_MASK         = 0x00000200L;
    constexpr unsigned int CP_HQD_SEMA_CMD__POLLING_DIS_MASK        = 0x00000100L;
    constexpr unsigned int CP_HQD_SUSPEND_CNTL_STACK_DW_CNT__CNT_MASK = 0x00001fffL;
    constexpr unsigned int CP_HQD_SUSPEND_CNTL_STACK_OFFSET__OFFSET_MASK = 0x00007ffcL;
    constexpr unsigned int CP_HQD_SUSPEND_WG_STATE_OFFSET__OFFSET_MASK = 0x01fffffcL;
    constexpr unsigned int CP_INT_CNTL_RING0__DMA_WATCH_INT_ENABLE_MASK = 0x00000400L;
    constexpr unsigned int CP_INT_CNTL_RING0__RESUME_INT_ENABLE_MASK = 0x00000100L;
    constexpr unsigned int CP_INT_CNTL_RING0__SUSPEND_INT_ENABLE_MASK = 0x00000200L;
    constexpr unsigned int CP_INT_CNTL_RING1__DMA_WATCH_INT_ENABLE_MASK = 0x00000400L;
    constexpr unsigned int CP_INT_CNTL_RING2__DMA_WATCH_INT_ENABLE_MASK = 0x00000400L;
    constexpr unsigned int CP_INT_CNTL__DMA_WATCH_INT_ENABLE_MASK   = 0x00000400L;
    constexpr unsigned int CP_INT_CNTL__RESUME_INT_ENABLE_MASK      = 0x00000100L;
    constexpr unsigned int CP_INT_CNTL__SUSPEND_INT_ENABLE_MASK     = 0x00000200L;
    constexpr unsigned int CP_INT_STATUS_RING0__DMA_WATCH_INT_STAT_MASK = 0x00000400L;
    constexpr unsigned int CP_INT_STATUS_RING0__RESUME_INT_STAT_MASK = 0x00000100L;
    constexpr unsigned int CP_INT_STATUS_RING0__SUSPEND_INT_STAT_MASK = 0x00000200L;
    constexpr unsigned int CP_INT_STATUS_RING1__DMA_WATCH_INT_STAT_MASK = 0x00000400L;
    constexpr unsigned int CP_INT_STATUS_RING2__DMA_WATCH_INT_STAT_MASK = 0x00000400L;
    constexpr unsigned int CP_INT_STATUS__DMA_WATCH_INT_STAT_MASK   = 0x00000400L;
    constexpr unsigned int CP_INT_STATUS__RESUME_INT_STAT_MASK      = 0x00000100L;
    constexpr unsigned int CP_INT_STATUS__SUSPEND_INT_STAT_MASK     = 0x00000200L;
    constexpr unsigned int CP_INT_STAT_DEBUG__DMA_WATCH_INT_ASSERTED_MASK = 0x00000400L;
    constexpr unsigned int CP_INT_STAT_DEBUG__RESUME_INT_ASSERTED_MASK = 0x00000100L;
    constexpr unsigned int CP_INT_STAT_DEBUG__SUSPEND_INT_ASSERTED_MASK = 0x00000200L;
    constexpr unsigned int CP_IQ_WAIT_TIME3__SUSPEND_QUE_MASK       = 0x000000ffL;
    constexpr unsigned int CP_MEC1_INTR_ROUTINE_START__IR_START_MASK = 0x000fffffL;
    constexpr unsigned int CP_MEC1_PRGRM_CNTR_START__IP_START_MASK  = 0x000fffffL;
    constexpr unsigned int CP_MEC2_INTR_ROUTINE_START__IR_START_MASK = 0x000fffffL;
    constexpr unsigned int CP_MEC2_PRGRM_CNTR_START__IP_START_MASK  = 0x000fffffL;
    constexpr unsigned int CP_MEC_CNTL__MEC_INVALIDATE_ICACHE_MASK  = 0x08000000L;
    constexpr unsigned int CP_MEC_CNTL__MEC_ME2_PIPE2_RESET_MASK    = 0x00400000L;
    constexpr unsigned int CP_MEC_CNTL__MEC_ME2_PIPE3_RESET_MASK    = 0x00800000L;
    constexpr unsigned int CP_MES_CNTL__MES_HALT_MASK               = 0x40000000L;
    constexpr unsigned int CP_MES_CNTL__MES_INVALIDATE_ICACHE_MASK  = 0x00000010L;
    constexpr unsigned int CP_MES_CNTL__MES_PIPE0_ACTIVE_MASK       = 0x04000000L;
    constexpr unsigned int CP_MES_CNTL__MES_PIPE0_RESET_MASK        = 0x00010000L;
    constexpr unsigned int CP_MES_CNTL__MES_PIPE1_ACTIVE_MASK       = 0x08000000L;
    constexpr unsigned int CP_MES_CNTL__MES_PIPE1_RESET_MASK        = 0x00020000L;
    constexpr unsigned int CP_MES_CNTL__MES_PIPE2_ACTIVE_MASK       = 0x10000000L;
    constexpr unsigned int CP_MES_CNTL__MES_PIPE2_RESET_MASK        = 0x00040000L;
    constexpr unsigned int CP_MES_CNTL__MES_PIPE3_ACTIVE_MASK       = 0x20000000L;
    constexpr unsigned int CP_MES_CNTL__MES_PIPE3_RESET_MASK        = 0x00080000L;
    constexpr unsigned int CP_MES_CNTL__MES_STEP_MASK               = 0x80000000L;
    constexpr unsigned int CP_MES_DC_BASE_CNTL__CACHE_POLICY_MASK   = 0x03000000L;
    constexpr unsigned int CP_MES_DC_BASE_CNTL__VMID_MASK           = 0x0000000fL;
    constexpr unsigned int CP_MES_DC_BASE_HI__DC_BASE_HI_MASK       = 0x0000ffffL;
    constexpr unsigned int CP_MES_DC_BASE_LO__DC_BASE_LO_MASK       = 0xffff0000L;
    constexpr unsigned int CP_MES_DC_OP_CNTL__BYPASS_ALL_MASK       = 0x00000004L;
    constexpr unsigned int CP_MES_DC_OP_CNTL__BYPASS_UNCACHED_MASK  = 0x00000008L;
    constexpr unsigned int CP_MES_DC_OP_CNTL__DCACHE_PRIMED_MASK    = 0x00000020L;
    constexpr unsigned int CP_MES_DC_OP_CNTL__INVALIDATE_DCACHE_COMPLETE_MASK = 0x00000002L;
    constexpr unsigned int CP_MES_DC_OP_CNTL__INVALIDATE_DCACHE_MASK = 0x00000001L;
    constexpr unsigned int CP_MES_DC_OP_CNTL__PRIME_DCACHE_MASK     = 0x00000010L;
    constexpr unsigned int CP_MES_DM_INDEX_ADDR__ADDR_MASK          = 0xffffffffL;
    constexpr unsigned int CP_MES_DM_INDEX_DATA__DATA_MASK          = 0xffffffffL;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL1__DOORBELL_EN_MASK = 0x40000000L;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL1__DOORBELL_HIT_MASK = 0x80000000L;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL1__DOORBELL_OFFSET_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL2__DOORBELL_EN_MASK = 0x40000000L;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL2__DOORBELL_HIT_MASK = 0x80000000L;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL2__DOORBELL_OFFSET_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL3__DOORBELL_EN_MASK = 0x40000000L;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL3__DOORBELL_HIT_MASK = 0x80000000L;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL3__DOORBELL_OFFSET_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_MES_HEADER_DUMP__HEADER_DUMP_MASK     = 0xffffffffL;
    constexpr unsigned int CP_MES_IC_BASE_CNTL__CACHE_POLICY_MASK   = 0x03000000L;
    constexpr unsigned int CP_MES_IC_BASE_CNTL__EXE_DISABLE_MASK    = 0x00800000L;
    constexpr unsigned int CP_MES_IC_BASE_CNTL__VMID_MASK           = 0x0000000fL;
    constexpr unsigned int CP_MES_IC_BASE_HI__IC_BASE_HI_MASK       = 0x0000ffffL;
    constexpr unsigned int CP_MES_IC_BASE_LO__IC_BASE_LO_MASK       = 0xfffff000L;
    constexpr unsigned int CP_MES_IC_OP_CNTL__ICACHE_PRIMED_MASK    = 0x00000020L;
    constexpr unsigned int CP_MES_IC_OP_CNTL__INVALIDATE_CACHE_MASK = 0x00000001L;
    constexpr unsigned int CP_MES_IC_OP_CNTL__PRIME_ICACHE_MASK     = 0x00000010L;
    constexpr unsigned int CP_MES_INSTR_PNTR__INSTR_PNTR_MASK       = 0x000fffffL;
    constexpr unsigned int CP_MES_INTR_ROUTINE_START__IR_START_MASK = 0xffffffffL;
    constexpr unsigned int CP_MES_LOCAL_APERTURE__APERTURE_MASK     = 0x00000003L;
    constexpr unsigned int CP_MES_LOCAL_BASE0_HI__BASE0_HI_MASK     = 0x0000ffffL;
    constexpr unsigned int CP_MES_LOCAL_BASE0_LO__BASE0_LO_MASK     = 0xffff0000L;
    constexpr unsigned int CP_MES_LOCAL_MASK0_HI__MASK0_HI_MASK     = 0x0000ffffL;
    constexpr unsigned int CP_MES_LOCAL_MASK0_LO__MASK0_LO_MASK     = 0xffff0000L;
    constexpr unsigned int CP_MES_MARCHID_HI__MARCHID_HI_MASK       = 0xffffffffL;
    constexpr unsigned int CP_MES_MARCHID_LO__MARCHID_LO_MASK       = 0xffffffffL;
    constexpr unsigned int CP_MES_MBADADDR_HI__ADDR_HI_MASK         = 0xffffffffL;
    constexpr unsigned int CP_MES_MBADADDR_LO__ADDR_LO_MASK         = 0xffffffffL;
    constexpr unsigned int CP_MES_MCAUSE_HI__CAUSE_HI_MASK          = 0xffffffffL;
    constexpr unsigned int CP_MES_MCAUSE_LO__CAUSE_LO_MASK          = 0xffffffffL;
    constexpr unsigned int CP_MES_MCYCLE_HI__CYCLE_HI_MASK          = 0xffffffffL;
    constexpr unsigned int CP_MES_MCYCLE_LO__CYCLE_LO_MASK          = 0xffffffffL;
    constexpr unsigned int CP_MES_MDBASE_HI__BASE_HI_MASK           = 0x0000ffffL;
    constexpr unsigned int CP_MES_MDBASE_LO__BASE_LO_MASK           = 0xffff0000L;
    constexpr unsigned int CP_MES_MDBOUND_HI__BOUND_HI_MASK         = 0xffffffffL;
    constexpr unsigned int CP_MES_MDBOUND_LO__BOUND_LO_MASK         = 0xffffffffL;
    constexpr unsigned int CP_MES_MEPC_HI__MEPC_HI_MASK             = 0xffffffffL;
    constexpr unsigned int CP_MES_MEPC_LO__MEPC_LO_MASK             = 0xffffffffL;
    constexpr unsigned int CP_MES_MHARTID_HI__MHARTID_HI_MASK       = 0xffffffffL;
    constexpr unsigned int CP_MES_MHARTID_LO__MHARTID_LO_MASK       = 0xffffffffL;
    constexpr unsigned int CP_MES_MIBASE_HI__IC_BASE_HI_MASK        = 0x0000ffffL;
    constexpr unsigned int CP_MES_MIBASE_LO__IC_BASE_LO_MASK        = 0xfffff000L;
    constexpr unsigned int CP_MES_MIBOUND_HI__BOUND_HI_MASK         = 0xffffffffL;
    constexpr unsigned int CP_MES_MIBOUND_LO__BOUND_LO_MASK         = 0xffffffffL;
    constexpr unsigned int CP_MES_MIE_HI__MES_INT_MASK              = 0xffffffffL;
    constexpr unsigned int CP_MES_MIE_LO__MES_INT_MASK              = 0xffffffffL;
    constexpr unsigned int CP_MES_MIMPID_HI__MIMPID_HI_MASK         = 0xffffffffL;
    constexpr unsigned int CP_MES_MIMPID_LO__MIMPID_LO_MASK         = 0xffffffffL;
    constexpr unsigned int CP_MES_MINSTRET_HI__INSTRET_HI_MASK      = 0xffffffffL;
    constexpr unsigned int CP_MES_MINSTRET_LO__INSTRET_LO_MASK      = 0xffffffffL;
    constexpr unsigned int CP_MES_MIP_HI__MIP_HI_MASK               = 0xffffffffL;
    constexpr unsigned int CP_MES_MIP_LO__MIP_LO_MASK               = 0xffffffffL;
    constexpr unsigned int CP_MES_MISA_HI__MISA_HI_MASK             = 0xffffffffL;
    constexpr unsigned int CP_MES_MISA_LO__MISA_LO_MASK             = 0xffffffffL;
    constexpr unsigned int CP_MES_MSCRATCH_HI__DATA_MASK            = 0xffffffffL;
    constexpr unsigned int CP_MES_MSCRATCH_LO__DATA_MASK            = 0xffffffffL;
    constexpr unsigned int CP_MES_MSTATUS_HI__STATUS_HI_MASK        = 0xffffffffL;
    constexpr unsigned int CP_MES_MSTATUS_LO__STATUS_LO_MASK        = 0xffffffffL;
    constexpr unsigned int CP_MES_MTIMECMP_HI__TIME_HI_MASK         = 0xffffffffL;
    constexpr unsigned int CP_MES_MTIMECMP_LO__TIME_LO_MASK         = 0xffffffffL;
    constexpr unsigned int CP_MES_MTIME_HI__TIME_HI_MASK            = 0xffffffffL;
    constexpr unsigned int CP_MES_MTIME_LO__TIME_LO_MASK            = 0xffffffffL;
    constexpr unsigned int CP_MES_MTVEC_HI__ADDR_LO_MASK            = 0xffffffffL;
    constexpr unsigned int CP_MES_MTVEC_LO__ADDR_LO_MASK            = 0xffffffffL;
    constexpr unsigned int CP_MES_MVENDORID_HI__MVENDORID_HI_MASK   = 0xffffffffL;
    constexpr unsigned int CP_MES_MVENDORID_LO__MVENDORID_LO_MASK   = 0xffffffffL;
    constexpr unsigned int CP_MES_PIPE0_PRIORITY__PRIORITY_MASK     = 0x00000003L;
    constexpr unsigned int CP_MES_PIPE1_PRIORITY__PRIORITY_MASK     = 0x00000003L;
    constexpr unsigned int CP_MES_PIPE2_PRIORITY__PRIORITY_MASK     = 0x00000003L;
    constexpr unsigned int CP_MES_PIPE3_PRIORITY__PRIORITY_MASK     = 0x00000003L;
    constexpr unsigned int CP_MES_PIPE_PRIORITY_CNTS__PRIORITY1_CNT_MASK = 0x000000ffL;
    constexpr unsigned int CP_MES_PIPE_PRIORITY_CNTS__PRIORITY2A_CNT_MASK = 0x0000ff00L;
    constexpr unsigned int CP_MES_PIPE_PRIORITY_CNTS__PRIORITY2B_CNT_MASK = 0x00ff0000L;
    constexpr unsigned int CP_MES_PIPE_PRIORITY_CNTS__PRIORITY3_CNT_MASK = 0xff000000L;
    constexpr unsigned int CP_MES_PRGRM_CNTR_START__IP_START_MASK   = 0x000fffffL;
    constexpr unsigned int CP_MES_PROCESS_QUANTUM_PIPE0__QUANTUM_DURATION_MASK = 0x0fffffffL;
    constexpr unsigned int CP_MES_PROCESS_QUANTUM_PIPE0__QUANTUM_EN_MASK = 0x80000000L;
    constexpr unsigned int CP_MES_PROCESS_QUANTUM_PIPE0__QUANTUM_SCALE_MASK = 0x60000000L;
    constexpr unsigned int CP_MES_PROCESS_QUANTUM_PIPE0__TIMER_EXPIRED_MASK = 0x10000000L;
    constexpr unsigned int CP_MES_PROCESS_QUANTUM_PIPE1__QUANTUM_DURATION_MASK = 0x0fffffffL;
    constexpr unsigned int CP_MES_PROCESS_QUANTUM_PIPE1__QUANTUM_EN_MASK = 0x80000000L;
    constexpr unsigned int CP_MES_PROCESS_QUANTUM_PIPE1__QUANTUM_SCALE_MASK = 0x60000000L;
    constexpr unsigned int CP_MES_PROCESS_QUANTUM_PIPE1__TIMER_EXPIRED_MASK = 0x10000000L;
    constexpr unsigned int CP_MES_SCRATCH_DATA__SCRATCH_DATA_MASK   = 0xffffffffL;
    constexpr unsigned int CP_MES_SCRATCH_INDEX__SCRATCH_INDEX_64BIT_MODE_MASK = 0x80000000L;
    constexpr unsigned int CP_MES_SCRATCH_INDEX__SCRATCH_INDEX_MASK = 0x000001ffL;
    constexpr unsigned int CP_ME_IC_BASE_CNTL__ADDRESS_CLAMP_MASK   = 0x00000010L;
    constexpr unsigned int CP_ME_IC_BASE_CNTL__CACHE_POLICY_MASK    = 0x03000000L;
    constexpr unsigned int CP_ME_IC_BASE_CNTL__EXE_DISABLE_MASK     = 0x00800000L;
    constexpr unsigned int CP_ME_IC_BASE_CNTL__VMID_MASK            = 0x0000000fL;
    constexpr unsigned int CP_ME_IC_BASE_HI__IC_BASE_HI_MASK        = 0x0000ffffL;
    constexpr unsigned int CP_ME_IC_BASE_LO__IC_BASE_LO_MASK        = 0xfffff000L;
    constexpr unsigned int CP_ME_IC_OP_CNTL__ICACHE_PRIMED_MASK     = 0x00000020L;
    constexpr unsigned int CP_ME_IC_OP_CNTL__INVALIDATE_CACHE_COMPLETE_MASK = 0x00000002L;
    constexpr unsigned int CP_ME_IC_OP_CNTL__INVALIDATE_CACHE_MASK  = 0x00000001L;
    constexpr unsigned int CP_ME_IC_OP_CNTL__PRIME_ICACHE_MASK      = 0x00000010L;
    constexpr unsigned int CP_ME_INTR_ROUTINE_START__IR_START_MASK  = 0x000fffffL;
    constexpr unsigned int CP_ME_MC_RADDR_HI__CACHE_POLICY_MASK     = 0x00c00000L;
    constexpr unsigned int CP_ME_MC_WADDR_HI__CACHE_POLICY_MASK     = 0x00c00000L;
    constexpr unsigned int CP_ME_PRGRM_CNTR_START__IP_START_MASK    = 0x000fffffL;
    constexpr unsigned int CP_ME_RAM_RADDR__ME_RAM_RADDR_MASK       = 0x000fffffL;
    constexpr unsigned int CP_ME_RAM_WADDR__ME_RAM_WADDR_MASK       = 0x001fffffL;
    constexpr unsigned int CP_MQD_CONTROL__CACHE_POLICY_MASK        = 0x03000000L;
    constexpr unsigned int CP_MQD_CONTROL__MQD_VOLATILE_MASK        = 0x04000000L;
    constexpr unsigned int CP_PFP_IC_BASE_CNTL__ADDRESS_CLAMP_MASK  = 0x00000010L;
    constexpr unsigned int CP_PFP_IC_BASE_CNTL__CACHE_POLICY_MASK   = 0x03000000L;
    constexpr unsigned int CP_PFP_IC_BASE_CNTL__EXE_DISABLE_MASK    = 0x00800000L;
    constexpr unsigned int CP_PFP_IC_BASE_CNTL__VMID_MASK           = 0x0000000fL;
    constexpr unsigned int CP_PFP_IC_BASE_HI__IC_BASE_HI_MASK       = 0x0000ffffL;
    constexpr unsigned int CP_PFP_IC_BASE_LO__IC_BASE_LO_MASK       = 0xfffff000L;
    constexpr unsigned int CP_PFP_IC_OP_CNTL__ICACHE_PRIMED_MASK    = 0x00000020L;
    constexpr unsigned int CP_PFP_IC_OP_CNTL__INVALIDATE_CACHE_COMPLETE_MASK = 0x00000002L;
    constexpr unsigned int CP_PFP_IC_OP_CNTL__INVALIDATE_CACHE_MASK = 0x00000001L;
    constexpr unsigned int CP_PFP_IC_OP_CNTL__PRIME_ICACHE_MASK     = 0x00000010L;
    constexpr unsigned int CP_PFP_INTR_ROUTINE_START__IR_START_MASK = 0x000fffffL;
    constexpr unsigned int CP_PFP_PRGRM_CNTR_START__IP_START_MASK   = 0x000fffffL;
    constexpr unsigned int CP_PIPE_STATS_CONTROL__CACHE_POLICY_MASK = 0x06000000L;
    constexpr unsigned int CP_PQ_STATUS__DOORBELL_UPDATED_EN_MASK   = 0x00000004L;
    constexpr unsigned int CP_PROCESS_QUANTUM__QUANTUM_DURATION_MASK = 0x0fffffffL;
    constexpr unsigned int CP_PROCESS_QUANTUM__QUANTUM_EN_MASK      = 0x80000000L;
    constexpr unsigned int CP_PROCESS_QUANTUM__QUANTUM_SCALE_MASK   = 0x60000000L;
    constexpr unsigned int CP_PROCESS_QUANTUM__TIMER_EXPIRED_MASK   = 0x10000000L;
    constexpr unsigned int CP_PWR_CNTL__CMP_CLK_HALT_ME3_PIPE0_MASK = 0x00100000L;
    constexpr unsigned int CP_PWR_CNTL__CMP_CLK_HALT_ME3_PIPE1_MASK = 0x00200000L;
    constexpr unsigned int CP_PWR_CNTL__CMP_CLK_HALT_ME3_PIPE2_MASK = 0x00400000L;
    constexpr unsigned int CP_PWR_CNTL__CMP_CLK_HALT_ME3_PIPE3_MASK = 0x00800000L;
    constexpr unsigned int CP_RB0_CNTL__CACHE_POLICY_MASK           = 0x03000000L;
    constexpr unsigned int CP_RB0_CNTL__RB_EXE_MASK                 = 0x10000000L;
    constexpr unsigned int CP_RB0_CNTL__RB_VOLATILE_MASK            = 0x04000000L;
    constexpr unsigned int CP_RB1_ACTIVE__ACTIVE_MASK               = 0x00000001L;
    constexpr unsigned int CP_RB1_BUFSZ_MASK__DATA_MASK             = 0x000fffffL;
    constexpr unsigned int CP_RB1_CNTL__CACHE_POLICY_MASK           = 0x03000000L;
    constexpr unsigned int CP_RB1_CNTL__RB_EXE_MASK                 = 0x10000000L;
    constexpr unsigned int CP_RB1_CNTL__RB_VOLATILE_MASK            = 0x04000000L;
    constexpr unsigned int CP_RB2_CNTL__CACHE_POLICY_MASK           = 0x03000000L;
    constexpr unsigned int CP_RB2_CNTL__RB_EXE_MASK                 = 0x10000000L;
    constexpr unsigned int CP_RB2_CNTL__RB_VOLATILE_MASK            = 0x04000000L;
    constexpr unsigned int CP_RB_CNTL__CACHE_POLICY_MASK            = 0x03000000L;
    constexpr unsigned int CP_RB_CNTL__RB_EXE_MASK                  = 0x10000000L;
    constexpr unsigned int CP_RB_CNTL__RB_VOLATILE_MASK             = 0x04000000L;
    constexpr unsigned int CP_ROQ1_THRESHOLDS__R0_IB1_START_MASK    = 0x000ffc00L;
    constexpr unsigned int CP_ROQ1_THRESHOLDS__R1_IB1_START_MASK    = 0x3ff00000L;
    constexpr unsigned int CP_ROQ1_THRESHOLDS__RB1_START_MASK       = 0x000003ffL;
    constexpr unsigned int CP_ROQ2_AVAIL__ROQ_CNT_DB_MASK           = 0x0fff0000L;
    constexpr unsigned int CP_ROQ2_AVAIL__ROQ_CNT_IB2_MASK          = 0x00000fffL;
    constexpr unsigned int CP_ROQ2_THRESHOLDS__R0_IB2_START_MASK    = 0x000003ffL;
    constexpr unsigned int CP_ROQ2_THRESHOLDS__R1_IB2_START_MASK    = 0x000ffc00L;
    constexpr unsigned int CP_ROQ3_THRESHOLDS__R0_DB_START_MASK     = 0x000003ffL;
    constexpr unsigned int CP_ROQ3_THRESHOLDS__R1_DB_START_MASK     = 0x000ffc00L;
    constexpr unsigned int CP_ROQ_AVAIL__ROQ_CNT_IB1_MASK           = 0x0fff0000L;
    constexpr unsigned int CP_ROQ_AVAIL__ROQ_CNT_RING_MASK          = 0x00000fffL;
    constexpr unsigned int CP_ROQ_DB_STAT__ROQ_RPTR_DB_MASK         = 0x00000fffL;
    constexpr unsigned int CP_ROQ_DB_STAT__ROQ_WPTR_DB_MASK         = 0x0fff0000L;
    constexpr unsigned int CP_ROQ_IB1_STAT__ROQ_RPTR_INDIRECT1_MASK = 0x00000fffL;
    constexpr unsigned int CP_ROQ_IB1_STAT__ROQ_WPTR_INDIRECT1_MASK = 0x0fff0000L;
    constexpr unsigned int CP_ROQ_IB2_STAT__ROQ_RPTR_INDIRECT2_MASK = 0x00000fffL;
    constexpr unsigned int CP_ROQ_IB2_STAT__ROQ_WPTR_INDIRECT2_MASK = 0x0fff0000L;
    constexpr unsigned int CP_ROQ_RB_STAT__ROQ_RPTR_PRIMARY_MASK    = 0x00000fffL;
    constexpr unsigned int CP_ROQ_RB_STAT__ROQ_WPTR_PRIMARY_MASK    = 0x0fff0000L;
    constexpr unsigned int CP_SCRATCH_INDEX__SCRATCH_INDEX_64BIT_MODE_MASK = 0x80000000L;
    constexpr unsigned int CP_SD_CNTL__GE_EN_MASK                   = 0x00000020L;
    constexpr unsigned int CP_SD_CNTL__SDMA_EN_MASK                 = 0x00000400L;
    constexpr unsigned int CP_SD_CNTL__SD_VMIDVEC_OVERRIDE_MASK     = 0x80000000L;
    constexpr unsigned int CP_SD_CNTL__UTCL1_EN_MASK                = 0x00000040L;
    constexpr unsigned int CP_STALLED_STAT2__PFP_TO_MEQ_DDID_NOT_RDY_TO_RCV_MASK = 0x00000040L;
    constexpr unsigned int CP_STALLED_STAT3__GCRIU_WAITING_ON_FREE_MASK = 0x00200000L;
    constexpr unsigned int CP_STAT__GCRIU_BUSY_MASK                 = 0x02000000L;
    constexpr unsigned int CP_STAT__ROQ_CE_DB_BUSY_MASK             = 0x00000040L;
    constexpr unsigned int CP_STAT__ROQ_DB_BUSY_MASK                = 0x00000020L;
    constexpr unsigned int CP_STREAM_OUT_CONTROL__CACHE_POLICY_MASK = 0x06000000L;
    constexpr unsigned int CP_SUSPEND_CNTL__ACE_SUSPEND_ACTIVE_MASK = 0x00000008L;
    constexpr unsigned int CP_SUSPEND_CNTL__RESUME_LOCK_MASK        = 0x00000004L;
    constexpr unsigned int CP_SUSPEND_CNTL__SUSPEND_ENABLE_MASK     = 0x00000002L;
    constexpr unsigned int CP_SUSPEND_CNTL__SUSPEND_MODE_MASK       = 0x00000001L;
    constexpr unsigned int CP_SUSPEND_RESUME_REQ__RESUME_REQ_MASK   = 0x00000002L;
    constexpr unsigned int CP_SUSPEND_RESUME_REQ__SUSPEND_REQ_MASK  = 0x00000001L;
    constexpr unsigned int CSPRIV_CONNECT__SAME_SIMD_RESUME_MASK    = 0x00080000L;
    constexpr unsigned int CSPRIV_CONNECT__TRACKER_BIT_MASK         = 0x40000000L;
    constexpr unsigned int CSPRIV_CONNECT__TUNNEL_DISP_MASK         = 0x00040000L;
    constexpr unsigned int DB_COUNT_CONTROL__DISABLE_CONSERVATIVE_ZPASS_COUNTS_MASK = 0x00000004L;
    constexpr unsigned int DB_COUNT_CONTROL__ENHANCED_CONSERVATIVE_ZPASS_COUNTS_MASK = 0x00000008L;
    constexpr unsigned int DB_DEBUG2__DISABLE_HTILE_PAIRED_PIPES_MASK = 0x00010000L;
    constexpr unsigned int DB_DEBUG2__DUAL_PIPE_REZ_STALL_MANUAL_CONTROL_MASK = 0x00400000L;
    constexpr unsigned int DB_DEBUG2__DUAL_PIPE_REZ_STALL_SELECT_NEW_MASK = 0x00800000L;
    constexpr unsigned int DB_DEBUG2__FORCE_ITERATE_256_MASK        = 0x03000000L;
    constexpr unsigned int DB_DEBUG2__FULL_TILE_CACHE_EVICT_ON_HALF_FULL_MASK = 0x00008000L;
    constexpr unsigned int DB_DEBUG2__FULL_TILE_WAVE_BREAK_MODE_MASK = 0x00300000L;
    constexpr unsigned int DB_DEBUG3__DELETE_CONTEXT_SUSPEND_MASK   = 0x20000000L;
    constexpr unsigned int DB_DEBUG3__DISABLE_MULTIDTAG_FL_PANIC_REQUIREMENT_MASK = 0x80000000L;
    constexpr unsigned int DB_DEBUG3__DISABLE_SLOCS_PER_CTXT_MATCH_MASK = 0x00010000L;
    constexpr unsigned int DB_DEBUG3__DISABLE_TS_WRITE_L0_MASK      = 0x40000000L;
    constexpr unsigned int DB_DEBUG4__ALWAYS_ON_RMI_CLK_EN_MASK     = 0x00000040L;
    constexpr unsigned int DB_DEBUG4__DISABLE_DYNAMIC_RAM_LIGHT_SLEEP_MODE_MASK = 0x00008000L;
    constexpr unsigned int DB_DEBUG4__DISABLE_HIZ_TS_COLLISION_DETECT_MASK = 0x00010000L;
    constexpr unsigned int DB_DEBUG4__DISABLE_LAST_OF_BURST_ON_ACCUM_ALL_EOT_MASK = 0x00020000L;
    constexpr unsigned int DB_DEBUG4__DISABLE_LAST_OF_BURST_ON_FLUSH_CHUNK0_ALL_DONE_MASK = 0x00040000L;
    constexpr unsigned int DB_DEBUG4__DISABLE_LATEZ_NO_EXPORT_POWER_SAVING_MASK = 0x00100000L;
    constexpr unsigned int DB_DEBUG4__DISABLE_MCC_BURST_FIFO_CONFLICT_MASK = 0x00400000L;
    constexpr unsigned int DB_DEBUG4__DISABLE_MCC_BURST_FIFO_MASK   = 0x00200000L;
    constexpr unsigned int DB_DEBUG4__DISABLE_RD_MEM_BURST_MASK     = 0x10000000L;
    constexpr unsigned int DB_DEBUG4__DISABLE_SEPARATE_DFSM_CLK_MASK = 0x00000020L;
    constexpr unsigned int DB_DEBUG4__DISABLE_SEPARATE_OP_PIPE_CLK_MASK = 0x00000010L;
    constexpr unsigned int DB_DEBUG4__DISABLE_WR_MEM_BURST_FLF_CONSECUTIVE_CHECK_MASK = 0x00800000L;
    constexpr unsigned int DB_DEBUG4__DISABLE_WR_MEM_BURST_POOLING_MASK = 0x08000000L;
    constexpr unsigned int DB_DEBUG4__ENABLE_A2M_DQUAD_OPTIMIZATION_MASK = 0x00001000L;
    constexpr unsigned int DB_DEBUG4__ENABLE_CZ_OVERFLOW_TESTMODE_MASK = 0x00080000L;
    constexpr unsigned int DB_DEBUG4__ENABLE_DBCB_SLOW_FORMAT_COLLAPSE_MASK = 0x00000080L;
    constexpr unsigned int DB_DEBUG4__LATE_ACK_PSD_EOP_GFX9_METHOD_MASK = 0x80000000L;
    constexpr unsigned int DB_DEBUG4__LATE_ACK_SCOREBOARD_MULTIPLE_SLOT_MASK = 0x40000000L;
    constexpr unsigned int DB_DEBUG4__LATE_ACK_SCOREBOARD_NEW_MASK  = 0x20000000L;
    constexpr unsigned int DB_DEBUG4__WR_MEM_BURST_CTL_MASK         = 0x07000000L;
    constexpr unsigned int DB_DEPTH_SIZE_XY__X_MAX_MASK             = 0x00003fffL;
    constexpr unsigned int DB_DEPTH_SIZE_XY__Y_MAX_MASK             = 0x3fff0000L;
    constexpr unsigned int DB_DEPTH_VIEW__SLICE_MAX_HI_MASK         = 0xc0000000L;
    constexpr unsigned int DB_DEPTH_VIEW__SLICE_START_HI_MASK       = 0x00001800L;
    constexpr unsigned int DB_DFSM_FLUSH_ENABLE__PRIMARY_EVENTS_MASK = 0x000007ffL;
    constexpr unsigned int DB_EQUAD_STUTTER_CONTROL__THRESHOLD_MASK = 0x000000ffL;
    constexpr unsigned int DB_EQUAD_STUTTER_CONTROL__TIMEOUT_MASK   = 0x00ff0000L;
    constexpr unsigned int DB_ETILE_STUTTER_CONTROL__THRESHOLD_MASK = 0x000000ffL;
    constexpr unsigned int DB_ETILE_STUTTER_CONTROL__TIMEOUT_MASK   = 0x00ff0000L;
    constexpr unsigned int DB_EXCEPTION_CONTROL__AUTO_FLUSH_HTILE_MASK = 0x00000008L;
    constexpr unsigned int DB_EXCEPTION_CONTROL__AUTO_FLUSH_QUAD_MASK = 0x00000010L;
    constexpr unsigned int DB_EXCEPTION_CONTROL__DTAG_WATERMARK_MASK = 0x7f000000L;
    constexpr unsigned int DB_EXCEPTION_CONTROL__FORCE_SUMMARIZE_MASK = 0x00000f00L;
    constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_CB_LQUAD_OVERRIDE_MASK = 0x00000004L;
    constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_CB_TILE_OVERRIDE_MASK = 0x00000002L;
    constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_RMI_RDREQ_OVERRIDE_MASK = 0x00000008L;
    constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_RMI_WRREQ_OVERRIDE_MASK = 0x00000010L;
    constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_SC_QUAD_OVERRIDE_MASK = 0x00000001L;
    constexpr unsigned int DB_FIFO_DEPTH1__MCC_DEPTH_MASK           = 0x00ff0000L;
    constexpr unsigned int DB_FIFO_DEPTH1__MI_RDREQ_FIFO_DEPTH_MASK = 0x000000ffL;
    constexpr unsigned int DB_FIFO_DEPTH1__MI_WRREQ_FIFO_DEPTH_MASK = 0x0000ff00L;
    constexpr unsigned int DB_FIFO_DEPTH1__QC_DEPTH_MASK            = 0xff000000L;
    constexpr unsigned int DB_FIFO_DEPTH2__ETILE_OP_FIFO_DEPTH_MASK = 0x0000ff00L;
    constexpr unsigned int DB_FIFO_DEPTH2__LQUAD_FIFO_DEPTH_MASK    = 0x01ff0000L;
    constexpr unsigned int DB_FIFO_DEPTH3__LTILE_PROBE_FIFO_DEPTH_MASK = 0x000000ffL;
    constexpr unsigned int DB_FIFO_DEPTH3__QUAD_READ_REQS_MASK      = 0xff000000L;
    constexpr unsigned int DB_FREE_CACHELINES__FREE_DTILE_DEPTH_MASK = 0x000000ffL;
    constexpr unsigned int DB_FREE_CACHELINES__FREE_HTILE_DEPTH_MASK = 0xff000000L;
    constexpr unsigned int DB_FREE_CACHELINES__FREE_PLANE_DEPTH_MASK = 0x0000ff00L;
    constexpr unsigned int DB_FREE_CACHELINES__FREE_Z_DEPTH_MASK    = 0x00ff0000L;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__DISABLE_RD_BURST_MASK = 0x40000000L;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__LEGACY_LOB_INSERT_EN_MASK = 0x80000000L;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__MAXBURST_MASK   = 0x000000ffL;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__TIMEOUT_MASK    = 0x00000700L;
    constexpr unsigned int DB_LQUAD_STUTTER_CONTROL__THRESHOLD_MASK = 0x000000ffL;
    constexpr unsigned int DB_LQUAD_STUTTER_CONTROL__TIMEOUT_MASK   = 0x00ff0000L;
    constexpr unsigned int DB_LTILE_STUTTER_CONTROL__THRESHOLD_MASK = 0x000000ffL;
    constexpr unsigned int DB_LTILE_STUTTER_CONTROL__TIMEOUT_MASK   = 0x00ff0000L;
    constexpr unsigned int DB_RMI_BC_GL2_CACHE_CONTROL__HTILE_RD_POLICY_MASK = 0x00300000L;
    constexpr unsigned int DB_RMI_BC_GL2_CACHE_CONTROL__HTILE_WR_POLICY_MASK = 0x00000030L;
    constexpr unsigned int DB_RMI_BC_GL2_CACHE_CONTROL__S_RD_POLICY_MASK = 0x000c0000L;
    constexpr unsigned int DB_RMI_BC_GL2_CACHE_CONTROL__S_WR_POLICY_MASK = 0x0000000cL;
    constexpr unsigned int DB_RMI_BC_GL2_CACHE_CONTROL__VOL_MASK    = 0x80000000L;
    constexpr unsigned int DB_RMI_BC_GL2_CACHE_CONTROL__ZPCPSD_WR_POLICY_MASK = 0x000000c0L;
    constexpr unsigned int DB_RMI_BC_GL2_CACHE_CONTROL__Z_RD_POLICY_MASK = 0x00030000L;
    constexpr unsigned int DB_RMI_BC_GL2_CACHE_CONTROL__Z_WR_POLICY_MASK = 0x00000003L;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__HTILE_RD_POLICY_MASK = 0x00300000L;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__HTILE_WR_POLICY_MASK = 0x00000030L;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__S_RD_POLICY_MASK = 0x000c0000L;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__S_WR_POLICY_MASK = 0x0000000cL;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__ZPCPSD_WR_POLICY_MASK = 0x000000c0L;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__Z_RD_POLICY_MASK = 0x00030000L;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__Z_WR_POLICY_MASK = 0x00000003L;
    constexpr unsigned int DB_SHADER_CONTROL__PRE_SHADER_DEPTH_COVERAGE_ENABLE_MASK = 0x00800000L;
    constexpr unsigned int DB_STENCIL_INFO__FAULT_BEHAVIOR_MASK     = 0x00000600L;
    constexpr unsigned int DB_STENCIL_INFO__ITERATE_256_MASK        = 0x00100000L;
    constexpr unsigned int DB_STENCIL_INFO__ITERATE_FLUSH_MASK      = 0x00000800L;
    constexpr unsigned int DB_WATERMARKS__DEPTH_CACHELINE_FREE_MASK = 0xff000000L;
    constexpr unsigned int DB_WATERMARKS__DEPTH_FLUSH_MASK          = 0x0000ff00L;
    constexpr unsigned int DB_WATERMARKS__DEPTH_FREE_MASK           = 0x000000ffL;
    constexpr unsigned int DB_WATERMARKS__DEPTH_PENDING_FREE_MASK   = 0x00ff0000L;
    constexpr unsigned int DB_Z_INFO__FAULT_BEHAVIOR_MASK           = 0x00000600L;
    constexpr unsigned int DB_Z_INFO__ITERATE_256_MASK              = 0x00100000L;
    constexpr unsigned int DB_Z_INFO__ITERATE_FLUSH_MASK            = 0x00000800L;
    constexpr unsigned int GCEA_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GCEA_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GCEA_PERFCOUNTER2_MODE__COMPARE_MODE0_MASK = 0x00000003L;
    constexpr unsigned int GCEA_PERFCOUNTER2_MODE__COMPARE_MODE1_MASK = 0x0000000cL;
    constexpr unsigned int GCEA_PERFCOUNTER2_MODE__COMPARE_MODE2_MASK = 0x00000030L;
    constexpr unsigned int GCEA_PERFCOUNTER2_MODE__COMPARE_MODE3_MASK = 0x000000c0L;
    constexpr unsigned int GCEA_PERFCOUNTER2_MODE__COMPARE_VALUE0_MASK = 0x00000f00L;
    constexpr unsigned int GCEA_PERFCOUNTER2_MODE__COMPARE_VALUE1_MASK = 0x0000f000L;
    constexpr unsigned int GCEA_PERFCOUNTER2_MODE__COMPARE_VALUE2_MASK = 0x000f0000L;
    constexpr unsigned int GCEA_PERFCOUNTER2_MODE__COMPARE_VALUE3_MASK = 0x00f00000L;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT__PERF_SEL1_MASK = 0x000ffc00L;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT__PERF_SEL_MASK  = 0x000003ffL;
    constexpr unsigned int GCMC_MEM_POWER_LS__LS_HOLD_MASK          = 0x00000fc0L;
    constexpr unsigned int GCMC_MEM_POWER_LS__LS_SETUP_MASK         = 0x0000003fL;
    constexpr unsigned int GCMC_SHARED_ACTIVE_FCN_ID__VFID_MASK     = 0x0000001fL;
    constexpr unsigned int GCMC_SHARED_ACTIVE_FCN_ID__VF_MASK       = 0x80000000L;
    constexpr unsigned int GCMC_SHARED_VIRT_RESET_REQ2__VF_MASK     = 0x00000001L;
    constexpr unsigned int GCMC_SHARED_VIRT_RESET_REQ__PF_MASK      = 0x80000000L;
    constexpr unsigned int GCMC_SHARED_VIRT_RESET_REQ__VF_MASK      = 0x7fffffffL;
    constexpr unsigned int GCMC_VM_AGP_BASE__AGP_BASE_MASK          = 0x00ffffffL;
    constexpr unsigned int GCMC_VM_AGP_BOT__AGP_BOT_MASK            = 0x00ffffffL;
    constexpr unsigned int GCMC_VM_AGP_TOP__AGP_TOP_MASK            = 0x00ffffffL;
    constexpr unsigned int GCMC_VM_APT_CNTL__DIRECT_SYSTEM_EN_MASK  = 0x00000002L;
    constexpr unsigned int GCMC_VM_APT_CNTL__FORCE_MTYPE_UC_MASK    = 0x00000001L;
    constexpr unsigned int GCMC_VM_CACHEABLE_DRAM_ADDRESS_END__ADDRESS_MASK = 0x000fffffL;
    constexpr unsigned int GCMC_VM_CACHEABLE_DRAM_ADDRESS_START__ADDRESS_MASK = 0x000fffffL;
    constexpr unsigned int GCMC_VM_FB_LOCATION_BASE__FB_BASE_MASK   = 0x00ffffffL;
    constexpr unsigned int GCMC_VM_FB_LOCATION_TOP__FB_TOP_MASK     = 0x00ffffffL;
    constexpr unsigned int GCMC_VM_FB_OFFSET__FB_OFFSET_MASK        = 0x00ffffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF0__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF0__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF1__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF1__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF2__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF2__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF3__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF3__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF4__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF4__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF5__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF5__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF6__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF6__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF7__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF7__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF8__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF8__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF9__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF9__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF10__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF10__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF11__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF11__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF12__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF12__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF13__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF13__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF14__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF14__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF15__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF15__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF16__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF16__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF17__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF17__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF18__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF18__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF19__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF19__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF20__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF20__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF21__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF21__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF22__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF22__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF23__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF23__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF24__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF24__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF25__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF25__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF26__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF26__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF27__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF27__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF28__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF28__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF29__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF29__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF30__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF30__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF31__VF_FB_OFFSET_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF31__VF_FB_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__CLEAR_MASK  = 0x20000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__ENABLE_MASK = 0x10000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__PERF_MODE_MASK = 0x0f000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__PERF_SEL_END_MASK = 0x0000ff00L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__PERF_SEL_MASK = 0x000000ffL;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__CLEAR_MASK  = 0x20000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__ENABLE_MASK = 0x10000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__PERF_MODE_MASK = 0x0f000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__PERF_SEL_END_MASK = 0x0000ff00L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__PERF_SEL_MASK = 0x000000ffL;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__CLEAR_MASK  = 0x20000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__ENABLE_MASK = 0x10000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__PERF_MODE_MASK = 0x0f000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__PERF_SEL_END_MASK = 0x0000ff00L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__PERF_SEL_MASK = 0x000000ffL;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__CLEAR_MASK  = 0x20000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__ENABLE_MASK = 0x10000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__PERF_MODE_MASK = 0x0f000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__PERF_SEL_END_MASK = 0x0000ff00L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__PERF_SEL_MASK = 0x000000ffL;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__CLEAR_MASK  = 0x20000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__ENABLE_MASK = 0x10000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__PERF_MODE_MASK = 0x0f000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__PERF_SEL_END_MASK = 0x0000ff00L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__PERF_SEL_MASK = 0x000000ffL;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__CLEAR_MASK  = 0x20000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__ENABLE_MASK = 0x10000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__PERF_MODE_MASK = 0x0f000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__PERF_SEL_END_MASK = 0x0000ff00L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__PERF_SEL_MASK = 0x000000ffL;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__CLEAR_MASK  = 0x20000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__ENABLE_MASK = 0x10000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__PERF_MODE_MASK = 0x0f000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__PERF_SEL_END_MASK = 0x0000ff00L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__PERF_SEL_MASK = 0x000000ffL;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__CLEAR_MASK  = 0x20000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__ENABLE_MASK = 0x10000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__PERF_MODE_MASK = 0x0f000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__PERF_SEL_END_MASK = 0x0000ff00L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__PERF_SEL_MASK = 0x000000ffL;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_HI__COMPARE_VALUE_MASK = 0xffff0000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_HI__COUNTER_HI_MASK = 0x0000ffffL;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_LO__COUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL_MASK = 0x02000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY_MASK = 0x01000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT_MASK = 0x0000000fL;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__START_TRIGGER_MASK = 0x0000ff00L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE_MASK = 0x04000000L;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER_MASK = 0x00ff0000L;
    constexpr unsigned int GCMC_VM_LOCAL_HBM_ADDRESS_END__ADDRESS_MASK = 0x000fffffL;
    constexpr unsigned int GCMC_VM_LOCAL_HBM_ADDRESS_LOCK_CNTL__LOCK_MASK = 0x00000001L;
    constexpr unsigned int GCMC_VM_LOCAL_HBM_ADDRESS_START__ADDRESS_MASK = 0x000fffffL;
    constexpr unsigned int GCMC_VM_MARC_BASE_HI_0__MARC_BASE_HI_0_MASK = 0x000fffffL;
    constexpr unsigned int GCMC_VM_MARC_BASE_HI_1__MARC_BASE_HI_1_MASK = 0x000fffffL;
    constexpr unsigned int GCMC_VM_MARC_BASE_HI_2__MARC_BASE_HI_2_MASK = 0x000fffffL;
    constexpr unsigned int GCMC_VM_MARC_BASE_HI_3__MARC_BASE_HI_3_MASK = 0x000fffffL;
    constexpr unsigned int GCMC_VM_MARC_BASE_LO_0__MARC_BASE_LO_0_MASK = 0xfffff000L;
    constexpr unsigned int GCMC_VM_MARC_BASE_LO_1__MARC_BASE_LO_1_MASK = 0xfffff000L;
    constexpr unsigned int GCMC_VM_MARC_BASE_LO_2__MARC_BASE_LO_2_MASK = 0xfffff000L;
    constexpr unsigned int GCMC_VM_MARC_BASE_LO_3__MARC_BASE_LO_3_MASK = 0xfffff000L;
    constexpr unsigned int GCMC_VM_MARC_LEN_HI_0__MARC_LEN_HI_0_MASK = 0x000fffffL;
    constexpr unsigned int GCMC_VM_MARC_LEN_HI_1__MARC_LEN_HI_1_MASK = 0x000fffffL;
    constexpr unsigned int GCMC_VM_MARC_LEN_HI_2__MARC_LEN_HI_2_MASK = 0x000fffffL;
    constexpr unsigned int GCMC_VM_MARC_LEN_HI_3__MARC_LEN_HI_3_MASK = 0x000fffffL;
    constexpr unsigned int GCMC_VM_MARC_LEN_LO_0__MARC_LEN_LO_0_MASK = 0xfffff000L;
    constexpr unsigned int GCMC_VM_MARC_LEN_LO_1__MARC_LEN_LO_1_MASK = 0xfffff000L;
    constexpr unsigned int GCMC_VM_MARC_LEN_LO_2__MARC_LEN_LO_2_MASK = 0xfffff000L;
    constexpr unsigned int GCMC_VM_MARC_LEN_LO_3__MARC_LEN_LO_3_MASK = 0xfffff000L;
    constexpr unsigned int GCMC_VM_MARC_RELOC_HI_0__MARC_RELOC_HI_0_MASK = 0x000fffffL;
    constexpr unsigned int GCMC_VM_MARC_RELOC_HI_1__MARC_RELOC_HI_1_MASK = 0x000fffffL;
    constexpr unsigned int GCMC_VM_MARC_RELOC_HI_2__MARC_RELOC_HI_2_MASK = 0x000fffffL;
    constexpr unsigned int GCMC_VM_MARC_RELOC_HI_3__MARC_RELOC_HI_3_MASK = 0x000fffffL;
    constexpr unsigned int GCMC_VM_MARC_RELOC_LO_0__MARC_ENABLE_0_MASK = 0x00000001L;
    constexpr unsigned int GCMC_VM_MARC_RELOC_LO_0__MARC_READONLY_0_MASK = 0x00000002L;
    constexpr unsigned int GCMC_VM_MARC_RELOC_LO_0__MARC_RELOC_LO_0_MASK = 0xfffff000L;
    constexpr unsigned int GCMC_VM_MARC_RELOC_LO_1__MARC_ENABLE_1_MASK = 0x00000001L;
    constexpr unsigned int GCMC_VM_MARC_RELOC_LO_1__MARC_READONLY_1_MASK = 0x00000002L;
    constexpr unsigned int GCMC_VM_MARC_RELOC_LO_1__MARC_RELOC_LO_1_MASK = 0xfffff000L;
    constexpr unsigned int GCMC_VM_MARC_RELOC_LO_2__MARC_ENABLE_2_MASK = 0x00000001L;
    constexpr unsigned int GCMC_VM_MARC_RELOC_LO_2__MARC_READONLY_2_MASK = 0x00000002L;
    constexpr unsigned int GCMC_VM_MARC_RELOC_LO_2__MARC_RELOC_LO_2_MASK = 0xfffff000L;
    constexpr unsigned int GCMC_VM_MARC_RELOC_LO_3__MARC_ENABLE_3_MASK = 0x00000001L;
    constexpr unsigned int GCMC_VM_MARC_RELOC_LO_3__MARC_READONLY_3_MASK = 0x00000002L;
    constexpr unsigned int GCMC_VM_MARC_RELOC_LO_3__MARC_RELOC_LO_3_MASK = 0xfffff000L;
    constexpr unsigned int GCMC_VM_MX_L1_TLB_CNTL__ECO_BITS_MASK    = 0x00000780L;
    constexpr unsigned int GCMC_VM_MX_L1_TLB_CNTL__ENABLE_ADVANCED_DRIVER_MODEL_MASK = 0x00000040L;
    constexpr unsigned int GCMC_VM_MX_L1_TLB_CNTL__ENABLE_L1_TLB_MASK = 0x00000001L;
    constexpr unsigned int GCMC_VM_MX_L1_TLB_CNTL__MTYPE_MASK       = 0x00003800L;
    constexpr unsigned int GCMC_VM_MX_L1_TLB_CNTL__SYSTEM_ACCESS_MODE_MASK = 0x00000018L;
    constexpr unsigned int GCMC_VM_MX_L1_TLB_CNTL__SYSTEM_APERTURE_UNMAPPED_ACCESS_MASK = 0x00000020L;
    constexpr unsigned int GCMC_VM_NB_LOWER_TOP_OF_DRAM2__ENABLE_MASK = 0x00000001L;
    constexpr unsigned int GCMC_VM_NB_LOWER_TOP_OF_DRAM2__LOWER_TOM2_MASK = 0xff800000L;
    constexpr unsigned int GCMC_VM_NB_MMIOBASE__MMIOBASE_MASK       = 0xffffffffL;
    constexpr unsigned int GCMC_VM_NB_MMIOLIMIT__MMIOLIMIT_MASK     = 0xffffffffL;
    constexpr unsigned int GCMC_VM_NB_PCI_ARB__VGA_HOLE_MASK        = 0x00000008L;
    constexpr unsigned int GCMC_VM_NB_PCI_CTRL__MMIOENABLE_MASK     = 0x00800000L;
    constexpr unsigned int GCMC_VM_NB_TOP_OF_DRAM_SLOT1__TOP_OF_DRAM_MASK = 0xff800000L;
    constexpr unsigned int GCMC_VM_NB_UPPER_TOP_OF_DRAM2__UPPER_TOM2_MASK = 0x00000fffL;
    constexpr unsigned int GCMC_VM_STEERING__DEFAULT_STEERING_MASK  = 0x00000003L;
    constexpr unsigned int GCMC_VM_SYSTEM_APERTURE_DEFAULT_ADDR_LSB__PHYSICAL_PAGE_NUMBER_LSB_MASK = 0xffffffffL;
    constexpr unsigned int GCMC_VM_SYSTEM_APERTURE_DEFAULT_ADDR_MSB__PHYSICAL_PAGE_NUMBER_MSB_MASK = 0x0000000fL;
    constexpr unsigned int GCMC_VM_SYSTEM_APERTURE_HIGH_ADDR__LOGICAL_ADDR_MASK = 0x3fffffffL;
    constexpr unsigned int GCMC_VM_SYSTEM_APERTURE_LOW_ADDR__LOGICAL_ADDR_MASK = 0x3fffffffL;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__OFF_HYSTERESIS_MASK  = 0x00000ff0L;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__ON_DELAY_MASK        = 0x0000000fL;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_OVERRIDE0_MASK  = 0x80000000L;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_OVERRIDE1_MASK  = 0x40000000L;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_OVERRIDE2_MASK  = 0x20000000L;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_OVERRIDE3_MASK  = 0x10000000L;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_OVERRIDE4_MASK  = 0x08000000L;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_OVERRIDE5_MASK  = 0x04000000L;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_OVERRIDE6_MASK  = 0x02000000L;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE0_MASK = 0x00800000L;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE1_MASK = 0x00400000L;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE2_MASK = 0x00200000L;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE3_MASK = 0x00100000L;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE4_MASK = 0x00080000L;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE5_MASK = 0x00040000L;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE6_MASK = 0x00020000L;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE7_MASK = 0x00010000L;
    constexpr unsigned int GCR_CMD_STATUS__GCR_CONTROL_MASK         = 0x0007ffffL;
    constexpr unsigned int GCR_CMD_STATUS__GCR_SEQ_OP_ERROR_MASK    = 0x40000000L;
    constexpr unsigned int GCR_CMD_STATUS__GCR_SRC_MASK             = 0x00700000L;
    constexpr unsigned int GCR_CMD_STATUS__GCR_TLB_SHOOTDOWN_MASK   = 0x00800000L;
    constexpr unsigned int GCR_CMD_STATUS__GCR_TLB_SHOOTDOWN_VMID_MASK = 0x0f000000L;
    constexpr unsigned int GCR_CMD_STATUS__UTCL2_NACK_ERROR_MASK    = 0x80000000L;
    constexpr unsigned int GCR_CMD_STATUS__UTCL2_NACK_STATUS_MASK   = 0x30000000L;
    constexpr unsigned int GCR_GENERAL_CNTL__BIG_PAGE_FILTER_DISABLE_MASK = 0x00000080L;
    constexpr unsigned int GCR_GENERAL_CNTL__CLIENT_ID_MASK         = 0x1ff00000L;
    constexpr unsigned int GCR_GENERAL_CNTL__FORCE_4K_L2_RESP_MASK  = 0x00000001L;
    constexpr unsigned int GCR_GENERAL_CNTL__FORCE_INV_ALL_MASK     = 0x00000008L;
    constexpr unsigned int GCR_GENERAL_CNTL__FORCE_SINGLE_WQ_MASK   = 0x00000200L;
    constexpr unsigned int GCR_GENERAL_CNTL__HI_PRIORITY_CNTL_MASK  = 0x00000030L;
    constexpr unsigned int GCR_GENERAL_CNTL__HI_PRIORITY_DISABLE_MASK = 0x00000040L;
    constexpr unsigned int GCR_GENERAL_CNTL__MIXED_RANGE_MODE_DIS_MASK = 0x00004000L;
    constexpr unsigned int GCR_GENERAL_CNTL__PERF_CNTR_ENABLE_MASK  = 0x00000100L;
    constexpr unsigned int GCR_GENERAL_CNTL__REDUCE_HALF_MAIN_WQ_MASK = 0x00000002L;
    constexpr unsigned int GCR_GENERAL_CNTL__REDUCE_HALF_PHY_WQ_MASK = 0x00000004L;
    constexpr unsigned int GCR_GENERAL_CNTL__TARGET_MGCG_CLKEN_DIS_MASK = 0x00002000L;
    constexpr unsigned int GCR_GENERAL_CNTL__UTCL2_REQ_PERM_MASK    = 0x00001c00L;
    constexpr unsigned int GCR_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GCR_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK = 0x000001ffL;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK = 0x0007fc00L;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT__PERF_SEL1_MASK  = 0x0007fc00L;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT__PERF_SEL_MASK   = 0x000001ffL;
    constexpr unsigned int GCR_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GCR_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GCR_PERFCOUNTER1_SELECT__CNTL_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int GCR_PERFCOUNTER1_SELECT__PERF_MODE_MASK  = 0x0f000000L;
    constexpr unsigned int GCR_PERFCOUNTER1_SELECT__PERF_SEL_MASK   = 0x000001ffL;
    constexpr unsigned int GCR_PIO_CNTL__GCR_DATA_INDEX_MASK        = 0x00000003L;
    constexpr unsigned int GCR_PIO_CNTL__GCR_PIO_RSP_DONE_MASK      = 0x40000000L;
    constexpr unsigned int GCR_PIO_CNTL__GCR_PIO_RSP_TAG_MASK       = 0x00ff0000L;
    constexpr unsigned int GCR_PIO_CNTL__GCR_READY_MASK             = 0x80000000L;
    constexpr unsigned int GCR_PIO_CNTL__GCR_REG_DONE_MASK          = 0x00000004L;
    constexpr unsigned int GCR_PIO_CNTL__GCR_REG_RESET_MASK         = 0x00000008L;
    constexpr unsigned int GCR_PIO_DATA__GCR_DATA_MASK              = 0xffffffffL;
    constexpr unsigned int GCR_SPARE__SPARE_BIT_1_MASK              = 0x00000002L;
    constexpr unsigned int GCR_SPARE__SPARE_BIT_2_MASK              = 0x00000004L;
    constexpr unsigned int GCR_SPARE__SPARE_BIT_3_MASK              = 0x00000008L;
    constexpr unsigned int GCR_SPARE__SPARE_BIT_4_MASK              = 0x00000010L;
    constexpr unsigned int GCR_SPARE__SPARE_BIT_5_MASK              = 0x00000020L;
    constexpr unsigned int GCR_SPARE__SPARE_BIT_6_MASK              = 0x00000040L;
    constexpr unsigned int GCR_SPARE__SPARE_BIT_7_MASK              = 0x00000080L;
    constexpr unsigned int GCR_SPARE__SPARE_BIT_8_0_MASK            = 0x0000ff00L;
    constexpr unsigned int GCR_SPARE__SPARE_BIT_31_16_MASK          = 0xffff0000L;
    constexpr unsigned int GCR_TARGET_DISABLE__DISABLE_GL2A0_PHY_MASK = 0x00000100L;
    constexpr unsigned int GCR_TARGET_DISABLE__DISABLE_GL2A1_PHY_MASK = 0x00000200L;
    constexpr unsigned int GCR_TARGET_DISABLE__DISABLE_GL2A2_PHY_MASK = 0x00000400L;
    constexpr unsigned int GCR_TARGET_DISABLE__DISABLE_GL2A3_PHY_MASK = 0x00000800L;
    constexpr unsigned int GCR_TARGET_DISABLE__DISABLE_SA0_PHY_MASK = 0x00000001L;
    constexpr unsigned int GCR_TARGET_DISABLE__DISABLE_SA0_VIRT_MASK = 0x00000002L;
    constexpr unsigned int GCR_TARGET_DISABLE__DISABLE_SA1_PHY_MASK = 0x00000004L;
    constexpr unsigned int GCR_TARGET_DISABLE__DISABLE_SA1_VIRT_MASK = 0x00000008L;
    constexpr unsigned int GCR_TARGET_DISABLE__DISABLE_SA2_PHY_MASK = 0x00000010L;
    constexpr unsigned int GCR_TARGET_DISABLE__DISABLE_SA2_VIRT_MASK = 0x00000020L;
    constexpr unsigned int GCR_TARGET_DISABLE__DISABLE_SA3_PHY_MASK = 0x00000040L;
    constexpr unsigned int GCR_TARGET_DISABLE__DISABLE_SA3_VIRT_MASK = 0x00000080L;
    constexpr unsigned int GCUTCL2_CGTT_CLK_CTRL__MGLS_OVERRIDE_MASK = 0x00008000L;
    constexpr unsigned int GCUTCL2_CGTT_CLK_CTRL__OFF_HYSTERESIS_MASK = 0x00000ff0L;
    constexpr unsigned int GCUTCL2_CGTT_CLK_CTRL__ON_DELAY_MASK     = 0x0000000fL;
    constexpr unsigned int GCUTCL2_CGTT_CLK_CTRL__SOFT_OVERRIDE_EXTRA_MASK = 0x00007000L;
    constexpr unsigned int GCUTCL2_CGTT_CLK_CTRL__SOFT_OVERRIDE_MASK = 0xff000000L;
    constexpr unsigned int GCUTCL2_CGTT_CLK_CTRL__SOFT_STALL_OVERRIDE_MASK = 0x00ff0000L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_MODE0_MASK = 0x00000003L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_MODE1_MASK = 0x0000000cL;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_MODE2_MASK = 0x00000030L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_MODE3_MASK = 0x000000c0L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_VALUE0_MASK = 0x00000f00L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_VALUE1_MASK = 0x0000f000L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_VALUE2_MASK = 0x000f0000L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_VALUE3_MASK = 0x00f00000L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__PERF_SEL1_MASK = 0x000ffc00L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__PERF_SEL_MASK = 0x000003ffL;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_MODE0_MASK = 0x00000003L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_MODE1_MASK = 0x0000000cL;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_MODE2_MASK = 0x00000030L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_MODE3_MASK = 0x000000c0L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_VALUE0_MASK = 0x00000f00L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_VALUE1_MASK = 0x0000f000L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_VALUE2_MASK = 0x000f0000L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_VALUE3_MASK = 0x00f00000L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__PERF_SEL1_MASK = 0x000ffc00L;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__PERF_SEL_MASK = 0x000003ffL;
    constexpr unsigned int GCVML2_WALKER_MACRO_THROTTLE_FETCH_LIMIT__LIMIT_MASK = 0x0000fffeL;
    constexpr unsigned int GCVML2_WALKER_MACRO_THROTTLE_TIME__TIME_MASK = 0x00ffffffL;
    constexpr unsigned int GCVML2_WALKER_MICRO_THROTTLE_FETCH_LIMIT__LIMIT_MASK = 0x0000fffeL;
    constexpr unsigned int GCVML2_WALKER_MICRO_THROTTLE_TIME__TIME_MASK = 0x00ffffffL;
    constexpr unsigned int GC_CAC_ACC_BCI1__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_SQ0_UPPER__UNUSED_0_MASK      = 0xffffff00L;
    constexpr unsigned int GC_CAC_ACC_SQ1_UPPER__UNUSED_0_MASK      = 0xffffff00L;
    constexpr unsigned int GC_CAC_ACC_SQ2_UPPER__UNUSED_0_MASK      = 0xffffff00L;
    constexpr unsigned int GC_CAC_ACC_SQ3_UPPER__UNUSED_0_MASK      = 0xffffff00L;
    constexpr unsigned int GC_CAC_ACC_SQ4_UPPER__UNUSED_0_MASK      = 0xffffff00L;
    constexpr unsigned int GC_CAC_ACC_SQ5_UPPER__UNUSED_0_MASK      = 0xffffff00L;
    constexpr unsigned int GC_CAC_ACC_SQ6_UPPER__UNUSED_0_MASK      = 0xffffff00L;
    constexpr unsigned int GC_CAC_ACC_SQ7_UPPER__UNUSED_0_MASK      = 0xffffff00L;
    constexpr unsigned int GC_CAC_ACC_SQ8_UPPER__UNUSED_0_MASK      = 0xffffff00L;
    constexpr unsigned int GC_CAC_CNTL__CAC_FORCE_DISABLE_MASK      = 0x00000001L;
    constexpr unsigned int GC_CAC_CNTL__UNUSED_0_MASK               = 0xfffe0000L;
    constexpr unsigned int GC_CAC_CTRL_2__GC_CAC_INDEX_AUTO_INCR_EN_MASK = 0x00000010L;
    constexpr unsigned int GC_CAC_OVRD_BCI__OVRRD_SELECT_MASK       = 0x00000003L;
    constexpr unsigned int GC_CAC_OVRD_BCI__OVRRD_VALUE_MASK        = 0x0000000cL;
    constexpr unsigned int GC_CAC_SOFT_CTRL__UNUSED_MASK            = 0xfffffffeL;
    constexpr unsigned int GC_CAC_WEIGHT_BCI_0__WEIGHT_BCI_SIG1_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_CP_1__UNUSED_0_MASK        = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_CU_0__UNUSED_0_MASK        = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_PC_0__UNUSED_0_MASK        = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_SXRB_0__UNUSED_0_MASK      = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_SX_0__UNUSED_0_MASK        = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_TA_0__UNUSED_0_MASK        = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ATCL2_2__UNUSED_0_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_UTCL2_VML2_2__UNUSED_0_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_UTCL2_WALKER_2__UNUSED_0_MASK = 0xffff0000L;
    constexpr unsigned int GC_EDC_CTRL__EDC_LEVEL_SEL_MASK          = 0x00004000L;
    constexpr unsigned int GC_EDC_CTRL__EDC_THROTTLE_PATTERN_BIT_NUMS_MASK = 0x00003c00L;
    constexpr unsigned int GC_IH_COOKIE_0_PTR__ADDR_MASK            = 0x000fffffL;
    constexpr unsigned int GC_THROTTLE_CTRL__FIXED_PATTERN_PERF_COUNTER_EN_MASK = 0x00800000L;
    constexpr unsigned int GC_THROTTLE_CTRL__GC_EDC_ONLY_MODE_MASK  = 0x00000040L;
    constexpr unsigned int GC_THROTTLE_CTRL__GC_EDC_OVERRIDE_MASK   = 0x00000080L;
    constexpr unsigned int GC_THROTTLE_CTRL__GC_EDC_PERF_COUNTER_EN_MASK = 0x00000400L;
    constexpr unsigned int GC_THROTTLE_CTRL__GC_EDC_STALL_EN_MASK   = 0x00000002L;
    constexpr unsigned int GC_THROTTLE_CTRL__LUT_HW_UPDATE_MASK     = 0x20000000L;
    constexpr unsigned int GC_THROTTLE_CTRL__PATTERN_MODE_MASK      = 0x00000020L;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_OVERRIDE_MASK      = 0x00000100L;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_PERF_COUNTER_EN_MASK = 0x00000800L;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_STALL_EN_MASK      = 0x00000010L;
    constexpr unsigned int GC_THROTTLE_CTRL__PWRBRK_OVERRIDE_MASK   = 0x00000200L;
    constexpr unsigned int GC_THROTTLE_CTRL__PWRBRK_PERF_COUNTER_EN_MASK = 0x00001000L;
    constexpr unsigned int GC_THROTTLE_CTRL__PWRBRK_POLARITY_CNTL_MASK = 0x00000008L;
    constexpr unsigned int GC_THROTTLE_CTRL__PWRBRK_STALL_EN_MASK   = 0x00000004L;
    constexpr unsigned int GC_THROTTLE_CTRL__RELEASE_STEP_INTERVAL_MASK = 0x007fe000L;
    constexpr unsigned int GC_THROTTLE_CTRL__THROTTLE_CTRL_SW_RST_MASK = 0x00000001L;
    constexpr unsigned int GC_THROTTLE_STATUS__FSM_STATE_MASK       = 0x0000000fL;
    constexpr unsigned int GC_THROTTLE_STATUS__PATTERN_INDEX_MASK   = 0x000003f0L;
    constexpr unsigned int GC_USER_RMI_REDUNDANCY__REPAIR_EN_IN_0_MASK = 0x00000002L;
    constexpr unsigned int GC_USER_RMI_REDUNDANCY__REPAIR_EN_IN_1_MASK = 0x00000004L;
    constexpr unsigned int GC_USER_RMI_REDUNDANCY__REPAIR_ID_SWAP_MASK = 0x00000010L;
    constexpr unsigned int GC_USER_RMI_REDUNDANCY__REPAIR_RMI_OVERRIDE_MASK = 0x00000008L;
    constexpr unsigned int GC_USER_SHADER_ARRAY_CONFIG__INACTIVE_WGPS_MASK = 0xffff0000L;
    constexpr unsigned int GE_CNTL__BREAK_WAVE_AT_EOI_MASK          = 0x00040000L;
    constexpr unsigned int GE_CNTL__PACKET_TO_ONE_PA_MASK           = 0x00080000L;
    constexpr unsigned int GE_CNTL__PRIM_GRP_SIZE_MASK              = 0x000001ffL;
    constexpr unsigned int GE_CNTL__VERT_GRP_SIZE_MASK              = 0x0003fe00L;
    constexpr unsigned int GE_DMA_FIRST_INDEX__FIRST_INDEX_MASK     = 0xffffffffL;
    constexpr unsigned int GE_INDX_OFFSET__INDX_OFFSET_MASK         = 0xffffffffL;
    constexpr unsigned int GE_MAX_OUTPUT_PER_SUBGROUP__MAX_VERTS_PER_SUBGROUP_MASK = 0x000003ffL;
    constexpr unsigned int GE_MAX_VTX_INDX__MAX_INDX_MASK           = 0xffffffffL;
    constexpr unsigned int GE_MIN_VTX_INDX__MIN_INDX_MASK           = 0xffffffffL;
    constexpr unsigned int GE_MULTI_PRIM_IB_RESET_EN__MATCH_ALL_BITS_MASK = 0x00000002L;
    constexpr unsigned int GE_MULTI_PRIM_IB_RESET_EN__RESET_EN_MASK = 0x00000001L;
    constexpr unsigned int GE_NGG_SUBGRP_CNTL__PRIM_AMP_FACTOR_MASK = 0x000001ffL;
    constexpr unsigned int GE_NGG_SUBGRP_CNTL__THDS_PER_SUBGRP_MASK = 0x0003fe00L;
    constexpr unsigned int GE_PC_ALLOC__NUM_PC_LINES_MASK           = 0x000007feL;
    constexpr unsigned int GE_PC_ALLOC__OVERSUB_EN_MASK             = 0x00000001L;
    constexpr unsigned int GE_PC_CNTL__EN_GEN_0_1_LATE_ALLOC_MASK   = 0x00010000L;
    constexpr unsigned int GE_PC_CNTL__PC_SIZE_MASK                 = 0x0000ffffL;
    constexpr unsigned int GE_PRIV_CONTROL__CLAMP_PRIMGRP_SIZE_MASK = 0x000003feL;
    constexpr unsigned int GE_PRIV_CONTROL__DISCARD_LEGACY_MASK     = 0x00000001L;
    constexpr unsigned int GE_PRIV_CONTROL__RESET_ON_PIPELINE_CHANGE_MASK = 0x00000400L;
    constexpr unsigned int GE_STEREO_CNTL__EN_STEREO_MASK           = 0x00000100L;
    constexpr unsigned int GE_STEREO_CNTL__RT_SLICE_MASK            = 0x00000007L;
    constexpr unsigned int GE_STEREO_CNTL__VIEWPORT_MASK            = 0x00000078L;
    constexpr unsigned int GE_USER_VGPR1__DATA_MASK                 = 0xffffffffL;
    constexpr unsigned int GE_USER_VGPR2__DATA_MASK                 = 0xffffffffL;
    constexpr unsigned int GE_USER_VGPR3__DATA_MASK                 = 0xffffffffL;
    constexpr unsigned int GFX_PIPE_PRIORITY__HP_PIPE_SELECT_MASK   = 0x00000001L;
    constexpr unsigned int GL1A_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GL1A_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0x0f000000L;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0xf0000000L;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__PERF_SEL1_MASK = 0x000ffc00L;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__PERF_SEL_MASK  = 0x000003ffL;
    constexpr unsigned int GL1A_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GL1A_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GL1A_PERFCOUNTER1_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int GL1A_PERFCOUNTER1_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int GL1A_PERFCOUNTER1_SELECT__PERF_SEL_MASK  = 0x000003ffL;
    constexpr unsigned int GL1A_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GL1A_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GL1A_PERFCOUNTER2_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int GL1A_PERFCOUNTER2_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int GL1A_PERFCOUNTER2_SELECT__PERF_SEL_MASK  = 0x000003ffL;
    constexpr unsigned int GL1A_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GL1A_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GL1A_PERFCOUNTER3_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int GL1A_PERFCOUNTER3_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int GL1A_PERFCOUNTER3_SELECT__PERF_SEL_MASK  = 0x000003ffL;
    constexpr unsigned int GL1C_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GL1C_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0x0f000000L;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0xf0000000L;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__PERF_SEL1_MASK = 0x000ffc00L;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__PERF_SEL_MASK  = 0x000003ffL;
    constexpr unsigned int GL1C_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GL1C_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GL1C_PERFCOUNTER1_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int GL1C_PERFCOUNTER1_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int GL1C_PERFCOUNTER1_SELECT__PERF_SEL_MASK  = 0x000003ffL;
    constexpr unsigned int GL1C_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GL1C_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GL1C_PERFCOUNTER2_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int GL1C_PERFCOUNTER2_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int GL1C_PERFCOUNTER2_SELECT__PERF_SEL_MASK  = 0x000003ffL;
    constexpr unsigned int GL1C_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GL1C_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GL1C_PERFCOUNTER3_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int GL1C_PERFCOUNTER3_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int GL1C_PERFCOUNTER3_SELECT__PERF_SEL_MASK  = 0x000003ffL;
    constexpr unsigned int GL1_ARB_STATUS__REQ_ARB_BUSY_MASK        = 0x00000001L;
    constexpr unsigned int GL1_ARB_STATUS__RET_ARB_BUSY_MASK        = 0x00000002L;
    constexpr unsigned int GL1_DRAM_BURST_CTRL__BURST_DISABLE_MASK  = 0x00000008L;
    constexpr unsigned int GL1_DRAM_BURST_CTRL__MAX_DRAM_BURST_MASK = 0x00000007L;
    constexpr unsigned int GL1_DRAM_BURST_MASK__DRAM_BURST_ADDR_MASK_MASK = 0x000000ffL;
    constexpr unsigned int GL1_PIPE_STEER__PIPE0_MASK               = 0x00000003L;
    constexpr unsigned int GL1_PIPE_STEER__PIPE1_MASK               = 0x0000000cL;
    constexpr unsigned int GL1_PIPE_STEER__PIPE2_MASK               = 0x00000030L;
    constexpr unsigned int GL1_PIPE_STEER__PIPE3_MASK               = 0x000000c0L;
    constexpr unsigned int GL2A_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GL2A_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0x0f000000L;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0xf0000000L;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__PERF_SEL1_MASK = 0x000ffc00L;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__PERF_SEL_MASK  = 0x000003ffL;
    constexpr unsigned int GL2A_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GL2A_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK = 0x0f000000L;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK = 0xf0000000L;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__PERF_SEL1_MASK = 0x000ffc00L;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__PERF_SEL_MASK  = 0x000003ffL;
    constexpr unsigned int GL2A_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GL2A_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GL2A_PERFCOUNTER2_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int GL2A_PERFCOUNTER2_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int GL2A_PERFCOUNTER2_SELECT__PERF_SEL_MASK  = 0x000003ffL;
    constexpr unsigned int GL2A_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GL2A_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GL2A_PERFCOUNTER3_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int GL2A_PERFCOUNTER3_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int GL2A_PERFCOUNTER3_SELECT__PERF_SEL_MASK  = 0x000003ffL;
    constexpr unsigned int GL2C_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GL2C_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0x0f000000L;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0xf0000000L;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__PERF_SEL1_MASK = 0x000ffc00L;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__PERF_SEL_MASK  = 0x000003ffL;
    constexpr unsigned int GL2C_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GL2C_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK = 0x0f000000L;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK = 0xf0000000L;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__PERF_SEL1_MASK = 0x000ffc00L;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__PERF_SEL_MASK  = 0x000003ffL;
    constexpr unsigned int GL2C_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GL2C_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GL2C_PERFCOUNTER2_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int GL2C_PERFCOUNTER2_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int GL2C_PERFCOUNTER2_SELECT__PERF_SEL_MASK  = 0x000003ffL;
    constexpr unsigned int GL2C_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GL2C_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GL2C_PERFCOUNTER3_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int GL2C_PERFCOUNTER3_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int GL2C_PERFCOUNTER3_SELECT__PERF_SEL_MASK  = 0x000003ffL;
    constexpr unsigned int GL2_PIPE_STEER_0__PIPE_0_TO_CHAN_IN_Q0_MASK = 0x00000007L;
    constexpr unsigned int GL2_PIPE_STEER_0__PIPE_0_TO_CHAN_IN_Q1_MASK = 0x00070000L;
    constexpr unsigned int GL2_PIPE_STEER_0__PIPE_1_TO_CHAN_IN_Q0_MASK = 0x00000070L;
    constexpr unsigned int GL2_PIPE_STEER_0__PIPE_1_TO_CHAN_IN_Q1_MASK = 0x00700000L;
    constexpr unsigned int GL2_PIPE_STEER_0__PIPE_2_TO_CHAN_IN_Q0_MASK = 0x00000700L;
    constexpr unsigned int GL2_PIPE_STEER_0__PIPE_2_TO_CHAN_IN_Q1_MASK = 0x07000000L;
    constexpr unsigned int GL2_PIPE_STEER_0__PIPE_3_TO_CHAN_IN_Q0_MASK = 0x00007000L;
    constexpr unsigned int GL2_PIPE_STEER_0__PIPE_3_TO_CHAN_IN_Q1_MASK = 0x70000000L;
    constexpr unsigned int GL2_PIPE_STEER_1__PIPE_0_TO_CHAN_IN_Q2_MASK = 0x00000007L;
    constexpr unsigned int GL2_PIPE_STEER_1__PIPE_0_TO_CHAN_IN_Q3_MASK = 0x00070000L;
    constexpr unsigned int GL2_PIPE_STEER_1__PIPE_1_TO_CHAN_IN_Q2_MASK = 0x00000070L;
    constexpr unsigned int GL2_PIPE_STEER_1__PIPE_1_TO_CHAN_IN_Q3_MASK = 0x00700000L;
    constexpr unsigned int GL2_PIPE_STEER_1__PIPE_2_TO_CHAN_IN_Q2_MASK = 0x00000700L;
    constexpr unsigned int GL2_PIPE_STEER_1__PIPE_2_TO_CHAN_IN_Q3_MASK = 0x07000000L;
    constexpr unsigned int GL2_PIPE_STEER_1__PIPE_3_TO_CHAN_IN_Q2_MASK = 0x00007000L;
    constexpr unsigned int GL2_PIPE_STEER_1__PIPE_3_TO_CHAN_IN_Q3_MASK = 0x70000000L;
    constexpr unsigned int GRBM_CAM_DATA_UPPER__CAM_ADDR_MASK       = 0x00000003L;
    constexpr unsigned int GRBM_CAM_DATA_UPPER__CAM_REMAPADDR_MASK  = 0x00030000L;
    constexpr unsigned int GRBM_CAM_INDEX__CAM_INDEX_MASK           = 0x0000000fL;
    constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SA_BROADCAST_WRITES_MASK = 0x20000000L;
    constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SA_INDEX_MASK    = 0x0000ff00L;
    constexpr unsigned int GRBM_GFX_INDEX__SA_BROADCAST_WRITES_MASK = 0x20000000L;
    constexpr unsigned int GRBM_GFX_INDEX__SA_INDEX_MASK            = 0x0000ff00L;
    constexpr unsigned int GRBM_HYP_CAM_DATA_UPPER__CAM_ADDR_MASK   = 0x00000003L;
    constexpr unsigned int GRBM_HYP_CAM_DATA_UPPER__CAM_REMAPADDR_MASK = 0x00030000L;
    constexpr unsigned int GRBM_HYP_CAM_INDEX__CAM_INDEX_MASK       = 0x0000000fL;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__CH_BUSY_USER_DEFINED_MASK_MASK = 0x00000010L;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__GL1CC_BUSY_USER_DEFINED_MASK_MASK = 0x00000100L;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__GL2CC_BUSY_USER_DEFINED_MASK_MASK = 0x00000004L;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__GUS_BUSY_USER_DEFINED_MASK_MASK = 0x00000080L;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__PH_BUSY_USER_DEFINED_MASK_MASK = 0x00000020L;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__PMM_BUSY_USER_DEFINED_MASK_MASK = 0x00000040L;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__SDMA_BUSY_USER_DEFINED_MASK_MASK = 0x00000008L;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__UTCL1_BUSY_USER_DEFINED_MASK_MASK = 0x00000002L;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__GE_BUSY_USER_DEFINED_MASK_MASK = 0x10000000L;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__TCP_BUSY_USER_DEFINED_MASK_MASK = 0x08000000L;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__CH_BUSY_USER_DEFINED_MASK_MASK = 0x00000010L;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__GL1CC_BUSY_USER_DEFINED_MASK_MASK = 0x00000100L;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__GL2CC_BUSY_USER_DEFINED_MASK_MASK = 0x00000004L;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__GUS_BUSY_USER_DEFINED_MASK_MASK = 0x00000080L;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__PH_BUSY_USER_DEFINED_MASK_MASK = 0x00000020L;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__PMM_BUSY_USER_DEFINED_MASK_MASK = 0x00000040L;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__SDMA_BUSY_USER_DEFINED_MASK_MASK = 0x00000008L;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__UTCL1_BUSY_USER_DEFINED_MASK_MASK = 0x00000002L;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__GE_BUSY_USER_DEFINED_MASK_MASK = 0x10000000L;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__TCP_BUSY_USER_DEFINED_MASK_MASK = 0x08000000L;
    constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__GL1CC_BUSY_USER_DEFINED_MASK_MASK = 0x02000000L;
    constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__TCP_BUSY_USER_DEFINED_MASK_MASK = 0x01000000L;
    constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__UTCL1_BUSY_USER_DEFINED_MASK_MASK = 0x00800000L;
    constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__GL1CC_BUSY_USER_DEFINED_MASK_MASK = 0x02000000L;
    constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__TCP_BUSY_USER_DEFINED_MASK_MASK = 0x01000000L;
    constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__UTCL1_BUSY_USER_DEFINED_MASK_MASK = 0x00800000L;
    constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__GL1CC_BUSY_USER_DEFINED_MASK_MASK = 0x02000000L;
    constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__TCP_BUSY_USER_DEFINED_MASK_MASK = 0x01000000L;
    constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__UTCL1_BUSY_USER_DEFINED_MASK_MASK = 0x00800000L;
    constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__GL1CC_BUSY_USER_DEFINED_MASK_MASK = 0x02000000L;
    constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__TCP_BUSY_USER_DEFINED_MASK_MASK = 0x01000000L;
    constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__UTCL1_BUSY_USER_DEFINED_MASK_MASK = 0x00800000L;
    constexpr unsigned int GRBM_SOFT_RESET__SOFT_RESET_SDMA0_MASK   = 0x00800000L;
    constexpr unsigned int GRBM_SOFT_RESET__SOFT_RESET_SDMA1_MASK   = 0x01000000L;
    constexpr unsigned int GRBM_STATUS2__SDMA0_RQ_PENDING_MASK      = 0x00400000L;
    constexpr unsigned int GRBM_STATUS2__SDMA1_RQ_PENDING_MASK      = 0x00800000L;
    constexpr unsigned int GRBM_STATUS2__SDMA_BUSY_MASK             = 0x00200000L;
    constexpr unsigned int GRBM_STATUS3__CH_BUSY_MASK               = 0x00004000L;
    constexpr unsigned int GRBM_STATUS3__GL1CC_BUSY_MASK            = 0x00010000L;
    constexpr unsigned int GRBM_STATUS3__GL2CC_BUSY_MASK            = 0x00008000L;
    constexpr unsigned int GRBM_STATUS3__GRBM_CPF_INTR_CREDIT_PENDING_MASK = 0x00000080L;
    constexpr unsigned int GRBM_STATUS3__GRBM_RLC_INTR_CREDIT_PENDING_MASK = 0x00000020L;
    constexpr unsigned int GRBM_STATUS3__GRBM_UTCL2_INTR_CREDIT_PENDING_MASK = 0x00000040L;
    constexpr unsigned int GRBM_STATUS3__GUS_BUSY_MASK              = 0x20000000L;
    constexpr unsigned int GRBM_STATUS3__GUS_LINK_BUSY_MASK         = 0x10000000L;
    constexpr unsigned int GRBM_STATUS3__MESPIPE0_RQ_PENDING_MASK   = 0x00000100L;
    constexpr unsigned int GRBM_STATUS3__MESPIPE1_RQ_PENDING_MASK   = 0x00000200L;
    constexpr unsigned int GRBM_STATUS3__MESPIPE2_RQ_PENDING_MASK   = 0x00000400L;
    constexpr unsigned int GRBM_STATUS3__MESPIPE3_RQ_PENDING_MASK   = 0x00000800L;
    constexpr unsigned int GRBM_STATUS3__PH_BUSY_MASK               = 0x00002000L;
    constexpr unsigned int GRBM_STATUS3__PMM_BUSY_MASK              = 0x80000000L;
    constexpr unsigned int GRBM_STATUS3__UTCL1_BUSY_MASK            = 0x40000000L;
    constexpr unsigned int GRBM_STATUS_SE0__GL1CC_BUSY_MASK         = 0x00000020L;
    constexpr unsigned int GRBM_STATUS_SE0__TCP_BUSY_MASK           = 0x00000010L;
    constexpr unsigned int GRBM_STATUS_SE0__UTCL1_BUSY_MASK         = 0x00000008L;
    constexpr unsigned int GRBM_STATUS_SE1__GL1CC_BUSY_MASK         = 0x00000020L;
    constexpr unsigned int GRBM_STATUS_SE1__TCP_BUSY_MASK           = 0x00000010L;
    constexpr unsigned int GRBM_STATUS_SE1__UTCL1_BUSY_MASK         = 0x00000008L;
    constexpr unsigned int GRBM_STATUS_SE2__GL1CC_BUSY_MASK         = 0x00000020L;
    constexpr unsigned int GRBM_STATUS_SE2__TCP_BUSY_MASK           = 0x00000010L;
    constexpr unsigned int GRBM_STATUS_SE2__UTCL1_BUSY_MASK         = 0x00000008L;
    constexpr unsigned int GRBM_STATUS_SE3__GL1CC_BUSY_MASK         = 0x00000020L;
    constexpr unsigned int GRBM_STATUS_SE3__TCP_BUSY_MASK           = 0x00000010L;
    constexpr unsigned int GRBM_STATUS_SE3__UTCL1_BUSY_MASK         = 0x00000008L;
    constexpr unsigned int GRBM_STATUS__GE_BUSY_MASK                = 0x00200000L;
    constexpr unsigned int GRBM_STATUS__GE_BUSY_NO_DMA_MASK         = 0x00010000L;
    constexpr unsigned int GRBM_WRITE_ERROR__WRITE_VFID_MASK        = 0x000007e0L;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__EN_INST_OPT_ADV_MASK = 0x00400000L;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__EN_INST_OPT_BASIC_MASK = 0x00200000L;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__HW_USE_ONLY_MASK = 0x00800000L;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__PARTIAL_ES_WAVE_ON_MASK = 0x00040000L;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__PARTIAL_VS_WAVE_ON_MASK = 0x00010000L;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__PRIMGROUP_SIZE_MASK = 0x0000ffffL;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__SWITCH_ON_EOI_MASK = 0x00080000L;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__SWITCH_ON_EOP_MASK = 0x00020000L;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__WD_SWITCH_ON_EOP_MASK = 0x00100000L;
    constexpr unsigned int IA_UTCL1_CNTL__MTYPE_OVERRIDE_MASK       = 0x20000000L;
    constexpr unsigned int IA_UTCL1_STATUS_2__FAULT_DETECTED_MASK   = 0x00000020L;
    constexpr unsigned int IA_UTCL1_STATUS_2__FAULT_UTCL1ID_MASK    = 0x00003f00L;
    constexpr unsigned int IA_UTCL1_STATUS_2__IA_ADC_BUSY_MASK      = 0x00000010L;
    constexpr unsigned int IA_UTCL1_STATUS_2__IA_BUSY_MASK          = 0x00000001L;
    constexpr unsigned int IA_UTCL1_STATUS_2__IA_DMA_BUSY_MASK      = 0x00000002L;
    constexpr unsigned int IA_UTCL1_STATUS_2__IA_DMA_REQ_BUSY_MASK  = 0x00000004L;
    constexpr unsigned int IA_UTCL1_STATUS_2__IA_GRP_BUSY_MASK      = 0x00000008L;
    constexpr unsigned int IA_UTCL1_STATUS_2__PRT_DETECTED_MASK     = 0x00000080L;
    constexpr unsigned int IA_UTCL1_STATUS_2__PRT_UTCL1ID_MASK      = 0x3f000000L;
    constexpr unsigned int IA_UTCL1_STATUS_2__RETRY_DETECTED_MASK   = 0x00000040L;
    constexpr unsigned int IA_UTCL1_STATUS_2__RETRY_UTCL1ID_MASK    = 0x003f0000L;
    constexpr unsigned int PA_CL_CNTL_STATUS__CL_BUSY_MASK          = 0x80000000L;
    constexpr unsigned int PA_CL_ENHANCE__DISABLE_PA_PH_INTF_FINE_CLOCK_GATE_MASK = 0x00400000L;
    constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_LINE_WIDTH_MASK = 0x08000000L;
    constexpr unsigned int PA_PH_ENHANCE__DISABLE_FOPKT_MASK        = 0x00000020L;
    constexpr unsigned int PA_PH_ENHANCE__DISABLE_FOPKT_SCAN_POST_RESET_MASK = 0x00000040L;
    constexpr unsigned int PA_PH_ENHANCE__DISABLE_PH_PERF_REG_FGCG_MASK = 0x00000200L;
    constexpr unsigned int PA_PH_ENHANCE__DISABLE_PH_SC_INTF_CLKEN_CLOCK_GATE_MASK = 0x00000080L;
    constexpr unsigned int PA_PH_ENHANCE__DISABLE_PH_SC_INTF_FINE_CLOCK_GATE_MASK = 0x00000010L;
    constexpr unsigned int PA_PH_ENHANCE__ECO_SPARE0_MASK           = 0x00000001L;
    constexpr unsigned int PA_PH_ENHANCE__ECO_SPARE1_MASK           = 0x00000002L;
    constexpr unsigned int PA_PH_ENHANCE__ECO_SPARE2_MASK           = 0x00000004L;
    constexpr unsigned int PA_PH_ENHANCE__ECO_SPARE3_MASK           = 0x00000008L;
    constexpr unsigned int PA_PH_ENHANCE__ENABLE_PH_INTF_CLKEN_STRETCH_MASK = 0x00001c00L;
    constexpr unsigned int PA_PH_INTERFACE_FIFO_SIZE__PA_PH_IF_FIFO_SIZE_MASK = 0x000003ffL;
    constexpr unsigned int PA_PH_INTERFACE_FIFO_SIZE__PH_SC_IF_FIFO_SIZE_MASK = 0x003f0000L;
    constexpr unsigned int PA_PH_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int PA_PH_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__PERF_SEL1_MASK = 0x000ffc00L;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__PERF_SEL_MASK = 0x000003ffL;
    constexpr unsigned int PA_PH_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int PA_PH_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__PERF_SEL1_MASK = 0x000ffc00L;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__PERF_SEL_MASK = 0x000003ffL;
    constexpr unsigned int PA_PH_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int PA_PH_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__PERF_SEL1_MASK = 0x000ffc00L;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__PERF_SEL_MASK = 0x000003ffL;
    constexpr unsigned int PA_PH_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int PA_PH_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__PERF_SEL1_MASK = 0x000ffc00L;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__PERF_SEL_MASK = 0x000003ffL;
    constexpr unsigned int PA_PH_PERFCOUNTER4_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int PA_PH_PERFCOUNTER4_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int PA_PH_PERFCOUNTER4_SELECT__PERF_SEL_MASK = 0x000003ffL;
    constexpr unsigned int PA_PH_PERFCOUNTER5_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int PA_PH_PERFCOUNTER5_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int PA_PH_PERFCOUNTER5_SELECT__PERF_SEL_MASK = 0x000003ffL;
    constexpr unsigned int PA_PH_PERFCOUNTER6_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int PA_PH_PERFCOUNTER6_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int PA_PH_PERFCOUNTER6_SELECT__PERF_SEL_MASK = 0x000003ffL;
    constexpr unsigned int PA_PH_PERFCOUNTER7_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int PA_PH_PERFCOUNTER7_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int PA_PH_PERFCOUNTER7_SELECT__PERF_SEL_MASK = 0x000003ffL;
    constexpr unsigned int PA_SC_BC_WAVE_BREAK__MAX_DEALLOCS_IN_WAVE_MASK = 0x000007ffL;
    constexpr unsigned int PA_SC_BC_WAVE_BREAK__MAX_FPOVS_IN_WAVE_MASK = 0x00ff0000L;
    constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_MAPPING_MODE_MASK = 0x60000000L;
    constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__BINNING_MODE_MASK = 0x00000003L;
    constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__CONTEXT_STATES_PER_BIN_MASK = 0x00001c00L;
    constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__DIRECT_OVERRIDE_MODE_MASK = 0x08000000L;
    constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__FPOVS_PER_BATCH_MASK = 0x07f80000L;
    constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__OVERRIDE_MASK = 0xf0000000L;
    constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__PERSISTENT_STATES_PER_BIN_MASK = 0x0003e000L;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__BIN_CONF_OVERRIDE_CHECK_MASK = 0x0c000000L;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__RESERVED_35_MASK = 0x000000c0L;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__RESERVED_41_MASK = 0x000c0000L;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__DRAW_DONE_MASK = 0xc0000000L;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__RESERVED_50_MASK = 0x00000030L;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_DRAW_MASK = 0x00003000L;
    constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNCERTAINTY_REGION_MULT_MASK = 0x06000000L;
    constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNCERTAINTY_REGION_PBB_MULT_MASK = 0x18000000L;
    constexpr unsigned int PA_SC_ENHANCE_1__DEBUG_PIXEL_PICKER_COUNT_PIXELS_MASK = 0x00002000L;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_BREAK_BATCH_ON_GFX_PIPELINE_RESET_MASK = 0x00040000L;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_BREAK_BATCH_ON_GFX_PIPE_SWITCH_MASK = 0x00000100L;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_EXPOSED_GT_DETAIL_RATE_TILE_COV_ADJ_MASK = 0x00008000L;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_FULL_TILE_WAVE_BREAK_MASK = 0x00000200L;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_PACKER_GRAD_FDCE_ENHANCE_MASK = 0x00001000L;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_PBB_EOP_INSERTION_FOR_MIXED_BINNING_AND_IMMEDIATE_MASK = 0x01000000L;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_SC_BCI_INTF_EARLY_WAKEUP_MASK = 0x00004000L;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_SC_DBR_DATAPATH_FGCG_MASK = 0x00200000L;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_SC_SPI_INTF_EARLY_WAKEUP_MASK = 0x00002000L;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_BLOCKING_WRITES_OF_GEN1_REG_MASK = 0x00080000L;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_BLOCKING_WRITES_OF_GEN2_REG_MASK = 0x00100000L;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_FPOV_WAVE_BREAK_MASK = 0x00000020L;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_LPOV_WAVE_BREAK_MASK = 0x00000010L;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_SC_SEND_DB_VPZ_FOR_EN_PRIM_PAYLOAD_MASK = 0x00000080L;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_VPZ_INJECTION_BEFORE_NULL_PRIMS_MASK = 0x00000400L;
    constexpr unsigned int PA_SC_ENHANCE_2__PBB_MAIN_CLK_REG_BUSY_WAKEUP_MASK = 0x00020000L;
    constexpr unsigned int PA_SC_ENHANCE_2__PBB_TIMEOUT_THRESHOLD_MODE_MASK = 0x00000800L;
    constexpr unsigned int PA_SC_ENHANCE_2__PBB_WARP_CLK_MAIN_CLK_WAKEUP_MASK = 0x00010000L;
    constexpr unsigned int PA_SC_ENHANCE_2__PROCESS_RESET_FORCE_STILE_MASK_TO_ZERO_MASK = 0x00800000L;
    constexpr unsigned int PA_SC_NGG_MODE_CNTL__MAX_FPOVS_IN_WAVE_MASK = 0x00ff0000L;
    constexpr unsigned int PA_SC_PBB_OVERRIDE_FLAG__OVERRIDE_MASK   = 0x00000001L;
    constexpr unsigned int PA_SC_PBB_OVERRIDE_FLAG__PIPE_ID_MASK    = 0x00000002L;
    constexpr unsigned int PA_SC_RASTER_CONFIG_1__SE_PAIR_XSEL_MASK = 0x0000000cL;
    constexpr unsigned int PA_SC_RASTER_CONFIG_1__SE_PAIR_YSEL_MASK = 0x00000030L;
    constexpr unsigned int PA_SC_RASTER_CONFIG__SE_XSEL_MASK        = 0x0c000000L;
    constexpr unsigned int PA_SC_RASTER_CONFIG__SE_YSEL_MASK        = 0x30000000L;
    constexpr unsigned int PA_SC_SHADER_CONTROL__WAVE_BREAK_REGION_SIZE_MASK = 0x00000060L;
    constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__FORCE_TILE_STEERING_OVERRIDE_USE_MASK = 0x80000000L;
    constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__SA_SELECT_MASK = 0x00000700L;
    constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__NUM_RB_PER_SC_MASK = 0x00030000L;
    constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__NUM_SC_MASK = 0x00003000L;
    constexpr unsigned int PA_STATE_STEREO_X__STEREO_X_OFFSET_MASK  = 0xffffffffL;
    constexpr unsigned int PA_STEREO_CNTL__RT_SLICE_MODE_MASK       = 0x000000e0L;
    constexpr unsigned int PA_STEREO_CNTL__RT_SLICE_OFFSET_MASK     = 0x00000f00L;
    constexpr unsigned int PA_STEREO_CNTL__STEREO_MODE_MASK         = 0x0000001eL;
    constexpr unsigned int PA_STEREO_CNTL__VP_ID_MODE_MASK          = 0x00070000L;
    constexpr unsigned int PA_STEREO_CNTL__VP_ID_OFFSET_MASK        = 0x00780000L;
    constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__PERF_SEL1_MASK = 0x000ffc00L;
    constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__PERF_SEL1_MASK = 0x000ffc00L;
    constexpr unsigned int PA_SU_SC_MODE_CNTL__KEEP_TOGETHER_ENABLE_MASK = 0x01000000L;
    constexpr unsigned int PMM_GENERAL_CNTL__PMM_ALOG_IH_IDLE_MASK  = 0x00000004L;
    constexpr unsigned int PMM_GENERAL_CNTL__PMM_DISABLE_MASK       = 0x00000002L;
    constexpr unsigned int PMM_GENERAL_CNTL__PMM_MODE_MASK          = 0x00000001L;
    constexpr unsigned int RLC_SPM_DEBUG_SELECT__RESERVED_MASK      = 0x00007f00L;
    constexpr unsigned int RLC_SPM_DESER_START_SKEW__DESER_START_SKEW_MASK = 0x0000007fL;
    constexpr unsigned int RLC_SPM_DESER_START_SKEW__RESERVED_MASK  = 0xffffff80L;
    constexpr unsigned int RLC_SPM_GLB_SAMPLEDELAY_IND_ADDR__GLB_SAMPLEDELAY_INDEX_MASK = 0xffffffffL;
    constexpr unsigned int RLC_SPM_GLB_SAMPLEDELAY_IND_DATA__data_MASK = 0x0000007fL;
    constexpr unsigned int RLC_SPM_GLB_SAMPLEDELAY_IND_DATA__RESERVED_MASK = 0xffffff80L;
    constexpr unsigned int RLC_SPM_GLOBALS_MUXSEL_SKEW__GLOBALS_MUXSEL_SKEW_MASK = 0x0000007fL;
    constexpr unsigned int RLC_SPM_GLOBALS_MUXSEL_SKEW__RESERVED_MASK = 0xffffff80L;
    constexpr unsigned int RLC_SPM_GLOBALS_SAMPLE_SKEW__GLOBALS_SAMPLE_SKEW_MASK = 0x0000007fL;
    constexpr unsigned int RLC_SPM_GLOBALS_SAMPLE_SKEW__RESERVED_MASK = 0xffffff80L;
    constexpr unsigned int RLC_SPM_GLOBAL_MUXSEL_ADDR__PERFMON_SEL_ADDR_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_GLOBAL_MUXSEL_ADDR__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_INT_INFO_1__INTERRUPT_INFO_1_MASK = 0xffffffffL;
    constexpr unsigned int RLC_SPM_INT_INFO_2__INTERRUPT_ID_MASK    = 0x00ff0000L;
    constexpr unsigned int RLC_SPM_INT_INFO_2__INTERRUPT_INFO_2_MASK = 0x0000ffffL;
    constexpr unsigned int RLC_SPM_INT_INFO_2__RESERVED_MASK        = 0xff000000L;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_BC_MASK         = 0x00001000L;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_FED_MASK        = 0x00000080L;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_MTYPE_MASK      = 0x00000e00L;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_MTYPE_OVER_MASK = 0x00000100L;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_NOFILL_MASK     = 0x00008000L;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_PERF_CNTR_MASK  = 0x00000040L;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_POLICY_MASK     = 0x00000030L;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_VOL_MASK        = 0x00004000L;
    constexpr unsigned int RLC_SPM_PERFMON_CNTL__RESERVED1_MASK     = 0x00000fffL;
    constexpr unsigned int RLC_SPM_PERFMON_GLB_SEGMENT_SIZE__GLOBAL_NUM_LINE_MASK = 0x0000ff00L;
    constexpr unsigned int RLC_SPM_PERFMON_GLB_SEGMENT_SIZE__PERFMON_SEGMENT_SIZE_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_PERFMON_GLB_SEGMENT_SIZE__RESERVED_MASK = 0xffff0000L;
    constexpr unsigned int RLC_SPM_PERFMON_SE3TO0_SEGMENT_SIZE__SE0_NUM_LINE_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_PERFMON_SE3TO0_SEGMENT_SIZE__SE1_NUM_LINE_MASK = 0x0000ff00L;
    constexpr unsigned int RLC_SPM_PERFMON_SE3TO0_SEGMENT_SIZE__SE2_NUM_LINE_MASK = 0x00ff0000L;
    constexpr unsigned int RLC_SPM_PERFMON_SE3TO0_SEGMENT_SIZE__SE3_NUM_LINE_MASK = 0xff000000L;
    constexpr unsigned int RLC_SPM_SAMPLE_CNT__COUNT_MASK           = 0xffffffffL;
    constexpr unsigned int RLC_SPM_SEGMENT_THRESHOLD__NUM_SEGMENT_THRESHOLD_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_SEGMENT_THRESHOLD__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_SE_MUXSEL_ADDR__PERFMON_SEL_ADDR_MASK = 0x000001ffL;
    constexpr unsigned int RLC_SPM_SE_MUXSEL_ADDR__RESERVED_MASK    = 0xfffffe00L;
    constexpr unsigned int RLC_SPM_SE_MUXSEL_SKEW__RESERVED_MASK    = 0xffffff80L;
    constexpr unsigned int RLC_SPM_SE_MUXSEL_SKEW__SE_MUXSEL_SKEW_MASK = 0x0000007fL;
    constexpr unsigned int RLC_SPM_SE_SAMPLEDELAY_IND_ADDR__SE_SAMPLEDELAY_INDEX_MASK = 0xffffffffL;
    constexpr unsigned int RLC_SPM_SE_SAMPLEDELAY_IND_DATA__data_MASK = 0x0000007fL;
    constexpr unsigned int RLC_SPM_SE_SAMPLEDELAY_IND_DATA__RESERVED_MASK = 0xffffff80L;
    constexpr unsigned int RLC_SPM_SE_SAMPLE_SKEW__RESERVED_MASK    = 0xffffff80L;
    constexpr unsigned int RLC_SPM_SE_SAMPLE_SKEW__SE_SAMPLE_SKEW_MASK = 0x0000007fL;
    constexpr unsigned int RLC_SPM_THREAD_TRACE_CTRL__THREAD_TRACE_INT_EN_MASK = 0x00000001L;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB0_MODE_OVERRIDE_EN_MASK = 0x00000004L;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_BREAK_LOB_ON_IDLEIN_MASK = 0x00020000L;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_MODE_MASK     = 0xc0000000L;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_MODE_OVERRIDE_EN_MASK = 0x00040000L;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_STALL_MASK    = 0x00010000L;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_STALL_TIMER_OVERRIDE_MASK = 0x00300000L;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_STALL_TIMER_START_VALUE_MASK = 0x3fc00000L;
    constexpr unsigned int RMI_GENERAL_CNTL1__ARBITER_ADDRESS_CHANGE_ENABLE_MASK = 0x00004000L;
    constexpr unsigned int RMI_GENERAL_CNTL1__LAST_OF_BURST_INSERTION_DISABLE_MASK = 0x00008000L;
    constexpr unsigned int RMI_GENERAL_CNTL1__POLICY_OVERRIDE_MASK  = 0x00000800L;
    constexpr unsigned int RMI_GENERAL_CNTL1__POLICY_OVERRIDE_VALUE_MASK = 0x00000600L;
    constexpr unsigned int RMI_GENERAL_CNTL1__TCIW1_64B_RD_STALL_MODE_MASK = 0x000000c0L;
    constexpr unsigned int RMI_GENERAL_CNTL1__UTCL1_PROBE0_RR_ARB_BURST_HINT_EN_MASK = 0x00001000L;
    constexpr unsigned int RMI_GENERAL_CNTL1__UTCL1_PROBE1_RR_ARB_BURST_HINT_EN_MASK = 0x00002000L;
    constexpr unsigned int RMI_GENERAL_CNTL__SKID_FIFO_1_OVERFLOW_ERROR_MASK_MASK = 0x10000000L;
    constexpr unsigned int RMI_GENERAL_CNTL__SKID_FIFO_1_UNDERFLOW_ERROR_MASK_MASK = 0x20000000L;
    constexpr unsigned int RMI_GENERAL_STATUS__SKID_FIFO_1_OVERFLOW_ERROR_MASK = 0x00000008L;
    constexpr unsigned int RMI_GENERAL_STATUS__SKID_FIFO_1_UNDERFLOW_ERROR_MASK = 0x00000010L;
    constexpr unsigned int RMI_GENERAL_STATUS__TCIW1_PRT_FIFO_BUSY_MASK = 0x00002000L;
    constexpr unsigned int RMI_GENERAL_STATUS__TCIW_FRMTR1_BUSY_MASK = 0x00004000L;
    constexpr unsigned int RMI_GENERAL_STATUS__TCIW_RTN_FRMTR1_BUSY_MASK = 0x00008000L;
    constexpr unsigned int RMI_GENERAL_STATUS__UTC_PROBE1_BUSY_MASK = 0x00040000L;
    constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_EVENT_WINDOW_MASK1_MASK = 0x00000300L;
    constexpr unsigned int RMI_PROBE_POP_LOGIC_CNTL__EXT_LAT_FIFO_1_MAX_DEPTH_MASK = 0x0001fc00L;
    constexpr unsigned int RMI_PROBE_POP_LOGIC_CNTL__XLAT_COMBINE1_DIS_MASK = 0x00020000L;
    constexpr unsigned int RMI_RB_GLX_CID_MAP__CB_CMASK_MAP_MASK    = 0x00000f00L;
    constexpr unsigned int RMI_RB_GLX_CID_MAP__CB_COLOR_MAP_MASK    = 0x0000000fL;
    constexpr unsigned int RMI_RB_GLX_CID_MAP__CB_DCC_MAP_MASK      = 0x0000f000L;
    constexpr unsigned int RMI_RB_GLX_CID_MAP__CB_FMASK_MAP_MASK    = 0x000000f0L;
    constexpr unsigned int RMI_RB_GLX_CID_MAP__DB_S_MAP_MASK        = 0x00f00000L;
    constexpr unsigned int RMI_RB_GLX_CID_MAP__DB_TILE_MAP_MASK     = 0x0f000000L;
    constexpr unsigned int RMI_RB_GLX_CID_MAP__DB_ZPCPSD_MAP_MASK   = 0xf0000000L;
    constexpr unsigned int RMI_RB_GLX_CID_MAP__DB_Z_MAP_MASK        = 0x000f0000L;
    constexpr unsigned int RMI_SCOREBOARD_CNTL__COMPLETE_RB1_FLUSH_MASK = 0x00000004L;
    constexpr unsigned int RMI_SCOREBOARD_CNTL__REQ_IN_RE_EN_AFTER_FLUSH_RB1_MASK = 0x00000008L;
    constexpr unsigned int RMI_SCOREBOARD_CNTL__TIME_STAMP_FLUSH_RB1_MASK = 0x00000010L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS0__COUNTER_SELECT_MASK = 0x07c00000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS1__COM_FLUSH_IN_PROG_RB1_MASK = 0x20000000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS1__RUNNING_CNT_OVERFLOW_RB1_MASK = 0x10000000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS1__RUNNING_CNT_RB1_MASK = 0x07ff8000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS1__RUNNING_CNT_UNDERFLOW_RB1_MASK = 0x08000000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__COM_FLUSH_DONE_RB1_MASK = 0x04000000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__SNAPSHOT_CNT_RB1_MASK = 0x01ffe000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__SNAPSHOT_CNT_UNDERFLOW_RB1_MASK = 0x02000000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__TIME_STAMP_FLUSH_DONE_RB1_MASK = 0x80000000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__TIME_STAMP_FLUSH_IN_PROG_RB1_MASK = 0x20000000L;
    constexpr unsigned int RMI_SPARE__ARBITER_ADDRESS_MASK_MASK     = 0xffff0000L;
    constexpr unsigned int RMI_SPARE__RMI_2_GL1_128B_READ_DISABLE_MASK = 0x00000002L;
    constexpr unsigned int RMI_SPARE__RMI_2_GL1_REPEATER_FGCG_DISABLE_MASK = 0x00000004L;
    constexpr unsigned int RMI_SUBBLOCK_STATUS0__UTC_EXT_LAT_HID_FIFO_EMPTY_PROBE1_MASK = 0x00020000L;
    constexpr unsigned int RMI_SUBBLOCK_STATUS0__UTC_EXT_LAT_HID_FIFO_FULL_PROBE1_MASK = 0x00010000L;
    constexpr unsigned int RMI_SUBBLOCK_STATUS0__UTC_EXT_LAT_HID_FIFO_NUM_USED_PROBE1_MASK = 0x0000fe00L;
    constexpr unsigned int RMI_SUBBLOCK_STATUS1__SKID_FIFO_1_FREE_SPACE_MASK = 0x000ffc00L;
    constexpr unsigned int RMI_SUBBLOCK_STATUS1__TCIW1_INFLIGHT_CNT_MASK = 0x3ff00000L;
    constexpr unsigned int RMI_SUBBLOCK_STATUS2__PRT_FIFO_1_NUM_USED_MASK = 0x0003fe00L;
    constexpr unsigned int RMI_SUBBLOCK_STATUS3__SKID_FIFO_1_FREE_SPACE_TOTAL_MASK = 0x000ffc00L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__ALL_FAULT_RET1_DATA_MASK = 0x80000000L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__RMI_IN1_REORDER_DIS_MASK = 0x20000000L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__SKID_FIFO_1_FREE_SPACE_DELTA_MASK = 0x07f80000L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__SKID_FIFO_1_FREE_SPACE_DELTA_UPDATE_MASK = 0x08000000L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__TCIW1_MAX_ALLOWED_INFLIGHT_REQ_MASK = 0x0007fe00L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__TCIW1_REQ_SAFE_MODE_MASK = 0x10000000L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__WR_COMBINE1_DIS_AT_LAST_OF_BURST_MASK = 0x40000000L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__WR_COMBINE1_DIS_OVERRIDE_MASK = 0x00000001L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__WR_COMBINE1_TIME_OUT_WINDOW_MASK = 0x000001feL;
    constexpr unsigned int RMI_UTCL1_CNTL2__GPUVM_16K_DEFAULT_MASK  = 0x20000000L;
    constexpr unsigned int RMI_UTCL1_CNTL2__LINE_INVALIDATE_OPT_MASK = 0x10000000L;
    constexpr unsigned int RMI_UTCL1_CNTL2__PERM_MODE_OVRD_MASK     = 0x08000000L;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB0_MODE_OVERRIDE_EN_MASK = 0x00000020L;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_BREAK_LOB_ON_IDLEIN_MASK = 0x00100000L;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_BREAK_LOB_ON_WEIGHTEDRR_MASK = 0x00040000L;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_MODE_MASK = 0x00030000L;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_MODE_OVERRIDE_EN_MASK = 0x00200000L;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_STALL_MASK = 0x00080000L;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_STALL_TIMER_OVERRIDE_MASK = 0x00c00000L;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_STALL_TIMER_START_VALUE_MASK = 0xff000000L;
    constexpr unsigned int SDMA0_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int SDMA0_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__PERF_SEL1_MASK = 0x000ffc00L;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__PERF_SEL_MASK = 0x000003ffL;
    constexpr unsigned int SDMA0_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int SDMA0_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__PERF_SEL1_MASK = 0x000ffc00L;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__PERF_SEL_MASK = 0x000003ffL;
    constexpr unsigned int SDMA1_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int SDMA1_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__PERF_SEL1_MASK = 0x000ffc00L;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__PERF_SEL_MASK = 0x000003ffL;
    constexpr unsigned int SDMA1_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int SDMA1_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__PERF_SEL1_MASK = 0x000ffc00L;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__PERF_SEL_MASK = 0x000003ffL;
    constexpr unsigned int SH_MEM_CONFIG__ALIGNMENT_MODE_MASK       = 0x0000000cL;
    constexpr unsigned int SH_MEM_CONFIG__DEFAULT_MTYPE_MASK        = 0x00000070L;
    constexpr unsigned int SH_MEM_CONFIG__ICACHE_USE_GL1_MASK       = 0x00040000L;
    constexpr unsigned int SH_MEM_CONFIG__INITIAL_INST_PREFETCH_MASK = 0x0000c000L;
    constexpr unsigned int SPI_CONFIG_CNTL_1__MAX_VTX_SYNC_CNT_MASK = 0x001f0000L;
    constexpr unsigned int SPI_CONFIG_CNTL_1__PC_LIMIT_ENABLE_MASK  = 0x00000060L;
    constexpr unsigned int SPI_DEBUG_CNTL_2__ECO_SPARE_0_MASK       = 0x00000001L;
    constexpr unsigned int SPI_DEBUG_CNTL_2__ECO_SPARE_1_MASK       = 0x00000002L;
    constexpr unsigned int SPI_DEBUG_CNTL_2__ECO_SPARE_2_MASK       = 0x00000004L;
    constexpr unsigned int SPI_DEBUG_CNTL_2__ECO_SPARE_3_MASK       = 0x00000008L;
    constexpr unsigned int SPI_DEBUG_CNTL_2__ECO_SPARE_4_MASK       = 0x00000010L;
    constexpr unsigned int SPI_DEBUG_CNTL_2__ECO_SPARE_5_MASK       = 0x00000020L;
    constexpr unsigned int SPI_DEBUG_CNTL_2__ECO_SPARE_6_MASK       = 0x00000040L;
    constexpr unsigned int SPI_DEBUG_CNTL_2__ECO_SPARE_7_MASK       = 0x00000080L;
    constexpr unsigned int SPI_DSM_CNTL2__SPI_SR_MEM_INJECT_DELAY_MASK = 0x000001f8L;
    constexpr unsigned int SPI_FEATURE_CTRL__ACTIVE_HARD_LOCK_LIMIT_MASK = 0x00000f80L;
    constexpr unsigned int SPI_FEATURE_CTRL__ALLOCATION_RATE_THROTTLE_THRESHOLD_MASK = 0x0000007cL;
    constexpr unsigned int SPI_FEATURE_CTRL__BUS_ACTIVITY_THRESHOLD_ALLOC_STALL_EN_MASK = 0x00080000L;
    constexpr unsigned int SPI_FEATURE_CTRL__BUS_ACTIVITY_THRESHOLD_MASK = 0x0ff00000L;
    constexpr unsigned int SPI_FEATURE_CTRL__CU_LOCKING_FAIRNESS_DISABLE_MASK = 0x00000001L;
    constexpr unsigned int SPI_FEATURE_CTRL__LR_IMBALANCE_THRESHOLD_MASK = 0x0003f000L;
    constexpr unsigned int SPI_FEATURE_CTRL__RA_PIPE_DEPTH_THRESHOLD_ALLOC_STALL_EN_MASK = 0x00040000L;
    constexpr unsigned int SPI_FEATURE_CTRL__TUNNELING_WAVE_LIMIT_MASK = 0xf0000000L;
    constexpr unsigned int SPI_LB_DATA_PERWGP_WAVE_CS__ACTIVE_MASK  = 0x0000ffffL;
    constexpr unsigned int SPI_LB_DATA_PERWGP_WAVE_HSGS__WGP_USED_GS_MASK = 0xffff0000L;
    constexpr unsigned int SPI_LB_DATA_PERWGP_WAVE_HSGS__WGP_USED_HS_MASK = 0x0000ffffL;
    constexpr unsigned int SPI_LB_DATA_PERWGP_WAVE_VSPS__WGP_USED_PS_MASK = 0xffff0000L;
    constexpr unsigned int SPI_LB_DATA_PERWGP_WAVE_VSPS__WGP_USED_VS_MASK = 0x0000ffffL;
    constexpr unsigned int SPI_LB_WGP_MASK__WGP_MASK_MASK           = 0x0000ffffL;
    constexpr unsigned int SPI_PERFCOUNTER4_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int SPI_PERFCOUNTER5_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int SPI_PG_ENABLE_STATIC_WGP_MASK__WGP_MASK_MASK = 0x0000ffffL;
    constexpr unsigned int SPI_PQEV_CTRL__COMPUTE_PIPE_EN_MASK      = 0x00ff0000L;
    constexpr unsigned int SPI_PQEV_CTRL__QUEUE_DURATION_MASK       = 0x0000fc00L;
    constexpr unsigned int SPI_PQEV_CTRL__SCAN_PERIOD_MASK          = 0x000003ffL;
    constexpr unsigned int SPI_PS_IN_CONTROL__PS_W32_EN_MASK        = 0x00008000L;
    constexpr unsigned int SPI_SHADER_IDX_FORMAT__IDX0_EXPORT_FORMAT_MASK = 0x0000000fL;
    constexpr unsigned int SPI_SHADER_PGM_HI_ES_GS__MEM_BASE_MASK   = 0x000000ffL;
    constexpr unsigned int SPI_SHADER_PGM_HI_LS_HS__MEM_BASE_MASK   = 0x000000ffL;
    constexpr unsigned int SPI_SHADER_PGM_LO_ES_GS__MEM_BASE_MASK   = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_PGM_LO_LS_HS__MEM_BASE_MASK   = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__FWD_PROGRESS_MASK = 0x04000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__MEM_ORDERED_MASK = 0x02000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__WGP_MODE_MASK   = 0x08000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__FWD_PROGRESS_MASK = 0x02000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__MEM_ORDERED_MASK = 0x01000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__WGP_MODE_MASK   = 0x04000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__FWD_PROGRESS_MASK = 0x04000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__MEM_ORDERED_MASK = 0x02000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__FWD_PROGRESS_MASK = 0x10000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__MEM_ORDERED_MASK = 0x08000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__SHARED_VGPR_CNT_MASK = 0xf0000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__USER_SGPR_MSB_MASK = 0x08000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__EXCP_EN_MASK    = 0x0003fe00L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__LDS_SIZE_MASK   = 0x07fc0000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__OC_LDS_EN_MASK  = 0x00000080L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__SHARED_VGPR_CNT_MASK = 0xf0000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__TG_SIZE_EN_MASK = 0x00000100L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__USER_SGPR_MSB_MASK = 0x08000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__SHARED_VGPR_CNT_MASK = 0xf0000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__USER_SGPR_MSB_MASK = 0x08000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__SHARED_VGPR_CNT_MASK = 0xf0000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__USER_SGPR_MSB_MASK = 0x08000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_GS__GROUP_FIFO_DEPTH_MASK = 0xfc000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_HS__GROUP_FIFO_DEPTH_MASK = 0x0000fc00L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__CU_EN_MASK      = 0x0000ffffL;
    constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__SPI_SHADER_LATE_ALLOC_GS_MASK = 0x007f0000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC4_HS__CU_EN_MASK      = 0x0000ffffL;
    constexpr unsigned int SPI_SHADER_PGM_RSRC4_PS__CU_EN_MASK      = 0x0000ffffL;
    constexpr unsigned int SPI_SHADER_PGM_RSRC4_VS__CU_EN_MASK      = 0x0000ffffL;
    constexpr unsigned int SPI_SHADER_POS_FORMAT__POS4_EXPORT_FORMAT_MASK = 0x000f0000L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__ALLOCATION_RATE_THROTTLING_THRESHOLD_MASK = 0x000e0000L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__GLOBAL_SCANNING_EN_MASK = 0x00010000L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__HARD_LOCK_HYSTERESIS_MASK = 0x00000200L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__HARD_LOCK_LOW_THRESHOLD_MASK = 0x00007c00L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__NUMBER_OF_REQUESTS_PER_CU_MASK = 0x0000001eL;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__PRODUCER_REQUEST_LOCKOUT_MASK = 0x00008000L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__SOFT_GROUPING_ALLOCATION_TIMEOUT_MASK = 0x000001e0L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__SOFT_GROUPING_EN_MASK = 0x00000001L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__ALLOCATION_RATE_THROTTLING_THRESHOLD_MASK = 0x000e0000L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__GLOBAL_SCANNING_EN_MASK = 0x00010000L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__HARD_LOCK_HYSTERESIS_MASK = 0x00000200L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__HARD_LOCK_LOW_THRESHOLD_MASK = 0x00007c00L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__NUMBER_OF_REQUESTS_PER_CU_MASK = 0x0000001eL;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__PRODUCER_REQUEST_LOCKOUT_MASK = 0x00008000L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__SOFT_GROUPING_ALLOCATION_TIMEOUT_MASK = 0x000001e0L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__SOFT_GROUPING_EN_MASK = 0x00000001L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__ALLOCATION_RATE_THROTTLING_THRESHOLD_MASK = 0x000e0000L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__GLOBAL_SCANNING_EN_MASK = 0x00010000L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__HARD_LOCK_HYSTERESIS_MASK = 0x00000200L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__HARD_LOCK_LOW_THRESHOLD_MASK = 0x00007c00L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__NUMBER_OF_REQUESTS_PER_CU_MASK = 0x0000001eL;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__PRODUCER_REQUEST_LOCKOUT_MASK = 0x00008000L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__SOFT_GROUPING_ALLOCATION_TIMEOUT_MASK = 0x000001e0L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__SOFT_GROUPING_EN_MASK = 0x00000001L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_VS__ALLOCATION_RATE_THROTTLING_THRESHOLD_MASK = 0x000e0000L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_VS__GLOBAL_SCANNING_EN_MASK = 0x00010000L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_VS__HARD_LOCK_HYSTERESIS_MASK = 0x00000200L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_VS__HARD_LOCK_LOW_THRESHOLD_MASK = 0x00007c00L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_VS__NUMBER_OF_REQUESTS_PER_CU_MASK = 0x0000001eL;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_VS__PRODUCER_REQUEST_LOCKOUT_MASK = 0x00008000L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_VS__SOFT_GROUPING_ALLOCATION_TIMEOUT_MASK = 0x000001e0L;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_VS__SOFT_GROUPING_EN_MASK = 0x00000001L;
    constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__BARRIER_LIMIT_HIERARCHY_LEVEL_MASK = 0x00080000L;
    constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__BARRIER_LIMIT_MASK = 0x0007e000L;
    constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__LDS_LIMIT_HIERARCHY_LEVEL_MASK = 0x10000000L;
    constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__LDS_LIMIT_MASK = 0x0ff00000L;
    constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__PERFORMANCE_LIMIT_ENABLE_MASK = 0x80000000L;
    constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__VGPR_PER_SIMD32_MASK = 0x00000fe0L;
    constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__VGPR_WRAP_DISABLE_MASK = 0x00001000L;
    constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__WAVES_PER_SIMD32_MASK = 0x0000001fL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_0__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_1__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_2__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_3__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_4__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_5__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_6__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_7__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_8__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_9__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_10__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_11__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_12__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_13__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_14__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_15__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_16__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_17__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_18__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_19__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_20__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_21__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_22__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_23__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_24__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_25__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_26__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_27__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_28__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_29__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_30__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_31__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_0__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_1__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_2__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_3__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_4__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_5__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_6__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_7__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_8__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_9__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_10__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_11__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_12__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_13__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_14__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_15__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_16__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_17__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_18__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_19__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_20__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_21__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_22__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_23__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_24__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_25__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_26__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_27__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_28__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_29__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_30__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_31__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_VS_OUT_CONFIG__NO_PC_EXPORT_MASK     = 0x00000080L;
    constexpr unsigned int SP_CONFIG__ALU_BUSY_MGCG_OVERRIDE_MASK   = 0x00000004L;
    constexpr unsigned int SP_CONFIG__DEST_CACHE_EVICT_COUNTER_MASK = 0x00000003L;
    constexpr unsigned int SP_CONFIG__DISABLE_TRANS_COEXEC_MASK     = 0x00000008L;
    constexpr unsigned int SQC_CACHES__L2_WB_POLICY_MASK            = 0x00060000L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__CLIENTID_MASK    = 0x0000ff80L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__CLIENT_INVALIDATE_ALL_VMID_MASK = 0x02000000L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__ENABLE_LFIFO_PRI_ARB_MASK = 0x00040000L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__ENABLE_PUSH_LFIFO_MASK = 0x00020000L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__FORCE_4K_L2_RESP_MASK = 0x00000001L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__FORCE_IN_ORDER_MASK = 0x08000000L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__FORCE_MISS_MASK  = 0x04000000L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__GPUVM_64K_DEF_MASK = 0x00000002L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__GPUVM_PERM_MODE_MASK = 0x00000004L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__REDUCE_CACHE_SIZE_BY_2_MASK = 0xc0000000L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__REDUCE_FIFO_DEPTH_BY_2_MASK = 0x30000000L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__REG_INV_ALL_VMID_MASK = 0x00800000L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__REG_INV_TOGGLE_MASK = 0x01000000L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__REG_INV_VMID_MASK = 0x00780000L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__RESP_FAULT_MODE_MASK = 0x00000060L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__RESP_MODE_MASK   = 0x00000018L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__ARB_BURST_MODE_MASK = 0x00030000L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__DIS_EDC_MASK     = 0x00000800L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__ENABLE_PERF_EVENT_RD_WR_MASK = 0x00040000L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__ENABLE_PERF_EVENT_VMID_MASK = 0x00100000L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__FORCE_FRAG_2M_TO_64K_MASK = 0x04000000L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__FORCE_GPUVM_INV_ACK_MASK = 0x00008000L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__FORCE_SNOOP_MASK = 0x00004000L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__GPUVM_16K_DEF_MASK = 0x20000000L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__GPUVM_INV_MODE_MASK = 0x00001000L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__LFIFO_SCAN_DISABLE_MASK = 0x00000100L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__LINE_INVALIDATE_OPT_MASK = 0x10000000L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__LINE_VALID_MASK  = 0x00000400L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__MTYPE_OVRD_DIS_MASK = 0x00000200L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__PERF_EVENT_RD_WR_MASK = 0x00080000L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__PERF_EVENT_VMID_MASK = 0x01e00000L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__PERM_MODE_OVRD_MASK = 0x08000000L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__SHOOTDOWN_OPT_MASK = 0x00002000L;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__SPARE_MASK       = 0x000000ffL;
    constexpr unsigned int SQC_DCACHE_UTCL0_STATUS__FAULT_DETECTED_MASK = 0x00000001L;
    constexpr unsigned int SQC_DCACHE_UTCL0_STATUS__PRT_DETECTED_MASK = 0x00000004L;
    constexpr unsigned int SQC_DCACHE_UTCL0_STATUS__RETRY_DETECTED_MASK = 0x00000002L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__CLIENTID_MASK    = 0x0000ff80L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__CLIENT_INVALIDATE_ALL_VMID_MASK = 0x02000000L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__ENABLE_LFIFO_PRI_ARB_MASK = 0x00040000L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__ENABLE_PUSH_LFIFO_MASK = 0x00020000L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__FORCE_4K_L2_RESP_MASK = 0x00000001L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__FORCE_IN_ORDER_MASK = 0x08000000L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__FORCE_MISS_MASK  = 0x04000000L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__GPUVM_64K_DEF_MASK = 0x00000002L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__GPUVM_PERM_MODE_MASK = 0x00000004L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__REDUCE_CACHE_SIZE_BY_2_MASK = 0xc0000000L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__REDUCE_FIFO_DEPTH_BY_2_MASK = 0x30000000L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__REG_INV_ALL_VMID_MASK = 0x00800000L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__REG_INV_TOGGLE_MASK = 0x01000000L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__REG_INV_VMID_MASK = 0x00780000L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__RESP_FAULT_MODE_MASK = 0x00000060L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__RESP_MODE_MASK   = 0x00000018L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__ARB_BURST_MODE_MASK = 0x00030000L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__DIS_EDC_MASK     = 0x00000800L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__ENABLE_PERF_EVENT_RD_WR_MASK = 0x00040000L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__ENABLE_PERF_EVENT_VMID_MASK = 0x00100000L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__FORCE_FRAG_2M_TO_64K_MASK = 0x04000000L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__FORCE_GPUVM_INV_ACK_MASK = 0x00008000L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__FORCE_SNOOP_MASK = 0x00004000L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__GPUVM_16K_DEF_MASK = 0x20000000L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__GPUVM_INV_MODE_MASK = 0x00001000L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__LFIFO_SCAN_DISABLE_MASK = 0x00000100L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__LINE_INVALIDATE_OPT_MASK = 0x10000000L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__LINE_VALID_MASK  = 0x00000400L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__MTYPE_OVRD_DIS_MASK = 0x00000200L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__PERF_EVENT_RD_WR_MASK = 0x00080000L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__PERF_EVENT_VMID_MASK = 0x01e00000L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__PERM_MODE_OVRD_MASK = 0x08000000L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__SHOOTDOWN_OPT_MASK = 0x00002000L;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__SPARE_MASK       = 0x000000ffL;
    constexpr unsigned int SQC_ICACHE_UTCL0_STATUS__FAULT_DETECTED_MASK = 0x00000001L;
    constexpr unsigned int SQC_ICACHE_UTCL0_STATUS__PRT_DETECTED_MASK = 0x00000004L;
    constexpr unsigned int SQC_ICACHE_UTCL0_STATUS__RETRY_DETECTED_MASK = 0x00000002L;
    constexpr unsigned int SQC_MISC_CONFIG__PERFTOKEN_DELAY_MASK    = 0x0000001fL;
    constexpr unsigned int SQG_CONFIG__UTCL0_PREFETCH_PAGE_MASK     = 0x0000000fL;
    constexpr unsigned int SQG_CONFIG__UTCL0_RETRY_TIMER_MASK       = 0x000007f0L;
    constexpr unsigned int SQG_STATUS__REG_BUSY_MASK                = 0x00000001L;
    constexpr unsigned int SQG_UTCL0_CNTL1__CLIENTID_MASK           = 0x0000ff80L;
    constexpr unsigned int SQG_UTCL0_CNTL1__CLIENT_INVALIDATE_ALL_VMID_MASK = 0x02000000L;
    constexpr unsigned int SQG_UTCL0_CNTL1__ENABLE_LFIFO_PRI_ARB_MASK = 0x00040000L;
    constexpr unsigned int SQG_UTCL0_CNTL1__ENABLE_PUSH_LFIFO_MASK  = 0x00020000L;
    constexpr unsigned int SQG_UTCL0_CNTL1__FORCE_4K_L2_RESP_MASK   = 0x00000001L;
    constexpr unsigned int SQG_UTCL0_CNTL1__FORCE_IN_ORDER_MASK     = 0x08000000L;
    constexpr unsigned int SQG_UTCL0_CNTL1__FORCE_MISS_MASK         = 0x04000000L;
    constexpr unsigned int SQG_UTCL0_CNTL1__GPUVM_64K_DEF_MASK      = 0x00000002L;
    constexpr unsigned int SQG_UTCL0_CNTL1__GPUVM_PERM_MODE_MASK    = 0x00000004L;
    constexpr unsigned int SQG_UTCL0_CNTL1__REDUCE_CACHE_SIZE_BY_2_MASK = 0xc0000000L;
    constexpr unsigned int SQG_UTCL0_CNTL1__REDUCE_FIFO_DEPTH_BY_2_MASK = 0x30000000L;
    constexpr unsigned int SQG_UTCL0_CNTL1__REG_INV_ALL_VMID_MASK   = 0x00800000L;
    constexpr unsigned int SQG_UTCL0_CNTL1__REG_INV_TOGGLE_MASK     = 0x01000000L;
    constexpr unsigned int SQG_UTCL0_CNTL1__REG_INV_VMID_MASK       = 0x00780000L;
    constexpr unsigned int SQG_UTCL0_CNTL1__RESERVED_MASK           = 0x00010000L;
    constexpr unsigned int SQG_UTCL0_CNTL1__RESP_FAULT_MODE_MASK    = 0x00000060L;
    constexpr unsigned int SQG_UTCL0_CNTL1__RESP_MODE_MASK          = 0x00000018L;
    constexpr unsigned int SQG_UTCL0_CNTL2__ARB_BURST_MODE_MASK     = 0x00030000L;
    constexpr unsigned int SQG_UTCL0_CNTL2__DIS_DUAL_L2_REQ_MASK    = 0x02000000L;
    constexpr unsigned int SQG_UTCL0_CNTL2__DIS_EDC_MASK            = 0x00000800L;
    constexpr unsigned int SQG_UTCL0_CNTL2__ENABLE_PERF_EVENT_RD_WR_MASK = 0x00040000L;
    constexpr unsigned int SQG_UTCL0_CNTL2__ENABLE_PERF_EVENT_VMID_MASK = 0x00100000L;
    constexpr unsigned int SQG_UTCL0_CNTL2__FORCE_FRAG_2M_TO_64K_MASK = 0x04000000L;
    constexpr unsigned int SQG_UTCL0_CNTL2__FORCE_GPUVM_INV_ACK_MASK = 0x00008000L;
    constexpr unsigned int SQG_UTCL0_CNTL2__FORCE_SNOOP_MASK        = 0x00004000L;
    constexpr unsigned int SQG_UTCL0_CNTL2__GPUVM_16K_DEF_MASK      = 0x20000000L;
    constexpr unsigned int SQG_UTCL0_CNTL2__GPUVM_INV_MODE_MASK     = 0x00001000L;
    constexpr unsigned int SQG_UTCL0_CNTL2__LFIFO_SCAN_DISABLE_MASK = 0x00000100L;
    constexpr unsigned int SQG_UTCL0_CNTL2__LINE_INVALIDATE_OPT_MASK = 0x10000000L;
    constexpr unsigned int SQG_UTCL0_CNTL2__LINE_VALID_MASK         = 0x00000400L;
    constexpr unsigned int SQG_UTCL0_CNTL2__MTYPE_OVRD_DIS_MASK     = 0x00000200L;
    constexpr unsigned int SQG_UTCL0_CNTL2__PERF_EVENT_RD_WR_MASK   = 0x00080000L;
    constexpr unsigned int SQG_UTCL0_CNTL2__PERF_EVENT_VMID_MASK    = 0x01e00000L;
    constexpr unsigned int SQG_UTCL0_CNTL2__PERM_MODE_OVRD_MASK     = 0x08000000L;
    constexpr unsigned int SQG_UTCL0_CNTL2__RESERVED_MASK           = 0xc0000000L;
    constexpr unsigned int SQG_UTCL0_CNTL2__SHOOTDOWN_OPT_MASK      = 0x00002000L;
    constexpr unsigned int SQG_UTCL0_CNTL2__SPARE_MASK              = 0x000000ffL;
    constexpr unsigned int SQG_UTCL0_STATUS__FAULT_DETECTED_MASK    = 0x00000001L;
    constexpr unsigned int SQG_UTCL0_STATUS__PRT_DETECTED_MASK      = 0x00000004L;
    constexpr unsigned int SQG_UTCL0_STATUS__RESERVED_MASK          = 0x000000f8L;
    constexpr unsigned int SQG_UTCL0_STATUS__RETRY_DETECTED_MASK    = 0x00000002L;
    constexpr unsigned int SQG_UTCL0_STATUS__UNUSED_MASK            = 0xffffff00L;
    constexpr unsigned int SQ_ALU_CLK_CTRL__FORCE_WGP_ON_SA0_MASK   = 0x0000ffffL;
    constexpr unsigned int SQ_ALU_CLK_CTRL__FORCE_WGP_ON_SA1_MASK   = 0xffff0000L;
    constexpr unsigned int SQ_ARB_CONFIG__FWD_PROG_INTERVAL_MASK    = 0x00000030L;
    constexpr unsigned int SQ_ARB_CONFIG__WG_RR_INTERVAL_MASK       = 0x00000003L;
    constexpr unsigned int SQ_CMD__CMD_MASK                         = 0x0000000fL;
    constexpr unsigned int SQ_CMD__WAVE_ID_MASK                     = 0x001f0000L;
    constexpr unsigned int SQ_CONFIG__VGPR_SWIZZLE_EN_MASK          = 0x00001000L;
    constexpr unsigned int SQ_DEBUG_STS_GLOBAL__INTERRUPT_BUSY_MASK = 0x00000002L;
    constexpr unsigned int SQ_DEBUG_STS_GLOBAL__WAVE_LEVEL_SA0_MASK = 0x0000fff0L;
    constexpr unsigned int SQ_DEBUG_STS_GLOBAL__WAVE_LEVEL_SA1_MASK = 0x0fff0000L;
    constexpr unsigned int SQ_DEBUG_STS_LOCAL__ARB_BUSY_MASK        = 0x00008000L;
    constexpr unsigned int SQ_DEBUG_STS_LOCAL__BRMSG_BUSY_MASK      = 0x00020000L;
    constexpr unsigned int SQ_DEBUG_STS_LOCAL__EXP_BUSY_MASK        = 0x00010000L;
    constexpr unsigned int SQ_DEBUG_STS_LOCAL__IS_BUSY_MASK         = 0x00002000L;
    constexpr unsigned int SQ_DEBUG_STS_LOCAL__SQ_BUSY_MASK         = 0x00001000L;
    constexpr unsigned int SQ_DEBUG_STS_LOCAL__VM_BUSY_MASK         = 0x00040000L;
    constexpr unsigned int SQ_FIFO_SIZES__EXPORT_BUF_PS_RESERVED_MASK = 0x0000c000L;
    constexpr unsigned int SQ_FIFO_SIZES__EXPORT_BUF_REDUCE_MASK    = 0x00030000L;
    constexpr unsigned int SQ_FIFO_SIZES__EXPORT_BUF_VS_RESERVED_MASK = 0x00003000L;
    constexpr unsigned int SQ_FIFO_SIZES__TTRACE_FIFO_SIZE_MASK     = 0x00000300L;
    constexpr unsigned int SQ_IND_INDEX__AUTO_INCR_MASK             = 0x00000800L;
    constexpr unsigned int SQ_IND_INDEX__WAVE_ID_MASK               = 0x0000001fL;
    constexpr unsigned int SQ_IND_INDEX__WORKITEM_ID_MASK           = 0x000007e0L;
    constexpr unsigned int SQ_LB_CTR_SEL0__DIV0_MASK                = 0x00008000L;
    constexpr unsigned int SQ_LB_CTR_SEL0__DIV1_MASK                = 0x80000000L;
    constexpr unsigned int SQ_LB_CTR_SEL0__SEL0_MASK                = 0x000000ffL;
    constexpr unsigned int SQ_LB_CTR_SEL0__SEL1_MASK                = 0x00ff0000L;
    constexpr unsigned int SQ_LB_CTR_SEL1__DIV2_MASK                = 0x00008000L;
    constexpr unsigned int SQ_LB_CTR_SEL1__DIV3_MASK                = 0x80000000L;
    constexpr unsigned int SQ_LB_CTR_SEL1__SEL2_MASK                = 0x000000ffL;
    constexpr unsigned int SQ_LB_CTR_SEL1__SEL3_MASK                = 0x00ff0000L;
    constexpr unsigned int SQ_LDS_CLK_CTRL__FORCE_WGP_ON_SA0_MASK   = 0x0000ffffL;
    constexpr unsigned int SQ_LDS_CLK_CTRL__FORCE_WGP_ON_SA1_MASK   = 0xffff0000L;
    constexpr unsigned int SQ_PERFCOUNTER_CTRL__CNTR_RATE_MASK      = 0x00000300L;
    constexpr unsigned int SQ_RANDOM_WAVE_PRI__RNG_MASK             = 0x00fffc00L;
    constexpr unsigned int SQ_RUNTIME_CONFIG__UNUSED_REGISTER_MASK  = 0x00000001L;
    constexpr unsigned int SQ_SHADER_TBA_HI__TRAP_EN_MASK           = 0x80000000L;
    constexpr unsigned int SQ_TEX_CLK_CTRL__FORCE_WGP_ON_SA0_MASK   = 0x0000ffffL;
    constexpr unsigned int SQ_TEX_CLK_CTRL__FORCE_WGP_ON_SA1_MASK   = 0xffff0000L;
    constexpr unsigned int SQ_THREAD_TRACE_BUF0_BASE__BASE_LO_MASK  = 0xffffffffL;
    constexpr unsigned int SQ_THREAD_TRACE_BUF0_SIZE__BASE_HI_MASK  = 0x0000000fL;
    constexpr unsigned int SQ_THREAD_TRACE_BUF0_SIZE__SIZE_MASK     = 0x3fffff00L;
    constexpr unsigned int SQ_THREAD_TRACE_BUF1_BASE__BASE_LO_MASK  = 0xffffffffL;
    constexpr unsigned int SQ_THREAD_TRACE_BUF1_SIZE__BASE_HI_MASK  = 0x0000000fL;
    constexpr unsigned int SQ_THREAD_TRACE_BUF1_SIZE__SIZE_MASK     = 0x3fffff00L;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__ALL_VMID_MASK      = 0x00000004L;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__CAPTURE_ALL_MASK   = 0x40000000L;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__CH_PERF_EN_MASK    = 0x00000008L;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__DOUBLE_BUFFER_MASK = 0x00000020L;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__DRAW_EVENT_EN_MASK = 0x80000000L;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__HIWATER_MASK       = 0x000001c0L;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__INTERRUPT_EN_MASK  = 0x00000010L;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__MODE_MASK          = 0x00000003L;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__REG_DROP_ON_STALL_MASK = 0x00001000L;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__REG_STALL_EN_MASK  = 0x00000200L;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__RT_FREQ_MASK       = 0x00030000L;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__SPI_STALL_EN_MASK  = 0x00000400L;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__SQ_STALL_EN_MASK   = 0x00000800L;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__SYNC_COUNT_DRAWS_MASK = 0x00080000L;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__SYNC_COUNT_MARKERS_MASK = 0x00040000L;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__UTIL_TIMER_MASK    = 0x00002000L;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__WAVESTART_MODE_MASK = 0x0000c000L;
    constexpr unsigned int SQ_THREAD_TRACE_DROPPED_CNTR__CNTR_MASK  = 0xffffffffL;
    constexpr unsigned int SQ_THREAD_TRACE_FINISH_DONE_DEBUG__EXPECT0_MASK = 0x0000fc00L;
    constexpr unsigned int SQ_THREAD_TRACE_FINISH_DONE_DEBUG__EXPECT1_MASK = 0xfc000000L;
    constexpr unsigned int SQ_THREAD_TRACE_FINISH_DONE_DEBUG__GFX0_MASK = 0x000003ffL;
    constexpr unsigned int SQ_THREAD_TRACE_FINISH_DONE_DEBUG__GFX1_MASK = 0x03ff0000L;
    constexpr unsigned int SQ_THREAD_TRACE_GFX_DRAW_CNTR__CNTR_MASK = 0xffffffffL;
    constexpr unsigned int SQ_THREAD_TRACE_GFX_MARKER_CNTR__CNTR_MASK = 0xffffffffL;
    constexpr unsigned int SQ_THREAD_TRACE_HP3D_DRAW_CNTR__CNTR_MASK = 0xffffffffL;
    constexpr unsigned int SQ_THREAD_TRACE_HP3D_MARKER_CNTR__CNTR_MASK = 0xffffffffL;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__SA_SEL_MASK        = 0x00000200L;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__SIMD_SEL_MASK      = 0x00000003L;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__WGP_SEL_MASK       = 0x000000f0L;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__WTYPE_INCLUDE_MASK = 0x0001fc00L;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__BUSY_MASK        = 0x02000000L;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__EVENT_CNTR_OVERFLOW_MASK = 0x04000000L;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__EVENT_CNTR_STALL_MASK = 0x08000000L;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__FINISH_DONE_MASK = 0x00fff000L;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__FINISH_PENDING_MASK = 0x00000fffL;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__UTC_ERR_MASK     = 0x01000000L;
    constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__INST_EXCLUDE_MASK = 0x03000000L;
    constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__REG_DETAIL_ALL_MASK = 0x80000000L;
    constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__REG_INCLUDE_MASK = 0x00ff0000L;
    constexpr unsigned int SQ_THREAD_TRACE_USERDATA_4__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SQ_THREAD_TRACE_USERDATA_5__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SQ_THREAD_TRACE_USERDATA_6__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SQ_THREAD_TRACE_USERDATA_7__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SQ_THREAD_TRACE_WPTR__BUFFER_ID_MASK     = 0x80000000L;
    constexpr unsigned int SQ_THREAD_TRACE_WPTR__OFFSET_MASK        = 0x1fffffffL;
    constexpr unsigned int SQ_WATCH0_ADDR_H__ADDR_MASK              = 0x0000ffffL;
    constexpr unsigned int SQ_WATCH0_ADDR_L__ADDR_MASK              = 0xffffffc0L;
    constexpr unsigned int SQ_WATCH0_CNTL__MASK_MASK                = 0x00ffffffL;
    constexpr unsigned int SQ_WATCH0_CNTL__VALID_MASK               = 0x80000000L;
    constexpr unsigned int SQ_WATCH0_CNTL__VMID_MASK                = 0x0f000000L;
    constexpr unsigned int SQ_WATCH1_ADDR_H__ADDR_MASK              = 0x0000ffffL;
    constexpr unsigned int SQ_WATCH1_ADDR_L__ADDR_MASK              = 0xffffffc0L;
    constexpr unsigned int SQ_WATCH1_CNTL__MASK_MASK                = 0x00ffffffL;
    constexpr unsigned int SQ_WATCH1_CNTL__VALID_MASK               = 0x80000000L;
    constexpr unsigned int SQ_WATCH1_CNTL__VMID_MASK                = 0x0f000000L;
    constexpr unsigned int SQ_WATCH2_ADDR_H__ADDR_MASK              = 0x0000ffffL;
    constexpr unsigned int SQ_WATCH2_ADDR_L__ADDR_MASK              = 0xffffffc0L;
    constexpr unsigned int SQ_WATCH2_CNTL__MASK_MASK                = 0x00ffffffL;
    constexpr unsigned int SQ_WATCH2_CNTL__VALID_MASK               = 0x80000000L;
    constexpr unsigned int SQ_WATCH2_CNTL__VMID_MASK                = 0x0f000000L;
    constexpr unsigned int SQ_WATCH3_ADDR_H__ADDR_MASK              = 0x0000ffffL;
    constexpr unsigned int SQ_WATCH3_ADDR_L__ADDR_MASK              = 0xffffffc0L;
    constexpr unsigned int SQ_WATCH3_CNTL__MASK_MASK                = 0x00ffffffL;
    constexpr unsigned int SQ_WATCH3_CNTL__VALID_MASK               = 0x80000000L;
    constexpr unsigned int SQ_WATCH3_CNTL__VMID_MASK                = 0x0f000000L;
    constexpr unsigned int SX_DEBUG_1__DISABLE_RAM_FGCG_MASK        = 0x00008000L;
    constexpr unsigned int SX_DEBUG_1__ENABLE_SAME_PC_GDS_CGTS_MASK = 0x00004000L;
    constexpr unsigned int SX_DEBUG_1__PC_DISABLE_SAME_ADDR_OPT_MASK = 0x00010000L;
    constexpr unsigned int TA_CNTL_AUX__AUTO_ALIGN_FORMAT_MASK      = 0x00000200L;
    constexpr unsigned int TA_POWER_CNTL__NOSAMPLER_CLK_EN_MODE_MASK = 0x00080000L;
    constexpr unsigned int TA_POWER_CNTL__NOSAMPLER_CLK_VALID_DELAY_MASK = 0x00070000L;
    constexpr unsigned int TA_POWER_CNTL__SAMPLER_CLK_EN_MODE_MASK  = 0x00000008L;
    constexpr unsigned int TA_POWER_CNTL__SAMPLER_CLK_VALID_DELAY_MASK = 0x00000007L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER2__REQ_MODE_MASK   = 0x00000007L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__COMPRESSION_ENABLE_MASK = 0x00000800L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__DLC_MASK      = 0x00000200L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__GLC_MASK      = 0x00000400L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__REQ_MODE_MASK = 0x00001000L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__SLC_MASK      = 0x00000100L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__COMPRESSION_ENABLE_MASK = 0x40000000L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__DATA_FORMAT_MASK = 0x00000fe0L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__DLC_MASK         = 0x10000000L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__GLC_MASK         = 0x20000000L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__NUM_FORMAT_MASK  = 0x0001e000L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__NUM_SAMPLES_MASK = 0x00c00000L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__OPCODE_TYPE_MASK = 0x07000000L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__SLC_MASK         = 0x08000000L;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__SW_MODE_MASK     = 0x003e0000L;
    constexpr unsigned int TD_CNTL__ARBITER_OLDEST_PRIORITY_MASK    = 0x02000000L;
    constexpr unsigned int TD_CNTL__DISABLE_SAMPLER_MAX_NORM_NUM_CLAMP_MASK = 0x00000040L;
    constexpr unsigned int TD_CNTL__DISABLE_SAMPLER_NEG_SCALED_NUM_CLAMP_MASK = 0x00000008L;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_ACTIVE_MASK       = 0x00000010L;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_CLEAN_MASK        = 0x00008000L;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_IDLE_MASK         = 0x00010000L;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_MODE1_FILTER1_THRESHOLD_MASK = 0x00000007L;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_MODE1_FILTER2_BYPASS_MASK = 0x00000008L;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_MODE2_INTR_THRESHOLD_MASK = 0x00000c00L;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_MODE2_LOCK_WINDOW_MASK = 0x000001c0L;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_MODE_MASK         = 0x00000020L;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_SPACE_EN_MASK     = 0x00007000L;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__OFF_HYSTERESIS_MASK = 0x00000ff0L;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__ON_DELAY_MASK       = 0x0000000fL;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_OVERRIDE0_MASK = 0x80000000L;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_OVERRIDE1_MASK = 0x40000000L;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_OVERRIDE2_MASK = 0x20000000L;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_OVERRIDE3_MASK = 0x10000000L;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_OVERRIDE4_MASK = 0x08000000L;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_OVERRIDE5_MASK = 0x04000000L;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_OVERRIDE6_MASK = 0x02000000L;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_STALL_OVERRIDE0_MASK = 0x00800000L;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_STALL_OVERRIDE1_MASK = 0x00400000L;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_STALL_OVERRIDE2_MASK = 0x00200000L;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_STALL_OVERRIDE3_MASK = 0x00100000L;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_STALL_OVERRIDE4_MASK = 0x00080000L;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_STALL_OVERRIDE5_MASK = 0x00040000L;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_STALL_OVERRIDE6_MASK = 0x00020000L;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_STALL_OVERRIDE7_MASK = 0x00010000L;
    constexpr unsigned int UTCL1_CTRL__UTCL1_CACHE_CORE_BYPASS_MASK = 0x00000004L;
    constexpr unsigned int UTCL1_CTRL__UTCL1_CACHE_WRITE_PERM_MASK  = 0x00080000L;
    constexpr unsigned int UTCL1_CTRL__UTCL1_FORCE_INV_ALL_DONE_MASK = 0x00000800L;
    constexpr unsigned int UTCL1_CTRL__UTCL1_FORCE_INV_ALL_MASK     = 0x00000400L;
    constexpr unsigned int UTCL1_CTRL__UTCL1_FORCE_RANGE_INV_TO_VMID_MASK = 0x00000200L;
    constexpr unsigned int UTCL1_CTRL__UTCL1_INV_FILTER_2M_MASK     = 0x00002000L;
    constexpr unsigned int UTCL1_CTRL__UTCL1_LARGE_PAGE_SIZE_MASK   = 0x00000002L;
    constexpr unsigned int UTCL1_CTRL__UTCL1_MH_CAM_DUPLICATE_4K_FILTER_MASK = 0x00100000L;
    constexpr unsigned int UTCL1_CTRL__UTCL1_MH_DISABLE_DUPLICATES_MASK = 0x00200000L;
    constexpr unsigned int UTCL1_CTRL__UTCL1_MH_DISABLE_RECENT_BUFFER_MASK = 0x00800000L;
    constexpr unsigned int UTCL1_CTRL__UTCL1_MH_INV_FRAG_SIZE_OVERRIDE_MASK = 0x00040000L;
    constexpr unsigned int UTCL1_CTRL__UTCL1_MISS_CC_PRIORITY_MASK  = 0x03000000L;
    constexpr unsigned int UTCL1_CTRL__UTCL1_RANGE_INV_FORCE_CHK_ALL_MASK = 0x00004000L;
    constexpr unsigned int UTCL1_CTRL__UTCL1_REDUCE_CC_SIZE_MASK    = 0x0c000000L;
    constexpr unsigned int UTCL1_CTRL__UTCL1_RMI_BYPASS_MASK        = 0x00000040L;
    constexpr unsigned int UTCL1_CTRL__UTCL1_RMI_DEDICATED_CACHE_CORE_MASK = 0x00000100L;
    constexpr unsigned int UTCL1_CTRL__UTCL1_SMALL_PAGE_SIZE_MASK   = 0x00000001L;
    constexpr unsigned int UTCL1_CTRL__UTCL1_SQCD_BYPASS_MASK       = 0x00000020L;
    constexpr unsigned int UTCL1_CTRL__UTCL1_SQCI_BYPASS_MASK       = 0x00000010L;
    constexpr unsigned int UTCL1_CTRL__UTCL1_SQG_BYPASS_MASK        = 0x00000080L;
    constexpr unsigned int UTCL1_CTRL__UTCL1_TCP_BYPASS_MASK        = 0x00000008L;
    constexpr unsigned int UTCL1_CTRL__UTCL1_UTCL2_FGCG_REPEATERS_OVERRIDE_MASK = 0x00001000L;
    constexpr unsigned int UTCL1_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int UTCL1_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int UTCL1_PERFCOUNTER0_SELECT__COUNTER_MODE_MASK = 0xf0000000L;
    constexpr unsigned int UTCL1_PERFCOUNTER0_SELECT__PERF_SEL_MASK = 0x000003ffL;
    constexpr unsigned int UTCL1_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int UTCL1_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int UTCL1_PERFCOUNTER1_SELECT__COUNTER_MODE_MASK = 0xf0000000L;
    constexpr unsigned int UTCL1_PERFCOUNTER1_SELECT__PERF_SEL_MASK = 0x000003ffL;
    constexpr unsigned int VGT_DMA_DATA_FIFO_DEPTH__DMA_DATA_FIFO_DEPTH_MASK = 0x000003ffL;
    constexpr unsigned int VGT_DMA_INDEX_TYPE__ATC_MASK             = 0x00000100L;
    constexpr unsigned int VGT_DMA_INDEX_TYPE__MTYPE_MASK           = 0x00003800L;
    constexpr unsigned int VGT_DMA_INDEX_TYPE__RDREQ_POLICY_MASK    = 0x000000c0L;
    constexpr unsigned int VGT_DRAW_PAYLOAD_CNTL__EN_DRAW_VP_MASK   = 0x00000010L;
    constexpr unsigned int VGT_ESGS_RING_SIZE__MEM_SIZE_MASK        = 0xffffffffL;
    constexpr unsigned int VGT_FIFO_DEPTHS__HSINPUT_FIFO_DEPTH_MASK = 0x1f800000L;
    constexpr unsigned int VGT_FIFO_DEPTHS__RESERVED_1_MASK         = 0x00400000L;
    constexpr unsigned int VGT_GS_MODE__COMPUTE_MODE_MASK           = 0x00004000L;
    constexpr unsigned int VGT_GS_MODE__ELEMENT_INFO_EN_MASK        = 0x00010000L;
    constexpr unsigned int VGT_GS_MODE__FAST_COMPUTE_MODE_MASK      = 0x00008000L;
    constexpr unsigned int VGT_SHADER_STAGES_EN__DYNAMIC_HS_MASK    = 0x00000100L;
    constexpr unsigned int VGT_SHADER_STAGES_EN__GS_W32_EN_MASK     = 0x00400000L;
    constexpr unsigned int VGT_SHADER_STAGES_EN__HS_W32_EN_MASK     = 0x00200000L;
    constexpr unsigned int VGT_SHADER_STAGES_EN__NGG_WAVE_ID_EN_MASK = 0x01000000L;
    constexpr unsigned int VGT_SHADER_STAGES_EN__PRIMGEN_PASSTHRU_EN_MASK = 0x02000000L;
    constexpr unsigned int VGT_SHADER_STAGES_EN__VS_W32_EN_MASK     = 0x00800000L;
    constexpr unsigned int VGT_TF_PARAM__DETECT_ONE_MASK            = 0x00080000L;
    constexpr unsigned int VGT_TF_PARAM__DETECT_ZERO_MASK           = 0x00100000L;
    constexpr unsigned int VGT_TF_PARAM__MTYPE_MASK                 = 0x03800000L;
    constexpr unsigned int VGT_TF_PARAM__NUM_DS_WAVES_PER_SIMD_MASK = 0x00003c00L;
    constexpr unsigned int VGT_TF_PARAM__RDREQ_POLICY_MASK          = 0x00018000L;
    constexpr unsigned int VGT_VTX_VECT_EJECT_REG__PRIM_COUNT_MASK  = 0x000003ffL;
    constexpr unsigned int WD_UTCL1_CNTL__MTYPE_OVERRIDE_MASK       = 0x20000000L;
} // namespace Gfx10

namespace Gfx101
{
    constexpr unsigned int CB_COLOR0_INFO__ALT_TILE_MODE_MASK       = 0x80000000L;
    constexpr unsigned int CB_COLOR1_INFO__ALT_TILE_MODE_MASK       = 0x80000000L;
    constexpr unsigned int CB_COLOR2_INFO__ALT_TILE_MODE_MASK       = 0x80000000L;
    constexpr unsigned int CB_COLOR3_INFO__ALT_TILE_MODE_MASK       = 0x80000000L;
    constexpr unsigned int CB_COLOR4_INFO__ALT_TILE_MODE_MASK       = 0x80000000L;
    constexpr unsigned int CB_COLOR5_INFO__ALT_TILE_MODE_MASK       = 0x80000000L;
    constexpr unsigned int CB_COLOR6_INFO__ALT_TILE_MODE_MASK       = 0x80000000L;
    constexpr unsigned int CB_COLOR7_INFO__ALT_TILE_MODE_MASK       = 0x80000000L;
    constexpr unsigned int CB_DCC_CONFIG__DCC_CACHE_NUM_TAGS_MASK   = 0xfc000000L;
    constexpr unsigned int CB_HW_CONTROL_3__DISABLE_DUALSRC_WITH_OBJPRIMID_FIX_MASK = 0x08000000L;
    constexpr unsigned int CHCG_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int CHCG_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0x0f000000L;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0xf0000000L;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT__PERF_SEL1_MASK = 0x000ffc00L;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT__PERF_SEL_MASK  = 0x000003ffL;
    constexpr unsigned int CHCG_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int CHCG_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int CHCG_PERFCOUNTER1_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int CHCG_PERFCOUNTER1_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int CHCG_PERFCOUNTER1_SELECT__PERF_SEL_MASK  = 0x000003ffL;
    constexpr unsigned int CHCG_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int CHCG_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int CHCG_PERFCOUNTER2_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int CHCG_PERFCOUNTER2_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int CHCG_PERFCOUNTER2_SELECT__PERF_SEL_MASK  = 0x000003ffL;
    constexpr unsigned int CHCG_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int CHCG_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int CHCG_PERFCOUNTER3_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int CHCG_PERFCOUNTER3_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int CHCG_PERFCOUNTER3_SELECT__PERF_SEL_MASK  = 0x000003ffL;
    constexpr unsigned int CH_ARB_CTRL__NUM_MEM_PIPES_MASK          = 0x00000007L;
    constexpr unsigned int CH_PIPE_STEER__PIPE4_MASK                = 0x00000300L;
    constexpr unsigned int CH_PIPE_STEER__PIPE5_MASK                = 0x00000c00L;
    constexpr unsigned int CH_PIPE_STEER__PIPE6_MASK                = 0x00003000L;
    constexpr unsigned int CH_PIPE_STEER__PIPE7_MASK                = 0x0000c000L;
    constexpr unsigned int CH_PIPE_STEER__PIPE8_MASK                = 0x00030000L;
    constexpr unsigned int CH_PIPE_STEER__PIPE9_MASK                = 0x000c0000L;
    constexpr unsigned int CH_PIPE_STEER__PIPE10_MASK               = 0x00300000L;
    constexpr unsigned int CH_PIPE_STEER__PIPE11_MASK               = 0x00c00000L;
    constexpr unsigned int CH_PIPE_STEER__PIPE12_MASK               = 0x03000000L;
    constexpr unsigned int CH_PIPE_STEER__PIPE13_MASK               = 0x0c000000L;
    constexpr unsigned int CH_PIPE_STEER__PIPE14_MASK               = 0x30000000L;
    constexpr unsigned int CH_PIPE_STEER__PIPE15_MASK               = 0xc0000000L;
    constexpr unsigned int CH_VC5_ENABLE__UTCL2_VC5_ENABLE_MASK     = 0x00000002L;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_0__COEFFICIENT_HIER_SELECT_MASK = 0x00000380L;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_0__COEFFICIENT_MASK = 0x007f8000L;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_0__CONTRIBUTION_HIER_SELECT_MASK = 0x00001c00L;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_0__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_0__GROUP_UPDATE_EN_MASK = 0x00002000L;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_0__RESERVED_MASK  = 0x00004000L;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_1__COEFFICIENT_HIER_SELECT_MASK = 0x00000380L;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_1__COEFFICIENT_MASK = 0x007f8000L;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_1__CONTRIBUTION_HIER_SELECT_MASK = 0x00001c00L;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_1__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_1__GROUP_UPDATE_EN_MASK = 0x00002000L;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_1__RESERVED_MASK  = 0x00004000L;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_2__COEFFICIENT_HIER_SELECT_MASK = 0x00000380L;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_2__COEFFICIENT_MASK = 0x007f8000L;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_2__CONTRIBUTION_HIER_SELECT_MASK = 0x00001c00L;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_2__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_2__GROUP_UPDATE_EN_MASK = 0x00002000L;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_2__RESERVED_MASK  = 0x00004000L;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_3__COEFFICIENT_HIER_SELECT_MASK = 0x00000380L;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_3__COEFFICIENT_MASK = 0x007f8000L;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_3__CONTRIBUTION_HIER_SELECT_MASK = 0x00001c00L;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_3__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_3__GROUP_UPDATE_EN_MASK = 0x00002000L;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_3__RESERVED_MASK  = 0x00004000L;
    constexpr unsigned int CP_EOP_DONE_DOORBELL__DOORBELL_OFFSET_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_GFX_HQD_CE_CNTL__BUF_SWAP_MASK        = 0x00030000L;
    constexpr unsigned int CP_MES_DCSR__CSR_MASK                    = 0xffffffffL;
    constexpr unsigned int CP_MES_DMCONTROL__CONTROL_MASK           = 0xffffffffL;
    constexpr unsigned int CP_MES_DMINFO__INFO_MASK                 = 0xffffffffL;
    constexpr unsigned int CP_MES_DPC_HIGH__INSTR_PNTR_MASK         = 0xffffffffL;
    constexpr unsigned int CP_MES_DPC_LOW__INSTR_PNTR_MASK          = 0xffffffffL;
    constexpr unsigned int CP_MES_DSCRATCH_HIGH__DATA_MASK          = 0xffffffffL;
    constexpr unsigned int CP_MES_DSCRATCH_LOW__DATA_MASK           = 0xffffffffL;
    constexpr unsigned int CP_MES_INTERRUPT__MES_INT_MASK           = 0x0000ffffL;
    constexpr unsigned int CP_MES_INTERRUPT__PENDING_INTERRUPT_MASK = 0xffff0000L;
    constexpr unsigned int CP_MES_PERFCOUNT_CNTL__EVENT_SEL_MASK    = 0x00000007L;
    constexpr unsigned int CP_MES_SETHALTNOTIFICATION__SETHALT_MASK = 0xffffffffL;
    constexpr unsigned int CP_MES_TDATA1_HIGH__DATA_MASK            = 0xffffffffL;
    constexpr unsigned int CP_MES_TDATA1_LOW__DATA_MASK             = 0xffffffffL;
    constexpr unsigned int CP_MES_TDATA2_HIGH__DATA_MASK            = 0xffffffffL;
    constexpr unsigned int CP_MES_TDATA2_LOW__DATA_MASK             = 0xffffffffL;
    constexpr unsigned int CP_MES_TDATA3_HIH__DATA_MASK             = 0xffffffffL;
    constexpr unsigned int CP_MES_TDATA3_LOW__DATA_MASK             = 0xffffffffL;
    constexpr unsigned int CP_MES_TSELCT_HIGH__TSELECT_MASK         = 0xffffffffL;
    constexpr unsigned int CP_MES_TSELCT_LOW__TSELECT_MASK          = 0xffffffffL;
    constexpr unsigned int CP_PIPE_STATS_DOORBELL__DOORBELL_OFFSET_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_SCRATCH_INDEX__SCRATCH_INDEX_MASK     = 0x000000ffL;
    constexpr unsigned int CP_SEM_DOORBELL__DOORBELL_OFFSET_MASK    = 0x0ffffffcL;
    constexpr unsigned int CP_SIG_SEM_ADDR_LO__SEM_ADDR_SWAP_MASK   = 0x00000003L;
    constexpr unsigned int CP_STREAM_OUT_DOORBELL__DOORBELL_OFFSET_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_WAIT_SEM_ADDR_LO__SEM_ADDR_SWAP_MASK  = 0x00000003L;
    constexpr unsigned int DB_DEBUG2__DISABLE_TILE_COVERED_FOR_PS_ITER_MASK = 0x00004000L;
    constexpr unsigned int DB_DEBUG2__DISABLE_VR_OBJ_PRIM_ID_MASK   = 0x04000000L;
    constexpr unsigned int DB_DEBUG2__DISABLE_VR_PS_INVOKE_MASK     = 0x08000000L;
    constexpr unsigned int DB_EXCEPTION_CONTROL__EXTRA_BITS_GROUP_A_MASK = 0x000000e0L;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__BYPASS_SORT_RD_BA_MASK = 0x20000000L;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__DBCB_LOB_SWITCH_TIMEOUT_MASK = 0x0003f800L;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__DISABLE_FLQ_LOB_EVERY_256B_MASK = 0x00100000L;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__DISABLE_MCC_BURST_COUNT_RESET_ON_LOB_MASK = 0x00080000L;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__DISABLE_MCC_BURST_FORCE_FLUSH_BEFORE_FIFO_MASK = 0x00400000L;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__DISABLE_ZCACHE_FL_OP_EVEN_ARB_MASK = 0x00200000L;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__ENABLE_FG_DEFAULT_TIMEOUT_MASK = 0x00040000L;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__ENABLE_TIMEOUT_CB_LOB_GEN_MASK = 0x02000000L;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__ENABLE_TIMEOUT_DKG_LOB_GEN_MASK = 0x00800000L;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__ENABLE_TIMEOUT_FG_LOB_FWDR_MASK = 0x08000000L;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__ENABLE_TIMEOUT_FL_BURST_MASK = 0x04000000L;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__ENABLE_TIMEOUT_LPF_LOB_GEN_MASK = 0x01000000L;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__ENABLE_TIMEOUT_RD_BA_ACCUM_MASK = 0x10000000L;
    constexpr unsigned int GCRD_SA_TARGETS_DISABLE__GCRD_TARGETS_DISABLE_MASK = 0x0007ffffL;
    constexpr unsigned int GC_CAC_ACC_CBR0__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CBR1__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CBR2__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CBR3__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_DBR0__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_DBR1__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_DBR2__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_DBR3__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_OVRD_CBR__OVRRD_SELECT_MASK       = 0x0000000fL;
    constexpr unsigned int GC_CAC_OVRD_CBR__OVRRD_VALUE_MASK        = 0x000000f0L;
    constexpr unsigned int GC_CAC_OVRD_CB__OVRRD_SELECT_MASK        = 0x0000000fL;
    constexpr unsigned int GC_CAC_OVRD_CB__OVRRD_VALUE_MASK         = 0x000000f0L;
    constexpr unsigned int GC_CAC_OVRD_DBR__OVRRD_SELECT_MASK       = 0x0000000fL;
    constexpr unsigned int GC_CAC_OVRD_DBR__OVRRD_VALUE_MASK        = 0x000000f0L;
    constexpr unsigned int GC_CAC_OVRD_DB__OVRRD_SELECT_MASK        = 0x0000000fL;
    constexpr unsigned int GC_CAC_OVRD_DB__OVRRD_VALUE_MASK         = 0x000000f0L;
    constexpr unsigned int GC_CAC_OVRD_GDS__OVRRD_SELECT_MASK       = 0x0000000fL;
    constexpr unsigned int GC_CAC_OVRD_GDS__OVRRD_VALUE_MASK        = 0x000000f0L;
    constexpr unsigned int GC_CAC_OVRD_PA__OVRRD_SELECT_MASK        = 0x00000003L;
    constexpr unsigned int GC_CAC_OVRD_PA__OVRRD_VALUE_MASK         = 0x0000000cL;
    constexpr unsigned int GC_CAC_OVRD_RMI__OVRRD_SELECT_MASK       = 0x00000001L;
    constexpr unsigned int GC_CAC_OVRD_RMI__OVRRD_VALUE_MASK        = 0x00000002L;
    constexpr unsigned int GC_CAC_OVRD_SC__OVRRD_SELECT_MASK        = 0x00000001L;
    constexpr unsigned int GC_CAC_OVRD_SC__OVRRD_VALUE_MASK         = 0x00000002L;
    constexpr unsigned int GC_CAC_OVRD_SQ__OVRRD_SELECT_MASK        = 0x0000003fL;
    constexpr unsigned int GC_CAC_OVRD_SQ__OVRRD_VALUE_MASK         = 0x00000fc0L;
    constexpr unsigned int GC_CAC_OVRD_TCP__OVRRD_SELECT_MASK       = 0x0000001fL;
    constexpr unsigned int GC_CAC_OVRD_TCP__OVRRD_VALUE_MASK        = 0x000003e0L;
    constexpr unsigned int GC_CAC_OVRD_TD__OVRRD_SELECT_MASK        = 0x000003ffL;
    constexpr unsigned int GC_CAC_OVRD_TD__OVRRD_VALUE_MASK         = 0x000ffc00L;
    constexpr unsigned int GC_CAC_WEIGHT_CBR_0__WEIGHT_CBR_SIG0_MASK = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_CBR_0__WEIGHT_CBR_SIG1_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_CBR_1__WEIGHT_CBR_SIG2_MASK = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_CBR_1__WEIGHT_CBR_SIG3_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_DBR_0__WEIGHT_DBR_SIG0_MASK = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_DBR_0__WEIGHT_DBR_SIG1_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_DBR_1__WEIGHT_DBR_SIG2_MASK = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_DBR_1__WEIGHT_DBR_SIG3_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_RMI_0__UNUSED_0_MASK       = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_SC_0__UNUSED_0_MASK        = 0xffff0000L;
    constexpr unsigned int GC_DIDT_CTRL0__DIDT_CLK_EN_OVERRIDE_MASK = 0x00000010L;
    constexpr unsigned int GC_DIDT_CTRL0__DIDT_CTRL_EN_MASK         = 0x00000001L;
    constexpr unsigned int GC_DIDT_CTRL0__DIDT_SW_RST_MASK          = 0x00000008L;
    constexpr unsigned int GC_DIDT_CTRL0__DIDT_TRIGGER_THROTTLE_LOWBIT_MASK = 0x000001e0L;
    constexpr unsigned int GC_DIDT_CTRL0__PHASE_OFFSET_MASK         = 0x00000006L;
    constexpr unsigned int GC_DIDT_CTRL1__MAX_POWER_MASK            = 0xffff0000L;
    constexpr unsigned int GC_DIDT_CTRL1__MIN_POWER_MASK            = 0x0000ffffL;
    constexpr unsigned int GC_DIDT_CTRL2__LONG_TERM_INTERVAL_RATIO_MASK = 0x78000000L;
    constexpr unsigned int GC_DIDT_CTRL2__MAX_POWER_DELTA_MASK      = 0x00003fffL;
    constexpr unsigned int GC_DIDT_CTRL2__SHORT_TERM_INTERVAL_SIZE_MASK = 0x03ff0000L;
    constexpr unsigned int GC_DIDT_CTRL2__UNUSED_0_MASK             = 0x0000c000L;
    constexpr unsigned int GC_DIDT_CTRL2__UNUSED_1_MASK             = 0x04000000L;
    constexpr unsigned int GC_DIDT_CTRL2__UNUSED_2_MASK             = 0x80000000L;
    constexpr unsigned int GC_DIDT_WEIGHT__DB_WEIGHT_MASK           = 0x0000ff00L;
    constexpr unsigned int GC_DIDT_WEIGHT__SQ_WEIGHT_MASK           = 0x000000ffL;
    constexpr unsigned int GC_DIDT_WEIGHT__TCP_WEIGHT_MASK          = 0xff000000L;
    constexpr unsigned int GC_DIDT_WEIGHT__TD_WEIGHT_MASK           = 0x00ff0000L;
    constexpr unsigned int GC_EDC_OVERFLOW__PSM_COUNTER_MASK        = 0xfffc0000L;
    constexpr unsigned int GC_USER_PRIM_CONFIG__INACTIVE_IA_MASK    = 0x00030000L;
    constexpr unsigned int GC_USER_PRIM_CONFIG__INACTIVE_VGT_PA_MASK = 0x0f000000L;
    constexpr unsigned int GE_FAST_CLKS__FORCE_FAST_CLK_MASK        = 0x80000000L;
    constexpr unsigned int GE_FAST_CLKS__HYSTERESIS_MASK            = 0x3fffffffL;
    constexpr unsigned int GE_FAST_CLKS__LOCK_MASK                  = 0x40000000L;
    constexpr unsigned int GL1_ARB_CTRL__NUM_MEM_PIPES_MASK         = 0x00000007L;
    constexpr unsigned int GL1_PIPE_STEER__PIPE4_MASK               = 0x00000300L;
    constexpr unsigned int GL1_PIPE_STEER__PIPE5_MASK               = 0x00000c00L;
    constexpr unsigned int GL1_PIPE_STEER__PIPE6_MASK               = 0x00003000L;
    constexpr unsigned int GL1_PIPE_STEER__PIPE7_MASK               = 0x0000c000L;
    constexpr unsigned int GL1_PIPE_STEER__PIPE8_MASK               = 0x00030000L;
    constexpr unsigned int GL1_PIPE_STEER__PIPE9_MASK               = 0x000c0000L;
    constexpr unsigned int GL1_PIPE_STEER__PIPE10_MASK              = 0x00300000L;
    constexpr unsigned int GL1_PIPE_STEER__PIPE11_MASK              = 0x00c00000L;
    constexpr unsigned int GL1_PIPE_STEER__PIPE12_MASK              = 0x03000000L;
    constexpr unsigned int GL1_PIPE_STEER__PIPE13_MASK              = 0x0c000000L;
    constexpr unsigned int GL1_PIPE_STEER__PIPE14_MASK              = 0x30000000L;
    constexpr unsigned int GL1_PIPE_STEER__PIPE15_MASK              = 0xc0000000L;
    constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_CPF_MASK = 0x00010000L;
    constexpr unsigned int GRBM_STATUS2__CPF_RQ_PENDING_MASK        = 0x00080000L;
    constexpr unsigned int GRBM_STATUS2__RLC_BUSY_MASK              = 0x01000000L;
    constexpr unsigned int GRBM_STATUS2__TCP_BUSY_MASK              = 0x02000000L;
    constexpr unsigned int GUS_PERFCOUNTER0_CFG__CLEAR_MASK         = 0x20000000L;
    constexpr unsigned int GUS_PERFCOUNTER0_CFG__ENABLE_MASK        = 0x10000000L;
    constexpr unsigned int GUS_PERFCOUNTER0_CFG__PERF_MODE_MASK     = 0x0f000000L;
    constexpr unsigned int GUS_PERFCOUNTER0_CFG__PERF_SEL_END_MASK  = 0x0000ff00L;
    constexpr unsigned int GUS_PERFCOUNTER0_CFG__PERF_SEL_MASK      = 0x000000ffL;
    constexpr unsigned int GUS_PERFCOUNTER1_CFG__CLEAR_MASK         = 0x20000000L;
    constexpr unsigned int GUS_PERFCOUNTER1_CFG__ENABLE_MASK        = 0x10000000L;
    constexpr unsigned int GUS_PERFCOUNTER1_CFG__PERF_MODE_MASK     = 0x0f000000L;
    constexpr unsigned int GUS_PERFCOUNTER1_CFG__PERF_SEL_END_MASK  = 0x0000ff00L;
    constexpr unsigned int GUS_PERFCOUNTER1_CFG__PERF_SEL_MASK      = 0x000000ffL;
    constexpr unsigned int GUS_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GUS_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GUS_PERFCOUNTER2_MODE__COMPARE_MODE0_MASK = 0x00000003L;
    constexpr unsigned int GUS_PERFCOUNTER2_MODE__COMPARE_MODE1_MASK = 0x0000000cL;
    constexpr unsigned int GUS_PERFCOUNTER2_MODE__COMPARE_MODE2_MASK = 0x00000030L;
    constexpr unsigned int GUS_PERFCOUNTER2_MODE__COMPARE_MODE3_MASK = 0x000000c0L;
    constexpr unsigned int GUS_PERFCOUNTER2_MODE__COMPARE_VALUE0_MASK = 0x00000f00L;
    constexpr unsigned int GUS_PERFCOUNTER2_MODE__COMPARE_VALUE1_MASK = 0x0000f000L;
    constexpr unsigned int GUS_PERFCOUNTER2_MODE__COMPARE_VALUE2_MASK = 0x000f0000L;
    constexpr unsigned int GUS_PERFCOUNTER2_MODE__COMPARE_VALUE3_MASK = 0x00f00000L;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT__CNTR_MODE_MASK  = 0x00f00000L;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT__PERF_SEL1_MASK  = 0x000ffc00L;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT__PERF_SEL_MASK   = 0x000003ffL;
    constexpr unsigned int GUS_PERFCOUNTER_HI__COMPARE_VALUE_MASK   = 0xffff0000L;
    constexpr unsigned int GUS_PERFCOUNTER_HI__COUNTER_HI_MASK      = 0x0000ffffL;
    constexpr unsigned int GUS_PERFCOUNTER_LO__COUNTER_LO_MASK      = 0xffffffffL;
    constexpr unsigned int GUS_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL_MASK = 0x02000000L;
    constexpr unsigned int GUS_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY_MASK = 0x01000000L;
    constexpr unsigned int GUS_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT_MASK = 0x0000000fL;
    constexpr unsigned int GUS_PERFCOUNTER_RSLT_CNTL__START_TRIGGER_MASK = 0x0000ff00L;
    constexpr unsigned int GUS_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE_MASK = 0x04000000L;
    constexpr unsigned int GUS_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER_MASK = 0x00ff0000L;
    constexpr unsigned int PA_CL_ENHANCE__EN_32BIT_OBJPRIMID_MASK   = 0x00800000L;
    constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_SHD_OBJPRIM_ID_MASK = 0x04000000L;
    constexpr unsigned int PA_SC_ENHANCE_1__ALLOW_SCALE_LINE_WIDTH_PAD_WITH_BINNING_MASK = 0x00020000L;
    constexpr unsigned int PA_SC_ENHANCE_1__DEBUG_PIXEL_PICKER_XY_UNPACK_MASK = 0x00001000L;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_SC_SEND_DB_VPZ_FOR_COMPOUND_INDEX_EN_MASK = 0x00000040L;
    constexpr unsigned int PA_SC_FOV_WINDOW_LR__LEFT_EYE_FOV_LEFT_MASK = 0x000000ffL;
    constexpr unsigned int PA_SC_FOV_WINDOW_LR__LEFT_EYE_FOV_RIGHT_MASK = 0x0000ff00L;
    constexpr unsigned int PA_SC_FOV_WINDOW_LR__RIGHT_EYE_FOV_LEFT_MASK = 0x00ff0000L;
    constexpr unsigned int PA_SC_FOV_WINDOW_LR__RIGHT_EYE_FOV_RIGHT_MASK = 0xff000000L;
    constexpr unsigned int PA_SC_FOV_WINDOW_TB__FOV_BOT_MASK        = 0x0000ff00L;
    constexpr unsigned int PA_SC_FOV_WINDOW_TB__FOV_TOP_MASK        = 0x000000ffL;
    constexpr unsigned int PA_SC_HORIZ_GRID__BOT_HALF_MASK          = 0x00ff0000L;
    constexpr unsigned int PA_SC_HORIZ_GRID__BOT_QTR_MASK           = 0xff000000L;
    constexpr unsigned int PA_SC_HORIZ_GRID__TOP_HALF_MASK          = 0x0000ff00L;
    constexpr unsigned int PA_SC_HORIZ_GRID__TOP_QTR_MASK           = 0x000000ffL;
    constexpr unsigned int PA_SC_LEFT_VERT_GRID__LEFT_HALF_MASK     = 0x0000ff00L;
    constexpr unsigned int PA_SC_LEFT_VERT_GRID__LEFT_QTR_MASK      = 0x000000ffL;
    constexpr unsigned int PA_SC_LEFT_VERT_GRID__RIGHT_HALF_MASK    = 0x00ff0000L;
    constexpr unsigned int PA_SC_LEFT_VERT_GRID__RIGHT_QTR_MASK     = 0xff000000L;
    constexpr unsigned int PA_SC_MODE_CNTL_0__SCALE_LINE_WIDTH_PAD_MASK = 0x00000010L;
    constexpr unsigned int PA_SC_RIGHT_VERT_GRID__LEFT_HALF_MASK    = 0x0000ff00L;
    constexpr unsigned int PA_SC_RIGHT_VERT_GRID__LEFT_QTR_MASK     = 0x000000ffL;
    constexpr unsigned int PA_SC_RIGHT_VERT_GRID__RIGHT_HALF_MASK   = 0x00ff0000L;
    constexpr unsigned int PA_SC_RIGHT_VERT_GRID__RIGHT_QTR_MASK    = 0xff000000L;
    constexpr unsigned int RLC_SPM_MC_CNTL__RESERVED_MASK           = 0xffff0000L;
    constexpr unsigned int RMI_CLOCK_CNTRL__DYN_CLK_RB1_BUSY_MASK_MASK = 0x01f00000L;
    constexpr unsigned int RMI_CLOCK_CNTRL__DYN_CLK_RB1_WAKEUP_MASK_MASK = 0x3e000000L;
    constexpr unsigned int RMI_GENERAL_CNTL__RB1_HARVEST_EN_MASK    = 0x00100000L;
    constexpr unsigned int RMI_GENERAL_STATUS__RDREQ_CONSUMER_FIFO_1_BUSY_MASK = 0x00020000L;
    constexpr unsigned int RMI_GENERAL_STATUS__WRREQ_CONSUMER_FIFO_1_BUSY_MASK = 0x00010000L;
    constexpr unsigned int RMI_SPARE_1__SPARE_BIT_8_MASK            = 0x00000001L;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG_1__XBAR_ARB_ROUND_ROBIN_WEIGHT_RB1_RD_MASK = 0x00ff0000L;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG_1__XBAR_ARB_ROUND_ROBIN_WEIGHT_RB1_WR_MASK = 0xff000000L;
    constexpr unsigned int RMI_XBAR_CONFIG__XBAR_EN_IN_RB1_MASK     = 0x00004000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__BARRIERS_MASK = 0x00078000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__LDS_MASK     = 0x00000f00L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__SGPR_MASK    = 0x000000f0L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__VGPR_MASK    = 0x0000000fL;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__WAVES_MASK   = 0x00007000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__BARRIERS_MASK = 0x00078000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__LDS_MASK     = 0x00000f00L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__SGPR_MASK    = 0x000000f0L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__VGPR_MASK    = 0x0000000fL;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__WAVES_MASK   = 0x00007000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__EN_MASK   = 0x00000001L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__QUEUE_MASK_MASK = 0x00ff0000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__TYPE_MASK_MASK = 0x0000fffeL;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__EN_MASK   = 0x00000001L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__QUEUE_MASK_MASK = 0x00ff0000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__TYPE_MASK_MASK = 0x0000fffeL;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__DISPATCH_DRAW_EN_MASK = 0x01000000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_0__COEFFICIENT_HIER_SELECT_MASK = 0x00000380L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_0__COEFFICIENT_MASK = 0x007f8000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_0__CONTRIBUTION_HIER_SELECT_MASK = 0x00001c00L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_0__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_0__GROUP_UPDATE_EN_MASK = 0x00002000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_0__RESERVED_MASK = 0x00004000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_1__COEFFICIENT_HIER_SELECT_MASK = 0x00000380L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_1__COEFFICIENT_MASK = 0x007f8000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_1__CONTRIBUTION_HIER_SELECT_MASK = 0x00001c00L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_1__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_1__GROUP_UPDATE_EN_MASK = 0x00002000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_1__RESERVED_MASK = 0x00004000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_2__COEFFICIENT_HIER_SELECT_MASK = 0x00000380L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_2__COEFFICIENT_MASK = 0x007f8000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_2__CONTRIBUTION_HIER_SELECT_MASK = 0x00001c00L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_2__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_2__GROUP_UPDATE_EN_MASK = 0x00002000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_2__RESERVED_MASK = 0x00004000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_3__COEFFICIENT_HIER_SELECT_MASK = 0x00000380L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_3__COEFFICIENT_MASK = 0x007f8000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_3__CONTRIBUTION_HIER_SELECT_MASK = 0x00001c00L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_3__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_3__GROUP_UPDATE_EN_MASK = 0x00002000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_3__RESERVED_MASK = 0x00004000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_0__COEFFICIENT_HIER_SELECT_MASK = 0x00000380L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_0__COEFFICIENT_MASK = 0x007f8000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_0__CONTRIBUTION_HIER_SELECT_MASK = 0x00001c00L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_0__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_0__GROUP_UPDATE_EN_MASK = 0x00002000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_0__RESERVED_MASK = 0x00004000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_1__COEFFICIENT_HIER_SELECT_MASK = 0x00000380L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_1__COEFFICIENT_MASK = 0x007f8000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_1__CONTRIBUTION_HIER_SELECT_MASK = 0x00001c00L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_1__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_1__GROUP_UPDATE_EN_MASK = 0x00002000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_1__RESERVED_MASK = 0x00004000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_2__COEFFICIENT_HIER_SELECT_MASK = 0x00000380L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_2__COEFFICIENT_MASK = 0x007f8000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_2__CONTRIBUTION_HIER_SELECT_MASK = 0x00001c00L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_2__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_2__GROUP_UPDATE_EN_MASK = 0x00002000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_2__RESERVED_MASK = 0x00004000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_3__COEFFICIENT_HIER_SELECT_MASK = 0x00000380L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_3__COEFFICIENT_MASK = 0x007f8000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_3__CONTRIBUTION_HIER_SELECT_MASK = 0x00001c00L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_3__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_3__GROUP_UPDATE_EN_MASK = 0x00002000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_3__RESERVED_MASK = 0x00004000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_0__COEFFICIENT_HIER_SELECT_MASK = 0x00000380L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_0__COEFFICIENT_MASK = 0x007f8000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_0__CONTRIBUTION_HIER_SELECT_MASK = 0x00001c00L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_0__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_0__GROUP_UPDATE_EN_MASK = 0x00002000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_0__RESERVED_MASK = 0x00004000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_1__COEFFICIENT_HIER_SELECT_MASK = 0x00000380L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_1__COEFFICIENT_MASK = 0x007f8000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_1__CONTRIBUTION_HIER_SELECT_MASK = 0x00001c00L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_1__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_1__GROUP_UPDATE_EN_MASK = 0x00002000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_1__RESERVED_MASK = 0x00004000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_2__COEFFICIENT_HIER_SELECT_MASK = 0x00000380L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_2__COEFFICIENT_MASK = 0x007f8000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_2__CONTRIBUTION_HIER_SELECT_MASK = 0x00001c00L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_2__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_2__GROUP_UPDATE_EN_MASK = 0x00002000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_2__RESERVED_MASK = 0x00004000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_3__COEFFICIENT_HIER_SELECT_MASK = 0x00000380L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_3__COEFFICIENT_MASK = 0x007f8000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_3__CONTRIBUTION_HIER_SELECT_MASK = 0x00001c00L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_3__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_3__GROUP_UPDATE_EN_MASK = 0x00002000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_3__RESERVED_MASK = 0x00004000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_0__COEFFICIENT_HIER_SELECT_MASK = 0x00000380L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_0__COEFFICIENT_MASK = 0x007f8000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_0__CONTRIBUTION_HIER_SELECT_MASK = 0x00001c00L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_0__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_0__GROUP_UPDATE_EN_MASK = 0x00002000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_0__RESERVED_MASK = 0x00004000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_1__COEFFICIENT_HIER_SELECT_MASK = 0x00000380L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_1__COEFFICIENT_MASK = 0x007f8000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_1__CONTRIBUTION_HIER_SELECT_MASK = 0x00001c00L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_1__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_1__GROUP_UPDATE_EN_MASK = 0x00002000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_1__RESERVED_MASK = 0x00004000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_2__COEFFICIENT_HIER_SELECT_MASK = 0x00000380L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_2__COEFFICIENT_MASK = 0x007f8000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_2__CONTRIBUTION_HIER_SELECT_MASK = 0x00001c00L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_2__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_2__GROUP_UPDATE_EN_MASK = 0x00002000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_2__RESERVED_MASK = 0x00004000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_3__COEFFICIENT_HIER_SELECT_MASK = 0x00000380L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_3__COEFFICIENT_MASK = 0x007f8000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_3__CONTRIBUTION_HIER_SELECT_MASK = 0x00001c00L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_3__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_3__GROUP_UPDATE_EN_MASK = 0x00002000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_3__RESERVED_MASK = 0x00004000L;
    constexpr unsigned int SPI_SYS_COMPUTE__PIPE_MASK               = 0x000000ffL;
    constexpr unsigned int SPI_SYS_WIF_CNTL__THRESHOLD_MASK         = 0x000000ffL;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS4__VALUE_MASK     = 0x0000007fL;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS5__VALUE_MASK     = 0x0000007fL;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS6__VALUE_MASK     = 0x0000007fL;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS7__VALUE_MASK     = 0x0000007fL;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_6__EN_WARN_MASK    = 0x80000000L;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_6__MAX_CNT_MASK    = 0x7fffffffL;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_7__EN_WARN_MASK    = 0x80000000L;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_7__MAX_CNT_MASK    = 0x7fffffffL;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_8__EN_WARN_MASK    = 0x80000000L;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_8__MAX_CNT_MASK    = 0x7fffffffL;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_9__EN_WARN_MASK    = 0x80000000L;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_9__MAX_CNT_MASK    = 0x7fffffffL;
    constexpr unsigned int SP_CONFIG__UNUSED_MASK                   = 0x00000100L;
    constexpr unsigned int SQ_CONFIG__DEBUG_ONE_INST_CLAUSE_MASK    = 0x00000400L;
    constexpr unsigned int SQ_CONFIG__DEBUG_SINGLE_MEMOP_MASK       = 0x00000200L;
    constexpr unsigned int SQ_CONFIG__UNUSED_MASK                   = 0x0000007fL;
    constexpr unsigned int SQ_WATCH0_CNTL__MODE_MASK                = 0x60000000L;
    constexpr unsigned int SQ_WATCH1_CNTL__MODE_MASK                = 0x60000000L;
    constexpr unsigned int SQ_WATCH2_CNTL__MODE_MASK                = 0x60000000L;
    constexpr unsigned int SQ_WATCH3_CNTL__MODE_MASK                = 0x60000000L;
    constexpr unsigned int SX_DEBUG_1__DEBUG_DATA_MASK              = 0xfffc0000L;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERFCOUNTER_SELECT2_MASK = 0x000003ffL;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERFCOUNTER_SELECT3_MASK = 0x000ffc00L;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERFCOUNTER_SELECT1_MASK = 0x000ffc00L;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERFCOUNTER_SELECT_MASK = 0x000003ffL;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERFCOUNTER_SELECT2_MASK = 0x000003ffL;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERFCOUNTER_SELECT3_MASK = 0x000ffc00L;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERFCOUNTER_SELECT1_MASK = 0x000ffc00L;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERFCOUNTER_SELECT_MASK = 0x000003ffL;
    constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERFCOUNTER_SELECT_MASK = 0x000003ffL;
    constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERFCOUNTER_SELECT_MASK = 0x000003ffL;
    constexpr unsigned int UTCL1_CTRL__RESERVED_MASK                = 0x00038000L;
    constexpr unsigned int UTCL1_UTCL0_INVREQ_DISABLE__UTCL1_UTCL0_INVREQ_DISABLE_MASK = 0x01ffffffL;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_BUSY_MASK           = 0x00000001L;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_GS_BUSY_MASK        = 0x00000080L;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_HS_BUSY_MASK        = 0x00000100L;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_OUT_BUSY_MASK       = 0x00000004L;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_OUT_INDX_BUSY_MASK  = 0x00000002L;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_PI_BUSY_MASK        = 0x00000040L;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_PRIMGEN_BUSY_MASK   = 0x00000400L;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_PT_BUSY_MASK        = 0x00000008L;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_TE11_BUSY_MASK      = 0x00000200L;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_TE_BUSY_MASK        = 0x00000010L;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_VR_BUSY_MASK        = 0x00000020L;
    constexpr unsigned int VGT_DISPATCH_DRAW_INDEX__MATCH_INDEX_MASK = 0xffffffffL;
    constexpr unsigned int VGT_DRAW_INITIATOR__GRBM_SKEW_NO_DEC_MASK = 0x00000100L;
    constexpr unsigned int VGT_DRAW_INITIATOR__UNROLLED_INST_MASK   = 0x00000080L;
    constexpr unsigned int VGT_SHADER_STAGES_EN__DISPATCH_DRAW_EN_MASK = 0x00000200L;
    constexpr unsigned int VGT_SHADER_STAGES_EN__DIS_DEALLOC_ACCUM_0_MASK = 0x00000400L;
    constexpr unsigned int VGT_SHADER_STAGES_EN__DIS_DEALLOC_ACCUM_1_MASK = 0x00000800L;
    constexpr unsigned int WD_CNTL_STATUS__WD_ADC_BUSY_MASK         = 0x00000008L;
    constexpr unsigned int WD_CNTL_STATUS__WD_BUSY_MASK             = 0x00000001L;
    constexpr unsigned int WD_CNTL_STATUS__WD_SPL_DI_BUSY_MASK      = 0x00000004L;
    constexpr unsigned int WD_CNTL_STATUS__WD_SPL_DMA_BUSY_MASK     = 0x00000002L;
} // namespace Gfx101

namespace Gfx101Plus
{
    constexpr unsigned int CB_COLOR0_ATTRIB3__CMASK_PIPE_ALIGNED_MASK = 0x04000000L;
    constexpr unsigned int CB_COLOR0_ATTRIB3__DCC_PIPE_ALIGNED_MASK = 0x40000000L;
    constexpr unsigned int CB_COLOR1_ATTRIB3__CMASK_PIPE_ALIGNED_MASK = 0x04000000L;
    constexpr unsigned int CB_COLOR1_ATTRIB3__DCC_PIPE_ALIGNED_MASK = 0x40000000L;
    constexpr unsigned int CB_COLOR2_ATTRIB3__CMASK_PIPE_ALIGNED_MASK = 0x04000000L;
    constexpr unsigned int CB_COLOR2_ATTRIB3__DCC_PIPE_ALIGNED_MASK = 0x40000000L;
    constexpr unsigned int CB_COLOR3_ATTRIB3__CMASK_PIPE_ALIGNED_MASK = 0x04000000L;
    constexpr unsigned int CB_COLOR3_ATTRIB3__DCC_PIPE_ALIGNED_MASK = 0x40000000L;
    constexpr unsigned int CB_COLOR4_ATTRIB3__CMASK_PIPE_ALIGNED_MASK = 0x04000000L;
    constexpr unsigned int CB_COLOR4_ATTRIB3__DCC_PIPE_ALIGNED_MASK = 0x40000000L;
    constexpr unsigned int CB_COLOR5_ATTRIB3__CMASK_PIPE_ALIGNED_MASK = 0x04000000L;
    constexpr unsigned int CB_COLOR5_ATTRIB3__DCC_PIPE_ALIGNED_MASK = 0x40000000L;
    constexpr unsigned int CB_COLOR6_ATTRIB3__CMASK_PIPE_ALIGNED_MASK = 0x04000000L;
    constexpr unsigned int CB_COLOR6_ATTRIB3__DCC_PIPE_ALIGNED_MASK = 0x40000000L;
    constexpr unsigned int CB_COLOR7_ATTRIB3__CMASK_PIPE_ALIGNED_MASK = 0x04000000L;
    constexpr unsigned int CB_COLOR7_ATTRIB3__DCC_PIPE_ALIGNED_MASK = 0x40000000L;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_LQUAD_FGCG_MASK = 0x00800000L;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_TILE_FGCG_MASK  = 0x00400000L;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__COLOR_BIG_PAGE_MASK = 0x80000000L;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__FMASK_BIG_PAGE_MASK = 0x40000000L;
    constexpr unsigned int COMPUTE_RELAUNCH2__IS_EVENT_MASK         = 0x40000000L;
    constexpr unsigned int COMPUTE_RELAUNCH2__IS_STATE_MASK         = 0x80000000L;
    constexpr unsigned int COMPUTE_RELAUNCH2__PAYLOAD_MASK          = 0x3fffffffL;
    constexpr unsigned int COMPUTE_USER_ACCUM_0__CONTRIBUTION_MASK  = 0x0000007fL;
    constexpr unsigned int COMPUTE_USER_ACCUM_1__CONTRIBUTION_MASK  = 0x0000007fL;
    constexpr unsigned int COMPUTE_USER_ACCUM_2__CONTRIBUTION_MASK  = 0x0000007fL;
    constexpr unsigned int COMPUTE_USER_ACCUM_3__CONTRIBUTION_MASK  = 0x0000007fL;
    constexpr unsigned int CP_CE_CS_PARTITION_INDEX__CS1_INDEX_MASK = 0x0001ffffL;
    constexpr unsigned int CP_CE_DOORBELL_CONTROL__DOORBELL_BIF_DROP_MASK = 0x00000002L;
    constexpr unsigned int CP_CE_DOORBELL_CONTROL__DOORBELL_EN_MASK = 0x40000000L;
    constexpr unsigned int CP_CE_DOORBELL_CONTROL__DOORBELL_HIT_MASK = 0x80000000L;
    constexpr unsigned int CP_CE_DOORBELL_CONTROL__DOORBELL_OFFSET_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_CE_JT_STAT__JT_LOADED_MASK            = 0x00000003L;
    constexpr unsigned int CP_CE_JT_STAT__WR_MASK_MASK              = 0x00030000L;
    constexpr unsigned int CP_DEBUG_2__CNTX_DONE_COPY_STATE_DISABLE_MASK = 0x00008000L;
    constexpr unsigned int CP_DEBUG_2__NOP_DISCARD_DISABLE_MASK     = 0x00010000L;
    constexpr unsigned int CP_GFX_HPD_STATUS0__ENABLE_OVERIDE_QUEUEID_MASK = 0x20000000L;
    constexpr unsigned int CP_GFX_HPD_STATUS0__FORCE_MAPPED_QUEUE_MASK = 0x00070000L;
    constexpr unsigned int CP_GFX_HPD_STATUS0__OVERIDE_QUEUEID_MASK = 0x40000000L;
    constexpr unsigned int CP_GFX_HQD_CE_BASE_HI__RB_BASE_HI_MASK   = 0x000000ffL;
    constexpr unsigned int CP_GFX_HQD_CE_BASE__RB_BASE_MASK         = 0xffffffffL;
    constexpr unsigned int CP_GFX_HQD_CE_CNTL__CACHE_POLICY_MASK    = 0x03000000L;
    constexpr unsigned int CP_GFX_HQD_CE_CNTL__MIN_AVAILSZ_MASK     = 0x00300000L;
    constexpr unsigned int CP_GFX_HQD_CE_CNTL__MIN_IB_AVAILSZ_MASK  = 0x00c00000L;
    constexpr unsigned int CP_GFX_HQD_CE_CNTL__RB_BLKSZ_MASK        = 0x00003f00L;
    constexpr unsigned int CP_GFX_HQD_CE_CNTL__RB_BUFSZ_MASK        = 0x0000003fL;
    constexpr unsigned int CP_GFX_HQD_CE_CNTL__RB_EXE_MASK          = 0x10000000L;
    constexpr unsigned int CP_GFX_HQD_CE_CNTL__RB_NO_UPDATE_MASK    = 0x08000000L;
    constexpr unsigned int CP_GFX_HQD_CE_CNTL__RB_RPTR_WR_ENA_MASK  = 0x80000000L;
    constexpr unsigned int CP_GFX_HQD_CE_CNTL__RB_VOLATILE_MASK     = 0x04000000L;
    constexpr unsigned int CP_GFX_HQD_CE_CSMD_RPTR__RB_RPTR_MASK    = 0x000fffffL;
    constexpr unsigned int CP_GFX_HQD_CE_OFFSET__DISABLE_RB_OFFSET_MASK = 0x80000000L;
    constexpr unsigned int CP_GFX_HQD_CE_OFFSET__RB_OFFSET_MASK     = 0x000fffffL;
    constexpr unsigned int CP_GFX_HQD_CE_RPTR_ADDR_HI__RB_RPTR_ADDR_HI_MASK = 0x0000ffffL;
    constexpr unsigned int CP_GFX_HQD_CE_RPTR_ADDR__RB_RPTR_ADDR_MASK = 0xfffffffcL;
    constexpr unsigned int CP_GFX_HQD_CE_RPTR_WR__RB_RPTR_WR_MASK   = 0x000fffffL;
    constexpr unsigned int CP_GFX_HQD_CE_RPTR__RB_RPTR_MASK         = 0x000fffffL;
    constexpr unsigned int CP_GFX_HQD_CE_WPTR_HI__RB_WPTR_MASK      = 0xffffffffL;
    constexpr unsigned int CP_GFX_HQD_CE_WPTR_POLL_ADDR_HI__RB_WPTR_POLL_ADDR_HI_MASK = 0x0000ffffL;
    constexpr unsigned int CP_GFX_HQD_CE_WPTR_POLL_ADDR_LO__RB_WPTR_POLL_ADDR_LO_MASK = 0xfffffffcL;
    constexpr unsigned int CP_GFX_HQD_CE_WPTR__RB_WPTR_MASK         = 0xffffffffL;
    constexpr unsigned int CP_GFX_HQD_CNTL__CE_HQD_NEQ_RB_HQD_MASK  = 0x40000000L;
    constexpr unsigned int CP_GFX_HQD_CNTL__KMD_QUEUE_MASK          = 0x20000000L;
    constexpr unsigned int CP_GFX_HQD_QUEUE_PRIORITY__PRIORITY_LEVEL_MASK = 0x0000000fL;
    constexpr unsigned int CP_MEC_JT_STAT__JT_LOADED_MASK           = 0x000000ffL;
    constexpr unsigned int CP_MEC_JT_STAT__WR_MASK_MASK             = 0x00ff0000L;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL4__DOORBELL_EN_MASK = 0x40000000L;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL4__DOORBELL_HIT_MASK = 0x80000000L;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL4__DOORBELL_OFFSET_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL5__DOORBELL_EN_MASK = 0x40000000L;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL5__DOORBELL_HIT_MASK = 0x80000000L;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL5__DOORBELL_OFFSET_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL6__DOORBELL_EN_MASK = 0x40000000L;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL6__DOORBELL_HIT_MASK = 0x80000000L;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL6__DOORBELL_OFFSET_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_MES_GP0_HI__M_RET_ADDR_MASK           = 0xffffffffL;
    constexpr unsigned int CP_MES_GP0_LO__DATA_MASK                 = 0xfffffffeL;
    constexpr unsigned int CP_MES_GP0_LO__PG_VIRT_HALTED_MASK       = 0x00000001L;
    constexpr unsigned int CP_MES_GP1_HI__RD_WR_SELECT_HI_MASK      = 0xffffffffL;
    constexpr unsigned int CP_MES_GP1_LO__RD_WR_SELECT_LO_MASK      = 0xffffffffL;
    constexpr unsigned int CP_MES_GP2_HI__STACK_PNTR_HI_MASK        = 0xffffffffL;
    constexpr unsigned int CP_MES_GP2_LO__STACK_PNTR_LO_MASK        = 0xffffffffL;
    constexpr unsigned int CP_MES_GP3_HI__DATA_MASK                 = 0xffffffffL;
    constexpr unsigned int CP_MES_GP3_LO__DATA_MASK                 = 0xffffffffL;
    constexpr unsigned int CP_MES_GP4_HI__DATA_MASK                 = 0xffffffffL;
    constexpr unsigned int CP_MES_GP4_LO__DATA_MASK                 = 0xffffffffL;
    constexpr unsigned int CP_MES_GP5_HI__M_RET_ADDR_MASK           = 0xffffffffL;
    constexpr unsigned int CP_MES_GP5_LO__DATA_MASK                 = 0xfffffffeL;
    constexpr unsigned int CP_MES_GP5_LO__PG_VIRT_HALTED_MASK       = 0x00000001L;
    constexpr unsigned int CP_MES_GP6_HI__RD_WR_SELECT_HI_MASK      = 0xffffffffL;
    constexpr unsigned int CP_MES_GP6_LO__RD_WR_SELECT_LO_MASK      = 0xffffffffL;
    constexpr unsigned int CP_MES_GP7_HI__STACK_PNTR_HI_MASK        = 0xffffffffL;
    constexpr unsigned int CP_MES_GP7_LO__STACK_PNTR_LO_MASK        = 0xffffffffL;
    constexpr unsigned int CP_MES_GP8_HI__DATA_MASK                 = 0xffffffffL;
    constexpr unsigned int CP_MES_GP8_LO__DATA_MASK                 = 0xffffffffL;
    constexpr unsigned int CP_MES_GP9_HI__DATA_MASK                 = 0xffffffffL;
    constexpr unsigned int CP_MES_GP9_LO__DATA_MASK                 = 0xffffffffL;
    constexpr unsigned int CP_PFP_JT_STAT__JT_LOADED_MASK           = 0x00000003L;
    constexpr unsigned int CP_PFP_JT_STAT__WR_MASK_MASK             = 0x00030000L;
    constexpr unsigned int CP_PQ_STATUS__DOORBELL_UPDATED_MODE_MASK = 0x00000008L;
    constexpr unsigned int CP_RB0_CNTL__CE_HQD_NEQ_RB_HQD_MASK      = 0x40000000L;
    constexpr unsigned int CP_RB1_CNTL__CE_HQD_NEQ_RB_HQD_MASK      = 0x40000000L;
    constexpr unsigned int CP_RB1_CNTL__KMD_QUEUE_MASK              = 0x20000000L;
    constexpr unsigned int CP_RB2_CNTL__CE_HQD_NEQ_RB_HQD_MASK      = 0x40000000L;
    constexpr unsigned int CP_RB2_CNTL__KMD_QUEUE_MASK              = 0x20000000L;
    constexpr unsigned int CP_RB_CNTL__CE_HQD_NEQ_RB_HQD_MASK       = 0x40000000L;
    constexpr unsigned int CP_RB_CNTL__KMD_QUEUE_MASK               = 0x20000000L;
    constexpr unsigned int CP_VMID_RESET__PIPE0_QUEUES_MASK         = 0x00ff0000L;
    constexpr unsigned int CP_VMID_RESET__PIPE1_QUEUES_MASK         = 0xff000000L;
    constexpr unsigned int DB_DEBUG3__DISABLE_RELOAD_CONTEXT_DRAW_DATA_MASK = 0x00000002L;
    constexpr unsigned int DB_DFSM_CONFIG__OUTPUT_WATCHDOG_MASK     = 0xff000000L;
    constexpr unsigned int DB_DFSM_CONFIG__SQUAD_WATERMARK_MASK     = 0x00003ff0L;
    constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_CB_RMIRET_OVERRIDE_MASK = 0x00000040L;
    constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_SC_TILE_OVERRIDE_MASK = 0x00000020L;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__S_BIG_PAGE_MASK = 0x02000000L;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__Z_BIG_PAGE_MASK = 0x01000000L;
    constexpr unsigned int GCR_GENERAL_CNTL__ENABLE_16K_UTCL2_REQ_MASK = 0x00008000L;
    constexpr unsigned int GC_THROTTLE_CTRL1__PCC_FP_PROGRAM_STEP_EN_MASK = 0x00000001L;
    constexpr unsigned int GC_THROTTLE_CTRL1__PCC_PROGRAM_MAX_STEP_MASK = 0x000003e0L;
    constexpr unsigned int GC_THROTTLE_CTRL1__PCC_PROGRAM_MIN_STEP_MASK = 0x0000001eL;
    constexpr unsigned int GC_THROTTLE_CTRL1__PCC_PROGRAM_UPWARDS_STEP_SIZE_MASK = 0x00001c00L;
    constexpr unsigned int GC_THROTTLE_CTRL1__PWRBRK_FP_PROGRAM_STEP_EN_MASK = 0x00002000L;
    constexpr unsigned int GC_THROTTLE_CTRL1__PWRBRK_PROGRAM_MAX_STEP_MASK = 0x007c0000L;
    constexpr unsigned int GC_THROTTLE_CTRL1__PWRBRK_PROGRAM_MIN_STEP_MASK = 0x0003c000L;
    constexpr unsigned int GC_THROTTLE_CTRL1__PWRBRK_PROGRAM_UPWARDS_STEP_SIZE_MASK = 0x03800000L;
    constexpr unsigned int GC_THROTTLE_CTRL__THROTTLE_CTRL_CLK_EN_OVERRIDE_MASK = 0x40000000L;
    constexpr unsigned int GE_STATUS__PERFCOUNTER_STATUS_MASK       = 0x00000001L;
    constexpr unsigned int GE_STATUS__THREAD_TRACE_STATUS_MASK      = 0x00000002L;
    constexpr unsigned int GE_USER_VGPR_EN__EN_USER_VGPR1_MASK      = 0x00000001L;
    constexpr unsigned int GE_USER_VGPR_EN__EN_USER_VGPR2_MASK      = 0x00000002L;
    constexpr unsigned int GE_USER_VGPR_EN__EN_USER_VGPR3_MASK      = 0x00000004L;
    constexpr unsigned int GRBM_IOV_READ_ERROR__IOV_ADDR_MASK       = 0x000ffffcL;
    constexpr unsigned int GRBM_IOV_READ_ERROR__IOV_ERROR_MASK      = 0x80000000L;
    constexpr unsigned int GRBM_IOV_READ_ERROR__IOV_OP_MASK         = 0x08000000L;
    constexpr unsigned int GRBM_IOV_READ_ERROR__IOV_VFID_MASK       = 0x03f00000L;
    constexpr unsigned int GRBM_IOV_READ_ERROR__IOV_VF_MASK         = 0x04000000L;
    constexpr unsigned int PA_CL_ENHANCE__ECO_SPARE2_MASK           = 0x20000000L;
    constexpr unsigned int PA_CL_ENHANCE__ECO_SPARE3_MASK           = 0x10000000L;
    constexpr unsigned int PA_SC_ENHANCE_2__BREAK_WHEN_ONE_NULL_PRIM_BATCH_MASK = 0x04000000L;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_DFSM_FLUSH_MASK = 0x02000000L;
    constexpr unsigned int PA_SC_ENHANCE_2__NULL_PRIM_BREAK_BATCH_LIMIT_MASK = 0x38000000L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA0_MASK                = 0x00000001L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA1_MASK                = 0x00000002L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA2_MASK                = 0x00000004L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA3_MASK                = 0x00000008L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA4_MASK                = 0x00000010L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA5_MASK                = 0x00000020L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA6_MASK                = 0x00000040L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA7_MASK                = 0x00000080L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA8_MASK                = 0x00000100L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA9_MASK                = 0x00000200L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA10_MASK               = 0x00000400L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA11_MASK               = 0x00000800L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA12_MASK               = 0x00001000L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA13_MASK               = 0x00002000L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA14_MASK               = 0x00004000L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA15_MASK               = 0x00008000L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA16_MASK               = 0x00010000L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA17_MASK               = 0x00020000L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA18_MASK               = 0x00040000L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA19_MASK               = 0x00080000L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA20_MASK               = 0x00100000L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA21_MASK               = 0x00200000L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA22_MASK               = 0x00400000L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA23_MASK               = 0x00800000L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA24_MASK               = 0x01000000L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA25_MASK               = 0x02000000L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA26_MASK               = 0x04000000L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA27_MASK               = 0x08000000L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA28_MASK               = 0x10000000L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA29_MASK               = 0x20000000L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA30_MASK               = 0x40000000L;
    constexpr unsigned int RLC_SPM_DEBUG__DATA31_MASK               = 0x80000000L;
    constexpr unsigned int RLC_SPM_RING_WRPTR__PERFMON_RING_WRPTR_MASK = 0xffffffe0L;
    constexpr unsigned int RLC_SPM_RING_WRPTR__RESERVED_MASK        = 0x0000001fL;
    constexpr unsigned int RLC_SPM_VIRT_CTRL__PauseSpmSamplingRequest_MASK = 0x00000001L;
    constexpr unsigned int RLC_SPM_VIRT_STATUS__SpmSamplingPaused_MASK = 0x00000001L;
    constexpr unsigned int RMI_SPARE_1__RMI_REORDER_DIS_BY_CID_MASK = 0x0000ff00L;
    constexpr unsigned int RMI_SPARE__EARLY_WRITE_ACK_ENABLE_C_RW_NOA_RESOLVE_DIS_MASK = 0x00000010L;
    constexpr unsigned int RMI_SPARE__NOFILL_RMI_CID_CC_MASK        = 0x00000100L;
    constexpr unsigned int RMI_SPARE__NOFILL_RMI_CID_CM_MASK        = 0x00000400L;
    constexpr unsigned int RMI_SPARE__NOFILL_RMI_CID_DC_MASK        = 0x00000800L;
    constexpr unsigned int RMI_SPARE__NOFILL_RMI_CID_FC_MASK        = 0x00000200L;
    constexpr unsigned int RMI_SPARE__NOFILL_RMI_CID_S_MASK         = 0x00002000L;
    constexpr unsigned int RMI_SPARE__NOFILL_RMI_CID_TILE_MASK      = 0x00004000L;
    constexpr unsigned int RMI_SPARE__NOFILL_RMI_CID_Z_MASK         = 0x00001000L;
    constexpr unsigned int RMI_SPARE__RMI_2_RB_REPEATER_FGCG_DISABLE_MASK = 0x00000008L;
    constexpr unsigned int RMI_SPARE__RMI_REORDER_BYPASS_CHANNEL_DIS_MASK = 0x00000020L;
    constexpr unsigned int RMI_SPARE__SPARE_BIT_15_0_MASK           = 0x00008000L;
    constexpr unsigned int RPB_DEINTRLV_COMBINE_CNTL__XPB_WRREQ_CRD_MASK = 0x00003fc0L;
    constexpr unsigned int RPB_DF_SDPPORT_CNTL__DF_DATA_CRD_MASK    = 0x00000fc0L;
    constexpr unsigned int RPB_DF_SDPPORT_CNTL__DF_HALT_THRESHOLD_MASK = 0x0000f000L;
    constexpr unsigned int RPB_DF_SDPPORT_CNTL__DF_REQ_CRD_MASK     = 0x0000003fL;
    constexpr unsigned int RPB_VC_SWITCH_RDWR__XPB_RDREQ_CRD_MASK   = 0x03fc0000L;
    constexpr unsigned int SPI_CONFIG_CNTL_1__EN_USER_ACCUM_MASK    = 0x00200000L;
    constexpr unsigned int SPI_DEBUG_CNTL_2__DISABLE_INTRA_PRIM_CONFLICT_MASK = 0x00000100L;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_ESGS_0__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_ESGS_1__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_ESGS_2__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_ESGS_3__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_LSHS_0__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_LSHS_1__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_LSHS_2__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_LSHS_3__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_PS_0__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_PS_1__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_PS_2__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_PS_3__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_VS_0__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_VS_1__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_VS_2__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_VS_3__CONTRIBUTION_MASK = 0x0000007fL;
    constexpr unsigned int SPI_START_PHASE__PC_X_PHASE_SE0_MASK     = 0x00000003L;
    constexpr unsigned int SPI_START_PHASE__PC_X_PHASE_SE1_MASK     = 0x0000000cL;
    constexpr unsigned int SPI_START_PHASE__PC_X_PHASE_SE2_MASK     = 0x00000030L;
    constexpr unsigned int SPI_START_PHASE__PC_X_PHASE_SE3_MASK     = 0x000000c0L;
    constexpr unsigned int SPI_USER_ACCUM_VMID_CNTL__EN_USER_ACCUM_MASK = 0x0000000fL;
    constexpr unsigned int SQC_MISC_CONFIG__SQC_SPI_TTRACE_FGCG_OVERRIDE_MASK = 0x00000020L;
    constexpr unsigned int SQ_CONFIG__LDS_BUSY_HYSTERESIS_CNT_MASK  = 0x00006000L;
    constexpr unsigned int SQ_CONFIG__SP_BUSY_HYSTERESIS_CNT_MASK   = 0x00018000L;
    constexpr unsigned int SQ_CONFIG__TA_BUSY_HYSTERESIS_CNT_MASK   = 0xc0000000L;
    constexpr unsigned int SX_DEBUG_1__DISABLE_COL_VAL_READ_OPT_MASK = 0x00020000L;
    constexpr unsigned int SX_DEBUG_1__DISABLE_REP_FGCG_MASK        = 0x00002000L;
    constexpr unsigned int TA_CNTL_AUX__ANISO_MAG_STEP_CLAMP_MASK   = 0x00000100L;
    constexpr unsigned int TA_CNTL_AUX__DERIV_ADJUST_DIS_MASK       = 0x00000010L;
    constexpr unsigned int TD_CNTL__DISABLE_ROUND_TO_ZERO_FOR_LARGE_FLOAT_TO_SMALL_FLOAT_MASK = 0x00400000L;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_MODE1_FILTER1_BYPASS_MASK = 0x00800000L;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_MODE1_INTR_ON_ALLOC_MASK = 0x01000000L;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_ONLY_MISS_MASK    = 0x00000200L;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_TRACK_SEGMENT_SIZE_MASK = 0x007e0000L;
    constexpr unsigned int VGT_GS_INSTANCE_CNT__EN_MAX_VERT_OUT_PER_GS_INSTANCE_MASK = 0x80000000L;
    constexpr unsigned int VGT_RESET_DEBUG__DISABLE_TE11_DIST_PIPE0_MASK = 0x00000008L;
    constexpr unsigned int VGT_RESET_DEBUG__DISABLE_TE11_DIST_PIPE1_MASK = 0x00000010L;
    constexpr unsigned int VGT_RESET_DEBUG__ENABLE_VMID_RESET_UTCL1_MASK = 0x00000020L;
} // namespace Gfx101Plus

namespace Nv10
{
    constexpr unsigned int CB_HW_CONTROL_1__CC_CACHE_NUM_TAGS_MASK  = 0x0001f800L;
    constexpr unsigned int CB_HW_CONTROL_1__CM_TILE_FIFO_DEPTH_MASK = 0x03fe0000L;
    constexpr unsigned int CB_HW_CONTROL_1__FC_CACHE_NUM_TAGS_MASK  = 0x000007e0L;
    constexpr unsigned int CB_HW_CONTROL_1__RMI_CREDITS_MASK        = 0xfc000000L;
    constexpr unsigned int CB_HW_CONTROL_3__DISABLE_OVERWRITE_COMBINER_TARGET_MASK_VALIDATION_MASK = 0x00000100L;
    constexpr unsigned int CH_ARB_CTRL__UC_IO_WR_PATH_MASK          = 0x00000008L;
    constexpr unsigned int CP_HQD_PQ_CONTROL__ENDIAN_SWAP_MASK      = 0x00030000L;
    constexpr unsigned int CP_MEC_DOORBELL_RANGE_LOWER__DOORBELL_RANGE_LOWER_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_MEC_DOORBELL_RANGE_UPPER__DOORBELL_RANGE_UPPER_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_RB0_CNTL__BUF_SWAP_MASK               = 0x00030000L;
    constexpr unsigned int CP_RB_CNTL__BUF_SWAP_MASK                = 0x00030000L;
    constexpr unsigned int CP_RB_DOORBELL_RANGE_LOWER__DOORBELL_RANGE_LOWER_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_RB_DOORBELL_RANGE_UPPER__DOORBELL_RANGE_UPPER_MASK = 0x0ffffffcL;
    constexpr unsigned int CP_SD_CNTL__RMI_EN_MASK                  = 0x00000100L;
    constexpr unsigned int CP_STALLED_STAT1__RBIU_TO_MEMWR_NOT_RDY_TO_RCV_MASK = 0x00000010L;
    constexpr unsigned int CP_STALLED_STAT1__RBIU_TO_SEM_NOT_RDY_TO_RCV_MASK = 0x00000004L;
    constexpr unsigned int CP_STALLED_STAT2__EOPD_FIFO_NEEDS_SC_EOP_DONE_MASK = 0x00200000L;
    constexpr unsigned int CP_STALLED_STAT2__EOPD_FIFO_NEEDS_WR_CONFIRM_MASK = 0x00400000L;
    constexpr unsigned int DB_DFSM_CONFIG__CAM_WATERMARK_MASK       = 0x00ff0000L;
    constexpr unsigned int DB_EXCEPTION_CONTROL__EXTRA_BITS_GROUP_B_MASK = 0x00fff000L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE0_MASK   = 0x00000001L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE1_MASK   = 0x00000002L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE2_MASK   = 0x00000004L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE3_MASK   = 0x00000008L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE4_MASK   = 0x00000010L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE5_MASK   = 0x00000020L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE6_MASK   = 0x00000040L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE7_MASK   = 0x00000080L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE8_MASK   = 0x00000100L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE9_MASK   = 0x00000200L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE10_MASK  = 0x00000400L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE11_MASK  = 0x00000800L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE12_MASK  = 0x00001000L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE13_MASK  = 0x00002000L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE14_MASK  = 0x00004000L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE15_MASK  = 0x00008000L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE16_MASK  = 0x00010000L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE17_MASK  = 0x00020000L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE18_MASK  = 0x00040000L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE19_MASK  = 0x00080000L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE20_MASK  = 0x00100000L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE21_MASK  = 0x00200000L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE22_MASK  = 0x00400000L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE23_MASK  = 0x00800000L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE24_MASK  = 0x01000000L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE25_MASK  = 0x02000000L;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE26_MASK  = 0x04000000L;
    constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_1_MASK  = 0x00000001L;
    constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_2_MASK  = 0x00000004L;
    constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_3_MASK  = 0x00000008L;
    constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_4_MASK  = 0x000003f0L;
    constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_5_MASK  = 0x0000fc00L;
    constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_6_MASK  = 0x00020000L;
    constexpr unsigned int DB_RESERVED_REG_1__FIELD_1_MASK          = 0x000007ffL;
    constexpr unsigned int DB_RESERVED_REG_1__FIELD_2_MASK          = 0x003ff800L;
    constexpr unsigned int DB_RESERVED_REG_2__FIELD_1_MASK          = 0x0000000fL;
    constexpr unsigned int DB_RESERVED_REG_2__FIELD_2_MASK          = 0x000000f0L;
    constexpr unsigned int DB_RESERVED_REG_2__FIELD_3_MASK          = 0x00001f00L;
    constexpr unsigned int DB_RESERVED_REG_2__FIELD_4_MASK          = 0x00006000L;
    constexpr unsigned int DB_RESERVED_REG_2__FIELD_5_MASK          = 0x00018000L;
    constexpr unsigned int DB_RESERVED_REG_2__FIELD_6_MASK          = 0x00060000L;
    constexpr unsigned int DB_RESERVED_REG_2__FIELD_7_MASK          = 0x00180000L;
    constexpr unsigned int DB_RESERVED_REG_2__FIELD_8_MASK          = 0xf0000000L;
    constexpr unsigned int DB_RESERVED_REG_3__FIELD_1_MASK          = 0x003fffffL;
    constexpr unsigned int DB_STENCIL_INFO__RESERVED_FIELD_1_MASK   = 0x0000e000L;
    constexpr unsigned int DB_Z_INFO__RESERVED_FIELD_1_MASK         = 0x0000e000L;
    constexpr unsigned int FORCE_SYMCLK_DISABLE__FORCE_SYMCLKA_DISABLE_MASK = 0x00000001L;
    constexpr unsigned int FORCE_SYMCLK_DISABLE__FORCE_SYMCLKB_DISABLE_MASK = 0x00000002L;
    constexpr unsigned int FORCE_SYMCLK_DISABLE__FORCE_SYMCLKC_DISABLE_MASK = 0x00000004L;
    constexpr unsigned int FORCE_SYMCLK_DISABLE__FORCE_SYMCLKD_DISABLE_MASK = 0x00000008L;
    constexpr unsigned int FORCE_SYMCLK_DISABLE__FORCE_SYMCLKE_DISABLE_MASK = 0x00000010L;
    constexpr unsigned int FORCE_SYMCLK_DISABLE__FORCE_SYMCLKF_DISABLE_MASK = 0x00000020L;
    constexpr unsigned int GB_MACROTILE_MODE0__BANK_HEIGHT_MASK     = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE0__BANK_WIDTH_MASK      = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE0__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE0__NUM_BANKS_MASK       = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE1__BANK_HEIGHT_MASK     = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE1__BANK_WIDTH_MASK      = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE1__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE1__NUM_BANKS_MASK       = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE2__BANK_HEIGHT_MASK     = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE2__BANK_WIDTH_MASK      = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE2__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE2__NUM_BANKS_MASK       = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE3__BANK_HEIGHT_MASK     = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE3__BANK_WIDTH_MASK      = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE3__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE3__NUM_BANKS_MASK       = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE4__BANK_HEIGHT_MASK     = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE4__BANK_WIDTH_MASK      = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE4__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE4__NUM_BANKS_MASK       = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE5__BANK_HEIGHT_MASK     = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE5__BANK_WIDTH_MASK      = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE5__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE5__NUM_BANKS_MASK       = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE6__BANK_HEIGHT_MASK     = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE6__BANK_WIDTH_MASK      = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE6__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE6__NUM_BANKS_MASK       = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE7__BANK_HEIGHT_MASK     = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE7__BANK_WIDTH_MASK      = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE7__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE7__NUM_BANKS_MASK       = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE8__BANK_HEIGHT_MASK     = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE8__BANK_WIDTH_MASK      = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE8__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE8__NUM_BANKS_MASK       = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE9__BANK_HEIGHT_MASK     = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE9__BANK_WIDTH_MASK      = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE9__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE9__NUM_BANKS_MASK       = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE10__BANK_HEIGHT_MASK    = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE10__BANK_WIDTH_MASK     = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE10__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE10__NUM_BANKS_MASK      = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE11__BANK_HEIGHT_MASK    = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE11__BANK_WIDTH_MASK     = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE11__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE11__NUM_BANKS_MASK      = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE12__BANK_HEIGHT_MASK    = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE12__BANK_WIDTH_MASK     = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE12__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE12__NUM_BANKS_MASK      = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE13__BANK_HEIGHT_MASK    = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE13__BANK_WIDTH_MASK     = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE13__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE13__NUM_BANKS_MASK      = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE14__BANK_HEIGHT_MASK    = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE14__BANK_WIDTH_MASK     = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE14__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE14__NUM_BANKS_MASK      = 0x000000c0L;
    constexpr unsigned int GB_MACROTILE_MODE15__BANK_HEIGHT_MASK    = 0x0000000cL;
    constexpr unsigned int GB_MACROTILE_MODE15__BANK_WIDTH_MASK     = 0x00000003L;
    constexpr unsigned int GB_MACROTILE_MODE15__MACRO_TILE_ASPECT_MASK = 0x00000030L;
    constexpr unsigned int GB_MACROTILE_MODE15__NUM_BANKS_MASK      = 0x000000c0L;
    constexpr unsigned int GB_TILE_MODE0__ARRAY_MODE_MASK           = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE0__MICRO_TILE_MODE_NEW_MASK  = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE0__PIPE_CONFIG_MASK          = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE0__SAMPLE_SPLIT_MASK         = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE0__TILE_SPLIT_MASK           = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE1__ARRAY_MODE_MASK           = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE1__MICRO_TILE_MODE_NEW_MASK  = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE1__PIPE_CONFIG_MASK          = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE1__SAMPLE_SPLIT_MASK         = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE1__TILE_SPLIT_MASK           = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE2__ARRAY_MODE_MASK           = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE2__MICRO_TILE_MODE_NEW_MASK  = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE2__PIPE_CONFIG_MASK          = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE2__SAMPLE_SPLIT_MASK         = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE2__TILE_SPLIT_MASK           = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE3__ARRAY_MODE_MASK           = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE3__MICRO_TILE_MODE_NEW_MASK  = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE3__PIPE_CONFIG_MASK          = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE3__SAMPLE_SPLIT_MASK         = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE3__TILE_SPLIT_MASK           = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE4__ARRAY_MODE_MASK           = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE4__MICRO_TILE_MODE_NEW_MASK  = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE4__PIPE_CONFIG_MASK          = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE4__SAMPLE_SPLIT_MASK         = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE4__TILE_SPLIT_MASK           = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE5__ARRAY_MODE_MASK           = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE5__MICRO_TILE_MODE_NEW_MASK  = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE5__PIPE_CONFIG_MASK          = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE5__SAMPLE_SPLIT_MASK         = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE5__TILE_SPLIT_MASK           = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE6__ARRAY_MODE_MASK           = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE6__MICRO_TILE_MODE_NEW_MASK  = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE6__PIPE_CONFIG_MASK          = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE6__SAMPLE_SPLIT_MASK         = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE6__TILE_SPLIT_MASK           = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE7__ARRAY_MODE_MASK           = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE7__MICRO_TILE_MODE_NEW_MASK  = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE7__PIPE_CONFIG_MASK          = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE7__SAMPLE_SPLIT_MASK         = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE7__TILE_SPLIT_MASK           = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE8__ARRAY_MODE_MASK           = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE8__MICRO_TILE_MODE_NEW_MASK  = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE8__PIPE_CONFIG_MASK          = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE8__SAMPLE_SPLIT_MASK         = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE8__TILE_SPLIT_MASK           = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE9__ARRAY_MODE_MASK           = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE9__MICRO_TILE_MODE_NEW_MASK  = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE9__PIPE_CONFIG_MASK          = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE9__SAMPLE_SPLIT_MASK         = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE9__TILE_SPLIT_MASK           = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE10__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE10__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE10__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE10__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE10__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE11__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE11__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE11__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE11__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE11__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE12__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE12__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE12__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE12__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE12__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE13__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE13__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE13__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE13__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE13__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE14__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE14__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE14__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE14__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE14__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE15__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE15__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE15__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE15__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE15__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE16__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE16__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE16__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE16__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE16__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE17__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE17__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE17__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE17__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE17__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE18__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE18__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE18__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE18__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE18__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE19__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE19__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE19__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE19__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE19__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE20__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE20__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE20__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE20__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE20__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE21__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE21__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE21__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE21__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE21__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE22__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE22__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE22__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE22__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE22__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE23__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE23__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE23__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE23__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE23__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE24__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE24__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE24__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE24__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE24__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE25__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE25__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE25__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE25__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE25__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE26__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE26__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE26__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE26__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE26__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE27__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE27__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE27__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE27__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE27__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE28__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE28__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE28__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE28__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE28__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE29__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE29__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE29__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE29__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE29__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE30__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE30__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE30__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE30__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE30__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GB_TILE_MODE31__ARRAY_MODE_MASK          = 0x0000003cL;
    constexpr unsigned int GB_TILE_MODE31__MICRO_TILE_MODE_NEW_MASK = 0x01c00000L;
    constexpr unsigned int GB_TILE_MODE31__PIPE_CONFIG_MASK         = 0x000007c0L;
    constexpr unsigned int GB_TILE_MODE31__SAMPLE_SPLIT_MASK        = 0x06000000L;
    constexpr unsigned int GB_TILE_MODE31__TILE_SPLIT_MASK          = 0x00003800L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER0_CFG__CLEAR_MASK   = 0x20000000L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER0_CFG__ENABLE_MASK  = 0x10000000L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER0_CFG__PERF_MODE_MASK = 0x0f000000L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER0_CFG__PERF_SEL_END_MASK = 0x0000ff00L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER0_CFG__PERF_SEL_MASK = 0x000000ffL;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER1_CFG__CLEAR_MASK   = 0x20000000L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER1_CFG__ENABLE_MASK  = 0x10000000L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER1_CFG__PERF_MODE_MASK = 0x0f000000L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER1_CFG__PERF_SEL_END_MASK = 0x0000ff00L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER1_CFG__PERF_SEL_MASK = 0x000000ffL;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_MODE__COMPARE_MODE0_MASK = 0x00000003L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_MODE__COMPARE_MODE1_MASK = 0x0000000cL;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_MODE__COMPARE_MODE2_MASK = 0x00000030L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_MODE__COMPARE_MODE3_MASK = 0x000000c0L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_MODE__COMPARE_VALUE0_MASK = 0x00000f00L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_MODE__COMPARE_VALUE1_MASK = 0x0000f000L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_MODE__COMPARE_VALUE2_MASK = 0x000f0000L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_MODE__COMPARE_VALUE3_MASK = 0x00f00000L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK = 0xf0000000L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK = 0x0f000000L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK = 0x000003ffL;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK = 0x000ffc00L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT__CNTR_MODE_MASK = 0x00f00000L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT__PERF_MODE1_MASK = 0x0f000000L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT__PERF_MODE_MASK = 0xf0000000L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT__PERF_SEL1_MASK = 0x000ffc00L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT__PERF_SEL_MASK = 0x000003ffL;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_HI__COMPARE_VALUE_MASK = 0xffff0000L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_HI__COUNTER_HI_MASK = 0x0000ffffL;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_LO__COUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL_MASK = 0x02000000L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY_MASK = 0x01000000L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT_MASK = 0x0000000fL;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_RSLT_CNTL__START_TRIGGER_MASK = 0x0000ff00L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE_MASK = 0x04000000L;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER_MASK = 0x00ff0000L;
    constexpr unsigned int GC_CAC_OVRD_LDS__OVRRD_SELECT_MASK       = 0x0000000fL;
    constexpr unsigned int GC_CAC_OVRD_LDS__OVRRD_VALUE_MASK        = 0x000000f0L;
    constexpr unsigned int GE_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
    constexpr unsigned int GE_PERFCOUNTER0_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT1__PERF_MODE2_MASK = 0x0f000000L;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT1__PERF_MODE3_MASK = 0xf0000000L;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK  = 0x000003ffL;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK  = 0x000ffc00L;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT__CNTR_MODE_MASK   = 0x00f00000L;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT__PERF_MODE0_MASK  = 0x0f000000L;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT__PERF_MODE1_MASK  = 0xf0000000L;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT__PERF_SEL0_MASK   = 0x000003ffL;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT__PERF_SEL1_MASK   = 0x000ffc00L;
    constexpr unsigned int GE_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
    constexpr unsigned int GE_PERFCOUNTER1_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT1__PERF_MODE2_MASK = 0x0f000000L;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT1__PERF_MODE3_MASK = 0xf0000000L;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT1__PERF_SEL2_MASK  = 0x000003ffL;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT1__PERF_SEL3_MASK  = 0x000ffc00L;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT__CNTR_MODE_MASK   = 0x00f00000L;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT__PERF_MODE0_MASK  = 0x0f000000L;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT__PERF_MODE1_MASK  = 0xf0000000L;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT__PERF_SEL0_MASK   = 0x000003ffL;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT__PERF_SEL1_MASK   = 0x000ffc00L;
    constexpr unsigned int GE_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
    constexpr unsigned int GE_PERFCOUNTER2_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT1__PERF_MODE2_MASK = 0x0f000000L;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT1__PERF_MODE3_MASK = 0xf0000000L;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT1__PERF_SEL2_MASK  = 0x000003ffL;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT1__PERF_SEL3_MASK  = 0x000ffc00L;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT__CNTR_MODE_MASK   = 0x00f00000L;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT__PERF_MODE0_MASK  = 0x0f000000L;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT__PERF_MODE1_MASK  = 0xf0000000L;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT__PERF_SEL0_MASK   = 0x000003ffL;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT__PERF_SEL1_MASK   = 0x000ffc00L;
    constexpr unsigned int GE_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
    constexpr unsigned int GE_PERFCOUNTER3_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT1__PERF_MODE2_MASK = 0x0f000000L;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT1__PERF_MODE3_MASK = 0xf0000000L;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT1__PERF_SEL2_MASK  = 0x000003ffL;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT1__PERF_SEL3_MASK  = 0x000ffc00L;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT__CNTR_MODE_MASK   = 0x00f00000L;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT__PERF_MODE0_MASK  = 0x0f000000L;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT__PERF_MODE1_MASK  = 0xf0000000L;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT__PERF_SEL0_MASK   = 0x000003ffL;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT__PERF_SEL1_MASK   = 0x000ffc00L;
    constexpr unsigned int GE_PERFCOUNTER4_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
    constexpr unsigned int GE_PERFCOUNTER4_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
    constexpr unsigned int GE_PERFCOUNTER4_SELECT__PERF_MODE_MASK   = 0xf0000000L;
    constexpr unsigned int GE_PERFCOUNTER4_SELECT__PERF_SEL0_MASK   = 0x000003ffL;
    constexpr unsigned int GE_PERFCOUNTER5_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
    constexpr unsigned int GE_PERFCOUNTER5_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
    constexpr unsigned int GE_PERFCOUNTER5_SELECT__PERF_MODE_MASK   = 0xf0000000L;
    constexpr unsigned int GE_PERFCOUNTER5_SELECT__PERF_SEL0_MASK   = 0x000003ffL;
    constexpr unsigned int GE_PERFCOUNTER6_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
    constexpr unsigned int GE_PERFCOUNTER6_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
    constexpr unsigned int GE_PERFCOUNTER6_SELECT__PERF_MODE_MASK   = 0xf0000000L;
    constexpr unsigned int GE_PERFCOUNTER6_SELECT__PERF_SEL0_MASK   = 0x000003ffL;
    constexpr unsigned int GE_PERFCOUNTER7_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
    constexpr unsigned int GE_PERFCOUNTER7_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
    constexpr unsigned int GE_PERFCOUNTER7_SELECT__PERF_MODE_MASK   = 0xf0000000L;
    constexpr unsigned int GE_PERFCOUNTER7_SELECT__PERF_SEL0_MASK   = 0x000003ffL;
    constexpr unsigned int GE_PERFCOUNTER8_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
    constexpr unsigned int GE_PERFCOUNTER8_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
    constexpr unsigned int GE_PERFCOUNTER8_SELECT__PERF_MODE_MASK   = 0xf0000000L;
    constexpr unsigned int GE_PERFCOUNTER8_SELECT__PERF_SEL0_MASK   = 0x000003ffL;
    constexpr unsigned int GE_PERFCOUNTER9_HI__PERFCOUNTER_HI_MASK  = 0xffffffffL;
    constexpr unsigned int GE_PERFCOUNTER9_LO__PERFCOUNTER_LO_MASK  = 0xffffffffL;
    constexpr unsigned int GE_PERFCOUNTER9_SELECT__PERF_MODE_MASK   = 0xf0000000L;
    constexpr unsigned int GE_PERFCOUNTER9_SELECT__PERF_SEL0_MASK   = 0x000003ffL;
    constexpr unsigned int GE_PERFCOUNTER10_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GE_PERFCOUNTER10_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GE_PERFCOUNTER10_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int GE_PERFCOUNTER10_SELECT__PERF_SEL0_MASK  = 0x000003ffL;
    constexpr unsigned int GE_PERFCOUNTER11_HI__PERFCOUNTER_HI_MASK = 0xffffffffL;
    constexpr unsigned int GE_PERFCOUNTER11_LO__PERFCOUNTER_LO_MASK = 0xffffffffL;
    constexpr unsigned int GE_PERFCOUNTER11_SELECT__PERF_MODE_MASK  = 0xf0000000L;
    constexpr unsigned int GE_PERFCOUNTER11_SELECT__PERF_SEL0_MASK  = 0x000003ffL;
    constexpr unsigned int GFX_GAP_PWROK__gfx_gap_pwrok_MASK        = 0x00000001L;
    constexpr unsigned int GL1_DRAM_BURST_CTRL__GATHER_64B_IO_BURST_DISABLE_MASK = 0x00000020L;
    constexpr unsigned int GL1_DRAM_BURST_CTRL__GATHER_64B_MEMORY_BURST_DISABLE_MASK = 0x00000010L;
    constexpr unsigned int GRBM_PM_CNTL__PM_READY_MASK              = 0x00000001L;
    constexpr unsigned int GRBM_PM_CNTL__PM_START_MASK              = 0x00010000L;
    constexpr unsigned int GSL_SOURCE_SELECT__GSL0_READY_SOURCE_SEL_MASK = 0x00000007L;
    constexpr unsigned int GSL_SOURCE_SELECT__GSL1_READY_SOURCE_SEL_MASK = 0x00000070L;
    constexpr unsigned int GSL_SOURCE_SELECT__GSL2_READY_SOURCE_SEL_MASK = 0x00000700L;
    constexpr unsigned int GSL_SOURCE_SELECT__GSL_TIMING_SYNC_SEL_MASK = 0x00070000L;
    constexpr unsigned int PA_CL_CNTL_STATUS__UTC_FAULT_DETECTED_MASK = 0x00000001L;
    constexpr unsigned int PA_CL_CNTL_STATUS__UTC_PRT_DETECTED_MASK = 0x00000004L;
    constexpr unsigned int PA_CL_CNTL_STATUS__UTC_RETRY_DETECTED_MASK = 0x00000002L;
    constexpr unsigned int PA_SC_ENHANCE_2__ECO_SPARE0_MASK         = 0x00000001L;
    constexpr unsigned int PA_SC_ENHANCE_2__ECO_SPARE1_MASK         = 0x00000002L;
    constexpr unsigned int PA_SC_ENHANCE_2__ECO_SPARE2_MASK         = 0x00000004L;
    constexpr unsigned int PA_SC_ENHANCE_2__ECO_SPARE3_MASK         = 0x00000008L;
    constexpr unsigned int PA_SC_ENHANCE_2__RSVD_MASK               = 0xc0000000L;
    constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__NUM_PACKER_PER_SC_MASK = 0x00100000L;
    constexpr unsigned int PA_SU_PERFCOUNTER0_HI__PERFCOUNTER_HI_MASK = 0x0000ffffL;
    constexpr unsigned int PA_SU_PERFCOUNTER1_HI__PERFCOUNTER_HI_MASK = 0x0000ffffL;
    constexpr unsigned int PA_SU_PERFCOUNTER2_HI__PERFCOUNTER_HI_MASK = 0x0000ffffL;
    constexpr unsigned int PA_SU_PERFCOUNTER3_HI__PERFCOUNTER_HI_MASK = 0x0000ffffL;
    constexpr unsigned int PWROK_REFCLK_GAP_CYCLES__Pwrok_PostAssertion_clkgap_cycles_MASK = 0x0000ff00L;
    constexpr unsigned int PWROK_REFCLK_GAP_CYCLES__Pwrok_PreAssertion_clkgap_cycles_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_ADDR__addr_MASK    = 0x000001ffL;
    constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_ADDR__RESERVED_MASK = 0xfffffe00L;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__RESERVED_MASK        = 0xfffffc00L;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeAccumDoneInt_MASK = 0x00000010L;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeResetAccum_MASK = 0x00000020L;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeSpmDoneInt_MASK = 0x00000008L;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeStartSpm_MASK  = 0x000003c0L;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__AutoAccumEn_MASK     = 0x00000002L;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__AutoResetPerfmonDisable_MASK = 0x00000040L;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__AutoSpmEn_MASK       = 0x00000004L;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__Globals_LoadOverride_MASK = 0x00000008L;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__RESERVED_MASK        = 0xffffff80L;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__SE0_LoadOverride_MASK = 0x00000010L;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__SE1_LoadOverride_MASK = 0x00000020L;
    constexpr unsigned int RLC_SPM_ACCUM_SAMPLES_REQUESTED__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__RESERVED_MASK      = 0xffff0000L;
    constexpr unsigned int RLC_SPM_ACCUM_THRESHOLD__RESERVED_MASK   = 0xffff0000L;
    constexpr unsigned int RLC_SPM_MC_CNTL__RESERVED_2_MASK         = 0x00002000L;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_4_0_MASK          = 0x00000f00L;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_4_1_MASK          = 0x0000f000L;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_16_MASK           = 0x00000001L;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_17_MASK           = 0x00000002L;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_18_MASK           = 0x00000004L;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_19_MASK           = 0x00000008L;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_20_MASK           = 0x00000010L;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_21_MASK           = 0x00000020L;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_22_MASK           = 0x00000040L;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_23_MASK           = 0x00000080L;
    constexpr unsigned int RMI_SPARE__SPARE_BIT_6_MASK              = 0x00000040L;
    constexpr unsigned int RPB_ATS_CNTL2__INVAL_COM_ROUTING_CODE_MASK = 0x00038000L;
    constexpr unsigned int RPB_ATS_CNTL2__PAGE_REQ_CMD_MASK         = 0x00000fc0L;
    constexpr unsigned int RPB_ATS_CNTL2__PAGE_ROUTING_CODE_MASK    = 0x00007000L;
    constexpr unsigned int RPB_ATS_CNTL2__TRANS_CMD_MASK            = 0x0000003fL;
    constexpr unsigned int RPB_ATS_CNTL2__VENDOR_ID_MASK            = 0x000c0000L;
    constexpr unsigned int RPB_ATS_CNTL__ATCTR_SWITCH_NUM_MASK      = 0x00078000L;
    constexpr unsigned int RPB_ATS_CNTL__INVAL_COM_CMD_MASK         = 0x7e000000L;
    constexpr unsigned int RPB_BIF_CNTL2__NBIF_HST_COMPCLKCTL_EN_MASK = 0x00000001L;
    constexpr unsigned int RPB_BIF_CNTL__ARB_MODE_MASK              = 0x00010000L;
    constexpr unsigned int RPB_BIF_CNTL__DRAIN_VC_NUM_MASK          = 0x00020000L;
    constexpr unsigned int RPB_BIF_CNTL__NBIF_DMA_ORIGCLKCTL_EN_MASK = 0x80000000L;
    constexpr unsigned int RPB_BIF_CNTL__PAGE_PRI_EN_MASK           = 0x08000000L;
    constexpr unsigned int RPB_BIF_CNTL__PARITY_CHECK_EN_MASK       = 0x40000000L;
    constexpr unsigned int RPB_BIF_CNTL__SWITCH_ENABLE_MASK         = 0x00040000L;
    constexpr unsigned int RPB_BIF_CNTL__SWITCH_THRESHOLD_MASK      = 0x07f80000L;
    constexpr unsigned int RPB_BIF_CNTL__TR_PRI_EN_MASK             = 0x10000000L;
    constexpr unsigned int RPB_BIF_CNTL__VC0_CHAINED_OVERRIDE_MASK  = 0x20000000L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATC_INV_BLOCKLEVEL_MASK = 0x000000c0L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATC_PAGE_BLOCKLEVEL_MASK = 0x00000030L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATC_TR_BLOCKLEVEL_MASK = 0x0000000cL;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATOMIC_BLOCKLEVEL_OVERRIDE_EN_MASK = 0x00020000L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATOMIC_BLOCKLEVEL_OVERRIDE_MASK = 0x00003000L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_RD_BLOCKLEVEL_OVERRIDE_EN_MASK = 0x00010000L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_RD_BLOCKLEVEL_OVERRIDE_MASK = 0x00000c00L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_WR_BLOCKLEVEL_OVERRIDE_EN_MASK = 0x00008000L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_WR_BLOCKLEVEL_OVERRIDE_MASK = 0x00000300L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__XPB_BLOCKLEVEL_OVERRIDE_EN_MASK = 0x00004000L;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_PAGE_PASSPW_OVERRIDE_EN_MASK = 0x00001000L;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_PAGE_PASSPW_OVERRIDE_MASK = 0x00000008L;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_RSPPASSPW_OVERRIDE_EN_MASK = 0x00002000L;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_RSPPASSPW_OVERRIDE_MASK = 0x00000100L;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_TR_PASSPW_OVERRIDE_EN_MASK = 0x00000800L;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_TR_PASSPW_OVERRIDE_MASK = 0x00000004L;
    constexpr unsigned int RPB_PASSPW_CONF__ATOMIC_PASSPW_OVERRIDE_MASK = 0x00000200L;
    constexpr unsigned int RPB_PASSPW_CONF__ATOMIC_RSPPASSPW_OVERRIDE_MASK = 0x00000400L;
    constexpr unsigned int RPB_PASSPW_CONF__RDRSP_PASSPW_OVERRIDE_EN_MASK = 0x00020000L;
    constexpr unsigned int RPB_PASSPW_CONF__RDRSP_PASSPW_OVERRIDE_MASK = 0x00010000L;
    constexpr unsigned int RPB_PASSPW_CONF__RD_PASSPW_OVERRIDE_MASK = 0x00000020L;
    constexpr unsigned int RPB_PASSPW_CONF__RD_RSPPASSPW_OVERRIDE_MASK = 0x00000080L;
    constexpr unsigned int RPB_PASSPW_CONF__WRRSP_PASSPW_OVERRIDE_EN_MASK = 0x00008000L;
    constexpr unsigned int RPB_PASSPW_CONF__WRRSP_PASSPW_OVERRIDE_MASK = 0x00004000L;
    constexpr unsigned int RPB_PASSPW_CONF__WR_PASSPW_OVERRIDE_MASK = 0x00000010L;
    constexpr unsigned int RPB_PASSPW_CONF__WR_RSPPASSPW_OVERRIDE_MASK = 0x00000040L;
    constexpr unsigned int RPB_TAG_CONF__RPB_ATS_PR_MASK            = 0x3ff00000L;
    constexpr unsigned int RPB_TAG_CONF__RPB_ATS_TR_MASK            = 0x000003ffL;
    constexpr unsigned int RPB_TAG_CONF__RPB_IO_WR_MASK             = 0x000ffc00L;
    constexpr unsigned int SCRATCH_REGISTER0__ScratchPad0_MASK      = 0xffffffffL;
    constexpr unsigned int SCRATCH_REGISTER1__ScratchPad1_MASK      = 0xffffffffL;
    constexpr unsigned int SCRATCH_REGISTER2__ScratchPad2_MASK      = 0xffffffffL;
    constexpr unsigned int SCRATCH_REGISTER3__ScratchPad3_MASK      = 0xffffffffL;
    constexpr unsigned int SCRATCH_REGISTER4__ScratchPad4_MASK      = 0xffffffffL;
    constexpr unsigned int SCRATCH_REGISTER5__ScratchPad5_MASK      = 0xffffffffL;
    constexpr unsigned int SCRATCH_REGISTER6__ScratchPad6_MASK      = 0xffffffffL;
    constexpr unsigned int SCRATCH_REGISTER7__ScratchPad7_MASK      = 0xffffffffL;
    constexpr unsigned int SH_MEM_CONFIG__ILLEGAL_INST_CHECK_DISABLE_MASK = 0x00020000L;
    constexpr unsigned int SH_MEM_CONFIG__NO_PREFETCH_ACROSS_PAGE_MASK = 0x00010000L;
    constexpr unsigned int SH_MEM_CONFIG__RETRY_MODE_MASK           = 0x00003000L;
    constexpr unsigned int SOCCLK_CGTT_BLK_CTRL_REG__SOCCLK_TURN_OFF_DELAY_MASK = 0x00000ff0L;
    constexpr unsigned int SOCCLK_CGTT_BLK_CTRL_REG__SOCCLK_TURN_ON_DELAY_MASK = 0x0000000fL;
    constexpr unsigned int SOC_GAP_PWROK__soc_gap_pwrok_MASK        = 0x00000001L;
    constexpr unsigned int SPI_CONFIG_CNTL_1_REMAP__RESERVED_MASK   = 0xffffffffL;
    constexpr unsigned int SPI_CONFIG_CNTL_1__RESERVED_MASK         = 0xffc00000L;
    constexpr unsigned int SPI_CONFIG_CNTL_2_REMAP__RESERVED_MASK   = 0xffffffffL;
    constexpr unsigned int SPI_CONFIG_CNTL_REMAP__RESERVED_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_CONFIG_CNTL__RSRC_MGMT_RESET_MASK    = 0x04000000L;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_4__COUNT_MASK    = 0x000007ffL;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_4__EVENTS_MASK   = 0x07ff0000L;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_5__COUNT_MASK    = 0x000007ffL;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_5__EVENTS_MASK   = 0x07ff0000L;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_6__COUNT_MASK    = 0x000007ffL;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_6__EVENTS_MASK   = 0x07ff0000L;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_7__COUNT_MASK    = 0x000007ffL;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_7__EVENTS_MASK   = 0x07ff0000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__BARRIERS_MASK = 0x00078000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__LDS_MASK     = 0x00000f00L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__SGPR_MASK    = 0x000000f0L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__VGPR_MASK    = 0x0000000fL;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__WAVES_MASK   = 0x00007000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__BARRIERS_MASK = 0x00078000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__LDS_MASK     = 0x00000f00L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__SGPR_MASK    = 0x000000f0L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__VGPR_MASK    = 0x0000000fL;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__WAVES_MASK   = 0x00007000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__BARRIERS_MASK = 0x00078000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__LDS_MASK     = 0x00000f00L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__SGPR_MASK    = 0x000000f0L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__VGPR_MASK    = 0x0000000fL;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__WAVES_MASK   = 0x00007000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__BARRIERS_MASK = 0x00078000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__LDS_MASK     = 0x00000f00L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__SGPR_MASK    = 0x000000f0L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__VGPR_MASK    = 0x0000000fL;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__WAVES_MASK   = 0x00007000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_0__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_1__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_2__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_3__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_4__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_5__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_6__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_7__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_8__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_9__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__EN_MASK   = 0x00000001L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__QUEUE_MASK_MASK = 0x00ff0000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__TYPE_MASK_MASK = 0x0000fffeL;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__EN_MASK   = 0x00000001L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__QUEUE_MASK_MASK = 0x00ff0000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__TYPE_MASK_MASK = 0x0000fffeL;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__EN_MASK   = 0x00000001L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__QUEUE_MASK_MASK = 0x00ff0000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__TYPE_MASK_MASK = 0x0000fffeL;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__EN_MASK   = 0x00000001L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__QUEUE_MASK_MASK = 0x00ff0000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__RESERVE_SPACE_ONLY_MASK = 0x01000000L;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__TYPE_MASK_MASK = 0x0000fffeL;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__CDBG_USER_MASK  = 0x40000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__CU_GROUP_ENABLE_MASK = 0x04000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__DEBUG_MODE_MASK = 0x00400000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__DX10_CLAMP_MASK = 0x00200000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__FLOAT_MODE_MASK = 0x000ff000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__FP16_OVFL_MASK  = 0x80000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__IEEE_MODE_MASK  = 0x00800000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__PRIORITY_MASK   = 0x00000c00L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__PRIV_MASK       = 0x00100000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__SGPRS_MASK      = 0x000003c0L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__VGPRS_MASK      = 0x0000003fL;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__VGPR_COMP_CNT_MASK = 0x03000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__CDBG_USER_MASK  = 0x20000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__DEBUG_MODE_MASK = 0x00400000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__DX10_CLAMP_MASK = 0x00200000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__FLOAT_MODE_MASK = 0x000ff000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__FP16_OVFL_MASK  = 0x40000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__IEEE_MODE_MASK  = 0x00800000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__PRIORITY_MASK   = 0x00000c00L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__PRIV_MASK       = 0x00100000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__SGPRS_MASK      = 0x000003c0L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__VGPRS_MASK      = 0x0000003fL;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__VGPR_COMP_CNT_MASK = 0x03000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_GS__EXCP_EN_MASK = 0x0001ff00L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_GS__LDS_SIZE_MASK = 0x1ff00000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_GS__OC_LDS_EN_MASK = 0x00000080L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_GS__SCRATCH_EN_MASK = 0x00000001L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_GS__TRAP_PRESENT_MASK = 0x00000040L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_GS__USER_SGPR_MASK = 0x0000003eL;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_VS__EXCP_EN_MASK = 0x0001ff00L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_VS__LDS_SIZE_MASK = 0x1ff00000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_VS__OC_LDS_EN_MASK = 0x00000080L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_VS__SCRATCH_EN_MASK = 0x00000001L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_VS__TRAP_PRESENT_MASK = 0x00000040L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_VS__USER_SGPR_MASK = 0x0000003eL;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES__EXCP_EN_MASK    = 0x0001ff00L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES__LDS_SIZE_MASK   = 0x1ff00000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES__OC_LDS_EN_MASK  = 0x00000080L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES__SCRATCH_EN_MASK = 0x00000001L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES__TRAP_PRESENT_MASK = 0x00000040L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES__USER_SGPR_MASK  = 0x0000003eL;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_ES__EXCP_EN_MASK = 0x01ff0000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_ES__LDS_SIZE_MASK = 0x0000ff80L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_ES__SCRATCH_EN_MASK = 0x00000001L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_ES__TRAP_PRESENT_MASK = 0x00000040L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_ES__USER_SGPR_MASK = 0x0000003eL;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_HS__EXCP_EN_MASK = 0x01ff0000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_HS__LDS_SIZE_MASK = 0x0000ff80L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_HS__SCRATCH_EN_MASK = 0x00000001L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_HS__TRAP_PRESENT_MASK = 0x00000040L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_HS__USER_SGPR_MASK = 0x0000003eL;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_VS__EXCP_EN_MASK = 0x01ff0000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_VS__LDS_SIZE_MASK = 0x0000ff80L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_VS__SCRATCH_EN_MASK = 0x00000001L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_VS__TRAP_PRESENT_MASK = 0x00000040L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_VS__USER_SGPR_MASK = 0x0000003eL;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS__EXCP_EN_MASK    = 0x01ff0000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS__LDS_SIZE_MASK   = 0x0000ff80L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS__SCRATCH_EN_MASK = 0x00000001L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS__TRAP_PRESENT_MASK = 0x00000040L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS__USER_SGPR_MASK  = 0x0000003eL;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_ES__CU_EN_MASK      = 0x0000ffffL;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_ES__GROUP_FIFO_DEPTH_MASK = 0xfc000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_ES__LOCK_LOW_THRESHOLD_MASK = 0x03c00000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_ES__WAVE_LIMIT_MASK = 0x003f0000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_LS__CU_EN_MASK      = 0x0000ffffL;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_LS__GROUP_FIFO_DEPTH_MASK = 0xfc000000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_LS__LOCK_LOW_THRESHOLD_MASK = 0x03c00000L;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_LS__WAVE_LIMIT_MASK = 0x003f0000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_ESGS__GROUP_UPDATE_EN_MASK = 0x00000040L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_ESGS__PER_TYPE_WAVE_COUNT_COEFFICIENT_MASK = 0x00ff0000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_ESGS__PER_TYPE_WAVE_COUNT_HIER_SELECT_MASK = 0x00000038L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_ESGS__TOTAL_WAVE_COUNT_COEFFICIENT_MASK = 0x0000ff00L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_ESGS__TOTAL_WAVE_COUNT_HIER_SELECT_MASK = 0x00000007L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_LSHS__GROUP_UPDATE_EN_MASK = 0x00000040L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_LSHS__PER_TYPE_WAVE_COUNT_COEFFICIENT_MASK = 0x00ff0000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_LSHS__PER_TYPE_WAVE_COUNT_HIER_SELECT_MASK = 0x00000038L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_LSHS__TOTAL_WAVE_COUNT_COEFFICIENT_MASK = 0x0000ff00L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_LSHS__TOTAL_WAVE_COUNT_HIER_SELECT_MASK = 0x00000007L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_PS__GROUP_UPDATE_EN_MASK = 0x00000040L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_PS__PER_TYPE_WAVE_COUNT_COEFFICIENT_MASK = 0x00ff0000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_PS__PER_TYPE_WAVE_COUNT_HIER_SELECT_MASK = 0x00000038L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_PS__TOTAL_WAVE_COUNT_COEFFICIENT_MASK = 0x0000ff00L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_PS__TOTAL_WAVE_COUNT_HIER_SELECT_MASK = 0x00000007L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_VS__GROUP_UPDATE_EN_MASK = 0x00000040L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_VS__PER_TYPE_WAVE_COUNT_COEFFICIENT_MASK = 0x00ff0000L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_VS__PER_TYPE_WAVE_COUNT_HIER_SELECT_MASK = 0x00000038L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_VS__TOTAL_WAVE_COUNT_COEFFICIENT_MASK = 0x0000ff00L;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_VS__TOTAL_WAVE_COUNT_HIER_SELECT_MASK = 0x00000007L;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_0__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_1__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_2__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_3__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_4__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_5__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_6__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_7__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_8__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_9__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_10__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_11__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_12__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_13__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_14__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_15__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_0__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_1__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_2__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_3__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_4__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_5__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_6__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_7__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_8__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_9__DATA_MASK     = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_10__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_11__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_12__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_13__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_14__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_15__DATA_MASK    = 0xffffffffL;
    constexpr unsigned int SPI_WAVE_LIMIT_CNTL_REMAP__RESERVED_MASK = 0xffffffffL;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__ES_GRP_VALUE_MASK = 0x003e0000L;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__LS_GRP_VALUE_MASK = 0x00000f80L;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_3__INT_SENT_MASK  = 0x80000000L;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_3__MAX_CNT_MASK   = 0x7fffffffL;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_5__INT_SENT_MASK  = 0x80000000L;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_5__MAX_CNT_MASK   = 0x7fffffffL;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_10__INT_SENT_MASK = 0x80000000L;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_10__MAX_CNT_MASK  = 0x7fffffffL;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_12__INT_SENT_MASK = 0x80000000L;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_12__MAX_CNT_MASK  = 0x7fffffffL;
    constexpr unsigned int SP_CONFIG__CAC_COUNTER_OVERRIDE_MASK     = 0x00000020L;
    constexpr unsigned int SP_CONFIG__DPMACC_MGCG_OVERRIDE_MASK     = 0x00000040L;
    constexpr unsigned int SP_CONFIG__SMACC_MGCG_OVERRIDE_MASK      = 0x00000080L;
    constexpr unsigned int SP_CONFIG__TRANS_MGCG_OVERRIDE_MASK      = 0x00000010L;
    constexpr unsigned int SQC_CACHES__VOL_MASK                     = 0x00000010L;
    constexpr unsigned int SQC_CACHES__WRITEBACK_MASK               = 0x00000008L;
    constexpr unsigned int SQC_CONFIG__IDENTITY_HASH_BANK_MASK      = 0x00000200L;
    constexpr unsigned int SQC_WRITEBACK__DIRTY_MASK                = 0x00000002L;
    constexpr unsigned int SQC_WRITEBACK__DWB_MASK                  = 0x00000001L;
    constexpr unsigned int SQ_ARB_CONFIG__DISABLE_SECOND_TRY_MASK   = 0x00000100L;
    constexpr unsigned int SQ_CONFIG__OVERRIDE_LDS_IDX_BUSY_MASK    = 0x00000800L;
    constexpr unsigned int SQ_CONFIG__REPLAY_SLEEP_CNT_MASK         = 0x0fe00000L;
    constexpr unsigned int SQ_PERFCOUNTER0_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER1_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER2_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER3_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER4_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER5_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER6_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER7_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER8_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER9_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER10_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER11_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER12_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER13_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER14_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_PERFCOUNTER15_SELECT__SQC_BANK_MASK_MASK = 0x0000f000L;
    constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__TOKEN_EXCLUDE_MASK = 0x00000fffL;
    constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERFCOUNTER_SELECT1_MASK = 0x000ffc00L;
    constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERFCOUNTER_SELECT1_MASK = 0x000ffc00L;
    constexpr unsigned int TA_CNTL_AUX__RESERVED_MASK               = 0x0000000eL;
    constexpr unsigned int TA_CNTL__FX_XNACK_CREDIT_MASK            = 0x0000007fL;
    constexpr unsigned int TA_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK  = 0x000000ffL;
    constexpr unsigned int TA_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK  = 0x0003fc00L;
    constexpr unsigned int TA_PERFCOUNTER0_SELECT__PERF_SEL1_MASK   = 0x0003fc00L;
    constexpr unsigned int TA_PERFCOUNTER0_SELECT__PERF_SEL_MASK    = 0x000000ffL;
    constexpr unsigned int TA_PERFCOUNTER1_SELECT__PERF_SEL_MASK    = 0x000000ffL;
    constexpr unsigned int TD_CNTL__DONE_SCOREBOARD_DEPTH_MASK      = 0x7c000000L;
    constexpr unsigned int TD_DEBUG_INDEX__INDEX_MASK               = 0x0000001fL;
    constexpr unsigned int TD_PERFCOUNTER0_SELECT1__PERF_SEL2_MASK  = 0x000000ffL;
    constexpr unsigned int TD_PERFCOUNTER0_SELECT1__PERF_SEL3_MASK  = 0x0003fc00L;
    constexpr unsigned int TD_PERFCOUNTER0_SELECT__PERF_SEL1_MASK   = 0x0003fc00L;
    constexpr unsigned int TD_PERFCOUNTER0_SELECT__PERF_SEL_MASK    = 0x000000ffL;
    constexpr unsigned int TD_PERFCOUNTER1_SELECT__PERF_SEL_MASK    = 0x000000ffL;
    constexpr unsigned int TD_POWER_CNTL__DISABLE_NOFILTER_FORMATTER_POWER_OPT_MASK = 0x00000100L;
    constexpr unsigned int TD_POWER_CNTL__FORCE_NOFILTER_CLK_TO_CORE_MASK = 0x00000002L;
    constexpr unsigned int TD_POWER_CNTL__FORCE_NOFILTER_D16_FORMATTERS_ON_MASK = 0x00000200L;
    constexpr unsigned int TD_POWER_CNTL__FORCE_SAMPLER_CLK_TO_CORE_MASK = 0x00000001L;
    constexpr unsigned int TD_POWER_CNTL__NOFILTER_CLK_VALID_DELAY_MASK = 0x000000e0L;
    constexpr unsigned int TD_POWER_CNTL__SAMPLER_CLK_VALID_DELAY_MASK = 0x0000001cL;
    constexpr unsigned int UTCL1_CTRL__UTCL1_MH_DISABLE_REQUEST_SQUASHING_MASK = 0x00400000L;
    constexpr unsigned int UTCL1_CTRL__UTCL1_REDUCE_MH_CAM_SIZE_MASK = 0xc0000000L;
    constexpr unsigned int UTCL1_CTRL__UTCL1_REDUCE_MH_CFIFO_SIZE_MASK = 0x30000000L;
    constexpr unsigned int VGT_ESGS_RING_SIZE_UMD__MEM_SIZE_MASK    = 0xffffffffL;
    constexpr unsigned int VGT_GSVS_RING_SIZE_UMD__MEM_SIZE_MASK    = 0xffffffffL;
    constexpr unsigned int VGT_HS_OFFCHIP_PARAM_UMD__OFFCHIP_BUFFERING_MASK = 0x000001ffL;
    constexpr unsigned int VGT_HS_OFFCHIP_PARAM_UMD__OFFCHIP_GRANULARITY_MASK = 0x00000600L;
    constexpr unsigned int VGT_HS_OFFCHIP_PARAM__OFFCHIP_BUFFERING_MASK = 0x000001ffL;
    constexpr unsigned int VGT_HS_OFFCHIP_PARAM__OFFCHIP_GRANULARITY_MASK = 0x00000600L;
    constexpr unsigned int VGT_TF_MEMORY_BASE_HI_UMD__BASE_HI_MASK  = 0x000000ffL;
    constexpr unsigned int VGT_TF_MEMORY_BASE_UMD__BASE_MASK        = 0xffffffffL;
    constexpr unsigned int VGT_TF_RING_SIZE_UMD__SIZE_MASK          = 0x0000ffffL;
} // namespace Nv10

namespace Oss50
{
    constexpr unsigned int SDMA0_PERFCOUNTER0_RESULT__PERF_COUNT_MASK = 0xffffffffL;
    constexpr unsigned int SDMA0_PERFCOUNTER1_RESULT__PERF_COUNT_MASK = 0xffffffffL;
    constexpr unsigned int SDMA0_PERFCOUNTER_TAG_DELAY_RANGE__RANGE_HIGH_MASK = 0x0fffc000L;
    constexpr unsigned int SDMA0_PERFCOUNTER_TAG_DELAY_RANGE__RANGE_LOW_MASK = 0x00003fffL;
    constexpr unsigned int SDMA0_PERFCOUNTER_TAG_DELAY_RANGE__SELECT_RW_MASK = 0x10000000L;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_CLEAR0_MASK     = 0x00000002L;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_CLEAR1_MASK     = 0x00000800L;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_ENABLE0_MASK    = 0x00000001L;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_ENABLE1_MASK    = 0x00000400L;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_SEL0_MASK       = 0x000003fcL;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_SEL1_MASK       = 0x000ff000L;
    constexpr unsigned int SDMA1_PERFCOUNTER0_RESULT__PERF_COUNT_MASK = 0xffffffffL;
    constexpr unsigned int SDMA1_PERFCOUNTER1_RESULT__PERF_COUNT_MASK = 0xffffffffL;
    constexpr unsigned int SDMA1_PERFCOUNTER_TAG_DELAY_RANGE__RANGE_HIGH_MASK = 0x0fffc000L;
    constexpr unsigned int SDMA1_PERFCOUNTER_TAG_DELAY_RANGE__RANGE_LOW_MASK = 0x00003fffL;
    constexpr unsigned int SDMA1_PERFCOUNTER_TAG_DELAY_RANGE__SELECT_RW_MASK = 0x10000000L;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_CLEAR0_MASK     = 0x00000002L;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_CLEAR1_MASK     = 0x00000800L;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_ENABLE0_MASK    = 0x00000001L;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_ENABLE1_MASK    = 0x00000400L;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_SEL0_MASK       = 0x000003fcL;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_SEL1_MASK       = 0x000ff000L;
    constexpr unsigned int SDMA_PGFSM_CONFIG__FSM_ADDR_MASK         = 0x000000ffL;
    constexpr unsigned int SDMA_PGFSM_CONFIG__P1_SELECT_MASK        = 0x00000400L;
    constexpr unsigned int SDMA_PGFSM_CONFIG__P2_SELECT_MASK        = 0x00000800L;
    constexpr unsigned int SDMA_PGFSM_CONFIG__POWER_DOWN_MASK       = 0x00000100L;
    constexpr unsigned int SDMA_PGFSM_CONFIG__POWER_UP_MASK         = 0x00000200L;
    constexpr unsigned int SDMA_PGFSM_CONFIG__READ_MASK             = 0x00002000L;
    constexpr unsigned int SDMA_PGFSM_CONFIG__REG_ADDR_MASK         = 0xf0000000L;
    constexpr unsigned int SDMA_PGFSM_CONFIG__SRBM_OVERRIDE_MASK    = 0x08000000L;
    constexpr unsigned int SDMA_PGFSM_CONFIG__WRITE_MASK            = 0x00001000L;
    constexpr unsigned int SDMA_PGFSM_READ__VALUE_MASK              = 0x00ffffffL;
    constexpr unsigned int SDMA_PGFSM_WRITE__VALUE_MASK             = 0xffffffffL;
    constexpr unsigned int SDMA_POWER_GATING__PG_CNTL_STATUS_MASK   = 0x00000030L;
    constexpr unsigned int SDMA_POWER_GATING__SDMA0_POWER_OFF_CONDITION_MASK = 0x00000001L;
    constexpr unsigned int SDMA_POWER_GATING__SDMA0_POWER_OFF_REQ_MASK = 0x00000004L;
    constexpr unsigned int SDMA_POWER_GATING__SDMA0_POWER_ON_CONDITION_MASK = 0x00000002L;
    constexpr unsigned int SDMA_POWER_GATING__SDMA0_POWER_ON_REQ_MASK = 0x00000008L;
} // namespace Oss50

namespace Raven
{
    constexpr unsigned int GC_CAC_ACC_PG0__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
    constexpr unsigned int GC_CAC_OVRD_PG__OVRRD_SELECT_MASK        = 0x0000ffffL;
    constexpr unsigned int GC_CAC_OVRD_PG__OVRRD_VALUE_MASK         = 0xffff0000L;
    constexpr unsigned int GC_CAC_PG_AGGR_LOWER__LKG_AGGR_31_0_MASK = 0xffffffffL;
    constexpr unsigned int GC_CAC_PG_AGGR_UPPER__LKG_AGGR_63_32_MASK = 0xffffffffL;
    constexpr unsigned int GC_CAC_WEIGHT_PG_0__WEIGHT_PG_SIG0_MASK  = 0x0000ffffL;
    constexpr unsigned int RLC_SPM_DEBUG_SELECT__RESERVED_MASK      = 0x00000f00L;
    constexpr unsigned int RLC_SPM_DEBUG_SELECT__RLC_DBG_FIFO_CNTL_MASK = 0x00002000L;
    constexpr unsigned int RLC_SPM_DEBUG_SELECT__RLC_MC_FIFO_CNTL_MASK = 0x00001000L;
    constexpr unsigned int RLC_SPM_DEBUG_SELECT__RLC_SPM_DEBUG_MODE_DUAL_MASK = 0x00004000L;
    constexpr unsigned int RLC_SPM_PERFMON_CNTL__RESERVED1_MASK     = 0x00000ffcL;
    constexpr unsigned int RLC_SPM_PERFMON_CNTL__RLC_DBG_STRM_EN_MASK = 0x00000001L;
    constexpr unsigned int RLC_SPM_PERFMON_CNTL__RLC_DBG_STRM_EXT_SAMPLE_MASK = 0x00000002L;
    constexpr unsigned int WD_DEBUG_REG7__SE1VGT_WD_thdgrp_send_in_MASK = 0x00000010L;
    constexpr unsigned int WD_DEBUG_REG7__se1_thdgrp_eop_MASK       = 0x00800000L;
    constexpr unsigned int WD_DEBUG_REG7__se1_thdgrp_is_event_MASK  = 0x00400000L;
    constexpr unsigned int WD_DEBUG_REG7__wd_arb_se1_input_fifo_empty_MASK = 0x00000040L;
    constexpr unsigned int WD_DEBUG_REG7__wd_arb_se1_input_fifo_full_MASK = 0x00000080L;
    constexpr unsigned int WD_DEBUG_REG7__wd_arb_se1_input_fifo_re_MASK = 0x00000020L;
} // namespace Raven

namespace Rv1x
{
    constexpr unsigned int GC_CAC_ACC_BCI1__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU3__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU4__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
    constexpr unsigned int GC_CAC_OVRD_BCI__OVRRD_SELECT_MASK       = 0x00000003L;
    constexpr unsigned int GC_CAC_OVRD_BCI__OVRRD_VALUE_MASK        = 0x0000000cL;
    constexpr unsigned int GC_CAC_WEIGHT_BCI_0__WEIGHT_BCI_SIG1_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_PG_0__unused_MASK          = 0xffff0000L;
    constexpr unsigned int IA_DEBUG_REG0__SPARE0_MASK               = 0x00000010L;
    constexpr unsigned int IA_DEBUG_REG0__SPARE1_MASK               = 0x00000200L;
    constexpr unsigned int IA_DEBUG_REG0__SPARE2_MASK               = 0x00ffc000L;
    constexpr unsigned int IA_DEBUG_REG0__SPARE3_MASK               = 0x04000000L;
    constexpr unsigned int IA_DEBUG_REG0__SPARE4_MASK               = 0x08000000L;
    constexpr unsigned int IA_DEBUG_REG0__SPARE5_MASK               = 0x40000000L;
    constexpr unsigned int IA_DEBUG_REG9__SPARE0_MASK               = 0x00004000L;
    constexpr unsigned int IA_DEBUG_REG9__SPARE1_MASK               = 0x00008000L;
    constexpr unsigned int PWR_OVERRIDE__VDDCR_CPU_OVERRIDE_MASK    = 0x00000001L;
    constexpr unsigned int RMI_CLOCK_CNTRL__DYN_CLK_RB1_BUSY_MASK_MASK = 0x01f00000L;
    constexpr unsigned int RMI_CLOCK_CNTRL__DYN_CLK_RB1_WAKEUP_MASK_MASK = 0x3e000000L;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_BREAK_LOB_ON_IDLEIN_MASK = 0x00020000L;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_MODE_MASK     = 0xc0000000L;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_STALL_MASK    = 0x00010000L;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_STALL_TIMER_OVERRIDE_MASK = 0x00300000L;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_STALL_TIMER_START_VALUE_MASK = 0x3fc00000L;
    constexpr unsigned int RMI_GENERAL_CNTL1__TCIW1_64B_RD_STALL_MODE_MASK = 0x000000c0L;
    constexpr unsigned int RMI_GENERAL_CNTL1__UTCL1_PROBE1_RR_ARB_BURST_HINT_EN_MASK = 0x00001000L;
    constexpr unsigned int RMI_GENERAL_CNTL__RB1_HARVEST_EN_MASK    = 0x00100000L;
    constexpr unsigned int RMI_GENERAL_CNTL__SKID_FIFO_1_OVERFLOW_ERROR_MASK_MASK = 0x10000000L;
    constexpr unsigned int RMI_GENERAL_CNTL__SKID_FIFO_1_UNDERFLOW_ERROR_MASK_MASK = 0x20000000L;
    constexpr unsigned int RMI_GENERAL_STATUS__RDREQ_CONSUMER_FIFO_1_BUSY_MASK = 0x00020000L;
    constexpr unsigned int RMI_GENERAL_STATUS__SKID_FIFO_1_OVERFLOW_ERROR_MASK = 0x00000008L;
    constexpr unsigned int RMI_GENERAL_STATUS__SKID_FIFO_1_UNDERFLOW_ERROR_MASK = 0x00000010L;
    constexpr unsigned int RMI_GENERAL_STATUS__TCIW1_PRT_FIFO_BUSY_MASK = 0x00002000L;
    constexpr unsigned int RMI_GENERAL_STATUS__TCIW_FRMTR1_BUSY_MASK = 0x00004000L;
    constexpr unsigned int RMI_GENERAL_STATUS__TCIW_RTN_FRMTR1_BUSY_MASK = 0x00008000L;
    constexpr unsigned int RMI_GENERAL_STATUS__UTC_PROBE1_BUSY_MASK = 0x00040000L;
    constexpr unsigned int RMI_GENERAL_STATUS__WRREQ_CONSUMER_FIFO_1_BUSY_MASK = 0x00010000L;
    constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_EVENT_WINDOW_MASK1_MASK = 0x00000300L;
    constexpr unsigned int RMI_PROBE_POP_LOGIC_CNTL__EXT_LAT_FIFO_1_MAX_DEPTH_MASK = 0x0001fc00L;
    constexpr unsigned int RMI_PROBE_POP_LOGIC_CNTL__XLAT_COMBINE1_DIS_MASK = 0x00020000L;
    constexpr unsigned int RMI_SCOREBOARD_CNTL__COMPLETE_RB1_FLUSH_MASK = 0x00000004L;
    constexpr unsigned int RMI_SCOREBOARD_CNTL__REQ_IN_RE_EN_AFTER_FLUSH_RB1_MASK = 0x00000008L;
    constexpr unsigned int RMI_SCOREBOARD_CNTL__TIME_STAMP_FLUSH_RB1_MASK = 0x00000010L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS1__COM_FLUSH_IN_PROG_RB1_MASK = 0x20000000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS1__RUNNING_CNT_OVERFLOW_RB1_MASK = 0x10000000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS1__RUNNING_CNT_RB1_MASK = 0x07ff8000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS1__RUNNING_CNT_UNDERFLOW_RB1_MASK = 0x08000000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__COM_FLUSH_DONE_RB1_MASK = 0x04000000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__SNAPSHOT_CNT_RB1_MASK = 0x01ffe000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__SNAPSHOT_CNT_UNDERFLOW_RB1_MASK = 0x02000000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__TIME_STAMP_FLUSH_DONE_RB1_MASK = 0x80000000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__TIME_STAMP_FLUSH_IN_PROG_RB1_MASK = 0x20000000L;
    constexpr unsigned int RMI_SUBBLOCK_STATUS0__UTC_EXT_LAT_HID_FIFO_EMPTY_PROBE1_MASK = 0x00020000L;
    constexpr unsigned int RMI_SUBBLOCK_STATUS0__UTC_EXT_LAT_HID_FIFO_FULL_PROBE1_MASK = 0x00010000L;
    constexpr unsigned int RMI_SUBBLOCK_STATUS0__UTC_EXT_LAT_HID_FIFO_NUM_USED_PROBE1_MASK = 0x0000fe00L;
    constexpr unsigned int RMI_SUBBLOCK_STATUS1__SKID_FIFO_1_FREE_SPACE_MASK = 0x000ffc00L;
    constexpr unsigned int RMI_SUBBLOCK_STATUS1__TCIW1_INFLIGHT_CNT_MASK = 0x3ff00000L;
    constexpr unsigned int RMI_SUBBLOCK_STATUS2__PRT_FIFO_1_NUM_USED_MASK = 0x0003fe00L;
    constexpr unsigned int RMI_SUBBLOCK_STATUS3__SKID_FIFO_1_FREE_SPACE_TOTAL_MASK = 0x000ffc00L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__ALL_FAULT_RET1_DATA_MASK = 0x80000000L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__RMI_IN1_REORDER_DIS_MASK = 0x20000000L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__SKID_FIFO_1_FREE_SPACE_DELTA_MASK = 0x07f80000L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__SKID_FIFO_1_FREE_SPACE_DELTA_UPDATE_MASK = 0x08000000L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__TCIW1_MAX_ALLOWED_INFLIGHT_REQ_MASK = 0x0007fe00L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__TCIW1_REQ_SAFE_MODE_MASK = 0x10000000L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__WR_COMBINE1_DIS_AT_LAST_OF_BURST_MASK = 0x40000000L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__WR_COMBINE1_DIS_OVERRIDE_MASK = 0x00000001L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__WR_COMBINE1_TIME_OUT_WINDOW_MASK = 0x000001feL;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG_1__XBAR_ARB_ROUND_ROBIN_WEIGHT_RB1_RD_MASK = 0x00ff0000L;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG_1__XBAR_ARB_ROUND_ROBIN_WEIGHT_RB1_WR_MASK = 0xff000000L;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_BREAK_LOB_ON_IDLEIN_MASK = 0x00100000L;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_BREAK_LOB_ON_WEIGHTEDRR_MASK = 0x00040000L;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_MODE_MASK = 0x00030000L;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_STALL_MASK = 0x00080000L;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_STALL_TIMER_OVERRIDE_MASK = 0x00c00000L;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_STALL_TIMER_START_VALUE_MASK = 0xff000000L;
    constexpr unsigned int RMI_XBAR_CONFIG__XBAR_EN_IN_RB1_MASK     = 0x00004000L;
    constexpr unsigned int RPB_ATS_CNTL2__INVAL_COM_ROUTING_CODE_MASK = 0x00038000L;
    constexpr unsigned int RPB_ATS_CNTL2__PAGE_REQ_CMD_MASK         = 0x00000fc0L;
    constexpr unsigned int RPB_ATS_CNTL2__PAGE_ROUTING_CODE_MASK    = 0x00007000L;
    constexpr unsigned int RPB_ATS_CNTL2__TRANS_CMD_MASK            = 0x0000003fL;
    constexpr unsigned int RPB_ATS_CNTL2__VENDOR_ID_MASK            = 0x000c0000L;
    constexpr unsigned int RPB_ATS_CNTL__ATCTR_SWITCH_NUM_MASK      = 0x00078000L;
    constexpr unsigned int RPB_ATS_CNTL__INVAL_COM_CMD_MASK         = 0x7e000000L;
    constexpr unsigned int RPB_BIF_CNTL__ARB_MODE_MASK              = 0x00010000L;
    constexpr unsigned int RPB_BIF_CNTL__DRAIN_VC_NUM_MASK          = 0x00020000L;
    constexpr unsigned int RPB_BIF_CNTL__PAGE_PRI_EN_MASK           = 0x08000000L;
    constexpr unsigned int RPB_BIF_CNTL__PARITY_CHECK_EN_MASK       = 0x40000000L;
    constexpr unsigned int RPB_BIF_CNTL__SWITCH_ENABLE_MASK         = 0x00040000L;
    constexpr unsigned int RPB_BIF_CNTL__SWITCH_THRESHOLD_MASK      = 0x07f80000L;
    constexpr unsigned int RPB_BIF_CNTL__TR_PRI_EN_MASK             = 0x10000000L;
    constexpr unsigned int RPB_BIF_CNTL__VC0_CHAINED_OVERRIDE_MASK  = 0x20000000L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATC_INV_BLOCKLEVEL_MASK = 0x000000c0L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATC_PAGE_BLOCKLEVEL_MASK = 0x00000030L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATC_TR_BLOCKLEVEL_MASK = 0x0000000cL;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATOMIC_BLOCKLEVEL_OVERRIDE_EN_MASK = 0x00020000L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATOMIC_BLOCKLEVEL_OVERRIDE_MASK = 0x00003000L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_RD_BLOCKLEVEL_OVERRIDE_EN_MASK = 0x00010000L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_RD_BLOCKLEVEL_OVERRIDE_MASK = 0x00000c00L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_WR_BLOCKLEVEL_OVERRIDE_EN_MASK = 0x00008000L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_WR_BLOCKLEVEL_OVERRIDE_MASK = 0x00000300L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__XPB_BLOCKLEVEL_OVERRIDE_EN_MASK = 0x00004000L;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_PAGE_PASSPW_OVERRIDE_EN_MASK = 0x00001000L;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_PAGE_PASSPW_OVERRIDE_MASK = 0x00000008L;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_RSPPASSPW_OVERRIDE_EN_MASK = 0x00002000L;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_RSPPASSPW_OVERRIDE_MASK = 0x00000100L;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_TR_PASSPW_OVERRIDE_EN_MASK = 0x00000800L;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_TR_PASSPW_OVERRIDE_MASK = 0x00000004L;
    constexpr unsigned int RPB_PASSPW_CONF__ATOMIC_PASSPW_OVERRIDE_MASK = 0x00000200L;
    constexpr unsigned int RPB_PASSPW_CONF__ATOMIC_RSPPASSPW_OVERRIDE_MASK = 0x00000400L;
    constexpr unsigned int RPB_PASSPW_CONF__RDRSP_PASSPW_OVERRIDE_EN_MASK = 0x00020000L;
    constexpr unsigned int RPB_PASSPW_CONF__RDRSP_PASSPW_OVERRIDE_MASK = 0x00010000L;
    constexpr unsigned int RPB_PASSPW_CONF__RD_PASSPW_OVERRIDE_MASK = 0x00000020L;
    constexpr unsigned int RPB_PASSPW_CONF__RD_RSPPASSPW_OVERRIDE_MASK = 0x00000080L;
    constexpr unsigned int RPB_PASSPW_CONF__WRRSP_PASSPW_OVERRIDE_EN_MASK = 0x00008000L;
    constexpr unsigned int RPB_PASSPW_CONF__WRRSP_PASSPW_OVERRIDE_MASK = 0x00004000L;
    constexpr unsigned int RPB_PASSPW_CONF__WR_PASSPW_OVERRIDE_MASK = 0x00000010L;
    constexpr unsigned int RPB_PASSPW_CONF__WR_RSPPASSPW_OVERRIDE_MASK = 0x00000040L;
    constexpr unsigned int VGT_DEBUG_REG0__SPARE0_MASK              = 0x80000000L;
    constexpr unsigned int VGT_DEBUG_REG0__SPARE1_MASK              = 0x10000000L;
    constexpr unsigned int VGT_DEBUG_REG0__SPARE2_MASK              = 0x02000000L;
    constexpr unsigned int VGT_DEBUG_REG0__SPARE3_MASK              = 0x00100000L;
    constexpr unsigned int VGT_DEBUG_REG0__SPARE4_MASK              = 0x00000080L;
    constexpr unsigned int VGT_DEBUG_REG0__SPARE5_MASK              = 0x00000040L;
    constexpr unsigned int VGT_DEBUG_REG1__SPARE0_MASK              = 0x00000200L;
    constexpr unsigned int VGT_DEBUG_REG1__SPARE1_MASK              = 0x00000100L;
    constexpr unsigned int VGT_DEBUG_REG1__SPARE2_MASK              = 0x00000080L;
    constexpr unsigned int VGT_DEBUG_REG1__SPARE3_MASK              = 0x00000040L;
    constexpr unsigned int VGT_DEBUG_REG1__SPARE4_MASK              = 0x00000020L;
    constexpr unsigned int VGT_DEBUG_REG1__SPARE5_MASK              = 0x00000010L;
    constexpr unsigned int VGT_DEBUG_REG2__SPARE_MASK               = 0xe0000000L;
    constexpr unsigned int VGT_DEBUG_REG4__SPARE_MASK               = 0x80000000L;
    constexpr unsigned int VGT_DEBUG_REG5__SPARE1_MASK              = 0x07000000L;
    constexpr unsigned int VGT_DEBUG_REG5__SPARE2_MASK              = 0x00070000L;
    constexpr unsigned int VGT_DEBUG_REG5__SPARE3_MASK              = 0x00000700L;
    constexpr unsigned int VGT_DEBUG_REG5__SPARE4_MASK              = 0x00000007L;
    constexpr unsigned int VGT_DEBUG_REG7__SPARE_MASK               = 0x0000ffe0L;
    constexpr unsigned int VGT_DEBUG_REG9__SPARE0_MASK              = 0x40000000L;
    constexpr unsigned int VGT_DEBUG_REG10__SPARE2_MASK             = 0x00000600L;
    constexpr unsigned int VGT_DEBUG_REG11__SPARE0_MASK             = 0x00040000L;
    constexpr unsigned int VGT_DEBUG_REG11__SPARE1_MASK             = 0x00000020L;
    constexpr unsigned int VGT_DEBUG_REG12__SPARE0_MASK             = 0x80000000L;
    constexpr unsigned int VGT_DEBUG_REG13__SPARE0_MASK             = 0x04000000L;
    constexpr unsigned int VGT_DEBUG_REG13__SPARE1_MASK             = 0x02000000L;
    constexpr unsigned int VGT_DEBUG_REG14__SPARE0_MASK             = 0x40000000L;
    constexpr unsigned int VGT_DEBUG_REG14__SPARE1_MASK             = 0x10000000L;
    constexpr unsigned int VGT_DEBUG_REG14__SPARE2_MASK             = 0x001ff000L;
    constexpr unsigned int VGT_DEBUG_REG14__SPARE3_MASK             = 0x0000000fL;
    constexpr unsigned int VGT_DEBUG_REG14__SPARE_MASK              = 0x01c00000L;
    constexpr unsigned int VGT_DEBUG_REG23__SPARE_MASK              = 0xff000000L;
    constexpr unsigned int VGT_DEBUG_REG30__SPARE_MASK              = 0xfff80000L;
    constexpr unsigned int VGT_DEBUG_REG32__SPARE_MASK              = 0xf0000000L;
    constexpr unsigned int WD_DEBUG_REG0__SPARE3_MASK               = 0x00010000L;
    constexpr unsigned int WD_DEBUG_REG1__SPARE0_MASK               = 0x00000100L;
    constexpr unsigned int WD_DEBUG_REG2__SPARE0_MASK               = 0x00000100L;
    constexpr unsigned int WD_DEBUG_REG3__SPARE0_MASK               = 0x00000002L;
    constexpr unsigned int WD_DEBUG_REG3__SPARE1_MASK               = 0x00800000L;
    constexpr unsigned int WD_DEBUG_REG5__SPARE0_MASK               = 0x00000002L;
    constexpr unsigned int WD_DEBUG_REG5__SPARE1_MASK               = 0x00800000L;
    constexpr unsigned int WD_DEBUG_REG7__SPARE1_MASK               = 0x00000f00L;
    constexpr unsigned int WD_DEBUG_REG7__SPARE2_MASK               = 0x0000f000L;
    constexpr unsigned int WD_DEBUG_REG7__SPARE5_MASK               = 0x00080000L;
    constexpr unsigned int WD_DEBUG_REG7__te11_arb_state_q_MASK     = 0x00070000L;
    constexpr unsigned int WD_DEBUG_REG9__SPARE0_MASK               = 0x0000f800L;
    constexpr unsigned int WD_DEBUG_REG9__SPARE1_MASK               = 0x08000000L;
    constexpr unsigned int WD_DEBUG_REG9__SPARE2_MASK               = 0x30000000L;
} // namespace Rv1x

namespace Rv2x
{
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_alloc_opco_error_MASK = 0x00000004L;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_dealloc_opco_error_MASK = 0x00000008L;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_dec_error_MASK = 0x00000002L;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_error_ds_address_MASK = 0x003fff00L;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_wrap_opco_error_MASK = 0x00000010L;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_write_dis_MASK = 0x00000001L;
    constexpr unsigned int alloc_DEBUG_DATA__Reserved0_MASK         = 0x000000e0L;
    constexpr unsigned int alloc_DEBUG_DATA__Reserved1_MASK         = 0xffc00000L;
    constexpr unsigned int DB_DEBUG4__DB_EXTRA_DEBUG4_MASK          = 0x7ff80000L;
    constexpr unsigned int GC_CAC_CNTL__CAC_ENABLE_MASK             = 0x00000001L;
    constexpr unsigned int GC_CAC_OVRD_BCI__OVRRD_SELECT_MASK       = 0x00000001L;
    constexpr unsigned int GC_CAC_OVRD_BCI__OVRRD_VALUE_MASK        = 0x00000002L;
    constexpr unsigned int GC_CAC_WEIGHT_CU_0__WEIGHT_CU_SIG1_MASK  = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_CU_1__WEIGHT_CU_SIG2_MASK  = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_CU_1__WEIGHT_CU_SIG3_MASK  = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_SXRB_0__WEIGHT_SXRB_SIG1_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ATCL2_2__WEIGHT_UTCL2_ATCL2_SIG5_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_UTCL2_VML2_2__WEIGHT_UTCL2_VML2_SIG5_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_UTCL2_WALKER_2__WEIGHT_UTCL2_WALKER_SIG5_MASK = 0xffff0000L;
    constexpr unsigned int gws_DEBUG_DATA__credit_cnt_MASK          = 0x00010000L;
    constexpr unsigned int gws_DEBUG_DATA__cur_reso_5to0_MASK       = 0x000001f8L;
    constexpr unsigned int gws_DEBUG_DATA__cur_reso_count_MASK      = 0x00008000L;
    constexpr unsigned int gws_DEBUG_DATA__Reserved0_MASK           = 0xff000000L;
    constexpr unsigned int IA_DEBUG_REG0__dma_grp_pipe1_valid_MASK  = 0x00001000L;
    constexpr unsigned int IA_DEBUG_REG0__grp_dma_pipe1_read_MASK   = 0x00002000L;
    constexpr unsigned int IA_DEBUG_REG0__RESERVED0_MASK            = 0x00000010L;
    constexpr unsigned int IA_DEBUG_REG0__RESERVED1_MASK            = 0x00000200L;
    constexpr unsigned int IA_DEBUG_REG0__RESERVED2_MASK            = 0x00ffc000L;
    constexpr unsigned int IA_DEBUG_REG0__RESERVED3_MASK            = 0x04000000L;
    constexpr unsigned int IA_DEBUG_REG0__RESERVED4_MASK            = 0x08000000L;
    constexpr unsigned int IA_DEBUG_REG0__RESERVED5_MASK            = 0x40000000L;
    constexpr unsigned int IA_DEBUG_REG0__RESERVED6_MASK            = 0x80000000L;
    constexpr unsigned int IA_DEBUG_REG0__tcarb_busy_MASK           = 0x00000080L;
    constexpr unsigned int IA_DEBUG_REG1__RESERVED0_MASK            = 0x00000080L;
    constexpr unsigned int IA_DEBUG_REG9__prim_counter_q_11_0_MASK  = 0xfff00000L;
    constexpr unsigned int IA_DEBUG_REG9__RESERVED0_MASK            = 0x00004000L;
    constexpr unsigned int IA_DEBUG_REG9__RESERVED1_MASK            = 0x00008000L;
    constexpr unsigned int IA_DEBUG_REG10__RESERVED0_MASK           = 0xffffffffL;
    constexpr unsigned int IA_DEBUG_REG11__RESERVED0_MASK           = 0xffffffffL;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_fragment_size_MASK = 0x003f0000L;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_io_steer_MASK = 0x00008000L;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_memlog_MASK = 0x00000800L;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_mtype_MASK = 0x00000600L;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_nack_MASK  = 0x00000180L;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_no_pte_MASK = 0x00001000L;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_perms_granted_MASK = 0x01c00000L;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_perms_requested_MASK = 0x0e000000L;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_physical_address_1_0_MASK = 0xc0000000L;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_pte_tmz_MASK = 0x00002000L;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_snoop_MASK = 0x10000000L;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_spa_MASK   = 0x00004000L;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_tag_MASK   = 0x0000007fL;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_valid_MASK = 0x20000000L;
    constexpr unsigned int IA_DEBUG_REG13__iUTCL2_IA_ret_physical_address_33_2_MASK = 0xc0000000L;
    constexpr unsigned int IA_DEBUG_REG14__IA_UTCL2_req_data_MASK   = 0x0003fffcL;
    constexpr unsigned int IA_DEBUG_REG14__IA_UTCL2_req_send_MASK   = 0x00080000L;
    constexpr unsigned int IA_DEBUG_REG14__iUTCL2_IA_ret_physical_address_35_34_MASK = 0x00000003L;
    constexpr unsigned int IA_DEBUG_REG14__qIA_UTCL2_req_free_MASK  = 0x00040000L;
    constexpr unsigned int IA_DEBUG_REG14__qUtcL2XferCycle_eq_0_MASK = 0x00100000L;
    constexpr unsigned int IA_DEBUG_REG14__RESERVED0_MASK           = 0xffe00000L;
    constexpr unsigned int IA_DEBUG_REG15__IAUtcL2Cnt_MASK          = 0x000000fcL;
    constexpr unsigned int IA_DEBUG_REG15__IAUtcL2iuPostArbFifo_Empty_MASK = 0x00000001L;
    constexpr unsigned int IA_DEBUG_REG15__IAUtcL2iuPostArbFifo_Full_MASK = 0x00000002L;
    constexpr unsigned int IA_DEBUG_REG15__IAUtcL2OutCnt_MASK       = 0x00003f00L;
    constexpr unsigned int IA_DEBUG_REG15__iUTCL10_UTCL2IU_req_rts_MASK = 0x00020000L;
    constexpr unsigned int IA_DEBUG_REG15__NewCycleXfer_MASK        = 0x01000000L;
    constexpr unsigned int IA_DEBUG_REG15__qUtcL2XferCycle_MASK     = 0x0001c000L;
    constexpr unsigned int IA_DEBUG_REG15__qXferId_MASK             = 0x00e00000L;
    constexpr unsigned int IA_DEBUG_REG15__RESERVED0_MASK           = 0xfe000000L;
    constexpr unsigned int IA_DEBUG_REG15__XferId_MASK              = 0x001c0000L;
    constexpr unsigned int IA_DEBUG_REG16__busy_MASK                = 0x00002000L;
    constexpr unsigned int IA_DEBUG_REG16__CLIENT_UTCL1_req0_ready_MASK = 0x40000000L;
    constexpr unsigned int IA_DEBUG_REG16__CLIENT_UTCL1_req0_valid_MASK = 0x80000000L;
    constexpr unsigned int IA_DEBUG_REG16__cpf_ia_invreq_clean_out_MASK = 0x00040000L;
    constexpr unsigned int IA_DEBUG_REG16__cpf_ia_invreq_flushtype_in_MASK = 0x00080000L;
    constexpr unsigned int IA_DEBUG_REG16__cpf_ia_invreq_start_in_MASK = 0x00100000L;
    constexpr unsigned int IA_DEBUG_REG16__IA_UTCL2_inv_ack_MASK    = 0x00200000L;
    constexpr unsigned int IA_DEBUG_REG16__IA_UTCL2_req_free_MASK   = 0x04000000L;
    constexpr unsigned int IA_DEBUG_REG16__IA_UTCL2_req_send_MASK   = 0x08000000L;
    constexpr unsigned int IA_DEBUG_REG16__outstanding_tc_accesses_8_0_MASK = 0x000001ffL;
    constexpr unsigned int IA_DEBUG_REG16__req0_valid_hold1_MASK    = 0x00000400L;
    constexpr unsigned int IA_DEBUG_REG16__req0_valid_hold2_MASK    = 0x00000200L;
    constexpr unsigned int IA_DEBUG_REG16__TC_IA_rdret_valid_MASK   = 0x00020000L;
    constexpr unsigned int IA_DEBUG_REG16__UTCL1_CLIENT_ret0_ready_MASK = 0x10000000L;
    constexpr unsigned int IA_DEBUG_REG16__UTCL1_CLIENT_ret0_valid_MASK = 0x20000000L;
    constexpr unsigned int IA_DEBUG_REG16__utcl2iu_busy_MASK        = 0x00000800L;
    constexpr unsigned int IA_DEBUG_REG16__UTCL2IU_UTCL1_ret_nack_MASK = 0x0000c000L;
    constexpr unsigned int IA_DEBUG_REG16__UTCL2IU_UTCL1_ret_valid_MASK = 0x00010000L;
    constexpr unsigned int IA_DEBUG_REG16__UTCL2_IA_inv_valid_MASK  = 0x00400000L;
    constexpr unsigned int IA_DEBUG_REG16__UTCL2_IA_ret_valid_MASK  = 0x02000000L;
    constexpr unsigned int IA_DEBUG_REG16__UTCL2_IA_ret_xnack_MASK  = 0x01800000L;
    constexpr unsigned int IA_DEBUG_REG16__utcl10_busy_MASK         = 0x00001000L;
    constexpr unsigned int oa_wc0_DEBUG_DATA__credit_cnt_MASK       = 0x00000002L;
    constexpr unsigned int oa_wc0_DEBUG_DATA__req_MASK              = 0x0007ff00L;
    constexpr unsigned int oa_wc0_DEBUG_DATA__Reserved0_MASK        = 0xfff80000L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy0_MASK      = 0x00000800L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy1_MASK      = 0x00001000L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy2_MASK      = 0x00002000L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy3_MASK      = 0x00004000L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy4_MASK      = 0x00008000L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy5_MASK      = 0x00010000L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy6_MASK      = 0x00020000L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy7_MASK      = 0x00040000L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy_MASK       = 0x00000001L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe1_busy_MASK       = 0x00000002L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe2_busy_MASK       = 0x00000004L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe3_busy_MASK       = 0x00000008L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe4_busy_MASK       = 0x00000010L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe5_busy_MASK       = 0x00000020L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe6_busy_MASK       = 0x00000040L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe7_busy_MASK       = 0x00000080L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe8_busy_MASK       = 0x00000100L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe9_busy_MASK       = 0x00000200L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__Pipe10_busy_MASK      = 0x00000400L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__Reserved0_MASK        = 0xfff80000L;
    constexpr unsigned int ord_app_DEBUG_DATA__fifo_busy_MASK       = 0x00000001L;
    constexpr unsigned int ord_app_DEBUG_DATA__ord_busy_MASK        = 0x00000002L;
    constexpr unsigned int ord_app_DEBUG_DATA__Reserved0_MASK       = 0x00000008L;
    constexpr unsigned int ord_app_DEBUG_DATA__Reserved1_MASK       = 0xfffff000L;
    constexpr unsigned int ord_app_DEBUG_DATA__sh0_cmd_fifo_empty_MASK = 0x00000010L;
    constexpr unsigned int ord_app_DEBUG_DATA__sh0_data_fifo_empty_MASK = 0x00000100L;
    constexpr unsigned int ord_app_DEBUG_DATA__sh1_cmd_fifo_empty_MASK = 0x00000020L;
    constexpr unsigned int ord_app_DEBUG_DATA__sh1_data_fifo_empty_MASK = 0x00000200L;
    constexpr unsigned int ord_app_DEBUG_DATA__sh2_cmd_fifo_empty_MASK = 0x00000040L;
    constexpr unsigned int ord_app_DEBUG_DATA__sh2_data_fifo_empty_MASK = 0x00000400L;
    constexpr unsigned int ord_app_DEBUG_DATA__sh3_cmd_fifo_empty_MASK = 0x00000080L;
    constexpr unsigned int ord_app_DEBUG_DATA__sh3_data_fifo_empty_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG00_0__ccgen_to_clipcc_fifo_empty_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG00_0__ccgen_to_clipcc_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG00_0__clipcode_fifo_fifo_empty_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG00_0__clipcode_fifo_full_MASK    = 0x00004000L;
    constexpr unsigned int PA_DEBUG00_0__clip_ga_bc_fifo_write_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG00_0__clip_to_ga_fifo_full_MASK  = 0x00000010L;
    constexpr unsigned int PA_DEBUG00_0__clip_to_ga_fifo_write_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG00_0__clip_to_outsm_fifo_empty_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG00_0__clip_to_outsm_fifo_full_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG00_0__clip_to_outsm_fifo_write_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG00_0__primic_to_clprim_fifo_empty_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG00_0__primic_to_clprim_fifo_full_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG00_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG00_0__su_clip_baryc_free_MASK    = 0x00000006L;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clipp_fifo_empty_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clipp_fifo_full_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clipp_fifo_write_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clips_fifo_empty_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clips_fifo_full_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG00_0__vte_out_clip_fifo_fifo_empty_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG00_0__vte_out_clip_fifo_fifo_full_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG00_0__vte_out_orig_fifo_fifo_empty_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG00_0__vte_out_orig_fifo_fifo_full_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG00_0__vte_out_orig_fifo_fifo_write_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG00_1__available_positions_MASK   = 0x00001fc0L;
    constexpr unsigned int PA_DEBUG00_1__ccgen_to_clipcc_fifo_full_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG00_1__ccgen_to_clipcc_write_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG00_1__current_state_MASK         = 0x00006000L;
    constexpr unsigned int PA_DEBUG00_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG00_1__statevar_bits_vs_out_ccdist0_vec_ena_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG00_1__statevar_bits_vs_out_ccdist1_vec_ena_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG00_1__sx0_receive_fifo_empty_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG00_1__sx0_receive_fifo_full_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG00_1__sx0_receive_fifo_write_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG00_1__vertex_fifo_empty_MASK     = 0x00008000L;
    constexpr unsigned int PA_DEBUG00_1__vertex_fifo_entriesavailable_MASK = 0x0000000fL;
    constexpr unsigned int PA_DEBUG00_1__vertex_fifo_full_MASK      = 0x00010000L;
    constexpr unsigned int PA_DEBUG00_1__vgt_to_ccgen_fifo_empty_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG00_1__vgt_to_ccgen_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG01_0__clip_extra_bc_valid_MASK   = 0x00000007L;
    constexpr unsigned int PA_DEBUG01_0__clip_ga_bc_fifo_write_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG01_0__clip_to_ga_fifo_write_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG01_0__clip_to_outsm_deallocate_slot_MASK = 0x00000e00L;
    constexpr unsigned int PA_DEBUG01_0__clip_to_outsm_null_primitive_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG01_0__clip_to_outsm_vertex_deallocate_MASK = 0x000001c0L;
    constexpr unsigned int PA_DEBUG01_0__clip_vert_vte_valid_MASK   = 0x00000020L;
    constexpr unsigned int PA_DEBUG01_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_fifo_fifo_advanceread_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_fifo_fifo_empty_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_rd_extra_bc_valid_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_rd_vertex_store_indx_MASK = 0x000c0000L;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_rd_vte_naninf_kill_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG01_0__vte_positions_vte_clip_vte_naninf_kill_0_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG01_0__vte_positions_vte_clip_vte_naninf_kill_1_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG01_0__vte_positions_vte_clip_vte_naninf_kill_2_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG01_1__ALWAYS_ZERO_MASK           = 0x000000ffL;
    constexpr unsigned int PA_DEBUG01_1__clip_extra_bc_valid_MASK   = 0x00000700L;
    constexpr unsigned int PA_DEBUG01_1__clip_ga_bc_fifo_write_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG01_1__clip_to_ga_fifo_write_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG01_1__clip_to_outsm_vertex_deallocate_MASK = 0x0000c000L;
    constexpr unsigned int PA_DEBUG01_1__clip_vert_vte_valid_MASK   = 0x00003800L;
    constexpr unsigned int PA_DEBUG01_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_fifo_fifo_advanceread_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_fifo_fifo_empty_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_rd_extra_bc_valid_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_rd_vertex_store_indx_MASK = 0x000c0000L;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_rd_vte_naninf_kill_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG02_0__clip_ga_bc_fifo_full_MASK  = 0x00040000L;
    constexpr unsigned int PA_DEBUG02_0__clip_ga_bc_fifo_write_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_clipga_extra_bc_coords_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_clipga_vte_naninf_kill_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_ga_fifo_full_MASK  = 0x00080000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_ga_fifo_write_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_clipped_prim_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_end_of_packet_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_fifo_advanceread_MASK = 0x40000000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_fifo_empty_MASK = 0x80000000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_first_prim_of_slot_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_null_primitive_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_vertex_store_indx_0_MASK = 0x00000f00L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_vertex_store_indx_1_MASK = 0x000000f0L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_vertex_store_indx_2_MASK = 0x0000000fL;
    constexpr unsigned int PA_DEBUG02_1__clip_extra_bc_valid_MASK   = 0x00000007L;
    constexpr unsigned int PA_DEBUG02_1__clip_ga_bc_fifo_full_MASK  = 0x00040000L;
    constexpr unsigned int PA_DEBUG02_1__clip_ga_bc_fifo_write_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_ga_fifo_full_MASK  = 0x00080000L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_ga_fifo_write_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_clipped_prim_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_clip_seq_indx_MASK = 0x000000c0L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_fifo_advanceread_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_fifo_empty_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_null_primitive_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_vertex_store_indx_1_MASK = 0x0000f000L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_vertex_store_indx_2_MASK = 0x00000f00L;
    constexpr unsigned int PA_DEBUG02_1__clip_vert_vte_valid_MASK   = 0x00000038L;
    constexpr unsigned int PA_DEBUG02_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_clip_code_or_MASK = 0x0000003fL;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_clip_primitive_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_deallocate_slot_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_end_of_packet_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_event_id_MASK = 0x00000fc0L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_first_prim_of_slot_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_state_var_indx_MASK = 0x00007000L;
    constexpr unsigned int PA_DEBUG03_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_clip_code_or_MASK = 0x00003fffL;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_deallocate_slot_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_end_of_packet_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_event_id_MASK = 0x0000c000L;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_first_prim_of_slot_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG03_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_param_cache_indx_0_MASK = 0x00000007L;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_vertex_store_indx_0_MASK = 0x001f8000L;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_vertex_store_indx_1_MASK = 0x00007e00L;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_vertex_store_indx_2_MASK = 0x000001f8L;
    constexpr unsigned int PA_DEBUG04_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_param_cache_indx_0_MASK = 0x000007ffL;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_vertex_store_indx_0_MASK = 0x001f0000L;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_vertex_store_indx_2_MASK = 0x0000f800L;
    constexpr unsigned int PA_DEBUG04_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_clip_code_or_MASK = 0x0000003fL;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_clip_primitive_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_deallocate_slot_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_end_of_packet_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_event_id_MASK = 0x00000fc0L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_first_prim_of_slot_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_state_var_indx_MASK = 0x00007000L;
    constexpr unsigned int PA_DEBUG05_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_clip_code_or_MASK = 0x00003fffL;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_deallocate_slot_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_end_of_packet_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_event_id_MASK = 0x0000c000L;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_first_prim_of_slot_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG05_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_param_cache_indx_0_MASK = 0x00000007L;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_vertex_store_indx_0_MASK = 0x001f8000L;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_vertex_store_indx_1_MASK = 0x00007e00L;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_vertex_store_indx_2_MASK = 0x000001f8L;
    constexpr unsigned int PA_DEBUG06_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_param_cache_indx_0_MASK = 0x000007ffL;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_vertex_store_indx_0_MASK = 0x001f0000L;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_vertex_store_indx_2_MASK = 0x0000f800L;
    constexpr unsigned int PA_DEBUG06_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_clip_code_or_MASK = 0x0000003fL;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_clip_primitive_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_deallocate_slot_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_end_of_packet_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_event_id_MASK = 0x00000fc0L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_first_prim_of_slot_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_state_var_indx_MASK = 0x00007000L;
    constexpr unsigned int PA_DEBUG07_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_clip_code_or_MASK = 0x00003fffL;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_deallocate_slot_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_end_of_packet_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_event_id_MASK = 0x0000c000L;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_first_prim_of_slot_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG07_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_param_cache_indx_0_MASK = 0x00000007L;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_vertex_store_indx_0_MASK = 0x001f8000L;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_vertex_store_indx_1_MASK = 0x00007e00L;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_vertex_store_indx_2_MASK = 0x000001f8L;
    constexpr unsigned int PA_DEBUG08_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_param_cache_indx_0_MASK = 0x000007ffL;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_vertex_store_indx_0_MASK = 0x001f0000L;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_vertex_store_indx_2_MASK = 0x0000f800L;
    constexpr unsigned int PA_DEBUG08_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_clip_code_or_MASK = 0x0000003fL;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_clip_primitive_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_deallocate_slot_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_end_of_packet_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_event_id_MASK = 0x00000fc0L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_first_prim_of_slot_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_state_var_indx_MASK = 0x00007000L;
    constexpr unsigned int PA_DEBUG09_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_clip_code_or_MASK = 0x00003fffL;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_deallocate_slot_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_end_of_packet_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_event_id_MASK = 0x0000c000L;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_first_prim_of_slot_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG09_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_param_cache_indx_0_MASK = 0x00000007L;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_vertex_store_indx_0_MASK = 0x001f8000L;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_vertex_store_indx_1_MASK = 0x00007e00L;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_vertex_store_indx_2_MASK = 0x000001f8L;
    constexpr unsigned int PA_DEBUG10_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_param_cache_indx_0_MASK = 0x000007ffL;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_vertex_store_indx_0_MASK = 0x001f0000L;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_vertex_store_indx_2_MASK = 0x0000f800L;
    constexpr unsigned int PA_DEBUG11_0__clipsm0_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x0000f000L;
    constexpr unsigned int PA_DEBUG11_0__clipsm0_clip_to_clipga_prim_valid_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG11_0__clipsm0_inc_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG11_0__clipsm1_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00000f00L;
    constexpr unsigned int PA_DEBUG11_0__clipsm1_clip_to_clipga_prim_valid_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG11_0__clipsm1_inc_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG11_0__clipsm2_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x000000f0L;
    constexpr unsigned int PA_DEBUG11_0__clipsm2_clip_to_clipga_prim_valid_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG11_0__clipsm2_inc_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG11_0__clipsm3_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x0000000fL;
    constexpr unsigned int PA_DEBUG11_0__clipsm3_clip_to_clipga_prim_valid_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG11_0__clipsm3_inc_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG11_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm0_clip_to_clipga_clip_primitive_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG11_1__clipsm0_clip_to_clipga_event_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG11_1__clipsm0_clip_to_clipga_prim_valid_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm0_inc_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm1_clip_to_clipga_clip_primitive_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG11_1__clipsm1_clip_to_clipga_event_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG11_1__clipsm1_clip_to_clipga_prim_valid_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm1_inc_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_clip_to_clipga_clip_primitive_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x0000f000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_clip_to_clipga_event_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_clip_to_clipga_prim_valid_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_inc_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_clip_to_clipga_clip_primitive_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00000f00L;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_clip_to_clipga_event_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_clip_to_clipga_prim_valid_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_inc_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG11_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG12_0__clipsm0_clprim_to_clip_clip_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG12_0__clipsm0_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG12_0__clipsm1_clprim_to_clip_clip_primitive_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG12_0__clipsm1_clprim_to_clip_prim_valid_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG12_0__clipsm2_clprim_to_clip_clip_primitive_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG12_0__clipsm2_clprim_to_clip_prim_valid_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG12_0__clipsm3_clprim_to_clip_clip_primitive_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG12_0__clipsm3_clprim_to_clip_prim_valid_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_available_clip_verts_MASK = 0x000003e0L;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_available_vte_out_clip_MASK = 0x0000001fL;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_seq_indx_load_MASK = 0x0000c000L;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_seq_indx_out_MASK = 0x00000c00L;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_seq_indx_vert_MASK = 0x00003000L;
    constexpr unsigned int PA_DEBUG12_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG12_1__ALWAYS_ZERO_MASK           = 0x000000ffL;
    constexpr unsigned int PA_DEBUG12_1__clipsm0_clprim_to_clip_clip_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG12_1__clipsm0_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG12_1__clipsm1_clprim_to_clip_clip_primitive_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG12_1__clipsm1_clprim_to_clip_prim_valid_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG12_1__clipsm2_clprim_to_clip_clip_primitive_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG12_1__clipsm2_clprim_to_clip_prim_valid_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG12_1__clipsm3_clprim_to_clip_clip_primitive_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG12_1__clipsm3_clprim_to_clip_prim_valid_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG12_1__clip_priority_available_clip_verts_MASK = 0x0000e000L;
    constexpr unsigned int PA_DEBUG12_1__clip_priority_available_vte_out_clip_MASK = 0x00001f00L;
    constexpr unsigned int PA_DEBUG12_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG13_0__ccgen_to_clipcc_fifo_empty_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG13_0__clipcc_vertex_store_indx_MASK = 0x00000030L;
    constexpr unsigned int PA_DEBUG13_0__clipcode_fifo_fifo_empty_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG13_0__clip_priority_seq_indx_out_cnt_MASK = 0x00001e00L;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_fifo_advanceread_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_fifo_contents_MASK = 0x001f0000L;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_fifo_full_MASK   = 0x00200000L;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_fifo_write_MASK  = 0x00800000L;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_rd_clipsm_wait_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_rd_orig_vertices_MASK = 0x00006000L;
    constexpr unsigned int PA_DEBUG13_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG13_0__vertval_bits_vertex_cc_next_valid_MASK = 0x0000000fL;
    constexpr unsigned int PA_DEBUG13_0__vte_out_orig_fifo_fifo_empty_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG13_1__clipcc_vertex_store_indx_MASK = 0x00003000L;
    constexpr unsigned int PA_DEBUG13_1__clipcode_fifo_fifo_empty_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG13_1__clprim_clip_primitive_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG13_1__clprim_cull_primitive_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG13_1__clprim_in_back_state_var_indx_MASK = 0x00000007L;
    constexpr unsigned int PA_DEBUG13_1__outsm_clr_fifo_advanceread_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG13_1__outsm_clr_fifo_contents_MASK = 0x001f0000L;
    constexpr unsigned int PA_DEBUG13_1__outsm_clr_fifo_full_MASK   = 0x00200000L;
    constexpr unsigned int PA_DEBUG13_1__outsm_clr_fifo_write_MASK  = 0x00800000L;
    constexpr unsigned int PA_DEBUG13_1__point_clip_candidate_MASK  = 0x00000008L;
    constexpr unsigned int PA_DEBUG13_1__prim_back_valid_MASK       = 0x00000080L;
    constexpr unsigned int PA_DEBUG13_1__prim_nan_kill_MASK         = 0x00000010L;
    constexpr unsigned int PA_DEBUG13_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG13_1__vertval_bits_vertex_cc_next_valid_MASK = 0x00000f00L;
    constexpr unsigned int PA_DEBUG13_1__vte_out_orig_fifo_fifo_empty_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_deallocate_slot_MASK = 0x0000e000L;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_end_of_packet_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_event_id_MASK = 0x003f0000L;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_event_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_first_prim_of_slot_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_vertex_store_indx_0_MASK = 0x000003f0L;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_vertex_store_indx_1_MASK = 0x0000000fL;
    constexpr unsigned int PA_DEBUG14_0__outputclprimtoclip_null_primitive_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG14_0__prim_back_valid_MASK       = 0x00800000L;
    constexpr unsigned int PA_DEBUG14_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_event_id_MASK = 0x003f0000L;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_event_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_vertex_store_indx_0_MASK = 0x0000f000L;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_vertex_store_indx_1_MASK = 0x00000fc0L;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_vertex_store_indx_2_MASK = 0x0000003fL;
    constexpr unsigned int PA_DEBUG14_1__prim_back_valid_MASK       = 0x00800000L;
    constexpr unsigned int PA_DEBUG14_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG15_0__primic_to_clprim_fifo_vertex_store_indx_0_MASK = 0x007c0000L;
    constexpr unsigned int PA_DEBUG15_0__primic_to_clprim_fifo_vertex_store_indx_1_MASK = 0x0003e000L;
    constexpr unsigned int PA_DEBUG15_0__primic_to_clprim_fifo_vertex_store_indx_2_MASK = 0x00001f00L;
    constexpr unsigned int PA_DEBUG15_0__primic_to_clprim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG15_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG15_0__vertval_bits_vertex_vertex_store_msb_MASK = 0x000000ffL;
    constexpr unsigned int PA_DEBUG15_1__primic_to_clprim_fifo_vertex_store_indx_0_MASK = 0x007c0000L;
    constexpr unsigned int PA_DEBUG15_1__primic_to_clprim_fifo_vertex_store_indx_1_MASK = 0x00030000L;
    constexpr unsigned int PA_DEBUG15_1__primic_to_clprim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG15_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG15_1__vertval_bits_vertex_vertex_store_msb_MASK = 0x0000ffffL;
    constexpr unsigned int PA_DEBUG16_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG16_0__sm0_clip_to_clipga_clip_to_outsm_cnt_eq0_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG16_0__sm0_clip_to_outsm_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG16_0__sm0_clip_vert_cnt_MASK     = 0x0000001fL;
    constexpr unsigned int PA_DEBUG16_0__sm0_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG16_0__sm0_current_state_MASK     = 0x0007f000L;
    constexpr unsigned int PA_DEBUG16_0__sm0_highest_priority_seq_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG16_0__sm0_inv_to_clip_data_valid_0_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG16_0__sm0_inv_to_clip_data_valid_1_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG16_0__sm0_outputcliptoga_0_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG16_0__sm0_vertex_clip_cnt_MASK   = 0x000003e0L;
    constexpr unsigned int PA_DEBUG16_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG16_1__sm0_clip_to_clipga_clip_to_outsm_cnt_eq0_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG16_1__sm0_clip_to_outsm_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG16_1__sm0_clip_vert_cnt_MASK     = 0x00001f00L;
    constexpr unsigned int PA_DEBUG16_1__sm0_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG16_1__sm0_current_state_MASK     = 0x00070000L;
    constexpr unsigned int PA_DEBUG16_1__sm0_highest_priority_seq_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG16_1__sm0_outputcliptoga_0_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG16_1__sm0_prim_end_state_MASK    = 0x0000007fL;
    constexpr unsigned int PA_DEBUG16_1__sm0_ps_expand_MASK         = 0x00000080L;
    constexpr unsigned int PA_DEBUG16_1__sm0_vertex_clip_cnt_MASK   = 0x0000e000L;
    constexpr unsigned int PA_DEBUG17_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG17_0__sm1_clip_to_clipga_clip_to_outsm_cnt_eq0_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG17_0__sm1_clip_to_outsm_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG17_0__sm1_clip_vert_cnt_MASK     = 0x0000001fL;
    constexpr unsigned int PA_DEBUG17_0__sm1_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG17_0__sm1_current_state_MASK     = 0x0007f000L;
    constexpr unsigned int PA_DEBUG17_0__sm1_highest_priority_seq_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG17_0__sm1_inv_to_clip_data_valid_0_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG17_0__sm1_inv_to_clip_data_valid_1_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG17_0__sm1_outputcliptoga_0_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG17_0__sm1_vertex_clip_cnt_MASK   = 0x000003e0L;
    constexpr unsigned int PA_DEBUG17_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG17_1__sm1_clip_to_clipga_clip_to_outsm_cnt_eq0_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG17_1__sm1_clip_to_outsm_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG17_1__sm1_clip_vert_cnt_MASK     = 0x00001f00L;
    constexpr unsigned int PA_DEBUG17_1__sm1_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG17_1__sm1_current_state_MASK     = 0x00070000L;
    constexpr unsigned int PA_DEBUG17_1__sm1_highest_priority_seq_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG17_1__sm1_outputcliptoga_0_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG17_1__sm1_prim_end_state_MASK    = 0x0000007fL;
    constexpr unsigned int PA_DEBUG17_1__sm1_ps_expand_MASK         = 0x00000080L;
    constexpr unsigned int PA_DEBUG17_1__sm1_vertex_clip_cnt_MASK   = 0x0000e000L;
    constexpr unsigned int PA_DEBUG18_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG18_0__sm2_clip_to_clipga_clip_to_outsm_cnt_eq0_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG18_0__sm2_clip_to_outsm_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG18_0__sm2_clip_vert_cnt_MASK     = 0x0000001fL;
    constexpr unsigned int PA_DEBUG18_0__sm2_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG18_0__sm2_current_state_MASK     = 0x0007f000L;
    constexpr unsigned int PA_DEBUG18_0__sm2_highest_priority_seq_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG18_0__sm2_inv_to_clip_data_valid_0_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG18_0__sm2_inv_to_clip_data_valid_1_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG18_0__sm2_outputcliptoga_0_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG18_0__sm2_vertex_clip_cnt_MASK   = 0x000003e0L;
    constexpr unsigned int PA_DEBUG18_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG18_1__sm2_clip_to_clipga_clip_to_outsm_cnt_eq0_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG18_1__sm2_clip_to_outsm_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG18_1__sm2_clip_vert_cnt_MASK     = 0x00001f00L;
    constexpr unsigned int PA_DEBUG18_1__sm2_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG18_1__sm2_current_state_MASK     = 0x00070000L;
    constexpr unsigned int PA_DEBUG18_1__sm2_highest_priority_seq_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG18_1__sm2_outputcliptoga_0_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG18_1__sm2_prim_end_state_MASK    = 0x0000007fL;
    constexpr unsigned int PA_DEBUG18_1__sm2_ps_expand_MASK         = 0x00000080L;
    constexpr unsigned int PA_DEBUG18_1__sm2_vertex_clip_cnt_MASK   = 0x0000e000L;
    constexpr unsigned int PA_DEBUG19_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG19_0__sm3_clip_to_clipga_clip_to_outsm_cnt_eq0_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG19_0__sm3_clip_to_outsm_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG19_0__sm3_clip_vert_cnt_MASK     = 0x0000001fL;
    constexpr unsigned int PA_DEBUG19_0__sm3_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG19_0__sm3_current_state_MASK     = 0x0007f000L;
    constexpr unsigned int PA_DEBUG19_0__sm3_highest_priority_seq_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG19_0__sm3_inv_to_clip_data_valid_0_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG19_0__sm3_inv_to_clip_data_valid_1_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG19_0__sm3_outputcliptoga_0_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG19_0__sm3_vertex_clip_cnt_MASK   = 0x000003e0L;
    constexpr unsigned int PA_DEBUG19_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG19_1__sm3_clip_to_clipga_clip_to_outsm_cnt_eq0_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG19_1__sm3_clip_to_outsm_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG19_1__sm3_clip_vert_cnt_MASK     = 0x00001f00L;
    constexpr unsigned int PA_DEBUG19_1__sm3_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG19_1__sm3_current_state_MASK     = 0x00070000L;
    constexpr unsigned int PA_DEBUG19_1__sm3_highest_priority_seq_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG19_1__sm3_outputcliptoga_0_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG19_1__sm3_prim_end_state_MASK    = 0x0000007fL;
    constexpr unsigned int PA_DEBUG19_1__sm3_ps_expand_MASK         = 0x00000080L;
    constexpr unsigned int PA_DEBUG19_1__sm3_vertex_clip_cnt_MASK   = 0x0000e000L;
    constexpr unsigned int PA_DEBUG20_0__point_address_MASK         = 0x00000001L;
    constexpr unsigned int PA_DEBUG20_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_advance_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_aux_inc_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_aux_sel_MASK = 0x000c0000L;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_pci_MASK     = 0x0003ff00L;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_req_mask_MASK = 0x000000f0L;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_sp_id_MASK   = 0x00300000L;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_state_var_indx_MASK = 0x0000000eL;
    constexpr unsigned int PA_DEBUG20_1__point_address_MASK         = 0x000001c0L;
    constexpr unsigned int PA_DEBUG20_1__position_address_MASK      = 0x0000003fL;
    constexpr unsigned int PA_DEBUG20_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_advance_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_aux_inc_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_aux_sel_MASK = 0x000c0000L;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_pci_MASK     = 0x00030000L;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_req_mask_MASK = 0x0000f000L;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_sp_id_MASK   = 0x00300000L;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_state_var_indx_MASK = 0x00000e00L;
    constexpr unsigned int PA_DEBUG21_0__aux_sel_MASK               = 0x00003000L;
    constexpr unsigned int PA_DEBUG21_0__pasx_req_cnt_0_MASK        = 0x00f00000L;
    constexpr unsigned int PA_DEBUG21_0__pasx_req_cnt_1_MASK        = 0x000f0000L;
    constexpr unsigned int PA_DEBUG21_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG21_0__statevar_bits_disable_sp_MASK = 0x00000f00L;
    constexpr unsigned int PA_DEBUG21_0__statevar_bits_vs_out_misc_vec_ena_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG21_0__sx_pending_fifo_contents_MASK = 0x0000007cL;
    constexpr unsigned int PA_DEBUG21_0__sx_receive_indx_MASK       = 0x00000003L;
    constexpr unsigned int PA_DEBUG21_0__sx_to_pa_empty_0_MASK      = 0x00008000L;
    constexpr unsigned int PA_DEBUG21_0__sx_to_pa_empty_1_MASK      = 0x00004000L;
    constexpr unsigned int PA_DEBUG21_1__available_positions_MASK   = 0x0000007fL;
    constexpr unsigned int PA_DEBUG21_1__pasx_req_cnt_0_MASK        = 0x00f00000L;
    constexpr unsigned int PA_DEBUG21_1__pasx_req_cnt_1_MASK        = 0x000f0000L;
    constexpr unsigned int PA_DEBUG21_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG21_1__statevar_bits_vs_out_misc_vec_ena_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG21_1__sx_pending_fifo_contents_MASK = 0x00007c00L;
    constexpr unsigned int PA_DEBUG21_1__sx_receive_indx_MASK       = 0x00000380L;
    constexpr unsigned int PA_DEBUG22_0__req_active_verts_loaded_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG22_0__req_active_verts_MASK      = 0x00007f00L;
    constexpr unsigned int PA_DEBUG22_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG22_0__su_aux_MASK                = 0x00000001L;
    constexpr unsigned int PA_DEBUG22_0__sx_request_indx_MASK       = 0x0000007eL;
    constexpr unsigned int PA_DEBUG22_0__vgt_to_ccgen_active_verts_MASK = 0x00fc0000L;
    constexpr unsigned int PA_DEBUG22_0__vgt_to_ccgen_state_var_indx_MASK = 0x00038000L;
    constexpr unsigned int PA_DEBUG22_1__param_cache_base_MASK      = 0x0000007fL;
    constexpr unsigned int PA_DEBUG22_1__req_active_verts_loaded_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG22_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG22_1__su_aux_MASK                = 0x00000180L;
    constexpr unsigned int PA_DEBUG22_1__sx_request_indx_MASK       = 0x00007e00L;
    constexpr unsigned int PA_DEBUG22_1__vgt_to_ccgen_active_verts_MASK = 0x00fc0000L;
    constexpr unsigned int PA_DEBUG22_1__vgt_to_ccgen_state_var_indx_MASK = 0x00030000L;
    constexpr unsigned int PA_DEBUG23_0__ALWAYS_ZERO_MASK           = 0x000000c0L;
    constexpr unsigned int PA_DEBUG23_0__event_id_gated_1to0_MASK   = 0x00c00000L;
    constexpr unsigned int PA_DEBUG23_0__geom_busy_MASK             = 0x00200000L;
    constexpr unsigned int PA_DEBUG23_0__geom_enable_MASK           = 0x00008000L;
    constexpr unsigned int PA_DEBUG23_0__ge_stallb_MASK             = 0x00004000L;
    constexpr unsigned int PA_DEBUG23_0__pfifo_busy_MASK            = 0x00080000L;
    constexpr unsigned int PA_DEBUG23_0__pmode_state_MASK           = 0x00003f00L;
    constexpr unsigned int PA_DEBUG23_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG23_0__su_baryc_cntl_state_MASK   = 0x00000003L;
    constexpr unsigned int PA_DEBUG23_0__su_clip_baryc_free_MASK    = 0x00030000L;
    constexpr unsigned int PA_DEBUG23_0__su_clip_rtr_MASK           = 0x00040000L;
    constexpr unsigned int PA_DEBUG23_0__su_cntl_busy_MASK          = 0x00100000L;
    constexpr unsigned int PA_DEBUG23_0__su_cntl_state_MASK         = 0x0000003cL;
    constexpr unsigned int PA_DEBUG24_0__cl_dyn_sclk_vld_MASK       = 0x00000080L;
    constexpr unsigned int PA_DEBUG24_0__event_gated_MASK           = 0x00000010L;
    constexpr unsigned int PA_DEBUG24_0__event_id_gated_5to2_MASK   = 0x0000000fL;
    constexpr unsigned int PA_DEBUG24_0__pmode_prim_gated_MASK      = 0x00000020L;
    constexpr unsigned int PA_DEBUG24_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG24_0__su_dyn_sclk_vld_MASK       = 0x00000040L;
    constexpr unsigned int PA_DEBUG24_0__y_sort0_gated_23_8_MASK    = 0x00ffff00L;
    constexpr unsigned int PA_DEBUG25_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG25_0__x_sort0_gated_23_8_MASK    = 0x0000ffffL;
    constexpr unsigned int PA_DEBUG25_0__y_sort1_gated_15_8_MASK    = 0x00ff0000L;
    constexpr unsigned int PA_DEBUG26_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG26_0__x_sort1_gated_23_8_MASK    = 0x00ffff00L;
    constexpr unsigned int PA_DEBUG26_0__y_sort1_gated_23_16_MASK   = 0x000000ffL;
    constexpr unsigned int PA_DEBUG27_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG27_0__x_sort2_gated_15_8_MASK    = 0x00ff0000L;
    constexpr unsigned int PA_DEBUG27_0__y_sort2_gated_23_8_MASK    = 0x0000ffffL;
    constexpr unsigned int PA_DEBUG28_0__attr_indx_sort0_gated_MASK = 0x003fff00L;
    constexpr unsigned int PA_DEBUG28_0__backfacing_gated_MASK      = 0x00800000L;
    constexpr unsigned int PA_DEBUG28_0__null_prim_gated_MASK       = 0x00400000L;
    constexpr unsigned int PA_DEBUG28_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG28_0__x_sort2_gated_23to16_MASK  = 0x000000ffL;
    constexpr unsigned int PA_DEBUG29_0__attr_indx_sort2_gated_7to0_MASK = 0x00ff0000L;
    constexpr unsigned int PA_DEBUG29_0__clipped_gated_MASK         = 0x00000008L;
    constexpr unsigned int PA_DEBUG29_0__dealloc_slot_gated_MASK    = 0x00000070L;
    constexpr unsigned int PA_DEBUG29_0__diamond_rule_gated_MASK    = 0x00000300L;
    constexpr unsigned int PA_DEBUG29_0__eop_gated_MASK             = 0x00008000L;
    constexpr unsigned int PA_DEBUG29_0__fpov_gated_MASK            = 0x00006000L;
    constexpr unsigned int PA_DEBUG29_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG29_0__st_indx_gated_MASK         = 0x00000007L;
    constexpr unsigned int PA_DEBUG29_0__type_gated_MASK            = 0x00001c00L;
    constexpr unsigned int PA_DEBUG29_0__xmajor_gated_MASK          = 0x00000080L;
    constexpr unsigned int PA_DEBUG30_0__attr_indx_sort1_gated_MASK = 0x000fffc0L;
    constexpr unsigned int PA_DEBUG30_0__attr_indx_sort2_gated_13to8_MASK = 0x0000003fL;
    constexpr unsigned int PA_DEBUG30_0__pa_reg_sclk_vld_MASK       = 0x00800000L;
    constexpr unsigned int PA_DEBUG30_0__provoking_vtx_gated_MASK   = 0x00300000L;
    constexpr unsigned int PA_DEBUG30_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG30_0__valid_prim_gated_MASK      = 0x00400000L;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm0_clprim_to_clip_prim_valid_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm1_clprim_to_clip_prim_valid_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm2_clprim_to_clip_prim_valid_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm3_clprim_to_clip_prim_valid_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm_clip_to_outsm_fifo_write_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_outsm_clr_fifo_not_empty_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_primic_to_clprim_valid_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_MASK          = 0x00000100L;
    constexpr unsigned int PA_DEBUG31_0__PA0_SC0_send_q_MASK        = 0x00000008L;
    constexpr unsigned int PA_DEBUG31_0__PA0_SC1_send_q_MASK        = 0x00000010L;
    constexpr unsigned int PA_DEBUG31_0__PA_PA_pascDataOut_send0_q_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG31_0__PA_PA_pascDataOut_send1_q_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG31_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_geom_busy_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_hold_busy_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_pfifo_busy_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_su_cntl_busy_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_valid_prim_gated_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG31_0__su_busy_MASK               = 0x00000200L;
    constexpr unsigned int PA_DEBUG31_0__VGT_PA_clipp_send_q_MASK   = 0x00000004L;
    constexpr unsigned int PA_DEBUG31_0__VGT_PA_clips_send_q_MASK   = 0x00000002L;
    constexpr unsigned int PA_DEBUG31_0__VGT_PA_clipv_send_q_MASK   = 0x00000001L;
    constexpr unsigned int PA_DEBUG31_0__vte_busy_debug_ib_busy_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG31_0__vte_busy_debug_veu_busy_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG31_0__vte_busy_MASK              = 0x00000080L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_ccgen_to_clipcc_fifo_busy_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_ccgen_to_clipcc_fifo_write_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipcode_fifo_fifo_busy_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipcode_fifo_fifo_write_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipsm0_current_state_not_empty_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipsm1_current_state_not_empty_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipsm2_current_state_not_empty_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipsm3_current_state_not_empty_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clip_to_ga_bc_busy_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clip_to_ga_fifo_write_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clip_to_outsm_fifo_busy_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clip_to_outsm_fifo_write_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_next_prim_back_valid_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_primic_to_clprim_fifo_not_empty_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_primic_to_clprim_fifo_write_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_prim_back_valid_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_sx_pending_fifo_not_empty_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vgt_to_clipp_fifo_busy_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vgt_to_clipp_fifo_write_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vgt_to_clips_fifo_busy_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vte_out_clip_fifo_fifo_busy_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vte_out_clip_fifo_fifo_write_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vte_out_orig_fifo_fifo_busy_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vte_out_orig_fifo_fifo_write_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG32_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG33_0__clipper_busy_debug_vgt_to_clips_fifo_write_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG33_0__PA_SE3SC_freeze_MASK       = 0x00000010L;
    constexpr unsigned int PA_DEBUG33_0__Reserved0_MASK             = 0xffffffe0L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_busy_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_rtr_in_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_rtr_out_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_rts_in_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_rts_out_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_iclient_send_valid_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_iutcl1_send_ready_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_oclient_send_ready_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_outcl1_send_type_MASK = 0x00600000L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_outcl1_send_valid_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_outcl1_send_vmid_MASK = 0x001e0000L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_tag_MASK = 0x000000ffL;
    constexpr unsigned int PA_DEBUG34_0__Reserved0_MASK             = 0xff800000L;
    constexpr unsigned int PA_DEBUG34_1__ngg_utcl1_debug00_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_busy_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_empty_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_full_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_read_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_write_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_iclient_send_valid_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_iutcl1_send_ready_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_oclient_send_ready_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_outcl1_send_type_MASK = 0x00600000L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_outcl1_send_valid_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_outcl1_send_vmid_MASK = 0x001e0000L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_tag_MASK = 0x000000ffL;
    constexpr unsigned int PA_DEBUG35_0__Reserved0_MASK             = 0xff800000L;
    constexpr unsigned int PA_DEBUG35_1__ngg_utcl1_debug01_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_busy_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_empty_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_full_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_read_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_write_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_iclient_send_valid_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_iutcl1_send_ready_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_oclient_send_ready_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_outcl1_send_type_MASK = 0x00600000L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_outcl1_send_valid_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_outcl1_send_vmid_MASK = 0x001e0000L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_tag_MASK = 0x000000ffL;
    constexpr unsigned int PA_DEBUG36_0__Reserved0_MASK             = 0xff800000L;
    constexpr unsigned int PA_DEBUG36_1__ngg_utcl1_debug02_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_busy_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_drop_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_io_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_mtype_MASK = 0x00003800L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_perf_cntr_en_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_rd_tmz_encr_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_snoop_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_space_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_tag_MASK = 0x03fc0000L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_vmid_MASK = 0x0003c000L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_rtr_in_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_rtr_out_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_rts_in_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_rts_out_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG37_0__Reserved0_MASK             = 0xfc000000L;
    constexpr unsigned int PA_DEBUG37_1__ngg_utcl1_debug03_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_busy_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_drop_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_io_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_mtype_MASK = 0x00003800L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_perf_cntr_en_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_rd_tmz_encr_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_snoop_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_space_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_tag_MASK = 0x03fc0000L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_vmid_MASK = 0x0003c000L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_rtr_in_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_rtr_out_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_rts_in_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_rts_out_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG38_0__Reserved0_MASK             = 0xfc000000L;
    constexpr unsigned int PA_DEBUG38_1__ngg_utcl1_debug04_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_busy_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_drop_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_io_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_mtype_MASK = 0x00003800L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_perf_cntr_en_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_rd_tmz_encr_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_snoop_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_space_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_tag_MASK = 0x03fc0000L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_vmid_MASK = 0x0003c000L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_rtr_in_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_rtr_out_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_rts_in_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_rts_out_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG39_0__Reserved0_MASK             = 0xfc000000L;
    constexpr unsigned int PA_DEBUG39_1__ngg_utcl1_debug05_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG40_0__ngg_debug_tc_request_arbiter_current_client_count_MASK = 0x00000003L;
    constexpr unsigned int PA_DEBUG40_0__ngg_debug_tc_request_arbiter_istream0_client_rts_MASK = 0x80000000L;
    constexpr unsigned int PA_DEBUG40_0__ngg_debug_tc_request_arbiter_istream0_client_tag_MASK = 0x3fc00000L;
    constexpr unsigned int PA_DEBUG40_0__ngg_debug_tc_request_arbiter_ostream0_client_rtr_MASK = 0x40000000L;
    constexpr unsigned int PA_DEBUG40_1__ngg_utcl1_debug06_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_credits_MASK = 0x0000007cL;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_credit_count_overflow_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_credit_count_underflow_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_data_rd_ptr_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_data_wr_ptr_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_irdreq_free_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_irdret_vld_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_irts_in_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_obusy_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_ooutstanding_tc_requests_exist_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_ordreq_clken_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_ordreq_send_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_ortr_in_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_outstanding_tc_requests_MASK = 0x1ff80000L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_reg_valid0_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_reg_valid1_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG41_0__Reserved0_MASK             = 0xe0000000L;
    constexpr unsigned int PA_DEBUG41_1__ngg_utcl1_debug07_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_current_dword_pointer_MASK = 0x00000f00L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_current_sideband_event_bit_set_MASK = 0x01000000L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_current_sideband_is_object_id_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_current_state_MASK = 0x00000038L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_have_available_sideband_tokens_MASK = 0x02000000L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_itc_return_empty_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_pending_subgroup_count_not_zero_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_pending_subgroup_count_range_MASK = 0x0001f000L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_sideband_tokens_not_max_value_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_sideband_tokens_overflow_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_sideband_tokens_underflow_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_valid_dword_count_MASK = 0x003e0000L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_wait_counter_busy_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG42_0__Reserved0_MASK             = 0xfc000000L;
    constexpr unsigned int PA_DEBUG42_1__ngg_utcl1_debug08_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_current_state_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_osideband_active_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_ovmid_MASK = 0x0000000fL;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_sideband_pop_bit_fifo_busy_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_sideband_pop_bit_fifo_empty_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_sideband_pop_bit_fifo_full_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_vmid_fifo_busy_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_vmid_fifo_empty_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_vmid_fifo_full_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG43_0__Reserved0_MASK             = 0xfffff000L;
    constexpr unsigned int PA_DEBUG43_1__ngg_utcl1_debug09_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents0_MASK = 0x00000ff0L;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents0_overflow_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents0_underflow_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents1_MASK = 0x000ff000L;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents1_overflow_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents1_underflow_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG44_0__Reserved0_MASK             = 0xfff00000L;
    constexpr unsigned int PA_DEBUG44_1__ngg_utcl1_debug10_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_current_fetch_state_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_current_receive_finalt_dword_pointer_MASK = 0x07800000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_current_receive_first_dword_pointer_MASK = 0x00780000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_current_receive_state_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_final_receive_cacheline_this_subgroup_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_final_receive_dword_of_subgroup_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_have_available_index_tokens_MASK = 0x20000000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_receive_fifo_busy_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_receive_fifo_empty_MASK = 0x08000000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_receive_fifo_full_MASK = 0x10000000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_tokens_MASK = 0x000000fcL;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_tokens_overflow_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_tokens_underflow_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_prim_indices_fifo_busy_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_sideband_data_context_id_bits_MASK = 0x00007000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_sideband_data_eop_bit_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_sideband_data_event_bit_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG45_0__Reserved0_MASK             = 0xc0000000L;
    constexpr unsigned int PA_DEBUG45_1__ngg_utcl1_debug11_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_active_pos_req_fosg_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_another_pos_fetch_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_current_state_MASK = 0x00018000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_end_prev_diff_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_end_start_diff_MASK = 0x02000000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_have_available_position_tokens_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_ifetch_to_primic_p_fifo_full_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_ifetch_to_primic_s_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_ipa_to_wd_dealloc_index_full_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_iposreq_to_posrtn_s_fifo_full_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_iposreq_to_posrtn_v_fifo_full_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_packer_object_id_valid_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_packer_sideband_valid_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_position_tokens_overflow_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_position_tokens_underflow_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_prev_pos_cacheline_valid_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_prev_select_end_cacheline_address_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_busy_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_final_prim_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_first_prim_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_miss_count_MASK = 0x00000180L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_null_prim_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_prim_valid_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_start_prev_diff_MASK = 0x01000000L;
    constexpr unsigned int PA_DEBUG46_0__Reserved0_MASK             = 0xfc000000L;
    constexpr unsigned int PA_DEBUG46_1__ngg_utcl1_debug12_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_current_state_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_iinput_sideband_valid_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_eop_bit_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_event_bit_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_event_id_MASK = 0x0001f800L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_event_second_cycle_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_state_id_MASK = 0x00380000L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_stream_id_MASK = 0x00000300L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_output_prim_empty_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_prim_fifo_busy_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_prim_fifo_full_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_sideband_fifo_busy_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_sideband_fifo_empty_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_sideband_fifo_full_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG47_0__Reserved0_MASK             = 0xffc00000L;
    constexpr unsigned int PA_DEBUG47_1__ngg_utcl1_debug13_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_active_pos_return_cache_pos_index_MASK = 0x0000c000L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_active_pos_return_first_vert_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_active_pos_return_state_MASK = 0x00000600L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_cache_pos_index_MASK = 0x00001800L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_ifetch_to_sxif_fifo_full_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_ipa_to_wd_dealloc_position_full_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_itc_return_empty_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_oposreq_to_posrtn_s_fifo_full_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_oposreq_to_posrtn_v_fifo_full_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_posreq_to_posrtn_s_fifo_busy_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_posreq_to_posrtn_s_fifo_empty_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_posreq_to_posrtn_v_fifo_busy_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_posreq_to_posrtn_v_fifo_empty_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG48_0__Reserved0_MASK             = 0xffff0000L;
    constexpr unsigned int PA_DEBUG48_1__ngg_utcl1_debug14_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_crawler_busy_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_memreg0_busy_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_memreg1_busy_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_memreg2_busy_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_oreturn_empty_stream0_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_oreturn_empty_stream1_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_oreturn_empty_stream2_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_return_data_read_reg_full_stream0_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_return_data_read_reg_full_stream1_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_return_data_read_reg_full_stream2_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG49_0__Reserved0_MASK             = 0xfffffc00L;
    constexpr unsigned int PA_DEBUG49_1__ngg_utcl1_debug15_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_encountered_error_writing_to_busy_location_stream0_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_encountered_error_writing_to_busy_location_stream1_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_encountered_error_writing_to_busy_location_stream2_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_memory_data_valid_stream0_count_MASK = 0x000001f8L;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_memory_data_valid_stream1_count_MASK = 0x00007e00L;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_memory_data_valid_stream2_count_MASK = 0x007f8000L;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_obusy_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG50_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG50_1__ngg_utcl1_debug16_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_amount_MASK = 0x0000ffe0L;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_fifo_busy_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_index_full_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_position_full_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_state_var_index_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_type_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_pa_to_wd_dealloc_fifo_empty_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_pa_to_wd_dealloc_fifo_read_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG51_0__Reserved0_MASK             = 0xfff00000L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_all_clean_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_current_state_MASK = 0x000e0000L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iindex_requester_idle_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iindex_utcl1_return_busy_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iindex_utcl1_send_busy_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_ioutstanding_tc_requests_exist_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iposition_requester_idle_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iposition_utcl1_return_busy_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iposition_utcl1_send_busy_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_isideband_requester_idle_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_isideband_utcl1_return_busy_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_isideband_utcl1_send_busy_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iutcl1_busy_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_oclean_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_vmid_count_MASK = 0x0000f000L;
    constexpr unsigned int PA_DEBUG52_0__Reserved0_MASK             = 0xfff00000L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_index_tokens_overflow_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_index_tokens_underflow_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_position_tokens_overflow_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_position_tokens_underflow_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sbmem_contents0_overflow_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sbmem_contents0_underflow_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sbmem_contents1_overflow_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sbmem_contents1_underflow_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sideband_tokens_overflow_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sideband_tokens_underflow_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_tc_credit_count_overflow_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_tc_credit_count_underflow_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_writing_to_busy_location_stream0_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_writing_to_busy_location_stream1_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_writing_to_busy_location_stream2_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG53_0__Reserved0_MASK             = 0xffff8000L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_index_receive_fifo_full_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_pa_to_wd_dealloc_index_full_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_pa_to_wd_dealloc_position_full_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_posreq_to_posrtn_s_fifo_full_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_posreq_to_posrtn_v_fifo_full_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_prim_fifo_full_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_prim_indices_fifo_full_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_return_data_full_stream0_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_return_data_full_stream1_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_return_data_full_stream2_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_sbmem_full_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_sideband_fifo_full_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_sideband_pop_bit_fifo_full_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_vmid_fifo_full_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG54_0__Reserved0_MASK             = 0xffffc000L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_index_receive_fifo_empty_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_pa_to_wd_dealloc_fifo_empty_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_posreq_to_posrtn_s_fifo_empty_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_posreq_to_posrtn_v_fifo_empty_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_prim_fifo_empty_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_prim_indices_fifo_empty_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_return_data_empty_stream0_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_return_data_empty_stream1_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_return_data_empty_stream2_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_sbmem_empty_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_sideband_fifo_empty_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_sideband_pop_bit_fifo_empty_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_vmid_fifo_empty_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG55_0__Reserved0_MASK             = 0xffffe000L;
    constexpr unsigned int PWR_OVERRIDE__VDDCR_CPU_OVERRIDE_MASK    = 0x00000001L;
    constexpr unsigned int rbuf_DEBUG_DATA__pixel_addr_mask_MASK    = 0x0001fffcL;
    constexpr unsigned int rbuf_DEBUG_DATA__Reserved0_MASK          = 0xff000000L;
    constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_ADDR__addr_MASK    = 0x000000ffL;
    constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_ADDR__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__RESERVED_MASK        = 0xfffffc00L;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeAccumDoneInt_MASK = 0x00000010L;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeResetAccum_MASK = 0x00000020L;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeSpmDoneInt_MASK = 0x00000008L;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeStartSpm_MASK  = 0x000003c0L;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__AutoAccumEn_MASK     = 0x00000002L;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__AutoResetPerfmonDisable_MASK = 0x00000020L;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__AutoSpmEn_MASK       = 0x00000004L;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__Globals_LoadOverride_MASK = 0x00000008L;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__RESERVED_MASK        = 0xffffffc0L;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__SE0_LoadOverride_MASK = 0x00000010L;
    constexpr unsigned int RLC_SPM_ACCUM_SAMPLES_REQUESTED__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__RESERVED_MASK      = 0xffff0000L;
    constexpr unsigned int RLC_SPM_ACCUM_THRESHOLD__RESERVED_MASK   = 0xffff0000L;
    constexpr unsigned int RPB_ATS_CNTL2__INVAL_COM_ROUTING_CODE_MASK = 0x00038000L;
    constexpr unsigned int RPB_ATS_CNTL2__PAGE_REQ_CMD_MASK         = 0x00000fc0L;
    constexpr unsigned int RPB_ATS_CNTL2__PAGE_ROUTING_CODE_MASK    = 0x00007000L;
    constexpr unsigned int RPB_ATS_CNTL2__TRANS_CMD_MASK            = 0x0000003fL;
    constexpr unsigned int RPB_ATS_CNTL2__VENDOR_ID_MASK            = 0x000c0000L;
    constexpr unsigned int RPB_ATS_CNTL__ATCTR_SWITCH_NUM_MASK      = 0x00078000L;
    constexpr unsigned int RPB_ATS_CNTL__INVAL_COM_CMD_MASK         = 0x7e000000L;
    constexpr unsigned int RPB_BIF_CNTL__ARB_MODE_MASK              = 0x00010000L;
    constexpr unsigned int RPB_BIF_CNTL__DRAIN_VC_NUM_MASK          = 0x00020000L;
    constexpr unsigned int RPB_BIF_CNTL__PAGE_PRI_EN_MASK           = 0x08000000L;
    constexpr unsigned int RPB_BIF_CNTL__PARITY_CHECK_EN_MASK       = 0x40000000L;
    constexpr unsigned int RPB_BIF_CNTL__SWITCH_ENABLE_MASK         = 0x00040000L;
    constexpr unsigned int RPB_BIF_CNTL__SWITCH_THRESHOLD_MASK      = 0x07f80000L;
    constexpr unsigned int RPB_BIF_CNTL__TR_PRI_EN_MASK             = 0x10000000L;
    constexpr unsigned int RPB_BIF_CNTL__VC0_CHAINED_OVERRIDE_MASK  = 0x20000000L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATC_INV_BLOCKLEVEL_MASK = 0x000000c0L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATC_PAGE_BLOCKLEVEL_MASK = 0x00000030L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATC_TR_BLOCKLEVEL_MASK = 0x0000000cL;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATOMIC_BLOCKLEVEL_OVERRIDE_EN_MASK = 0x00020000L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATOMIC_BLOCKLEVEL_OVERRIDE_MASK = 0x00003000L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_RD_BLOCKLEVEL_OVERRIDE_EN_MASK = 0x00010000L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_RD_BLOCKLEVEL_OVERRIDE_MASK = 0x00000c00L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_WR_BLOCKLEVEL_OVERRIDE_EN_MASK = 0x00008000L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_WR_BLOCKLEVEL_OVERRIDE_MASK = 0x00000300L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__XPB_BLOCKLEVEL_OVERRIDE_EN_MASK = 0x00004000L;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_PAGE_PASSPW_OVERRIDE_EN_MASK = 0x00001000L;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_PAGE_PASSPW_OVERRIDE_MASK = 0x00000008L;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_RSPPASSPW_OVERRIDE_EN_MASK = 0x00002000L;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_RSPPASSPW_OVERRIDE_MASK = 0x00000100L;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_TR_PASSPW_OVERRIDE_EN_MASK = 0x00000800L;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_TR_PASSPW_OVERRIDE_MASK = 0x00000004L;
    constexpr unsigned int RPB_PASSPW_CONF__ATOMIC_PASSPW_OVERRIDE_MASK = 0x00000200L;
    constexpr unsigned int RPB_PASSPW_CONF__ATOMIC_RSPPASSPW_OVERRIDE_MASK = 0x00000400L;
    constexpr unsigned int RPB_PASSPW_CONF__RDRSP_PASSPW_OVERRIDE_EN_MASK = 0x00020000L;
    constexpr unsigned int RPB_PASSPW_CONF__RDRSP_PASSPW_OVERRIDE_MASK = 0x00010000L;
    constexpr unsigned int RPB_PASSPW_CONF__RD_PASSPW_OVERRIDE_MASK = 0x00000020L;
    constexpr unsigned int RPB_PASSPW_CONF__RD_RSPPASSPW_OVERRIDE_MASK = 0x00000080L;
    constexpr unsigned int RPB_PASSPW_CONF__WRRSP_PASSPW_OVERRIDE_EN_MASK = 0x00008000L;
    constexpr unsigned int RPB_PASSPW_CONF__WRRSP_PASSPW_OVERRIDE_MASK = 0x00004000L;
    constexpr unsigned int RPB_PASSPW_CONF__WR_PASSPW_OVERRIDE_MASK = 0x00000010L;
    constexpr unsigned int RPB_PASSPW_CONF__WR_RSPPASSPW_OVERRIDE_MASK = 0x00000040L;
    constexpr unsigned int RPB_TAG_CONF__RPB_ATS_PR_MASK            = 0x00ff0000L;
    constexpr unsigned int RPB_TAG_CONF__RPB_ATS_TR_MASK            = 0x000000ffL;
    constexpr unsigned int RPB_TAG_CONF__RPB_IO_WR_MASK             = 0x0000ff00L;
    constexpr unsigned int SQ_CONFIG__UNUSED_MASK                   = 0x0000007fL;
    constexpr unsigned int VGT_DEBUG_REG0__frmt_pg_busy_MASK        = 0x00040000L;
    constexpr unsigned int VGT_DEBUG_REG0__RESERVED0_MASK           = 0x00000002L;
    constexpr unsigned int VGT_DEBUG_REG0__RESERVED1_MASK           = 0x000000f8L;
    constexpr unsigned int VGT_DEBUG_REG0__RESERVED2_MASK           = 0x00100000L;
    constexpr unsigned int VGT_DEBUG_REG0__RESERVED3_MASK           = 0x80000000L;
    constexpr unsigned int VGT_DEBUG_REG0__sclk_tell_vid_MASK       = 0x10000000L;
    constexpr unsigned int VGT_DEBUG_REG0__tell_clk_busy_MASK       = 0x02000000L;
    constexpr unsigned int VGT_DEBUG_REG1__RESERVED0_MASK           = 0x000003ffL;
    constexpr unsigned int VGT_DEBUG_REG1__RESERVED1_MASK           = 0x0000c000L;
    constexpr unsigned int VGT_DEBUG_REG1__RESERVED2_MASK           = 0x00020000L;
    constexpr unsigned int VGT_DEBUG_REG1__RESERVED3_MASK           = 0x00080000L;
    constexpr unsigned int VGT_DEBUG_REG1__RESERVED4_MASK           = 0x00200000L;
    constexpr unsigned int VGT_DEBUG_REG1__RESERVED5_MASK           = 0x00800000L;
    constexpr unsigned int VGT_DEBUG_REG1__RESERVED6_MASK           = 0x02000000L;
    constexpr unsigned int VGT_DEBUG_REG2__grpModBusy_q_MASK        = 0x00000080L;
    constexpr unsigned int VGT_DEBUG_REG2__hsTgFifoEmpty_MASK       = 0x00000800L;
    constexpr unsigned int VGT_DEBUG_REG2__hsTgFifoFull_MASK        = 0x00020000L;
    constexpr unsigned int VGT_DEBUG_REG2__hs_busy_q_MASK           = 0x00000001L;
    constexpr unsigned int VGT_DEBUG_REG2__hs_noif_busy_q_MASK      = 0x00000002L;
    constexpr unsigned int VGT_DEBUG_REG2__int_VGT_WD_packet_send_q_MASK = 0x00000040L;
    constexpr unsigned int VGT_DEBUG_REG2__lsVertIfBusy_0_q_MASK    = 0x00000008L;
    constexpr unsigned int VGT_DEBUG_REG2__not_VGT_WD_thdgrp_rtr_MASK = 0x00080000L;
    constexpr unsigned int VGT_DEBUG_REG2__RESERVED0_MASK           = 0x00000030L;
    constexpr unsigned int VGT_DEBUG_REG2__RESERVED1_MASK           = 0x00000200L;
    constexpr unsigned int VGT_DEBUG_REG2__RESERVED2_MASK           = 0x00002000L;
    constexpr unsigned int VGT_DEBUG_REG2__RESERVED3_MASK           = 0x00008000L;
    constexpr unsigned int VGT_DEBUG_REG2__RESERVED4_MASK           = 0xf8000000L;
    constexpr unsigned int VGT_DEBUG_REG2__tfmmIsBusy_q_MASK        = 0x00000004L;
    constexpr unsigned int VGT_DEBUG_REG4__hsTgSendFlush_MASK       = 0x20000000L;
    constexpr unsigned int VGT_DEBUG_REG4__RESERVED0_MASK           = 0x80000000L;
    constexpr unsigned int VGT_DEBUG_REG5__hsTgCreditCnt_0_MASK     = 0x000000f8L;
    constexpr unsigned int VGT_DEBUG_REG5__RESERVED0_MASK           = 0x00000007L;
    constexpr unsigned int VGT_DEBUG_REG5__RESERVED1_MASK           = 0x00000300L;
    constexpr unsigned int VGT_DEBUG_REG5__RESERVED2_MASK           = 0x00070000L;
    constexpr unsigned int VGT_DEBUG_REG5__RESERVED3_MASK           = 0x00f80000L;
    constexpr unsigned int VGT_DEBUG_REG5__RESERVED4_MASK           = 0x03000000L;
    constexpr unsigned int VGT_DEBUG_REG7__RESERVED0_MASK           = 0x0000ffe0L;
    constexpr unsigned int VGT_DEBUG_REG9__RESERVED0_MASK           = 0x00000780L;
    constexpr unsigned int VGT_DEBUG_REG9__RESERVED1_MASK           = 0x00800000L;
    constexpr unsigned int VGT_DEBUG_REG9__RESERVED2_MASK           = 0x06000000L;
    constexpr unsigned int VGT_DEBUG_REG9__RESERVED3_MASK           = 0x40000000L;
    constexpr unsigned int VGT_DEBUG_REG9__RESERVED4_MASK           = 0x80000000L;
    constexpr unsigned int VGT_DEBUG_REG10__num_es_waves_r3_MASK    = 0x0e000000L;
    constexpr unsigned int VGT_DEBUG_REG10__num_gs_waves_r3_MASK    = 0x01800000L;
    constexpr unsigned int VGT_DEBUG_REG10__RESERVED0_MASK          = 0x00001e00L;
    constexpr unsigned int VGT_DEBUG_REG10__RESERVED1_MASK          = 0xf0000000L;
    constexpr unsigned int VGT_DEBUG_REG11__RESERVED0_MASK          = 0x00000008L;
    constexpr unsigned int VGT_DEBUG_REG11__RESERVED1_MASK          = 0x00000020L;
    constexpr unsigned int VGT_DEBUG_REG11__RESERVED2_MASK          = 0x00000380L;
    constexpr unsigned int VGT_DEBUG_REG11__RESERVED3_MASK          = 0x00008000L;
    constexpr unsigned int VGT_DEBUG_REG11__RESERVED4_MASK          = 0x00040000L;
    constexpr unsigned int VGT_DEBUG_REG11__RESERVED5_MASK          = 0x00100000L;
    constexpr unsigned int VGT_DEBUG_REG11__RESERVED6_MASK          = 0x01000000L;
    constexpr unsigned int VGT_DEBUG_REG11__RESERVED7_MASK          = 0x08000000L;
    constexpr unsigned int VGT_DEBUG_REG11__RESERVED8_MASK          = 0x40000000L;
    constexpr unsigned int VGT_DEBUG_REG11__VGT_SPI_gssubgrp_rtr_MASK = 0x00004000L;
    constexpr unsigned int VGT_DEBUG_REG12__RESERVED0_MASK          = 0x40000000L;
    constexpr unsigned int VGT_DEBUG_REG12__RESERVED1_MASK          = 0x80000000L;
    constexpr unsigned int VGT_DEBUG_REG13__RESERVED0_MASK          = 0x01000000L;
    constexpr unsigned int VGT_DEBUG_REG13__RESERVED1_MASK          = 0x02000000L;
    constexpr unsigned int VGT_DEBUG_REG13__RESERVED2_MASK          = 0x04000000L;
    constexpr unsigned int VGT_DEBUG_REG14__RESERVED0_MASK          = 0x0000000fL;
    constexpr unsigned int VGT_DEBUG_REG14__RESERVED1_MASK          = 0x000001c0L;
    constexpr unsigned int VGT_DEBUG_REG14__RESERVED2_MASK          = 0x00000400L;
    constexpr unsigned int VGT_DEBUG_REG14__RESERVED3_MASK          = 0xfffff000L;
    constexpr unsigned int VGT_DEBUG_REG15__active_sm_q_4_0_MASK    = 0x000003e0L;
    constexpr unsigned int VGT_DEBUG_REG15__cntr_tbl_wrptr_q_4_0_MASK = 0x000f8000L;
    constexpr unsigned int VGT_DEBUG_REG15__entry_rdptr_q_4_0_MASK  = 0x00007c00L;
    constexpr unsigned int VGT_DEBUG_REG15__RESERVED0_MASK          = 0x03f00000L;
    constexpr unsigned int VGT_DEBUG_REG15__RESERVED1_MASK          = 0xe0000000L;
    constexpr unsigned int VGT_DEBUG_REG16__RESERVED0_MASK          = 0x00800000L;
    constexpr unsigned int VGT_DEBUG_REG23__frmt_pg_busy_MASK       = 0x01000000L;
    constexpr unsigned int VGT_DEBUG_REG23__RESERVED_MASK           = 0xfe000000L;
    constexpr unsigned int VGT_DEBUG_REG30__eopg_p2_MASK            = 0x08000000L;
    constexpr unsigned int VGT_DEBUG_REG30__eop_p1_q_MASK           = 0x10000000L;
    constexpr unsigned int VGT_DEBUG_REG30__esvert_fifo_full_MASK   = 0x00400000L;
    constexpr unsigned int VGT_DEBUG_REG30__eswave_fifo_full_MASK   = 0x02000000L;
    constexpr unsigned int VGT_DEBUG_REG30__event_flag_p1_q_MASK    = 0x20000000L;
    constexpr unsigned int VGT_DEBUG_REG30__gsinvoc_fifo_full_MASK  = 0x04000000L;
    constexpr unsigned int VGT_DEBUG_REG30__gsprim_fifo_full_MASK   = 0x00800000L;
    constexpr unsigned int VGT_DEBUG_REG30__gswave_fifo_full_MASK   = 0x01000000L;
    constexpr unsigned int VGT_DEBUG_REG30__non_pg_perfcounter_start_MASK = 0x00080000L;
    constexpr unsigned int VGT_DEBUG_REG30__non_pg_perfcounter_stop_MASK = 0x00100000L;
    constexpr unsigned int VGT_DEBUG_REG30__ordered_id_mode_p1_q_MASK = 0x40000000L;
    constexpr unsigned int VGT_DEBUG_REG30__te_vert_fifo_re_MASK    = 0x80000000L;
    constexpr unsigned int VGT_DEBUG_REG32__su_output_fifo_empty_MASK = 0x40000000L;
    constexpr unsigned int VGT_DEBUG_REG32__su_output_fifo_full_MASK = 0x80000000L;
    constexpr unsigned int VGT_DEBUG_REG35__RESERVED0_MASK          = 0xffffffffL;
    constexpr unsigned int wbuf_DEBUG_DATA__cstate_3to0_MASK        = 0x0001e000L;
    constexpr unsigned int wbuf_DEBUG_DATA__Reserved0_MASK          = 0x0000003fL;
    constexpr unsigned int wbuf_DEBUG_DATA__Reserved1_MASK          = 0xffc00000L;
    constexpr unsigned int wbuf_DEBUG_DATA__wr_pixel_ptr_nxt_MASK   = 0x00000f80L;
    constexpr unsigned int WD_DEBUG_REG0__RESERVED0_MASK            = 0x00010000L;
    constexpr unsigned int WD_DEBUG_REG1__reg_xfer_valid_MASK       = 0x00000100L;
    constexpr unsigned int WD_DEBUG_REG2__p1_grbm_fifo_rdata_reg_id_4_0_MASK = 0x0001f000L;
    constexpr unsigned int WD_DEBUG_REG2__p1_grbm_fifo_rdata_state_2_0_MASK = 0x000e0000L;
    constexpr unsigned int WD_DEBUG_REG2__p1_reg_xfer_valid_MASK    = 0x00000100L;
    constexpr unsigned int WD_DEBUG_REG3__RESERVED0_MASK            = 0x00000002L;
    constexpr unsigned int WD_DEBUG_REG3__RESERVED1_MASK            = 0x00000800L;
    constexpr unsigned int WD_DEBUG_REG3__RESERVED2_MASK            = 0x00800000L;
    constexpr unsigned int WD_DEBUG_REG5__RESERVED0_MASK            = 0x00000002L;
    constexpr unsigned int WD_DEBUG_REG5__RESERVED1_MASK            = 0x00000800L;
    constexpr unsigned int WD_DEBUG_REG5__RESERVED2_MASK            = 0x00800000L;
    constexpr unsigned int WD_DEBUG_REG7__SE2VGT_WD_thdgrp_send_in_MASK = 0x00000100L;
    constexpr unsigned int WD_DEBUG_REG7__se2_thdgrp_eop_MASK       = 0x02000000L;
    constexpr unsigned int WD_DEBUG_REG7__se2_thdgrp_is_event_MASK  = 0x01000000L;
    constexpr unsigned int WD_DEBUG_REG7__SE3VGT_WD_thdgrp_send_in_MASK = 0x00001000L;
    constexpr unsigned int WD_DEBUG_REG7__se3_thdgrp_eop_MASK       = 0x08000000L;
    constexpr unsigned int WD_DEBUG_REG7__se3_thdgrp_is_event_MASK  = 0x04000000L;
    constexpr unsigned int WD_DEBUG_REG7__te11_arb_state_q_MASK     = 0x000f0000L;
    constexpr unsigned int WD_DEBUG_REG7__wd_arb_se2_input_fifo_empty_MASK = 0x00000400L;
    constexpr unsigned int WD_DEBUG_REG7__wd_arb_se2_input_fifo_full_MASK = 0x00000800L;
    constexpr unsigned int WD_DEBUG_REG7__wd_arb_se2_input_fifo_re_MASK = 0x00000200L;
    constexpr unsigned int WD_DEBUG_REG7__wd_arb_se3_input_fifo_empty_MASK = 0x00004000L;
    constexpr unsigned int WD_DEBUG_REG7__wd_arb_se3_input_fifo_full_MASK = 0x00008000L;
    constexpr unsigned int WD_DEBUG_REG7__wd_arb_se3_input_fifo_re_MASK = 0x00002000L;
    constexpr unsigned int WD_DEBUG_REG9__event_flag_p0_q_or_null_flags_p0_q_MASK = 0x00000008L;
    constexpr unsigned int WD_DEBUG_REG9__RESERVED0_MASK            = 0x0000f800L;
    constexpr unsigned int WD_DEBUG_REG9__RESERVED1_MASK            = 0x01000000L;
    constexpr unsigned int WD_DEBUG_REG9__RESERVED2_MASK            = 0x08000000L;
    constexpr unsigned int WD_DEBUG_REG9__RESERVED3_MASK            = 0x30000000L;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_fragment_size_MASK = 0x003f0000L;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_io_steer_MASK = 0x00008000L;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_memlog_MASK = 0x00000800L;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_mtype_MASK = 0x00000600L;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_nack_MASK  = 0x00000180L;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_no_pte_MASK = 0x00001000L;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_perms_granted_MASK = 0x01c00000L;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_perms_requested_MASK = 0x0e000000L;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_physical_address_1_0_MASK = 0xc0000000L;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_pte_tmz_MASK = 0x00002000L;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_snoop_MASK = 0x10000000L;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_spa_MASK   = 0x00004000L;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_tag_MASK   = 0x0000007fL;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_valid_MASK = 0x20000000L;
    constexpr unsigned int WD_DEBUG_REG15__iUTCL2_WD_ret_physical_address_33_2_MASK = 0xffffffffL;
    constexpr unsigned int WD_DEBUG_REG16__iUTCL2_WD_ret_physical_address_35_34_MASK = 0x00000003L;
    constexpr unsigned int WD_DEBUG_REG16__qUtcL2XferCycle_MASK     = 0x00100000L;
    constexpr unsigned int WD_DEBUG_REG16__qWD_UTCL2_req_free_MASK  = 0x00040000L;
    constexpr unsigned int WD_DEBUG_REG16__RESERVED0_MASK           = 0xffe00000L;
    constexpr unsigned int WD_DEBUG_REG16__WD_UTCL2_req_data_MASK   = 0x0003fffcL;
    constexpr unsigned int WD_DEBUG_REG16__WD_UTCL2_req_send_MASK   = 0x00080000L;
    constexpr unsigned int WD_DEBUG_REG17__iUTCL10_UTCL2IU_req_rts_MASK = 0x00020000L;
    constexpr unsigned int WD_DEBUG_REG17__iUTCL11_UTCL2IU_req_rts_MASK = 0x00040000L;
    constexpr unsigned int WD_DEBUG_REG17__NewCycleXfer_MASK        = 0x01000000L;
    constexpr unsigned int WD_DEBUG_REG17__qUtcL2XferCycle_MASK     = 0x0001c000L;
    constexpr unsigned int WD_DEBUG_REG17__qXferId_MASK             = 0x00e00000L;
    constexpr unsigned int WD_DEBUG_REG17__RESERVED0_MASK           = 0xfe000000L;
    constexpr unsigned int WD_DEBUG_REG17__WDUtcL2Cnt_MASK          = 0x000000fcL;
    constexpr unsigned int WD_DEBUG_REG17__WDUtcL2iuPostArbFifo_Empty_MASK = 0x00000001L;
    constexpr unsigned int WD_DEBUG_REG17__WDUtcL2iuPostArbFifo_Full_MASK = 0x00000002L;
    constexpr unsigned int WD_DEBUG_REG17__WDUtcL2OutCnt_MASK       = 0x00003f00L;
    constexpr unsigned int WD_DEBUG_REG17__XferId_MASK              = 0x00180000L;
    constexpr unsigned int WD_DEBUG_REG18__busy_MASK                = 0x00000200L;
    constexpr unsigned int WD_DEBUG_REG18__CLIENT_UTCL1_req0_ready_MASK = 0x40000000L;
    constexpr unsigned int WD_DEBUG_REG18__CLIENT_UTCL1_req0_valid_MASK = 0x80000000L;
    constexpr unsigned int WD_DEBUG_REG18__CLIENT_UTCL1_req1_ready_MASK = 0x04000000L;
    constexpr unsigned int WD_DEBUG_REG18__CLIENT_UTCL1_req1_valid_MASK = 0x08000000L;
    constexpr unsigned int WD_DEBUG_REG18__cpf_wd_invreq_clean_out_MASK = 0x00004000L;
    constexpr unsigned int WD_DEBUG_REG18__cpf_wd_invreq_flushtype_in_MASK = 0x00008000L;
    constexpr unsigned int WD_DEBUG_REG18__cpf_wd_invreq_start_in_MASK = 0x00010000L;
    constexpr unsigned int WD_DEBUG_REG18__outstanding_tc_accesses_2_0_MASK = 0x00000007L;
    constexpr unsigned int WD_DEBUG_REG18__TC_WD_ret_valid_MASK     = 0x00002000L;
    constexpr unsigned int WD_DEBUG_REG18__UTCL1_CLIENT_ret0_ready_MASK = 0x10000000L;
    constexpr unsigned int WD_DEBUG_REG18__UTCL1_CLIENT_ret0_valid_MASK = 0x20000000L;
    constexpr unsigned int WD_DEBUG_REG18__UTCL1_CLIENT_ret1_ready_MASK = 0x01000000L;
    constexpr unsigned int WD_DEBUG_REG18__UTCL1_CLIENT_ret1_valid_MASK = 0x02000000L;
    constexpr unsigned int WD_DEBUG_REG18__utcl2iu_busy_MASK        = 0x00000008L;
    constexpr unsigned int WD_DEBUG_REG18__UTCL2IU_UTCL1_ret_nack_MASK = 0x00000c00L;
    constexpr unsigned int WD_DEBUG_REG18__UTCL2IU_UTCL1_ret_valid_MASK = 0x00001000L;
    constexpr unsigned int WD_DEBUG_REG18__UTCL2_WD_inv_valid_MASK  = 0x00040000L;
    constexpr unsigned int WD_DEBUG_REG18__UTCL2_WD_ret_valid_MASK  = 0x00200000L;
    constexpr unsigned int WD_DEBUG_REG18__UTCL2_WD_ret_xnack_MASK  = 0x00180000L;
    constexpr unsigned int WD_DEBUG_REG18__utcl10_se0_busy_MASK     = 0x00000100L;
    constexpr unsigned int WD_DEBUG_REG18__utcl10_se1_busy_MASK     = 0x00000080L;
    constexpr unsigned int WD_DEBUG_REG18__utcl10_se2_busy_MASK     = 0x00000040L;
    constexpr unsigned int WD_DEBUG_REG18__utcl10_se3_busy_MASK     = 0x00000020L;
    constexpr unsigned int WD_DEBUG_REG18__utcl11_busy_MASK         = 0x00000010L;
    constexpr unsigned int WD_DEBUG_REG18__WD_UTCL2_inv_ack_MASK    = 0x00020000L;
    constexpr unsigned int WD_DEBUG_REG18__WD_UTCL2_req_free_MASK   = 0x00400000L;
    constexpr unsigned int WD_DEBUG_REG18__WD_UTCL2_req_send_MASK   = 0x00800000L;
    constexpr unsigned int WD_DEBUG_REG19__dispatch_draw_mode_p4_MASK = 0x20000000L;
    constexpr unsigned int WD_DEBUG_REG19__dma_dummy_req_p3_q_MASK  = 0x10000000L;
    constexpr unsigned int WD_DEBUG_REG19__dma_issue_p2_MASK        = 0x80000000L;
    constexpr unsigned int WD_DEBUG_REG19__dma_out_of_range_p3_q_MASK = 0x40000000L;
    constexpr unsigned int WD_DEBUG_REG19__dma_primgroup_size_MASK  = 0x0000ffffL;
    constexpr unsigned int WD_DEBUG_REG19__dma_wd_switch_on_eop_MASK = 0x00100000L;
    constexpr unsigned int WD_DEBUG_REG19__RESERVED0_MASK           = 0x000f0000L;
    constexpr unsigned int WD_DEBUG_REG19__RESERVED1_MASK           = 0x0fe00000L;
    constexpr unsigned int WD_DEBUG_REG20__reg_state_or_event_data_p2_15_0_MASK = 0x0000ffffL;
    constexpr unsigned int WD_DEBUG_REG20__reg_state_or_event_data_p2_16_MASK = 0x00010000L;
    constexpr unsigned int WD_DEBUG_REG20__reg_state_or_event_data_p2_17_MASK = 0x00020000L;
    constexpr unsigned int WD_DEBUG_REG20__reg_state_or_event_data_p2_18_MASK = 0x00040000L;
    constexpr unsigned int WD_DEBUG_REG20__reg_state_or_event_data_p2_19_MASK = 0x00080000L;
    constexpr unsigned int WD_DEBUG_REG20__reg_state_or_event_data_p2_20_MASK = 0x00100000L;
    constexpr unsigned int WD_DEBUG_REG20__reg_state_or_event_data_p2_21_MASK = 0x00200000L;
    constexpr unsigned int WD_DEBUG_REG20__reg_state_or_event_data_p2_22_MASK = 0x00400000L;
    constexpr unsigned int WD_DEBUG_REG20__reg_state_or_event_data_p2_23_MASK = 0x00800000L;
    constexpr unsigned int WD_DEBUG_REG20__reg_state_or_event_data_p2_31_24_MASK = 0xff000000L;
    constexpr unsigned int WD_DEBUG_REG21__hp_dispatch_draw_mode_p4_MASK = 0x20000000L;
    constexpr unsigned int WD_DEBUG_REG21__hp_dma_dummy_req_p3_q_MASK = 0x10000000L;
    constexpr unsigned int WD_DEBUG_REG21__hp_dma_issue_p2_MASK     = 0x80000000L;
    constexpr unsigned int WD_DEBUG_REG21__hp_dma_out_of_range_p3_q_MASK = 0x40000000L;
    constexpr unsigned int WD_DEBUG_REG21__hp_dma_primgroup_size_MASK = 0x0000ffffL;
    constexpr unsigned int WD_DEBUG_REG21__hp_dma_wd_switch_on_eop_MASK = 0x00100000L;
    constexpr unsigned int WD_DEBUG_REG21__RESERVED0_MASK           = 0x000f0000L;
    constexpr unsigned int WD_DEBUG_REG21__RESERVED1_MASK           = 0x0fe00000L;
} // namespace Rv2x

namespace Vega
{
    constexpr unsigned int GC_CAC_ACC_BCI1__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU3__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU4__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
    constexpr unsigned int GC_CAC_OVRD_BCI__OVRRD_SELECT_MASK       = 0x00000003L;
    constexpr unsigned int GC_CAC_OVRD_BCI__OVRRD_VALUE_MASK        = 0x0000000cL;
    constexpr unsigned int GC_CAC_WEIGHT_BCI_0__WEIGHT_BCI_SIG1_MASK = 0xffff0000L;
    constexpr unsigned int IA_DEBUG_REG0__SPARE0_MASK               = 0x00000010L;
    constexpr unsigned int IA_DEBUG_REG0__SPARE1_MASK               = 0x00000200L;
    constexpr unsigned int IA_DEBUG_REG0__SPARE2_MASK               = 0x00ffc000L;
    constexpr unsigned int IA_DEBUG_REG0__SPARE3_MASK               = 0x04000000L;
    constexpr unsigned int IA_DEBUG_REG0__SPARE4_MASK               = 0x08000000L;
    constexpr unsigned int IA_DEBUG_REG0__SPARE5_MASK               = 0x40000000L;
    constexpr unsigned int IA_DEBUG_REG9__SPARE0_MASK               = 0x00004000L;
    constexpr unsigned int IA_DEBUG_REG9__SPARE1_MASK               = 0x00008000L;
    constexpr unsigned int RLC_SPM_DEBUG_SELECT__RESERVED_MASK      = 0x00007f00L;
    constexpr unsigned int RLC_SPM_PERFMON_CNTL__RESERVED1_MASK     = 0x00000fffL;
    constexpr unsigned int RMI_CLOCK_CNTRL__DYN_CLK_RB1_BUSY_MASK_MASK = 0x01f00000L;
    constexpr unsigned int RMI_CLOCK_CNTRL__DYN_CLK_RB1_WAKEUP_MASK_MASK = 0x3e000000L;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_BREAK_LOB_ON_IDLEIN_MASK = 0x00020000L;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_MODE_MASK     = 0xc0000000L;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_STALL_MASK    = 0x00010000L;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_STALL_TIMER_OVERRIDE_MASK = 0x00300000L;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_STALL_TIMER_START_VALUE_MASK = 0x3fc00000L;
    constexpr unsigned int RMI_GENERAL_CNTL1__TCIW1_64B_RD_STALL_MODE_MASK = 0x000000c0L;
    constexpr unsigned int RMI_GENERAL_CNTL1__UTCL1_PROBE1_RR_ARB_BURST_HINT_EN_MASK = 0x00001000L;
    constexpr unsigned int RMI_GENERAL_CNTL__RB1_HARVEST_EN_MASK    = 0x00100000L;
    constexpr unsigned int RMI_GENERAL_CNTL__SKID_FIFO_1_OVERFLOW_ERROR_MASK_MASK = 0x10000000L;
    constexpr unsigned int RMI_GENERAL_CNTL__SKID_FIFO_1_UNDERFLOW_ERROR_MASK_MASK = 0x20000000L;
    constexpr unsigned int RMI_GENERAL_STATUS__RDREQ_CONSUMER_FIFO_1_BUSY_MASK = 0x00020000L;
    constexpr unsigned int RMI_GENERAL_STATUS__SKID_FIFO_1_OVERFLOW_ERROR_MASK = 0x00000008L;
    constexpr unsigned int RMI_GENERAL_STATUS__SKID_FIFO_1_UNDERFLOW_ERROR_MASK = 0x00000010L;
    constexpr unsigned int RMI_GENERAL_STATUS__TCIW1_PRT_FIFO_BUSY_MASK = 0x00002000L;
    constexpr unsigned int RMI_GENERAL_STATUS__TCIW_FRMTR1_BUSY_MASK = 0x00004000L;
    constexpr unsigned int RMI_GENERAL_STATUS__TCIW_RTN_FRMTR1_BUSY_MASK = 0x00008000L;
    constexpr unsigned int RMI_GENERAL_STATUS__UTC_PROBE1_BUSY_MASK = 0x00040000L;
    constexpr unsigned int RMI_GENERAL_STATUS__WRREQ_CONSUMER_FIFO_1_BUSY_MASK = 0x00010000L;
    constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_EVENT_WINDOW_MASK1_MASK = 0x00000300L;
    constexpr unsigned int RMI_PROBE_POP_LOGIC_CNTL__EXT_LAT_FIFO_1_MAX_DEPTH_MASK = 0x0001fc00L;
    constexpr unsigned int RMI_PROBE_POP_LOGIC_CNTL__XLAT_COMBINE1_DIS_MASK = 0x00020000L;
    constexpr unsigned int RMI_SCOREBOARD_CNTL__COMPLETE_RB1_FLUSH_MASK = 0x00000004L;
    constexpr unsigned int RMI_SCOREBOARD_CNTL__REQ_IN_RE_EN_AFTER_FLUSH_RB1_MASK = 0x00000008L;
    constexpr unsigned int RMI_SCOREBOARD_CNTL__TIME_STAMP_FLUSH_RB1_MASK = 0x00000010L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS1__COM_FLUSH_IN_PROG_RB1_MASK = 0x20000000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS1__RUNNING_CNT_OVERFLOW_RB1_MASK = 0x10000000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS1__RUNNING_CNT_RB1_MASK = 0x07ff8000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS1__RUNNING_CNT_UNDERFLOW_RB1_MASK = 0x08000000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__COM_FLUSH_DONE_RB1_MASK = 0x04000000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__SNAPSHOT_CNT_RB1_MASK = 0x01ffe000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__SNAPSHOT_CNT_UNDERFLOW_RB1_MASK = 0x02000000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__TIME_STAMP_FLUSH_DONE_RB1_MASK = 0x80000000L;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__TIME_STAMP_FLUSH_IN_PROG_RB1_MASK = 0x20000000L;
    constexpr unsigned int RMI_SUBBLOCK_STATUS0__UTC_EXT_LAT_HID_FIFO_EMPTY_PROBE1_MASK = 0x00020000L;
    constexpr unsigned int RMI_SUBBLOCK_STATUS0__UTC_EXT_LAT_HID_FIFO_FULL_PROBE1_MASK = 0x00010000L;
    constexpr unsigned int RMI_SUBBLOCK_STATUS0__UTC_EXT_LAT_HID_FIFO_NUM_USED_PROBE1_MASK = 0x0000fe00L;
    constexpr unsigned int RMI_SUBBLOCK_STATUS1__SKID_FIFO_1_FREE_SPACE_MASK = 0x000ffc00L;
    constexpr unsigned int RMI_SUBBLOCK_STATUS1__TCIW1_INFLIGHT_CNT_MASK = 0x3ff00000L;
    constexpr unsigned int RMI_SUBBLOCK_STATUS2__PRT_FIFO_1_NUM_USED_MASK = 0x0003fe00L;
    constexpr unsigned int RMI_SUBBLOCK_STATUS3__SKID_FIFO_1_FREE_SPACE_TOTAL_MASK = 0x000ffc00L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__ALL_FAULT_RET1_DATA_MASK = 0x80000000L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__RMI_IN1_REORDER_DIS_MASK = 0x20000000L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__SKID_FIFO_1_FREE_SPACE_DELTA_MASK = 0x07f80000L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__SKID_FIFO_1_FREE_SPACE_DELTA_UPDATE_MASK = 0x08000000L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__TCIW1_MAX_ALLOWED_INFLIGHT_REQ_MASK = 0x0007fe00L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__TCIW1_REQ_SAFE_MODE_MASK = 0x10000000L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__WR_COMBINE1_DIS_AT_LAST_OF_BURST_MASK = 0x40000000L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__WR_COMBINE1_DIS_OVERRIDE_MASK = 0x00000001L;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__WR_COMBINE1_TIME_OUT_WINDOW_MASK = 0x000001feL;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG_1__XBAR_ARB_ROUND_ROBIN_WEIGHT_RB1_RD_MASK = 0x00ff0000L;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG_1__XBAR_ARB_ROUND_ROBIN_WEIGHT_RB1_WR_MASK = 0xff000000L;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_BREAK_LOB_ON_IDLEIN_MASK = 0x00100000L;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_BREAK_LOB_ON_WEIGHTEDRR_MASK = 0x00040000L;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_MODE_MASK = 0x00030000L;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_STALL_MASK = 0x00080000L;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_STALL_TIMER_OVERRIDE_MASK = 0x00c00000L;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_STALL_TIMER_START_VALUE_MASK = 0xff000000L;
    constexpr unsigned int RMI_XBAR_CONFIG__XBAR_EN_IN_RB1_MASK     = 0x00004000L;
    constexpr unsigned int RPB_ATS_CNTL2__INVAL_COM_ROUTING_CODE_MASK = 0x00038000L;
    constexpr unsigned int RPB_ATS_CNTL2__PAGE_REQ_CMD_MASK         = 0x00000fc0L;
    constexpr unsigned int RPB_ATS_CNTL2__PAGE_ROUTING_CODE_MASK    = 0x00007000L;
    constexpr unsigned int RPB_ATS_CNTL2__TRANS_CMD_MASK            = 0x0000003fL;
    constexpr unsigned int RPB_ATS_CNTL2__VENDOR_ID_MASK            = 0x000c0000L;
    constexpr unsigned int RPB_ATS_CNTL__ATCTR_SWITCH_NUM_MASK      = 0x00078000L;
    constexpr unsigned int RPB_ATS_CNTL__INVAL_COM_CMD_MASK         = 0x7e000000L;
    constexpr unsigned int RPB_BIF_CNTL__ARB_MODE_MASK              = 0x00010000L;
    constexpr unsigned int RPB_BIF_CNTL__DRAIN_VC_NUM_MASK          = 0x00020000L;
    constexpr unsigned int RPB_BIF_CNTL__PAGE_PRI_EN_MASK           = 0x08000000L;
    constexpr unsigned int RPB_BIF_CNTL__PARITY_CHECK_EN_MASK       = 0x40000000L;
    constexpr unsigned int RPB_BIF_CNTL__SWITCH_ENABLE_MASK         = 0x00040000L;
    constexpr unsigned int RPB_BIF_CNTL__SWITCH_THRESHOLD_MASK      = 0x07f80000L;
    constexpr unsigned int RPB_BIF_CNTL__TR_PRI_EN_MASK             = 0x10000000L;
    constexpr unsigned int RPB_BIF_CNTL__VC0_CHAINED_OVERRIDE_MASK  = 0x20000000L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATC_INV_BLOCKLEVEL_MASK = 0x000000c0L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATC_PAGE_BLOCKLEVEL_MASK = 0x00000030L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATC_TR_BLOCKLEVEL_MASK = 0x0000000cL;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATOMIC_BLOCKLEVEL_OVERRIDE_EN_MASK = 0x00020000L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATOMIC_BLOCKLEVEL_OVERRIDE_MASK = 0x00003000L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_RD_BLOCKLEVEL_OVERRIDE_EN_MASK = 0x00010000L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_RD_BLOCKLEVEL_OVERRIDE_MASK = 0x00000c00L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_WR_BLOCKLEVEL_OVERRIDE_EN_MASK = 0x00008000L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_WR_BLOCKLEVEL_OVERRIDE_MASK = 0x00000300L;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__XPB_BLOCKLEVEL_OVERRIDE_EN_MASK = 0x00004000L;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_PAGE_PASSPW_OVERRIDE_EN_MASK = 0x00001000L;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_PAGE_PASSPW_OVERRIDE_MASK = 0x00000008L;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_RSPPASSPW_OVERRIDE_EN_MASK = 0x00002000L;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_RSPPASSPW_OVERRIDE_MASK = 0x00000100L;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_TR_PASSPW_OVERRIDE_EN_MASK = 0x00000800L;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_TR_PASSPW_OVERRIDE_MASK = 0x00000004L;
    constexpr unsigned int RPB_PASSPW_CONF__ATOMIC_PASSPW_OVERRIDE_MASK = 0x00000200L;
    constexpr unsigned int RPB_PASSPW_CONF__ATOMIC_RSPPASSPW_OVERRIDE_MASK = 0x00000400L;
    constexpr unsigned int RPB_PASSPW_CONF__RDRSP_PASSPW_OVERRIDE_EN_MASK = 0x00020000L;
    constexpr unsigned int RPB_PASSPW_CONF__RDRSP_PASSPW_OVERRIDE_MASK = 0x00010000L;
    constexpr unsigned int RPB_PASSPW_CONF__RD_PASSPW_OVERRIDE_MASK = 0x00000020L;
    constexpr unsigned int RPB_PASSPW_CONF__RD_RSPPASSPW_OVERRIDE_MASK = 0x00000080L;
    constexpr unsigned int RPB_PASSPW_CONF__WRRSP_PASSPW_OVERRIDE_EN_MASK = 0x00008000L;
    constexpr unsigned int RPB_PASSPW_CONF__WRRSP_PASSPW_OVERRIDE_MASK = 0x00004000L;
    constexpr unsigned int RPB_PASSPW_CONF__WR_PASSPW_OVERRIDE_MASK = 0x00000010L;
    constexpr unsigned int RPB_PASSPW_CONF__WR_RSPPASSPW_OVERRIDE_MASK = 0x00000040L;
    constexpr unsigned int SDMA1_PERFCOUNTER0_RESULT__PERF_COUNT_MASK = 0xffffffffL;
    constexpr unsigned int SDMA1_PERFCOUNTER1_RESULT__PERF_COUNT_MASK = 0xffffffffL;
    constexpr unsigned int SDMA1_PERFCOUNTER_TAG_DELAY_RANGE__RANGE_HIGH_MASK = 0x0fffc000L;
    constexpr unsigned int SDMA1_PERFCOUNTER_TAG_DELAY_RANGE__RANGE_LOW_MASK = 0x00003fffL;
    constexpr unsigned int SDMA1_PERFCOUNTER_TAG_DELAY_RANGE__SELECT_RW_MASK = 0x10000000L;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_CLEAR0_MASK     = 0x00000002L;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_CLEAR1_MASK     = 0x00000800L;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_ENABLE0_MASK    = 0x00000001L;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_ENABLE1_MASK    = 0x00000400L;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_SEL0_MASK       = 0x000003fcL;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_SEL1_MASK       = 0x000ff000L;
    constexpr unsigned int VGT_DEBUG_REG0__SPARE0_MASK              = 0x80000000L;
    constexpr unsigned int VGT_DEBUG_REG0__SPARE1_MASK              = 0x10000000L;
    constexpr unsigned int VGT_DEBUG_REG0__SPARE2_MASK              = 0x02000000L;
    constexpr unsigned int VGT_DEBUG_REG0__SPARE3_MASK              = 0x00100000L;
    constexpr unsigned int VGT_DEBUG_REG0__SPARE4_MASK              = 0x00000080L;
    constexpr unsigned int VGT_DEBUG_REG0__SPARE5_MASK              = 0x00000040L;
    constexpr unsigned int VGT_DEBUG_REG1__SPARE0_MASK              = 0x00000200L;
    constexpr unsigned int VGT_DEBUG_REG1__SPARE1_MASK              = 0x00000100L;
    constexpr unsigned int VGT_DEBUG_REG1__SPARE2_MASK              = 0x00000080L;
    constexpr unsigned int VGT_DEBUG_REG1__SPARE3_MASK              = 0x00000040L;
    constexpr unsigned int VGT_DEBUG_REG1__SPARE4_MASK              = 0x00000020L;
    constexpr unsigned int VGT_DEBUG_REG1__SPARE5_MASK              = 0x00000010L;
    constexpr unsigned int VGT_DEBUG_REG2__SPARE_MASK               = 0xe0000000L;
    constexpr unsigned int VGT_DEBUG_REG4__SPARE_MASK               = 0x80000000L;
    constexpr unsigned int VGT_DEBUG_REG5__SPARE1_MASK              = 0x07000000L;
    constexpr unsigned int VGT_DEBUG_REG5__SPARE2_MASK              = 0x00070000L;
    constexpr unsigned int VGT_DEBUG_REG5__SPARE3_MASK              = 0x00000700L;
    constexpr unsigned int VGT_DEBUG_REG5__SPARE4_MASK              = 0x00000007L;
    constexpr unsigned int VGT_DEBUG_REG7__SPARE_MASK               = 0x0000ffe0L;
    constexpr unsigned int VGT_DEBUG_REG9__SPARE0_MASK              = 0x40000000L;
    constexpr unsigned int VGT_DEBUG_REG10__SPARE2_MASK             = 0x00000600L;
    constexpr unsigned int VGT_DEBUG_REG11__SPARE0_MASK             = 0x00040000L;
    constexpr unsigned int VGT_DEBUG_REG11__SPARE1_MASK             = 0x00000020L;
    constexpr unsigned int VGT_DEBUG_REG12__SPARE0_MASK             = 0x80000000L;
    constexpr unsigned int VGT_DEBUG_REG13__SPARE0_MASK             = 0x04000000L;
    constexpr unsigned int VGT_DEBUG_REG13__SPARE1_MASK             = 0x02000000L;
    constexpr unsigned int VGT_DEBUG_REG14__SPARE0_MASK             = 0x40000000L;
    constexpr unsigned int VGT_DEBUG_REG14__SPARE1_MASK             = 0x10000000L;
    constexpr unsigned int VGT_DEBUG_REG14__SPARE2_MASK             = 0x001ff000L;
    constexpr unsigned int VGT_DEBUG_REG14__SPARE3_MASK             = 0x0000000fL;
    constexpr unsigned int VGT_DEBUG_REG14__SPARE_MASK              = 0x01c00000L;
    constexpr unsigned int VGT_DEBUG_REG23__SPARE_MASK              = 0xff000000L;
    constexpr unsigned int VGT_DEBUG_REG30__SPARE_MASK              = 0xfff80000L;
    constexpr unsigned int VGT_DEBUG_REG32__SPARE_MASK              = 0xf0000000L;
    constexpr unsigned int WD_DEBUG_REG0__SPARE3_MASK               = 0x00010000L;
    constexpr unsigned int WD_DEBUG_REG1__SPARE0_MASK               = 0x00000100L;
    constexpr unsigned int WD_DEBUG_REG2__SPARE0_MASK               = 0x00000100L;
    constexpr unsigned int WD_DEBUG_REG3__SPARE0_MASK               = 0x00000002L;
    constexpr unsigned int WD_DEBUG_REG3__SPARE1_MASK               = 0x00800000L;
    constexpr unsigned int WD_DEBUG_REG5__SPARE0_MASK               = 0x00000002L;
    constexpr unsigned int WD_DEBUG_REG5__SPARE1_MASK               = 0x00800000L;
    constexpr unsigned int WD_DEBUG_REG7__SPARE0_MASK               = 0x000000f0L;
    constexpr unsigned int WD_DEBUG_REG7__SPARE1_MASK               = 0x00000f00L;
    constexpr unsigned int WD_DEBUG_REG7__SPARE2_MASK               = 0x0000f000L;
    constexpr unsigned int WD_DEBUG_REG7__SPARE3_MASK               = 0x000f0000L;
    constexpr unsigned int WD_DEBUG_REG7__SPARE4_MASK               = 0x0fc00000L;
    constexpr unsigned int WD_DEBUG_REG9__SPARE0_MASK               = 0x0000f800L;
    constexpr unsigned int WD_DEBUG_REG9__SPARE1_MASK               = 0x08000000L;
    constexpr unsigned int WD_DEBUG_REG9__SPARE2_MASK               = 0x30000000L;
} // namespace Vega

namespace Vg10
{
    constexpr unsigned int GC_CAC_ACC_CBR0__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CBR1__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CBR2__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CBR3__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU11__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU12__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU13__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU14__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU15__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_DBR0__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_DBR1__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_DBR2__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_DBR3__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_OVRD_CBR__OVRRD_SELECT_MASK       = 0x0000000fL;
    constexpr unsigned int GC_CAC_OVRD_CBR__OVRRD_VALUE_MASK        = 0x000000f0L;
    constexpr unsigned int GC_CAC_OVRD_DBR__OVRRD_SELECT_MASK       = 0x0000000fL;
    constexpr unsigned int GC_CAC_OVRD_DBR__OVRRD_VALUE_MASK        = 0x000000f0L;
    constexpr unsigned int GC_CAC_WEIGHT_CBR_0__WEIGHT_CBR_SIG0_MASK = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_CBR_0__WEIGHT_CBR_SIG1_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_CBR_1__WEIGHT_CBR_SIG2_MASK = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_CBR_1__WEIGHT_CBR_SIG3_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_CU_6__WEIGHT_CU_SIG12_MASK = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_CU_6__WEIGHT_CU_SIG13_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_CU_7__WEIGHT_CU_SIG14_MASK = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_CU_7__WEIGHT_CU_SIG15_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_DBR_0__WEIGHT_DBR_SIG0_MASK = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_DBR_0__WEIGHT_DBR_SIG1_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_DBR_1__WEIGHT_DBR_SIG2_MASK = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_DBR_1__WEIGHT_DBR_SIG3_MASK = 0xffff0000L;
    constexpr unsigned int GC_DIDT_WEIGHT_1__DBR_WEIGHT_MASK        = 0x000000ffL;
    constexpr unsigned int RLC_SPM_CBR0_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_CBR0_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_CBR1_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_CBR1_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_DBR0_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_DBR0_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_DBR1_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_DBR1_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
} // namespace Vg10

namespace Vg10_Vg12
{
    constexpr unsigned int RPB_EA_QUEUE_WR__EA_NUMBER_MASK          = 0x0000001fL;
    constexpr unsigned int RPB_EA_QUEUE_WR__READ_QUEUE_MASK         = 0x00000700L;
    constexpr unsigned int RPB_EA_QUEUE_WR__UPDATE_MASK             = 0x00000800L;
    constexpr unsigned int RPB_EA_QUEUE_WR__WRITE_QUEUE_MASK        = 0x000000e0L;
} // namespace Vg10_Vg12

namespace Vg10_Vg12_Rv1x
{
    constexpr unsigned int RPB_TAG_CONF__RPB_ATS_PR_MASK            = 0x00ff0000L;
    constexpr unsigned int RPB_TAG_CONF__RPB_ATS_TR_MASK            = 0x000000ffL;
    constexpr unsigned int RPB_TAG_CONF__RPB_IO_WR_MASK             = 0x0000ff00L;
    constexpr unsigned int SQ_CONFIG__UNUSED_MASK                   = 0x0000007fL;
} // namespace Vg10_Vg12_Rv1x

namespace Vg12
{
    constexpr unsigned int DB_DEBUG4__DB_EXTRA_DEBUG4_MASK          = 0x3ff80000L;
    constexpr unsigned int DB_DEBUG4__DISABLE_8PPC_OBJPRIMID_WHEN_NO_SHADER_EXPORTS_MASK = 0x40000000L;
    constexpr unsigned int GC_CAC_CNTL__CAC_FORCE_DISABLE_MASK      = 0x00000001L;
    constexpr unsigned int GC_CAC_INDEX_AUTO_INCR_EN__GC_CAC_INDEX_AUTO_INCR_EN_MASK = 0x00000001L;
    constexpr unsigned int GC_EDC_CTRL__EDC_THROTTLE_PATTERN_BIT_NUMS_MASK = 0x0000f000L;
    constexpr unsigned int GC_EDC_CTRL__GC_EDC_ONLY_MODE_MASK       = 0x00000800L;
    constexpr unsigned int GC_EDC_CTRL__PCC_THROTTLE_PATTERN_BIT_NUMS_MASK = 0x000f0000L;
    constexpr unsigned int GC_EDC_CTRL__RELEASE_STEP_INTERVAL_MASK  = 0x3ff00000L;
    constexpr unsigned int GC_EDC_PERF_COUNTER__EDC_PERF_COUNTER_MASK = 0xffffffffL;
    constexpr unsigned int GC_EDC_STATUS__THROTTLE_PATTERN_INDEX_MASK = 0xfc000000L;
    constexpr unsigned int GC_THROTTLE_CTRL__GC_EDC_OVERRIDE_MASK   = 0x00000070L;
    constexpr unsigned int GC_THROTTLE_CTRL__GC_EDC_PERF_COUNTER_EN_MASK = 0x00000100L;
    constexpr unsigned int GC_THROTTLE_CTRL__GC_EDC_STALL_EN_MASK   = 0x00000002L;
    constexpr unsigned int GC_THROTTLE_CTRL__INST_THROT_DECR_MASK   = 0x80000000L;
    constexpr unsigned int GC_THROTTLE_CTRL__INST_THROT_INCR_MASK   = 0x40000000L;
    constexpr unsigned int GC_THROTTLE_CTRL__PATTERN_MODE_MASK      = 0x00000008L;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_FIXED_PATTERN_MAX_MASK = 0x3e000000L;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_FIXED_PATTERN_MIN_MASK = 0x01f00000L;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_OVERRIDE_MASK      = 0x00000080L;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_PERF_COUNTER_EN_MASK = 0x00000200L;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_STALL_EN_MASK      = 0x00000004L;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_THROT_INCR_STEP_INTERVAL_MASK = 0x000ffc00L;
    constexpr unsigned int GC_THROTTLE_CTRL__THROTTLE_CTRL_SW_RST_MASK = 0x00000001L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_PF_MASK = 0x80000000L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF0_MASK = 0x00000001L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF1_MASK = 0x00000002L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF2_MASK = 0x00000004L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF3_MASK = 0x00000008L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF4_MASK = 0x00000010L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF5_MASK = 0x00000020L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF6_MASK = 0x00000040L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF7_MASK = 0x00000080L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF8_MASK = 0x00000100L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF9_MASK = 0x00000200L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF10_MASK = 0x00000400L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF11_MASK = 0x00000800L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF12_MASK = 0x00001000L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF13_MASK = 0x00002000L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF14_MASK = 0x00004000L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF15_MASK = 0x00008000L;
    constexpr unsigned int MC_VM_XGMI_LFB_CNTL__PF_LFB_REGION_MASK  = 0x00000007L;
    constexpr unsigned int MC_VM_XGMI_LFB_CNTL__PF_MAX_REGION_MASK  = 0x00000038L;
    constexpr unsigned int MC_VM_XGMI_LFB_SIZE__PF_LFB_SIZE_MASK    = 0x0000ffffL;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_SC_SEND_DB_VPZ_FOR_COMPOUND_INDEX_EN_MASK = 0x00000040L;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_SC_SEND_DB_VPZ_FOR_EN_PIPELINE_PRIMID_MASK = 0x00000080L;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_0_MASK         = 0x00000001L;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_1_MASK         = 0x00000002L;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_2_MASK         = 0x00000004L;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_3_MASK         = 0x00000008L;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_4_MASK         = 0x00000010L;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_5_MASK         = 0x00000020L;
    constexpr unsigned int PA_SC_ENHANCE_2__RSVD_MASK               = 0xffffff00L;
    constexpr unsigned int PA_STATE_STEREO_X__STEREO_X_OFFSET_MASK  = 0xffffffffL;
    constexpr unsigned int PA_STEREO_CNTL__EN_STEREO_MASK           = 0x00000001L;
    constexpr unsigned int PA_STEREO_CNTL__RT_SLICE_MODE_MASK       = 0x000000e0L;
    constexpr unsigned int PA_STEREO_CNTL__RT_SLICE_OFFSET_MASK     = 0x00000300L;
    constexpr unsigned int PA_STEREO_CNTL__STEREO_MODE_MASK         = 0x0000001eL;
    constexpr unsigned int PA_STEREO_CNTL__VP_ID_MODE_MASK          = 0x00001c00L;
    constexpr unsigned int PA_STEREO_CNTL__VP_ID_OFFSET_MASK        = 0x0001e000L;
    constexpr unsigned int VML2_MEM_ECC_CNTL__DED_COUNT_MASK        = 0x00c00000L;
    constexpr unsigned int VML2_MEM_ECC_CNTL__DSM_IRRITATOR_DATA_MASK = 0x0000c000L;
    constexpr unsigned int VML2_MEM_ECC_CNTL__ENABLE_ERROR_INJECT_MASK = 0x00060000L;
    constexpr unsigned int VML2_MEM_ECC_CNTL__ENABLE_SINGLE_WRITE_MASK = 0x00010000L;
    constexpr unsigned int VML2_MEM_ECC_CNTL__INDEX_MASK            = 0x000000ffL;
    constexpr unsigned int VML2_MEM_ECC_CNTL__INJECT_DELAY_MASK     = 0x00003f00L;
    constexpr unsigned int VML2_MEM_ECC_CNTL__SEC_COUNT_MASK        = 0x00300000L;
    constexpr unsigned int VML2_MEM_ECC_CNTL__SELECT_INJECT_DELAY_MASK = 0x00080000L;
    constexpr unsigned int VML2_MEM_ECC_CNTL__WRITE_COUNTERS_MASK   = 0x01000000L;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__DED_COUNT_MASK = 0x00c00000L;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__DSM_IRRITATOR_DATA_MASK = 0x0000c000L;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__ENABLE_ERROR_INJECT_MASK = 0x00060000L;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__ENABLE_SINGLE_WRITE_MASK = 0x00010000L;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__INDEX_MASK     = 0x000000ffL;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__INJECT_DELAY_MASK = 0x00003f00L;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__SEC_COUNT_MASK = 0x00300000L;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__SELECT_INJECT_DELAY_MASK = 0x00080000L;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__WRITE_COUNTERS_MASK = 0x01000000L;
} // namespace Vg12

namespace Vg20
{
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_alloc_opco_error_MASK = 0x00000004L;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_dealloc_opco_error_MASK = 0x00000008L;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_dec_error_MASK = 0x00000002L;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_error_ds_address_MASK = 0x003fff00L;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_wrap_opco_error_MASK = 0x00000010L;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_write_dis_MASK = 0x00000001L;
    constexpr unsigned int alloc_DEBUG_DATA__Reserved0_MASK         = 0x000000e0L;
    constexpr unsigned int alloc_DEBUG_DATA__Reserved1_MASK         = 0xffc00000L;
    constexpr unsigned int CP_ECC_DMA_FIRST_OCCURRENCE__CLIENT_MASK = 0x000000f0L;
    constexpr unsigned int CP_ECC_DMA_FIRST_OCCURRENCE__INTERFACE_MASK = 0x00000003L;
    constexpr unsigned int CP_ECC_DMA_FIRST_OCCURRENCE__ME_MASK     = 0x00000300L;
    constexpr unsigned int CP_ECC_DMA_FIRST_OCCURRENCE__PIPE_MASK   = 0x00000c00L;
    constexpr unsigned int CP_ECC_DMA_FIRST_OCCURRENCE__QUEUE_MASK  = 0x00007000L;
    constexpr unsigned int CP_ECC_DMA_FIRST_OCCURRENCE__VMID_MASK   = 0x000f0000L;
    constexpr unsigned int CP_EDC_FUE_CNTL__CP_FUE_FLAG_MASK        = 0x00010000L;
    constexpr unsigned int CP_EDC_FUE_CNTL__CP_FUE_MASK_MASK        = 0x00000001L;
    constexpr unsigned int CP_EDC_FUE_CNTL__GDS_FUE_FLAG_MASK       = 0x00040000L;
    constexpr unsigned int CP_EDC_FUE_CNTL__GDS_FUE_MASK_MASK       = 0x00000004L;
    constexpr unsigned int CP_EDC_FUE_CNTL__SPI_FUE_FLAG_MASK       = 0x00020000L;
    constexpr unsigned int CP_EDC_FUE_CNTL__SPI_FUE_MASK_MASK       = 0x00000002L;
    constexpr unsigned int CP_EDC_FUE_CNTL__TCA_FUE_FLAG_MASK       = 0x00200000L;
    constexpr unsigned int CP_EDC_FUE_CNTL__TCA_FUE_MASK_MASK       = 0x00000020L;
    constexpr unsigned int CP_EDC_FUE_CNTL__TCC_FUE_FLAG_MASK       = 0x00400000L;
    constexpr unsigned int CP_EDC_FUE_CNTL__TCC_FUE_MASK_MASK       = 0x00000040L;
    constexpr unsigned int CP_EDC_FUE_CNTL__TC_CPG_FUE_FLAG_MASK    = 0x00100000L;
    constexpr unsigned int CP_EDC_FUE_CNTL__TC_CPG_FUE_MASK_MASK    = 0x00000010L;
    constexpr unsigned int CP_EDC_FUE_CNTL__TC_RLC_FUE_FLAG_MASK    = 0x00080000L;
    constexpr unsigned int CP_EDC_FUE_CNTL__TC_RLC_FUE_MASK_MASK    = 0x00000008L;
    constexpr unsigned int CP_EDC_FUE_CNTL__UTCL2_FUE_FLAG_MASK     = 0x00800000L;
    constexpr unsigned int CP_EDC_FUE_CNTL__UTCL2_FUE_MASK_MASK     = 0x00000080L;
    constexpr unsigned int DB_DEBUG4__DB_EXTRA_DEBUG4_MASK          = 0x3ff80000L;
    constexpr unsigned int DB_DEBUG4__DISABLE_8PPC_OBJPRIMID_WHEN_NO_SHADER_EXPORTS_MASK = 0x40000000L;
    constexpr unsigned int GC_CAC_ACC_CBR0__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CBR1__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CBR2__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CBR3__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU5__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU6__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU7__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU8__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU9__ACCUMULATOR_31_0_MASK    = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU10__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU11__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU12__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU13__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU14__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_CU15__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_DBR0__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_DBR1__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_DBR2__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_ACC_DBR3__ACCUMULATOR_31_0_MASK   = 0xffffffffL;
    constexpr unsigned int GC_CAC_CNTL__CAC_FORCE_DISABLE_MASK      = 0x00000001L;
    constexpr unsigned int GC_CAC_INDEX_AUTO_INCR_EN__GC_CAC_INDEX_AUTO_INCR_EN_MASK = 0x00000001L;
    constexpr unsigned int GC_CAC_OVRD_CBR__OVRRD_SELECT_MASK       = 0x0000000fL;
    constexpr unsigned int GC_CAC_OVRD_CBR__OVRRD_VALUE_MASK        = 0x000000f0L;
    constexpr unsigned int GC_CAC_OVRD_DBR__OVRRD_SELECT_MASK       = 0x0000000fL;
    constexpr unsigned int GC_CAC_OVRD_DBR__OVRRD_VALUE_MASK        = 0x000000f0L;
    constexpr unsigned int GC_CAC_WEIGHT_CBR_0__WEIGHT_CBR_SIG0_MASK = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_CBR_0__WEIGHT_CBR_SIG1_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_CBR_1__WEIGHT_CBR_SIG2_MASK = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_CBR_1__WEIGHT_CBR_SIG3_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_DBR_0__WEIGHT_DBR_SIG0_MASK = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_DBR_0__WEIGHT_DBR_SIG1_MASK = 0xffff0000L;
    constexpr unsigned int GC_CAC_WEIGHT_DBR_1__WEIGHT_DBR_SIG2_MASK = 0x0000ffffL;
    constexpr unsigned int GC_CAC_WEIGHT_DBR_1__WEIGHT_DBR_SIG3_MASK = 0xffff0000L;
    constexpr unsigned int GC_DIDT_CTRL0__DIDT_PSM_SELECTION_MASK   = 0x00000200L;
    constexpr unsigned int GC_DIDT_WEIGHT_1__DBR_WEIGHT_MASK        = 0x000000ffL;
    constexpr unsigned int GC_EDC_CTRL__EDC_PSM_SELECTION_MASK      = 0x00000400L;
    constexpr unsigned int GC_EDC_CTRL__EDC_THROTTLE_PATTERN_BIT_NUMS_MASK = 0x0000f000L;
    constexpr unsigned int GC_EDC_CTRL__GC_EDC_ONLY_MODE_MASK       = 0x00000800L;
    constexpr unsigned int GC_EDC_CTRL__PCC_THROTTLE_PATTERN_BIT_NUMS_MASK = 0x000f0000L;
    constexpr unsigned int GC_EDC_CTRL__RELEASE_STEP_INTERVAL_MASK  = 0x3ff00000L;
    constexpr unsigned int GC_EDC_PERF_COUNTER__EDC_PERF_COUNTER_MASK = 0xffffffffL;
    constexpr unsigned int GC_EDC_STATUS__THROTTLE_PATTERN_INDEX_MASK = 0xfc000000L;
    constexpr unsigned int GC_THROTTLE_CTRL__GC_EDC_OVERRIDE_MASK   = 0x00000070L;
    constexpr unsigned int GC_THROTTLE_CTRL__GC_EDC_PERF_COUNTER_EN_MASK = 0x00000100L;
    constexpr unsigned int GC_THROTTLE_CTRL__GC_EDC_STALL_EN_MASK   = 0x00000002L;
    constexpr unsigned int GC_THROTTLE_CTRL__INST_THROT_DECR_MASK   = 0x80000000L;
    constexpr unsigned int GC_THROTTLE_CTRL__INST_THROT_INCR_MASK   = 0x40000000L;
    constexpr unsigned int GC_THROTTLE_CTRL__PATTERN_MODE_MASK      = 0x00000008L;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_FIXED_PATTERN_MAX_MASK = 0x3e000000L;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_FIXED_PATTERN_MIN_MASK = 0x01f00000L;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_OVERRIDE_MASK      = 0x00000080L;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_PERF_COUNTER_EN_MASK = 0x00000200L;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_STALL_EN_MASK      = 0x00000004L;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_THROT_INCR_STEP_INTERVAL_MASK = 0x000ffc00L;
    constexpr unsigned int GC_THROTTLE_CTRL__THROTTLE_CTRL_SW_RST_MASK = 0x00000001L;
    constexpr unsigned int gws_DEBUG_DATA__credit_cnt_MASK          = 0x00010000L;
    constexpr unsigned int gws_DEBUG_DATA__cur_reso_5to0_MASK       = 0x000001f8L;
    constexpr unsigned int gws_DEBUG_DATA__cur_reso_count_MASK      = 0x00008000L;
    constexpr unsigned int gws_DEBUG_DATA__Reserved0_MASK           = 0xff000000L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_PF_MASK = 0x80000000L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF0_MASK = 0x00000001L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF1_MASK = 0x00000002L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF2_MASK = 0x00000004L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF3_MASK = 0x00000008L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF4_MASK = 0x00000010L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF5_MASK = 0x00000020L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF6_MASK = 0x00000040L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF7_MASK = 0x00000080L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF8_MASK = 0x00000100L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF9_MASK = 0x00000200L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF10_MASK = 0x00000400L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF11_MASK = 0x00000800L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF12_MASK = 0x00001000L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF13_MASK = 0x00002000L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF14_MASK = 0x00004000L;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF15_MASK = 0x00008000L;
    constexpr unsigned int MC_VM_XGMI_LFB_CNTL__PF_LFB_REGION_MASK  = 0x00000007L;
    constexpr unsigned int MC_VM_XGMI_LFB_CNTL__PF_MAX_REGION_MASK  = 0x00000070L;
    constexpr unsigned int MC_VM_XGMI_LFB_SIZE__PF_LFB_SIZE_MASK    = 0x0000ffffL;
    constexpr unsigned int oa_wc0_DEBUG_DATA__credit_cnt_MASK       = 0x00000002L;
    constexpr unsigned int oa_wc0_DEBUG_DATA__req_MASK              = 0x0007ff00L;
    constexpr unsigned int oa_wc0_DEBUG_DATA__Reserved0_MASK        = 0xfff80000L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy0_MASK      = 0x00000800L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy1_MASK      = 0x00001000L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy2_MASK      = 0x00002000L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy3_MASK      = 0x00004000L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy4_MASK      = 0x00008000L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy5_MASK      = 0x00010000L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy6_MASK      = 0x00020000L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy7_MASK      = 0x00040000L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy_MASK       = 0x00000001L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe1_busy_MASK       = 0x00000002L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe2_busy_MASK       = 0x00000004L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe3_busy_MASK       = 0x00000008L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe4_busy_MASK       = 0x00000010L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe5_busy_MASK       = 0x00000020L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe6_busy_MASK       = 0x00000040L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe7_busy_MASK       = 0x00000080L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe8_busy_MASK       = 0x00000100L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe9_busy_MASK       = 0x00000200L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__Pipe10_busy_MASK      = 0x00000400L;
    constexpr unsigned int oa_wc1_DEBUG_DATA__Reserved0_MASK        = 0xfff80000L;
    constexpr unsigned int ord_app_DEBUG_DATA__fifo_busy_MASK       = 0x00000001L;
    constexpr unsigned int ord_app_DEBUG_DATA__ord_busy_MASK        = 0x00000002L;
    constexpr unsigned int ord_app_DEBUG_DATA__Reserved0_MASK       = 0x00000008L;
    constexpr unsigned int ord_app_DEBUG_DATA__Reserved1_MASK       = 0xfffff000L;
    constexpr unsigned int ord_app_DEBUG_DATA__sh0_cmd_fifo_empty_MASK = 0x00000010L;
    constexpr unsigned int ord_app_DEBUG_DATA__sh0_data_fifo_empty_MASK = 0x00000100L;
    constexpr unsigned int ord_app_DEBUG_DATA__sh1_cmd_fifo_empty_MASK = 0x00000020L;
    constexpr unsigned int ord_app_DEBUG_DATA__sh1_data_fifo_empty_MASK = 0x00000200L;
    constexpr unsigned int ord_app_DEBUG_DATA__sh2_cmd_fifo_empty_MASK = 0x00000040L;
    constexpr unsigned int ord_app_DEBUG_DATA__sh2_data_fifo_empty_MASK = 0x00000400L;
    constexpr unsigned int ord_app_DEBUG_DATA__sh3_cmd_fifo_empty_MASK = 0x00000080L;
    constexpr unsigned int ord_app_DEBUG_DATA__sh3_data_fifo_empty_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG00_0__ccgen_to_clipcc_fifo_empty_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG00_0__ccgen_to_clipcc_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG00_0__clipcode_fifo_fifo_empty_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG00_0__clipcode_fifo_full_MASK    = 0x00004000L;
    constexpr unsigned int PA_DEBUG00_0__clip_ga_bc_fifo_write_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG00_0__clip_to_ga_fifo_full_MASK  = 0x00000010L;
    constexpr unsigned int PA_DEBUG00_0__clip_to_ga_fifo_write_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG00_0__clip_to_outsm_fifo_empty_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG00_0__clip_to_outsm_fifo_full_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG00_0__clip_to_outsm_fifo_write_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG00_0__primic_to_clprim_fifo_empty_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG00_0__primic_to_clprim_fifo_full_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG00_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG00_0__su_clip_baryc_free_MASK    = 0x00000006L;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clipp_fifo_empty_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clipp_fifo_full_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clipp_fifo_write_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clips_fifo_empty_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clips_fifo_full_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG00_0__vte_out_clip_fifo_fifo_empty_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG00_0__vte_out_clip_fifo_fifo_full_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG00_0__vte_out_orig_fifo_fifo_empty_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG00_0__vte_out_orig_fifo_fifo_full_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG00_0__vte_out_orig_fifo_fifo_write_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG00_1__available_positions_MASK   = 0x00001fc0L;
    constexpr unsigned int PA_DEBUG00_1__ccgen_to_clipcc_fifo_full_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG00_1__ccgen_to_clipcc_write_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG00_1__current_state_MASK         = 0x00006000L;
    constexpr unsigned int PA_DEBUG00_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG00_1__statevar_bits_vs_out_ccdist0_vec_ena_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG00_1__statevar_bits_vs_out_ccdist1_vec_ena_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG00_1__sx0_receive_fifo_empty_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG00_1__sx0_receive_fifo_full_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG00_1__sx0_receive_fifo_write_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG00_1__vertex_fifo_empty_MASK     = 0x00008000L;
    constexpr unsigned int PA_DEBUG00_1__vertex_fifo_entriesavailable_MASK = 0x0000000fL;
    constexpr unsigned int PA_DEBUG00_1__vertex_fifo_full_MASK      = 0x00010000L;
    constexpr unsigned int PA_DEBUG00_1__vgt_to_ccgen_fifo_empty_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG00_1__vgt_to_ccgen_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG01_0__clip_extra_bc_valid_MASK   = 0x00000007L;
    constexpr unsigned int PA_DEBUG01_0__clip_ga_bc_fifo_write_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG01_0__clip_to_ga_fifo_write_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG01_0__clip_to_outsm_deallocate_slot_MASK = 0x00000e00L;
    constexpr unsigned int PA_DEBUG01_0__clip_to_outsm_null_primitive_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG01_0__clip_to_outsm_vertex_deallocate_MASK = 0x000001c0L;
    constexpr unsigned int PA_DEBUG01_0__clip_vert_vte_valid_MASK   = 0x00000020L;
    constexpr unsigned int PA_DEBUG01_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_fifo_fifo_advanceread_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_fifo_fifo_empty_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_rd_extra_bc_valid_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_rd_vertex_store_indx_MASK = 0x000c0000L;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_rd_vte_naninf_kill_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG01_0__vte_positions_vte_clip_vte_naninf_kill_0_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG01_0__vte_positions_vte_clip_vte_naninf_kill_1_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG01_0__vte_positions_vte_clip_vte_naninf_kill_2_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG01_1__ALWAYS_ZERO_MASK           = 0x000000ffL;
    constexpr unsigned int PA_DEBUG01_1__clip_extra_bc_valid_MASK   = 0x00000700L;
    constexpr unsigned int PA_DEBUG01_1__clip_ga_bc_fifo_write_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG01_1__clip_to_ga_fifo_write_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG01_1__clip_to_outsm_vertex_deallocate_MASK = 0x0000c000L;
    constexpr unsigned int PA_DEBUG01_1__clip_vert_vte_valid_MASK   = 0x00003800L;
    constexpr unsigned int PA_DEBUG01_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_fifo_fifo_advanceread_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_fifo_fifo_empty_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_rd_extra_bc_valid_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_rd_vertex_store_indx_MASK = 0x000c0000L;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_rd_vte_naninf_kill_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG02_0__clip_ga_bc_fifo_full_MASK  = 0x00040000L;
    constexpr unsigned int PA_DEBUG02_0__clip_ga_bc_fifo_write_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_clipga_extra_bc_coords_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_clipga_vte_naninf_kill_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_ga_fifo_full_MASK  = 0x00080000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_ga_fifo_write_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_clipped_prim_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_end_of_packet_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_fifo_advanceread_MASK = 0x40000000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_fifo_empty_MASK = 0x80000000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_first_prim_of_slot_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_null_primitive_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_vertex_store_indx_0_MASK = 0x00000f00L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_vertex_store_indx_1_MASK = 0x000000f0L;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_vertex_store_indx_2_MASK = 0x0000000fL;
    constexpr unsigned int PA_DEBUG02_1__clip_extra_bc_valid_MASK   = 0x00000007L;
    constexpr unsigned int PA_DEBUG02_1__clip_ga_bc_fifo_full_MASK  = 0x00040000L;
    constexpr unsigned int PA_DEBUG02_1__clip_ga_bc_fifo_write_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_ga_fifo_full_MASK  = 0x00080000L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_ga_fifo_write_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_clipped_prim_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_clip_seq_indx_MASK = 0x000000c0L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_fifo_advanceread_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_fifo_empty_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_null_primitive_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_vertex_store_indx_1_MASK = 0x0000f000L;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_vertex_store_indx_2_MASK = 0x00000f00L;
    constexpr unsigned int PA_DEBUG02_1__clip_vert_vte_valid_MASK   = 0x00000038L;
    constexpr unsigned int PA_DEBUG02_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_clip_code_or_MASK = 0x0000003fL;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_clip_primitive_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_deallocate_slot_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_end_of_packet_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_event_id_MASK = 0x00000fc0L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_first_prim_of_slot_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_state_var_indx_MASK = 0x00007000L;
    constexpr unsigned int PA_DEBUG03_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_clip_code_or_MASK = 0x00003fffL;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_deallocate_slot_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_end_of_packet_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_event_id_MASK = 0x0000c000L;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_first_prim_of_slot_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG03_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_param_cache_indx_0_MASK = 0x00000007L;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_vertex_store_indx_0_MASK = 0x001f8000L;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_vertex_store_indx_1_MASK = 0x00007e00L;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_vertex_store_indx_2_MASK = 0x000001f8L;
    constexpr unsigned int PA_DEBUG04_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_param_cache_indx_0_MASK = 0x000007ffL;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_vertex_store_indx_0_MASK = 0x001f0000L;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_vertex_store_indx_2_MASK = 0x0000f800L;
    constexpr unsigned int PA_DEBUG04_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_clip_code_or_MASK = 0x0000003fL;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_clip_primitive_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_deallocate_slot_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_end_of_packet_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_event_id_MASK = 0x00000fc0L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_first_prim_of_slot_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_state_var_indx_MASK = 0x00007000L;
    constexpr unsigned int PA_DEBUG05_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_clip_code_or_MASK = 0x00003fffL;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_deallocate_slot_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_end_of_packet_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_event_id_MASK = 0x0000c000L;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_first_prim_of_slot_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG05_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_param_cache_indx_0_MASK = 0x00000007L;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_vertex_store_indx_0_MASK = 0x001f8000L;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_vertex_store_indx_1_MASK = 0x00007e00L;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_vertex_store_indx_2_MASK = 0x000001f8L;
    constexpr unsigned int PA_DEBUG06_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_param_cache_indx_0_MASK = 0x000007ffL;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_vertex_store_indx_0_MASK = 0x001f0000L;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_vertex_store_indx_2_MASK = 0x0000f800L;
    constexpr unsigned int PA_DEBUG06_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_clip_code_or_MASK = 0x0000003fL;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_clip_primitive_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_deallocate_slot_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_end_of_packet_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_event_id_MASK = 0x00000fc0L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_first_prim_of_slot_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_state_var_indx_MASK = 0x00007000L;
    constexpr unsigned int PA_DEBUG07_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_clip_code_or_MASK = 0x00003fffL;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_deallocate_slot_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_end_of_packet_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_event_id_MASK = 0x0000c000L;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_first_prim_of_slot_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG07_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_param_cache_indx_0_MASK = 0x00000007L;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_vertex_store_indx_0_MASK = 0x001f8000L;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_vertex_store_indx_1_MASK = 0x00007e00L;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_vertex_store_indx_2_MASK = 0x000001f8L;
    constexpr unsigned int PA_DEBUG08_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_param_cache_indx_0_MASK = 0x000007ffL;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_vertex_store_indx_0_MASK = 0x001f0000L;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_vertex_store_indx_2_MASK = 0x0000f800L;
    constexpr unsigned int PA_DEBUG08_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_clip_code_or_MASK = 0x0000003fL;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_clip_primitive_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_deallocate_slot_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_end_of_packet_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_event_id_MASK = 0x00000fc0L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_first_prim_of_slot_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_state_var_indx_MASK = 0x00007000L;
    constexpr unsigned int PA_DEBUG09_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_clip_code_or_MASK = 0x00003fffL;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_deallocate_slot_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_end_of_packet_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_event_id_MASK = 0x0000c000L;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_first_prim_of_slot_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG09_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_param_cache_indx_0_MASK = 0x00000007L;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_vertex_store_indx_0_MASK = 0x001f8000L;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_vertex_store_indx_1_MASK = 0x00007e00L;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_vertex_store_indx_2_MASK = 0x000001f8L;
    constexpr unsigned int PA_DEBUG10_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_event_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_null_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_param_cache_indx_0_MASK = 0x000007ffL;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_vertex_store_indx_0_MASK = 0x001f0000L;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_vertex_store_indx_2_MASK = 0x0000f800L;
    constexpr unsigned int PA_DEBUG11_0__clipsm0_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x0000f000L;
    constexpr unsigned int PA_DEBUG11_0__clipsm0_clip_to_clipga_prim_valid_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG11_0__clipsm0_inc_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG11_0__clipsm1_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00000f00L;
    constexpr unsigned int PA_DEBUG11_0__clipsm1_clip_to_clipga_prim_valid_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG11_0__clipsm1_inc_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG11_0__clipsm2_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x000000f0L;
    constexpr unsigned int PA_DEBUG11_0__clipsm2_clip_to_clipga_prim_valid_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG11_0__clipsm2_inc_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG11_0__clipsm3_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x0000000fL;
    constexpr unsigned int PA_DEBUG11_0__clipsm3_clip_to_clipga_prim_valid_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG11_0__clipsm3_inc_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG11_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm0_clip_to_clipga_clip_primitive_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG11_1__clipsm0_clip_to_clipga_event_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG11_1__clipsm0_clip_to_clipga_prim_valid_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm0_inc_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm1_clip_to_clipga_clip_primitive_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG11_1__clipsm1_clip_to_clipga_event_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG11_1__clipsm1_clip_to_clipga_prim_valid_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm1_inc_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_clip_to_clipga_clip_primitive_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x0000f000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_clip_to_clipga_event_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_clip_to_clipga_prim_valid_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_inc_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_clip_to_clipga_clip_primitive_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00000f00L;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_clip_to_clipga_event_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_clip_to_clipga_prim_valid_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_inc_clip_to_clipga_clip_to_outsm_cnt_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG11_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG12_0__clipsm0_clprim_to_clip_clip_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG12_0__clipsm0_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG12_0__clipsm1_clprim_to_clip_clip_primitive_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG12_0__clipsm1_clprim_to_clip_prim_valid_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG12_0__clipsm2_clprim_to_clip_clip_primitive_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG12_0__clipsm2_clprim_to_clip_prim_valid_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG12_0__clipsm3_clprim_to_clip_clip_primitive_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG12_0__clipsm3_clprim_to_clip_prim_valid_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_available_clip_verts_MASK = 0x000003e0L;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_available_vte_out_clip_MASK = 0x0000001fL;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_seq_indx_load_MASK = 0x0000c000L;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_seq_indx_out_MASK = 0x00000c00L;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_seq_indx_vert_MASK = 0x00003000L;
    constexpr unsigned int PA_DEBUG12_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG12_1__ALWAYS_ZERO_MASK           = 0x000000ffL;
    constexpr unsigned int PA_DEBUG12_1__clipsm0_clprim_to_clip_clip_primitive_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG12_1__clipsm0_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG12_1__clipsm1_clprim_to_clip_clip_primitive_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG12_1__clipsm1_clprim_to_clip_prim_valid_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG12_1__clipsm2_clprim_to_clip_clip_primitive_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG12_1__clipsm2_clprim_to_clip_prim_valid_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG12_1__clipsm3_clprim_to_clip_clip_primitive_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG12_1__clipsm3_clprim_to_clip_prim_valid_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG12_1__clip_priority_available_clip_verts_MASK = 0x0000e000L;
    constexpr unsigned int PA_DEBUG12_1__clip_priority_available_vte_out_clip_MASK = 0x00001f00L;
    constexpr unsigned int PA_DEBUG12_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG13_0__ccgen_to_clipcc_fifo_empty_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG13_0__clipcc_vertex_store_indx_MASK = 0x00000030L;
    constexpr unsigned int PA_DEBUG13_0__clipcode_fifo_fifo_empty_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG13_0__clip_priority_seq_indx_out_cnt_MASK = 0x00001e00L;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_fifo_advanceread_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_fifo_contents_MASK = 0x001f0000L;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_fifo_full_MASK   = 0x00200000L;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_fifo_write_MASK  = 0x00800000L;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_rd_clipsm_wait_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_rd_orig_vertices_MASK = 0x00006000L;
    constexpr unsigned int PA_DEBUG13_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG13_0__vertval_bits_vertex_cc_next_valid_MASK = 0x0000000fL;
    constexpr unsigned int PA_DEBUG13_0__vte_out_orig_fifo_fifo_empty_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG13_1__clipcc_vertex_store_indx_MASK = 0x00003000L;
    constexpr unsigned int PA_DEBUG13_1__clipcode_fifo_fifo_empty_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG13_1__clprim_clip_primitive_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG13_1__clprim_cull_primitive_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG13_1__clprim_in_back_state_var_indx_MASK = 0x00000007L;
    constexpr unsigned int PA_DEBUG13_1__outsm_clr_fifo_advanceread_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG13_1__outsm_clr_fifo_contents_MASK = 0x001f0000L;
    constexpr unsigned int PA_DEBUG13_1__outsm_clr_fifo_full_MASK   = 0x00200000L;
    constexpr unsigned int PA_DEBUG13_1__outsm_clr_fifo_write_MASK  = 0x00800000L;
    constexpr unsigned int PA_DEBUG13_1__point_clip_candidate_MASK  = 0x00000008L;
    constexpr unsigned int PA_DEBUG13_1__prim_back_valid_MASK       = 0x00000080L;
    constexpr unsigned int PA_DEBUG13_1__prim_nan_kill_MASK         = 0x00000010L;
    constexpr unsigned int PA_DEBUG13_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG13_1__vertval_bits_vertex_cc_next_valid_MASK = 0x00000f00L;
    constexpr unsigned int PA_DEBUG13_1__vte_out_orig_fifo_fifo_empty_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_deallocate_slot_MASK = 0x0000e000L;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_end_of_packet_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_event_id_MASK = 0x003f0000L;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_event_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_first_prim_of_slot_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_vertex_store_indx_0_MASK = 0x000003f0L;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_vertex_store_indx_1_MASK = 0x0000000fL;
    constexpr unsigned int PA_DEBUG14_0__outputclprimtoclip_null_primitive_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG14_0__prim_back_valid_MASK       = 0x00800000L;
    constexpr unsigned int PA_DEBUG14_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_event_id_MASK = 0x003f0000L;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_event_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_vertex_store_indx_0_MASK = 0x0000f000L;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_vertex_store_indx_1_MASK = 0x00000fc0L;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_vertex_store_indx_2_MASK = 0x0000003fL;
    constexpr unsigned int PA_DEBUG14_1__prim_back_valid_MASK       = 0x00800000L;
    constexpr unsigned int PA_DEBUG14_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG15_0__primic_to_clprim_fifo_vertex_store_indx_0_MASK = 0x007c0000L;
    constexpr unsigned int PA_DEBUG15_0__primic_to_clprim_fifo_vertex_store_indx_1_MASK = 0x0003e000L;
    constexpr unsigned int PA_DEBUG15_0__primic_to_clprim_fifo_vertex_store_indx_2_MASK = 0x00001f00L;
    constexpr unsigned int PA_DEBUG15_0__primic_to_clprim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG15_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG15_0__vertval_bits_vertex_vertex_store_msb_MASK = 0x000000ffL;
    constexpr unsigned int PA_DEBUG15_1__primic_to_clprim_fifo_vertex_store_indx_0_MASK = 0x007c0000L;
    constexpr unsigned int PA_DEBUG15_1__primic_to_clprim_fifo_vertex_store_indx_1_MASK = 0x00030000L;
    constexpr unsigned int PA_DEBUG15_1__primic_to_clprim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG15_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG15_1__vertval_bits_vertex_vertex_store_msb_MASK = 0x0000ffffL;
    constexpr unsigned int PA_DEBUG16_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG16_0__sm0_clip_to_clipga_clip_to_outsm_cnt_eq0_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG16_0__sm0_clip_to_outsm_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG16_0__sm0_clip_vert_cnt_MASK     = 0x0000001fL;
    constexpr unsigned int PA_DEBUG16_0__sm0_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG16_0__sm0_current_state_MASK     = 0x0007f000L;
    constexpr unsigned int PA_DEBUG16_0__sm0_highest_priority_seq_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG16_0__sm0_inv_to_clip_data_valid_0_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG16_0__sm0_inv_to_clip_data_valid_1_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG16_0__sm0_outputcliptoga_0_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG16_0__sm0_vertex_clip_cnt_MASK   = 0x000003e0L;
    constexpr unsigned int PA_DEBUG16_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG16_1__sm0_clip_to_clipga_clip_to_outsm_cnt_eq0_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG16_1__sm0_clip_to_outsm_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG16_1__sm0_clip_vert_cnt_MASK     = 0x00001f00L;
    constexpr unsigned int PA_DEBUG16_1__sm0_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG16_1__sm0_current_state_MASK     = 0x00070000L;
    constexpr unsigned int PA_DEBUG16_1__sm0_highest_priority_seq_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG16_1__sm0_outputcliptoga_0_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG16_1__sm0_prim_end_state_MASK    = 0x0000007fL;
    constexpr unsigned int PA_DEBUG16_1__sm0_ps_expand_MASK         = 0x00000080L;
    constexpr unsigned int PA_DEBUG16_1__sm0_vertex_clip_cnt_MASK   = 0x0000e000L;
    constexpr unsigned int PA_DEBUG17_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG17_0__sm1_clip_to_clipga_clip_to_outsm_cnt_eq0_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG17_0__sm1_clip_to_outsm_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG17_0__sm1_clip_vert_cnt_MASK     = 0x0000001fL;
    constexpr unsigned int PA_DEBUG17_0__sm1_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG17_0__sm1_current_state_MASK     = 0x0007f000L;
    constexpr unsigned int PA_DEBUG17_0__sm1_highest_priority_seq_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG17_0__sm1_inv_to_clip_data_valid_0_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG17_0__sm1_inv_to_clip_data_valid_1_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG17_0__sm1_outputcliptoga_0_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG17_0__sm1_vertex_clip_cnt_MASK   = 0x000003e0L;
    constexpr unsigned int PA_DEBUG17_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG17_1__sm1_clip_to_clipga_clip_to_outsm_cnt_eq0_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG17_1__sm1_clip_to_outsm_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG17_1__sm1_clip_vert_cnt_MASK     = 0x00001f00L;
    constexpr unsigned int PA_DEBUG17_1__sm1_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG17_1__sm1_current_state_MASK     = 0x00070000L;
    constexpr unsigned int PA_DEBUG17_1__sm1_highest_priority_seq_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG17_1__sm1_outputcliptoga_0_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG17_1__sm1_prim_end_state_MASK    = 0x0000007fL;
    constexpr unsigned int PA_DEBUG17_1__sm1_ps_expand_MASK         = 0x00000080L;
    constexpr unsigned int PA_DEBUG17_1__sm1_vertex_clip_cnt_MASK   = 0x0000e000L;
    constexpr unsigned int PA_DEBUG18_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG18_0__sm2_clip_to_clipga_clip_to_outsm_cnt_eq0_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG18_0__sm2_clip_to_outsm_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG18_0__sm2_clip_vert_cnt_MASK     = 0x0000001fL;
    constexpr unsigned int PA_DEBUG18_0__sm2_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG18_0__sm2_current_state_MASK     = 0x0007f000L;
    constexpr unsigned int PA_DEBUG18_0__sm2_highest_priority_seq_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG18_0__sm2_inv_to_clip_data_valid_0_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG18_0__sm2_inv_to_clip_data_valid_1_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG18_0__sm2_outputcliptoga_0_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG18_0__sm2_vertex_clip_cnt_MASK   = 0x000003e0L;
    constexpr unsigned int PA_DEBUG18_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG18_1__sm2_clip_to_clipga_clip_to_outsm_cnt_eq0_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG18_1__sm2_clip_to_outsm_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG18_1__sm2_clip_vert_cnt_MASK     = 0x00001f00L;
    constexpr unsigned int PA_DEBUG18_1__sm2_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG18_1__sm2_current_state_MASK     = 0x00070000L;
    constexpr unsigned int PA_DEBUG18_1__sm2_highest_priority_seq_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG18_1__sm2_outputcliptoga_0_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG18_1__sm2_prim_end_state_MASK    = 0x0000007fL;
    constexpr unsigned int PA_DEBUG18_1__sm2_ps_expand_MASK         = 0x00000080L;
    constexpr unsigned int PA_DEBUG18_1__sm2_vertex_clip_cnt_MASK   = 0x0000e000L;
    constexpr unsigned int PA_DEBUG19_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG19_0__sm3_clip_to_clipga_clip_to_outsm_cnt_eq0_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG19_0__sm3_clip_to_outsm_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG19_0__sm3_clip_vert_cnt_MASK     = 0x0000001fL;
    constexpr unsigned int PA_DEBUG19_0__sm3_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG19_0__sm3_current_state_MASK     = 0x0007f000L;
    constexpr unsigned int PA_DEBUG19_0__sm3_highest_priority_seq_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG19_0__sm3_inv_to_clip_data_valid_0_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG19_0__sm3_inv_to_clip_data_valid_1_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG19_0__sm3_outputcliptoga_0_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG19_0__sm3_vertex_clip_cnt_MASK   = 0x000003e0L;
    constexpr unsigned int PA_DEBUG19_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG19_1__sm3_clip_to_clipga_clip_to_outsm_cnt_eq0_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG19_1__sm3_clip_to_outsm_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG19_1__sm3_clip_vert_cnt_MASK     = 0x00001f00L;
    constexpr unsigned int PA_DEBUG19_1__sm3_clprim_to_clip_prim_valid_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG19_1__sm3_current_state_MASK     = 0x00070000L;
    constexpr unsigned int PA_DEBUG19_1__sm3_highest_priority_seq_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG19_1__sm3_outputcliptoga_0_MASK  = 0x00400000L;
    constexpr unsigned int PA_DEBUG19_1__sm3_prim_end_state_MASK    = 0x0000007fL;
    constexpr unsigned int PA_DEBUG19_1__sm3_ps_expand_MASK         = 0x00000080L;
    constexpr unsigned int PA_DEBUG19_1__sm3_vertex_clip_cnt_MASK   = 0x0000e000L;
    constexpr unsigned int PA_DEBUG20_0__point_address_MASK         = 0x00000001L;
    constexpr unsigned int PA_DEBUG20_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_advance_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_aux_inc_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_aux_sel_MASK = 0x000c0000L;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_pci_MASK     = 0x0003ff00L;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_req_mask_MASK = 0x000000f0L;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_sp_id_MASK   = 0x00300000L;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_state_var_indx_MASK = 0x0000000eL;
    constexpr unsigned int PA_DEBUG20_1__point_address_MASK         = 0x000001c0L;
    constexpr unsigned int PA_DEBUG20_1__position_address_MASK      = 0x0000003fL;
    constexpr unsigned int PA_DEBUG20_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_advance_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_aux_inc_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_aux_sel_MASK = 0x000c0000L;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_pci_MASK     = 0x00030000L;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_req_mask_MASK = 0x0000f000L;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_sp_id_MASK   = 0x00300000L;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_state_var_indx_MASK = 0x00000e00L;
    constexpr unsigned int PA_DEBUG21_0__aux_sel_MASK               = 0x00003000L;
    constexpr unsigned int PA_DEBUG21_0__pasx_req_cnt_0_MASK        = 0x00f00000L;
    constexpr unsigned int PA_DEBUG21_0__pasx_req_cnt_1_MASK        = 0x000f0000L;
    constexpr unsigned int PA_DEBUG21_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG21_0__statevar_bits_disable_sp_MASK = 0x00000f00L;
    constexpr unsigned int PA_DEBUG21_0__statevar_bits_vs_out_misc_vec_ena_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG21_0__sx_pending_fifo_contents_MASK = 0x0000007cL;
    constexpr unsigned int PA_DEBUG21_0__sx_receive_indx_MASK       = 0x00000003L;
    constexpr unsigned int PA_DEBUG21_0__sx_to_pa_empty_0_MASK      = 0x00008000L;
    constexpr unsigned int PA_DEBUG21_0__sx_to_pa_empty_1_MASK      = 0x00004000L;
    constexpr unsigned int PA_DEBUG21_1__available_positions_MASK   = 0x0000007fL;
    constexpr unsigned int PA_DEBUG21_1__pasx_req_cnt_0_MASK        = 0x00f00000L;
    constexpr unsigned int PA_DEBUG21_1__pasx_req_cnt_1_MASK        = 0x000f0000L;
    constexpr unsigned int PA_DEBUG21_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG21_1__statevar_bits_vs_out_misc_vec_ena_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG21_1__sx_pending_fifo_contents_MASK = 0x00007c00L;
    constexpr unsigned int PA_DEBUG21_1__sx_receive_indx_MASK       = 0x00000380L;
    constexpr unsigned int PA_DEBUG22_0__req_active_verts_loaded_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG22_0__req_active_verts_MASK      = 0x00007f00L;
    constexpr unsigned int PA_DEBUG22_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG22_0__su_aux_MASK                = 0x00000001L;
    constexpr unsigned int PA_DEBUG22_0__sx_request_indx_MASK       = 0x0000007eL;
    constexpr unsigned int PA_DEBUG22_0__vgt_to_ccgen_active_verts_MASK = 0x00fc0000L;
    constexpr unsigned int PA_DEBUG22_0__vgt_to_ccgen_state_var_indx_MASK = 0x00038000L;
    constexpr unsigned int PA_DEBUG22_1__param_cache_base_MASK      = 0x0000007fL;
    constexpr unsigned int PA_DEBUG22_1__req_active_verts_loaded_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG22_1__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG22_1__su_aux_MASK                = 0x00000180L;
    constexpr unsigned int PA_DEBUG22_1__sx_request_indx_MASK       = 0x00007e00L;
    constexpr unsigned int PA_DEBUG22_1__vgt_to_ccgen_active_verts_MASK = 0x00fc0000L;
    constexpr unsigned int PA_DEBUG22_1__vgt_to_ccgen_state_var_indx_MASK = 0x00030000L;
    constexpr unsigned int PA_DEBUG23_0__ALWAYS_ZERO_MASK           = 0x000000c0L;
    constexpr unsigned int PA_DEBUG23_0__event_id_gated_1to0_MASK   = 0x00c00000L;
    constexpr unsigned int PA_DEBUG23_0__geom_busy_MASK             = 0x00200000L;
    constexpr unsigned int PA_DEBUG23_0__geom_enable_MASK           = 0x00008000L;
    constexpr unsigned int PA_DEBUG23_0__ge_stallb_MASK             = 0x00004000L;
    constexpr unsigned int PA_DEBUG23_0__pfifo_busy_MASK            = 0x00080000L;
    constexpr unsigned int PA_DEBUG23_0__pmode_state_MASK           = 0x00003f00L;
    constexpr unsigned int PA_DEBUG23_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG23_0__su_baryc_cntl_state_MASK   = 0x00000003L;
    constexpr unsigned int PA_DEBUG23_0__su_clip_baryc_free_MASK    = 0x00030000L;
    constexpr unsigned int PA_DEBUG23_0__su_clip_rtr_MASK           = 0x00040000L;
    constexpr unsigned int PA_DEBUG23_0__su_cntl_busy_MASK          = 0x00100000L;
    constexpr unsigned int PA_DEBUG23_0__su_cntl_state_MASK         = 0x0000003cL;
    constexpr unsigned int PA_DEBUG24_0__cl_dyn_sclk_vld_MASK       = 0x00000080L;
    constexpr unsigned int PA_DEBUG24_0__event_gated_MASK           = 0x00000010L;
    constexpr unsigned int PA_DEBUG24_0__event_id_gated_5to2_MASK   = 0x0000000fL;
    constexpr unsigned int PA_DEBUG24_0__pmode_prim_gated_MASK      = 0x00000020L;
    constexpr unsigned int PA_DEBUG24_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG24_0__su_dyn_sclk_vld_MASK       = 0x00000040L;
    constexpr unsigned int PA_DEBUG24_0__y_sort0_gated_23_8_MASK    = 0x00ffff00L;
    constexpr unsigned int PA_DEBUG25_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG25_0__x_sort0_gated_23_8_MASK    = 0x0000ffffL;
    constexpr unsigned int PA_DEBUG25_0__y_sort1_gated_15_8_MASK    = 0x00ff0000L;
    constexpr unsigned int PA_DEBUG26_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG26_0__x_sort1_gated_23_8_MASK    = 0x00ffff00L;
    constexpr unsigned int PA_DEBUG26_0__y_sort1_gated_23_16_MASK   = 0x000000ffL;
    constexpr unsigned int PA_DEBUG27_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG27_0__x_sort2_gated_15_8_MASK    = 0x00ff0000L;
    constexpr unsigned int PA_DEBUG27_0__y_sort2_gated_23_8_MASK    = 0x0000ffffL;
    constexpr unsigned int PA_DEBUG28_0__attr_indx_sort0_gated_MASK = 0x003fff00L;
    constexpr unsigned int PA_DEBUG28_0__backfacing_gated_MASK      = 0x00800000L;
    constexpr unsigned int PA_DEBUG28_0__null_prim_gated_MASK       = 0x00400000L;
    constexpr unsigned int PA_DEBUG28_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG28_0__x_sort2_gated_23to16_MASK  = 0x000000ffL;
    constexpr unsigned int PA_DEBUG29_0__attr_indx_sort2_gated_7to0_MASK = 0x00ff0000L;
    constexpr unsigned int PA_DEBUG29_0__clipped_gated_MASK         = 0x00000008L;
    constexpr unsigned int PA_DEBUG29_0__dealloc_slot_gated_MASK    = 0x00000070L;
    constexpr unsigned int PA_DEBUG29_0__diamond_rule_gated_MASK    = 0x00000300L;
    constexpr unsigned int PA_DEBUG29_0__eop_gated_MASK             = 0x00008000L;
    constexpr unsigned int PA_DEBUG29_0__fpov_gated_MASK            = 0x00006000L;
    constexpr unsigned int PA_DEBUG29_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG29_0__st_indx_gated_MASK         = 0x00000007L;
    constexpr unsigned int PA_DEBUG29_0__type_gated_MASK            = 0x00001c00L;
    constexpr unsigned int PA_DEBUG29_0__xmajor_gated_MASK          = 0x00000080L;
    constexpr unsigned int PA_DEBUG30_0__attr_indx_sort1_gated_MASK = 0x000fffc0L;
    constexpr unsigned int PA_DEBUG30_0__attr_indx_sort2_gated_13to8_MASK = 0x0000003fL;
    constexpr unsigned int PA_DEBUG30_0__pa_reg_sclk_vld_MASK       = 0x00800000L;
    constexpr unsigned int PA_DEBUG30_0__provoking_vtx_gated_MASK   = 0x00300000L;
    constexpr unsigned int PA_DEBUG30_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG30_0__valid_prim_gated_MASK      = 0x00400000L;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm0_clprim_to_clip_prim_valid_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm1_clprim_to_clip_prim_valid_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm2_clprim_to_clip_prim_valid_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm3_clprim_to_clip_prim_valid_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm_clip_to_outsm_fifo_write_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_outsm_clr_fifo_not_empty_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_primic_to_clprim_valid_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_MASK          = 0x00000100L;
    constexpr unsigned int PA_DEBUG31_0__PA0_SC0_send_q_MASK        = 0x00000008L;
    constexpr unsigned int PA_DEBUG31_0__PA0_SC1_send_q_MASK        = 0x00000010L;
    constexpr unsigned int PA_DEBUG31_0__PA_PA_pascDataOut_send0_q_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG31_0__PA_PA_pascDataOut_send1_q_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG31_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_geom_busy_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_hold_busy_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_pfifo_busy_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_su_cntl_busy_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_valid_prim_gated_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG31_0__su_busy_MASK               = 0x00000200L;
    constexpr unsigned int PA_DEBUG31_0__VGT_PA_clipp_send_q_MASK   = 0x00000004L;
    constexpr unsigned int PA_DEBUG31_0__VGT_PA_clips_send_q_MASK   = 0x00000002L;
    constexpr unsigned int PA_DEBUG31_0__VGT_PA_clipv_send_q_MASK   = 0x00000001L;
    constexpr unsigned int PA_DEBUG31_0__vte_busy_debug_ib_busy_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG31_0__vte_busy_debug_veu_busy_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG31_0__vte_busy_MASK              = 0x00000080L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_ccgen_to_clipcc_fifo_busy_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_ccgen_to_clipcc_fifo_write_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipcode_fifo_fifo_busy_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipcode_fifo_fifo_write_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipsm0_current_state_not_empty_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipsm1_current_state_not_empty_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipsm2_current_state_not_empty_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipsm3_current_state_not_empty_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clip_to_ga_bc_busy_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clip_to_ga_fifo_write_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clip_to_outsm_fifo_busy_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clip_to_outsm_fifo_write_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_next_prim_back_valid_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_primic_to_clprim_fifo_not_empty_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_primic_to_clprim_fifo_write_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_prim_back_valid_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_sx_pending_fifo_not_empty_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vgt_to_clipp_fifo_busy_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vgt_to_clipp_fifo_write_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vgt_to_clips_fifo_busy_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vte_out_clip_fifo_fifo_busy_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vte_out_clip_fifo_fifo_write_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vte_out_orig_fifo_fifo_busy_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vte_out_orig_fifo_fifo_write_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG32_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG33_0__clipper_busy_debug_vgt_to_clips_fifo_write_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG33_0__PA_SE3SC_freeze_MASK       = 0x00000010L;
    constexpr unsigned int PA_DEBUG33_0__Reserved0_MASK             = 0xffffffe0L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_busy_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_rtr_in_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_rtr_out_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_rts_in_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_rts_out_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_iclient_send_valid_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_iutcl1_send_ready_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_oclient_send_ready_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_outcl1_send_type_MASK = 0x00600000L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_outcl1_send_valid_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_outcl1_send_vmid_MASK = 0x001e0000L;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_tag_MASK = 0x000000ffL;
    constexpr unsigned int PA_DEBUG34_0__Reserved0_MASK             = 0xff800000L;
    constexpr unsigned int PA_DEBUG34_1__ngg_utcl1_debug00_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_busy_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_empty_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_full_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_read_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_write_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_iclient_send_valid_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_iutcl1_send_ready_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_oclient_send_ready_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_outcl1_send_type_MASK = 0x00600000L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_outcl1_send_valid_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_outcl1_send_vmid_MASK = 0x001e0000L;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_tag_MASK = 0x000000ffL;
    constexpr unsigned int PA_DEBUG35_0__Reserved0_MASK             = 0xff800000L;
    constexpr unsigned int PA_DEBUG35_1__ngg_utcl1_debug01_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_busy_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_empty_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_full_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_read_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_write_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_iclient_send_valid_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_iutcl1_send_ready_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_oclient_send_ready_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_outcl1_send_type_MASK = 0x00600000L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_outcl1_send_valid_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_outcl1_send_vmid_MASK = 0x001e0000L;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_tag_MASK = 0x000000ffL;
    constexpr unsigned int PA_DEBUG36_0__Reserved0_MASK             = 0xff800000L;
    constexpr unsigned int PA_DEBUG36_1__ngg_utcl1_debug02_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_busy_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_drop_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_io_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_mtype_MASK = 0x00003800L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_perf_cntr_en_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_rd_tmz_encr_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_snoop_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_space_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_tag_MASK = 0x03fc0000L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_vmid_MASK = 0x0003c000L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_rtr_in_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_rtr_out_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_rts_in_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_rts_out_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG37_0__Reserved0_MASK             = 0xfc000000L;
    constexpr unsigned int PA_DEBUG37_1__ngg_utcl1_debug03_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_busy_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_drop_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_io_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_mtype_MASK = 0x00003800L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_perf_cntr_en_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_rd_tmz_encr_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_snoop_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_space_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_tag_MASK = 0x03fc0000L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_vmid_MASK = 0x0003c000L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_rtr_in_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_rtr_out_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_rts_in_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_rts_out_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG38_0__Reserved0_MASK             = 0xfc000000L;
    constexpr unsigned int PA_DEBUG38_1__ngg_utcl1_debug04_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_busy_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_drop_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_io_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_mtype_MASK = 0x00003800L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_perf_cntr_en_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_rd_tmz_encr_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_snoop_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_space_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_tag_MASK = 0x03fc0000L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_vmid_MASK = 0x0003c000L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_rtr_in_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_rtr_out_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_rts_in_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_rts_out_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG39_0__Reserved0_MASK             = 0xfc000000L;
    constexpr unsigned int PA_DEBUG39_1__ngg_utcl1_debug05_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG40_0__ngg_debug_tc_request_arbiter_current_client_count_MASK = 0x00000003L;
    constexpr unsigned int PA_DEBUG40_0__ngg_debug_tc_request_arbiter_istream0_client_rts_MASK = 0x80000000L;
    constexpr unsigned int PA_DEBUG40_0__ngg_debug_tc_request_arbiter_istream0_client_tag_MASK = 0x3fc00000L;
    constexpr unsigned int PA_DEBUG40_0__ngg_debug_tc_request_arbiter_ostream0_client_rtr_MASK = 0x40000000L;
    constexpr unsigned int PA_DEBUG40_1__ngg_utcl1_debug06_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_credits_MASK = 0x0000007cL;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_credit_count_overflow_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_credit_count_underflow_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_data_rd_ptr_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_data_wr_ptr_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_irdreq_free_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_irdret_vld_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_irts_in_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_obusy_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_ooutstanding_tc_requests_exist_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_ordreq_clken_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_ordreq_send_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_ortr_in_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_outstanding_tc_requests_MASK = 0x1ff80000L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_reg_valid0_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_reg_valid1_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG41_0__Reserved0_MASK             = 0xe0000000L;
    constexpr unsigned int PA_DEBUG41_1__ngg_utcl1_debug07_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_current_dword_pointer_MASK = 0x00000f00L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_current_sideband_event_bit_set_MASK = 0x01000000L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_current_sideband_is_object_id_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_current_state_MASK = 0x00000038L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_have_available_sideband_tokens_MASK = 0x02000000L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_itc_return_empty_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_pending_subgroup_count_not_zero_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_pending_subgroup_count_range_MASK = 0x0001f000L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_sideband_tokens_not_max_value_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_sideband_tokens_overflow_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_sideband_tokens_underflow_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_valid_dword_count_MASK = 0x003e0000L;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_wait_counter_busy_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG42_0__Reserved0_MASK             = 0xfc000000L;
    constexpr unsigned int PA_DEBUG42_1__ngg_utcl1_debug08_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_current_state_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_osideband_active_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_ovmid_MASK = 0x0000000fL;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_sideband_pop_bit_fifo_busy_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_sideband_pop_bit_fifo_empty_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_sideband_pop_bit_fifo_full_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_vmid_fifo_busy_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_vmid_fifo_empty_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_vmid_fifo_full_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG43_0__Reserved0_MASK             = 0xfffff000L;
    constexpr unsigned int PA_DEBUG43_1__ngg_utcl1_debug09_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents0_MASK = 0x00000ff0L;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents0_overflow_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents0_underflow_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents1_MASK = 0x000ff000L;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents1_overflow_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents1_underflow_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG44_0__Reserved0_MASK             = 0xfff00000L;
    constexpr unsigned int PA_DEBUG44_1__ngg_utcl1_debug10_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_current_fetch_state_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_current_receive_finalt_dword_pointer_MASK = 0x07800000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_current_receive_first_dword_pointer_MASK = 0x00780000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_current_receive_state_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_final_receive_cacheline_this_subgroup_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_final_receive_dword_of_subgroup_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_have_available_index_tokens_MASK = 0x20000000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_receive_fifo_busy_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_receive_fifo_empty_MASK = 0x08000000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_receive_fifo_full_MASK = 0x10000000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_tokens_MASK = 0x000000fcL;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_tokens_overflow_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_tokens_underflow_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_prim_indices_fifo_busy_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_sideband_data_context_id_bits_MASK = 0x00007000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_sideband_data_eop_bit_MASK = 0x00008000L;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_sideband_data_event_bit_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG45_0__Reserved0_MASK             = 0xc0000000L;
    constexpr unsigned int PA_DEBUG45_1__ngg_utcl1_debug11_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_active_pos_req_fosg_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_another_pos_fetch_MASK = 0x00400000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_current_state_MASK = 0x00018000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_end_prev_diff_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_end_start_diff_MASK = 0x02000000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_have_available_position_tokens_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_ifetch_to_primic_p_fifo_full_MASK = 0x00200000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_ifetch_to_primic_s_fifo_full_MASK = 0x00100000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_ipa_to_wd_dealloc_index_full_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_iposreq_to_posrtn_s_fifo_full_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_iposreq_to_posrtn_v_fifo_full_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_packer_object_id_valid_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_packer_sideband_valid_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_position_tokens_overflow_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_position_tokens_underflow_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_prev_pos_cacheline_valid_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_prev_select_end_cacheline_address_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_busy_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_final_prim_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_first_prim_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_miss_count_MASK = 0x00000180L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_null_prim_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_prim_valid_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_start_prev_diff_MASK = 0x01000000L;
    constexpr unsigned int PA_DEBUG46_0__Reserved0_MASK             = 0xfc000000L;
    constexpr unsigned int PA_DEBUG46_1__ngg_utcl1_debug12_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_current_state_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_iinput_sideband_valid_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_eop_bit_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_event_bit_MASK = 0x00040000L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_event_id_MASK = 0x0001f800L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_event_second_cycle_MASK = 0x00020000L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_state_id_MASK = 0x00380000L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_stream_id_MASK = 0x00000300L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_output_prim_empty_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_prim_fifo_busy_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_prim_fifo_full_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_sideband_fifo_busy_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_sideband_fifo_empty_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_sideband_fifo_full_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG47_0__Reserved0_MASK             = 0xffc00000L;
    constexpr unsigned int PA_DEBUG47_1__ngg_utcl1_debug13_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_active_pos_return_cache_pos_index_MASK = 0x0000c000L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_active_pos_return_first_vert_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_active_pos_return_state_MASK = 0x00000600L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_cache_pos_index_MASK = 0x00001800L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_ifetch_to_sxif_fifo_full_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_ipa_to_wd_dealloc_position_full_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_itc_return_empty_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_oposreq_to_posrtn_s_fifo_full_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_oposreq_to_posrtn_v_fifo_full_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_posreq_to_posrtn_s_fifo_busy_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_posreq_to_posrtn_s_fifo_empty_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_posreq_to_posrtn_v_fifo_busy_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_posreq_to_posrtn_v_fifo_empty_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG48_0__Reserved0_MASK             = 0xffff0000L;
    constexpr unsigned int PA_DEBUG48_1__ngg_utcl1_debug14_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_crawler_busy_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_memreg0_busy_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_memreg1_busy_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_memreg2_busy_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_oreturn_empty_stream0_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_oreturn_empty_stream1_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_oreturn_empty_stream2_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_return_data_read_reg_full_stream0_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_return_data_read_reg_full_stream1_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_return_data_read_reg_full_stream2_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG49_0__Reserved0_MASK             = 0xfffffc00L;
    constexpr unsigned int PA_DEBUG49_1__ngg_utcl1_debug15_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_encountered_error_writing_to_busy_location_stream0_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_encountered_error_writing_to_busy_location_stream1_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_encountered_error_writing_to_busy_location_stream2_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_memory_data_valid_stream0_count_MASK = 0x000001f8L;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_memory_data_valid_stream1_count_MASK = 0x00007e00L;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_memory_data_valid_stream2_count_MASK = 0x007f8000L;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_obusy_MASK = 0x00800000L;
    constexpr unsigned int PA_DEBUG50_0__Reserved0_MASK             = 0xff000000L;
    constexpr unsigned int PA_DEBUG50_1__ngg_utcl1_debug16_MASK     = 0xffffffffL;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_amount_MASK = 0x0000ffe0L;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_fifo_busy_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_index_full_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_position_full_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_state_var_index_MASK = 0x00070000L;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_type_MASK = 0x00080000L;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_pa_to_wd_dealloc_fifo_empty_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_pa_to_wd_dealloc_fifo_read_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG51_0__Reserved0_MASK             = 0xfff00000L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_all_clean_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_current_state_MASK = 0x000e0000L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iindex_requester_idle_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iindex_utcl1_return_busy_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iindex_utcl1_send_busy_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_ioutstanding_tc_requests_exist_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iposition_requester_idle_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iposition_utcl1_return_busy_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iposition_utcl1_send_busy_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_isideband_requester_idle_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_isideband_utcl1_return_busy_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_isideband_utcl1_send_busy_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iutcl1_busy_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_oclean_MASK = 0x00010000L;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_vmid_count_MASK = 0x0000f000L;
    constexpr unsigned int PA_DEBUG52_0__Reserved0_MASK             = 0xfff00000L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_index_tokens_overflow_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_index_tokens_underflow_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_position_tokens_overflow_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_position_tokens_underflow_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sbmem_contents0_overflow_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sbmem_contents0_underflow_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sbmem_contents1_overflow_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sbmem_contents1_underflow_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sideband_tokens_overflow_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sideband_tokens_underflow_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_tc_credit_count_overflow_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_tc_credit_count_underflow_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_writing_to_busy_location_stream0_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_writing_to_busy_location_stream1_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_writing_to_busy_location_stream2_MASK = 0x00004000L;
    constexpr unsigned int PA_DEBUG53_0__Reserved0_MASK             = 0xffff8000L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_index_receive_fifo_full_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_pa_to_wd_dealloc_index_full_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_pa_to_wd_dealloc_position_full_MASK = 0x00002000L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_posreq_to_posrtn_s_fifo_full_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_posreq_to_posrtn_v_fifo_full_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_prim_fifo_full_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_prim_indices_fifo_full_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_return_data_full_stream0_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_return_data_full_stream1_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_return_data_full_stream2_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_sbmem_full_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_sideband_fifo_full_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_sideband_pop_bit_fifo_full_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_vmid_fifo_full_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG54_0__Reserved0_MASK             = 0xffffc000L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_index_receive_fifo_empty_MASK = 0x00000008L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_pa_to_wd_dealloc_fifo_empty_MASK = 0x00001000L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_posreq_to_posrtn_s_fifo_empty_MASK = 0x00000100L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_posreq_to_posrtn_v_fifo_empty_MASK = 0x00000080L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_prim_fifo_empty_MASK = 0x00000020L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_prim_indices_fifo_empty_MASK = 0x00000010L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_return_data_empty_stream0_MASK = 0x00000200L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_return_data_empty_stream1_MASK = 0x00000400L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_return_data_empty_stream2_MASK = 0x00000800L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_sbmem_empty_MASK = 0x00000004L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_sideband_fifo_empty_MASK = 0x00000040L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_sideband_pop_bit_fifo_empty_MASK = 0x00000001L;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_vmid_fifo_empty_MASK = 0x00000002L;
    constexpr unsigned int PA_DEBUG55_0__Reserved0_MASK             = 0xffffe000L;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_SC_SEND_DB_VPZ_FOR_COMPOUND_INDEX_EN_MASK = 0x00000040L;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_SC_SEND_DB_VPZ_FOR_EN_PIPELINE_PRIMID_MASK = 0x00000080L;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_0_MASK         = 0x00000001L;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_1_MASK         = 0x00000002L;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_2_MASK         = 0x00000004L;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_3_MASK         = 0x00000008L;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_4_MASK         = 0x00000010L;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_5_MASK         = 0x00000020L;
    constexpr unsigned int PA_SC_ENHANCE_2__RSVD_MASK               = 0xffffff00L;
    constexpr unsigned int PA_STATE_STEREO_X__STEREO_X_OFFSET_MASK  = 0xffffffffL;
    constexpr unsigned int PA_STEREO_CNTL__EN_STEREO_MASK           = 0x00000001L;
    constexpr unsigned int PA_STEREO_CNTL__RT_SLICE_MODE_MASK       = 0x000000e0L;
    constexpr unsigned int PA_STEREO_CNTL__RT_SLICE_OFFSET_MASK     = 0x00000300L;
    constexpr unsigned int PA_STEREO_CNTL__STEREO_MODE_MASK         = 0x0000001eL;
    constexpr unsigned int PA_STEREO_CNTL__VP_ID_MODE_MASK          = 0x00001c00L;
    constexpr unsigned int PA_STEREO_CNTL__VP_ID_OFFSET_MASK        = 0x0001e000L;
    constexpr unsigned int rbuf_DEBUG_DATA__pixel_addr_mask_MASK    = 0x0001fffcL;
    constexpr unsigned int rbuf_DEBUG_DATA__Reserved0_MASK          = 0xff000000L;
    constexpr unsigned int RLC_SPM_CBR0_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_CBR0_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_CBR1_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_CBR1_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_DBR0_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_DBR0_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RLC_SPM_DBR1_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY_MASK = 0x000000ffL;
    constexpr unsigned int RLC_SPM_DBR1_PERFMON_SAMPLE_DELAY__RESERVED_MASK = 0xffffff00L;
    constexpr unsigned int RPB_EA_QUEUE_WR__EA_NUMBER_MASK          = 0x0000003fL;
    constexpr unsigned int RPB_EA_QUEUE_WR__READ_QUEUE_MASK         = 0x00000e00L;
    constexpr unsigned int RPB_EA_QUEUE_WR__UPDATE_MASK             = 0x00001000L;
    constexpr unsigned int RPB_EA_QUEUE_WR__WRITE_QUEUE_MASK        = 0x000001c0L;
    constexpr unsigned int RPB_TAG_CONF__RPB_ATS_PR_MASK            = 0x3ff00000L;
    constexpr unsigned int RPB_TAG_CONF__RPB_ATS_TR_MASK            = 0x000003ffL;
    constexpr unsigned int RPB_TAG_CONF__RPB_IO_WR_MASK             = 0x000ffc00L;
    constexpr unsigned int SQ_CONFIG__DISABLE_BARRIER_WAITCNT_MASK  = 0x00000001L;
    constexpr unsigned int SQ_CONFIG__UNUSED_MASK                   = 0x0000007eL;
    constexpr unsigned int TA_DSM_CNTL2__TA_FL_LFIFO_ENABLE_ERROR_INJECT_MASK = 0x000000c0L;
    constexpr unsigned int TA_DSM_CNTL2__TA_FL_LFIFO_SELECT_INJECT_DELAY_MASK = 0x00000100L;
    constexpr unsigned int TA_DSM_CNTL2__TA_FS_AFIFO_ENABLE_ERROR_INJECT_MASK = 0x00000018L;
    constexpr unsigned int TA_DSM_CNTL2__TA_FS_AFIFO_SELECT_INJECT_DELAY_MASK = 0x00000020L;
    constexpr unsigned int TA_DSM_CNTL2__TA_FS_CFIFO_ENABLE_ERROR_INJECT_MASK = 0x00003000L;
    constexpr unsigned int TA_DSM_CNTL2__TA_FS_CFIFO_SELECT_INJECT_DELAY_MASK = 0x00004000L;
    constexpr unsigned int TA_DSM_CNTL2__TA_FS_DFIFO_ENABLE_ERROR_INJECT_MASK = 0x00000003L;
    constexpr unsigned int TA_DSM_CNTL2__TA_FS_DFIFO_SELECT_INJECT_DELAY_MASK = 0x00000004L;
    constexpr unsigned int TA_DSM_CNTL2__TA_FX_LFIFO_ENABLE_ERROR_INJECT_MASK = 0x00000600L;
    constexpr unsigned int TA_DSM_CNTL2__TA_FX_LFIFO_SELECT_INJECT_DELAY_MASK = 0x00000800L;
    constexpr unsigned int TA_DSM_CNTL2__TA_INJECT_DELAY_MASK       = 0xfc000000L;
    constexpr unsigned int TA_DSM_CNTL__TA_FL_LFIFO_DSM_IRRITATOR_DATA_MASK = 0x000000c0L;
    constexpr unsigned int TA_DSM_CNTL__TA_FL_LFIFO_ENABLE_SINGLE_WRITE_MASK = 0x00000100L;
    constexpr unsigned int TA_DSM_CNTL__TA_FS_AFIFO_DSM_IRRITATOR_DATA_MASK = 0x00000018L;
    constexpr unsigned int TA_DSM_CNTL__TA_FS_AFIFO_ENABLE_SINGLE_WRITE_MASK = 0x00000020L;
    constexpr unsigned int TA_DSM_CNTL__TA_FS_CFIFO_DSM_IRRITATOR_DATA_MASK = 0x00003000L;
    constexpr unsigned int TA_DSM_CNTL__TA_FS_CFIFO_ENABLE_SINGLE_WRITE_MASK = 0x00004000L;
    constexpr unsigned int TA_DSM_CNTL__TA_FS_DFIFO_DSM_IRRITATOR_DATA_MASK = 0x00000003L;
    constexpr unsigned int TA_DSM_CNTL__TA_FS_DFIFO_ENABLE_SINGLE_WRITE_MASK = 0x00000004L;
    constexpr unsigned int TA_DSM_CNTL__TA_FX_LFIFO_DSM_IRRITATOR_DATA_MASK = 0x00000600L;
    constexpr unsigned int TA_DSM_CNTL__TA_FX_LFIFO_ENABLE_SINGLE_WRITE_MASK = 0x00000800L;
    constexpr unsigned int TA_EDC_CNT__TA_FL_LFIFO_SED_COUNT_MASK   = 0x000000c0L;
    constexpr unsigned int TA_EDC_CNT__TA_FS_AFIFO_SED_COUNT_MASK   = 0x00000030L;
    constexpr unsigned int TA_EDC_CNT__TA_FS_CFIFO_SED_COUNT_MASK   = 0x00000c00L;
    constexpr unsigned int TA_EDC_CNT__TA_FS_DFIFO_DED_COUNT_MASK   = 0x0000000cL;
    constexpr unsigned int TA_EDC_CNT__TA_FS_DFIFO_SEC_COUNT_MASK   = 0x00000003L;
    constexpr unsigned int TA_EDC_CNT__TA_FX_LFIFO_SED_COUNT_MASK   = 0x00000300L;
    constexpr unsigned int TCI_DSM_CNTL2__TCI_INJECT_DELAY_MASK     = 0xfc000000L;
    constexpr unsigned int TCI_DSM_CNTL2__WRITE_RAM_ENABLE_ERROR_INJECT_MASK = 0x00000003L;
    constexpr unsigned int TCI_DSM_CNTL2__WRITE_RAM_SELECT_INJECT_DELAY_MASK = 0x00000004L;
    constexpr unsigned int TCI_DSM_CNTL__WRITE_RAM_IRRITATOR_DATA_SEL_MASK = 0x00000003L;
    constexpr unsigned int TCI_DSM_CNTL__WRITE_RAM_IRRITATOR_SINGLE_WRITE_MASK = 0x00000004L;
    constexpr unsigned int TCI_EDC_CNT__WRITE_RAM_SED_COUNT_MASK    = 0x00000003L;
    constexpr unsigned int TD_EDC_CNT__CS_FIFO_SED_COUNT_MASK       = 0x00000300L;
    constexpr unsigned int TD_EDC_CNT__SS_FIFO_HI_DED_COUNT_MASK    = 0x000000c0L;
    constexpr unsigned int TD_EDC_CNT__SS_FIFO_HI_SEC_COUNT_MASK    = 0x00000030L;
    constexpr unsigned int TD_EDC_CNT__SS_FIFO_LO_DED_COUNT_MASK    = 0x0000000cL;
    constexpr unsigned int TD_EDC_CNT__SS_FIFO_LO_SEC_COUNT_MASK    = 0x00000003L;
    constexpr unsigned int VML2_MEM_ECC_CNTL__DED_COUNT_MASK        = 0x0000c000L;
    constexpr unsigned int VML2_MEM_ECC_CNTL__DSM_IRRITATOR_DATA_MASK = 0x000000c0L;
    constexpr unsigned int VML2_MEM_ECC_CNTL__ENABLE_ERROR_INJECT_MASK = 0x00000600L;
    constexpr unsigned int VML2_MEM_ECC_CNTL__ENABLE_SINGLE_WRITE_MASK = 0x00000100L;
    constexpr unsigned int VML2_MEM_ECC_CNTL__INJECT_DELAY_MASK     = 0x0000003fL;
    constexpr unsigned int VML2_MEM_ECC_CNTL__SEC_COUNT_MASK        = 0x00003000L;
    constexpr unsigned int VML2_MEM_ECC_CNTL__SELECT_INJECT_DELAY_MASK = 0x00000800L;
    constexpr unsigned int VML2_MEM_ECC_CNTL__TEST_FUE_MASK         = 0x00020000L;
    constexpr unsigned int VML2_MEM_ECC_CNTL__WRITE_COUNTERS_MASK   = 0x00010000L;
    constexpr unsigned int VML2_MEM_ECC_INDEX__INDEX_MASK           = 0x000000ffL;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__DED_COUNT_MASK = 0x0000c000L;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__DSM_IRRITATOR_DATA_MASK = 0x000000c0L;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__ENABLE_ERROR_INJECT_MASK = 0x00000600L;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__ENABLE_SINGLE_WRITE_MASK = 0x00000100L;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__INJECT_DELAY_MASK = 0x0000003fL;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__SEC_COUNT_MASK = 0x00003000L;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__SELECT_INJECT_DELAY_MASK = 0x00000800L;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__TEST_FUE_MASK  = 0x00020000L;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__WRITE_COUNTERS_MASK = 0x00010000L;
    constexpr unsigned int VML2_WALKER_MEM_ECC_INDEX__INDEX_MASK    = 0x000000ffL;
    constexpr unsigned int wbuf_DEBUG_DATA__cstate_3to0_MASK        = 0x0001e000L;
    constexpr unsigned int wbuf_DEBUG_DATA__Reserved0_MASK          = 0x0000003fL;
    constexpr unsigned int wbuf_DEBUG_DATA__Reserved1_MASK          = 0xffc00000L;
    constexpr unsigned int wbuf_DEBUG_DATA__wr_pixel_ptr_nxt_MASK   = 0x00000f80L;
} // namespace Vg20

