/*
 ***********************************************************************************************************************
 *
 *  Copyright (c) 2019 Advanced Micro Devices, Inc. All Rights Reserved.
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in all
 *  copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 *
 **********************************************************************************************************************/

#pragma once

constexpr unsigned int ATC_ATS_CNTL__CREDITS_ATS_RPB__SHIFT     = 0x00000008;
constexpr unsigned int ATC_ATS_CNTL__DISABLE_ATC__SHIFT         = 0x00000000;
constexpr unsigned int ATC_ATS_CNTL__DISABLE_PASID__SHIFT       = 0x00000002;
constexpr unsigned int ATC_ATS_CNTL__DISABLE_PRI__SHIFT         = 0x00000001;
constexpr unsigned int ATC_ATS_CNTL__INVALIDATION_LOG_KEEP_ORDER__SHIFT = 0x00000014;
constexpr unsigned int ATC_ATS_CNTL__TRANS_EXE_RETURN__SHIFT    = 0x00000016;
constexpr unsigned int ATC_ATS_CNTL__TRANS_LOG_KEEP_ORDER__SHIFT = 0x00000015;
constexpr unsigned int ATC_ATS_DEFAULT_PAGE_LOW__DEFAULT_PAGE__SHIFT = 0x00000000;
constexpr unsigned int ATC_ATS_FAULT_CNTL__FAULT_CRASH_TABLE__SHIFT = 0x00000014;
constexpr unsigned int ATC_ATS_FAULT_CNTL__FAULT_INTERRUPT_TABLE__SHIFT = 0x0000000a;
constexpr unsigned int ATC_ATS_FAULT_CNTL__FAULT_REGISTER_LOG__SHIFT = 0x00000000;
constexpr unsigned int ATC_ATS_FAULT_STATUS_ADDR__PAGE_ADDR__SHIFT = 0x00000000;
constexpr unsigned int ATC_ATS_FAULT_STATUS_INFO2__MMHUB_INV_VMID__SHIFT = 0x00000009;
constexpr unsigned int ATC_ATS_FAULT_STATUS_INFO2__VFID__SHIFT  = 0x00000001;
constexpr unsigned int ATC_ATS_FAULT_STATUS_INFO2__VF__SHIFT    = 0x00000000;
constexpr unsigned int ATC_ATS_FAULT_STATUS_INFO__EXTRA_INFO2__SHIFT = 0x00000010;
constexpr unsigned int ATC_ATS_FAULT_STATUS_INFO__EXTRA_INFO__SHIFT = 0x0000000f;
constexpr unsigned int ATC_ATS_FAULT_STATUS_INFO__FAULT_TYPE__SHIFT = 0x00000000;
constexpr unsigned int ATC_ATS_FAULT_STATUS_INFO__INVALIDATION__SHIFT = 0x00000011;
constexpr unsigned int ATC_ATS_FAULT_STATUS_INFO__PAGE_ADDR_HIGH__SHIFT = 0x00000018;
constexpr unsigned int ATC_ATS_FAULT_STATUS_INFO__PAGE_REQUEST__SHIFT = 0x00000012;
constexpr unsigned int ATC_ATS_FAULT_STATUS_INFO__STATUS__SHIFT = 0x00000013;
constexpr unsigned int ATC_ATS_FAULT_STATUS_INFO__VMID__SHIFT   = 0x0000000a;
constexpr unsigned int ATC_ATS_GFX_ATCL2_STATUS__POWERED_DOWN__SHIFT = 0x00000000;
constexpr unsigned int ATC_ATS_MMHUB_ATCL2_STATUS__POWERED_DOWN__SHIFT = 0x00000000;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__ATS_INV_CFG_MODE__SHIFT = 0x00000001;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__ATS_INV_HALT_THRESHOLD__SHIFT = 0x00000003;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__ATS_INV_SELF_ACTIVATE__SHIFT = 0x00000000;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_GFX_RDY_MODE__SHIFT = 0x0000000e;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_GFX_SDPVDCI_ORIGDATACKENRCV__SHIFT = 0x00000019;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_GFX_SDPVDCI_ORIGDATACKEN__SHIFT = 0x00000018;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_GFX_SDPVDCI_RDRSPCKENRCV__SHIFT = 0x00000011;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_GFX_SDPVDCI_RDRSPCKEN__SHIFT = 0x00000010;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_GFX_SDPVDCI_RDRSPDATACKENRCV__SHIFT = 0x00000013;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_GFX_SDPVDCI_RDRSPDATACKEN__SHIFT = 0x00000012;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_GFX_SDPVDCI_REQCKENRCV__SHIFT = 0x00000017;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_GFX_SDPVDCI_REQCKEN__SHIFT = 0x00000016;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_GFX_SDPVDCI_WRRSPCKENRCV__SHIFT = 0x00000015;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_GFX_SDPVDCI_WRRSPCKEN__SHIFT = 0x00000014;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_MMHUB_RDY_MODE__SHIFT = 0x0000000f;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_TRANS_HALT_THRESHOLD__SHIFT = 0x00000009;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_TRANS_PASSIVE_MODE__SHIFT = 0x0000000d;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_TRANS_QUICK_COMACK__SHIFT = 0x00000008;
constexpr unsigned int ATC_ATS_SDPPORT_CNTL__UTCL2_TRANS_SELF_ACTIVATE__SHIFT = 0x00000007;
constexpr unsigned int ATC_ATS_STATUS__BUSY__SHIFT              = 0x00000000;
constexpr unsigned int ATC_ATS_STATUS__CRASHED__SHIFT           = 0x00000001;
constexpr unsigned int ATC_ATS_STATUS__DEADLOCK_DETECTION__SHIFT = 0x00000002;
constexpr unsigned int ATC_ATS_STATUS__FLUSH_INVALIDATION_OUTSTANDING__SHIFT = 0x00000003;
constexpr unsigned int ATC_ATS_STATUS__NONFLUSH_INVALIDATION_OUTSTANDING__SHIFT = 0x00000006;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID0__SHIFT = 0x00000000;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID1__SHIFT = 0x00000001;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID2__SHIFT = 0x00000002;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID3__SHIFT = 0x00000003;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID4__SHIFT = 0x00000004;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID5__SHIFT = 0x00000005;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID6__SHIFT = 0x00000006;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID7__SHIFT = 0x00000007;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID8__SHIFT = 0x00000008;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID9__SHIFT = 0x00000009;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID10__SHIFT = 0x0000000a;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID11__SHIFT = 0x0000000b;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID12__SHIFT = 0x0000000c;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID13__SHIFT = 0x0000000d;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID14__SHIFT = 0x0000000e;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_GFX_STAT__VMID15__SHIFT = 0x0000000f;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID0__SHIFT = 0x00000000;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID1__SHIFT = 0x00000001;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID2__SHIFT = 0x00000002;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID3__SHIFT = 0x00000003;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID4__SHIFT = 0x00000004;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID5__SHIFT = 0x00000005;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID6__SHIFT = 0x00000006;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID7__SHIFT = 0x00000007;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID8__SHIFT = 0x00000008;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID9__SHIFT = 0x00000009;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID10__SHIFT = 0x0000000a;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID11__SHIFT = 0x0000000b;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID12__SHIFT = 0x0000000c;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID13__SHIFT = 0x0000000d;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID14__SHIFT = 0x0000000e;
constexpr unsigned int ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT__VMID15__SHIFT = 0x0000000f;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID0_OUTSTANDING__SHIFT = 0x00000000;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID1_OUTSTANDING__SHIFT = 0x00000001;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID2_OUTSTANDING__SHIFT = 0x00000002;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID3_OUTSTANDING__SHIFT = 0x00000003;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID4_OUTSTANDING__SHIFT = 0x00000004;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID5_OUTSTANDING__SHIFT = 0x00000005;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID6_OUTSTANDING__SHIFT = 0x00000006;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID7_OUTSTANDING__SHIFT = 0x00000007;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID8_OUTSTANDING__SHIFT = 0x00000008;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID9_OUTSTANDING__SHIFT = 0x00000009;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID10_OUTSTANDING__SHIFT = 0x0000000a;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID11_OUTSTANDING__SHIFT = 0x0000000b;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID12_OUTSTANDING__SHIFT = 0x0000000c;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID13_OUTSTANDING__SHIFT = 0x0000000d;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID14_OUTSTANDING__SHIFT = 0x0000000e;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID15_OUTSTANDING__SHIFT = 0x0000000f;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID16_OUTSTANDING__SHIFT = 0x00000010;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID17_OUTSTANDING__SHIFT = 0x00000011;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID18_OUTSTANDING__SHIFT = 0x00000012;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID19_OUTSTANDING__SHIFT = 0x00000013;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID20_OUTSTANDING__SHIFT = 0x00000014;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID21_OUTSTANDING__SHIFT = 0x00000015;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID22_OUTSTANDING__SHIFT = 0x00000016;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID23_OUTSTANDING__SHIFT = 0x00000017;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID24_OUTSTANDING__SHIFT = 0x00000018;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID25_OUTSTANDING__SHIFT = 0x00000019;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID26_OUTSTANDING__SHIFT = 0x0000001a;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID27_OUTSTANDING__SHIFT = 0x0000001b;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID28_OUTSTANDING__SHIFT = 0x0000001c;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID29_OUTSTANDING__SHIFT = 0x0000001d;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID30_OUTSTANDING__SHIFT = 0x0000001e;
constexpr unsigned int ATC_ATS_VMID_STATUS__VMID31_OUTSTANDING__SHIFT = 0x0000001f;
constexpr unsigned int ATC_PERFCOUNTER0_CFG__CLEAR__SHIFT       = 0x0000001d;
constexpr unsigned int ATC_PERFCOUNTER0_CFG__ENABLE__SHIFT      = 0x0000001c;
constexpr unsigned int ATC_PERFCOUNTER0_CFG__PERF_MODE__SHIFT   = 0x00000018;
constexpr unsigned int ATC_PERFCOUNTER0_CFG__PERF_SEL_END__SHIFT = 0x00000008;
constexpr unsigned int ATC_PERFCOUNTER0_CFG__PERF_SEL__SHIFT    = 0x00000000;
constexpr unsigned int ATC_PERFCOUNTER1_CFG__CLEAR__SHIFT       = 0x0000001d;
constexpr unsigned int ATC_PERFCOUNTER1_CFG__ENABLE__SHIFT      = 0x0000001c;
constexpr unsigned int ATC_PERFCOUNTER1_CFG__PERF_MODE__SHIFT   = 0x00000018;
constexpr unsigned int ATC_PERFCOUNTER1_CFG__PERF_SEL_END__SHIFT = 0x00000008;
constexpr unsigned int ATC_PERFCOUNTER1_CFG__PERF_SEL__SHIFT    = 0x00000000;
constexpr unsigned int ATC_PERFCOUNTER2_CFG__CLEAR__SHIFT       = 0x0000001d;
constexpr unsigned int ATC_PERFCOUNTER2_CFG__ENABLE__SHIFT      = 0x0000001c;
constexpr unsigned int ATC_PERFCOUNTER2_CFG__PERF_MODE__SHIFT   = 0x00000018;
constexpr unsigned int ATC_PERFCOUNTER2_CFG__PERF_SEL_END__SHIFT = 0x00000008;
constexpr unsigned int ATC_PERFCOUNTER2_CFG__PERF_SEL__SHIFT    = 0x00000000;
constexpr unsigned int ATC_PERFCOUNTER3_CFG__CLEAR__SHIFT       = 0x0000001d;
constexpr unsigned int ATC_PERFCOUNTER3_CFG__ENABLE__SHIFT      = 0x0000001c;
constexpr unsigned int ATC_PERFCOUNTER3_CFG__PERF_MODE__SHIFT   = 0x00000018;
constexpr unsigned int ATC_PERFCOUNTER3_CFG__PERF_SEL_END__SHIFT = 0x00000008;
constexpr unsigned int ATC_PERFCOUNTER3_CFG__PERF_SEL__SHIFT    = 0x00000000;
constexpr unsigned int ATC_PERFCOUNTER_HI__COMPARE_VALUE__SHIFT = 0x00000010;
constexpr unsigned int ATC_PERFCOUNTER_HI__COUNTER_HI__SHIFT    = 0x00000000;
constexpr unsigned int ATC_PERFCOUNTER_LO__COUNTER_LO__SHIFT    = 0x00000000;
constexpr unsigned int ATC_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL__SHIFT = 0x00000019;
constexpr unsigned int ATC_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY__SHIFT = 0x00000018;
constexpr unsigned int ATC_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT__SHIFT = 0x00000000;
constexpr unsigned int ATC_PERFCOUNTER_RSLT_CNTL__START_TRIGGER__SHIFT = 0x00000008;
constexpr unsigned int ATC_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE__SHIFT = 0x0000001a;
constexpr unsigned int ATC_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER__SHIFT = 0x00000010;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID0__SHIFT   = 0x00000000;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID1__SHIFT   = 0x00000001;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID2__SHIFT   = 0x00000002;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID3__SHIFT   = 0x00000003;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID4__SHIFT   = 0x00000004;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID5__SHIFT   = 0x00000005;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID6__SHIFT   = 0x00000006;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID7__SHIFT   = 0x00000007;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID8__SHIFT   = 0x00000008;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID9__SHIFT   = 0x00000009;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID10__SHIFT  = 0x0000000a;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID11__SHIFT  = 0x0000000b;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID12__SHIFT  = 0x0000000c;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID13__SHIFT  = 0x0000000d;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID14__SHIFT  = 0x0000000e;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID15__SHIFT  = 0x0000000f;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID16__SHIFT  = 0x00000010;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID17__SHIFT  = 0x00000011;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID18__SHIFT  = 0x00000012;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID19__SHIFT  = 0x00000013;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID20__SHIFT  = 0x00000014;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID21__SHIFT  = 0x00000015;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID22__SHIFT  = 0x00000016;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID23__SHIFT  = 0x00000017;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID24__SHIFT  = 0x00000018;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID25__SHIFT  = 0x00000019;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID26__SHIFT  = 0x0000001a;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID27__SHIFT  = 0x0000001b;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID28__SHIFT  = 0x0000001c;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID29__SHIFT  = 0x0000001d;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID30__SHIFT  = 0x0000001e;
constexpr unsigned int ATC_TRANS_FAULT_RSPCNTRL__VMID31__SHIFT  = 0x0000001f;
constexpr unsigned int ATC_VMID0_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID0_PASID_MAPPING__PASID__SHIFT    = 0x00000000;
constexpr unsigned int ATC_VMID0_PASID_MAPPING__VALID__SHIFT    = 0x0000001f;
constexpr unsigned int ATC_VMID1_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID1_PASID_MAPPING__PASID__SHIFT    = 0x00000000;
constexpr unsigned int ATC_VMID1_PASID_MAPPING__VALID__SHIFT    = 0x0000001f;
constexpr unsigned int ATC_VMID2_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID2_PASID_MAPPING__PASID__SHIFT    = 0x00000000;
constexpr unsigned int ATC_VMID2_PASID_MAPPING__VALID__SHIFT    = 0x0000001f;
constexpr unsigned int ATC_VMID3_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID3_PASID_MAPPING__PASID__SHIFT    = 0x00000000;
constexpr unsigned int ATC_VMID3_PASID_MAPPING__VALID__SHIFT    = 0x0000001f;
constexpr unsigned int ATC_VMID4_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID4_PASID_MAPPING__PASID__SHIFT    = 0x00000000;
constexpr unsigned int ATC_VMID4_PASID_MAPPING__VALID__SHIFT    = 0x0000001f;
constexpr unsigned int ATC_VMID5_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID5_PASID_MAPPING__PASID__SHIFT    = 0x00000000;
constexpr unsigned int ATC_VMID5_PASID_MAPPING__VALID__SHIFT    = 0x0000001f;
constexpr unsigned int ATC_VMID6_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID6_PASID_MAPPING__PASID__SHIFT    = 0x00000000;
constexpr unsigned int ATC_VMID6_PASID_MAPPING__VALID__SHIFT    = 0x0000001f;
constexpr unsigned int ATC_VMID7_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID7_PASID_MAPPING__PASID__SHIFT    = 0x00000000;
constexpr unsigned int ATC_VMID7_PASID_MAPPING__VALID__SHIFT    = 0x0000001f;
constexpr unsigned int ATC_VMID8_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID8_PASID_MAPPING__PASID__SHIFT    = 0x00000000;
constexpr unsigned int ATC_VMID8_PASID_MAPPING__VALID__SHIFT    = 0x0000001f;
constexpr unsigned int ATC_VMID9_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID9_PASID_MAPPING__PASID__SHIFT    = 0x00000000;
constexpr unsigned int ATC_VMID9_PASID_MAPPING__VALID__SHIFT    = 0x0000001f;
constexpr unsigned int ATC_VMID10_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID10_PASID_MAPPING__PASID__SHIFT   = 0x00000000;
constexpr unsigned int ATC_VMID10_PASID_MAPPING__VALID__SHIFT   = 0x0000001f;
constexpr unsigned int ATC_VMID11_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID11_PASID_MAPPING__PASID__SHIFT   = 0x00000000;
constexpr unsigned int ATC_VMID11_PASID_MAPPING__VALID__SHIFT   = 0x0000001f;
constexpr unsigned int ATC_VMID12_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID12_PASID_MAPPING__PASID__SHIFT   = 0x00000000;
constexpr unsigned int ATC_VMID12_PASID_MAPPING__VALID__SHIFT   = 0x0000001f;
constexpr unsigned int ATC_VMID13_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID13_PASID_MAPPING__PASID__SHIFT   = 0x00000000;
constexpr unsigned int ATC_VMID13_PASID_MAPPING__VALID__SHIFT   = 0x0000001f;
constexpr unsigned int ATC_VMID14_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID14_PASID_MAPPING__PASID__SHIFT   = 0x00000000;
constexpr unsigned int ATC_VMID14_PASID_MAPPING__VALID__SHIFT   = 0x0000001f;
constexpr unsigned int ATC_VMID15_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID15_PASID_MAPPING__PASID__SHIFT   = 0x00000000;
constexpr unsigned int ATC_VMID15_PASID_MAPPING__VALID__SHIFT   = 0x0000001f;
constexpr unsigned int ATC_VMID16_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID16_PASID_MAPPING__PASID__SHIFT   = 0x00000000;
constexpr unsigned int ATC_VMID16_PASID_MAPPING__VALID__SHIFT   = 0x0000001f;
constexpr unsigned int ATC_VMID17_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID17_PASID_MAPPING__PASID__SHIFT   = 0x00000000;
constexpr unsigned int ATC_VMID17_PASID_MAPPING__VALID__SHIFT   = 0x0000001f;
constexpr unsigned int ATC_VMID18_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID18_PASID_MAPPING__PASID__SHIFT   = 0x00000000;
constexpr unsigned int ATC_VMID18_PASID_MAPPING__VALID__SHIFT   = 0x0000001f;
constexpr unsigned int ATC_VMID19_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID19_PASID_MAPPING__PASID__SHIFT   = 0x00000000;
constexpr unsigned int ATC_VMID19_PASID_MAPPING__VALID__SHIFT   = 0x0000001f;
constexpr unsigned int ATC_VMID20_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID20_PASID_MAPPING__PASID__SHIFT   = 0x00000000;
constexpr unsigned int ATC_VMID20_PASID_MAPPING__VALID__SHIFT   = 0x0000001f;
constexpr unsigned int ATC_VMID21_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID21_PASID_MAPPING__PASID__SHIFT   = 0x00000000;
constexpr unsigned int ATC_VMID21_PASID_MAPPING__VALID__SHIFT   = 0x0000001f;
constexpr unsigned int ATC_VMID22_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID22_PASID_MAPPING__PASID__SHIFT   = 0x00000000;
constexpr unsigned int ATC_VMID22_PASID_MAPPING__VALID__SHIFT   = 0x0000001f;
constexpr unsigned int ATC_VMID23_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID23_PASID_MAPPING__PASID__SHIFT   = 0x00000000;
constexpr unsigned int ATC_VMID23_PASID_MAPPING__VALID__SHIFT   = 0x0000001f;
constexpr unsigned int ATC_VMID24_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID24_PASID_MAPPING__PASID__SHIFT   = 0x00000000;
constexpr unsigned int ATC_VMID24_PASID_MAPPING__VALID__SHIFT   = 0x0000001f;
constexpr unsigned int ATC_VMID25_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID25_PASID_MAPPING__PASID__SHIFT   = 0x00000000;
constexpr unsigned int ATC_VMID25_PASID_MAPPING__VALID__SHIFT   = 0x0000001f;
constexpr unsigned int ATC_VMID26_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID26_PASID_MAPPING__PASID__SHIFT   = 0x00000000;
constexpr unsigned int ATC_VMID26_PASID_MAPPING__VALID__SHIFT   = 0x0000001f;
constexpr unsigned int ATC_VMID27_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID27_PASID_MAPPING__PASID__SHIFT   = 0x00000000;
constexpr unsigned int ATC_VMID27_PASID_MAPPING__VALID__SHIFT   = 0x0000001f;
constexpr unsigned int ATC_VMID28_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID28_PASID_MAPPING__PASID__SHIFT   = 0x00000000;
constexpr unsigned int ATC_VMID28_PASID_MAPPING__VALID__SHIFT   = 0x0000001f;
constexpr unsigned int ATC_VMID29_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID29_PASID_MAPPING__PASID__SHIFT   = 0x00000000;
constexpr unsigned int ATC_VMID29_PASID_MAPPING__VALID__SHIFT   = 0x0000001f;
constexpr unsigned int ATC_VMID30_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID30_PASID_MAPPING__PASID__SHIFT   = 0x00000000;
constexpr unsigned int ATC_VMID30_PASID_MAPPING__VALID__SHIFT   = 0x0000001f;
constexpr unsigned int ATC_VMID31_PASID_MAPPING__NO_INVALIDATION__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID31_PASID_MAPPING__PASID__SHIFT   = 0x00000000;
constexpr unsigned int ATC_VMID31_PASID_MAPPING__VALID__SHIFT   = 0x0000001f;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID0_REMAPPING_FINISHED__SHIFT = 0x00000000;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID1_REMAPPING_FINISHED__SHIFT = 0x00000001;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID2_REMAPPING_FINISHED__SHIFT = 0x00000002;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID3_REMAPPING_FINISHED__SHIFT = 0x00000003;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID4_REMAPPING_FINISHED__SHIFT = 0x00000004;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID5_REMAPPING_FINISHED__SHIFT = 0x00000005;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID6_REMAPPING_FINISHED__SHIFT = 0x00000006;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID7_REMAPPING_FINISHED__SHIFT = 0x00000007;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID8_REMAPPING_FINISHED__SHIFT = 0x00000008;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID9_REMAPPING_FINISHED__SHIFT = 0x00000009;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID10_REMAPPING_FINISHED__SHIFT = 0x0000000a;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID11_REMAPPING_FINISHED__SHIFT = 0x0000000b;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID12_REMAPPING_FINISHED__SHIFT = 0x0000000c;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID13_REMAPPING_FINISHED__SHIFT = 0x0000000d;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID14_REMAPPING_FINISHED__SHIFT = 0x0000000e;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID15_REMAPPING_FINISHED__SHIFT = 0x0000000f;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID16_REMAPPING_FINISHED__SHIFT = 0x00000010;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID17_REMAPPING_FINISHED__SHIFT = 0x00000011;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID18_REMAPPING_FINISHED__SHIFT = 0x00000012;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID19_REMAPPING_FINISHED__SHIFT = 0x00000013;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID20_REMAPPING_FINISHED__SHIFT = 0x00000014;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID21_REMAPPING_FINISHED__SHIFT = 0x00000015;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID22_REMAPPING_FINISHED__SHIFT = 0x00000016;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID23_REMAPPING_FINISHED__SHIFT = 0x00000017;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID24_REMAPPING_FINISHED__SHIFT = 0x00000018;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID25_REMAPPING_FINISHED__SHIFT = 0x00000019;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID26_REMAPPING_FINISHED__SHIFT = 0x0000001a;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID27_REMAPPING_FINISHED__SHIFT = 0x0000001b;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID28_REMAPPING_FINISHED__SHIFT = 0x0000001c;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID29_REMAPPING_FINISHED__SHIFT = 0x0000001d;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID30_REMAPPING_FINISHED__SHIFT = 0x0000001e;
constexpr unsigned int ATC_VMID_PASID_MAPPING_UPDATE_STATUS__VMID31_REMAPPING_FINISHED__SHIFT = 0x0000001f;
constexpr unsigned int ATS_IH_CREDIT__CREDIT_VALUE__SHIFT       = 0x00000000;
constexpr unsigned int ATS_IH_CREDIT__IH_CLIENT_ID__SHIFT       = 0x00000010;
constexpr unsigned int BCI_DEBUG_READ__DATA__SHIFT              = 0x00000000;
constexpr unsigned int CB_BLEND0_CONTROL__ALPHA_COMB_FCN__SHIFT = 0x00000015;
constexpr unsigned int CB_BLEND0_CONTROL__ALPHA_DESTBLEND__SHIFT = 0x00000018;
constexpr unsigned int CB_BLEND0_CONTROL__ALPHA_SRCBLEND__SHIFT = 0x00000010;
constexpr unsigned int CB_BLEND0_CONTROL__COLOR_COMB_FCN__SHIFT = 0x00000005;
constexpr unsigned int CB_BLEND0_CONTROL__COLOR_DESTBLEND__SHIFT = 0x00000008;
constexpr unsigned int CB_BLEND0_CONTROL__COLOR_SRCBLEND__SHIFT = 0x00000000;
constexpr unsigned int CB_BLEND0_CONTROL__DISABLE_ROP3__SHIFT   = 0x0000001f;
constexpr unsigned int CB_BLEND0_CONTROL__ENABLE__SHIFT         = 0x0000001e;
constexpr unsigned int CB_BLEND0_CONTROL__SEPARATE_ALPHA_BLEND__SHIFT = 0x0000001d;
constexpr unsigned int CB_BLEND1_CONTROL__ALPHA_COMB_FCN__SHIFT = 0x00000015;
constexpr unsigned int CB_BLEND1_CONTROL__ALPHA_DESTBLEND__SHIFT = 0x00000018;
constexpr unsigned int CB_BLEND1_CONTROL__ALPHA_SRCBLEND__SHIFT = 0x00000010;
constexpr unsigned int CB_BLEND1_CONTROL__COLOR_COMB_FCN__SHIFT = 0x00000005;
constexpr unsigned int CB_BLEND1_CONTROL__COLOR_DESTBLEND__SHIFT = 0x00000008;
constexpr unsigned int CB_BLEND1_CONTROL__COLOR_SRCBLEND__SHIFT = 0x00000000;
constexpr unsigned int CB_BLEND1_CONTROL__DISABLE_ROP3__SHIFT   = 0x0000001f;
constexpr unsigned int CB_BLEND1_CONTROL__ENABLE__SHIFT         = 0x0000001e;
constexpr unsigned int CB_BLEND1_CONTROL__SEPARATE_ALPHA_BLEND__SHIFT = 0x0000001d;
constexpr unsigned int CB_BLEND2_CONTROL__ALPHA_COMB_FCN__SHIFT = 0x00000015;
constexpr unsigned int CB_BLEND2_CONTROL__ALPHA_DESTBLEND__SHIFT = 0x00000018;
constexpr unsigned int CB_BLEND2_CONTROL__ALPHA_SRCBLEND__SHIFT = 0x00000010;
constexpr unsigned int CB_BLEND2_CONTROL__COLOR_COMB_FCN__SHIFT = 0x00000005;
constexpr unsigned int CB_BLEND2_CONTROL__COLOR_DESTBLEND__SHIFT = 0x00000008;
constexpr unsigned int CB_BLEND2_CONTROL__COLOR_SRCBLEND__SHIFT = 0x00000000;
constexpr unsigned int CB_BLEND2_CONTROL__DISABLE_ROP3__SHIFT   = 0x0000001f;
constexpr unsigned int CB_BLEND2_CONTROL__ENABLE__SHIFT         = 0x0000001e;
constexpr unsigned int CB_BLEND2_CONTROL__SEPARATE_ALPHA_BLEND__SHIFT = 0x0000001d;
constexpr unsigned int CB_BLEND3_CONTROL__ALPHA_COMB_FCN__SHIFT = 0x00000015;
constexpr unsigned int CB_BLEND3_CONTROL__ALPHA_DESTBLEND__SHIFT = 0x00000018;
constexpr unsigned int CB_BLEND3_CONTROL__ALPHA_SRCBLEND__SHIFT = 0x00000010;
constexpr unsigned int CB_BLEND3_CONTROL__COLOR_COMB_FCN__SHIFT = 0x00000005;
constexpr unsigned int CB_BLEND3_CONTROL__COLOR_DESTBLEND__SHIFT = 0x00000008;
constexpr unsigned int CB_BLEND3_CONTROL__COLOR_SRCBLEND__SHIFT = 0x00000000;
constexpr unsigned int CB_BLEND3_CONTROL__DISABLE_ROP3__SHIFT   = 0x0000001f;
constexpr unsigned int CB_BLEND3_CONTROL__ENABLE__SHIFT         = 0x0000001e;
constexpr unsigned int CB_BLEND3_CONTROL__SEPARATE_ALPHA_BLEND__SHIFT = 0x0000001d;
constexpr unsigned int CB_BLEND4_CONTROL__ALPHA_COMB_FCN__SHIFT = 0x00000015;
constexpr unsigned int CB_BLEND4_CONTROL__ALPHA_DESTBLEND__SHIFT = 0x00000018;
constexpr unsigned int CB_BLEND4_CONTROL__ALPHA_SRCBLEND__SHIFT = 0x00000010;
constexpr unsigned int CB_BLEND4_CONTROL__COLOR_COMB_FCN__SHIFT = 0x00000005;
constexpr unsigned int CB_BLEND4_CONTROL__COLOR_DESTBLEND__SHIFT = 0x00000008;
constexpr unsigned int CB_BLEND4_CONTROL__COLOR_SRCBLEND__SHIFT = 0x00000000;
constexpr unsigned int CB_BLEND4_CONTROL__DISABLE_ROP3__SHIFT   = 0x0000001f;
constexpr unsigned int CB_BLEND4_CONTROL__ENABLE__SHIFT         = 0x0000001e;
constexpr unsigned int CB_BLEND4_CONTROL__SEPARATE_ALPHA_BLEND__SHIFT = 0x0000001d;
constexpr unsigned int CB_BLEND5_CONTROL__ALPHA_COMB_FCN__SHIFT = 0x00000015;
constexpr unsigned int CB_BLEND5_CONTROL__ALPHA_DESTBLEND__SHIFT = 0x00000018;
constexpr unsigned int CB_BLEND5_CONTROL__ALPHA_SRCBLEND__SHIFT = 0x00000010;
constexpr unsigned int CB_BLEND5_CONTROL__COLOR_COMB_FCN__SHIFT = 0x00000005;
constexpr unsigned int CB_BLEND5_CONTROL__COLOR_DESTBLEND__SHIFT = 0x00000008;
constexpr unsigned int CB_BLEND5_CONTROL__COLOR_SRCBLEND__SHIFT = 0x00000000;
constexpr unsigned int CB_BLEND5_CONTROL__DISABLE_ROP3__SHIFT   = 0x0000001f;
constexpr unsigned int CB_BLEND5_CONTROL__ENABLE__SHIFT         = 0x0000001e;
constexpr unsigned int CB_BLEND5_CONTROL__SEPARATE_ALPHA_BLEND__SHIFT = 0x0000001d;
constexpr unsigned int CB_BLEND6_CONTROL__ALPHA_COMB_FCN__SHIFT = 0x00000015;
constexpr unsigned int CB_BLEND6_CONTROL__ALPHA_DESTBLEND__SHIFT = 0x00000018;
constexpr unsigned int CB_BLEND6_CONTROL__ALPHA_SRCBLEND__SHIFT = 0x00000010;
constexpr unsigned int CB_BLEND6_CONTROL__COLOR_COMB_FCN__SHIFT = 0x00000005;
constexpr unsigned int CB_BLEND6_CONTROL__COLOR_DESTBLEND__SHIFT = 0x00000008;
constexpr unsigned int CB_BLEND6_CONTROL__COLOR_SRCBLEND__SHIFT = 0x00000000;
constexpr unsigned int CB_BLEND6_CONTROL__DISABLE_ROP3__SHIFT   = 0x0000001f;
constexpr unsigned int CB_BLEND6_CONTROL__ENABLE__SHIFT         = 0x0000001e;
constexpr unsigned int CB_BLEND6_CONTROL__SEPARATE_ALPHA_BLEND__SHIFT = 0x0000001d;
constexpr unsigned int CB_BLEND7_CONTROL__ALPHA_COMB_FCN__SHIFT = 0x00000015;
constexpr unsigned int CB_BLEND7_CONTROL__ALPHA_DESTBLEND__SHIFT = 0x00000018;
constexpr unsigned int CB_BLEND7_CONTROL__ALPHA_SRCBLEND__SHIFT = 0x00000010;
constexpr unsigned int CB_BLEND7_CONTROL__COLOR_COMB_FCN__SHIFT = 0x00000005;
constexpr unsigned int CB_BLEND7_CONTROL__COLOR_DESTBLEND__SHIFT = 0x00000008;
constexpr unsigned int CB_BLEND7_CONTROL__COLOR_SRCBLEND__SHIFT = 0x00000000;
constexpr unsigned int CB_BLEND7_CONTROL__DISABLE_ROP3__SHIFT   = 0x0000001f;
constexpr unsigned int CB_BLEND7_CONTROL__ENABLE__SHIFT         = 0x0000001e;
constexpr unsigned int CB_BLEND7_CONTROL__SEPARATE_ALPHA_BLEND__SHIFT = 0x0000001d;
constexpr unsigned int CB_BLEND_ALPHA__BLEND_ALPHA__SHIFT       = 0x00000000;
constexpr unsigned int CB_BLEND_BLUE__BLEND_BLUE__SHIFT         = 0x00000000;
constexpr unsigned int CB_BLEND_GREEN__BLEND_GREEN__SHIFT       = 0x00000000;
constexpr unsigned int CB_BLEND_RED__BLEND_RED__SHIFT           = 0x00000000;
constexpr unsigned int CB_CGTT_SCLK_CTRL__OFF_HYSTERESIS__SHIFT = 0x00000004;
constexpr unsigned int CB_CGTT_SCLK_CTRL__ON_DELAY__SHIFT       = 0x00000000;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_OVERRIDE0__SHIFT = 0x0000001f;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_OVERRIDE1__SHIFT = 0x0000001e;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_OVERRIDE2__SHIFT = 0x0000001d;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_OVERRIDE3__SHIFT = 0x0000001c;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_OVERRIDE4__SHIFT = 0x0000001b;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_OVERRIDE5__SHIFT = 0x0000001a;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_OVERRIDE6__SHIFT = 0x00000019;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_OVERRIDE7__SHIFT = 0x00000018;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE0__SHIFT = 0x00000017;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE1__SHIFT = 0x00000016;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE2__SHIFT = 0x00000015;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE3__SHIFT = 0x00000014;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE4__SHIFT = 0x00000013;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE5__SHIFT = 0x00000012;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE6__SHIFT = 0x00000011;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE7__SHIFT = 0x00000010;
constexpr unsigned int CB_COLOR0_ATTRIB2__MAX_MIP__SHIFT        = 0x0000001c;
constexpr unsigned int CB_COLOR0_ATTRIB2__MIP0_HEIGHT__SHIFT    = 0x00000000;
constexpr unsigned int CB_COLOR0_ATTRIB2__MIP0_WIDTH__SHIFT     = 0x0000000e;
constexpr unsigned int CB_COLOR0_ATTRIB__FORCE_DST_ALPHA_1__SHIFT = 0x00000011;
constexpr unsigned int CB_COLOR0_ATTRIB__NUM_FRAGMENTS__SHIFT   = 0x0000000f;
constexpr unsigned int CB_COLOR0_ATTRIB__NUM_SAMPLES__SHIFT     = 0x0000000c;
constexpr unsigned int CB_COLOR0_BASE_EXT__BASE_256B__SHIFT     = 0x00000000;
constexpr unsigned int CB_COLOR0_BASE__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR0_CLEAR_WORD0__CLEAR_WORD0__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR0_CLEAR_WORD1__CLEAR_WORD1__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR0_CMASK_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR0_CMASK__BASE_256B__SHIFT        = 0x00000000;
constexpr unsigned int CB_COLOR0_DCC_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR0_DCC_BASE__BASE_256B__SHIFT     = 0x00000000;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__COLOR_TRANSFORM__SHIFT = 0x00000007;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__INDEPENDENT_64B_BLOCKS__SHIFT = 0x00000009;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__KEY_CLEAR_ENABLE__SHIFT = 0x00000001;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__LOSSY_ALPHA_PRECISION__SHIFT = 0x0000000e;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__LOSSY_RGB_PRECISION__SHIFT = 0x0000000a;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000005;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE__SHIFT = 0x00000002;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__MIN_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000004;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR0_FMASK_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR0_FMASK__BASE_256B__SHIFT        = 0x00000000;
constexpr unsigned int CB_COLOR0_INFO__BLEND_BYPASS__SHIFT      = 0x00000010;
constexpr unsigned int CB_COLOR0_INFO__BLEND_CLAMP__SHIFT       = 0x0000000f;
constexpr unsigned int CB_COLOR0_INFO__BLEND_OPT_DISCARD_PIXEL__SHIFT = 0x00000017;
constexpr unsigned int CB_COLOR0_INFO__BLEND_OPT_DONT_RD_DST__SHIFT = 0x00000014;
constexpr unsigned int CB_COLOR0_INFO__CMASK_ADDR_TYPE__SHIFT   = 0x0000001d;
constexpr unsigned int CB_COLOR0_INFO__COMPRESSION__SHIFT       = 0x0000000e;
constexpr unsigned int CB_COLOR0_INFO__COMP_SWAP__SHIFT         = 0x0000000b;
constexpr unsigned int CB_COLOR0_INFO__DCC_ENABLE__SHIFT        = 0x0000001c;
constexpr unsigned int CB_COLOR0_INFO__ENDIAN__SHIFT            = 0x00000000;
constexpr unsigned int CB_COLOR0_INFO__FAST_CLEAR__SHIFT        = 0x0000000d;
constexpr unsigned int CB_COLOR0_INFO__FMASK_COMPRESSION_DISABLE__SHIFT = 0x0000001a;
constexpr unsigned int CB_COLOR0_INFO__FMASK_COMPRESS_1FRAG_ONLY__SHIFT = 0x0000001b;
constexpr unsigned int CB_COLOR0_INFO__FORMAT__SHIFT            = 0x00000002;
constexpr unsigned int CB_COLOR0_INFO__NUMBER_TYPE__SHIFT       = 0x00000008;
constexpr unsigned int CB_COLOR0_INFO__ROUND_MODE__SHIFT        = 0x00000012;
constexpr unsigned int CB_COLOR0_INFO__SIMPLE_FLOAT__SHIFT      = 0x00000011;
constexpr unsigned int CB_COLOR0_VIEW__SLICE_MAX__SHIFT         = 0x0000000d;
constexpr unsigned int CB_COLOR0_VIEW__SLICE_START__SHIFT       = 0x00000000;
constexpr unsigned int CB_COLOR1_ATTRIB2__MAX_MIP__SHIFT        = 0x0000001c;
constexpr unsigned int CB_COLOR1_ATTRIB2__MIP0_HEIGHT__SHIFT    = 0x00000000;
constexpr unsigned int CB_COLOR1_ATTRIB2__MIP0_WIDTH__SHIFT     = 0x0000000e;
constexpr unsigned int CB_COLOR1_ATTRIB__FORCE_DST_ALPHA_1__SHIFT = 0x00000011;
constexpr unsigned int CB_COLOR1_ATTRIB__NUM_FRAGMENTS__SHIFT   = 0x0000000f;
constexpr unsigned int CB_COLOR1_ATTRIB__NUM_SAMPLES__SHIFT     = 0x0000000c;
constexpr unsigned int CB_COLOR1_BASE_EXT__BASE_256B__SHIFT     = 0x00000000;
constexpr unsigned int CB_COLOR1_BASE__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR1_CLEAR_WORD0__CLEAR_WORD0__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR1_CLEAR_WORD1__CLEAR_WORD1__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR1_CMASK_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR1_CMASK__BASE_256B__SHIFT        = 0x00000000;
constexpr unsigned int CB_COLOR1_DCC_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR1_DCC_BASE__BASE_256B__SHIFT     = 0x00000000;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__COLOR_TRANSFORM__SHIFT = 0x00000007;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__INDEPENDENT_64B_BLOCKS__SHIFT = 0x00000009;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__KEY_CLEAR_ENABLE__SHIFT = 0x00000001;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__LOSSY_ALPHA_PRECISION__SHIFT = 0x0000000e;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__LOSSY_RGB_PRECISION__SHIFT = 0x0000000a;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000005;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE__SHIFT = 0x00000002;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__MIN_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000004;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR1_FMASK_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR1_FMASK__BASE_256B__SHIFT        = 0x00000000;
constexpr unsigned int CB_COLOR1_INFO__BLEND_BYPASS__SHIFT      = 0x00000010;
constexpr unsigned int CB_COLOR1_INFO__BLEND_CLAMP__SHIFT       = 0x0000000f;
constexpr unsigned int CB_COLOR1_INFO__BLEND_OPT_DISCARD_PIXEL__SHIFT = 0x00000017;
constexpr unsigned int CB_COLOR1_INFO__BLEND_OPT_DONT_RD_DST__SHIFT = 0x00000014;
constexpr unsigned int CB_COLOR1_INFO__CMASK_ADDR_TYPE__SHIFT   = 0x0000001d;
constexpr unsigned int CB_COLOR1_INFO__COMPRESSION__SHIFT       = 0x0000000e;
constexpr unsigned int CB_COLOR1_INFO__COMP_SWAP__SHIFT         = 0x0000000b;
constexpr unsigned int CB_COLOR1_INFO__DCC_ENABLE__SHIFT        = 0x0000001c;
constexpr unsigned int CB_COLOR1_INFO__ENDIAN__SHIFT            = 0x00000000;
constexpr unsigned int CB_COLOR1_INFO__FAST_CLEAR__SHIFT        = 0x0000000d;
constexpr unsigned int CB_COLOR1_INFO__FMASK_COMPRESSION_DISABLE__SHIFT = 0x0000001a;
constexpr unsigned int CB_COLOR1_INFO__FMASK_COMPRESS_1FRAG_ONLY__SHIFT = 0x0000001b;
constexpr unsigned int CB_COLOR1_INFO__FORMAT__SHIFT            = 0x00000002;
constexpr unsigned int CB_COLOR1_INFO__NUMBER_TYPE__SHIFT       = 0x00000008;
constexpr unsigned int CB_COLOR1_INFO__ROUND_MODE__SHIFT        = 0x00000012;
constexpr unsigned int CB_COLOR1_INFO__SIMPLE_FLOAT__SHIFT      = 0x00000011;
constexpr unsigned int CB_COLOR1_VIEW__SLICE_MAX__SHIFT         = 0x0000000d;
constexpr unsigned int CB_COLOR1_VIEW__SLICE_START__SHIFT       = 0x00000000;
constexpr unsigned int CB_COLOR2_ATTRIB2__MAX_MIP__SHIFT        = 0x0000001c;
constexpr unsigned int CB_COLOR2_ATTRIB2__MIP0_HEIGHT__SHIFT    = 0x00000000;
constexpr unsigned int CB_COLOR2_ATTRIB2__MIP0_WIDTH__SHIFT     = 0x0000000e;
constexpr unsigned int CB_COLOR2_ATTRIB__FORCE_DST_ALPHA_1__SHIFT = 0x00000011;
constexpr unsigned int CB_COLOR2_ATTRIB__NUM_FRAGMENTS__SHIFT   = 0x0000000f;
constexpr unsigned int CB_COLOR2_ATTRIB__NUM_SAMPLES__SHIFT     = 0x0000000c;
constexpr unsigned int CB_COLOR2_BASE_EXT__BASE_256B__SHIFT     = 0x00000000;
constexpr unsigned int CB_COLOR2_BASE__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR2_CLEAR_WORD0__CLEAR_WORD0__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR2_CLEAR_WORD1__CLEAR_WORD1__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR2_CMASK_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR2_CMASK__BASE_256B__SHIFT        = 0x00000000;
constexpr unsigned int CB_COLOR2_DCC_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR2_DCC_BASE__BASE_256B__SHIFT     = 0x00000000;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__COLOR_TRANSFORM__SHIFT = 0x00000007;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__INDEPENDENT_64B_BLOCKS__SHIFT = 0x00000009;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__KEY_CLEAR_ENABLE__SHIFT = 0x00000001;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__LOSSY_ALPHA_PRECISION__SHIFT = 0x0000000e;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__LOSSY_RGB_PRECISION__SHIFT = 0x0000000a;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000005;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE__SHIFT = 0x00000002;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__MIN_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000004;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR2_FMASK_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR2_FMASK__BASE_256B__SHIFT        = 0x00000000;
constexpr unsigned int CB_COLOR2_INFO__BLEND_BYPASS__SHIFT      = 0x00000010;
constexpr unsigned int CB_COLOR2_INFO__BLEND_CLAMP__SHIFT       = 0x0000000f;
constexpr unsigned int CB_COLOR2_INFO__BLEND_OPT_DISCARD_PIXEL__SHIFT = 0x00000017;
constexpr unsigned int CB_COLOR2_INFO__BLEND_OPT_DONT_RD_DST__SHIFT = 0x00000014;
constexpr unsigned int CB_COLOR2_INFO__CMASK_ADDR_TYPE__SHIFT   = 0x0000001d;
constexpr unsigned int CB_COLOR2_INFO__COMPRESSION__SHIFT       = 0x0000000e;
constexpr unsigned int CB_COLOR2_INFO__COMP_SWAP__SHIFT         = 0x0000000b;
constexpr unsigned int CB_COLOR2_INFO__DCC_ENABLE__SHIFT        = 0x0000001c;
constexpr unsigned int CB_COLOR2_INFO__ENDIAN__SHIFT            = 0x00000000;
constexpr unsigned int CB_COLOR2_INFO__FAST_CLEAR__SHIFT        = 0x0000000d;
constexpr unsigned int CB_COLOR2_INFO__FMASK_COMPRESSION_DISABLE__SHIFT = 0x0000001a;
constexpr unsigned int CB_COLOR2_INFO__FMASK_COMPRESS_1FRAG_ONLY__SHIFT = 0x0000001b;
constexpr unsigned int CB_COLOR2_INFO__FORMAT__SHIFT            = 0x00000002;
constexpr unsigned int CB_COLOR2_INFO__NUMBER_TYPE__SHIFT       = 0x00000008;
constexpr unsigned int CB_COLOR2_INFO__ROUND_MODE__SHIFT        = 0x00000012;
constexpr unsigned int CB_COLOR2_INFO__SIMPLE_FLOAT__SHIFT      = 0x00000011;
constexpr unsigned int CB_COLOR2_VIEW__SLICE_MAX__SHIFT         = 0x0000000d;
constexpr unsigned int CB_COLOR2_VIEW__SLICE_START__SHIFT       = 0x00000000;
constexpr unsigned int CB_COLOR3_ATTRIB2__MAX_MIP__SHIFT        = 0x0000001c;
constexpr unsigned int CB_COLOR3_ATTRIB2__MIP0_HEIGHT__SHIFT    = 0x00000000;
constexpr unsigned int CB_COLOR3_ATTRIB2__MIP0_WIDTH__SHIFT     = 0x0000000e;
constexpr unsigned int CB_COLOR3_ATTRIB__FORCE_DST_ALPHA_1__SHIFT = 0x00000011;
constexpr unsigned int CB_COLOR3_ATTRIB__NUM_FRAGMENTS__SHIFT   = 0x0000000f;
constexpr unsigned int CB_COLOR3_ATTRIB__NUM_SAMPLES__SHIFT     = 0x0000000c;
constexpr unsigned int CB_COLOR3_BASE_EXT__BASE_256B__SHIFT     = 0x00000000;
constexpr unsigned int CB_COLOR3_BASE__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR3_CLEAR_WORD0__CLEAR_WORD0__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR3_CLEAR_WORD1__CLEAR_WORD1__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR3_CMASK_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR3_CMASK__BASE_256B__SHIFT        = 0x00000000;
constexpr unsigned int CB_COLOR3_DCC_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR3_DCC_BASE__BASE_256B__SHIFT     = 0x00000000;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__COLOR_TRANSFORM__SHIFT = 0x00000007;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__INDEPENDENT_64B_BLOCKS__SHIFT = 0x00000009;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__KEY_CLEAR_ENABLE__SHIFT = 0x00000001;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__LOSSY_ALPHA_PRECISION__SHIFT = 0x0000000e;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__LOSSY_RGB_PRECISION__SHIFT = 0x0000000a;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000005;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE__SHIFT = 0x00000002;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__MIN_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000004;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR3_FMASK_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR3_FMASK__BASE_256B__SHIFT        = 0x00000000;
constexpr unsigned int CB_COLOR3_INFO__BLEND_BYPASS__SHIFT      = 0x00000010;
constexpr unsigned int CB_COLOR3_INFO__BLEND_CLAMP__SHIFT       = 0x0000000f;
constexpr unsigned int CB_COLOR3_INFO__BLEND_OPT_DISCARD_PIXEL__SHIFT = 0x00000017;
constexpr unsigned int CB_COLOR3_INFO__BLEND_OPT_DONT_RD_DST__SHIFT = 0x00000014;
constexpr unsigned int CB_COLOR3_INFO__CMASK_ADDR_TYPE__SHIFT   = 0x0000001d;
constexpr unsigned int CB_COLOR3_INFO__COMPRESSION__SHIFT       = 0x0000000e;
constexpr unsigned int CB_COLOR3_INFO__COMP_SWAP__SHIFT         = 0x0000000b;
constexpr unsigned int CB_COLOR3_INFO__DCC_ENABLE__SHIFT        = 0x0000001c;
constexpr unsigned int CB_COLOR3_INFO__ENDIAN__SHIFT            = 0x00000000;
constexpr unsigned int CB_COLOR3_INFO__FAST_CLEAR__SHIFT        = 0x0000000d;
constexpr unsigned int CB_COLOR3_INFO__FMASK_COMPRESSION_DISABLE__SHIFT = 0x0000001a;
constexpr unsigned int CB_COLOR3_INFO__FMASK_COMPRESS_1FRAG_ONLY__SHIFT = 0x0000001b;
constexpr unsigned int CB_COLOR3_INFO__FORMAT__SHIFT            = 0x00000002;
constexpr unsigned int CB_COLOR3_INFO__NUMBER_TYPE__SHIFT       = 0x00000008;
constexpr unsigned int CB_COLOR3_INFO__ROUND_MODE__SHIFT        = 0x00000012;
constexpr unsigned int CB_COLOR3_INFO__SIMPLE_FLOAT__SHIFT      = 0x00000011;
constexpr unsigned int CB_COLOR3_VIEW__SLICE_MAX__SHIFT         = 0x0000000d;
constexpr unsigned int CB_COLOR3_VIEW__SLICE_START__SHIFT       = 0x00000000;
constexpr unsigned int CB_COLOR4_ATTRIB2__MAX_MIP__SHIFT        = 0x0000001c;
constexpr unsigned int CB_COLOR4_ATTRIB2__MIP0_HEIGHT__SHIFT    = 0x00000000;
constexpr unsigned int CB_COLOR4_ATTRIB2__MIP0_WIDTH__SHIFT     = 0x0000000e;
constexpr unsigned int CB_COLOR4_ATTRIB__FORCE_DST_ALPHA_1__SHIFT = 0x00000011;
constexpr unsigned int CB_COLOR4_ATTRIB__NUM_FRAGMENTS__SHIFT   = 0x0000000f;
constexpr unsigned int CB_COLOR4_ATTRIB__NUM_SAMPLES__SHIFT     = 0x0000000c;
constexpr unsigned int CB_COLOR4_BASE_EXT__BASE_256B__SHIFT     = 0x00000000;
constexpr unsigned int CB_COLOR4_BASE__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR4_CLEAR_WORD0__CLEAR_WORD0__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR4_CLEAR_WORD1__CLEAR_WORD1__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR4_CMASK_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR4_CMASK__BASE_256B__SHIFT        = 0x00000000;
constexpr unsigned int CB_COLOR4_DCC_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR4_DCC_BASE__BASE_256B__SHIFT     = 0x00000000;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__COLOR_TRANSFORM__SHIFT = 0x00000007;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__INDEPENDENT_64B_BLOCKS__SHIFT = 0x00000009;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__KEY_CLEAR_ENABLE__SHIFT = 0x00000001;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__LOSSY_ALPHA_PRECISION__SHIFT = 0x0000000e;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__LOSSY_RGB_PRECISION__SHIFT = 0x0000000a;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000005;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE__SHIFT = 0x00000002;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__MIN_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000004;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR4_FMASK_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR4_FMASK__BASE_256B__SHIFT        = 0x00000000;
constexpr unsigned int CB_COLOR4_INFO__BLEND_BYPASS__SHIFT      = 0x00000010;
constexpr unsigned int CB_COLOR4_INFO__BLEND_CLAMP__SHIFT       = 0x0000000f;
constexpr unsigned int CB_COLOR4_INFO__BLEND_OPT_DISCARD_PIXEL__SHIFT = 0x00000017;
constexpr unsigned int CB_COLOR4_INFO__BLEND_OPT_DONT_RD_DST__SHIFT = 0x00000014;
constexpr unsigned int CB_COLOR4_INFO__CMASK_ADDR_TYPE__SHIFT   = 0x0000001d;
constexpr unsigned int CB_COLOR4_INFO__COMPRESSION__SHIFT       = 0x0000000e;
constexpr unsigned int CB_COLOR4_INFO__COMP_SWAP__SHIFT         = 0x0000000b;
constexpr unsigned int CB_COLOR4_INFO__DCC_ENABLE__SHIFT        = 0x0000001c;
constexpr unsigned int CB_COLOR4_INFO__ENDIAN__SHIFT            = 0x00000000;
constexpr unsigned int CB_COLOR4_INFO__FAST_CLEAR__SHIFT        = 0x0000000d;
constexpr unsigned int CB_COLOR4_INFO__FMASK_COMPRESSION_DISABLE__SHIFT = 0x0000001a;
constexpr unsigned int CB_COLOR4_INFO__FMASK_COMPRESS_1FRAG_ONLY__SHIFT = 0x0000001b;
constexpr unsigned int CB_COLOR4_INFO__FORMAT__SHIFT            = 0x00000002;
constexpr unsigned int CB_COLOR4_INFO__NUMBER_TYPE__SHIFT       = 0x00000008;
constexpr unsigned int CB_COLOR4_INFO__ROUND_MODE__SHIFT        = 0x00000012;
constexpr unsigned int CB_COLOR4_INFO__SIMPLE_FLOAT__SHIFT      = 0x00000011;
constexpr unsigned int CB_COLOR4_VIEW__SLICE_MAX__SHIFT         = 0x0000000d;
constexpr unsigned int CB_COLOR4_VIEW__SLICE_START__SHIFT       = 0x00000000;
constexpr unsigned int CB_COLOR5_ATTRIB2__MAX_MIP__SHIFT        = 0x0000001c;
constexpr unsigned int CB_COLOR5_ATTRIB2__MIP0_HEIGHT__SHIFT    = 0x00000000;
constexpr unsigned int CB_COLOR5_ATTRIB2__MIP0_WIDTH__SHIFT     = 0x0000000e;
constexpr unsigned int CB_COLOR5_ATTRIB__FORCE_DST_ALPHA_1__SHIFT = 0x00000011;
constexpr unsigned int CB_COLOR5_ATTRIB__NUM_FRAGMENTS__SHIFT   = 0x0000000f;
constexpr unsigned int CB_COLOR5_ATTRIB__NUM_SAMPLES__SHIFT     = 0x0000000c;
constexpr unsigned int CB_COLOR5_BASE_EXT__BASE_256B__SHIFT     = 0x00000000;
constexpr unsigned int CB_COLOR5_BASE__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR5_CLEAR_WORD0__CLEAR_WORD0__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR5_CLEAR_WORD1__CLEAR_WORD1__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR5_CMASK_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR5_CMASK__BASE_256B__SHIFT        = 0x00000000;
constexpr unsigned int CB_COLOR5_DCC_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR5_DCC_BASE__BASE_256B__SHIFT     = 0x00000000;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__COLOR_TRANSFORM__SHIFT = 0x00000007;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__INDEPENDENT_64B_BLOCKS__SHIFT = 0x00000009;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__KEY_CLEAR_ENABLE__SHIFT = 0x00000001;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__LOSSY_ALPHA_PRECISION__SHIFT = 0x0000000e;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__LOSSY_RGB_PRECISION__SHIFT = 0x0000000a;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000005;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE__SHIFT = 0x00000002;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__MIN_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000004;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR5_FMASK_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR5_FMASK__BASE_256B__SHIFT        = 0x00000000;
constexpr unsigned int CB_COLOR5_INFO__BLEND_BYPASS__SHIFT      = 0x00000010;
constexpr unsigned int CB_COLOR5_INFO__BLEND_CLAMP__SHIFT       = 0x0000000f;
constexpr unsigned int CB_COLOR5_INFO__BLEND_OPT_DISCARD_PIXEL__SHIFT = 0x00000017;
constexpr unsigned int CB_COLOR5_INFO__BLEND_OPT_DONT_RD_DST__SHIFT = 0x00000014;
constexpr unsigned int CB_COLOR5_INFO__CMASK_ADDR_TYPE__SHIFT   = 0x0000001d;
constexpr unsigned int CB_COLOR5_INFO__COMPRESSION__SHIFT       = 0x0000000e;
constexpr unsigned int CB_COLOR5_INFO__COMP_SWAP__SHIFT         = 0x0000000b;
constexpr unsigned int CB_COLOR5_INFO__DCC_ENABLE__SHIFT        = 0x0000001c;
constexpr unsigned int CB_COLOR5_INFO__ENDIAN__SHIFT            = 0x00000000;
constexpr unsigned int CB_COLOR5_INFO__FAST_CLEAR__SHIFT        = 0x0000000d;
constexpr unsigned int CB_COLOR5_INFO__FMASK_COMPRESSION_DISABLE__SHIFT = 0x0000001a;
constexpr unsigned int CB_COLOR5_INFO__FMASK_COMPRESS_1FRAG_ONLY__SHIFT = 0x0000001b;
constexpr unsigned int CB_COLOR5_INFO__FORMAT__SHIFT            = 0x00000002;
constexpr unsigned int CB_COLOR5_INFO__NUMBER_TYPE__SHIFT       = 0x00000008;
constexpr unsigned int CB_COLOR5_INFO__ROUND_MODE__SHIFT        = 0x00000012;
constexpr unsigned int CB_COLOR5_INFO__SIMPLE_FLOAT__SHIFT      = 0x00000011;
constexpr unsigned int CB_COLOR5_VIEW__SLICE_MAX__SHIFT         = 0x0000000d;
constexpr unsigned int CB_COLOR5_VIEW__SLICE_START__SHIFT       = 0x00000000;
constexpr unsigned int CB_COLOR6_ATTRIB2__MAX_MIP__SHIFT        = 0x0000001c;
constexpr unsigned int CB_COLOR6_ATTRIB2__MIP0_HEIGHT__SHIFT    = 0x00000000;
constexpr unsigned int CB_COLOR6_ATTRIB2__MIP0_WIDTH__SHIFT     = 0x0000000e;
constexpr unsigned int CB_COLOR6_ATTRIB__FORCE_DST_ALPHA_1__SHIFT = 0x00000011;
constexpr unsigned int CB_COLOR6_ATTRIB__NUM_FRAGMENTS__SHIFT   = 0x0000000f;
constexpr unsigned int CB_COLOR6_ATTRIB__NUM_SAMPLES__SHIFT     = 0x0000000c;
constexpr unsigned int CB_COLOR6_BASE_EXT__BASE_256B__SHIFT     = 0x00000000;
constexpr unsigned int CB_COLOR6_BASE__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR6_CLEAR_WORD0__CLEAR_WORD0__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR6_CLEAR_WORD1__CLEAR_WORD1__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR6_CMASK_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR6_CMASK__BASE_256B__SHIFT        = 0x00000000;
constexpr unsigned int CB_COLOR6_DCC_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR6_DCC_BASE__BASE_256B__SHIFT     = 0x00000000;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__COLOR_TRANSFORM__SHIFT = 0x00000007;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__INDEPENDENT_64B_BLOCKS__SHIFT = 0x00000009;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__KEY_CLEAR_ENABLE__SHIFT = 0x00000001;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__LOSSY_ALPHA_PRECISION__SHIFT = 0x0000000e;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__LOSSY_RGB_PRECISION__SHIFT = 0x0000000a;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000005;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE__SHIFT = 0x00000002;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__MIN_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000004;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR6_FMASK_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR6_FMASK__BASE_256B__SHIFT        = 0x00000000;
constexpr unsigned int CB_COLOR6_INFO__BLEND_BYPASS__SHIFT      = 0x00000010;
constexpr unsigned int CB_COLOR6_INFO__BLEND_CLAMP__SHIFT       = 0x0000000f;
constexpr unsigned int CB_COLOR6_INFO__BLEND_OPT_DISCARD_PIXEL__SHIFT = 0x00000017;
constexpr unsigned int CB_COLOR6_INFO__BLEND_OPT_DONT_RD_DST__SHIFT = 0x00000014;
constexpr unsigned int CB_COLOR6_INFO__CMASK_ADDR_TYPE__SHIFT   = 0x0000001d;
constexpr unsigned int CB_COLOR6_INFO__COMPRESSION__SHIFT       = 0x0000000e;
constexpr unsigned int CB_COLOR6_INFO__COMP_SWAP__SHIFT         = 0x0000000b;
constexpr unsigned int CB_COLOR6_INFO__DCC_ENABLE__SHIFT        = 0x0000001c;
constexpr unsigned int CB_COLOR6_INFO__ENDIAN__SHIFT            = 0x00000000;
constexpr unsigned int CB_COLOR6_INFO__FAST_CLEAR__SHIFT        = 0x0000000d;
constexpr unsigned int CB_COLOR6_INFO__FMASK_COMPRESSION_DISABLE__SHIFT = 0x0000001a;
constexpr unsigned int CB_COLOR6_INFO__FMASK_COMPRESS_1FRAG_ONLY__SHIFT = 0x0000001b;
constexpr unsigned int CB_COLOR6_INFO__FORMAT__SHIFT            = 0x00000002;
constexpr unsigned int CB_COLOR6_INFO__NUMBER_TYPE__SHIFT       = 0x00000008;
constexpr unsigned int CB_COLOR6_INFO__ROUND_MODE__SHIFT        = 0x00000012;
constexpr unsigned int CB_COLOR6_INFO__SIMPLE_FLOAT__SHIFT      = 0x00000011;
constexpr unsigned int CB_COLOR6_VIEW__SLICE_MAX__SHIFT         = 0x0000000d;
constexpr unsigned int CB_COLOR6_VIEW__SLICE_START__SHIFT       = 0x00000000;
constexpr unsigned int CB_COLOR7_ATTRIB2__MAX_MIP__SHIFT        = 0x0000001c;
constexpr unsigned int CB_COLOR7_ATTRIB2__MIP0_HEIGHT__SHIFT    = 0x00000000;
constexpr unsigned int CB_COLOR7_ATTRIB2__MIP0_WIDTH__SHIFT     = 0x0000000e;
constexpr unsigned int CB_COLOR7_ATTRIB__FORCE_DST_ALPHA_1__SHIFT = 0x00000011;
constexpr unsigned int CB_COLOR7_ATTRIB__NUM_FRAGMENTS__SHIFT   = 0x0000000f;
constexpr unsigned int CB_COLOR7_ATTRIB__NUM_SAMPLES__SHIFT     = 0x0000000c;
constexpr unsigned int CB_COLOR7_BASE_EXT__BASE_256B__SHIFT     = 0x00000000;
constexpr unsigned int CB_COLOR7_BASE__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR7_CLEAR_WORD0__CLEAR_WORD0__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR7_CLEAR_WORD1__CLEAR_WORD1__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR7_CMASK_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR7_CMASK__BASE_256B__SHIFT        = 0x00000000;
constexpr unsigned int CB_COLOR7_DCC_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR7_DCC_BASE__BASE_256B__SHIFT     = 0x00000000;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__COLOR_TRANSFORM__SHIFT = 0x00000007;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__INDEPENDENT_64B_BLOCKS__SHIFT = 0x00000009;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__KEY_CLEAR_ENABLE__SHIFT = 0x00000001;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__LOSSY_ALPHA_PRECISION__SHIFT = 0x0000000e;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__LOSSY_RGB_PRECISION__SHIFT = 0x0000000a;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000005;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE__SHIFT = 0x00000002;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__MIN_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000004;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR7_FMASK_BASE_EXT__BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR7_FMASK__BASE_256B__SHIFT        = 0x00000000;
constexpr unsigned int CB_COLOR7_INFO__BLEND_BYPASS__SHIFT      = 0x00000010;
constexpr unsigned int CB_COLOR7_INFO__BLEND_CLAMP__SHIFT       = 0x0000000f;
constexpr unsigned int CB_COLOR7_INFO__BLEND_OPT_DISCARD_PIXEL__SHIFT = 0x00000017;
constexpr unsigned int CB_COLOR7_INFO__BLEND_OPT_DONT_RD_DST__SHIFT = 0x00000014;
constexpr unsigned int CB_COLOR7_INFO__CMASK_ADDR_TYPE__SHIFT   = 0x0000001d;
constexpr unsigned int CB_COLOR7_INFO__COMPRESSION__SHIFT       = 0x0000000e;
constexpr unsigned int CB_COLOR7_INFO__COMP_SWAP__SHIFT         = 0x0000000b;
constexpr unsigned int CB_COLOR7_INFO__DCC_ENABLE__SHIFT        = 0x0000001c;
constexpr unsigned int CB_COLOR7_INFO__ENDIAN__SHIFT            = 0x00000000;
constexpr unsigned int CB_COLOR7_INFO__FAST_CLEAR__SHIFT        = 0x0000000d;
constexpr unsigned int CB_COLOR7_INFO__FMASK_COMPRESSION_DISABLE__SHIFT = 0x0000001a;
constexpr unsigned int CB_COLOR7_INFO__FMASK_COMPRESS_1FRAG_ONLY__SHIFT = 0x0000001b;
constexpr unsigned int CB_COLOR7_INFO__FORMAT__SHIFT            = 0x00000002;
constexpr unsigned int CB_COLOR7_INFO__NUMBER_TYPE__SHIFT       = 0x00000008;
constexpr unsigned int CB_COLOR7_INFO__ROUND_MODE__SHIFT        = 0x00000012;
constexpr unsigned int CB_COLOR7_INFO__SIMPLE_FLOAT__SHIFT      = 0x00000011;
constexpr unsigned int CB_COLOR7_VIEW__SLICE_MAX__SHIFT         = 0x0000000d;
constexpr unsigned int CB_COLOR7_VIEW__SLICE_START__SHIFT       = 0x00000000;
constexpr unsigned int CB_COLOR_CONTROL__DEGAMMA_ENABLE__SHIFT  = 0x00000003;
constexpr unsigned int CB_COLOR_CONTROL__DISABLE_DUAL_QUAD__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR_CONTROL__MODE__SHIFT            = 0x00000004;
constexpr unsigned int CB_COLOR_CONTROL__ROP3__SHIFT            = 0x00000010;
constexpr unsigned int CB_DCC_CONFIG__FC_RDLAT_KEYID_FIFO_DEPTH__SHIFT = 0x00000008;
constexpr unsigned int CB_DCC_CONFIG__OVERWRITE_COMBINER_CC_POP_DISABLE__SHIFT = 0x00000006;
constexpr unsigned int CB_DCC_CONFIG__OVERWRITE_COMBINER_DEPTH__SHIFT = 0x00000000;
constexpr unsigned int CB_DCC_CONFIG__OVERWRITE_COMBINER_DISABLE__SHIFT = 0x00000005;
constexpr unsigned int CB_DCC_CONFIG__READ_RETURN_SKID_FIFO_DEPTH__SHIFT = 0x00000010;
constexpr unsigned int CB_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int CB_DCC_CONTROL__OVERWRITE_COMBINER_WATERMARK__SHIFT = 0x00000002;
constexpr unsigned int CB_HW_CONTROL_1__CM_CACHE_NUM_TAGS__SHIFT = 0x00000000;
constexpr unsigned int CB_HW_CONTROL_1__FC_CACHE_NUM_TAGS__SHIFT = 0x00000005;
constexpr unsigned int CB_HW_CONTROL_2__CC_EVEN_ODD_FIFO_DEPTH__SHIFT = 0x00000000;
constexpr unsigned int CB_HW_CONTROL_2__DRR_ASSUMED_FIFO_DEPTH_DIV8__SHIFT = 0x00000018;
constexpr unsigned int CB_HW_CONTROL_2__FC_RDLAT_QUAD_FIFO_DEPTH__SHIFT = 0x0000000f;
constexpr unsigned int CB_HW_CONTROL_2__FC_RDLAT_TILE_FIFO_DEPTH__SHIFT = 0x00000008;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_BLENDER_CLOCK_GATING__SHIFT = 0x0000001a;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_CC_CACHE_OVWR_STATUS_ACCUM__SHIFT = 0x00000005;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_CC_CACHE_PANIC_GATING__SHIFT = 0x00000007;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_CMASK_LAST_QUAD_INSERTION__SHIFT = 0x0000000b;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_EARLY_WRACKS_CC__SHIFT = 0x00000011;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_EARLY_WRACKS_CM__SHIFT = 0x00000014;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_EARLY_WRACKS_DC__SHIFT = 0x00000013;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_EARLY_WRACKS_FC__SHIFT = 0x00000012;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_FAST_CLEAR_FETCH_OPT__SHIFT = 0x00000002;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_NACK_COLOR_RD_WR_OPT__SHIFT = 0x00000019;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_NACK_PROCESSING_CC__SHIFT = 0x00000015;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_NACK_PROCESSING_CM__SHIFT = 0x00000018;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_NACK_PROCESSING_DC__SHIFT = 0x00000017;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_NACK_PROCESSING_FC__SHIFT = 0x00000016;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_OC_FIXES_OF_BUG_522542__SHIFT = 0x0000000e;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_OVERWRITE_COMBINER_CAM_CLR__SHIFT = 0x00000004;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_QUAD_MARKER_DROP_STOP__SHIFT = 0x00000003;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_ROP3_FIXES_OF_BUG_511967__SHIFT = 0x0000000c;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_ROP3_FIXES_OF_BUG_520657__SHIFT = 0x0000000d;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_SHADER_BLEND_OPTS__SHIFT = 0x0000000a;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_SLOW_MODE_EMPTY_HALF_QUAD_KILL__SHIFT = 0x00000000;
constexpr unsigned int CB_HW_CONTROL_3__FORCE_RMI_CLKEN_HIGH__SHIFT = 0x00000010;
constexpr unsigned int CB_HW_CONTROL_3__FORCE_RMI_LAST_HIGH__SHIFT = 0x0000000f;
constexpr unsigned int CB_HW_CONTROL_3__RAM_ADDRESS_CONFLICTS_DISALLOWED__SHIFT = 0x00000001;
constexpr unsigned int CB_HW_CONTROL_3__SPLIT_ALL_FAST_MODE_TRANSFERS__SHIFT = 0x00000009;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_BYPASS__SHIFT = 0x00000019;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_DISCARD_PIXEL__SHIFT = 0x0000001a;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_DONT_RD_DST__SHIFT = 0x00000018;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_RESULT_EQ_DEST__SHIFT = 0x00000015;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_WHEN_DISABLED_SRCALPHA_IS_USED__SHIFT = 0x0000001b;
constexpr unsigned int CB_HW_CONTROL__DISABLE_CC_IB_SERIALIZER_STATE_OPT__SHIFT = 0x0000001e;
constexpr unsigned int CB_HW_CONTROL__DISABLE_FULL_WRITE_MASK__SHIFT = 0x00000016;
constexpr unsigned int CB_HW_CONTROL__DISABLE_INTNORM_LE11BPC_CLAMPING__SHIFT = 0x00000012;
constexpr unsigned int CB_HW_CONTROL__DISABLE_PIXEL_IN_QUAD_FIX_FOR_LINEAR_SURFACE__SHIFT = 0x0000001f;
constexpr unsigned int CB_HW_CONTROL__DISABLE_RESOLVE_OPT_FOR_SINGLE_FRAG__SHIFT = 0x00000017;
constexpr unsigned int CB_HW_CONTROL__FORCE_ALWAYS_TOGGLE__SHIFT = 0x00000014;
constexpr unsigned int CB_HW_CONTROL__FORCE_NEEDS_DST__SHIFT    = 0x00000013;
constexpr unsigned int CB_HW_CONTROL__PRIORITIZE_FC_EVICT_OVER_FOP_RD_ON_BANK_CONFLICT__SHIFT = 0x0000001d;
constexpr unsigned int CB_HW_CONTROL__PRIORITIZE_FC_WR_OVER_FC_RD_ON_CMASK_CONFLICT__SHIFT = 0x0000001c;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__BREAK_GROUP_AGE__SHIFT = 0x00000006;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__IGNORE_URGENT_AGE__SHIFT = 0x00000002;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__MODE__SHIFT        = 0x00000000;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__SCALE_AGE__SHIFT   = 0x00000017;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__SCALE_WEIGHT__SHIFT = 0x0000001a;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__SEND_LASTS_WITHIN_GROUPS__SHIFT = 0x0000001d;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__WEIGHT_CC__SHIFT   = 0x0000000a;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__WEIGHT_CM__SHIFT   = 0x0000000e;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__WEIGHT_DC__SHIFT   = 0x00000010;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__WEIGHT_DECAY_NOREQS__SHIFT = 0x00000014;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__WEIGHT_DECAY_REQS__SHIFT = 0x00000012;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__WEIGHT_FC__SHIFT   = 0x0000000c;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__WEIGHT_IGNORE_NUM_TIDS__SHIFT = 0x00000016;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__BREAK_GROUP_AGE__SHIFT = 0x00000006;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__IGNORE_URGENT_AGE__SHIFT = 0x00000002;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__MODE__SHIFT        = 0x00000000;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__SCALE_AGE__SHIFT   = 0x00000017;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__SCALE_WEIGHT__SHIFT = 0x0000001a;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__SEND_LASTS_WITHIN_GROUPS__SHIFT = 0x0000001d;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__WEIGHT_CC__SHIFT   = 0x0000000a;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__WEIGHT_CM__SHIFT   = 0x0000000e;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__WEIGHT_DC__SHIFT   = 0x00000010;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__WEIGHT_DECAY_NOREQS__SHIFT = 0x00000014;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__WEIGHT_DECAY_REQS__SHIFT = 0x00000012;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__WEIGHT_FC__SHIFT   = 0x0000000c;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__WEIGHT_IGNORE_BYTE_MASK__SHIFT = 0x00000016;
constexpr unsigned int CB_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
constexpr unsigned int CB_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
constexpr unsigned int CB_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT  = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int CB_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT  = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int CB_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT  = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int CB_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT  = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER_FILTER__CLEAR_FILTER_ENABLE__SHIFT = 0x0000000a;
constexpr unsigned int CB_PERFCOUNTER_FILTER__CLEAR_FILTER_SEL__SHIFT = 0x0000000b;
constexpr unsigned int CB_PERFCOUNTER_FILTER__FORMAT_FILTER_ENABLE__SHIFT = 0x00000004;
constexpr unsigned int CB_PERFCOUNTER_FILTER__FORMAT_FILTER_SEL__SHIFT = 0x00000005;
constexpr unsigned int CB_PERFCOUNTER_FILTER__MRT_FILTER_ENABLE__SHIFT = 0x0000000c;
constexpr unsigned int CB_PERFCOUNTER_FILTER__MRT_FILTER_SEL__SHIFT = 0x0000000d;
constexpr unsigned int CB_PERFCOUNTER_FILTER__NUM_FRAGMENTS_FILTER_ENABLE__SHIFT = 0x00000015;
constexpr unsigned int CB_PERFCOUNTER_FILTER__NUM_FRAGMENTS_FILTER_SEL__SHIFT = 0x00000016;
constexpr unsigned int CB_PERFCOUNTER_FILTER__NUM_SAMPLES_FILTER_ENABLE__SHIFT = 0x00000011;
constexpr unsigned int CB_PERFCOUNTER_FILTER__NUM_SAMPLES_FILTER_SEL__SHIFT = 0x00000012;
constexpr unsigned int CB_PERFCOUNTER_FILTER__OP_FILTER_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER_FILTER__OP_FILTER_SEL__SHIFT = 0x00000001;
constexpr unsigned int CB_SHADER_MASK__OUTPUT0_ENABLE__SHIFT    = 0x00000000;
constexpr unsigned int CB_SHADER_MASK__OUTPUT1_ENABLE__SHIFT    = 0x00000004;
constexpr unsigned int CB_SHADER_MASK__OUTPUT2_ENABLE__SHIFT    = 0x00000008;
constexpr unsigned int CB_SHADER_MASK__OUTPUT3_ENABLE__SHIFT    = 0x0000000c;
constexpr unsigned int CB_SHADER_MASK__OUTPUT4_ENABLE__SHIFT    = 0x00000010;
constexpr unsigned int CB_SHADER_MASK__OUTPUT5_ENABLE__SHIFT    = 0x00000014;
constexpr unsigned int CB_SHADER_MASK__OUTPUT6_ENABLE__SHIFT    = 0x00000018;
constexpr unsigned int CB_SHADER_MASK__OUTPUT7_ENABLE__SHIFT    = 0x0000001c;
constexpr unsigned int CB_TARGET_MASK__TARGET0_ENABLE__SHIFT    = 0x00000000;
constexpr unsigned int CB_TARGET_MASK__TARGET1_ENABLE__SHIFT    = 0x00000004;
constexpr unsigned int CB_TARGET_MASK__TARGET2_ENABLE__SHIFT    = 0x00000008;
constexpr unsigned int CB_TARGET_MASK__TARGET3_ENABLE__SHIFT    = 0x0000000c;
constexpr unsigned int CB_TARGET_MASK__TARGET4_ENABLE__SHIFT    = 0x00000010;
constexpr unsigned int CB_TARGET_MASK__TARGET5_ENABLE__SHIFT    = 0x00000014;
constexpr unsigned int CB_TARGET_MASK__TARGET6_ENABLE__SHIFT    = 0x00000018;
constexpr unsigned int CB_TARGET_MASK__TARGET7_ENABLE__SHIFT    = 0x0000001c;
constexpr unsigned int CC_RB_BACKEND_DISABLE__BACKEND_DISABLE__SHIFT = 0x00000010;
constexpr unsigned int CC_RB_DAISY_CHAIN__RB_0__SHIFT           = 0x00000000;
constexpr unsigned int CC_RB_DAISY_CHAIN__RB_1__SHIFT           = 0x00000004;
constexpr unsigned int CC_RB_DAISY_CHAIN__RB_2__SHIFT           = 0x00000008;
constexpr unsigned int CC_RB_DAISY_CHAIN__RB_3__SHIFT           = 0x0000000c;
constexpr unsigned int CC_RB_DAISY_CHAIN__RB_4__SHIFT           = 0x00000010;
constexpr unsigned int CC_RB_DAISY_CHAIN__RB_5__SHIFT           = 0x00000014;
constexpr unsigned int CC_RB_DAISY_CHAIN__RB_6__SHIFT           = 0x00000018;
constexpr unsigned int CC_RB_DAISY_CHAIN__RB_7__SHIFT           = 0x0000001c;
constexpr unsigned int CC_RB_REDUNDANCY__EN_REDUNDANCY0__SHIFT  = 0x0000000c;
constexpr unsigned int CC_RB_REDUNDANCY__EN_REDUNDANCY1__SHIFT  = 0x00000014;
constexpr unsigned int CC_RB_REDUNDANCY__FAILED_RB0__SHIFT      = 0x00000008;
constexpr unsigned int CC_RB_REDUNDANCY__FAILED_RB1__SHIFT      = 0x00000010;
constexpr unsigned int COHER_DEST_BASE_0__DEST_BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int COHER_DEST_BASE_1__DEST_BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int COHER_DEST_BASE_2__DEST_BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int COHER_DEST_BASE_3__DEST_BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int COHER_DEST_BASE_HI_0__DEST_BASE_HI_256B__SHIFT = 0x00000000;
constexpr unsigned int COHER_DEST_BASE_HI_1__DEST_BASE_HI_256B__SHIFT = 0x00000000;
constexpr unsigned int COHER_DEST_BASE_HI_2__DEST_BASE_HI_256B__SHIFT = 0x00000000;
constexpr unsigned int COHER_DEST_BASE_HI_3__DEST_BASE_HI_256B__SHIFT = 0x00000000;
constexpr unsigned int COMPUTE_DIM_X__SIZE__SHIFT               = 0x00000000;
constexpr unsigned int COMPUTE_DIM_Y__SIZE__SHIFT               = 0x00000000;
constexpr unsigned int COMPUTE_DIM_Z__SIZE__SHIFT               = 0x00000000;
constexpr unsigned int COMPUTE_DISPATCH_ID__DISPATCH_ID__SHIFT  = 0x00000000;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__COMPUTE_SHADER_EN__SHIFT = 0x00000000;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__FORCE_START_AT_000__SHIFT = 0x00000002;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__ORDERED_APPEND_ENBL__SHIFT = 0x00000003;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__ORDERED_APPEND_MODE__SHIFT = 0x00000004;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__ORDER_MODE__SHIFT = 0x00000006;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__PARTIAL_TG_EN__SHIFT = 0x00000001;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__RESERVED__SHIFT = 0x0000000c;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__RESTORE__SHIFT = 0x0000000e;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__SCALAR_L1_INV_VOL__SHIFT = 0x0000000a;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__USE_THREAD_DIMENSIONS__SHIFT = 0x00000005;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__VECTOR_L1_INV_VOL__SHIFT = 0x0000000b;
constexpr unsigned int COMPUTE_DISPATCH_PKT_ADDR_HI__DATA__SHIFT = 0x00000000;
constexpr unsigned int COMPUTE_DISPATCH_PKT_ADDR_LO__DATA__SHIFT = 0x00000000;
constexpr unsigned int COMPUTE_DISPATCH_SCRATCH_BASE_HI__DATA__SHIFT = 0x00000000;
constexpr unsigned int COMPUTE_DISPATCH_SCRATCH_BASE_LO__DATA__SHIFT = 0x00000000;
constexpr unsigned int COMPUTE_MISC_RESERVED__RESERVED2__SHIFT  = 0x00000002;
constexpr unsigned int COMPUTE_MISC_RESERVED__RESERVED3__SHIFT  = 0x00000003;
constexpr unsigned int COMPUTE_MISC_RESERVED__RESERVED4__SHIFT  = 0x00000004;
constexpr unsigned int COMPUTE_MISC_RESERVED__SEND_SEID__SHIFT  = 0x00000000;
constexpr unsigned int COMPUTE_MISC_RESERVED__WAVE_ID_BASE__SHIFT = 0x00000005;
constexpr unsigned int COMPUTE_NOWHERE__DATA__SHIFT             = 0x00000000;
constexpr unsigned int COMPUTE_NUM_THREAD_X__NUM_THREAD_FULL__SHIFT = 0x00000000;
constexpr unsigned int COMPUTE_NUM_THREAD_X__NUM_THREAD_PARTIAL__SHIFT = 0x00000010;
constexpr unsigned int COMPUTE_NUM_THREAD_Y__NUM_THREAD_FULL__SHIFT = 0x00000000;
constexpr unsigned int COMPUTE_NUM_THREAD_Y__NUM_THREAD_PARTIAL__SHIFT = 0x00000010;
constexpr unsigned int COMPUTE_NUM_THREAD_Z__NUM_THREAD_FULL__SHIFT = 0x00000000;
constexpr unsigned int COMPUTE_NUM_THREAD_Z__NUM_THREAD_PARTIAL__SHIFT = 0x00000010;
constexpr unsigned int COMPUTE_PERFCOUNT_ENABLE__PERFCOUNT_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int COMPUTE_PGM_HI__DATA__SHIFT              = 0x00000000;
constexpr unsigned int COMPUTE_PGM_LO__DATA__SHIFT              = 0x00000000;
constexpr unsigned int COMPUTE_PGM_RSRC1__BULKY__SHIFT          = 0x00000018;
constexpr unsigned int COMPUTE_PGM_RSRC1__CDBG_USER__SHIFT      = 0x00000019;
constexpr unsigned int COMPUTE_PGM_RSRC1__DEBUG_MODE__SHIFT     = 0x00000016;
constexpr unsigned int COMPUTE_PGM_RSRC1__DX10_CLAMP__SHIFT     = 0x00000015;
constexpr unsigned int COMPUTE_PGM_RSRC1__FLOAT_MODE__SHIFT     = 0x0000000c;
constexpr unsigned int COMPUTE_PGM_RSRC1__FP16_OVFL__SHIFT      = 0x0000001a;
constexpr unsigned int COMPUTE_PGM_RSRC1__IEEE_MODE__SHIFT      = 0x00000017;
constexpr unsigned int COMPUTE_PGM_RSRC1__PRIORITY__SHIFT       = 0x0000000a;
constexpr unsigned int COMPUTE_PGM_RSRC1__PRIV__SHIFT           = 0x00000014;
constexpr unsigned int COMPUTE_PGM_RSRC1__SGPRS__SHIFT          = 0x00000006;
constexpr unsigned int COMPUTE_PGM_RSRC1__VGPRS__SHIFT          = 0x00000000;
constexpr unsigned int COMPUTE_PGM_RSRC2__EXCP_EN_MSB__SHIFT    = 0x0000000d;
constexpr unsigned int COMPUTE_PGM_RSRC2__EXCP_EN__SHIFT        = 0x00000018;
constexpr unsigned int COMPUTE_PGM_RSRC2__LDS_SIZE__SHIFT       = 0x0000000f;
constexpr unsigned int COMPUTE_PGM_RSRC2__SCRATCH_EN__SHIFT     = 0x00000000;
constexpr unsigned int COMPUTE_PGM_RSRC2__TGID_X_EN__SHIFT      = 0x00000007;
constexpr unsigned int COMPUTE_PGM_RSRC2__TGID_Y_EN__SHIFT      = 0x00000008;
constexpr unsigned int COMPUTE_PGM_RSRC2__TGID_Z_EN__SHIFT      = 0x00000009;
constexpr unsigned int COMPUTE_PGM_RSRC2__TG_SIZE_EN__SHIFT     = 0x0000000a;
constexpr unsigned int COMPUTE_PGM_RSRC2__TIDIG_COMP_CNT__SHIFT = 0x0000000b;
constexpr unsigned int COMPUTE_PGM_RSRC2__TRAP_PRESENT__SHIFT   = 0x00000006;
constexpr unsigned int COMPUTE_PGM_RSRC2__USER_SGPR__SHIFT      = 0x00000001;
constexpr unsigned int COMPUTE_PIPELINESTAT_ENABLE__PIPELINESTAT_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int COMPUTE_RELAUNCH__IS_EVENT__SHIFT        = 0x0000001e;
constexpr unsigned int COMPUTE_RELAUNCH__IS_STATE__SHIFT        = 0x0000001f;
constexpr unsigned int COMPUTE_RELAUNCH__PAYLOAD__SHIFT         = 0x00000000;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__CU_GROUP_COUNT__SHIFT = 0x00000018;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__FORCE_SIMD_DIST__SHIFT = 0x00000017;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__LOCK_THRESHOLD__SHIFT = 0x00000010;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__SIMD_DEST_CNTL__SHIFT = 0x00000016;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__TG_PER_CU__SHIFT = 0x0000000c;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__WAVES_PER_SH__SHIFT = 0x00000000;
constexpr unsigned int COMPUTE_RESTART_X__RESTART__SHIFT        = 0x00000000;
constexpr unsigned int COMPUTE_RESTART_Y__RESTART__SHIFT        = 0x00000000;
constexpr unsigned int COMPUTE_RESTART_Z__RESTART__SHIFT        = 0x00000000;
constexpr unsigned int COMPUTE_START_X__START__SHIFT            = 0x00000000;
constexpr unsigned int COMPUTE_START_Y__START__SHIFT            = 0x00000000;
constexpr unsigned int COMPUTE_START_Z__START__SHIFT            = 0x00000000;
constexpr unsigned int COMPUTE_THREADGROUP_ID__THREADGROUP_ID__SHIFT = 0x00000000;
constexpr unsigned int COMPUTE_THREAD_TRACE_ENABLE__THREAD_TRACE_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int COMPUTE_TMPRING_SIZE__WAVESIZE__SHIFT    = 0x0000000c;
constexpr unsigned int COMPUTE_TMPRING_SIZE__WAVES__SHIFT       = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_0__DATA__SHIFT         = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_1__DATA__SHIFT         = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_2__DATA__SHIFT         = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_3__DATA__SHIFT         = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_4__DATA__SHIFT         = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_5__DATA__SHIFT         = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_6__DATA__SHIFT         = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_7__DATA__SHIFT         = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_8__DATA__SHIFT         = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_9__DATA__SHIFT         = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_10__DATA__SHIFT        = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_11__DATA__SHIFT        = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_12__DATA__SHIFT        = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_13__DATA__SHIFT        = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_14__DATA__SHIFT        = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_15__DATA__SHIFT        = 0x00000000;
constexpr unsigned int COMPUTE_VMID__DATA__SHIFT                = 0x00000000;
constexpr unsigned int COMPUTE_WAVE_RESTORE_ADDR_HI__ADDR__SHIFT = 0x00000000;
constexpr unsigned int COMPUTE_WAVE_RESTORE_ADDR_LO__ADDR__SHIFT = 0x00000000;
constexpr unsigned int CPC_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int CPC_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__CNTR_MODE2__SHIFT = 0x0000001c;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__CNTR_MODE3__SHIFT = 0x00000018;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT__CNTR_MODE0__SHIFT = 0x0000001c;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT__CNTR_MODE1__SHIFT = 0x00000018;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT__SPM_MODE__SHIFT = 0x00000014;
constexpr unsigned int CPC_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int CPC_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int CPC_PERFCOUNTER1_SELECT__CNTR_MODE0__SHIFT = 0x0000001c;
constexpr unsigned int CPC_PERFCOUNTER1_SELECT__CNTR_MODE1__SHIFT = 0x00000018;
constexpr unsigned int CPC_PERFCOUNTER1_SELECT__SPM_MODE__SHIFT = 0x00000014;
constexpr unsigned int CPF_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int CPF_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__CNTR_MODE2__SHIFT = 0x0000001c;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__CNTR_MODE3__SHIFT = 0x00000018;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT__CNTR_MODE0__SHIFT = 0x0000001c;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT__CNTR_MODE1__SHIFT = 0x00000018;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT__SPM_MODE__SHIFT = 0x00000014;
constexpr unsigned int CPF_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int CPF_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int CPF_PERFCOUNTER1_SELECT__CNTR_MODE0__SHIFT = 0x0000001c;
constexpr unsigned int CPF_PERFCOUNTER1_SELECT__CNTR_MODE1__SHIFT = 0x00000018;
constexpr unsigned int CPF_PERFCOUNTER1_SELECT__SPM_MODE__SHIFT = 0x00000014;
constexpr unsigned int CPG_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int CPG_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__CNTR_MODE2__SHIFT = 0x0000001c;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__CNTR_MODE3__SHIFT = 0x00000018;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT__CNTR_MODE0__SHIFT = 0x0000001c;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT__CNTR_MODE1__SHIFT = 0x00000018;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT__SPM_MODE__SHIFT = 0x00000014;
constexpr unsigned int CPG_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int CPG_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int CPG_PERFCOUNTER1_SELECT__CNTR_MODE0__SHIFT = 0x0000001c;
constexpr unsigned int CPG_PERFCOUNTER1_SELECT__CNTR_MODE1__SHIFT = 0x00000018;
constexpr unsigned int CPG_PERFCOUNTER1_SELECT__SPM_MODE__SHIFT = 0x00000014;
constexpr unsigned int CP_APPEND_ADDR_HI__CACHE_POLICY__SHIFT   = 0x00000019;
constexpr unsigned int CP_APPEND_ADDR_HI__COMMAND__SHIFT        = 0x0000001d;
constexpr unsigned int CP_APPEND_ADDR_HI__CS_PS_SEL__SHIFT      = 0x00000010;
constexpr unsigned int CP_APPEND_ADDR_HI__MEM_ADDR_HI__SHIFT    = 0x00000000;
constexpr unsigned int CP_APPEND_ADDR_LO__MEM_ADDR_LO__SHIFT    = 0x00000002;
constexpr unsigned int CP_APPEND_DATA_HI__DATA__SHIFT           = 0x00000000;
constexpr unsigned int CP_APPEND_DATA_LO__DATA__SHIFT           = 0x00000000;
constexpr unsigned int CP_APPEND_LAST_CS_FENCE_HI__LAST_FENCE__SHIFT = 0x00000000;
constexpr unsigned int CP_APPEND_LAST_CS_FENCE_LO__LAST_FENCE__SHIFT = 0x00000000;
constexpr unsigned int CP_APPEND_LAST_PS_FENCE_HI__LAST_FENCE__SHIFT = 0x00000000;
constexpr unsigned int CP_APPEND_LAST_PS_FENCE_LO__LAST_FENCE__SHIFT = 0x00000000;
constexpr unsigned int CP_AQL_SMM_STATUS__AQL_QUEUE_SMM__SHIFT  = 0x00000000;
constexpr unsigned int CP_ATOMIC_PREOP_HI__ATOMIC_PREOP_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_ATOMIC_PREOP_LO__ATOMIC_PREOP_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_BUSY_STAT__CE_PARSING_PACKETS__SHIFT  = 0x00000016;
constexpr unsigned int CP_BUSY_STAT__COHER_CNT_NEQ_ZERO__SHIFT  = 0x00000006;
constexpr unsigned int CP_BUSY_STAT__EOP_DONE_BUSY__SHIFT       = 0x00000012;
constexpr unsigned int CP_BUSY_STAT__GFX_CONTEXT_BUSY__SHIFT    = 0x0000000f;
constexpr unsigned int CP_BUSY_STAT__ME_PARSER_BUSY__SHIFT      = 0x00000011;
constexpr unsigned int CP_BUSY_STAT__ME_PARSING_PACKETS__SHIFT  = 0x00000008;
constexpr unsigned int CP_BUSY_STAT__PFP_PARSING_PACKETS__SHIFT = 0x00000007;
constexpr unsigned int CP_BUSY_STAT__PIPE_STATS_BUSY__SHIFT     = 0x00000014;
constexpr unsigned int CP_BUSY_STAT__RCIU_CE_BUSY__SHIFT        = 0x00000015;
constexpr unsigned int CP_BUSY_STAT__RCIU_ME_BUSY__SHIFT        = 0x0000000a;
constexpr unsigned int CP_BUSY_STAT__RCIU_PFP_BUSY__SHIFT       = 0x00000009;
constexpr unsigned int CP_BUSY_STAT__REG_BUS_FIFO_BUSY__SHIFT   = 0x00000000;
constexpr unsigned int CP_BUSY_STAT__SEM_CMDFIFO_NOT_EMPTY__SHIFT = 0x0000000c;
constexpr unsigned int CP_BUSY_STAT__SEM_FAILED_AND_HOLDING__SHIFT = 0x0000000d;
constexpr unsigned int CP_BUSY_STAT__SEM_POLLING_FOR_PASS__SHIFT = 0x0000000e;
constexpr unsigned int CP_BUSY_STAT__STRM_OUT_BUSY__SHIFT       = 0x00000013;
constexpr unsigned int CP_CEQ1_AVAIL__CEQ_CNT_IB1__SHIFT        = 0x00000010;
constexpr unsigned int CP_CEQ1_AVAIL__CEQ_CNT_RING__SHIFT       = 0x00000000;
constexpr unsigned int CP_CEQ2_AVAIL__CEQ_CNT_IB2__SHIFT        = 0x00000000;
constexpr unsigned int CP_CE_COMPARE_COUNT__COMPARE_COUNT__SHIFT = 0x00000000;
constexpr unsigned int CP_CE_COMPLETION_STATUS__STATUS__SHIFT   = 0x00000000;
constexpr unsigned int CP_CE_COUNTER__CONST_ENGINE_COUNT__SHIFT = 0x00000000;
constexpr unsigned int CP_CE_DE_COUNT__DRAW_ENGINE_COUNT__SHIFT = 0x00000000;
constexpr unsigned int CP_CE_HEADER_DUMP__CE_HEADER_DUMP__SHIFT = 0x00000000;
constexpr unsigned int CP_CE_IB1_BASE_HI__IB1_BASE_HI__SHIFT    = 0x00000000;
constexpr unsigned int CP_CE_IB1_BASE_LO__IB1_BASE_LO__SHIFT    = 0x00000002;
constexpr unsigned int CP_CE_IB1_BUFSZ__IB1_BUFSZ__SHIFT        = 0x00000000;
constexpr unsigned int CP_CE_IB1_CMD_BUFSZ__IB1_CMD_REQSZ__SHIFT = 0x00000000;
constexpr unsigned int CP_CE_IB1_OFFSET__IB1_OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int CP_CE_IB2_BASE_HI__IB2_BASE_HI__SHIFT    = 0x00000000;
constexpr unsigned int CP_CE_IB2_BASE_LO__IB2_BASE_LO__SHIFT    = 0x00000002;
constexpr unsigned int CP_CE_IB2_BUFSZ__IB2_BUFSZ__SHIFT        = 0x00000000;
constexpr unsigned int CP_CE_IB2_CMD_BUFSZ__IB2_CMD_REQSZ__SHIFT = 0x00000000;
constexpr unsigned int CP_CE_IB2_OFFSET__IB2_OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int CP_CE_INIT_BASE_HI__INIT_BASE_HI__SHIFT  = 0x00000000;
constexpr unsigned int CP_CE_INIT_BASE_LO__INIT_BASE_LO__SHIFT  = 0x00000005;
constexpr unsigned int CP_CE_INIT_BUFSZ__INIT_BUFSZ__SHIFT      = 0x00000000;
constexpr unsigned int CP_CE_INIT_CMD_BUFSZ__INIT_CMD_REQSZ__SHIFT = 0x00000000;
constexpr unsigned int CP_CE_INSTR_PNTR__INSTR_PNTR__SHIFT      = 0x00000000;
constexpr unsigned int CP_CE_INTR_ROUTINE_START__IR_START__SHIFT = 0x00000000;
constexpr unsigned int CP_CE_METADATA_BASE_ADDR_HI__ADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_CE_METADATA_BASE_ADDR__ADDR_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_CE_PRGRM_CNTR_START__IP_START__SHIFT  = 0x00000000;
constexpr unsigned int CP_CE_ROQ_IB1_STAT__CEQ_RPTR_INDIRECT1__SHIFT = 0x00000000;
constexpr unsigned int CP_CE_ROQ_IB1_STAT__CEQ_WPTR_INDIRECT1__SHIFT = 0x00000010;
constexpr unsigned int CP_CE_ROQ_IB2_STAT__CEQ_RPTR_INDIRECT2__SHIFT = 0x00000000;
constexpr unsigned int CP_CE_ROQ_IB2_STAT__CEQ_WPTR_INDIRECT2__SHIFT = 0x00000010;
constexpr unsigned int CP_CE_ROQ_RB_STAT__CEQ_RPTR_PRIMARY__SHIFT = 0x00000000;
constexpr unsigned int CP_CE_ROQ_RB_STAT__CEQ_WPTR_PRIMARY__SHIFT = 0x00000010;
constexpr unsigned int CP_CMD_DATA__CMD_DATA__SHIFT             = 0x00000000;
constexpr unsigned int CP_CMD_INDEX__CMD_INDEX__SHIFT           = 0x00000000;
constexpr unsigned int CP_CMD_INDEX__CMD_ME_SEL__SHIFT          = 0x0000000c;
constexpr unsigned int CP_CMD_INDEX__CMD_QUEUE_SEL__SHIFT       = 0x00000010;
constexpr unsigned int CP_CNTX_STAT__ACTIVE_GFX_CONTEXTS__SHIFT = 0x00000014;
constexpr unsigned int CP_CNTX_STAT__ACTIVE_HP3D_CONTEXTS__SHIFT = 0x00000000;
constexpr unsigned int CP_CNTX_STAT__CURRENT_GFX_CONTEXT__SHIFT = 0x0000001c;
constexpr unsigned int CP_CNTX_STAT__CURRENT_HP3D_CONTEXT__SHIFT = 0x00000008;
constexpr unsigned int CP_COHER_BASE_HI__COHER_BASE_HI_256B__SHIFT = 0x00000000;
constexpr unsigned int CP_COHER_BASE__COHER_BASE_256B__SHIFT    = 0x00000000;
constexpr unsigned int CP_COHER_CNTL__CB_ACTION_ENA__SHIFT      = 0x00000019;
constexpr unsigned int CP_COHER_CNTL__DB_ACTION_ENA__SHIFT      = 0x0000001a;
constexpr unsigned int CP_COHER_CNTL__SH_ICACHE_ACTION_ENA__SHIFT = 0x0000001d;
constexpr unsigned int CP_COHER_CNTL__SH_KCACHE_ACTION_ENA__SHIFT = 0x0000001b;
constexpr unsigned int CP_COHER_CNTL__SH_KCACHE_VOL_ACTION_ENA__SHIFT = 0x0000001c;
constexpr unsigned int CP_COHER_CNTL__SH_KCACHE_WB_ACTION_ENA__SHIFT = 0x0000001e;
constexpr unsigned int CP_COHER_CNTL__TCL1_ACTION_ENA__SHIFT    = 0x00000016;
constexpr unsigned int CP_COHER_CNTL__TCL1_VOL_ACTION_ENA__SHIFT = 0x0000000f;
constexpr unsigned int CP_COHER_CNTL__TC_ACTION_ENA__SHIFT      = 0x00000017;
constexpr unsigned int CP_COHER_CNTL__TC_INV_METADATA_ACTION_ENA__SHIFT = 0x00000005;
constexpr unsigned int CP_COHER_CNTL__TC_NC_ACTION_ENA__SHIFT   = 0x00000003;
constexpr unsigned int CP_COHER_CNTL__TC_WB_ACTION_ENA__SHIFT   = 0x00000012;
constexpr unsigned int CP_COHER_CNTL__TC_WC_ACTION_ENA__SHIFT   = 0x00000004;
constexpr unsigned int CP_COHER_SIZE_HI__COHER_SIZE_HI_256B__SHIFT = 0x00000000;
constexpr unsigned int CP_COHER_SIZE__COHER_SIZE_256B__SHIFT    = 0x00000000;
constexpr unsigned int CP_COHER_START_DELAY__START_DELAY_COUNT__SHIFT = 0x00000000;
constexpr unsigned int CP_COHER_STATUS__MEID__SHIFT             = 0x00000018;
constexpr unsigned int CP_COHER_STATUS__STATUS__SHIFT           = 0x0000001f;
constexpr unsigned int CP_CONTEXT_CNTL__ME0PIPE0_MAX_PIPE_CNTX__SHIFT = 0x00000004;
constexpr unsigned int CP_CONTEXT_CNTL__ME0PIPE1_MAX_PIPE_CNTX__SHIFT = 0x00000014;
constexpr unsigned int CP_CSF_STAT__BUFFER_REQUEST_COUNT__SHIFT = 0x00000008;
constexpr unsigned int CP_DEVICE_ID__DEVICE_ID__SHIFT           = 0x00000000;
constexpr unsigned int CP_DE_CE_COUNT__CONST_ENGINE_COUNT__SHIFT = 0x00000000;
constexpr unsigned int CP_DE_DE_COUNT__DRAW_ENGINE_COUNT__SHIFT = 0x00000000;
constexpr unsigned int CP_DE_LAST_INVAL_COUNT__LAST_INVAL_COUNT__SHIFT = 0x00000000;
constexpr unsigned int CP_DFY_ADDR_HI__ADDR_HI__SHIFT           = 0x00000000;
constexpr unsigned int CP_DFY_ADDR_LO__ADDR_LO__SHIFT           = 0x00000005;
constexpr unsigned int CP_DFY_CMD__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int CP_DFY_CMD__SIZE__SHIFT                  = 0x00000010;
constexpr unsigned int CP_DFY_CNTL__ENABLE__SHIFT               = 0x0000001f;
constexpr unsigned int CP_DFY_CNTL__LFSR_RESET__SHIFT           = 0x0000001c;
constexpr unsigned int CP_DFY_CNTL__MODE__SHIFT                 = 0x0000001d;
constexpr unsigned int CP_DFY_CNTL__TPI_SDP_SEL__SHIFT          = 0x0000001a;
constexpr unsigned int CP_DFY_DATA_0__DATA__SHIFT               = 0x00000000;
constexpr unsigned int CP_DFY_DATA_1__DATA__SHIFT               = 0x00000000;
constexpr unsigned int CP_DFY_DATA_2__DATA__SHIFT               = 0x00000000;
constexpr unsigned int CP_DFY_DATA_3__DATA__SHIFT               = 0x00000000;
constexpr unsigned int CP_DFY_DATA_4__DATA__SHIFT               = 0x00000000;
constexpr unsigned int CP_DFY_DATA_5__DATA__SHIFT               = 0x00000000;
constexpr unsigned int CP_DFY_DATA_6__DATA__SHIFT               = 0x00000000;
constexpr unsigned int CP_DFY_DATA_7__DATA__SHIFT               = 0x00000000;
constexpr unsigned int CP_DFY_DATA_8__DATA__SHIFT               = 0x00000000;
constexpr unsigned int CP_DFY_DATA_9__DATA__SHIFT               = 0x00000000;
constexpr unsigned int CP_DFY_DATA_10__DATA__SHIFT              = 0x00000000;
constexpr unsigned int CP_DFY_DATA_11__DATA__SHIFT              = 0x00000000;
constexpr unsigned int CP_DFY_DATA_12__DATA__SHIFT              = 0x00000000;
constexpr unsigned int CP_DFY_DATA_13__DATA__SHIFT              = 0x00000000;
constexpr unsigned int CP_DFY_DATA_14__DATA__SHIFT              = 0x00000000;
constexpr unsigned int CP_DFY_DATA_15__DATA__SHIFT              = 0x00000000;
constexpr unsigned int CP_DFY_STAT__BURST_COUNT__SHIFT          = 0x00000000;
constexpr unsigned int CP_DFY_STAT__BUSY__SHIFT                 = 0x0000001f;
constexpr unsigned int CP_DFY_STAT__TAGS_PENDING__SHIFT         = 0x00000010;
constexpr unsigned int CP_DISPATCH_INDR_ADDR_HI__ADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_DISPATCH_INDR_ADDR__ADDR_LO__SHIFT    = 0x00000000;
constexpr unsigned int CP_DMA_CNTL__BUFFER_DEPTH__SHIFT         = 0x00000010;
constexpr unsigned int CP_DMA_CNTL__MIN_AVAILSZ__SHIFT          = 0x00000004;
constexpr unsigned int CP_DMA_CNTL__PIO_COUNT__SHIFT            = 0x0000001e;
constexpr unsigned int CP_DMA_CNTL__PIO_FIFO_EMPTY__SHIFT       = 0x0000001c;
constexpr unsigned int CP_DMA_CNTL__PIO_FIFO_FULL__SHIFT        = 0x0000001d;
constexpr unsigned int CP_DMA_CNTL__UTCL1_FAULT_CONTROL__SHIFT  = 0x00000000;
constexpr unsigned int CP_DMA_ME_COMMAND__BYTE_COUNT__SHIFT     = 0x00000000;
constexpr unsigned int CP_DMA_ME_COMMAND__DAIC__SHIFT           = 0x0000001d;
constexpr unsigned int CP_DMA_ME_COMMAND__DAS__SHIFT            = 0x0000001b;
constexpr unsigned int CP_DMA_ME_COMMAND__DIS_WC__SHIFT         = 0x0000001f;
constexpr unsigned int CP_DMA_ME_COMMAND__RAW_WAIT__SHIFT       = 0x0000001e;
constexpr unsigned int CP_DMA_ME_COMMAND__SAIC__SHIFT           = 0x0000001c;
constexpr unsigned int CP_DMA_ME_COMMAND__SAS__SHIFT            = 0x0000001a;
constexpr unsigned int CP_DMA_ME_CONTROL__DST_CACHE_POLICY__SHIFT = 0x00000019;
constexpr unsigned int CP_DMA_ME_CONTROL__DST_SELECT__SHIFT     = 0x00000014;
constexpr unsigned int CP_DMA_ME_CONTROL__MEMLOG_CLEAR__SHIFT   = 0x0000000a;
constexpr unsigned int CP_DMA_ME_CONTROL__SRC_CACHE_POLICY__SHIFT = 0x0000000d;
constexpr unsigned int CP_DMA_ME_CONTROL__SRC_SELECT__SHIFT     = 0x0000001d;
constexpr unsigned int CP_DMA_ME_DST_ADDR_HI__DST_ADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_DMA_ME_DST_ADDR__DST_ADDR__SHIFT      = 0x00000000;
constexpr unsigned int CP_DMA_ME_SRC_ADDR_HI__SRC_ADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_DMA_ME_SRC_ADDR__SRC_ADDR__SHIFT      = 0x00000000;
constexpr unsigned int CP_DMA_PFP_COMMAND__BYTE_COUNT__SHIFT    = 0x00000000;
constexpr unsigned int CP_DMA_PFP_COMMAND__DAIC__SHIFT          = 0x0000001d;
constexpr unsigned int CP_DMA_PFP_COMMAND__DAS__SHIFT           = 0x0000001b;
constexpr unsigned int CP_DMA_PFP_COMMAND__DIS_WC__SHIFT        = 0x0000001f;
constexpr unsigned int CP_DMA_PFP_COMMAND__RAW_WAIT__SHIFT      = 0x0000001e;
constexpr unsigned int CP_DMA_PFP_COMMAND__SAIC__SHIFT          = 0x0000001c;
constexpr unsigned int CP_DMA_PFP_COMMAND__SAS__SHIFT           = 0x0000001a;
constexpr unsigned int CP_DMA_PFP_CONTROL__DST_CACHE_POLICY__SHIFT = 0x00000019;
constexpr unsigned int CP_DMA_PFP_CONTROL__DST_SELECT__SHIFT    = 0x00000014;
constexpr unsigned int CP_DMA_PFP_CONTROL__MEMLOG_CLEAR__SHIFT  = 0x0000000a;
constexpr unsigned int CP_DMA_PFP_CONTROL__SRC_CACHE_POLICY__SHIFT = 0x0000000d;
constexpr unsigned int CP_DMA_PFP_CONTROL__SRC_SELECT__SHIFT    = 0x0000001d;
constexpr unsigned int CP_DMA_PFP_DST_ADDR_HI__DST_ADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_DMA_PFP_DST_ADDR__DST_ADDR__SHIFT     = 0x00000000;
constexpr unsigned int CP_DMA_PFP_SRC_ADDR_HI__SRC_ADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_DMA_PFP_SRC_ADDR__SRC_ADDR__SHIFT     = 0x00000000;
constexpr unsigned int CP_DMA_PIO_COMMAND__BYTE_COUNT__SHIFT    = 0x00000000;
constexpr unsigned int CP_DMA_PIO_COMMAND__DAIC__SHIFT          = 0x0000001d;
constexpr unsigned int CP_DMA_PIO_COMMAND__DAS__SHIFT           = 0x0000001b;
constexpr unsigned int CP_DMA_PIO_COMMAND__DIS_WC__SHIFT        = 0x0000001f;
constexpr unsigned int CP_DMA_PIO_COMMAND__RAW_WAIT__SHIFT      = 0x0000001e;
constexpr unsigned int CP_DMA_PIO_COMMAND__SAIC__SHIFT          = 0x0000001c;
constexpr unsigned int CP_DMA_PIO_COMMAND__SAS__SHIFT           = 0x0000001a;
constexpr unsigned int CP_DMA_READ_TAGS__DMA_READ_TAG_VALID__SHIFT = 0x0000001c;
constexpr unsigned int CP_DMA_READ_TAGS__DMA_READ_TAG__SHIFT    = 0x00000000;
constexpr unsigned int CP_DRAW_INDX_INDR_ADDR_HI__ADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_DRAW_INDX_INDR_ADDR__ADDR_LO__SHIFT   = 0x00000000;
constexpr unsigned int CP_DRAW_OBJECT_COUNTER__COUNT__SHIFT     = 0x00000000;
constexpr unsigned int CP_DRAW_OBJECT__OBJECT__SHIFT            = 0x00000000;
constexpr unsigned int CP_DRAW_WINDOW_CNTL__DISABLE_DRAW_WINDOW_HI__SHIFT = 0x00000002;
constexpr unsigned int CP_DRAW_WINDOW_CNTL__DISABLE_DRAW_WINDOW_LO_MAX__SHIFT = 0x00000000;
constexpr unsigned int CP_DRAW_WINDOW_CNTL__DISABLE_DRAW_WINDOW_LO_MIN__SHIFT = 0x00000001;
constexpr unsigned int CP_DRAW_WINDOW_CNTL__MODE__SHIFT         = 0x00000008;
constexpr unsigned int CP_DRAW_WINDOW_HI__WINDOW_HI__SHIFT      = 0x00000000;
constexpr unsigned int CP_DRAW_WINDOW_LO__MAX__SHIFT            = 0x00000010;
constexpr unsigned int CP_DRAW_WINDOW_LO__MIN__SHIFT            = 0x00000000;
constexpr unsigned int CP_DRAW_WINDOW_MASK_HI__WINDOW_MASK_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_ECC_FIRSTOCCURRENCE_RING0__OBSOLETE__SHIFT = 0x00000000;
constexpr unsigned int CP_ECC_FIRSTOCCURRENCE_RING1__OBSOLETE__SHIFT = 0x00000000;
constexpr unsigned int CP_ECC_FIRSTOCCURRENCE_RING2__OBSOLETE__SHIFT = 0x00000000;
constexpr unsigned int CP_ECC_FIRSTOCCURRENCE__CLIENT__SHIFT    = 0x00000004;
constexpr unsigned int CP_ECC_FIRSTOCCURRENCE__INTERFACE__SHIFT = 0x00000000;
constexpr unsigned int CP_ECC_FIRSTOCCURRENCE__ME__SHIFT        = 0x00000008;
constexpr unsigned int CP_ECC_FIRSTOCCURRENCE__PIPE__SHIFT      = 0x0000000a;
constexpr unsigned int CP_ECC_FIRSTOCCURRENCE__QUEUE__SHIFT     = 0x0000000c;
constexpr unsigned int CP_ECC_FIRSTOCCURRENCE__VMID__SHIFT      = 0x00000010;
constexpr unsigned int CP_EOPQ_WAIT_TIME__SCALE_COUNT__SHIFT    = 0x0000000a;
constexpr unsigned int CP_EOPQ_WAIT_TIME__WAIT_TIME__SHIFT      = 0x00000000;
constexpr unsigned int CP_EOP_DONE_ADDR_HI__ADDR_HI__SHIFT      = 0x00000000;
constexpr unsigned int CP_EOP_DONE_ADDR_LO__ADDR_LO__SHIFT      = 0x00000002;
constexpr unsigned int CP_EOP_DONE_CNTX_ID__CNTX_ID__SHIFT      = 0x00000000;
constexpr unsigned int CP_EOP_DONE_DATA_CNTL__DATA_SEL__SHIFT   = 0x0000001d;
constexpr unsigned int CP_EOP_DONE_DATA_CNTL__DST_SEL__SHIFT    = 0x00000010;
constexpr unsigned int CP_EOP_DONE_DATA_CNTL__INT_SEL__SHIFT    = 0x00000018;
constexpr unsigned int CP_EOP_DONE_DATA_HI__DATA_HI__SHIFT      = 0x00000000;
constexpr unsigned int CP_EOP_DONE_DATA_LO__DATA_LO__SHIFT      = 0x00000000;
constexpr unsigned int CP_EOP_DONE_EVENT_CNTL__CACHE_POLICY__SHIFT = 0x00000019;
constexpr unsigned int CP_EOP_DONE_EVENT_CNTL__EXECUTE__SHIFT   = 0x0000001c;
constexpr unsigned int CP_EOP_LAST_FENCE_HI__LAST_FENCE_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_EOP_LAST_FENCE_LO__LAST_FENCE_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_FATAL_ERROR__CPF_FATAL_ERROR__SHIFT   = 0x00000000;
constexpr unsigned int CP_FATAL_ERROR__CPG_FATAL_ERROR__SHIFT   = 0x00000001;
constexpr unsigned int CP_FATAL_ERROR__CPG_TAG_FATAL_ERROR_EN__SHIFT = 0x00000004;
constexpr unsigned int CP_FATAL_ERROR__DIS_CPG_FATAL_ERROR__SHIFT = 0x00000003;
constexpr unsigned int CP_FATAL_ERROR__GFX_HALT_PROC__SHIFT     = 0x00000002;
constexpr unsigned int CP_GFX_ERROR__APPEND_UTCL1_ERROR__SHIFT  = 0x0000000f;
constexpr unsigned int CP_GFX_ERROR__C1_FETCHER_UTCL1_ERROR__SHIFT = 0x0000001c;
constexpr unsigned int CP_GFX_ERROR__C2_FETCHER_UTCL1_ERROR__SHIFT = 0x0000001d;
constexpr unsigned int CP_GFX_ERROR__CE_DMA_UTCL1_ERROR__SHIFT  = 0x00000010;
constexpr unsigned int CP_GFX_ERROR__CE_INIT_UTCL1_ERROR__SHIFT = 0x0000001f;
constexpr unsigned int CP_GFX_ERROR__CE_TC_UTCL1_ERROR__SHIFT   = 0x00000016;
constexpr unsigned int CP_GFX_ERROR__DMA_DST_UTCL1_ERROR__SHIFT = 0x00000013;
constexpr unsigned int CP_GFX_ERROR__DMA_SRC_UTCL1_ERROR__SHIFT = 0x00000012;
constexpr unsigned int CP_GFX_ERROR__EDC_ERROR_ID__SHIFT        = 0x00000000;
constexpr unsigned int CP_GFX_ERROR__I1_FETCHER_UTCL1_ERROR__SHIFT = 0x0000001a;
constexpr unsigned int CP_GFX_ERROR__I2_FETCHER_UTCL1_ERROR__SHIFT = 0x0000001b;
constexpr unsigned int CP_GFX_ERROR__ME_TC_UTCL1_ERROR__SHIFT   = 0x00000015;
constexpr unsigned int CP_GFX_ERROR__PFP_TC_UTCL1_ERROR__SHIFT  = 0x00000014;
constexpr unsigned int CP_GFX_ERROR__PFP_VGTDMA_UTCL1_ERROR__SHIFT = 0x00000011;
constexpr unsigned int CP_GFX_ERROR__PRT_LOD_UTCL1_ERROR__SHIFT = 0x00000017;
constexpr unsigned int CP_GFX_ERROR__QU_EOP_UTCL1_ERROR__SHIFT  = 0x00000009;
constexpr unsigned int CP_GFX_ERROR__QU_PIPE_UTCL1_ERROR__SHIFT = 0x0000000a;
constexpr unsigned int CP_GFX_ERROR__QU_READ_UTCL1_ERROR__SHIFT = 0x0000000b;
constexpr unsigned int CP_GFX_ERROR__QU_STRM_UTCL1_ERROR__SHIFT = 0x00000008;
constexpr unsigned int CP_GFX_ERROR__RB_FETCHER_UTCL1_ERROR__SHIFT = 0x00000019;
constexpr unsigned int CP_GFX_ERROR__RDPTR_RPT_UTCL1_ERROR__SHIFT = 0x00000018;
constexpr unsigned int CP_GFX_ERROR__SEM_UTCL1_ERROR__SHIFT     = 0x00000007;
constexpr unsigned int CP_GFX_ERROR__SHADOW_UTCL1_ERROR__SHIFT  = 0x0000000e;
constexpr unsigned int CP_GFX_ERROR__ST_FETCHER_UTCL1_ERROR__SHIFT = 0x0000001e;
constexpr unsigned int CP_GFX_ERROR__SUA_ERROR__SHIFT           = 0x00000004;
constexpr unsigned int CP_GFX_ERROR__SYNC_MEMRD_UTCL1_ERROR__SHIFT = 0x0000000c;
constexpr unsigned int CP_GFX_ERROR__SYNC_MEMWR_UTCL1_ERROR__SHIFT = 0x0000000d;
constexpr unsigned int CP_GFX_MQD_BASE_ADDR_HI__BASE_ADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_GFX_MQD_BASE_ADDR__BASE_ADDR__SHIFT   = 0x00000002;
constexpr unsigned int CP_GFX_MQD_CONTROL__CACHE_POLICY__SHIFT  = 0x00000018;
constexpr unsigned int CP_GFX_MQD_CONTROL__EXE_DISABLE__SHIFT   = 0x00000017;
constexpr unsigned int CP_GFX_MQD_CONTROL__PRIV_STATE__SHIFT    = 0x00000008;
constexpr unsigned int CP_GFX_MQD_CONTROL__VMID__SHIFT          = 0x00000000;
constexpr unsigned int CP_GRBM_FREE_COUNT__FREE_COUNT_GDS__SHIFT = 0x00000008;
constexpr unsigned int CP_GRBM_FREE_COUNT__FREE_COUNT_PFP__SHIFT = 0x00000010;
constexpr unsigned int CP_GRBM_FREE_COUNT__FREE_COUNT__SHIFT    = 0x00000000;
constexpr unsigned int CP_HPD_ROQ_OFFSETS__IB_OFFSET__SHIFT     = 0x00000010;
constexpr unsigned int CP_HPD_ROQ_OFFSETS__IQ_OFFSET__SHIFT     = 0x00000000;
constexpr unsigned int CP_HPD_ROQ_OFFSETS__PQ_OFFSET__SHIFT     = 0x00000008;
constexpr unsigned int CP_HPD_STATUS0__FETCHING_MQD__SHIFT      = 0x00000010;
constexpr unsigned int CP_HPD_STATUS0__FORCE_QUEUE_STATE__SHIFT = 0x00000014;
constexpr unsigned int CP_HPD_STATUS0__FORCE_QUEUE__SHIFT       = 0x0000001f;
constexpr unsigned int CP_HPD_STATUS0__MAPPED_QUEUE__SHIFT      = 0x00000005;
constexpr unsigned int CP_HPD_STATUS0__PEND_TXFER_SIZE_IQ__SHIFT = 0x00000012;
constexpr unsigned int CP_HPD_STATUS0__PEND_TXFER_SIZE_PQIB__SHIFT = 0x00000011;
constexpr unsigned int CP_HPD_STATUS0__QUEUE_AVAILABLE__SHIFT   = 0x00000008;
constexpr unsigned int CP_HPD_STATUS0__QUEUE_STATE__SHIFT       = 0x00000000;
constexpr unsigned int CP_HPD_UTCL1_CNTL__SELECT__SHIFT         = 0x00000000;
constexpr unsigned int CP_HPD_UTCL1_ERROR_ADDR__ADDR__SHIFT     = 0x0000000c;
constexpr unsigned int CP_HPD_UTCL1_ERROR__ADDR_HI__SHIFT       = 0x00000000;
constexpr unsigned int CP_HPD_UTCL1_ERROR__TYPE__SHIFT          = 0x00000010;
constexpr unsigned int CP_HPD_UTCL1_ERROR__VMID__SHIFT          = 0x00000014;
constexpr unsigned int CP_HQD_ACTIVE__ACTIVE__SHIFT             = 0x00000000;
constexpr unsigned int CP_HQD_ACTIVE__BUSY_GATE__SHIFT          = 0x00000001;
constexpr unsigned int CP_HQD_AQL_CONTROL__CONTROL0_EN__SHIFT   = 0x0000000f;
constexpr unsigned int CP_HQD_AQL_CONTROL__CONTROL0__SHIFT      = 0x00000000;
constexpr unsigned int CP_HQD_AQL_CONTROL__CONTROL1_EN__SHIFT   = 0x0000001f;
constexpr unsigned int CP_HQD_AQL_CONTROL__CONTROL1__SHIFT      = 0x00000010;
constexpr unsigned int CP_HQD_ATOMIC0_PREOP_HI__ATOMIC0_PREOP_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_HQD_ATOMIC0_PREOP_LO__ATOMIC0_PREOP_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_HQD_ATOMIC1_PREOP_HI__ATOMIC1_PREOP_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_HQD_ATOMIC1_PREOP_LO__ATOMIC1_PREOP_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_HQD_CNTL_STACK_OFFSET__OFFSET__SHIFT  = 0x00000002;
constexpr unsigned int CP_HQD_CNTL_STACK_SIZE__SIZE__SHIFT      = 0x0000000c;
constexpr unsigned int CP_HQD_CTX_SAVE_BASE_ADDR_HI__ADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_HQD_CTX_SAVE_BASE_ADDR_LO__ADDR__SHIFT = 0x0000000c;
constexpr unsigned int CP_HQD_CTX_SAVE_CONTROL__EXE_DISABLE__SHIFT = 0x00000017;
constexpr unsigned int CP_HQD_CTX_SAVE_CONTROL__POLICY__SHIFT   = 0x00000003;
constexpr unsigned int CP_HQD_CTX_SAVE_SIZE__SIZE__SHIFT        = 0x0000000c;
constexpr unsigned int CP_HQD_DEQUEUE_REQUEST__DEQUEUE_INT__SHIFT = 0x00000008;
constexpr unsigned int CP_HQD_DEQUEUE_REQUEST__DEQUEUE_REQ_EN__SHIFT = 0x0000000a;
constexpr unsigned int CP_HQD_DEQUEUE_REQUEST__DEQUEUE_REQ__SHIFT = 0x00000000;
constexpr unsigned int CP_HQD_DEQUEUE_REQUEST__IQ_REQ_PEND_EN__SHIFT = 0x00000009;
constexpr unsigned int CP_HQD_DEQUEUE_REQUEST__IQ_REQ_PEND__SHIFT = 0x00000004;
constexpr unsigned int CP_HQD_DMA_OFFLOAD__DMA_OFFLOAD__SHIFT   = 0x00000000;
constexpr unsigned int CP_HQD_EOP_BASE_ADDR_HI__BASE_ADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_HQD_EOP_BASE_ADDR__BASE_ADDR__SHIFT   = 0x00000000;
constexpr unsigned int CP_HQD_EOP_CONTROL__CACHE_POLICY__SHIFT  = 0x00000018;
constexpr unsigned int CP_HQD_EOP_CONTROL__EOP_SIZE__SHIFT      = 0x00000000;
constexpr unsigned int CP_HQD_EOP_CONTROL__EXE_DISABLE__SHIFT   = 0x00000017;
constexpr unsigned int CP_HQD_EOP_CONTROL__HALT_FETCHER_EN__SHIFT = 0x00000016;
constexpr unsigned int CP_HQD_EOP_CONTROL__HALT_FETCHER__SHIFT  = 0x00000015;
constexpr unsigned int CP_HQD_EOP_CONTROL__PEND_SIG_SEM__SHIFT  = 0x0000001f;
constexpr unsigned int CP_HQD_EOP_CONTROL__PROCESSING_EOPIB__SHIFT = 0x0000000d;
constexpr unsigned int CP_HQD_EOP_CONTROL__PROCESSING_EOP__SHIFT = 0x00000008;
constexpr unsigned int CP_HQD_EOP_CONTROL__PROCESS_EOPIB_EN__SHIFT = 0x0000000e;
constexpr unsigned int CP_HQD_EOP_CONTROL__PROCESS_EOP_EN__SHIFT = 0x0000000c;
constexpr unsigned int CP_HQD_EOP_CONTROL__SIG_SEM_RESULT__SHIFT = 0x0000001d;
constexpr unsigned int CP_HQD_EOP_EVENTS__CS_PARTIAL_FLUSH_PEND__SHIFT = 0x00000010;
constexpr unsigned int CP_HQD_EOP_EVENTS__EVENT_COUNT__SHIFT    = 0x00000000;
constexpr unsigned int CP_HQD_EOP_RPTR__DEQUEUE_PEND__SHIFT     = 0x0000001d;
constexpr unsigned int CP_HQD_EOP_RPTR__INIT_FETCHER__SHIFT     = 0x0000001f;
constexpr unsigned int CP_HQD_EOP_RPTR__RESET_FETCHER__SHIFT    = 0x0000001c;
constexpr unsigned int CP_HQD_EOP_RPTR__RPTR_EQ_CSMD_WPTR__SHIFT = 0x0000001e;
constexpr unsigned int CP_HQD_EOP_RPTR__RPTR__SHIFT             = 0x00000000;
constexpr unsigned int CP_HQD_EOP_WPTR_MEM__WPTR__SHIFT         = 0x00000000;
constexpr unsigned int CP_HQD_EOP_WPTR__EOP_AVAIL__SHIFT        = 0x00000010;
constexpr unsigned int CP_HQD_EOP_WPTR__EOP_EMPTY__SHIFT        = 0x0000000f;
constexpr unsigned int CP_HQD_EOP_WPTR__WPTR__SHIFT             = 0x00000000;
constexpr unsigned int CP_HQD_ERROR__AQL_ERROR__SHIFT           = 0x00000005;
constexpr unsigned int CP_HQD_ERROR__DMA_DST_UTCL1_ERROR__SHIFT = 0x00000010;
constexpr unsigned int CP_HQD_ERROR__DMA_SRC_UTCL1_ERROR__SHIFT = 0x0000000f;
constexpr unsigned int CP_HQD_ERROR__EDC_ERROR_ID__SHIFT        = 0x00000000;
constexpr unsigned int CP_HQD_ERROR__EOP_UTCL1_ERROR__SHIFT     = 0x0000000a;
constexpr unsigned int CP_HQD_ERROR__IB_UTCL1_ERROR__SHIFT      = 0x00000009;
constexpr unsigned int CP_HQD_ERROR__IQ_UTCL1_ERROR__SHIFT      = 0x0000000b;
constexpr unsigned int CP_HQD_ERROR__PQ_UTCL1_ERROR__SHIFT      = 0x00000008;
constexpr unsigned int CP_HQD_ERROR__QU_UTCL1_ERROR__SHIFT      = 0x00000012;
constexpr unsigned int CP_HQD_ERROR__RRPT_UTCL1_ERROR__SHIFT    = 0x0000000c;
constexpr unsigned int CP_HQD_ERROR__SEM_UTCL1_ERROR__SHIFT     = 0x0000000e;
constexpr unsigned int CP_HQD_ERROR__SR_UTCL1_ERROR__SHIFT      = 0x00000011;
constexpr unsigned int CP_HQD_ERROR__SUA_ERROR__SHIFT           = 0x00000004;
constexpr unsigned int CP_HQD_ERROR__TC_UTCL1_ERROR__SHIFT      = 0x00000013;
constexpr unsigned int CP_HQD_ERROR__WPP_UTCL1_ERROR__SHIFT     = 0x0000000d;
constexpr unsigned int CP_HQD_GFX_CONTROL__DB_UPDATED_MSG_EN__SHIFT = 0x0000000f;
constexpr unsigned int CP_HQD_GFX_CONTROL__MESSAGE__SHIFT       = 0x00000000;
constexpr unsigned int CP_HQD_GFX_CONTROL__MISC__SHIFT          = 0x00000004;
constexpr unsigned int CP_HQD_GFX_STATUS__STATUS__SHIFT         = 0x00000000;
constexpr unsigned int CP_HQD_HQ_CONTROL0__CONTROL__SHIFT       = 0x00000000;
constexpr unsigned int CP_HQD_HQ_CONTROL1__CONTROL__SHIFT       = 0x00000000;
constexpr unsigned int CP_HQD_HQ_SCHEDULER0__SCHEDULER__SHIFT   = 0x00000000;
constexpr unsigned int CP_HQD_HQ_SCHEDULER1__SCHEDULER__SHIFT   = 0x00000000;
constexpr unsigned int CP_HQD_HQ_STATUS0__DB_UPDATED_MSG_EN__SHIFT = 0x0000001f;
constexpr unsigned int CP_HQD_HQ_STATUS0__DEQUEUE_RETRY_CNT__SHIFT = 0x00000002;
constexpr unsigned int CP_HQD_HQ_STATUS0__DEQUEUE_STATUS__SHIFT = 0x00000000;
constexpr unsigned int CP_HQD_HQ_STATUS0__PG_ACTIVATED__SHIFT   = 0x00000009;
constexpr unsigned int CP_HQD_HQ_STATUS0__QUEUE_IDLE__SHIFT     = 0x0000001e;
constexpr unsigned int CP_HQD_HQ_STATUS0__RSVR_29_10__SHIFT     = 0x0000000a;
constexpr unsigned int CP_HQD_HQ_STATUS0__RSV_6_4__SHIFT        = 0x00000004;
constexpr unsigned int CP_HQD_HQ_STATUS0__SCRATCH_RAM_INIT__SHIFT = 0x00000007;
constexpr unsigned int CP_HQD_HQ_STATUS0__TCL2_DIRTY__SHIFT     = 0x00000008;
constexpr unsigned int CP_HQD_HQ_STATUS1__STATUS__SHIFT         = 0x00000000;
constexpr unsigned int CP_HQD_IB_BASE_ADDR_HI__IB_BASE_ADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_HQD_IB_BASE_ADDR__IB_BASE_ADDR__SHIFT = 0x00000002;
constexpr unsigned int CP_HQD_IB_CONTROL__IB_CACHE_POLICY__SHIFT = 0x00000018;
constexpr unsigned int CP_HQD_IB_CONTROL__IB_EXE_DISABLE__SHIFT = 0x00000017;
constexpr unsigned int CP_HQD_IB_CONTROL__IB_SIZE__SHIFT        = 0x00000000;
constexpr unsigned int CP_HQD_IB_CONTROL__MIN_IB_AVAIL_SIZE__SHIFT = 0x00000014;
constexpr unsigned int CP_HQD_IB_CONTROL__PROCESSING_IB__SHIFT  = 0x0000001f;
constexpr unsigned int CP_HQD_IB_RPTR__CONSUMED_OFFSET__SHIFT   = 0x00000000;
constexpr unsigned int CP_HQD_IQ_RPTR__OFFSET__SHIFT            = 0x00000000;
constexpr unsigned int CP_HQD_IQ_TIMER__ACTIVE__SHIFT           = 0x0000001f;
constexpr unsigned int CP_HQD_IQ_TIMER__CACHE_POLICY__SHIFT     = 0x00000018;
constexpr unsigned int CP_HQD_IQ_TIMER__CLOCK_COUNT__SHIFT      = 0x0000000e;
constexpr unsigned int CP_HQD_IQ_TIMER__EXE_DISABLE__SHIFT      = 0x00000017;
constexpr unsigned int CP_HQD_IQ_TIMER__IMMEDIATE_EXPIRE__SHIFT = 0x0000000b;
constexpr unsigned int CP_HQD_IQ_TIMER__INTERRUPT_SIZE__SHIFT   = 0x00000010;
constexpr unsigned int CP_HQD_IQ_TIMER__INTERRUPT_TYPE__SHIFT   = 0x0000000c;
constexpr unsigned int CP_HQD_IQ_TIMER__PROCESSING_IQ__SHIFT    = 0x0000001e;
constexpr unsigned int CP_HQD_IQ_TIMER__PROCESS_IQ_EN__SHIFT    = 0x0000001d;
constexpr unsigned int CP_HQD_IQ_TIMER__QUANTUM_TIMER__SHIFT    = 0x00000016;
constexpr unsigned int CP_HQD_IQ_TIMER__REARM_TIMER__SHIFT      = 0x0000001c;
constexpr unsigned int CP_HQD_IQ_TIMER__RETRY_TYPE__SHIFT       = 0x00000008;
constexpr unsigned int CP_HQD_IQ_TIMER__WAIT_TIME__SHIFT        = 0x00000000;
constexpr unsigned int CP_HQD_MSG_TYPE__ACTION__SHIFT           = 0x00000000;
constexpr unsigned int CP_HQD_MSG_TYPE__SAVE_STATE__SHIFT       = 0x00000004;
constexpr unsigned int CP_HQD_OFFLOAD__AQL_OFFLOAD_EN__SHIFT    = 0x00000003;
constexpr unsigned int CP_HQD_OFFLOAD__AQL_OFFLOAD__SHIFT       = 0x00000002;
constexpr unsigned int CP_HQD_OFFLOAD__DMA_OFFLOAD_EN__SHIFT    = 0x00000001;
constexpr unsigned int CP_HQD_OFFLOAD__DMA_OFFLOAD__SHIFT       = 0x00000000;
constexpr unsigned int CP_HQD_OFFLOAD__EOP_OFFLOAD_EN__SHIFT    = 0x00000005;
constexpr unsigned int CP_HQD_OFFLOAD__EOP_OFFLOAD__SHIFT       = 0x00000004;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__CACHE_FULL_PACKET_EN__SHIFT = 0x0000001b;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__DISP_ACTIVE__SHIFT = 0x0000001f;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__EOP_SWITCH_QOS_EN__SHIFT = 0x00000018;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__IB_SWITCH_QOS_EN__SHIFT = 0x00000017;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__IQ_SWITCH_QOS_EN__SHIFT = 0x00000016;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__PQ_SWITCH_QOS_EN__SHIFT = 0x00000019;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__PRELOAD_REQ__SHIFT = 0x00000000;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__PRELOAD_SIZE__SHIFT = 0x00000008;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__QSWITCH_MODE__SHIFT = 0x0000001e;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__RELAUNCH_WAVES__SHIFT = 0x0000001d;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__RESTORE_ACTIVE__SHIFT = 0x0000001c;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__TC_OFFLOAD_QOS_EN__SHIFT = 0x0000001a;
constexpr unsigned int CP_HQD_PERSISTENT_STATE__WPP_SWITCH_QOS_EN__SHIFT = 0x00000015;
constexpr unsigned int CP_HQD_PIPE_PRIORITY__PIPE_PRIORITY__SHIFT = 0x00000000;
constexpr unsigned int CP_HQD_PQ_BASE_HI__ADDR_HI__SHIFT        = 0x00000000;
constexpr unsigned int CP_HQD_PQ_BASE__ADDR__SHIFT              = 0x00000000;
constexpr unsigned int CP_HQD_PQ_CONTROL__CACHE_POLICY__SHIFT   = 0x00000018;
constexpr unsigned int CP_HQD_PQ_CONTROL__EXE_DISABLE__SHIFT    = 0x00000017;
constexpr unsigned int CP_HQD_PQ_CONTROL__KMD_QUEUE__SHIFT      = 0x0000001f;
constexpr unsigned int CP_HQD_PQ_CONTROL__MIN_AVAIL_SIZE__SHIFT = 0x00000014;
constexpr unsigned int CP_HQD_PQ_CONTROL__NO_UPDATE_RPTR__SHIFT = 0x0000001b;
constexpr unsigned int CP_HQD_PQ_CONTROL__PQ_EMPTY__SHIFT       = 0x0000000f;
constexpr unsigned int CP_HQD_PQ_CONTROL__PRIV_STATE__SHIFT     = 0x0000001e;
constexpr unsigned int CP_HQD_PQ_CONTROL__QUEUE_FULL_EN__SHIFT  = 0x0000000e;
constexpr unsigned int CP_HQD_PQ_CONTROL__QUEUE_SIZE__SHIFT     = 0x00000000;
constexpr unsigned int CP_HQD_PQ_CONTROL__RPTR_BLOCK_SIZE__SHIFT = 0x00000008;
constexpr unsigned int CP_HQD_PQ_CONTROL__RPTR_CARRY__SHIFT     = 0x00000007;
constexpr unsigned int CP_HQD_PQ_CONTROL__UNORD_DISPATCH__SHIFT = 0x0000001c;
constexpr unsigned int CP_HQD_PQ_CONTROL__WPTR_CARRY__SHIFT     = 0x00000006;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_BIF_DROP__SHIFT = 0x00000001;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_EN__SHIFT = 0x0000001e;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_HIT__SHIFT = 0x0000001f;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_MODE__SHIFT = 0x00000000;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_OFFSET__SHIFT = 0x00000002;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_SCHD_HIT__SHIFT = 0x0000001d;
constexpr unsigned int CP_HQD_PQ_DOORBELL_CONTROL__DOORBELL_SOURCE__SHIFT = 0x0000001c;
constexpr unsigned int CP_HQD_PQ_RPTR_REPORT_ADDR_HI__RPTR_REPORT_ADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_HQD_PQ_RPTR_REPORT_ADDR__RPTR_REPORT_ADDR__SHIFT = 0x00000002;
constexpr unsigned int CP_HQD_PQ_RPTR__CONSUMED_OFFSET__SHIFT   = 0x00000000;
constexpr unsigned int CP_HQD_PQ_WPTR_HI__DATA__SHIFT           = 0x00000000;
constexpr unsigned int CP_HQD_PQ_WPTR_LO__OFFSET__SHIFT         = 0x00000000;
constexpr unsigned int CP_HQD_PQ_WPTR_POLL_ADDR_HI__WPTR_ADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_HQD_PQ_WPTR_POLL_ADDR__WPTR_ADDR__SHIFT = 0x00000003;
constexpr unsigned int CP_HQD_QUANTUM__QUANTUM_ACTIVE__SHIFT    = 0x0000001f;
constexpr unsigned int CP_HQD_QUANTUM__QUANTUM_DURATION__SHIFT  = 0x00000008;
constexpr unsigned int CP_HQD_QUANTUM__QUANTUM_EN__SHIFT        = 0x00000000;
constexpr unsigned int CP_HQD_QUANTUM__QUANTUM_SCALE__SHIFT     = 0x00000004;
constexpr unsigned int CP_HQD_QUEUE_PRIORITY__PRIORITY_LEVEL__SHIFT = 0x00000000;
constexpr unsigned int CP_HQD_SEMA_CMD__RESULT__SHIFT           = 0x00000001;
constexpr unsigned int CP_HQD_SEMA_CMD__RETRY__SHIFT            = 0x00000000;
constexpr unsigned int CP_HQD_VMID__IB_VMID__SHIFT              = 0x00000008;
constexpr unsigned int CP_HQD_VMID__VMID__SHIFT                 = 0x00000000;
constexpr unsigned int CP_HQD_VMID__VQID__SHIFT                 = 0x00000010;
constexpr unsigned int CP_HQD_WG_STATE_OFFSET__OFFSET__SHIFT    = 0x00000002;
constexpr unsigned int CP_IB1_BASE_HI__IB1_BASE_HI__SHIFT       = 0x00000000;
constexpr unsigned int CP_IB1_BASE_LO__IB1_BASE_LO__SHIFT       = 0x00000002;
constexpr unsigned int CP_IB1_BUFSZ__IB1_BUFSZ__SHIFT           = 0x00000000;
constexpr unsigned int CP_IB1_CMD_BUFSZ__IB1_CMD_REQSZ__SHIFT   = 0x00000000;
constexpr unsigned int CP_IB1_OFFSET__IB1_OFFSET__SHIFT         = 0x00000000;
constexpr unsigned int CP_IB1_PREAMBLE_BEGIN__IB1_PREAMBLE_BEGIN__SHIFT = 0x00000000;
constexpr unsigned int CP_IB1_PREAMBLE_END__IB1_PREAMBLE_END__SHIFT = 0x00000000;
constexpr unsigned int CP_IB2_BASE_HI__IB2_BASE_HI__SHIFT       = 0x00000000;
constexpr unsigned int CP_IB2_BASE_LO__IB2_BASE_LO__SHIFT       = 0x00000002;
constexpr unsigned int CP_IB2_BUFSZ__IB2_BUFSZ__SHIFT           = 0x00000000;
constexpr unsigned int CP_IB2_CMD_BUFSZ__IB2_CMD_REQSZ__SHIFT   = 0x00000000;
constexpr unsigned int CP_IB2_OFFSET__IB2_OFFSET__SHIFT         = 0x00000000;
constexpr unsigned int CP_IB2_PREAMBLE_BEGIN__IB2_PREAMBLE_BEGIN__SHIFT = 0x00000000;
constexpr unsigned int CP_IB2_PREAMBLE_END__IB2_PREAMBLE_END__SHIFT = 0x00000000;
constexpr unsigned int CP_INDEX_BASE_ADDR_HI__ADDR_HI__SHIFT    = 0x00000000;
constexpr unsigned int CP_INDEX_BASE_ADDR__ADDR_LO__SHIFT       = 0x00000000;
constexpr unsigned int CP_INDEX_TYPE__INDEX_TYPE__SHIFT         = 0x00000000;
constexpr unsigned int CP_INT_CNTL_RING0__CMP_BUSY_INT_ENABLE__SHIFT = 0x00000012;
constexpr unsigned int CP_INT_CNTL_RING0__CNTX_BUSY_INT_ENABLE__SHIFT = 0x00000013;
constexpr unsigned int CP_INT_CNTL_RING0__CNTX_EMPTY_INT_ENABLE__SHIFT = 0x00000014;
constexpr unsigned int CP_INT_CNTL_RING0__CP_ECC_ERROR_INT_ENABLE__SHIFT = 0x0000000e;
constexpr unsigned int CP_INT_CNTL_RING0__CP_VM_DOORBELL_WR_INT_ENABLE__SHIFT = 0x0000000b;
constexpr unsigned int CP_INT_CNTL_RING0__GENERIC0_INT_ENABLE__SHIFT = 0x0000001f;
constexpr unsigned int CP_INT_CNTL_RING0__GENERIC1_INT_ENABLE__SHIFT = 0x0000001e;
constexpr unsigned int CP_INT_CNTL_RING0__GENERIC2_INT_ENABLE__SHIFT = 0x0000001d;
constexpr unsigned int CP_INT_CNTL_RING0__GFX_IDLE_INT_ENABLE__SHIFT = 0x00000015;
constexpr unsigned int CP_INT_CNTL_RING0__GPF_INT_ENABLE__SHIFT = 0x00000010;
constexpr unsigned int CP_INT_CNTL_RING0__OPCODE_ERROR_INT_ENABLE__SHIFT = 0x00000018;
constexpr unsigned int CP_INT_CNTL_RING0__PRIV_INSTR_INT_ENABLE__SHIFT = 0x00000016;
constexpr unsigned int CP_INT_CNTL_RING0__PRIV_REG_INT_ENABLE__SHIFT = 0x00000017;
constexpr unsigned int CP_INT_CNTL_RING0__RESERVED_BIT_ERROR_INT_ENABLE__SHIFT = 0x0000001b;
constexpr unsigned int CP_INT_CNTL_RING0__TIME_STAMP_INT_ENABLE__SHIFT = 0x0000001a;
constexpr unsigned int CP_INT_CNTL_RING0__WRM_POLL_TIMEOUT_INT_ENABLE__SHIFT = 0x00000011;
constexpr unsigned int CP_INT_CNTL_RING1__CMP_BUSY_INT_ENABLE__SHIFT = 0x00000012;
constexpr unsigned int CP_INT_CNTL_RING1__CNTX_BUSY_INT_ENABLE__SHIFT = 0x00000013;
constexpr unsigned int CP_INT_CNTL_RING1__CNTX_EMPTY_INT_ENABLE__SHIFT = 0x00000014;
constexpr unsigned int CP_INT_CNTL_RING1__CP_ECC_ERROR_INT_ENABLE__SHIFT = 0x0000000e;
constexpr unsigned int CP_INT_CNTL_RING1__CP_VM_DOORBELL_WR_INT_ENABLE__SHIFT = 0x0000000b;
constexpr unsigned int CP_INT_CNTL_RING1__GENERIC0_INT_ENABLE__SHIFT = 0x0000001f;
constexpr unsigned int CP_INT_CNTL_RING1__GENERIC1_INT_ENABLE__SHIFT = 0x0000001e;
constexpr unsigned int CP_INT_CNTL_RING1__GENERIC2_INT_ENABLE__SHIFT = 0x0000001d;
constexpr unsigned int CP_INT_CNTL_RING1__GFX_IDLE_INT_ENABLE__SHIFT = 0x00000015;
constexpr unsigned int CP_INT_CNTL_RING1__GPF_INT_ENABLE__SHIFT = 0x00000010;
constexpr unsigned int CP_INT_CNTL_RING1__OPCODE_ERROR_INT_ENABLE__SHIFT = 0x00000018;
constexpr unsigned int CP_INT_CNTL_RING1__PRIV_INSTR_INT_ENABLE__SHIFT = 0x00000016;
constexpr unsigned int CP_INT_CNTL_RING1__PRIV_REG_INT_ENABLE__SHIFT = 0x00000017;
constexpr unsigned int CP_INT_CNTL_RING1__RESERVED_BIT_ERROR_INT_ENABLE__SHIFT = 0x0000001b;
constexpr unsigned int CP_INT_CNTL_RING1__TIME_STAMP_INT_ENABLE__SHIFT = 0x0000001a;
constexpr unsigned int CP_INT_CNTL_RING1__WRM_POLL_TIMEOUT_INT_ENABLE__SHIFT = 0x00000011;
constexpr unsigned int CP_INT_CNTL_RING2__CMP_BUSY_INT_ENABLE__SHIFT = 0x00000012;
constexpr unsigned int CP_INT_CNTL_RING2__CNTX_BUSY_INT_ENABLE__SHIFT = 0x00000013;
constexpr unsigned int CP_INT_CNTL_RING2__CNTX_EMPTY_INT_ENABLE__SHIFT = 0x00000014;
constexpr unsigned int CP_INT_CNTL_RING2__CP_ECC_ERROR_INT_ENABLE__SHIFT = 0x0000000e;
constexpr unsigned int CP_INT_CNTL_RING2__CP_VM_DOORBELL_WR_INT_ENABLE__SHIFT = 0x0000000b;
constexpr unsigned int CP_INT_CNTL_RING2__GENERIC0_INT_ENABLE__SHIFT = 0x0000001f;
constexpr unsigned int CP_INT_CNTL_RING2__GENERIC1_INT_ENABLE__SHIFT = 0x0000001e;
constexpr unsigned int CP_INT_CNTL_RING2__GENERIC2_INT_ENABLE__SHIFT = 0x0000001d;
constexpr unsigned int CP_INT_CNTL_RING2__GFX_IDLE_INT_ENABLE__SHIFT = 0x00000015;
constexpr unsigned int CP_INT_CNTL_RING2__GPF_INT_ENABLE__SHIFT = 0x00000010;
constexpr unsigned int CP_INT_CNTL_RING2__OPCODE_ERROR_INT_ENABLE__SHIFT = 0x00000018;
constexpr unsigned int CP_INT_CNTL_RING2__PRIV_INSTR_INT_ENABLE__SHIFT = 0x00000016;
constexpr unsigned int CP_INT_CNTL_RING2__PRIV_REG_INT_ENABLE__SHIFT = 0x00000017;
constexpr unsigned int CP_INT_CNTL_RING2__RESERVED_BIT_ERROR_INT_ENABLE__SHIFT = 0x0000001b;
constexpr unsigned int CP_INT_CNTL_RING2__TIME_STAMP_INT_ENABLE__SHIFT = 0x0000001a;
constexpr unsigned int CP_INT_CNTL_RING2__WRM_POLL_TIMEOUT_INT_ENABLE__SHIFT = 0x00000011;
constexpr unsigned int CP_INT_CNTL__CMP_BUSY_INT_ENABLE__SHIFT  = 0x00000012;
constexpr unsigned int CP_INT_CNTL__CNTX_BUSY_INT_ENABLE__SHIFT = 0x00000013;
constexpr unsigned int CP_INT_CNTL__CNTX_EMPTY_INT_ENABLE__SHIFT = 0x00000014;
constexpr unsigned int CP_INT_CNTL__CP_ECC_ERROR_INT_ENABLE__SHIFT = 0x0000000e;
constexpr unsigned int CP_INT_CNTL__CP_VM_DOORBELL_WR_INT_ENABLE__SHIFT = 0x0000000b;
constexpr unsigned int CP_INT_CNTL__GENERIC0_INT_ENABLE__SHIFT  = 0x0000001f;
constexpr unsigned int CP_INT_CNTL__GENERIC1_INT_ENABLE__SHIFT  = 0x0000001e;
constexpr unsigned int CP_INT_CNTL__GENERIC2_INT_ENABLE__SHIFT  = 0x0000001d;
constexpr unsigned int CP_INT_CNTL__GFX_IDLE_INT_ENABLE__SHIFT  = 0x00000015;
constexpr unsigned int CP_INT_CNTL__GPF_INT_ENABLE__SHIFT       = 0x00000010;
constexpr unsigned int CP_INT_CNTL__OPCODE_ERROR_INT_ENABLE__SHIFT = 0x00000018;
constexpr unsigned int CP_INT_CNTL__PRIV_INSTR_INT_ENABLE__SHIFT = 0x00000016;
constexpr unsigned int CP_INT_CNTL__PRIV_REG_INT_ENABLE__SHIFT  = 0x00000017;
constexpr unsigned int CP_INT_CNTL__RESERVED_BIT_ERROR_INT_ENABLE__SHIFT = 0x0000001b;
constexpr unsigned int CP_INT_CNTL__TIME_STAMP_INT_ENABLE__SHIFT = 0x0000001a;
constexpr unsigned int CP_INT_CNTL__WRM_POLL_TIMEOUT_INT_ENABLE__SHIFT = 0x00000011;
constexpr unsigned int CP_INT_STATUS_RING0__CMP_BUSY_INT_STAT__SHIFT = 0x00000012;
constexpr unsigned int CP_INT_STATUS_RING0__CNTX_EMPTY_INT_STAT__SHIFT = 0x00000014;
constexpr unsigned int CP_INT_STATUS_RING0__CP_ECC_ERROR_INT_STAT__SHIFT = 0x0000000e;
constexpr unsigned int CP_INT_STATUS_RING0__CP_VM_DOORBELL_WR_INT_STAT__SHIFT = 0x0000000b;
constexpr unsigned int CP_INT_STATUS_RING0__GCNTX_BUSY_INT_STAT__SHIFT = 0x00000013;
constexpr unsigned int CP_INT_STATUS_RING0__GENERIC0_INT_STAT__SHIFT = 0x0000001f;
constexpr unsigned int CP_INT_STATUS_RING0__GENERIC1_INT_STAT__SHIFT = 0x0000001e;
constexpr unsigned int CP_INT_STATUS_RING0__GENERIC2_INT_STAT__SHIFT = 0x0000001d;
constexpr unsigned int CP_INT_STATUS_RING0__GFX_IDLE_INT_STAT__SHIFT = 0x00000015;
constexpr unsigned int CP_INT_STATUS_RING0__GPF_INT_STAT__SHIFT = 0x00000010;
constexpr unsigned int CP_INT_STATUS_RING0__OPCODE_ERROR_INT_STAT__SHIFT = 0x00000018;
constexpr unsigned int CP_INT_STATUS_RING0__PRIV_INSTR_INT_STAT__SHIFT = 0x00000016;
constexpr unsigned int CP_INT_STATUS_RING0__PRIV_REG_INT_STAT__SHIFT = 0x00000017;
constexpr unsigned int CP_INT_STATUS_RING0__RESERVED_BIT_ERROR_INT_STAT__SHIFT = 0x0000001b;
constexpr unsigned int CP_INT_STATUS_RING0__TIME_STAMP_INT_STAT__SHIFT = 0x0000001a;
constexpr unsigned int CP_INT_STATUS_RING0__WRM_POLL_TIMEOUT_INT_STAT__SHIFT = 0x00000011;
constexpr unsigned int CP_INT_STATUS_RING1__CMP_BUSY_INT_STAT__SHIFT = 0x00000012;
constexpr unsigned int CP_INT_STATUS_RING1__CNTX_BUSY_INT_STAT__SHIFT = 0x00000013;
constexpr unsigned int CP_INT_STATUS_RING1__CNTX_EMPTY_INT_STAT__SHIFT = 0x00000014;
constexpr unsigned int CP_INT_STATUS_RING1__CP_ECC_ERROR_INT_STAT__SHIFT = 0x0000000e;
constexpr unsigned int CP_INT_STATUS_RING1__CP_VM_DOORBELL_WR_INT_STAT__SHIFT = 0x0000000b;
constexpr unsigned int CP_INT_STATUS_RING1__GENERIC0_INT_STAT__SHIFT = 0x0000001f;
constexpr unsigned int CP_INT_STATUS_RING1__GENERIC1_INT_STAT__SHIFT = 0x0000001e;
constexpr unsigned int CP_INT_STATUS_RING1__GENERIC2_INT_STAT__SHIFT = 0x0000001d;
constexpr unsigned int CP_INT_STATUS_RING1__GFX_IDLE_INT_STAT__SHIFT = 0x00000015;
constexpr unsigned int CP_INT_STATUS_RING1__GPF_INT_STAT__SHIFT = 0x00000010;
constexpr unsigned int CP_INT_STATUS_RING1__OPCODE_ERROR_INT_STAT__SHIFT = 0x00000018;
constexpr unsigned int CP_INT_STATUS_RING1__PRIV_INSTR_INT_STAT__SHIFT = 0x00000016;
constexpr unsigned int CP_INT_STATUS_RING1__PRIV_REG_INT_STAT__SHIFT = 0x00000017;
constexpr unsigned int CP_INT_STATUS_RING1__RESERVED_BIT_ERROR_INT_STAT__SHIFT = 0x0000001b;
constexpr unsigned int CP_INT_STATUS_RING1__TIME_STAMP_INT_STAT__SHIFT = 0x0000001a;
constexpr unsigned int CP_INT_STATUS_RING1__WRM_POLL_TIMEOUT_INT_STAT__SHIFT = 0x00000011;
constexpr unsigned int CP_INT_STATUS_RING2__CMP_BUSY_INT_STAT__SHIFT = 0x00000012;
constexpr unsigned int CP_INT_STATUS_RING2__CNTX_BUSY_INT_STAT__SHIFT = 0x00000013;
constexpr unsigned int CP_INT_STATUS_RING2__CNTX_EMPTY_INT_STAT__SHIFT = 0x00000014;
constexpr unsigned int CP_INT_STATUS_RING2__CP_ECC_ERROR_INT_STAT__SHIFT = 0x0000000e;
constexpr unsigned int CP_INT_STATUS_RING2__CP_VM_DOORBELL_WR_INT_STAT__SHIFT = 0x0000000b;
constexpr unsigned int CP_INT_STATUS_RING2__GENERIC0_INT_STAT__SHIFT = 0x0000001f;
constexpr unsigned int CP_INT_STATUS_RING2__GENERIC1_INT_STAT__SHIFT = 0x0000001e;
constexpr unsigned int CP_INT_STATUS_RING2__GENERIC2_INT_STAT__SHIFT = 0x0000001d;
constexpr unsigned int CP_INT_STATUS_RING2__GFX_IDLE_INT_STAT__SHIFT = 0x00000015;
constexpr unsigned int CP_INT_STATUS_RING2__GPF_INT_STAT__SHIFT = 0x00000010;
constexpr unsigned int CP_INT_STATUS_RING2__OPCODE_ERROR_INT_STAT__SHIFT = 0x00000018;
constexpr unsigned int CP_INT_STATUS_RING2__PRIV_INSTR_INT_STAT__SHIFT = 0x00000016;
constexpr unsigned int CP_INT_STATUS_RING2__PRIV_REG_INT_STAT__SHIFT = 0x00000017;
constexpr unsigned int CP_INT_STATUS_RING2__RESERVED_BIT_ERROR_INT_STAT__SHIFT = 0x0000001b;
constexpr unsigned int CP_INT_STATUS_RING2__TIME_STAMP_INT_STAT__SHIFT = 0x0000001a;
constexpr unsigned int CP_INT_STATUS_RING2__WRM_POLL_TIMEOUT_INT_STAT__SHIFT = 0x00000011;
constexpr unsigned int CP_INT_STATUS__CMP_BUSY_INT_STAT__SHIFT  = 0x00000012;
constexpr unsigned int CP_INT_STATUS__CNTX_BUSY_INT_STAT__SHIFT = 0x00000013;
constexpr unsigned int CP_INT_STATUS__CNTX_EMPTY_INT_STAT__SHIFT = 0x00000014;
constexpr unsigned int CP_INT_STATUS__CP_ECC_ERROR_INT_STAT__SHIFT = 0x0000000e;
constexpr unsigned int CP_INT_STATUS__CP_VM_DOORBELL_WR_INT_STAT__SHIFT = 0x0000000b;
constexpr unsigned int CP_INT_STATUS__GENERIC0_INT_STAT__SHIFT  = 0x0000001f;
constexpr unsigned int CP_INT_STATUS__GENERIC1_INT_STAT__SHIFT  = 0x0000001e;
constexpr unsigned int CP_INT_STATUS__GENERIC2_INT_STAT__SHIFT  = 0x0000001d;
constexpr unsigned int CP_INT_STATUS__GFX_IDLE_INT_STAT__SHIFT  = 0x00000015;
constexpr unsigned int CP_INT_STATUS__GPF_INT_STAT__SHIFT       = 0x00000010;
constexpr unsigned int CP_INT_STATUS__OPCODE_ERROR_INT_STAT__SHIFT = 0x00000018;
constexpr unsigned int CP_INT_STATUS__PRIV_INSTR_INT_STAT__SHIFT = 0x00000016;
constexpr unsigned int CP_INT_STATUS__PRIV_REG_INT_STAT__SHIFT  = 0x00000017;
constexpr unsigned int CP_INT_STATUS__RESERVED_BIT_ERROR_INT_STAT__SHIFT = 0x0000001b;
constexpr unsigned int CP_INT_STATUS__TIME_STAMP_INT_STAT__SHIFT = 0x0000001a;
constexpr unsigned int CP_INT_STATUS__WRM_POLL_TIMEOUT_INT_STAT__SHIFT = 0x00000011;
constexpr unsigned int CP_INT_STAT_DEBUG__CMP_BUSY_INT_ASSERTED__SHIFT = 0x00000012;
constexpr unsigned int CP_INT_STAT_DEBUG__CNTX_BUSY_INT_ASSERTED__SHIFT = 0x00000013;
constexpr unsigned int CP_INT_STAT_DEBUG__CNTX_EMPTY_INT_ASSERTED__SHIFT = 0x00000014;
constexpr unsigned int CP_INT_STAT_DEBUG__CP_ECC_ERROR_INT_ASSERTED__SHIFT = 0x0000000e;
constexpr unsigned int CP_INT_STAT_DEBUG__CP_VM_DOORBELL_WR_INT_ASSERTED__SHIFT = 0x0000000b;
constexpr unsigned int CP_INT_STAT_DEBUG__GENERIC0_INT_ASSERTED__SHIFT = 0x0000001f;
constexpr unsigned int CP_INT_STAT_DEBUG__GENERIC1_INT_ASSERTED__SHIFT = 0x0000001e;
constexpr unsigned int CP_INT_STAT_DEBUG__GENERIC2_INT_ASSERTED__SHIFT = 0x0000001d;
constexpr unsigned int CP_INT_STAT_DEBUG__GFX_IDLE_INT_ASSERTED__SHIFT = 0x00000015;
constexpr unsigned int CP_INT_STAT_DEBUG__GPF_INT_ASSERTED__SHIFT = 0x00000010;
constexpr unsigned int CP_INT_STAT_DEBUG__OPCODE_ERROR_INT_ASSERTED__SHIFT = 0x00000018;
constexpr unsigned int CP_INT_STAT_DEBUG__PRIV_INSTR_INT_ASSERTED__SHIFT = 0x00000016;
constexpr unsigned int CP_INT_STAT_DEBUG__PRIV_REG_INT_ASSERTED__SHIFT = 0x00000017;
constexpr unsigned int CP_INT_STAT_DEBUG__RESERVED_BIT_ERROR_INT_ASSERTED__SHIFT = 0x0000001b;
constexpr unsigned int CP_INT_STAT_DEBUG__TIME_STAMP_INT_ASSERTED__SHIFT = 0x0000001a;
constexpr unsigned int CP_INT_STAT_DEBUG__WRM_POLL_TIMEOUT_INT_ASSERTED__SHIFT = 0x00000011;
constexpr unsigned int CP_IQ_WAIT_TIME1__ATOMIC_OFFLOAD__SHIFT  = 0x00000008;
constexpr unsigned int CP_IQ_WAIT_TIME1__GWS__SHIFT             = 0x00000018;
constexpr unsigned int CP_IQ_WAIT_TIME1__IB_OFFLOAD__SHIFT      = 0x00000000;
constexpr unsigned int CP_IQ_WAIT_TIME1__WRM_OFFLOAD__SHIFT     = 0x00000010;
constexpr unsigned int CP_IQ_WAIT_TIME2__DEQ_RETRY__SHIFT       = 0x00000018;
constexpr unsigned int CP_IQ_WAIT_TIME2__QUE_SLEEP__SHIFT       = 0x00000000;
constexpr unsigned int CP_IQ_WAIT_TIME2__SCH_WAVE__SHIFT        = 0x00000008;
constexpr unsigned int CP_IQ_WAIT_TIME2__SEM_REARM__SHIFT       = 0x00000010;
constexpr unsigned int CP_MAX_CONTEXT__MAX_CONTEXT__SHIFT       = 0x00000000;
constexpr unsigned int CP_ME0_PIPE0_PRIORITY__PRIORITY__SHIFT   = 0x00000000;
constexpr unsigned int CP_ME0_PIPE0_VMID__VMID__SHIFT           = 0x00000000;
constexpr unsigned int CP_ME0_PIPE1_PRIORITY__PRIORITY__SHIFT   = 0x00000000;
constexpr unsigned int CP_ME0_PIPE1_VMID__VMID__SHIFT           = 0x00000000;
constexpr unsigned int CP_ME0_PIPE2_PRIORITY__PRIORITY__SHIFT   = 0x00000000;
constexpr unsigned int CP_ME0_PIPE_PRIORITY_CNTS__PRIORITY1_CNT__SHIFT = 0x00000000;
constexpr unsigned int CP_ME0_PIPE_PRIORITY_CNTS__PRIORITY2A_CNT__SHIFT = 0x00000008;
constexpr unsigned int CP_ME0_PIPE_PRIORITY_CNTS__PRIORITY2B_CNT__SHIFT = 0x00000010;
constexpr unsigned int CP_ME0_PIPE_PRIORITY_CNTS__PRIORITY3_CNT__SHIFT = 0x00000018;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__CMP_QUERY_STATUS_INT_ASSERTED__SHIFT = 0x0000000c;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__CP_ECC_ERROR_INT_ASSERTED__SHIFT = 0x0000000e;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__DEQUEUE_REQUEST_INT_ASSERTED__SHIFT = 0x0000000d;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__GENERIC0_INT_ASSERTED__SHIFT = 0x0000001f;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__GENERIC1_INT_ASSERTED__SHIFT = 0x0000001e;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__GENERIC2_INT_ASSERTED__SHIFT = 0x0000001d;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__GPF_INT_ASSERTED__SHIFT = 0x00000010;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__OPCODE_ERROR_INT_ASSERTED__SHIFT = 0x00000018;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__PRIV_REG_INT_ASSERTED__SHIFT = 0x00000017;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__RESERVED_BIT_ERROR_INT_ASSERTED__SHIFT = 0x0000001b;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__SUA_VIOLATION_INT_STATUS__SHIFT = 0x0000000f;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__TIME_STAMP_INT_ASSERTED__SHIFT = 0x0000001a;
constexpr unsigned int CP_ME1_INT_STAT_DEBUG__WRM_POLL_TIMEOUT_INT_ASSERTED__SHIFT = 0x00000011;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__CMP_QUERY_STATUS_INT_ENABLE__SHIFT = 0x0000000c;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__CP_ECC_ERROR_INT_ENABLE__SHIFT = 0x0000000e;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__DEQUEUE_REQUEST_INT_ENABLE__SHIFT = 0x0000000d;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__GENERIC0_INT_ENABLE__SHIFT = 0x0000001f;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__GENERIC1_INT_ENABLE__SHIFT = 0x0000001e;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__GENERIC2_INT_ENABLE__SHIFT = 0x0000001d;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__GPF_INT_ENABLE__SHIFT = 0x00000010;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__OPCODE_ERROR_INT_ENABLE__SHIFT = 0x00000018;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__PRIV_REG_INT_ENABLE__SHIFT = 0x00000017;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__RESERVED_BIT_ERROR_INT_ENABLE__SHIFT = 0x0000001b;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__SUA_VIOLATION_INT_ENABLE__SHIFT = 0x0000000f;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__TIME_STAMP_INT_ENABLE__SHIFT = 0x0000001a;
constexpr unsigned int CP_ME1_PIPE0_INT_CNTL__WRM_POLL_TIMEOUT_INT_ENABLE__SHIFT = 0x00000011;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__CMP_QUERY_STATUS_INT_STATUS__SHIFT = 0x0000000c;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__CP_ECC_ERROR_INT_STATUS__SHIFT = 0x0000000e;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__DEQUEUE_REQUEST_INT_STATUS__SHIFT = 0x0000000d;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__GENERIC0_INT_STATUS__SHIFT = 0x0000001f;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__GENERIC1_INT_STATUS__SHIFT = 0x0000001e;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__GENERIC2_INT_STATUS__SHIFT = 0x0000001d;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__GPF_INT_STATUS__SHIFT = 0x00000010;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__OPCODE_ERROR_INT_STATUS__SHIFT = 0x00000018;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__PRIV_REG_INT_STATUS__SHIFT = 0x00000017;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__RESERVED_BIT_ERROR_INT_STATUS__SHIFT = 0x0000001b;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__SUA_VIOLATION_INT_STATUS__SHIFT = 0x0000000f;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__TIME_STAMP_INT_STATUS__SHIFT = 0x0000001a;
constexpr unsigned int CP_ME1_PIPE0_INT_STATUS__WRM_POLL_TIMEOUT_INT_STATUS__SHIFT = 0x00000011;
constexpr unsigned int CP_ME1_PIPE0_PRIORITY__PRIORITY__SHIFT   = 0x00000000;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__CMP_QUERY_STATUS_INT_ENABLE__SHIFT = 0x0000000c;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__CP_ECC_ERROR_INT_ENABLE__SHIFT = 0x0000000e;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__DEQUEUE_REQUEST_INT_ENABLE__SHIFT = 0x0000000d;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__GENERIC0_INT_ENABLE__SHIFT = 0x0000001f;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__GENERIC1_INT_ENABLE__SHIFT = 0x0000001e;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__GENERIC2_INT_ENABLE__SHIFT = 0x0000001d;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__GPF_INT_ENABLE__SHIFT = 0x00000010;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__OPCODE_ERROR_INT_ENABLE__SHIFT = 0x00000018;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__PRIV_REG_INT_ENABLE__SHIFT = 0x00000017;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__RESERVED_BIT_ERROR_INT_ENABLE__SHIFT = 0x0000001b;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__SUA_VIOLATION_INT_ENABLE__SHIFT = 0x0000000f;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__TIME_STAMP_INT_ENABLE__SHIFT = 0x0000001a;
constexpr unsigned int CP_ME1_PIPE1_INT_CNTL__WRM_POLL_TIMEOUT_INT_ENABLE__SHIFT = 0x00000011;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__CMP_QUERY_STATUS_INT_STATUS__SHIFT = 0x0000000c;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__CP_ECC_ERROR_INT_STATUS__SHIFT = 0x0000000e;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__DEQUEUE_REQUEST_INT_STATUS__SHIFT = 0x0000000d;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__GENERIC0_INT_STATUS__SHIFT = 0x0000001f;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__GENERIC1_INT_STATUS__SHIFT = 0x0000001e;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__GENERIC2_INT_STATUS__SHIFT = 0x0000001d;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__GPF_INT_STATUS__SHIFT = 0x00000010;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__OPCODE_ERROR_INT_STATUS__SHIFT = 0x00000018;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__PRIV_REG_INT_STATUS__SHIFT = 0x00000017;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__RESERVED_BIT_ERROR_INT_STATUS__SHIFT = 0x0000001b;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__SUA_VIOLATION_INT_STATUS__SHIFT = 0x0000000f;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__TIME_STAMP_INT_STATUS__SHIFT = 0x0000001a;
constexpr unsigned int CP_ME1_PIPE1_INT_STATUS__WRM_POLL_TIMEOUT_INT_STATUS__SHIFT = 0x00000011;
constexpr unsigned int CP_ME1_PIPE1_PRIORITY__PRIORITY__SHIFT   = 0x00000000;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__CMP_QUERY_STATUS_INT_ENABLE__SHIFT = 0x0000000c;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__CP_ECC_ERROR_INT_ENABLE__SHIFT = 0x0000000e;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__DEQUEUE_REQUEST_INT_ENABLE__SHIFT = 0x0000000d;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__GENERIC0_INT_ENABLE__SHIFT = 0x0000001f;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__GENERIC1_INT_ENABLE__SHIFT = 0x0000001e;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__GENERIC2_INT_ENABLE__SHIFT = 0x0000001d;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__GPF_INT_ENABLE__SHIFT = 0x00000010;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__OPCODE_ERROR_INT_ENABLE__SHIFT = 0x00000018;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__PRIV_REG_INT_ENABLE__SHIFT = 0x00000017;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__RESERVED_BIT_ERROR_INT_ENABLE__SHIFT = 0x0000001b;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__SUA_VIOLATION_INT_ENABLE__SHIFT = 0x0000000f;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__TIME_STAMP_INT_ENABLE__SHIFT = 0x0000001a;
constexpr unsigned int CP_ME1_PIPE2_INT_CNTL__WRM_POLL_TIMEOUT_INT_ENABLE__SHIFT = 0x00000011;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__CMP_QUERY_STATUS_INT_STATUS__SHIFT = 0x0000000c;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__CP_ECC_ERROR_INT_STATUS__SHIFT = 0x0000000e;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__DEQUEUE_REQUEST_INT_STATUS__SHIFT = 0x0000000d;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__GENERIC0_INT_STATUS__SHIFT = 0x0000001f;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__GENERIC1_INT_STATUS__SHIFT = 0x0000001e;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__GENERIC2_INT_STATUS__SHIFT = 0x0000001d;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__GPF_INT_STATUS__SHIFT = 0x00000010;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__OPCODE_ERROR_INT_STATUS__SHIFT = 0x00000018;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__PRIV_REG_INT_STATUS__SHIFT = 0x00000017;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__RESERVED_BIT_ERROR_INT_STATUS__SHIFT = 0x0000001b;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__SUA_VIOLATION_INT_STATUS__SHIFT = 0x0000000f;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__TIME_STAMP_INT_STATUS__SHIFT = 0x0000001a;
constexpr unsigned int CP_ME1_PIPE2_INT_STATUS__WRM_POLL_TIMEOUT_INT_STATUS__SHIFT = 0x00000011;
constexpr unsigned int CP_ME1_PIPE2_PRIORITY__PRIORITY__SHIFT   = 0x00000000;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__CMP_QUERY_STATUS_INT_ENABLE__SHIFT = 0x0000000c;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__CP_ECC_ERROR_INT_ENABLE__SHIFT = 0x0000000e;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__DEQUEUE_REQUEST_INT_ENABLE__SHIFT = 0x0000000d;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__GENERIC0_INT_ENABLE__SHIFT = 0x0000001f;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__GENERIC1_INT_ENABLE__SHIFT = 0x0000001e;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__GENERIC2_INT_ENABLE__SHIFT = 0x0000001d;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__GPF_INT_ENABLE__SHIFT = 0x00000010;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__OPCODE_ERROR_INT_ENABLE__SHIFT = 0x00000018;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__PRIV_REG_INT_ENABLE__SHIFT = 0x00000017;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__RESERVED_BIT_ERROR_INT_ENABLE__SHIFT = 0x0000001b;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__SUA_VIOLATION_INT_ENABLE__SHIFT = 0x0000000f;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__TIME_STAMP_INT_ENABLE__SHIFT = 0x0000001a;
constexpr unsigned int CP_ME1_PIPE3_INT_CNTL__WRM_POLL_TIMEOUT_INT_ENABLE__SHIFT = 0x00000011;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__CMP_QUERY_STATUS_INT_STATUS__SHIFT = 0x0000000c;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__CP_ECC_ERROR_INT_STATUS__SHIFT = 0x0000000e;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__DEQUEUE_REQUEST_INT_STATUS__SHIFT = 0x0000000d;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__GENERIC0_INT_STATUS__SHIFT = 0x0000001f;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__GENERIC1_INT_STATUS__SHIFT = 0x0000001e;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__GENERIC2_INT_STATUS__SHIFT = 0x0000001d;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__GPF_INT_STATUS__SHIFT = 0x00000010;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__OPCODE_ERROR_INT_STATUS__SHIFT = 0x00000018;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__PRIV_REG_INT_STATUS__SHIFT = 0x00000017;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__RESERVED_BIT_ERROR_INT_STATUS__SHIFT = 0x0000001b;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__SUA_VIOLATION_INT_STATUS__SHIFT = 0x0000000f;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__TIME_STAMP_INT_STATUS__SHIFT = 0x0000001a;
constexpr unsigned int CP_ME1_PIPE3_INT_STATUS__WRM_POLL_TIMEOUT_INT_STATUS__SHIFT = 0x00000011;
constexpr unsigned int CP_ME1_PIPE3_PRIORITY__PRIORITY__SHIFT   = 0x00000000;
constexpr unsigned int CP_ME1_PIPE_PRIORITY_CNTS__PRIORITY1_CNT__SHIFT = 0x00000000;
constexpr unsigned int CP_ME1_PIPE_PRIORITY_CNTS__PRIORITY2A_CNT__SHIFT = 0x00000008;
constexpr unsigned int CP_ME1_PIPE_PRIORITY_CNTS__PRIORITY2B_CNT__SHIFT = 0x00000010;
constexpr unsigned int CP_ME1_PIPE_PRIORITY_CNTS__PRIORITY3_CNT__SHIFT = 0x00000018;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__CMP_QUERY_STATUS_INT_ASSERTED__SHIFT = 0x0000000c;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__CP_ECC_ERROR_INT_ASSERTED__SHIFT = 0x0000000e;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__DEQUEUE_REQUEST_INT_ASSERTED__SHIFT = 0x0000000d;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__GENERIC0_INT_ASSERTED__SHIFT = 0x0000001f;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__GENERIC1_INT_ASSERTED__SHIFT = 0x0000001e;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__GENERIC2_INT_ASSERTED__SHIFT = 0x0000001d;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__GPF_INT_ASSERTED__SHIFT = 0x00000010;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__OPCODE_ERROR_INT_ASSERTED__SHIFT = 0x00000018;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__PRIV_REG_INT_ASSERTED__SHIFT = 0x00000017;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__RESERVED_BIT_ERROR_INT_ASSERTED__SHIFT = 0x0000001b;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__SUA_VIOLATION_INT_STATUS__SHIFT = 0x0000000f;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__TIME_STAMP_INT_ASSERTED__SHIFT = 0x0000001a;
constexpr unsigned int CP_ME2_INT_STAT_DEBUG__WRM_POLL_TIMEOUT_INT_ASSERTED__SHIFT = 0x00000011;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__CMP_QUERY_STATUS_INT_ENABLE__SHIFT = 0x0000000c;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__CP_ECC_ERROR_INT_ENABLE__SHIFT = 0x0000000e;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__DEQUEUE_REQUEST_INT_ENABLE__SHIFT = 0x0000000d;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__GENERIC0_INT_ENABLE__SHIFT = 0x0000001f;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__GENERIC1_INT_ENABLE__SHIFT = 0x0000001e;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__GENERIC2_INT_ENABLE__SHIFT = 0x0000001d;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__GPF_INT_ENABLE__SHIFT = 0x00000010;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__OPCODE_ERROR_INT_ENABLE__SHIFT = 0x00000018;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__PRIV_REG_INT_ENABLE__SHIFT = 0x00000017;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__RESERVED_BIT_ERROR_INT_ENABLE__SHIFT = 0x0000001b;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__SUA_VIOLATION_INT_ENABLE__SHIFT = 0x0000000f;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__TIME_STAMP_INT_ENABLE__SHIFT = 0x0000001a;
constexpr unsigned int CP_ME2_PIPE0_INT_CNTL__WRM_POLL_TIMEOUT_INT_ENABLE__SHIFT = 0x00000011;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__CMP_QUERY_STATUS_INT_STATUS__SHIFT = 0x0000000c;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__CP_ECC_ERROR_INT_STATUS__SHIFT = 0x0000000e;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__DEQUEUE_REQUEST_INT_STATUS__SHIFT = 0x0000000d;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__GENERIC0_INT_STATUS__SHIFT = 0x0000001f;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__GENERIC1_INT_STATUS__SHIFT = 0x0000001e;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__GENERIC2_INT_STATUS__SHIFT = 0x0000001d;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__GPF_INT_STATUS__SHIFT = 0x00000010;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__OPCODE_ERROR_INT_STATUS__SHIFT = 0x00000018;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__PRIV_REG_INT_STATUS__SHIFT = 0x00000017;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__RESERVED_BIT_ERROR_INT_STATUS__SHIFT = 0x0000001b;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__SUA_VIOLATION_INT_STATUS__SHIFT = 0x0000000f;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__TIME_STAMP_INT_STATUS__SHIFT = 0x0000001a;
constexpr unsigned int CP_ME2_PIPE0_INT_STATUS__WRM_POLL_TIMEOUT_INT_STATUS__SHIFT = 0x00000011;
constexpr unsigned int CP_ME2_PIPE0_PRIORITY__PRIORITY__SHIFT   = 0x00000000;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__CMP_QUERY_STATUS_INT_ENABLE__SHIFT = 0x0000000c;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__CP_ECC_ERROR_INT_ENABLE__SHIFT = 0x0000000e;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__DEQUEUE_REQUEST_INT_ENABLE__SHIFT = 0x0000000d;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__GENERIC0_INT_ENABLE__SHIFT = 0x0000001f;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__GENERIC1_INT_ENABLE__SHIFT = 0x0000001e;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__GENERIC2_INT_ENABLE__SHIFT = 0x0000001d;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__GPF_INT_ENABLE__SHIFT = 0x00000010;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__OPCODE_ERROR_INT_ENABLE__SHIFT = 0x00000018;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__PRIV_REG_INT_ENABLE__SHIFT = 0x00000017;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__RESERVED_BIT_ERROR_INT_ENABLE__SHIFT = 0x0000001b;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__SUA_VIOLATION_INT_ENABLE__SHIFT = 0x0000000f;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__TIME_STAMP_INT_ENABLE__SHIFT = 0x0000001a;
constexpr unsigned int CP_ME2_PIPE1_INT_CNTL__WRM_POLL_TIMEOUT_INT_ENABLE__SHIFT = 0x00000011;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__CMP_QUERY_STATUS_INT_STATUS__SHIFT = 0x0000000c;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__CP_ECC_ERROR_INT_STATUS__SHIFT = 0x0000000e;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__DEQUEUE_REQUEST_INT_STATUS__SHIFT = 0x0000000d;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__GENERIC0_INT_STATUS__SHIFT = 0x0000001f;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__GENERIC1_INT_STATUS__SHIFT = 0x0000001e;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__GENERIC2_INT_STATUS__SHIFT = 0x0000001d;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__GPF_INT_STATUS__SHIFT = 0x00000010;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__OPCODE_ERROR_INT_STATUS__SHIFT = 0x00000018;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__PRIV_REG_INT_STATUS__SHIFT = 0x00000017;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__RESERVED_BIT_ERROR_INT_STATUS__SHIFT = 0x0000001b;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__SUA_VIOLATION_INT_STATUS__SHIFT = 0x0000000f;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__TIME_STAMP_INT_STATUS__SHIFT = 0x0000001a;
constexpr unsigned int CP_ME2_PIPE1_INT_STATUS__WRM_POLL_TIMEOUT_INT_STATUS__SHIFT = 0x00000011;
constexpr unsigned int CP_ME2_PIPE1_PRIORITY__PRIORITY__SHIFT   = 0x00000000;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__CMP_QUERY_STATUS_INT_ENABLE__SHIFT = 0x0000000c;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__CP_ECC_ERROR_INT_ENABLE__SHIFT = 0x0000000e;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__DEQUEUE_REQUEST_INT_ENABLE__SHIFT = 0x0000000d;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__GENERIC0_INT_ENABLE__SHIFT = 0x0000001f;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__GENERIC1_INT_ENABLE__SHIFT = 0x0000001e;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__GENERIC2_INT_ENABLE__SHIFT = 0x0000001d;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__GPF_INT_ENABLE__SHIFT = 0x00000010;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__OPCODE_ERROR_INT_ENABLE__SHIFT = 0x00000018;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__PRIV_REG_INT_ENABLE__SHIFT = 0x00000017;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__RESERVED_BIT_ERROR_INT_ENABLE__SHIFT = 0x0000001b;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__SUA_VIOLATION_INT_ENABLE__SHIFT = 0x0000000f;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__TIME_STAMP_INT_ENABLE__SHIFT = 0x0000001a;
constexpr unsigned int CP_ME2_PIPE2_INT_CNTL__WRM_POLL_TIMEOUT_INT_ENABLE__SHIFT = 0x00000011;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__CMP_QUERY_STATUS_INT_STATUS__SHIFT = 0x0000000c;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__CP_ECC_ERROR_INT_STATUS__SHIFT = 0x0000000e;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__DEQUEUE_REQUEST_INT_STATUS__SHIFT = 0x0000000d;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__GENERIC0_INT_STATUS__SHIFT = 0x0000001f;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__GENERIC1_INT_STATUS__SHIFT = 0x0000001e;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__GENERIC2_INT_STATUS__SHIFT = 0x0000001d;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__GPF_INT_STATUS__SHIFT = 0x00000010;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__OPCODE_ERROR_INT_STATUS__SHIFT = 0x00000018;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__PRIV_REG_INT_STATUS__SHIFT = 0x00000017;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__RESERVED_BIT_ERROR_INT_STATUS__SHIFT = 0x0000001b;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__SUA_VIOLATION_INT_STATUS__SHIFT = 0x0000000f;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__TIME_STAMP_INT_STATUS__SHIFT = 0x0000001a;
constexpr unsigned int CP_ME2_PIPE2_INT_STATUS__WRM_POLL_TIMEOUT_INT_STATUS__SHIFT = 0x00000011;
constexpr unsigned int CP_ME2_PIPE2_PRIORITY__PRIORITY__SHIFT   = 0x00000000;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__CMP_QUERY_STATUS_INT_ENABLE__SHIFT = 0x0000000c;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__CP_ECC_ERROR_INT_ENABLE__SHIFT = 0x0000000e;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__DEQUEUE_REQUEST_INT_ENABLE__SHIFT = 0x0000000d;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__GENERIC0_INT_ENABLE__SHIFT = 0x0000001f;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__GENERIC1_INT_ENABLE__SHIFT = 0x0000001e;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__GENERIC2_INT_ENABLE__SHIFT = 0x0000001d;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__GPF_INT_ENABLE__SHIFT = 0x00000010;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__OPCODE_ERROR_INT_ENABLE__SHIFT = 0x00000018;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__PRIV_REG_INT_ENABLE__SHIFT = 0x00000017;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__RESERVED_BIT_ERROR_INT_ENABLE__SHIFT = 0x0000001b;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__SUA_VIOLATION_INT_ENABLE__SHIFT = 0x0000000f;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__TIME_STAMP_INT_ENABLE__SHIFT = 0x0000001a;
constexpr unsigned int CP_ME2_PIPE3_INT_CNTL__WRM_POLL_TIMEOUT_INT_ENABLE__SHIFT = 0x00000011;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__CMP_QUERY_STATUS_INT_STATUS__SHIFT = 0x0000000c;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__CP_ECC_ERROR_INT_STATUS__SHIFT = 0x0000000e;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__DEQUEUE_REQUEST_INT_STATUS__SHIFT = 0x0000000d;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__GENERIC0_INT_STATUS__SHIFT = 0x0000001f;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__GENERIC1_INT_STATUS__SHIFT = 0x0000001e;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__GENERIC2_INT_STATUS__SHIFT = 0x0000001d;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__GPF_INT_STATUS__SHIFT = 0x00000010;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__OPCODE_ERROR_INT_STATUS__SHIFT = 0x00000018;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__PRIV_REG_INT_STATUS__SHIFT = 0x00000017;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__RESERVED_BIT_ERROR_INT_STATUS__SHIFT = 0x0000001b;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__SUA_VIOLATION_INT_STATUS__SHIFT = 0x0000000f;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__TIME_STAMP_INT_STATUS__SHIFT = 0x0000001a;
constexpr unsigned int CP_ME2_PIPE3_INT_STATUS__WRM_POLL_TIMEOUT_INT_STATUS__SHIFT = 0x00000011;
constexpr unsigned int CP_ME2_PIPE3_PRIORITY__PRIORITY__SHIFT   = 0x00000000;
constexpr unsigned int CP_ME2_PIPE_PRIORITY_CNTS__PRIORITY1_CNT__SHIFT = 0x00000000;
constexpr unsigned int CP_ME2_PIPE_PRIORITY_CNTS__PRIORITY2A_CNT__SHIFT = 0x00000008;
constexpr unsigned int CP_ME2_PIPE_PRIORITY_CNTS__PRIORITY2B_CNT__SHIFT = 0x00000010;
constexpr unsigned int CP_ME2_PIPE_PRIORITY_CNTS__PRIORITY3_CNT__SHIFT = 0x00000018;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__EDC_DMA_FED_INT__SHIFT = 0x00000008;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__EDC_GDS_FED_INT__SHIFT = 0x00000004;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__EDC_ROQ_FED_INT__SHIFT = 0x00000000;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__EDC_SCRATCH_FED_INT__SHIFT = 0x00000005;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__EDC_SR_MEM_FED_INT__SHIFT = 0x0000000d;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__EDC_TC_FED_INT__SHIFT = 0x00000003;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__FATAL_EDC_ERROR_INT__SHIFT = 0x0000000f;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__GPF_INT_CPC__SHIFT = 0x0000000c;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__GPF_INT_CPF__SHIFT = 0x0000000a;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__GPF_INT_DMA__SHIFT = 0x0000000b;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__IQ_TIMER_INT__SHIFT = 0x00000009;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__PRIV_REG_INT__SHIFT = 0x00000001;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__QUEUE_MESSAGE_INT__SHIFT = 0x0000000e;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__RESERVED_BIT_ERR_INT__SHIFT = 0x00000002;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__SUA_VIOLATION_INT__SHIFT = 0x00000007;
constexpr unsigned int CP_MEC1_F32_INTERRUPT__WAVE_RESTORE_INT__SHIFT = 0x00000006;
constexpr unsigned int CP_MEC1_F32_INT_DIS__EDC_DMA_FED_INT__SHIFT = 0x00000008;
constexpr unsigned int CP_MEC1_F32_INT_DIS__EDC_GDS_FED_INT__SHIFT = 0x00000004;
constexpr unsigned int CP_MEC1_F32_INT_DIS__EDC_ROQ_FED_INT__SHIFT = 0x00000000;
constexpr unsigned int CP_MEC1_F32_INT_DIS__EDC_SCRATCH_FED_INT__SHIFT = 0x00000005;
constexpr unsigned int CP_MEC1_F32_INT_DIS__EDC_SR_MEM_FED_INT__SHIFT = 0x0000000d;
constexpr unsigned int CP_MEC1_F32_INT_DIS__EDC_TC_FED_INT__SHIFT = 0x00000003;
constexpr unsigned int CP_MEC1_F32_INT_DIS__FATAL_EDC_ERROR_INT__SHIFT = 0x0000000f;
constexpr unsigned int CP_MEC1_F32_INT_DIS__GPF_INT_CPC__SHIFT  = 0x0000000c;
constexpr unsigned int CP_MEC1_F32_INT_DIS__GPF_INT_CPF__SHIFT  = 0x0000000a;
constexpr unsigned int CP_MEC1_F32_INT_DIS__GPF_INT_DMA__SHIFT  = 0x0000000b;
constexpr unsigned int CP_MEC1_F32_INT_DIS__IQ_TIMER_INT__SHIFT = 0x00000009;
constexpr unsigned int CP_MEC1_F32_INT_DIS__PRIV_REG_INT__SHIFT = 0x00000001;
constexpr unsigned int CP_MEC1_F32_INT_DIS__QUEUE_MESSAGE_INT__SHIFT = 0x0000000e;
constexpr unsigned int CP_MEC1_F32_INT_DIS__RESERVED_BIT_ERR_INT__SHIFT = 0x00000002;
constexpr unsigned int CP_MEC1_F32_INT_DIS__SUA_VIOLATION_INT__SHIFT = 0x00000007;
constexpr unsigned int CP_MEC1_F32_INT_DIS__WAVE_RESTORE_INT__SHIFT = 0x00000006;
constexpr unsigned int CP_MEC1_INSTR_PNTR__INSTR_PNTR__SHIFT    = 0x00000000;
constexpr unsigned int CP_MEC1_INTR_ROUTINE_START__IR_START__SHIFT = 0x00000000;
constexpr unsigned int CP_MEC1_PRGRM_CNTR_START__IP_START__SHIFT = 0x00000000;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__EDC_DMA_FED_INT__SHIFT = 0x00000008;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__EDC_GDS_FED_INT__SHIFT = 0x00000004;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__EDC_ROQ_FED_INT__SHIFT = 0x00000000;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__EDC_SCRATCH_FED_INT__SHIFT = 0x00000005;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__EDC_SR_MEM_FED_INT__SHIFT = 0x0000000d;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__EDC_TC_FED_INT__SHIFT = 0x00000003;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__FATAL_EDC_ERROR_INT__SHIFT = 0x0000000f;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__GPF_INT_CPC__SHIFT = 0x0000000c;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__GPF_INT_CPF__SHIFT = 0x0000000a;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__GPF_INT_DMA__SHIFT = 0x0000000b;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__IQ_TIMER_INT__SHIFT = 0x00000009;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__PRIV_REG_INT__SHIFT = 0x00000001;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__QUEUE_MESSAGE_INT__SHIFT = 0x0000000e;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__RESERVED_BIT_ERR_INT__SHIFT = 0x00000002;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__SUA_VIOLATION_INT__SHIFT = 0x00000007;
constexpr unsigned int CP_MEC2_F32_INTERRUPT__WAVE_RESTORE_INT__SHIFT = 0x00000006;
constexpr unsigned int CP_MEC2_F32_INT_DIS__EDC_DMA_FED_INT__SHIFT = 0x00000008;
constexpr unsigned int CP_MEC2_F32_INT_DIS__EDC_GDS_FED_INT__SHIFT = 0x00000004;
constexpr unsigned int CP_MEC2_F32_INT_DIS__EDC_ROQ_FED_INT__SHIFT = 0x00000000;
constexpr unsigned int CP_MEC2_F32_INT_DIS__EDC_SCRATCH_FED_INT__SHIFT = 0x00000005;
constexpr unsigned int CP_MEC2_F32_INT_DIS__EDC_SR_MEM_FED_INT__SHIFT = 0x0000000d;
constexpr unsigned int CP_MEC2_F32_INT_DIS__EDC_TC_FED_INT__SHIFT = 0x00000003;
constexpr unsigned int CP_MEC2_F32_INT_DIS__FATAL_EDC_ERROR_INT__SHIFT = 0x0000000f;
constexpr unsigned int CP_MEC2_F32_INT_DIS__GPF_INT_CPC__SHIFT  = 0x0000000c;
constexpr unsigned int CP_MEC2_F32_INT_DIS__GPF_INT_CPF__SHIFT  = 0x0000000a;
constexpr unsigned int CP_MEC2_F32_INT_DIS__GPF_INT_DMA__SHIFT  = 0x0000000b;
constexpr unsigned int CP_MEC2_F32_INT_DIS__IQ_TIMER_INT__SHIFT = 0x00000009;
constexpr unsigned int CP_MEC2_F32_INT_DIS__PRIV_REG_INT__SHIFT = 0x00000001;
constexpr unsigned int CP_MEC2_F32_INT_DIS__QUEUE_MESSAGE_INT__SHIFT = 0x0000000e;
constexpr unsigned int CP_MEC2_F32_INT_DIS__RESERVED_BIT_ERR_INT__SHIFT = 0x00000002;
constexpr unsigned int CP_MEC2_F32_INT_DIS__SUA_VIOLATION_INT__SHIFT = 0x00000007;
constexpr unsigned int CP_MEC2_F32_INT_DIS__WAVE_RESTORE_INT__SHIFT = 0x00000006;
constexpr unsigned int CP_MEC2_INSTR_PNTR__INSTR_PNTR__SHIFT    = 0x00000000;
constexpr unsigned int CP_MEC2_INTR_ROUTINE_START__IR_START__SHIFT = 0x00000000;
constexpr unsigned int CP_MEC2_PRGRM_CNTR_START__IP_START__SHIFT = 0x00000000;
constexpr unsigned int CP_MEC_CNTL__MEC_ME1_HALT__SHIFT         = 0x0000001e;
constexpr unsigned int CP_MEC_CNTL__MEC_ME1_PIPE0_RESET__SHIFT  = 0x00000010;
constexpr unsigned int CP_MEC_CNTL__MEC_ME1_PIPE1_RESET__SHIFT  = 0x00000011;
constexpr unsigned int CP_MEC_CNTL__MEC_ME1_PIPE2_RESET__SHIFT  = 0x00000012;
constexpr unsigned int CP_MEC_CNTL__MEC_ME1_PIPE3_RESET__SHIFT  = 0x00000013;
constexpr unsigned int CP_MEC_CNTL__MEC_ME1_STEP__SHIFT         = 0x0000001f;
constexpr unsigned int CP_MEC_CNTL__MEC_ME2_HALT__SHIFT         = 0x0000001c;
constexpr unsigned int CP_MEC_CNTL__MEC_ME2_PIPE0_RESET__SHIFT  = 0x00000014;
constexpr unsigned int CP_MEC_CNTL__MEC_ME2_PIPE1_RESET__SHIFT  = 0x00000015;
constexpr unsigned int CP_MEC_CNTL__MEC_ME2_STEP__SHIFT         = 0x0000001d;
constexpr unsigned int CP_MEC_DOORBELL_RANGE_LOWER__DOORBELL_RANGE_LOWER__SHIFT = 0x00000002;
constexpr unsigned int CP_MEC_DOORBELL_RANGE_UPPER__DOORBELL_RANGE_UPPER__SHIFT = 0x00000002;
constexpr unsigned int CP_MEC_ME1_HEADER_DUMP__HEADER_DUMP__SHIFT = 0x00000000;
constexpr unsigned int CP_MEC_ME2_HEADER_DUMP__HEADER_DUMP__SHIFT = 0x00000000;
constexpr unsigned int CP_MEM_SLP_CNTL__CP_LS_DS_BUSY_OVERRIDE__SHIFT = 0x00000007;
constexpr unsigned int CP_MEM_SLP_CNTL__CP_MEM_DS_EN__SHIFT     = 0x00000001;
constexpr unsigned int CP_MEM_SLP_CNTL__CP_MEM_LS_EN__SHIFT     = 0x00000000;
constexpr unsigned int CP_MEM_SLP_CNTL__CP_MEM_LS_OFF_DELAY__SHIFT = 0x00000010;
constexpr unsigned int CP_MEM_SLP_CNTL__CP_MEM_LS_ON_DELAY__SHIFT = 0x00000008;
constexpr unsigned int CP_MEM_SLP_CNTL__RESERVED1__SHIFT        = 0x00000018;
constexpr unsigned int CP_MEM_SLP_CNTL__RESERVED__SHIFT         = 0x00000002;
constexpr unsigned int CP_MEQ_AVAIL__MEQ_CNT__SHIFT             = 0x00000000;
constexpr unsigned int CP_MEQ_STAT__MEQ_RPTR__SHIFT             = 0x00000000;
constexpr unsigned int CP_MEQ_STAT__MEQ_WPTR__SHIFT             = 0x00000010;
constexpr unsigned int CP_MEQ_STQ_THRESHOLD__STQ_START__SHIFT   = 0x00000000;
constexpr unsigned int CP_MEQ_THRESHOLDS__MEQ1_START__SHIFT     = 0x00000000;
constexpr unsigned int CP_MEQ_THRESHOLDS__MEQ2_START__SHIFT     = 0x00000008;
constexpr unsigned int CP_ME_ATOMIC_PREOP_HI__ATOMIC_PREOP_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_ME_ATOMIC_PREOP_LO__ATOMIC_PREOP_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_ME_CNTL__CE_HALT__SHIFT               = 0x00000018;
constexpr unsigned int CP_ME_CNTL__CE_INVALIDATE_ICACHE__SHIFT  = 0x00000004;
constexpr unsigned int CP_ME_CNTL__CE_PIPE0_RESET__SHIFT        = 0x00000010;
constexpr unsigned int CP_ME_CNTL__CE_PIPE1_RESET__SHIFT        = 0x00000011;
constexpr unsigned int CP_ME_CNTL__CE_STEP__SHIFT               = 0x00000019;
constexpr unsigned int CP_ME_CNTL__ME_HALT__SHIFT               = 0x0000001c;
constexpr unsigned int CP_ME_CNTL__ME_INVALIDATE_ICACHE__SHIFT  = 0x00000008;
constexpr unsigned int CP_ME_CNTL__ME_PIPE0_RESET__SHIFT        = 0x00000014;
constexpr unsigned int CP_ME_CNTL__ME_PIPE1_RESET__SHIFT        = 0x00000015;
constexpr unsigned int CP_ME_CNTL__ME_STEP__SHIFT               = 0x0000001d;
constexpr unsigned int CP_ME_CNTL__PFP_HALT__SHIFT              = 0x0000001a;
constexpr unsigned int CP_ME_CNTL__PFP_INVALIDATE_ICACHE__SHIFT = 0x00000006;
constexpr unsigned int CP_ME_CNTL__PFP_PIPE0_RESET__SHIFT       = 0x00000012;
constexpr unsigned int CP_ME_CNTL__PFP_PIPE1_RESET__SHIFT       = 0x00000013;
constexpr unsigned int CP_ME_CNTL__PFP_STEP__SHIFT              = 0x0000001b;
constexpr unsigned int CP_ME_COHER_BASE_HI__COHER_BASE_HI_256B__SHIFT = 0x00000000;
constexpr unsigned int CP_ME_COHER_BASE__COHER_BASE_256B__SHIFT = 0x00000000;
constexpr unsigned int CP_ME_COHER_CNTL__CB0_DEST_BASE_ENA__SHIFT = 0x00000006;
constexpr unsigned int CP_ME_COHER_CNTL__CB1_DEST_BASE_ENA__SHIFT = 0x00000007;
constexpr unsigned int CP_ME_COHER_CNTL__CB2_DEST_BASE_ENA__SHIFT = 0x00000008;
constexpr unsigned int CP_ME_COHER_CNTL__CB3_DEST_BASE_ENA__SHIFT = 0x00000009;
constexpr unsigned int CP_ME_COHER_CNTL__CB4_DEST_BASE_ENA__SHIFT = 0x0000000a;
constexpr unsigned int CP_ME_COHER_CNTL__CB5_DEST_BASE_ENA__SHIFT = 0x0000000b;
constexpr unsigned int CP_ME_COHER_CNTL__CB6_DEST_BASE_ENA__SHIFT = 0x0000000c;
constexpr unsigned int CP_ME_COHER_CNTL__CB7_DEST_BASE_ENA__SHIFT = 0x0000000d;
constexpr unsigned int CP_ME_COHER_CNTL__DB_DEST_BASE_ENA__SHIFT = 0x0000000e;
constexpr unsigned int CP_ME_COHER_CNTL__DEST_BASE_0_ENA__SHIFT = 0x00000000;
constexpr unsigned int CP_ME_COHER_CNTL__DEST_BASE_1_ENA__SHIFT = 0x00000001;
constexpr unsigned int CP_ME_COHER_CNTL__DEST_BASE_2_ENA__SHIFT = 0x00000013;
constexpr unsigned int CP_ME_COHER_CNTL__DEST_BASE_3_ENA__SHIFT = 0x00000015;
constexpr unsigned int CP_ME_COHER_SIZE_HI__COHER_SIZE_HI_256B__SHIFT = 0x00000000;
constexpr unsigned int CP_ME_COHER_SIZE__COHER_SIZE_256B__SHIFT = 0x00000000;
constexpr unsigned int CP_ME_COHER_STATUS__MATCHING_GFX_CNTX__SHIFT = 0x00000000;
constexpr unsigned int CP_ME_COHER_STATUS__STATUS__SHIFT        = 0x0000001f;
constexpr unsigned int CP_ME_HEADER_DUMP__ME_HEADER_DUMP__SHIFT = 0x00000000;
constexpr unsigned int CP_ME_INSTR_PNTR__INSTR_PNTR__SHIFT      = 0x00000000;
constexpr unsigned int CP_ME_INTR_ROUTINE_START__IR_START__SHIFT = 0x00000000;
constexpr unsigned int CP_ME_MC_RADDR_HI__CACHE_POLICY__SHIFT   = 0x00000016;
constexpr unsigned int CP_ME_MC_RADDR_HI__ME_MC_RADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_ME_MC_RADDR_LO__ME_MC_RADDR_LO__SHIFT = 0x00000002;
constexpr unsigned int CP_ME_MC_WADDR_HI__CACHE_POLICY__SHIFT   = 0x00000016;
constexpr unsigned int CP_ME_MC_WADDR_HI__ME_MC_WADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_ME_MC_WADDR_LO__ME_MC_WADDR_LO__SHIFT = 0x00000002;
constexpr unsigned int CP_ME_MC_WDATA_HI__ME_MC_WDATA_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_ME_MC_WDATA_LO__ME_MC_WDATA_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_ME_PREEMPTION__OBSOLETE__SHIFT        = 0x00000000;
constexpr unsigned int CP_ME_PRGRM_CNTR_START__IP_START__SHIFT  = 0x00000000;
constexpr unsigned int CP_ME_RAM_DATA__ME_RAM_DATA__SHIFT       = 0x00000000;
constexpr unsigned int CP_ME_RAM_RADDR__ME_RAM_RADDR__SHIFT     = 0x00000000;
constexpr unsigned int CP_ME_RAM_WADDR__ME_RAM_WADDR__SHIFT     = 0x00000000;
constexpr unsigned int CP_MQD_BASE_ADDR_HI__BASE_ADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_MQD_BASE_ADDR__BASE_ADDR__SHIFT       = 0x00000002;
constexpr unsigned int CP_MQD_CONTROL__CACHE_POLICY__SHIFT      = 0x00000018;
constexpr unsigned int CP_MQD_CONTROL__EXE_DISABLE__SHIFT       = 0x00000017;
constexpr unsigned int CP_MQD_CONTROL__PRIV_STATE__SHIFT        = 0x00000008;
constexpr unsigned int CP_MQD_CONTROL__PROCESSING_MQD_EN__SHIFT = 0x0000000d;
constexpr unsigned int CP_MQD_CONTROL__PROCESSING_MQD__SHIFT    = 0x0000000c;
constexpr unsigned int CP_MQD_CONTROL__VMID__SHIFT              = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_NEEDED_COUNT0_HI__NUM_PRIM_NEEDED_CNT0_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_NEEDED_COUNT0_LO__NUM_PRIM_NEEDED_CNT0_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_NEEDED_COUNT1_HI__NUM_PRIM_NEEDED_CNT1_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_NEEDED_COUNT1_LO__NUM_PRIM_NEEDED_CNT1_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_NEEDED_COUNT2_HI__NUM_PRIM_NEEDED_CNT2_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_NEEDED_COUNT2_LO__NUM_PRIM_NEEDED_CNT2_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_NEEDED_COUNT3_HI__NUM_PRIM_NEEDED_CNT3_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_NEEDED_COUNT3_LO__NUM_PRIM_NEEDED_CNT3_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_WRITTEN_COUNT0_HI__NUM_PRIM_WRITTEN_CNT0_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_WRITTEN_COUNT0_LO__NUM_PRIM_WRITTEN_CNT0_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_WRITTEN_COUNT1_HI__NUM_PRIM_WRITTEN_CNT1_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_WRITTEN_COUNT1_LO__NUM_PRIM_WRITTEN_CNT1_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_WRITTEN_COUNT2_HI__NUM_PRIM_WRITTEN_CNT2_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_WRITTEN_COUNT2_LO__NUM_PRIM_WRITTEN_CNT2_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_WRITTEN_COUNT3_HI__NUM_PRIM_WRITTEN_CNT3_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_WRITTEN_COUNT3_LO__NUM_PRIM_WRITTEN_CNT3_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_PA_CINVOC_COUNT_HI__CINVOC_COUNT_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_PA_CINVOC_COUNT_LO__CINVOC_COUNT_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_PA_CPRIM_COUNT_HI__CPRIM_COUNT_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_PA_CPRIM_COUNT_LO__CPRIM_COUNT_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_PERFMON_CNTL__PERFMON_ENABLE_MODE__SHIFT = 0x00000008;
constexpr unsigned int CP_PERFMON_CNTL__PERFMON_SAMPLE_ENABLE__SHIFT = 0x0000000a;
constexpr unsigned int CP_PERFMON_CNTL__PERFMON_STATE__SHIFT    = 0x00000000;
constexpr unsigned int CP_PERFMON_CNTL__SPM_PERFMON_STATE__SHIFT = 0x00000004;
constexpr unsigned int CP_PERFMON_CNTX_CNTL__PERFMON_ENABLE__SHIFT = 0x0000001f;
constexpr unsigned int CP_PFP_ATOMIC_PREOP_HI__ATOMIC_PREOP_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_PFP_ATOMIC_PREOP_LO__ATOMIC_PREOP_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_PFP_COMPLETION_STATUS__STATUS__SHIFT  = 0x00000000;
constexpr unsigned int CP_PFP_F32_INTERRUPT__PRIV_REG_INT__SHIFT = 0x00000001;
constexpr unsigned int CP_PFP_F32_INTERRUPT__RESERVED_BIT_ERR_INT__SHIFT = 0x00000002;
constexpr unsigned int CP_PFP_HEADER_DUMP__PFP_HEADER_DUMP__SHIFT = 0x00000000;
constexpr unsigned int CP_PFP_IB_CONTROL__IB_EN__SHIFT          = 0x00000000;
constexpr unsigned int CP_PFP_INSTR_PNTR__INSTR_PNTR__SHIFT     = 0x00000000;
constexpr unsigned int CP_PFP_INTR_ROUTINE_START__IR_START__SHIFT = 0x00000000;
constexpr unsigned int CP_PFP_LOAD_CONTROL__CNTX_REG_EN__SHIFT  = 0x00000001;
constexpr unsigned int CP_PFP_LOAD_CONTROL__CONFIG_REG_EN__SHIFT = 0x00000000;
constexpr unsigned int CP_PFP_LOAD_CONTROL__SH_CS_REG_EN__SHIFT = 0x00000018;
constexpr unsigned int CP_PFP_LOAD_CONTROL__SH_GFX_REG_EN__SHIFT = 0x00000010;
constexpr unsigned int CP_PFP_METADATA_BASE_ADDR_HI__ADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_PFP_METADATA_BASE_ADDR__ADDR_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_PFP_PRGRM_CNTR_START__IP_START__SHIFT = 0x00000000;
constexpr unsigned int CP_PIPEID__PIPE_ID__SHIFT                = 0x00000000;
constexpr unsigned int CP_PIPE_STATS_ADDR_HI__PIPE_STATS_ADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_PIPE_STATS_ADDR_LO__PIPE_STATS_ADDR_LO__SHIFT = 0x00000002;
constexpr unsigned int CP_PIPE_STATS_CONTROL__CACHE_POLICY__SHIFT = 0x00000019;
constexpr unsigned int CP_PQ_STATUS__DOORBELL_ENABLE__SHIFT     = 0x00000001;
constexpr unsigned int CP_PQ_STATUS__DOORBELL_UPDATED__SHIFT    = 0x00000000;
constexpr unsigned int CP_PQ_WPTR_POLL_CNTL1__QUEUE_MASK__SHIFT = 0x00000000;
constexpr unsigned int CP_PQ_WPTR_POLL_CNTL__DISABLE_PEND_REQ_ONE_SHOT__SHIFT = 0x0000001d;
constexpr unsigned int CP_PQ_WPTR_POLL_CNTL__EN__SHIFT          = 0x0000001f;
constexpr unsigned int CP_PQ_WPTR_POLL_CNTL__PERIOD__SHIFT      = 0x00000000;
constexpr unsigned int CP_PQ_WPTR_POLL_CNTL__POLL_ACTIVE__SHIFT = 0x0000001e;
constexpr unsigned int CP_PRED_NOT_VISIBLE__NOT_VISIBLE__SHIFT  = 0x00000000;
constexpr unsigned int CP_PWR_CNTL__CMP_CLK_HALT_ME1_PIPE0__SHIFT = 0x00000008;
constexpr unsigned int CP_PWR_CNTL__CMP_CLK_HALT_ME1_PIPE1__SHIFT = 0x00000009;
constexpr unsigned int CP_PWR_CNTL__CMP_CLK_HALT_ME1_PIPE2__SHIFT = 0x0000000a;
constexpr unsigned int CP_PWR_CNTL__CMP_CLK_HALT_ME1_PIPE3__SHIFT = 0x0000000b;
constexpr unsigned int CP_PWR_CNTL__CMP_CLK_HALT_ME2_PIPE0__SHIFT = 0x00000010;
constexpr unsigned int CP_PWR_CNTL__CMP_CLK_HALT_ME2_PIPE1__SHIFT = 0x00000011;
constexpr unsigned int CP_PWR_CNTL__CMP_CLK_HALT_ME2_PIPE2__SHIFT = 0x00000012;
constexpr unsigned int CP_PWR_CNTL__CMP_CLK_HALT_ME2_PIPE3__SHIFT = 0x00000013;
constexpr unsigned int CP_PWR_CNTL__GFX_CLK_HALT_ME0_PIPE0__SHIFT = 0x00000000;
constexpr unsigned int CP_PWR_CNTL__GFX_CLK_HALT_ME0_PIPE1__SHIFT = 0x00000001;
constexpr unsigned int CP_QUEUE_THRESHOLDS__ROQ_IB1_START__SHIFT = 0x00000000;
constexpr unsigned int CP_QUEUE_THRESHOLDS__ROQ_IB2_START__SHIFT = 0x00000008;
constexpr unsigned int CP_RB0_ACTIVE__ACTIVE__SHIFT             = 0x00000000;
constexpr unsigned int CP_RB0_BASE_HI__RB_BASE_HI__SHIFT        = 0x00000000;
constexpr unsigned int CP_RB0_BASE__RB_BASE__SHIFT              = 0x00000000;
constexpr unsigned int CP_RB0_BUFSZ_MASK__DATA__SHIFT           = 0x00000000;
constexpr unsigned int CP_RB0_CNTL__CACHE_POLICY__SHIFT         = 0x00000018;
constexpr unsigned int CP_RB0_CNTL__MIN_AVAILSZ__SHIFT          = 0x00000014;
constexpr unsigned int CP_RB0_CNTL__MIN_IB_AVAILSZ__SHIFT       = 0x00000016;
constexpr unsigned int CP_RB0_CNTL__RB_BLKSZ__SHIFT             = 0x00000008;
constexpr unsigned int CP_RB0_CNTL__RB_BUFSZ__SHIFT             = 0x00000000;
constexpr unsigned int CP_RB0_CNTL__RB_NO_UPDATE__SHIFT         = 0x0000001b;
constexpr unsigned int CP_RB0_CNTL__RB_RPTR_WR_ENA__SHIFT       = 0x0000001f;
constexpr unsigned int CP_RB0_RPTR_ADDR_HI__RB_RPTR_ADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_RB0_RPTR_ADDR__RB_RPTR_ADDR__SHIFT    = 0x00000002;
constexpr unsigned int CP_RB0_RPTR__RB_RPTR__SHIFT              = 0x00000000;
constexpr unsigned int CP_RB0_WPTR_HI__RB_WPTR__SHIFT           = 0x00000000;
constexpr unsigned int CP_RB0_WPTR__RB_WPTR__SHIFT              = 0x00000000;
constexpr unsigned int CP_RB1_BASE_HI__RB_BASE_HI__SHIFT        = 0x00000000;
constexpr unsigned int CP_RB1_BASE__RB_BASE__SHIFT              = 0x00000000;
constexpr unsigned int CP_RB1_CNTL__CACHE_POLICY__SHIFT         = 0x00000018;
constexpr unsigned int CP_RB1_CNTL__MIN_AVAILSZ__SHIFT          = 0x00000014;
constexpr unsigned int CP_RB1_CNTL__MIN_IB_AVAILSZ__SHIFT       = 0x00000016;
constexpr unsigned int CP_RB1_CNTL__RB_BLKSZ__SHIFT             = 0x00000008;
constexpr unsigned int CP_RB1_CNTL__RB_BUFSZ__SHIFT             = 0x00000000;
constexpr unsigned int CP_RB1_CNTL__RB_NO_UPDATE__SHIFT         = 0x0000001b;
constexpr unsigned int CP_RB1_CNTL__RB_RPTR_WR_ENA__SHIFT       = 0x0000001f;
constexpr unsigned int CP_RB1_RPTR_ADDR_HI__RB_RPTR_ADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_RB1_RPTR_ADDR__RB_RPTR_ADDR__SHIFT    = 0x00000002;
constexpr unsigned int CP_RB1_RPTR__RB_RPTR__SHIFT              = 0x00000000;
constexpr unsigned int CP_RB1_WPTR_HI__RB_WPTR__SHIFT           = 0x00000000;
constexpr unsigned int CP_RB1_WPTR__RB_WPTR__SHIFT              = 0x00000000;
constexpr unsigned int CP_RB2_BASE__RB_BASE__SHIFT              = 0x00000000;
constexpr unsigned int CP_RB2_CNTL__CACHE_POLICY__SHIFT         = 0x00000018;
constexpr unsigned int CP_RB2_CNTL__MIN_AVAILSZ__SHIFT          = 0x00000014;
constexpr unsigned int CP_RB2_CNTL__MIN_IB_AVAILSZ__SHIFT       = 0x00000016;
constexpr unsigned int CP_RB2_CNTL__RB_BLKSZ__SHIFT             = 0x00000008;
constexpr unsigned int CP_RB2_CNTL__RB_BUFSZ__SHIFT             = 0x00000000;
constexpr unsigned int CP_RB2_CNTL__RB_NO_UPDATE__SHIFT         = 0x0000001b;
constexpr unsigned int CP_RB2_CNTL__RB_RPTR_WR_ENA__SHIFT       = 0x0000001f;
constexpr unsigned int CP_RB2_RPTR_ADDR_HI__RB_RPTR_ADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_RB2_RPTR_ADDR__RB_RPTR_ADDR__SHIFT    = 0x00000002;
constexpr unsigned int CP_RB2_RPTR__RB_RPTR__SHIFT              = 0x00000000;
constexpr unsigned int CP_RB2_WPTR__RB_WPTR__SHIFT              = 0x00000000;
constexpr unsigned int CP_RB_ACTIVE__ACTIVE__SHIFT              = 0x00000000;
constexpr unsigned int CP_RB_BASE__RB_BASE__SHIFT               = 0x00000000;
constexpr unsigned int CP_RB_BUFSZ_MASK__DATA__SHIFT            = 0x00000000;
constexpr unsigned int CP_RB_CNTL__CACHE_POLICY__SHIFT          = 0x00000018;
constexpr unsigned int CP_RB_CNTL__MIN_AVAILSZ__SHIFT           = 0x00000014;
constexpr unsigned int CP_RB_CNTL__MIN_IB_AVAILSZ__SHIFT        = 0x00000016;
constexpr unsigned int CP_RB_CNTL__RB_BLKSZ__SHIFT              = 0x00000008;
constexpr unsigned int CP_RB_CNTL__RB_BUFSZ__SHIFT              = 0x00000000;
constexpr unsigned int CP_RB_CNTL__RB_NO_UPDATE__SHIFT          = 0x0000001b;
constexpr unsigned int CP_RB_CNTL__RB_RPTR_WR_ENA__SHIFT        = 0x0000001f;
constexpr unsigned int CP_RB_DOORBELL_CLEAR__MAPPED_QUEUE__SHIFT = 0x00000000;
constexpr unsigned int CP_RB_DOORBELL_CLEAR__MAPPED_QUE_DOORBELL_EN_CLEAR__SHIFT = 0x00000008;
constexpr unsigned int CP_RB_DOORBELL_CLEAR__MAPPED_QUE_DOORBELL_HIT_CLEAR__SHIFT = 0x00000009;
constexpr unsigned int CP_RB_DOORBELL_CLEAR__MASTER_DOORBELL_EN_CLEAR__SHIFT = 0x0000000a;
constexpr unsigned int CP_RB_DOORBELL_CLEAR__MASTER_DOORBELL_HIT_CLEAR__SHIFT = 0x0000000b;
constexpr unsigned int CP_RB_DOORBELL_CLEAR__QUEUES_DOORBELL_EN_CLEAR__SHIFT = 0x0000000c;
constexpr unsigned int CP_RB_DOORBELL_CLEAR__QUEUES_DOORBELL_HIT_CLEAR__SHIFT = 0x0000000d;
constexpr unsigned int CP_RB_DOORBELL_CONTROL__DOORBELL_BIF_DROP__SHIFT = 0x00000001;
constexpr unsigned int CP_RB_DOORBELL_CONTROL__DOORBELL_EN__SHIFT = 0x0000001e;
constexpr unsigned int CP_RB_DOORBELL_CONTROL__DOORBELL_HIT__SHIFT = 0x0000001f;
constexpr unsigned int CP_RB_DOORBELL_CONTROL__DOORBELL_OFFSET__SHIFT = 0x00000002;
constexpr unsigned int CP_RB_DOORBELL_RANGE_LOWER__DOORBELL_RANGE_LOWER__SHIFT = 0x00000002;
constexpr unsigned int CP_RB_DOORBELL_RANGE_UPPER__DOORBELL_RANGE_UPPER__SHIFT = 0x00000002;
constexpr unsigned int CP_RB_OFFSET__RB_OFFSET__SHIFT           = 0x00000000;
constexpr unsigned int CP_RB_RPTR_ADDR_HI__RB_RPTR_ADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_RB_RPTR_ADDR__RB_RPTR_ADDR__SHIFT     = 0x00000002;
constexpr unsigned int CP_RB_RPTR_WR__RB_RPTR_WR__SHIFT         = 0x00000000;
constexpr unsigned int CP_RB_RPTR__RB_RPTR__SHIFT               = 0x00000000;
constexpr unsigned int CP_RB_STATUS__DOORBELL_ENABLE__SHIFT     = 0x00000001;
constexpr unsigned int CP_RB_STATUS__DOORBELL_UPDATED__SHIFT    = 0x00000000;
constexpr unsigned int CP_RB_VMID__RB0_VMID__SHIFT              = 0x00000000;
constexpr unsigned int CP_RB_VMID__RB1_VMID__SHIFT              = 0x00000008;
constexpr unsigned int CP_RB_VMID__RB2_VMID__SHIFT              = 0x00000010;
constexpr unsigned int CP_RB_WPTR_DELAY__PRE_WRITE_LIMIT__SHIFT = 0x0000001c;
constexpr unsigned int CP_RB_WPTR_DELAY__PRE_WRITE_TIMER__SHIFT = 0x00000000;
constexpr unsigned int CP_RB_WPTR_HI__RB_WPTR__SHIFT            = 0x00000000;
constexpr unsigned int CP_RB_WPTR_POLL_ADDR_HI__RB_WPTR_POLL_ADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_RB_WPTR_POLL_ADDR_LO__RB_WPTR_POLL_ADDR_LO__SHIFT = 0x00000002;
constexpr unsigned int CP_RB_WPTR_POLL_CNTL__IDLE_POLL_COUNT__SHIFT = 0x00000010;
constexpr unsigned int CP_RB_WPTR_POLL_CNTL__POLL_FREQUENCY__SHIFT = 0x00000000;
constexpr unsigned int CP_RB_WPTR__RB_WPTR__SHIFT               = 0x00000000;
constexpr unsigned int CP_RING0_PRIORITY__PRIORITY__SHIFT       = 0x00000000;
constexpr unsigned int CP_RING1_PRIORITY__PRIORITY__SHIFT       = 0x00000000;
constexpr unsigned int CP_RING2_PRIORITY__PRIORITY__SHIFT       = 0x00000000;
constexpr unsigned int CP_RINGID__RINGID__SHIFT                 = 0x00000000;
constexpr unsigned int CP_RING_PRIORITY_CNTS__PRIORITY1_CNT__SHIFT = 0x00000000;
constexpr unsigned int CP_RING_PRIORITY_CNTS__PRIORITY2A_CNT__SHIFT = 0x00000008;
constexpr unsigned int CP_RING_PRIORITY_CNTS__PRIORITY2B_CNT__SHIFT = 0x00000010;
constexpr unsigned int CP_RING_PRIORITY_CNTS__PRIORITY3_CNT__SHIFT = 0x00000018;
constexpr unsigned int CP_ROQ1_THRESHOLDS__RB1_START__SHIFT     = 0x00000000;
constexpr unsigned int CP_ROQ2_AVAIL__ROQ_CNT_IB2__SHIFT        = 0x00000000;
constexpr unsigned int CP_ROQ_AVAIL__ROQ_CNT_IB1__SHIFT         = 0x00000010;
constexpr unsigned int CP_ROQ_AVAIL__ROQ_CNT_RING__SHIFT        = 0x00000000;
constexpr unsigned int CP_ROQ_IB1_STAT__ROQ_RPTR_INDIRECT1__SHIFT = 0x00000000;
constexpr unsigned int CP_ROQ_IB1_STAT__ROQ_WPTR_INDIRECT1__SHIFT = 0x00000010;
constexpr unsigned int CP_ROQ_IB2_STAT__ROQ_RPTR_INDIRECT2__SHIFT = 0x00000000;
constexpr unsigned int CP_ROQ_IB2_STAT__ROQ_WPTR_INDIRECT2__SHIFT = 0x00000010;
constexpr unsigned int CP_ROQ_RB_STAT__ROQ_RPTR_PRIMARY__SHIFT  = 0x00000000;
constexpr unsigned int CP_ROQ_RB_STAT__ROQ_WPTR_PRIMARY__SHIFT  = 0x00000010;
constexpr unsigned int CP_ROQ_THRESHOLDS__IB1_START__SHIFT      = 0x00000000;
constexpr unsigned int CP_ROQ_THRESHOLDS__IB2_START__SHIFT      = 0x00000008;
constexpr unsigned int CP_SAMPLE_STATUS__DISP_INDIRECT_ACTIVE__SHIFT = 0x00000007;
constexpr unsigned int CP_SAMPLE_STATUS__DRAW_INDIRECT_ACTIVE__SHIFT = 0x00000006;
constexpr unsigned int CP_SAMPLE_STATUS__PIPELINE_ACTIVE__SHIFT = 0x00000002;
constexpr unsigned int CP_SAMPLE_STATUS__SCREEN_EXT_ACTIVE__SHIFT = 0x00000005;
constexpr unsigned int CP_SAMPLE_STATUS__STIPPLE_ACTIVE__SHIFT  = 0x00000003;
constexpr unsigned int CP_SAMPLE_STATUS__STREAMOUT_ACTIVE__SHIFT = 0x00000001;
constexpr unsigned int CP_SAMPLE_STATUS__VGT_BUFFERS_ACTIVE__SHIFT = 0x00000004;
constexpr unsigned int CP_SAMPLE_STATUS__Z_PASS_ACITVE__SHIFT   = 0x00000000;
constexpr unsigned int CP_SCRATCH_DATA__SCRATCH_DATA__SHIFT     = 0x00000000;
constexpr unsigned int CP_SCRATCH_INDEX__SCRATCH_INDEX__SHIFT   = 0x00000000;
constexpr unsigned int CP_SC_PSINVOC_COUNT0_HI__PSINVOC_COUNT0_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_SC_PSINVOC_COUNT0_LO__PSINVOC_COUNT0_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_SC_PSINVOC_COUNT1_HI__OBSOLETE__SHIFT = 0x00000000;
constexpr unsigned int CP_SC_PSINVOC_COUNT1_LO__OBSOLETE__SHIFT = 0x00000000;
constexpr unsigned int CP_SD_CNTL__CPC_EN__SHIFT                = 0x00000002;
constexpr unsigned int CP_SD_CNTL__CPF_EN__SHIFT                = 0x00000000;
constexpr unsigned int CP_SD_CNTL__CPG_EN__SHIFT                = 0x00000001;
constexpr unsigned int CP_SD_CNTL__EA_EN__SHIFT                 = 0x00000009;
constexpr unsigned int CP_SD_CNTL__RLC_EN__SHIFT                = 0x00000003;
constexpr unsigned int CP_SD_CNTL__SPI_EN__SHIFT                = 0x00000004;
constexpr unsigned int CP_SEM_WAIT_TIMER__SEM_WAIT_TIMER__SHIFT = 0x00000000;
constexpr unsigned int CP_SIG_SEM_ADDR_HI__SEM_ADDR_HI__SHIFT   = 0x00000000;
constexpr unsigned int CP_SIG_SEM_ADDR_HI__SEM_CLIENT_CODE__SHIFT = 0x00000018;
constexpr unsigned int CP_SIG_SEM_ADDR_HI__SEM_SELECT__SHIFT    = 0x0000001d;
constexpr unsigned int CP_SIG_SEM_ADDR_HI__SEM_SIGNAL_TYPE__SHIFT = 0x00000014;
constexpr unsigned int CP_SIG_SEM_ADDR_HI__SEM_USE_MAILBOX__SHIFT = 0x00000010;
constexpr unsigned int CP_SIG_SEM_ADDR_LO__SEM_ADDR_LO__SHIFT   = 0x00000003;
constexpr unsigned int CP_SOFT_RESET_CNTL__CMP_HQD_QUEUE_DOORBELL_RESET__SHIFT = 0x00000004;
constexpr unsigned int CP_SOFT_RESET_CNTL__CMP_HQD_REG_RESET__SHIFT = 0x00000002;
constexpr unsigned int CP_SOFT_RESET_CNTL__CMP_INTR_REG_RESET__SHIFT = 0x00000003;
constexpr unsigned int CP_SOFT_RESET_CNTL__CMP_ONLY_SOFT_RESET__SHIFT = 0x00000000;
constexpr unsigned int CP_SOFT_RESET_CNTL__GFX_INTR_REG_RESET__SHIFT = 0x00000006;
constexpr unsigned int CP_SOFT_RESET_CNTL__GFX_ONLY_SOFT_RESET__SHIFT = 0x00000001;
constexpr unsigned int CP_SOFT_RESET_CNTL__GFX_RB_DOORBELL_RESET__SHIFT = 0x00000005;
constexpr unsigned int CP_STALLED_STAT1__ME_HAS_ACTIVE_CE_BUFFER_FLAG__SHIFT = 0x0000000a;
constexpr unsigned int CP_STALLED_STAT1__ME_HAS_ACTIVE_DE_BUFFER_FLAG__SHIFT = 0x0000000b;
constexpr unsigned int CP_STALLED_STAT1__ME_STALLED_ON_ATOMIC_RTN_DATA__SHIFT = 0x0000000d;
constexpr unsigned int CP_STALLED_STAT1__ME_STALLED_ON_TC_WR_CONFIRM__SHIFT = 0x0000000c;
constexpr unsigned int CP_STALLED_STAT1__ME_WAITING_ON_REG_READ_DATA__SHIFT = 0x0000000f;
constexpr unsigned int CP_STALLED_STAT1__ME_WAITING_ON_TC_READ_DATA__SHIFT = 0x0000000e;
constexpr unsigned int CP_STALLED_STAT1__RBIU_TO_DMA_NOT_RDY_TO_RCV__SHIFT = 0x00000000;
constexpr unsigned int CP_STALLED_STAT1__RCIU_HALTED_BY_REG_VIOLATION__SHIFT = 0x0000001d;
constexpr unsigned int CP_STALLED_STAT1__RCIU_STALLED_ON_APPEND_READ__SHIFT = 0x0000001c;
constexpr unsigned int CP_STALLED_STAT1__RCIU_STALLED_ON_DMA_READ__SHIFT = 0x0000001b;
constexpr unsigned int CP_STALLED_STAT1__RCIU_STALLED_ON_ME_READ__SHIFT = 0x0000001a;
constexpr unsigned int CP_STALLED_STAT1__RCIU_WAITING_ON_GDS_FREE__SHIFT = 0x00000017;
constexpr unsigned int CP_STALLED_STAT1__RCIU_WAITING_ON_GRBM_FREE__SHIFT = 0x00000018;
constexpr unsigned int CP_STALLED_STAT1__RCIU_WAITING_ON_VGT_FREE__SHIFT = 0x00000019;
constexpr unsigned int CP_STALLED_STAT2__APPEND_ACTIVE_PARTITION__SHIFT = 0x0000001c;
constexpr unsigned int CP_STALLED_STAT2__APPEND_RDY_WAIT_ON_CS_DONE__SHIFT = 0x00000019;
constexpr unsigned int CP_STALLED_STAT2__APPEND_RDY_WAIT_ON_PS_DONE__SHIFT = 0x0000001a;
constexpr unsigned int CP_STALLED_STAT2__APPEND_WAITING_TO_SEND_MEMWRITE__SHIFT = 0x0000001d;
constexpr unsigned int CP_STALLED_STAT2__APPEND_WAIT_ON_WR_CONFIRM__SHIFT = 0x0000001b;
constexpr unsigned int CP_STALLED_STAT2__GFX_CNTX_NOT_AVAIL_TO_ME__SHIFT = 0x0000000b;
constexpr unsigned int CP_STALLED_STAT2__MEQ_TO_ME_NOT_RDY_TO_RCV__SHIFT = 0x00000010;
constexpr unsigned int CP_STALLED_STAT2__ME_RCIU_NOT_RDY_TO_RCV__SHIFT = 0x0000000c;
constexpr unsigned int CP_STALLED_STAT2__ME_TO_CONST_NOT_RDY_TO_RCV__SHIFT = 0x0000000d;
constexpr unsigned int CP_STALLED_STAT2__ME_WAITING_DATA_FROM_PFP__SHIFT = 0x0000000e;
constexpr unsigned int CP_STALLED_STAT2__ME_WAITING_DATA_FROM_STQ__SHIFT = 0x00000012;
constexpr unsigned int CP_STALLED_STAT2__ME_WAITING_ON_PARTIAL_FLUSH__SHIFT = 0x0000000f;
constexpr unsigned int CP_STALLED_STAT2__ME_WAIT_ON_AVAIL_BUFFER__SHIFT = 0x0000000a;
constexpr unsigned int CP_STALLED_STAT2__ME_WAIT_ON_CE_COUNTER__SHIFT = 0x00000009;
constexpr unsigned int CP_STALLED_STAT2__PFP_RCIU_READ_PENDING__SHIFT = 0x00000005;
constexpr unsigned int CP_STALLED_STAT2__PFP_STALLED_ON_ATOMIC_RTN_DATA__SHIFT = 0x00000014;
constexpr unsigned int CP_STALLED_STAT2__PFP_STALLED_ON_TC_WR_CONFIRM__SHIFT = 0x00000013;
constexpr unsigned int CP_STALLED_STAT2__PFP_TO_CSF_NOT_RDY_TO_RCV__SHIFT = 0x00000000;
constexpr unsigned int CP_STALLED_STAT2__PFP_TO_MEQ_NOT_RDY_TO_RCV__SHIFT = 0x00000001;
constexpr unsigned int CP_STALLED_STAT2__PFP_TO_RCIU_NOT_RDY_TO_RCV__SHIFT = 0x00000002;
constexpr unsigned int CP_STALLED_STAT2__PFP_TO_VGT_WRITES_PENDING__SHIFT = 0x00000004;
constexpr unsigned int CP_STALLED_STAT2__PFP_WAITING_ON_BUFFER_DATA__SHIFT = 0x00000008;
constexpr unsigned int CP_STALLED_STAT2__PIPE_STATS_WR_DATA_PENDING__SHIFT = 0x00000018;
constexpr unsigned int CP_STALLED_STAT2__STQ_TO_ME_NOT_RDY_TO_RCV__SHIFT = 0x00000011;
constexpr unsigned int CP_STALLED_STAT2__STRMO_WR_OF_PRIM_DATA_PENDING__SHIFT = 0x00000017;
constexpr unsigned int CP_STALLED_STAT2__SURF_SYNC_NEEDS_ALL_CLEAN__SHIFT = 0x0000001f;
constexpr unsigned int CP_STALLED_STAT2__SURF_SYNC_NEEDS_IDLE_CNTXS__SHIFT = 0x0000001e;
constexpr unsigned int CP_STALLED_STAT3__CE_STALLED_ON_ATOMIC_RTN_DATA__SHIFT = 0x00000011;
constexpr unsigned int CP_STALLED_STAT3__CE_STALLED_ON_TC_WR_CONFIRM__SHIFT = 0x00000010;
constexpr unsigned int CP_STALLED_STAT3__CE_TO_CSF_NOT_RDY_TO_RCV__SHIFT = 0x00000000;
constexpr unsigned int CP_STALLED_STAT3__CE_TO_INC_FIFO_NOT_RDY_TO_RCV__SHIFT = 0x00000006;
constexpr unsigned int CP_STALLED_STAT3__CE_TO_RAM_DUMP_NOT_RDY__SHIFT = 0x00000004;
constexpr unsigned int CP_STALLED_STAT3__CE_TO_RAM_INIT_FETCHER_NOT_RDY_TO_RCV__SHIFT = 0x00000001;
constexpr unsigned int CP_STALLED_STAT3__CE_TO_RAM_INIT_NOT_RDY__SHIFT = 0x00000003;
constexpr unsigned int CP_STALLED_STAT3__CE_TO_RAM_WRITE_NOT_RDY__SHIFT = 0x00000005;
constexpr unsigned int CP_STALLED_STAT3__CE_TO_WR_FIFO_NOT_RDY_TO_RCV__SHIFT = 0x00000007;
constexpr unsigned int CP_STALLED_STAT3__CE_WAITING_ON_BUFFER_DATA__SHIFT = 0x0000000a;
constexpr unsigned int CP_STALLED_STAT3__CE_WAITING_ON_CE_BUFFER_FLAG__SHIFT = 0x0000000b;
constexpr unsigned int CP_STALLED_STAT3__CE_WAITING_ON_DATA_FROM_RAM_INIT_FETCHER__SHIFT = 0x00000002;
constexpr unsigned int CP_STALLED_STAT3__CE_WAITING_ON_DE_COUNTER_UNDERFLOW__SHIFT = 0x0000000d;
constexpr unsigned int CP_STALLED_STAT3__CE_WAITING_ON_DE_COUNTER__SHIFT = 0x0000000c;
constexpr unsigned int CP_STALLED_STAT3__TCIU_WAITING_ON_FREE__SHIFT = 0x0000000e;
constexpr unsigned int CP_STALLED_STAT3__TCIU_WAITING_ON_TAGS__SHIFT = 0x0000000f;
constexpr unsigned int CP_STALLED_STAT3__UTCL1_WAITING_ON_TRANS__SHIFT = 0x00000014;
constexpr unsigned int CP_STALLED_STAT3__UTCL2IU_WAITING_ON_FREE__SHIFT = 0x00000012;
constexpr unsigned int CP_STALLED_STAT3__UTCL2IU_WAITING_ON_TAGS__SHIFT = 0x00000013;
constexpr unsigned int CP_STAT__CE_BUSY__SHIFT                  = 0x0000001a;
constexpr unsigned int CP_STAT__CP_BUSY__SHIFT                  = 0x0000001f;
constexpr unsigned int CP_STAT__DC_BUSY__SHIFT                  = 0x0000000d;
constexpr unsigned int CP_STAT__DMA_BUSY__SHIFT                 = 0x00000016;
constexpr unsigned int CP_STAT__INTERRUPT_BUSY__SHIFT           = 0x00000014;
constexpr unsigned int CP_STAT__MEQ_BUSY__SHIFT                 = 0x00000010;
constexpr unsigned int CP_STAT__ME_BUSY__SHIFT                  = 0x00000011;
constexpr unsigned int CP_STAT__PFP_BUSY__SHIFT                 = 0x0000000f;
constexpr unsigned int CP_STAT__QUERY_BUSY__SHIFT               = 0x00000012;
constexpr unsigned int CP_STAT__RCIU_BUSY__SHIFT                = 0x00000017;
constexpr unsigned int CP_STAT__ROQ_CE_INDIRECT1_BUSY__SHIFT    = 0x0000001d;
constexpr unsigned int CP_STAT__ROQ_CE_INDIRECT2_BUSY__SHIFT    = 0x0000001e;
constexpr unsigned int CP_STAT__ROQ_CE_RING_BUSY__SHIFT         = 0x0000001c;
constexpr unsigned int CP_STAT__ROQ_INDIRECT1_BUSY__SHIFT       = 0x0000000a;
constexpr unsigned int CP_STAT__ROQ_INDIRECT2_BUSY__SHIFT       = 0x0000000b;
constexpr unsigned int CP_STAT__ROQ_RING_BUSY__SHIFT            = 0x00000009;
constexpr unsigned int CP_STAT__ROQ_STATE_BUSY__SHIFT           = 0x0000000c;
constexpr unsigned int CP_STAT__SCRATCH_RAM_BUSY__SHIFT         = 0x00000018;
constexpr unsigned int CP_STAT__SEMAPHORE_BUSY__SHIFT           = 0x00000013;
constexpr unsigned int CP_STAT__SURFACE_SYNC_BUSY__SHIFT        = 0x00000015;
constexpr unsigned int CP_STAT__TCIU_BUSY__SHIFT                = 0x0000001b;
constexpr unsigned int CP_STAT__UTCL2IU_BUSY__SHIFT             = 0x0000000e;
constexpr unsigned int CP_STQ_AVAIL__STQ_CNT__SHIFT             = 0x00000000;
constexpr unsigned int CP_STQ_STAT__STQ_RPTR__SHIFT             = 0x00000000;
constexpr unsigned int CP_STQ_THRESHOLDS__STQ0_START__SHIFT     = 0x00000000;
constexpr unsigned int CP_STQ_THRESHOLDS__STQ1_START__SHIFT     = 0x00000008;
constexpr unsigned int CP_STQ_THRESHOLDS__STQ2_START__SHIFT     = 0x00000010;
constexpr unsigned int CP_STQ_WR_STAT__STQ_WPTR__SHIFT          = 0x00000000;
constexpr unsigned int CP_STREAM_OUT_ADDR_HI__STREAM_OUT_ADDR_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_STREAM_OUT_ADDR_LO__STREAM_OUT_ADDR_LO__SHIFT = 0x00000002;
constexpr unsigned int CP_STREAM_OUT_CONTROL__CACHE_POLICY__SHIFT = 0x00000019;
constexpr unsigned int CP_STRMOUT_CNTL__OFFSET_UPDATE_DONE__SHIFT = 0x00000000;
constexpr unsigned int CP_ST_BASE_HI__ST_BASE_HI__SHIFT         = 0x00000000;
constexpr unsigned int CP_ST_BASE_LO__ST_BASE_LO__SHIFT         = 0x00000002;
constexpr unsigned int CP_ST_BUFSZ__ST_BUFSZ__SHIFT             = 0x00000000;
constexpr unsigned int CP_ST_CMD_BUFSZ__ST_CMD_REQSZ__SHIFT     = 0x00000000;
constexpr unsigned int CP_VGT_CSINVOC_COUNT_HI__CSINVOC_COUNT_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_VGT_CSINVOC_COUNT_LO__CSINVOC_COUNT_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_VGT_DSINVOC_COUNT_HI__DSINVOC_COUNT_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_VGT_DSINVOC_COUNT_LO__DSINVOC_COUNT_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_VGT_GSINVOC_COUNT_HI__GSINVOC_COUNT_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_VGT_GSINVOC_COUNT_LO__GSINVOC_COUNT_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_VGT_GSPRIM_COUNT_HI__GSPRIM_COUNT_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_VGT_GSPRIM_COUNT_LO__GSPRIM_COUNT_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_VGT_HSINVOC_COUNT_HI__HSINVOC_COUNT_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_VGT_HSINVOC_COUNT_LO__HSINVOC_COUNT_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_VGT_IAPRIM_COUNT_HI__IAPRIM_COUNT_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_VGT_IAPRIM_COUNT_LO__IAPRIM_COUNT_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_VGT_IAVERT_COUNT_HI__IAVERT_COUNT_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_VGT_IAVERT_COUNT_LO__IAVERT_COUNT_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_VGT_VSINVOC_COUNT_HI__VSINVOC_COUNT_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_VGT_VSINVOC_COUNT_LO__VSINVOC_COUNT_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_VIRT_STATUS__VIRT_STATUS__SHIFT       = 0x00000000;
constexpr unsigned int CP_VMID_PREEMPT__PREEMPT_REQUEST__SHIFT  = 0x00000000;
constexpr unsigned int CP_VMID_PREEMPT__VIRT_COMMAND__SHIFT     = 0x00000010;
constexpr unsigned int CP_VMID_RESET__RESET_REQUEST__SHIFT      = 0x00000000;
constexpr unsigned int CP_VMID_STATUS__PREEMPT_CE_STATUS__SHIFT = 0x00000010;
constexpr unsigned int CP_VMID_STATUS__PREEMPT_DE_STATUS__SHIFT = 0x00000000;
constexpr unsigned int CP_VMID__VMID__SHIFT                     = 0x00000000;
constexpr unsigned int CP_WAIT_REG_MEM_TIMEOUT__WAIT_REG_MEM_TIMEOUT__SHIFT = 0x00000000;
constexpr unsigned int CP_WAIT_SEM_ADDR_HI__SEM_ADDR_HI__SHIFT  = 0x00000000;
constexpr unsigned int CP_WAIT_SEM_ADDR_HI__SEM_CLIENT_CODE__SHIFT = 0x00000018;
constexpr unsigned int CP_WAIT_SEM_ADDR_HI__SEM_SELECT__SHIFT   = 0x0000001d;
constexpr unsigned int CP_WAIT_SEM_ADDR_HI__SEM_SIGNAL_TYPE__SHIFT = 0x00000014;
constexpr unsigned int CP_WAIT_SEM_ADDR_HI__SEM_USE_MAILBOX__SHIFT = 0x00000010;
constexpr unsigned int CP_WAIT_SEM_ADDR_LO__SEM_ADDR_LO__SHIFT  = 0x00000003;
constexpr unsigned int CSPRIV_CONNECT__DOORBELL_OFFSET__SHIFT   = 0x00000000;
constexpr unsigned int CSPRIV_CONNECT__QSWITCH_MODE__SHIFT      = 0x00000019;
constexpr unsigned int CSPRIV_CONNECT__QUEUE_ID__SHIFT          = 0x00000015;
constexpr unsigned int CSPRIV_CONNECT__RELAUNCH_WAVES__SHIFT    = 0x00000018;
constexpr unsigned int CSPRIV_CONNECT__VMID__SHIFT              = 0x0000001a;
constexpr unsigned int CS_COPY_STATE__SRC_STATE_ID__SHIFT       = 0x00000000;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_OFFSET0__SHIFT = 0x00000008;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_OFFSET1__SHIFT = 0x0000000a;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_OFFSET2__SHIFT = 0x0000000c;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_OFFSET3__SHIFT = 0x0000000e;
constexpr unsigned int DB_ALPHA_TO_MASK__OFFSET_ROUND__SHIFT    = 0x00000010;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__OFF_HYSTERESIS__SHIFT = 0x00000004;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__ON_DELAY__SHIFT      = 0x00000000;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__RESERVED__SHIFT      = 0x0000000c;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE0__SHIFT = 0x0000001f;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE1__SHIFT = 0x0000001e;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE2__SHIFT = 0x0000001d;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE3__SHIFT = 0x0000001c;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE4__SHIFT = 0x0000001b;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE5__SHIFT = 0x0000001a;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE6__SHIFT = 0x00000019;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE7__SHIFT = 0x00000018;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_STALL_OVERRIDE0__SHIFT = 0x00000017;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_STALL_OVERRIDE1__SHIFT = 0x00000016;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_STALL_OVERRIDE2__SHIFT = 0x00000015;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_STALL_OVERRIDE3__SHIFT = 0x00000014;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_STALL_OVERRIDE4__SHIFT = 0x00000013;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_STALL_OVERRIDE5__SHIFT = 0x00000012;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_STALL_OVERRIDE6__SHIFT = 0x00000011;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_STALL_OVERRIDE7__SHIFT = 0x00000010;
constexpr unsigned int DB_COUNT_CONTROL__DBFAIL_ENABLE__SHIFT   = 0x00000014;
constexpr unsigned int DB_COUNT_CONTROL__PERFECT_ZPASS_COUNTS__SHIFT = 0x00000001;
constexpr unsigned int DB_COUNT_CONTROL__SAMPLE_RATE__SHIFT     = 0x00000004;
constexpr unsigned int DB_COUNT_CONTROL__SFAIL_ENABLE__SHIFT    = 0x00000010;
constexpr unsigned int DB_COUNT_CONTROL__SLICE_EVEN_ENABLE__SHIFT = 0x00000018;
constexpr unsigned int DB_COUNT_CONTROL__SLICE_ODD_ENABLE__SHIFT = 0x0000001c;
constexpr unsigned int DB_COUNT_CONTROL__ZFAIL_ENABLE__SHIFT    = 0x0000000c;
constexpr unsigned int DB_COUNT_CONTROL__ZPASS_ENABLE__SHIFT    = 0x00000008;
constexpr unsigned int DB_COUNT_CONTROL__ZPASS_INCREMENT_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int DB_CREDIT_LIMIT__DB_CB_LQUAD_CREDITS__SHIFT = 0x0000000a;
constexpr unsigned int DB_CREDIT_LIMIT__DB_CB_TILE_CREDITS__SHIFT = 0x00000018;
constexpr unsigned int DB_CREDIT_LIMIT__DB_SC_QUAD_CREDITS__SHIFT = 0x00000005;
constexpr unsigned int DB_CREDIT_LIMIT__DB_SC_TILE_CREDITS__SHIFT = 0x00000000;
constexpr unsigned int DB_DEBUG2__ALLOW_COMPZ_BYTE_MASKING__SHIFT = 0x00000000;
constexpr unsigned int DB_DEBUG2__CLK_OFF_DELAY__SHIFT          = 0x00000009;
constexpr unsigned int DB_DEBUG2__DISABLE_DTT_DATA_FORWARDING__SHIFT = 0x00000012;
constexpr unsigned int DB_DEBUG2__DISABLE_NULL_EOT_FORWARDING__SHIFT = 0x00000011;
constexpr unsigned int DB_DEBUG2__DISABLE_PREZL_FIFO_STALL_REZ__SHIFT = 0x00000006;
constexpr unsigned int DB_DEBUG2__DISABLE_PREZL_FIFO_STALL__SHIFT = 0x00000005;
constexpr unsigned int DB_DEBUG2__DISABLE_PREZL_VIEWPORT_STALL__SHIFT = 0x0000001d;
constexpr unsigned int DB_DEBUG2__DISABLE_QUAD_COHERENCY_STALL__SHIFT = 0x00000013;
constexpr unsigned int DB_DEBUG2__DISABLE_SINGLE_STENCIL_QUAD_SUMM__SHIFT = 0x0000001e;
constexpr unsigned int DB_DEBUG2__DISABLE_TC_MASK_L0_CACHE__SHIFT = 0x00000002;
constexpr unsigned int DB_DEBUG2__DISABLE_TC_ZRANGE_L0_CACHE__SHIFT = 0x00000001;
constexpr unsigned int DB_DEBUG2__DISABLE_WRITE_STALL_ON_RDWR_CONFLICT__SHIFT = 0x0000001f;
constexpr unsigned int DB_DEBUG2__DTR_PREZ_STALLS_FOR_ETF_ROOM__SHIFT = 0x00000004;
constexpr unsigned int DB_DEBUG2__DTR_ROUND_ROBIN_ARB__SHIFT    = 0x00000003;
constexpr unsigned int DB_DEBUG2__ENABLE_PREZ_OF_REZ_SUMM__SHIFT = 0x0000001c;
constexpr unsigned int DB_DEBUG2__ENABLE_VIEWPORT_STALL_ON_ALL__SHIFT = 0x00000007;
constexpr unsigned int DB_DEBUG2__OPTIMIZE_HIZ_MATCHES_FB_DISABLE__SHIFT = 0x00000008;
constexpr unsigned int DB_DEBUG3__DISABLE_CLEAR_ZRANGE_CORRECTION__SHIFT = 0x00000000;
constexpr unsigned int DB_DEBUG3__DISABLE_DI_DT_STALL__SHIFT    = 0x00000019;
constexpr unsigned int DB_DEBUG3__DISABLE_EQAA_A2M_PERF_OPT__SHIFT = 0x00000018;
constexpr unsigned int DB_DEBUG3__DISABLE_HIZ_ON_VPORT_CLAMP__SHIFT = 0x00000004;
constexpr unsigned int DB_DEBUG3__DISABLE_HZ_TC_WRITE_COMBINE__SHIFT = 0x00000014;
constexpr unsigned int DB_DEBUG3__DISABLE_OP_DF_BYPASS__SHIFT   = 0x0000000d;
constexpr unsigned int DB_DEBUG3__DISABLE_OP_DF_DIRECT_FEEDBACK__SHIFT = 0x0000000f;
constexpr unsigned int DB_DEBUG3__DISABLE_OP_DF_WRITE_COMBINE__SHIFT = 0x0000000e;
constexpr unsigned int DB_DEBUG3__DISABLE_OP_S_DATA_FORWARDING__SHIFT = 0x00000012;
constexpr unsigned int DB_DEBUG3__DISABLE_OP_Z_DATA_FORWARDING__SHIFT = 0x0000000c;
constexpr unsigned int DB_DEBUG3__DISABLE_OVERRASTERIZATION_FIX__SHIFT = 0x0000001b;
constexpr unsigned int DB_DEBUG3__DISABLE_RAM_READ_SUPPRESION_ON_FWD__SHIFT = 0x00000017;
constexpr unsigned int DB_DEBUG3__DISABLE_RECOMP_TO_1ZPLANE_WITHOUT_FASTOP__SHIFT = 0x0000000a;
constexpr unsigned int DB_DEBUG3__DISABLE_REDUNDANT_PLANE_FLUSHES_OPT__SHIFT = 0x00000009;
constexpr unsigned int DB_DEBUG3__DISABLE_TCP_CAM_BYPASS__SHIFT = 0x00000007;
constexpr unsigned int DB_DEBUG3__DISABLE_TC_UPDATE_WRITE_COMBINE__SHIFT = 0x00000013;
constexpr unsigned int DB_DEBUG3__DISABLE_TL_SSO_NULL_SUPPRESSION__SHIFT = 0x00000003;
constexpr unsigned int DB_DEBUG3__DISABLE_ZCMP_DIRTY_SUPPRESSION__SHIFT = 0x00000008;
constexpr unsigned int DB_DEBUG3__DONT_INSERT_CONTEXT_SUSPEND__SHIFT = 0x0000001c;
constexpr unsigned int DB_DEBUG3__ENABLE_DB_PROCESS_RESET__SHIFT = 0x0000001a;
constexpr unsigned int DB_DEBUG3__ENABLE_INCOHERENT_EQAA_READS__SHIFT = 0x0000000b;
constexpr unsigned int DB_DEBUG3__ENABLE_RECOMP_ZDIRTY_SUPPRESSION_OPT__SHIFT = 0x00000015;
constexpr unsigned int DB_DEBUG3__ENABLE_TC_MA_ROUND_ROBIN_ARB__SHIFT = 0x00000016;
constexpr unsigned int DB_DEBUG3__EQAA_INTERPOLATE_COMP_Z__SHIFT = 0x00000005;
constexpr unsigned int DB_DEBUG3__EQAA_INTERPOLATE_SRC_Z__SHIFT = 0x00000006;
constexpr unsigned int DB_DEBUG3__FORCE_DB_IS_GOOD__SHIFT       = 0x00000002;
constexpr unsigned int DB_DEBUG3__SLOW_PREZ_TO_A2M_OMASK_RATE__SHIFT = 0x00000011;
constexpr unsigned int DB_DEBUG4__DFSM_CONVERT_PASSTHROUGH_TO_BYPASS__SHIFT = 0x00000008;
constexpr unsigned int DB_DEBUG4__DISABLE_DTT_FAST_HTILENACK_LOOKUP__SHIFT = 0x0000000d;
constexpr unsigned int DB_DEBUG4__DISABLE_PREZ_POSTZ_DTILE_CONFLICT_STALL__SHIFT = 0x00000003;
constexpr unsigned int DB_DEBUG4__DISABLE_QC_STENCIL_MASK_SUMMATION__SHIFT = 0x00000001;
constexpr unsigned int DB_DEBUG4__DISABLE_QC_Z_MASK_SUMMATION__SHIFT = 0x00000000;
constexpr unsigned int DB_DEBUG4__DISABLE_RESCHECK_MEMCOHER_OPTIMIZATION__SHIFT = 0x0000000e;
constexpr unsigned int DB_DEBUG4__DISABLE_RESUMM_TO_SINGLE_STENCIL__SHIFT = 0x00000002;
constexpr unsigned int DB_DEBUG4__DISABLE_UNMAPPED_H_INDICATOR__SHIFT = 0x0000000b;
constexpr unsigned int DB_DEBUG4__DISABLE_UNMAPPED_S_INDICATOR__SHIFT = 0x0000000a;
constexpr unsigned int DB_DEBUG4__DISABLE_UNMAPPED_Z_INDICATOR__SHIFT = 0x00000009;
constexpr unsigned int DB_DEBUG__DEBUG_DEPTH_COMPRESS_DISABLE__SHIFT = 0x00000001;
constexpr unsigned int DB_DEBUG__DEBUG_FAST_STENCIL_DISABLE__SHIFT = 0x0000000f;
constexpr unsigned int DB_DEBUG__DEBUG_FAST_Z_DISABLE__SHIFT    = 0x0000000e;
constexpr unsigned int DB_DEBUG__DEBUG_FORCE_DEPTH_READ__SHIFT  = 0x00000006;
constexpr unsigned int DB_DEBUG__DEBUG_FORCE_FULL_Z_RANGE__SHIFT = 0x00000013;
constexpr unsigned int DB_DEBUG__DEBUG_FORCE_HIS_ENABLE0__SHIFT = 0x0000000a;
constexpr unsigned int DB_DEBUG__DEBUG_FORCE_HIS_ENABLE1__SHIFT = 0x0000000c;
constexpr unsigned int DB_DEBUG__DEBUG_FORCE_HIZ_ENABLE__SHIFT  = 0x00000008;
constexpr unsigned int DB_DEBUG__DEBUG_FORCE_STENCIL_READ__SHIFT = 0x00000007;
constexpr unsigned int DB_DEBUG__DEBUG_NOOP_CULL_DISABLE__SHIFT = 0x00000010;
constexpr unsigned int DB_DEBUG__DEBUG_STENCIL_COMPRESS_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int DB_DEBUG__DECOMPRESS_AFTER_N_ZPLANES__SHIFT = 0x00000018;
constexpr unsigned int DB_DEBUG__DEPTH_CACHE_FORCE_MISS__SHIFT  = 0x00000012;
constexpr unsigned int DB_DEBUG__DISABLE_DEPTH_SURFACE_SYNC__SHIFT = 0x0000001e;
constexpr unsigned int DB_DEBUG__DISABLE_HTILE_SURFACE_SYNC__SHIFT = 0x0000001f;
constexpr unsigned int DB_DEBUG__DISABLE_SUMM_SQUADS__SHIFT     = 0x00000011;
constexpr unsigned int DB_DEBUG__DISABLE_VPORT_ZPLANE_OPTIMIZATION__SHIFT = 0x00000017;
constexpr unsigned int DB_DEBUG__FETCH_FULL_STENCIL_TILE__SHIFT = 0x00000003;
constexpr unsigned int DB_DEBUG__FETCH_FULL_Z_TILE__SHIFT       = 0x00000002;
constexpr unsigned int DB_DEBUG__FORCE_MISS_IF_NOT_INFLIGHT__SHIFT = 0x0000001d;
constexpr unsigned int DB_DEBUG__FORCE_Z_MODE__SHIFT            = 0x00000004;
constexpr unsigned int DB_DEBUG__NEVER_FREE_Z_ONLY__SHIFT       = 0x00000015;
constexpr unsigned int DB_DEBUG__ONE_FREE_IN_FLIGHT__SHIFT      = 0x0000001c;
constexpr unsigned int DB_DEBUG__ZPASS_COUNTS_LOOK_AT_PIPE_STAT_EVENTS__SHIFT = 0x00000016;
constexpr unsigned int DB_DEPTH_BOUNDS_MAX__MAX__SHIFT          = 0x00000000;
constexpr unsigned int DB_DEPTH_BOUNDS_MIN__MIN__SHIFT          = 0x00000000;
constexpr unsigned int DB_DEPTH_CLEAR__DEPTH_CLEAR__SHIFT       = 0x00000000;
constexpr unsigned int DB_DEPTH_CONTROL__BACKFACE_ENABLE__SHIFT = 0x00000007;
constexpr unsigned int DB_DEPTH_CONTROL__DEPTH_BOUNDS_ENABLE__SHIFT = 0x00000003;
constexpr unsigned int DB_DEPTH_CONTROL__DISABLE_COLOR_WRITES_ON_DEPTH_PASS__SHIFT = 0x0000001f;
constexpr unsigned int DB_DEPTH_CONTROL__ENABLE_COLOR_WRITES_ON_DEPTH_FAIL__SHIFT = 0x0000001e;
constexpr unsigned int DB_DEPTH_CONTROL__STENCILFUNC_BF__SHIFT  = 0x00000014;
constexpr unsigned int DB_DEPTH_CONTROL__STENCILFUNC__SHIFT     = 0x00000008;
constexpr unsigned int DB_DEPTH_CONTROL__STENCIL_ENABLE__SHIFT  = 0x00000000;
constexpr unsigned int DB_DEPTH_CONTROL__ZFUNC__SHIFT           = 0x00000004;
constexpr unsigned int DB_DEPTH_CONTROL__Z_ENABLE__SHIFT        = 0x00000001;
constexpr unsigned int DB_DEPTH_CONTROL__Z_WRITE_ENABLE__SHIFT  = 0x00000002;
constexpr unsigned int DB_DEPTH_VIEW__MIPID__SHIFT              = 0x0000001a;
constexpr unsigned int DB_DEPTH_VIEW__SLICE_MAX__SHIFT          = 0x0000000d;
constexpr unsigned int DB_DEPTH_VIEW__SLICE_START__SHIFT        = 0x00000000;
constexpr unsigned int DB_DEPTH_VIEW__STENCIL_READ_ONLY__SHIFT  = 0x00000019;
constexpr unsigned int DB_DEPTH_VIEW__Z_READ_ONLY__SHIFT        = 0x00000018;
constexpr unsigned int DB_DFSM_CONFIG__BYPASS_DFSM__SHIFT       = 0x00000000;
constexpr unsigned int DB_DFSM_CONFIG__DISABLE_POPS__SHIFT      = 0x00000002;
constexpr unsigned int DB_DFSM_CONFIG__DISABLE_PUNCHOUT__SHIFT  = 0x00000001;
constexpr unsigned int DB_DFSM_CONFIG__FORCE_FLUSH__SHIFT       = 0x00000003;
constexpr unsigned int DB_DFSM_CONTROL__DISALLOW_OVERFLOW__SHIFT = 0x00000003;
constexpr unsigned int DB_DFSM_CONTROL__POPS_DRAIN_PS_ON_OVERLAP__SHIFT = 0x00000002;
constexpr unsigned int DB_DFSM_CONTROL__PUNCHOUT_MODE__SHIFT    = 0x00000000;
constexpr unsigned int DB_DFSM_FLUSH_AUX_EVENT__EVENT_A__SHIFT  = 0x00000000;
constexpr unsigned int DB_DFSM_FLUSH_AUX_EVENT__EVENT_B__SHIFT  = 0x00000008;
constexpr unsigned int DB_DFSM_FLUSH_AUX_EVENT__EVENT_C__SHIFT  = 0x00000010;
constexpr unsigned int DB_DFSM_FLUSH_AUX_EVENT__EVENT_D__SHIFT  = 0x00000018;
constexpr unsigned int DB_DFSM_FLUSH_ENABLE__AUX_EVENTS__SHIFT  = 0x0000001c;
constexpr unsigned int DB_DFSM_FLUSH_ENABLE__AUX_FORCE_PASSTHRU__SHIFT = 0x00000018;
constexpr unsigned int DB_DFSM_FLUSH_ENABLE__PRIMARY_EVENTS__SHIFT = 0x00000000;
constexpr unsigned int DB_DFSM_PRIMS_IN_FLIGHT__HIGH_WATERMARK__SHIFT = 0x00000000;
constexpr unsigned int DB_DFSM_TILES_IN_FLIGHT__HIGH_WATERMARK__SHIFT = 0x00000000;
constexpr unsigned int DB_DFSM_WATCHDOG__TIMER_TARGET__SHIFT    = 0x00000000;
constexpr unsigned int DB_EQAA__ALPHA_TO_MASK_EQAA_DISABLE__SHIFT = 0x00000015;
constexpr unsigned int DB_EQAA__ALPHA_TO_MASK_NUM_SAMPLES__SHIFT = 0x0000000c;
constexpr unsigned int DB_EQAA__ENABLE_POSTZ_OVERRASTERIZATION__SHIFT = 0x0000001b;
constexpr unsigned int DB_EQAA__HIGH_QUALITY_INTERSECTIONS__SHIFT = 0x00000010;
constexpr unsigned int DB_EQAA__INCOHERENT_EQAA_READS__SHIFT    = 0x00000011;
constexpr unsigned int DB_EQAA__INTERPOLATE_COMP_Z__SHIFT       = 0x00000012;
constexpr unsigned int DB_EQAA__INTERPOLATE_SRC_Z__SHIFT        = 0x00000013;
constexpr unsigned int DB_EQAA__MASK_EXPORT_NUM_SAMPLES__SHIFT  = 0x00000008;
constexpr unsigned int DB_EQAA__MAX_ANCHOR_SAMPLES__SHIFT       = 0x00000000;
constexpr unsigned int DB_EQAA__OVERRASTERIZATION_AMOUNT__SHIFT = 0x00000018;
constexpr unsigned int DB_EQAA__PS_ITER_SAMPLES__SHIFT          = 0x00000004;
constexpr unsigned int DB_EQAA__STATIC_ANCHOR_ASSOCIATIONS__SHIFT = 0x00000014;
constexpr unsigned int DB_EXCEPTION_CONTROL__EARLY_Z_PANIC_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int DB_EXCEPTION_CONTROL__LATE_Z_PANIC_DISABLE__SHIFT = 0x00000001;
constexpr unsigned int DB_EXCEPTION_CONTROL__RE_Z_PANIC_DISABLE__SHIFT = 0x00000002;
constexpr unsigned int DB_FIFO_DEPTH2__EQUAD_FIFO_DEPTH__SHIFT  = 0x00000000;
constexpr unsigned int DB_FIFO_DEPTH2__ETILE_OP_FIFO_DEPTH__SHIFT = 0x00000008;
constexpr unsigned int DB_FIFO_DEPTH2__LTILE_OP_FIFO_DEPTH__SHIFT = 0x00000019;
constexpr unsigned int DB_FREE_CACHELINES__FREE_DTILE_DEPTH__SHIFT = 0x00000000;
constexpr unsigned int DB_HTILE_DATA_BASE_HI__BASE_HI__SHIFT    = 0x00000000;
constexpr unsigned int DB_HTILE_DATA_BASE__BASE_256B__SHIFT     = 0x00000000;
constexpr unsigned int DB_HTILE_SURFACE__DST_OUTSIDE_ZERO_TO_ONE__SHIFT = 0x00000010;
constexpr unsigned int DB_HTILE_SURFACE__FULL_CACHE__SHIFT      = 0x00000001;
constexpr unsigned int DB_HTILE_SURFACE__PIPE_ALIGNED__SHIFT    = 0x00000012;
constexpr unsigned int DB_MEM_ARB_WATERMARKS__CLIENT0_WATERMARK__SHIFT = 0x00000000;
constexpr unsigned int DB_MEM_ARB_WATERMARKS__CLIENT1_WATERMARK__SHIFT = 0x00000008;
constexpr unsigned int DB_MEM_ARB_WATERMARKS__CLIENT2_WATERMARK__SHIFT = 0x00000010;
constexpr unsigned int DB_MEM_ARB_WATERMARKS__CLIENT3_WATERMARK__SHIFT = 0x00000018;
constexpr unsigned int DB_OCCLUSION_COUNT0_HI__COUNT_HI__SHIFT  = 0x00000000;
constexpr unsigned int DB_OCCLUSION_COUNT0_LOW__COUNT_LOW__SHIFT = 0x00000000;
constexpr unsigned int DB_OCCLUSION_COUNT1_HI__COUNT_HI__SHIFT  = 0x00000000;
constexpr unsigned int DB_OCCLUSION_COUNT1_LOW__COUNT_LOW__SHIFT = 0x00000000;
constexpr unsigned int DB_OCCLUSION_COUNT2_HI__COUNT_HI__SHIFT  = 0x00000000;
constexpr unsigned int DB_OCCLUSION_COUNT2_LOW__COUNT_LOW__SHIFT = 0x00000000;
constexpr unsigned int DB_OCCLUSION_COUNT3_HI__COUNT_HI__SHIFT  = 0x00000000;
constexpr unsigned int DB_OCCLUSION_COUNT3_LOW__COUNT_LOW__SHIFT = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
constexpr unsigned int DB_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
constexpr unsigned int DB_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT  = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
constexpr unsigned int DB_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
constexpr unsigned int DB_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT = 0x00000018;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT  = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT = 0x00000018;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT  = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT = 0x00000018;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT  = 0x00000000;
constexpr unsigned int DB_PRELOAD_CONTROL__MAX_X__SHIFT         = 0x00000010;
constexpr unsigned int DB_PRELOAD_CONTROL__MAX_Y__SHIFT         = 0x00000018;
constexpr unsigned int DB_PRELOAD_CONTROL__START_X__SHIFT       = 0x00000000;
constexpr unsigned int DB_PRELOAD_CONTROL__START_Y__SHIFT       = 0x00000008;
constexpr unsigned int DB_READ_DEBUG_3__DEBUG_DATA__SHIFT       = 0x00000000;
constexpr unsigned int DB_READ_DEBUG_4__DEBUG_DATA__SHIFT       = 0x00000000;
constexpr unsigned int DB_READ_DEBUG_5__DEBUG_DATA__SHIFT       = 0x00000000;
constexpr unsigned int DB_READ_DEBUG_6__DEBUG_DATA__SHIFT       = 0x00000000;
constexpr unsigned int DB_READ_DEBUG_7__DEBUG_DATA__SHIFT       = 0x00000000;
constexpr unsigned int DB_READ_DEBUG_8__DEBUG_DATA__SHIFT       = 0x00000000;
constexpr unsigned int DB_READ_DEBUG_9__DEBUG_DATA__SHIFT       = 0x00000000;
constexpr unsigned int DB_READ_DEBUG_A__DEBUG_DATA__SHIFT       = 0x00000000;
constexpr unsigned int DB_READ_DEBUG_B__DEBUG_DATA__SHIFT       = 0x00000000;
constexpr unsigned int DB_READ_DEBUG_C__DEBUG_DATA__SHIFT       = 0x00000000;
constexpr unsigned int DB_READ_DEBUG_D__DEBUG_DATA__SHIFT       = 0x00000000;
constexpr unsigned int DB_READ_DEBUG_E__DEBUG_DATA__SHIFT       = 0x00000000;
constexpr unsigned int DB_READ_DEBUG_F__DEBUG_DATA__SHIFT       = 0x00000000;
constexpr unsigned int DB_RENDER_CONTROL__COPY_CENTROID__SHIFT  = 0x00000007;
constexpr unsigned int DB_RENDER_CONTROL__COPY_SAMPLE__SHIFT    = 0x00000008;
constexpr unsigned int DB_RENDER_CONTROL__DECOMPRESS_ENABLE__SHIFT = 0x0000000c;
constexpr unsigned int DB_RENDER_CONTROL__DEPTH_CLEAR_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int DB_RENDER_CONTROL__DEPTH_COMPRESS_DISABLE__SHIFT = 0x00000006;
constexpr unsigned int DB_RENDER_CONTROL__DEPTH_COPY__SHIFT     = 0x00000002;
constexpr unsigned int DB_RENDER_CONTROL__RESUMMARIZE_ENABLE__SHIFT = 0x00000004;
constexpr unsigned int DB_RENDER_CONTROL__STENCIL_CLEAR_ENABLE__SHIFT = 0x00000001;
constexpr unsigned int DB_RENDER_CONTROL__STENCIL_COMPRESS_DISABLE__SHIFT = 0x00000005;
constexpr unsigned int DB_RENDER_CONTROL__STENCIL_COPY__SHIFT   = 0x00000003;
constexpr unsigned int DB_RENDER_OVERRIDE2__ALLOW_PARTIAL_RES_HIER_KILL__SHIFT = 0x00000019;
constexpr unsigned int DB_RENDER_OVERRIDE2__DECOMPRESS_Z_ON_FLUSH__SHIFT = 0x00000008;
constexpr unsigned int DB_RENDER_OVERRIDE2__DEPTH_BOUNDS_HIER_DEPTH_DISABLE__SHIFT = 0x0000000a;
constexpr unsigned int DB_RENDER_OVERRIDE2__DISABLE_COLOR_ON_VALIDATION__SHIFT = 0x00000007;
constexpr unsigned int DB_RENDER_OVERRIDE2__DISABLE_FAST_PASS__SHIFT = 0x00000017;
constexpr unsigned int DB_RENDER_OVERRIDE2__DISABLE_REG_SNOOP__SHIFT = 0x00000009;
constexpr unsigned int DB_RENDER_OVERRIDE2__DISABLE_SMEM_EXPCLEAR_OPTIMIZATION__SHIFT = 0x00000006;
constexpr unsigned int DB_RENDER_OVERRIDE2__DISABLE_ZMASK_EXPCLEAR_OPTIMIZATION__SHIFT = 0x00000005;
constexpr unsigned int DB_RENDER_OVERRIDE2__HIS_SFUNC_BF__SHIFT = 0x00000012;
constexpr unsigned int DB_RENDER_OVERRIDE2__HIS_SFUNC_FF__SHIFT = 0x0000000f;
constexpr unsigned int DB_RENDER_OVERRIDE2__HIZ_ZFUNC__SHIFT    = 0x0000000c;
constexpr unsigned int DB_RENDER_OVERRIDE2__PARTIAL_SQUAD_LAUNCH_CONTROL__SHIFT = 0x00000000;
constexpr unsigned int DB_RENDER_OVERRIDE2__PARTIAL_SQUAD_LAUNCH_COUNTDOWN__SHIFT = 0x00000002;
constexpr unsigned int DB_RENDER_OVERRIDE2__PRESERVE_SRESULTS__SHIFT = 0x00000016;
constexpr unsigned int DB_RENDER_OVERRIDE2__PRESERVE_ZRANGE__SHIFT = 0x00000015;
constexpr unsigned int DB_RENDER_OVERRIDE2__SEPARATE_HIZS_FUNC_ENABLE__SHIFT = 0x0000000b;
constexpr unsigned int DB_RENDER_OVERRIDE__DISABLE_FULLY_COVERED__SHIFT = 0x00000012;
constexpr unsigned int DB_RENDER_OVERRIDE__DISABLE_TILE_RATE_TILES__SHIFT = 0x0000001a;
constexpr unsigned int DB_RENDER_OVERRIDE__DISABLE_VIEWPORT_CLAMP__SHIFT = 0x00000010;
constexpr unsigned int DB_RENDER_OVERRIDE__FAST_STENCIL_DISABLE__SHIFT = 0x00000008;
constexpr unsigned int DB_RENDER_OVERRIDE__FAST_Z_DISABLE__SHIFT = 0x00000007;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_COLOR_KILL__SHIFT = 0x0000000a;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_FULL_Z_RANGE__SHIFT = 0x0000000d;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_HIS_ENABLE0__SHIFT = 0x00000002;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_HIS_ENABLE1__SHIFT = 0x00000004;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_HIZ_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_QC_SMASK_CONFLICT__SHIFT = 0x0000000f;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_SHADER_Z_ORDER__SHIFT = 0x00000006;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_STENCIL_DIRTY__SHIFT = 0x0000001c;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_STENCIL_READ__SHIFT = 0x0000000c;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_STENCIL_VALID__SHIFT = 0x0000001e;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_Z_DIRTY__SHIFT = 0x0000001b;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_Z_LIMIT_SUMM__SHIFT = 0x00000013;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_Z_READ__SHIFT  = 0x0000000b;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_Z_VALID__SHIFT = 0x0000001d;
constexpr unsigned int DB_RENDER_OVERRIDE__IGNORE_SC_ZRANGE__SHIFT = 0x00000011;
constexpr unsigned int DB_RENDER_OVERRIDE__MAX_TILES_IN_DTT__SHIFT = 0x00000015;
constexpr unsigned int DB_RENDER_OVERRIDE__NOOP_CULL_DISABLE__SHIFT = 0x00000009;
constexpr unsigned int DB_RENDER_OVERRIDE__PRESERVE_COMPRESSION__SHIFT = 0x0000001f;
constexpr unsigned int DB_RING_CONTROL__COUNTER_CONTROL__SHIFT  = 0x00000000;
constexpr unsigned int DB_SHADER_CONTROL__ALPHA_TO_MASK_DISABLE__SHIFT = 0x0000000b;
constexpr unsigned int DB_SHADER_CONTROL__CONSERVATIVE_Z_EXPORT__SHIFT = 0x0000000d;
constexpr unsigned int DB_SHADER_CONTROL__COVERAGE_TO_MASK_ENABLE__SHIFT = 0x00000007;
constexpr unsigned int DB_SHADER_CONTROL__DEPTH_BEFORE_SHADER__SHIFT = 0x0000000c;
constexpr unsigned int DB_SHADER_CONTROL__DUAL_QUAD_DISABLE__SHIFT = 0x0000000f;
constexpr unsigned int DB_SHADER_CONTROL__EXEC_IF_OVERLAPPED__SHIFT = 0x00000011;
constexpr unsigned int DB_SHADER_CONTROL__EXEC_ON_HIER_FAIL__SHIFT = 0x00000009;
constexpr unsigned int DB_SHADER_CONTROL__EXEC_ON_NOOP__SHIFT   = 0x0000000a;
constexpr unsigned int DB_SHADER_CONTROL__KILL_ENABLE__SHIFT    = 0x00000006;
constexpr unsigned int DB_SHADER_CONTROL__MASK_EXPORT_ENABLE__SHIFT = 0x00000008;
constexpr unsigned int DB_SHADER_CONTROL__POPS_OVERLAP_NUM_SAMPLES__SHIFT = 0x00000014;
constexpr unsigned int DB_SHADER_CONTROL__PRIMITIVE_ORDERED_PIXEL_SHADER__SHIFT = 0x00000010;
constexpr unsigned int DB_SHADER_CONTROL__STENCIL_OP_VAL_EXPORT_ENABLE__SHIFT = 0x00000002;
constexpr unsigned int DB_SHADER_CONTROL__STENCIL_TEST_VAL_EXPORT_ENABLE__SHIFT = 0x00000001;
constexpr unsigned int DB_SHADER_CONTROL__Z_EXPORT_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int DB_SHADER_CONTROL__Z_ORDER__SHIFT        = 0x00000004;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE0__COMPAREFUNC0__SHIFT = 0x00000000;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE0__COMPAREMASK0__SHIFT = 0x0000000c;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE0__COMPAREVALUE0__SHIFT = 0x00000004;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE0__ENABLE0__SHIFT = 0x00000018;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE1__COMPAREFUNC1__SHIFT = 0x00000000;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE1__COMPAREMASK1__SHIFT = 0x0000000c;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE1__COMPAREVALUE1__SHIFT = 0x00000004;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE1__ENABLE1__SHIFT = 0x00000018;
constexpr unsigned int DB_STENCILREFMASK_BF__STENCILMASK_BF__SHIFT = 0x00000008;
constexpr unsigned int DB_STENCILREFMASK_BF__STENCILOPVAL_BF__SHIFT = 0x00000018;
constexpr unsigned int DB_STENCILREFMASK_BF__STENCILTESTVAL_BF__SHIFT = 0x00000000;
constexpr unsigned int DB_STENCILREFMASK_BF__STENCILWRITEMASK_BF__SHIFT = 0x00000010;
constexpr unsigned int DB_STENCILREFMASK__STENCILMASK__SHIFT    = 0x00000008;
constexpr unsigned int DB_STENCILREFMASK__STENCILOPVAL__SHIFT   = 0x00000018;
constexpr unsigned int DB_STENCILREFMASK__STENCILTESTVAL__SHIFT = 0x00000000;
constexpr unsigned int DB_STENCILREFMASK__STENCILWRITEMASK__SHIFT = 0x00000010;
constexpr unsigned int DB_STENCIL_CLEAR__CLEAR__SHIFT           = 0x00000000;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILFAIL_BF__SHIFT = 0x0000000c;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILFAIL__SHIFT   = 0x00000000;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILZFAIL_BF__SHIFT = 0x00000014;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILZFAIL__SHIFT  = 0x00000008;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILZPASS_BF__SHIFT = 0x00000010;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILZPASS__SHIFT  = 0x00000004;
constexpr unsigned int DB_STENCIL_INFO__ALLOW_EXPCLEAR__SHIFT   = 0x0000001b;
constexpr unsigned int DB_STENCIL_INFO__FORMAT__SHIFT           = 0x00000000;
constexpr unsigned int DB_STENCIL_INFO__PARTIALLY_RESIDENT__SHIFT = 0x0000000c;
constexpr unsigned int DB_STENCIL_INFO__SW_MODE__SHIFT          = 0x00000004;
constexpr unsigned int DB_STENCIL_INFO__TILE_STENCIL_DISABLE__SHIFT = 0x0000001d;
constexpr unsigned int DB_STENCIL_READ_BASE_HI__BASE_HI__SHIFT  = 0x00000000;
constexpr unsigned int DB_STENCIL_READ_BASE__BASE_256B__SHIFT   = 0x00000000;
constexpr unsigned int DB_STENCIL_WRITE_BASE_HI__BASE_HI__SHIFT = 0x00000000;
constexpr unsigned int DB_STENCIL_WRITE_BASE__BASE_256B__SHIFT  = 0x00000000;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA1_X__SHIFT       = 0x00000000;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA1_Y__SHIFT       = 0x00000002;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA2_X__SHIFT       = 0x00000004;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA2_Y__SHIFT       = 0x00000006;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA4_X__SHIFT       = 0x00000008;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA4_Y__SHIFT       = 0x0000000a;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA8_X__SHIFT       = 0x0000000c;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA8_Y__SHIFT       = 0x0000000e;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA16_X__SHIFT      = 0x00000010;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA16_Y__SHIFT      = 0x00000012;
constexpr unsigned int DB_WATERMARKS__DEPTH_FREE__SHIFT         = 0x00000000;
constexpr unsigned int DB_ZPASS_COUNT_HI__COUNT_HI__SHIFT       = 0x00000000;
constexpr unsigned int DB_ZPASS_COUNT_LOW__COUNT_LOW__SHIFT     = 0x00000000;
constexpr unsigned int DB_Z_INFO__ALLOW_EXPCLEAR__SHIFT         = 0x0000001b;
constexpr unsigned int DB_Z_INFO__DECOMPRESS_ON_N_ZPLANES__SHIFT = 0x00000017;
constexpr unsigned int DB_Z_INFO__FORMAT__SHIFT                 = 0x00000000;
constexpr unsigned int DB_Z_INFO__MAXMIP__SHIFT                 = 0x00000010;
constexpr unsigned int DB_Z_INFO__NUM_SAMPLES__SHIFT            = 0x00000002;
constexpr unsigned int DB_Z_INFO__PARTIALLY_RESIDENT__SHIFT     = 0x0000000c;
constexpr unsigned int DB_Z_INFO__READ_SIZE__SHIFT              = 0x0000001c;
constexpr unsigned int DB_Z_INFO__SW_MODE__SHIFT                = 0x00000004;
constexpr unsigned int DB_Z_INFO__TILE_SURFACE_ENABLE__SHIFT    = 0x0000001d;
constexpr unsigned int DB_Z_INFO__ZRANGE_PRECISION__SHIFT       = 0x0000001f;
constexpr unsigned int DB_Z_READ_BASE_HI__BASE_HI__SHIFT        = 0x00000000;
constexpr unsigned int DB_Z_READ_BASE__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int DB_Z_WRITE_BASE_HI__BASE_HI__SHIFT       = 0x00000000;
constexpr unsigned int DB_Z_WRITE_BASE__BASE_256B__SHIFT        = 0x00000000;
constexpr unsigned int DEBUG_DATA__DEBUG_DATA__SHIFT            = 0x00000000;
constexpr unsigned int DEBUG_INDEX__DEBUG_INDEX__SHIFT          = 0x00000000;
constexpr unsigned int GB_ADDR_CONFIG_READ__MAX_COMPRESSED_FRAGS__SHIFT = 0x00000006;
constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_PIPES__SHIFT    = 0x00000000;
constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_RB_PER_SE__SHIFT = 0x0000001a;
constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_SHADER_ENGINES__SHIFT = 0x00000013;
constexpr unsigned int GB_ADDR_CONFIG_READ__PIPE_INTERLEAVE_SIZE__SHIFT = 0x00000003;
constexpr unsigned int GB_ADDR_CONFIG__MAX_COMPRESSED_FRAGS__SHIFT = 0x00000006;
constexpr unsigned int GB_ADDR_CONFIG__NUM_PIPES__SHIFT         = 0x00000000;
constexpr unsigned int GB_ADDR_CONFIG__NUM_RB_PER_SE__SHIFT     = 0x0000001a;
constexpr unsigned int GB_ADDR_CONFIG__NUM_SHADER_ENGINES__SHIFT = 0x00000013;
constexpr unsigned int GB_ADDR_CONFIG__PIPE_INTERLEAVE_SIZE__SHIFT = 0x00000003;
constexpr unsigned int GB_BACKEND_MAP__BACKEND_MAP__SHIFT       = 0x00000000;
constexpr unsigned int GB_EDC_MODE__BYPASS__SHIFT               = 0x0000001f;
constexpr unsigned int GB_EDC_MODE__COUNT_FED_OUT__SHIFT        = 0x00000010;
constexpr unsigned int GB_EDC_MODE__DED_MODE__SHIFT             = 0x00000014;
constexpr unsigned int GB_EDC_MODE__FORCE_SEC_ON_DED__SHIFT     = 0x0000000f;
constexpr unsigned int GB_EDC_MODE__GATE_FUE__SHIFT             = 0x00000011;
constexpr unsigned int GB_EDC_MODE__PROP_FED__SHIFT             = 0x0000001d;
constexpr unsigned int GB_GPU_ID__GPU_ID__SHIFT                 = 0x00000000;
constexpr unsigned int GCEA_PERFCOUNTER0_CFG__CLEAR__SHIFT      = 0x0000001d;
constexpr unsigned int GCEA_PERFCOUNTER0_CFG__ENABLE__SHIFT     = 0x0000001c;
constexpr unsigned int GCEA_PERFCOUNTER0_CFG__PERF_MODE__SHIFT  = 0x00000018;
constexpr unsigned int GCEA_PERFCOUNTER0_CFG__PERF_SEL_END__SHIFT = 0x00000008;
constexpr unsigned int GCEA_PERFCOUNTER0_CFG__PERF_SEL__SHIFT   = 0x00000000;
constexpr unsigned int GCEA_PERFCOUNTER1_CFG__CLEAR__SHIFT      = 0x0000001d;
constexpr unsigned int GCEA_PERFCOUNTER1_CFG__ENABLE__SHIFT     = 0x0000001c;
constexpr unsigned int GCEA_PERFCOUNTER1_CFG__PERF_MODE__SHIFT  = 0x00000018;
constexpr unsigned int GCEA_PERFCOUNTER1_CFG__PERF_SEL_END__SHIFT = 0x00000008;
constexpr unsigned int GCEA_PERFCOUNTER1_CFG__PERF_SEL__SHIFT   = 0x00000000;
constexpr unsigned int GCEA_PERFCOUNTER_HI__COMPARE_VALUE__SHIFT = 0x00000010;
constexpr unsigned int GCEA_PERFCOUNTER_HI__COUNTER_HI__SHIFT   = 0x00000000;
constexpr unsigned int GCEA_PERFCOUNTER_LO__COUNTER_LO__SHIFT   = 0x00000000;
constexpr unsigned int GCEA_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL__SHIFT = 0x00000019;
constexpr unsigned int GCEA_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY__SHIFT = 0x00000018;
constexpr unsigned int GCEA_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT__SHIFT = 0x00000000;
constexpr unsigned int GCEA_PERFCOUNTER_RSLT_CNTL__START_TRIGGER__SHIFT = 0x00000008;
constexpr unsigned int GCEA_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE__SHIFT = 0x0000001a;
constexpr unsigned int GCEA_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_ACC_BCI0__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_CB0__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_CB1__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_CB2__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_CB3__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_CP0__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_CP1__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_CP2__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_CU0__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_DB0__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_DB1__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_DB2__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_DB3__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_EA0__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_EA1__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_EA2__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_EA3__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_EA4__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_EA5__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_GDS0__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_GDS1__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_GDS2__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_GDS3__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_LDS0__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_LDS1__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_LDS2__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_LDS3__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_PA0__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_PA1__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_PC0__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_RMI0__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SC0__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SPI0__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SPI1__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SPI2__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SPI3__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SPI4__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SPI5__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SQ0_LOWER__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SQ0_UPPER__ACCUMULATOR_39_32__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SQ1_LOWER__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SQ1_UPPER__ACCUMULATOR_39_32__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SQ2_LOWER__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SQ2_UPPER__ACCUMULATOR_39_32__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SQ3_LOWER__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SQ3_UPPER__ACCUMULATOR_39_32__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SQ4_LOWER__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SQ4_UPPER__ACCUMULATOR_39_32__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SQ5_LOWER__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SQ5_UPPER__ACCUMULATOR_39_32__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SQ6_LOWER__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SQ6_UPPER__ACCUMULATOR_39_32__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SQ7_LOWER__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SQ7_UPPER__ACCUMULATOR_39_32__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SQ8_LOWER__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SQ8_UPPER__ACCUMULATOR_39_32__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SX0__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_SXRB0__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_TA0__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_TCP0__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_TCP1__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_TCP2__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_TCP3__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_TCP4__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_TD0__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_TD1__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_TD2__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_TD3__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_TD4__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_TD5__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_ATCL20__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_ATCL21__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_ATCL22__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_ATCL23__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_ATCL24__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_ROUTER0__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_ROUTER1__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_ROUTER2__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_ROUTER3__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_ROUTER4__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_ROUTER5__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_ROUTER6__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_ROUTER7__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_ROUTER8__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_ROUTER9__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_VML20__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_VML21__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_VML22__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_VML23__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_VML24__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_WALKER0__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_WALKER1__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_WALKER2__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_WALKER3__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_ACC_UTCL2_WALKER4__ACCUMULATOR_31_0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_AGGR_LOWER__AGGR_31_0__SHIFT      = 0x00000000;
constexpr unsigned int GC_CAC_AGGR_UPPER__AGGR_63_32__SHIFT     = 0x00000000;
constexpr unsigned int GC_CAC_CGTT_CLK_CTRL__OFF_HYSTERESIS__SHIFT = 0x00000004;
constexpr unsigned int GC_CAC_CGTT_CLK_CTRL__ON_DELAY__SHIFT    = 0x00000000;
constexpr unsigned int GC_CAC_CGTT_CLK_CTRL__SOFT_OVERRIDE_DYN__SHIFT = 0x0000001e;
constexpr unsigned int GC_CAC_CGTT_CLK_CTRL__SOFT_OVERRIDE_REG__SHIFT = 0x0000001f;
constexpr unsigned int GC_CAC_CNTL__CAC_THRESHOLD__SHIFT        = 0x00000001;
constexpr unsigned int GC_CAC_CTRL_1__CAC_WINDOW__SHIFT         = 0x00000000;
constexpr unsigned int GC_CAC_CTRL_1__TDP_WINDOW__SHIFT         = 0x00000018;
constexpr unsigned int GC_CAC_CTRL_2__CAC_ENABLE__SHIFT         = 0x00000000;
constexpr unsigned int GC_CAC_CTRL_2__CAC_SOFT_CTRL_ENABLE__SHIFT = 0x00000001;
constexpr unsigned int GC_CAC_IND_DATA__GC_CAC_IND_DATA__SHIFT  = 0x00000000;
constexpr unsigned int GC_CAC_IND_INDEX__GC_CAC_IND_ADDR__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_OVRD_BCI__OVRRD_SELECT__SHIFT     = 0x00000000;
constexpr unsigned int GC_CAC_OVRD_CB__OVRRD_SELECT__SHIFT      = 0x00000000;
constexpr unsigned int GC_CAC_OVRD_CP__OVRRD_SELECT__SHIFT      = 0x00000000;
constexpr unsigned int GC_CAC_OVRD_CP__OVRRD_VALUE__SHIFT       = 0x00000003;
constexpr unsigned int GC_CAC_OVRD_CU__OVRRD_SELECT__SHIFT      = 0x00000000;
constexpr unsigned int GC_CAC_OVRD_CU__OVRRD_VALUE__SHIFT       = 0x00000001;
constexpr unsigned int GC_CAC_OVRD_DB__OVRRD_SELECT__SHIFT      = 0x00000000;
constexpr unsigned int GC_CAC_OVRD_EA__OVRRD_SELECT__SHIFT      = 0x00000000;
constexpr unsigned int GC_CAC_OVRD_EA__OVRRD_VALUE__SHIFT       = 0x00000006;
constexpr unsigned int GC_CAC_OVRD_GDS__OVRRD_SELECT__SHIFT     = 0x00000000;
constexpr unsigned int GC_CAC_OVRD_LDS__OVRRD_SELECT__SHIFT     = 0x00000000;
constexpr unsigned int GC_CAC_OVRD_PA__OVRRD_SELECT__SHIFT      = 0x00000000;
constexpr unsigned int GC_CAC_OVRD_PC__OVRRD_SELECT__SHIFT      = 0x00000000;
constexpr unsigned int GC_CAC_OVRD_PC__OVRRD_VALUE__SHIFT       = 0x00000001;
constexpr unsigned int GC_CAC_OVRD_RMI__OVRRD_SELECT__SHIFT     = 0x00000000;
constexpr unsigned int GC_CAC_OVRD_SC__OVRRD_SELECT__SHIFT      = 0x00000000;
constexpr unsigned int GC_CAC_OVRD_SPI__OVRRD_SELECT__SHIFT     = 0x00000000;
constexpr unsigned int GC_CAC_OVRD_SPI__OVRRD_VALUE__SHIFT      = 0x00000006;
constexpr unsigned int GC_CAC_OVRD_SQ__OVRRD_SELECT__SHIFT      = 0x00000000;
constexpr unsigned int GC_CAC_OVRD_SXRB__OVRRD_SELECT__SHIFT    = 0x00000000;
constexpr unsigned int GC_CAC_OVRD_SXRB__OVRRD_VALUE__SHIFT     = 0x00000001;
constexpr unsigned int GC_CAC_OVRD_SX__OVRRD_SELECT__SHIFT      = 0x00000000;
constexpr unsigned int GC_CAC_OVRD_SX__OVRRD_VALUE__SHIFT       = 0x00000001;
constexpr unsigned int GC_CAC_OVRD_TA__OVRRD_SELECT__SHIFT      = 0x00000000;
constexpr unsigned int GC_CAC_OVRD_TA__OVRRD_VALUE__SHIFT       = 0x00000001;
constexpr unsigned int GC_CAC_OVRD_TCP__OVRRD_SELECT__SHIFT     = 0x00000000;
constexpr unsigned int GC_CAC_OVRD_TD__OVRRD_SELECT__SHIFT      = 0x00000000;
constexpr unsigned int GC_CAC_OVRD_UTCL2_ATCL2__OVRRD_SELECT__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_OVRD_UTCL2_ATCL2__OVRRD_VALUE__SHIFT = 0x00000005;
constexpr unsigned int GC_CAC_OVRD_UTCL2_ROUTER__OVRRD_SELECT__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_OVRD_UTCL2_ROUTER__OVRRD_VALUE__SHIFT = 0x0000000a;
constexpr unsigned int GC_CAC_OVRD_UTCL2_VML2__OVRRD_SELECT__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_OVRD_UTCL2_VML2__OVRRD_VALUE__SHIFT = 0x00000005;
constexpr unsigned int GC_CAC_OVRD_UTCL2_WALKER__OVRRD_SELECT__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_OVRD_UTCL2_WALKER__OVRRD_VALUE__SHIFT = 0x00000005;
constexpr unsigned int GC_CAC_OVR_SEL__CAC_OVR_SEL__SHIFT       = 0x00000000;
constexpr unsigned int GC_CAC_OVR_VAL__CAC_OVR_VAL__SHIFT       = 0x00000000;
constexpr unsigned int GC_CAC_SOFT_CTRL__SOFT_SNAP__SHIFT       = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_BCI_0__WEIGHT_BCI_SIG0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_CB_0__WEIGHT_CB_SIG0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_CB_0__WEIGHT_CB_SIG1__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_CB_1__WEIGHT_CB_SIG2__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_CB_1__WEIGHT_CB_SIG3__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_CP_0__WEIGHT_CP_SIG0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_CP_0__WEIGHT_CP_SIG1__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_CP_1__WEIGHT_CP_SIG2__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_CU_0__WEIGHT_CU_SIG0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_DB_0__WEIGHT_DB_SIG0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_DB_0__WEIGHT_DB_SIG1__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_DB_1__WEIGHT_DB_SIG2__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_DB_1__WEIGHT_DB_SIG3__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_EA_0__WEIGHT_EA_SIG0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_EA_0__WEIGHT_EA_SIG1__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_EA_1__WEIGHT_EA_SIG2__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_EA_1__WEIGHT_EA_SIG3__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_EA_2__WEIGHT_EA_SIG4__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_EA_2__WEIGHT_EA_SIG5__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_LDS_0__WEIGHT_LDS_SIG0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_LDS_0__WEIGHT_LDS_SIG1__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_LDS_1__WEIGHT_LDS_SIG2__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_LDS_1__WEIGHT_LDS_SIG3__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_PA_0__WEIGHT_PA_SIG0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_PA_0__WEIGHT_PA_SIG1__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_PC_0__WEIGHT_PC_SIG0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_RMI_0__WEIGHT_RMI_SIG0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_SC_0__WEIGHT_SC_SIG0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_SPI_0__WEIGHT_SPI_SIG0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_SPI_0__WEIGHT_SPI_SIG1__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_SPI_1__WEIGHT_SPI_SIG2__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_SPI_1__WEIGHT_SPI_SIG3__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_SPI_2__WEIGHT_SPI_SIG4__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_SPI_2__WEIGHT_SPI_SIG5__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_SQ_0__WEIGHT_SQ_SIG0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_SQ_0__WEIGHT_SQ_SIG1__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_SQ_1__WEIGHT_SQ_SIG2__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_SQ_1__WEIGHT_SQ_SIG3__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_SQ_2__WEIGHT_SQ_SIG4__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_SQ_2__WEIGHT_SQ_SIG5__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_SXRB_0__WEIGHT_SXRB_SIG0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_SX_0__WEIGHT_SX_SIG0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_TA_0__WEIGHT_TA_SIG0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_TD_0__WEIGHT_TD_SIG0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_TD_0__WEIGHT_TD_SIG1__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_TD_1__WEIGHT_TD_SIG2__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_TD_1__WEIGHT_TD_SIG3__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_TD_2__WEIGHT_TD_SIG4__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_TD_2__WEIGHT_TD_SIG5__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ATCL2_0__WEIGHT_UTCL2_ATCL2_SIG0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ATCL2_0__WEIGHT_UTCL2_ATCL2_SIG1__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ATCL2_1__WEIGHT_UTCL2_ATCL2_SIG2__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ATCL2_1__WEIGHT_UTCL2_ATCL2_SIG3__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ATCL2_2__WEIGHT_UTCL2_ATCL2_SIG4__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ROUTER_0__WEIGHT_UTCL2_ROUTER_SIG0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ROUTER_0__WEIGHT_UTCL2_ROUTER_SIG1__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ROUTER_1__WEIGHT_UTCL2_ROUTER_SIG2__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ROUTER_1__WEIGHT_UTCL2_ROUTER_SIG3__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ROUTER_2__WEIGHT_UTCL2_ROUTER_SIG4__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ROUTER_2__WEIGHT_UTCL2_ROUTER_SIG5__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ROUTER_3__WEIGHT_UTCL2_ROUTER_SIG6__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ROUTER_3__WEIGHT_UTCL2_ROUTER_SIG7__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ROUTER_4__WEIGHT_UTCL2_ROUTER_SIG8__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ROUTER_4__WEIGHT_UTCL2_ROUTER_SIG9__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_VML2_0__WEIGHT_UTCL2_VML2_SIG0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_VML2_0__WEIGHT_UTCL2_VML2_SIG1__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_VML2_1__WEIGHT_UTCL2_VML2_SIG2__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_VML2_1__WEIGHT_UTCL2_VML2_SIG3__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_VML2_2__WEIGHT_UTCL2_VML2_SIG4__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_WALKER_0__WEIGHT_UTCL2_WALKER_SIG0__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_WALKER_0__WEIGHT_UTCL2_WALKER_SIG1__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_WALKER_1__WEIGHT_UTCL2_WALKER_SIG2__SHIFT = 0x00000000;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_WALKER_1__WEIGHT_UTCL2_WALKER_SIG3__SHIFT = 0x00000010;
constexpr unsigned int GC_CAC_WEIGHT_UTCL2_WALKER_2__WEIGHT_UTCL2_WALKER_SIG4__SHIFT = 0x00000000;
constexpr unsigned int GC_EDC_CTRL__EDC_ALLOW_WRITE_PWRDELTA__SHIFT = 0x00000009;
constexpr unsigned int GC_EDC_CTRL__EDC_CLK_EN_OVERRIDE__SHIFT  = 0x00000002;
constexpr unsigned int GC_EDC_CTRL__EDC_EN__SHIFT               = 0x00000000;
constexpr unsigned int GC_EDC_CTRL__EDC_FORCE_STALL__SHIFT      = 0x00000003;
constexpr unsigned int GC_EDC_CTRL__EDC_SW_RST__SHIFT           = 0x00000001;
constexpr unsigned int GC_EDC_CTRL__EDC_TRIGGER_THROTTLE_LOWBIT__SHIFT = 0x00000004;
constexpr unsigned int GC_EDC_OVERFLOW__EDC_ROLLING_POWER_DELTA_OVERFLOW__SHIFT = 0x00000000;
constexpr unsigned int GC_EDC_OVERFLOW__EDC_THROTTLE_LEVEL_OVERFLOW_COUNTER__SHIFT = 0x00000001;
constexpr unsigned int GC_EDC_ROLLING_POWER_DELTA__EDC_ROLLING_POWER_DELTA__SHIFT = 0x00000000;
constexpr unsigned int GC_EDC_STATUS__EDC_THROTTLE_LEVEL__SHIFT = 0x00000000;
constexpr unsigned int GC_EDC_THRESHOLD__EDC_THRESHOLD__SHIFT   = 0x00000000;
constexpr unsigned int GC_USER_RB_BACKEND_DISABLE__BACKEND_DISABLE__SHIFT = 0x00000010;
constexpr unsigned int GC_USER_RB_REDUNDANCY__EN_REDUNDANCY0__SHIFT = 0x0000000c;
constexpr unsigned int GC_USER_RB_REDUNDANCY__EN_REDUNDANCY1__SHIFT = 0x00000014;
constexpr unsigned int GC_USER_RB_REDUNDANCY__FAILED_RB0__SHIFT = 0x00000008;
constexpr unsigned int GC_USER_RB_REDUNDANCY__FAILED_RB1__SHIFT = 0x00000010;
constexpr unsigned int GC_USER_SHADER_RATE_CONFIG__DPFP_RATE__SHIFT = 0x00000001;
constexpr unsigned int GC_USER_SHADER_RATE_CONFIG__SQC_BALANCE_DISABLE__SHIFT = 0x00000003;
constexpr unsigned int GDS_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int GDS_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int GDS_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int GDS_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int GDS_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int GDS_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int GDS_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int GDS_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int GDS_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int GDS_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int GDS_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int GDS_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int GFX_COPY_STATE__SRC_STATE_ID__SHIFT      = 0x00000000;
constexpr unsigned int GFX_PIPE_CONTROL__CONTEXT_SUSPEND_EN__SHIFT = 0x00000010;
constexpr unsigned int GFX_PIPE_CONTROL__HYSTERESIS_CNT__SHIFT  = 0x00000000;
constexpr unsigned int GFX_PIPE_CONTROL__RESERVED__SHIFT        = 0x0000000d;
constexpr unsigned int GRBM_CAM_DATA__CAM_ADDR__SHIFT           = 0x00000000;
constexpr unsigned int GRBM_CAM_DATA__CAM_REMAPADDR__SHIFT      = 0x00000010;
constexpr unsigned int GRBM_CAM_INDEX__CAM_INDEX__SHIFT         = 0x00000000;
constexpr unsigned int GRBM_CGTT_CLK_CNTL__OFF_HYSTERESIS__SHIFT = 0x00000004;
constexpr unsigned int GRBM_CGTT_CLK_CNTL__ON_DELAY__SHIFT      = 0x00000000;
constexpr unsigned int GRBM_CGTT_CLK_CNTL__SOFT_OVERRIDE_DYN__SHIFT = 0x0000001e;
constexpr unsigned int GRBM_CGTT_CLK_CNTL__SOFT_STALL_OVERRIDE0__SHIFT = 0x00000017;
constexpr unsigned int GRBM_CGTT_CLK_CNTL__SOFT_STALL_OVERRIDE1__SHIFT = 0x00000016;
constexpr unsigned int GRBM_CGTT_CLK_CNTL__SOFT_STALL_OVERRIDE2__SHIFT = 0x00000015;
constexpr unsigned int GRBM_CGTT_CLK_CNTL__SOFT_STALL_OVERRIDE3__SHIFT = 0x00000014;
constexpr unsigned int GRBM_CGTT_CLK_CNTL__SOFT_STALL_OVERRIDE4__SHIFT = 0x00000013;
constexpr unsigned int GRBM_CGTT_CLK_CNTL__SOFT_STALL_OVERRIDE5__SHIFT = 0x00000012;
constexpr unsigned int GRBM_CGTT_CLK_CNTL__SOFT_STALL_OVERRIDE6__SHIFT = 0x00000011;
constexpr unsigned int GRBM_CGTT_CLK_CNTL__SOFT_STALL_OVERRIDE7__SHIFT = 0x00000010;
constexpr unsigned int GRBM_CHIP_REVISION__CHIP_REVISION__SHIFT = 0x00000000;
constexpr unsigned int GRBM_CNTL__READ_TIMEOUT__SHIFT           = 0x00000000;
constexpr unsigned int GRBM_CNTL__REPORT_LAST_RDERR__SHIFT      = 0x0000001f;
constexpr unsigned int GRBM_DEBUG_DATA__DATA__SHIFT             = 0x00000000;
constexpr unsigned int GRBM_DSM_BYPASS__BYPASS_BITS__SHIFT      = 0x00000000;
constexpr unsigned int GRBM_DSM_BYPASS__BYPASS_EN__SHIFT        = 0x00000002;
constexpr unsigned int GRBM_GFX_CLKEN_CNTL__POST_DELAY_CNT__SHIFT = 0x00000008;
constexpr unsigned int GRBM_GFX_CLKEN_CNTL__PREFIX_DELAY_CNT__SHIFT = 0x00000000;
constexpr unsigned int GRBM_GFX_CNTL_SR_DATA__MEID__SHIFT       = 0x00000002;
constexpr unsigned int GRBM_GFX_CNTL_SR_DATA__PIPEID__SHIFT     = 0x00000000;
constexpr unsigned int GRBM_GFX_CNTL_SR_DATA__QUEUEID__SHIFT    = 0x00000008;
constexpr unsigned int GRBM_GFX_CNTL_SR_DATA__VMID__SHIFT       = 0x00000004;
constexpr unsigned int GRBM_GFX_CNTL_SR_SELECT__INDEX__SHIFT    = 0x00000000;
constexpr unsigned int GRBM_GFX_CNTL__MEID__SHIFT               = 0x00000002;
constexpr unsigned int GRBM_GFX_CNTL__PIPEID__SHIFT             = 0x00000000;
constexpr unsigned int GRBM_GFX_CNTL__QUEUEID__SHIFT            = 0x00000008;
constexpr unsigned int GRBM_GFX_CNTL__VMID__SHIFT               = 0x00000004;
constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__INSTANCE_BROADCAST_WRITES__SHIFT = 0x0000001e;
constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__INSTANCE_INDEX__SHIFT = 0x00000000;
constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SE_BROADCAST_WRITES__SHIFT = 0x0000001f;
constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SE_INDEX__SHIFT  = 0x00000010;
constexpr unsigned int GRBM_GFX_INDEX_SR_SELECT__INDEX__SHIFT   = 0x00000000;
constexpr unsigned int GRBM_GFX_INDEX__INSTANCE_BROADCAST_WRITES__SHIFT = 0x0000001e;
constexpr unsigned int GRBM_GFX_INDEX__INSTANCE_INDEX__SHIFT    = 0x00000000;
constexpr unsigned int GRBM_GFX_INDEX__SE_BROADCAST_WRITES__SHIFT = 0x0000001f;
constexpr unsigned int GRBM_GFX_INDEX__SE_INDEX__SHIFT          = 0x00000010;
constexpr unsigned int GRBM_HYP_CAM_DATA__CAM_ADDR__SHIFT       = 0x00000000;
constexpr unsigned int GRBM_HYP_CAM_DATA__CAM_REMAPADDR__SHIFT  = 0x00000010;
constexpr unsigned int GRBM_HYP_CAM_INDEX__CAM_INDEX__SHIFT     = 0x00000000;
constexpr unsigned int GRBM_IH_CREDIT__CREDIT_VALUE__SHIFT      = 0x00000000;
constexpr unsigned int GRBM_IH_CREDIT__IH_CLIENT_ID__SHIFT      = 0x00000010;
constexpr unsigned int GRBM_INT_CNTL__GUI_IDLE_INT_ENABLE__SHIFT = 0x00000013;
constexpr unsigned int GRBM_INT_CNTL__RDERR_INT_ENABLE__SHIFT   = 0x00000000;
constexpr unsigned int GRBM_IOV_ERROR__IOV_ADDR__SHIFT          = 0x00000002;
constexpr unsigned int GRBM_IOV_ERROR__IOV_ERROR__SHIFT         = 0x0000001f;
constexpr unsigned int GRBM_IOV_ERROR__IOV_OP__SHIFT            = 0x0000001b;
constexpr unsigned int GRBM_IOV_ERROR__IOV_VFID__SHIFT          = 0x00000014;
constexpr unsigned int GRBM_IOV_ERROR__IOV_VF__SHIFT            = 0x0000001a;
constexpr unsigned int GRBM_NOWHERE__DATA__SHIFT                = 0x00000000;
constexpr unsigned int GRBM_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int GRBM_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__BCI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000019;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__CB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000015;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__CB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000b;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__CP_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000016;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__DB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000014;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__DB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000a;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__EA_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001e;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__GDS_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000018;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__GRBM_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000013;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__PA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000012;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__RLC_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001a;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__RMI_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001f;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__SC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000011;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__SPI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000010;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__SX_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000e;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__TA_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000d;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__UTCL2_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001d;
constexpr unsigned int GRBM_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int GRBM_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__BCI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000019;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__CB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000015;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__CB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000b;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__CP_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000016;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__DB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000014;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__DB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000a;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__EA_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001e;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__GDS_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000018;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__GRBM_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000013;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__PA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000012;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__RLC_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001a;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__RMI_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001f;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__SC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000011;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__SPI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000010;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__SX_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000e;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__TA_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000d;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__UTCL2_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001d;
constexpr unsigned int GRBM_PWR_CNTL2__PWR_GFX3D_REQUEST_HALT__SHIFT = 0x00000014;
constexpr unsigned int GRBM_PWR_CNTL2__PWR_REQUEST_HALT__SHIFT  = 0x00000010;
constexpr unsigned int GRBM_PWR_CNTL__ALL_REQ_EN__SHIFT         = 0x0000000f;
constexpr unsigned int GRBM_PWR_CNTL__ALL_REQ_TYPE__SHIFT       = 0x00000000;
constexpr unsigned int GRBM_PWR_CNTL__ALL_RSP_TYPE__SHIFT       = 0x00000004;
constexpr unsigned int GRBM_PWR_CNTL__GFX_REQ_EN__SHIFT         = 0x0000000e;
constexpr unsigned int GRBM_PWR_CNTL__GFX_REQ_TYPE__SHIFT       = 0x00000002;
constexpr unsigned int GRBM_PWR_CNTL__GFX_RSP_TYPE__SHIFT       = 0x00000006;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_GDS_DMA__SHIFT = 0x00000013;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_ME0PIPE0_CF__SHIFT = 0x00000014;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_ME0PIPE0_PF__SHIFT = 0x00000015;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_ME0PIPE1_CF__SHIFT = 0x00000016;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_ME0PIPE1_PF__SHIFT = 0x00000017;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_ME1PIPE0__SHIFT = 0x00000018;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_ME1PIPE1__SHIFT = 0x00000019;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_ME1PIPE2__SHIFT = 0x0000001a;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_ME1PIPE3__SHIFT = 0x0000001b;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_ME2PIPE0__SHIFT = 0x0000001c;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_ME2PIPE1__SHIFT = 0x0000001d;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_ME2PIPE2__SHIFT = 0x0000001e;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_ME2PIPE3__SHIFT = 0x0000001f;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_RLC__SHIFT = 0x00000012;
constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_RSMU__SHIFT = 0x00000011;
constexpr unsigned int GRBM_READ_ERROR__READ_ADDRESS__SHIFT     = 0x00000002;
constexpr unsigned int GRBM_READ_ERROR__READ_ERROR__SHIFT       = 0x0000001f;
constexpr unsigned int GRBM_READ_ERROR__READ_MEID__SHIFT        = 0x00000016;
constexpr unsigned int GRBM_READ_ERROR__READ_PIPEID__SHIFT      = 0x00000014;
constexpr unsigned int GRBM_SCRATCH_REG0__SCRATCH_REG0__SHIFT   = 0x00000000;
constexpr unsigned int GRBM_SCRATCH_REG1__SCRATCH_REG1__SHIFT   = 0x00000000;
constexpr unsigned int GRBM_SCRATCH_REG2__SCRATCH_REG2__SHIFT   = 0x00000000;
constexpr unsigned int GRBM_SCRATCH_REG3__SCRATCH_REG3__SHIFT   = 0x00000000;
constexpr unsigned int GRBM_SCRATCH_REG4__SCRATCH_REG4__SHIFT   = 0x00000000;
constexpr unsigned int GRBM_SCRATCH_REG5__SCRATCH_REG5__SHIFT   = 0x00000000;
constexpr unsigned int GRBM_SCRATCH_REG6__SCRATCH_REG6__SHIFT   = 0x00000000;
constexpr unsigned int GRBM_SCRATCH_REG7__SCRATCH_REG7__SHIFT   = 0x00000000;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__BCI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000015;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__CB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000012;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__CB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000b;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__DB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000011;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__DB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000a;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__PA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000014;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__RMI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000016;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__SC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000010;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__SPI_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000f;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__SX_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000d;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__TA_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000c;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__BCI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000015;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__CB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000012;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__CB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000b;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__DB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000011;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__DB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000a;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__PA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000014;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__RMI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000016;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__SC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000010;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__SPI_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000f;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__SX_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000d;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__TA_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000c;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__BCI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000015;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__CB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000012;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__CB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000b;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__DB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000011;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__DB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000a;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__PA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000014;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__RMI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000016;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__SC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000010;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__SPI_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000f;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__SX_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000d;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__TA_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000c;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__BCI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000015;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__CB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000012;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__CB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000b;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__DB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000011;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__DB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000a;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__PA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000014;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__RMI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000016;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__SC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000010;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__SPI_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000f;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__SX_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000d;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__TA_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000c;
constexpr unsigned int GRBM_SKEW_CNTL__SKEW_COUNT__SHIFT        = 0x00000006;
constexpr unsigned int GRBM_SKEW_CNTL__SKEW_TOP_THRESHOLD__SHIFT = 0x00000000;
constexpr unsigned int GRBM_SOFT_RESET__SOFT_RESET_CAC__SHIFT   = 0x00000014;
constexpr unsigned int GRBM_SOFT_RESET__SOFT_RESET_CPAXI__SHIFT = 0x00000015;
constexpr unsigned int GRBM_SOFT_RESET__SOFT_RESET_CPC__SHIFT   = 0x00000012;
constexpr unsigned int GRBM_SOFT_RESET__SOFT_RESET_CPF__SHIFT   = 0x00000011;
constexpr unsigned int GRBM_SOFT_RESET__SOFT_RESET_CPG__SHIFT   = 0x00000013;
constexpr unsigned int GRBM_SOFT_RESET__SOFT_RESET_CP__SHIFT    = 0x00000000;
constexpr unsigned int GRBM_SOFT_RESET__SOFT_RESET_EA__SHIFT    = 0x00000016;
constexpr unsigned int GRBM_SOFT_RESET__SOFT_RESET_GFX__SHIFT   = 0x00000010;
constexpr unsigned int GRBM_SOFT_RESET__SOFT_RESET_RLC__SHIFT   = 0x00000002;
constexpr unsigned int GRBM_STATUS2__CPAXI_BUSY__SHIFT          = 0x0000001f;
constexpr unsigned int GRBM_STATUS2__CPC_BUSY__SHIFT            = 0x0000001d;
constexpr unsigned int GRBM_STATUS2__CPF_BUSY__SHIFT            = 0x0000001c;
constexpr unsigned int GRBM_STATUS2__CPG_BUSY__SHIFT            = 0x0000001e;
constexpr unsigned int GRBM_STATUS2__EA_BUSY__SHIFT             = 0x00000010;
constexpr unsigned int GRBM_STATUS2__EA_LINK_BUSY__SHIFT        = 0x00000014;
constexpr unsigned int GRBM_STATUS2__ME0PIPE1_CF_RQ_PENDING__SHIFT = 0x00000004;
constexpr unsigned int GRBM_STATUS2__ME0PIPE1_CMDFIFO_AVAIL__SHIFT = 0x00000000;
constexpr unsigned int GRBM_STATUS2__ME0PIPE1_PF_RQ_PENDING__SHIFT = 0x00000005;
constexpr unsigned int GRBM_STATUS2__ME1PIPE0_RQ_PENDING__SHIFT = 0x00000006;
constexpr unsigned int GRBM_STATUS2__ME1PIPE1_RQ_PENDING__SHIFT = 0x00000007;
constexpr unsigned int GRBM_STATUS2__ME1PIPE2_RQ_PENDING__SHIFT = 0x00000008;
constexpr unsigned int GRBM_STATUS2__ME1PIPE3_RQ_PENDING__SHIFT = 0x00000009;
constexpr unsigned int GRBM_STATUS2__ME2PIPE0_RQ_PENDING__SHIFT = 0x0000000a;
constexpr unsigned int GRBM_STATUS2__ME2PIPE1_RQ_PENDING__SHIFT = 0x0000000b;
constexpr unsigned int GRBM_STATUS2__ME2PIPE2_RQ_PENDING__SHIFT = 0x0000000c;
constexpr unsigned int GRBM_STATUS2__ME2PIPE3_RQ_PENDING__SHIFT = 0x0000000d;
constexpr unsigned int GRBM_STATUS2__RLC_RQ_PENDING__SHIFT      = 0x0000000e;
constexpr unsigned int GRBM_STATUS2__RMI_BUSY__SHIFT            = 0x00000011;
constexpr unsigned int GRBM_STATUS2__UTCL2_BUSY__SHIFT          = 0x0000000f;
constexpr unsigned int GRBM_STATUS2__UTCL2_RQ_PENDING__SHIFT    = 0x00000012;
constexpr unsigned int GRBM_STATUS_SE0__BCI_BUSY__SHIFT         = 0x00000016;
constexpr unsigned int GRBM_STATUS_SE0__CB_BUSY__SHIFT          = 0x0000001f;
constexpr unsigned int GRBM_STATUS_SE0__CB_CLEAN__SHIFT         = 0x00000002;
constexpr unsigned int GRBM_STATUS_SE0__DB_BUSY__SHIFT          = 0x0000001e;
constexpr unsigned int GRBM_STATUS_SE0__DB_CLEAN__SHIFT         = 0x00000001;
constexpr unsigned int GRBM_STATUS_SE0__PA_BUSY__SHIFT          = 0x00000018;
constexpr unsigned int GRBM_STATUS_SE0__RMI_BUSY__SHIFT         = 0x00000015;
constexpr unsigned int GRBM_STATUS_SE0__SC_BUSY__SHIFT          = 0x0000001d;
constexpr unsigned int GRBM_STATUS_SE0__SPI_BUSY__SHIFT         = 0x0000001b;
constexpr unsigned int GRBM_STATUS_SE0__SX_BUSY__SHIFT          = 0x0000001a;
constexpr unsigned int GRBM_STATUS_SE0__TA_BUSY__SHIFT          = 0x00000019;
constexpr unsigned int GRBM_STATUS_SE1__BCI_BUSY__SHIFT         = 0x00000016;
constexpr unsigned int GRBM_STATUS_SE1__CB_BUSY__SHIFT          = 0x0000001f;
constexpr unsigned int GRBM_STATUS_SE1__CB_CLEAN__SHIFT         = 0x00000002;
constexpr unsigned int GRBM_STATUS_SE1__DB_BUSY__SHIFT          = 0x0000001e;
constexpr unsigned int GRBM_STATUS_SE1__DB_CLEAN__SHIFT         = 0x00000001;
constexpr unsigned int GRBM_STATUS_SE1__PA_BUSY__SHIFT          = 0x00000018;
constexpr unsigned int GRBM_STATUS_SE1__RMI_BUSY__SHIFT         = 0x00000015;
constexpr unsigned int GRBM_STATUS_SE1__SC_BUSY__SHIFT          = 0x0000001d;
constexpr unsigned int GRBM_STATUS_SE1__SPI_BUSY__SHIFT         = 0x0000001b;
constexpr unsigned int GRBM_STATUS_SE1__SX_BUSY__SHIFT          = 0x0000001a;
constexpr unsigned int GRBM_STATUS_SE1__TA_BUSY__SHIFT          = 0x00000019;
constexpr unsigned int GRBM_STATUS_SE2__BCI_BUSY__SHIFT         = 0x00000016;
constexpr unsigned int GRBM_STATUS_SE2__CB_BUSY__SHIFT          = 0x0000001f;
constexpr unsigned int GRBM_STATUS_SE2__CB_CLEAN__SHIFT         = 0x00000002;
constexpr unsigned int GRBM_STATUS_SE2__DB_BUSY__SHIFT          = 0x0000001e;
constexpr unsigned int GRBM_STATUS_SE2__DB_CLEAN__SHIFT         = 0x00000001;
constexpr unsigned int GRBM_STATUS_SE2__PA_BUSY__SHIFT          = 0x00000018;
constexpr unsigned int GRBM_STATUS_SE2__RMI_BUSY__SHIFT         = 0x00000015;
constexpr unsigned int GRBM_STATUS_SE2__SC_BUSY__SHIFT          = 0x0000001d;
constexpr unsigned int GRBM_STATUS_SE2__SPI_BUSY__SHIFT         = 0x0000001b;
constexpr unsigned int GRBM_STATUS_SE2__SX_BUSY__SHIFT          = 0x0000001a;
constexpr unsigned int GRBM_STATUS_SE2__TA_BUSY__SHIFT          = 0x00000019;
constexpr unsigned int GRBM_STATUS_SE3__BCI_BUSY__SHIFT         = 0x00000016;
constexpr unsigned int GRBM_STATUS_SE3__CB_BUSY__SHIFT          = 0x0000001f;
constexpr unsigned int GRBM_STATUS_SE3__CB_CLEAN__SHIFT         = 0x00000002;
constexpr unsigned int GRBM_STATUS_SE3__DB_BUSY__SHIFT          = 0x0000001e;
constexpr unsigned int GRBM_STATUS_SE3__DB_CLEAN__SHIFT         = 0x00000001;
constexpr unsigned int GRBM_STATUS_SE3__PA_BUSY__SHIFT          = 0x00000018;
constexpr unsigned int GRBM_STATUS_SE3__RMI_BUSY__SHIFT         = 0x00000015;
constexpr unsigned int GRBM_STATUS_SE3__SC_BUSY__SHIFT          = 0x0000001d;
constexpr unsigned int GRBM_STATUS_SE3__SPI_BUSY__SHIFT         = 0x0000001b;
constexpr unsigned int GRBM_STATUS_SE3__SX_BUSY__SHIFT          = 0x0000001a;
constexpr unsigned int GRBM_STATUS_SE3__TA_BUSY__SHIFT          = 0x00000019;
constexpr unsigned int GRBM_STATUS__BCI_BUSY__SHIFT             = 0x00000017;
constexpr unsigned int GRBM_STATUS__CB_BUSY__SHIFT              = 0x0000001e;
constexpr unsigned int GRBM_STATUS__CB_CLEAN__SHIFT             = 0x0000000d;
constexpr unsigned int GRBM_STATUS__CP_BUSY__SHIFT              = 0x0000001d;
constexpr unsigned int GRBM_STATUS__CP_COHERENCY_BUSY__SHIFT    = 0x0000001c;
constexpr unsigned int GRBM_STATUS__DB_BUSY__SHIFT              = 0x0000001a;
constexpr unsigned int GRBM_STATUS__DB_CLEAN__SHIFT             = 0x0000000c;
constexpr unsigned int GRBM_STATUS__GDS_BUSY__SHIFT             = 0x0000000f;
constexpr unsigned int GRBM_STATUS__GDS_DMA_RQ_PENDING__SHIFT   = 0x00000009;
constexpr unsigned int GRBM_STATUS__GUI_ACTIVE__SHIFT           = 0x0000001f;
constexpr unsigned int GRBM_STATUS__ME0PIPE0_CF_RQ_PENDING__SHIFT = 0x00000007;
constexpr unsigned int GRBM_STATUS__ME0PIPE0_CMDFIFO_AVAIL__SHIFT = 0x00000000;
constexpr unsigned int GRBM_STATUS__ME0PIPE0_PF_RQ_PENDING__SHIFT = 0x00000008;
constexpr unsigned int GRBM_STATUS__PA_BUSY__SHIFT              = 0x00000019;
constexpr unsigned int GRBM_STATUS__RSMU_RQ_PENDING__SHIFT      = 0x00000005;
constexpr unsigned int GRBM_STATUS__SC_BUSY__SHIFT              = 0x00000018;
constexpr unsigned int GRBM_STATUS__SPI_BUSY__SHIFT             = 0x00000016;
constexpr unsigned int GRBM_STATUS__SX_BUSY__SHIFT              = 0x00000014;
constexpr unsigned int GRBM_STATUS__TA_BUSY__SHIFT              = 0x0000000e;
constexpr unsigned int GRBM_TRAP_ADDR_MSK__DATA__SHIFT          = 0x00000000;
constexpr unsigned int GRBM_TRAP_ADDR__DATA__SHIFT              = 0x00000000;
constexpr unsigned int GRBM_TRAP_OP__RW__SHIFT                  = 0x00000000;
constexpr unsigned int GRBM_TRAP_WD_MSK__DATA__SHIFT            = 0x00000000;
constexpr unsigned int GRBM_TRAP_WD__DATA__SHIFT                = 0x00000000;
constexpr unsigned int GRBM_UTCL2_INVAL_RANGE_END__DATA__SHIFT  = 0x00000000;
constexpr unsigned int GRBM_UTCL2_INVAL_RANGE_START__DATA__SHIFT = 0x00000000;
constexpr unsigned int GRBM_WAIT_IDLE_CLOCKS__WAIT_IDLE_CLOCKS__SHIFT = 0x00000000;
constexpr unsigned int GRBM_WRITE_ERROR__WRITE_ERROR__SHIFT     = 0x0000001f;
constexpr unsigned int GRBM_WRITE_ERROR__WRITE_MEID__SHIFT      = 0x00000016;
constexpr unsigned int GRBM_WRITE_ERROR__WRITE_PIPEID__SHIFT    = 0x00000014;
constexpr unsigned int GRBM_WRITE_ERROR__WRITE_REQUESTER_RLC__SHIFT = 0x00000000;
constexpr unsigned int GRBM_WRITE_ERROR__WRITE_REQUESTER_RSMU__SHIFT = 0x00000001;
constexpr unsigned int GRBM_WRITE_ERROR__WRITE_SSRCID__SHIFT    = 0x00000002;
constexpr unsigned int GRBM_WRITE_ERROR__WRITE_VFID__SHIFT      = 0x00000005;
constexpr unsigned int GRBM_WRITE_ERROR__WRITE_VF__SHIFT        = 0x0000000c;
constexpr unsigned int GRBM_WRITE_ERROR__WRITE_VMID__SHIFT      = 0x0000000d;
constexpr unsigned int IA_ENHANCE__MISC__SHIFT                  = 0x00000000;
constexpr unsigned int IA_MULTI_VGT_PARAM__PARTIAL_ES_WAVE_ON__SHIFT = 0x00000012;
constexpr unsigned int IA_MULTI_VGT_PARAM__PARTIAL_VS_WAVE_ON__SHIFT = 0x00000010;
constexpr unsigned int IA_MULTI_VGT_PARAM__PRIMGROUP_SIZE__SHIFT = 0x00000000;
constexpr unsigned int IA_MULTI_VGT_PARAM__SWITCH_ON_EOI__SHIFT = 0x00000013;
constexpr unsigned int IA_MULTI_VGT_PARAM__SWITCH_ON_EOP__SHIFT = 0x00000011;
constexpr unsigned int IA_MULTI_VGT_PARAM__WD_SWITCH_ON_EOP__SHIFT = 0x00000014;
constexpr unsigned int IA_UTCL1_CNTL__BYPASS__SHIFT             = 0x00000019;
constexpr unsigned int IA_UTCL1_CNTL__DROP_MODE__SHIFT          = 0x00000018;
constexpr unsigned int IA_UTCL1_CNTL__FORCE_SNOOP__SHIFT        = 0x0000001c;
constexpr unsigned int IA_UTCL1_CNTL__FRAG_LIMIT_MODE__SHIFT    = 0x0000001b;
constexpr unsigned int IA_UTCL1_CNTL__INVALIDATE__SHIFT         = 0x0000001a;
constexpr unsigned int IA_UTCL1_CNTL__VMID_RESET_MODE__SHIFT    = 0x00000017;
constexpr unsigned int IA_UTCL1_CNTL__XNACK_REDO_TIMER_CNT__SHIFT = 0x00000000;
constexpr unsigned int IA_UTCL1_STATUS__FAULT_DETECTED__SHIFT   = 0x00000000;
constexpr unsigned int IA_UTCL1_STATUS__FAULT_UTCL1ID__SHIFT    = 0x00000008;
constexpr unsigned int IA_UTCL1_STATUS__PRT_DETECTED__SHIFT     = 0x00000002;
constexpr unsigned int IA_UTCL1_STATUS__PRT_UTCL1ID__SHIFT      = 0x00000018;
constexpr unsigned int IA_UTCL1_STATUS__RETRY_DETECTED__SHIFT   = 0x00000001;
constexpr unsigned int IA_UTCL1_STATUS__RETRY_UTCL1ID__SHIFT    = 0x00000010;
constexpr unsigned int LDS_CONFIG__ADDR_OUT_OF_RANGE_REPORTING__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_CLIP_CNTL__BOUNDARY_EDGE_FLAG_ENA__SHIFT = 0x00000012;
constexpr unsigned int PA_CL_CLIP_CNTL__CLIP_DISABLE__SHIFT     = 0x00000010;
constexpr unsigned int PA_CL_CLIP_CNTL__DIS_CLIP_ERR_DETECT__SHIFT = 0x00000014;
constexpr unsigned int PA_CL_CLIP_CNTL__DX_CLIP_SPACE_DEF__SHIFT = 0x00000013;
constexpr unsigned int PA_CL_CLIP_CNTL__DX_LINEAR_ATTR_CLIP_ENA__SHIFT = 0x00000018;
constexpr unsigned int PA_CL_CLIP_CNTL__DX_RASTERIZATION_KILL__SHIFT = 0x00000016;
constexpr unsigned int PA_CL_CLIP_CNTL__PS_UCP_MODE__SHIFT      = 0x0000000e;
constexpr unsigned int PA_CL_CLIP_CNTL__PS_UCP_Y_SCALE_NEG__SHIFT = 0x0000000d;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_CULL_ONLY_ENA__SHIFT = 0x00000011;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_0__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_1__SHIFT        = 0x00000001;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_2__SHIFT        = 0x00000002;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_3__SHIFT        = 0x00000003;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_4__SHIFT        = 0x00000004;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_5__SHIFT        = 0x00000005;
constexpr unsigned int PA_CL_CLIP_CNTL__VTE_VPORT_PROVOKE_DISABLE__SHIFT = 0x00000019;
constexpr unsigned int PA_CL_CLIP_CNTL__VTX_KILL_OR__SHIFT      = 0x00000015;
constexpr unsigned int PA_CL_CLIP_CNTL__ZCLIP_FAR_DISABLE__SHIFT = 0x0000001b;
constexpr unsigned int PA_CL_CLIP_CNTL__ZCLIP_NEAR_DISABLE__SHIFT = 0x0000001a;
constexpr unsigned int PA_CL_ENHANCE__CLIPPED_PRIM_SEQ_STALL__SHIFT = 0x00000003;
constexpr unsigned int PA_CL_ENHANCE__CLIP_VTX_REORDER_ENA__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_ENHANCE__ECO_SPARE0__SHIFT         = 0x0000001f;
constexpr unsigned int PA_CL_ENHANCE__ECO_SPARE1__SHIFT         = 0x0000001e;
constexpr unsigned int PA_CL_ENHANCE__IGNORE_PIPELINE_RESET__SHIFT = 0x00000006;
constexpr unsigned int PA_CL_ENHANCE__KILL_INNER_EDGE_FLAGS__SHIFT = 0x00000007;
constexpr unsigned int PA_CL_ENHANCE__NGG_BYPASS_PRIM_FILTER__SHIFT = 0x0000000b;
constexpr unsigned int PA_CL_ENHANCE__NGG_PA_TO_ALL_SC__SHIFT   = 0x00000008;
constexpr unsigned int PA_CL_ENHANCE__NGG_PRIM_INDICES_FIFO_DEPTH__SHIFT = 0x0000000e;
constexpr unsigned int PA_CL_ENHANCE__NGG_SIDEBAND_MEMORY_DEPTH__SHIFT = 0x0000000c;
constexpr unsigned int PA_CL_ENHANCE__NUM_CLIP_SEQ__SHIFT       = 0x00000001;
constexpr unsigned int PA_CL_ENHANCE__TC_LATENCY_TIME_STAMP_RESOLUTION__SHIFT = 0x00000009;
constexpr unsigned int PA_CL_ENHANCE__VE_NAN_PROC_DISABLE__SHIFT = 0x00000004;
constexpr unsigned int PA_CL_ENHANCE__XTRA_DEBUG_REG_SEL__SHIFT = 0x00000005;
constexpr unsigned int PA_CL_GB_HORZ_CLIP_ADJ__DATA_REGISTER__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_GB_HORZ_DISC_ADJ__DATA_REGISTER__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_GB_VERT_CLIP_ADJ__DATA_REGISTER__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_GB_VERT_DISC_ADJ__DATA_REGISTER__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_CLIP_DIST_INF_DISCARD__SHIFT = 0x0000000e;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_W_INF_RETAIN__SHIFT = 0x0000000d;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_W_NAN_TO_INF__SHIFT = 0x0000000c;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_XY_INF_RETAIN__SHIFT = 0x00000009;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_XY_NAN_TO_INF__SHIFT = 0x00000008;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_Z_INF_RETAIN__SHIFT = 0x0000000b;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_Z_NAN_TO_INF__SHIFT = 0x0000000a;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_0XNANINF_IS_0__SHIFT = 0x00000003;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_NO_OUTPUT_NEG_0__SHIFT = 0x00000014;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_W_INF_DISCARD__SHIFT = 0x00000002;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_W_NAN_RETAIN__SHIFT = 0x00000006;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_W_RECIP_NAN_IS_0__SHIFT = 0x00000007;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_XY_INF_DISCARD__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_XY_NAN_RETAIN__SHIFT = 0x00000004;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_Z_INF_DISCARD__SHIFT = 0x00000001;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_Z_NAN_RETAIN__SHIFT = 0x00000005;
constexpr unsigned int PA_CL_NGG_CNTL__INDEX_BUF_EDGE_FLAG_ENA__SHIFT = 0x00000001;
constexpr unsigned int PA_CL_NGG_CNTL__VERTEX_REUSE_OFF__SHIFT  = 0x00000000;
constexpr unsigned int PA_CL_POINT_CULL_RAD__DATA_REGISTER__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_POINT_SIZE__DATA_REGISTER__SHIFT   = 0x00000000;
constexpr unsigned int PA_CL_POINT_X_RAD__DATA_REGISTER__SHIFT  = 0x00000000;
constexpr unsigned int PA_CL_POINT_Y_RAD__DATA_REGISTER__SHIFT  = 0x00000000;
constexpr unsigned int PA_CL_RESET_DEBUG__CL_TRIV_DISC_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_UCP_0_W__DATA_REGISTER__SHIFT      = 0x00000000;
constexpr unsigned int PA_CL_UCP_0_X__DATA_REGISTER__SHIFT      = 0x00000000;
constexpr unsigned int PA_CL_UCP_0_Y__DATA_REGISTER__SHIFT      = 0x00000000;
constexpr unsigned int PA_CL_UCP_0_Z__DATA_REGISTER__SHIFT      = 0x00000000;
constexpr unsigned int PA_CL_UCP_1_W__DATA_REGISTER__SHIFT      = 0x00000000;
constexpr unsigned int PA_CL_UCP_1_X__DATA_REGISTER__SHIFT      = 0x00000000;
constexpr unsigned int PA_CL_UCP_1_Y__DATA_REGISTER__SHIFT      = 0x00000000;
constexpr unsigned int PA_CL_UCP_1_Z__DATA_REGISTER__SHIFT      = 0x00000000;
constexpr unsigned int PA_CL_UCP_2_W__DATA_REGISTER__SHIFT      = 0x00000000;
constexpr unsigned int PA_CL_UCP_2_X__DATA_REGISTER__SHIFT      = 0x00000000;
constexpr unsigned int PA_CL_UCP_2_Y__DATA_REGISTER__SHIFT      = 0x00000000;
constexpr unsigned int PA_CL_UCP_2_Z__DATA_REGISTER__SHIFT      = 0x00000000;
constexpr unsigned int PA_CL_UCP_3_W__DATA_REGISTER__SHIFT      = 0x00000000;
constexpr unsigned int PA_CL_UCP_3_X__DATA_REGISTER__SHIFT      = 0x00000000;
constexpr unsigned int PA_CL_UCP_3_Y__DATA_REGISTER__SHIFT      = 0x00000000;
constexpr unsigned int PA_CL_UCP_3_Z__DATA_REGISTER__SHIFT      = 0x00000000;
constexpr unsigned int PA_CL_UCP_4_W__DATA_REGISTER__SHIFT      = 0x00000000;
constexpr unsigned int PA_CL_UCP_4_X__DATA_REGISTER__SHIFT      = 0x00000000;
constexpr unsigned int PA_CL_UCP_4_Y__DATA_REGISTER__SHIFT      = 0x00000000;
constexpr unsigned int PA_CL_UCP_4_Z__DATA_REGISTER__SHIFT      = 0x00000000;
constexpr unsigned int PA_CL_UCP_5_W__DATA_REGISTER__SHIFT      = 0x00000000;
constexpr unsigned int PA_CL_UCP_5_X__DATA_REGISTER__SHIFT      = 0x00000000;
constexpr unsigned int PA_CL_UCP_5_Y__DATA_REGISTER__SHIFT      = 0x00000000;
constexpr unsigned int PA_CL_UCP_5_Z__DATA_REGISTER__SHIFT      = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_1__VPORT_XOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_2__VPORT_XOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_3__VPORT_XOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_4__VPORT_XOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_5__VPORT_XOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_6__VPORT_XOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_7__VPORT_XOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_8__VPORT_XOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_9__VPORT_XOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_10__VPORT_XOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_11__VPORT_XOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_12__VPORT_XOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_13__VPORT_XOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_14__VPORT_XOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_15__VPORT_XOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET__VPORT_XOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_1__VPORT_XSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_2__VPORT_XSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_3__VPORT_XSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_4__VPORT_XSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_5__VPORT_XSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_6__VPORT_XSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_7__VPORT_XSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_8__VPORT_XSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_9__VPORT_XSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_10__VPORT_XSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_11__VPORT_XSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_12__VPORT_XSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_13__VPORT_XSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_14__VPORT_XSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_15__VPORT_XSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE__VPORT_XSCALE__SHIFT  = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_1__VPORT_YOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_2__VPORT_YOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_3__VPORT_YOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_4__VPORT_YOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_5__VPORT_YOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_6__VPORT_YOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_7__VPORT_YOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_8__VPORT_YOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_9__VPORT_YOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_10__VPORT_YOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_11__VPORT_YOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_12__VPORT_YOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_13__VPORT_YOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_14__VPORT_YOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_15__VPORT_YOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET__VPORT_YOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_1__VPORT_YSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_2__VPORT_YSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_3__VPORT_YSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_4__VPORT_YSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_5__VPORT_YSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_6__VPORT_YSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_7__VPORT_YSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_8__VPORT_YSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_9__VPORT_YSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_10__VPORT_YSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_11__VPORT_YSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_12__VPORT_YSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_13__VPORT_YSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_14__VPORT_YSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_15__VPORT_YSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE__VPORT_YSCALE__SHIFT  = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_1__VPORT_ZOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_2__VPORT_ZOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_3__VPORT_ZOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_4__VPORT_ZOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_5__VPORT_ZOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_6__VPORT_ZOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_7__VPORT_ZOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_8__VPORT_ZOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_9__VPORT_ZOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_10__VPORT_ZOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_11__VPORT_ZOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_12__VPORT_ZOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_13__VPORT_ZOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_14__VPORT_ZOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_15__VPORT_ZOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET__VPORT_ZOFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_1__VPORT_ZSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_2__VPORT_ZSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_3__VPORT_ZSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_4__VPORT_ZSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_5__VPORT_ZSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_6__VPORT_ZSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_7__VPORT_ZSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_8__VPORT_ZSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_9__VPORT_ZSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_10__VPORT_ZSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_11__VPORT_ZSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_12__VPORT_ZSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_13__VPORT_ZSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_14__VPORT_ZSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_15__VPORT_ZSCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE__VPORT_ZSCALE__SHIFT  = 0x00000000;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_0__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_1__SHIFT = 0x00000001;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_2__SHIFT = 0x00000002;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_3__SHIFT = 0x00000003;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_4__SHIFT = 0x00000004;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_5__SHIFT = 0x00000005;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_6__SHIFT = 0x00000006;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_7__SHIFT = 0x00000007;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_0__SHIFT = 0x00000008;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_1__SHIFT = 0x00000009;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_2__SHIFT = 0x0000000a;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_3__SHIFT = 0x0000000b;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_4__SHIFT = 0x0000000c;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_5__SHIFT = 0x0000000d;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_6__SHIFT = 0x0000000e;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_7__SHIFT = 0x0000000f;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_EDGE_FLAG__SHIFT = 0x00000011;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_GS_CUT_FLAG__SHIFT = 0x00000019;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_KILL_FLAG__SHIFT = 0x00000014;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_POINT_SIZE__SHIFT = 0x00000010;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_RENDER_TARGET_INDX__SHIFT = 0x00000012;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_VIEWPORT_INDX__SHIFT = 0x00000013;
constexpr unsigned int PA_CL_VS_OUT_CNTL__VS_OUT_CCDIST0_VEC_ENA__SHIFT = 0x00000016;
constexpr unsigned int PA_CL_VS_OUT_CNTL__VS_OUT_CCDIST1_VEC_ENA__SHIFT = 0x00000017;
constexpr unsigned int PA_CL_VS_OUT_CNTL__VS_OUT_MISC_SIDE_BUS_ENA__SHIFT = 0x00000018;
constexpr unsigned int PA_CL_VS_OUT_CNTL__VS_OUT_MISC_VEC_ENA__SHIFT = 0x00000015;
constexpr unsigned int PA_CL_VTE_CNTL__PERFCOUNTER_REF__SHIFT   = 0x0000000b;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_X_OFFSET_ENA__SHIFT = 0x00000001;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_X_SCALE_ENA__SHIFT = 0x00000000;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_Y_OFFSET_ENA__SHIFT = 0x00000003;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_Y_SCALE_ENA__SHIFT = 0x00000002;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_Z_OFFSET_ENA__SHIFT = 0x00000005;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_Z_SCALE_ENA__SHIFT = 0x00000004;
constexpr unsigned int PA_CL_VTE_CNTL__VTX_W0_FMT__SHIFT        = 0x0000000a;
constexpr unsigned int PA_CL_VTE_CNTL__VTX_XY_FMT__SHIFT        = 0x00000008;
constexpr unsigned int PA_CL_VTE_CNTL__VTX_Z_FMT__SHIFT         = 0x00000009;
constexpr unsigned int PA_SC_AA_CONFIG__AA_MASK_CENTROID_DTMN__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_AA_CONFIG__COVERAGE_TO_SHADER_SELECT__SHIFT = 0x0000001a;
constexpr unsigned int PA_SC_AA_CONFIG__DETAIL_TO_EXPOSED_MODE__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_AA_CONFIG__MAX_SAMPLE_DIST__SHIFT  = 0x0000000d;
constexpr unsigned int PA_SC_AA_CONFIG__MSAA_EXPOSED_SAMPLES__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_AA_CONFIG__MSAA_NUM_SAMPLES__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_AA_MASK_X0Y0_X1Y0__AA_MASK_X0Y0__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_AA_MASK_X0Y0_X1Y0__AA_MASK_X1Y0__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_AA_MASK_X0Y1_X1Y1__AA_MASK_X0Y1__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_AA_MASK_X0Y1_X1Y1__AA_MASK_X1Y1__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S0_X__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S0_Y__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S1_X__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S1_Y__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S2_X__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S2_Y__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S3_X__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S3_Y__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S4_X__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S4_Y__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S5_X__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S5_Y__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S6_X__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S6_Y__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S7_X__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S7_Y__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S8_X__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S8_Y__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S9_X__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S9_Y__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S10_X__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S10_Y__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S11_X__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S11_Y__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S12_X__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S12_Y__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S13_X__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S13_Y__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S14_X__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S14_Y__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S15_X__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S15_Y__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S0_X__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S0_Y__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S1_X__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S1_Y__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S2_X__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S2_Y__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S3_X__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S3_Y__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S4_X__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S4_Y__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S5_X__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S5_Y__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S6_X__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S6_Y__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S7_X__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S7_Y__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S8_X__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S8_Y__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S9_X__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S9_Y__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S10_X__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S10_Y__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S11_X__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S11_Y__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S12_X__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S12_Y__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S13_X__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S13_Y__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S14_X__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S14_Y__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S15_X__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S15_Y__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S0_X__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S0_Y__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S1_X__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S1_Y__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S2_X__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S2_Y__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S3_X__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S3_Y__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S4_X__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S4_Y__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S5_X__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S5_Y__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S6_X__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S6_Y__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S7_X__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S7_Y__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S8_X__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S8_Y__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S9_X__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S9_Y__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S10_X__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S10_Y__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S11_X__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S11_Y__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S12_X__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S12_Y__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S13_X__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S13_Y__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S14_X__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S14_Y__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S15_X__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S15_Y__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S0_X__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S0_Y__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S1_X__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S1_Y__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S2_X__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S2_Y__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S3_X__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S3_Y__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S4_X__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S4_Y__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S5_X__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S5_Y__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S6_X__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S6_Y__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S7_X__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S7_Y__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S8_X__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S8_Y__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S9_X__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S9_Y__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S10_X__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S10_Y__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S11_X__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S11_Y__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S12_X__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S12_Y__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S13_X__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S13_Y__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S14_X__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S14_Y__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S15_X__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S15_Y__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BINNING_MODE__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_SIZE_X_EXTEND__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_SIZE_X__SHIFT   = 0x00000002;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_SIZE_Y_EXTEND__SHIFT = 0x00000007;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_SIZE_Y__SHIFT   = 0x00000003;
constexpr unsigned int PA_SC_BINNER_CNTL_0__CONTEXT_STATES_PER_BIN__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_BINNER_CNTL_0__DISABLE_START_OF_PRIM__SHIFT = 0x00000012;
constexpr unsigned int PA_SC_BINNER_CNTL_0__FPOVS_PER_BATCH__SHIFT = 0x00000013;
constexpr unsigned int PA_SC_BINNER_CNTL_0__OPTIMAL_BIN_SELECTION__SHIFT = 0x0000001b;
constexpr unsigned int PA_SC_BINNER_CNTL_0__PERSISTENT_STATES_PER_BIN__SHIFT = 0x0000000d;
constexpr unsigned int PA_SC_BINNER_CNTL_1__MAX_ALLOC_COUNT__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_CNTL_1__MAX_PRIM_PER_BATCH__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__BREAK_BATCH__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__CACHE_FLUSH_TS__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__CACHE_FLUSH__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__CONTEXT_DONE__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__CS_PARTIAL_FLUSH__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__END_OF_PIPE_IB_END__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__END_OF_PIPE_INCR_DE__SHIFT = 0x00000016;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__RESERVED_0__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__RESERVED_9__SHIFT = 0x00000012;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__RST_PIX_CNT__SHIFT = 0x0000001a;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__SAMPLE_STREAMOUTSTATS1__SHIFT = 0x00000002;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__SAMPLE_STREAMOUTSTATS2__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__SAMPLE_STREAMOUTSTATS3__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__VGT_STREAMOUT_RESET__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__VGT_STREAMOUT_SYNC__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__VS_PARTIAL_FLUSH__SHIFT = 0x0000001e;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__CACHE_FLUSH_AND_INV_EVENT__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__CACHE_FLUSH_AND_INV_TS_EVENT__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__FLUSH_DFSM__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__FLUSH_ES_OUTPUT__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__FLUSH_HS_OUTPUT__SHIFT = 0x00000002;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PERFCOUNTER_SAMPLE__SHIFT = 0x00000016;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PERFCOUNTER_START__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PERFCOUNTER_STOP__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PIPELINESTAT_START__SHIFT = 0x00000012;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PIPELINESTAT_STOP__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PS_PARTIAL_FLUSH__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__RESET_TO_LOWEST_VGT__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__SAMPLE_PIPELINESTAT__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__SO_VGTSTREAMOUT_FLUSH__SHIFT = 0x0000001e;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__ZPASS_DONE__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__BLOCK_CONTEXT_DONE__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__BOTTOM_OF_PIPE_TS__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__CS_DONE__SHIFT = 0x0000001e;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__DB_CACHE_FLUSH_AND_INV__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__FLUSH_AND_INV_CB_DATA_TS__SHIFT = 0x0000001a;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__FLUSH_AND_INV_CB_META__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__FLUSH_AND_INV_DB_DATA_TS__SHIFT = 0x00000016;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__FLUSH_AND_INV_DB_META__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__RESET_VTX_CNT__SHIFT = 0x00000002;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__SAMPLE_STREAMOUTSTATS__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__SC_SEND_DB_VPZ__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__SQ_NON_EVENT__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__TGID_ROLLOVER__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__VGT_FLUSH__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__CONTEXT_SUSPEND__SHIFT = 0x00000016;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__ENABLE_LEGACY_PIPELINE__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__ENABLE_NGG_PIPELINE__SHIFT = 0x0000001a;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__FLUSH_AND_INV_CB_PIXEL_DATA__SHIFT = 0x00000002;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__OFFCHIP_HS_DEALLOC__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__PIXEL_PIPE_STAT_CONTROL__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__PIXEL_PIPE_STAT_DUMP__SHIFT = 0x00000012;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__PIXEL_PIPE_STAT_RESET__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__PS_DONE__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_FINISH__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_MARKER__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_START__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_STOP__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_0__BATCH_HIST_NUM_CONTEXT_THRESHOLD__SHIFT = 0x00000017;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_0__BATCH_HIST_NUM_PRIMS_THRESHOLD__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_0__BIN_HIST_NUM_CONTEXT_THRESHOLD__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_0__BIN_HIST_NUM_PRIMS_THRESHOLD__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_1__BATCH_HIST_NUM_PERSISTENT_STATE_THRESHOLD__SHIFT = 0x00000005;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_1__BATCH_HIST_NUM_TRIV_REJECTED_PRIMS_THRESHOLD__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_1__BIN_HIST_NUM_PERSISTENT_STATE_THRESHOLD__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_2__BATCH_HIST_NUM_COLUMNS_PER_ROW_THRESHOLD__SHIFT = 0x0000000b;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_2__BATCH_HIST_NUM_ROWS_PER_PRIM_THRESHOLD__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_3__BATCH_HIST_NUM_PS_WAVE_BREAKS_THRESHOLD__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_TIMEOUT_COUNTER__THRESHOLD__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_0__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_1__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_2__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_3__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_4__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_5__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_6__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_7__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_8__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_9__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_10__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_11__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_12__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_13__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_14__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_15__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_CLIPRECT_0_BR__BR_X__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_0_BR__BR_Y__SHIFT         = 0x00000010;
constexpr unsigned int PA_SC_CLIPRECT_0_TL__TL_X__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_0_TL__TL_Y__SHIFT         = 0x00000010;
constexpr unsigned int PA_SC_CLIPRECT_1_BR__BR_X__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_1_BR__BR_Y__SHIFT         = 0x00000010;
constexpr unsigned int PA_SC_CLIPRECT_1_TL__TL_X__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_1_TL__TL_Y__SHIFT         = 0x00000010;
constexpr unsigned int PA_SC_CLIPRECT_2_BR__BR_X__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_2_BR__BR_Y__SHIFT         = 0x00000010;
constexpr unsigned int PA_SC_CLIPRECT_2_TL__TL_X__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_2_TL__TL_Y__SHIFT         = 0x00000010;
constexpr unsigned int PA_SC_CLIPRECT_3_BR__BR_X__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_3_BR__BR_Y__SHIFT         = 0x00000010;
constexpr unsigned int PA_SC_CLIPRECT_3_TL__TL_X__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_3_TL__TL_Y__SHIFT         = 0x00000010;
constexpr unsigned int PA_SC_CLIPRECT_RULE__CLIP_RULE__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__CENTROID_SAMPLE_OVERRIDE__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__COVERAGE_AA_MASK_ENABLE__SHIFT = 0x00000015;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__DEGENERATE_OVERRIDE_INNER_TO_NORMAL_DISABLE__SHIFT = 0x0000000f;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__INNER_UNCERTAINTY_EDGERULE_OVERRIDE__SHIFT = 0x00000013;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__NULL_SQUAD_AA_MASK_ENABLE__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OUTER_UNCERTAINTY_EDGERULE_OVERRIDE__SHIFT = 0x00000012;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OVERRIDE_OVER_RAST_INNER_TO_NORMAL__SHIFT = 0x0000000d;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OVERRIDE_UNDER_RAST_INNER_TO_NORMAL__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OVER_RAST_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OVER_RAST_SAMPLE_SELECT__SHIFT = 0x00000001;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__PBB_UNCERTAINTY_REGION_ENABLE__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__POSTZ_AA_MASK_ENABLE__SHIFT = 0x00000017;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__PREZ_AA_MASK_ENABLE__SHIFT = 0x00000016;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNCERTAINTY_REGION_MODE__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNDER_RAST_ENABLE__SHIFT = 0x00000005;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNDER_RAST_SAMPLE_SELECT__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__ZMM_TRI_EXTENT__SHIFT = 0x0000000b;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__ZMM_TRI_OFFSET__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_DEBUG_DATA__DATA__SHIFT            = 0x00000000;
constexpr unsigned int PA_SC_DSM_CNTL__FORCE_EOV_REZ_0__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_DSM_CNTL__FORCE_EOV_REZ_1__SHIFT   = 0x00000001;
constexpr unsigned int PA_SC_EDGERULE__ER_LINE_BT__SHIFT        = 0x0000001c;
constexpr unsigned int PA_SC_EDGERULE__ER_LINE_LR__SHIFT        = 0x0000000c;
constexpr unsigned int PA_SC_EDGERULE__ER_LINE_RL__SHIFT        = 0x00000012;
constexpr unsigned int PA_SC_EDGERULE__ER_LINE_TB__SHIFT        = 0x00000018;
constexpr unsigned int PA_SC_EDGERULE__ER_POINT__SHIFT          = 0x00000004;
constexpr unsigned int PA_SC_EDGERULE__ER_RECT__SHIFT           = 0x00000008;
constexpr unsigned int PA_SC_EDGERULE__ER_TRI__SHIFT            = 0x00000000;
constexpr unsigned int PA_SC_ENHANCE_1__BYPASS_PBB__SHIFT       = 0x00000004;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_FORCE_SOP_ALL_EVENTS__SHIFT = 0x00000013;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PACKER_ODC_ENHANCE__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PBB_BINNING_CLK_OPTIMIZATION__SHIFT = 0x00000016;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PBB_CLK_OPTIMIZATION__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PBB_SCISSOR_CLK_OPTIMIZATION__SHIFT = 0x00000015;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PBB_SCISSOR_OPT__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_BINNING__SHIFT = 0x00000003;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_DB_TILE_INTF_FINE_CLOCK_GATE__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_PIPELINE_RESET_LEGACY_MODE_TRANSITION__SHIFT = 0x0000000f;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_PROCESS_RESET_PBB__SHIFT = 0x00000009;
constexpr unsigned int PA_SC_ENHANCE_1__ECO_SPARE0__SHIFT       = 0x00000005;
constexpr unsigned int PA_SC_ENHANCE_1__ECO_SPARE1__SHIFT       = 0x00000006;
constexpr unsigned int PA_SC_ENHANCE_1__ECO_SPARE2__SHIFT       = 0x00000007;
constexpr unsigned int PA_SC_ENHANCE_1__ECO_SPARE3__SHIFT       = 0x00000008;
constexpr unsigned int PA_SC_ENHANCE_1__ENABLE_DFSM_FLUSH_EVENT_TO_FLUSH_POPS_CAM__SHIFT = 0x0000000b;
constexpr unsigned int PA_SC_ENHANCE_1__OPTIMAL_BIN_SELECTION__SHIFT = 0x00000012;
constexpr unsigned int PA_SC_ENHANCE_1__REALIGN_DQUADS_OVERRIDE_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_ENHANCE_1__REALIGN_DQUADS_OVERRIDE__SHIFT = 0x00000001;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_AA_MASK_FULL_FIX__SHIFT = 0x00000002;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_DUALGRAD_PERF_OPTIMIZATION__SHIFT = 0x00000007;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_EOP_LINE_STIPPLE_RESET__SHIFT = 0x0000001a;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_EOV_ALL_CTRL_ONLY_COMBINATIONS__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OOO_NO_EOPG_SKEW_DESIRED_FIFO_IS_CURRENT_FIFO__SHIFT = 0x00000017;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_DESIRED_FIFO_EMPTY_SWITCHING__SHIFT = 0x00000013;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_EMPTY_SWITCHING_HYSTERYSIS__SHIFT = 0x00000015;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_EOP_SYNC_NULL_PRIMS_LAST__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_PA_SC_GUIDANCE__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_SELECTED_FIFO_EMPTY_SWITCHING__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_THRESHOLD_SWITCHING__SHIFT = 0x00000011;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_PA_SC_GUIDANCE__SHIFT = 0x0000000b;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SCISSOR_FIX__SHIFT = 0x00000005;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SC_DB_TILE_FIX__SHIFT = 0x00000001;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SC_PROCESS_RESET_PRIM__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SC_PROCESS_RESET_SUPERTILE__SHIFT = 0x00000009;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SC_PROCESS_RESET_TILE__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_VPZ_EOP_LINE_STIPPLE_RESET__SHIFT = 0x0000001b;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_1XMSAA_SAMPLE_LOCATIONS__SHIFT = 0x00000003;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_1XMSAA_SAMPLE_LOC_CENTROID__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_MULTICYCLE_BUBBLE_FREEZE__SHIFT = 0x0000000d;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_OUT_OF_ORDER_DESIRED_FIFO_IS_NEXT_FEID__SHIFT = 0x00000016;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_OUT_OF_ORDER_POLY_MODE__SHIFT = 0x0000000f;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_OUT_OF_ORDER_THRESHOLD_SWITCH_AT_EOPG_ONLY__SHIFT = 0x00000012;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_PA_SC_OUT_OF_ORDER__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_ENHANCE__IOO_DISABLE_SCAN_UNSELECTED_FIFOS_FOR_DUAL_GFX_RING_CHANGE__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_ENHANCE__OOO_DISABLE_EOPG_SKEW_THRESHOLD_SWITCHING__SHIFT = 0x00000019;
constexpr unsigned int PA_SC_ENHANCE__OOO_DISABLE_EOP_ON_FIRST_LIVE_PRIM_HIT__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_ENHANCE__OOO_USE_ABSOLUTE_FIFO_COUNT_IN_THRESHOLD_SWITCHING__SHIFT = 0x0000001d;
constexpr unsigned int PA_SC_ENHANCE__SEND_UNLIT_STILES_TO_PACKER__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_FIFO_DEPTH_CNTL__DEPTH__SHIFT      = 0x00000000;
constexpr unsigned int PA_SC_FIFO_SIZE__SC_BACKEND_PRIM_FIFO_SIZE__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_FIFO_SIZE__SC_EARLYZ_TILE_FIFO_SIZE__SHIFT = 0x00000015;
constexpr unsigned int PA_SC_FIFO_SIZE__SC_FRONTEND_PRIM_FIFO_SIZE__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_FIFO_SIZE__SC_HIZ_TILE_FIFO_SIZE__SHIFT = 0x0000000f;
constexpr unsigned int PA_SC_FORCE_EOV_MAX_CNTS__FORCE_EOV_MAX_CLK_CNT__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_FORCE_EOV_MAX_CNTS__FORCE_EOV_MAX_REZ_CNT__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_GENERIC_SCISSOR_BR__BR_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_GENERIC_SCISSOR_BR__BR_Y__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_GENERIC_SCISSOR_TL__TL_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_GENERIC_SCISSOR_TL__TL_Y__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_GENERIC_SCISSOR_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_COUNT__COUNT__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_HV_EN__ENABLE_HV_PRE_SHADER__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_HV_EN__FORCE_PRE_SHADER_ALL_PIXELS__SHIFT = 0x00000001;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_HV_LOCK__DISABLE_NON_PRIV_WRITES__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_H__X_COORD__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_OCCURRENCE__COUNT__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_V__Y_COORD__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_IF_FIFO_SIZE__SC_BCI_IF_FIFO_SIZE__SHIFT = 0x00000012;
constexpr unsigned int PA_SC_IF_FIFO_SIZE__SC_DB_QUAD_IF_FIFO_SIZE__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_IF_FIFO_SIZE__SC_DB_TILE_IF_FIFO_SIZE__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_IF_FIFO_SIZE__SC_SPI_IF_FIFO_SIZE__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_LINE_CNTL__DX10_DIAMOND_TEST_ENA__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_LINE_CNTL__EXPAND_LINE_WIDTH__SHIFT = 0x00000009;
constexpr unsigned int PA_SC_LINE_CNTL__LAST_PIXEL__SHIFT       = 0x0000000a;
constexpr unsigned int PA_SC_LINE_CNTL__PERPENDICULAR_ENDCAP_ENA__SHIFT = 0x0000000b;
constexpr unsigned int PA_SC_LINE_STIPPLE_STATE__CURRENT_COUNT__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_LINE_STIPPLE_STATE__CURRENT_PTR__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_LINE_STIPPLE__AUTO_RESET_CNTL__SHIFT = 0x0000001d;
constexpr unsigned int PA_SC_LINE_STIPPLE__LINE_PATTERN__SHIFT  = 0x00000000;
constexpr unsigned int PA_SC_LINE_STIPPLE__PATTERN_BIT_ORDER__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_LINE_STIPPLE__REPEAT_COUNT__SHIFT  = 0x00000010;
constexpr unsigned int PA_SC_MODE_CNTL_0__ALTERNATE_RBS_PER_TILE__SHIFT = 0x00000005;
constexpr unsigned int PA_SC_MODE_CNTL_0__COARSE_TILE_STARTS_ON_EVEN_RB__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_MODE_CNTL_0__LINE_STIPPLE_ENABLE__SHIFT = 0x00000002;
constexpr unsigned int PA_SC_MODE_CNTL_0__MSAA_ENABLE__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_MODE_CNTL_0__SEND_UNLIT_STILES_TO_PKR__SHIFT = 0x00000003;
constexpr unsigned int PA_SC_MODE_CNTL_0__VPORT_SCISSOR_ENABLE__SHIFT = 0x00000001;
constexpr unsigned int PA_SC_MODE_CNTL_1__FORCE_EOV_CNTDWN_ENABLE__SHIFT = 0x00000019;
constexpr unsigned int PA_SC_MODE_CNTL_1__FORCE_EOV_REZ_ENABLE__SHIFT = 0x0000001a;
constexpr unsigned int PA_SC_MODE_CNTL_1__GPU_ID_OVERRIDE_ENABLE__SHIFT = 0x00000013;
constexpr unsigned int PA_SC_MODE_CNTL_1__GPU_ID_OVERRIDE__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_MODE_CNTL_1__KILL_PIX_POST_DETAIL_MASK__SHIFT = 0x0000000f;
constexpr unsigned int PA_SC_MODE_CNTL_1__KILL_PIX_POST_HI_Z__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_MODE_CNTL_1__MULTI_GPU_PRIM_DISCARD_ENABLE__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_MODE_CNTL_1__MULTI_GPU_SUPERTILE_ENABLE__SHIFT = 0x00000012;
constexpr unsigned int PA_SC_MODE_CNTL_1__MULTI_SHADER_ENGINE_PRIM_DISCARD_ENABLE__SHIFT = 0x00000011;
constexpr unsigned int PA_SC_MODE_CNTL_1__OUT_OF_ORDER_PRIMITIVE_ENABLE__SHIFT = 0x0000001b;
constexpr unsigned int PA_SC_MODE_CNTL_1__OUT_OF_ORDER_WATER_MARK__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_MODE_CNTL_1__PS_ITER_SAMPLE__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_MODE_CNTL_1__SUPERTILE_WALK_ORDER_ENABLE__SHIFT = 0x00000007;
constexpr unsigned int PA_SC_MODE_CNTL_1__TILE_COVER_DISABLE__SHIFT = 0x00000009;
constexpr unsigned int PA_SC_MODE_CNTL_1__TILE_COVER_NO_SCISSOR__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_MODE_CNTL_1__TILE_WALK_ORDER_ENABLE__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_ALIGN8_PRIM_FITS_ST__SHIFT = 0x00000002;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_ALIGNMENT__SHIFT = 0x00000001;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_FENCE_ENABLE__SHIFT = 0x00000003;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_FENCE_SIZE__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_SIZE__SHIFT      = 0x00000000;
constexpr unsigned int PA_SC_MODE_CNTL_1__ZMM_LINE_EXTENT__SHIFT = 0x0000000b;
constexpr unsigned int PA_SC_MODE_CNTL_1__ZMM_LINE_OFFSET__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_MODE_CNTL_1__ZMM_RECT_EXTENT__SHIFT = 0x0000000d;
constexpr unsigned int PA_SC_NGG_MODE_CNTL__MAX_DEALLOCS_IN_WAVE__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_COUNT__COUNT__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_HV_EN__ENABLE_HV_PRE_SHADER__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_HV_EN__FORCE_PRE_SHADER_ALL_PIXELS__SHIFT = 0x00000001;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_HV_LOCK__DISABLE_NON_PRIV_WRITES__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_H__X_COORD__SHIFT  = 0x00000000;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_OCCURRENCE__COUNT__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_V__Y_COORD__SHIFT  = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER4_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER4_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER4_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER5_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER5_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER5_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER6_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER6_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER6_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER7_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER7_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER7_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_PKR_WAVE_TABLE_CNTL__SIZE__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_RASTER_CONFIG_1__SE_PAIR_MAP__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_RASTER_CONFIG_1__SE_PAIR_XSEL__SHIFT = 0x00000002;
constexpr unsigned int PA_SC_RASTER_CONFIG__PKR_MAP__SHIFT      = 0x00000008;
constexpr unsigned int PA_SC_RASTER_CONFIG__PKR_XSEL2__SHIFT    = 0x0000000e;
constexpr unsigned int PA_SC_RASTER_CONFIG__PKR_XSEL__SHIFT     = 0x0000000a;
constexpr unsigned int PA_SC_RASTER_CONFIG__PKR_YSEL__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_MAP_PKR0__SHIFT  = 0x00000000;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_MAP_PKR1__SHIFT  = 0x00000002;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_XSEL2__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_XSEL__SHIFT      = 0x00000006;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_YSEL__SHIFT      = 0x00000007;
constexpr unsigned int PA_SC_RASTER_CONFIG__SC_MAP__SHIFT       = 0x00000010;
constexpr unsigned int PA_SC_RASTER_CONFIG__SC_XSEL__SHIFT      = 0x00000012;
constexpr unsigned int PA_SC_RASTER_CONFIG__SC_YSEL__SHIFT      = 0x00000014;
constexpr unsigned int PA_SC_RASTER_CONFIG__SE_MAP__SHIFT       = 0x00000018;
constexpr unsigned int PA_SC_RASTER_CONFIG__SE_XSEL__SHIFT      = 0x0000001a;
constexpr unsigned int PA_SC_SCREEN_EXTENT_CONTROL__SLICE_EVEN_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_SCREEN_EXTENT_CONTROL__SLICE_ODD_ENABLE__SHIFT = 0x00000002;
constexpr unsigned int PA_SC_SCREEN_EXTENT_MAX_0__X__SHIFT      = 0x00000000;
constexpr unsigned int PA_SC_SCREEN_EXTENT_MAX_0__Y__SHIFT      = 0x00000010;
constexpr unsigned int PA_SC_SCREEN_EXTENT_MAX_1__X__SHIFT      = 0x00000000;
constexpr unsigned int PA_SC_SCREEN_EXTENT_MAX_1__Y__SHIFT      = 0x00000010;
constexpr unsigned int PA_SC_SCREEN_EXTENT_MIN_0__X__SHIFT      = 0x00000000;
constexpr unsigned int PA_SC_SCREEN_EXTENT_MIN_0__Y__SHIFT      = 0x00000010;
constexpr unsigned int PA_SC_SCREEN_EXTENT_MIN_1__X__SHIFT      = 0x00000000;
constexpr unsigned int PA_SC_SCREEN_EXTENT_MIN_1__Y__SHIFT      = 0x00000010;
constexpr unsigned int PA_SC_SCREEN_SCISSOR_BR__BR_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_SCREEN_SCISSOR_BR__BR_Y__SHIFT     = 0x00000010;
constexpr unsigned int PA_SC_SCREEN_SCISSOR_TL__TL_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_SCREEN_SCISSOR_TL__TL_Y__SHIFT     = 0x00000010;
constexpr unsigned int PA_SC_SHADER_CONTROL__LOAD_COLLISION_WAVEID__SHIFT = 0x00000002;
constexpr unsigned int PA_SC_SHADER_CONTROL__LOAD_INTRAWAVE_COLLISION__SHIFT = 0x00000003;
constexpr unsigned int PA_SC_SHADER_CONTROL__REALIGN_DQUADS_AFTER_N_WAVES__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__ONE_RB_MODE_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__RB_SELECT__SHIFT = 0x00000005;
constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__SE_SELECT__SHIFT = 0x00000001;
constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__ENABLE__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__NUM_RB_PER_SE__SHIFT = 0x00000005;
constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__NUM_SE__SHIFT = 0x00000001;
constexpr unsigned int PA_SC_TRAP_SCREEN_COUNT__COUNT__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_TRAP_SCREEN_HV_EN__ENABLE_HV_PRE_SHADER__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_TRAP_SCREEN_HV_EN__FORCE_PRE_SHADER_ALL_PIXELS__SHIFT = 0x00000001;
constexpr unsigned int PA_SC_TRAP_SCREEN_HV_LOCK__DISABLE_NON_PRIV_WRITES__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_TRAP_SCREEN_H__X_COORD__SHIFT      = 0x00000000;
constexpr unsigned int PA_SC_TRAP_SCREEN_OCCURRENCE__COUNT__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_TRAP_SCREEN_V__Y_COORD__SHIFT      = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_0_BR__BR_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_0_BR__BR_Y__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_0_TL__TL_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_0_TL__TL_Y__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_0_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_1_BR__BR_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_1_BR__BR_Y__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_1_TL__TL_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_1_TL__TL_Y__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_1_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_2_BR__BR_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_2_BR__BR_Y__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_2_TL__TL_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_2_TL__TL_Y__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_2_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_3_BR__BR_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_3_BR__BR_Y__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_3_TL__TL_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_3_TL__TL_Y__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_3_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_4_BR__BR_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_4_BR__BR_Y__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_4_TL__TL_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_4_TL__TL_Y__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_4_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_5_BR__BR_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_5_BR__BR_Y__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_5_TL__TL_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_5_TL__TL_Y__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_5_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_6_BR__BR_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_6_BR__BR_Y__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_6_TL__TL_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_6_TL__TL_Y__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_6_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_7_BR__BR_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_7_BR__BR_Y__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_7_TL__TL_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_7_TL__TL_Y__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_7_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_8_BR__BR_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_8_BR__BR_Y__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_8_TL__TL_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_8_TL__TL_Y__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_8_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_9_BR__BR_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_9_BR__BR_Y__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_9_TL__TL_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_9_TL__TL_Y__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_9_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_10_BR__BR_X__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_10_BR__BR_Y__SHIFT   = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_10_TL__TL_X__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_10_TL__TL_Y__SHIFT   = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_10_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_11_BR__BR_X__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_11_BR__BR_Y__SHIFT   = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_11_TL__TL_X__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_11_TL__TL_Y__SHIFT   = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_11_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_12_BR__BR_X__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_12_BR__BR_Y__SHIFT   = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_12_TL__TL_X__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_12_TL__TL_Y__SHIFT   = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_12_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_13_BR__BR_X__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_13_BR__BR_Y__SHIFT   = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_13_TL__TL_X__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_13_TL__TL_Y__SHIFT   = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_13_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_14_BR__BR_X__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_14_BR__BR_Y__SHIFT   = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_14_TL__TL_X__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_14_TL__TL_Y__SHIFT   = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_14_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_15_BR__BR_X__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_15_BR__BR_Y__SHIFT   = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_15_TL__TL_X__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_15_TL__TL_Y__SHIFT   = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_15_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_ZMAX_0__VPORT_ZMAX__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_1__VPORT_ZMAX__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_2__VPORT_ZMAX__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_3__VPORT_ZMAX__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_4__VPORT_ZMAX__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_5__VPORT_ZMAX__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_6__VPORT_ZMAX__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_7__VPORT_ZMAX__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_8__VPORT_ZMAX__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_9__VPORT_ZMAX__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_10__VPORT_ZMAX__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_11__VPORT_ZMAX__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_12__VPORT_ZMAX__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_13__VPORT_ZMAX__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_14__VPORT_ZMAX__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_15__VPORT_ZMAX__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_0__VPORT_ZMIN__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_1__VPORT_ZMIN__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_2__VPORT_ZMIN__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_3__VPORT_ZMIN__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_4__VPORT_ZMIN__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_5__VPORT_ZMIN__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_6__VPORT_ZMIN__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_7__VPORT_ZMIN__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_8__VPORT_ZMIN__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_9__VPORT_ZMIN__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_10__VPORT_ZMIN__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_11__VPORT_ZMIN__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_12__VPORT_ZMIN__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_13__VPORT_ZMIN__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_14__VPORT_ZMIN__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_15__VPORT_ZMIN__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_WINDOW_OFFSET__WINDOW_X_OFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_WINDOW_OFFSET__WINDOW_Y_OFFSET__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_WINDOW_SCISSOR_BR__BR_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_WINDOW_SCISSOR_BR__BR_Y__SHIFT     = 0x00000010;
constexpr unsigned int PA_SC_WINDOW_SCISSOR_TL__TL_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_WINDOW_SCISSOR_TL__TL_Y__SHIFT     = 0x00000010;
constexpr unsigned int PA_SC_WINDOW_SCISSOR_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SIDEBAND_REQUEST_DELAYS__INITIAL_DELAY__SHIFT = 0x00000010;
constexpr unsigned int PA_SIDEBAND_REQUEST_DELAYS__RETRY_DELAY__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_CNTL_STATUS__SU_BUSY__SHIFT        = 0x0000001f;
constexpr unsigned int PA_SU_DEBUG_DATA__DATA__SHIFT            = 0x00000000;
constexpr unsigned int PA_SU_HARDWARE_SCREEN_OFFSET__HW_SCREEN_OFFSET_X__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_HARDWARE_SCREEN_OFFSET__HW_SCREEN_OFFSET_Y__SHIFT = 0x00000010;
constexpr unsigned int PA_SU_LINE_CNTL__WIDTH__SHIFT            = 0x00000000;
constexpr unsigned int PA_SU_LINE_STIPPLE_CNTL__DIAMOND_ADJUST__SHIFT = 0x00000004;
constexpr unsigned int PA_SU_LINE_STIPPLE_CNTL__EXPAND_FULL_LENGTH__SHIFT = 0x00000002;
constexpr unsigned int PA_SU_LINE_STIPPLE_CNTL__FRACTIONAL_ACCUM__SHIFT = 0x00000003;
constexpr unsigned int PA_SU_LINE_STIPPLE_CNTL__LINE_STIPPLE_RESET__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_LINE_STIPPLE_SCALE__LINE_STIPPLE_SCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_LINE_STIPPLE_VALUE__LINE_STIPPLE_VALUE__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__DISCARD_0_AREA_LINES__SHIFT = 0x00000001;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__DISCARD_0_AREA_POINTS__SHIFT = 0x00000002;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__DISCARD_0_AREA_RECTANGLES__SHIFT = 0x00000003;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__DISCARD_0_AREA_TRIANGLES__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__USE_PROVOKING_ZW__SHIFT = 0x00000004;
constexpr unsigned int PA_SU_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_POINT_MINMAX__MAX_SIZE__SHIFT      = 0x00000010;
constexpr unsigned int PA_SU_POINT_MINMAX__MIN_SIZE__SHIFT      = 0x00000000;
constexpr unsigned int PA_SU_POINT_SIZE__HEIGHT__SHIFT          = 0x00000000;
constexpr unsigned int PA_SU_POINT_SIZE__WIDTH__SHIFT           = 0x00000010;
constexpr unsigned int PA_SU_POLY_OFFSET_BACK_OFFSET__OFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_POLY_OFFSET_BACK_SCALE__SCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_POLY_OFFSET_CLAMP__CLAMP__SHIFT    = 0x00000000;
constexpr unsigned int PA_SU_POLY_OFFSET_DB_FMT_CNTL__POLY_OFFSET_DB_IS_FLOAT_FMT__SHIFT = 0x00000008;
constexpr unsigned int PA_SU_POLY_OFFSET_DB_FMT_CNTL__POLY_OFFSET_NEG_NUM_DB_BITS__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_POLY_OFFSET_FRONT_OFFSET__OFFSET__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_POLY_OFFSET_FRONT_SCALE__SCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__LINE_EXPAND_ENA__SHIFT = 0x00000005;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__LINE_FILTER_DISABLE__SHIFT = 0x00000001;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__POINT_EXPAND_ENA__SHIFT = 0x00000006;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__POINT_FILTER_DISABLE__SHIFT = 0x00000002;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__PRIM_EXPAND_CONSTANT__SHIFT = 0x00000008;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__RECTANGLE_EXPAND_ENA__SHIFT = 0x00000007;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__RECTANGLE_FILTER_DISABLE__SHIFT = 0x00000003;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__TRIANGLE_EXPAND_ENA__SHIFT = 0x00000004;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__TRIANGLE_FILTER_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__XMAX_RIGHT_EXCLUSION__SHIFT = 0x0000001e;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__YMAX_BOTTOM_EXCLUSION__SHIFT = 0x0000001f;
constexpr unsigned int PA_SU_SC_MODE_CNTL__CULL_BACK__SHIFT     = 0x00000001;
constexpr unsigned int PA_SU_SC_MODE_CNTL__CULL_FRONT__SHIFT    = 0x00000000;
constexpr unsigned int PA_SU_SC_MODE_CNTL__FACE__SHIFT          = 0x00000002;
constexpr unsigned int PA_SU_SC_MODE_CNTL__MULTI_PRIM_IB_ENA__SHIFT = 0x00000015;
constexpr unsigned int PA_SU_SC_MODE_CNTL__NEW_QUAD_DECOMPOSITION__SHIFT = 0x00000017;
constexpr unsigned int PA_SU_SC_MODE_CNTL__PERSP_CORR_DIS__SHIFT = 0x00000014;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLYMODE_BACK_PTYPE__SHIFT = 0x00000008;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLYMODE_FRONT_PTYPE__SHIFT = 0x00000005;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLY_MODE__SHIFT     = 0x00000003;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLY_OFFSET_BACK_ENABLE__SHIFT = 0x0000000c;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLY_OFFSET_FRONT_ENABLE__SHIFT = 0x0000000b;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLY_OFFSET_PARA_ENABLE__SHIFT = 0x0000000d;
constexpr unsigned int PA_SU_SC_MODE_CNTL__PROVOKING_VTX_LAST__SHIFT = 0x00000013;
constexpr unsigned int PA_SU_SC_MODE_CNTL__RIGHT_TRIANGLE_ALTERNATE_GRADIENT_REF__SHIFT = 0x00000016;
constexpr unsigned int PA_SU_SC_MODE_CNTL__VTX_WINDOW_OFFSET_ENABLE__SHIFT = 0x00000010;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__LINE_FILTER_DISABLE__SHIFT = 0x00000002;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__POINT_FILTER_DISABLE__SHIFT = 0x00000003;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__RECTANGLE_FILTER_DISABLE__SHIFT = 0x00000004;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__SMALL_PRIM_FILTER_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__TRIANGLE_FILTER_DISABLE__SHIFT = 0x00000001;
constexpr unsigned int PA_SU_VTX_CNTL__PIX_CENTER__SHIFT        = 0x00000000;
constexpr unsigned int PA_SU_VTX_CNTL__QUANT_MODE__SHIFT        = 0x00000003;
constexpr unsigned int PA_SU_VTX_CNTL__ROUND_MODE__SHIFT        = 0x00000001;
constexpr unsigned int port_a_addr__Index__SHIFT                = 0x00000000;
constexpr unsigned int port_a_addr__ReadEnable__SHIFT           = 0x0000001f;
constexpr unsigned int port_a_addr__Reserved__SHIFT             = 0x00000008;
constexpr unsigned int port_a_data_hi__Data__SHIFT              = 0x00000000;
constexpr unsigned int port_a_data_lo__Data__SHIFT              = 0x00000000;
constexpr unsigned int port_b_addr__Index__SHIFT                = 0x00000000;
constexpr unsigned int port_b_addr__ReadEnable__SHIFT           = 0x0000001f;
constexpr unsigned int port_b_addr__Reserved__SHIFT             = 0x00000008;
constexpr unsigned int port_b_data_hi__Data__SHIFT              = 0x00000000;
constexpr unsigned int port_b_data_lo__Data__SHIFT              = 0x00000000;
constexpr unsigned int port_c_addr__Index__SHIFT                = 0x00000000;
constexpr unsigned int port_c_addr__ReadEnable__SHIFT           = 0x0000001f;
constexpr unsigned int port_c_addr__Reserved__SHIFT             = 0x00000008;
constexpr unsigned int port_c_data_hi__Data__SHIFT              = 0x00000000;
constexpr unsigned int port_c_data_lo__Data__SHIFT              = 0x00000000;
constexpr unsigned int port_d_addr__Index__SHIFT                = 0x00000000;
constexpr unsigned int port_d_addr__ReadEnable__SHIFT           = 0x0000001f;
constexpr unsigned int port_d_addr__Reserved__SHIFT             = 0x00000008;
constexpr unsigned int port_d_data_hi__Data__SHIFT              = 0x00000000;
constexpr unsigned int port_d_data_lo__Data__SHIFT              = 0x00000000;
constexpr unsigned int RLC_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int RLC_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int RLC_PERFCOUNTER0_SELECT__PERFCOUNTER_SELECT__SHIFT = 0x00000000;
constexpr unsigned int RLC_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int RLC_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int RLC_PERFCOUNTER1_SELECT__PERFCOUNTER_SELECT__SHIFT = 0x00000000;
constexpr unsigned int RLC_PERFMON_CLK_CNTL__PERFMON_CLOCK_STATE__SHIFT = 0x00000000;
constexpr unsigned int RLC_PERFMON_CNTL__PERFMON_SAMPLE_ENABLE__SHIFT = 0x0000000a;
constexpr unsigned int RLC_PERFMON_CNTL__PERFMON_STATE__SHIFT   = 0x00000000;
constexpr unsigned int RLC_SPM_DEBUG_SELECT__RESERVED__SHIFT    = 0x00000008;
constexpr unsigned int RLC_SPM_DEBUG_SELECT__SELECT__SHIFT      = 0x00000000;
constexpr unsigned int RLC_SPM_GLOBAL_MUXSEL_ADDR__PERFMON_SEL_ADDR__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_GLOBAL_MUXSEL_DATA__PERFMON_SEL_DATA__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_INT_CNTL__RESERVED__SHIFT        = 0x00000001;
constexpr unsigned int RLC_SPM_INT_CNTL__RLC_SPM_INT_CNTL__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_INT_STATUS__RESERVED__SHIFT      = 0x00000001;
constexpr unsigned int RLC_SPM_INT_STATUS__RLC_SPM_INT_STATUS__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_POLICY__SHIFT   = 0x00000004;
constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_VMID__SHIFT     = 0x00000000;
constexpr unsigned int RLC_SPM_PERFMON_CNTL__PERFMON_RING_MODE__SHIFT = 0x0000000c;
constexpr unsigned int RLC_SPM_PERFMON_CNTL__PERFMON_SAMPLE_INTERVAL__SHIFT = 0x00000010;
constexpr unsigned int RLC_SPM_PERFMON_CNTL__RESERVED__SHIFT    = 0x0000000e;
constexpr unsigned int RLC_SPM_PERFMON_RING_BASE_HI__RESERVED__SHIFT = 0x00000010;
constexpr unsigned int RLC_SPM_PERFMON_RING_BASE_HI__RING_BASE_HI__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_PERFMON_RING_BASE_LO__RING_BASE_LO__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_PERFMON_RING_SIZE__RING_BASE_SIZE__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__GLOBAL_NUM_LINE__SHIFT = 0x0000000b;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__PERFMON_SEGMENT_SIZE__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__RESERVED1__SHIFT = 0x00000008;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__RESERVED__SHIFT = 0x0000001f;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__SE0_NUM_LINE__SHIFT = 0x00000010;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__SE1_NUM_LINE__SHIFT = 0x00000015;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__SE2_NUM_LINE__SHIFT = 0x0000001a;
constexpr unsigned int RLC_SPM_RING_RDPTR__PERFMON_RING_RDPTR__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_SEGMENT_THRESHOLD__NUM_SEGMENT_THRESHOLD__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_SE_MUXSEL_ADDR__PERFMON_SEL_ADDR__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_SE_MUXSEL_DATA__PERFMON_SEL_DATA__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__BYPASS__SHIFT        = 0x00000019;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__DROP_MODE__SHIFT     = 0x00000018;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__FORCE_SNOOP__SHIFT   = 0x0000001c;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__FRAG_LIMIT_MODE__SHIFT = 0x0000001b;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__INVALIDATE__SHIFT    = 0x0000001a;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__RESERVED__SHIFT      = 0x0000001e;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__XNACK_REDO_TIMER_CNT__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_UTCL1_ERROR_1__Translated_ReqErrorAddr_MSB__SHIFT = 0x00000006;
constexpr unsigned int RLC_SPM_UTCL1_ERROR_1__Translated_ReqErrorVmid__SHIFT = 0x00000002;
constexpr unsigned int RLC_SPM_UTCL1_ERROR_1__Translated_ReqError__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_UTCL1_ERROR_2__Translated_ReqErrorAddr_LSB__SHIFT = 0x00000000;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__OFF_HYSTERESIS__SHIFT = 0x00000004;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__ON_DELAY__SHIFT      = 0x00000000;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_OVERRIDE0__SHIFT = 0x0000001f;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_OVERRIDE1__SHIFT = 0x0000001e;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_OVERRIDE2__SHIFT = 0x0000001d;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_OVERRIDE3__SHIFT = 0x0000001c;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_OVERRIDE4__SHIFT = 0x0000001b;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_OVERRIDE5__SHIFT = 0x0000001a;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_OVERRIDE6__SHIFT = 0x00000019;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE0__SHIFT = 0x00000017;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE1__SHIFT = 0x00000016;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE2__SHIFT = 0x00000015;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE3__SHIFT = 0x00000014;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE4__SHIFT = 0x00000013;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE5__SHIFT = 0x00000012;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE6__SHIFT = 0x00000011;
constexpr unsigned int RMI_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE7__SHIFT = 0x00000010;
constexpr unsigned int RMI_CLOCK_CNTRL__DYN_CLK_CMN_BUSY_MASK__SHIFT = 0x00000005;
constexpr unsigned int RMI_CLOCK_CNTRL__DYN_CLK_CMN_WAKEUP_MASK__SHIFT = 0x0000000f;
constexpr unsigned int RMI_CLOCK_CNTRL__DYN_CLK_RB0_BUSY_MASK__SHIFT = 0x00000000;
constexpr unsigned int RMI_CLOCK_CNTRL__DYN_CLK_RB0_WAKEUP_MASK__SHIFT = 0x0000000a;
constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB0_BREAK_LOB_ON_IDLEIN__SHIFT = 0x00000001;
constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB0_MODE__SHIFT   = 0x0000000e;
constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB0_STALL_TIMER_OVERRIDE__SHIFT = 0x00000004;
constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB0_STALL_TIMER_START_VALUE__SHIFT = 0x00000006;
constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB0_STALL__SHIFT  = 0x00000000;
constexpr unsigned int RMI_GENERAL_CNTL1__EARLY_WRACK_DISABLE_FOR_LOOPBACK__SHIFT = 0x00000008;
constexpr unsigned int RMI_GENERAL_CNTL1__EARLY_WRACK_ENABLE_PER_MTYPE__SHIFT = 0x00000000;
constexpr unsigned int RMI_GENERAL_CNTL1__POLICY_OVERRIDE_VALUE__SHIFT = 0x00000009;
constexpr unsigned int RMI_GENERAL_CNTL1__TCIW0_64B_RD_STALL_MODE__SHIFT = 0x00000004;
constexpr unsigned int RMI_GENERAL_CNTL__BURST_DISABLE__SHIFT   = 0x00000000;
constexpr unsigned int RMI_GENERAL_CNTL__LOOPBACK_DIS_BY_REQ_TYPE__SHIFT = 0x00000015;
constexpr unsigned int RMI_GENERAL_CNTL__RB0_HARVEST_EN__SHIFT  = 0x00000013;
constexpr unsigned int RMI_GENERAL_CNTL__SKID_FIFO_0_OVERFLOW_ERROR_MASK__SHIFT = 0x0000001a;
constexpr unsigned int RMI_GENERAL_CNTL__SKID_FIFO_0_UNDERFLOW_ERROR_MASK__SHIFT = 0x0000001b;
constexpr unsigned int RMI_GENERAL_CNTL__SKID_FIFO_FREESPACE_IS_ZERO_ERROR_MASK__SHIFT = 0x0000001e;
constexpr unsigned int RMI_GENERAL_CNTL__VMID_BYPASS_ENABLE__SHIFT = 0x00000001;
constexpr unsigned int RMI_GENERAL_CNTL__XBAR_MUX_CONFIG_UPDATE__SHIFT = 0x00000019;
constexpr unsigned int RMI_GENERAL_CNTL__XBAR_MUX_CONFIG__SHIFT = 0x00000011;
constexpr unsigned int RMI_GENERAL_STATUS__GENERAL_RMI_ERRORS_COMBINED__SHIFT = 0x00000000;
constexpr unsigned int RMI_GENERAL_STATUS__RDREQ_CONSUMER_FIFO_0_BUSY__SHIFT = 0x0000000c;
constexpr unsigned int RMI_GENERAL_STATUS__RMI_SCOREBOARD_BUSY__SHIFT = 0x00000007;
constexpr unsigned int RMI_GENERAL_STATUS__RMI_UTCL1_BUSY__SHIFT = 0x00000006;
constexpr unsigned int RMI_GENERAL_STATUS__RMI_XBAR_BUSY__SHIFT = 0x00000005;
constexpr unsigned int RMI_GENERAL_STATUS__RMI_XNACK_BUSY__SHIFT = 0x00000014;
constexpr unsigned int RMI_GENERAL_STATUS__SKID_FIFO_0_OVERFLOW_ERROR__SHIFT = 0x00000001;
constexpr unsigned int RMI_GENERAL_STATUS__SKID_FIFO_0_UNDERFLOW_ERROR__SHIFT = 0x00000002;
constexpr unsigned int RMI_GENERAL_STATUS__SKID_FIFO_FREESPACE_IS_ZERO_ERROR__SHIFT = 0x0000001f;
constexpr unsigned int RMI_GENERAL_STATUS__TCIW0_PRT_FIFO_BUSY__SHIFT = 0x00000008;
constexpr unsigned int RMI_GENERAL_STATUS__TCIW_FRMTR0_BUSY__SHIFT = 0x00000009;
constexpr unsigned int RMI_GENERAL_STATUS__TCIW_RTN_FRMTR0_BUSY__SHIFT = 0x0000000a;
constexpr unsigned int RMI_GENERAL_STATUS__UTC_PROBE0_BUSY__SHIFT = 0x00000013;
constexpr unsigned int RMI_GENERAL_STATUS__WRREQ_CONSUMER_FIFO_0_BUSY__SHIFT = 0x0000000b;
constexpr unsigned int RMI_GENERAL_STATUS__XNACK_FIFO_EMPTY__SHIFT = 0x0000001d;
constexpr unsigned int RMI_GENERAL_STATUS__XNACK_FIFO_FULL__SHIFT = 0x0000001e;
constexpr unsigned int RMI_GENERAL_STATUS__XNACK_FIFO_NUM_USED__SHIFT = 0x00000015;
constexpr unsigned int RMI_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int RMI_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT = 0x00000018;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int RMI_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__EVENT_BASED_PERF_EN_SEL__SHIFT = 0x00000002;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_CNTR_SPM_SEL__SHIFT = 0x0000001a;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_COUNTER_BURST_LENGTH_THRESHOLD__SHIFT = 0x00000013;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_COUNTER_CID__SHIFT = 0x0000000a;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_COUNTER_VMID__SHIFT = 0x0000000e;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_EVENT_WINDOW_MASK0__SHIFT = 0x00000006;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_SOFT_RESET__SHIFT = 0x00000019;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__TC_PERF_EN_SEL__SHIFT = 0x00000004;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__TRANS_BASED_PERF_EN_SEL__SHIFT = 0x00000000;
constexpr unsigned int RMI_PROBE_POP_LOGIC_CNTL__EXT_LAT_FIFO_0_MAX_DEPTH__SHIFT = 0x00000000;
constexpr unsigned int RMI_PROBE_POP_LOGIC_CNTL__REDUCE_MAX_XLAT_CHAIN_SIZE_BY_2__SHIFT = 0x00000008;
constexpr unsigned int RMI_PROBE_POP_LOGIC_CNTL__XLAT_COMBINE0_DIS__SHIFT = 0x00000007;
constexpr unsigned int RMI_SCOREBOARD_CNTL__COMPLETE_RB0_FLUSH__SHIFT = 0x00000000;
constexpr unsigned int RMI_SCOREBOARD_CNTL__FORCE_VMID_INVAL_DONE_EN__SHIFT = 0x00000008;
constexpr unsigned int RMI_SCOREBOARD_CNTL__FORCE_VMID_INVAL_DONE_TIMER_START_VALUE__SHIFT = 0x00000009;
constexpr unsigned int RMI_SCOREBOARD_CNTL__REQ_IN_RE_EN_AFTER_FLUSH_RB0__SHIFT = 0x00000001;
constexpr unsigned int RMI_SCOREBOARD_CNTL__TIME_STAMP_FLUSH_RB0__SHIFT = 0x00000007;
constexpr unsigned int RMI_SCOREBOARD_CNTL__VMID_INVAL_FLUSH_TYPE_OVERRIDE_EN__SHIFT = 0x00000005;
constexpr unsigned int RMI_SCOREBOARD_CNTL__VMID_INVAL_FLUSH_TYPE_OVERRIDE_VALUE__SHIFT = 0x00000006;
constexpr unsigned int RMI_SCOREBOARD_STATUS0__CP_VMID_INV_DONE__SHIFT = 0x00000013;
constexpr unsigned int RMI_SCOREBOARD_STATUS0__CP_VMID_INV_FLUSH_TYPE__SHIFT = 0x00000014;
constexpr unsigned int RMI_SCOREBOARD_STATUS0__CP_VMID_INV_IN_PROG__SHIFT = 0x00000001;
constexpr unsigned int RMI_SCOREBOARD_STATUS0__CP_VMID_INV_REQ_VMID__SHIFT = 0x00000002;
constexpr unsigned int RMI_SCOREBOARD_STATUS0__CP_VMID_INV_UTC_DONE__SHIFT = 0x00000012;
constexpr unsigned int RMI_SCOREBOARD_STATUS0__CURRENT_SESSION_ID__SHIFT = 0x00000000;
constexpr unsigned int RMI_SCOREBOARD_STATUS0__FORCE_VMID_INV_DONE__SHIFT = 0x00000015;
constexpr unsigned int RMI_SCOREBOARD_STATUS1__COM_FLUSH_IN_PROG_RB0__SHIFT = 0x0000001e;
constexpr unsigned int RMI_SCOREBOARD_STATUS1__MULTI_VMID_INVAL_FROM_CP_DETECTED__SHIFT = 0x0000000e;
constexpr unsigned int RMI_SCOREBOARD_STATUS1__RUNNING_CNT_OVERFLOW_RB0__SHIFT = 0x0000000d;
constexpr unsigned int RMI_SCOREBOARD_STATUS1__RUNNING_CNT_RB0__SHIFT = 0x00000000;
constexpr unsigned int RMI_SCOREBOARD_STATUS1__RUNNING_CNT_UNDERFLOW_RB0__SHIFT = 0x0000000c;
constexpr unsigned int RMI_SCOREBOARD_STATUS2__COM_FLUSH_DONE_RB0__SHIFT = 0x0000001b;
constexpr unsigned int RMI_SCOREBOARD_STATUS2__SNAPSHOT_CNT_RB0__SHIFT = 0x00000000;
constexpr unsigned int RMI_SCOREBOARD_STATUS2__SNAPSHOT_CNT_UNDERFLOW_RB0__SHIFT = 0x0000000c;
constexpr unsigned int RMI_SCOREBOARD_STATUS2__TIME_STAMP_FLUSH_DONE_RB0__SHIFT = 0x0000001e;
constexpr unsigned int RMI_SCOREBOARD_STATUS2__TIME_STAMP_FLUSH_IN_PROG_RB0__SHIFT = 0x0000001c;
constexpr unsigned int RMI_SPARE_1__SPARE_BIT_9__SHIFT          = 0x00000001;
constexpr unsigned int RMI_SPARE_1__SPARE_BIT_10__SHIFT         = 0x00000002;
constexpr unsigned int RMI_SPARE_1__SPARE_BIT_11__SHIFT         = 0x00000003;
constexpr unsigned int RMI_SPARE_1__SPARE_BIT_12__SHIFT         = 0x00000004;
constexpr unsigned int RMI_SPARE_1__SPARE_BIT_13__SHIFT         = 0x00000005;
constexpr unsigned int RMI_SPARE_1__SPARE_BIT_14__SHIFT         = 0x00000006;
constexpr unsigned int RMI_SPARE_1__SPARE_BIT_15__SHIFT         = 0x00000007;
constexpr unsigned int RMI_SPARE_1__SPARE_BIT_16_1__SHIFT       = 0x00000010;
constexpr unsigned int RMI_SPARE_2__SPARE_BIT_8_2__SHIFT        = 0x00000010;
constexpr unsigned int RMI_SPARE_2__SPARE_BIT_8_3__SHIFT        = 0x00000018;
constexpr unsigned int RMI_SPARE__RMI_ARBITER_STALL_TIMER_ENABLED_ALLOW_STREAMING__SHIFT = 0x00000000;
constexpr unsigned int RMI_SPARE__SPARE_BIT_7__SHIFT            = 0x00000007;
constexpr unsigned int RMI_SUBBLOCK_STATUS0__TCIW0_INFLIGHT_CNT__SHIFT = 0x00000012;
constexpr unsigned int RMI_SUBBLOCK_STATUS0__UTC_EXT_LAT_HID_FIFO_EMPTY_PROBE0__SHIFT = 0x00000008;
constexpr unsigned int RMI_SUBBLOCK_STATUS0__UTC_EXT_LAT_HID_FIFO_FULL_PROBE0__SHIFT = 0x00000007;
constexpr unsigned int RMI_SUBBLOCK_STATUS0__UTC_EXT_LAT_HID_FIFO_NUM_USED_PROBE0__SHIFT = 0x00000000;
constexpr unsigned int RMI_SUBBLOCK_STATUS1__SKID_FIFO_0_FREE_SPACE__SHIFT = 0x00000000;
constexpr unsigned int RMI_SUBBLOCK_STATUS2__PRT_FIFO_0_NUM_USED__SHIFT = 0x00000000;
constexpr unsigned int RMI_SUBBLOCK_STATUS3__SKID_FIFO_0_FREE_SPACE_TOTAL__SHIFT = 0x00000000;
constexpr unsigned int RMI_TCIW_FORMATTER0_CNTL__ALL_FAULT_RET0_DATA__SHIFT = 0x0000001f;
constexpr unsigned int RMI_TCIW_FORMATTER0_CNTL__RMI_IN0_REORDER_DIS__SHIFT = 0x0000001d;
constexpr unsigned int RMI_TCIW_FORMATTER0_CNTL__SKID_FIFO_0_FREE_SPACE_DELTA_UPDATE__SHIFT = 0x0000001b;
constexpr unsigned int RMI_TCIW_FORMATTER0_CNTL__SKID_FIFO_0_FREE_SPACE_DELTA__SHIFT = 0x00000013;
constexpr unsigned int RMI_TCIW_FORMATTER0_CNTL__TCIW0_MAX_ALLOWED_INFLIGHT_REQ__SHIFT = 0x00000009;
constexpr unsigned int RMI_TCIW_FORMATTER0_CNTL__TCIW0_REQ_SAFE_MODE__SHIFT = 0x0000001c;
constexpr unsigned int RMI_TCIW_FORMATTER0_CNTL__WR_COMBINE0_DIS_AT_LAST_OF_BURST__SHIFT = 0x0000001e;
constexpr unsigned int RMI_TCIW_FORMATTER0_CNTL__WR_COMBINE0_DIS_OVERRIDE__SHIFT = 0x00000000;
constexpr unsigned int RMI_TCIW_FORMATTER0_CNTL__WR_COMBINE0_TIME_OUT_WINDOW__SHIFT = 0x00000001;
constexpr unsigned int RMI_UTCL1_CNTL1__CLIENTID__SHIFT         = 0x00000007;
constexpr unsigned int RMI_UTCL1_CNTL1__CLIENT_INVALIDATE_ALL_VMID__SHIFT = 0x00000019;
constexpr unsigned int RMI_UTCL1_CNTL1__ENABLE_LFIFO_PRI_ARB__SHIFT = 0x00000012;
constexpr unsigned int RMI_UTCL1_CNTL1__ENABLE_PUSH_LFIFO__SHIFT = 0x00000011;
constexpr unsigned int RMI_UTCL1_CNTL1__FORCE_4K_L2_RESP__SHIFT = 0x00000000;
constexpr unsigned int RMI_UTCL1_CNTL1__FORCE_IN_ORDER__SHIFT   = 0x0000001b;
constexpr unsigned int RMI_UTCL1_CNTL1__FORCE_MISS__SHIFT       = 0x0000001a;
constexpr unsigned int RMI_UTCL1_CNTL1__GPUVM_64K_DEF__SHIFT    = 0x00000001;
constexpr unsigned int RMI_UTCL1_CNTL1__GPUVM_PERM_MODE__SHIFT  = 0x00000002;
constexpr unsigned int RMI_UTCL1_CNTL1__REDUCE_CACHE_SIZE_BY_2__SHIFT = 0x0000001e;
constexpr unsigned int RMI_UTCL1_CNTL1__REDUCE_FIFO_DEPTH_BY_2__SHIFT = 0x0000001c;
constexpr unsigned int RMI_UTCL1_CNTL1__REG_INV_ALL_VMID__SHIFT = 0x00000017;
constexpr unsigned int RMI_UTCL1_CNTL1__REG_INV_TOGGLE__SHIFT   = 0x00000018;
constexpr unsigned int RMI_UTCL1_CNTL1__REG_INV_VMID__SHIFT     = 0x00000013;
constexpr unsigned int RMI_UTCL1_CNTL1__RESP_FAULT_MODE__SHIFT  = 0x00000005;
constexpr unsigned int RMI_UTCL1_CNTL1__RESP_MODE__SHIFT        = 0x00000003;
constexpr unsigned int RMI_UTCL1_CNTL1__USERVM_DIS__SHIFT       = 0x00000010;
constexpr unsigned int RMI_UTCL1_CNTL2__DIS_EDC__SHIFT          = 0x0000000b;
constexpr unsigned int RMI_UTCL1_CNTL2__FORCE_GPUVM_INV_ACK__SHIFT = 0x0000000f;
constexpr unsigned int RMI_UTCL1_CNTL2__FORCE_SNOOP__SHIFT      = 0x0000000e;
constexpr unsigned int RMI_UTCL1_CNTL2__GPUVM_INV_MODE__SHIFT   = 0x0000000c;
constexpr unsigned int RMI_UTCL1_CNTL2__LINE_VALID__SHIFT       = 0x0000000a;
constexpr unsigned int RMI_UTCL1_CNTL2__MTYPE_OVRD_DIS__SHIFT   = 0x00000009;
constexpr unsigned int RMI_UTCL1_CNTL2__SHOOTDOWN_OPT__SHIFT    = 0x0000000d;
constexpr unsigned int RMI_UTCL1_CNTL2__UTCL1_ARB_BURST_MODE__SHIFT = 0x00000010;
constexpr unsigned int RMI_UTCL1_CNTL2__UTCL1_DIS_DUAL_L2_REQ__SHIFT = 0x00000019;
constexpr unsigned int RMI_UTCL1_CNTL2__UTCL1_ENABLE_PERF_EVENT_RD_WR__SHIFT = 0x00000012;
constexpr unsigned int RMI_UTCL1_CNTL2__UTCL1_ENABLE_PERF_EVENT_VMID__SHIFT = 0x00000014;
constexpr unsigned int RMI_UTCL1_CNTL2__UTCL1_FORCE_FRAG_2M_TO_64K__SHIFT = 0x0000001a;
constexpr unsigned int RMI_UTCL1_CNTL2__UTCL1_PERF_EVENT_RD_WR__SHIFT = 0x00000013;
constexpr unsigned int RMI_UTCL1_CNTL2__UTCL1_PERF_EVENT_VMID__SHIFT = 0x00000015;
constexpr unsigned int RMI_UTCL1_CNTL2__UTC_SPARE__SHIFT        = 0x00000000;
constexpr unsigned int RMI_UTCL1_STATUS__FAULT_DETECTED__SHIFT  = 0x00000000;
constexpr unsigned int RMI_UTCL1_STATUS__PRT_DETECTED__SHIFT    = 0x00000002;
constexpr unsigned int RMI_UTCL1_STATUS__RETRY_DETECTED__SHIFT  = 0x00000001;
constexpr unsigned int RMI_UTC_XNACK_N_MISC_CNTL__CP_VMID_RESET_REQUEST_DISABLE__SHIFT = 0x0000000d;
constexpr unsigned int RMI_UTC_XNACK_N_MISC_CNTL__IND_XNACK_TIMER_START_VALUE__SHIFT = 0x00000008;
constexpr unsigned int RMI_UTC_XNACK_N_MISC_CNTL__MASTER_XNACK_TIMER_INC__SHIFT = 0x00000000;
constexpr unsigned int RMI_UTC_XNACK_N_MISC_CNTL__UTCL1_PERM_MODE__SHIFT = 0x0000000c;
constexpr unsigned int RMI_XBAR_ARBITER_CONFIG_1__XBAR_ARB_ROUND_ROBIN_WEIGHT_RB0_RD__SHIFT = 0x00000000;
constexpr unsigned int RMI_XBAR_ARBITER_CONFIG_1__XBAR_ARB_ROUND_ROBIN_WEIGHT_RB0_WR__SHIFT = 0x00000008;
constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB0_BREAK_LOB_ON_IDLEIN__SHIFT = 0x00000004;
constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB0_BREAK_LOB_ON_WEIGHTEDRR__SHIFT = 0x00000002;
constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB0_MODE__SHIFT = 0x00000000;
constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB0_STALL_TIMER_OVERRIDE__SHIFT = 0x00000006;
constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB0_STALL_TIMER_START_VALUE__SHIFT = 0x00000008;
constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB0_STALL__SHIFT = 0x00000003;
constexpr unsigned int RMI_XBAR_CONFIG__ARBITER_DIS__SHIFT      = 0x00000007;
constexpr unsigned int RMI_XBAR_CONFIG__XBAR_EN_IN_RB0__SHIFT   = 0x0000000d;
constexpr unsigned int RMI_XBAR_CONFIG__XBAR_EN_IN_REQ_OVERRIDE__SHIFT = 0x0000000c;
constexpr unsigned int RMI_XBAR_CONFIG__XBAR_EN_IN_REQ__SHIFT   = 0x00000008;
constexpr unsigned int RMI_XBAR_CONFIG__XBAR_MUX_CONFIG_CB_DB_OVERRIDE__SHIFT = 0x00000006;
constexpr unsigned int RMI_XBAR_CONFIG__XBAR_MUX_CONFIG_OVERRIDE__SHIFT = 0x00000000;
constexpr unsigned int RMI_XBAR_CONFIG__XBAR_MUX_CONFIG_REQ_TYPE_OVERRIDE__SHIFT = 0x00000002;
constexpr unsigned int RMI_XNACK_DEBUG__XNACK_PER_VMID__SHIFT   = 0x00000000;
constexpr unsigned int RPB_ARB_CNTL2__ATC_PAGE_SWITCH_NUM__SHIFT = 0x00000010;
constexpr unsigned int RPB_ARB_CNTL2__ATOMIC_SWITCH_NUM__SHIFT  = 0x00000008;
constexpr unsigned int RPB_ARB_CNTL2__P2P_SWITCH_NUM__SHIFT     = 0x00000000;
constexpr unsigned int RPB_ARB_CNTL__ARB_MODE__SHIFT            = 0x00000018;
constexpr unsigned int RPB_ARB_CNTL__ATC_TR_SWITCH_NUM__SHIFT   = 0x00000010;
constexpr unsigned int RPB_ARB_CNTL__RD_SWITCH_NUM__SHIFT       = 0x00000000;
constexpr unsigned int RPB_ARB_CNTL__SWITCH_NUM_MODE__SHIFT     = 0x00000019;
constexpr unsigned int RPB_ARB_CNTL__WR_SWITCH_NUM__SHIFT       = 0x00000008;
constexpr unsigned int RPB_ATS_CNTL__ATCPAGE_SWITCH_NUM__SHIFT  = 0x00000013;
constexpr unsigned int RPB_ATS_CNTL__PAGE_MIN_LATENCY_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int RPB_ATS_CNTL__SWITCH_THRESHOLD__SHIFT    = 0x00000002;
constexpr unsigned int RPB_ATS_CNTL__TIME_SLICE__SHIFT          = 0x00000007;
constexpr unsigned int RPB_ATS_CNTL__TR_MIN_LATENCY_ENABLE__SHIFT = 0x00000001;
constexpr unsigned int RPB_ATS_CNTL__WR_AT__SHIFT               = 0x00000017;
constexpr unsigned int RPB_BIF_CNTL__VC0_SWITCH_NUM__SHIFT      = 0x00000000;
constexpr unsigned int RPB_BIF_CNTL__VC1_SWITCH_NUM__SHIFT      = 0x00000008;
constexpr unsigned int RPB_BLOCKLEVEL_CONF__XPB_BLOCKLEVEL_OVERRIDE__SHIFT = 0x00000000;
constexpr unsigned int RPB_CID_QUEUE_EX_DATA__READ_ENTRIES__SHIFT = 0x00000010;
constexpr unsigned int RPB_CID_QUEUE_EX_DATA__WRITE_ENTRIES__SHIFT = 0x00000000;
constexpr unsigned int RPB_CID_QUEUE_EX__OFFSET__SHIFT          = 0x00000001;
constexpr unsigned int RPB_CID_QUEUE_EX__START__SHIFT           = 0x00000000;
constexpr unsigned int RPB_CID_QUEUE_RD__CLIENT_ID_HIGH__SHIFT  = 0x00000005;
constexpr unsigned int RPB_CID_QUEUE_RD__CLIENT_ID_LOW__SHIFT   = 0x00000000;
constexpr unsigned int RPB_CID_QUEUE_RD__READ_QUEUE__SHIFT      = 0x0000000e;
constexpr unsigned int RPB_CID_QUEUE_RD__WRITE_QUEUE__SHIFT     = 0x0000000b;
constexpr unsigned int RPB_CID_QUEUE_WR__CLIENT_ID_HIGH__SHIFT  = 0x00000005;
constexpr unsigned int RPB_CID_QUEUE_WR__CLIENT_ID_LOW__SHIFT   = 0x00000000;
constexpr unsigned int RPB_CID_QUEUE_WR__READ_QUEUE__SHIFT      = 0x0000000f;
constexpr unsigned int RPB_CID_QUEUE_WR__UPDATE_MODE__SHIFT     = 0x0000000b;
constexpr unsigned int RPB_CID_QUEUE_WR__UPDATE__SHIFT          = 0x00000012;
constexpr unsigned int RPB_CID_QUEUE_WR__WRITE_QUEUE__SHIFT     = 0x0000000c;
constexpr unsigned int RPB_DEINTRLV_COMBINE_CNTL__WC_CHAINED_BREAK_EN__SHIFT = 0x00000004;
constexpr unsigned int RPB_DEINTRLV_COMBINE_CNTL__WC_CHAINED_FLUSH_TIMER__SHIFT = 0x00000000;
constexpr unsigned int RPB_DEINTRLV_COMBINE_CNTL__WC_HANDLE_CHECK_DISABLE__SHIFT = 0x00000005;
constexpr unsigned int RPB_EA_QUEUE_WR__EA_NUMBER__SHIFT        = 0x00000000;
constexpr unsigned int RPB_EFF_CNTL__RD_LAZY_TIMER__SHIFT       = 0x00000008;
constexpr unsigned int RPB_EFF_CNTL__WR_LAZY_TIMER__SHIFT       = 0x00000000;
constexpr unsigned int RPB_PASSPW_CONF__XPB_PASSPW_OVERRIDE__SHIFT = 0x00000000;
constexpr unsigned int RPB_PASSPW_CONF__XPB_RSPPASSPW_OVERRIDE__SHIFT = 0x00000001;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__CLEAR__SHIFT       = 0x0000001d;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__ENABLE__SHIFT      = 0x0000001c;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__PERF_MODE__SHIFT   = 0x00000018;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__PERF_SEL_END__SHIFT = 0x00000008;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__PERF_SEL__SHIFT    = 0x00000000;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__CLEAR__SHIFT       = 0x0000001d;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__ENABLE__SHIFT      = 0x0000001c;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__PERF_MODE__SHIFT   = 0x00000018;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__PERF_SEL_END__SHIFT = 0x00000008;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__PERF_SEL__SHIFT    = 0x00000000;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__CLEAR__SHIFT       = 0x0000001d;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__ENABLE__SHIFT      = 0x0000001c;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__PERF_MODE__SHIFT   = 0x00000018;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__PERF_SEL_END__SHIFT = 0x00000008;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__PERF_SEL__SHIFT    = 0x00000000;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__CLEAR__SHIFT       = 0x0000001d;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__ENABLE__SHIFT      = 0x0000001c;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__PERF_MODE__SHIFT   = 0x00000018;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__PERF_SEL_END__SHIFT = 0x00000008;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__PERF_SEL__SHIFT    = 0x00000000;
constexpr unsigned int RPB_PERFCOUNTER_HI__COMPARE_VALUE__SHIFT = 0x00000010;
constexpr unsigned int RPB_PERFCOUNTER_HI__COUNTER_HI__SHIFT    = 0x00000000;
constexpr unsigned int RPB_PERFCOUNTER_LO__COUNTER_LO__SHIFT    = 0x00000000;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL__SHIFT = 0x00000019;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY__SHIFT = 0x00000018;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT__SHIFT = 0x00000000;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__START_TRIGGER__SHIFT = 0x00000008;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE__SHIFT = 0x0000001a;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER__SHIFT = 0x00000010;
constexpr unsigned int RPB_PERF_COUNTER_CNTL__PERF_COUNTER_SELECT__SHIFT = 0x00000000;
constexpr unsigned int RPB_RD_QUEUE_CNTL2__Q4_PATTERN_MASK_HIGH__SHIFT = 0x00000005;
constexpr unsigned int RPB_RD_QUEUE_CNTL2__Q4_PATTERN_MASK_LOW__SHIFT = 0x00000000;
constexpr unsigned int RPB_RD_QUEUE_CNTL2__Q5_PATTERN_MASK_HIGH__SHIFT = 0x00000010;
constexpr unsigned int RPB_RD_QUEUE_CNTL2__Q5_PATTERN_MASK_LOW__SHIFT = 0x0000000b;
constexpr unsigned int RPB_RD_QUEUE_CNTL__ARB_MODE__SHIFT       = 0x00000000;
constexpr unsigned int RPB_RD_QUEUE_CNTL__Q4_PATTERN_HIGH__SHIFT = 0x0000000a;
constexpr unsigned int RPB_RD_QUEUE_CNTL__Q4_PATTERN_LOW__SHIFT = 0x00000005;
constexpr unsigned int RPB_RD_QUEUE_CNTL__Q4_SHARED__SHIFT      = 0x00000001;
constexpr unsigned int RPB_RD_QUEUE_CNTL__Q4_UNITID_EA_MODE__SHIFT = 0x00000003;
constexpr unsigned int RPB_RD_QUEUE_CNTL__Q5_PATTERN_HIGH__SHIFT = 0x00000015;
constexpr unsigned int RPB_RD_QUEUE_CNTL__Q5_PATTERN_LOW__SHIFT = 0x00000010;
constexpr unsigned int RPB_RD_QUEUE_CNTL__Q5_SHARED__SHIFT      = 0x00000002;
constexpr unsigned int RPB_RD_QUEUE_CNTL__Q5_UNITID_EA_MODE__SHIFT = 0x00000004;
constexpr unsigned int RPB_RD_SWITCH_CNTL__QUEUE0_SWITCH_NUM__SHIFT = 0x00000000;
constexpr unsigned int RPB_RD_SWITCH_CNTL__QUEUE1_SWITCH_NUM__SHIFT = 0x00000007;
constexpr unsigned int RPB_RD_SWITCH_CNTL__QUEUE2_SWITCH_NUM__SHIFT = 0x0000000e;
constexpr unsigned int RPB_RD_SWITCH_CNTL__QUEUE3_SWITCH_NUM__SHIFT = 0x00000015;
constexpr unsigned int RPB_RD_SWITCH_CNTL__SWITCH_NUM_MODE__SHIFT = 0x0000001c;
constexpr unsigned int RPB_SDPPORT_CNTL__DF_SDPVDCI_RDRSPCKENRCV__SHIFT = 0x00000017;
constexpr unsigned int RPB_SDPPORT_CNTL__DF_SDPVDCI_RDRSPCKEN__SHIFT = 0x00000016;
constexpr unsigned int RPB_SDPPORT_CNTL__DF_SDPVDCI_RDRSPDATACKENRCV__SHIFT = 0x00000019;
constexpr unsigned int RPB_SDPPORT_CNTL__DF_SDPVDCI_RDRSPDATACKEN__SHIFT = 0x00000018;
constexpr unsigned int RPB_SDPPORT_CNTL__DF_SDPVDCI_WRRSPCKENRCV__SHIFT = 0x0000001b;
constexpr unsigned int RPB_SDPPORT_CNTL__DF_SDPVDCI_WRRSPCKEN__SHIFT = 0x0000001a;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_DMA_CFG_MODE__SHIFT = 0x00000001;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_DMA_ENABLE_DISRUPT_FULLDIS__SHIFT = 0x00000005;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_DMA_ENABLE_REISSUE_CREDIT__SHIFT = 0x00000003;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_DMA_ENABLE_SATURATE_COUNTER__SHIFT = 0x00000004;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_DMA_HALT_THRESHOLD__SHIFT = 0x00000006;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_DMA_SELF_ACTIVATE__SHIFT = 0x00000000;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_HST_CFG_MODE__SHIFT = 0x0000000b;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_HST_ENABLE_DISRUPT_FULLDIS__SHIFT = 0x0000000f;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_HST_ENABLE_REISSUE_CREDIT__SHIFT = 0x0000000d;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_HST_ENABLE_SATURATE_COUNTER__SHIFT = 0x0000000e;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_HST_HALT_THRESHOLD__SHIFT = 0x00000010;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_HST_PASSIVE_MODE__SHIFT = 0x00000014;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_HST_QUICK_COMACK__SHIFT = 0x00000015;
constexpr unsigned int RPB_SDPPORT_CNTL__NBIF_HST_SELF_ACTIVATE__SHIFT = 0x0000000a;
constexpr unsigned int RPB_SWITCH_CNTL2__RD_QUEUE4_SWITCH_NUM__SHIFT = 0x00000000;
constexpr unsigned int RPB_SWITCH_CNTL2__RD_QUEUE5_SWITCH_NUM__SHIFT = 0x00000007;
constexpr unsigned int RPB_SWITCH_CNTL2__WR_QUEUE4_SWITCH_NUM__SHIFT = 0x0000000e;
constexpr unsigned int RPB_SWITCH_CNTL2__WR_QUEUE5_SWITCH_NUM__SHIFT = 0x00000015;
constexpr unsigned int RPB_VC_SWITCH_RDWR__MODE__SHIFT          = 0x00000000;
constexpr unsigned int RPB_VC_SWITCH_RDWR__NUM_RD__SHIFT        = 0x00000002;
constexpr unsigned int RPB_VC_SWITCH_RDWR__NUM_WR__SHIFT        = 0x0000000a;
constexpr unsigned int RPB_WR_QUEUE_CNTL2__Q4_PATTERN_MASK_HIGH__SHIFT = 0x00000005;
constexpr unsigned int RPB_WR_QUEUE_CNTL2__Q4_PATTERN_MASK_LOW__SHIFT = 0x00000000;
constexpr unsigned int RPB_WR_QUEUE_CNTL2__Q5_PATTERN_MASK_HIGH__SHIFT = 0x00000010;
constexpr unsigned int RPB_WR_QUEUE_CNTL2__Q5_PATTERN_MASK_LOW__SHIFT = 0x0000000b;
constexpr unsigned int RPB_WR_QUEUE_CNTL__ARB_MODE__SHIFT       = 0x00000000;
constexpr unsigned int RPB_WR_QUEUE_CNTL__Q4_PATTERN_HIGH__SHIFT = 0x0000000a;
constexpr unsigned int RPB_WR_QUEUE_CNTL__Q4_PATTERN_LOW__SHIFT = 0x00000005;
constexpr unsigned int RPB_WR_QUEUE_CNTL__Q4_SHARED__SHIFT      = 0x00000001;
constexpr unsigned int RPB_WR_QUEUE_CNTL__Q4_UNITID_EA_MODE__SHIFT = 0x00000003;
constexpr unsigned int RPB_WR_QUEUE_CNTL__Q5_PATTERN_HIGH__SHIFT = 0x00000015;
constexpr unsigned int RPB_WR_QUEUE_CNTL__Q5_PATTERN_LOW__SHIFT = 0x00000010;
constexpr unsigned int RPB_WR_QUEUE_CNTL__Q5_SHARED__SHIFT      = 0x00000002;
constexpr unsigned int RPB_WR_QUEUE_CNTL__Q5_UNITID_EA_MODE__SHIFT = 0x00000004;
constexpr unsigned int RPB_WR_SWITCH_CNTL__QUEUE0_SWITCH_NUM__SHIFT = 0x00000000;
constexpr unsigned int RPB_WR_SWITCH_CNTL__QUEUE1_SWITCH_NUM__SHIFT = 0x00000007;
constexpr unsigned int RPB_WR_SWITCH_CNTL__QUEUE2_SWITCH_NUM__SHIFT = 0x0000000e;
constexpr unsigned int RPB_WR_SWITCH_CNTL__QUEUE3_SWITCH_NUM__SHIFT = 0x00000015;
constexpr unsigned int RPB_WR_SWITCH_CNTL__SWITCH_NUM_MODE__SHIFT = 0x0000001c;
constexpr unsigned int SCRATCH_ADDR__OBSOLETE_ADDR__SHIFT       = 0x00000000;
constexpr unsigned int SCRATCH_REG0__SCRATCH_REG0__SHIFT        = 0x00000000;
constexpr unsigned int SCRATCH_REG1__SCRATCH_REG1__SHIFT        = 0x00000000;
constexpr unsigned int SCRATCH_REG2__SCRATCH_REG2__SHIFT        = 0x00000000;
constexpr unsigned int SCRATCH_REG3__SCRATCH_REG3__SHIFT        = 0x00000000;
constexpr unsigned int SCRATCH_REG4__SCRATCH_REG4__SHIFT        = 0x00000000;
constexpr unsigned int SCRATCH_REG5__SCRATCH_REG5__SHIFT        = 0x00000000;
constexpr unsigned int SCRATCH_REG6__SCRATCH_REG6__SHIFT        = 0x00000000;
constexpr unsigned int SCRATCH_REG7__SCRATCH_REG7__SHIFT        = 0x00000000;
constexpr unsigned int SCRATCH_UMSK__OBSOLETE_SWAP__SHIFT       = 0x00000010;
constexpr unsigned int SCRATCH_UMSK__OBSOLETE_UMSK__SHIFT       = 0x00000000;
constexpr unsigned int SH_MEM_BASES__PRIVATE_BASE__SHIFT        = 0x00000000;
constexpr unsigned int SH_MEM_BASES__SHARED_BASE__SHIFT         = 0x00000010;
constexpr unsigned int SH_MEM_CONFIG__ADDRESS_MODE__SHIFT       = 0x00000000;
constexpr unsigned int SPIS_DEBUG_READ__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_ARB_CNTL_0__EXP_ARB_COL_WT__SHIFT    = 0x00000000;
constexpr unsigned int SPI_ARB_CNTL_0__EXP_ARB_GDS_WT__SHIFT    = 0x00000008;
constexpr unsigned int SPI_ARB_CNTL_0__EXP_ARB_POS_WT__SHIFT    = 0x00000004;
constexpr unsigned int SPI_ARB_CYCLES_0__TS0_DURATION__SHIFT    = 0x00000000;
constexpr unsigned int SPI_ARB_CYCLES_0__TS1_DURATION__SHIFT    = 0x00000010;
constexpr unsigned int SPI_ARB_CYCLES_1__TS2_DURATION__SHIFT    = 0x00000000;
constexpr unsigned int SPI_ARB_CYCLES_1__TS3_DURATION__SHIFT    = 0x00000010;
constexpr unsigned int SPI_ARB_PRIORITY__PIPE_ORDER_TS0__SHIFT  = 0x00000000;
constexpr unsigned int SPI_ARB_PRIORITY__PIPE_ORDER_TS1__SHIFT  = 0x00000003;
constexpr unsigned int SPI_ARB_PRIORITY__PIPE_ORDER_TS2__SHIFT  = 0x00000006;
constexpr unsigned int SPI_ARB_PRIORITY__PIPE_ORDER_TS3__SHIFT  = 0x00000009;
constexpr unsigned int SPI_ARB_PRIORITY__TS0_DUR_MULT__SHIFT    = 0x0000000c;
constexpr unsigned int SPI_ARB_PRIORITY__TS1_DUR_MULT__SHIFT    = 0x0000000e;
constexpr unsigned int SPI_ARB_PRIORITY__TS2_DUR_MULT__SHIFT    = 0x00000010;
constexpr unsigned int SPI_ARB_PRIORITY__TS3_DUR_MULT__SHIFT    = 0x00000012;
constexpr unsigned int SPI_BARYC_CNTL__FRONT_FACE_ALL_BITS__SHIFT = 0x00000018;
constexpr unsigned int SPI_BARYC_CNTL__LINEAR_CENTER_CNTL__SHIFT = 0x00000008;
constexpr unsigned int SPI_BARYC_CNTL__LINEAR_CENTROID_CNTL__SHIFT = 0x0000000c;
constexpr unsigned int SPI_BARYC_CNTL__PERSP_CENTER_CNTL__SHIFT = 0x00000000;
constexpr unsigned int SPI_BARYC_CNTL__PERSP_CENTROID_CNTL__SHIFT = 0x00000004;
constexpr unsigned int SPI_BARYC_CNTL__POS_FLOAT_LOCATION__SHIFT = 0x00000010;
constexpr unsigned int SPI_BARYC_CNTL__POS_FLOAT_ULC__SHIFT     = 0x00000014;
constexpr unsigned int SPI_COMPUTE_QUEUE_RESET__RESET__SHIFT    = 0x00000000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE__DONE_INTERRUPT_EN__SHIFT = 0x00000002;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE__GDS_INTERRUPT_EN__SHIFT = 0x00000001;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE__GDS_REQ_BUSY__SHIFT = 0x0000001e;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE__INITIATE__SHIFT = 0x00000000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE__SAVE_BUSY__SHIFT = 0x0000001f;
constexpr unsigned int SPI_CONFIG_CNTL_1__CRC_SIMD_ID_WADDR_DISABLE__SHIFT = 0x00000008;
constexpr unsigned int SPI_CONFIG_CNTL_1__CSC_PWR_SAVE_DISABLE__SHIFT = 0x0000000e;
constexpr unsigned int SPI_CONFIG_CNTL_1__CSG_PWR_SAVE_DISABLE__SHIFT = 0x0000000f;
constexpr unsigned int SPI_CONFIG_CNTL_1__INTERP_ONE_PRIM_PER_ROW__SHIFT = 0x00000004;
constexpr unsigned int SPI_CONFIG_CNTL_1__LBPW_CU_CHK_CNT__SHIFT = 0x0000000a;
constexpr unsigned int SPI_CONFIG_CNTL_1__LBPW_CU_CHK_MODE__SHIFT = 0x00000009;
constexpr unsigned int SPI_CONFIG_CNTL_1__PC_LIMIT_STRICT__SHIFT = 0x00000007;
constexpr unsigned int SPI_CONFIG_CNTL_1__VTX_DONE_DELAY__SHIFT = 0x00000000;
constexpr unsigned int SPI_CONFIG_CNTL_2__CONTEXT_SAVE_WAIT_GDS_GRANT_CYCLE_OVHD__SHIFT = 0x00000004;
constexpr unsigned int SPI_CONFIG_CNTL_2__CONTEXT_SAVE_WAIT_GDS_REQUEST_CYCLE_OVHD__SHIFT = 0x00000000;
constexpr unsigned int SPI_CONFIG_CNTL__ALLOC_ARB_LRU_ENA__SHIFT = 0x0000001c;
constexpr unsigned int SPI_CONFIG_CNTL__ENABLE_SQG_BOP_EVENTS__SHIFT = 0x00000019;
constexpr unsigned int SPI_CONFIG_CNTL__ENABLE_SQG_TOP_EVENTS__SHIFT = 0x00000018;
constexpr unsigned int SPI_CONFIG_CNTL__EXP_ARB_LRU_ENA__SHIFT  = 0x0000001d;
constexpr unsigned int SPI_CONFIG_CNTL__EXP_PRIORITY_ORDER__SHIFT = 0x00000015;
constexpr unsigned int SPI_CONFIG_CNTL__GPR_WRITE_PRIORITY__SHIFT = 0x00000000;
constexpr unsigned int SPI_CONFIG_CNTL__PS_PKR_PRIORITY_CNTL__SHIFT = 0x0000001e;
constexpr unsigned int SPI_CONFIG_CNTL__TTRACE_STALL_ALL__SHIFT = 0x0000001b;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_0__COUNT__SHIFT  = 0x00000000;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_0__EVENTS__SHIFT = 0x00000010;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_1__COUNT__SHIFT  = 0x00000000;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_1__EVENTS__SHIFT = 0x00000010;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_2__COUNT__SHIFT  = 0x00000000;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_2__EVENTS__SHIFT = 0x00000010;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_3__COUNT__SHIFT  = 0x00000000;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_3__EVENTS__SHIFT = 0x00000010;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_STATUS__ACTIVE__SHIFT  = 0x00000000;
constexpr unsigned int SPI_DEBUG_READ__DATA__SHIFT              = 0x00000000;
constexpr unsigned int SPI_DSM_CNTL2__SPI_SR_MEM_ENABLE_ERROR_INJECT__SHIFT = 0x00000000;
constexpr unsigned int SPI_DSM_CNTL2__SPI_SR_MEM_SELECT_INJECT_DELAY__SHIFT = 0x00000002;
constexpr unsigned int SPI_DSM_CNTL__SPI_SR_MEM_DSM_IRRITATOR_DATA__SHIFT = 0x00000000;
constexpr unsigned int SPI_DSM_CNTL__SPI_SR_MEM_ENABLE_SINGLE_WRITE__SHIFT = 0x00000002;
constexpr unsigned int SPI_EDC_CNT__SPI_SR_MEM_SED_COUNT__SHIFT = 0x00000000;
constexpr unsigned int SPI_GFX_CNTL__RESET_COUNTS__SHIFT        = 0x00000000;
constexpr unsigned int SPI_INTERP_CONTROL_0__FLAT_SHADE_ENA__SHIFT = 0x00000000;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_ENA__SHIFT = 0x00000001;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_OVRD_W__SHIFT = 0x0000000b;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_OVRD_X__SHIFT = 0x00000002;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_OVRD_Y__SHIFT = 0x00000005;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_OVRD_Z__SHIFT = 0x00000008;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_TOP_1__SHIFT = 0x0000000e;
constexpr unsigned int SPI_LB_CTR_CTRL__CLEAR_ON_READ__SHIFT    = 0x00000003;
constexpr unsigned int SPI_LB_CTR_CTRL__LOAD__SHIFT             = 0x00000000;
constexpr unsigned int SPI_LB_CTR_CTRL__RESET_COUNTS__SHIFT     = 0x00000004;
constexpr unsigned int SPI_LB_CTR_CTRL__WAVES_SELECT__SHIFT     = 0x00000001;
constexpr unsigned int SPI_LB_DATA_REG__CNT_DATA__SHIFT         = 0x00000000;
constexpr unsigned int SPI_LB_DATA_WAVES__COUNT0__SHIFT         = 0x00000000;
constexpr unsigned int SPI_LB_DATA_WAVES__COUNT1__SHIFT         = 0x00000010;
constexpr unsigned int SPI_P0_TRAP_SCREEN_GPR_MIN__SGPR_MIN__SHIFT = 0x00000006;
constexpr unsigned int SPI_P0_TRAP_SCREEN_GPR_MIN__VGPR_MIN__SHIFT = 0x00000000;
constexpr unsigned int SPI_P0_TRAP_SCREEN_PSBA_HI__MEM_BASE__SHIFT = 0x00000000;
constexpr unsigned int SPI_P0_TRAP_SCREEN_PSBA_LO__MEM_BASE__SHIFT = 0x00000000;
constexpr unsigned int SPI_P0_TRAP_SCREEN_PSMA_HI__MEM_BASE__SHIFT = 0x00000000;
constexpr unsigned int SPI_P0_TRAP_SCREEN_PSMA_LO__MEM_BASE__SHIFT = 0x00000000;
constexpr unsigned int SPI_P1_TRAP_SCREEN_GPR_MIN__SGPR_MIN__SHIFT = 0x00000006;
constexpr unsigned int SPI_P1_TRAP_SCREEN_GPR_MIN__VGPR_MIN__SHIFT = 0x00000000;
constexpr unsigned int SPI_P1_TRAP_SCREEN_PSBA_HI__MEM_BASE__SHIFT = 0x00000000;
constexpr unsigned int SPI_P1_TRAP_SCREEN_PSBA_LO__MEM_BASE__SHIFT = 0x00000000;
constexpr unsigned int SPI_P1_TRAP_SCREEN_PSMA_HI__MEM_BASE__SHIFT = 0x00000000;
constexpr unsigned int SPI_P1_TRAP_SCREEN_PSMA_LO__MEM_BASE__SHIFT = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER4_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER4_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER4_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER5_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER5_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER5_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN0_MAX__SHIFT    = 0x00000004;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN0_MIN__SHIFT    = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN1_MAX__SHIFT    = 0x0000000c;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN1_MIN__SHIFT    = 0x00000008;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN2_MAX__SHIFT    = 0x00000014;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN2_MIN__SHIFT    = 0x00000010;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN3_MAX__SHIFT    = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN3_MIN__SHIFT    = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_ADDR__ANCILLARY_ENA__SHIFT  = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_ADDR__FRONT_FACE_ENA__SHIFT = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_ADDR__LINEAR_CENTER_ENA__SHIFT = 0x00000005;
constexpr unsigned int SPI_PS_INPUT_ADDR__LINEAR_CENTROID_ENA__SHIFT = 0x00000006;
constexpr unsigned int SPI_PS_INPUT_ADDR__LINEAR_SAMPLE_ENA__SHIFT = 0x00000004;
constexpr unsigned int SPI_PS_INPUT_ADDR__LINE_STIPPLE_TEX_ENA__SHIFT = 0x00000007;
constexpr unsigned int SPI_PS_INPUT_ADDR__PERSP_CENTER_ENA__SHIFT = 0x00000001;
constexpr unsigned int SPI_PS_INPUT_ADDR__PERSP_CENTROID_ENA__SHIFT = 0x00000002;
constexpr unsigned int SPI_PS_INPUT_ADDR__PERSP_PULL_MODEL_ENA__SHIFT = 0x00000003;
constexpr unsigned int SPI_PS_INPUT_ADDR__PERSP_SAMPLE_ENA__SHIFT = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_FIXED_PT_ENA__SHIFT = 0x0000000f;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_W_FLOAT_ENA__SHIFT = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_X_FLOAT_ENA__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_Y_FLOAT_ENA__SHIFT = 0x00000009;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_Z_FLOAT_ENA__SHIFT = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_ADDR__SAMPLE_COVERAGE_ENA__SHIFT = 0x0000000e;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__ATTR0_VALID__SHIFT  = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__ATTR1_VALID__SHIFT  = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__CYL_WRAP__SHIFT     = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__DEFAULT_VAL__SHIFT  = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__DUP__SHIFT          = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__FLAT_SHADE__SHIFT   = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__OFFSET__SHIFT       = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__PT_SPRITE_TEX_ATTR1__SHIFT = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__PT_SPRITE_TEX__SHIFT = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__ATTR0_VALID__SHIFT  = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__ATTR1_VALID__SHIFT  = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__CYL_WRAP__SHIFT     = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__DEFAULT_VAL__SHIFT  = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__DUP__SHIFT          = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__FLAT_SHADE__SHIFT   = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__OFFSET__SHIFT       = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__PT_SPRITE_TEX_ATTR1__SHIFT = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__PT_SPRITE_TEX__SHIFT = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__ATTR0_VALID__SHIFT  = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__ATTR1_VALID__SHIFT  = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__CYL_WRAP__SHIFT     = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__DEFAULT_VAL__SHIFT  = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__DUP__SHIFT          = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__FLAT_SHADE__SHIFT   = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__OFFSET__SHIFT       = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__PT_SPRITE_TEX_ATTR1__SHIFT = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__PT_SPRITE_TEX__SHIFT = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__ATTR0_VALID__SHIFT  = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__ATTR1_VALID__SHIFT  = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__CYL_WRAP__SHIFT     = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__DEFAULT_VAL__SHIFT  = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__DUP__SHIFT          = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__FLAT_SHADE__SHIFT   = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__OFFSET__SHIFT       = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__PT_SPRITE_TEX_ATTR1__SHIFT = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__PT_SPRITE_TEX__SHIFT = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__ATTR0_VALID__SHIFT  = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__ATTR1_VALID__SHIFT  = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__CYL_WRAP__SHIFT     = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__DEFAULT_VAL__SHIFT  = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__DUP__SHIFT          = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__FLAT_SHADE__SHIFT   = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__OFFSET__SHIFT       = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__PT_SPRITE_TEX_ATTR1__SHIFT = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__PT_SPRITE_TEX__SHIFT = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__ATTR0_VALID__SHIFT  = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__ATTR1_VALID__SHIFT  = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__CYL_WRAP__SHIFT     = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__DEFAULT_VAL__SHIFT  = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__DUP__SHIFT          = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__FLAT_SHADE__SHIFT   = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__OFFSET__SHIFT       = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__PT_SPRITE_TEX_ATTR1__SHIFT = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__PT_SPRITE_TEX__SHIFT = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__ATTR0_VALID__SHIFT  = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__ATTR1_VALID__SHIFT  = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__CYL_WRAP__SHIFT     = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__DEFAULT_VAL__SHIFT  = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__DUP__SHIFT          = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__FLAT_SHADE__SHIFT   = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__OFFSET__SHIFT       = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__PT_SPRITE_TEX_ATTR1__SHIFT = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__PT_SPRITE_TEX__SHIFT = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__ATTR0_VALID__SHIFT  = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__ATTR1_VALID__SHIFT  = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__CYL_WRAP__SHIFT     = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__DEFAULT_VAL__SHIFT  = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__DUP__SHIFT          = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__FLAT_SHADE__SHIFT   = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__OFFSET__SHIFT       = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__PT_SPRITE_TEX_ATTR1__SHIFT = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__PT_SPRITE_TEX__SHIFT = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__ATTR0_VALID__SHIFT  = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__ATTR1_VALID__SHIFT  = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__CYL_WRAP__SHIFT     = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__DEFAULT_VAL__SHIFT  = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__DUP__SHIFT          = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__FLAT_SHADE__SHIFT   = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__OFFSET__SHIFT       = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__PT_SPRITE_TEX_ATTR1__SHIFT = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__PT_SPRITE_TEX__SHIFT = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__ATTR0_VALID__SHIFT  = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__ATTR1_VALID__SHIFT  = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__CYL_WRAP__SHIFT     = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__DEFAULT_VAL__SHIFT  = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__DUP__SHIFT          = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__FLAT_SHADE__SHIFT   = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__OFFSET__SHIFT       = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__PT_SPRITE_TEX_ATTR1__SHIFT = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__PT_SPRITE_TEX__SHIFT = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__ATTR0_VALID__SHIFT = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__ATTR1_VALID__SHIFT = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__CYL_WRAP__SHIFT    = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__DEFAULT_VAL__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__DUP__SHIFT         = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__FLAT_SHADE__SHIFT  = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__PT_SPRITE_TEX_ATTR1__SHIFT = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__PT_SPRITE_TEX__SHIFT = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__ATTR0_VALID__SHIFT = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__ATTR1_VALID__SHIFT = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__CYL_WRAP__SHIFT    = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__DEFAULT_VAL__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__DUP__SHIFT         = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__FLAT_SHADE__SHIFT  = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__PT_SPRITE_TEX_ATTR1__SHIFT = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__PT_SPRITE_TEX__SHIFT = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__ATTR0_VALID__SHIFT = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__ATTR1_VALID__SHIFT = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__CYL_WRAP__SHIFT    = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__DEFAULT_VAL__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__DUP__SHIFT         = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__FLAT_SHADE__SHIFT  = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__PT_SPRITE_TEX_ATTR1__SHIFT = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__PT_SPRITE_TEX__SHIFT = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__ATTR0_VALID__SHIFT = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__ATTR1_VALID__SHIFT = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__CYL_WRAP__SHIFT    = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__DEFAULT_VAL__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__DUP__SHIFT         = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__FLAT_SHADE__SHIFT  = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__PT_SPRITE_TEX_ATTR1__SHIFT = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__PT_SPRITE_TEX__SHIFT = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__ATTR0_VALID__SHIFT = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__ATTR1_VALID__SHIFT = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__CYL_WRAP__SHIFT    = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__DEFAULT_VAL__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__DUP__SHIFT         = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__FLAT_SHADE__SHIFT  = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__PT_SPRITE_TEX_ATTR1__SHIFT = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__PT_SPRITE_TEX__SHIFT = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__ATTR0_VALID__SHIFT = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__ATTR1_VALID__SHIFT = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__CYL_WRAP__SHIFT    = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__DEFAULT_VAL__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__DUP__SHIFT         = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__FLAT_SHADE__SHIFT  = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__PT_SPRITE_TEX_ATTR1__SHIFT = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__PT_SPRITE_TEX__SHIFT = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__ATTR0_VALID__SHIFT = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__ATTR1_VALID__SHIFT = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__CYL_WRAP__SHIFT    = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__DEFAULT_VAL__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__DUP__SHIFT         = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__FLAT_SHADE__SHIFT  = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__PT_SPRITE_TEX_ATTR1__SHIFT = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__PT_SPRITE_TEX__SHIFT = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__ATTR0_VALID__SHIFT = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__ATTR1_VALID__SHIFT = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__CYL_WRAP__SHIFT    = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__DEFAULT_VAL__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__DUP__SHIFT         = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__FLAT_SHADE__SHIFT  = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__PT_SPRITE_TEX_ATTR1__SHIFT = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__PT_SPRITE_TEX__SHIFT = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__ATTR0_VALID__SHIFT = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__ATTR1_VALID__SHIFT = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__CYL_WRAP__SHIFT    = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__DEFAULT_VAL__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__DUP__SHIFT         = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__FLAT_SHADE__SHIFT  = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__PT_SPRITE_TEX_ATTR1__SHIFT = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__PT_SPRITE_TEX__SHIFT = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__ATTR0_VALID__SHIFT = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__ATTR1_VALID__SHIFT = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__CYL_WRAP__SHIFT    = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__DEFAULT_VAL__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__DUP__SHIFT         = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__FLAT_SHADE__SHIFT  = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__PT_SPRITE_TEX_ATTR1__SHIFT = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__PT_SPRITE_TEX__SHIFT = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__ATTR0_VALID__SHIFT = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__ATTR1_VALID__SHIFT = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__DEFAULT_VAL__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__DUP__SHIFT         = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__FLAT_SHADE__SHIFT  = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__ATTR0_VALID__SHIFT = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__ATTR1_VALID__SHIFT = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__DEFAULT_VAL__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__DUP__SHIFT         = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__FLAT_SHADE__SHIFT  = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__ATTR0_VALID__SHIFT = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__ATTR1_VALID__SHIFT = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__DEFAULT_VAL__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__DUP__SHIFT         = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__FLAT_SHADE__SHIFT  = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__ATTR0_VALID__SHIFT = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__ATTR1_VALID__SHIFT = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__DEFAULT_VAL__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__DUP__SHIFT         = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__FLAT_SHADE__SHIFT  = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__ATTR0_VALID__SHIFT = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__ATTR1_VALID__SHIFT = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__DEFAULT_VAL__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__DUP__SHIFT         = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__FLAT_SHADE__SHIFT  = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__ATTR0_VALID__SHIFT = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__ATTR1_VALID__SHIFT = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__DEFAULT_VAL__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__DUP__SHIFT         = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__FLAT_SHADE__SHIFT  = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__ATTR0_VALID__SHIFT = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__ATTR1_VALID__SHIFT = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__DEFAULT_VAL__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__DUP__SHIFT         = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__FLAT_SHADE__SHIFT  = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__ATTR0_VALID__SHIFT = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__ATTR1_VALID__SHIFT = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__DEFAULT_VAL__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__DUP__SHIFT         = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__FLAT_SHADE__SHIFT  = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__ATTR0_VALID__SHIFT = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__ATTR1_VALID__SHIFT = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__DEFAULT_VAL__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__DUP__SHIFT         = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__FLAT_SHADE__SHIFT  = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__ATTR0_VALID__SHIFT = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__ATTR1_VALID__SHIFT = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__DEFAULT_VAL__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__DUP__SHIFT         = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__FLAT_SHADE__SHIFT  = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__ATTR0_VALID__SHIFT = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__ATTR1_VALID__SHIFT = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__DEFAULT_VAL__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__DUP__SHIFT         = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__FLAT_SHADE__SHIFT  = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__ATTR0_VALID__SHIFT = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__ATTR1_VALID__SHIFT = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__DEFAULT_VAL_ATTR1__SHIFT = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__DEFAULT_VAL__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__DUP__SHIFT         = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__FLAT_SHADE__SHIFT  = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__FP16_INTERP_MODE__SHIFT = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__USE_DEFAULT_ATTR1__SHIFT = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_ENA__ANCILLARY_ENA__SHIFT   = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_ENA__FRONT_FACE_ENA__SHIFT  = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_ENA__LINEAR_CENTER_ENA__SHIFT = 0x00000005;
constexpr unsigned int SPI_PS_INPUT_ENA__LINEAR_CENTROID_ENA__SHIFT = 0x00000006;
constexpr unsigned int SPI_PS_INPUT_ENA__LINEAR_SAMPLE_ENA__SHIFT = 0x00000004;
constexpr unsigned int SPI_PS_INPUT_ENA__LINE_STIPPLE_TEX_ENA__SHIFT = 0x00000007;
constexpr unsigned int SPI_PS_INPUT_ENA__PERSP_CENTER_ENA__SHIFT = 0x00000001;
constexpr unsigned int SPI_PS_INPUT_ENA__PERSP_CENTROID_ENA__SHIFT = 0x00000002;
constexpr unsigned int SPI_PS_INPUT_ENA__PERSP_PULL_MODEL_ENA__SHIFT = 0x00000003;
constexpr unsigned int SPI_PS_INPUT_ENA__PERSP_SAMPLE_ENA__SHIFT = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_FIXED_PT_ENA__SHIFT = 0x0000000f;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_W_FLOAT_ENA__SHIFT = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_X_FLOAT_ENA__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_Y_FLOAT_ENA__SHIFT = 0x00000009;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_Z_FLOAT_ENA__SHIFT = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_ENA__SAMPLE_COVERAGE_ENA__SHIFT = 0x0000000e;
constexpr unsigned int SPI_PS_IN_CONTROL__BC_OPTIMIZE_DISABLE__SHIFT = 0x0000000e;
constexpr unsigned int SPI_PS_IN_CONTROL__LATE_PC_DEALLOC__SHIFT = 0x00000008;
constexpr unsigned int SPI_PS_IN_CONTROL__NUM_INTERP__SHIFT     = 0x00000000;
constexpr unsigned int SPI_PS_IN_CONTROL__OFFCHIP_PARAM_EN__SHIFT = 0x00000007;
constexpr unsigned int SPI_PS_IN_CONTROL__PARAM_GEN__SHIFT      = 0x00000006;
constexpr unsigned int SPI_PS_MAX_WAVE_ID__MAX_COLLISION_WAVE_ID__SHIFT = 0x00000010;
constexpr unsigned int SPI_PS_MAX_WAVE_ID__MAX_WAVE_ID__SHIFT   = 0x00000000;
constexpr unsigned int SPI_RESET_DEBUG__DISABLE_GFX_RESET_ALL_VMID__SHIFT = 0x00000002;
constexpr unsigned int SPI_RESET_DEBUG__DISABLE_GFX_RESET_PER_VMID__SHIFT = 0x00000001;
constexpr unsigned int SPI_RESET_DEBUG__DISABLE_GFX_RESET_PRIORITY__SHIFT = 0x00000004;
constexpr unsigned int SPI_RESET_DEBUG__DISABLE_GFX_RESET_RESOURCE__SHIFT = 0x00000003;
constexpr unsigned int SPI_RESET_DEBUG__DISABLE_GFX_RESET__SHIFT = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__BARRIERS__SHIFT = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__LDS__SHIFT    = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__SGPR__SHIFT   = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__VGPR__SHIFT   = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__WAVES__SHIFT  = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__BARRIERS__SHIFT = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__LDS__SHIFT    = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__SGPR__SHIFT   = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__VGPR__SHIFT   = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__WAVES__SHIFT  = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__BARRIERS__SHIFT = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__LDS__SHIFT    = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__SGPR__SHIFT   = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__VGPR__SHIFT   = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__WAVES__SHIFT  = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__BARRIERS__SHIFT = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__LDS__SHIFT    = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__SGPR__SHIFT   = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__VGPR__SHIFT   = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__WAVES__SHIFT  = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__BARRIERS__SHIFT = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__LDS__SHIFT    = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__SGPR__SHIFT   = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__VGPR__SHIFT   = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__WAVES__SHIFT  = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__BARRIERS__SHIFT = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__LDS__SHIFT    = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__SGPR__SHIFT   = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__VGPR__SHIFT   = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__WAVES__SHIFT  = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__BARRIERS__SHIFT = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__LDS__SHIFT    = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__SGPR__SHIFT   = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__VGPR__SHIFT   = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__WAVES__SHIFT  = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__BARRIERS__SHIFT = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__LDS__SHIFT    = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__SGPR__SHIFT   = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__VGPR__SHIFT   = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__WAVES__SHIFT  = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__BARRIERS__SHIFT = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__LDS__SHIFT    = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__SGPR__SHIFT   = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__VGPR__SHIFT   = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__WAVES__SHIFT  = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__BARRIERS__SHIFT = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__LDS__SHIFT    = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__SGPR__SHIFT   = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__VGPR__SHIFT   = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__WAVES__SHIFT  = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_0__EN__SHIFT  = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_0__QUEUE_MASK__SHIFT = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_0__TYPE_MASK__SHIFT = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_1__EN__SHIFT  = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_1__QUEUE_MASK__SHIFT = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_1__TYPE_MASK__SHIFT = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_2__EN__SHIFT  = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_2__QUEUE_MASK__SHIFT = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_2__TYPE_MASK__SHIFT = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_3__EN__SHIFT  = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_3__QUEUE_MASK__SHIFT = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_3__TYPE_MASK__SHIFT = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_4__EN__SHIFT  = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_4__QUEUE_MASK__SHIFT = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_4__TYPE_MASK__SHIFT = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_5__EN__SHIFT  = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_5__QUEUE_MASK__SHIFT = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_5__TYPE_MASK__SHIFT = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_6__EN__SHIFT  = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_6__QUEUE_MASK__SHIFT = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_6__TYPE_MASK__SHIFT = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_7__EN__SHIFT  = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_7__QUEUE_MASK__SHIFT = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_7__TYPE_MASK__SHIFT = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_8__EN__SHIFT  = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_8__QUEUE_MASK__SHIFT = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_8__TYPE_MASK__SHIFT = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_9__EN__SHIFT  = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_9__QUEUE_MASK__SHIFT = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_9__TYPE_MASK__SHIFT = 0x00000001;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL0_EXPORT_FORMAT__SHIFT = 0x00000000;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL1_EXPORT_FORMAT__SHIFT = 0x00000004;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL2_EXPORT_FORMAT__SHIFT = 0x00000008;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL3_EXPORT_FORMAT__SHIFT = 0x0000000c;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL4_EXPORT_FORMAT__SHIFT = 0x00000010;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL5_EXPORT_FORMAT__SHIFT = 0x00000014;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL6_EXPORT_FORMAT__SHIFT = 0x00000018;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL7_EXPORT_FORMAT__SHIFT = 0x0000001c;
constexpr unsigned int SPI_SHADER_LATE_ALLOC_VS__LIMIT__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_HI_ES__MEM_BASE__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_HI_GS__MEM_BASE__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_HI_HS__MEM_BASE__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_HI_LS__MEM_BASE__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_HI_PS__MEM_BASE__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_HI_VS__MEM_BASE__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_LO_ES__MEM_BASE__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_LO_GS__MEM_BASE__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_LO_HS__MEM_BASE__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_LO_LS__MEM_BASE__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_LO_PS__MEM_BASE__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_LO_VS__MEM_BASE__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__CDBG_USER__SHIFT = 0x0000001c;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__CU_GROUP_ENABLE__SHIFT = 0x00000018;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__DEBUG_MODE__SHIFT = 0x00000016;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__DX10_CLAMP__SHIFT = 0x00000015;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__FLOAT_MODE__SHIFT = 0x0000000c;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__FP16_OVFL__SHIFT = 0x0000001f;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__GS_VGPR_COMP_CNT__SHIFT = 0x0000001d;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__IEEE_MODE__SHIFT = 0x00000017;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__PRIORITY__SHIFT = 0x0000000a;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__PRIV__SHIFT     = 0x00000014;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__SGPRS__SHIFT    = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__VGPRS__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__CDBG_USER__SHIFT = 0x0000001b;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__DEBUG_MODE__SHIFT = 0x00000016;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__DX10_CLAMP__SHIFT = 0x00000015;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__FLOAT_MODE__SHIFT = 0x0000000c;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__FP16_OVFL__SHIFT = 0x0000001e;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__IEEE_MODE__SHIFT = 0x00000017;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__LS_VGPR_COMP_CNT__SHIFT = 0x0000001c;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__PRIORITY__SHIFT = 0x0000000a;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__PRIV__SHIFT     = 0x00000014;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__SGPRS__SHIFT    = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__VGPRS__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__CDBG_USER__SHIFT = 0x0000001c;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__CU_GROUP_DISABLE__SHIFT = 0x00000018;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__DEBUG_MODE__SHIFT = 0x00000016;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__DX10_CLAMP__SHIFT = 0x00000015;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__FLOAT_MODE__SHIFT = 0x0000000c;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__FP16_OVFL__SHIFT = 0x0000001d;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__IEEE_MODE__SHIFT = 0x00000017;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__PRIORITY__SHIFT = 0x0000000a;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__PRIV__SHIFT     = 0x00000014;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__SGPRS__SHIFT    = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__VGPRS__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__CDBG_USER__SHIFT = 0x0000001e;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__CU_GROUP_ENABLE__SHIFT = 0x0000001a;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__DEBUG_MODE__SHIFT = 0x00000016;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__DX10_CLAMP__SHIFT = 0x00000015;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__FLOAT_MODE__SHIFT = 0x0000000c;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__FP16_OVFL__SHIFT = 0x0000001f;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__IEEE_MODE__SHIFT = 0x00000017;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__PRIORITY__SHIFT = 0x0000000a;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__PRIV__SHIFT     = 0x00000014;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__SGPRS__SHIFT    = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__VGPRS__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__VGPR_COMP_CNT__SHIFT = 0x00000018;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__EXCP_EN__SHIFT = 0x00000007;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__LDS_SIZE__SHIFT = 0x00000013;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__OC_LDS_EN__SHIFT = 0x00000012;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__SCRATCH_EN__SHIFT = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__SKIP_USGPR0__SHIFT = 0x0000001b;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__TRAP_PRESENT__SHIFT = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__USER_SGPR_MSB__SHIFT = 0x0000001c;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__USER_SGPR__SHIFT = 0x00000001;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__VGPR_COMP_CNT__SHIFT = 0x00000010;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__ES_VGPR_COMP_CNT__SHIFT = 0x00000010;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__EXCP_EN__SHIFT  = 0x00000007;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__LDS_SIZE__SHIFT = 0x00000013;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__OC_LDS_EN__SHIFT = 0x00000012;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__SCRATCH_EN__SHIFT = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__TRAP_PRESENT__SHIFT = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__USER_SGPR__SHIFT = 0x00000001;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__SCRATCH_EN__SHIFT = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__TRAP_PRESENT__SHIFT = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__USER_SGPR__SHIFT = 0x00000001;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__EXCP_EN__SHIFT  = 0x00000010;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__EXTRA_LDS_SIZE__SHIFT = 0x00000008;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__LOAD_COLLISION_WAVEID__SHIFT = 0x00000019;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__LOAD_INTRAWAVE_COLLISION__SHIFT = 0x0000001a;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__SCRATCH_EN__SHIFT = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__TRAP_PRESENT__SHIFT = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__USER_SGPR__SHIFT = 0x00000001;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__WAVE_CNT_EN__SHIFT = 0x00000007;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__EXCP_EN__SHIFT  = 0x0000000d;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__OC_LDS_EN__SHIFT = 0x00000007;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__PC_BASE_EN__SHIFT = 0x00000016;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__SCRATCH_EN__SHIFT = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__SO_BASE0_EN__SHIFT = 0x00000008;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__SO_BASE1_EN__SHIFT = 0x00000009;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__SO_BASE2_EN__SHIFT = 0x0000000a;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__SO_BASE3_EN__SHIFT = 0x0000000b;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__SO_EN__SHIFT    = 0x0000000c;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__TRAP_PRESENT__SHIFT = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__USER_SGPR__SHIFT = 0x00000001;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_GS__CU_EN__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_GS__LOCK_LOW_THRESHOLD__SHIFT = 0x00000016;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_GS__WAVE_LIMIT__SHIFT = 0x00000010;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_HS__CU_EN__SHIFT    = 0x00000010;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_HS__LOCK_LOW_THRESHOLD__SHIFT = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_HS__WAVE_LIMIT__SHIFT = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_PS__CU_EN__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_PS__LOCK_LOW_THRESHOLD__SHIFT = 0x00000016;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_PS__WAVE_LIMIT__SHIFT = 0x00000010;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_VS__CU_EN__SHIFT    = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_VS__LOCK_LOW_THRESHOLD__SHIFT = 0x00000016;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_VS__WAVE_LIMIT__SHIFT = 0x00000010;
constexpr unsigned int SPI_SHADER_POS_FORMAT__POS0_EXPORT_FORMAT__SHIFT = 0x00000000;
constexpr unsigned int SPI_SHADER_POS_FORMAT__POS1_EXPORT_FORMAT__SHIFT = 0x00000004;
constexpr unsigned int SPI_SHADER_POS_FORMAT__POS2_EXPORT_FORMAT__SHIFT = 0x00000008;
constexpr unsigned int SPI_SHADER_POS_FORMAT__POS3_EXPORT_FORMAT__SHIFT = 0x0000000c;
constexpr unsigned int SPI_SHADER_USER_DATA_ADDR_HI_GS__MEM_BASE__SHIFT = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_ADDR_HI_HS__MEM_BASE__SHIFT = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_ADDR_LO_GS__MEM_BASE__SHIFT = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_ADDR_LO_HS__MEM_BASE__SHIFT = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_0__DATA__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_1__DATA__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_2__DATA__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_3__DATA__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_4__DATA__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_5__DATA__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_6__DATA__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_7__DATA__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_8__DATA__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_9__DATA__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_10__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_11__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_12__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_13__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_14__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_15__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_16__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_17__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_18__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_19__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_20__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_21__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_22__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_23__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_24__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_25__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_26__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_27__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_28__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_29__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_30__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_31__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_0__DATA__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_1__DATA__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_2__DATA__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_3__DATA__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_4__DATA__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_5__DATA__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_6__DATA__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_7__DATA__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_8__DATA__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_9__DATA__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_10__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_11__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_12__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_13__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_14__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_15__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_16__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_17__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_18__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_19__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_20__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_21__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_22__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_23__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_24__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_25__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_26__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_27__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_28__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_29__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_30__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_31__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SPI_SHADER_Z_FORMAT__Z_EXPORT_FORMAT__SHIFT = 0x00000000;
constexpr unsigned int SPI_SX_EXPORT_BUFFER_SIZES__COLOR_BUFFER_SIZE__SHIFT = 0x00000000;
constexpr unsigned int SPI_SX_EXPORT_BUFFER_SIZES__POSITION_BUFFER_SIZE__SHIFT = 0x00000010;
constexpr unsigned int SPI_SX_SCOREBOARD_BUFFER_SIZES__COLOR_SCOREBOARD_SIZE__SHIFT = 0x00000000;
constexpr unsigned int SPI_SX_SCOREBOARD_BUFFER_SIZES__POSITION_SCOREBOARD_SIZE__SHIFT = 0x00000010;
constexpr unsigned int SPI_TMPRING_SIZE__WAVESIZE__SHIFT        = 0x0000000c;
constexpr unsigned int SPI_TMPRING_SIZE__WAVES__SHIFT           = 0x00000000;
constexpr unsigned int SPI_VS_OUT_CONFIG__VS_EXPORT_COUNT__SHIFT = 0x00000001;
constexpr unsigned int SPI_VS_OUT_CONFIG__VS_HALF_PACK__SHIFT   = 0x00000006;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS0__VALUE__SHIFT   = 0x00000000;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS1__VALUE__SHIFT   = 0x00000000;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS2__VALUE__SHIFT   = 0x00000000;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS3__VALUE__SHIFT   = 0x00000000;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__GS_GRP_VALUE__SHIFT = 0x00000016;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__HS_GRP_VALUE__SHIFT = 0x0000000c;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__VALUE__SHIFT   = 0x00000000;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_HP3D__GS_GRP_VALUE__SHIFT = 0x00000016;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_HP3D__HS_GRP_VALUE__SHIFT = 0x0000000c;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_HP3D__VALUE__SHIFT  = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_CNTL__EN__SHIFT          = 0x00000004;
constexpr unsigned int SPI_WF_LIFETIME_CNTL__SAMPLE_PERIOD__SHIFT = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_DEBUG__OVERRIDE_EN__SHIFT = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_DEBUG__START_VALUE__SHIFT = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_0__EN_WARN__SHIFT  = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_0__MAX_CNT__SHIFT  = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_1__EN_WARN__SHIFT  = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_1__MAX_CNT__SHIFT  = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_2__EN_WARN__SHIFT  = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_2__MAX_CNT__SHIFT  = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_3__EN_WARN__SHIFT  = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_3__MAX_CNT__SHIFT  = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_4__EN_WARN__SHIFT  = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_4__MAX_CNT__SHIFT  = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_5__EN_WARN__SHIFT  = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_5__MAX_CNT__SHIFT  = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_0__INT_SENT__SHIFT = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_0__MAX_CNT__SHIFT = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_1__INT_SENT__SHIFT = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_1__MAX_CNT__SHIFT = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_2__INT_SENT__SHIFT = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_2__MAX_CNT__SHIFT = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_4__INT_SENT__SHIFT = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_4__MAX_CNT__SHIFT = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_6__INT_SENT__SHIFT = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_6__MAX_CNT__SHIFT = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_7__INT_SENT__SHIFT = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_7__MAX_CNT__SHIFT = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_8__INT_SENT__SHIFT = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_8__MAX_CNT__SHIFT = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_9__INT_SENT__SHIFT = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_9__MAX_CNT__SHIFT = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_11__INT_SENT__SHIFT = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_11__MAX_CNT__SHIFT = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_13__INT_SENT__SHIFT = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_13__MAX_CNT__SHIFT = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_14__INT_SENT__SHIFT = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_14__MAX_CNT__SHIFT = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_15__INT_SENT__SHIFT = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_15__MAX_CNT__SHIFT = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_16__INT_SENT__SHIFT = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_16__MAX_CNT__SHIFT = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_17__INT_SENT__SHIFT = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_17__MAX_CNT__SHIFT = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_18__INT_SENT__SHIFT = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_18__MAX_CNT__SHIFT = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_19__INT_SENT__SHIFT = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_19__MAX_CNT__SHIFT = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_20__INT_SENT__SHIFT = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_20__MAX_CNT__SHIFT = 0x00000000;
constexpr unsigned int SQC_CACHES__COMPLETE__SHIFT              = 0x00000010;
constexpr unsigned int SQC_CACHES__INVALIDATE__SHIFT            = 0x00000002;
constexpr unsigned int SQC_CACHES__TARGET_DATA__SHIFT           = 0x00000001;
constexpr unsigned int SQC_CACHES__TARGET_INST__SHIFT           = 0x00000000;
constexpr unsigned int SQC_CONFIG__DATA_CACHE_SIZE__SHIFT       = 0x00000002;
constexpr unsigned int SQC_CONFIG__EVICT_LRU__SHIFT             = 0x0000000c;
constexpr unsigned int SQC_CONFIG__FORCE_1_BANK__SHIFT          = 0x0000000f;
constexpr unsigned int SQC_CONFIG__FORCE_2_BANK__SHIFT          = 0x0000000e;
constexpr unsigned int SQC_CONFIG__FORCE_ALWAYS_MISS__SHIFT     = 0x00000007;
constexpr unsigned int SQC_CONFIG__FORCE_IN_ORDER__SHIFT        = 0x00000008;
constexpr unsigned int SQC_CONFIG__HIT_FIFO_DEPTH__SHIFT        = 0x00000006;
constexpr unsigned int SQC_CONFIG__IDENTITY_HASH_SET__SHIFT     = 0x0000000a;
constexpr unsigned int SQC_CONFIG__INST_CACHE_SIZE__SHIFT       = 0x00000000;
constexpr unsigned int SQC_CONFIG__LS_DISABLE_CLOCKS__SHIFT     = 0x00000010;
constexpr unsigned int SQC_CONFIG__MISS_FIFO_DEPTH__SHIFT       = 0x00000004;
constexpr unsigned int SQC_CONFIG__PER_VMID_INV_DISABLE__SHIFT  = 0x0000000b;
constexpr unsigned int SQ_CMD__CHECK_VMID__SHIFT                = 0x00000007;
constexpr unsigned int SQ_CMD__CMD__SHIFT                       = 0x00000000;
constexpr unsigned int SQ_CMD__DATA__SHIFT                      = 0x00000008;
constexpr unsigned int SQ_CMD__MODE__SHIFT                      = 0x00000004;
constexpr unsigned int SQ_CMD__QUEUE_ID__SHIFT                  = 0x00000018;
constexpr unsigned int SQ_CMD__VM_ID__SHIFT                     = 0x0000001c;
constexpr unsigned int SQ_CMD__WAVE_ID__SHIFT                   = 0x00000010;
constexpr unsigned int SQ_CONFIG__DISABLE_SP_REDUNDANT_THREAD_GATING__SHIFT = 0x0000001d;
constexpr unsigned int SQ_CONFIG__ENABLE_HIPRIO_ON_EXP_RDY_VS__SHIFT = 0x00000012;
constexpr unsigned int SQ_CONFIG__PRIO_VAL_ON_EXP_RDY_VS__SHIFT = 0x00000013;
constexpr unsigned int SQ_DEBUG_CTRL_LOCAL__UNUSED__SHIFT       = 0x00000000;
constexpr unsigned int SQ_DEBUG_STS_GLOBAL__BUSY__SHIFT         = 0x00000000;
constexpr unsigned int SQ_DEBUG_STS_LOCAL__BUSY__SHIFT          = 0x00000000;
constexpr unsigned int SQ_DEBUG_STS_LOCAL__WAVE_LEVEL__SHIFT    = 0x00000004;
constexpr unsigned int SQ_DSM_CNTL2__LDS_D_ENABLE_ERROR_INJECT__SHIFT = 0x00000003;
constexpr unsigned int SQ_DSM_CNTL2__LDS_D_SELECT_INJECT_DELAY__SHIFT = 0x00000005;
constexpr unsigned int SQ_DSM_CNTL2__LDS_INJECT_DELAY__SHIFT    = 0x0000000e;
constexpr unsigned int SQ_DSM_CNTL2__LDS_I_ENABLE_ERROR_INJECT__SHIFT = 0x00000006;
constexpr unsigned int SQ_DSM_CNTL2__LDS_I_SELECT_INJECT_DELAY__SHIFT = 0x00000008;
constexpr unsigned int SQ_DSM_CNTL2__SGPR_ENABLE_ERROR_INJECT__SHIFT = 0x00000000;
constexpr unsigned int SQ_DSM_CNTL2__SGPR_SELECT_INJECT_DELAY__SHIFT = 0x00000002;
constexpr unsigned int SQ_DSM_CNTL2__SP_ENABLE_ERROR_INJECT__SHIFT = 0x00000009;
constexpr unsigned int SQ_DSM_CNTL2__SP_INJECT_DELAY__SHIFT     = 0x00000014;
constexpr unsigned int SQ_DSM_CNTL2__SP_SELECT_INJECT_DELAY__SHIFT = 0x0000000b;
constexpr unsigned int SQ_DSM_CNTL2__SQ_INJECT_DELAY__SHIFT     = 0x0000001a;
constexpr unsigned int SQ_DSM_CNTL__LDS_ENABLE_SINGLE_WRITE01__SHIFT = 0x00000012;
constexpr unsigned int SQ_DSM_CNTL__LDS_ENABLE_SINGLE_WRITE23__SHIFT = 0x00000015;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_LDS_IRRITATOR_DATA0__SHIFT = 0x00000010;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_LDS_IRRITATOR_DATA1__SHIFT = 0x00000011;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_LDS_IRRITATOR_DATA2__SHIFT = 0x00000013;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_LDS_IRRITATOR_DATA3__SHIFT = 0x00000014;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_SGPR_IRRITATOR_DATA0__SHIFT = 0x00000008;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_SGPR_IRRITATOR_DATA1__SHIFT = 0x00000009;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_SP_IRRITATOR_DATA0__SHIFT = 0x00000018;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_SP_IRRITATOR_DATA1__SHIFT = 0x00000019;
constexpr unsigned int SQ_DSM_CNTL__SGPR_ENABLE_SINGLE_WRITE__SHIFT = 0x0000000a;
constexpr unsigned int SQ_DSM_CNTL__SPI_BACKPRESSURE_0__SHIFT   = 0x00000002;
constexpr unsigned int SQ_DSM_CNTL__SPI_BACKPRESSURE_1__SHIFT   = 0x00000003;
constexpr unsigned int SQ_DSM_CNTL__SP_ENABLE_SINGLE_WRITE__SHIFT = 0x0000001a;
constexpr unsigned int SQ_DSM_CNTL__WAVEFRONT_STALL_0__SHIFT    = 0x00000000;
constexpr unsigned int SQ_DSM_CNTL__WAVEFRONT_STALL_1__SHIFT    = 0x00000001;
constexpr unsigned int SQ_EDC_CNT__LDS_D_DED_COUNT__SHIFT       = 0x00000002;
constexpr unsigned int SQ_EDC_CNT__LDS_D_SEC_COUNT__SHIFT       = 0x00000000;
constexpr unsigned int SQ_EDC_CNT__LDS_I_DED_COUNT__SHIFT       = 0x00000006;
constexpr unsigned int SQ_EDC_CNT__LDS_I_SEC_COUNT__SHIFT       = 0x00000004;
constexpr unsigned int SQ_EDC_CNT__SGPR_DED_COUNT__SHIFT        = 0x0000000a;
constexpr unsigned int SQ_EDC_CNT__SGPR_SEC_COUNT__SHIFT        = 0x00000008;
constexpr unsigned int SQ_EDC_CNT__VGPR0_DED_COUNT__SHIFT       = 0x0000000e;
constexpr unsigned int SQ_EDC_CNT__VGPR0_SEC_COUNT__SHIFT       = 0x0000000c;
constexpr unsigned int SQ_EDC_CNT__VGPR1_DED_COUNT__SHIFT       = 0x00000012;
constexpr unsigned int SQ_EDC_CNT__VGPR1_SEC_COUNT__SHIFT       = 0x00000010;
constexpr unsigned int SQ_EDC_CNT__VGPR2_DED_COUNT__SHIFT       = 0x00000016;
constexpr unsigned int SQ_EDC_CNT__VGPR2_SEC_COUNT__SHIFT       = 0x00000014;
constexpr unsigned int SQ_EDC_CNT__VGPR3_DED_COUNT__SHIFT       = 0x0000001a;
constexpr unsigned int SQ_EDC_CNT__VGPR3_SEC_COUNT__SHIFT       = 0x00000018;
constexpr unsigned int SQ_EDC_FUE_CNTL__BLOCK_FUE_FLAGS__SHIFT  = 0x00000000;
constexpr unsigned int SQ_EDC_FUE_CNTL__FUE_INTERRUPT_ENABLES__SHIFT = 0x00000010;
constexpr unsigned int SQ_FIFO_SIZES__INTERRUPT_FIFO_SIZE__SHIFT = 0x00000000;
constexpr unsigned int SQ_FIFO_SIZES__TTRACE_FIFO_SIZE__SHIFT   = 0x00000008;
constexpr unsigned int SQ_FIFO_SIZES__VMEM_DATA_FIFO_SIZE__SHIFT = 0x00000012;
constexpr unsigned int SQ_IND_DATA__DATA__SHIFT                 = 0x00000000;
constexpr unsigned int SQ_IND_INDEX__INDEX__SHIFT               = 0x00000010;
constexpr unsigned int SQ_IND_INDEX__WAVE_ID__SHIFT             = 0x00000000;
constexpr unsigned int SQ_INTERRUPT_AUTO_MASK__MASK__SHIFT      = 0x00000000;
constexpr unsigned int SQ_INTERRUPT_MSG_CTRL__STALL__SHIFT      = 0x00000000;
constexpr unsigned int SQ_LB_CTR_CTRL__CLEAR__SHIFT             = 0x00000002;
constexpr unsigned int SQ_LB_CTR_CTRL__LOAD__SHIFT              = 0x00000001;
constexpr unsigned int SQ_LB_CTR_CTRL__START__SHIFT             = 0x00000000;
constexpr unsigned int SQ_LB_DATA0__DATA__SHIFT                 = 0x00000000;
constexpr unsigned int SQ_LB_DATA1__DATA__SHIFT                 = 0x00000000;
constexpr unsigned int SQ_LB_DATA2__DATA__SHIFT                 = 0x00000000;
constexpr unsigned int SQ_LB_DATA3__DATA__SHIFT                 = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT  = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER0_SELECT__SPM_MODE__SHIFT  = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT  = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER1_SELECT__SPM_MODE__SHIFT  = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT  = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER2_SELECT__SPM_MODE__SHIFT  = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT  = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER3_SELECT__SPM_MODE__SHIFT  = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER4_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER4_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER4_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER4_SELECT__PERF_SEL__SHIFT  = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER4_SELECT__SPM_MODE__SHIFT  = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER5_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER5_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER5_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER5_SELECT__PERF_SEL__SHIFT  = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER5_SELECT__SPM_MODE__SHIFT  = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER6_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER6_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER6_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER6_SELECT__PERF_SEL__SHIFT  = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER6_SELECT__SPM_MODE__SHIFT  = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER7_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER7_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER7_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER7_SELECT__PERF_SEL__SHIFT  = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER7_SELECT__SPM_MODE__SHIFT  = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER8_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER8_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER8_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER8_SELECT__PERF_SEL__SHIFT  = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER8_SELECT__SPM_MODE__SHIFT  = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER9_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER9_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER9_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER9_SELECT__PERF_SEL__SHIFT  = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER9_SELECT__SPM_MODE__SHIFT  = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER10_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER10_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER10_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER10_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER10_SELECT__SPM_MODE__SHIFT = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER11_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER11_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER11_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER11_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER11_SELECT__SPM_MODE__SHIFT = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER12_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER12_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER12_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER12_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER12_SELECT__SPM_MODE__SHIFT = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER13_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER13_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER13_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER13_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER13_SELECT__SPM_MODE__SHIFT = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER14_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER14_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER14_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER14_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER14_SELECT__SPM_MODE__SHIFT = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER15_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER15_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER15_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER15_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER15_SELECT__SPM_MODE__SHIFT = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER_CTRL2__FORCE_EN__SHIFT    = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__CNTR_RATE__SHIFT    = 0x00000008;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__CS_EN__SHIFT        = 0x00000006;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__DISABLE_FLUSH__SHIFT = 0x0000000d;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__ES_EN__SHIFT        = 0x00000003;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__GS_EN__SHIFT        = 0x00000002;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__HS_EN__SHIFT        = 0x00000004;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__LS_EN__SHIFT        = 0x00000005;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__PS_EN__SHIFT        = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__VS_EN__SHIFT        = 0x00000001;
constexpr unsigned int SQ_RANDOM_WAVE_PRI__RET__SHIFT           = 0x00000000;
constexpr unsigned int SQ_RANDOM_WAVE_PRI__RNG__SHIFT           = 0x0000000a;
constexpr unsigned int SQ_RANDOM_WAVE_PRI__RUI__SHIFT           = 0x00000007;
constexpr unsigned int SQ_SHADER_TBA_HI__ADDR_HI__SHIFT         = 0x00000000;
constexpr unsigned int SQ_SHADER_TBA_LO__ADDR_LO__SHIFT         = 0x00000000;
constexpr unsigned int SQ_SHADER_TMA_HI__ADDR_HI__SHIFT         = 0x00000000;
constexpr unsigned int SQ_SHADER_TMA_LO__ADDR_LO__SHIFT         = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_STATUS__FINISH_PENDING__SHIFT = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_0__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_1__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_2__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_3__DATA__SHIFT  = 0x00000000;
constexpr unsigned int SQ_TIME_HI__TIME__SHIFT                  = 0x00000000;
constexpr unsigned int SQ_TIME_LO__TIME__SHIFT                  = 0x00000000;
constexpr unsigned int SQ_WREXEC_EXEC_HI__ADDR_HI__SHIFT        = 0x00000000;
constexpr unsigned int SQ_WREXEC_EXEC_HI__FIRST_WAVE__SHIFT     = 0x0000001a;
constexpr unsigned int SQ_WREXEC_EXEC_HI__MSB__SHIFT            = 0x0000001f;
constexpr unsigned int SQ_WREXEC_EXEC_HI__MTYPE__SHIFT          = 0x0000001c;
constexpr unsigned int SQ_WREXEC_EXEC_LO__ADDR_LO__SHIFT        = 0x00000000;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT0_ALPHA_OPT_DISABLE__SHIFT = 0x00000001;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT0_COLOR_OPT_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT1_ALPHA_OPT_DISABLE__SHIFT = 0x00000005;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT1_COLOR_OPT_DISABLE__SHIFT = 0x00000004;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT2_ALPHA_OPT_DISABLE__SHIFT = 0x00000009;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT2_COLOR_OPT_DISABLE__SHIFT = 0x00000008;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT3_ALPHA_OPT_DISABLE__SHIFT = 0x0000000d;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT3_COLOR_OPT_DISABLE__SHIFT = 0x0000000c;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT4_ALPHA_OPT_DISABLE__SHIFT = 0x00000011;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT4_COLOR_OPT_DISABLE__SHIFT = 0x00000010;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT5_ALPHA_OPT_DISABLE__SHIFT = 0x00000015;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT5_COLOR_OPT_DISABLE__SHIFT = 0x00000014;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT6_ALPHA_OPT_DISABLE__SHIFT = 0x00000019;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT6_COLOR_OPT_DISABLE__SHIFT = 0x00000018;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT7_ALPHA_OPT_DISABLE__SHIFT = 0x0000001d;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT7_COLOR_OPT_DISABLE__SHIFT = 0x0000001c;
constexpr unsigned int SX_BLEND_OPT_CONTROL__PIXEN_ZERO_OPT_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT0_EPSILON__SHIFT = 0x00000000;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT1_EPSILON__SHIFT = 0x00000004;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT2_EPSILON__SHIFT = 0x00000008;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT3_EPSILON__SHIFT = 0x0000000c;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT4_EPSILON__SHIFT = 0x00000010;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT5_EPSILON__SHIFT = 0x00000014;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT6_EPSILON__SHIFT = 0x00000018;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT7_EPSILON__SHIFT = 0x0000001c;
constexpr unsigned int SX_DEBUG_1__DISABLE_BLEND_OPT_BYPASS__SHIFT = 0x00000009;
constexpr unsigned int SX_DEBUG_1__DISABLE_BLEND_OPT_DISCARD_PIXEL__SHIFT = 0x0000000a;
constexpr unsigned int SX_DEBUG_1__DISABLE_BLEND_OPT_DONT_RD_DST__SHIFT = 0x00000008;
constexpr unsigned int SX_DEBUG_1__DISABLE_PIX_EN_ZERO_OPT__SHIFT = 0x0000000c;
constexpr unsigned int SX_DEBUG_1__DISABLE_QUAD_PAIR_OPT__SHIFT = 0x0000000b;
constexpr unsigned int SX_DEBUG_1__SX_DB_QUAD_CREDIT__SHIFT     = 0x00000000;
constexpr unsigned int SX_MRT0_BLEND_OPT__ALPHA_COMB_FCN__SHIFT = 0x00000018;
constexpr unsigned int SX_MRT0_BLEND_OPT__ALPHA_DST_OPT__SHIFT  = 0x00000014;
constexpr unsigned int SX_MRT0_BLEND_OPT__ALPHA_SRC_OPT__SHIFT  = 0x00000010;
constexpr unsigned int SX_MRT0_BLEND_OPT__COLOR_COMB_FCN__SHIFT = 0x00000008;
constexpr unsigned int SX_MRT0_BLEND_OPT__COLOR_DST_OPT__SHIFT  = 0x00000004;
constexpr unsigned int SX_MRT0_BLEND_OPT__COLOR_SRC_OPT__SHIFT  = 0x00000000;
constexpr unsigned int SX_MRT1_BLEND_OPT__ALPHA_COMB_FCN__SHIFT = 0x00000018;
constexpr unsigned int SX_MRT1_BLEND_OPT__ALPHA_DST_OPT__SHIFT  = 0x00000014;
constexpr unsigned int SX_MRT1_BLEND_OPT__ALPHA_SRC_OPT__SHIFT  = 0x00000010;
constexpr unsigned int SX_MRT1_BLEND_OPT__COLOR_COMB_FCN__SHIFT = 0x00000008;
constexpr unsigned int SX_MRT1_BLEND_OPT__COLOR_DST_OPT__SHIFT  = 0x00000004;
constexpr unsigned int SX_MRT1_BLEND_OPT__COLOR_SRC_OPT__SHIFT  = 0x00000000;
constexpr unsigned int SX_MRT2_BLEND_OPT__ALPHA_COMB_FCN__SHIFT = 0x00000018;
constexpr unsigned int SX_MRT2_BLEND_OPT__ALPHA_DST_OPT__SHIFT  = 0x00000014;
constexpr unsigned int SX_MRT2_BLEND_OPT__ALPHA_SRC_OPT__SHIFT  = 0x00000010;
constexpr unsigned int SX_MRT2_BLEND_OPT__COLOR_COMB_FCN__SHIFT = 0x00000008;
constexpr unsigned int SX_MRT2_BLEND_OPT__COLOR_DST_OPT__SHIFT  = 0x00000004;
constexpr unsigned int SX_MRT2_BLEND_OPT__COLOR_SRC_OPT__SHIFT  = 0x00000000;
constexpr unsigned int SX_MRT3_BLEND_OPT__ALPHA_COMB_FCN__SHIFT = 0x00000018;
constexpr unsigned int SX_MRT3_BLEND_OPT__ALPHA_DST_OPT__SHIFT  = 0x00000014;
constexpr unsigned int SX_MRT3_BLEND_OPT__ALPHA_SRC_OPT__SHIFT  = 0x00000010;
constexpr unsigned int SX_MRT3_BLEND_OPT__COLOR_COMB_FCN__SHIFT = 0x00000008;
constexpr unsigned int SX_MRT3_BLEND_OPT__COLOR_DST_OPT__SHIFT  = 0x00000004;
constexpr unsigned int SX_MRT3_BLEND_OPT__COLOR_SRC_OPT__SHIFT  = 0x00000000;
constexpr unsigned int SX_MRT4_BLEND_OPT__ALPHA_COMB_FCN__SHIFT = 0x00000018;
constexpr unsigned int SX_MRT4_BLEND_OPT__ALPHA_DST_OPT__SHIFT  = 0x00000014;
constexpr unsigned int SX_MRT4_BLEND_OPT__ALPHA_SRC_OPT__SHIFT  = 0x00000010;
constexpr unsigned int SX_MRT4_BLEND_OPT__COLOR_COMB_FCN__SHIFT = 0x00000008;
constexpr unsigned int SX_MRT4_BLEND_OPT__COLOR_DST_OPT__SHIFT  = 0x00000004;
constexpr unsigned int SX_MRT4_BLEND_OPT__COLOR_SRC_OPT__SHIFT  = 0x00000000;
constexpr unsigned int SX_MRT5_BLEND_OPT__ALPHA_COMB_FCN__SHIFT = 0x00000018;
constexpr unsigned int SX_MRT5_BLEND_OPT__ALPHA_DST_OPT__SHIFT  = 0x00000014;
constexpr unsigned int SX_MRT5_BLEND_OPT__ALPHA_SRC_OPT__SHIFT  = 0x00000010;
constexpr unsigned int SX_MRT5_BLEND_OPT__COLOR_COMB_FCN__SHIFT = 0x00000008;
constexpr unsigned int SX_MRT5_BLEND_OPT__COLOR_DST_OPT__SHIFT  = 0x00000004;
constexpr unsigned int SX_MRT5_BLEND_OPT__COLOR_SRC_OPT__SHIFT  = 0x00000000;
constexpr unsigned int SX_MRT6_BLEND_OPT__ALPHA_COMB_FCN__SHIFT = 0x00000018;
constexpr unsigned int SX_MRT6_BLEND_OPT__ALPHA_DST_OPT__SHIFT  = 0x00000014;
constexpr unsigned int SX_MRT6_BLEND_OPT__ALPHA_SRC_OPT__SHIFT  = 0x00000010;
constexpr unsigned int SX_MRT6_BLEND_OPT__COLOR_COMB_FCN__SHIFT = 0x00000008;
constexpr unsigned int SX_MRT6_BLEND_OPT__COLOR_DST_OPT__SHIFT  = 0x00000004;
constexpr unsigned int SX_MRT6_BLEND_OPT__COLOR_SRC_OPT__SHIFT  = 0x00000000;
constexpr unsigned int SX_MRT7_BLEND_OPT__ALPHA_COMB_FCN__SHIFT = 0x00000018;
constexpr unsigned int SX_MRT7_BLEND_OPT__ALPHA_DST_OPT__SHIFT  = 0x00000014;
constexpr unsigned int SX_MRT7_BLEND_OPT__ALPHA_SRC_OPT__SHIFT  = 0x00000010;
constexpr unsigned int SX_MRT7_BLEND_OPT__COLOR_COMB_FCN__SHIFT = 0x00000008;
constexpr unsigned int SX_MRT7_BLEND_OPT__COLOR_DST_OPT__SHIFT  = 0x00000004;
constexpr unsigned int SX_MRT7_BLEND_OPT__COLOR_SRC_OPT__SHIFT  = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int SX_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int SX_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int SX_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT0__SHIFT           = 0x00000000;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT1__SHIFT           = 0x00000004;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT2__SHIFT           = 0x00000008;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT3__SHIFT           = 0x0000000c;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT4__SHIFT           = 0x00000010;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT5__SHIFT           = 0x00000014;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT6__SHIFT           = 0x00000018;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT7__SHIFT           = 0x0000001c;
constexpr unsigned int TA_BC_BASE_ADDR_HI__ADDRESS__SHIFT       = 0x00000000;
constexpr unsigned int TA_BC_BASE_ADDR__ADDRESS__SHIFT          = 0x00000000;
constexpr unsigned int TA_CGTT_CTRL__OFF_HYSTERESIS__SHIFT      = 0x00000004;
constexpr unsigned int TA_CGTT_CTRL__ON_DELAY__SHIFT            = 0x00000000;
constexpr unsigned int TA_CGTT_CTRL__SOFT_OVERRIDE0__SHIFT      = 0x0000001f;
constexpr unsigned int TA_CGTT_CTRL__SOFT_OVERRIDE1__SHIFT      = 0x0000001e;
constexpr unsigned int TA_CGTT_CTRL__SOFT_OVERRIDE2__SHIFT      = 0x0000001d;
constexpr unsigned int TA_CGTT_CTRL__SOFT_OVERRIDE3__SHIFT      = 0x0000001c;
constexpr unsigned int TA_CGTT_CTRL__SOFT_OVERRIDE4__SHIFT      = 0x0000001b;
constexpr unsigned int TA_CGTT_CTRL__SOFT_OVERRIDE5__SHIFT      = 0x0000001a;
constexpr unsigned int TA_CGTT_CTRL__SOFT_OVERRIDE6__SHIFT      = 0x00000019;
constexpr unsigned int TA_CGTT_CTRL__SOFT_OVERRIDE7__SHIFT      = 0x00000018;
constexpr unsigned int TA_CGTT_CTRL__SOFT_STALL_OVERRIDE0__SHIFT = 0x00000017;
constexpr unsigned int TA_CGTT_CTRL__SOFT_STALL_OVERRIDE1__SHIFT = 0x00000016;
constexpr unsigned int TA_CGTT_CTRL__SOFT_STALL_OVERRIDE2__SHIFT = 0x00000015;
constexpr unsigned int TA_CGTT_CTRL__SOFT_STALL_OVERRIDE3__SHIFT = 0x00000014;
constexpr unsigned int TA_CGTT_CTRL__SOFT_STALL_OVERRIDE4__SHIFT = 0x00000013;
constexpr unsigned int TA_CGTT_CTRL__SOFT_STALL_OVERRIDE5__SHIFT = 0x00000012;
constexpr unsigned int TA_CGTT_CTRL__SOFT_STALL_OVERRIDE6__SHIFT = 0x00000011;
constexpr unsigned int TA_CGTT_CTRL__SOFT_STALL_OVERRIDE7__SHIFT = 0x00000010;
constexpr unsigned int TA_CNTL_AUX__ANISO_ERROR_FP_VBIAS__SHIFT = 0x0000000c;
constexpr unsigned int TA_CNTL_AUX__ANISO_HALF_THRESH__SHIFT    = 0x0000000a;
constexpr unsigned int TA_CNTL_AUX__ANISO_RATIO_LUT__SHIFT      = 0x00000011;
constexpr unsigned int TA_CNTL_AUX__ANISO_STEP_ORDER__SHIFT     = 0x0000000d;
constexpr unsigned int TA_CNTL_AUX__ANISO_STEP__SHIFT           = 0x0000000e;
constexpr unsigned int TA_CNTL_AUX__ANISO_TAP__SHIFT            = 0x00000012;
constexpr unsigned int TA_CNTL_AUX__ANISO_WEIGHT_MODE__SHIFT    = 0x00000010;
constexpr unsigned int TA_CNTL_AUX__ARRAY_ROUND_MODE__SHIFT     = 0x0000001e;
constexpr unsigned int TA_CNTL_AUX__CUBEMAP_SLICE_CLAMP__SHIFT  = 0x0000001c;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_DFMT_NFMT_DISABLE__SHIFT = 0x0000001a;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_MISC_DISABLE__SHIFT = 0x00000016;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_OPCODE_STRICT_DISABLE__SHIFT = 0x00000015;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_RESERVED_DISABLE__SHIFT = 0x00000014;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_SAMPLER_MSAA_DISABLE__SHIFT = 0x00000018;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_SAMPLE_C_DFMT_DISABLE__SHIFT = 0x00000017;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_WRITEOP_READFMT_DISABLE__SHIFT = 0x00000019;
constexpr unsigned int TA_CNTL_AUX__DISABLE_DWORD_X2_COALESCE__SHIFT = 0x0000001b;
constexpr unsigned int TA_CNTL_AUX__DISABLE_GATHER4_BC_SWIZZLE__SHIFT = 0x00000007;
constexpr unsigned int TA_CNTL_AUX__GATHERH_DST_SEL__SHIFT      = 0x00000006;
constexpr unsigned int TA_CNTL_AUX__MINMAG_UNNORM__SHIFT        = 0x0000000f;
constexpr unsigned int TA_CNTL_AUX__SCOAL_DSWIZZLE_N__SHIFT     = 0x00000000;
constexpr unsigned int TA_CNTL_AUX__TFAULT_EN_OVERRIDE__SHIFT   = 0x00000005;
constexpr unsigned int TA_CNTL_AUX__TRUNC_SMALL_NEG__SHIFT      = 0x0000001d;
constexpr unsigned int TA_CNTL__ALIGNER_CREDIT__SHIFT           = 0x00000010;
constexpr unsigned int TA_CNTL__TD_FIFO_CREDIT__SHIFT           = 0x00000016;
constexpr unsigned int TA_CS_BC_BASE_ADDR_HI__ADDRESS__SHIFT    = 0x00000000;
constexpr unsigned int TA_CS_BC_BASE_ADDR__ADDRESS__SHIFT       = 0x00000000;
constexpr unsigned int TA_DEBUG_DATA__DATA__SHIFT               = 0x00000000;
constexpr unsigned int TA_DEBUG_INDEX__INDEX__SHIFT             = 0x00000000;
constexpr unsigned int TA_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int TA_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int TA_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
constexpr unsigned int TA_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
constexpr unsigned int TA_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
constexpr unsigned int TA_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
constexpr unsigned int TA_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int TA_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
constexpr unsigned int TA_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int TA_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
constexpr unsigned int TA_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT  = 0x00000000;
constexpr unsigned int TA_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int TA_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int TA_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int TA_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int TA_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT  = 0x00000000;
constexpr unsigned int TA_RESERVED_010C__Unused__SHIFT          = 0x00000000;
constexpr unsigned int TA_SCRATCH__SCRATCH__SHIFT               = 0x00000000;
constexpr unsigned int TA_STATUS__AL_BUSY__SHIFT                = 0x0000001e;
constexpr unsigned int TA_STATUS__BUSY__SHIFT                   = 0x0000001f;
constexpr unsigned int TA_STATUS__FA_BUSY__SHIFT                = 0x0000001d;
constexpr unsigned int TA_STATUS__FA_LFIFO_EMPTYB__SHIFT        = 0x00000015;
constexpr unsigned int TA_STATUS__FA_PFIFO_EMPTYB__SHIFT        = 0x00000014;
constexpr unsigned int TA_STATUS__FA_SFIFO_EMPTYB__SHIFT        = 0x00000016;
constexpr unsigned int TA_STATUS__FG_BUSY__SHIFT                = 0x00000019;
constexpr unsigned int TA_STATUS__FG_LFIFO_EMPTYB__SHIFT        = 0x0000000d;
constexpr unsigned int TA_STATUS__FG_PFIFO_EMPTYB__SHIFT        = 0x0000000c;
constexpr unsigned int TA_STATUS__FG_SFIFO_EMPTYB__SHIFT        = 0x0000000e;
constexpr unsigned int TA_STATUS__FL_BUSY__SHIFT                = 0x0000001b;
constexpr unsigned int TA_STATUS__FL_LFIFO_EMPTYB__SHIFT        = 0x00000011;
constexpr unsigned int TA_STATUS__FL_PFIFO_EMPTYB__SHIFT        = 0x00000010;
constexpr unsigned int TA_STATUS__FL_SFIFO_EMPTYB__SHIFT        = 0x00000012;
constexpr unsigned int TA_STATUS__IN_BUSY__SHIFT                = 0x00000018;
constexpr unsigned int TA_STATUS__LA_BUSY__SHIFT                = 0x0000001a;
constexpr unsigned int TA_STATUS__TA_BUSY__SHIFT                = 0x0000001c;
constexpr unsigned int TCI_CNTL_1__REQ_FIFO_DEPTH__SHIFT        = 0x00000010;
constexpr unsigned int TCI_CNTL_1__WBINVL1_NUM_CYCLES__SHIFT    = 0x00000000;
constexpr unsigned int TCI_CNTL_1__WDATA_RAM_DEPTH__SHIFT       = 0x00000018;
constexpr unsigned int TCI_CNTL_2__L1_INVAL_ON_WBINVL2__SHIFT   = 0x00000000;
constexpr unsigned int TCI_CNTL_2__TCA_MAX_CREDIT__SHIFT        = 0x00000001;
constexpr unsigned int TCI_STATUS__TCI_BUSY__SHIFT              = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT = 0x00000018;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int TCP_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int TCP_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int TCP_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int TCP_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__BUFFER__SHIFT = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__DATA_FORMAT__SHIFT = 0x00000003;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__DIM__SHIFT    = 0x00000002;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__FLAT__SHIFT   = 0x00000001;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__NUM_FORMAT__SHIFT = 0x00000004;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__NUM_SAMPLES__SHIFT = 0x00000006;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__OPCODE_TYPE__SHIFT = 0x00000007;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__SW_MODE__SHIFT = 0x00000005;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__BUFFER__SHIFT    = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__DATA_FORMAT__SHIFT = 0x00000005;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__DIM__SHIFT       = 0x00000002;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__FLAT__SHIFT      = 0x00000001;
constexpr unsigned int TD_CGTT_CTRL__OFF_HYSTERESIS__SHIFT      = 0x00000004;
constexpr unsigned int TD_CGTT_CTRL__ON_DELAY__SHIFT            = 0x00000000;
constexpr unsigned int TD_CGTT_CTRL__SOFT_OVERRIDE0__SHIFT      = 0x0000001f;
constexpr unsigned int TD_CGTT_CTRL__SOFT_OVERRIDE1__SHIFT      = 0x0000001e;
constexpr unsigned int TD_CGTT_CTRL__SOFT_OVERRIDE2__SHIFT      = 0x0000001d;
constexpr unsigned int TD_CGTT_CTRL__SOFT_OVERRIDE3__SHIFT      = 0x0000001c;
constexpr unsigned int TD_CGTT_CTRL__SOFT_OVERRIDE4__SHIFT      = 0x0000001b;
constexpr unsigned int TD_CGTT_CTRL__SOFT_OVERRIDE5__SHIFT      = 0x0000001a;
constexpr unsigned int TD_CGTT_CTRL__SOFT_OVERRIDE6__SHIFT      = 0x00000019;
constexpr unsigned int TD_CGTT_CTRL__SOFT_OVERRIDE7__SHIFT      = 0x00000018;
constexpr unsigned int TD_CGTT_CTRL__SOFT_STALL_OVERRIDE0__SHIFT = 0x00000017;
constexpr unsigned int TD_CGTT_CTRL__SOFT_STALL_OVERRIDE1__SHIFT = 0x00000016;
constexpr unsigned int TD_CGTT_CTRL__SOFT_STALL_OVERRIDE2__SHIFT = 0x00000015;
constexpr unsigned int TD_CGTT_CTRL__SOFT_STALL_OVERRIDE3__SHIFT = 0x00000014;
constexpr unsigned int TD_CGTT_CTRL__SOFT_STALL_OVERRIDE4__SHIFT = 0x00000013;
constexpr unsigned int TD_CGTT_CTRL__SOFT_STALL_OVERRIDE5__SHIFT = 0x00000012;
constexpr unsigned int TD_CGTT_CTRL__SOFT_STALL_OVERRIDE6__SHIFT = 0x00000011;
constexpr unsigned int TD_CGTT_CTRL__SOFT_STALL_OVERRIDE7__SHIFT = 0x00000010;
constexpr unsigned int TD_CNTL__DISABLE_2BIT_SIGNED_FORMAT__SHIFT = 0x00000017;
constexpr unsigned int TD_CNTL__DISABLE_POWER_THROTTLE__SHIFT   = 0x00000014;
constexpr unsigned int TD_CNTL__ENABLE_ROUND_TO_ZERO__SHIFT     = 0x00000015;
constexpr unsigned int TD_CNTL__EXTEND_LDS_STALL__SHIFT         = 0x00000009;
constexpr unsigned int TD_CNTL__GATHER4_DX9_MODE__SHIFT         = 0x00000013;
constexpr unsigned int TD_CNTL__GATHER4_FLOAT_MODE__SHIFT       = 0x00000010;
constexpr unsigned int TD_CNTL__LDS_STALL_PHASE_ADJUST__SHIFT   = 0x0000000b;
constexpr unsigned int TD_CNTL__LD_FLOAT_MODE__SHIFT            = 0x00000012;
constexpr unsigned int TD_CNTL__PAD_STALL_EN__SHIFT             = 0x00000008;
constexpr unsigned int TD_CNTL__PRECISION_COMPATIBILITY__SHIFT  = 0x0000000f;
constexpr unsigned int TD_CNTL__SYNC_PHASE_SH__SHIFT            = 0x00000000;
constexpr unsigned int TD_CNTL__SYNC_PHASE_VC_SMX__SHIFT        = 0x00000004;
constexpr unsigned int TD_DEBUG_DATA__DATA__SHIFT               = 0x00000000;
constexpr unsigned int TD_DEBUG_INDEX__INDEX__SHIFT             = 0x00000000;
constexpr unsigned int TD_DSM_CNTL2__TD_CS_FIFO_ENABLE_ERROR_INJECT__SHIFT = 0x00000006;
constexpr unsigned int TD_DSM_CNTL2__TD_CS_FIFO_SELECT_INJECT_DELAY__SHIFT = 0x00000008;
constexpr unsigned int TD_DSM_CNTL2__TD_INJECT_DELAY__SHIFT     = 0x0000001a;
constexpr unsigned int TD_DSM_CNTL2__TD_SS_FIFO_HI_ENABLE_ERROR_INJECT__SHIFT = 0x00000003;
constexpr unsigned int TD_DSM_CNTL2__TD_SS_FIFO_HI_SELECT_INJECT_DELAY__SHIFT = 0x00000005;
constexpr unsigned int TD_DSM_CNTL2__TD_SS_FIFO_LO_ENABLE_ERROR_INJECT__SHIFT = 0x00000000;
constexpr unsigned int TD_DSM_CNTL2__TD_SS_FIFO_LO_SELECT_INJECT_DELAY__SHIFT = 0x00000002;
constexpr unsigned int TD_DSM_CNTL__TD_CS_FIFO_DSM_IRRITATOR_DATA__SHIFT = 0x00000006;
constexpr unsigned int TD_DSM_CNTL__TD_CS_FIFO_ENABLE_SINGLE_WRITE__SHIFT = 0x00000008;
constexpr unsigned int TD_DSM_CNTL__TD_SS_FIFO_HI_DSM_IRRITATOR_DATA__SHIFT = 0x00000003;
constexpr unsigned int TD_DSM_CNTL__TD_SS_FIFO_HI_ENABLE_SINGLE_WRITE__SHIFT = 0x00000005;
constexpr unsigned int TD_DSM_CNTL__TD_SS_FIFO_LO_DSM_IRRITATOR_DATA__SHIFT = 0x00000000;
constexpr unsigned int TD_DSM_CNTL__TD_SS_FIFO_LO_ENABLE_SINGLE_WRITE__SHIFT = 0x00000002;
constexpr unsigned int TD_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int TD_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int TD_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
constexpr unsigned int TD_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
constexpr unsigned int TD_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
constexpr unsigned int TD_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
constexpr unsigned int TD_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int TD_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
constexpr unsigned int TD_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int TD_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
constexpr unsigned int TD_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT  = 0x00000000;
constexpr unsigned int TD_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
constexpr unsigned int TD_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
constexpr unsigned int TD_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT = 0x00000014;
constexpr unsigned int TD_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
constexpr unsigned int TD_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT  = 0x00000000;
constexpr unsigned int TD_SCRATCH__SCRATCH__SHIFT               = 0x00000000;
constexpr unsigned int TD_STATUS__BUSY__SHIFT                   = 0x0000001f;
constexpr unsigned int VGT_CACHE_INVALIDATION__AUTO_INVLD_EN__SHIFT = 0x00000006;
constexpr unsigned int VGT_CACHE_INVALIDATION__CACHE_INVALIDATION__SHIFT = 0x00000000;
constexpr unsigned int VGT_CACHE_INVALIDATION__DIS_INSTANCING_OPT__SHIFT = 0x00000004;
constexpr unsigned int VGT_CACHE_INVALIDATION__DIS_RANGE_FULL_INVLD__SHIFT = 0x0000000b;
constexpr unsigned int VGT_CACHE_INVALIDATION__ENABLE_PING_PONG_EOI__SHIFT = 0x0000001d;
constexpr unsigned int VGT_CACHE_INVALIDATION__ENABLE_PING_PONG__SHIFT = 0x00000015;
constexpr unsigned int VGT_CACHE_INVALIDATION__EN_WAVE_MERGE__SHIFT = 0x0000001c;
constexpr unsigned int VGT_CACHE_INVALIDATION__ES_LIMIT__SHIFT  = 0x00000010;
constexpr unsigned int VGT_CACHE_INVALIDATION__GS_LATE_ALLOC_EN__SHIFT = 0x0000000c;
constexpr unsigned int VGT_CACHE_INVALIDATION__OPT_FLOW_CNTL_1__SHIFT = 0x00000016;
constexpr unsigned int VGT_CACHE_INVALIDATION__OPT_FLOW_CNTL_2__SHIFT = 0x00000019;
constexpr unsigned int VGT_CACHE_INVALIDATION__STREAMOUT_FULL_FLUSH__SHIFT = 0x0000000d;
constexpr unsigned int VGT_CACHE_INVALIDATION__USE_GS_DONE__SHIFT = 0x00000009;
constexpr unsigned int VGT_CACHE_INVALIDATION__VS_NO_EXTRA_BUFFER__SHIFT = 0x00000005;
constexpr unsigned int VGT_DMA_BASE_HI__BASE_ADDR__SHIFT        = 0x00000000;
constexpr unsigned int VGT_DMA_BASE__BASE_ADDR__SHIFT           = 0x00000000;
constexpr unsigned int VGT_DMA_CONTROL__IA_SWITCH_ON_EOP__SHIFT = 0x00000011;
constexpr unsigned int VGT_DMA_CONTROL__PRIMGROUP_SIZE__SHIFT   = 0x00000000;
constexpr unsigned int VGT_DMA_CONTROL__SWITCH_ON_EOI__SHIFT    = 0x00000013;
constexpr unsigned int VGT_DMA_CONTROL__WD_SWITCH_ON_EOP__SHIFT = 0x00000014;
constexpr unsigned int VGT_DMA_DATA_FIFO_DEPTH__DMA_DATA_FIFO_DEPTH__SHIFT = 0x00000000;
constexpr unsigned int VGT_DMA_EVENT_INITIATOR__ADDRESS_HI__SHIFT = 0x0000000a;
constexpr unsigned int VGT_DMA_EVENT_INITIATOR__EVENT_TYPE__SHIFT = 0x00000000;
constexpr unsigned int VGT_DMA_EVENT_INITIATOR__EXTENDED_EVENT__SHIFT = 0x0000001b;
constexpr unsigned int VGT_DMA_INDEX_TYPE__BUF_TYPE__SHIFT      = 0x00000004;
constexpr unsigned int VGT_DMA_INDEX_TYPE__INDEX_TYPE__SHIFT    = 0x00000000;
constexpr unsigned int VGT_DMA_INDEX_TYPE__NOT_EOP__SHIFT       = 0x00000009;
constexpr unsigned int VGT_DMA_INDEX_TYPE__RDREQ_POLICY__SHIFT  = 0x00000006;
constexpr unsigned int VGT_DMA_INDEX_TYPE__REQ_PATH__SHIFT      = 0x0000000a;
constexpr unsigned int VGT_DMA_INDEX_TYPE__SWAP_MODE__SHIFT     = 0x00000002;
constexpr unsigned int VGT_DMA_LS_HS_CONFIG__HS_NUM_INPUT_CP__SHIFT = 0x00000008;
constexpr unsigned int VGT_DMA_MAX_SIZE__MAX_SIZE__SHIFT        = 0x00000000;
constexpr unsigned int VGT_DMA_NUM_INSTANCES__NUM_INSTANCES__SHIFT = 0x00000000;
constexpr unsigned int VGT_DMA_PRIMITIVE_TYPE__PRIM_TYPE__SHIFT = 0x00000000;
constexpr unsigned int VGT_DMA_REQ_FIFO_DEPTH__DMA_REQ_FIFO_DEPTH__SHIFT = 0x00000000;
constexpr unsigned int VGT_DMA_SIZE__NUM_INDICES__SHIFT         = 0x00000000;
constexpr unsigned int VGT_DRAW_INITIATOR__MAJOR_MODE__SHIFT    = 0x00000002;
constexpr unsigned int VGT_DRAW_INITIATOR__NOT_EOP__SHIFT       = 0x00000005;
constexpr unsigned int VGT_DRAW_INITIATOR__REG_RT_INDEX__SHIFT  = 0x0000001d;
constexpr unsigned int VGT_DRAW_INITIATOR__SOURCE_SELECT__SHIFT = 0x00000000;
constexpr unsigned int VGT_DRAW_INITIATOR__SPRITE_EN_R6XX__SHIFT = 0x00000004;
constexpr unsigned int VGT_DRAW_INITIATOR__USE_OPAQUE__SHIFT    = 0x00000006;
constexpr unsigned int VGT_DRAW_INIT_FIFO_DEPTH__DRAW_INIT_FIFO_DEPTH__SHIFT = 0x00000000;
constexpr unsigned int VGT_DRAW_PAYLOAD_CNTL__EN_REG_RT_INDEX__SHIFT = 0x00000001;
constexpr unsigned int VGT_ENHANCE__MISC__SHIFT                 = 0x00000000;
constexpr unsigned int VGT_ESGS_RING_ITEMSIZE__ITEMSIZE__SHIFT  = 0x00000000;
constexpr unsigned int VGT_ES_PER_GS__ES_PER_GS__SHIFT          = 0x00000000;
constexpr unsigned int VGT_EVENT_ADDRESS_REG__ADDRESS_LOW__SHIFT = 0x00000000;
constexpr unsigned int VGT_EVENT_INITIATOR__ADDRESS_HI__SHIFT   = 0x0000000a;
constexpr unsigned int VGT_EVENT_INITIATOR__EVENT_TYPE__SHIFT   = 0x00000000;
constexpr unsigned int VGT_EVENT_INITIATOR__EXTENDED_EVENT__SHIFT = 0x0000001b;
constexpr unsigned int VGT_FIFO_DEPTHS__CLIPP_FIFO_DEPTH__SHIFT = 0x00000008;
constexpr unsigned int VGT_FIFO_DEPTHS__RESERVED_0__SHIFT       = 0x00000007;
constexpr unsigned int VGT_FIFO_DEPTHS__VS_DEALLOC_TBL_DEPTH__SHIFT = 0x00000000;
constexpr unsigned int VGT_GROUP_DECR__DECR__SHIFT              = 0x00000000;
constexpr unsigned int VGT_GROUP_FIRST_DECR__FIRST_DECR__SHIFT  = 0x00000000;
constexpr unsigned int VGT_GROUP_PRIM_TYPE__PRIM_ORDER__SHIFT   = 0x00000010;
constexpr unsigned int VGT_GROUP_PRIM_TYPE__PRIM_TYPE__SHIFT    = 0x00000000;
constexpr unsigned int VGT_GROUP_PRIM_TYPE__RETAIN_ORDER__SHIFT = 0x0000000e;
constexpr unsigned int VGT_GROUP_PRIM_TYPE__RETAIN_QUADS__SHIFT = 0x0000000f;
constexpr unsigned int VGT_GROUP_VECT_0_CNTL__COMP_W_EN__SHIFT  = 0x00000003;
constexpr unsigned int VGT_GROUP_VECT_0_CNTL__COMP_X_EN__SHIFT  = 0x00000000;
constexpr unsigned int VGT_GROUP_VECT_0_CNTL__COMP_Y_EN__SHIFT  = 0x00000001;
constexpr unsigned int VGT_GROUP_VECT_0_CNTL__COMP_Z_EN__SHIFT  = 0x00000002;
constexpr unsigned int VGT_GROUP_VECT_0_CNTL__SHIFT__SHIFT      = 0x00000010;
constexpr unsigned int VGT_GROUP_VECT_0_CNTL__STRIDE__SHIFT     = 0x00000008;
constexpr unsigned int VGT_GROUP_VECT_0_FMT_CNTL__W_CONV__SHIFT = 0x00000018;
constexpr unsigned int VGT_GROUP_VECT_0_FMT_CNTL__W_OFFSET__SHIFT = 0x0000001c;
constexpr unsigned int VGT_GROUP_VECT_0_FMT_CNTL__X_CONV__SHIFT = 0x00000000;
constexpr unsigned int VGT_GROUP_VECT_0_FMT_CNTL__X_OFFSET__SHIFT = 0x00000004;
constexpr unsigned int VGT_GROUP_VECT_0_FMT_CNTL__Y_CONV__SHIFT = 0x00000008;
constexpr unsigned int VGT_GROUP_VECT_0_FMT_CNTL__Y_OFFSET__SHIFT = 0x0000000c;
constexpr unsigned int VGT_GROUP_VECT_0_FMT_CNTL__Z_CONV__SHIFT = 0x00000010;
constexpr unsigned int VGT_GROUP_VECT_0_FMT_CNTL__Z_OFFSET__SHIFT = 0x00000014;
constexpr unsigned int VGT_GROUP_VECT_1_CNTL__COMP_W_EN__SHIFT  = 0x00000003;
constexpr unsigned int VGT_GROUP_VECT_1_CNTL__COMP_X_EN__SHIFT  = 0x00000000;
constexpr unsigned int VGT_GROUP_VECT_1_CNTL__COMP_Y_EN__SHIFT  = 0x00000001;
constexpr unsigned int VGT_GROUP_VECT_1_CNTL__COMP_Z_EN__SHIFT  = 0x00000002;
constexpr unsigned int VGT_GROUP_VECT_1_CNTL__SHIFT__SHIFT      = 0x00000010;
constexpr unsigned int VGT_GROUP_VECT_1_CNTL__STRIDE__SHIFT     = 0x00000008;
constexpr unsigned int VGT_GROUP_VECT_1_FMT_CNTL__W_CONV__SHIFT = 0x00000018;
constexpr unsigned int VGT_GROUP_VECT_1_FMT_CNTL__W_OFFSET__SHIFT = 0x0000001c;
constexpr unsigned int VGT_GROUP_VECT_1_FMT_CNTL__X_CONV__SHIFT = 0x00000000;
constexpr unsigned int VGT_GROUP_VECT_1_FMT_CNTL__X_OFFSET__SHIFT = 0x00000004;
constexpr unsigned int VGT_GROUP_VECT_1_FMT_CNTL__Y_CONV__SHIFT = 0x00000008;
constexpr unsigned int VGT_GROUP_VECT_1_FMT_CNTL__Y_OFFSET__SHIFT = 0x0000000c;
constexpr unsigned int VGT_GROUP_VECT_1_FMT_CNTL__Z_CONV__SHIFT = 0x00000010;
constexpr unsigned int VGT_GROUP_VECT_1_FMT_CNTL__Z_OFFSET__SHIFT = 0x00000014;
constexpr unsigned int VGT_GSVS_RING_ITEMSIZE__ITEMSIZE__SHIFT  = 0x00000000;
constexpr unsigned int VGT_GSVS_RING_OFFSET_1__OFFSET__SHIFT    = 0x00000000;
constexpr unsigned int VGT_GSVS_RING_OFFSET_2__OFFSET__SHIFT    = 0x00000000;
constexpr unsigned int VGT_GSVS_RING_OFFSET_3__OFFSET__SHIFT    = 0x00000000;
constexpr unsigned int VGT_GSVS_RING_SIZE__MEM_SIZE__SHIFT      = 0x00000000;
constexpr unsigned int VGT_GS_INSTANCE_CNT__CNT__SHIFT          = 0x00000002;
constexpr unsigned int VGT_GS_INSTANCE_CNT__ENABLE__SHIFT       = 0x00000000;
constexpr unsigned int VGT_GS_MAX_VERT_OUT__MAX_VERT_OUT__SHIFT = 0x00000000;
constexpr unsigned int VGT_GS_MAX_WAVE_ID__MAX_WAVE_ID__SHIFT   = 0x00000000;
constexpr unsigned int VGT_GS_MODE__CUT_MODE__SHIFT             = 0x00000004;
constexpr unsigned int VGT_GS_MODE__ES_PASSTHRU__SHIFT          = 0x0000000d;
constexpr unsigned int VGT_GS_MODE__ES_WRITE_OPTIMIZE__SHIFT    = 0x00000013;
constexpr unsigned int VGT_GS_MODE__GS_C_PACK_EN__SHIFT         = 0x0000000b;
constexpr unsigned int VGT_GS_MODE__GS_WRITE_OPTIMIZE__SHIFT    = 0x00000014;
constexpr unsigned int VGT_GS_MODE__MODE__SHIFT                 = 0x00000000;
constexpr unsigned int VGT_GS_MODE__ONCHIP__SHIFT               = 0x00000015;
constexpr unsigned int VGT_GS_MODE__PARTIAL_THD_AT_EOI__SHIFT   = 0x00000011;
constexpr unsigned int VGT_GS_MODE__RESERVED_0__SHIFT           = 0x00000003;
constexpr unsigned int VGT_GS_MODE__RESERVED_1__SHIFT           = 0x00000006;
constexpr unsigned int VGT_GS_MODE__RESERVED_2__SHIFT           = 0x0000000c;
constexpr unsigned int VGT_GS_MODE__SUPPRESS_CUTS__SHIFT        = 0x00000012;
constexpr unsigned int VGT_GS_ONCHIP_CNTL__ES_VERTS_PER_SUBGRP__SHIFT = 0x00000000;
constexpr unsigned int VGT_GS_ONCHIP_CNTL__GS_INST_PRIMS_IN_SUBGRP__SHIFT = 0x00000016;
constexpr unsigned int VGT_GS_ONCHIP_CNTL__GS_PRIMS_PER_SUBGRP__SHIFT = 0x0000000b;
constexpr unsigned int VGT_GS_OUT_PRIM_TYPE__OUTPRIM_TYPE_1__SHIFT = 0x00000008;
constexpr unsigned int VGT_GS_OUT_PRIM_TYPE__OUTPRIM_TYPE_2__SHIFT = 0x00000010;
constexpr unsigned int VGT_GS_OUT_PRIM_TYPE__OUTPRIM_TYPE_3__SHIFT = 0x00000016;
constexpr unsigned int VGT_GS_OUT_PRIM_TYPE__OUTPRIM_TYPE__SHIFT = 0x00000000;
constexpr unsigned int VGT_GS_OUT_PRIM_TYPE__UNIQUE_TYPE_PER_STREAM__SHIFT = 0x0000001f;
constexpr unsigned int VGT_GS_PER_ES__GS_PER_ES__SHIFT          = 0x00000000;
constexpr unsigned int VGT_GS_PER_VS__GS_PER_VS__SHIFT          = 0x00000000;
constexpr unsigned int VGT_GS_VERTEX_REUSE__VERT_REUSE__SHIFT   = 0x00000000;
constexpr unsigned int VGT_GS_VERT_ITEMSIZE_1__ITEMSIZE__SHIFT  = 0x00000000;
constexpr unsigned int VGT_GS_VERT_ITEMSIZE_2__ITEMSIZE__SHIFT  = 0x00000000;
constexpr unsigned int VGT_GS_VERT_ITEMSIZE_3__ITEMSIZE__SHIFT  = 0x00000000;
constexpr unsigned int VGT_GS_VERT_ITEMSIZE__ITEMSIZE__SHIFT    = 0x00000000;
constexpr unsigned int VGT_HOS_CNTL__TESS_MODE__SHIFT           = 0x00000000;
constexpr unsigned int VGT_HOS_MAX_TESS_LEVEL__MAX_TESS__SHIFT  = 0x00000000;
constexpr unsigned int VGT_HOS_MIN_TESS_LEVEL__MIN_TESS__SHIFT  = 0x00000000;
constexpr unsigned int VGT_HOS_REUSE_DEPTH__REUSE_DEPTH__SHIFT  = 0x00000000;
constexpr unsigned int VGT_HS_OFFCHIP_PARAM__OFFCHIP_BUFFERING__SHIFT = 0x00000000;
constexpr unsigned int VGT_IMMED_DATA__DATA__SHIFT              = 0x00000000;
constexpr unsigned int VGT_INDEX_TYPE__INDEX_TYPE__SHIFT        = 0x00000000;
constexpr unsigned int VGT_INDX_OFFSET__INDX_OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int VGT_INSTANCE_BASE_ID__INSTANCE_BASE_ID__SHIFT = 0x00000000;
constexpr unsigned int VGT_INSTANCE_STEP_RATE_0__STEP_RATE__SHIFT = 0x00000000;
constexpr unsigned int VGT_INSTANCE_STEP_RATE_1__STEP_RATE__SHIFT = 0x00000000;
constexpr unsigned int VGT_LAST_COPY_STATE__DST_STATE_ID__SHIFT = 0x00000010;
constexpr unsigned int VGT_LAST_COPY_STATE__SRC_STATE_ID__SHIFT = 0x00000000;
constexpr unsigned int VGT_LS_HS_CONFIG__HS_NUM_INPUT_CP__SHIFT = 0x00000008;
constexpr unsigned int VGT_LS_HS_CONFIG__HS_NUM_OUTPUT_CP__SHIFT = 0x0000000e;
constexpr unsigned int VGT_LS_HS_CONFIG__NUM_PATCHES__SHIFT     = 0x00000000;
constexpr unsigned int VGT_MAX_VTX_INDX__MAX_INDX__SHIFT        = 0x00000000;
constexpr unsigned int VGT_MC_LAT_CNTL__MC_TIME_STAMP_RES__SHIFT = 0x00000000;
constexpr unsigned int VGT_MIN_VTX_INDX__MIN_INDX__SHIFT        = 0x00000000;
constexpr unsigned int VGT_MULTI_PRIM_IB_RESET_EN__MATCH_ALL_BITS__SHIFT = 0x00000001;
constexpr unsigned int VGT_MULTI_PRIM_IB_RESET_EN__RESET_EN__SHIFT = 0x00000000;
constexpr unsigned int VGT_MULTI_PRIM_IB_RESET_INDX__RESET_INDX__SHIFT = 0x00000000;
constexpr unsigned int VGT_NUM_INDICES__NUM_INDICES__SHIFT      = 0x00000000;
constexpr unsigned int VGT_NUM_INSTANCES__NUM_INSTANCES__SHIFT  = 0x00000000;
constexpr unsigned int VGT_OUTPUT_PATH_CNTL__PATH_SELECT__SHIFT = 0x00000000;
constexpr unsigned int VGT_OUT_DEALLOC_CNTL__DEALLOC_DIST__SHIFT = 0x00000000;
constexpr unsigned int VGT_PRIMITIVEID_EN__DISABLE_RESET_ON_EOI__SHIFT = 0x00000001;
constexpr unsigned int VGT_PRIMITIVEID_EN__NGG_DISABLE_PROVOK_REUSE__SHIFT = 0x00000002;
constexpr unsigned int VGT_PRIMITIVEID_EN__PRIMITIVEID_EN__SHIFT = 0x00000000;
constexpr unsigned int VGT_PRIMITIVEID_RESET__VALUE__SHIFT      = 0x00000000;
constexpr unsigned int VGT_PRIMITIVE_TYPE__PRIM_TYPE__SHIFT     = 0x00000000;
constexpr unsigned int VGT_RESET_DEBUG__GS_DISABLE__SHIFT       = 0x00000000;
constexpr unsigned int VGT_RESET_DEBUG__TESS_DISABLE__SHIFT     = 0x00000001;
constexpr unsigned int VGT_RESET_DEBUG__WD_DISABLE__SHIFT       = 0x00000002;
constexpr unsigned int VGT_REUSE_OFF__REUSE_OFF__SHIFT          = 0x00000000;
constexpr unsigned int VGT_SHADER_STAGES_EN__ES_EN__SHIFT       = 0x00000003;
constexpr unsigned int VGT_SHADER_STAGES_EN__GS_EN__SHIFT       = 0x00000005;
constexpr unsigned int VGT_SHADER_STAGES_EN__GS_FAST_LAUNCH__SHIFT = 0x00000013;
constexpr unsigned int VGT_SHADER_STAGES_EN__HS_EN__SHIFT       = 0x00000002;
constexpr unsigned int VGT_SHADER_STAGES_EN__LS_EN__SHIFT       = 0x00000000;
constexpr unsigned int VGT_SHADER_STAGES_EN__MAX_PRIMGRP_IN_WAVE__SHIFT = 0x0000000f;
constexpr unsigned int VGT_SHADER_STAGES_EN__ORDERED_ID_MODE__SHIFT = 0x0000000e;
constexpr unsigned int VGT_SHADER_STAGES_EN__PRIMGEN_EN__SHIFT  = 0x0000000d;
constexpr unsigned int VGT_SHADER_STAGES_EN__VS_EN__SHIFT       = 0x00000006;
constexpr unsigned int VGT_SHADER_STAGES_EN__VS_WAVE_ID_EN__SHIFT = 0x0000000c;
constexpr unsigned int VGT_STRMOUT_BUFFER_CONFIG__STREAM_0_BUFFER_EN__SHIFT = 0x00000000;
constexpr unsigned int VGT_STRMOUT_BUFFER_CONFIG__STREAM_1_BUFFER_EN__SHIFT = 0x00000004;
constexpr unsigned int VGT_STRMOUT_BUFFER_CONFIG__STREAM_2_BUFFER_EN__SHIFT = 0x00000008;
constexpr unsigned int VGT_STRMOUT_BUFFER_CONFIG__STREAM_3_BUFFER_EN__SHIFT = 0x0000000c;
constexpr unsigned int VGT_STRMOUT_BUFFER_FILLED_SIZE_0__SIZE__SHIFT = 0x00000000;
constexpr unsigned int VGT_STRMOUT_BUFFER_FILLED_SIZE_1__SIZE__SHIFT = 0x00000000;
constexpr unsigned int VGT_STRMOUT_BUFFER_FILLED_SIZE_2__SIZE__SHIFT = 0x00000000;
constexpr unsigned int VGT_STRMOUT_BUFFER_FILLED_SIZE_3__SIZE__SHIFT = 0x00000000;
constexpr unsigned int VGT_STRMOUT_BUFFER_OFFSET_0__OFFSET__SHIFT = 0x00000000;
constexpr unsigned int VGT_STRMOUT_BUFFER_OFFSET_1__OFFSET__SHIFT = 0x00000000;
constexpr unsigned int VGT_STRMOUT_BUFFER_OFFSET_2__OFFSET__SHIFT = 0x00000000;
constexpr unsigned int VGT_STRMOUT_BUFFER_OFFSET_3__OFFSET__SHIFT = 0x00000000;
constexpr unsigned int VGT_STRMOUT_BUFFER_SIZE_0__SIZE__SHIFT   = 0x00000000;
constexpr unsigned int VGT_STRMOUT_BUFFER_SIZE_1__SIZE__SHIFT   = 0x00000000;
constexpr unsigned int VGT_STRMOUT_BUFFER_SIZE_2__SIZE__SHIFT   = 0x00000000;
constexpr unsigned int VGT_STRMOUT_BUFFER_SIZE_3__SIZE__SHIFT   = 0x00000000;
constexpr unsigned int VGT_STRMOUT_CONFIG__EN_PRIMS_NEEDED_CNT__SHIFT = 0x00000007;
constexpr unsigned int VGT_STRMOUT_CONFIG__RAST_STREAM_MASK__SHIFT = 0x00000008;
constexpr unsigned int VGT_STRMOUT_CONFIG__RAST_STREAM__SHIFT   = 0x00000004;
constexpr unsigned int VGT_STRMOUT_CONFIG__STREAMOUT_0_EN__SHIFT = 0x00000000;
constexpr unsigned int VGT_STRMOUT_CONFIG__STREAMOUT_1_EN__SHIFT = 0x00000001;
constexpr unsigned int VGT_STRMOUT_CONFIG__STREAMOUT_2_EN__SHIFT = 0x00000002;
constexpr unsigned int VGT_STRMOUT_CONFIG__STREAMOUT_3_EN__SHIFT = 0x00000003;
constexpr unsigned int VGT_STRMOUT_CONFIG__USE_RAST_STREAM_MASK__SHIFT = 0x0000001f;
constexpr unsigned int VGT_STRMOUT_DELAY__SE0_WD_DELAY__SHIFT   = 0x00000008;
constexpr unsigned int VGT_STRMOUT_DELAY__SE1_WD_DELAY__SHIFT   = 0x0000000b;
constexpr unsigned int VGT_STRMOUT_DELAY__SE2_WD_DELAY__SHIFT   = 0x0000000e;
constexpr unsigned int VGT_STRMOUT_DELAY__SE3_WD_DELAY__SHIFT   = 0x00000011;
constexpr unsigned int VGT_STRMOUT_DELAY__SKIP_DELAY__SHIFT     = 0x00000000;
constexpr unsigned int VGT_STRMOUT_DRAW_OPAQUE_BUFFER_FILLED_SIZE__SIZE__SHIFT = 0x00000000;
constexpr unsigned int VGT_STRMOUT_DRAW_OPAQUE_OFFSET__OFFSET__SHIFT = 0x00000000;
constexpr unsigned int VGT_STRMOUT_DRAW_OPAQUE_VERTEX_STRIDE__VERTEX_STRIDE__SHIFT = 0x00000000;
constexpr unsigned int VGT_STRMOUT_VTX_STRIDE_0__STRIDE__SHIFT  = 0x00000000;
constexpr unsigned int VGT_STRMOUT_VTX_STRIDE_1__STRIDE__SHIFT  = 0x00000000;
constexpr unsigned int VGT_STRMOUT_VTX_STRIDE_2__STRIDE__SHIFT  = 0x00000000;
constexpr unsigned int VGT_STRMOUT_VTX_STRIDE_3__STRIDE__SHIFT  = 0x00000000;
constexpr unsigned int VGT_SYS_CONFIG__ADC_EVENT_FILTER_DISABLE__SHIFT = 0x00000007;
constexpr unsigned int VGT_SYS_CONFIG__DUAL_CORE_EN__SHIFT      = 0x00000000;
constexpr unsigned int VGT_SYS_CONFIG__MAX_LS_HS_THDGRP__SHIFT  = 0x00000001;
constexpr unsigned int VGT_TESS_DISTRIBUTION__ACCUM_ISOLINE__SHIFT = 0x00000000;
constexpr unsigned int VGT_TESS_DISTRIBUTION__ACCUM_QUAD__SHIFT = 0x00000010;
constexpr unsigned int VGT_TESS_DISTRIBUTION__ACCUM_TRI__SHIFT  = 0x00000008;
constexpr unsigned int VGT_TESS_DISTRIBUTION__DONUT_SPLIT__SHIFT = 0x00000018;
constexpr unsigned int VGT_TESS_DISTRIBUTION__TRAP_SPLIT__SHIFT = 0x0000001d;
constexpr unsigned int VGT_TF_MEMORY_BASE_HI__BASE_HI__SHIFT    = 0x00000000;
constexpr unsigned int VGT_TF_MEMORY_BASE__BASE__SHIFT          = 0x00000000;
constexpr unsigned int VGT_TF_PARAM__DEPRECATED__SHIFT          = 0x00000009;
constexpr unsigned int VGT_TF_PARAM__DISABLE_DONUTS__SHIFT      = 0x0000000e;
constexpr unsigned int VGT_TF_PARAM__DISTRIBUTION_MODE__SHIFT   = 0x00000011;
constexpr unsigned int VGT_TF_PARAM__PARTITIONING__SHIFT        = 0x00000002;
constexpr unsigned int VGT_TF_PARAM__RDREQ_POLICY__SHIFT        = 0x0000000f;
constexpr unsigned int VGT_TF_PARAM__RESERVED_REDUC_AXIS__SHIFT = 0x00000008;
constexpr unsigned int VGT_TF_PARAM__TOPOLOGY__SHIFT            = 0x00000005;
constexpr unsigned int VGT_TF_PARAM__TYPE__SHIFT                = 0x00000000;
constexpr unsigned int VGT_TF_RING_SIZE__SIZE__SHIFT            = 0x00000000;
constexpr unsigned int VGT_VERTEX_REUSE_BLOCK_CNTL__VTX_REUSE_DEPTH__SHIFT = 0x00000000;
constexpr unsigned int VGT_VS_MAX_WAVE_ID__MAX_WAVE_ID__SHIFT   = 0x00000000;
constexpr unsigned int VGT_VTX_CNT_EN__VTX_CNT_EN__SHIFT        = 0x00000000;
constexpr unsigned int VGT_VTX_VECT_EJECT_REG__PRIM_COUNT__SHIFT = 0x00000000;
constexpr unsigned int WD_BUF_RESOURCE_1__INDEX_BUF_SIZE__SHIFT = 0x00000010;
constexpr unsigned int WD_BUF_RESOURCE_1__POS_BUF_SIZE__SHIFT   = 0x00000000;
constexpr unsigned int WD_BUF_RESOURCE_2__ADDR_MODE__SHIFT      = 0x0000000f;
constexpr unsigned int WD_BUF_RESOURCE_2__CNTL_SB_BUF_SIZE__SHIFT = 0x00000010;
constexpr unsigned int WD_BUF_RESOURCE_2__PARAM_BUF_SIZE__SHIFT = 0x00000000;
constexpr unsigned int WD_CNTL_SB_BUF_BASE_HI__BASE_HI__SHIFT   = 0x00000000;
constexpr unsigned int WD_CNTL_SB_BUF_BASE__BASE__SHIFT         = 0x00000000;
constexpr unsigned int WD_ENHANCE__MISC__SHIFT                  = 0x00000000;
constexpr unsigned int WD_INDEX_BUF_BASE_HI__BASE_HI__SHIFT     = 0x00000000;
constexpr unsigned int WD_INDEX_BUF_BASE__BASE__SHIFT           = 0x00000000;
constexpr unsigned int WD_POS_BUF_BASE_HI__BASE_HI__SHIFT       = 0x00000000;
constexpr unsigned int WD_POS_BUF_BASE__BASE__SHIFT             = 0x00000000;
constexpr unsigned int WD_QOS__DRAW_STALL__SHIFT                = 0x00000000;
constexpr unsigned int WD_UTCL1_CNTL__BYPASS__SHIFT             = 0x00000019;
constexpr unsigned int WD_UTCL1_CNTL__DROP_MODE__SHIFT          = 0x00000018;
constexpr unsigned int WD_UTCL1_CNTL__FORCE_SNOOP__SHIFT        = 0x0000001c;
constexpr unsigned int WD_UTCL1_CNTL__FRAG_LIMIT_MODE__SHIFT    = 0x0000001b;
constexpr unsigned int WD_UTCL1_CNTL__INVALIDATE__SHIFT         = 0x0000001a;
constexpr unsigned int WD_UTCL1_CNTL__VMID_RESET_MODE__SHIFT    = 0x00000017;
constexpr unsigned int WD_UTCL1_CNTL__XNACK_REDO_TIMER_CNT__SHIFT = 0x00000000;
constexpr unsigned int WD_UTCL1_STATUS__FAULT_DETECTED__SHIFT   = 0x00000000;
constexpr unsigned int WD_UTCL1_STATUS__FAULT_UTCL1ID__SHIFT    = 0x00000008;
constexpr unsigned int WD_UTCL1_STATUS__PRT_DETECTED__SHIFT     = 0x00000002;
constexpr unsigned int WD_UTCL1_STATUS__PRT_UTCL1ID__SHIFT      = 0x00000018;
constexpr unsigned int WD_UTCL1_STATUS__RETRY_DETECTED__SHIFT   = 0x00000001;
constexpr unsigned int WD_UTCL1_STATUS__RETRY_UTCL1ID__SHIFT    = 0x00000010;

namespace Apu09Plus
{
    constexpr unsigned int RPB_EA_QUEUE_WR__READ_QUEUE__SHIFT       = 0x00000008;
    constexpr unsigned int RPB_EA_QUEUE_WR__UPDATE__SHIFT           = 0x0000000b;
    constexpr unsigned int RPB_EA_QUEUE_WR__WRITE_QUEUE__SHIFT      = 0x00000005;
} // namespace Apu09Plus

namespace Apu09_1xPlus
{
    constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_ADDR__addr__SHIFT  = 0x00000000;
    constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_DATA__data__SHIFT  = 0x00000000;
    constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_DATA__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeRearmAccum__SHIFT = 0x00000002;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeResetPerfMonitors__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeStartAccumulation__SHIFT = 0x00000001;
    constexpr unsigned int RLC_SPM_ACCUM_DATARAM_ADDR__addr__SHIFT  = 0x00000000;
    constexpr unsigned int RLC_SPM_ACCUM_DATARAM_ADDR__RESERVED__SHIFT = 0x00000007;
    constexpr unsigned int RLC_SPM_ACCUM_DATARAM_DATA__data__SHIFT  = 0x00000000;
    constexpr unsigned int RLC_SPM_ACCUM_DATARAM_WRCOUNT__DataRamWrCount__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_ACCUM_DATARAM_WRCOUNT__RESERVED__SHIFT = 0x00000013;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__EnableAccum__SHIFT   = 0x00000000;
    constexpr unsigned int RLC_SPM_ACCUM_SAMPLES_REQUESTED__SamplesRequested__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__AccumArmed__SHIFT  = 0x0000000b;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__AccumDone__SHIFT   = 0x00000008;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__AccumOverflow__SHIFT = 0x0000000a;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__AllFifosEmpty__SHIFT = 0x0000000e;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__FinalSequenceInProgress__SHIFT = 0x0000000d;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__FSMIsIdle__SHIFT   = 0x0000000f;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__NumbSamplesCompleted__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__SequenceInProgress__SHIFT = 0x0000000c;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__SpmDone__SHIFT     = 0x00000009;
    constexpr unsigned int RLC_SPM_ACCUM_THRESHOLD__Threshold__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_CHKSUM_GS__CHECKSUM__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_CHKSUM_HS__CHECKSUM__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_CHKSUM_PS__CHECKSUM__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_CHKSUM_VS__CHECKSUM__SHIFT = 0x00000000;
} // namespace Apu09_1xPlus

namespace Gfx09
{
    constexpr unsigned int ATC_L2_PERFCOUNTER0_CFG__CLEAR__SHIFT    = 0x0000001d;
    constexpr unsigned int ATC_L2_PERFCOUNTER0_CFG__ENABLE__SHIFT   = 0x0000001c;
    constexpr unsigned int ATC_L2_PERFCOUNTER0_CFG__PERF_MODE__SHIFT = 0x00000018;
    constexpr unsigned int ATC_L2_PERFCOUNTER0_CFG__PERF_SEL_END__SHIFT = 0x00000008;
    constexpr unsigned int ATC_L2_PERFCOUNTER0_CFG__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int ATC_L2_PERFCOUNTER1_CFG__CLEAR__SHIFT    = 0x0000001d;
    constexpr unsigned int ATC_L2_PERFCOUNTER1_CFG__ENABLE__SHIFT   = 0x0000001c;
    constexpr unsigned int ATC_L2_PERFCOUNTER1_CFG__PERF_MODE__SHIFT = 0x00000018;
    constexpr unsigned int ATC_L2_PERFCOUNTER1_CFG__PERF_SEL_END__SHIFT = 0x00000008;
    constexpr unsigned int ATC_L2_PERFCOUNTER1_CFG__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int ATC_L2_PERFCOUNTER_HI__COMPARE_VALUE__SHIFT = 0x00000010;
    constexpr unsigned int ATC_L2_PERFCOUNTER_HI__COUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int ATC_L2_PERFCOUNTER_LO__COUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int ATC_L2_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL__SHIFT = 0x00000019;
    constexpr unsigned int ATC_L2_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY__SHIFT = 0x00000018;
    constexpr unsigned int ATC_L2_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int ATC_L2_PERFCOUNTER_RSLT_CNTL__START_TRIGGER__SHIFT = 0x00000008;
    constexpr unsigned int ATC_L2_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE__SHIFT = 0x0000001a;
    constexpr unsigned int ATC_L2_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER__SHIFT = 0x00000010;
    constexpr unsigned int CB_COLOR0_ATTRIB__COLOR_SW_MODE__SHIFT   = 0x00000012;
    constexpr unsigned int CB_COLOR0_ATTRIB__FMASK_SW_MODE__SHIFT   = 0x00000017;
    constexpr unsigned int CB_COLOR0_ATTRIB__META_LINEAR__SHIFT     = 0x0000000b;
    constexpr unsigned int CB_COLOR0_ATTRIB__MIP0_DEPTH__SHIFT      = 0x00000000;
    constexpr unsigned int CB_COLOR0_ATTRIB__PIPE_ALIGNED__SHIFT    = 0x0000001f;
    constexpr unsigned int CB_COLOR0_ATTRIB__RB_ALIGNED__SHIFT      = 0x0000001e;
    constexpr unsigned int CB_COLOR0_ATTRIB__RESOURCE_TYPE__SHIFT   = 0x0000001c;
    constexpr unsigned int CB_COLOR0_VIEW__MIP_LEVEL__SHIFT         = 0x00000018;
    constexpr unsigned int CB_COLOR1_ATTRIB__COLOR_SW_MODE__SHIFT   = 0x00000012;
    constexpr unsigned int CB_COLOR1_ATTRIB__FMASK_SW_MODE__SHIFT   = 0x00000017;
    constexpr unsigned int CB_COLOR1_ATTRIB__META_LINEAR__SHIFT     = 0x0000000b;
    constexpr unsigned int CB_COLOR1_ATTRIB__MIP0_DEPTH__SHIFT      = 0x00000000;
    constexpr unsigned int CB_COLOR1_ATTRIB__PIPE_ALIGNED__SHIFT    = 0x0000001f;
    constexpr unsigned int CB_COLOR1_ATTRIB__RB_ALIGNED__SHIFT      = 0x0000001e;
    constexpr unsigned int CB_COLOR1_ATTRIB__RESOURCE_TYPE__SHIFT   = 0x0000001c;
    constexpr unsigned int CB_COLOR1_VIEW__MIP_LEVEL__SHIFT         = 0x00000018;
    constexpr unsigned int CB_COLOR2_ATTRIB__COLOR_SW_MODE__SHIFT   = 0x00000012;
    constexpr unsigned int CB_COLOR2_ATTRIB__FMASK_SW_MODE__SHIFT   = 0x00000017;
    constexpr unsigned int CB_COLOR2_ATTRIB__META_LINEAR__SHIFT     = 0x0000000b;
    constexpr unsigned int CB_COLOR2_ATTRIB__MIP0_DEPTH__SHIFT      = 0x00000000;
    constexpr unsigned int CB_COLOR2_ATTRIB__PIPE_ALIGNED__SHIFT    = 0x0000001f;
    constexpr unsigned int CB_COLOR2_ATTRIB__RB_ALIGNED__SHIFT      = 0x0000001e;
    constexpr unsigned int CB_COLOR2_ATTRIB__RESOURCE_TYPE__SHIFT   = 0x0000001c;
    constexpr unsigned int CB_COLOR2_VIEW__MIP_LEVEL__SHIFT         = 0x00000018;
    constexpr unsigned int CB_COLOR3_ATTRIB__COLOR_SW_MODE__SHIFT   = 0x00000012;
    constexpr unsigned int CB_COLOR3_ATTRIB__FMASK_SW_MODE__SHIFT   = 0x00000017;
    constexpr unsigned int CB_COLOR3_ATTRIB__META_LINEAR__SHIFT     = 0x0000000b;
    constexpr unsigned int CB_COLOR3_ATTRIB__MIP0_DEPTH__SHIFT      = 0x00000000;
    constexpr unsigned int CB_COLOR3_ATTRIB__PIPE_ALIGNED__SHIFT    = 0x0000001f;
    constexpr unsigned int CB_COLOR3_ATTRIB__RB_ALIGNED__SHIFT      = 0x0000001e;
    constexpr unsigned int CB_COLOR3_ATTRIB__RESOURCE_TYPE__SHIFT   = 0x0000001c;
    constexpr unsigned int CB_COLOR3_VIEW__MIP_LEVEL__SHIFT         = 0x00000018;
    constexpr unsigned int CB_COLOR4_ATTRIB__COLOR_SW_MODE__SHIFT   = 0x00000012;
    constexpr unsigned int CB_COLOR4_ATTRIB__FMASK_SW_MODE__SHIFT   = 0x00000017;
    constexpr unsigned int CB_COLOR4_ATTRIB__META_LINEAR__SHIFT     = 0x0000000b;
    constexpr unsigned int CB_COLOR4_ATTRIB__MIP0_DEPTH__SHIFT      = 0x00000000;
    constexpr unsigned int CB_COLOR4_ATTRIB__PIPE_ALIGNED__SHIFT    = 0x0000001f;
    constexpr unsigned int CB_COLOR4_ATTRIB__RB_ALIGNED__SHIFT      = 0x0000001e;
    constexpr unsigned int CB_COLOR4_ATTRIB__RESOURCE_TYPE__SHIFT   = 0x0000001c;
    constexpr unsigned int CB_COLOR4_VIEW__MIP_LEVEL__SHIFT         = 0x00000018;
    constexpr unsigned int CB_COLOR5_ATTRIB__COLOR_SW_MODE__SHIFT   = 0x00000012;
    constexpr unsigned int CB_COLOR5_ATTRIB__FMASK_SW_MODE__SHIFT   = 0x00000017;
    constexpr unsigned int CB_COLOR5_ATTRIB__META_LINEAR__SHIFT     = 0x0000000b;
    constexpr unsigned int CB_COLOR5_ATTRIB__MIP0_DEPTH__SHIFT      = 0x00000000;
    constexpr unsigned int CB_COLOR5_ATTRIB__PIPE_ALIGNED__SHIFT    = 0x0000001f;
    constexpr unsigned int CB_COLOR5_ATTRIB__RB_ALIGNED__SHIFT      = 0x0000001e;
    constexpr unsigned int CB_COLOR5_ATTRIB__RESOURCE_TYPE__SHIFT   = 0x0000001c;
    constexpr unsigned int CB_COLOR5_VIEW__MIP_LEVEL__SHIFT         = 0x00000018;
    constexpr unsigned int CB_COLOR6_ATTRIB__COLOR_SW_MODE__SHIFT   = 0x00000012;
    constexpr unsigned int CB_COLOR6_ATTRIB__FMASK_SW_MODE__SHIFT   = 0x00000017;
    constexpr unsigned int CB_COLOR6_ATTRIB__META_LINEAR__SHIFT     = 0x0000000b;
    constexpr unsigned int CB_COLOR6_ATTRIB__MIP0_DEPTH__SHIFT      = 0x00000000;
    constexpr unsigned int CB_COLOR6_ATTRIB__PIPE_ALIGNED__SHIFT    = 0x0000001f;
    constexpr unsigned int CB_COLOR6_ATTRIB__RB_ALIGNED__SHIFT      = 0x0000001e;
    constexpr unsigned int CB_COLOR6_ATTRIB__RESOURCE_TYPE__SHIFT   = 0x0000001c;
    constexpr unsigned int CB_COLOR6_VIEW__MIP_LEVEL__SHIFT         = 0x00000018;
    constexpr unsigned int CB_COLOR7_ATTRIB__COLOR_SW_MODE__SHIFT   = 0x00000012;
    constexpr unsigned int CB_COLOR7_ATTRIB__FMASK_SW_MODE__SHIFT   = 0x00000017;
    constexpr unsigned int CB_COLOR7_ATTRIB__META_LINEAR__SHIFT     = 0x0000000b;
    constexpr unsigned int CB_COLOR7_ATTRIB__MIP0_DEPTH__SHIFT      = 0x00000000;
    constexpr unsigned int CB_COLOR7_ATTRIB__PIPE_ALIGNED__SHIFT    = 0x0000001f;
    constexpr unsigned int CB_COLOR7_ATTRIB__RB_ALIGNED__SHIFT      = 0x0000001e;
    constexpr unsigned int CB_COLOR7_ATTRIB__RESOURCE_TYPE__SHIFT   = 0x0000001c;
    constexpr unsigned int CB_COLOR7_VIEW__MIP_LEVEL__SHIFT         = 0x00000018;
    constexpr unsigned int CB_DCC_CONFIG__DCC_CACHE_EVICT_POINT__SHIFT = 0x00000018;
    constexpr unsigned int CB_DCC_CONFIG__DCC_CACHE_NUM_TAGS__SHIFT = 0x0000001c;
    constexpr unsigned int CB_DCC_CONTROL__OVERWRITE_COMBINER_MRT_SHARING_DISABLE__SHIFT = 0x00000001;
    constexpr unsigned int CB_HW_CONTROL_1__CC_CACHE_NUM_TAGS__SHIFT = 0x0000000b;
    constexpr unsigned int CB_HW_CONTROL_1__CM_TILE_FIFO_DEPTH__SHIFT = 0x00000011;
    constexpr unsigned int CB_HW_CONTROL_1__RMI_CREDITS__SHIFT      = 0x0000001a;
    constexpr unsigned int CB_HW_CONTROL_2__CHICKEN_BITS__SHIFT     = 0x0000001c;
    constexpr unsigned int CB_HW_CONTROL_3__COLOR_CACHE_PREFETCH_NUM_CLS__SHIFT = 0x0000001c;
    constexpr unsigned int CB_HW_CONTROL_3__DISABLE_CC_CACHE_OVWR_KEY_MOD__SHIFT = 0x00000006;
    constexpr unsigned int CB_HW_CONTROL_3__DISABLE_DUALSRC_WITH_OBJPRIMID_FIX__SHIFT = 0x0000001b;
    constexpr unsigned int CB_HW_CONTROL_3__DISABLE_OVERWRITE_COMBINER_TARGET_MASK_VALIDATION__SHIFT = 0x00000008;
    constexpr unsigned int CB_HW_CONTROL__ALLOW_MRT_WITH_DUAL_SOURCE__SHIFT = 0x00000010;
    constexpr unsigned int CB_HW_CONTROL__CC_CACHE_EVICT_POINT__SHIFT = 0x0000000c;
    constexpr unsigned int CB_HW_CONTROL__CM_CACHE_EVICT_POINT__SHIFT = 0x00000000;
    constexpr unsigned int CB_HW_CONTROL__FC_CACHE_EVICT_POINT__SHIFT = 0x00000006;
    constexpr unsigned int CB_MRT0_EPITCH__EPITCH__SHIFT            = 0x00000000;
    constexpr unsigned int CB_MRT1_EPITCH__EPITCH__SHIFT            = 0x00000000;
    constexpr unsigned int CB_MRT2_EPITCH__EPITCH__SHIFT            = 0x00000000;
    constexpr unsigned int CB_MRT3_EPITCH__EPITCH__SHIFT            = 0x00000000;
    constexpr unsigned int CB_MRT4_EPITCH__EPITCH__SHIFT            = 0x00000000;
    constexpr unsigned int CB_MRT5_EPITCH__EPITCH__SHIFT            = 0x00000000;
    constexpr unsigned int CB_MRT6_EPITCH__EPITCH__SHIFT            = 0x00000000;
    constexpr unsigned int CB_MRT7_EPITCH__EPITCH__SHIFT            = 0x00000000;
    constexpr unsigned int COMPUTE_PGM_RSRC2__SKIP_USGPR0__SHIFT    = 0x0000001f;
    constexpr unsigned int COMPUTE_RESOURCE_LIMITS__SIMD_DISABLE__SHIFT = 0x0000001b;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE0__SH0_CU_EN__SHIFT = 0x00000000;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE0__SH1_CU_EN__SHIFT = 0x00000010;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE1__SH0_CU_EN__SHIFT = 0x00000000;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE1__SH1_CU_EN__SHIFT = 0x00000010;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE2__SH0_CU_EN__SHIFT = 0x00000000;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE2__SH1_CU_EN__SHIFT = 0x00000010;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE3__SH0_CU_EN__SHIFT = 0x00000000;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE3__SH1_CU_EN__SHIFT = 0x00000010;
    constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__CNTR_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__CNTR_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int CPC_PERFCOUNTER0_SELECT__CNTR_SEL0__SHIFT = 0x00000000;
    constexpr unsigned int CPC_PERFCOUNTER0_SELECT__CNTR_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int CPC_PERFCOUNTER1_SELECT__CNTR_SEL0__SHIFT = 0x00000000;
    constexpr unsigned int CPC_PERFCOUNTER1_SELECT__CNTR_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__CNTR_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__CNTR_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int CPF_PERFCOUNTER0_SELECT__CNTR_SEL0__SHIFT = 0x00000000;
    constexpr unsigned int CPF_PERFCOUNTER0_SELECT__CNTR_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int CPF_PERFCOUNTER1_SELECT__CNTR_SEL0__SHIFT = 0x00000000;
    constexpr unsigned int CPF_PERFCOUNTER1_SELECT__CNTR_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__CNTR_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__CNTR_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int CPG_PERFCOUNTER0_SELECT__CNTR_SEL0__SHIFT = 0x00000000;
    constexpr unsigned int CPG_PERFCOUNTER0_SELECT__CNTR_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int CPG_PERFCOUNTER1_SELECT__CNTR_SEL0__SHIFT = 0x00000000;
    constexpr unsigned int CPG_PERFCOUNTER1_SELECT__CNTR_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int CP_CE_RB_OFFSET__RB_OFFSET__SHIFT        = 0x00000000;
    constexpr unsigned int CP_CONTEXT_CNTL__ME0PIPE0_MAX_WD_CNTX__SHIFT = 0x00000000;
    constexpr unsigned int CP_CONTEXT_CNTL__ME0PIPE1_MAX_WD_CNTX__SHIFT = 0x00000010;
    constexpr unsigned int CP_DFY_CNTL__MTYPE__SHIFT                = 0x00000002;
    constexpr unsigned int CP_DFY_CNTL__POLICY__SHIFT               = 0x00000000;
    constexpr unsigned int CP_EOP_DONE_EVENT_CNTL__WBINV_ACTION_ENA__SHIFT = 0x0000000c;
    constexpr unsigned int CP_EOP_DONE_EVENT_CNTL__WBINV_TC_OP__SHIFT = 0x00000000;
    constexpr unsigned int CP_GFX_ERROR__RSVD1_ERROR__SHIFT         = 0x00000005;
    constexpr unsigned int CP_GFX_ERROR__RSVD2_ERROR__SHIFT         = 0x00000006;
    constexpr unsigned int CP_HQD_IQ_TIMER__QUEUE_TYPE__SHIFT       = 0x00000019;
    constexpr unsigned int CP_HQD_PQ_CONTROL__ENDIAN_SWAP__SHIFT    = 0x00000011;
    constexpr unsigned int CP_HQD_PQ_CONTROL__ROQ_PQ_IB_FLIP__SHIFT = 0x0000001d;
    constexpr unsigned int CP_HQD_PQ_CONTROL__SLOT_BASED_WPTR__SHIFT = 0x00000019;
    constexpr unsigned int CP_HQD_PQ_CONTROL__WPP_CLAMP_EN__SHIFT   = 0x00000010;
    constexpr unsigned int CP_MEC_CNTL__MEC_INVALIDATE_ICACHE__SHIFT = 0x00000004;
    constexpr unsigned int CP_RB0_CNTL__BUF_SWAP__SHIFT             = 0x00000011;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_0__DOORBELL_EN__SHIFT = 0x0000001e;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_0__DOORBELL_HIT__SHIFT = 0x0000001f;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_0__DOORBELL_OFFSET__SHIFT = 0x00000002;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_1__DOORBELL_EN__SHIFT = 0x0000001e;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_1__DOORBELL_HIT__SHIFT = 0x0000001f;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_1__DOORBELL_OFFSET__SHIFT = 0x00000002;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_2__DOORBELL_EN__SHIFT = 0x0000001e;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_2__DOORBELL_HIT__SHIFT = 0x0000001f;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_2__DOORBELL_OFFSET__SHIFT = 0x00000002;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_3__DOORBELL_EN__SHIFT = 0x0000001e;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_3__DOORBELL_HIT__SHIFT = 0x0000001f;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_3__DOORBELL_OFFSET__SHIFT = 0x00000002;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_4__DOORBELL_EN__SHIFT = 0x0000001e;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_4__DOORBELL_HIT__SHIFT = 0x0000001f;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_4__DOORBELL_OFFSET__SHIFT = 0x00000002;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_5__DOORBELL_EN__SHIFT = 0x0000001e;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_5__DOORBELL_HIT__SHIFT = 0x0000001f;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_5__DOORBELL_OFFSET__SHIFT = 0x00000002;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_6__DOORBELL_EN__SHIFT = 0x0000001e;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_6__DOORBELL_HIT__SHIFT = 0x0000001f;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_6__DOORBELL_OFFSET__SHIFT = 0x00000002;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_7__DOORBELL_EN__SHIFT = 0x0000001e;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_7__DOORBELL_HIT__SHIFT = 0x0000001f;
    constexpr unsigned int CP_RB_DOORBELL_CONTROL_SCH_7__DOORBELL_OFFSET__SHIFT = 0x00000002;
    constexpr unsigned int CP_ROQ1_THRESHOLDS__R0_IB1_START__SHIFT  = 0x00000010;
    constexpr unsigned int CP_ROQ1_THRESHOLDS__R1_IB1_START__SHIFT  = 0x00000018;
    constexpr unsigned int CP_ROQ1_THRESHOLDS__RB2_START__SHIFT     = 0x00000008;
    constexpr unsigned int CP_ROQ2_THRESHOLDS__R0_IB2_START__SHIFT  = 0x00000008;
    constexpr unsigned int CP_ROQ2_THRESHOLDS__R1_IB2_START__SHIFT  = 0x00000010;
    constexpr unsigned int CP_ROQ2_THRESHOLDS__R2_IB1_START__SHIFT  = 0x00000000;
    constexpr unsigned int CP_ROQ2_THRESHOLDS__R2_IB2_START__SHIFT  = 0x00000018;
    constexpr unsigned int CP_SD_CNTL__IA_EN__SHIFT                 = 0x00000006;
    constexpr unsigned int CP_SD_CNTL__PA_EN__SHIFT                 = 0x00000007;
    constexpr unsigned int CP_SD_CNTL__RMI_EN__SHIFT                = 0x00000008;
    constexpr unsigned int CP_SD_CNTL__WD_EN__SHIFT                 = 0x00000005;
    constexpr unsigned int CP_SIG_SEM_ADDR_LO__SEM_ADDR_SWAP__SHIFT = 0x00000000;
    constexpr unsigned int CP_STALLED_STAT1__RBIU_TO_MEMWR_NOT_RDY_TO_RCV__SHIFT = 0x00000004;
    constexpr unsigned int CP_STALLED_STAT1__RBIU_TO_SEM_NOT_RDY_TO_RCV__SHIFT = 0x00000002;
    constexpr unsigned int CP_STALLED_STAT2__EOPD_FIFO_NEEDS_SC_EOP_DONE__SHIFT = 0x00000015;
    constexpr unsigned int CP_STALLED_STAT2__EOPD_FIFO_NEEDS_WR_CONFIRM__SHIFT = 0x00000016;
    constexpr unsigned int CP_WAIT_SEM_ADDR_LO__SEM_ADDR_SWAP__SHIFT = 0x00000000;
    constexpr unsigned int DB_DEBUG2__DISABLE_TILE_COVERED_FOR_PS_ITER__SHIFT = 0x0000000e;
    constexpr unsigned int DB_DEBUG2__ENABLE_SUBTILE_GROUPING__SHIFT = 0x0000000f;
    constexpr unsigned int DB_DEBUG2__RESERVED__SHIFT               = 0x00000010;
    constexpr unsigned int DB_DEBUG3__ALLOW_RF2P_RW_COLLISION__SHIFT = 0x00000010;
    constexpr unsigned int DB_DEBUG3__DISABLE_4XAA_2P_DELAYED_WRITE__SHIFT = 0x0000001e;
    constexpr unsigned int DB_DEBUG3__DISABLE_4XAA_2P_INTERLEAVED_PMASK__SHIFT = 0x0000001f;
    constexpr unsigned int DB_DEBUG3__DONT_DELETE_CONTEXT_SUSPEND__SHIFT = 0x0000001d;
    constexpr unsigned int DB_DEBUG3__ROUND_ZRANGE_CORRECTION__SHIFT = 0x00000001;
    constexpr unsigned int DB_DEBUG4__ALWAYS_ON_RMI_CLK_EN__SHIFT   = 0x00000007;
    constexpr unsigned int DB_DEBUG4__DB_EXTRA_DEBUG4__SHIFT        = 0x00000013;
    constexpr unsigned int DB_DEBUG4__DISABLE_4XAA_2P_ZD_HOLDOFF__SHIFT = 0x00000004;
    constexpr unsigned int DB_DEBUG4__DISABLE_DYNAMIC_RAM_LIGHT_SLEEP_MODE__SHIFT = 0x00000010;
    constexpr unsigned int DB_DEBUG4__DISABLE_HIZ_Q1_TS_COLLISION_DETECT__SHIFT = 0x00000011;
    constexpr unsigned int DB_DEBUG4__DISABLE_HIZ_Q2_TS_COLLISION_DETECT__SHIFT = 0x00000012;
    constexpr unsigned int DB_DEBUG4__DISABLE_SEPARATE_DFSM_CLK__SHIFT = 0x0000000c;
    constexpr unsigned int DB_DEBUG4__DISABLE_TS_WRITE_L0__SHIFT    = 0x0000000f;
    constexpr unsigned int DB_DEBUG4__ENABLE_A2M_DQUAD_OPTIMIZATION__SHIFT = 0x00000005;
    constexpr unsigned int DB_DEBUG4__ENABLE_DBCB_SLOW_FORMAT_COLLAPSE__SHIFT = 0x00000006;
    constexpr unsigned int DB_DEPTH_SIZE__X_MAX__SHIFT              = 0x00000000;
    constexpr unsigned int DB_DEPTH_SIZE__Y_MAX__SHIFT              = 0x00000010;
    constexpr unsigned int DB_DFSM_CONFIG__MIDDLE_PIPE_MAX_DEPTH__SHIFT = 0x00000008;
    constexpr unsigned int DB_DFSM_PRIMS_IN_FLIGHT__HARD_LIMIT__SHIFT = 0x00000010;
    constexpr unsigned int DB_DFSM_TILES_IN_FLIGHT__HARD_LIMIT__SHIFT = 0x00000010;
    constexpr unsigned int DB_DFSM_WATERMARK__DFSM_HIGH_WATERMARK__SHIFT = 0x00000000;
    constexpr unsigned int DB_DFSM_WATERMARK__POPS_HIGH_WATERMARK__SHIFT = 0x00000010;
    constexpr unsigned int DB_FIFO_DEPTH1__DB_RMI_RDREQ_CREDITS__SHIFT = 0x00000000;
    constexpr unsigned int DB_FIFO_DEPTH1__DB_RMI_WRREQ_CREDITS__SHIFT = 0x00000005;
    constexpr unsigned int DB_FIFO_DEPTH1__LTILE_PROBE_FIFO_DEPTH__SHIFT = 0x00000015;
    constexpr unsigned int DB_FIFO_DEPTH1__MCC_DEPTH__SHIFT         = 0x0000000a;
    constexpr unsigned int DB_FIFO_DEPTH1__QC_DEPTH__SHIFT          = 0x00000010;
    constexpr unsigned int DB_FIFO_DEPTH2__LQUAD_FIFO_DEPTH__SHIFT  = 0x0000000f;
    constexpr unsigned int DB_FREE_CACHELINES__FREE_HTILE_DEPTH__SHIFT = 0x00000014;
    constexpr unsigned int DB_FREE_CACHELINES__FREE_PLANE_DEPTH__SHIFT = 0x00000007;
    constexpr unsigned int DB_FREE_CACHELINES__FREE_Z_DEPTH__SHIFT  = 0x0000000e;
    constexpr unsigned int DB_FREE_CACHELINES__QUAD_READ_REQS__SHIFT = 0x00000018;
    constexpr unsigned int DB_HTILE_SURFACE__HTILE_USES_PRELOAD_WIN__SHIFT = 0x00000002;
    constexpr unsigned int DB_HTILE_SURFACE__PREFETCH_HEIGHT__SHIFT = 0x0000000a;
    constexpr unsigned int DB_HTILE_SURFACE__PREFETCH_WIDTH__SHIFT  = 0x00000004;
    constexpr unsigned int DB_HTILE_SURFACE__PRELOAD__SHIFT         = 0x00000003;
    constexpr unsigned int DB_HTILE_SURFACE__RB_ALIGNED__SHIFT      = 0x00000013;
    constexpr unsigned int DB_RMI_CACHE_POLICY__CC_RD__SHIFT        = 0x00000010;
    constexpr unsigned int DB_RMI_CACHE_POLICY__CC_WR__SHIFT        = 0x00000018;
    constexpr unsigned int DB_RMI_CACHE_POLICY__CMASK_RD__SHIFT     = 0x00000012;
    constexpr unsigned int DB_RMI_CACHE_POLICY__CMASK_WR__SHIFT     = 0x0000001a;
    constexpr unsigned int DB_RMI_CACHE_POLICY__DCC_RD__SHIFT       = 0x00000013;
    constexpr unsigned int DB_RMI_CACHE_POLICY__DCC_WR__SHIFT       = 0x0000001b;
    constexpr unsigned int DB_RMI_CACHE_POLICY__FMASK_RD__SHIFT     = 0x00000011;
    constexpr unsigned int DB_RMI_CACHE_POLICY__FMASK_WR__SHIFT     = 0x00000019;
    constexpr unsigned int DB_RMI_CACHE_POLICY__HTILE_RD__SHIFT     = 0x00000002;
    constexpr unsigned int DB_RMI_CACHE_POLICY__HTILE_WR__SHIFT     = 0x0000000a;
    constexpr unsigned int DB_RMI_CACHE_POLICY__S_RD__SHIFT         = 0x00000001;
    constexpr unsigned int DB_RMI_CACHE_POLICY__S_WR__SHIFT         = 0x00000009;
    constexpr unsigned int DB_RMI_CACHE_POLICY__ZPCPSD_WR__SHIFT    = 0x0000000b;
    constexpr unsigned int DB_RMI_CACHE_POLICY__Z_RD__SHIFT         = 0x00000000;
    constexpr unsigned int DB_RMI_CACHE_POLICY__Z_WR__SHIFT         = 0x00000008;
    constexpr unsigned int DB_STENCIL_INFO2__EPITCH__SHIFT          = 0x00000000;
    constexpr unsigned int DB_STENCIL_INFO__CLEAR_DISALLOWED__SHIFT = 0x0000001e;
    constexpr unsigned int DB_STENCIL_INFO__FAULT_BEHAVIOR__SHIFT   = 0x0000000d;
    constexpr unsigned int DB_STENCIL_INFO__ITERATE_FLUSH__SHIFT    = 0x0000000f;
    constexpr unsigned int DB_WATERMARKS__AUTO_FLUSH_HTILE__SHIFT   = 0x0000001e;
    constexpr unsigned int DB_WATERMARKS__AUTO_FLUSH_QUAD__SHIFT    = 0x0000001f;
    constexpr unsigned int DB_WATERMARKS__DEPTH_CACHELINE_FREE__SHIFT = 0x00000014;
    constexpr unsigned int DB_WATERMARKS__DEPTH_FLUSH__SHIFT        = 0x00000005;
    constexpr unsigned int DB_WATERMARKS__DEPTH_PENDING_FREE__SHIFT = 0x0000000f;
    constexpr unsigned int DB_WATERMARKS__FORCE_SUMMARIZE__SHIFT    = 0x0000000b;
    constexpr unsigned int DB_Z_INFO2__EPITCH__SHIFT                = 0x00000000;
    constexpr unsigned int DB_Z_INFO__CLEAR_DISALLOWED__SHIFT       = 0x0000001e;
    constexpr unsigned int DB_Z_INFO__FAULT_BEHAVIOR__SHIFT         = 0x0000000d;
    constexpr unsigned int DB_Z_INFO__ITERATE_FLUSH__SHIFT          = 0x0000000f;
    constexpr unsigned int GB_ADDR_CONFIG_READ__BANK_INTERLEAVE_SIZE__SHIFT = 0x00000008;
    constexpr unsigned int GB_ADDR_CONFIG_READ__MULTI_GPU_TILE_SIZE__SHIFT = 0x00000018;
    constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_BANKS__SHIFT    = 0x0000000c;
    constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_GPUS__SHIFT     = 0x00000015;
    constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_LOWER_PIPES__SHIFT = 0x0000001e;
    constexpr unsigned int GB_ADDR_CONFIG_READ__ROW_SIZE__SHIFT     = 0x0000001c;
    constexpr unsigned int GB_ADDR_CONFIG_READ__SE_ENABLE__SHIFT    = 0x0000001f;
    constexpr unsigned int GB_ADDR_CONFIG_READ__SHADER_ENGINE_TILE_SIZE__SHIFT = 0x00000010;
    constexpr unsigned int GB_ADDR_CONFIG__BANK_INTERLEAVE_SIZE__SHIFT = 0x00000008;
    constexpr unsigned int GB_ADDR_CONFIG__MULTI_GPU_TILE_SIZE__SHIFT = 0x00000018;
    constexpr unsigned int GB_ADDR_CONFIG__NUM_BANKS__SHIFT         = 0x0000000c;
    constexpr unsigned int GB_ADDR_CONFIG__NUM_GPUS__SHIFT          = 0x00000015;
    constexpr unsigned int GB_ADDR_CONFIG__NUM_LOWER_PIPES__SHIFT   = 0x0000001e;
    constexpr unsigned int GB_ADDR_CONFIG__ROW_SIZE__SHIFT          = 0x0000001c;
    constexpr unsigned int GB_ADDR_CONFIG__SE_ENABLE__SHIFT         = 0x0000001f;
    constexpr unsigned int GB_ADDR_CONFIG__SHADER_ENGINE_TILE_SIZE__SHIFT = 0x00000010;
    constexpr unsigned int GB_MACROTILE_MODE0__BANK_HEIGHT__SHIFT   = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE0__BANK_WIDTH__SHIFT    = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE0__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE0__NUM_BANKS__SHIFT     = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE1__BANK_HEIGHT__SHIFT   = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE1__BANK_WIDTH__SHIFT    = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE1__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE1__NUM_BANKS__SHIFT     = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE2__BANK_HEIGHT__SHIFT   = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE2__BANK_WIDTH__SHIFT    = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE2__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE2__NUM_BANKS__SHIFT     = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE3__BANK_HEIGHT__SHIFT   = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE3__BANK_WIDTH__SHIFT    = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE3__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE3__NUM_BANKS__SHIFT     = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE4__BANK_HEIGHT__SHIFT   = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE4__BANK_WIDTH__SHIFT    = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE4__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE4__NUM_BANKS__SHIFT     = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE5__BANK_HEIGHT__SHIFT   = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE5__BANK_WIDTH__SHIFT    = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE5__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE5__NUM_BANKS__SHIFT     = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE6__BANK_HEIGHT__SHIFT   = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE6__BANK_WIDTH__SHIFT    = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE6__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE6__NUM_BANKS__SHIFT     = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE7__BANK_HEIGHT__SHIFT   = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE7__BANK_WIDTH__SHIFT    = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE7__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE7__NUM_BANKS__SHIFT     = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE8__BANK_HEIGHT__SHIFT   = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE8__BANK_WIDTH__SHIFT    = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE8__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE8__NUM_BANKS__SHIFT     = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE9__BANK_HEIGHT__SHIFT   = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE9__BANK_WIDTH__SHIFT    = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE9__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE9__NUM_BANKS__SHIFT     = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE10__BANK_HEIGHT__SHIFT  = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE10__BANK_WIDTH__SHIFT   = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE10__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE10__NUM_BANKS__SHIFT    = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE11__BANK_HEIGHT__SHIFT  = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE11__BANK_WIDTH__SHIFT   = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE11__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE11__NUM_BANKS__SHIFT    = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE12__BANK_HEIGHT__SHIFT  = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE12__BANK_WIDTH__SHIFT   = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE12__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE12__NUM_BANKS__SHIFT    = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE13__BANK_HEIGHT__SHIFT  = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE13__BANK_WIDTH__SHIFT   = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE13__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE13__NUM_BANKS__SHIFT    = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE14__BANK_HEIGHT__SHIFT  = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE14__BANK_WIDTH__SHIFT   = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE14__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE14__NUM_BANKS__SHIFT    = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE15__BANK_HEIGHT__SHIFT  = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE15__BANK_WIDTH__SHIFT   = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE15__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE15__NUM_BANKS__SHIFT    = 0x00000006;
    constexpr unsigned int GB_TILE_MODE0__ARRAY_MODE__SHIFT         = 0x00000002;
    constexpr unsigned int GB_TILE_MODE0__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE0__PIPE_CONFIG__SHIFT        = 0x00000006;
    constexpr unsigned int GB_TILE_MODE0__SAMPLE_SPLIT__SHIFT       = 0x00000019;
    constexpr unsigned int GB_TILE_MODE0__TILE_SPLIT__SHIFT         = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE1__ARRAY_MODE__SHIFT         = 0x00000002;
    constexpr unsigned int GB_TILE_MODE1__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE1__PIPE_CONFIG__SHIFT        = 0x00000006;
    constexpr unsigned int GB_TILE_MODE1__SAMPLE_SPLIT__SHIFT       = 0x00000019;
    constexpr unsigned int GB_TILE_MODE1__TILE_SPLIT__SHIFT         = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE2__ARRAY_MODE__SHIFT         = 0x00000002;
    constexpr unsigned int GB_TILE_MODE2__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE2__PIPE_CONFIG__SHIFT        = 0x00000006;
    constexpr unsigned int GB_TILE_MODE2__SAMPLE_SPLIT__SHIFT       = 0x00000019;
    constexpr unsigned int GB_TILE_MODE2__TILE_SPLIT__SHIFT         = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE3__ARRAY_MODE__SHIFT         = 0x00000002;
    constexpr unsigned int GB_TILE_MODE3__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE3__PIPE_CONFIG__SHIFT        = 0x00000006;
    constexpr unsigned int GB_TILE_MODE3__SAMPLE_SPLIT__SHIFT       = 0x00000019;
    constexpr unsigned int GB_TILE_MODE3__TILE_SPLIT__SHIFT         = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE4__ARRAY_MODE__SHIFT         = 0x00000002;
    constexpr unsigned int GB_TILE_MODE4__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE4__PIPE_CONFIG__SHIFT        = 0x00000006;
    constexpr unsigned int GB_TILE_MODE4__SAMPLE_SPLIT__SHIFT       = 0x00000019;
    constexpr unsigned int GB_TILE_MODE4__TILE_SPLIT__SHIFT         = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE5__ARRAY_MODE__SHIFT         = 0x00000002;
    constexpr unsigned int GB_TILE_MODE5__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE5__PIPE_CONFIG__SHIFT        = 0x00000006;
    constexpr unsigned int GB_TILE_MODE5__SAMPLE_SPLIT__SHIFT       = 0x00000019;
    constexpr unsigned int GB_TILE_MODE5__TILE_SPLIT__SHIFT         = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE6__ARRAY_MODE__SHIFT         = 0x00000002;
    constexpr unsigned int GB_TILE_MODE6__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE6__PIPE_CONFIG__SHIFT        = 0x00000006;
    constexpr unsigned int GB_TILE_MODE6__SAMPLE_SPLIT__SHIFT       = 0x00000019;
    constexpr unsigned int GB_TILE_MODE6__TILE_SPLIT__SHIFT         = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE7__ARRAY_MODE__SHIFT         = 0x00000002;
    constexpr unsigned int GB_TILE_MODE7__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE7__PIPE_CONFIG__SHIFT        = 0x00000006;
    constexpr unsigned int GB_TILE_MODE7__SAMPLE_SPLIT__SHIFT       = 0x00000019;
    constexpr unsigned int GB_TILE_MODE7__TILE_SPLIT__SHIFT         = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE8__ARRAY_MODE__SHIFT         = 0x00000002;
    constexpr unsigned int GB_TILE_MODE8__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE8__PIPE_CONFIG__SHIFT        = 0x00000006;
    constexpr unsigned int GB_TILE_MODE8__SAMPLE_SPLIT__SHIFT       = 0x00000019;
    constexpr unsigned int GB_TILE_MODE8__TILE_SPLIT__SHIFT         = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE9__ARRAY_MODE__SHIFT         = 0x00000002;
    constexpr unsigned int GB_TILE_MODE9__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE9__PIPE_CONFIG__SHIFT        = 0x00000006;
    constexpr unsigned int GB_TILE_MODE9__SAMPLE_SPLIT__SHIFT       = 0x00000019;
    constexpr unsigned int GB_TILE_MODE9__TILE_SPLIT__SHIFT         = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE10__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE10__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE10__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE10__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE10__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE11__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE11__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE11__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE11__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE11__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE12__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE12__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE12__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE12__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE12__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE13__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE13__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE13__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE13__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE13__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE14__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE14__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE14__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE14__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE14__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE15__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE15__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE15__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE15__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE15__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE16__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE16__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE16__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE16__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE16__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE17__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE17__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE17__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE17__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE17__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE18__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE18__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE18__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE18__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE18__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE19__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE19__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE19__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE19__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE19__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE20__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE20__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE20__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE20__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE20__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE21__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE21__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE21__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE21__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE21__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE22__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE22__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE22__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE22__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE22__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE23__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE23__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE23__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE23__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE23__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE24__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE24__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE24__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE24__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE24__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE25__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE25__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE25__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE25__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE25__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE26__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE26__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE26__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE26__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE26__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE27__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE27__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE27__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE27__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE27__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE28__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE28__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE28__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE28__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE28__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE29__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE29__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE29__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE29__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE29__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE30__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE30__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE30__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE30__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE30__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE31__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE31__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE31__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE31__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE31__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GC_CAC_ACC_CU1__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU2__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_IA0__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_SXRB1__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_TCC0__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_TCC1__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_TCC2__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_TCC3__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_TCC4__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_VGT0__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_VGT1__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_VGT2__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_WD0__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
    constexpr unsigned int GC_CAC_CNTL__CAC_BLOCK_ID__SHIFT         = 0x00000011;
    constexpr unsigned int GC_CAC_CNTL__CAC_SIGNAL_ID__SHIFT        = 0x00000017;
    constexpr unsigned int GC_CAC_OVRD_CB__OVRRD_VALUE__SHIFT       = 0x00000004;
    constexpr unsigned int GC_CAC_OVRD_DB__OVRRD_VALUE__SHIFT       = 0x00000004;
    constexpr unsigned int GC_CAC_OVRD_GDS__OVRRD_VALUE__SHIFT      = 0x00000004;
    constexpr unsigned int GC_CAC_OVRD_IA__OVRRD_SELECT__SHIFT      = 0x00000000;
    constexpr unsigned int GC_CAC_OVRD_IA__OVRRD_VALUE__SHIFT       = 0x00000001;
    constexpr unsigned int GC_CAC_OVRD_LDS__OVRRD_VALUE__SHIFT      = 0x00000004;
    constexpr unsigned int GC_CAC_OVRD_PA__OVRRD_VALUE__SHIFT       = 0x00000002;
    constexpr unsigned int GC_CAC_OVRD_RMI__OVRRD_VALUE__SHIFT      = 0x00000001;
    constexpr unsigned int GC_CAC_OVRD_SC__OVRRD_VALUE__SHIFT       = 0x00000001;
    constexpr unsigned int GC_CAC_OVRD_SQ__OVRRD_VALUE__SHIFT       = 0x00000009;
    constexpr unsigned int GC_CAC_OVRD_TCC__OVRRD_SELECT__SHIFT     = 0x00000000;
    constexpr unsigned int GC_CAC_OVRD_TCC__OVRRD_VALUE__SHIFT      = 0x00000005;
    constexpr unsigned int GC_CAC_OVRD_TCP__OVRRD_VALUE__SHIFT      = 0x00000005;
    constexpr unsigned int GC_CAC_OVRD_TD__OVRRD_VALUE__SHIFT       = 0x00000006;
    constexpr unsigned int GC_CAC_OVRD_VGT__OVRRD_SELECT__SHIFT     = 0x00000000;
    constexpr unsigned int GC_CAC_OVRD_VGT__OVRRD_VALUE__SHIFT      = 0x00000003;
    constexpr unsigned int GC_CAC_OVRD_WD__OVRRD_SELECT__SHIFT      = 0x00000000;
    constexpr unsigned int GC_CAC_OVRD_WD__OVRRD_VALUE__SHIFT       = 0x00000001;
    constexpr unsigned int GC_CAC_WEIGHT_IA_0__WEIGHT_IA_SIG0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_SQ_3__WEIGHT_SQ_SIG6__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_SQ_3__WEIGHT_SQ_SIG7__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_SQ_4__WEIGHT_SQ_SIG8__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_VGT_0__WEIGHT_VGT_SIG0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_VGT_0__WEIGHT_VGT_SIG1__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_VGT_1__WEIGHT_VGT_SIG2__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_WD_0__WEIGHT_WD_SIG0__SHIFT = 0x00000000;
    constexpr unsigned int GC_DIDT_CTRL0__DIDT_CLK_EN_OVERRIDE__SHIFT = 0x00000004;
    constexpr unsigned int GC_DIDT_CTRL0__DIDT_CTRL_EN__SHIFT       = 0x00000000;
    constexpr unsigned int GC_DIDT_CTRL0__DIDT_SW_RST__SHIFT        = 0x00000003;
    constexpr unsigned int GC_DIDT_CTRL0__DIDT_TRIGGER_THROTTLE_LOWBIT__SHIFT = 0x00000005;
    constexpr unsigned int GC_DIDT_CTRL0__PHASE_OFFSET__SHIFT       = 0x00000001;
    constexpr unsigned int GC_DIDT_CTRL1__MAX_POWER__SHIFT          = 0x00000010;
    constexpr unsigned int GC_DIDT_CTRL1__MIN_POWER__SHIFT          = 0x00000000;
    constexpr unsigned int GC_DIDT_CTRL2__LONG_TERM_INTERVAL_RATIO__SHIFT = 0x0000001b;
    constexpr unsigned int GC_DIDT_CTRL2__MAX_POWER_DELTA__SHIFT    = 0x00000000;
    constexpr unsigned int GC_DIDT_CTRL2__SHORT_TERM_INTERVAL_SIZE__SHIFT = 0x00000010;
    constexpr unsigned int GC_DIDT_DROOP_CTRL__DIDT_DROOP_LEVEL_EN__SHIFT = 0x00000000;
    constexpr unsigned int GC_DIDT_DROOP_CTRL__DIDT_DROOP_LEVEL_INDEX__SHIFT = 0x0000000f;
    constexpr unsigned int GC_DIDT_DROOP_CTRL__DIDT_DROOP_LEVEL_OVERFLOW__SHIFT = 0x0000001f;
    constexpr unsigned int GC_DIDT_DROOP_CTRL__DIDT_DROOP_THRESHOLD__SHIFT = 0x00000001;
    constexpr unsigned int GC_DIDT_DROOP_CTRL__DIDT_LEVEL_SEL__SHIFT = 0x00000013;
    constexpr unsigned int GC_DIDT_WEIGHT__DB_WEIGHT__SHIFT         = 0x00000008;
    constexpr unsigned int GC_DIDT_WEIGHT__SQ_WEIGHT__SHIFT         = 0x00000000;
    constexpr unsigned int GC_DIDT_WEIGHT__TCP_WEIGHT__SHIFT        = 0x00000018;
    constexpr unsigned int GC_DIDT_WEIGHT__TD_WEIGHT__SHIFT         = 0x00000010;
    constexpr unsigned int GC_EDC_DROOP_CTRL__AVG_PSM_SEL__SHIFT    = 0x00000014;
    constexpr unsigned int GC_EDC_DROOP_CTRL__EDC_DROOP_LEVEL_EN__SHIFT = 0x00000000;
    constexpr unsigned int GC_EDC_DROOP_CTRL__EDC_DROOP_LEVEL_INDEX__SHIFT = 0x0000000f;
    constexpr unsigned int GC_EDC_DROOP_CTRL__EDC_DROOP_THRESHOLD__SHIFT = 0x00000001;
    constexpr unsigned int GC_EDC_DROOP_CTRL__EDC_LEVEL_SEL__SHIFT  = 0x00000015;
    constexpr unsigned int GC_EDC_OVERFLOW__EDC_DROOP_LEVEL_OVERFLOW__SHIFT = 0x00000011;
    constexpr unsigned int GC_EDC_OVERFLOW__PSM_COUNTER__SHIFT      = 0x00000012;
    constexpr unsigned int GC_EDC_STATUS__EDC_ROLLING_DROOP_DELTA__SHIFT = 0x00000003;
    constexpr unsigned int GC_USER_PRIM_CONFIG__INACTIVE_IA__SHIFT  = 0x00000010;
    constexpr unsigned int GC_USER_PRIM_CONFIG__INACTIVE_VGT_PA__SHIFT = 0x00000018;
    constexpr unsigned int GC_USER_SHADER_ARRAY_CONFIG__INACTIVE_CUS__SHIFT = 0x00000010;
    constexpr unsigned int GC_USER_SHADER_RATE_CONFIG__HALF_LDS__SHIFT = 0x00000004;
    constexpr unsigned int GRBM_CHICKEN_BITS__DISABLE_CP_VMID_RESET_REQ__SHIFT = 0x00000000;
    constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SH_BROADCAST_WRITES__SHIFT = 0x0000001d;
    constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SH_INDEX__SHIFT  = 0x00000008;
    constexpr unsigned int GRBM_GFX_INDEX__SH_BROADCAST_WRITES__SHIFT = 0x0000001d;
    constexpr unsigned int GRBM_GFX_INDEX__SH_INDEX__SHIFT          = 0x00000008;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__IA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000017;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__TC_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001b;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__VGT_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__WD_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001c;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__IA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000017;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__TC_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001b;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__VGT_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__WD_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001c;
    constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_CPF__SHIFT = 0x00000010;
    constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__VGT_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000013;
    constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__VGT_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000013;
    constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__VGT_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000013;
    constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__VGT_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000013;
    constexpr unsigned int GRBM_STATUS2__CPF_RQ_PENDING__SHIFT      = 0x00000013;
    constexpr unsigned int GRBM_STATUS2__RLC_BUSY__SHIFT            = 0x00000018;
    constexpr unsigned int GRBM_STATUS2__TCC_CC_RESIDENT__SHIFT     = 0x0000001a;
    constexpr unsigned int GRBM_STATUS2__TC_BUSY__SHIFT             = 0x00000019;
    constexpr unsigned int GRBM_STATUS_SE0__VGT_BUSY__SHIFT         = 0x00000017;
    constexpr unsigned int GRBM_STATUS_SE1__VGT_BUSY__SHIFT         = 0x00000017;
    constexpr unsigned int GRBM_STATUS_SE2__VGT_BUSY__SHIFT         = 0x00000017;
    constexpr unsigned int GRBM_STATUS_SE3__VGT_BUSY__SHIFT         = 0x00000017;
    constexpr unsigned int GRBM_STATUS__IA_BUSY_NO_DMA__SHIFT       = 0x00000012;
    constexpr unsigned int GRBM_STATUS__IA_BUSY__SHIFT              = 0x00000013;
    constexpr unsigned int GRBM_STATUS__VGT_BUSY__SHIFT             = 0x00000011;
    constexpr unsigned int GRBM_STATUS__WD_BUSY_NO_DMA__SHIFT       = 0x00000010;
    constexpr unsigned int GRBM_STATUS__WD_BUSY__SHIFT              = 0x00000015;
    constexpr unsigned int IA_CNTL_STATUS__IA_ADC_BUSY__SHIFT       = 0x00000004;
    constexpr unsigned int IA_CNTL_STATUS__IA_BUSY__SHIFT           = 0x00000000;
    constexpr unsigned int IA_CNTL_STATUS__IA_DMA_BUSY__SHIFT       = 0x00000001;
    constexpr unsigned int IA_CNTL_STATUS__IA_DMA_REQ_BUSY__SHIFT   = 0x00000002;
    constexpr unsigned int IA_CNTL_STATUS__IA_GRP_BUSY__SHIFT       = 0x00000003;
    constexpr unsigned int IA_DEBUG_DATA__DATA__SHIFT               = 0x00000000;
    constexpr unsigned int IA_DEBUG_REG0__ia_busy__SHIFT            = 0x00000002;
    constexpr unsigned int IA_DEBUG_REG0__sclk_core_vld__SHIFT      = 0x0000001d;
    constexpr unsigned int IA_DEBUG_REG0__sclk_reg_vld__SHIFT       = 0x0000001c;
    constexpr unsigned int IA_DEBUG_REG1__dma_data_fifo_full__SHIFT = 0x0000000f;
    constexpr unsigned int IA_MULTI_VGT_PARAM__EN_INST_OPT_ADV__SHIFT = 0x00000016;
    constexpr unsigned int IA_MULTI_VGT_PARAM__EN_INST_OPT_BASIC__SHIFT = 0x00000015;
    constexpr unsigned int IA_MULTI_VGT_PARAM__HW_USE_ONLY__SHIFT   = 0x00000017;
    constexpr unsigned int IA_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int IA_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT  = 0x00000000;
    constexpr unsigned int IA_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int IA_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int IA_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int IA_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT  = 0x00000000;
    constexpr unsigned int IA_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int IA_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int IA_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int IA_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT  = 0x00000000;
    constexpr unsigned int IA_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int IA_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int IA_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int IA_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT  = 0x00000000;
    constexpr unsigned int IA_UTCL1_CNTL__FORCE_SD_VMID_DIRTY__SHIFT = 0x0000001d;
    constexpr unsigned int MC_MEM_POWER_LS__LS_HOLD__SHIFT          = 0x00000006;
    constexpr unsigned int MC_MEM_POWER_LS__LS_SETUP__SHIFT         = 0x00000000;
    constexpr unsigned int MC_SHARED_VIRT_RESET_REQ__PF__SHIFT      = 0x0000001f;
    constexpr unsigned int MC_SHARED_VIRT_RESET_REQ__VF__SHIFT      = 0x00000000;
    constexpr unsigned int MC_VM_AGP_BASE__AGP_BASE__SHIFT          = 0x00000000;
    constexpr unsigned int MC_VM_AGP_BOT__AGP_BOT__SHIFT            = 0x00000000;
    constexpr unsigned int MC_VM_AGP_TOP__AGP_TOP__SHIFT            = 0x00000000;
    constexpr unsigned int MC_VM_APT_CNTL__DIRECT_SYSTEM_EN__SHIFT  = 0x00000001;
    constexpr unsigned int MC_VM_APT_CNTL__FORCE_MTYPE_UC__SHIFT    = 0x00000000;
    constexpr unsigned int MC_VM_CACHEABLE_DRAM_ADDRESS_END__ADDRESS__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_CACHEABLE_DRAM_ADDRESS_START__ADDRESS__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_FB_LOCATION_BASE__FB_BASE__SHIFT   = 0x00000000;
    constexpr unsigned int MC_VM_FB_LOCATION_TOP__FB_TOP__SHIFT     = 0x00000000;
    constexpr unsigned int MC_VM_FB_OFFSET__FB_OFFSET__SHIFT        = 0x00000000;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF0__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF0__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF1__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF1__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF2__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF2__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF3__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF3__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF4__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF4__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF5__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF5__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF6__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF6__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF7__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF7__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF8__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF8__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF9__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF9__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF10__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF10__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF11__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF11__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF12__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF12__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF13__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF13__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF14__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF14__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF15__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int MC_VM_FB_SIZE_OFFSET_VF15__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER0_CFG__CLEAR__SHIFT  = 0x0000001d;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER0_CFG__ENABLE__SHIFT = 0x0000001c;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER0_CFG__PERF_MODE__SHIFT = 0x00000018;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER0_CFG__PERF_SEL_END__SHIFT = 0x00000008;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER0_CFG__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER1_CFG__CLEAR__SHIFT  = 0x0000001d;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER1_CFG__ENABLE__SHIFT = 0x0000001c;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER1_CFG__PERF_MODE__SHIFT = 0x00000018;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER1_CFG__PERF_SEL_END__SHIFT = 0x00000008;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER1_CFG__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER2_CFG__CLEAR__SHIFT  = 0x0000001d;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER2_CFG__ENABLE__SHIFT = 0x0000001c;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER2_CFG__PERF_MODE__SHIFT = 0x00000018;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER2_CFG__PERF_SEL_END__SHIFT = 0x00000008;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER2_CFG__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER3_CFG__CLEAR__SHIFT  = 0x0000001d;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER3_CFG__ENABLE__SHIFT = 0x0000001c;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER3_CFG__PERF_MODE__SHIFT = 0x00000018;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER3_CFG__PERF_SEL_END__SHIFT = 0x00000008;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER3_CFG__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER4_CFG__CLEAR__SHIFT  = 0x0000001d;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER4_CFG__ENABLE__SHIFT = 0x0000001c;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER4_CFG__PERF_MODE__SHIFT = 0x00000018;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER4_CFG__PERF_SEL_END__SHIFT = 0x00000008;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER4_CFG__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER5_CFG__CLEAR__SHIFT  = 0x0000001d;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER5_CFG__ENABLE__SHIFT = 0x0000001c;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER5_CFG__PERF_MODE__SHIFT = 0x00000018;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER5_CFG__PERF_SEL_END__SHIFT = 0x00000008;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER5_CFG__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER6_CFG__CLEAR__SHIFT  = 0x0000001d;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER6_CFG__ENABLE__SHIFT = 0x0000001c;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER6_CFG__PERF_MODE__SHIFT = 0x00000018;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER6_CFG__PERF_SEL_END__SHIFT = 0x00000008;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER6_CFG__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER7_CFG__CLEAR__SHIFT  = 0x0000001d;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER7_CFG__ENABLE__SHIFT = 0x0000001c;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER7_CFG__PERF_MODE__SHIFT = 0x00000018;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER7_CFG__PERF_SEL_END__SHIFT = 0x00000008;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER7_CFG__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_HI__COMPARE_VALUE__SHIFT = 0x00000010;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_HI__COUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_LO__COUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL__SHIFT = 0x00000019;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY__SHIFT = 0x00000018;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_RSLT_CNTL__START_TRIGGER__SHIFT = 0x00000008;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE__SHIFT = 0x0000001a;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER__SHIFT = 0x00000010;
    constexpr unsigned int MC_VM_LOCAL_HBM_ADDRESS_END__ADDRESS__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_LOCAL_HBM_ADDRESS_LOCK_CNTL__LOCK__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_LOCAL_HBM_ADDRESS_START__ADDRESS__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_MARC_BASE_HI_0__MARC_BASE_HI_0__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_MARC_BASE_HI_1__MARC_BASE_HI_1__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_MARC_BASE_HI_2__MARC_BASE_HI_2__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_MARC_BASE_HI_3__MARC_BASE_HI_3__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_MARC_BASE_LO_0__MARC_BASE_LO_0__SHIFT = 0x0000000c;
    constexpr unsigned int MC_VM_MARC_BASE_LO_1__MARC_BASE_LO_1__SHIFT = 0x0000000c;
    constexpr unsigned int MC_VM_MARC_BASE_LO_2__MARC_BASE_LO_2__SHIFT = 0x0000000c;
    constexpr unsigned int MC_VM_MARC_BASE_LO_3__MARC_BASE_LO_3__SHIFT = 0x0000000c;
    constexpr unsigned int MC_VM_MARC_LEN_HI_0__MARC_LEN_HI_0__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_MARC_LEN_HI_1__MARC_LEN_HI_1__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_MARC_LEN_HI_2__MARC_LEN_HI_2__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_MARC_LEN_HI_3__MARC_LEN_HI_3__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_MARC_LEN_LO_0__MARC_LEN_LO_0__SHIFT = 0x0000000c;
    constexpr unsigned int MC_VM_MARC_LEN_LO_1__MARC_LEN_LO_1__SHIFT = 0x0000000c;
    constexpr unsigned int MC_VM_MARC_LEN_LO_2__MARC_LEN_LO_2__SHIFT = 0x0000000c;
    constexpr unsigned int MC_VM_MARC_LEN_LO_3__MARC_LEN_LO_3__SHIFT = 0x0000000c;
    constexpr unsigned int MC_VM_MARC_RELOC_HI_0__MARC_RELOC_HI_0__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_MARC_RELOC_HI_1__MARC_RELOC_HI_1__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_MARC_RELOC_HI_2__MARC_RELOC_HI_2__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_MARC_RELOC_HI_3__MARC_RELOC_HI_3__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_MARC_RELOC_LO_0__MARC_ENABLE_0__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_MARC_RELOC_LO_0__MARC_READONLY_0__SHIFT = 0x00000001;
    constexpr unsigned int MC_VM_MARC_RELOC_LO_0__MARC_RELOC_LO_0__SHIFT = 0x0000000c;
    constexpr unsigned int MC_VM_MARC_RELOC_LO_1__MARC_ENABLE_1__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_MARC_RELOC_LO_1__MARC_READONLY_1__SHIFT = 0x00000001;
    constexpr unsigned int MC_VM_MARC_RELOC_LO_1__MARC_RELOC_LO_1__SHIFT = 0x0000000c;
    constexpr unsigned int MC_VM_MARC_RELOC_LO_2__MARC_ENABLE_2__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_MARC_RELOC_LO_2__MARC_READONLY_2__SHIFT = 0x00000001;
    constexpr unsigned int MC_VM_MARC_RELOC_LO_2__MARC_RELOC_LO_2__SHIFT = 0x0000000c;
    constexpr unsigned int MC_VM_MARC_RELOC_LO_3__MARC_ENABLE_3__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_MARC_RELOC_LO_3__MARC_READONLY_3__SHIFT = 0x00000001;
    constexpr unsigned int MC_VM_MARC_RELOC_LO_3__MARC_RELOC_LO_3__SHIFT = 0x0000000c;
    constexpr unsigned int MC_VM_MX_L1_TLB_CNTL__ATC_EN__SHIFT      = 0x0000000d;
    constexpr unsigned int MC_VM_MX_L1_TLB_CNTL__ECO_BITS__SHIFT    = 0x00000007;
    constexpr unsigned int MC_VM_MX_L1_TLB_CNTL__ENABLE_ADVANCED_DRIVER_MODEL__SHIFT = 0x00000006;
    constexpr unsigned int MC_VM_MX_L1_TLB_CNTL__ENABLE_L1_TLB__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_MX_L1_TLB_CNTL__MTYPE__SHIFT       = 0x0000000b;
    constexpr unsigned int MC_VM_MX_L1_TLB_CNTL__SYSTEM_ACCESS_MODE__SHIFT = 0x00000003;
    constexpr unsigned int MC_VM_MX_L1_TLB_CNTL__SYSTEM_APERTURE_UNMAPPED_ACCESS__SHIFT = 0x00000005;
    constexpr unsigned int MC_VM_NB_LOWER_TOP_OF_DRAM2__ENABLE__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_NB_LOWER_TOP_OF_DRAM2__LOWER_TOM2__SHIFT = 0x00000017;
    constexpr unsigned int MC_VM_NB_MMIOBASE__MMIOBASE__SHIFT       = 0x00000000;
    constexpr unsigned int MC_VM_NB_MMIOLIMIT__MMIOLIMIT__SHIFT     = 0x00000000;
    constexpr unsigned int MC_VM_NB_PCI_ARB__VGA_HOLE__SHIFT        = 0x00000003;
    constexpr unsigned int MC_VM_NB_PCI_CTRL__MMIOENABLE__SHIFT     = 0x00000017;
    constexpr unsigned int MC_VM_NB_TOP_OF_DRAM_SLOT1__TOP_OF_DRAM__SHIFT = 0x00000017;
    constexpr unsigned int MC_VM_NB_UPPER_TOP_OF_DRAM2__UPPER_TOM2__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_STEERING__DEFAULT_STEERING__SHIFT  = 0x00000000;
    constexpr unsigned int MC_VM_SYSTEM_APERTURE_DEFAULT_ADDR_LSB__PHYSICAL_PAGE_NUMBER_LSB__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_SYSTEM_APERTURE_DEFAULT_ADDR_MSB__PHYSICAL_PAGE_NUMBER_MSB__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_SYSTEM_APERTURE_HIGH_ADDR__LOGICAL_ADDR__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_SYSTEM_APERTURE_LOW_ADDR__LOGICAL_ADDR__SHIFT = 0x00000000;
    constexpr unsigned int PA_CL_CNTL_STATUS__UTC_FAULT_DETECTED__SHIFT = 0x00000000;
    constexpr unsigned int PA_CL_CNTL_STATUS__UTC_PRT_DETECTED__SHIFT = 0x00000002;
    constexpr unsigned int PA_CL_CNTL_STATUS__UTC_RETRY_DETECTED__SHIFT = 0x00000001;
    constexpr unsigned int PA_CL_ENHANCE__ECO_SPARE2__SHIFT         = 0x0000001d;
    constexpr unsigned int PA_CL_ENHANCE__ECO_SPARE3__SHIFT         = 0x0000001c;
    constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_LINE_WIDTH__SHIFT = 0x0000001a;
    constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_SHD_OBJPRIM_ID__SHIFT = 0x0000001b;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__FLUSH_GS_OUTPUT__SHIFT = 0x0000001a;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__CS_CONTEXT_DONE__SHIFT = 0x00000006;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__FLUSH_SX_TS__SHIFT = 0x00000012;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__RESERVED_63__SHIFT = 0x0000001e;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__SX_CB_RAT_ACK_REQUEST__SHIFT = 0x00000004;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_FLUSH__SHIFT = 0x0000000c;
    constexpr unsigned int PA_SC_ENHANCE_1__ALLOW_SCALE_LINE_WIDTH_PAD_WITH_BINNING__SHIFT = 0x00000011;
    constexpr unsigned int PA_SC_ENHANCE_1__DEBUG_PIXEL_PICKER_XY_UNPACK__SHIFT = 0x0000000c;
    constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PACKER_GRAD_FDCE_ENHANCE__SHIFT = 0x0000000d;
    constexpr unsigned int PA_SC_FOV_WINDOW_LR__LEFT_EYE_FOV_LEFT__SHIFT = 0x00000000;
    constexpr unsigned int PA_SC_FOV_WINDOW_LR__LEFT_EYE_FOV_RIGHT__SHIFT = 0x00000008;
    constexpr unsigned int PA_SC_FOV_WINDOW_LR__RIGHT_EYE_FOV_LEFT__SHIFT = 0x00000010;
    constexpr unsigned int PA_SC_FOV_WINDOW_LR__RIGHT_EYE_FOV_RIGHT__SHIFT = 0x00000018;
    constexpr unsigned int PA_SC_FOV_WINDOW_TB__FOV_BOT__SHIFT      = 0x00000008;
    constexpr unsigned int PA_SC_FOV_WINDOW_TB__FOV_TOP__SHIFT      = 0x00000000;
    constexpr unsigned int PA_SC_HORIZ_GRID__BOT_HALF__SHIFT        = 0x00000010;
    constexpr unsigned int PA_SC_HORIZ_GRID__BOT_QTR__SHIFT         = 0x00000018;
    constexpr unsigned int PA_SC_HORIZ_GRID__TOP_HALF__SHIFT        = 0x00000008;
    constexpr unsigned int PA_SC_HORIZ_GRID__TOP_QTR__SHIFT         = 0x00000000;
    constexpr unsigned int PA_SC_LEFT_VERT_GRID__LEFT_HALF__SHIFT   = 0x00000008;
    constexpr unsigned int PA_SC_LEFT_VERT_GRID__LEFT_QTR__SHIFT    = 0x00000000;
    constexpr unsigned int PA_SC_LEFT_VERT_GRID__RIGHT_HALF__SHIFT  = 0x00000010;
    constexpr unsigned int PA_SC_LEFT_VERT_GRID__RIGHT_QTR__SHIFT   = 0x00000018;
    constexpr unsigned int PA_SC_MODE_CNTL_0__SCALE_LINE_WIDTH_PAD__SHIFT = 0x00000004;
    constexpr unsigned int PA_SC_RASTER_CONFIG_1__SE_PAIR_YSEL__SHIFT = 0x00000005;
    constexpr unsigned int PA_SC_RASTER_CONFIG__SE_YSEL__SHIFT      = 0x0000001d;
    constexpr unsigned int PA_SC_RIGHT_VERT_GRID__LEFT_HALF__SHIFT  = 0x00000008;
    constexpr unsigned int PA_SC_RIGHT_VERT_GRID__LEFT_QTR__SHIFT   = 0x00000000;
    constexpr unsigned int PA_SC_RIGHT_VERT_GRID__RIGHT_HALF__SHIFT = 0x00000010;
    constexpr unsigned int PA_SC_RIGHT_VERT_GRID__RIGHT_QTR__SHIFT  = 0x00000018;
    constexpr unsigned int PA_UTCL1_CNTL1__CLIENTID__SHIFT          = 0x00000007;
    constexpr unsigned int PA_UTCL1_CNTL1__ENABLE_LFIFO_PRI_ARB__SHIFT = 0x00000012;
    constexpr unsigned int PA_UTCL1_CNTL1__ENABLE_PUSH_LFIFO__SHIFT = 0x00000011;
    constexpr unsigned int PA_UTCL1_CNTL1__FORCE_4K_L2_RESP__SHIFT  = 0x00000000;
    constexpr unsigned int PA_UTCL1_CNTL1__FORCE_IN_ORDER__SHIFT    = 0x0000001b;
    constexpr unsigned int PA_UTCL1_CNTL1__FORCE_MISS__SHIFT        = 0x0000001a;
    constexpr unsigned int PA_UTCL1_CNTL1__GPUVM_64K_DEFAULT__SHIFT = 0x00000001;
    constexpr unsigned int PA_UTCL1_CNTL1__GPUVM_PERM_MODE__SHIFT   = 0x00000002;
    constexpr unsigned int PA_UTCL1_CNTL1__INVALIDATE_ALL_VMID__SHIFT = 0x00000019;
    constexpr unsigned int PA_UTCL1_CNTL1__REDUCE_CACHE_SIZE_BY_2__SHIFT = 0x0000001e;
    constexpr unsigned int PA_UTCL1_CNTL1__REDUCE_FIFO_DEPTH_BY_2__SHIFT = 0x0000001c;
    constexpr unsigned int PA_UTCL1_CNTL1__REG_INV_ALL_VMID__SHIFT  = 0x00000017;
    constexpr unsigned int PA_UTCL1_CNTL1__REG_INV_TOGGLE__SHIFT    = 0x00000018;
    constexpr unsigned int PA_UTCL1_CNTL1__REG_INV_VMID__SHIFT      = 0x00000013;
    constexpr unsigned int PA_UTCL1_CNTL1__RESP_FAULT_MODE__SHIFT   = 0x00000005;
    constexpr unsigned int PA_UTCL1_CNTL1__RESP_MODE__SHIFT         = 0x00000003;
    constexpr unsigned int PA_UTCL1_CNTL1__SPARE__SHIFT             = 0x00000010;
    constexpr unsigned int PA_UTCL1_CNTL2__ENABLE_PERF_EVENT_RD_WR__SHIFT = 0x00000012;
    constexpr unsigned int PA_UTCL1_CNTL2__ENABLE_PERF_EVENT_VMID__SHIFT = 0x00000014;
    constexpr unsigned int PA_UTCL1_CNTL2__ENABLE_SHOOTDOWN_OPT__SHIFT = 0x0000000d;
    constexpr unsigned int PA_UTCL1_CNTL2__FORCE_FRAG_2M_TO_64K__SHIFT = 0x0000001a;
    constexpr unsigned int PA_UTCL1_CNTL2__FORCE_GPUVM_INV_ACK__SHIFT = 0x0000000f;
    constexpr unsigned int PA_UTCL1_CNTL2__FORCE_SNOOP__SHIFT       = 0x0000000e;
    constexpr unsigned int PA_UTCL1_CNTL2__GPUVM_INV_MODE__SHIFT    = 0x0000000c;
    constexpr unsigned int PA_UTCL1_CNTL2__LINE_VALID__SHIFT        = 0x0000000a;
    constexpr unsigned int PA_UTCL1_CNTL2__MTYPE_OVRD_DIS__SHIFT    = 0x00000009;
    constexpr unsigned int PA_UTCL1_CNTL2__PERF_EVENT_RD_WR__SHIFT  = 0x00000013;
    constexpr unsigned int PA_UTCL1_CNTL2__PERF_EVENT_VMID__SHIFT   = 0x00000015;
    constexpr unsigned int PA_UTCL1_CNTL2__RESERVED__SHIFT          = 0x0000001b;
    constexpr unsigned int PA_UTCL1_CNTL2__SPARE1__SHIFT            = 0x00000000;
    constexpr unsigned int PA_UTCL1_CNTL2__SPARE2__SHIFT            = 0x00000008;
    constexpr unsigned int PA_UTCL1_CNTL2__SPARE3__SHIFT            = 0x0000000b;
    constexpr unsigned int PA_UTCL1_CNTL2__SPARE4__SHIFT            = 0x00000010;
    constexpr unsigned int PA_UTCL1_CNTL2__SPARE5__SHIFT            = 0x00000019;
    constexpr unsigned int RLC_SPM_CB_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_CB_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_CPC_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_CPC_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_CPF_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_CPF_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_CPG_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_CPG_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_DB_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_DB_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_DEBUG__DATA__SHIFT               = 0x00000000;
    constexpr unsigned int RLC_SPM_GDS_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_GDS_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_IA_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_IA_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_MC_CNTL__RESERVED__SHIFT         = 0x0000000a;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_FED__SHIFT      = 0x00000006;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_MTYPE_OVER__SHIFT = 0x00000007;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_MTYPE__SHIFT    = 0x00000008;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_PERF_CNTR__SHIFT = 0x00000005;
    constexpr unsigned int RLC_SPM_PA_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_PA_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_RMI_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_RMI_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_SC_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_SC_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_SPI_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_SPI_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_SQG_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_SQG_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_SX_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_SX_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_TA_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_TA_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_TCA_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_TCA_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_TCC_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_TCC_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_TCP_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_TCP_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_TD_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_TD_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_UTCL1_CNTL__FORCE_SD_VMID_DIRTY__SHIFT = 0x0000001d;
    constexpr unsigned int RLC_SPM_VGT_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_VGT_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RMI_GENERAL_CNTL1__POLICY_OVERRIDE__SHIFT = 0x0000000a;
    constexpr unsigned int RMI_GENERAL_CNTL1__UTCL1_PROBE0_RR_ARB_BURST_HINT_EN__SHIFT = 0x0000000b;
    constexpr unsigned int RMI_SPARE_1__SPARE_BIT_8_1__SHIFT        = 0x00000008;
    constexpr unsigned int RMI_SPARE_1__SPARE_BIT_8__SHIFT          = 0x00000000;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_4_0__SHIFT        = 0x00000008;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_4_1__SHIFT        = 0x0000000c;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_16__SHIFT         = 0x00000000;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_17__SHIFT         = 0x00000001;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_18__SHIFT         = 0x00000002;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_19__SHIFT         = 0x00000003;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_20__SHIFT         = 0x00000004;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_21__SHIFT         = 0x00000005;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_22__SHIFT         = 0x00000006;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_23__SHIFT         = 0x00000007;
    constexpr unsigned int RMI_SPARE__SPARE_BIT_1__SHIFT            = 0x00000001;
    constexpr unsigned int RMI_SPARE__SPARE_BIT_2__SHIFT            = 0x00000002;
    constexpr unsigned int RMI_SPARE__SPARE_BIT_3__SHIFT            = 0x00000003;
    constexpr unsigned int RMI_SPARE__SPARE_BIT_4__SHIFT            = 0x00000004;
    constexpr unsigned int RMI_SPARE__SPARE_BIT_5__SHIFT            = 0x00000005;
    constexpr unsigned int RMI_SPARE__SPARE_BIT_6__SHIFT            = 0x00000006;
    constexpr unsigned int RMI_SPARE__SPARE_BIT_8_0__SHIFT          = 0x00000008;
    constexpr unsigned int RMI_SPARE__SPARE_BIT_16_0__SHIFT         = 0x00000010;
    constexpr unsigned int SDMA0_PERFCOUNTER0_RESULT__PERF_COUNT__SHIFT = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER1_RESULT__PERF_COUNT__SHIFT = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER_TAG_DELAY_RANGE__RANGE_HIGH__SHIFT = 0x0000000e;
    constexpr unsigned int SDMA0_PERFCOUNTER_TAG_DELAY_RANGE__RANGE_LOW__SHIFT = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER_TAG_DELAY_RANGE__SELECT_RW__SHIFT = 0x0000001c;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_CLEAR0__SHIFT   = 0x00000001;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_CLEAR1__SHIFT   = 0x0000000b;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_ENABLE0__SHIFT  = 0x00000000;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_ENABLE1__SHIFT  = 0x0000000a;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_SEL0__SHIFT     = 0x00000002;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_SEL1__SHIFT     = 0x0000000c;
    constexpr unsigned int SDMA_PGFSM_CONFIG__FSM_ADDR__SHIFT       = 0x00000000;
    constexpr unsigned int SDMA_PGFSM_CONFIG__P1_SELECT__SHIFT      = 0x0000000a;
    constexpr unsigned int SDMA_PGFSM_CONFIG__P2_SELECT__SHIFT      = 0x0000000b;
    constexpr unsigned int SDMA_PGFSM_CONFIG__POWER_DOWN__SHIFT     = 0x00000008;
    constexpr unsigned int SDMA_PGFSM_CONFIG__POWER_UP__SHIFT       = 0x00000009;
    constexpr unsigned int SDMA_PGFSM_CONFIG__READ__SHIFT           = 0x0000000d;
    constexpr unsigned int SDMA_PGFSM_CONFIG__REG_ADDR__SHIFT       = 0x0000001c;
    constexpr unsigned int SDMA_PGFSM_CONFIG__SRBM_OVERRIDE__SHIFT  = 0x0000001b;
    constexpr unsigned int SDMA_PGFSM_CONFIG__WRITE__SHIFT          = 0x0000000c;
    constexpr unsigned int SDMA_PGFSM_READ__VALUE__SHIFT            = 0x00000000;
    constexpr unsigned int SDMA_PGFSM_WRITE__VALUE__SHIFT           = 0x00000000;
    constexpr unsigned int SDMA_POWER_GATING__PG_CNTL_STATUS__SHIFT = 0x00000004;
    constexpr unsigned int SDMA_POWER_GATING__SDMA0_POWER_OFF_CONDITION__SHIFT = 0x00000000;
    constexpr unsigned int SDMA_POWER_GATING__SDMA0_POWER_OFF_REQ__SHIFT = 0x00000002;
    constexpr unsigned int SDMA_POWER_GATING__SDMA0_POWER_ON_CONDITION__SHIFT = 0x00000001;
    constexpr unsigned int SDMA_POWER_GATING__SDMA0_POWER_ON_REQ__SHIFT = 0x00000003;
    constexpr unsigned int SH_MEM_CONFIG__ALIGNMENT_MODE__SHIFT     = 0x00000003;
    constexpr unsigned int SH_MEM_CONFIG__PRIVATE_NV__SHIFT         = 0x0000000d;
    constexpr unsigned int SH_MEM_CONFIG__RETRY_DISABLE__SHIFT      = 0x0000000c;
    constexpr unsigned int SPI_CONFIG_CNTL_1__BATON_RESET_DISABLE__SHIFT = 0x00000005;
    constexpr unsigned int SPI_CONFIG_CNTL_1__PC_LIMIT_ENABLE__SHIFT = 0x00000006;
    constexpr unsigned int SPI_CONFIG_CNTL_1__PC_LIMIT_SIZE__SHIFT  = 0x00000010;
    constexpr unsigned int SPI_CONFIG_CNTL__RSRC_MGMT_RESET__SHIFT  = 0x0000001a;
    constexpr unsigned int SPI_CONFIG_PS_CU_EN__ENABLE__SHIFT       = 0x00000000;
    constexpr unsigned int SPI_CONFIG_PS_CU_EN__PKR0_CU_EN__SHIFT   = 0x00000001;
    constexpr unsigned int SPI_CONFIG_PS_CU_EN__PKR1_CU_EN__SHIFT   = 0x00000010;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_4__COUNT__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_4__EVENTS__SHIFT = 0x00000010;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_5__COUNT__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_5__EVENTS__SHIFT = 0x00000010;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_6__COUNT__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_6__EVENTS__SHIFT = 0x00000010;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_7__COUNT__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_7__EVENTS__SHIFT = 0x00000010;
    constexpr unsigned int SPI_DSM_CNTL2__SPI_SR_MEM_INJECT_DELAY__SHIFT = 0x00000004;
    constexpr unsigned int SPI_DSM_CNTL2__UNUSED__SHIFT             = 0x0000000a;
    constexpr unsigned int SPI_DSM_CNTL__UNUSED__SHIFT              = 0x00000003;
    constexpr unsigned int SPI_LB_CU_MASK__CU_MASK__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_LB_DATA_PERCU_WAVE_CS__ACTIVE__SHIFT = 0x00000000;
    constexpr unsigned int SPI_LB_DATA_PERCU_WAVE_HSGS__CU_USED_GS__SHIFT = 0x00000010;
    constexpr unsigned int SPI_LB_DATA_PERCU_WAVE_HSGS__CU_USED_HS__SHIFT = 0x00000000;
    constexpr unsigned int SPI_LB_DATA_PERCU_WAVE_VSPS__CU_USED_PS__SHIFT = 0x00000010;
    constexpr unsigned int SPI_LB_DATA_PERCU_WAVE_VSPS__CU_USED_VS__SHIFT = 0x00000000;
    constexpr unsigned int SPI_PG_ENABLE_STATIC_CU_MASK__CU_MASK__SHIFT = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__BARRIERS__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__LDS__SHIFT   = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__SGPR__SHIFT  = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__VGPR__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__WAVES__SHIFT = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__BARRIERS__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__LDS__SHIFT   = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__SGPR__SHIFT  = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__VGPR__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__WAVES__SHIFT = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__BARRIERS__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__LDS__SHIFT   = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__SGPR__SHIFT  = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__VGPR__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__WAVES__SHIFT = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__BARRIERS__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__LDS__SHIFT   = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__SGPR__SHIFT  = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__VGPR__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__WAVES__SHIFT = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__BARRIERS__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__LDS__SHIFT   = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__SGPR__SHIFT  = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__VGPR__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__WAVES__SHIFT = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__BARRIERS__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__LDS__SHIFT   = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__SGPR__SHIFT  = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__VGPR__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__WAVES__SHIFT = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_0__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_1__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_2__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_3__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_4__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_5__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_6__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_7__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_8__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_9__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__EN__SHIFT = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__QUEUE_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__TYPE_MASK__SHIFT = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__EN__SHIFT = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__QUEUE_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__TYPE_MASK__SHIFT = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__EN__SHIFT = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__QUEUE_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__TYPE_MASK__SHIFT = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__EN__SHIFT = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__QUEUE_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__TYPE_MASK__SHIFT = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__EN__SHIFT = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__QUEUE_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__TYPE_MASK__SHIFT = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__EN__SHIFT = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__QUEUE_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__TYPE_MASK__SHIFT = 0x00000001;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__SKIP_USGPR0__SHIFT = 0x0000001b;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__USER_SGPR_MSB__SHIFT = 0x0000001c;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__EXCP_EN__SHIFT  = 0x00000007;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__LDS_SIZE__SHIFT = 0x00000010;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__SKIP_USGPR0__SHIFT = 0x0000001b;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__USER_SGPR_MSB__SHIFT = 0x0000001c;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__SKIP_USGPR0__SHIFT = 0x0000001b;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__USER_SGPR_MSB__SHIFT = 0x0000001c;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__DISPATCH_DRAW_EN__SHIFT = 0x00000018;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__SKIP_USGPR0__SHIFT = 0x0000001b;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__USER_SGPR_MSB__SHIFT = 0x0000001c;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_GS__SIMD_DISABLE__SHIFT = 0x0000001a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_HS__SIMD_DISABLE__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_PS__SIMD_DISABLE__SHIFT = 0x0000001a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_VS__SIMD_DISABLE__SHIFT = 0x0000001a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__GROUP_FIFO_DEPTH__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__SPI_SHADER_LATE_ALLOC_GS__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PGM_RSRC4_HS__GROUP_FIFO_DEPTH__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_0__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_1__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_2__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_3__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_4__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_5__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_6__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_7__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_8__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_9__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_10__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_11__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_12__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_13__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_14__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_15__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_16__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_17__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_18__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_19__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_20__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_21__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_22__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_23__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_24__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_25__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_26__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_27__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_28__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_29__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_30__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_31__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_0__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_1__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_2__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_3__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_4__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_5__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_6__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_7__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_8__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_9__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_10__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_11__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_12__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_13__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_14__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_15__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_16__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_17__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_18__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_19__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_20__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_21__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_22__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_23__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_24__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_25__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_26__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_27__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_28__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_29__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_30__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_31__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_0__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_1__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_2__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_3__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_4__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_5__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_6__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_7__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_8__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_9__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_10__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_11__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_12__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_13__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_14__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_15__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_16__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_17__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_18__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_19__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_20__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_21__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_22__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_23__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_24__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_25__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_26__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_27__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_28__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_29__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_30__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_31__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_START_PHASE__SGPR_START_PHASE__SHIFT = 0x00000002;
    constexpr unsigned int SPI_START_PHASE__VGPR_START_PHASE__SHIFT = 0x00000000;
    constexpr unsigned int SPI_START_PHASE__WAVE_START_PHASE__SHIFT = 0x00000004;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS4__VALUE__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS5__VALUE__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS6__VALUE__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS7__VALUE__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__ES_GRP_VALUE__SHIFT = 0x00000011;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__LS_GRP_VALUE__SHIFT = 0x00000007;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_6__EN_WARN__SHIFT  = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_6__MAX_CNT__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_7__EN_WARN__SHIFT  = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_7__MAX_CNT__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_8__EN_WARN__SHIFT  = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_8__MAX_CNT__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_9__EN_WARN__SHIFT  = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_9__MAX_CNT__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_3__INT_SENT__SHIFT = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_3__MAX_CNT__SHIFT = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_5__INT_SENT__SHIFT = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_5__MAX_CNT__SHIFT = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_10__INT_SENT__SHIFT = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_10__MAX_CNT__SHIFT = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_12__INT_SENT__SHIFT = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_12__MAX_CNT__SHIFT = 0x00000000;
    constexpr unsigned int SQC_CACHES__VOL__SHIFT                   = 0x00000004;
    constexpr unsigned int SQC_CACHES__WRITEBACK__SHIFT             = 0x00000003;
    constexpr unsigned int SQC_CONFIG__IDENTITY_HASH_BANK__SHIFT    = 0x00000009;
    constexpr unsigned int SQC_CONFIG__INST_PRF_COUNT__SHIFT        = 0x00000018;
    constexpr unsigned int SQC_CONFIG__INST_PRF_FILTER_DIS__SHIFT   = 0x0000001a;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__CLIENTID__SHIFT  = 0x00000007;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__CLIENT_INVALIDATE_ALL_VMID__SHIFT = 0x00000019;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__ENABLE_LFIFO_PRI_ARB__SHIFT = 0x00000012;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__ENABLE_PUSH_LFIFO__SHIFT = 0x00000011;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__FORCE_4K_L2_RESP__SHIFT = 0x00000000;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__FORCE_IN_ORDER__SHIFT = 0x0000001b;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__FORCE_MISS__SHIFT = 0x0000001a;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__GPUVM_64K_DEF__SHIFT = 0x00000001;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__GPUVM_PERM_MODE__SHIFT = 0x00000002;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__REDUCE_CACHE_SIZE_BY_2__SHIFT = 0x0000001e;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__REDUCE_FIFO_DEPTH_BY_2__SHIFT = 0x0000001c;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__REG_INVALIDATE_ALL_VMID__SHIFT = 0x00000017;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__REG_INVALIDATE_TOGGLE__SHIFT = 0x00000018;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__REG_INVALIDATE_VMID__SHIFT = 0x00000013;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__RESP_FAULT_MODE__SHIFT = 0x00000005;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL1__RESP_MODE__SHIFT = 0x00000003;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__ARB_BURST_MODE__SHIFT = 0x00000010;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__DIS_EDC__SHIFT   = 0x0000000b;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__ENABLE_PERF_EVENT_RD_WR__SHIFT = 0x00000012;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__ENABLE_PERF_EVENT_VMID__SHIFT = 0x00000014;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__FORCE_FRAG_2M_TO_64K__SHIFT = 0x0000001a;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__FORCE_GPUVM_INV_ACK__SHIFT = 0x0000000f;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__FORCE_SNOOP__SHIFT = 0x0000000e;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__GPUVM_INV_MODE__SHIFT = 0x0000000c;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__LFIFO_SCAN_DISABLE__SHIFT = 0x00000008;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__LINE_VALID__SHIFT = 0x0000000a;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__MTYPE_OVRD_DIS__SHIFT = 0x00000009;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__PERF_EVENT_RD_WR__SHIFT = 0x00000013;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__PERF_EVENT_VMID__SHIFT = 0x00000015;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__SHOOTDOWN_OPT__SHIFT = 0x0000000d;
    constexpr unsigned int SQC_DCACHE_UTCL1_CNTL2__SPARE__SHIFT     = 0x00000000;
    constexpr unsigned int SQC_DCACHE_UTCL1_STATUS__FAULT_DETECTED__SHIFT = 0x00000000;
    constexpr unsigned int SQC_DCACHE_UTCL1_STATUS__PRT_DETECTED__SHIFT = 0x00000002;
    constexpr unsigned int SQC_DCACHE_UTCL1_STATUS__RETRY_DETECTED__SHIFT = 0x00000001;
    constexpr unsigned int SQC_DSM_CNTL2A__DATA_BANK_RAM_ENABLE_ERROR_INJECT__SHIFT = 0x00000018;
    constexpr unsigned int SQC_DSM_CNTL2A__DATA_BANK_RAM_SELECT_INJECT_DELAY__SHIFT = 0x0000001a;
    constexpr unsigned int SQC_DSM_CNTL2A__DATA_DIRTY_BIT_RAM_ENABLE_ERROR_INJECT__SHIFT = 0x00000015;
    constexpr unsigned int SQC_DSM_CNTL2A__DATA_DIRTY_BIT_RAM_SELECT_INJECT_DELAY__SHIFT = 0x00000017;
    constexpr unsigned int SQC_DSM_CNTL2A__DATA_HIT_FIFO_ENABLE_ERROR_INJECT__SHIFT = 0x0000000f;
    constexpr unsigned int SQC_DSM_CNTL2A__DATA_HIT_FIFO_SELECT_INJECT_DELAY__SHIFT = 0x00000011;
    constexpr unsigned int SQC_DSM_CNTL2A__DATA_MISS_FIFO_ENABLE_ERROR_INJECT__SHIFT = 0x00000012;
    constexpr unsigned int SQC_DSM_CNTL2A__DATA_MISS_FIFO_SELECT_INJECT_DELAY__SHIFT = 0x00000014;
    constexpr unsigned int SQC_DSM_CNTL2A__DATA_TAG_RAM_ENABLE_ERROR_INJECT__SHIFT = 0x0000000c;
    constexpr unsigned int SQC_DSM_CNTL2A__DATA_TAG_RAM_SELECT_INJECT_DELAY__SHIFT = 0x0000000e;
    constexpr unsigned int SQC_DSM_CNTL2A__INST_BANK_RAM_ENABLE_ERROR_INJECT__SHIFT = 0x00000009;
    constexpr unsigned int SQC_DSM_CNTL2A__INST_BANK_RAM_SELECT_INJECT_DELAY__SHIFT = 0x0000000b;
    constexpr unsigned int SQC_DSM_CNTL2A__INST_MISS_FIFO_ENABLE_ERROR_INJECT__SHIFT = 0x00000006;
    constexpr unsigned int SQC_DSM_CNTL2A__INST_MISS_FIFO_SELECT_INJECT_DELAY__SHIFT = 0x00000008;
    constexpr unsigned int SQC_DSM_CNTL2A__INST_TAG_RAM_ENABLE_ERROR_INJECT__SHIFT = 0x00000000;
    constexpr unsigned int SQC_DSM_CNTL2A__INST_TAG_RAM_SELECT_INJECT_DELAY__SHIFT = 0x00000002;
    constexpr unsigned int SQC_DSM_CNTL2A__INST_UTCL1_MISS_FIFO_ENABLE_ERROR_INJECT__SHIFT = 0x00000003;
    constexpr unsigned int SQC_DSM_CNTL2A__INST_UTCL1_MISS_FIFO_SELECT_INJECT_DELAY__SHIFT = 0x00000005;
    constexpr unsigned int SQC_DSM_CNTL2B__DATA_BANK_RAM_ENABLE_ERROR_INJECT__SHIFT = 0x00000018;
    constexpr unsigned int SQC_DSM_CNTL2B__DATA_BANK_RAM_SELECT_INJECT_DELAY__SHIFT = 0x0000001a;
    constexpr unsigned int SQC_DSM_CNTL2B__DATA_DIRTY_BIT_RAM_ENABLE_ERROR_INJECT__SHIFT = 0x00000015;
    constexpr unsigned int SQC_DSM_CNTL2B__DATA_DIRTY_BIT_RAM_SELECT_INJECT_DELAY__SHIFT = 0x00000017;
    constexpr unsigned int SQC_DSM_CNTL2B__DATA_HIT_FIFO_ENABLE_ERROR_INJECT__SHIFT = 0x0000000f;
    constexpr unsigned int SQC_DSM_CNTL2B__DATA_HIT_FIFO_SELECT_INJECT_DELAY__SHIFT = 0x00000011;
    constexpr unsigned int SQC_DSM_CNTL2B__DATA_MISS_FIFO_ENABLE_ERROR_INJECT__SHIFT = 0x00000012;
    constexpr unsigned int SQC_DSM_CNTL2B__DATA_MISS_FIFO_SELECT_INJECT_DELAY__SHIFT = 0x00000014;
    constexpr unsigned int SQC_DSM_CNTL2B__DATA_TAG_RAM_ENABLE_ERROR_INJECT__SHIFT = 0x0000000c;
    constexpr unsigned int SQC_DSM_CNTL2B__DATA_TAG_RAM_SELECT_INJECT_DELAY__SHIFT = 0x0000000e;
    constexpr unsigned int SQC_DSM_CNTL2B__INST_BANK_RAM_ENABLE_ERROR_INJECT__SHIFT = 0x00000009;
    constexpr unsigned int SQC_DSM_CNTL2B__INST_BANK_RAM_SELECT_INJECT_DELAY__SHIFT = 0x0000000b;
    constexpr unsigned int SQC_DSM_CNTL2B__INST_MISS_FIFO_ENABLE_ERROR_INJECT__SHIFT = 0x00000006;
    constexpr unsigned int SQC_DSM_CNTL2B__INST_MISS_FIFO_SELECT_INJECT_DELAY__SHIFT = 0x00000008;
    constexpr unsigned int SQC_DSM_CNTL2B__INST_TAG_RAM_ENABLE_ERROR_INJECT__SHIFT = 0x00000000;
    constexpr unsigned int SQC_DSM_CNTL2B__INST_TAG_RAM_SELECT_INJECT_DELAY__SHIFT = 0x00000002;
    constexpr unsigned int SQC_DSM_CNTL2B__INST_UTCL1_MISS_FIFO_ENABLE_ERROR_INJECT__SHIFT = 0x00000003;
    constexpr unsigned int SQC_DSM_CNTL2B__INST_UTCL1_MISS_FIFO_SELECT_INJECT_DELAY__SHIFT = 0x00000005;
    constexpr unsigned int SQC_DSM_CNTL2__DATA_CU0_UTCL1_LFIFO_ENABLE_ERROR_INJECT__SHIFT = 0x00000006;
    constexpr unsigned int SQC_DSM_CNTL2__DATA_CU0_UTCL1_LFIFO_SELECT_INJECT_DELAY__SHIFT = 0x00000008;
    constexpr unsigned int SQC_DSM_CNTL2__DATA_CU0_WRITE_DATA_BUF_ENABLE_ERROR_INJECT__SHIFT = 0x00000003;
    constexpr unsigned int SQC_DSM_CNTL2__DATA_CU0_WRITE_DATA_BUF_SELECT_INJECT_DELAY__SHIFT = 0x00000005;
    constexpr unsigned int SQC_DSM_CNTL2__DATA_CU1_UTCL1_LFIFO_ENABLE_ERROR_INJECT__SHIFT = 0x0000000c;
    constexpr unsigned int SQC_DSM_CNTL2__DATA_CU1_UTCL1_LFIFO_SELECT_INJECT_DELAY__SHIFT = 0x0000000e;
    constexpr unsigned int SQC_DSM_CNTL2__DATA_CU1_WRITE_DATA_BUF_ENABLE_ERROR_INJECT__SHIFT = 0x00000009;
    constexpr unsigned int SQC_DSM_CNTL2__DATA_CU1_WRITE_DATA_BUF_SELECT_INJECT_DELAY__SHIFT = 0x0000000b;
    constexpr unsigned int SQC_DSM_CNTL2__DATA_CU2_UTCL1_LFIFO_ENABLE_ERROR_INJECT__SHIFT = 0x00000012;
    constexpr unsigned int SQC_DSM_CNTL2__DATA_CU2_UTCL1_LFIFO_SELECT_INJECT_DELAY__SHIFT = 0x00000014;
    constexpr unsigned int SQC_DSM_CNTL2__DATA_CU2_WRITE_DATA_BUF_ENABLE_ERROR_INJECT__SHIFT = 0x0000000f;
    constexpr unsigned int SQC_DSM_CNTL2__DATA_CU2_WRITE_DATA_BUF_SELECT_INJECT_DELAY__SHIFT = 0x00000011;
    constexpr unsigned int SQC_DSM_CNTL2__INJECT_DELAY__SHIFT       = 0x0000001a;
    constexpr unsigned int SQC_DSM_CNTL2__INST_UTCL1_LFIFO_ENABLE_ERROR_INJECT__SHIFT = 0x00000000;
    constexpr unsigned int SQC_DSM_CNTL2__INST_UTCL1_LFIFO_SELECT_INJECT_DELAY__SHIFT = 0x00000002;
    constexpr unsigned int SQC_DSM_CNTLA__DATA_BANK_RAM_DSM_IRRITATOR_DATA__SHIFT = 0x00000018;
    constexpr unsigned int SQC_DSM_CNTLA__DATA_BANK_RAM_ENABLE_SINGLE_WRITE__SHIFT = 0x0000001a;
    constexpr unsigned int SQC_DSM_CNTLA__DATA_DIRTY_BIT_RAM_DSM_IRRITATOR_DATA__SHIFT = 0x00000015;
    constexpr unsigned int SQC_DSM_CNTLA__DATA_DIRTY_BIT_RAM_ENABLE_SINGLE_WRITE__SHIFT = 0x00000017;
    constexpr unsigned int SQC_DSM_CNTLA__DATA_HIT_FIFO_DSM_IRRITATOR_DATA__SHIFT = 0x0000000f;
    constexpr unsigned int SQC_DSM_CNTLA__DATA_HIT_FIFO_ENABLE_SINGLE_WRITE__SHIFT = 0x00000011;
    constexpr unsigned int SQC_DSM_CNTLA__DATA_MISS_FIFO_DSM_IRRITATOR_DATA__SHIFT = 0x00000012;
    constexpr unsigned int SQC_DSM_CNTLA__DATA_MISS_FIFO_ENABLE_SINGLE_WRITE__SHIFT = 0x00000014;
    constexpr unsigned int SQC_DSM_CNTLA__DATA_TAG_RAM_DSM_IRRITATOR_DATA__SHIFT = 0x0000000c;
    constexpr unsigned int SQC_DSM_CNTLA__DATA_TAG_RAM_ENABLE_SINGLE_WRITE__SHIFT = 0x0000000e;
    constexpr unsigned int SQC_DSM_CNTLA__INST_BANK_RAM_DSM_IRRITATOR_DATA__SHIFT = 0x00000009;
    constexpr unsigned int SQC_DSM_CNTLA__INST_BANK_RAM_ENABLE_SINGLE_WRITE__SHIFT = 0x0000000b;
    constexpr unsigned int SQC_DSM_CNTLA__INST_MISS_FIFO_DSM_IRRITATOR_DATA__SHIFT = 0x00000006;
    constexpr unsigned int SQC_DSM_CNTLA__INST_MISS_FIFO_ENABLE_SINGLE_WRITE__SHIFT = 0x00000008;
    constexpr unsigned int SQC_DSM_CNTLA__INST_TAG_RAM_DSM_IRRITATOR_DATA__SHIFT = 0x00000000;
    constexpr unsigned int SQC_DSM_CNTLA__INST_TAG_RAM_ENABLE_SINGLE_WRITE__SHIFT = 0x00000002;
    constexpr unsigned int SQC_DSM_CNTLA__INST_UTCL1_MISS_FIFO_DSM_IRRITATOR_DATA__SHIFT = 0x00000003;
    constexpr unsigned int SQC_DSM_CNTLA__INST_UTCL1_MISS_FIFO_ENABLE_SINGLE_WRITE__SHIFT = 0x00000005;
    constexpr unsigned int SQC_DSM_CNTLB__DATA_BANK_RAM_DSM_IRRITATOR_DATA__SHIFT = 0x00000018;
    constexpr unsigned int SQC_DSM_CNTLB__DATA_BANK_RAM_ENABLE_SINGLE_WRITE__SHIFT = 0x0000001a;
    constexpr unsigned int SQC_DSM_CNTLB__DATA_DIRTY_BIT_RAM_DSM_IRRITATOR_DATA__SHIFT = 0x00000015;
    constexpr unsigned int SQC_DSM_CNTLB__DATA_DIRTY_BIT_RAM_ENABLE_SINGLE_WRITE__SHIFT = 0x00000017;
    constexpr unsigned int SQC_DSM_CNTLB__DATA_HIT_FIFO_DSM_IRRITATOR_DATA__SHIFT = 0x0000000f;
    constexpr unsigned int SQC_DSM_CNTLB__DATA_HIT_FIFO_ENABLE_SINGLE_WRITE__SHIFT = 0x00000011;
    constexpr unsigned int SQC_DSM_CNTLB__DATA_MISS_FIFO_DSM_IRRITATOR_DATA__SHIFT = 0x00000012;
    constexpr unsigned int SQC_DSM_CNTLB__DATA_MISS_FIFO_ENABLE_SINGLE_WRITE__SHIFT = 0x00000014;
    constexpr unsigned int SQC_DSM_CNTLB__DATA_TAG_RAM_DSM_IRRITATOR_DATA__SHIFT = 0x0000000c;
    constexpr unsigned int SQC_DSM_CNTLB__DATA_TAG_RAM_ENABLE_SINGLE_WRITE__SHIFT = 0x0000000e;
    constexpr unsigned int SQC_DSM_CNTLB__INST_BANK_RAM_DSM_IRRITATOR_DATA__SHIFT = 0x00000009;
    constexpr unsigned int SQC_DSM_CNTLB__INST_BANK_RAM_ENABLE_SINGLE_WRITE__SHIFT = 0x0000000b;
    constexpr unsigned int SQC_DSM_CNTLB__INST_MISS_FIFO_DSM_IRRITATOR_DATA__SHIFT = 0x00000006;
    constexpr unsigned int SQC_DSM_CNTLB__INST_MISS_FIFO_ENABLE_SINGLE_WRITE__SHIFT = 0x00000008;
    constexpr unsigned int SQC_DSM_CNTLB__INST_TAG_RAM_DSM_IRRITATOR_DATA__SHIFT = 0x00000000;
    constexpr unsigned int SQC_DSM_CNTLB__INST_TAG_RAM_ENABLE_SINGLE_WRITE__SHIFT = 0x00000002;
    constexpr unsigned int SQC_DSM_CNTLB__INST_UTCL1_MISS_FIFO_DSM_IRRITATOR_DATA__SHIFT = 0x00000003;
    constexpr unsigned int SQC_DSM_CNTLB__INST_UTCL1_MISS_FIFO_ENABLE_SINGLE_WRITE__SHIFT = 0x00000005;
    constexpr unsigned int SQC_DSM_CNTL__DATA_CU0_UTCL1_LFIFO_DSM_IRRITATOR_DATA__SHIFT = 0x00000006;
    constexpr unsigned int SQC_DSM_CNTL__DATA_CU0_UTCL1_LFIFO_ENABLE_SINGLE_WRITE__SHIFT = 0x00000008;
    constexpr unsigned int SQC_DSM_CNTL__DATA_CU0_WRITE_DATA_BUF_DSM_IRRITATOR_DATA__SHIFT = 0x00000003;
    constexpr unsigned int SQC_DSM_CNTL__DATA_CU0_WRITE_DATA_BUF_ENABLE_SINGLE_WRITE__SHIFT = 0x00000005;
    constexpr unsigned int SQC_DSM_CNTL__DATA_CU1_UTCL1_LFIFO_DSM_IRRITATOR_DATA__SHIFT = 0x0000000c;
    constexpr unsigned int SQC_DSM_CNTL__DATA_CU1_UTCL1_LFIFO_ENABLE_SINGLE_WRITE__SHIFT = 0x0000000e;
    constexpr unsigned int SQC_DSM_CNTL__DATA_CU1_WRITE_DATA_BUF_DSM_IRRITATOR_DATA__SHIFT = 0x00000009;
    constexpr unsigned int SQC_DSM_CNTL__DATA_CU1_WRITE_DATA_BUF_ENABLE_SINGLE_WRITE__SHIFT = 0x0000000b;
    constexpr unsigned int SQC_DSM_CNTL__DATA_CU2_UTCL1_LFIFO_DSM_IRRITATOR_DATA__SHIFT = 0x00000012;
    constexpr unsigned int SQC_DSM_CNTL__DATA_CU2_UTCL1_LFIFO_ENABLE_SINGLE_WRITE__SHIFT = 0x00000014;
    constexpr unsigned int SQC_DSM_CNTL__DATA_CU2_WRITE_DATA_BUF_DSM_IRRITATOR_DATA__SHIFT = 0x0000000f;
    constexpr unsigned int SQC_DSM_CNTL__DATA_CU2_WRITE_DATA_BUF_ENABLE_SINGLE_WRITE__SHIFT = 0x00000011;
    constexpr unsigned int SQC_DSM_CNTL__INST_UTCL1_LFIFO_DSM_IRRITATOR_DATA__SHIFT = 0x00000000;
    constexpr unsigned int SQC_DSM_CNTL__INST_UTCL1_LFIFO_ENABLE_SINGLE_WRITE__SHIFT = 0x00000002;
    constexpr unsigned int SQC_EDC_CNT2__DATA_BANKA_BANK_RAM_DED_COUNT__SHIFT = 0x0000000e;
    constexpr unsigned int SQC_EDC_CNT2__DATA_BANKA_BANK_RAM_SEC_COUNT__SHIFT = 0x0000000c;
    constexpr unsigned int SQC_EDC_CNT2__DATA_BANKA_DIRTY_BIT_RAM_SED_COUNT__SHIFT = 0x00000018;
    constexpr unsigned int SQC_EDC_CNT2__DATA_BANKA_HIT_FIFO_SED_COUNT__SHIFT = 0x00000014;
    constexpr unsigned int SQC_EDC_CNT2__DATA_BANKA_MISS_FIFO_SED_COUNT__SHIFT = 0x00000016;
    constexpr unsigned int SQC_EDC_CNT2__DATA_BANKA_TAG_RAM_DED_COUNT__SHIFT = 0x0000000a;
    constexpr unsigned int SQC_EDC_CNT2__DATA_BANKA_TAG_RAM_SEC_COUNT__SHIFT = 0x00000008;
    constexpr unsigned int SQC_EDC_CNT2__INST_BANKA_BANK_RAM_DED_COUNT__SHIFT = 0x00000006;
    constexpr unsigned int SQC_EDC_CNT2__INST_BANKA_BANK_RAM_SEC_COUNT__SHIFT = 0x00000004;
    constexpr unsigned int SQC_EDC_CNT2__INST_BANKA_MISS_FIFO_SED_COUNT__SHIFT = 0x00000012;
    constexpr unsigned int SQC_EDC_CNT2__INST_BANKA_TAG_RAM_DED_COUNT__SHIFT = 0x00000002;
    constexpr unsigned int SQC_EDC_CNT2__INST_BANKA_TAG_RAM_SEC_COUNT__SHIFT = 0x00000000;
    constexpr unsigned int SQC_EDC_CNT2__INST_BANKA_UTCL1_MISS_FIFO_SED_COUNT__SHIFT = 0x00000010;
    constexpr unsigned int SQC_EDC_CNT2__INST_UTCL1_LFIFO_DED_COUNT__SHIFT = 0x0000001c;
    constexpr unsigned int SQC_EDC_CNT2__INST_UTCL1_LFIFO_SEC_COUNT__SHIFT = 0x0000001a;
    constexpr unsigned int SQC_EDC_CNT3__DATA_BANKB_BANK_RAM_DED_COUNT__SHIFT = 0x0000000e;
    constexpr unsigned int SQC_EDC_CNT3__DATA_BANKB_BANK_RAM_SEC_COUNT__SHIFT = 0x0000000c;
    constexpr unsigned int SQC_EDC_CNT3__DATA_BANKB_DIRTY_BIT_RAM_SED_COUNT__SHIFT = 0x00000018;
    constexpr unsigned int SQC_EDC_CNT3__DATA_BANKB_HIT_FIFO_SED_COUNT__SHIFT = 0x00000014;
    constexpr unsigned int SQC_EDC_CNT3__DATA_BANKB_MISS_FIFO_SED_COUNT__SHIFT = 0x00000016;
    constexpr unsigned int SQC_EDC_CNT3__DATA_BANKB_TAG_RAM_DED_COUNT__SHIFT = 0x0000000a;
    constexpr unsigned int SQC_EDC_CNT3__DATA_BANKB_TAG_RAM_SEC_COUNT__SHIFT = 0x00000008;
    constexpr unsigned int SQC_EDC_CNT3__INST_BANKB_BANK_RAM_DED_COUNT__SHIFT = 0x00000006;
    constexpr unsigned int SQC_EDC_CNT3__INST_BANKB_BANK_RAM_SEC_COUNT__SHIFT = 0x00000004;
    constexpr unsigned int SQC_EDC_CNT3__INST_BANKB_MISS_FIFO_SED_COUNT__SHIFT = 0x00000012;
    constexpr unsigned int SQC_EDC_CNT3__INST_BANKB_TAG_RAM_DED_COUNT__SHIFT = 0x00000002;
    constexpr unsigned int SQC_EDC_CNT3__INST_BANKB_TAG_RAM_SEC_COUNT__SHIFT = 0x00000000;
    constexpr unsigned int SQC_EDC_CNT3__INST_BANKB_UTCL1_MISS_FIFO_SED_COUNT__SHIFT = 0x00000010;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU0_UTCL1_LFIFO_DED_COUNT__SHIFT = 0x00000006;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU0_UTCL1_LFIFO_SEC_COUNT__SHIFT = 0x00000004;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU0_WRITE_DATA_BUF_DED_COUNT__SHIFT = 0x00000002;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU0_WRITE_DATA_BUF_SEC_COUNT__SHIFT = 0x00000000;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU1_UTCL1_LFIFO_DED_COUNT__SHIFT = 0x0000000e;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU1_UTCL1_LFIFO_SEC_COUNT__SHIFT = 0x0000000c;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU1_WRITE_DATA_BUF_DED_COUNT__SHIFT = 0x0000000a;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU1_WRITE_DATA_BUF_SEC_COUNT__SHIFT = 0x00000008;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU2_UTCL1_LFIFO_DED_COUNT__SHIFT = 0x00000016;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU2_UTCL1_LFIFO_SEC_COUNT__SHIFT = 0x00000014;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU2_WRITE_DATA_BUF_DED_COUNT__SHIFT = 0x00000012;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU2_WRITE_DATA_BUF_SEC_COUNT__SHIFT = 0x00000010;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU3_UTCL1_LFIFO_DED_COUNT__SHIFT = 0x0000001e;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU3_UTCL1_LFIFO_SEC_COUNT__SHIFT = 0x0000001c;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU3_WRITE_DATA_BUF_DED_COUNT__SHIFT = 0x0000001a;
    constexpr unsigned int SQC_EDC_CNT__DATA_CU3_WRITE_DATA_BUF_SEC_COUNT__SHIFT = 0x00000018;
    constexpr unsigned int SQC_EDC_FUE_CNTL__BLOCK_FUE_FLAGS__SHIFT = 0x00000000;
    constexpr unsigned int SQC_EDC_FUE_CNTL__FUE_INTERRUPT_ENABLES__SHIFT = 0x00000010;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__CLIENTID__SHIFT  = 0x00000007;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__CLIENT_INVALIDATE_ALL_VMID__SHIFT = 0x00000019;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__ENABLE_LFIFO_PRI_ARB__SHIFT = 0x00000012;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__ENABLE_PUSH_LFIFO__SHIFT = 0x00000011;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__FORCE_4K_L2_RESP__SHIFT = 0x00000000;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__FORCE_IN_ORDER__SHIFT = 0x0000001b;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__FORCE_MISS__SHIFT = 0x0000001a;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__GPUVM_64K_DEF__SHIFT = 0x00000001;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__GPUVM_PERM_MODE__SHIFT = 0x00000002;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__REDUCE_CACHE_SIZE_BY_2__SHIFT = 0x0000001e;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__REDUCE_FIFO_DEPTH_BY_2__SHIFT = 0x0000001c;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__REG_INVALIDATE_ALL_VMID__SHIFT = 0x00000017;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__REG_INVALIDATE_TOGGLE__SHIFT = 0x00000018;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__REG_INVALIDATE_VMID__SHIFT = 0x00000013;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__RESP_FAULT_MODE__SHIFT = 0x00000005;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL1__RESP_MODE__SHIFT = 0x00000003;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__ARB_BURST_MODE__SHIFT = 0x00000010;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__DIS_EDC__SHIFT   = 0x0000000b;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__ENABLE_PERF_EVENT_RD_WR__SHIFT = 0x00000012;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__ENABLE_PERF_EVENT_VMID__SHIFT = 0x00000014;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__FORCE_FRAG_2M_TO_64K__SHIFT = 0x0000001a;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__FORCE_GPUVM_INV_ACK__SHIFT = 0x0000000f;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__FORCE_SNOOP__SHIFT = 0x0000000e;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__GPUVM_INV_MODE__SHIFT = 0x0000000c;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__LFIFO_SCAN_DISABLE__SHIFT = 0x00000008;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__LINE_VALID__SHIFT = 0x0000000a;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__MTYPE_OVRD_DIS__SHIFT = 0x00000009;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__PERF_EVENT_RD_WR__SHIFT = 0x00000013;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__PERF_EVENT_VMID__SHIFT = 0x00000015;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__SHOOTDOWN_OPT__SHIFT = 0x0000000d;
    constexpr unsigned int SQC_ICACHE_UTCL1_CNTL2__SPARE__SHIFT     = 0x00000000;
    constexpr unsigned int SQC_ICACHE_UTCL1_STATUS__FAULT_DETECTED__SHIFT = 0x00000000;
    constexpr unsigned int SQC_ICACHE_UTCL1_STATUS__PRT_DETECTED__SHIFT = 0x00000002;
    constexpr unsigned int SQC_ICACHE_UTCL1_STATUS__RETRY_DETECTED__SHIFT = 0x00000001;
    constexpr unsigned int SQC_WRITEBACK__DIRTY__SHIFT              = 0x00000001;
    constexpr unsigned int SQC_WRITEBACK__DWB__SHIFT                = 0x00000000;
    constexpr unsigned int SQ_ALU_CLK_CTRL__FORCE_CU_ON_SH0__SHIFT  = 0x00000000;
    constexpr unsigned int SQ_ALU_CLK_CTRL__FORCE_CU_ON_SH1__SHIFT  = 0x00000010;
    constexpr unsigned int SQ_BUF_RSRC_WORD0__BASE_ADDRESS__SHIFT   = 0x00000000;
    constexpr unsigned int SQ_BUF_RSRC_WORD1__BASE_ADDRESS_HI__SHIFT = 0x00000000;
    constexpr unsigned int SQ_BUF_RSRC_WORD1__CACHE_SWIZZLE__SHIFT  = 0x0000001e;
    constexpr unsigned int SQ_BUF_RSRC_WORD1__STRIDE__SHIFT         = 0x00000010;
    constexpr unsigned int SQ_BUF_RSRC_WORD1__SWIZZLE_ENABLE__SHIFT = 0x0000001f;
    constexpr unsigned int SQ_BUF_RSRC_WORD2__NUM_RECORDS__SHIFT    = 0x00000000;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__ADD_TID_ENABLE__SHIFT = 0x00000017;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__DATA_FORMAT__SHIFT    = 0x0000000f;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__DST_SEL_W__SHIFT      = 0x00000009;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__DST_SEL_X__SHIFT      = 0x00000000;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__DST_SEL_Y__SHIFT      = 0x00000003;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__DST_SEL_Z__SHIFT      = 0x00000006;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__INDEX_STRIDE__SHIFT   = 0x00000015;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__NUM_FORMAT__SHIFT     = 0x0000000c;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__NV__SHIFT             = 0x0000001b;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__TYPE__SHIFT           = 0x0000001e;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__USER_VM_ENABLE__SHIFT = 0x00000013;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__USER_VM_MODE__SHIFT   = 0x00000014;
    constexpr unsigned int SQ_CMD_TIMESTAMP__TIMESTAMP__SHIFT       = 0x00000000;
    constexpr unsigned int SQ_CMD__SIMD_ID__SHIFT                   = 0x00000014;
    constexpr unsigned int SQ_CONFIG__DEBUG_EN__SHIFT               = 0x00000008;
    constexpr unsigned int SQ_CONFIG__DEBUG_ONE_INST_CLAUSE__SHIFT  = 0x0000000a;
    constexpr unsigned int SQ_CONFIG__DEBUG_SINGLE_MEMOP__SHIFT     = 0x00000009;
    constexpr unsigned int SQ_CONFIG__DISABLE_FLAT_SOFT_CLAUSE__SHIFT = 0x0000001e;
    constexpr unsigned int SQ_CONFIG__DISABLE_MIMG_SOFT_CLAUSE__SHIFT = 0x0000001f;
    constexpr unsigned int SQ_CONFIG__DISABLE_SMEM_SOFT_CLAUSE__SHIFT = 0x00000011;
    constexpr unsigned int SQ_CONFIG__DISABLE_SP_VGPR_WRITE_SKIP__SHIFT = 0x0000001c;
    constexpr unsigned int SQ_CONFIG__DISABLE_VMEM_SOFT_CLAUSE__SHIFT = 0x00000010;
    constexpr unsigned int SQ_CONFIG__DUA_FLAT_LDS_PINGPONG_DISABLE__SHIFT = 0x0000000f;
    constexpr unsigned int SQ_CONFIG__DUA_FLAT_LOCK_ENABLE__SHIFT   = 0x0000000d;
    constexpr unsigned int SQ_CONFIG__DUA_LDS_BYPASS_DISABLE__SHIFT = 0x0000000e;
    constexpr unsigned int SQ_CONFIG__EARLY_TA_DONE_DISABLE__SHIFT  = 0x0000000c;
    constexpr unsigned int SQ_CONFIG__OVERRIDE_ALU_BUSY__SHIFT      = 0x00000007;
    constexpr unsigned int SQ_CONFIG__OVERRIDE_LDS_IDX_BUSY__SHIFT  = 0x0000000b;
    constexpr unsigned int SQ_CONFIG__REPLAY_SLEEP_CNT__SHIFT       = 0x00000015;
    constexpr unsigned int SQ_DS_0__ENCODING__SHIFT                 = 0x0000001a;
    constexpr unsigned int SQ_DS_0__GDS__SHIFT                      = 0x00000010;
    constexpr unsigned int SQ_DS_0__OFFSET0__SHIFT                  = 0x00000000;
    constexpr unsigned int SQ_DS_0__OFFSET1__SHIFT                  = 0x00000008;
    constexpr unsigned int SQ_DS_0__OP__SHIFT                       = 0x00000011;
    constexpr unsigned int SQ_DS_1__ADDR__SHIFT                     = 0x00000000;
    constexpr unsigned int SQ_DS_1__DATA0__SHIFT                    = 0x00000008;
    constexpr unsigned int SQ_DS_1__DATA1__SHIFT                    = 0x00000010;
    constexpr unsigned int SQ_DS_1__VDST__SHIFT                     = 0x00000018;
    constexpr unsigned int SQ_EDC_DED_CNT__LDS_DED__SHIFT           = 0x00000000;
    constexpr unsigned int SQ_EDC_DED_CNT__SGPR_DED__SHIFT          = 0x00000008;
    constexpr unsigned int SQ_EDC_DED_CNT__VGPR_DED__SHIFT          = 0x00000010;
    constexpr unsigned int SQ_EDC_INFO__SIMD_ID__SHIFT              = 0x00000004;
    constexpr unsigned int SQ_EDC_INFO__SOURCE__SHIFT               = 0x00000006;
    constexpr unsigned int SQ_EDC_INFO__VM_ID__SHIFT                = 0x00000009;
    constexpr unsigned int SQ_EDC_INFO__WAVE_ID__SHIFT              = 0x00000000;
    constexpr unsigned int SQ_EDC_SEC_CNT__LDS_SEC__SHIFT           = 0x00000000;
    constexpr unsigned int SQ_EDC_SEC_CNT__SGPR_SEC__SHIFT          = 0x00000008;
    constexpr unsigned int SQ_EDC_SEC_CNT__VGPR_SEC__SHIFT          = 0x00000010;
    constexpr unsigned int SQ_EXP_0__COMPR__SHIFT                   = 0x0000000a;
    constexpr unsigned int SQ_EXP_0__DONE__SHIFT                    = 0x0000000b;
    constexpr unsigned int SQ_EXP_0__ENCODING__SHIFT                = 0x0000001a;
    constexpr unsigned int SQ_EXP_0__EN__SHIFT                      = 0x00000000;
    constexpr unsigned int SQ_EXP_0__TGT__SHIFT                     = 0x00000004;
    constexpr unsigned int SQ_EXP_0__VM__SHIFT                      = 0x0000000c;
    constexpr unsigned int SQ_EXP_1__VSRC0__SHIFT                   = 0x00000000;
    constexpr unsigned int SQ_EXP_1__VSRC1__SHIFT                   = 0x00000008;
    constexpr unsigned int SQ_EXP_1__VSRC2__SHIFT                   = 0x00000010;
    constexpr unsigned int SQ_EXP_1__VSRC3__SHIFT                   = 0x00000018;
    constexpr unsigned int SQ_FIFO_SIZES__EXPORT_BUF_SIZE__SHIFT    = 0x00000010;
    constexpr unsigned int SQ_FLAT_0__ENCODING__SHIFT               = 0x0000001a;
    constexpr unsigned int SQ_FLAT_0__GLC__SHIFT                    = 0x00000010;
    constexpr unsigned int SQ_FLAT_0__LDS__SHIFT                    = 0x0000000d;
    constexpr unsigned int SQ_FLAT_0__OFFSET__SHIFT                 = 0x00000000;
    constexpr unsigned int SQ_FLAT_0__OP__SHIFT                     = 0x00000012;
    constexpr unsigned int SQ_FLAT_0__SEG__SHIFT                    = 0x0000000e;
    constexpr unsigned int SQ_FLAT_0__SLC__SHIFT                    = 0x00000011;
    constexpr unsigned int SQ_FLAT_1__ADDR__SHIFT                   = 0x00000000;
    constexpr unsigned int SQ_FLAT_1__DATA__SHIFT                   = 0x00000008;
    constexpr unsigned int SQ_FLAT_1__NV__SHIFT                     = 0x00000017;
    constexpr unsigned int SQ_FLAT_1__SADDR__SHIFT                  = 0x00000010;
    constexpr unsigned int SQ_FLAT_1__VDST__SHIFT                   = 0x00000018;
    constexpr unsigned int SQ_FLAT_SCRATCH_WORD0__SIZE__SHIFT       = 0x00000000;
    constexpr unsigned int SQ_FLAT_SCRATCH_WORD1__OFFSET__SHIFT     = 0x00000000;
    constexpr unsigned int SQ_GLBL_0__ENCODING__SHIFT               = 0x0000001a;
    constexpr unsigned int SQ_GLBL_0__GLC__SHIFT                    = 0x00000010;
    constexpr unsigned int SQ_GLBL_0__LDS__SHIFT                    = 0x0000000d;
    constexpr unsigned int SQ_GLBL_0__OFFSET__SHIFT                 = 0x00000000;
    constexpr unsigned int SQ_GLBL_0__OP__SHIFT                     = 0x00000012;
    constexpr unsigned int SQ_GLBL_0__SEG__SHIFT                    = 0x0000000e;
    constexpr unsigned int SQ_GLBL_0__SLC__SHIFT                    = 0x00000011;
    constexpr unsigned int SQ_GLBL_1__ADDR__SHIFT                   = 0x00000000;
    constexpr unsigned int SQ_GLBL_1__DATA__SHIFT                   = 0x00000008;
    constexpr unsigned int SQ_GLBL_1__NV__SHIFT                     = 0x00000017;
    constexpr unsigned int SQ_GLBL_1__SADDR__SHIFT                  = 0x00000010;
    constexpr unsigned int SQ_GLBL_1__VDST__SHIFT                   = 0x00000018;
    constexpr unsigned int SQ_IMG_RSRC_WORD0__BASE_ADDRESS__SHIFT   = 0x00000000;
    constexpr unsigned int SQ_IMG_RSRC_WORD1__BASE_ADDRESS_HI__SHIFT = 0x00000000;
    constexpr unsigned int SQ_IMG_RSRC_WORD1__DATA_FORMAT__SHIFT    = 0x00000014;
    constexpr unsigned int SQ_IMG_RSRC_WORD1__META_DIRECT__SHIFT    = 0x0000001f;
    constexpr unsigned int SQ_IMG_RSRC_WORD1__MIN_LOD__SHIFT        = 0x00000008;
    constexpr unsigned int SQ_IMG_RSRC_WORD1__NUM_FORMAT__SHIFT     = 0x0000001a;
    constexpr unsigned int SQ_IMG_RSRC_WORD1__NV__SHIFT             = 0x0000001e;
    constexpr unsigned int SQ_IMG_RSRC_WORD2__HEIGHT__SHIFT         = 0x0000000e;
    constexpr unsigned int SQ_IMG_RSRC_WORD2__PERF_MOD__SHIFT       = 0x0000001c;
    constexpr unsigned int SQ_IMG_RSRC_WORD2__WIDTH__SHIFT          = 0x00000000;
    constexpr unsigned int SQ_IMG_RSRC_WORD3__BASE_LEVEL__SHIFT     = 0x0000000c;
    constexpr unsigned int SQ_IMG_RSRC_WORD3__DST_SEL_W__SHIFT      = 0x00000009;
    constexpr unsigned int SQ_IMG_RSRC_WORD3__DST_SEL_X__SHIFT      = 0x00000000;
    constexpr unsigned int SQ_IMG_RSRC_WORD3__DST_SEL_Y__SHIFT      = 0x00000003;
    constexpr unsigned int SQ_IMG_RSRC_WORD3__DST_SEL_Z__SHIFT      = 0x00000006;
    constexpr unsigned int SQ_IMG_RSRC_WORD3__LAST_LEVEL__SHIFT     = 0x00000010;
    constexpr unsigned int SQ_IMG_RSRC_WORD3__SW_MODE__SHIFT        = 0x00000014;
    constexpr unsigned int SQ_IMG_RSRC_WORD3__TYPE__SHIFT           = 0x0000001c;
    constexpr unsigned int SQ_IMG_RSRC_WORD4__BC_SWIZZLE__SHIFT     = 0x0000001d;
    constexpr unsigned int SQ_IMG_RSRC_WORD4__DEPTH__SHIFT          = 0x00000000;
    constexpr unsigned int SQ_IMG_RSRC_WORD4__PITCH__SHIFT          = 0x0000000d;
    constexpr unsigned int SQ_IMG_RSRC_WORD5__ARRAY_PITCH__SHIFT    = 0x0000000d;
    constexpr unsigned int SQ_IMG_RSRC_WORD5__BASE_ARRAY__SHIFT     = 0x00000000;
    constexpr unsigned int SQ_IMG_RSRC_WORD5__MAX_MIP__SHIFT        = 0x0000001c;
    constexpr unsigned int SQ_IMG_RSRC_WORD5__META_DATA_ADDRESS__SHIFT = 0x00000011;
    constexpr unsigned int SQ_IMG_RSRC_WORD5__META_LINEAR__SHIFT    = 0x00000019;
    constexpr unsigned int SQ_IMG_RSRC_WORD5__META_PIPE_ALIGNED__SHIFT = 0x0000001a;
    constexpr unsigned int SQ_IMG_RSRC_WORD5__META_RB_ALIGNED__SHIFT = 0x0000001b;
    constexpr unsigned int SQ_IMG_RSRC_WORD6__ALPHA_IS_ON_MSB__SHIFT = 0x00000016;
    constexpr unsigned int SQ_IMG_RSRC_WORD6__COLOR_TRANSFORM__SHIFT = 0x00000017;
    constexpr unsigned int SQ_IMG_RSRC_WORD6__COMPRESSION_EN__SHIFT = 0x00000015;
    constexpr unsigned int SQ_IMG_RSRC_WORD6__COUNTER_BANK_ID__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_IMG_RSRC_WORD6__LOD_HDW_CNT_EN__SHIFT = 0x00000014;
    constexpr unsigned int SQ_IMG_RSRC_WORD6__LOST_ALPHA_BITS__SHIFT = 0x00000018;
    constexpr unsigned int SQ_IMG_RSRC_WORD6__LOST_COLOR_BITS__SHIFT = 0x0000001c;
    constexpr unsigned int SQ_IMG_RSRC_WORD6__MIN_LOD_WARN__SHIFT   = 0x00000000;
    constexpr unsigned int SQ_IMG_RSRC_WORD7__META_DATA_ADDRESS__SHIFT = 0x00000000;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__ANISO_BIAS__SHIFT     = 0x00000015;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__ANISO_THRESHOLD__SHIFT = 0x00000010;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__CLAMP_X__SHIFT        = 0x00000000;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__CLAMP_Y__SHIFT        = 0x00000003;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__CLAMP_Z__SHIFT        = 0x00000006;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__COMPAT_MODE__SHIFT    = 0x0000001f;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__DEPTH_COMPARE_FUNC__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__DISABLE_CUBE_WRAP__SHIFT = 0x0000001c;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__FILTER_MODE__SHIFT    = 0x0000001d;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__FORCE_DEGAMMA__SHIFT  = 0x00000014;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__FORCE_UNNORMALIZED__SHIFT = 0x0000000f;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__MAX_ANISO_RATIO__SHIFT = 0x00000009;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__MC_COORD_TRUNC__SHIFT = 0x00000013;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__TRUNC_COORD__SHIFT    = 0x0000001b;
    constexpr unsigned int SQ_IMG_SAMP_WORD1__MAX_LOD__SHIFT        = 0x0000000c;
    constexpr unsigned int SQ_IMG_SAMP_WORD1__MIN_LOD__SHIFT        = 0x00000000;
    constexpr unsigned int SQ_IMG_SAMP_WORD1__PERF_MIP__SHIFT       = 0x00000018;
    constexpr unsigned int SQ_IMG_SAMP_WORD1__PERF_Z__SHIFT         = 0x0000001c;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__ANISO_OVERRIDE__SHIFT = 0x0000001f;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__BLEND_ZERO_PRT__SHIFT = 0x0000001d;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__FILTER_PREC_FIX__SHIFT = 0x0000001e;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__LOD_BIAS_SEC__SHIFT   = 0x0000000e;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__LOD_BIAS__SHIFT       = 0x00000000;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__MIP_FILTER__SHIFT     = 0x0000001a;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__MIP_POINT_PRECLAMP__SHIFT = 0x0000001c;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__XY_MAG_FILTER__SHIFT  = 0x00000014;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__XY_MIN_FILTER__SHIFT  = 0x00000016;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__Z_FILTER__SHIFT       = 0x00000018;
    constexpr unsigned int SQ_IMG_SAMP_WORD3__BORDER_COLOR_PTR__SHIFT = 0x00000000;
    constexpr unsigned int SQ_IMG_SAMP_WORD3__BORDER_COLOR_TYPE__SHIFT = 0x0000001e;
    constexpr unsigned int SQ_IMG_SAMP_WORD3__SKIP_DEGAMMA__SHIFT   = 0x0000000c;
    constexpr unsigned int SQ_IND_INDEX__AUTO_INCR__SHIFT           = 0x0000000c;
    constexpr unsigned int SQ_IND_INDEX__FORCE_READ__SHIFT          = 0x0000000d;
    constexpr unsigned int SQ_IND_INDEX__READ_TIMEOUT__SHIFT        = 0x0000000e;
    constexpr unsigned int SQ_IND_INDEX__SIMD_ID__SHIFT             = 0x00000004;
    constexpr unsigned int SQ_IND_INDEX__THREAD_ID__SHIFT           = 0x00000006;
    constexpr unsigned int SQ_IND_INDEX__UNINDEXED__SHIFT           = 0x0000000f;
    constexpr unsigned int SQ_INST__ENCODING__SHIFT                 = 0x00000000;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__CMD_TIMESTAMP__SHIFT = 0x00000004;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__ENCODING__SHIFT = 0x0000001a;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__HOST_CMD_OVERFLOW__SHIFT = 0x00000005;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__HOST_REG_OVERFLOW__SHIFT = 0x00000006;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__IMMED_OVERFLOW__SHIFT = 0x00000007;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__REG_TIMESTAMP__SHIFT = 0x00000003;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__SE_ID__SHIFT = 0x00000018;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__THREAD_TRACE_BUF_FULL__SHIFT = 0x00000002;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__THREAD_TRACE_UTC_ERROR__SHIFT = 0x00000008;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__THREAD_TRACE__SHIFT = 0x00000000;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__WLT__SHIFT = 0x00000001;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_HI__ENCODING__SHIFT = 0x0000000a;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_HI__SE_ID__SHIFT  = 0x00000008;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__CMD_TIMESTAMP__SHIFT = 0x00000004;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__HOST_CMD_OVERFLOW__SHIFT = 0x00000005;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__HOST_REG_OVERFLOW__SHIFT = 0x00000006;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__IMMED_OVERFLOW__SHIFT = 0x00000007;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__REG_TIMESTAMP__SHIFT = 0x00000003;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__THREAD_TRACE_BUF_FULL__SHIFT = 0x00000002;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__THREAD_TRACE_UTC_ERROR__SHIFT = 0x00000008;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__THREAD_TRACE__SHIFT = 0x00000000;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__WLT__SHIFT    = 0x00000001;
    constexpr unsigned int SQ_INTERRUPT_WORD_CMN_CTXID__ENCODING__SHIFT = 0x0000001a;
    constexpr unsigned int SQ_INTERRUPT_WORD_CMN_CTXID__SE_ID__SHIFT = 0x00000018;
    constexpr unsigned int SQ_INTERRUPT_WORD_CMN_HI__ENCODING__SHIFT = 0x0000000a;
    constexpr unsigned int SQ_INTERRUPT_WORD_CMN_HI__SE_ID__SHIFT   = 0x00000008;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_CTXID__CU_ID__SHIFT = 0x00000014;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_CTXID__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_CTXID__ENCODING__SHIFT = 0x0000001a;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_CTXID__PRIV__SHIFT = 0x0000000d;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_CTXID__SE_ID__SHIFT = 0x00000018;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_CTXID__SH_ID__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_CTXID__SIMD_ID__SHIFT = 0x00000012;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_CTXID__WAVE_ID__SHIFT = 0x0000000e;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_HI__CU_ID__SHIFT  = 0x00000000;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_HI__ENCODING__SHIFT = 0x0000000a;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_HI__SE_ID__SHIFT  = 0x00000008;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_HI__VM_ID__SHIFT  = 0x00000004;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_LO__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_LO__PRIV__SHIFT   = 0x00000019;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_LO__SH_ID__SHIFT  = 0x00000018;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_LO__SIMD_ID__SHIFT = 0x0000001e;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_LO__WAVE_ID__SHIFT = 0x0000001a;
    constexpr unsigned int SQ_LB_CTR0_CU__SH0_MASK__SHIFT           = 0x00000000;
    constexpr unsigned int SQ_LB_CTR0_CU__SH1_MASK__SHIFT           = 0x00000010;
    constexpr unsigned int SQ_LB_CTR1_CU__SH0_MASK__SHIFT           = 0x00000000;
    constexpr unsigned int SQ_LB_CTR1_CU__SH1_MASK__SHIFT           = 0x00000010;
    constexpr unsigned int SQ_LB_CTR2_CU__SH0_MASK__SHIFT           = 0x00000000;
    constexpr unsigned int SQ_LB_CTR2_CU__SH1_MASK__SHIFT           = 0x00000010;
    constexpr unsigned int SQ_LB_CTR3_CU__SH0_MASK__SHIFT           = 0x00000000;
    constexpr unsigned int SQ_LB_CTR3_CU__SH1_MASK__SHIFT           = 0x00000010;
    constexpr unsigned int SQ_LB_CTR_SEL__SEL0__SHIFT               = 0x00000000;
    constexpr unsigned int SQ_LB_CTR_SEL__SEL1__SHIFT               = 0x00000004;
    constexpr unsigned int SQ_LB_CTR_SEL__SEL2__SHIFT               = 0x00000008;
    constexpr unsigned int SQ_LB_CTR_SEL__SEL3__SHIFT               = 0x0000000c;
    constexpr unsigned int SQ_LDS_CLK_CTRL__FORCE_CU_ON_SH0__SHIFT  = 0x00000000;
    constexpr unsigned int SQ_LDS_CLK_CTRL__FORCE_CU_ON_SH1__SHIFT  = 0x00000010;
    constexpr unsigned int SQ_M0_GPR_IDX_WORD__INDEX__SHIFT         = 0x00000000;
    constexpr unsigned int SQ_M0_GPR_IDX_WORD__VDST_REL__SHIFT      = 0x0000000f;
    constexpr unsigned int SQ_M0_GPR_IDX_WORD__VSRC0_REL__SHIFT     = 0x0000000c;
    constexpr unsigned int SQ_M0_GPR_IDX_WORD__VSRC1_REL__SHIFT     = 0x0000000d;
    constexpr unsigned int SQ_M0_GPR_IDX_WORD__VSRC2_REL__SHIFT     = 0x0000000e;
    constexpr unsigned int SQ_MIMG_0__A16__SHIFT                    = 0x0000000f;
    constexpr unsigned int SQ_MIMG_0__DA__SHIFT                     = 0x0000000e;
    constexpr unsigned int SQ_MIMG_0__DMASK__SHIFT                  = 0x00000008;
    constexpr unsigned int SQ_MIMG_0__ENCODING__SHIFT               = 0x0000001a;
    constexpr unsigned int SQ_MIMG_0__GLC__SHIFT                    = 0x0000000d;
    constexpr unsigned int SQ_MIMG_0__LWE__SHIFT                    = 0x00000011;
    constexpr unsigned int SQ_MIMG_0__OPM__SHIFT                    = 0x00000000;
    constexpr unsigned int SQ_MIMG_0__OP__SHIFT                     = 0x00000012;
    constexpr unsigned int SQ_MIMG_0__SLC__SHIFT                    = 0x00000019;
    constexpr unsigned int SQ_MIMG_0__TFE__SHIFT                    = 0x00000010;
    constexpr unsigned int SQ_MIMG_0__UNORM__SHIFT                  = 0x0000000c;
    constexpr unsigned int SQ_MIMG_1__D16__SHIFT                    = 0x0000001f;
    constexpr unsigned int SQ_MIMG_1__SRSRC__SHIFT                  = 0x00000010;
    constexpr unsigned int SQ_MIMG_1__SSAMP__SHIFT                  = 0x00000015;
    constexpr unsigned int SQ_MIMG_1__VADDR__SHIFT                  = 0x00000000;
    constexpr unsigned int SQ_MIMG_1__VDATA__SHIFT                  = 0x00000008;
    constexpr unsigned int SQ_MTBUF_0__DFMT__SHIFT                  = 0x00000013;
    constexpr unsigned int SQ_MTBUF_0__ENCODING__SHIFT              = 0x0000001a;
    constexpr unsigned int SQ_MTBUF_0__GLC__SHIFT                   = 0x0000000e;
    constexpr unsigned int SQ_MTBUF_0__IDXEN__SHIFT                 = 0x0000000d;
    constexpr unsigned int SQ_MTBUF_0__NFMT__SHIFT                  = 0x00000017;
    constexpr unsigned int SQ_MTBUF_0__OFFEN__SHIFT                 = 0x0000000c;
    constexpr unsigned int SQ_MTBUF_0__OFFSET__SHIFT                = 0x00000000;
    constexpr unsigned int SQ_MTBUF_0__OP__SHIFT                    = 0x0000000f;
    constexpr unsigned int SQ_MTBUF_1__SLC__SHIFT                   = 0x00000016;
    constexpr unsigned int SQ_MTBUF_1__SOFFSET__SHIFT               = 0x00000018;
    constexpr unsigned int SQ_MTBUF_1__SRSRC__SHIFT                 = 0x00000010;
    constexpr unsigned int SQ_MTBUF_1__TFE__SHIFT                   = 0x00000017;
    constexpr unsigned int SQ_MTBUF_1__VADDR__SHIFT                 = 0x00000000;
    constexpr unsigned int SQ_MTBUF_1__VDATA__SHIFT                 = 0x00000008;
    constexpr unsigned int SQ_MUBUF_0__ENCODING__SHIFT              = 0x0000001a;
    constexpr unsigned int SQ_MUBUF_0__GLC__SHIFT                   = 0x0000000e;
    constexpr unsigned int SQ_MUBUF_0__IDXEN__SHIFT                 = 0x0000000d;
    constexpr unsigned int SQ_MUBUF_0__LDS__SHIFT                   = 0x00000010;
    constexpr unsigned int SQ_MUBUF_0__OFFEN__SHIFT                 = 0x0000000c;
    constexpr unsigned int SQ_MUBUF_0__OFFSET__SHIFT                = 0x00000000;
    constexpr unsigned int SQ_MUBUF_0__OP__SHIFT                    = 0x00000012;
    constexpr unsigned int SQ_MUBUF_0__SLC__SHIFT                   = 0x00000011;
    constexpr unsigned int SQ_MUBUF_1__SOFFSET__SHIFT               = 0x00000018;
    constexpr unsigned int SQ_MUBUF_1__SRSRC__SHIFT                 = 0x00000010;
    constexpr unsigned int SQ_MUBUF_1__TFE__SHIFT                   = 0x00000017;
    constexpr unsigned int SQ_MUBUF_1__VADDR__SHIFT                 = 0x00000000;
    constexpr unsigned int SQ_MUBUF_1__VDATA__SHIFT                 = 0x00000008;
    constexpr unsigned int SQ_PERFCOUNTER0_SELECT__SIMD_MASK__SHIFT = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER0_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER0_SELECT__SQC_CLIENT_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER1_SELECT__SIMD_MASK__SHIFT = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER1_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER1_SELECT__SQC_CLIENT_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER2_SELECT__SIMD_MASK__SHIFT = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER2_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER2_SELECT__SQC_CLIENT_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER3_SELECT__SIMD_MASK__SHIFT = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER3_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER3_SELECT__SQC_CLIENT_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER4_SELECT__SIMD_MASK__SHIFT = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER4_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER4_SELECT__SQC_CLIENT_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER5_SELECT__SIMD_MASK__SHIFT = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER5_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER5_SELECT__SQC_CLIENT_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER6_SELECT__SIMD_MASK__SHIFT = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER6_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER6_SELECT__SQC_CLIENT_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER7_SELECT__SIMD_MASK__SHIFT = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER7_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER7_SELECT__SQC_CLIENT_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER8_SELECT__SIMD_MASK__SHIFT = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER8_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER8_SELECT__SQC_CLIENT_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER9_SELECT__SIMD_MASK__SHIFT = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER9_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER9_SELECT__SQC_CLIENT_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER10_SELECT__SIMD_MASK__SHIFT = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER10_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER10_SELECT__SQC_CLIENT_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER11_SELECT__SIMD_MASK__SHIFT = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER11_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER11_SELECT__SQC_CLIENT_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER12_SELECT__SIMD_MASK__SHIFT = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER12_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER12_SELECT__SQC_CLIENT_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER13_SELECT__SIMD_MASK__SHIFT = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER13_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER13_SELECT__SQC_CLIENT_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER14_SELECT__SIMD_MASK__SHIFT = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER14_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER14_SELECT__SQC_CLIENT_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER15_SELECT__SIMD_MASK__SHIFT = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER15_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER15_SELECT__SQC_CLIENT_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER_MASK__SH0_MASK__SHIFT     = 0x00000000;
    constexpr unsigned int SQ_PERFCOUNTER_MASK__SH1_MASK__SHIFT     = 0x00000010;
    constexpr unsigned int SQ_POWER_THROTTLE2__LONG_TERM_INTERVAL_RATIO__SHIFT = 0x0000001b;
    constexpr unsigned int SQ_POWER_THROTTLE2__MAX_POWER_DELTA__SHIFT = 0x00000000;
    constexpr unsigned int SQ_POWER_THROTTLE2__SHORT_TERM_INTERVAL_SIZE__SHIFT = 0x00000010;
    constexpr unsigned int SQ_POWER_THROTTLE2__USE_REF_CLOCK__SHIFT = 0x0000001f;
    constexpr unsigned int SQ_POWER_THROTTLE__MAX_POWER__SHIFT      = 0x00000010;
    constexpr unsigned int SQ_POWER_THROTTLE__MIN_POWER__SHIFT      = 0x00000000;
    constexpr unsigned int SQ_POWER_THROTTLE__PHASE_OFFSET__SHIFT   = 0x0000001e;
    constexpr unsigned int SQ_REG_CREDITS__CMD_CREDITS__SHIFT       = 0x00000008;
    constexpr unsigned int SQ_REG_CREDITS__CMD_OVERFLOW__SHIFT      = 0x0000001f;
    constexpr unsigned int SQ_REG_CREDITS__IMMED_OVERFLOW__SHIFT    = 0x0000001e;
    constexpr unsigned int SQ_REG_CREDITS__REG_BUSY__SHIFT          = 0x0000001c;
    constexpr unsigned int SQ_REG_CREDITS__SRBM_CREDITS__SHIFT      = 0x00000000;
    constexpr unsigned int SQ_REG_CREDITS__SRBM_OVERFLOW__SHIFT     = 0x0000001d;
    constexpr unsigned int SQ_REG_TIMESTAMP__TIMESTAMP__SHIFT       = 0x00000000;
    constexpr unsigned int SQ_RUNTIME_CONFIG__ENABLE_TEX_ARB_OLDEST__SHIFT = 0x00000000;
    constexpr unsigned int SQ_SCRATCH_0__ENCODING__SHIFT            = 0x0000001a;
    constexpr unsigned int SQ_SCRATCH_0__GLC__SHIFT                 = 0x00000010;
    constexpr unsigned int SQ_SCRATCH_0__LDS__SHIFT                 = 0x0000000d;
    constexpr unsigned int SQ_SCRATCH_0__OFFSET__SHIFT              = 0x00000000;
    constexpr unsigned int SQ_SCRATCH_0__OP__SHIFT                  = 0x00000012;
    constexpr unsigned int SQ_SCRATCH_0__SEG__SHIFT                 = 0x0000000e;
    constexpr unsigned int SQ_SCRATCH_0__SLC__SHIFT                 = 0x00000011;
    constexpr unsigned int SQ_SCRATCH_1__ADDR__SHIFT                = 0x00000000;
    constexpr unsigned int SQ_SCRATCH_1__DATA__SHIFT                = 0x00000008;
    constexpr unsigned int SQ_SCRATCH_1__NV__SHIFT                  = 0x00000017;
    constexpr unsigned int SQ_SCRATCH_1__SADDR__SHIFT               = 0x00000010;
    constexpr unsigned int SQ_SCRATCH_1__VDST__SHIFT                = 0x00000018;
    constexpr unsigned int SQ_SMEM_0__ENCODING__SHIFT               = 0x0000001a;
    constexpr unsigned int SQ_SMEM_0__GLC__SHIFT                    = 0x00000010;
    constexpr unsigned int SQ_SMEM_0__IMM__SHIFT                    = 0x00000011;
    constexpr unsigned int SQ_SMEM_0__NV__SHIFT                     = 0x0000000f;
    constexpr unsigned int SQ_SMEM_0__OP__SHIFT                     = 0x00000012;
    constexpr unsigned int SQ_SMEM_0__SBASE__SHIFT                  = 0x00000000;
    constexpr unsigned int SQ_SMEM_0__SDATA__SHIFT                  = 0x00000006;
    constexpr unsigned int SQ_SMEM_0__SOFFSET_EN__SHIFT             = 0x0000000e;
    constexpr unsigned int SQ_SMEM_1__OFFSET__SHIFT                 = 0x00000000;
    constexpr unsigned int SQ_SMEM_1__SOFFSET__SHIFT                = 0x00000019;
    constexpr unsigned int SQ_SOP1__ENCODING__SHIFT                 = 0x00000017;
    constexpr unsigned int SQ_SOP1__OP__SHIFT                       = 0x00000008;
    constexpr unsigned int SQ_SOP1__SDST__SHIFT                     = 0x00000010;
    constexpr unsigned int SQ_SOP1__SSRC0__SHIFT                    = 0x00000000;
    constexpr unsigned int SQ_SOP2__ENCODING__SHIFT                 = 0x0000001e;
    constexpr unsigned int SQ_SOP2__OP__SHIFT                       = 0x00000017;
    constexpr unsigned int SQ_SOP2__SDST__SHIFT                     = 0x00000010;
    constexpr unsigned int SQ_SOP2__SSRC0__SHIFT                    = 0x00000000;
    constexpr unsigned int SQ_SOP2__SSRC1__SHIFT                    = 0x00000008;
    constexpr unsigned int SQ_SOPC__ENCODING__SHIFT                 = 0x00000017;
    constexpr unsigned int SQ_SOPC__OP__SHIFT                       = 0x00000010;
    constexpr unsigned int SQ_SOPC__SSRC0__SHIFT                    = 0x00000000;
    constexpr unsigned int SQ_SOPC__SSRC1__SHIFT                    = 0x00000008;
    constexpr unsigned int SQ_SOPK__ENCODING__SHIFT                 = 0x0000001c;
    constexpr unsigned int SQ_SOPK__OP__SHIFT                       = 0x00000017;
    constexpr unsigned int SQ_SOPK__SDST__SHIFT                     = 0x00000010;
    constexpr unsigned int SQ_SOPK__SIMM16__SHIFT                   = 0x00000000;
    constexpr unsigned int SQ_SOPP__ENCODING__SHIFT                 = 0x00000017;
    constexpr unsigned int SQ_SOPP__OP__SHIFT                       = 0x00000010;
    constexpr unsigned int SQ_SOPP__SIMM16__SHIFT                   = 0x00000000;
    constexpr unsigned int SQ_TEX_CLK_CTRL__FORCE_CU_ON_SH0__SHIFT  = 0x00000000;
    constexpr unsigned int SQ_TEX_CLK_CTRL__FORCE_CU_ON_SH1__SHIFT  = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_BASE2__ADDR_HI__SHIFT    = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_BASE__ADDR__SHIFT        = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_CNTR__CNTR__SHIFT        = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__RESET_BUFFER__SHIFT = 0x0000001f;
    constexpr unsigned int SQ_THREAD_TRACE_HIWATER__HIWATER__SHIFT  = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__CU_SEL__SHIFT      = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__REG_STALL_EN__SHIFT = 0x00000007;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__SH_SEL__SHIFT      = 0x00000005;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__SIMD_EN__SHIFT     = 0x00000008;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__SPI_STALL_EN__SHIFT = 0x0000000e;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__SQ_STALL_EN__SHIFT = 0x0000000f;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__VM_ID_MASK__SHIFT  = 0x0000000c;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__AUTOFLUSH_EN__SHIFT = 0x00000019;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__CAPTURE_MODE__SHIFT = 0x00000017;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__INTERRUPT_EN__SHIFT = 0x0000001e;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__ISSUE_MASK__SHIFT  = 0x0000001b;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__MASK_CS__SHIFT     = 0x00000012;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__MASK_ES__SHIFT     = 0x00000009;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__MASK_GS__SHIFT     = 0x00000006;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__MASK_HS__SHIFT     = 0x0000000c;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__MASK_LS__SHIFT     = 0x0000000f;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__MASK_PS__SHIFT     = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__MASK_VS__SHIFT     = 0x00000003;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__MODE__SHIFT        = 0x00000015;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__TC_PERF_EN__SHIFT  = 0x0000001a;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__TEST_MODE__SHIFT   = 0x0000001d;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__WRAP__SHIFT        = 0x0000001f;
    constexpr unsigned int SQ_THREAD_TRACE_PERF_MASK__SH0_MASK__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_PERF_MASK__SH1_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_SIZE__SIZE__SHIFT        = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__BUSY__SHIFT      = 0x0000001e;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__FINISH_DONE__SHIFT = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__FULL__SHIFT      = 0x0000001f;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__NEW_BUF__SHIFT   = 0x0000001d;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__UTC_ERROR__SHIFT = 0x0000001c;
    constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK2__INST_MASK__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__REG_DROP_ON_STALL__SHIFT = 0x00000018;
    constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__REG_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__TOKEN_MASK__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_CMN__TIME_DELTA__SHIFT = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_CMN__TOKEN_TYPE__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_EVENT__EVENT_TYPE__SHIFT = 0x0000000a;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_EVENT__SH_ID__SHIFT = 0x00000005;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_EVENT__STAGE__SHIFT = 0x00000006;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_EVENT__TIME_DELTA__SHIFT = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_EVENT__TOKEN_TYPE__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_PC_1_OF_2__PC_LO__SHIFT = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_PC_1_OF_2__SIMD_ID__SHIFT = 0x00000009;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_PC_1_OF_2__TIME_DELTA__SHIFT = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_PC_1_OF_2__TOKEN_TYPE__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_PC_1_OF_2__TRAP_ERROR__SHIFT = 0x0000000f;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_PC_1_OF_2__WAVE_ID__SHIFT = 0x00000005;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_PC_2_OF_2__PC_HI__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_USERDATA_1_OF_2__CU_ID__SHIFT = 0x00000006;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_USERDATA_1_OF_2__DATA_LO__SHIFT = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_USERDATA_1_OF_2__SH_ID__SHIFT = 0x00000005;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_USERDATA_1_OF_2__SIMD_ID__SHIFT = 0x0000000e;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_USERDATA_1_OF_2__TIME_DELTA__SHIFT = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_USERDATA_1_OF_2__TOKEN_TYPE__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_USERDATA_1_OF_2__WAVE_ID__SHIFT = 0x0000000a;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_USERDATA_2_OF_2__DATA_HI__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST__INST_TYPE__SHIFT = 0x0000000b;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST__SIMD_ID__SHIFT = 0x00000009;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST__TIME_DELTA__SHIFT = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST__TOKEN_TYPE__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST__WAVE_ID__SHIFT = 0x00000005;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST0__SHIFT = 0x00000008;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST1__SHIFT = 0x0000000a;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST2__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST3__SHIFT = 0x0000000e;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST4__SHIFT = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST5__SHIFT = 0x00000012;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST6__SHIFT = 0x00000014;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST7__SHIFT = 0x00000016;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST8__SHIFT = 0x00000018;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST9__SHIFT = 0x0000001a;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__SIMD_ID__SHIFT = 0x00000005;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__TIME_DELTA__SHIFT = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__TOKEN_TYPE__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_MISC__MISC_TOKEN_TYPE__SHIFT = 0x0000000d;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_MISC__SH_ID__SHIFT  = 0x0000000c;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_MISC__TIME_DELTA__SHIFT = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_MISC__TOKEN_TYPE__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_1_OF_2__CNTR0__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_1_OF_2__CNTR1_LO__SHIFT = 0x00000019;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_1_OF_2__CNTR_BANK__SHIFT = 0x0000000a;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_1_OF_2__CU_ID__SHIFT = 0x00000006;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_1_OF_2__SH_ID__SHIFT = 0x00000005;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_1_OF_2__TIME_DELTA__SHIFT = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_1_OF_2__TOKEN_TYPE__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_2_OF_2__CNTR1_HI__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_2_OF_2__CNTR2__SHIFT = 0x00000006;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_2_OF_2__CNTR3__SHIFT = 0x00000013;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__ME_ID__SHIFT = 0x00000007;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__PIPE_ID__SHIFT = 0x00000005;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__REG_ADDR__SHIFT = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__REG_DROPPED_PREV__SHIFT = 0x00000009;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__REG_OP__SHIFT = 0x0000000f;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__REG_PRIV__SHIFT = 0x0000000e;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__REG_TYPE__SHIFT = 0x0000000a;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__TIME_DELTA__SHIFT = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__TOKEN_TYPE__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_2_OF_2__DATA__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_CS_1_OF_2__DATA_LO__SHIFT = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_CS_1_OF_2__ME_ID__SHIFT = 0x00000007;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_CS_1_OF_2__PIPE_ID__SHIFT = 0x00000005;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_CS_1_OF_2__REG_ADDR__SHIFT = 0x00000009;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_CS_1_OF_2__TIME_DELTA__SHIFT = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_CS_1_OF_2__TOKEN_TYPE__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_CS_2_OF_2__DATA_HI__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_TIMESTAMP_1_OF_2__TIME_LO__SHIFT = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_TIMESTAMP_1_OF_2__TOKEN_TYPE__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_TIMESTAMP_2_OF_2__TIME_HI__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__COUNT__SHIFT = 0x00000016;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__CU_ID__SHIFT = 0x00000006;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__DISPATCHER__SHIFT = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__SH_ID__SHIFT = 0x00000005;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__SIMD_ID__SHIFT = 0x0000000e;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__TG_ID__SHIFT = 0x0000001d;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__TIME_DELTA__SHIFT = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__TOKEN_TYPE__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__VS_NO_ALLOC_OR_GROUPED__SHIFT = 0x00000015;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__WAVE_ID__SHIFT = 0x0000000a;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE__CU_ID__SHIFT  = 0x00000006;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE__SH_ID__SHIFT  = 0x00000005;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE__SIMD_ID__SHIFT = 0x0000000e;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE__TIME_DELTA__SHIFT = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE__TOKEN_TYPE__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE__WAVE_ID__SHIFT = 0x0000000a;
    constexpr unsigned int SQ_THREAD_TRACE_WPTR__READ_OFFSET__SHIFT = 0x0000001e;
    constexpr unsigned int SQ_THREAD_TRACE_WPTR__WPTR__SHIFT        = 0x00000000;
    constexpr unsigned int SQ_UTCL1_CNTL1__CLIENTID__SHIFT          = 0x00000007;
    constexpr unsigned int SQ_UTCL1_CNTL1__ENABLE_LFIFO_PRI_ARB__SHIFT = 0x00000012;
    constexpr unsigned int SQ_UTCL1_CNTL1__ENABLE_PUSH_LFIFO__SHIFT = 0x00000011;
    constexpr unsigned int SQ_UTCL1_CNTL1__FORCE_4K_L2_RESP__SHIFT  = 0x00000000;
    constexpr unsigned int SQ_UTCL1_CNTL1__FORCE_IN_ORDER__SHIFT    = 0x0000001b;
    constexpr unsigned int SQ_UTCL1_CNTL1__FORCE_MISS__SHIFT        = 0x0000001a;
    constexpr unsigned int SQ_UTCL1_CNTL1__GPUVM_64K_DEF__SHIFT     = 0x00000001;
    constexpr unsigned int SQ_UTCL1_CNTL1__GPUVM_PERM_MODE__SHIFT   = 0x00000002;
    constexpr unsigned int SQ_UTCL1_CNTL1__REDUCE_CACHE_SIZE_BY_2__SHIFT = 0x0000001e;
    constexpr unsigned int SQ_UTCL1_CNTL1__REDUCE_FIFO_DEPTH_BY_2__SHIFT = 0x0000001c;
    constexpr unsigned int SQ_UTCL1_CNTL1__REG_INVALIDATE_ALL_VMID__SHIFT = 0x00000017;
    constexpr unsigned int SQ_UTCL1_CNTL1__REG_INVALIDATE_ALL__SHIFT = 0x00000019;
    constexpr unsigned int SQ_UTCL1_CNTL1__REG_INVALIDATE_TOGGLE__SHIFT = 0x00000018;
    constexpr unsigned int SQ_UTCL1_CNTL1__REG_INVALIDATE_VMID__SHIFT = 0x00000013;
    constexpr unsigned int SQ_UTCL1_CNTL1__RESP_FAULT_MODE__SHIFT   = 0x00000005;
    constexpr unsigned int SQ_UTCL1_CNTL1__RESP_MODE__SHIFT         = 0x00000003;
    constexpr unsigned int SQ_UTCL1_CNTL1__USERVM_DIS__SHIFT        = 0x00000010;
    constexpr unsigned int SQ_UTCL1_CNTL2__DIS_EDC__SHIFT           = 0x0000000b;
    constexpr unsigned int SQ_UTCL1_CNTL2__FORCE_FRAG_2M_TO_64K__SHIFT = 0x0000001a;
    constexpr unsigned int SQ_UTCL1_CNTL2__FORCE_GPUVM_INV_ACK__SHIFT = 0x0000000f;
    constexpr unsigned int SQ_UTCL1_CNTL2__FORCE_SNOOP__SHIFT       = 0x0000000e;
    constexpr unsigned int SQ_UTCL1_CNTL2__GPUVM_INV_MODE__SHIFT    = 0x0000000c;
    constexpr unsigned int SQ_UTCL1_CNTL2__LFIFO_SCAN_DISABLE__SHIFT = 0x00000008;
    constexpr unsigned int SQ_UTCL1_CNTL2__LINE_VALID__SHIFT        = 0x0000000a;
    constexpr unsigned int SQ_UTCL1_CNTL2__MTYPE_OVRD_DIS__SHIFT    = 0x00000009;
    constexpr unsigned int SQ_UTCL1_CNTL2__PREFETCH_PAGE__SHIFT     = 0x0000001c;
    constexpr unsigned int SQ_UTCL1_CNTL2__RETRY_TIMER__SHIFT       = 0x00000010;
    constexpr unsigned int SQ_UTCL1_CNTL2__SHOOTDOWN_OPT__SHIFT     = 0x0000000d;
    constexpr unsigned int SQ_UTCL1_CNTL2__SPARE__SHIFT             = 0x00000000;
    constexpr unsigned int SQ_UTCL1_STATUS__FAULT_DETECTED__SHIFT   = 0x00000000;
    constexpr unsigned int SQ_UTCL1_STATUS__PRT_DETECTED__SHIFT     = 0x00000002;
    constexpr unsigned int SQ_UTCL1_STATUS__RESERVED__SHIFT         = 0x00000003;
    constexpr unsigned int SQ_UTCL1_STATUS__RETRY_DETECTED__SHIFT   = 0x00000001;
    constexpr unsigned int SQ_UTCL1_STATUS__UNUSED__SHIFT           = 0x00000010;
    constexpr unsigned int SQ_VINTRP__ATTRCHAN__SHIFT               = 0x00000008;
    constexpr unsigned int SQ_VINTRP__ATTR__SHIFT                   = 0x0000000a;
    constexpr unsigned int SQ_VINTRP__ENCODING__SHIFT               = 0x0000001a;
    constexpr unsigned int SQ_VINTRP__OP__SHIFT                     = 0x00000010;
    constexpr unsigned int SQ_VINTRP__VDST__SHIFT                   = 0x00000012;
    constexpr unsigned int SQ_VINTRP__VSRC__SHIFT                   = 0x00000000;
    constexpr unsigned int SQ_VOP1__ENCODING__SHIFT                 = 0x00000019;
    constexpr unsigned int SQ_VOP1__OP__SHIFT                       = 0x00000009;
    constexpr unsigned int SQ_VOP1__SRC0__SHIFT                     = 0x00000000;
    constexpr unsigned int SQ_VOP1__VDST__SHIFT                     = 0x00000011;
    constexpr unsigned int SQ_VOP2__ENCODING__SHIFT                 = 0x0000001f;
    constexpr unsigned int SQ_VOP2__OP__SHIFT                       = 0x00000019;
    constexpr unsigned int SQ_VOP2__SRC0__SHIFT                     = 0x00000000;
    constexpr unsigned int SQ_VOP2__VDST__SHIFT                     = 0x00000011;
    constexpr unsigned int SQ_VOP2__VSRC1__SHIFT                    = 0x00000009;
    constexpr unsigned int SQ_VOP3P_0__CLAMP__SHIFT                 = 0x0000000f;
    constexpr unsigned int SQ_VOP3P_0__ENCODING__SHIFT              = 0x00000017;
    constexpr unsigned int SQ_VOP3P_0__NEG_HI__SHIFT                = 0x00000008;
    constexpr unsigned int SQ_VOP3P_0__OP_SEL_HI_2__SHIFT           = 0x0000000e;
    constexpr unsigned int SQ_VOP3P_0__OP_SEL__SHIFT                = 0x0000000b;
    constexpr unsigned int SQ_VOP3P_0__OP__SHIFT                    = 0x00000010;
    constexpr unsigned int SQ_VOP3P_0__VDST__SHIFT                  = 0x00000000;
    constexpr unsigned int SQ_VOP3P_1__NEG__SHIFT                   = 0x0000001d;
    constexpr unsigned int SQ_VOP3P_1__OP_SEL_HI__SHIFT             = 0x0000001b;
    constexpr unsigned int SQ_VOP3P_1__SRC0__SHIFT                  = 0x00000000;
    constexpr unsigned int SQ_VOP3P_1__SRC1__SHIFT                  = 0x00000009;
    constexpr unsigned int SQ_VOP3P_1__SRC2__SHIFT                  = 0x00000012;
    constexpr unsigned int SQ_VOP3_0_SDST_ENC__CLAMP__SHIFT         = 0x0000000f;
    constexpr unsigned int SQ_VOP3_0_SDST_ENC__ENCODING__SHIFT      = 0x0000001a;
    constexpr unsigned int SQ_VOP3_0_SDST_ENC__OP__SHIFT            = 0x00000010;
    constexpr unsigned int SQ_VOP3_0_SDST_ENC__SDST__SHIFT          = 0x00000008;
    constexpr unsigned int SQ_VOP3_0_SDST_ENC__VDST__SHIFT          = 0x00000000;
    constexpr unsigned int SQ_VOP3_0__ABS__SHIFT                    = 0x00000008;
    constexpr unsigned int SQ_VOP3_0__CLAMP__SHIFT                  = 0x0000000f;
    constexpr unsigned int SQ_VOP3_0__ENCODING__SHIFT               = 0x0000001a;
    constexpr unsigned int SQ_VOP3_0__OP_SEL__SHIFT                 = 0x0000000b;
    constexpr unsigned int SQ_VOP3_0__OP__SHIFT                     = 0x00000010;
    constexpr unsigned int SQ_VOP3_0__VDST__SHIFT                   = 0x00000000;
    constexpr unsigned int SQ_VOP3_1__NEG__SHIFT                    = 0x0000001d;
    constexpr unsigned int SQ_VOP3_1__OMOD__SHIFT                   = 0x0000001b;
    constexpr unsigned int SQ_VOP3_1__SRC0__SHIFT                   = 0x00000000;
    constexpr unsigned int SQ_VOP3_1__SRC1__SHIFT                   = 0x00000009;
    constexpr unsigned int SQ_VOP3_1__SRC2__SHIFT                   = 0x00000012;
    constexpr unsigned int SQ_VOPC__ENCODING__SHIFT                 = 0x00000019;
    constexpr unsigned int SQ_VOPC__OP__SHIFT                       = 0x00000011;
    constexpr unsigned int SQ_VOPC__SRC0__SHIFT                     = 0x00000000;
    constexpr unsigned int SQ_VOPC__VSRC1__SHIFT                    = 0x00000009;
    constexpr unsigned int SQ_VOP_DPP__BANK_MASK__SHIFT             = 0x00000018;
    constexpr unsigned int SQ_VOP_DPP__BOUND_CTRL__SHIFT            = 0x00000013;
    constexpr unsigned int SQ_VOP_DPP__DPP_CTRL__SHIFT              = 0x00000008;
    constexpr unsigned int SQ_VOP_DPP__ROW_MASK__SHIFT              = 0x0000001c;
    constexpr unsigned int SQ_VOP_DPP__SRC0_ABS__SHIFT              = 0x00000015;
    constexpr unsigned int SQ_VOP_DPP__SRC0_NEG__SHIFT              = 0x00000014;
    constexpr unsigned int SQ_VOP_DPP__SRC0__SHIFT                  = 0x00000000;
    constexpr unsigned int SQ_VOP_DPP__SRC1_ABS__SHIFT              = 0x00000017;
    constexpr unsigned int SQ_VOP_DPP__SRC1_NEG__SHIFT              = 0x00000016;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__S0__SHIFT          = 0x00000017;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__S1__SHIFT          = 0x0000001f;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SDST__SHIFT        = 0x00000008;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SD__SHIFT          = 0x0000000f;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC0_ABS__SHIFT    = 0x00000015;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC0_NEG__SHIFT    = 0x00000014;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC0_SEL__SHIFT    = 0x00000010;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC0_SEXT__SHIFT   = 0x00000013;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC0__SHIFT        = 0x00000000;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC1_ABS__SHIFT    = 0x0000001d;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC1_NEG__SHIFT    = 0x0000001c;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC1_SEL__SHIFT    = 0x00000018;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC1_SEXT__SHIFT   = 0x0000001b;
    constexpr unsigned int SQ_VOP_SDWA__CLAMP__SHIFT                = 0x0000000d;
    constexpr unsigned int SQ_VOP_SDWA__DST_SEL__SHIFT              = 0x00000008;
    constexpr unsigned int SQ_VOP_SDWA__DST_UNUSED__SHIFT           = 0x0000000b;
    constexpr unsigned int SQ_VOP_SDWA__OMOD__SHIFT                 = 0x0000000e;
    constexpr unsigned int SQ_VOP_SDWA__S0__SHIFT                   = 0x00000017;
    constexpr unsigned int SQ_VOP_SDWA__S1__SHIFT                   = 0x0000001f;
    constexpr unsigned int SQ_VOP_SDWA__SRC0_ABS__SHIFT             = 0x00000015;
    constexpr unsigned int SQ_VOP_SDWA__SRC0_NEG__SHIFT             = 0x00000014;
    constexpr unsigned int SQ_VOP_SDWA__SRC0_SEL__SHIFT             = 0x00000010;
    constexpr unsigned int SQ_VOP_SDWA__SRC0_SEXT__SHIFT            = 0x00000013;
    constexpr unsigned int SQ_VOP_SDWA__SRC0__SHIFT                 = 0x00000000;
    constexpr unsigned int SQ_VOP_SDWA__SRC1_ABS__SHIFT             = 0x0000001d;
    constexpr unsigned int SQ_VOP_SDWA__SRC1_NEG__SHIFT             = 0x0000001c;
    constexpr unsigned int SQ_VOP_SDWA__SRC1_SEL__SHIFT             = 0x00000018;
    constexpr unsigned int SQ_VOP_SDWA__SRC1_SEXT__SHIFT            = 0x0000001b;
    constexpr unsigned int SQ_WREXEC_EXEC_HI__ATC__SHIFT            = 0x0000001b;
    constexpr unsigned int SX_DEBUG_1__DEBUG_DATA__SHIFT            = 0x0000000e;
    constexpr unsigned int TA_CNTL_AUX__ANISO_MIP_ADJ_MODE__SHIFT   = 0x00000013;
    constexpr unsigned int TA_CNTL_AUX__NONIMG_ANISO_BYPASS__SHIFT  = 0x00000009;
    constexpr unsigned int TA_CNTL_AUX__RESERVED__SHIFT             = 0x00000001;
    constexpr unsigned int TA_CNTL__FX_XNACK_CREDIT__SHIFT          = 0x00000000;
    constexpr unsigned int TA_CNTL__SQ_XNACK_CREDIT__SHIFT          = 0x00000009;
    constexpr unsigned int TA_CNTL__TC_DATA_CREDIT__SHIFT           = 0x0000000d;
    constexpr unsigned int TCA_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x00000018;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x0000001c;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT = 0x00000018;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT = 0x0000001c;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int TCA_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int TCA_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int TCA_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int TCA_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x00000018;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x0000001c;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT = 0x00000018;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT = 0x0000001c;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int TCC_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int TCC_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int TCC_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int TCC_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__ADDR_MODE__SHIFT = 0x0000000b;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__COMPRESSION_ENABLE__SHIFT = 0x0000000a;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__GLC__SHIFT    = 0x00000008;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__SLC__SHIFT    = 0x00000009;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__ADDR_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__COMPRESSION_ENABLE__SHIFT = 0x0000001b;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__GLC__SHIFT       = 0x00000019;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__NUM_FORMAT__SHIFT = 0x0000000b;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__NUM_SAMPLES__SHIFT = 0x00000014;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__OPCODE_TYPE__SHIFT = 0x00000016;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__SLC__SHIFT       = 0x0000001a;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__SW_MODE__SHIFT   = 0x0000000f;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_0__SHIFT  = 0x00000000;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_1__SHIFT  = 0x00000002;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_2__SHIFT  = 0x00000004;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_3__SHIFT  = 0x00000006;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_4__SHIFT  = 0x00000008;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_5__SHIFT  = 0x0000000a;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_6__SHIFT  = 0x0000000c;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_7__SHIFT  = 0x0000000e;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_8__SHIFT  = 0x00000010;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_9__SHIFT  = 0x00000012;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_10__SHIFT = 0x00000014;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_11__SHIFT = 0x00000016;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_12__SHIFT = 0x00000018;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_13__SHIFT = 0x0000001a;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_14__SHIFT = 0x0000001c;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY0__POLICY_15__SHIFT = 0x0000001e;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_16__SHIFT = 0x00000000;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_17__SHIFT = 0x00000002;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_18__SHIFT = 0x00000004;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_19__SHIFT = 0x00000006;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_20__SHIFT = 0x00000008;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_21__SHIFT = 0x0000000a;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_22__SHIFT = 0x0000000c;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_23__SHIFT = 0x0000000e;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_24__SHIFT = 0x00000010;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_25__SHIFT = 0x00000012;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_26__SHIFT = 0x00000014;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_27__SHIFT = 0x00000016;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_28__SHIFT = 0x00000018;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_29__SHIFT = 0x0000001a;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_30__SHIFT = 0x0000001c;
    constexpr unsigned int TC_CFG_L1_LOAD_POLICY1__POLICY_31__SHIFT = 0x0000001e;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_0__SHIFT  = 0x00000000;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_1__SHIFT  = 0x00000001;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_2__SHIFT  = 0x00000002;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_3__SHIFT  = 0x00000003;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_4__SHIFT  = 0x00000004;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_5__SHIFT  = 0x00000005;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_6__SHIFT  = 0x00000006;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_7__SHIFT  = 0x00000007;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_8__SHIFT  = 0x00000008;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_9__SHIFT  = 0x00000009;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_10__SHIFT = 0x0000000a;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_11__SHIFT = 0x0000000b;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_12__SHIFT = 0x0000000c;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_13__SHIFT = 0x0000000d;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_14__SHIFT = 0x0000000e;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_15__SHIFT = 0x0000000f;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_16__SHIFT = 0x00000010;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_17__SHIFT = 0x00000011;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_18__SHIFT = 0x00000012;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_19__SHIFT = 0x00000013;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_20__SHIFT = 0x00000014;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_21__SHIFT = 0x00000015;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_22__SHIFT = 0x00000016;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_23__SHIFT = 0x00000017;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_24__SHIFT = 0x00000018;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_25__SHIFT = 0x00000019;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_26__SHIFT = 0x0000001a;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_27__SHIFT = 0x0000001b;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_28__SHIFT = 0x0000001c;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_29__SHIFT = 0x0000001d;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_30__SHIFT = 0x0000001e;
    constexpr unsigned int TC_CFG_L1_STORE_POLICY__POLICY_31__SHIFT = 0x0000001f;
    constexpr unsigned int TC_CFG_L1_VOLATILE__VOL__SHIFT           = 0x00000000;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_0__SHIFT = 0x00000000;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_1__SHIFT = 0x00000002;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_2__SHIFT = 0x00000004;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_3__SHIFT = 0x00000006;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_4__SHIFT = 0x00000008;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_5__SHIFT = 0x0000000a;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_6__SHIFT = 0x0000000c;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_7__SHIFT = 0x0000000e;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_8__SHIFT = 0x00000010;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_9__SHIFT = 0x00000012;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_10__SHIFT = 0x00000014;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_11__SHIFT = 0x00000016;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_12__SHIFT = 0x00000018;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_13__SHIFT = 0x0000001a;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_14__SHIFT = 0x0000001c;
    constexpr unsigned int TC_CFG_L2_ATOMIC_POLICY__POLICY_15__SHIFT = 0x0000001e;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_0__SHIFT  = 0x00000000;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_1__SHIFT  = 0x00000002;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_2__SHIFT  = 0x00000004;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_3__SHIFT  = 0x00000006;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_4__SHIFT  = 0x00000008;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_5__SHIFT  = 0x0000000a;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_6__SHIFT  = 0x0000000c;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_7__SHIFT  = 0x0000000e;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_8__SHIFT  = 0x00000010;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_9__SHIFT  = 0x00000012;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_10__SHIFT = 0x00000014;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_11__SHIFT = 0x00000016;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_12__SHIFT = 0x00000018;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_13__SHIFT = 0x0000001a;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_14__SHIFT = 0x0000001c;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY0__POLICY_15__SHIFT = 0x0000001e;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_16__SHIFT = 0x00000000;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_17__SHIFT = 0x00000002;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_18__SHIFT = 0x00000004;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_19__SHIFT = 0x00000006;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_20__SHIFT = 0x00000008;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_21__SHIFT = 0x0000000a;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_22__SHIFT = 0x0000000c;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_23__SHIFT = 0x0000000e;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_24__SHIFT = 0x00000010;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_25__SHIFT = 0x00000012;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_26__SHIFT = 0x00000014;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_27__SHIFT = 0x00000016;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_28__SHIFT = 0x00000018;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_29__SHIFT = 0x0000001a;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_30__SHIFT = 0x0000001c;
    constexpr unsigned int TC_CFG_L2_LOAD_POLICY1__POLICY_31__SHIFT = 0x0000001e;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_0__SHIFT = 0x00000000;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_1__SHIFT = 0x00000002;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_2__SHIFT = 0x00000004;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_3__SHIFT = 0x00000006;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_4__SHIFT = 0x00000008;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_5__SHIFT = 0x0000000a;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_6__SHIFT = 0x0000000c;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_7__SHIFT = 0x0000000e;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_8__SHIFT = 0x00000010;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_9__SHIFT = 0x00000012;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_10__SHIFT = 0x00000014;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_11__SHIFT = 0x00000016;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_12__SHIFT = 0x00000018;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_13__SHIFT = 0x0000001a;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_14__SHIFT = 0x0000001c;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY0__POLICY_15__SHIFT = 0x0000001e;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_16__SHIFT = 0x00000000;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_17__SHIFT = 0x00000002;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_18__SHIFT = 0x00000004;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_19__SHIFT = 0x00000006;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_20__SHIFT = 0x00000008;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_21__SHIFT = 0x0000000a;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_22__SHIFT = 0x0000000c;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_23__SHIFT = 0x0000000e;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_24__SHIFT = 0x00000010;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_25__SHIFT = 0x00000012;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_26__SHIFT = 0x00000014;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_27__SHIFT = 0x00000016;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_28__SHIFT = 0x00000018;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_29__SHIFT = 0x0000001a;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_30__SHIFT = 0x0000001c;
    constexpr unsigned int TC_CFG_L2_STORE_POLICY1__POLICY_31__SHIFT = 0x0000001e;
    constexpr unsigned int TC_CFG_L2_VOLATILE__VOL__SHIFT           = 0x00000000;
    constexpr unsigned int TD_CNTL__DISABLE_MM_QNAN_COMPARE_RESULT__SHIFT = 0x00000018;
    constexpr unsigned int UTCL2_CGTT_CLK_CTRL__MGLS_OVERRIDE__SHIFT = 0x0000000f;
    constexpr unsigned int UTCL2_CGTT_CLK_CTRL__OFF_HYSTERESIS__SHIFT = 0x00000004;
    constexpr unsigned int UTCL2_CGTT_CLK_CTRL__ON_DELAY__SHIFT     = 0x00000000;
    constexpr unsigned int UTCL2_CGTT_CLK_CTRL__SOFT_OVERRIDE_EXTRA__SHIFT = 0x0000000c;
    constexpr unsigned int UTCL2_CGTT_CLK_CTRL__SOFT_OVERRIDE__SHIFT = 0x00000018;
    constexpr unsigned int UTCL2_CGTT_CLK_CTRL__SOFT_STALL_OVERRIDE__SHIFT = 0x00000010;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_BUSY__SHIFT         = 0x00000000;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_GS_BUSY__SHIFT      = 0x00000007;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_HS_BUSY__SHIFT      = 0x00000008;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_OUT_BUSY__SHIFT     = 0x00000002;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_OUT_INDX_BUSY__SHIFT = 0x00000001;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_PI_BUSY__SHIFT      = 0x00000006;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_PRIMGEN_BUSY__SHIFT = 0x0000000a;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_PT_BUSY__SHIFT      = 0x00000003;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_TE11_BUSY__SHIFT    = 0x00000009;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_TE_BUSY__SHIFT      = 0x00000004;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_VR_BUSY__SHIFT      = 0x00000005;
    constexpr unsigned int VGT_DEBUG_DATA__DATA__SHIFT              = 0x00000000;
    constexpr unsigned int VGT_DEBUG_REG0__gog_busy__SHIFT          = 0x00000010;
    constexpr unsigned int VGT_DEBUG_REG0__gs_busy__SHIFT           = 0x0000000c;
    constexpr unsigned int VGT_DEBUG_REG0__sclk_core_vld__SHIFT     = 0x0000001d;
    constexpr unsigned int VGT_DEBUG_REG0__sclk_gs_vld__SHIFT       = 0x0000001e;
    constexpr unsigned int VGT_DEBUG_REG0__vgt_busy__SHIFT          = 0x00000002;
    constexpr unsigned int VGT_DEBUG_REG11__gs_issue_rtr__SHIFT     = 0x00000010;
    constexpr unsigned int VGT_DEBUG_REG15__output_fifo_full__SHIFT = 0x00000003;
    constexpr unsigned int VGT_DEBUG_REG16__gog_busy__SHIFT         = 0x00000000;
    constexpr unsigned int VGT_DISPATCH_DRAW_INDEX__MATCH_INDEX__SHIFT = 0x00000000;
    constexpr unsigned int VGT_DMA_CONTROL__EN_INST_OPT_ADV__SHIFT  = 0x00000016;
    constexpr unsigned int VGT_DMA_CONTROL__EN_INST_OPT_BASIC__SHIFT = 0x00000015;
    constexpr unsigned int VGT_DMA_CONTROL__HW_USE_ONLY__SHIFT      = 0x00000017;
    constexpr unsigned int VGT_DMA_DATA_FIFO_DEPTH__DMA2DRAW_FIFO_DEPTH__SHIFT = 0x00000009;
    constexpr unsigned int VGT_DMA_INDEX_TYPE__PRIMGEN_EN__SHIFT    = 0x00000008;
    constexpr unsigned int VGT_DRAW_INITIATOR__GRBM_SKEW_NO_DEC__SHIFT = 0x00000008;
    constexpr unsigned int VGT_DRAW_INITIATOR__UNROLLED_INST__SHIFT = 0x00000007;
    constexpr unsigned int VGT_FIFO_DEPTHS__HSINPUT_FIFO_DEPTH__SHIFT = 0x00000016;
    constexpr unsigned int VGT_GS_MAX_PRIMS_PER_SUBGROUP__MAX_PRIMS_PER_SUBGROUP__SHIFT = 0x00000000;
    constexpr unsigned int VGT_GS_MODE__RESERVED_3__SHIFT           = 0x0000000e;
    constexpr unsigned int VGT_GS_MODE__RESERVED_4__SHIFT           = 0x0000000f;
    constexpr unsigned int VGT_GS_MODE__RESERVED_5__SHIFT           = 0x00000010;
    constexpr unsigned int VGT_HS_OFFCHIP_PARAM__OFFCHIP_GRANULARITY__SHIFT = 0x00000009;
    constexpr unsigned int VGT_INDEX_TYPE__PRIMGEN_EN__SHIFT        = 0x00000008;
    constexpr unsigned int VGT_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int VGT_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int VGT_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER_SEID_MASK__PERF_SEID_IGNORE_MASK__SHIFT = 0x00000000;
    constexpr unsigned int VGT_SHADER_STAGES_EN__DISPATCH_DRAW_EN__SHIFT = 0x00000009;
    constexpr unsigned int VGT_SHADER_STAGES_EN__DIS_DEALLOC_ACCUM_0__SHIFT = 0x0000000a;
    constexpr unsigned int VGT_SHADER_STAGES_EN__DIS_DEALLOC_ACCUM_1__SHIFT = 0x0000000b;
    constexpr unsigned int WD_CNTL_STATUS__WD_ADC_BUSY__SHIFT       = 0x00000003;
    constexpr unsigned int WD_CNTL_STATUS__WD_BUSY__SHIFT           = 0x00000000;
    constexpr unsigned int WD_CNTL_STATUS__WD_SPL_DI_BUSY__SHIFT    = 0x00000002;
    constexpr unsigned int WD_CNTL_STATUS__WD_SPL_DMA_BUSY__SHIFT   = 0x00000001;
    constexpr unsigned int WD_DEBUG_DATA__DATA__SHIFT               = 0x00000000;
    constexpr unsigned int WD_DEBUG_REG0__sclk_core_vld__SHIFT      = 0x0000001e;
    constexpr unsigned int WD_DEBUG_REG0__sclk_input_vld__SHIFT     = 0x0000001d;
    constexpr unsigned int WD_DEBUG_REG0__sclk_reg_vld__SHIFT       = 0x0000001c;
    constexpr unsigned int WD_DEBUG_REG0__wd_busy__SHIFT            = 0x00000002;
    constexpr unsigned int WD_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int WD_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int WD_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int WD_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT  = 0x00000000;
    constexpr unsigned int WD_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int WD_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int WD_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int WD_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT  = 0x00000000;
    constexpr unsigned int WD_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int WD_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int WD_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int WD_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT  = 0x00000000;
    constexpr unsigned int WD_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int WD_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int WD_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int WD_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT  = 0x00000000;
    constexpr unsigned int WD_UTCL1_CNTL__FORCE_SD_VMID_DIRTY__SHIFT = 0x0000001d;
} // namespace Gfx09

namespace Gfx09_0
{
    constexpr unsigned int CP_PRT_LOD_STATS_CNTL0__BU_SIZE__SHIFT   = 0x00000000;
    constexpr unsigned int CP_PRT_LOD_STATS_CNTL1__BASE_LO__SHIFT   = 0x00000000;
    constexpr unsigned int CP_PRT_LOD_STATS_CNTL2__BASE_HI__SHIFT   = 0x00000000;
    constexpr unsigned int CP_PRT_LOD_STATS_CNTL3__CACHE_POLICY__SHIFT = 0x0000001c;
    constexpr unsigned int CP_PRT_LOD_STATS_CNTL3__INTERVAL__SHIFT  = 0x00000002;
    constexpr unsigned int CP_PRT_LOD_STATS_CNTL3__MC_VMID__SHIFT   = 0x00000017;
    constexpr unsigned int CP_PRT_LOD_STATS_CNTL3__REPORT_AND_RESET__SHIFT = 0x00000013;
    constexpr unsigned int CP_PRT_LOD_STATS_CNTL3__RESET_CNT__SHIFT = 0x0000000a;
    constexpr unsigned int CP_PRT_LOD_STATS_CNTL3__RESET_FORCE__SHIFT = 0x00000012;
    constexpr unsigned int GC_CAC_ACC_CU5__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU6__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU7__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU8__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU9__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU10__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_SQ0_UPPER__UNUSED_0__SHIFT    = 0x00000008;
    constexpr unsigned int GC_CAC_ACC_SQ1_UPPER__UNUSED_0__SHIFT    = 0x00000008;
    constexpr unsigned int GC_CAC_ACC_SQ2_UPPER__UNUSED_0__SHIFT    = 0x00000008;
    constexpr unsigned int GC_CAC_ACC_SQ3_UPPER__UNUSED_0__SHIFT    = 0x00000008;
    constexpr unsigned int GC_CAC_ACC_SQ4_UPPER__UNUSED_0__SHIFT    = 0x00000008;
    constexpr unsigned int GC_CAC_ACC_SQ5_UPPER__UNUSED_0__SHIFT    = 0x00000008;
    constexpr unsigned int GC_CAC_ACC_SQ6_UPPER__UNUSED_0__SHIFT    = 0x00000008;
    constexpr unsigned int GC_CAC_ACC_SQ7_UPPER__UNUSED_0__SHIFT    = 0x00000008;
    constexpr unsigned int GC_CAC_ACC_SQ8_UPPER__UNUSED_0__SHIFT    = 0x00000008;
    constexpr unsigned int GC_CAC_CNTL__CAC_ENABLE__SHIFT           = 0x00000000;
    constexpr unsigned int GC_CAC_CNTL__UNUSED_0__SHIFT             = 0x0000001f;
    constexpr unsigned int GC_CAC_CTRL_2__UNUSED_0__SHIFT           = 0x00000002;
    constexpr unsigned int GC_CAC_SOFT_CTRL__UNUSED__SHIFT          = 0x00000001;
    constexpr unsigned int GC_CAC_WEIGHT_CP_1__UNUSED_0__SHIFT      = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_CU_0__WEIGHT_CU_SIG1__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_CU_1__WEIGHT_CU_SIG2__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_CU_1__WEIGHT_CU_SIG3__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_CU_2__WEIGHT_CU_SIG4__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_CU_2__WEIGHT_CU_SIG5__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_CU_3__WEIGHT_CU_SIG6__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_CU_3__WEIGHT_CU_SIG7__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_CU_4__WEIGHT_CU_SIG8__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_CU_4__WEIGHT_CU_SIG9__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_CU_5__WEIGHT_CU_SIG10__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_CU_5__WEIGHT_CU_SIG11__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_IA_0__UNUSED_0__SHIFT      = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_PC_0__UNUSED_0__SHIFT      = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_RMI_0__UNUSED__SHIFT       = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_SC_0__UNUSED_0__SHIFT      = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_SQ_4__UNUSED_0__SHIFT      = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_SXRB_0__WEIGHT_SXRB_SIG1__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_SX_0__UNUSED_0__SHIFT      = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_TA_0__UNUSED_0__SHIFT      = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ATCL2_2__WEIGHT_UTCL2_ATCL2_SIG5__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_UTCL2_VML2_2__WEIGHT_UTCL2_VML2_SIG5__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_UTCL2_WALKER_2__WEIGHT_UTCL2_WALKER_SIG5__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_VGT_1__UNUSED_0__SHIFT     = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_WD_0__UNUSED_0__SHIFT      = 0x00000010;
    constexpr unsigned int GC_DIDT_CTRL2__UNUSED_0__SHIFT           = 0x0000000e;
    constexpr unsigned int GC_DIDT_CTRL2__UNUSED_1__SHIFT           = 0x0000001a;
    constexpr unsigned int GC_DIDT_CTRL2__UNUSED_2__SHIFT           = 0x0000001f;
    constexpr unsigned int GC_EDC_CTRL__UNUSED_0__SHIFT             = 0x0000000a;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT1__PERFCOUNTER_SELECT2__SHIFT = 0x00000000;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT1__PERFCOUNTER_SELECT3__SHIFT = 0x0000000a;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT__PERFCOUNTER_SELECT1__SHIFT = 0x0000000a;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT__PERFCOUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int GDS_PERFCOUNTER1_SELECT__PERFCOUNTER_SELECT1__SHIFT = 0x0000000a;
    constexpr unsigned int GDS_PERFCOUNTER1_SELECT__PERFCOUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int GDS_PERFCOUNTER2_SELECT__PERFCOUNTER_SELECT1__SHIFT = 0x0000000a;
    constexpr unsigned int GDS_PERFCOUNTER2_SELECT__PERFCOUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int GDS_PERFCOUNTER3_SELECT__PERFCOUNTER_SELECT1__SHIFT = 0x0000000a;
    constexpr unsigned int GDS_PERFCOUNTER3_SELECT__PERFCOUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int PA_SC_ENHANCE_1__RSVD__SHIFT             = 0x00000017;
    constexpr unsigned int SX_DEBUG_1__PC_CFG__SHIFT                = 0x0000000d;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERFCOUNTER_SELECT2__SHIFT = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERFCOUNTER_SELECT3__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERFCOUNTER_SELECT1__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERFCOUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERFCOUNTER_SELECT2__SHIFT = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERFCOUNTER_SELECT3__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERFCOUNTER_SELECT1__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERFCOUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERFCOUNTER_SELECT1__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERFCOUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERFCOUNTER_SELECT1__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERFCOUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int TA_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int TA_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int TD_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int TD_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int WD_DEBUG_REG0__SPARE2__SHIFT             = 0x0000000c;
} // namespace Gfx09_0

namespace Gfx09_1x
{
    constexpr unsigned int DB_DEBUG2__DISABLE_VR_OBJ_PRIM_ID__SHIFT = 0x0000001a;
    constexpr unsigned int DB_DEBUG2__DISABLE_VR_PS_INVOKE__SHIFT   = 0x0000001b;
    constexpr unsigned int DB_DEBUG4__FULL_TILE_CACHE_EVICT_ON_HALF_FULL__SHIFT = 0x0000001f;
    constexpr unsigned int GC_DIDT_DROOP_CTRL1__DIDT_DROOP_DELTA_THRESHOLD__SHIFT = 0x00000001;
    constexpr unsigned int GC_DIDT_DROOP_CTRL1__DIDT_DROOP_LEVEL_RELEASE_EN__SHIFT = 0x00000000;
    constexpr unsigned int LDS_CONFIG__DISABLE_RAM_CLOCK_GATING__SHIFT = 0x00000002;
    constexpr unsigned int MC_SHARED_ACTIVE_FCN_ID__VFID__SHIFT     = 0x00000000;
    constexpr unsigned int MC_SHARED_ACTIVE_FCN_ID__VF__SHIFT       = 0x0000001f;
    constexpr unsigned int PA_SC_ENHANCE_1__RSVD__SHIFT             = 0x0000001f;
    constexpr unsigned int RLC_SPM_PERFMON_SAMPLE_DELAY_MAX__PERFMON_MAX_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_PERFMON_SAMPLE_DELAY_MAX__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int SPI_DEBUG_CNTL_2__SPI_SPARE__SHIFT       = 0x00000000;
    constexpr unsigned int SX_DEBUG_1__DISABLE_SX_DB_FGCG__SHIFT    = 0x0000000d;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT  = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT  = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT  = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT  = 0x00000000;
    constexpr unsigned int VGT_DEBUG_REG0__pg_busy__SHIFT           = 0x0000000b;
    constexpr unsigned int VGT_DEBUG_REG30__pg_busy__SHIFT          = 0x00000004;
    constexpr unsigned int VGT_DEBUG_REG30__pg_noif_busy__SHIFT     = 0x00000005;
    constexpr unsigned int VGT_DEBUG_REG30__pg_spi_interface_busy__SHIFT = 0x00000006;
    constexpr unsigned int VGT_DEBUG_REG30__pg_te_prim_fifo_busy__SHIFT = 0x00000007;
    constexpr unsigned int WD_DEBUG_REG0__wd_ngg_busy__SHIFT        = 0x0000000c;
    constexpr unsigned int WD_DEBUG_REG22__csbm_tcarb_tag__SHIFT    = 0x0000000f;
    constexpr unsigned int WD_DEBUG_REG22__eop_p3__SHIFT            = 0x0000001a;
    constexpr unsigned int WD_DEBUG_REG22__is_event_p3__SHIFT       = 0x00000019;
    constexpr unsigned int WD_DEBUG_REG22__null_p3__SHIFT           = 0x0000001b;
    constexpr unsigned int WD_DEBUG_REG22__state_id_p3__SHIFT       = 0x0000001c;
    constexpr unsigned int WD_DEBUG_REG22__wd_csbm_sm_gds_data__SHIFT = 0x0000000c;
    constexpr unsigned int WD_DEBUG_REG22__wd_csbm_sm_spi_grant_ordered_id__SHIFT = 0x00000000;
    constexpr unsigned int WD_DEBUG_REG22__wd_ngg_csbm_dma_busy__SHIFT = 0x0000000e;
    constexpr unsigned int WD_DEBUG_REG22__wd_ngg_csbm_no_dma_busy__SHIFT = 0x0000001f;
} // namespace Gfx09_1x

namespace Gfx09_1xPlus
{
    constexpr unsigned int CB_COLOR0_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR0_DCC_CONTROL__ENABLE_CONSTANT_ENCODE_REG_WRITE__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR1_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR1_DCC_CONTROL__ENABLE_CONSTANT_ENCODE_REG_WRITE__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR2_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR2_DCC_CONTROL__ENABLE_CONSTANT_ENCODE_REG_WRITE__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR3_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR3_DCC_CONTROL__ENABLE_CONSTANT_ENCODE_REG_WRITE__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR4_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR4_DCC_CONTROL__ENABLE_CONSTANT_ENCODE_REG_WRITE__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR5_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR5_DCC_CONTROL__ENABLE_CONSTANT_ENCODE_REG_WRITE__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR6_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR6_DCC_CONTROL__ENABLE_CONSTANT_ENCODE_REG_WRITE__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR7_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR7_DCC_CONTROL__ENABLE_CONSTANT_ENCODE_REG_WRITE__SHIFT = 0x00000013;
    constexpr unsigned int CB_DCC_CONFIG__DISABLE_CONSTANT_ENCODE__SHIFT = 0x00000007;
    constexpr unsigned int CB_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_AC01__SHIFT = 0x00000008;
    constexpr unsigned int CB_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG__SHIFT = 0x0000000a;
    constexpr unsigned int CB_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_SINGLE__SHIFT = 0x00000009;
    constexpr unsigned int CB_DCC_CONTROL__DISABLE_ELIMFC_SKIP_OF_AC01__SHIFT = 0x0000000c;
    constexpr unsigned int CB_DCC_CONTROL__DISABLE_ELIMFC_SKIP_OF_SINGLE__SHIFT = 0x0000000d;
    constexpr unsigned int CB_DCC_CONTROL__ENABLE_ELIMFC_SKIP_OF_REG__SHIFT = 0x0000000e;
    constexpr unsigned int COMPUTE_DISPATCH_END__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int COMPUTE_SHADER_CHKSUM__CHECKSUM__SHIFT   = 0x00000000;
    constexpr unsigned int GC_CAC_CTRL_2__GC_LCAC_ENABLE__SHIFT     = 0x00000002;
    constexpr unsigned int GC_CAC_CTRL_2__SE_LCAC_ENABLE__SHIFT     = 0x00000003;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GDS_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int GDS_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GDS_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int GDS_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GDS_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int GDS_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GDS_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int GDS_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GDS_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int GDS_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GDS_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int GDS_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GRBM_FENCE_RANGE0__END__SHIFT            = 0x00000010;
    constexpr unsigned int GRBM_FENCE_RANGE0__START__SHIFT          = 0x00000000;
    constexpr unsigned int GRBM_FENCE_RANGE1__END__SHIFT            = 0x00000010;
    constexpr unsigned int GRBM_FENCE_RANGE1__START__SHIFT          = 0x00000000;
    constexpr unsigned int PA_CL_CLIP_CNTL__ZCLIP_PROG_NEAR_ENA__SHIFT = 0x0000001c;
    constexpr unsigned int PA_CL_ENHANCE__NO_SWITCH_TO_LEGACY_AFTER_VMID_RESET__SHIFT = 0x00000013;
    constexpr unsigned int PA_CL_ENHANCE__OUTPUT_SWITCH_TO_LEGACY_EVENT__SHIFT = 0x00000012;
    constexpr unsigned int PA_CL_ENHANCE__POLY_INNER_EDGE_FLAG_DISABLE__SHIFT = 0x00000014;
    constexpr unsigned int PA_CL_ENHANCE__PROG_NEAR_CLIP_PLANE_ENABLE__SHIFT = 0x00000011;
    constexpr unsigned int PA_CL_ENHANCE__TC_REQUEST_PERF_CNTR_ENABLE__SHIFT = 0x00000015;
    constexpr unsigned int PA_CL_PROG_NEAR_CLIP_Z__DATA_REGISTER__SHIFT = 0x00000000;
    constexpr unsigned int PA_SC_BINNER_CNTL_0__FLUSH_ON_BINNING_TRANSITION__SHIFT = 0x0000001c;
    constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_INTF_CG__SHIFT  = 0x00000017;
    constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_QUAD_PROC_FDCE_ENHANCE__SHIFT = 0x0000001b;
    constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_PS_PA_ARBITER_FIX_1__SHIFT = 0x0000001d;
    constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_PS_PA_ARBITER_FIX__SHIFT = 0x0000001c;
    constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SHADER_PROFILING_FOR_POWER__SHIFT = 0x00000019;
    constexpr unsigned int PA_SC_ENHANCE_1__FLUSH_ON_BINNING_TRANSITION__SHIFT = 0x0000001a;
    constexpr unsigned int PA_SC_ENHANCE_1__IOO_DISABLE_EOP_ON_FIRST_LIVE_PRIM_HIT__SHIFT = 0x00000018;
    constexpr unsigned int PA_SC_ENHANCE_1__PASS_VPZ_EVENT_TO_SPI__SHIFT = 0x0000001e;
    constexpr unsigned int PA_SC_LINE_CNTL__EXTRA_DX_DY_PRECISION__SHIFT = 0x0000000d;
    constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__SC_1XMSAA_COMPATIBLE_DISABLE__SHIFT = 0x00000006;
    constexpr unsigned int RPB_RD_SWITCH_CNTL__WEIGHT_ADJUST_STEP__SHIFT = 0x0000001e;
    constexpr unsigned int RPB_RD_SWITCH_CNTL__WORKLOAD_ADJUST_EN__SHIFT = 0x0000001d;
    constexpr unsigned int RPB_WR_SWITCH_CNTL__WEIGHT_ADJUST_STEP__SHIFT = 0x0000001e;
    constexpr unsigned int RPB_WR_SWITCH_CNTL__WORKLOAD_ADJUST_EN__SHIFT = 0x0000001d;
    constexpr unsigned int SPI_WAVE_LIMIT_CNTL__GS_WAVE_GRAN__SHIFT = 0x00000004;
    constexpr unsigned int SPI_WAVE_LIMIT_CNTL__HS_WAVE_GRAN__SHIFT = 0x00000006;
    constexpr unsigned int SPI_WAVE_LIMIT_CNTL__PS_WAVE_GRAN__SHIFT = 0x00000000;
    constexpr unsigned int SPI_WAVE_LIMIT_CNTL__VS_WAVE_GRAN__SHIFT = 0x00000002;
} // namespace Gfx09_1xPlus

namespace Gfx10
{
    constexpr unsigned int CB_CACHE_EVICT_POINTS__CC_CACHE_EVICT_POINT__SHIFT = 0x00000018;
    constexpr unsigned int CB_CACHE_EVICT_POINTS__CM_CACHE_EVICT_POINT__SHIFT = 0x00000000;
    constexpr unsigned int CB_CACHE_EVICT_POINTS__DCC_CACHE_EVICT_POINT__SHIFT = 0x00000010;
    constexpr unsigned int CB_CACHE_EVICT_POINTS__FC_CACHE_EVICT_POINT__SHIFT = 0x00000008;
    constexpr unsigned int CB_COLOR0_ATTRIB3__COLOR_SW_MODE__SHIFT  = 0x0000000e;
    constexpr unsigned int CB_COLOR0_ATTRIB3__FMASK_SW_MODE__SHIFT  = 0x00000013;
    constexpr unsigned int CB_COLOR0_ATTRIB3__META_LINEAR__SHIFT    = 0x0000000d;
    constexpr unsigned int CB_COLOR0_ATTRIB3__MIP0_DEPTH__SHIFT     = 0x00000000;
    constexpr unsigned int CB_COLOR0_ATTRIB3__RESOURCE_LEVEL__SHIFT = 0x0000001b;
    constexpr unsigned int CB_COLOR0_ATTRIB3__RESOURCE_TYPE__SHIFT  = 0x00000018;
    constexpr unsigned int CB_COLOR0_ATTRIB__DISABLE_FMASK_NOFETCH_OPT__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR0_ATTRIB__FMASK_BANK_HEIGHT__SHIFT = 0x0000000a;
    constexpr unsigned int CB_COLOR0_ATTRIB__FMASK_TILE_MODE_INDEX__SHIFT = 0x00000005;
    constexpr unsigned int CB_COLOR0_ATTRIB__LIMIT_COLOR_FETCH_TO_256B_MAX__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR0_ATTRIB__TILE_MODE_INDEX__SHIFT = 0x00000000;
    constexpr unsigned int CB_COLOR0_CMASK_SLICE__TILE_MAX__SHIFT   = 0x00000000;
    constexpr unsigned int CB_COLOR0_DCC_CONTROL__INDEPENDENT_128B_BLOCKS__SHIFT = 0x00000014;
    constexpr unsigned int CB_COLOR0_FMASK_SLICE__TILE_MAX__SHIFT   = 0x00000000;
    constexpr unsigned int CB_COLOR0_INFO__CMASK_IS_LINEAR__SHIFT   = 0x00000013;
    constexpr unsigned int CB_COLOR0_INFO__LINEAR_GENERAL__SHIFT    = 0x00000007;
    constexpr unsigned int CB_COLOR0_PITCH__FMASK_TILE_MAX__SHIFT   = 0x00000014;
    constexpr unsigned int CB_COLOR0_PITCH__TILE_MAX__SHIFT         = 0x00000000;
    constexpr unsigned int CB_COLOR0_SLICE__TILE_MAX__SHIFT         = 0x00000000;
    constexpr unsigned int CB_COLOR0_VIEW__MIP_LEVEL__SHIFT         = 0x0000001a;
    constexpr unsigned int CB_COLOR1_ATTRIB3__COLOR_SW_MODE__SHIFT  = 0x0000000e;
    constexpr unsigned int CB_COLOR1_ATTRIB3__FMASK_SW_MODE__SHIFT  = 0x00000013;
    constexpr unsigned int CB_COLOR1_ATTRIB3__META_LINEAR__SHIFT    = 0x0000000d;
    constexpr unsigned int CB_COLOR1_ATTRIB3__MIP0_DEPTH__SHIFT     = 0x00000000;
    constexpr unsigned int CB_COLOR1_ATTRIB3__RESOURCE_LEVEL__SHIFT = 0x0000001b;
    constexpr unsigned int CB_COLOR1_ATTRIB3__RESOURCE_TYPE__SHIFT  = 0x00000018;
    constexpr unsigned int CB_COLOR1_ATTRIB__DISABLE_FMASK_NOFETCH_OPT__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR1_ATTRIB__FMASK_BANK_HEIGHT__SHIFT = 0x0000000a;
    constexpr unsigned int CB_COLOR1_ATTRIB__FMASK_TILE_MODE_INDEX__SHIFT = 0x00000005;
    constexpr unsigned int CB_COLOR1_ATTRIB__LIMIT_COLOR_FETCH_TO_256B_MAX__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR1_ATTRIB__TILE_MODE_INDEX__SHIFT = 0x00000000;
    constexpr unsigned int CB_COLOR1_CMASK_SLICE__TILE_MAX__SHIFT   = 0x00000000;
    constexpr unsigned int CB_COLOR1_DCC_CONTROL__INDEPENDENT_128B_BLOCKS__SHIFT = 0x00000014;
    constexpr unsigned int CB_COLOR1_FMASK_SLICE__TILE_MAX__SHIFT   = 0x00000000;
    constexpr unsigned int CB_COLOR1_INFO__CMASK_IS_LINEAR__SHIFT   = 0x00000013;
    constexpr unsigned int CB_COLOR1_INFO__LINEAR_GENERAL__SHIFT    = 0x00000007;
    constexpr unsigned int CB_COLOR1_PITCH__FMASK_TILE_MAX__SHIFT   = 0x00000014;
    constexpr unsigned int CB_COLOR1_PITCH__TILE_MAX__SHIFT         = 0x00000000;
    constexpr unsigned int CB_COLOR1_SLICE__TILE_MAX__SHIFT         = 0x00000000;
    constexpr unsigned int CB_COLOR1_VIEW__MIP_LEVEL__SHIFT         = 0x0000001a;
    constexpr unsigned int CB_COLOR2_ATTRIB3__COLOR_SW_MODE__SHIFT  = 0x0000000e;
    constexpr unsigned int CB_COLOR2_ATTRIB3__FMASK_SW_MODE__SHIFT  = 0x00000013;
    constexpr unsigned int CB_COLOR2_ATTRIB3__META_LINEAR__SHIFT    = 0x0000000d;
    constexpr unsigned int CB_COLOR2_ATTRIB3__MIP0_DEPTH__SHIFT     = 0x00000000;
    constexpr unsigned int CB_COLOR2_ATTRIB3__RESOURCE_LEVEL__SHIFT = 0x0000001b;
    constexpr unsigned int CB_COLOR2_ATTRIB3__RESOURCE_TYPE__SHIFT  = 0x00000018;
    constexpr unsigned int CB_COLOR2_ATTRIB__DISABLE_FMASK_NOFETCH_OPT__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR2_ATTRIB__FMASK_BANK_HEIGHT__SHIFT = 0x0000000a;
    constexpr unsigned int CB_COLOR2_ATTRIB__FMASK_TILE_MODE_INDEX__SHIFT = 0x00000005;
    constexpr unsigned int CB_COLOR2_ATTRIB__LIMIT_COLOR_FETCH_TO_256B_MAX__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR2_ATTRIB__TILE_MODE_INDEX__SHIFT = 0x00000000;
    constexpr unsigned int CB_COLOR2_CMASK_SLICE__TILE_MAX__SHIFT   = 0x00000000;
    constexpr unsigned int CB_COLOR2_DCC_CONTROL__INDEPENDENT_128B_BLOCKS__SHIFT = 0x00000014;
    constexpr unsigned int CB_COLOR2_FMASK_SLICE__TILE_MAX__SHIFT   = 0x00000000;
    constexpr unsigned int CB_COLOR2_INFO__CMASK_IS_LINEAR__SHIFT   = 0x00000013;
    constexpr unsigned int CB_COLOR2_INFO__LINEAR_GENERAL__SHIFT    = 0x00000007;
    constexpr unsigned int CB_COLOR2_PITCH__FMASK_TILE_MAX__SHIFT   = 0x00000014;
    constexpr unsigned int CB_COLOR2_PITCH__TILE_MAX__SHIFT         = 0x00000000;
    constexpr unsigned int CB_COLOR2_SLICE__TILE_MAX__SHIFT         = 0x00000000;
    constexpr unsigned int CB_COLOR2_VIEW__MIP_LEVEL__SHIFT         = 0x0000001a;
    constexpr unsigned int CB_COLOR3_ATTRIB3__COLOR_SW_MODE__SHIFT  = 0x0000000e;
    constexpr unsigned int CB_COLOR3_ATTRIB3__FMASK_SW_MODE__SHIFT  = 0x00000013;
    constexpr unsigned int CB_COLOR3_ATTRIB3__META_LINEAR__SHIFT    = 0x0000000d;
    constexpr unsigned int CB_COLOR3_ATTRIB3__MIP0_DEPTH__SHIFT     = 0x00000000;
    constexpr unsigned int CB_COLOR3_ATTRIB3__RESOURCE_LEVEL__SHIFT = 0x0000001b;
    constexpr unsigned int CB_COLOR3_ATTRIB3__RESOURCE_TYPE__SHIFT  = 0x00000018;
    constexpr unsigned int CB_COLOR3_ATTRIB__DISABLE_FMASK_NOFETCH_OPT__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR3_ATTRIB__FMASK_BANK_HEIGHT__SHIFT = 0x0000000a;
    constexpr unsigned int CB_COLOR3_ATTRIB__FMASK_TILE_MODE_INDEX__SHIFT = 0x00000005;
    constexpr unsigned int CB_COLOR3_ATTRIB__LIMIT_COLOR_FETCH_TO_256B_MAX__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR3_ATTRIB__TILE_MODE_INDEX__SHIFT = 0x00000000;
    constexpr unsigned int CB_COLOR3_CMASK_SLICE__TILE_MAX__SHIFT   = 0x00000000;
    constexpr unsigned int CB_COLOR3_DCC_CONTROL__INDEPENDENT_128B_BLOCKS__SHIFT = 0x00000014;
    constexpr unsigned int CB_COLOR3_FMASK_SLICE__TILE_MAX__SHIFT   = 0x00000000;
    constexpr unsigned int CB_COLOR3_INFO__CMASK_IS_LINEAR__SHIFT   = 0x00000013;
    constexpr unsigned int CB_COLOR3_INFO__LINEAR_GENERAL__SHIFT    = 0x00000007;
    constexpr unsigned int CB_COLOR3_PITCH__FMASK_TILE_MAX__SHIFT   = 0x00000014;
    constexpr unsigned int CB_COLOR3_PITCH__TILE_MAX__SHIFT         = 0x00000000;
    constexpr unsigned int CB_COLOR3_SLICE__TILE_MAX__SHIFT         = 0x00000000;
    constexpr unsigned int CB_COLOR3_VIEW__MIP_LEVEL__SHIFT         = 0x0000001a;
    constexpr unsigned int CB_COLOR4_ATTRIB3__COLOR_SW_MODE__SHIFT  = 0x0000000e;
    constexpr unsigned int CB_COLOR4_ATTRIB3__FMASK_SW_MODE__SHIFT  = 0x00000013;
    constexpr unsigned int CB_COLOR4_ATTRIB3__META_LINEAR__SHIFT    = 0x0000000d;
    constexpr unsigned int CB_COLOR4_ATTRIB3__MIP0_DEPTH__SHIFT     = 0x00000000;
    constexpr unsigned int CB_COLOR4_ATTRIB3__RESOURCE_LEVEL__SHIFT = 0x0000001b;
    constexpr unsigned int CB_COLOR4_ATTRIB3__RESOURCE_TYPE__SHIFT  = 0x00000018;
    constexpr unsigned int CB_COLOR4_ATTRIB__DISABLE_FMASK_NOFETCH_OPT__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR4_ATTRIB__FMASK_BANK_HEIGHT__SHIFT = 0x0000000a;
    constexpr unsigned int CB_COLOR4_ATTRIB__FMASK_TILE_MODE_INDEX__SHIFT = 0x00000005;
    constexpr unsigned int CB_COLOR4_ATTRIB__LIMIT_COLOR_FETCH_TO_256B_MAX__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR4_ATTRIB__TILE_MODE_INDEX__SHIFT = 0x00000000;
    constexpr unsigned int CB_COLOR4_CMASK_SLICE__TILE_MAX__SHIFT   = 0x00000000;
    constexpr unsigned int CB_COLOR4_DCC_CONTROL__INDEPENDENT_128B_BLOCKS__SHIFT = 0x00000014;
    constexpr unsigned int CB_COLOR4_FMASK_SLICE__TILE_MAX__SHIFT   = 0x00000000;
    constexpr unsigned int CB_COLOR4_INFO__CMASK_IS_LINEAR__SHIFT   = 0x00000013;
    constexpr unsigned int CB_COLOR4_INFO__LINEAR_GENERAL__SHIFT    = 0x00000007;
    constexpr unsigned int CB_COLOR4_PITCH__FMASK_TILE_MAX__SHIFT   = 0x00000014;
    constexpr unsigned int CB_COLOR4_PITCH__TILE_MAX__SHIFT         = 0x00000000;
    constexpr unsigned int CB_COLOR4_SLICE__TILE_MAX__SHIFT         = 0x00000000;
    constexpr unsigned int CB_COLOR4_VIEW__MIP_LEVEL__SHIFT         = 0x0000001a;
    constexpr unsigned int CB_COLOR5_ATTRIB3__COLOR_SW_MODE__SHIFT  = 0x0000000e;
    constexpr unsigned int CB_COLOR5_ATTRIB3__FMASK_SW_MODE__SHIFT  = 0x00000013;
    constexpr unsigned int CB_COLOR5_ATTRIB3__META_LINEAR__SHIFT    = 0x0000000d;
    constexpr unsigned int CB_COLOR5_ATTRIB3__MIP0_DEPTH__SHIFT     = 0x00000000;
    constexpr unsigned int CB_COLOR5_ATTRIB3__RESOURCE_LEVEL__SHIFT = 0x0000001b;
    constexpr unsigned int CB_COLOR5_ATTRIB3__RESOURCE_TYPE__SHIFT  = 0x00000018;
    constexpr unsigned int CB_COLOR5_ATTRIB__DISABLE_FMASK_NOFETCH_OPT__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR5_ATTRIB__FMASK_BANK_HEIGHT__SHIFT = 0x0000000a;
    constexpr unsigned int CB_COLOR5_ATTRIB__FMASK_TILE_MODE_INDEX__SHIFT = 0x00000005;
    constexpr unsigned int CB_COLOR5_ATTRIB__LIMIT_COLOR_FETCH_TO_256B_MAX__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR5_ATTRIB__TILE_MODE_INDEX__SHIFT = 0x00000000;
    constexpr unsigned int CB_COLOR5_CMASK_SLICE__TILE_MAX__SHIFT   = 0x00000000;
    constexpr unsigned int CB_COLOR5_DCC_CONTROL__INDEPENDENT_128B_BLOCKS__SHIFT = 0x00000014;
    constexpr unsigned int CB_COLOR5_FMASK_SLICE__TILE_MAX__SHIFT   = 0x00000000;
    constexpr unsigned int CB_COLOR5_INFO__CMASK_IS_LINEAR__SHIFT   = 0x00000013;
    constexpr unsigned int CB_COLOR5_INFO__LINEAR_GENERAL__SHIFT    = 0x00000007;
    constexpr unsigned int CB_COLOR5_PITCH__FMASK_TILE_MAX__SHIFT   = 0x00000014;
    constexpr unsigned int CB_COLOR5_PITCH__TILE_MAX__SHIFT         = 0x00000000;
    constexpr unsigned int CB_COLOR5_SLICE__TILE_MAX__SHIFT         = 0x00000000;
    constexpr unsigned int CB_COLOR5_VIEW__MIP_LEVEL__SHIFT         = 0x0000001a;
    constexpr unsigned int CB_COLOR6_ATTRIB3__COLOR_SW_MODE__SHIFT  = 0x0000000e;
    constexpr unsigned int CB_COLOR6_ATTRIB3__FMASK_SW_MODE__SHIFT  = 0x00000013;
    constexpr unsigned int CB_COLOR6_ATTRIB3__META_LINEAR__SHIFT    = 0x0000000d;
    constexpr unsigned int CB_COLOR6_ATTRIB3__MIP0_DEPTH__SHIFT     = 0x00000000;
    constexpr unsigned int CB_COLOR6_ATTRIB3__RESOURCE_LEVEL__SHIFT = 0x0000001b;
    constexpr unsigned int CB_COLOR6_ATTRIB3__RESOURCE_TYPE__SHIFT  = 0x00000018;
    constexpr unsigned int CB_COLOR6_ATTRIB__DISABLE_FMASK_NOFETCH_OPT__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR6_ATTRIB__FMASK_BANK_HEIGHT__SHIFT = 0x0000000a;
    constexpr unsigned int CB_COLOR6_ATTRIB__FMASK_TILE_MODE_INDEX__SHIFT = 0x00000005;
    constexpr unsigned int CB_COLOR6_ATTRIB__LIMIT_COLOR_FETCH_TO_256B_MAX__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR6_ATTRIB__TILE_MODE_INDEX__SHIFT = 0x00000000;
    constexpr unsigned int CB_COLOR6_CMASK_SLICE__TILE_MAX__SHIFT   = 0x00000000;
    constexpr unsigned int CB_COLOR6_DCC_CONTROL__INDEPENDENT_128B_BLOCKS__SHIFT = 0x00000014;
    constexpr unsigned int CB_COLOR6_FMASK_SLICE__TILE_MAX__SHIFT   = 0x00000000;
    constexpr unsigned int CB_COLOR6_INFO__CMASK_IS_LINEAR__SHIFT   = 0x00000013;
    constexpr unsigned int CB_COLOR6_INFO__LINEAR_GENERAL__SHIFT    = 0x00000007;
    constexpr unsigned int CB_COLOR6_PITCH__FMASK_TILE_MAX__SHIFT   = 0x00000014;
    constexpr unsigned int CB_COLOR6_PITCH__TILE_MAX__SHIFT         = 0x00000000;
    constexpr unsigned int CB_COLOR6_SLICE__TILE_MAX__SHIFT         = 0x00000000;
    constexpr unsigned int CB_COLOR6_VIEW__MIP_LEVEL__SHIFT         = 0x0000001a;
    constexpr unsigned int CB_COLOR7_ATTRIB3__COLOR_SW_MODE__SHIFT  = 0x0000000e;
    constexpr unsigned int CB_COLOR7_ATTRIB3__FMASK_SW_MODE__SHIFT  = 0x00000013;
    constexpr unsigned int CB_COLOR7_ATTRIB3__META_LINEAR__SHIFT    = 0x0000000d;
    constexpr unsigned int CB_COLOR7_ATTRIB3__MIP0_DEPTH__SHIFT     = 0x00000000;
    constexpr unsigned int CB_COLOR7_ATTRIB3__RESOURCE_LEVEL__SHIFT = 0x0000001b;
    constexpr unsigned int CB_COLOR7_ATTRIB3__RESOURCE_TYPE__SHIFT  = 0x00000018;
    constexpr unsigned int CB_COLOR7_ATTRIB__DISABLE_FMASK_NOFETCH_OPT__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR7_ATTRIB__FMASK_BANK_HEIGHT__SHIFT = 0x0000000a;
    constexpr unsigned int CB_COLOR7_ATTRIB__FMASK_TILE_MODE_INDEX__SHIFT = 0x00000005;
    constexpr unsigned int CB_COLOR7_ATTRIB__LIMIT_COLOR_FETCH_TO_256B_MAX__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR7_ATTRIB__TILE_MODE_INDEX__SHIFT = 0x00000000;
    constexpr unsigned int CB_COLOR7_CMASK_SLICE__TILE_MAX__SHIFT   = 0x00000000;
    constexpr unsigned int CB_COLOR7_DCC_CONTROL__INDEPENDENT_128B_BLOCKS__SHIFT = 0x00000014;
    constexpr unsigned int CB_COLOR7_FMASK_SLICE__TILE_MAX__SHIFT   = 0x00000000;
    constexpr unsigned int CB_COLOR7_INFO__CMASK_IS_LINEAR__SHIFT   = 0x00000013;
    constexpr unsigned int CB_COLOR7_INFO__LINEAR_GENERAL__SHIFT    = 0x00000007;
    constexpr unsigned int CB_COLOR7_PITCH__FMASK_TILE_MAX__SHIFT   = 0x00000014;
    constexpr unsigned int CB_COLOR7_PITCH__TILE_MAX__SHIFT         = 0x00000000;
    constexpr unsigned int CB_COLOR7_SLICE__TILE_MAX__SHIFT         = 0x00000000;
    constexpr unsigned int CB_COLOR7_VIEW__MIP_LEVEL__SHIFT         = 0x0000001a;
    constexpr unsigned int CB_COVERAGE_OUT_CONTROL__COVERAGE_OUT_CHANNEL__SHIFT = 0x00000004;
    constexpr unsigned int CB_COVERAGE_OUT_CONTROL__COVERAGE_OUT_ENABLE__SHIFT = 0x00000000;
    constexpr unsigned int CB_COVERAGE_OUT_CONTROL__COVERAGE_OUT_MRT__SHIFT = 0x00000001;
    constexpr unsigned int CB_COVERAGE_OUT_CONTROL__COVERAGE_OUT_SAMPLES__SHIFT = 0x00000008;
    constexpr unsigned int CB_HW_CONTROL_2__CHICKEN_BITS__SHIFT     = 0x0000001e;
    constexpr unsigned int CB_HW_CONTROL_3__DISABLE_FMASK_NOFETCH_OPT_BC__SHIFT = 0x0000001f;
    constexpr unsigned int CB_HW_CONTROL_3__DISABLE_FMASK_NOFETCH_OPT__SHIFT = 0x0000001e;
    constexpr unsigned int CB_HW_CONTROL_4__COLOR_CACHE_FETCH_NUM_CLS_LOG2__SHIFT = 0x00000000;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_BC_COLOR_CACHE_PREFETCH__SHIFT = 0x0000000e;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_CMASK_CLOCK_GATING__SHIFT = 0x00000006;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_COLOR_CLOCK_GATING__SHIFT = 0x00000008;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_FMASK_CLOCK_GATING__SHIFT = 0x00000007;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_KEYXFR_HIT_RETURNS__SHIFT = 0x0000000d;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_MA_WAIT_FOR_LAST__SHIFT = 0x0000000f;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_QSB_AA_MODE__SHIFT = 0x00000009;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_QSB_FRAG_GT0__SHIFT = 0x0000000b;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_QSB_SPECULATIVE__SHIFT = 0x00000010;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_QSB_WAIT_FOR_SCORE__SHIFT = 0x0000000a;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_USE_OF_QUAD_SCOREBOARD__SHIFT = 0x00000005;
    constexpr unsigned int CB_HW_CONTROL_4__FC_QSB_FIFO_DEPTH__SHIFT = 0x00000018;
    constexpr unsigned int CB_HW_CONTROL_4__FMASK_CACHE_FETCH_NUM_CLS_LOG2__SHIFT = 0x00000003;
    constexpr unsigned int CB_HW_CONTROL_4__QSB_WAIT_FOR_SCORE__SHIFT = 0x00000011;
    constexpr unsigned int CB_HW_CONTROL_4__REVERSE_KEYXFR_RD_PRIORITY__SHIFT = 0x0000000c;
    constexpr unsigned int CB_HW_CONTROL__ALLOW_MRT_WITH_DUAL_SOURCE__SHIFT = 0x00000000;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__CMASK_RD_POLICY__SHIFT = 0x00000010;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__CMASK_WR_POLICY__SHIFT = 0x00000000;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__COLOR_RD_POLICY__SHIFT = 0x00000016;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__COLOR_WR_POLICY__SHIFT = 0x00000006;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__DCC_RD_POLICY__SHIFT = 0x00000014;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__DCC_WR_POLICY__SHIFT = 0x00000004;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__FMASK_RD_POLICY__SHIFT = 0x00000012;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__FMASK_WR_POLICY__SHIFT = 0x00000002;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__VOLAT__SHIFT = 0x0000001f;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__CMASK_RD_POLICY__SHIFT = 0x00000010;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__CMASK_WR_POLICY__SHIFT = 0x00000000;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__COLOR_RD_POLICY__SHIFT = 0x00000016;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__COLOR_WR_POLICY__SHIFT = 0x00000006;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__DCC_RD_POLICY__SHIFT = 0x00000014;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__DCC_WR_POLICY__SHIFT = 0x00000004;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__FMASK_RD_POLICY__SHIFT = 0x00000012;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__FMASK_WR_POLICY__SHIFT = 0x00000002;
    constexpr unsigned int CB_STUTTER_CONTROL_CMASK_RDLAT__THRESHOLD__SHIFT = 0x00000000;
    constexpr unsigned int CB_STUTTER_CONTROL_CMASK_RDLAT__TIMEOUT__SHIFT = 0x00000008;
    constexpr unsigned int CB_STUTTER_CONTROL_COLOR_RDLAT__THRESHOLD__SHIFT = 0x00000000;
    constexpr unsigned int CB_STUTTER_CONTROL_COLOR_RDLAT__TIMEOUT__SHIFT = 0x00000008;
    constexpr unsigned int CB_STUTTER_CONTROL_FMASK_RDLAT__THRESHOLD__SHIFT = 0x00000000;
    constexpr unsigned int CB_STUTTER_CONTROL_FMASK_RDLAT__TIMEOUT__SHIFT = 0x00000008;
    constexpr unsigned int CC_RMI_REDUNDANCY__REPAIR_EN_IN_0__SHIFT = 0x00000001;
    constexpr unsigned int CC_RMI_REDUNDANCY__REPAIR_EN_IN_1__SHIFT = 0x00000002;
    constexpr unsigned int CC_RMI_REDUNDANCY__REPAIR_ID_SWAP__SHIFT = 0x00000004;
    constexpr unsigned int CC_RMI_REDUNDANCY__REPAIR_RMI_OVERRIDE__SHIFT = 0x00000003;
    constexpr unsigned int CHA_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int CHA_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x00000018;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x0000001c;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int CHA_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int CHA_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int CHA_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int CHA_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int CHA_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int CHA_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int CHA_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int CHA_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int CHA_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int CHA_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int CHA_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int CHA_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int CHA_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int CHA_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int CHA_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x00000018;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x0000001c;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int CHC_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int CHC_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int CHC_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int CHC_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int CHC_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int CHC_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int CH_ARB_CTRL__NUM_MEM_PIPES__SHIFT        = 0x00000000;
    constexpr unsigned int CH_ARB_STATUS__REQ_ARB_BUSY__SHIFT       = 0x00000000;
    constexpr unsigned int CH_ARB_STATUS__RET_ARB_BUSY__SHIFT       = 0x00000001;
    constexpr unsigned int CH_DRAM_BURST_CTRL__BURST_DISABLE__SHIFT = 0x00000003;
    constexpr unsigned int CH_DRAM_BURST_CTRL__GATHER_64B_IO_BURST_DISABLE__SHIFT = 0x00000005;
    constexpr unsigned int CH_DRAM_BURST_CTRL__GATHER_64B_MEMORY_BURST_DISABLE__SHIFT = 0x00000004;
    constexpr unsigned int CH_DRAM_BURST_CTRL__MAX_DRAM_BURST__SHIFT = 0x00000000;
    constexpr unsigned int CH_DRAM_BURST_MASK__DRAM_BURST_ADDR_MASK__SHIFT = 0x00000000;
    constexpr unsigned int CH_PIPE_STEER__PIPE0__SHIFT              = 0x00000000;
    constexpr unsigned int CH_PIPE_STEER__PIPE1__SHIFT              = 0x00000002;
    constexpr unsigned int CH_PIPE_STEER__PIPE2__SHIFT              = 0x00000004;
    constexpr unsigned int CH_PIPE_STEER__PIPE3__SHIFT              = 0x00000006;
    constexpr unsigned int COMPUTE_DDID_INDEX__INDEX__SHIFT         = 0x00000000;
    constexpr unsigned int COMPUTE_DESTINATION_EN_SE0__CU_EN__SHIFT = 0x00000000;
    constexpr unsigned int COMPUTE_DESTINATION_EN_SE1__CU_EN__SHIFT = 0x00000000;
    constexpr unsigned int COMPUTE_DESTINATION_EN_SE2__CU_EN__SHIFT = 0x00000000;
    constexpr unsigned int COMPUTE_DESTINATION_EN_SE3__CU_EN__SHIFT = 0x00000000;
    constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__CS_W32_EN__SHIFT = 0x0000000f;
    constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__TUNNEL_ENABLE__SHIFT = 0x0000000d;
    constexpr unsigned int COMPUTE_DISPATCH_TUNNEL__IMMEDIATE__SHIFT = 0x0000000a;
    constexpr unsigned int COMPUTE_DISPATCH_TUNNEL__OFF_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int COMPUTE_PGM_RSRC1__FWD_PROGRESS__SHIFT   = 0x0000001f;
    constexpr unsigned int COMPUTE_PGM_RSRC1__MEM_ORDERED__SHIFT    = 0x0000001e;
    constexpr unsigned int COMPUTE_PGM_RSRC1__WGP_MODE__SHIFT       = 0x0000001d;
    constexpr unsigned int COMPUTE_PGM_RSRC3__SHARED_VGPR_CNT__SHIFT = 0x00000000;
    constexpr unsigned int COMPUTE_REQ_CTRL__ALLOCATION_RATE_THROTTLING_THRESHOLD__SHIFT = 0x00000011;
    constexpr unsigned int COMPUTE_REQ_CTRL__DEDICATED_PREALLOCATION_BUFFER_LIMIT__SHIFT = 0x00000014;
    constexpr unsigned int COMPUTE_REQ_CTRL__GLOBAL_SCANNING_EN__SHIFT = 0x00000010;
    constexpr unsigned int COMPUTE_REQ_CTRL__HARD_LOCK_HYSTERESIS__SHIFT = 0x00000009;
    constexpr unsigned int COMPUTE_REQ_CTRL__HARD_LOCK_LOW_THRESHOLD__SHIFT = 0x0000000a;
    constexpr unsigned int COMPUTE_REQ_CTRL__NUMBER_OF_REQUESTS_PER_CU__SHIFT = 0x00000001;
    constexpr unsigned int COMPUTE_REQ_CTRL__PRODUCER_REQUEST_LOCKOUT__SHIFT = 0x0000000f;
    constexpr unsigned int COMPUTE_REQ_CTRL__SOFT_GROUPING_ALLOCATION_TIMEOUT__SHIFT = 0x00000005;
    constexpr unsigned int COMPUTE_REQ_CTRL__SOFT_GROUPING_EN__SHIFT = 0x00000000;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE0__SA0_CU_EN__SHIFT = 0x00000000;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE0__SA1_CU_EN__SHIFT = 0x00000010;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE1__SA0_CU_EN__SHIFT = 0x00000000;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE1__SA1_CU_EN__SHIFT = 0x00000010;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE2__SA0_CU_EN__SHIFT = 0x00000000;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE2__SA1_CU_EN__SHIFT = 0x00000010;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE3__SA0_CU_EN__SHIFT = 0x00000000;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE3__SA1_CU_EN__SHIFT = 0x00000010;
    constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int CPC_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int CPC_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int CPC_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int CPC_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int CPF_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int CPF_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int CPF_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int CPF_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int CPG_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int CPG_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int CPG_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int CPG_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int CP_APPEND_CMD_ADDR_HI__ADDR_HI__SHIFT    = 0x00000000;
    constexpr unsigned int CP_APPEND_CMD_ADDR_HI__RSVD__SHIFT       = 0x00000010;
    constexpr unsigned int CP_APPEND_CMD_ADDR_LO__ADDR_LO__SHIFT    = 0x00000002;
    constexpr unsigned int CP_APPEND_CMD_ADDR_LO__RSVD__SHIFT       = 0x00000000;
    constexpr unsigned int CP_APPEND_DATA__DATA__SHIFT              = 0x00000000;
    constexpr unsigned int CP_APPEND_DDID_CNT__DATA__SHIFT          = 0x00000000;
    constexpr unsigned int CP_APPEND_LAST_CS_FENCE__LAST_FENCE__SHIFT = 0x00000000;
    constexpr unsigned int CP_APPEND_LAST_PS_FENCE__LAST_FENCE__SHIFT = 0x00000000;
    constexpr unsigned int CP_CEQ2_AVAIL__CEQ_CNT_DB__SHIFT         = 0x00000010;
    constexpr unsigned int CP_CE_CS_PARTITION_INDEX__CS1_INDEX__SHIFT = 0x00000000;
    constexpr unsigned int CP_CE_DB_BASE_HI__DB_BASE_HI__SHIFT      = 0x00000000;
    constexpr unsigned int CP_CE_DB_BASE_LO__DB_BASE_LO__SHIFT      = 0x00000002;
    constexpr unsigned int CP_CE_DB_BUFSZ__DB_BUFSZ__SHIFT          = 0x00000000;
    constexpr unsigned int CP_CE_DB_CMD_BUFSZ__DB_CMD_REQSZ__SHIFT  = 0x00000000;
    constexpr unsigned int CP_CE_IC_BASE_CNTL__ADDRESS_CLAMP__SHIFT = 0x00000004;
    constexpr unsigned int CP_CE_IC_BASE_CNTL__CACHE_POLICY__SHIFT  = 0x00000018;
    constexpr unsigned int CP_CE_IC_BASE_CNTL__EXE_DISABLE__SHIFT   = 0x00000017;
    constexpr unsigned int CP_CE_IC_BASE_CNTL__VMID__SHIFT          = 0x00000000;
    constexpr unsigned int CP_CE_IC_BASE_HI__IC_BASE_HI__SHIFT      = 0x00000000;
    constexpr unsigned int CP_CE_IC_BASE_LO__IC_BASE_LO__SHIFT      = 0x0000000c;
    constexpr unsigned int CP_CE_IC_OP_CNTL__ICACHE_PRIMED__SHIFT   = 0x00000005;
    constexpr unsigned int CP_CE_IC_OP_CNTL__INVALIDATE_CACHE_COMPLETE__SHIFT = 0x00000001;
    constexpr unsigned int CP_CE_IC_OP_CNTL__INVALIDATE_CACHE__SHIFT = 0x00000000;
    constexpr unsigned int CP_CE_IC_OP_CNTL__PRIME_ICACHE__SHIFT    = 0x00000004;
    constexpr unsigned int CP_CE_ROQ_DB_STAT__CEQ_RPTR_DB__SHIFT    = 0x00000000;
    constexpr unsigned int CP_CE_ROQ_DB_STAT__CEQ_WPTR_DB__SHIFT    = 0x00000010;
    constexpr unsigned int CP_CONTEXT_CNTL__ME0PIPE0_MAX_GE_CNTX__SHIFT = 0x00000000;
    constexpr unsigned int CP_CONTEXT_CNTL__ME0PIPE1_MAX_GE_CNTX__SHIFT = 0x00000010;
    constexpr unsigned int CP_DB_BASE_HI__DB_BASE_HI__SHIFT         = 0x00000000;
    constexpr unsigned int CP_DB_BASE_LO__DB_BASE_LO__SHIFT         = 0x00000002;
    constexpr unsigned int CP_DB_BUFSZ__DB_BUFSZ__SHIFT             = 0x00000000;
    constexpr unsigned int CP_DB_CMD_BUFSZ__DB_CMD_REQSZ__SHIFT     = 0x00000000;
    constexpr unsigned int CP_DDID_BASE_ADDR_HI__BASE_ADDR_HI__SHIFT = 0x00000000;
    constexpr unsigned int CP_DDID_BASE_ADDR_LO__BASE_ADDR_LO__SHIFT = 0x00000006;
    constexpr unsigned int CP_DDID_CNTL__ENABLE__SHIFT              = 0x0000001f;
    constexpr unsigned int CP_DDID_CNTL__MODE__SHIFT                = 0x0000001e;
    constexpr unsigned int CP_DDID_CNTL__POLICY__SHIFT              = 0x0000001c;
    constexpr unsigned int CP_DDID_CNTL__SIZE__SHIFT                = 0x00000010;
    constexpr unsigned int CP_DDID_CNTL__THRESHOLD__SHIFT           = 0x00000000;
    constexpr unsigned int CP_DDID_CNTL__VMID_SEL__SHIFT            = 0x00000018;
    constexpr unsigned int CP_DDID_CNTL__VMID__SHIFT                = 0x00000014;
    constexpr unsigned int CP_DEBUG_2__DC_DISABLE_BROADCAST__SHIFT  = 0x0000001d;
    constexpr unsigned int CP_DEBUG_2__DC_FORCE_CLK_EN__SHIFT       = 0x0000001c;
    constexpr unsigned int CP_DEBUG_2__DC_INTERLEAVE_WG_SIZE_CNST__SHIFT = 0x00000011;
    constexpr unsigned int CP_DEBUG_2__NOT_EOP_HW_DETECT_DISABLE__SHIFT = 0x0000001e;
    constexpr unsigned int CP_DEBUG_2__PFP_DDID_HW_DETECT_DISABLE__SHIFT = 0x0000001f;
    constexpr unsigned int CP_DFY_CNTL__MTYPE__SHIFT                = 0x0000000c;
    constexpr unsigned int CP_DFY_CNTL__POLICY__SHIFT               = 0x00000008;
    constexpr unsigned int CP_DFY_CNTL__REPEATER_FGCG_DISABLE__SHIFT = 0x00000019;
    constexpr unsigned int CP_DFY_CNTL__VOL__SHIFT                  = 0x0000000a;
    constexpr unsigned int CP_DMA_CNTL__WATCH_CONTROL__SHIFT        = 0x00000001;
    constexpr unsigned int CP_DMA_ME_CMD_ADDR_HI__ADDR_HI__SHIFT    = 0x00000000;
    constexpr unsigned int CP_DMA_ME_CMD_ADDR_HI__RSVD__SHIFT       = 0x00000010;
    constexpr unsigned int CP_DMA_ME_CMD_ADDR_LO__ADDR_LO__SHIFT    = 0x00000002;
    constexpr unsigned int CP_DMA_ME_CMD_ADDR_LO__RSVD__SHIFT       = 0x00000000;
    constexpr unsigned int CP_DMA_ME_CONTROL__DST_VOLATLE__SHIFT    = 0x0000001b;
    constexpr unsigned int CP_DMA_ME_CONTROL__SRC_VOLATLE__SHIFT    = 0x0000000f;
    constexpr unsigned int CP_DMA_PFP_CMD_ADDR_HI__ADDR_HI__SHIFT   = 0x00000000;
    constexpr unsigned int CP_DMA_PFP_CMD_ADDR_HI__RSVD__SHIFT      = 0x00000010;
    constexpr unsigned int CP_DMA_PFP_CMD_ADDR_LO__ADDR_LO__SHIFT   = 0x00000002;
    constexpr unsigned int CP_DMA_PFP_CMD_ADDR_LO__RSVD__SHIFT      = 0x00000000;
    constexpr unsigned int CP_DMA_PFP_CONTROL__DST_VOLATLE__SHIFT   = 0x0000001b;
    constexpr unsigned int CP_DMA_PFP_CONTROL__SRC_VOLATLE__SHIFT   = 0x0000000f;
    constexpr unsigned int CP_DMA_WATCH0_ADDR_HI__ADDR_HI__SHIFT    = 0x00000000;
    constexpr unsigned int CP_DMA_WATCH0_ADDR_HI__RSVD__SHIFT       = 0x00000010;
    constexpr unsigned int CP_DMA_WATCH0_ADDR_LO__ADDR_LO__SHIFT    = 0x00000007;
    constexpr unsigned int CP_DMA_WATCH0_ADDR_LO__RSVD__SHIFT       = 0x00000000;
    constexpr unsigned int CP_DMA_WATCH0_CNTL__ANY_VMID__SHIFT      = 0x0000000a;
    constexpr unsigned int CP_DMA_WATCH0_CNTL__RSVD1__SHIFT         = 0x00000004;
    constexpr unsigned int CP_DMA_WATCH0_CNTL__RSVD2__SHIFT         = 0x0000000b;
    constexpr unsigned int CP_DMA_WATCH0_CNTL__VMID__SHIFT          = 0x00000000;
    constexpr unsigned int CP_DMA_WATCH0_CNTL__WATCH_READS__SHIFT   = 0x00000008;
    constexpr unsigned int CP_DMA_WATCH0_CNTL__WATCH_WRITES__SHIFT  = 0x00000009;
    constexpr unsigned int CP_DMA_WATCH0_MASK__MASK__SHIFT          = 0x00000007;
    constexpr unsigned int CP_DMA_WATCH0_MASK__RSVD__SHIFT          = 0x00000000;
    constexpr unsigned int CP_DMA_WATCH1_ADDR_HI__ADDR_HI__SHIFT    = 0x00000000;
    constexpr unsigned int CP_DMA_WATCH1_ADDR_HI__RSVD__SHIFT       = 0x00000010;
    constexpr unsigned int CP_DMA_WATCH1_ADDR_LO__ADDR_LO__SHIFT    = 0x00000007;
    constexpr unsigned int CP_DMA_WATCH1_ADDR_LO__RSVD__SHIFT       = 0x00000000;
    constexpr unsigned int CP_DMA_WATCH1_CNTL__ANY_VMID__SHIFT      = 0x0000000a;
    constexpr unsigned int CP_DMA_WATCH1_CNTL__RSVD1__SHIFT         = 0x00000004;
    constexpr unsigned int CP_DMA_WATCH1_CNTL__RSVD2__SHIFT         = 0x0000000b;
    constexpr unsigned int CP_DMA_WATCH1_CNTL__VMID__SHIFT          = 0x00000000;
    constexpr unsigned int CP_DMA_WATCH1_CNTL__WATCH_READS__SHIFT   = 0x00000008;
    constexpr unsigned int CP_DMA_WATCH1_CNTL__WATCH_WRITES__SHIFT  = 0x00000009;
    constexpr unsigned int CP_DMA_WATCH1_MASK__MASK__SHIFT          = 0x00000007;
    constexpr unsigned int CP_DMA_WATCH1_MASK__RSVD__SHIFT          = 0x00000000;
    constexpr unsigned int CP_DMA_WATCH2_ADDR_HI__ADDR_HI__SHIFT    = 0x00000000;
    constexpr unsigned int CP_DMA_WATCH2_ADDR_HI__RSVD__SHIFT       = 0x00000010;
    constexpr unsigned int CP_DMA_WATCH2_ADDR_LO__ADDR_LO__SHIFT    = 0x00000007;
    constexpr unsigned int CP_DMA_WATCH2_ADDR_LO__RSVD__SHIFT       = 0x00000000;
    constexpr unsigned int CP_DMA_WATCH2_CNTL__ANY_VMID__SHIFT      = 0x0000000a;
    constexpr unsigned int CP_DMA_WATCH2_CNTL__RSVD1__SHIFT         = 0x00000004;
    constexpr unsigned int CP_DMA_WATCH2_CNTL__RSVD2__SHIFT         = 0x0000000b;
    constexpr unsigned int CP_DMA_WATCH2_CNTL__VMID__SHIFT          = 0x00000000;
    constexpr unsigned int CP_DMA_WATCH2_CNTL__WATCH_READS__SHIFT   = 0x00000008;
    constexpr unsigned int CP_DMA_WATCH2_CNTL__WATCH_WRITES__SHIFT  = 0x00000009;
    constexpr unsigned int CP_DMA_WATCH2_MASK__MASK__SHIFT          = 0x00000007;
    constexpr unsigned int CP_DMA_WATCH2_MASK__RSVD__SHIFT          = 0x00000000;
    constexpr unsigned int CP_DMA_WATCH3_ADDR_HI__ADDR_HI__SHIFT    = 0x00000000;
    constexpr unsigned int CP_DMA_WATCH3_ADDR_HI__RSVD__SHIFT       = 0x00000010;
    constexpr unsigned int CP_DMA_WATCH3_ADDR_LO__ADDR_LO__SHIFT    = 0x00000007;
    constexpr unsigned int CP_DMA_WATCH3_ADDR_LO__RSVD__SHIFT       = 0x00000000;
    constexpr unsigned int CP_DMA_WATCH3_CNTL__ANY_VMID__SHIFT      = 0x0000000a;
    constexpr unsigned int CP_DMA_WATCH3_CNTL__RSVD1__SHIFT         = 0x00000004;
    constexpr unsigned int CP_DMA_WATCH3_CNTL__RSVD2__SHIFT         = 0x0000000b;
    constexpr unsigned int CP_DMA_WATCH3_CNTL__VMID__SHIFT          = 0x00000000;
    constexpr unsigned int CP_DMA_WATCH3_CNTL__WATCH_READS__SHIFT   = 0x00000008;
    constexpr unsigned int CP_DMA_WATCH3_CNTL__WATCH_WRITES__SHIFT  = 0x00000009;
    constexpr unsigned int CP_DMA_WATCH3_MASK__MASK__SHIFT          = 0x00000007;
    constexpr unsigned int CP_DMA_WATCH3_MASK__RSVD__SHIFT          = 0x00000000;
    constexpr unsigned int CP_DMA_WATCH_STAT_ADDR_HI__ADDR_HI__SHIFT = 0x00000000;
    constexpr unsigned int CP_DMA_WATCH_STAT_ADDR_LO__ADDR_LO__SHIFT = 0x00000002;
    constexpr unsigned int CP_DMA_WATCH_STAT__CLIENT_ID__SHIFT      = 0x00000008;
    constexpr unsigned int CP_DMA_WATCH_STAT__PIPE__SHIFT           = 0x0000000c;
    constexpr unsigned int CP_DMA_WATCH_STAT__RD_WR__SHIFT          = 0x00000014;
    constexpr unsigned int CP_DMA_WATCH_STAT__TRAP_FLAG__SHIFT      = 0x0000001f;
    constexpr unsigned int CP_DMA_WATCH_STAT__VMID__SHIFT           = 0x00000000;
    constexpr unsigned int CP_DMA_WATCH_STAT__WATCH_ID__SHIFT       = 0x00000010;
    constexpr unsigned int CP_EOP_DONE_EVENT_CNTL__EOP_VOLATILE__SHIFT = 0x0000001b;
    constexpr unsigned int CP_EOP_DONE_EVENT_CNTL__GCR_CNTL__SHIFT  = 0x0000000c;
    constexpr unsigned int CP_FETCHER_SOURCE__ME_SRC__SHIFT         = 0x00000000;
    constexpr unsigned int CP_GFX_DDID_DELTA_RPT_COUNT__COUNT__SHIFT = 0x00000000;
    constexpr unsigned int CP_GFX_DDID_INFLIGHT_COUNT__COUNT__SHIFT = 0x00000000;
    constexpr unsigned int CP_GFX_DDID_RPTR__COUNT__SHIFT           = 0x00000000;
    constexpr unsigned int CP_GFX_DDID_WPTR__COUNT__SHIFT           = 0x00000000;
    constexpr unsigned int CP_GFX_ERROR__CE_DATA_FETCHER_UTCL1_ERROR__SHIFT = 0x00000005;
    constexpr unsigned int CP_GFX_ERROR__DATA_FETCHER_UTCL1_ERROR__SHIFT = 0x00000006;
    constexpr unsigned int CP_GFX_HPD_CONTROL0__PIPE_HOLDING__SHIFT = 0x00000004;
    constexpr unsigned int CP_GFX_HPD_CONTROL0__SUSPEND_ENABLE__SHIFT = 0x00000000;
    constexpr unsigned int CP_GFX_HPD_OSPRE_FENCE_ADDR_HI__ADDR_HI__SHIFT = 0x00000000;
    constexpr unsigned int CP_GFX_HPD_OSPRE_FENCE_ADDR_HI__RSVD__SHIFT = 0x00000010;
    constexpr unsigned int CP_GFX_HPD_OSPRE_FENCE_ADDR_LO__ADDR_LO__SHIFT = 0x00000002;
    constexpr unsigned int CP_GFX_HPD_OSPRE_FENCE_DATA_HI__DATA_HI__SHIFT = 0x00000000;
    constexpr unsigned int CP_GFX_HPD_OSPRE_FENCE_DATA_LO__DATA_LO__SHIFT = 0x00000000;
    constexpr unsigned int CP_GFX_HPD_STATUS0__FORCE_QUEUE_STATE__SHIFT = 0x00000014;
    constexpr unsigned int CP_GFX_HPD_STATUS0__FORCE_QUEUE__SHIFT   = 0x0000001f;
    constexpr unsigned int CP_GFX_HPD_STATUS0__MAPPED_QUEUE__SHIFT  = 0x00000005;
    constexpr unsigned int CP_GFX_HPD_STATUS0__QUEUE_AVAILABLE__SHIFT = 0x00000008;
    constexpr unsigned int CP_GFX_HPD_STATUS0__QUEUE_STATE__SHIFT   = 0x00000000;
    constexpr unsigned int CP_GFX_HPD_STATUS0__SUSPEND_REQ__SHIFT   = 0x0000001c;
    constexpr unsigned int CP_GFX_HQD_ACTIVE__ACTIVE__SHIFT         = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_BASE_HI__RB_BASE_HI__SHIFT    = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_BASE__RB_BASE__SHIFT          = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_CNTL__BUF_SWAP__SHIFT         = 0x00000010;
    constexpr unsigned int CP_GFX_HQD_CNTL__CACHE_POLICY__SHIFT     = 0x00000018;
    constexpr unsigned int CP_GFX_HQD_CNTL__MIN_AVAILSZ__SHIFT      = 0x00000014;
    constexpr unsigned int CP_GFX_HQD_CNTL__MIN_IB_AVAILSZ__SHIFT   = 0x00000016;
    constexpr unsigned int CP_GFX_HQD_CNTL__RB_BLKSZ__SHIFT         = 0x00000008;
    constexpr unsigned int CP_GFX_HQD_CNTL__RB_BUFSZ__SHIFT         = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_CNTL__RB_EXE__SHIFT           = 0x0000001c;
    constexpr unsigned int CP_GFX_HQD_CNTL__RB_NO_UPDATE__SHIFT     = 0x0000001b;
    constexpr unsigned int CP_GFX_HQD_CNTL__RB_RPTR_WR_ENA__SHIFT   = 0x0000001f;
    constexpr unsigned int CP_GFX_HQD_CNTL__RB_VOLATILE__SHIFT      = 0x0000001a;
    constexpr unsigned int CP_GFX_HQD_CSMD_RPTR__RB_RPTR__SHIFT     = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_DEQUEUE_REQUEST__DEQUEUE_REQ_EN__SHIFT = 0x0000000a;
    constexpr unsigned int CP_GFX_HQD_DEQUEUE_REQUEST__DEQUEUE_REQ__SHIFT = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_DEQUEUE_REQUEST__IQ_REQ_PEND_EN__SHIFT = 0x00000009;
    constexpr unsigned int CP_GFX_HQD_DEQUEUE_REQUEST__IQ_REQ_PEND__SHIFT = 0x00000004;
    constexpr unsigned int CP_GFX_HQD_HQ_CONTROL0__COMMAND__SHIFT   = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_HQ_STATUS0__DEQUEUE_STATUS__SHIFT = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_HQ_STATUS0__OS_PREEMPT_STATUS__SHIFT = 0x00000004;
    constexpr unsigned int CP_GFX_HQD_HQ_STATUS0__PREEMPT_ACK__SHIFT = 0x00000006;
    constexpr unsigned int CP_GFX_HQD_HQ_STATUS0__QUEUE_IDLE__SHIFT = 0x0000001e;
    constexpr unsigned int CP_GFX_HQD_MAPPED__MAPPED__SHIFT         = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_OFFSET__DISABLE_RB_OFFSET__SHIFT = 0x0000001f;
    constexpr unsigned int CP_GFX_HQD_OFFSET__RB_OFFSET__SHIFT      = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_QUANTUM__QUANTUM_ACTIVE__SHIFT = 0x0000001f;
    constexpr unsigned int CP_GFX_HQD_QUANTUM__QUANTUM_DURATION__SHIFT = 0x00000008;
    constexpr unsigned int CP_GFX_HQD_QUANTUM__QUANTUM_EN__SHIFT    = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_QUANTUM__QUANTUM_SCALE__SHIFT = 0x00000003;
    constexpr unsigned int CP_GFX_HQD_QUEUE_PRIORITY__PRIORITY_LEVEL__SHIFT = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_QUE_MGR_CONTROL__CONTROL__SHIFT = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_RPTR_ADDR_HI__RB_RPTR_ADDR_HI__SHIFT = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_RPTR_ADDR__RB_RPTR_ADDR__SHIFT = 0x00000002;
    constexpr unsigned int CP_GFX_HQD_RPTR__RB_RPTR__SHIFT          = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_VMID__VMID__SHIFT             = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_WPTR_HI__RB_WPTR__SHIFT       = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_WPTR__RB_WPTR__SHIFT          = 0x00000000;
    constexpr unsigned int CP_GFX_INDEX_MUTEX__CLIENTID__SHIFT      = 0x00000001;
    constexpr unsigned int CP_GFX_INDEX_MUTEX__REQUEST__SHIFT       = 0x00000000;
    constexpr unsigned int CP_GFX_MQD_BASE_ADDR_HI__APP_VMID__SHIFT = 0x0000001c;
    constexpr unsigned int CP_GFX_MQD_CONTROL__PROCESSING_MQD_EN__SHIFT = 0x0000000d;
    constexpr unsigned int CP_GFX_MQD_CONTROL__PROCESSING_MQD__SHIFT = 0x0000000c;
    constexpr unsigned int CP_GFX_QUEUE_INDEX__PIPE_ID__SHIFT       = 0x00000004;
    constexpr unsigned int CP_GFX_QUEUE_INDEX__QUEUE_ACCESS__SHIFT  = 0x00000000;
    constexpr unsigned int CP_GFX_QUEUE_INDEX__QUEUE_ID__SHIFT      = 0x00000008;
    constexpr unsigned int CP_HPD_MES_ROQ_OFFSETS__IB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int CP_HPD_MES_ROQ_OFFSETS__IQ_OFFSET__SHIFT = 0x00000000;
    constexpr unsigned int CP_HPD_MES_ROQ_OFFSETS__PQ_OFFSET__SHIFT = 0x00000008;
    constexpr unsigned int CP_HPD_STATUS0__ENABLE_OFFLOAD_CHECK__SHIFT = 0x0000001c;
    constexpr unsigned int CP_HPD_STATUS0__FREEZE_QUEUE_STATE__SHIFT = 0x0000001e;
    constexpr unsigned int CP_HPD_STATUS0__MASTER_QUEUE_IDLE_DIS__SHIFT = 0x0000001b;
    constexpr unsigned int CP_HQD_DDID_DELTA_RPT_COUNT__COUNT__SHIFT = 0x00000000;
    constexpr unsigned int CP_HQD_DDID_INFLIGHT_COUNT__COUNT__SHIFT = 0x00000000;
    constexpr unsigned int CP_HQD_DDID_RPTR__RPTR__SHIFT            = 0x00000000;
    constexpr unsigned int CP_HQD_DDID_WPTR__WPTR__SHIFT            = 0x00000000;
    constexpr unsigned int CP_HQD_DEQUEUE_STATUS__DEQUEUE_STAT_EN__SHIFT = 0x0000000a;
    constexpr unsigned int CP_HQD_DEQUEUE_STATUS__DEQUEUE_STAT__SHIFT = 0x00000000;
    constexpr unsigned int CP_HQD_DEQUEUE_STATUS__SUSPEND_REQ_PEND_EN__SHIFT = 0x00000009;
    constexpr unsigned int CP_HQD_DEQUEUE_STATUS__SUSPEND_REQ_PEND__SHIFT = 0x00000004;
    constexpr unsigned int CP_HQD_EOP_CONTROL__EOP_VOLATILE__SHIFT  = 0x0000001a;
    constexpr unsigned int CP_HQD_IB_CONTROL__IB_VOLATILE__SHIFT    = 0x0000001a;
    constexpr unsigned int CP_HQD_IQ_TIMER__IQ_VOLATILE__SHIFT      = 0x0000001a;
    constexpr unsigned int CP_HQD_IQ_TIMER__QUEUE_TYPE__SHIFT       = 0x0000001b;
    constexpr unsigned int CP_HQD_PERSISTENT_STATE__SUSPEND_STATUS__SHIFT = 0x00000007;
    constexpr unsigned int CP_HQD_PERSISTENT_STATE__WPP_CLAMP_EN__SHIFT = 0x00000014;
    constexpr unsigned int CP_HQD_PQ_CONTROL__PQ_VOLATILE__SHIFT    = 0x0000001a;
    constexpr unsigned int CP_HQD_PQ_CONTROL__SLOT_BASED_WPTR__SHIFT = 0x00000012;
    constexpr unsigned int CP_HQD_PQ_CONTROL__TUNNEL_DISPATCH__SHIFT = 0x0000001d;
    constexpr unsigned int CP_HQD_SEMA_CMD__MESSAGE_EN__SHIFT       = 0x00000009;
    constexpr unsigned int CP_HQD_SEMA_CMD__POLLING_DIS__SHIFT      = 0x00000008;
    constexpr unsigned int CP_HQD_SUSPEND_CNTL_STACK_DW_CNT__CNT__SHIFT = 0x00000000;
    constexpr unsigned int CP_HQD_SUSPEND_CNTL_STACK_OFFSET__OFFSET__SHIFT = 0x00000002;
    constexpr unsigned int CP_HQD_SUSPEND_WG_STATE_OFFSET__OFFSET__SHIFT = 0x00000002;
    constexpr unsigned int CP_INT_CNTL_RING0__DMA_WATCH_INT_ENABLE__SHIFT = 0x0000000a;
    constexpr unsigned int CP_INT_CNTL_RING0__RESUME_INT_ENABLE__SHIFT = 0x00000008;
    constexpr unsigned int CP_INT_CNTL_RING0__SUSPEND_INT_ENABLE__SHIFT = 0x00000009;
    constexpr unsigned int CP_INT_CNTL_RING1__DMA_WATCH_INT_ENABLE__SHIFT = 0x0000000a;
    constexpr unsigned int CP_INT_CNTL_RING2__DMA_WATCH_INT_ENABLE__SHIFT = 0x0000000a;
    constexpr unsigned int CP_INT_CNTL__DMA_WATCH_INT_ENABLE__SHIFT = 0x0000000a;
    constexpr unsigned int CP_INT_CNTL__RESUME_INT_ENABLE__SHIFT    = 0x00000008;
    constexpr unsigned int CP_INT_CNTL__SUSPEND_INT_ENABLE__SHIFT   = 0x00000009;
    constexpr unsigned int CP_INT_STATUS_RING0__DMA_WATCH_INT_STAT__SHIFT = 0x0000000a;
    constexpr unsigned int CP_INT_STATUS_RING0__RESUME_INT_STAT__SHIFT = 0x00000008;
    constexpr unsigned int CP_INT_STATUS_RING0__SUSPEND_INT_STAT__SHIFT = 0x00000009;
    constexpr unsigned int CP_INT_STATUS_RING1__DMA_WATCH_INT_STAT__SHIFT = 0x0000000a;
    constexpr unsigned int CP_INT_STATUS_RING2__DMA_WATCH_INT_STAT__SHIFT = 0x0000000a;
    constexpr unsigned int CP_INT_STATUS__DMA_WATCH_INT_STAT__SHIFT = 0x0000000a;
    constexpr unsigned int CP_INT_STATUS__RESUME_INT_STAT__SHIFT    = 0x00000008;
    constexpr unsigned int CP_INT_STATUS__SUSPEND_INT_STAT__SHIFT   = 0x00000009;
    constexpr unsigned int CP_INT_STAT_DEBUG__DMA_WATCH_INT_ASSERTED__SHIFT = 0x0000000a;
    constexpr unsigned int CP_INT_STAT_DEBUG__RESUME_INT_ASSERTED__SHIFT = 0x00000008;
    constexpr unsigned int CP_INT_STAT_DEBUG__SUSPEND_INT_ASSERTED__SHIFT = 0x00000009;
    constexpr unsigned int CP_IQ_WAIT_TIME3__SUSPEND_QUE__SHIFT     = 0x00000000;
    constexpr unsigned int CP_MEC_CNTL__MEC_INVALIDATE_ICACHE__SHIFT = 0x0000001b;
    constexpr unsigned int CP_MEC_CNTL__MEC_ME2_PIPE2_RESET__SHIFT  = 0x00000016;
    constexpr unsigned int CP_MEC_CNTL__MEC_ME2_PIPE3_RESET__SHIFT  = 0x00000017;
    constexpr unsigned int CP_MES_CNTL__MES_HALT__SHIFT             = 0x0000001e;
    constexpr unsigned int CP_MES_CNTL__MES_INVALIDATE_ICACHE__SHIFT = 0x00000004;
    constexpr unsigned int CP_MES_CNTL__MES_PIPE0_ACTIVE__SHIFT     = 0x0000001a;
    constexpr unsigned int CP_MES_CNTL__MES_PIPE0_RESET__SHIFT      = 0x00000010;
    constexpr unsigned int CP_MES_CNTL__MES_PIPE1_ACTIVE__SHIFT     = 0x0000001b;
    constexpr unsigned int CP_MES_CNTL__MES_PIPE1_RESET__SHIFT      = 0x00000011;
    constexpr unsigned int CP_MES_CNTL__MES_PIPE2_ACTIVE__SHIFT     = 0x0000001c;
    constexpr unsigned int CP_MES_CNTL__MES_PIPE2_RESET__SHIFT      = 0x00000012;
    constexpr unsigned int CP_MES_CNTL__MES_PIPE3_ACTIVE__SHIFT     = 0x0000001d;
    constexpr unsigned int CP_MES_CNTL__MES_PIPE3_RESET__SHIFT      = 0x00000013;
    constexpr unsigned int CP_MES_CNTL__MES_STEP__SHIFT             = 0x0000001f;
    constexpr unsigned int CP_MES_DC_BASE_CNTL__CACHE_POLICY__SHIFT = 0x00000018;
    constexpr unsigned int CP_MES_DC_BASE_CNTL__VMID__SHIFT         = 0x00000000;
    constexpr unsigned int CP_MES_DC_BASE_HI__DC_BASE_HI__SHIFT     = 0x00000000;
    constexpr unsigned int CP_MES_DC_BASE_LO__DC_BASE_LO__SHIFT     = 0x00000010;
    constexpr unsigned int CP_MES_DC_OP_CNTL__BYPASS_ALL__SHIFT     = 0x00000002;
    constexpr unsigned int CP_MES_DC_OP_CNTL__BYPASS_UNCACHED__SHIFT = 0x00000003;
    constexpr unsigned int CP_MES_DC_OP_CNTL__DCACHE_PRIMED__SHIFT  = 0x00000005;
    constexpr unsigned int CP_MES_DC_OP_CNTL__INVALIDATE_DCACHE_COMPLETE__SHIFT = 0x00000001;
    constexpr unsigned int CP_MES_DC_OP_CNTL__INVALIDATE_DCACHE__SHIFT = 0x00000000;
    constexpr unsigned int CP_MES_DC_OP_CNTL__PRIME_DCACHE__SHIFT   = 0x00000004;
    constexpr unsigned int CP_MES_DM_INDEX_ADDR__ADDR__SHIFT        = 0x00000000;
    constexpr unsigned int CP_MES_DM_INDEX_DATA__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL1__DOORBELL_EN__SHIFT = 0x0000001e;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL1__DOORBELL_HIT__SHIFT = 0x0000001f;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL1__DOORBELL_OFFSET__SHIFT = 0x00000002;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL2__DOORBELL_EN__SHIFT = 0x0000001e;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL2__DOORBELL_HIT__SHIFT = 0x0000001f;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL2__DOORBELL_OFFSET__SHIFT = 0x00000002;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL3__DOORBELL_EN__SHIFT = 0x0000001e;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL3__DOORBELL_HIT__SHIFT = 0x0000001f;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL3__DOORBELL_OFFSET__SHIFT = 0x00000002;
    constexpr unsigned int CP_MES_HEADER_DUMP__HEADER_DUMP__SHIFT   = 0x00000000;
    constexpr unsigned int CP_MES_IC_BASE_CNTL__CACHE_POLICY__SHIFT = 0x00000018;
    constexpr unsigned int CP_MES_IC_BASE_CNTL__EXE_DISABLE__SHIFT  = 0x00000017;
    constexpr unsigned int CP_MES_IC_BASE_CNTL__VMID__SHIFT         = 0x00000000;
    constexpr unsigned int CP_MES_IC_BASE_HI__IC_BASE_HI__SHIFT     = 0x00000000;
    constexpr unsigned int CP_MES_IC_BASE_LO__IC_BASE_LO__SHIFT     = 0x0000000c;
    constexpr unsigned int CP_MES_IC_OP_CNTL__ICACHE_PRIMED__SHIFT  = 0x00000005;
    constexpr unsigned int CP_MES_IC_OP_CNTL__INVALIDATE_CACHE__SHIFT = 0x00000000;
    constexpr unsigned int CP_MES_IC_OP_CNTL__PRIME_ICACHE__SHIFT   = 0x00000004;
    constexpr unsigned int CP_MES_INSTR_PNTR__INSTR_PNTR__SHIFT     = 0x00000000;
    constexpr unsigned int CP_MES_INTERRUPT__MES_INT__SHIFT         = 0x00000000;
    constexpr unsigned int CP_MES_INTR_ROUTINE_START__IR_START__SHIFT = 0x00000000;
    constexpr unsigned int CP_MES_LOCAL_APERTURE__APERTURE__SHIFT   = 0x00000000;
    constexpr unsigned int CP_MES_LOCAL_BASE0_HI__BASE0_HI__SHIFT   = 0x00000000;
    constexpr unsigned int CP_MES_LOCAL_BASE0_LO__BASE0_LO__SHIFT   = 0x00000010;
    constexpr unsigned int CP_MES_LOCAL_MASK0_HI__MASK0_HI__SHIFT   = 0x00000000;
    constexpr unsigned int CP_MES_LOCAL_MASK0_LO__MASK0_LO__SHIFT   = 0x00000010;
    constexpr unsigned int CP_MES_MARCHID_HI__MARCHID_HI__SHIFT     = 0x00000000;
    constexpr unsigned int CP_MES_MARCHID_LO__MARCHID_LO__SHIFT     = 0x00000000;
    constexpr unsigned int CP_MES_MBADADDR_HI__ADDR_HI__SHIFT       = 0x00000000;
    constexpr unsigned int CP_MES_MBADADDR_LO__ADDR_LO__SHIFT       = 0x00000000;
    constexpr unsigned int CP_MES_MCAUSE_HI__CAUSE_HI__SHIFT        = 0x00000000;
    constexpr unsigned int CP_MES_MCAUSE_LO__CAUSE_LO__SHIFT        = 0x00000000;
    constexpr unsigned int CP_MES_MCYCLE_HI__CYCLE_HI__SHIFT        = 0x00000000;
    constexpr unsigned int CP_MES_MCYCLE_LO__CYCLE_LO__SHIFT        = 0x00000000;
    constexpr unsigned int CP_MES_MDBASE_HI__BASE_HI__SHIFT         = 0x00000000;
    constexpr unsigned int CP_MES_MDBASE_LO__BASE_LO__SHIFT         = 0x00000010;
    constexpr unsigned int CP_MES_MDBOUND_HI__BOUND_HI__SHIFT       = 0x00000000;
    constexpr unsigned int CP_MES_MDBOUND_LO__BOUND_LO__SHIFT       = 0x00000000;
    constexpr unsigned int CP_MES_MEPC_HI__MEPC_HI__SHIFT           = 0x00000000;
    constexpr unsigned int CP_MES_MEPC_LO__MEPC_LO__SHIFT           = 0x00000000;
    constexpr unsigned int CP_MES_MHARTID_HI__MHARTID_HI__SHIFT     = 0x00000000;
    constexpr unsigned int CP_MES_MHARTID_LO__MHARTID_LO__SHIFT     = 0x00000000;
    constexpr unsigned int CP_MES_MIBASE_HI__IC_BASE_HI__SHIFT      = 0x00000000;
    constexpr unsigned int CP_MES_MIBASE_LO__IC_BASE_LO__SHIFT      = 0x0000000c;
    constexpr unsigned int CP_MES_MIBOUND_HI__BOUND_HI__SHIFT       = 0x00000000;
    constexpr unsigned int CP_MES_MIBOUND_LO__BOUND_LO__SHIFT       = 0x00000000;
    constexpr unsigned int CP_MES_MIE_HI__MES_INT__SHIFT            = 0x00000000;
    constexpr unsigned int CP_MES_MIE_LO__MES_INT__SHIFT            = 0x00000000;
    constexpr unsigned int CP_MES_MIMPID_HI__MIMPID_HI__SHIFT       = 0x00000000;
    constexpr unsigned int CP_MES_MIMPID_LO__MIMPID_LO__SHIFT       = 0x00000000;
    constexpr unsigned int CP_MES_MINSTRET_HI__INSTRET_HI__SHIFT    = 0x00000000;
    constexpr unsigned int CP_MES_MINSTRET_LO__INSTRET_LO__SHIFT    = 0x00000000;
    constexpr unsigned int CP_MES_MIP_HI__MIP_HI__SHIFT             = 0x00000000;
    constexpr unsigned int CP_MES_MIP_LO__MIP_LO__SHIFT             = 0x00000000;
    constexpr unsigned int CP_MES_MISA_HI__MISA_HI__SHIFT           = 0x00000000;
    constexpr unsigned int CP_MES_MISA_LO__MISA_LO__SHIFT           = 0x00000000;
    constexpr unsigned int CP_MES_MSCRATCH_HI__DATA__SHIFT          = 0x00000000;
    constexpr unsigned int CP_MES_MSCRATCH_LO__DATA__SHIFT          = 0x00000000;
    constexpr unsigned int CP_MES_MSTATUS_HI__STATUS_HI__SHIFT      = 0x00000000;
    constexpr unsigned int CP_MES_MSTATUS_LO__STATUS_LO__SHIFT      = 0x00000000;
    constexpr unsigned int CP_MES_MTIMECMP_HI__TIME_HI__SHIFT       = 0x00000000;
    constexpr unsigned int CP_MES_MTIMECMP_LO__TIME_LO__SHIFT       = 0x00000000;
    constexpr unsigned int CP_MES_MTIME_HI__TIME_HI__SHIFT          = 0x00000000;
    constexpr unsigned int CP_MES_MTIME_LO__TIME_LO__SHIFT          = 0x00000000;
    constexpr unsigned int CP_MES_MTVEC_HI__ADDR_LO__SHIFT          = 0x00000000;
    constexpr unsigned int CP_MES_MTVEC_LO__ADDR_LO__SHIFT          = 0x00000000;
    constexpr unsigned int CP_MES_MVENDORID_HI__MVENDORID_HI__SHIFT = 0x00000000;
    constexpr unsigned int CP_MES_MVENDORID_LO__MVENDORID_LO__SHIFT = 0x00000000;
    constexpr unsigned int CP_MES_PERFCOUNT_CNTL__EVENT_SEL__SHIFT  = 0x00000000;
    constexpr unsigned int CP_MES_PIPE0_PRIORITY__PRIORITY__SHIFT   = 0x00000000;
    constexpr unsigned int CP_MES_PIPE1_PRIORITY__PRIORITY__SHIFT   = 0x00000000;
    constexpr unsigned int CP_MES_PIPE2_PRIORITY__PRIORITY__SHIFT   = 0x00000000;
    constexpr unsigned int CP_MES_PIPE3_PRIORITY__PRIORITY__SHIFT   = 0x00000000;
    constexpr unsigned int CP_MES_PIPE_PRIORITY_CNTS__PRIORITY1_CNT__SHIFT = 0x00000000;
    constexpr unsigned int CP_MES_PIPE_PRIORITY_CNTS__PRIORITY2A_CNT__SHIFT = 0x00000008;
    constexpr unsigned int CP_MES_PIPE_PRIORITY_CNTS__PRIORITY2B_CNT__SHIFT = 0x00000010;
    constexpr unsigned int CP_MES_PIPE_PRIORITY_CNTS__PRIORITY3_CNT__SHIFT = 0x00000018;
    constexpr unsigned int CP_MES_PRGRM_CNTR_START__IP_START__SHIFT = 0x00000000;
    constexpr unsigned int CP_MES_PROCESS_QUANTUM_PIPE0__QUANTUM_DURATION__SHIFT = 0x00000000;
    constexpr unsigned int CP_MES_PROCESS_QUANTUM_PIPE0__QUANTUM_EN__SHIFT = 0x0000001f;
    constexpr unsigned int CP_MES_PROCESS_QUANTUM_PIPE0__QUANTUM_SCALE__SHIFT = 0x0000001d;
    constexpr unsigned int CP_MES_PROCESS_QUANTUM_PIPE0__TIMER_EXPIRED__SHIFT = 0x0000001c;
    constexpr unsigned int CP_MES_PROCESS_QUANTUM_PIPE1__QUANTUM_DURATION__SHIFT = 0x00000000;
    constexpr unsigned int CP_MES_PROCESS_QUANTUM_PIPE1__QUANTUM_EN__SHIFT = 0x0000001f;
    constexpr unsigned int CP_MES_PROCESS_QUANTUM_PIPE1__QUANTUM_SCALE__SHIFT = 0x0000001d;
    constexpr unsigned int CP_MES_PROCESS_QUANTUM_PIPE1__TIMER_EXPIRED__SHIFT = 0x0000001c;
    constexpr unsigned int CP_MES_SCRATCH_DATA__SCRATCH_DATA__SHIFT = 0x00000000;
    constexpr unsigned int CP_MES_SCRATCH_INDEX__SCRATCH_INDEX_64BIT_MODE__SHIFT = 0x0000001f;
    constexpr unsigned int CP_MES_SCRATCH_INDEX__SCRATCH_INDEX__SHIFT = 0x00000000;
    constexpr unsigned int CP_ME_IC_BASE_CNTL__ADDRESS_CLAMP__SHIFT = 0x00000004;
    constexpr unsigned int CP_ME_IC_BASE_CNTL__CACHE_POLICY__SHIFT  = 0x00000018;
    constexpr unsigned int CP_ME_IC_BASE_CNTL__EXE_DISABLE__SHIFT   = 0x00000017;
    constexpr unsigned int CP_ME_IC_BASE_CNTL__VMID__SHIFT          = 0x00000000;
    constexpr unsigned int CP_ME_IC_BASE_HI__IC_BASE_HI__SHIFT      = 0x00000000;
    constexpr unsigned int CP_ME_IC_BASE_LO__IC_BASE_LO__SHIFT      = 0x0000000c;
    constexpr unsigned int CP_ME_IC_OP_CNTL__ICACHE_PRIMED__SHIFT   = 0x00000005;
    constexpr unsigned int CP_ME_IC_OP_CNTL__INVALIDATE_CACHE_COMPLETE__SHIFT = 0x00000001;
    constexpr unsigned int CP_ME_IC_OP_CNTL__INVALIDATE_CACHE__SHIFT = 0x00000000;
    constexpr unsigned int CP_ME_IC_OP_CNTL__PRIME_ICACHE__SHIFT    = 0x00000004;
    constexpr unsigned int CP_MQD_CONTROL__MQD_VOLATILE__SHIFT      = 0x0000001a;
    constexpr unsigned int CP_PFP_IC_BASE_CNTL__ADDRESS_CLAMP__SHIFT = 0x00000004;
    constexpr unsigned int CP_PFP_IC_BASE_CNTL__CACHE_POLICY__SHIFT = 0x00000018;
    constexpr unsigned int CP_PFP_IC_BASE_CNTL__EXE_DISABLE__SHIFT  = 0x00000017;
    constexpr unsigned int CP_PFP_IC_BASE_CNTL__VMID__SHIFT         = 0x00000000;
    constexpr unsigned int CP_PFP_IC_BASE_HI__IC_BASE_HI__SHIFT     = 0x00000000;
    constexpr unsigned int CP_PFP_IC_BASE_LO__IC_BASE_LO__SHIFT     = 0x0000000c;
    constexpr unsigned int CP_PFP_IC_OP_CNTL__ICACHE_PRIMED__SHIFT  = 0x00000005;
    constexpr unsigned int CP_PFP_IC_OP_CNTL__INVALIDATE_CACHE_COMPLETE__SHIFT = 0x00000001;
    constexpr unsigned int CP_PFP_IC_OP_CNTL__INVALIDATE_CACHE__SHIFT = 0x00000000;
    constexpr unsigned int CP_PFP_IC_OP_CNTL__PRIME_ICACHE__SHIFT   = 0x00000004;
    constexpr unsigned int CP_PQ_STATUS__DOORBELL_UPDATED_EN__SHIFT = 0x00000002;
    constexpr unsigned int CP_PROCESS_QUANTUM__QUANTUM_DURATION__SHIFT = 0x00000000;
    constexpr unsigned int CP_PROCESS_QUANTUM__QUANTUM_EN__SHIFT    = 0x0000001f;
    constexpr unsigned int CP_PROCESS_QUANTUM__QUANTUM_SCALE__SHIFT = 0x0000001d;
    constexpr unsigned int CP_PROCESS_QUANTUM__TIMER_EXPIRED__SHIFT = 0x0000001c;
    constexpr unsigned int CP_PWR_CNTL__CMP_CLK_HALT_ME3_PIPE0__SHIFT = 0x00000014;
    constexpr unsigned int CP_PWR_CNTL__CMP_CLK_HALT_ME3_PIPE1__SHIFT = 0x00000015;
    constexpr unsigned int CP_PWR_CNTL__CMP_CLK_HALT_ME3_PIPE2__SHIFT = 0x00000016;
    constexpr unsigned int CP_PWR_CNTL__CMP_CLK_HALT_ME3_PIPE3__SHIFT = 0x00000017;
    constexpr unsigned int CP_RB0_CNTL__RB_EXE__SHIFT               = 0x0000001c;
    constexpr unsigned int CP_RB0_CNTL__RB_VOLATILE__SHIFT          = 0x0000001a;
    constexpr unsigned int CP_RB1_ACTIVE__ACTIVE__SHIFT             = 0x00000000;
    constexpr unsigned int CP_RB1_BUFSZ_MASK__DATA__SHIFT           = 0x00000000;
    constexpr unsigned int CP_RB1_CNTL__RB_EXE__SHIFT               = 0x0000001c;
    constexpr unsigned int CP_RB1_CNTL__RB_VOLATILE__SHIFT          = 0x0000001a;
    constexpr unsigned int CP_RB2_CNTL__RB_EXE__SHIFT               = 0x0000001c;
    constexpr unsigned int CP_RB2_CNTL__RB_VOLATILE__SHIFT          = 0x0000001a;
    constexpr unsigned int CP_RB_CNTL__RB_EXE__SHIFT                = 0x0000001c;
    constexpr unsigned int CP_RB_CNTL__RB_VOLATILE__SHIFT           = 0x0000001a;
    constexpr unsigned int CP_ROQ1_THRESHOLDS__R0_IB1_START__SHIFT  = 0x0000000a;
    constexpr unsigned int CP_ROQ1_THRESHOLDS__R1_IB1_START__SHIFT  = 0x00000014;
    constexpr unsigned int CP_ROQ2_AVAIL__ROQ_CNT_DB__SHIFT         = 0x00000010;
    constexpr unsigned int CP_ROQ2_THRESHOLDS__R0_IB2_START__SHIFT  = 0x00000000;
    constexpr unsigned int CP_ROQ2_THRESHOLDS__R1_IB2_START__SHIFT  = 0x0000000a;
    constexpr unsigned int CP_ROQ3_THRESHOLDS__R0_DB_START__SHIFT   = 0x00000000;
    constexpr unsigned int CP_ROQ3_THRESHOLDS__R1_DB_START__SHIFT   = 0x0000000a;
    constexpr unsigned int CP_ROQ_DB_STAT__ROQ_RPTR_DB__SHIFT       = 0x00000000;
    constexpr unsigned int CP_ROQ_DB_STAT__ROQ_WPTR_DB__SHIFT       = 0x00000010;
    constexpr unsigned int CP_SCRATCH_INDEX__SCRATCH_INDEX_64BIT_MODE__SHIFT = 0x0000001f;
    constexpr unsigned int CP_SD_CNTL__GE_EN__SHIFT                 = 0x00000005;
    constexpr unsigned int CP_SD_CNTL__SDMA_EN__SHIFT               = 0x0000000a;
    constexpr unsigned int CP_SD_CNTL__SD_VMIDVEC_OVERRIDE__SHIFT   = 0x0000001f;
    constexpr unsigned int CP_SD_CNTL__UTCL1_EN__SHIFT              = 0x00000006;
    constexpr unsigned int CP_STALLED_STAT2__PFP_TO_MEQ_DDID_NOT_RDY_TO_RCV__SHIFT = 0x00000006;
    constexpr unsigned int CP_STALLED_STAT3__GCRIU_WAITING_ON_FREE__SHIFT = 0x00000015;
    constexpr unsigned int CP_STAT__GCRIU_BUSY__SHIFT               = 0x00000019;
    constexpr unsigned int CP_STAT__ROQ_CE_DB_BUSY__SHIFT           = 0x00000006;
    constexpr unsigned int CP_STAT__ROQ_DB_BUSY__SHIFT              = 0x00000005;
    constexpr unsigned int CP_SUSPEND_CNTL__ACE_SUSPEND_ACTIVE__SHIFT = 0x00000003;
    constexpr unsigned int CP_SUSPEND_CNTL__RESUME_LOCK__SHIFT      = 0x00000002;
    constexpr unsigned int CP_SUSPEND_CNTL__SUSPEND_ENABLE__SHIFT   = 0x00000001;
    constexpr unsigned int CP_SUSPEND_CNTL__SUSPEND_MODE__SHIFT     = 0x00000000;
    constexpr unsigned int CP_SUSPEND_RESUME_REQ__RESUME_REQ__SHIFT = 0x00000001;
    constexpr unsigned int CP_SUSPEND_RESUME_REQ__SUSPEND_REQ__SHIFT = 0x00000000;
    constexpr unsigned int CSPRIV_CONNECT__SAME_SIMD_RESUME__SHIFT  = 0x00000013;
    constexpr unsigned int CSPRIV_CONNECT__TRACKER_BIT__SHIFT       = 0x0000001e;
    constexpr unsigned int CSPRIV_CONNECT__TUNNEL_DISP__SHIFT       = 0x00000012;
    constexpr unsigned int DB_COUNT_CONTROL__DISABLE_CONSERVATIVE_ZPASS_COUNTS__SHIFT = 0x00000002;
    constexpr unsigned int DB_COUNT_CONTROL__ENHANCED_CONSERVATIVE_ZPASS_COUNTS__SHIFT = 0x00000003;
    constexpr unsigned int DB_DEBUG2__DISABLE_HTILE_PAIRED_PIPES__SHIFT = 0x00000010;
    constexpr unsigned int DB_DEBUG2__DUAL_PIPE_REZ_STALL_MANUAL_CONTROL__SHIFT = 0x00000016;
    constexpr unsigned int DB_DEBUG2__DUAL_PIPE_REZ_STALL_SELECT_NEW__SHIFT = 0x00000017;
    constexpr unsigned int DB_DEBUG2__FORCE_ITERATE_256__SHIFT      = 0x00000018;
    constexpr unsigned int DB_DEBUG2__FULL_TILE_CACHE_EVICT_ON_HALF_FULL__SHIFT = 0x0000000f;
    constexpr unsigned int DB_DEBUG2__FULL_TILE_WAVE_BREAK_MODE__SHIFT = 0x00000014;
    constexpr unsigned int DB_DEBUG3__DELETE_CONTEXT_SUSPEND__SHIFT = 0x0000001d;
    constexpr unsigned int DB_DEBUG3__DISABLE_MULTIDTAG_FL_PANIC_REQUIREMENT__SHIFT = 0x0000001f;
    constexpr unsigned int DB_DEBUG3__DISABLE_SLOCS_PER_CTXT_MATCH__SHIFT = 0x00000010;
    constexpr unsigned int DB_DEBUG3__DISABLE_TS_WRITE_L0__SHIFT    = 0x0000001e;
    constexpr unsigned int DB_DEBUG4__ALWAYS_ON_RMI_CLK_EN__SHIFT   = 0x00000006;
    constexpr unsigned int DB_DEBUG4__DISABLE_DYNAMIC_RAM_LIGHT_SLEEP_MODE__SHIFT = 0x0000000f;
    constexpr unsigned int DB_DEBUG4__DISABLE_HIZ_TS_COLLISION_DETECT__SHIFT = 0x00000010;
    constexpr unsigned int DB_DEBUG4__DISABLE_LAST_OF_BURST_ON_ACCUM_ALL_EOT__SHIFT = 0x00000011;
    constexpr unsigned int DB_DEBUG4__DISABLE_LAST_OF_BURST_ON_FLUSH_CHUNK0_ALL_DONE__SHIFT = 0x00000012;
    constexpr unsigned int DB_DEBUG4__DISABLE_LATEZ_NO_EXPORT_POWER_SAVING__SHIFT = 0x00000014;
    constexpr unsigned int DB_DEBUG4__DISABLE_MCC_BURST_FIFO_CONFLICT__SHIFT = 0x00000016;
    constexpr unsigned int DB_DEBUG4__DISABLE_MCC_BURST_FIFO__SHIFT = 0x00000015;
    constexpr unsigned int DB_DEBUG4__DISABLE_RD_MEM_BURST__SHIFT   = 0x0000001c;
    constexpr unsigned int DB_DEBUG4__DISABLE_SEPARATE_DFSM_CLK__SHIFT = 0x00000005;
    constexpr unsigned int DB_DEBUG4__DISABLE_SEPARATE_OP_PIPE_CLK__SHIFT = 0x00000004;
    constexpr unsigned int DB_DEBUG4__DISABLE_WR_MEM_BURST_FLF_CONSECUTIVE_CHECK__SHIFT = 0x00000017;
    constexpr unsigned int DB_DEBUG4__DISABLE_WR_MEM_BURST_POOLING__SHIFT = 0x0000001b;
    constexpr unsigned int DB_DEBUG4__ENABLE_A2M_DQUAD_OPTIMIZATION__SHIFT = 0x0000000c;
    constexpr unsigned int DB_DEBUG4__ENABLE_CZ_OVERFLOW_TESTMODE__SHIFT = 0x00000013;
    constexpr unsigned int DB_DEBUG4__ENABLE_DBCB_SLOW_FORMAT_COLLAPSE__SHIFT = 0x00000007;
    constexpr unsigned int DB_DEBUG4__LATE_ACK_PSD_EOP_GFX9_METHOD__SHIFT = 0x0000001f;
    constexpr unsigned int DB_DEBUG4__LATE_ACK_SCOREBOARD_MULTIPLE_SLOT__SHIFT = 0x0000001e;
    constexpr unsigned int DB_DEBUG4__LATE_ACK_SCOREBOARD_NEW__SHIFT = 0x0000001d;
    constexpr unsigned int DB_DEBUG4__WR_MEM_BURST_CTL__SHIFT       = 0x00000018;
    constexpr unsigned int DB_DEPTH_SIZE_XY__X_MAX__SHIFT           = 0x00000000;
    constexpr unsigned int DB_DEPTH_SIZE_XY__Y_MAX__SHIFT           = 0x00000010;
    constexpr unsigned int DB_DEPTH_VIEW__SLICE_MAX_HI__SHIFT       = 0x0000001e;
    constexpr unsigned int DB_DEPTH_VIEW__SLICE_START_HI__SHIFT     = 0x0000000b;
    constexpr unsigned int DB_EQUAD_STUTTER_CONTROL__THRESHOLD__SHIFT = 0x00000000;
    constexpr unsigned int DB_EQUAD_STUTTER_CONTROL__TIMEOUT__SHIFT = 0x00000010;
    constexpr unsigned int DB_ETILE_STUTTER_CONTROL__THRESHOLD__SHIFT = 0x00000000;
    constexpr unsigned int DB_ETILE_STUTTER_CONTROL__TIMEOUT__SHIFT = 0x00000010;
    constexpr unsigned int DB_EXCEPTION_CONTROL__AUTO_FLUSH_HTILE__SHIFT = 0x00000003;
    constexpr unsigned int DB_EXCEPTION_CONTROL__AUTO_FLUSH_QUAD__SHIFT = 0x00000004;
    constexpr unsigned int DB_EXCEPTION_CONTROL__DTAG_WATERMARK__SHIFT = 0x00000018;
    constexpr unsigned int DB_EXCEPTION_CONTROL__FORCE_SUMMARIZE__SHIFT = 0x00000008;
    constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_CB_LQUAD_OVERRIDE__SHIFT = 0x00000002;
    constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_CB_TILE_OVERRIDE__SHIFT = 0x00000001;
    constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_RMI_RDREQ_OVERRIDE__SHIFT = 0x00000003;
    constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_RMI_WRREQ_OVERRIDE__SHIFT = 0x00000004;
    constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_SC_QUAD_OVERRIDE__SHIFT = 0x00000000;
    constexpr unsigned int DB_FIFO_DEPTH1__MCC_DEPTH__SHIFT         = 0x00000010;
    constexpr unsigned int DB_FIFO_DEPTH1__MI_RDREQ_FIFO_DEPTH__SHIFT = 0x00000000;
    constexpr unsigned int DB_FIFO_DEPTH1__MI_WRREQ_FIFO_DEPTH__SHIFT = 0x00000008;
    constexpr unsigned int DB_FIFO_DEPTH1__QC_DEPTH__SHIFT          = 0x00000018;
    constexpr unsigned int DB_FIFO_DEPTH2__LQUAD_FIFO_DEPTH__SHIFT  = 0x00000010;
    constexpr unsigned int DB_FIFO_DEPTH3__LTILE_PROBE_FIFO_DEPTH__SHIFT = 0x00000000;
    constexpr unsigned int DB_FIFO_DEPTH3__QUAD_READ_REQS__SHIFT    = 0x00000018;
    constexpr unsigned int DB_FREE_CACHELINES__FREE_HTILE_DEPTH__SHIFT = 0x00000018;
    constexpr unsigned int DB_FREE_CACHELINES__FREE_PLANE_DEPTH__SHIFT = 0x00000008;
    constexpr unsigned int DB_FREE_CACHELINES__FREE_Z_DEPTH__SHIFT  = 0x00000010;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__DBCB_LOB_SWITCH_TIMEOUT__SHIFT = 0x0000000b;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__DISABLE_RD_BURST__SHIFT = 0x0000001e;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__LEGACY_LOB_INSERT_EN__SHIFT = 0x0000001f;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__MAXBURST__SHIFT = 0x00000000;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__TIMEOUT__SHIFT  = 0x00000008;
    constexpr unsigned int DB_LQUAD_STUTTER_CONTROL__THRESHOLD__SHIFT = 0x00000000;
    constexpr unsigned int DB_LQUAD_STUTTER_CONTROL__TIMEOUT__SHIFT = 0x00000010;
    constexpr unsigned int DB_LTILE_STUTTER_CONTROL__THRESHOLD__SHIFT = 0x00000000;
    constexpr unsigned int DB_LTILE_STUTTER_CONTROL__TIMEOUT__SHIFT = 0x00000010;
    constexpr unsigned int DB_RMI_BC_GL2_CACHE_CONTROL__HTILE_RD_POLICY__SHIFT = 0x00000014;
    constexpr unsigned int DB_RMI_BC_GL2_CACHE_CONTROL__HTILE_WR_POLICY__SHIFT = 0x00000004;
    constexpr unsigned int DB_RMI_BC_GL2_CACHE_CONTROL__S_RD_POLICY__SHIFT = 0x00000012;
    constexpr unsigned int DB_RMI_BC_GL2_CACHE_CONTROL__S_WR_POLICY__SHIFT = 0x00000002;
    constexpr unsigned int DB_RMI_BC_GL2_CACHE_CONTROL__VOL__SHIFT  = 0x0000001f;
    constexpr unsigned int DB_RMI_BC_GL2_CACHE_CONTROL__ZPCPSD_WR_POLICY__SHIFT = 0x00000006;
    constexpr unsigned int DB_RMI_BC_GL2_CACHE_CONTROL__Z_RD_POLICY__SHIFT = 0x00000010;
    constexpr unsigned int DB_RMI_BC_GL2_CACHE_CONTROL__Z_WR_POLICY__SHIFT = 0x00000000;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__HTILE_RD_POLICY__SHIFT = 0x00000014;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__HTILE_WR_POLICY__SHIFT = 0x00000004;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__S_RD_POLICY__SHIFT = 0x00000012;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__S_WR_POLICY__SHIFT = 0x00000002;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__ZPCPSD_WR_POLICY__SHIFT = 0x00000006;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__Z_RD_POLICY__SHIFT = 0x00000010;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__Z_WR_POLICY__SHIFT = 0x00000000;
    constexpr unsigned int DB_SHADER_CONTROL__PRE_SHADER_DEPTH_COVERAGE_ENABLE__SHIFT = 0x00000017;
    constexpr unsigned int DB_STENCIL_INFO__FAULT_BEHAVIOR__SHIFT   = 0x00000009;
    constexpr unsigned int DB_STENCIL_INFO__ITERATE_256__SHIFT      = 0x00000014;
    constexpr unsigned int DB_STENCIL_INFO__ITERATE_FLUSH__SHIFT    = 0x0000000b;
    constexpr unsigned int DB_WATERMARKS__DEPTH_CACHELINE_FREE__SHIFT = 0x00000018;
    constexpr unsigned int DB_WATERMARKS__DEPTH_FLUSH__SHIFT        = 0x00000008;
    constexpr unsigned int DB_WATERMARKS__DEPTH_PENDING_FREE__SHIFT = 0x00000010;
    constexpr unsigned int DB_Z_INFO__FAULT_BEHAVIOR__SHIFT         = 0x00000009;
    constexpr unsigned int DB_Z_INFO__ITERATE_256__SHIFT            = 0x00000014;
    constexpr unsigned int DB_Z_INFO__ITERATE_FLUSH__SHIFT          = 0x0000000b;
    constexpr unsigned int GCEA_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GCEA_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GCEA_PERFCOUNTER2_MODE__COMPARE_MODE0__SHIFT = 0x00000000;
    constexpr unsigned int GCEA_PERFCOUNTER2_MODE__COMPARE_MODE1__SHIFT = 0x00000002;
    constexpr unsigned int GCEA_PERFCOUNTER2_MODE__COMPARE_MODE2__SHIFT = 0x00000004;
    constexpr unsigned int GCEA_PERFCOUNTER2_MODE__COMPARE_MODE3__SHIFT = 0x00000006;
    constexpr unsigned int GCEA_PERFCOUNTER2_MODE__COMPARE_VALUE0__SHIFT = 0x00000008;
    constexpr unsigned int GCEA_PERFCOUNTER2_MODE__COMPARE_VALUE1__SHIFT = 0x0000000c;
    constexpr unsigned int GCEA_PERFCOUNTER2_MODE__COMPARE_VALUE2__SHIFT = 0x00000010;
    constexpr unsigned int GCEA_PERFCOUNTER2_MODE__COMPARE_VALUE3__SHIFT = 0x00000014;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_MEM_POWER_LS__LS_HOLD__SHIFT        = 0x00000006;
    constexpr unsigned int GCMC_MEM_POWER_LS__LS_SETUP__SHIFT       = 0x00000000;
    constexpr unsigned int GCMC_SHARED_ACTIVE_FCN_ID__VFID__SHIFT   = 0x00000000;
    constexpr unsigned int GCMC_SHARED_ACTIVE_FCN_ID__VF__SHIFT     = 0x0000001f;
    constexpr unsigned int GCMC_SHARED_VIRT_RESET_REQ2__VF__SHIFT   = 0x00000000;
    constexpr unsigned int GCMC_SHARED_VIRT_RESET_REQ__PF__SHIFT    = 0x0000001f;
    constexpr unsigned int GCMC_SHARED_VIRT_RESET_REQ__VF__SHIFT    = 0x00000000;
    constexpr unsigned int GCMC_VM_AGP_BASE__AGP_BASE__SHIFT        = 0x00000000;
    constexpr unsigned int GCMC_VM_AGP_BOT__AGP_BOT__SHIFT          = 0x00000000;
    constexpr unsigned int GCMC_VM_AGP_TOP__AGP_TOP__SHIFT          = 0x00000000;
    constexpr unsigned int GCMC_VM_APT_CNTL__DIRECT_SYSTEM_EN__SHIFT = 0x00000001;
    constexpr unsigned int GCMC_VM_APT_CNTL__FORCE_MTYPE_UC__SHIFT  = 0x00000000;
    constexpr unsigned int GCMC_VM_CACHEABLE_DRAM_ADDRESS_END__ADDRESS__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_CACHEABLE_DRAM_ADDRESS_START__ADDRESS__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_LOCATION_BASE__FB_BASE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_LOCATION_TOP__FB_TOP__SHIFT   = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_OFFSET__FB_OFFSET__SHIFT      = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF0__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF0__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF1__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF1__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF2__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF2__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF3__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF3__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF4__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF4__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF5__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF5__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF6__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF6__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF7__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF7__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF8__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF8__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF9__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF9__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF10__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF10__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF11__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF11__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF12__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF12__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF13__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF13__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF14__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF14__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF15__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF15__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF16__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF16__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF17__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF17__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF18__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF18__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF19__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF19__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF20__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF20__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF21__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF21__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF22__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF22__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF23__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF23__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF24__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF24__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF25__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF25__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF26__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF26__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF27__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF27__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF28__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF28__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF29__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF29__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF30__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF30__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF31__VF_FB_OFFSET__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_FB_SIZE_OFFSET_VF31__VF_FB_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__CLEAR__SHIFT = 0x0000001d;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__ENABLE__SHIFT = 0x0000001c;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__PERF_MODE__SHIFT = 0x00000018;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__PERF_SEL_END__SHIFT = 0x00000008;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__CLEAR__SHIFT = 0x0000001d;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__ENABLE__SHIFT = 0x0000001c;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__PERF_MODE__SHIFT = 0x00000018;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__PERF_SEL_END__SHIFT = 0x00000008;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__CLEAR__SHIFT = 0x0000001d;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__ENABLE__SHIFT = 0x0000001c;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__PERF_MODE__SHIFT = 0x00000018;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__PERF_SEL_END__SHIFT = 0x00000008;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__CLEAR__SHIFT = 0x0000001d;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__ENABLE__SHIFT = 0x0000001c;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__PERF_MODE__SHIFT = 0x00000018;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__PERF_SEL_END__SHIFT = 0x00000008;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__CLEAR__SHIFT = 0x0000001d;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__ENABLE__SHIFT = 0x0000001c;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__PERF_MODE__SHIFT = 0x00000018;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__PERF_SEL_END__SHIFT = 0x00000008;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__CLEAR__SHIFT = 0x0000001d;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__ENABLE__SHIFT = 0x0000001c;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__PERF_MODE__SHIFT = 0x00000018;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__PERF_SEL_END__SHIFT = 0x00000008;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__CLEAR__SHIFT = 0x0000001d;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__ENABLE__SHIFT = 0x0000001c;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__PERF_MODE__SHIFT = 0x00000018;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__PERF_SEL_END__SHIFT = 0x00000008;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__CLEAR__SHIFT = 0x0000001d;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__ENABLE__SHIFT = 0x0000001c;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__PERF_MODE__SHIFT = 0x00000018;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__PERF_SEL_END__SHIFT = 0x00000008;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_HI__COMPARE_VALUE__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_HI__COUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_LO__COUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL__SHIFT = 0x00000019;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY__SHIFT = 0x00000018;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__START_TRIGGER__SHIFT = 0x00000008;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE__SHIFT = 0x0000001a;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER__SHIFT = 0x00000010;
    constexpr unsigned int GCMC_VM_LOCAL_HBM_ADDRESS_END__ADDRESS__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_LOCAL_HBM_ADDRESS_LOCK_CNTL__LOCK__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_LOCAL_HBM_ADDRESS_START__ADDRESS__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_MARC_BASE_HI_0__MARC_BASE_HI_0__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_MARC_BASE_HI_1__MARC_BASE_HI_1__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_MARC_BASE_HI_2__MARC_BASE_HI_2__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_MARC_BASE_HI_3__MARC_BASE_HI_3__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_MARC_BASE_LO_0__MARC_BASE_LO_0__SHIFT = 0x0000000c;
    constexpr unsigned int GCMC_VM_MARC_BASE_LO_1__MARC_BASE_LO_1__SHIFT = 0x0000000c;
    constexpr unsigned int GCMC_VM_MARC_BASE_LO_2__MARC_BASE_LO_2__SHIFT = 0x0000000c;
    constexpr unsigned int GCMC_VM_MARC_BASE_LO_3__MARC_BASE_LO_3__SHIFT = 0x0000000c;
    constexpr unsigned int GCMC_VM_MARC_LEN_HI_0__MARC_LEN_HI_0__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_MARC_LEN_HI_1__MARC_LEN_HI_1__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_MARC_LEN_HI_2__MARC_LEN_HI_2__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_MARC_LEN_HI_3__MARC_LEN_HI_3__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_MARC_LEN_LO_0__MARC_LEN_LO_0__SHIFT = 0x0000000c;
    constexpr unsigned int GCMC_VM_MARC_LEN_LO_1__MARC_LEN_LO_1__SHIFT = 0x0000000c;
    constexpr unsigned int GCMC_VM_MARC_LEN_LO_2__MARC_LEN_LO_2__SHIFT = 0x0000000c;
    constexpr unsigned int GCMC_VM_MARC_LEN_LO_3__MARC_LEN_LO_3__SHIFT = 0x0000000c;
    constexpr unsigned int GCMC_VM_MARC_RELOC_HI_0__MARC_RELOC_HI_0__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_MARC_RELOC_HI_1__MARC_RELOC_HI_1__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_MARC_RELOC_HI_2__MARC_RELOC_HI_2__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_MARC_RELOC_HI_3__MARC_RELOC_HI_3__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_MARC_RELOC_LO_0__MARC_ENABLE_0__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_MARC_RELOC_LO_0__MARC_READONLY_0__SHIFT = 0x00000001;
    constexpr unsigned int GCMC_VM_MARC_RELOC_LO_0__MARC_RELOC_LO_0__SHIFT = 0x0000000c;
    constexpr unsigned int GCMC_VM_MARC_RELOC_LO_1__MARC_ENABLE_1__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_MARC_RELOC_LO_1__MARC_READONLY_1__SHIFT = 0x00000001;
    constexpr unsigned int GCMC_VM_MARC_RELOC_LO_1__MARC_RELOC_LO_1__SHIFT = 0x0000000c;
    constexpr unsigned int GCMC_VM_MARC_RELOC_LO_2__MARC_ENABLE_2__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_MARC_RELOC_LO_2__MARC_READONLY_2__SHIFT = 0x00000001;
    constexpr unsigned int GCMC_VM_MARC_RELOC_LO_2__MARC_RELOC_LO_2__SHIFT = 0x0000000c;
    constexpr unsigned int GCMC_VM_MARC_RELOC_LO_3__MARC_ENABLE_3__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_MARC_RELOC_LO_3__MARC_READONLY_3__SHIFT = 0x00000001;
    constexpr unsigned int GCMC_VM_MARC_RELOC_LO_3__MARC_RELOC_LO_3__SHIFT = 0x0000000c;
    constexpr unsigned int GCMC_VM_MX_L1_TLB_CNTL__ECO_BITS__SHIFT  = 0x00000007;
    constexpr unsigned int GCMC_VM_MX_L1_TLB_CNTL__ENABLE_ADVANCED_DRIVER_MODEL__SHIFT = 0x00000006;
    constexpr unsigned int GCMC_VM_MX_L1_TLB_CNTL__ENABLE_L1_TLB__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_MX_L1_TLB_CNTL__MTYPE__SHIFT     = 0x0000000b;
    constexpr unsigned int GCMC_VM_MX_L1_TLB_CNTL__SYSTEM_ACCESS_MODE__SHIFT = 0x00000003;
    constexpr unsigned int GCMC_VM_MX_L1_TLB_CNTL__SYSTEM_APERTURE_UNMAPPED_ACCESS__SHIFT = 0x00000005;
    constexpr unsigned int GCMC_VM_NB_LOWER_TOP_OF_DRAM2__ENABLE__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_NB_LOWER_TOP_OF_DRAM2__LOWER_TOM2__SHIFT = 0x00000017;
    constexpr unsigned int GCMC_VM_NB_MMIOBASE__MMIOBASE__SHIFT     = 0x00000000;
    constexpr unsigned int GCMC_VM_NB_MMIOLIMIT__MMIOLIMIT__SHIFT   = 0x00000000;
    constexpr unsigned int GCMC_VM_NB_PCI_ARB__VGA_HOLE__SHIFT      = 0x00000003;
    constexpr unsigned int GCMC_VM_NB_PCI_CTRL__MMIOENABLE__SHIFT   = 0x00000017;
    constexpr unsigned int GCMC_VM_NB_TOP_OF_DRAM_SLOT1__TOP_OF_DRAM__SHIFT = 0x00000017;
    constexpr unsigned int GCMC_VM_NB_UPPER_TOP_OF_DRAM2__UPPER_TOM2__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_STEERING__DEFAULT_STEERING__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_SYSTEM_APERTURE_DEFAULT_ADDR_LSB__PHYSICAL_PAGE_NUMBER_LSB__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_SYSTEM_APERTURE_DEFAULT_ADDR_MSB__PHYSICAL_PAGE_NUMBER_MSB__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_SYSTEM_APERTURE_HIGH_ADDR__LOGICAL_ADDR__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_SYSTEM_APERTURE_LOW_ADDR__LOGICAL_ADDR__SHIFT = 0x00000000;
    constexpr unsigned int GCRD_SA_TARGETS_DISABLE__GCRD_TARGETS_DISABLE__SHIFT = 0x00000000;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__OFF_HYSTERESIS__SHIFT = 0x00000004;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__ON_DELAY__SHIFT      = 0x00000000;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_OVERRIDE0__SHIFT = 0x0000001f;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_OVERRIDE1__SHIFT = 0x0000001e;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_OVERRIDE2__SHIFT = 0x0000001d;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_OVERRIDE3__SHIFT = 0x0000001c;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_OVERRIDE4__SHIFT = 0x0000001b;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_OVERRIDE5__SHIFT = 0x0000001a;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_OVERRIDE6__SHIFT = 0x00000019;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE0__SHIFT = 0x00000017;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE1__SHIFT = 0x00000016;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE2__SHIFT = 0x00000015;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE3__SHIFT = 0x00000014;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE4__SHIFT = 0x00000013;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE5__SHIFT = 0x00000012;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE6__SHIFT = 0x00000011;
    constexpr unsigned int GCR_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE7__SHIFT = 0x00000010;
    constexpr unsigned int GCR_CMD_STATUS__GCR_CONTROL__SHIFT       = 0x00000000;
    constexpr unsigned int GCR_CMD_STATUS__GCR_SEQ_OP_ERROR__SHIFT  = 0x0000001e;
    constexpr unsigned int GCR_CMD_STATUS__GCR_SRC__SHIFT           = 0x00000014;
    constexpr unsigned int GCR_CMD_STATUS__GCR_TLB_SHOOTDOWN_VMID__SHIFT = 0x00000018;
    constexpr unsigned int GCR_CMD_STATUS__GCR_TLB_SHOOTDOWN__SHIFT = 0x00000017;
    constexpr unsigned int GCR_CMD_STATUS__UTCL2_NACK_ERROR__SHIFT  = 0x0000001f;
    constexpr unsigned int GCR_CMD_STATUS__UTCL2_NACK_STATUS__SHIFT = 0x0000001c;
    constexpr unsigned int GCR_GENERAL_CNTL__BIG_PAGE_FILTER_DISABLE__SHIFT = 0x00000007;
    constexpr unsigned int GCR_GENERAL_CNTL__CLIENT_ID__SHIFT       = 0x00000014;
    constexpr unsigned int GCR_GENERAL_CNTL__FORCE_4K_L2_RESP__SHIFT = 0x00000000;
    constexpr unsigned int GCR_GENERAL_CNTL__FORCE_INV_ALL__SHIFT   = 0x00000003;
    constexpr unsigned int GCR_GENERAL_CNTL__FORCE_SINGLE_WQ__SHIFT = 0x00000009;
    constexpr unsigned int GCR_GENERAL_CNTL__HI_PRIORITY_CNTL__SHIFT = 0x00000004;
    constexpr unsigned int GCR_GENERAL_CNTL__HI_PRIORITY_DISABLE__SHIFT = 0x00000006;
    constexpr unsigned int GCR_GENERAL_CNTL__MIXED_RANGE_MODE_DIS__SHIFT = 0x0000000e;
    constexpr unsigned int GCR_GENERAL_CNTL__PERF_CNTR_ENABLE__SHIFT = 0x00000008;
    constexpr unsigned int GCR_GENERAL_CNTL__REDUCE_HALF_MAIN_WQ__SHIFT = 0x00000001;
    constexpr unsigned int GCR_GENERAL_CNTL__REDUCE_HALF_PHY_WQ__SHIFT = 0x00000002;
    constexpr unsigned int GCR_GENERAL_CNTL__TARGET_MGCG_CLKEN_DIS__SHIFT = 0x0000000d;
    constexpr unsigned int GCR_GENERAL_CNTL__UTCL2_REQ_PERM__SHIFT  = 0x0000000a;
    constexpr unsigned int GCR_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GCR_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GCR_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GCR_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GCR_PERFCOUNTER1_SELECT__CNTL_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GCR_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x00000018;
    constexpr unsigned int GCR_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GCR_PIO_CNTL__GCR_DATA_INDEX__SHIFT      = 0x00000000;
    constexpr unsigned int GCR_PIO_CNTL__GCR_PIO_RSP_DONE__SHIFT    = 0x0000001e;
    constexpr unsigned int GCR_PIO_CNTL__GCR_PIO_RSP_TAG__SHIFT     = 0x00000010;
    constexpr unsigned int GCR_PIO_CNTL__GCR_READY__SHIFT           = 0x0000001f;
    constexpr unsigned int GCR_PIO_CNTL__GCR_REG_DONE__SHIFT        = 0x00000002;
    constexpr unsigned int GCR_PIO_CNTL__GCR_REG_RESET__SHIFT       = 0x00000003;
    constexpr unsigned int GCR_PIO_DATA__GCR_DATA__SHIFT            = 0x00000000;
    constexpr unsigned int GCR_SPARE__SPARE_BIT_1__SHIFT            = 0x00000001;
    constexpr unsigned int GCR_SPARE__SPARE_BIT_2__SHIFT            = 0x00000002;
    constexpr unsigned int GCR_SPARE__SPARE_BIT_3__SHIFT            = 0x00000003;
    constexpr unsigned int GCR_SPARE__SPARE_BIT_4__SHIFT            = 0x00000004;
    constexpr unsigned int GCR_SPARE__SPARE_BIT_5__SHIFT            = 0x00000005;
    constexpr unsigned int GCR_SPARE__SPARE_BIT_6__SHIFT            = 0x00000006;
    constexpr unsigned int GCR_SPARE__SPARE_BIT_7__SHIFT            = 0x00000007;
    constexpr unsigned int GCR_SPARE__SPARE_BIT_8_0__SHIFT          = 0x00000008;
    constexpr unsigned int GCR_SPARE__SPARE_BIT_31_16__SHIFT        = 0x00000010;
    constexpr unsigned int GCR_TARGET_DISABLE__DISABLE_GL2A0_PHY__SHIFT = 0x00000008;
    constexpr unsigned int GCR_TARGET_DISABLE__DISABLE_GL2A1_PHY__SHIFT = 0x00000009;
    constexpr unsigned int GCR_TARGET_DISABLE__DISABLE_GL2A2_PHY__SHIFT = 0x0000000a;
    constexpr unsigned int GCR_TARGET_DISABLE__DISABLE_GL2A3_PHY__SHIFT = 0x0000000b;
    constexpr unsigned int GCR_TARGET_DISABLE__DISABLE_SA0_PHY__SHIFT = 0x00000000;
    constexpr unsigned int GCR_TARGET_DISABLE__DISABLE_SA0_VIRT__SHIFT = 0x00000001;
    constexpr unsigned int GCR_TARGET_DISABLE__DISABLE_SA1_PHY__SHIFT = 0x00000002;
    constexpr unsigned int GCR_TARGET_DISABLE__DISABLE_SA1_VIRT__SHIFT = 0x00000003;
    constexpr unsigned int GCR_TARGET_DISABLE__DISABLE_SA2_PHY__SHIFT = 0x00000004;
    constexpr unsigned int GCR_TARGET_DISABLE__DISABLE_SA2_VIRT__SHIFT = 0x00000005;
    constexpr unsigned int GCR_TARGET_DISABLE__DISABLE_SA3_PHY__SHIFT = 0x00000006;
    constexpr unsigned int GCR_TARGET_DISABLE__DISABLE_SA3_VIRT__SHIFT = 0x00000007;
    constexpr unsigned int GCUTCL2_CGTT_CLK_CTRL__MGLS_OVERRIDE__SHIFT = 0x0000000f;
    constexpr unsigned int GCUTCL2_CGTT_CLK_CTRL__OFF_HYSTERESIS__SHIFT = 0x00000004;
    constexpr unsigned int GCUTCL2_CGTT_CLK_CTRL__ON_DELAY__SHIFT   = 0x00000000;
    constexpr unsigned int GCUTCL2_CGTT_CLK_CTRL__SOFT_OVERRIDE_EXTRA__SHIFT = 0x0000000c;
    constexpr unsigned int GCUTCL2_CGTT_CLK_CTRL__SOFT_OVERRIDE__SHIFT = 0x00000018;
    constexpr unsigned int GCUTCL2_CGTT_CLK_CTRL__SOFT_STALL_OVERRIDE__SHIFT = 0x00000010;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_MODE0__SHIFT = 0x00000000;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_MODE1__SHIFT = 0x00000002;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_MODE2__SHIFT = 0x00000004;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_MODE3__SHIFT = 0x00000006;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_VALUE0__SHIFT = 0x00000008;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_VALUE1__SHIFT = 0x0000000c;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_VALUE2__SHIFT = 0x00000010;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_VALUE3__SHIFT = 0x00000014;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_MODE0__SHIFT = 0x00000000;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_MODE1__SHIFT = 0x00000002;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_MODE2__SHIFT = 0x00000004;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_MODE3__SHIFT = 0x00000006;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_VALUE0__SHIFT = 0x00000008;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_VALUE1__SHIFT = 0x0000000c;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_VALUE2__SHIFT = 0x00000010;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_VALUE3__SHIFT = 0x00000014;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GCVML2_WALKER_MACRO_THROTTLE_FETCH_LIMIT__LIMIT__SHIFT = 0x00000001;
    constexpr unsigned int GCVML2_WALKER_MACRO_THROTTLE_TIME__TIME__SHIFT = 0x00000000;
    constexpr unsigned int GCVML2_WALKER_MICRO_THROTTLE_FETCH_LIMIT__LIMIT__SHIFT = 0x00000001;
    constexpr unsigned int GCVML2_WALKER_MICRO_THROTTLE_TIME__TIME__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_BCI1__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_SQ0_UPPER__UNUSED_0__SHIFT    = 0x00000008;
    constexpr unsigned int GC_CAC_ACC_SQ1_UPPER__UNUSED_0__SHIFT    = 0x00000008;
    constexpr unsigned int GC_CAC_ACC_SQ2_UPPER__UNUSED_0__SHIFT    = 0x00000008;
    constexpr unsigned int GC_CAC_ACC_SQ3_UPPER__UNUSED_0__SHIFT    = 0x00000008;
    constexpr unsigned int GC_CAC_ACC_SQ4_UPPER__UNUSED_0__SHIFT    = 0x00000008;
    constexpr unsigned int GC_CAC_ACC_SQ5_UPPER__UNUSED_0__SHIFT    = 0x00000008;
    constexpr unsigned int GC_CAC_ACC_SQ6_UPPER__UNUSED_0__SHIFT    = 0x00000008;
    constexpr unsigned int GC_CAC_ACC_SQ7_UPPER__UNUSED_0__SHIFT    = 0x00000008;
    constexpr unsigned int GC_CAC_ACC_SQ8_UPPER__UNUSED_0__SHIFT    = 0x00000008;
    constexpr unsigned int GC_CAC_CNTL__CAC_FORCE_DISABLE__SHIFT    = 0x00000000;
    constexpr unsigned int GC_CAC_CNTL__UNUSED_0__SHIFT             = 0x00000011;
    constexpr unsigned int GC_CAC_CTRL_2__GC_CAC_INDEX_AUTO_INCR_EN__SHIFT = 0x00000004;
    constexpr unsigned int GC_CAC_OVRD_BCI__OVRRD_VALUE__SHIFT      = 0x00000002;
    constexpr unsigned int GC_CAC_SOFT_CTRL__UNUSED__SHIFT          = 0x00000001;
    constexpr unsigned int GC_CAC_WEIGHT_BCI_0__WEIGHT_BCI_SIG1__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_CP_1__UNUSED_0__SHIFT      = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_CU_0__UNUSED_0__SHIFT      = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_PC_0__UNUSED_0__SHIFT      = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_SXRB_0__UNUSED_0__SHIFT    = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_SX_0__UNUSED_0__SHIFT      = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_TA_0__UNUSED_0__SHIFT      = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ATCL2_2__UNUSED_0__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_UTCL2_VML2_2__UNUSED_0__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_UTCL2_WALKER_2__UNUSED_0__SHIFT = 0x00000010;
    constexpr unsigned int GC_EDC_CTRL__EDC_LEVEL_SEL__SHIFT        = 0x0000000e;
    constexpr unsigned int GC_EDC_CTRL__EDC_THROTTLE_PATTERN_BIT_NUMS__SHIFT = 0x0000000a;
    constexpr unsigned int GC_IH_COOKIE_0_PTR__ADDR__SHIFT          = 0x00000000;
    constexpr unsigned int GC_THROTTLE_CTRL__FIXED_PATTERN_PERF_COUNTER_EN__SHIFT = 0x00000017;
    constexpr unsigned int GC_THROTTLE_CTRL__GC_EDC_ONLY_MODE__SHIFT = 0x00000006;
    constexpr unsigned int GC_THROTTLE_CTRL__GC_EDC_OVERRIDE__SHIFT = 0x00000007;
    constexpr unsigned int GC_THROTTLE_CTRL__GC_EDC_PERF_COUNTER_EN__SHIFT = 0x0000000a;
    constexpr unsigned int GC_THROTTLE_CTRL__GC_EDC_STALL_EN__SHIFT = 0x00000001;
    constexpr unsigned int GC_THROTTLE_CTRL__LUT_HW_UPDATE__SHIFT   = 0x0000001d;
    constexpr unsigned int GC_THROTTLE_CTRL__PATTERN_MODE__SHIFT    = 0x00000005;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_OVERRIDE__SHIFT    = 0x00000008;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_PERF_COUNTER_EN__SHIFT = 0x0000000b;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_STALL_EN__SHIFT    = 0x00000004;
    constexpr unsigned int GC_THROTTLE_CTRL__PWRBRK_OVERRIDE__SHIFT = 0x00000009;
    constexpr unsigned int GC_THROTTLE_CTRL__PWRBRK_PERF_COUNTER_EN__SHIFT = 0x0000000c;
    constexpr unsigned int GC_THROTTLE_CTRL__PWRBRK_POLARITY_CNTL__SHIFT = 0x00000003;
    constexpr unsigned int GC_THROTTLE_CTRL__PWRBRK_STALL_EN__SHIFT = 0x00000002;
    constexpr unsigned int GC_THROTTLE_CTRL__RELEASE_STEP_INTERVAL__SHIFT = 0x0000000d;
    constexpr unsigned int GC_THROTTLE_CTRL__THROTTLE_CTRL_SW_RST__SHIFT = 0x00000000;
    constexpr unsigned int GC_THROTTLE_STATUS__FSM_STATE__SHIFT     = 0x00000000;
    constexpr unsigned int GC_THROTTLE_STATUS__PATTERN_INDEX__SHIFT = 0x00000004;
    constexpr unsigned int GC_USER_RMI_REDUNDANCY__REPAIR_EN_IN_0__SHIFT = 0x00000001;
    constexpr unsigned int GC_USER_RMI_REDUNDANCY__REPAIR_EN_IN_1__SHIFT = 0x00000002;
    constexpr unsigned int GC_USER_RMI_REDUNDANCY__REPAIR_ID_SWAP__SHIFT = 0x00000004;
    constexpr unsigned int GC_USER_RMI_REDUNDANCY__REPAIR_RMI_OVERRIDE__SHIFT = 0x00000003;
    constexpr unsigned int GC_USER_SHADER_ARRAY_CONFIG__INACTIVE_WGPS__SHIFT = 0x00000010;
    constexpr unsigned int GE_CNTL__BREAK_WAVE_AT_EOI__SHIFT        = 0x00000012;
    constexpr unsigned int GE_CNTL__PACKET_TO_ONE_PA__SHIFT         = 0x00000013;
    constexpr unsigned int GE_CNTL__PRIM_GRP_SIZE__SHIFT            = 0x00000000;
    constexpr unsigned int GE_CNTL__VERT_GRP_SIZE__SHIFT            = 0x00000009;
    constexpr unsigned int GE_DMA_FIRST_INDEX__FIRST_INDEX__SHIFT   = 0x00000000;
    constexpr unsigned int GE_INDX_OFFSET__INDX_OFFSET__SHIFT       = 0x00000000;
    constexpr unsigned int GE_MAX_OUTPUT_PER_SUBGROUP__MAX_VERTS_PER_SUBGROUP__SHIFT = 0x00000000;
    constexpr unsigned int GE_MAX_VTX_INDX__MAX_INDX__SHIFT         = 0x00000000;
    constexpr unsigned int GE_MIN_VTX_INDX__MIN_INDX__SHIFT         = 0x00000000;
    constexpr unsigned int GE_MULTI_PRIM_IB_RESET_EN__MATCH_ALL_BITS__SHIFT = 0x00000001;
    constexpr unsigned int GE_MULTI_PRIM_IB_RESET_EN__RESET_EN__SHIFT = 0x00000000;
    constexpr unsigned int GE_NGG_SUBGRP_CNTL__PRIM_AMP_FACTOR__SHIFT = 0x00000000;
    constexpr unsigned int GE_NGG_SUBGRP_CNTL__THDS_PER_SUBGRP__SHIFT = 0x00000009;
    constexpr unsigned int GE_PC_ALLOC__NUM_PC_LINES__SHIFT         = 0x00000001;
    constexpr unsigned int GE_PC_ALLOC__OVERSUB_EN__SHIFT           = 0x00000000;
    constexpr unsigned int GE_PC_CNTL__EN_GEN_0_1_LATE_ALLOC__SHIFT = 0x00000010;
    constexpr unsigned int GE_PC_CNTL__PC_SIZE__SHIFT               = 0x00000000;
    constexpr unsigned int GE_PRIV_CONTROL__CLAMP_PRIMGRP_SIZE__SHIFT = 0x00000001;
    constexpr unsigned int GE_PRIV_CONTROL__DISCARD_LEGACY__SHIFT   = 0x00000000;
    constexpr unsigned int GE_PRIV_CONTROL__RESET_ON_PIPELINE_CHANGE__SHIFT = 0x0000000a;
    constexpr unsigned int GE_STEREO_CNTL__EN_STEREO__SHIFT         = 0x00000008;
    constexpr unsigned int GE_STEREO_CNTL__RT_SLICE__SHIFT          = 0x00000000;
    constexpr unsigned int GE_STEREO_CNTL__VIEWPORT__SHIFT          = 0x00000003;
    constexpr unsigned int GE_USER_VGPR1__DATA__SHIFT               = 0x00000000;
    constexpr unsigned int GE_USER_VGPR2__DATA__SHIFT               = 0x00000000;
    constexpr unsigned int GE_USER_VGPR3__DATA__SHIFT               = 0x00000000;
    constexpr unsigned int GFX_PIPE_PRIORITY__HP_PIPE_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x00000018;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x0000001c;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GL1A_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GL1A_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GL1A_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GL1A_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GL1A_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GL1A_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x00000018;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x0000001c;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GL1C_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GL1C_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GL1C_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GL1C_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GL1C_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GL1C_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GL1_ARB_CTRL__NUM_MEM_PIPES__SHIFT       = 0x00000000;
    constexpr unsigned int GL1_ARB_STATUS__REQ_ARB_BUSY__SHIFT      = 0x00000000;
    constexpr unsigned int GL1_ARB_STATUS__RET_ARB_BUSY__SHIFT      = 0x00000001;
    constexpr unsigned int GL1_DRAM_BURST_CTRL__BURST_DISABLE__SHIFT = 0x00000003;
    constexpr unsigned int GL1_DRAM_BURST_CTRL__MAX_DRAM_BURST__SHIFT = 0x00000000;
    constexpr unsigned int GL1_DRAM_BURST_MASK__DRAM_BURST_ADDR_MASK__SHIFT = 0x00000000;
    constexpr unsigned int GL1_PIPE_STEER__PIPE0__SHIFT             = 0x00000000;
    constexpr unsigned int GL1_PIPE_STEER__PIPE1__SHIFT             = 0x00000002;
    constexpr unsigned int GL1_PIPE_STEER__PIPE2__SHIFT             = 0x00000004;
    constexpr unsigned int GL1_PIPE_STEER__PIPE3__SHIFT             = 0x00000006;
    constexpr unsigned int GL2A_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x00000018;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x0000001c;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT = 0x00000018;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT = 0x0000001c;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GL2A_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GL2A_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GL2A_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GL2A_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x00000018;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x0000001c;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT = 0x00000018;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT = 0x0000001c;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GL2C_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GL2C_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GL2C_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GL2C_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GL2_PIPE_STEER_0__PIPE_0_TO_CHAN_IN_Q0__SHIFT = 0x00000000;
    constexpr unsigned int GL2_PIPE_STEER_0__PIPE_0_TO_CHAN_IN_Q1__SHIFT = 0x00000010;
    constexpr unsigned int GL2_PIPE_STEER_0__PIPE_1_TO_CHAN_IN_Q0__SHIFT = 0x00000004;
    constexpr unsigned int GL2_PIPE_STEER_0__PIPE_1_TO_CHAN_IN_Q1__SHIFT = 0x00000014;
    constexpr unsigned int GL2_PIPE_STEER_0__PIPE_2_TO_CHAN_IN_Q0__SHIFT = 0x00000008;
    constexpr unsigned int GL2_PIPE_STEER_0__PIPE_2_TO_CHAN_IN_Q1__SHIFT = 0x00000018;
    constexpr unsigned int GL2_PIPE_STEER_0__PIPE_3_TO_CHAN_IN_Q0__SHIFT = 0x0000000c;
    constexpr unsigned int GL2_PIPE_STEER_0__PIPE_3_TO_CHAN_IN_Q1__SHIFT = 0x0000001c;
    constexpr unsigned int GL2_PIPE_STEER_1__PIPE_0_TO_CHAN_IN_Q2__SHIFT = 0x00000000;
    constexpr unsigned int GL2_PIPE_STEER_1__PIPE_0_TO_CHAN_IN_Q3__SHIFT = 0x00000010;
    constexpr unsigned int GL2_PIPE_STEER_1__PIPE_1_TO_CHAN_IN_Q2__SHIFT = 0x00000004;
    constexpr unsigned int GL2_PIPE_STEER_1__PIPE_1_TO_CHAN_IN_Q3__SHIFT = 0x00000014;
    constexpr unsigned int GL2_PIPE_STEER_1__PIPE_2_TO_CHAN_IN_Q2__SHIFT = 0x00000008;
    constexpr unsigned int GL2_PIPE_STEER_1__PIPE_2_TO_CHAN_IN_Q3__SHIFT = 0x00000018;
    constexpr unsigned int GL2_PIPE_STEER_1__PIPE_3_TO_CHAN_IN_Q2__SHIFT = 0x0000000c;
    constexpr unsigned int GL2_PIPE_STEER_1__PIPE_3_TO_CHAN_IN_Q3__SHIFT = 0x0000001c;
    constexpr unsigned int GRBM_CAM_DATA_UPPER__CAM_ADDR__SHIFT     = 0x00000000;
    constexpr unsigned int GRBM_CAM_DATA_UPPER__CAM_REMAPADDR__SHIFT = 0x00000010;
    constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SA_BROADCAST_WRITES__SHIFT = 0x0000001d;
    constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SA_INDEX__SHIFT  = 0x00000008;
    constexpr unsigned int GRBM_GFX_INDEX__SA_BROADCAST_WRITES__SHIFT = 0x0000001d;
    constexpr unsigned int GRBM_GFX_INDEX__SA_INDEX__SHIFT          = 0x00000008;
    constexpr unsigned int GRBM_HYP_CAM_DATA_UPPER__CAM_ADDR__SHIFT = 0x00000000;
    constexpr unsigned int GRBM_HYP_CAM_DATA_UPPER__CAM_REMAPADDR__SHIFT = 0x00000010;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__CH_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000004;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__GL1CC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000008;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__GL2CC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000002;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__GUS_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000007;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__PH_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000005;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__PMM_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000006;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__SDMA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000003;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__UTCL1_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000001;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__GE_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001c;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__TCP_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001b;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__CH_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000004;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__GL1CC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000008;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__GL2CC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000002;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__GUS_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000007;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__PH_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000005;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__PMM_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000006;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__SDMA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000003;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__UTCL1_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000001;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__GE_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001c;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__TCP_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001b;
    constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__GL1CC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000019;
    constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__TCP_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000018;
    constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__UTCL1_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000017;
    constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__GL1CC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000019;
    constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__TCP_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000018;
    constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__UTCL1_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000017;
    constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__GL1CC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000019;
    constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__TCP_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000018;
    constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__UTCL1_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000017;
    constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__GL1CC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000019;
    constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__TCP_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000018;
    constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__UTCL1_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000017;
    constexpr unsigned int GRBM_SOFT_RESET__SOFT_RESET_SDMA0__SHIFT = 0x00000017;
    constexpr unsigned int GRBM_SOFT_RESET__SOFT_RESET_SDMA1__SHIFT = 0x00000018;
    constexpr unsigned int GRBM_STATUS2__SDMA0_RQ_PENDING__SHIFT    = 0x00000016;
    constexpr unsigned int GRBM_STATUS2__SDMA1_RQ_PENDING__SHIFT    = 0x00000017;
    constexpr unsigned int GRBM_STATUS2__SDMA_BUSY__SHIFT           = 0x00000015;
    constexpr unsigned int GRBM_STATUS3__CH_BUSY__SHIFT             = 0x0000000e;
    constexpr unsigned int GRBM_STATUS3__GL1CC_BUSY__SHIFT          = 0x00000010;
    constexpr unsigned int GRBM_STATUS3__GL2CC_BUSY__SHIFT          = 0x0000000f;
    constexpr unsigned int GRBM_STATUS3__GRBM_CPF_INTR_CREDIT_PENDING__SHIFT = 0x00000007;
    constexpr unsigned int GRBM_STATUS3__GRBM_RLC_INTR_CREDIT_PENDING__SHIFT = 0x00000005;
    constexpr unsigned int GRBM_STATUS3__GRBM_UTCL2_INTR_CREDIT_PENDING__SHIFT = 0x00000006;
    constexpr unsigned int GRBM_STATUS3__GUS_BUSY__SHIFT            = 0x0000001d;
    constexpr unsigned int GRBM_STATUS3__GUS_LINK_BUSY__SHIFT       = 0x0000001c;
    constexpr unsigned int GRBM_STATUS3__MESPIPE0_RQ_PENDING__SHIFT = 0x00000008;
    constexpr unsigned int GRBM_STATUS3__MESPIPE1_RQ_PENDING__SHIFT = 0x00000009;
    constexpr unsigned int GRBM_STATUS3__MESPIPE2_RQ_PENDING__SHIFT = 0x0000000a;
    constexpr unsigned int GRBM_STATUS3__MESPIPE3_RQ_PENDING__SHIFT = 0x0000000b;
    constexpr unsigned int GRBM_STATUS3__PH_BUSY__SHIFT             = 0x0000000d;
    constexpr unsigned int GRBM_STATUS3__PMM_BUSY__SHIFT            = 0x0000001f;
    constexpr unsigned int GRBM_STATUS3__UTCL1_BUSY__SHIFT          = 0x0000001e;
    constexpr unsigned int GRBM_STATUS_SE0__GL1CC_BUSY__SHIFT       = 0x00000005;
    constexpr unsigned int GRBM_STATUS_SE0__TCP_BUSY__SHIFT         = 0x00000004;
    constexpr unsigned int GRBM_STATUS_SE0__UTCL1_BUSY__SHIFT       = 0x00000003;
    constexpr unsigned int GRBM_STATUS_SE1__GL1CC_BUSY__SHIFT       = 0x00000005;
    constexpr unsigned int GRBM_STATUS_SE1__TCP_BUSY__SHIFT         = 0x00000004;
    constexpr unsigned int GRBM_STATUS_SE1__UTCL1_BUSY__SHIFT       = 0x00000003;
    constexpr unsigned int GRBM_STATUS_SE2__GL1CC_BUSY__SHIFT       = 0x00000005;
    constexpr unsigned int GRBM_STATUS_SE2__TCP_BUSY__SHIFT         = 0x00000004;
    constexpr unsigned int GRBM_STATUS_SE2__UTCL1_BUSY__SHIFT       = 0x00000003;
    constexpr unsigned int GRBM_STATUS_SE3__GL1CC_BUSY__SHIFT       = 0x00000005;
    constexpr unsigned int GRBM_STATUS_SE3__TCP_BUSY__SHIFT         = 0x00000004;
    constexpr unsigned int GRBM_STATUS_SE3__UTCL1_BUSY__SHIFT       = 0x00000003;
    constexpr unsigned int GRBM_STATUS__GE_BUSY_NO_DMA__SHIFT       = 0x00000010;
    constexpr unsigned int GRBM_STATUS__GE_BUSY__SHIFT              = 0x00000015;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__EN_INST_OPT_ADV__SHIFT = 0x00000016;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__EN_INST_OPT_BASIC__SHIFT = 0x00000015;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__HW_USE_ONLY__SHIFT = 0x00000017;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__PARTIAL_ES_WAVE_ON__SHIFT = 0x00000012;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__PARTIAL_VS_WAVE_ON__SHIFT = 0x00000010;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__PRIMGROUP_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__SWITCH_ON_EOI__SHIFT = 0x00000013;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__SWITCH_ON_EOP__SHIFT = 0x00000011;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__WD_SWITCH_ON_EOP__SHIFT = 0x00000014;
    constexpr unsigned int IA_UTCL1_CNTL__MTYPE_OVERRIDE__SHIFT     = 0x0000001d;
    constexpr unsigned int IA_UTCL1_STATUS_2__FAULT_DETECTED__SHIFT = 0x00000005;
    constexpr unsigned int IA_UTCL1_STATUS_2__FAULT_UTCL1ID__SHIFT  = 0x00000008;
    constexpr unsigned int IA_UTCL1_STATUS_2__IA_ADC_BUSY__SHIFT    = 0x00000004;
    constexpr unsigned int IA_UTCL1_STATUS_2__IA_BUSY__SHIFT        = 0x00000000;
    constexpr unsigned int IA_UTCL1_STATUS_2__IA_DMA_BUSY__SHIFT    = 0x00000001;
    constexpr unsigned int IA_UTCL1_STATUS_2__IA_DMA_REQ_BUSY__SHIFT = 0x00000002;
    constexpr unsigned int IA_UTCL1_STATUS_2__IA_GRP_BUSY__SHIFT    = 0x00000003;
    constexpr unsigned int IA_UTCL1_STATUS_2__PRT_DETECTED__SHIFT   = 0x00000007;
    constexpr unsigned int IA_UTCL1_STATUS_2__PRT_UTCL1ID__SHIFT    = 0x00000018;
    constexpr unsigned int IA_UTCL1_STATUS_2__RETRY_DETECTED__SHIFT = 0x00000006;
    constexpr unsigned int IA_UTCL1_STATUS_2__RETRY_UTCL1ID__SHIFT  = 0x00000010;
    constexpr unsigned int PA_CL_CNTL_STATUS__CL_BUSY__SHIFT        = 0x0000001f;
    constexpr unsigned int PA_CL_ENHANCE__DISABLE_PA_PH_INTF_FINE_CLOCK_GATE__SHIFT = 0x00000016;
    constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_LINE_WIDTH__SHIFT = 0x0000001b;
    constexpr unsigned int PA_PH_ENHANCE__DISABLE_FOPKT_SCAN_POST_RESET__SHIFT = 0x00000006;
    constexpr unsigned int PA_PH_ENHANCE__DISABLE_FOPKT__SHIFT      = 0x00000005;
    constexpr unsigned int PA_PH_ENHANCE__DISABLE_PH_PERF_REG_FGCG__SHIFT = 0x00000009;
    constexpr unsigned int PA_PH_ENHANCE__DISABLE_PH_SC_INTF_CLKEN_CLOCK_GATE__SHIFT = 0x00000007;
    constexpr unsigned int PA_PH_ENHANCE__DISABLE_PH_SC_INTF_FINE_CLOCK_GATE__SHIFT = 0x00000004;
    constexpr unsigned int PA_PH_ENHANCE__ECO_SPARE0__SHIFT         = 0x00000000;
    constexpr unsigned int PA_PH_ENHANCE__ECO_SPARE1__SHIFT         = 0x00000001;
    constexpr unsigned int PA_PH_ENHANCE__ECO_SPARE2__SHIFT         = 0x00000002;
    constexpr unsigned int PA_PH_ENHANCE__ECO_SPARE3__SHIFT         = 0x00000003;
    constexpr unsigned int PA_PH_ENHANCE__ENABLE_PH_INTF_CLKEN_STRETCH__SHIFT = 0x0000000a;
    constexpr unsigned int PA_PH_INTERFACE_FIFO_SIZE__PA_PH_IF_FIFO_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_INTERFACE_FIFO_SIZE__PH_SC_IF_FIFO_SIZE__SHIFT = 0x00000010;
    constexpr unsigned int PA_PH_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER4_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER4_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER4_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER5_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER5_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER5_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER6_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER6_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER6_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER7_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER7_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER7_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int PA_SC_BC_WAVE_BREAK__MAX_DEALLOCS_IN_WAVE__SHIFT = 0x00000000;
    constexpr unsigned int PA_SC_BC_WAVE_BREAK__MAX_FPOVS_IN_WAVE__SHIFT = 0x00000010;
    constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_MAPPING_MODE__SHIFT = 0x0000001d;
    constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__BINNING_MODE__SHIFT = 0x00000000;
    constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__CONTEXT_STATES_PER_BIN__SHIFT = 0x0000000a;
    constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__DIRECT_OVERRIDE_MODE__SHIFT = 0x0000001b;
    constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__FPOVS_PER_BATCH__SHIFT = 0x00000013;
    constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__OVERRIDE__SHIFT = 0x0000001c;
    constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__PERSISTENT_STATES_PER_BIN__SHIFT = 0x0000000d;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__BIN_CONF_OVERRIDE_CHECK__SHIFT = 0x0000001a;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__RESERVED_35__SHIFT = 0x00000006;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__RESERVED_41__SHIFT = 0x00000012;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__DRAW_DONE__SHIFT = 0x0000001e;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__RESERVED_50__SHIFT = 0x00000004;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_DRAW__SHIFT = 0x0000000c;
    constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNCERTAINTY_REGION_MULT__SHIFT = 0x00000019;
    constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNCERTAINTY_REGION_PBB_MULT__SHIFT = 0x0000001b;
    constexpr unsigned int PA_SC_ENHANCE_1__DEBUG_PIXEL_PICKER_COUNT_PIXELS__SHIFT = 0x0000000d;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_BREAK_BATCH_ON_GFX_PIPELINE_RESET__SHIFT = 0x00000012;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_BREAK_BATCH_ON_GFX_PIPE_SWITCH__SHIFT = 0x00000008;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_EXPOSED_GT_DETAIL_RATE_TILE_COV_ADJ__SHIFT = 0x0000000f;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_FULL_TILE_WAVE_BREAK__SHIFT = 0x00000009;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_PACKER_GRAD_FDCE_ENHANCE__SHIFT = 0x0000000c;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_PBB_EOP_INSERTION_FOR_MIXED_BINNING_AND_IMMEDIATE__SHIFT = 0x00000018;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_SC_BCI_INTF_EARLY_WAKEUP__SHIFT = 0x0000000e;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_SC_DBR_DATAPATH_FGCG__SHIFT = 0x00000015;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_SC_SPI_INTF_EARLY_WAKEUP__SHIFT = 0x0000000d;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_BLOCKING_WRITES_OF_GEN1_REG__SHIFT = 0x00000013;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_BLOCKING_WRITES_OF_GEN2_REG__SHIFT = 0x00000014;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_FPOV_WAVE_BREAK__SHIFT = 0x00000005;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_LPOV_WAVE_BREAK__SHIFT = 0x00000004;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_SC_SEND_DB_VPZ_FOR_EN_PRIM_PAYLOAD__SHIFT = 0x00000007;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_VPZ_INJECTION_BEFORE_NULL_PRIMS__SHIFT = 0x0000000a;
    constexpr unsigned int PA_SC_ENHANCE_2__PBB_MAIN_CLK_REG_BUSY_WAKEUP__SHIFT = 0x00000011;
    constexpr unsigned int PA_SC_ENHANCE_2__PBB_TIMEOUT_THRESHOLD_MODE__SHIFT = 0x0000000b;
    constexpr unsigned int PA_SC_ENHANCE_2__PBB_WARP_CLK_MAIN_CLK_WAKEUP__SHIFT = 0x00000010;
    constexpr unsigned int PA_SC_ENHANCE_2__PROCESS_RESET_FORCE_STILE_MASK_TO_ZERO__SHIFT = 0x00000017;
    constexpr unsigned int PA_SC_NGG_MODE_CNTL__MAX_FPOVS_IN_WAVE__SHIFT = 0x00000010;
    constexpr unsigned int PA_SC_PBB_OVERRIDE_FLAG__OVERRIDE__SHIFT = 0x00000000;
    constexpr unsigned int PA_SC_PBB_OVERRIDE_FLAG__PIPE_ID__SHIFT  = 0x00000001;
    constexpr unsigned int PA_SC_RASTER_CONFIG_1__SE_PAIR_YSEL__SHIFT = 0x00000004;
    constexpr unsigned int PA_SC_RASTER_CONFIG__SE_YSEL__SHIFT      = 0x0000001c;
    constexpr unsigned int PA_SC_SHADER_CONTROL__WAVE_BREAK_REGION_SIZE__SHIFT = 0x00000005;
    constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__FORCE_TILE_STEERING_OVERRIDE_USE__SHIFT = 0x0000001f;
    constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__SA_SELECT__SHIFT = 0x00000008;
    constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__NUM_PACKER_PER_SC__SHIFT = 0x00000014;
    constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__NUM_RB_PER_SC__SHIFT = 0x00000010;
    constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__NUM_SC__SHIFT = 0x0000000c;
    constexpr unsigned int PA_STATE_STEREO_X__STEREO_X_OFFSET__SHIFT = 0x00000000;
    constexpr unsigned int PA_STEREO_CNTL__RT_SLICE_MODE__SHIFT     = 0x00000005;
    constexpr unsigned int PA_STEREO_CNTL__RT_SLICE_OFFSET__SHIFT   = 0x00000008;
    constexpr unsigned int PA_STEREO_CNTL__STEREO_MODE__SHIFT       = 0x00000001;
    constexpr unsigned int PA_STEREO_CNTL__VP_ID_MODE__SHIFT        = 0x00000010;
    constexpr unsigned int PA_STEREO_CNTL__VP_ID_OFFSET__SHIFT      = 0x00000013;
    constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int PA_SU_SC_MODE_CNTL__KEEP_TOGETHER_ENABLE__SHIFT = 0x00000018;
    constexpr unsigned int PMM_GENERAL_CNTL__PMM_ALOG_IH_IDLE__SHIFT = 0x00000002;
    constexpr unsigned int PMM_GENERAL_CNTL__PMM_DISABLE__SHIFT     = 0x00000001;
    constexpr unsigned int PMM_GENERAL_CNTL__PMM_MODE__SHIFT        = 0x00000000;
    constexpr unsigned int RLC_SPM_DESER_START_SKEW__DESER_START_SKEW__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_DESER_START_SKEW__RESERVED__SHIFT = 0x00000007;
    constexpr unsigned int RLC_SPM_GLB_SAMPLEDELAY_IND_ADDR__GLB_SAMPLEDELAY_INDEX__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_GLB_SAMPLEDELAY_IND_DATA__data__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_GLB_SAMPLEDELAY_IND_DATA__RESERVED__SHIFT = 0x00000007;
    constexpr unsigned int RLC_SPM_GLOBALS_MUXSEL_SKEW__GLOBALS_MUXSEL_SKEW__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_GLOBALS_MUXSEL_SKEW__RESERVED__SHIFT = 0x00000007;
    constexpr unsigned int RLC_SPM_GLOBALS_SAMPLE_SKEW__GLOBALS_SAMPLE_SKEW__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_GLOBALS_SAMPLE_SKEW__RESERVED__SHIFT = 0x00000007;
    constexpr unsigned int RLC_SPM_GLOBAL_MUXSEL_ADDR__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_INT_INFO_1__INTERRUPT_INFO_1__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_INT_INFO_2__INTERRUPT_ID__SHIFT  = 0x00000010;
    constexpr unsigned int RLC_SPM_INT_INFO_2__INTERRUPT_INFO_2__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_INT_INFO_2__RESERVED__SHIFT      = 0x00000018;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_BC__SHIFT       = 0x0000000c;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_FED__SHIFT      = 0x00000007;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_MTYPE_OVER__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_MTYPE__SHIFT    = 0x00000009;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_NOFILL__SHIFT   = 0x0000000f;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_PERF_CNTR__SHIFT = 0x00000006;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_VOL__SHIFT      = 0x0000000e;
    constexpr unsigned int RLC_SPM_PERFMON_CNTL__RESERVED1__SHIFT   = 0x00000000;
    constexpr unsigned int RLC_SPM_PERFMON_GLB_SEGMENT_SIZE__GLOBAL_NUM_LINE__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_PERFMON_GLB_SEGMENT_SIZE__PERFMON_SEGMENT_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_PERFMON_GLB_SEGMENT_SIZE__RESERVED__SHIFT = 0x00000010;
    constexpr unsigned int RLC_SPM_PERFMON_SE3TO0_SEGMENT_SIZE__SE0_NUM_LINE__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_PERFMON_SE3TO0_SEGMENT_SIZE__SE1_NUM_LINE__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_PERFMON_SE3TO0_SEGMENT_SIZE__SE2_NUM_LINE__SHIFT = 0x00000010;
    constexpr unsigned int RLC_SPM_PERFMON_SE3TO0_SEGMENT_SIZE__SE3_NUM_LINE__SHIFT = 0x00000018;
    constexpr unsigned int RLC_SPM_SAMPLE_CNT__COUNT__SHIFT         = 0x00000000;
    constexpr unsigned int RLC_SPM_SEGMENT_THRESHOLD__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_SE_MUXSEL_ADDR__RESERVED__SHIFT  = 0x00000009;
    constexpr unsigned int RLC_SPM_SE_MUXSEL_SKEW__RESERVED__SHIFT  = 0x00000007;
    constexpr unsigned int RLC_SPM_SE_MUXSEL_SKEW__SE_MUXSEL_SKEW__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_SE_SAMPLEDELAY_IND_ADDR__SE_SAMPLEDELAY_INDEX__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_SE_SAMPLEDELAY_IND_DATA__data__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_SE_SAMPLEDELAY_IND_DATA__RESERVED__SHIFT = 0x00000007;
    constexpr unsigned int RLC_SPM_SE_SAMPLE_SKEW__RESERVED__SHIFT  = 0x00000007;
    constexpr unsigned int RLC_SPM_SE_SAMPLE_SKEW__SE_SAMPLE_SKEW__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_THREAD_TRACE_CTRL__THREAD_TRACE_INT_EN__SHIFT = 0x00000000;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB0_MODE_OVERRIDE_EN__SHIFT = 0x00000002;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_BREAK_LOB_ON_IDLEIN__SHIFT = 0x00000011;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_MODE_OVERRIDE_EN__SHIFT = 0x00000012;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_MODE__SHIFT   = 0x0000001e;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_STALL_TIMER_OVERRIDE__SHIFT = 0x00000014;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_STALL_TIMER_START_VALUE__SHIFT = 0x00000016;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_STALL__SHIFT  = 0x00000010;
    constexpr unsigned int RMI_GENERAL_CNTL1__ARBITER_ADDRESS_CHANGE_ENABLE__SHIFT = 0x0000000e;
    constexpr unsigned int RMI_GENERAL_CNTL1__LAST_OF_BURST_INSERTION_DISABLE__SHIFT = 0x0000000f;
    constexpr unsigned int RMI_GENERAL_CNTL1__POLICY_OVERRIDE__SHIFT = 0x0000000b;
    constexpr unsigned int RMI_GENERAL_CNTL1__TCIW1_64B_RD_STALL_MODE__SHIFT = 0x00000006;
    constexpr unsigned int RMI_GENERAL_CNTL1__UTCL1_PROBE0_RR_ARB_BURST_HINT_EN__SHIFT = 0x0000000c;
    constexpr unsigned int RMI_GENERAL_CNTL1__UTCL1_PROBE1_RR_ARB_BURST_HINT_EN__SHIFT = 0x0000000d;
    constexpr unsigned int RMI_GENERAL_CNTL__SKID_FIFO_1_OVERFLOW_ERROR_MASK__SHIFT = 0x0000001c;
    constexpr unsigned int RMI_GENERAL_CNTL__SKID_FIFO_1_UNDERFLOW_ERROR_MASK__SHIFT = 0x0000001d;
    constexpr unsigned int RMI_GENERAL_STATUS__SKID_FIFO_1_OVERFLOW_ERROR__SHIFT = 0x00000003;
    constexpr unsigned int RMI_GENERAL_STATUS__SKID_FIFO_1_UNDERFLOW_ERROR__SHIFT = 0x00000004;
    constexpr unsigned int RMI_GENERAL_STATUS__TCIW1_PRT_FIFO_BUSY__SHIFT = 0x0000000d;
    constexpr unsigned int RMI_GENERAL_STATUS__TCIW_FRMTR1_BUSY__SHIFT = 0x0000000e;
    constexpr unsigned int RMI_GENERAL_STATUS__TCIW_RTN_FRMTR1_BUSY__SHIFT = 0x0000000f;
    constexpr unsigned int RMI_GENERAL_STATUS__UTC_PROBE1_BUSY__SHIFT = 0x00000012;
    constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_EVENT_WINDOW_MASK1__SHIFT = 0x00000008;
    constexpr unsigned int RMI_PROBE_POP_LOGIC_CNTL__EXT_LAT_FIFO_1_MAX_DEPTH__SHIFT = 0x0000000a;
    constexpr unsigned int RMI_PROBE_POP_LOGIC_CNTL__XLAT_COMBINE1_DIS__SHIFT = 0x00000011;
    constexpr unsigned int RMI_RB_GLX_CID_MAP__CB_CMASK_MAP__SHIFT  = 0x00000008;
    constexpr unsigned int RMI_RB_GLX_CID_MAP__CB_COLOR_MAP__SHIFT  = 0x00000000;
    constexpr unsigned int RMI_RB_GLX_CID_MAP__CB_DCC_MAP__SHIFT    = 0x0000000c;
    constexpr unsigned int RMI_RB_GLX_CID_MAP__CB_FMASK_MAP__SHIFT  = 0x00000004;
    constexpr unsigned int RMI_RB_GLX_CID_MAP__DB_S_MAP__SHIFT      = 0x00000014;
    constexpr unsigned int RMI_RB_GLX_CID_MAP__DB_TILE_MAP__SHIFT   = 0x00000018;
    constexpr unsigned int RMI_RB_GLX_CID_MAP__DB_ZPCPSD_MAP__SHIFT = 0x0000001c;
    constexpr unsigned int RMI_RB_GLX_CID_MAP__DB_Z_MAP__SHIFT      = 0x00000010;
    constexpr unsigned int RMI_SCOREBOARD_CNTL__COMPLETE_RB1_FLUSH__SHIFT = 0x00000002;
    constexpr unsigned int RMI_SCOREBOARD_CNTL__REQ_IN_RE_EN_AFTER_FLUSH_RB1__SHIFT = 0x00000003;
    constexpr unsigned int RMI_SCOREBOARD_CNTL__TIME_STAMP_FLUSH_RB1__SHIFT = 0x00000004;
    constexpr unsigned int RMI_SCOREBOARD_STATUS0__COUNTER_SELECT__SHIFT = 0x00000016;
    constexpr unsigned int RMI_SCOREBOARD_STATUS1__COM_FLUSH_IN_PROG_RB1__SHIFT = 0x0000001d;
    constexpr unsigned int RMI_SCOREBOARD_STATUS1__RUNNING_CNT_OVERFLOW_RB1__SHIFT = 0x0000001c;
    constexpr unsigned int RMI_SCOREBOARD_STATUS1__RUNNING_CNT_RB1__SHIFT = 0x0000000f;
    constexpr unsigned int RMI_SCOREBOARD_STATUS1__RUNNING_CNT_UNDERFLOW_RB1__SHIFT = 0x0000001b;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__COM_FLUSH_DONE_RB1__SHIFT = 0x0000001a;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__SNAPSHOT_CNT_RB1__SHIFT = 0x0000000d;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__SNAPSHOT_CNT_UNDERFLOW_RB1__SHIFT = 0x00000019;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__TIME_STAMP_FLUSH_DONE_RB1__SHIFT = 0x0000001f;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__TIME_STAMP_FLUSH_IN_PROG_RB1__SHIFT = 0x0000001d;
    constexpr unsigned int RMI_SPARE__ARBITER_ADDRESS_MASK__SHIFT   = 0x00000010;
    constexpr unsigned int RMI_SPARE__RMI_2_GL1_128B_READ_DISABLE__SHIFT = 0x00000001;
    constexpr unsigned int RMI_SPARE__RMI_2_GL1_REPEATER_FGCG_DISABLE__SHIFT = 0x00000002;
    constexpr unsigned int RMI_SUBBLOCK_STATUS0__UTC_EXT_LAT_HID_FIFO_EMPTY_PROBE1__SHIFT = 0x00000011;
    constexpr unsigned int RMI_SUBBLOCK_STATUS0__UTC_EXT_LAT_HID_FIFO_FULL_PROBE1__SHIFT = 0x00000010;
    constexpr unsigned int RMI_SUBBLOCK_STATUS0__UTC_EXT_LAT_HID_FIFO_NUM_USED_PROBE1__SHIFT = 0x00000009;
    constexpr unsigned int RMI_SUBBLOCK_STATUS1__SKID_FIFO_1_FREE_SPACE__SHIFT = 0x0000000a;
    constexpr unsigned int RMI_SUBBLOCK_STATUS1__TCIW1_INFLIGHT_CNT__SHIFT = 0x00000014;
    constexpr unsigned int RMI_SUBBLOCK_STATUS2__PRT_FIFO_1_NUM_USED__SHIFT = 0x00000009;
    constexpr unsigned int RMI_SUBBLOCK_STATUS3__SKID_FIFO_1_FREE_SPACE_TOTAL__SHIFT = 0x0000000a;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__ALL_FAULT_RET1_DATA__SHIFT = 0x0000001f;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__RMI_IN1_REORDER_DIS__SHIFT = 0x0000001d;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__SKID_FIFO_1_FREE_SPACE_DELTA_UPDATE__SHIFT = 0x0000001b;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__SKID_FIFO_1_FREE_SPACE_DELTA__SHIFT = 0x00000013;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__TCIW1_MAX_ALLOWED_INFLIGHT_REQ__SHIFT = 0x00000009;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__TCIW1_REQ_SAFE_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__WR_COMBINE1_DIS_AT_LAST_OF_BURST__SHIFT = 0x0000001e;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__WR_COMBINE1_DIS_OVERRIDE__SHIFT = 0x00000000;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__WR_COMBINE1_TIME_OUT_WINDOW__SHIFT = 0x00000001;
    constexpr unsigned int RMI_UTCL1_CNTL2__GPUVM_16K_DEFAULT__SHIFT = 0x0000001d;
    constexpr unsigned int RMI_UTCL1_CNTL2__LINE_INVALIDATE_OPT__SHIFT = 0x0000001c;
    constexpr unsigned int RMI_UTCL1_CNTL2__PERM_MODE_OVRD__SHIFT   = 0x0000001b;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB0_MODE_OVERRIDE_EN__SHIFT = 0x00000005;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_BREAK_LOB_ON_IDLEIN__SHIFT = 0x00000014;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_BREAK_LOB_ON_WEIGHTEDRR__SHIFT = 0x00000012;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_MODE_OVERRIDE_EN__SHIFT = 0x00000015;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_MODE__SHIFT = 0x00000010;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_STALL_TIMER_OVERRIDE__SHIFT = 0x00000016;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_STALL_TIMER_START_VALUE__SHIFT = 0x00000018;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_STALL__SHIFT = 0x00000013;
    constexpr unsigned int SDMA0_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int SH_MEM_CONFIG__ALIGNMENT_MODE__SHIFT     = 0x00000002;
    constexpr unsigned int SH_MEM_CONFIG__DEFAULT_MTYPE__SHIFT      = 0x00000004;
    constexpr unsigned int SH_MEM_CONFIG__ICACHE_USE_GL1__SHIFT     = 0x00000012;
    constexpr unsigned int SH_MEM_CONFIG__INITIAL_INST_PREFETCH__SHIFT = 0x0000000e;
    constexpr unsigned int SPI_CONFIG_CNTL_1__MAX_VTX_SYNC_CNT__SHIFT = 0x00000010;
    constexpr unsigned int SPI_CONFIG_CNTL_1__PC_LIMIT_ENABLE__SHIFT = 0x00000005;
    constexpr unsigned int SPI_DEBUG_CNTL_2__ECO_SPARE_0__SHIFT     = 0x00000000;
    constexpr unsigned int SPI_DEBUG_CNTL_2__ECO_SPARE_1__SHIFT     = 0x00000001;
    constexpr unsigned int SPI_DEBUG_CNTL_2__ECO_SPARE_2__SHIFT     = 0x00000002;
    constexpr unsigned int SPI_DEBUG_CNTL_2__ECO_SPARE_3__SHIFT     = 0x00000003;
    constexpr unsigned int SPI_DEBUG_CNTL_2__ECO_SPARE_4__SHIFT     = 0x00000004;
    constexpr unsigned int SPI_DEBUG_CNTL_2__ECO_SPARE_5__SHIFT     = 0x00000005;
    constexpr unsigned int SPI_DEBUG_CNTL_2__ECO_SPARE_6__SHIFT     = 0x00000006;
    constexpr unsigned int SPI_DEBUG_CNTL_2__ECO_SPARE_7__SHIFT     = 0x00000007;
    constexpr unsigned int SPI_DSM_CNTL2__SPI_SR_MEM_INJECT_DELAY__SHIFT = 0x00000003;
    constexpr unsigned int SPI_FEATURE_CTRL__ACTIVE_HARD_LOCK_LIMIT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_FEATURE_CTRL__ALLOCATION_RATE_THROTTLE_THRESHOLD__SHIFT = 0x00000002;
    constexpr unsigned int SPI_FEATURE_CTRL__BUS_ACTIVITY_THRESHOLD_ALLOC_STALL_EN__SHIFT = 0x00000013;
    constexpr unsigned int SPI_FEATURE_CTRL__BUS_ACTIVITY_THRESHOLD__SHIFT = 0x00000014;
    constexpr unsigned int SPI_FEATURE_CTRL__CU_LOCKING_FAIRNESS_DISABLE__SHIFT = 0x00000000;
    constexpr unsigned int SPI_FEATURE_CTRL__LR_IMBALANCE_THRESHOLD__SHIFT = 0x0000000c;
    constexpr unsigned int SPI_FEATURE_CTRL__RA_PIPE_DEPTH_THRESHOLD_ALLOC_STALL_EN__SHIFT = 0x00000012;
    constexpr unsigned int SPI_FEATURE_CTRL__TUNNELING_WAVE_LIMIT__SHIFT = 0x0000001c;
    constexpr unsigned int SPI_LB_DATA_PERWGP_WAVE_CS__ACTIVE__SHIFT = 0x00000000;
    constexpr unsigned int SPI_LB_DATA_PERWGP_WAVE_HSGS__WGP_USED_GS__SHIFT = 0x00000010;
    constexpr unsigned int SPI_LB_DATA_PERWGP_WAVE_HSGS__WGP_USED_HS__SHIFT = 0x00000000;
    constexpr unsigned int SPI_LB_DATA_PERWGP_WAVE_VSPS__WGP_USED_PS__SHIFT = 0x00000010;
    constexpr unsigned int SPI_LB_DATA_PERWGP_WAVE_VSPS__WGP_USED_VS__SHIFT = 0x00000000;
    constexpr unsigned int SPI_LB_WGP_MASK__WGP_MASK__SHIFT         = 0x00000000;
    constexpr unsigned int SPI_PG_ENABLE_STATIC_WGP_MASK__WGP_MASK__SHIFT = 0x00000000;
    constexpr unsigned int SPI_PQEV_CTRL__COMPUTE_PIPE_EN__SHIFT    = 0x00000010;
    constexpr unsigned int SPI_PQEV_CTRL__QUEUE_DURATION__SHIFT     = 0x0000000a;
    constexpr unsigned int SPI_PQEV_CTRL__SCAN_PERIOD__SHIFT        = 0x00000000;
    constexpr unsigned int SPI_PS_IN_CONTROL__PS_W32_EN__SHIFT      = 0x0000000f;
    constexpr unsigned int SPI_SHADER_IDX_FORMAT__IDX0_EXPORT_FORMAT__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_HI_ES_GS__MEM_BASE__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_HI_LS_HS__MEM_BASE__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_LO_ES_GS__MEM_BASE__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_LO_LS_HS__MEM_BASE__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__FWD_PROGRESS__SHIFT = 0x0000001a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__MEM_ORDERED__SHIFT = 0x00000019;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__WGP_MODE__SHIFT = 0x0000001b;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__FWD_PROGRESS__SHIFT = 0x00000019;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__MEM_ORDERED__SHIFT = 0x00000018;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__WGP_MODE__SHIFT = 0x0000001a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__FWD_PROGRESS__SHIFT = 0x0000001a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__MEM_ORDERED__SHIFT = 0x00000019;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__FWD_PROGRESS__SHIFT = 0x0000001c;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__MEM_ORDERED__SHIFT = 0x0000001b;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__SHARED_VGPR_CNT__SHIFT = 0x0000001c;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__USER_SGPR_MSB__SHIFT = 0x0000001b;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__EXCP_EN__SHIFT  = 0x00000009;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__LDS_SIZE__SHIFT = 0x00000012;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__OC_LDS_EN__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__SHARED_VGPR_CNT__SHIFT = 0x0000001c;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__TG_SIZE_EN__SHIFT = 0x00000008;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__USER_SGPR_MSB__SHIFT = 0x0000001b;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__SHARED_VGPR_CNT__SHIFT = 0x0000001c;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__USER_SGPR_MSB__SHIFT = 0x0000001b;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__SHARED_VGPR_CNT__SHIFT = 0x0000001c;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__USER_SGPR_MSB__SHIFT = 0x0000001b;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_GS__GROUP_FIFO_DEPTH__SHIFT = 0x0000001a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_HS__GROUP_FIFO_DEPTH__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__CU_EN__SHIFT    = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__SPI_SHADER_LATE_ALLOC_GS__SHIFT = 0x00000010;
    constexpr unsigned int SPI_SHADER_PGM_RSRC4_HS__CU_EN__SHIFT    = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC4_PS__CU_EN__SHIFT    = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC4_VS__CU_EN__SHIFT    = 0x00000000;
    constexpr unsigned int SPI_SHADER_POS_FORMAT__POS4_EXPORT_FORMAT__SHIFT = 0x00000010;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__ALLOCATION_RATE_THROTTLING_THRESHOLD__SHIFT = 0x00000011;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__GLOBAL_SCANNING_EN__SHIFT = 0x00000010;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__HARD_LOCK_HYSTERESIS__SHIFT = 0x00000009;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__HARD_LOCK_LOW_THRESHOLD__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__NUMBER_OF_REQUESTS_PER_CU__SHIFT = 0x00000001;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__PRODUCER_REQUEST_LOCKOUT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__SOFT_GROUPING_ALLOCATION_TIMEOUT__SHIFT = 0x00000005;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__SOFT_GROUPING_EN__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__ALLOCATION_RATE_THROTTLING_THRESHOLD__SHIFT = 0x00000011;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__GLOBAL_SCANNING_EN__SHIFT = 0x00000010;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__HARD_LOCK_HYSTERESIS__SHIFT = 0x00000009;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__HARD_LOCK_LOW_THRESHOLD__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__NUMBER_OF_REQUESTS_PER_CU__SHIFT = 0x00000001;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__PRODUCER_REQUEST_LOCKOUT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__SOFT_GROUPING_ALLOCATION_TIMEOUT__SHIFT = 0x00000005;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__SOFT_GROUPING_EN__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__ALLOCATION_RATE_THROTTLING_THRESHOLD__SHIFT = 0x00000011;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__GLOBAL_SCANNING_EN__SHIFT = 0x00000010;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__HARD_LOCK_HYSTERESIS__SHIFT = 0x00000009;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__HARD_LOCK_LOW_THRESHOLD__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__NUMBER_OF_REQUESTS_PER_CU__SHIFT = 0x00000001;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__PRODUCER_REQUEST_LOCKOUT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__SOFT_GROUPING_ALLOCATION_TIMEOUT__SHIFT = 0x00000005;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__SOFT_GROUPING_EN__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_VS__ALLOCATION_RATE_THROTTLING_THRESHOLD__SHIFT = 0x00000011;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_VS__GLOBAL_SCANNING_EN__SHIFT = 0x00000010;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_VS__HARD_LOCK_HYSTERESIS__SHIFT = 0x00000009;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_VS__HARD_LOCK_LOW_THRESHOLD__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_VS__NUMBER_OF_REQUESTS_PER_CU__SHIFT = 0x00000001;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_VS__PRODUCER_REQUEST_LOCKOUT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_VS__SOFT_GROUPING_ALLOCATION_TIMEOUT__SHIFT = 0x00000005;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_VS__SOFT_GROUPING_EN__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__BARRIER_LIMIT_HIERARCHY_LEVEL__SHIFT = 0x00000013;
    constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__BARRIER_LIMIT__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__LDS_LIMIT_HIERARCHY_LEVEL__SHIFT = 0x0000001c;
    constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__LDS_LIMIT__SHIFT = 0x00000014;
    constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__PERFORMANCE_LIMIT_ENABLE__SHIFT = 0x0000001f;
    constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__VGPR_PER_SIMD32__SHIFT = 0x00000005;
    constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__VGPR_WRAP_DISABLE__SHIFT = 0x0000000c;
    constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__WAVES_PER_SIMD32__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_0__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_1__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_2__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_3__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_4__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_5__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_6__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_7__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_8__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_9__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_10__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_11__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_12__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_13__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_14__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_15__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_16__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_17__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_18__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_19__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_20__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_21__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_22__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_23__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_24__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_25__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_26__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_27__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_28__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_29__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_30__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_31__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_0__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_1__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_2__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_3__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_4__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_5__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_6__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_7__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_8__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_9__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_10__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_11__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_12__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_13__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_14__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_15__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_16__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_17__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_18__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_19__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_20__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_21__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_22__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_23__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_24__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_25__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_26__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_27__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_28__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_29__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_30__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_31__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_VS_OUT_CONFIG__NO_PC_EXPORT__SHIFT   = 0x00000007;
    constexpr unsigned int SP_CONFIG__ALU_BUSY_MGCG_OVERRIDE__SHIFT = 0x00000002;
    constexpr unsigned int SP_CONFIG__DEST_CACHE_EVICT_COUNTER__SHIFT = 0x00000000;
    constexpr unsigned int SP_CONFIG__DISABLE_TRANS_COEXEC__SHIFT   = 0x00000003;
    constexpr unsigned int SQC_CACHES__L2_WB_POLICY__SHIFT          = 0x00000011;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__CLIENTID__SHIFT  = 0x00000007;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__CLIENT_INVALIDATE_ALL_VMID__SHIFT = 0x00000019;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__ENABLE_LFIFO_PRI_ARB__SHIFT = 0x00000012;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__ENABLE_PUSH_LFIFO__SHIFT = 0x00000011;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__FORCE_4K_L2_RESP__SHIFT = 0x00000000;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__FORCE_IN_ORDER__SHIFT = 0x0000001b;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__FORCE_MISS__SHIFT = 0x0000001a;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__GPUVM_64K_DEF__SHIFT = 0x00000001;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__GPUVM_PERM_MODE__SHIFT = 0x00000002;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__REDUCE_CACHE_SIZE_BY_2__SHIFT = 0x0000001e;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__REDUCE_FIFO_DEPTH_BY_2__SHIFT = 0x0000001c;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__REG_INV_ALL_VMID__SHIFT = 0x00000017;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__REG_INV_TOGGLE__SHIFT = 0x00000018;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__REG_INV_VMID__SHIFT = 0x00000013;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__RESP_FAULT_MODE__SHIFT = 0x00000005;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL1__RESP_MODE__SHIFT = 0x00000003;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__ARB_BURST_MODE__SHIFT = 0x00000010;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__DIS_EDC__SHIFT   = 0x0000000b;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__ENABLE_PERF_EVENT_RD_WR__SHIFT = 0x00000012;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__ENABLE_PERF_EVENT_VMID__SHIFT = 0x00000014;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__FORCE_FRAG_2M_TO_64K__SHIFT = 0x0000001a;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__FORCE_GPUVM_INV_ACK__SHIFT = 0x0000000f;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__FORCE_SNOOP__SHIFT = 0x0000000e;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__GPUVM_16K_DEF__SHIFT = 0x0000001d;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__GPUVM_INV_MODE__SHIFT = 0x0000000c;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__LFIFO_SCAN_DISABLE__SHIFT = 0x00000008;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__LINE_INVALIDATE_OPT__SHIFT = 0x0000001c;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__LINE_VALID__SHIFT = 0x0000000a;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__MTYPE_OVRD_DIS__SHIFT = 0x00000009;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__PERF_EVENT_RD_WR__SHIFT = 0x00000013;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__PERF_EVENT_VMID__SHIFT = 0x00000015;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__PERM_MODE_OVRD__SHIFT = 0x0000001b;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__SHOOTDOWN_OPT__SHIFT = 0x0000000d;
    constexpr unsigned int SQC_DCACHE_UTCL0_CNTL2__SPARE__SHIFT     = 0x00000000;
    constexpr unsigned int SQC_DCACHE_UTCL0_STATUS__FAULT_DETECTED__SHIFT = 0x00000000;
    constexpr unsigned int SQC_DCACHE_UTCL0_STATUS__PRT_DETECTED__SHIFT = 0x00000002;
    constexpr unsigned int SQC_DCACHE_UTCL0_STATUS__RETRY_DETECTED__SHIFT = 0x00000001;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__CLIENTID__SHIFT  = 0x00000007;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__CLIENT_INVALIDATE_ALL_VMID__SHIFT = 0x00000019;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__ENABLE_LFIFO_PRI_ARB__SHIFT = 0x00000012;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__ENABLE_PUSH_LFIFO__SHIFT = 0x00000011;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__FORCE_4K_L2_RESP__SHIFT = 0x00000000;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__FORCE_IN_ORDER__SHIFT = 0x0000001b;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__FORCE_MISS__SHIFT = 0x0000001a;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__GPUVM_64K_DEF__SHIFT = 0x00000001;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__GPUVM_PERM_MODE__SHIFT = 0x00000002;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__REDUCE_CACHE_SIZE_BY_2__SHIFT = 0x0000001e;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__REDUCE_FIFO_DEPTH_BY_2__SHIFT = 0x0000001c;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__REG_INV_ALL_VMID__SHIFT = 0x00000017;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__REG_INV_TOGGLE__SHIFT = 0x00000018;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__REG_INV_VMID__SHIFT = 0x00000013;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__RESP_FAULT_MODE__SHIFT = 0x00000005;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL1__RESP_MODE__SHIFT = 0x00000003;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__ARB_BURST_MODE__SHIFT = 0x00000010;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__DIS_EDC__SHIFT   = 0x0000000b;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__ENABLE_PERF_EVENT_RD_WR__SHIFT = 0x00000012;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__ENABLE_PERF_EVENT_VMID__SHIFT = 0x00000014;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__FORCE_FRAG_2M_TO_64K__SHIFT = 0x0000001a;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__FORCE_GPUVM_INV_ACK__SHIFT = 0x0000000f;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__FORCE_SNOOP__SHIFT = 0x0000000e;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__GPUVM_16K_DEF__SHIFT = 0x0000001d;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__GPUVM_INV_MODE__SHIFT = 0x0000000c;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__LFIFO_SCAN_DISABLE__SHIFT = 0x00000008;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__LINE_INVALIDATE_OPT__SHIFT = 0x0000001c;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__LINE_VALID__SHIFT = 0x0000000a;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__MTYPE_OVRD_DIS__SHIFT = 0x00000009;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__PERF_EVENT_RD_WR__SHIFT = 0x00000013;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__PERF_EVENT_VMID__SHIFT = 0x00000015;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__PERM_MODE_OVRD__SHIFT = 0x0000001b;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__SHOOTDOWN_OPT__SHIFT = 0x0000000d;
    constexpr unsigned int SQC_ICACHE_UTCL0_CNTL2__SPARE__SHIFT     = 0x00000000;
    constexpr unsigned int SQC_ICACHE_UTCL0_STATUS__FAULT_DETECTED__SHIFT = 0x00000000;
    constexpr unsigned int SQC_ICACHE_UTCL0_STATUS__PRT_DETECTED__SHIFT = 0x00000002;
    constexpr unsigned int SQC_ICACHE_UTCL0_STATUS__RETRY_DETECTED__SHIFT = 0x00000001;
    constexpr unsigned int SQC_MISC_CONFIG__PERFTOKEN_DELAY__SHIFT  = 0x00000000;
    constexpr unsigned int SQG_CONFIG__UTCL0_PREFETCH_PAGE__SHIFT   = 0x00000000;
    constexpr unsigned int SQG_CONFIG__UTCL0_RETRY_TIMER__SHIFT     = 0x00000004;
    constexpr unsigned int SQG_STATUS__REG_BUSY__SHIFT              = 0x00000000;
    constexpr unsigned int SQG_UTCL0_CNTL1__CLIENTID__SHIFT         = 0x00000007;
    constexpr unsigned int SQG_UTCL0_CNTL1__CLIENT_INVALIDATE_ALL_VMID__SHIFT = 0x00000019;
    constexpr unsigned int SQG_UTCL0_CNTL1__ENABLE_LFIFO_PRI_ARB__SHIFT = 0x00000012;
    constexpr unsigned int SQG_UTCL0_CNTL1__ENABLE_PUSH_LFIFO__SHIFT = 0x00000011;
    constexpr unsigned int SQG_UTCL0_CNTL1__FORCE_4K_L2_RESP__SHIFT = 0x00000000;
    constexpr unsigned int SQG_UTCL0_CNTL1__FORCE_IN_ORDER__SHIFT   = 0x0000001b;
    constexpr unsigned int SQG_UTCL0_CNTL1__FORCE_MISS__SHIFT       = 0x0000001a;
    constexpr unsigned int SQG_UTCL0_CNTL1__GPUVM_64K_DEF__SHIFT    = 0x00000001;
    constexpr unsigned int SQG_UTCL0_CNTL1__GPUVM_PERM_MODE__SHIFT  = 0x00000002;
    constexpr unsigned int SQG_UTCL0_CNTL1__REDUCE_CACHE_SIZE_BY_2__SHIFT = 0x0000001e;
    constexpr unsigned int SQG_UTCL0_CNTL1__REDUCE_FIFO_DEPTH_BY_2__SHIFT = 0x0000001c;
    constexpr unsigned int SQG_UTCL0_CNTL1__REG_INV_ALL_VMID__SHIFT = 0x00000017;
    constexpr unsigned int SQG_UTCL0_CNTL1__REG_INV_TOGGLE__SHIFT   = 0x00000018;
    constexpr unsigned int SQG_UTCL0_CNTL1__REG_INV_VMID__SHIFT     = 0x00000013;
    constexpr unsigned int SQG_UTCL0_CNTL1__RESERVED__SHIFT         = 0x00000010;
    constexpr unsigned int SQG_UTCL0_CNTL1__RESP_FAULT_MODE__SHIFT  = 0x00000005;
    constexpr unsigned int SQG_UTCL0_CNTL1__RESP_MODE__SHIFT        = 0x00000003;
    constexpr unsigned int SQG_UTCL0_CNTL2__ARB_BURST_MODE__SHIFT   = 0x00000010;
    constexpr unsigned int SQG_UTCL0_CNTL2__DIS_DUAL_L2_REQ__SHIFT  = 0x00000019;
    constexpr unsigned int SQG_UTCL0_CNTL2__DIS_EDC__SHIFT          = 0x0000000b;
    constexpr unsigned int SQG_UTCL0_CNTL2__ENABLE_PERF_EVENT_RD_WR__SHIFT = 0x00000012;
    constexpr unsigned int SQG_UTCL0_CNTL2__ENABLE_PERF_EVENT_VMID__SHIFT = 0x00000014;
    constexpr unsigned int SQG_UTCL0_CNTL2__FORCE_FRAG_2M_TO_64K__SHIFT = 0x0000001a;
    constexpr unsigned int SQG_UTCL0_CNTL2__FORCE_GPUVM_INV_ACK__SHIFT = 0x0000000f;
    constexpr unsigned int SQG_UTCL0_CNTL2__FORCE_SNOOP__SHIFT      = 0x0000000e;
    constexpr unsigned int SQG_UTCL0_CNTL2__GPUVM_16K_DEF__SHIFT    = 0x0000001d;
    constexpr unsigned int SQG_UTCL0_CNTL2__GPUVM_INV_MODE__SHIFT   = 0x0000000c;
    constexpr unsigned int SQG_UTCL0_CNTL2__LFIFO_SCAN_DISABLE__SHIFT = 0x00000008;
    constexpr unsigned int SQG_UTCL0_CNTL2__LINE_INVALIDATE_OPT__SHIFT = 0x0000001c;
    constexpr unsigned int SQG_UTCL0_CNTL2__LINE_VALID__SHIFT       = 0x0000000a;
    constexpr unsigned int SQG_UTCL0_CNTL2__MTYPE_OVRD_DIS__SHIFT   = 0x00000009;
    constexpr unsigned int SQG_UTCL0_CNTL2__PERF_EVENT_RD_WR__SHIFT = 0x00000013;
    constexpr unsigned int SQG_UTCL0_CNTL2__PERF_EVENT_VMID__SHIFT  = 0x00000015;
    constexpr unsigned int SQG_UTCL0_CNTL2__PERM_MODE_OVRD__SHIFT   = 0x0000001b;
    constexpr unsigned int SQG_UTCL0_CNTL2__RESERVED__SHIFT         = 0x0000001e;
    constexpr unsigned int SQG_UTCL0_CNTL2__SHOOTDOWN_OPT__SHIFT    = 0x0000000d;
    constexpr unsigned int SQG_UTCL0_CNTL2__SPARE__SHIFT            = 0x00000000;
    constexpr unsigned int SQG_UTCL0_STATUS__FAULT_DETECTED__SHIFT  = 0x00000000;
    constexpr unsigned int SQG_UTCL0_STATUS__PRT_DETECTED__SHIFT    = 0x00000002;
    constexpr unsigned int SQG_UTCL0_STATUS__RESERVED__SHIFT        = 0x00000003;
    constexpr unsigned int SQG_UTCL0_STATUS__RETRY_DETECTED__SHIFT  = 0x00000001;
    constexpr unsigned int SQG_UTCL0_STATUS__UNUSED__SHIFT          = 0x00000008;
    constexpr unsigned int SQ_ALU_CLK_CTRL__FORCE_WGP_ON_SA0__SHIFT = 0x00000000;
    constexpr unsigned int SQ_ALU_CLK_CTRL__FORCE_WGP_ON_SA1__SHIFT = 0x00000010;
    constexpr unsigned int SQ_ARB_CONFIG__FWD_PROG_INTERVAL__SHIFT  = 0x00000004;
    constexpr unsigned int SQ_ARB_CONFIG__WG_RR_INTERVAL__SHIFT     = 0x00000000;
    constexpr unsigned int SQ_CONFIG__UNUSED__SHIFT                 = 0x00000000;
    constexpr unsigned int SQ_CONFIG__VGPR_SWIZZLE_EN__SHIFT        = 0x0000000c;
    constexpr unsigned int SQ_DEBUG_STS_GLOBAL__INTERRUPT_BUSY__SHIFT = 0x00000001;
    constexpr unsigned int SQ_DEBUG_STS_GLOBAL__WAVE_LEVEL_SA0__SHIFT = 0x00000004;
    constexpr unsigned int SQ_DEBUG_STS_GLOBAL__WAVE_LEVEL_SA1__SHIFT = 0x00000010;
    constexpr unsigned int SQ_DEBUG_STS_LOCAL__ARB_BUSY__SHIFT      = 0x0000000f;
    constexpr unsigned int SQ_DEBUG_STS_LOCAL__BRMSG_BUSY__SHIFT    = 0x00000011;
    constexpr unsigned int SQ_DEBUG_STS_LOCAL__EXP_BUSY__SHIFT      = 0x00000010;
    constexpr unsigned int SQ_DEBUG_STS_LOCAL__IS_BUSY__SHIFT       = 0x0000000d;
    constexpr unsigned int SQ_DEBUG_STS_LOCAL__SQ_BUSY__SHIFT       = 0x0000000c;
    constexpr unsigned int SQ_DEBUG_STS_LOCAL__VM_BUSY__SHIFT       = 0x00000012;
    constexpr unsigned int SQ_FIFO_SIZES__EXPORT_BUF_PS_RESERVED__SHIFT = 0x0000000e;
    constexpr unsigned int SQ_FIFO_SIZES__EXPORT_BUF_REDUCE__SHIFT  = 0x00000010;
    constexpr unsigned int SQ_FIFO_SIZES__EXPORT_BUF_VS_RESERVED__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_IND_INDEX__AUTO_INCR__SHIFT           = 0x0000000b;
    constexpr unsigned int SQ_IND_INDEX__WORKITEM_ID__SHIFT         = 0x00000005;
    constexpr unsigned int SQ_LB_CTR_SEL0__DIV0__SHIFT              = 0x0000000f;
    constexpr unsigned int SQ_LB_CTR_SEL0__DIV1__SHIFT              = 0x0000001f;
    constexpr unsigned int SQ_LB_CTR_SEL0__SEL0__SHIFT              = 0x00000000;
    constexpr unsigned int SQ_LB_CTR_SEL0__SEL1__SHIFT              = 0x00000010;
    constexpr unsigned int SQ_LB_CTR_SEL1__DIV2__SHIFT              = 0x0000000f;
    constexpr unsigned int SQ_LB_CTR_SEL1__DIV3__SHIFT              = 0x0000001f;
    constexpr unsigned int SQ_LB_CTR_SEL1__SEL2__SHIFT              = 0x00000000;
    constexpr unsigned int SQ_LB_CTR_SEL1__SEL3__SHIFT              = 0x00000010;
    constexpr unsigned int SQ_LDS_CLK_CTRL__FORCE_WGP_ON_SA0__SHIFT = 0x00000000;
    constexpr unsigned int SQ_LDS_CLK_CTRL__FORCE_WGP_ON_SA1__SHIFT = 0x00000010;
    constexpr unsigned int SQ_RUNTIME_CONFIG__UNUSED_REGISTER__SHIFT = 0x00000000;
    constexpr unsigned int SQ_SHADER_TBA_HI__TRAP_EN__SHIFT         = 0x0000001f;
    constexpr unsigned int SQ_TEX_CLK_CTRL__FORCE_WGP_ON_SA0__SHIFT = 0x00000000;
    constexpr unsigned int SQ_TEX_CLK_CTRL__FORCE_WGP_ON_SA1__SHIFT = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_BUF0_BASE__BASE_LO__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_BUF0_SIZE__BASE_HI__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_BUF0_SIZE__SIZE__SHIFT   = 0x00000008;
    constexpr unsigned int SQ_THREAD_TRACE_BUF1_BASE__BASE_LO__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_BUF1_SIZE__BASE_HI__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_BUF1_SIZE__SIZE__SHIFT   = 0x00000008;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__ALL_VMID__SHIFT    = 0x00000002;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__CAPTURE_ALL__SHIFT = 0x0000001e;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__CH_PERF_EN__SHIFT  = 0x00000003;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__DOUBLE_BUFFER__SHIFT = 0x00000005;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__DRAW_EVENT_EN__SHIFT = 0x0000001f;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__HIWATER__SHIFT     = 0x00000006;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__INTERRUPT_EN__SHIFT = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__MODE__SHIFT        = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__REG_DROP_ON_STALL__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__REG_STALL_EN__SHIFT = 0x00000009;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__RT_FREQ__SHIFT     = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__SPI_STALL_EN__SHIFT = 0x0000000a;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__SQ_STALL_EN__SHIFT = 0x0000000b;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__SYNC_COUNT_DRAWS__SHIFT = 0x00000013;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__SYNC_COUNT_MARKERS__SHIFT = 0x00000012;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__UTIL_TIMER__SHIFT  = 0x0000000d;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__WAVESTART_MODE__SHIFT = 0x0000000e;
    constexpr unsigned int SQ_THREAD_TRACE_DROPPED_CNTR__CNTR__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_FINISH_DONE_DEBUG__EXPECT0__SHIFT = 0x0000000a;
    constexpr unsigned int SQ_THREAD_TRACE_FINISH_DONE_DEBUG__EXPECT1__SHIFT = 0x0000001a;
    constexpr unsigned int SQ_THREAD_TRACE_FINISH_DONE_DEBUG__GFX0__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_FINISH_DONE_DEBUG__GFX1__SHIFT = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_GFX_DRAW_CNTR__CNTR__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_GFX_MARKER_CNTR__CNTR__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_HP3D_DRAW_CNTR__CNTR__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_HP3D_MARKER_CNTR__CNTR__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__SA_SEL__SHIFT      = 0x00000009;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__SIMD_SEL__SHIFT    = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__WGP_SEL__SHIFT     = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__WTYPE_INCLUDE__SHIFT = 0x0000000a;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__BUSY__SHIFT      = 0x00000019;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__EVENT_CNTR_OVERFLOW__SHIFT = 0x0000001a;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__EVENT_CNTR_STALL__SHIFT = 0x0000001b;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__FINISH_DONE__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__UTC_ERR__SHIFT   = 0x00000018;
    constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__INST_EXCLUDE__SHIFT = 0x00000018;
    constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__REG_DETAIL_ALL__SHIFT = 0x0000001f;
    constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__REG_INCLUDE__SHIFT = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__TOKEN_EXCLUDE__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_USERDATA_4__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_USERDATA_5__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_USERDATA_6__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_USERDATA_7__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WPTR__BUFFER_ID__SHIFT   = 0x0000001f;
    constexpr unsigned int SQ_THREAD_TRACE_WPTR__OFFSET__SHIFT      = 0x00000000;
    constexpr unsigned int SQ_WATCH0_ADDR_H__ADDR__SHIFT            = 0x00000000;
    constexpr unsigned int SQ_WATCH0_ADDR_L__ADDR__SHIFT            = 0x00000006;
    constexpr unsigned int SQ_WATCH0_CNTL__MASK__SHIFT              = 0x00000000;
    constexpr unsigned int SQ_WATCH0_CNTL__VALID__SHIFT             = 0x0000001f;
    constexpr unsigned int SQ_WATCH0_CNTL__VMID__SHIFT              = 0x00000018;
    constexpr unsigned int SQ_WATCH1_ADDR_H__ADDR__SHIFT            = 0x00000000;
    constexpr unsigned int SQ_WATCH1_ADDR_L__ADDR__SHIFT            = 0x00000006;
    constexpr unsigned int SQ_WATCH1_CNTL__MASK__SHIFT              = 0x00000000;
    constexpr unsigned int SQ_WATCH1_CNTL__VALID__SHIFT             = 0x0000001f;
    constexpr unsigned int SQ_WATCH1_CNTL__VMID__SHIFT              = 0x00000018;
    constexpr unsigned int SQ_WATCH2_ADDR_H__ADDR__SHIFT            = 0x00000000;
    constexpr unsigned int SQ_WATCH2_ADDR_L__ADDR__SHIFT            = 0x00000006;
    constexpr unsigned int SQ_WATCH2_CNTL__MASK__SHIFT              = 0x00000000;
    constexpr unsigned int SQ_WATCH2_CNTL__VALID__SHIFT             = 0x0000001f;
    constexpr unsigned int SQ_WATCH2_CNTL__VMID__SHIFT              = 0x00000018;
    constexpr unsigned int SQ_WATCH3_ADDR_H__ADDR__SHIFT            = 0x00000000;
    constexpr unsigned int SQ_WATCH3_ADDR_L__ADDR__SHIFT            = 0x00000006;
    constexpr unsigned int SQ_WATCH3_CNTL__MASK__SHIFT              = 0x00000000;
    constexpr unsigned int SQ_WATCH3_CNTL__VALID__SHIFT             = 0x0000001f;
    constexpr unsigned int SQ_WATCH3_CNTL__VMID__SHIFT              = 0x00000018;
    constexpr unsigned int SX_DEBUG_1__DISABLE_RAM_FGCG__SHIFT      = 0x0000000f;
    constexpr unsigned int SX_DEBUG_1__ENABLE_SAME_PC_GDS_CGTS__SHIFT = 0x0000000e;
    constexpr unsigned int SX_DEBUG_1__PC_DISABLE_SAME_ADDR_OPT__SHIFT = 0x00000010;
    constexpr unsigned int TA_CNTL_AUX__AUTO_ALIGN_FORMAT__SHIFT    = 0x00000009;
    constexpr unsigned int TA_POWER_CNTL__NOSAMPLER_CLK_EN_MODE__SHIFT = 0x00000013;
    constexpr unsigned int TA_POWER_CNTL__NOSAMPLER_CLK_VALID_DELAY__SHIFT = 0x00000010;
    constexpr unsigned int TA_POWER_CNTL__SAMPLER_CLK_EN_MODE__SHIFT = 0x00000003;
    constexpr unsigned int TA_POWER_CNTL__SAMPLER_CLK_VALID_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER2__REQ_MODE__SHIFT = 0x00000000;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__COMPRESSION_ENABLE__SHIFT = 0x0000000b;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__DLC__SHIFT    = 0x00000009;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__GLC__SHIFT    = 0x0000000a;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__REQ_MODE__SHIFT = 0x0000000c;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__SLC__SHIFT    = 0x00000008;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__COMPRESSION_ENABLE__SHIFT = 0x0000001e;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__DLC__SHIFT       = 0x0000001c;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__GLC__SHIFT       = 0x0000001d;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__NUM_FORMAT__SHIFT = 0x0000000d;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__NUM_SAMPLES__SHIFT = 0x00000016;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__OPCODE_TYPE__SHIFT = 0x00000018;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__SLC__SHIFT       = 0x0000001b;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__SW_MODE__SHIFT   = 0x00000011;
    constexpr unsigned int TD_CNTL__ARBITER_OLDEST_PRIORITY__SHIFT  = 0x00000019;
    constexpr unsigned int TD_CNTL__DISABLE_SAMPLER_MAX_NORM_NUM_CLAMP__SHIFT = 0x00000006;
    constexpr unsigned int TD_CNTL__DISABLE_SAMPLER_NEG_SCALED_NUM_CLAMP__SHIFT = 0x00000003;
    constexpr unsigned int TD_CNTL__DONE_SCOREBOARD_DEPTH__SHIFT    = 0x0000001a;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_ACTIVE__SHIFT     = 0x00000004;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_CLEAN__SHIFT      = 0x0000000f;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_IDLE__SHIFT       = 0x00000010;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_MODE1_FILTER1_THRESHOLD__SHIFT = 0x00000000;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_MODE1_FILTER2_BYPASS__SHIFT = 0x00000003;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_MODE2_INTR_THRESHOLD__SHIFT = 0x0000000a;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_MODE2_LOCK_WINDOW__SHIFT = 0x00000006;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_MODE__SHIFT       = 0x00000005;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_SPACE_EN__SHIFT   = 0x0000000c;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__OFF_HYSTERESIS__SHIFT = 0x00000004;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__ON_DELAY__SHIFT     = 0x00000000;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_OVERRIDE0__SHIFT = 0x0000001f;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_OVERRIDE1__SHIFT = 0x0000001e;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_OVERRIDE2__SHIFT = 0x0000001d;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_OVERRIDE3__SHIFT = 0x0000001c;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_OVERRIDE4__SHIFT = 0x0000001b;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_OVERRIDE5__SHIFT = 0x0000001a;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_OVERRIDE6__SHIFT = 0x00000019;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_STALL_OVERRIDE0__SHIFT = 0x00000017;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_STALL_OVERRIDE1__SHIFT = 0x00000016;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_STALL_OVERRIDE2__SHIFT = 0x00000015;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_STALL_OVERRIDE3__SHIFT = 0x00000014;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_STALL_OVERRIDE4__SHIFT = 0x00000013;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_STALL_OVERRIDE5__SHIFT = 0x00000012;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_STALL_OVERRIDE6__SHIFT = 0x00000011;
    constexpr unsigned int UTCL1_CGTT_CLK_CTRL__SOFT_STALL_OVERRIDE7__SHIFT = 0x00000010;
    constexpr unsigned int UTCL1_CTRL__UTCL1_CACHE_CORE_BYPASS__SHIFT = 0x00000002;
    constexpr unsigned int UTCL1_CTRL__UTCL1_CACHE_WRITE_PERM__SHIFT = 0x00000013;
    constexpr unsigned int UTCL1_CTRL__UTCL1_FORCE_INV_ALL_DONE__SHIFT = 0x0000000b;
    constexpr unsigned int UTCL1_CTRL__UTCL1_FORCE_INV_ALL__SHIFT   = 0x0000000a;
    constexpr unsigned int UTCL1_CTRL__UTCL1_FORCE_RANGE_INV_TO_VMID__SHIFT = 0x00000009;
    constexpr unsigned int UTCL1_CTRL__UTCL1_INV_FILTER_2M__SHIFT   = 0x0000000d;
    constexpr unsigned int UTCL1_CTRL__UTCL1_LARGE_PAGE_SIZE__SHIFT = 0x00000001;
    constexpr unsigned int UTCL1_CTRL__UTCL1_MH_CAM_DUPLICATE_4K_FILTER__SHIFT = 0x00000014;
    constexpr unsigned int UTCL1_CTRL__UTCL1_MH_DISABLE_DUPLICATES__SHIFT = 0x00000015;
    constexpr unsigned int UTCL1_CTRL__UTCL1_MH_DISABLE_RECENT_BUFFER__SHIFT = 0x00000017;
    constexpr unsigned int UTCL1_CTRL__UTCL1_MH_INV_FRAG_SIZE_OVERRIDE__SHIFT = 0x00000012;
    constexpr unsigned int UTCL1_CTRL__UTCL1_MISS_CC_PRIORITY__SHIFT = 0x00000018;
    constexpr unsigned int UTCL1_CTRL__UTCL1_RANGE_INV_FORCE_CHK_ALL__SHIFT = 0x0000000e;
    constexpr unsigned int UTCL1_CTRL__UTCL1_REDUCE_CC_SIZE__SHIFT  = 0x0000001a;
    constexpr unsigned int UTCL1_CTRL__UTCL1_RMI_BYPASS__SHIFT      = 0x00000006;
    constexpr unsigned int UTCL1_CTRL__UTCL1_RMI_DEDICATED_CACHE_CORE__SHIFT = 0x00000008;
    constexpr unsigned int UTCL1_CTRL__UTCL1_SMALL_PAGE_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int UTCL1_CTRL__UTCL1_SQCD_BYPASS__SHIFT     = 0x00000005;
    constexpr unsigned int UTCL1_CTRL__UTCL1_SQCI_BYPASS__SHIFT     = 0x00000004;
    constexpr unsigned int UTCL1_CTRL__UTCL1_SQG_BYPASS__SHIFT      = 0x00000007;
    constexpr unsigned int UTCL1_CTRL__UTCL1_TCP_BYPASS__SHIFT      = 0x00000003;
    constexpr unsigned int UTCL1_CTRL__UTCL1_UTCL2_FGCG_REPEATERS_OVERRIDE__SHIFT = 0x0000000c;
    constexpr unsigned int UTCL1_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int UTCL1_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int UTCL1_PERFCOUNTER0_SELECT__COUNTER_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int UTCL1_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int UTCL1_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int UTCL1_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int UTCL1_PERFCOUNTER1_SELECT__COUNTER_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int UTCL1_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int VGT_DMA_INDEX_TYPE__ATC__SHIFT           = 0x00000008;
    constexpr unsigned int VGT_DMA_INDEX_TYPE__MTYPE__SHIFT         = 0x0000000b;
    constexpr unsigned int VGT_DRAW_PAYLOAD_CNTL__EN_DRAW_VP__SHIFT = 0x00000004;
    constexpr unsigned int VGT_ESGS_RING_SIZE__MEM_SIZE__SHIFT      = 0x00000000;
    constexpr unsigned int VGT_FIFO_DEPTHS__HSINPUT_FIFO_DEPTH__SHIFT = 0x00000017;
    constexpr unsigned int VGT_FIFO_DEPTHS__RESERVED_1__SHIFT       = 0x00000016;
    constexpr unsigned int VGT_GS_MODE__COMPUTE_MODE__SHIFT         = 0x0000000e;
    constexpr unsigned int VGT_GS_MODE__ELEMENT_INFO_EN__SHIFT      = 0x00000010;
    constexpr unsigned int VGT_GS_MODE__FAST_COMPUTE_MODE__SHIFT    = 0x0000000f;
    constexpr unsigned int VGT_SHADER_STAGES_EN__DYNAMIC_HS__SHIFT  = 0x00000008;
    constexpr unsigned int VGT_SHADER_STAGES_EN__GS_W32_EN__SHIFT   = 0x00000016;
    constexpr unsigned int VGT_SHADER_STAGES_EN__HS_W32_EN__SHIFT   = 0x00000015;
    constexpr unsigned int VGT_SHADER_STAGES_EN__NGG_WAVE_ID_EN__SHIFT = 0x00000018;
    constexpr unsigned int VGT_SHADER_STAGES_EN__PRIMGEN_PASSTHRU_EN__SHIFT = 0x00000019;
    constexpr unsigned int VGT_SHADER_STAGES_EN__VS_W32_EN__SHIFT   = 0x00000017;
    constexpr unsigned int VGT_TF_PARAM__DETECT_ONE__SHIFT          = 0x00000013;
    constexpr unsigned int VGT_TF_PARAM__DETECT_ZERO__SHIFT         = 0x00000014;
    constexpr unsigned int VGT_TF_PARAM__MTYPE__SHIFT               = 0x00000017;
    constexpr unsigned int VGT_TF_PARAM__NUM_DS_WAVES_PER_SIMD__SHIFT = 0x0000000a;
    constexpr unsigned int WD_UTCL1_CNTL__MTYPE_OVERRIDE__SHIFT     = 0x0000001d;
} // namespace Gfx10

namespace Gfx101
{
    constexpr unsigned int CB_COLOR0_INFO__ALT_TILE_MODE__SHIFT     = 0x0000001f;
    constexpr unsigned int CB_COLOR1_INFO__ALT_TILE_MODE__SHIFT     = 0x0000001f;
    constexpr unsigned int CB_COLOR2_INFO__ALT_TILE_MODE__SHIFT     = 0x0000001f;
    constexpr unsigned int CB_COLOR3_INFO__ALT_TILE_MODE__SHIFT     = 0x0000001f;
    constexpr unsigned int CB_COLOR4_INFO__ALT_TILE_MODE__SHIFT     = 0x0000001f;
    constexpr unsigned int CB_COLOR5_INFO__ALT_TILE_MODE__SHIFT     = 0x0000001f;
    constexpr unsigned int CB_COLOR6_INFO__ALT_TILE_MODE__SHIFT     = 0x0000001f;
    constexpr unsigned int CB_COLOR7_INFO__ALT_TILE_MODE__SHIFT     = 0x0000001f;
    constexpr unsigned int CB_DCC_CONFIG__DCC_CACHE_NUM_TAGS__SHIFT = 0x0000001a;
    constexpr unsigned int CB_HW_CONTROL_3__DISABLE_DUALSRC_WITH_OBJPRIMID_FIX__SHIFT = 0x0000001b;
    constexpr unsigned int CHCG_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int CHCG_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x00000018;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x0000001c;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int CHCG_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int CHCG_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int CHCG_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int CHCG_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int CHCG_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int CHCG_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int CHCG_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int CHCG_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int CHCG_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int CHCG_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int CHCG_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int CHCG_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int CHCG_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int CHCG_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int CHCG_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int CH_PIPE_STEER__PIPE4__SHIFT              = 0x00000008;
    constexpr unsigned int CH_PIPE_STEER__PIPE5__SHIFT              = 0x0000000a;
    constexpr unsigned int CH_PIPE_STEER__PIPE6__SHIFT              = 0x0000000c;
    constexpr unsigned int CH_PIPE_STEER__PIPE7__SHIFT              = 0x0000000e;
    constexpr unsigned int CH_PIPE_STEER__PIPE8__SHIFT              = 0x00000010;
    constexpr unsigned int CH_PIPE_STEER__PIPE9__SHIFT              = 0x00000012;
    constexpr unsigned int CH_PIPE_STEER__PIPE10__SHIFT             = 0x00000014;
    constexpr unsigned int CH_PIPE_STEER__PIPE11__SHIFT             = 0x00000016;
    constexpr unsigned int CH_PIPE_STEER__PIPE12__SHIFT             = 0x00000018;
    constexpr unsigned int CH_PIPE_STEER__PIPE13__SHIFT             = 0x0000001a;
    constexpr unsigned int CH_PIPE_STEER__PIPE14__SHIFT             = 0x0000001c;
    constexpr unsigned int CH_PIPE_STEER__PIPE15__SHIFT             = 0x0000001e;
    constexpr unsigned int CH_VC5_ENABLE__UTCL2_VC5_ENABLE__SHIFT   = 0x00000001;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_0__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_0__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_0__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_0__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_0__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_0__RESERVED__SHIFT = 0x0000000e;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_1__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_1__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_1__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_1__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_1__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_1__RESERVED__SHIFT = 0x0000000e;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_2__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_2__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_2__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_2__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_2__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_2__RESERVED__SHIFT = 0x0000000e;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_3__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_3__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_3__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_3__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_3__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_3__RESERVED__SHIFT = 0x0000000e;
    constexpr unsigned int CP_EOP_DONE_DOORBELL__DOORBELL_OFFSET__SHIFT = 0x00000002;
    constexpr unsigned int CP_GFX_HQD_CE_CNTL__BUF_SWAP__SHIFT      = 0x00000010;
    constexpr unsigned int CP_MES_DCSR__CSR__SHIFT                  = 0x00000000;
    constexpr unsigned int CP_MES_DMCONTROL__CONTROL__SHIFT         = 0x00000000;
    constexpr unsigned int CP_MES_DMINFO__INFO__SHIFT               = 0x00000000;
    constexpr unsigned int CP_MES_DPC_HIGH__INSTR_PNTR__SHIFT       = 0x00000000;
    constexpr unsigned int CP_MES_DPC_LOW__INSTR_PNTR__SHIFT        = 0x00000000;
    constexpr unsigned int CP_MES_DSCRATCH_HIGH__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int CP_MES_DSCRATCH_LOW__DATA__SHIFT         = 0x00000000;
    constexpr unsigned int CP_MES_INTERRUPT__PENDING_INTERRUPT__SHIFT = 0x00000010;
    constexpr unsigned int CP_MES_SETHALTNOTIFICATION__SETHALT__SHIFT = 0x00000000;
    constexpr unsigned int CP_MES_TDATA1_HIGH__DATA__SHIFT          = 0x00000000;
    constexpr unsigned int CP_MES_TDATA1_LOW__DATA__SHIFT           = 0x00000000;
    constexpr unsigned int CP_MES_TDATA2_HIGH__DATA__SHIFT          = 0x00000000;
    constexpr unsigned int CP_MES_TDATA2_LOW__DATA__SHIFT           = 0x00000000;
    constexpr unsigned int CP_MES_TDATA3_HIH__DATA__SHIFT           = 0x00000000;
    constexpr unsigned int CP_MES_TDATA3_LOW__DATA__SHIFT           = 0x00000000;
    constexpr unsigned int CP_MES_TSELCT_HIGH__TSELECT__SHIFT       = 0x00000000;
    constexpr unsigned int CP_MES_TSELCT_LOW__TSELECT__SHIFT        = 0x00000000;
    constexpr unsigned int CP_PIPE_STATS_DOORBELL__DOORBELL_OFFSET__SHIFT = 0x00000002;
    constexpr unsigned int CP_SEM_DOORBELL__DOORBELL_OFFSET__SHIFT  = 0x00000002;
    constexpr unsigned int CP_SIG_SEM_ADDR_LO__SEM_ADDR_SWAP__SHIFT = 0x00000000;
    constexpr unsigned int CP_STREAM_OUT_DOORBELL__DOORBELL_OFFSET__SHIFT = 0x00000002;
    constexpr unsigned int CP_WAIT_SEM_ADDR_LO__SEM_ADDR_SWAP__SHIFT = 0x00000000;
    constexpr unsigned int DB_DEBUG2__DISABLE_TILE_COVERED_FOR_PS_ITER__SHIFT = 0x0000000e;
    constexpr unsigned int DB_DEBUG2__DISABLE_VR_OBJ_PRIM_ID__SHIFT = 0x0000001a;
    constexpr unsigned int DB_DEBUG2__DISABLE_VR_PS_INVOKE__SHIFT   = 0x0000001b;
    constexpr unsigned int DB_EXCEPTION_CONTROL__EXTRA_BITS_GROUP_A__SHIFT = 0x00000005;
    constexpr unsigned int DB_EXCEPTION_CONTROL__EXTRA_BITS_GROUP_B__SHIFT = 0x0000000c;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__BYPASS_SORT_RD_BA__SHIFT = 0x0000001d;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__DISABLE_FLQ_LOB_EVERY_256B__SHIFT = 0x00000014;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__DISABLE_MCC_BURST_COUNT_RESET_ON_LOB__SHIFT = 0x00000013;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__DISABLE_MCC_BURST_FORCE_FLUSH_BEFORE_FIFO__SHIFT = 0x00000016;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__DISABLE_ZCACHE_FL_OP_EVEN_ARB__SHIFT = 0x00000015;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__ENABLE_FG_DEFAULT_TIMEOUT__SHIFT = 0x00000012;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__ENABLE_TIMEOUT_CB_LOB_GEN__SHIFT = 0x00000019;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__ENABLE_TIMEOUT_DKG_LOB_GEN__SHIFT = 0x00000017;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__ENABLE_TIMEOUT_FG_LOB_FWDR__SHIFT = 0x0000001b;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__ENABLE_TIMEOUT_FL_BURST__SHIFT = 0x0000001a;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__ENABLE_TIMEOUT_LPF_LOB_GEN__SHIFT = 0x00000018;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__ENABLE_TIMEOUT_RD_BA_ACCUM__SHIFT = 0x0000001c;
    constexpr unsigned int GC_CAC_ACC_CBR0__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CBR1__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CBR2__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CBR3__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_DBR0__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_DBR1__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_DBR2__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_DBR3__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_OVRD_CBR__OVRRD_SELECT__SHIFT     = 0x00000000;
    constexpr unsigned int GC_CAC_OVRD_CBR__OVRRD_VALUE__SHIFT      = 0x00000004;
    constexpr unsigned int GC_CAC_OVRD_CB__OVRRD_VALUE__SHIFT       = 0x00000004;
    constexpr unsigned int GC_CAC_OVRD_DBR__OVRRD_SELECT__SHIFT     = 0x00000000;
    constexpr unsigned int GC_CAC_OVRD_DBR__OVRRD_VALUE__SHIFT      = 0x00000004;
    constexpr unsigned int GC_CAC_OVRD_DB__OVRRD_VALUE__SHIFT       = 0x00000004;
    constexpr unsigned int GC_CAC_OVRD_GDS__OVRRD_VALUE__SHIFT      = 0x00000004;
    constexpr unsigned int GC_CAC_OVRD_PA__OVRRD_VALUE__SHIFT       = 0x00000002;
    constexpr unsigned int GC_CAC_OVRD_RMI__OVRRD_VALUE__SHIFT      = 0x00000001;
    constexpr unsigned int GC_CAC_OVRD_SC__OVRRD_VALUE__SHIFT       = 0x00000001;
    constexpr unsigned int GC_CAC_OVRD_SQ__OVRRD_VALUE__SHIFT       = 0x00000006;
    constexpr unsigned int GC_CAC_OVRD_TCP__OVRRD_VALUE__SHIFT      = 0x00000005;
    constexpr unsigned int GC_CAC_OVRD_TD__OVRRD_VALUE__SHIFT       = 0x0000000a;
    constexpr unsigned int GC_CAC_WEIGHT_CBR_0__WEIGHT_CBR_SIG0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_CBR_0__WEIGHT_CBR_SIG1__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_CBR_1__WEIGHT_CBR_SIG2__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_CBR_1__WEIGHT_CBR_SIG3__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_DBR_0__WEIGHT_DBR_SIG0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_DBR_0__WEIGHT_DBR_SIG1__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_DBR_1__WEIGHT_DBR_SIG2__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_DBR_1__WEIGHT_DBR_SIG3__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_RMI_0__UNUSED_0__SHIFT     = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_SC_0__UNUSED_0__SHIFT      = 0x00000010;
    constexpr unsigned int GC_DIDT_CTRL0__DIDT_CLK_EN_OVERRIDE__SHIFT = 0x00000004;
    constexpr unsigned int GC_DIDT_CTRL0__DIDT_CTRL_EN__SHIFT       = 0x00000000;
    constexpr unsigned int GC_DIDT_CTRL0__DIDT_SW_RST__SHIFT        = 0x00000003;
    constexpr unsigned int GC_DIDT_CTRL0__DIDT_TRIGGER_THROTTLE_LOWBIT__SHIFT = 0x00000005;
    constexpr unsigned int GC_DIDT_CTRL0__PHASE_OFFSET__SHIFT       = 0x00000001;
    constexpr unsigned int GC_DIDT_CTRL1__MAX_POWER__SHIFT          = 0x00000010;
    constexpr unsigned int GC_DIDT_CTRL1__MIN_POWER__SHIFT          = 0x00000000;
    constexpr unsigned int GC_DIDT_CTRL2__LONG_TERM_INTERVAL_RATIO__SHIFT = 0x0000001b;
    constexpr unsigned int GC_DIDT_CTRL2__MAX_POWER_DELTA__SHIFT    = 0x00000000;
    constexpr unsigned int GC_DIDT_CTRL2__SHORT_TERM_INTERVAL_SIZE__SHIFT = 0x00000010;
    constexpr unsigned int GC_DIDT_CTRL2__UNUSED_0__SHIFT           = 0x0000000e;
    constexpr unsigned int GC_DIDT_CTRL2__UNUSED_1__SHIFT           = 0x0000001a;
    constexpr unsigned int GC_DIDT_CTRL2__UNUSED_2__SHIFT           = 0x0000001f;
    constexpr unsigned int GC_DIDT_WEIGHT__DB_WEIGHT__SHIFT         = 0x00000008;
    constexpr unsigned int GC_DIDT_WEIGHT__SQ_WEIGHT__SHIFT         = 0x00000000;
    constexpr unsigned int GC_DIDT_WEIGHT__TCP_WEIGHT__SHIFT        = 0x00000018;
    constexpr unsigned int GC_DIDT_WEIGHT__TD_WEIGHT__SHIFT         = 0x00000010;
    constexpr unsigned int GC_EDC_OVERFLOW__PSM_COUNTER__SHIFT      = 0x00000012;
    constexpr unsigned int GC_USER_PRIM_CONFIG__INACTIVE_IA__SHIFT  = 0x00000010;
    constexpr unsigned int GC_USER_PRIM_CONFIG__INACTIVE_VGT_PA__SHIFT = 0x00000018;
    constexpr unsigned int GE_FAST_CLKS__FORCE_FAST_CLK__SHIFT      = 0x0000001f;
    constexpr unsigned int GE_FAST_CLKS__HYSTERESIS__SHIFT          = 0x00000000;
    constexpr unsigned int GE_FAST_CLKS__LOCK__SHIFT                = 0x0000001e;
    constexpr unsigned int GL1_PIPE_STEER__PIPE4__SHIFT             = 0x00000008;
    constexpr unsigned int GL1_PIPE_STEER__PIPE5__SHIFT             = 0x0000000a;
    constexpr unsigned int GL1_PIPE_STEER__PIPE6__SHIFT             = 0x0000000c;
    constexpr unsigned int GL1_PIPE_STEER__PIPE7__SHIFT             = 0x0000000e;
    constexpr unsigned int GL1_PIPE_STEER__PIPE8__SHIFT             = 0x00000010;
    constexpr unsigned int GL1_PIPE_STEER__PIPE9__SHIFT             = 0x00000012;
    constexpr unsigned int GL1_PIPE_STEER__PIPE10__SHIFT            = 0x00000014;
    constexpr unsigned int GL1_PIPE_STEER__PIPE11__SHIFT            = 0x00000016;
    constexpr unsigned int GL1_PIPE_STEER__PIPE12__SHIFT            = 0x00000018;
    constexpr unsigned int GL1_PIPE_STEER__PIPE13__SHIFT            = 0x0000001a;
    constexpr unsigned int GL1_PIPE_STEER__PIPE14__SHIFT            = 0x0000001c;
    constexpr unsigned int GL1_PIPE_STEER__PIPE15__SHIFT            = 0x0000001e;
    constexpr unsigned int GRBM_READ_ERROR2__READ_REQUESTER_CPF__SHIFT = 0x00000010;
    constexpr unsigned int GRBM_STATUS2__CPF_RQ_PENDING__SHIFT      = 0x00000013;
    constexpr unsigned int GRBM_STATUS2__RLC_BUSY__SHIFT            = 0x00000018;
    constexpr unsigned int GRBM_STATUS2__TCP_BUSY__SHIFT            = 0x00000019;
    constexpr unsigned int GUS_PERFCOUNTER0_CFG__CLEAR__SHIFT       = 0x0000001d;
    constexpr unsigned int GUS_PERFCOUNTER0_CFG__ENABLE__SHIFT      = 0x0000001c;
    constexpr unsigned int GUS_PERFCOUNTER0_CFG__PERF_MODE__SHIFT   = 0x00000018;
    constexpr unsigned int GUS_PERFCOUNTER0_CFG__PERF_SEL_END__SHIFT = 0x00000008;
    constexpr unsigned int GUS_PERFCOUNTER0_CFG__PERF_SEL__SHIFT    = 0x00000000;
    constexpr unsigned int GUS_PERFCOUNTER1_CFG__CLEAR__SHIFT       = 0x0000001d;
    constexpr unsigned int GUS_PERFCOUNTER1_CFG__ENABLE__SHIFT      = 0x0000001c;
    constexpr unsigned int GUS_PERFCOUNTER1_CFG__PERF_MODE__SHIFT   = 0x00000018;
    constexpr unsigned int GUS_PERFCOUNTER1_CFG__PERF_SEL_END__SHIFT = 0x00000008;
    constexpr unsigned int GUS_PERFCOUNTER1_CFG__PERF_SEL__SHIFT    = 0x00000000;
    constexpr unsigned int GUS_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GUS_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GUS_PERFCOUNTER2_MODE__COMPARE_MODE0__SHIFT = 0x00000000;
    constexpr unsigned int GUS_PERFCOUNTER2_MODE__COMPARE_MODE1__SHIFT = 0x00000002;
    constexpr unsigned int GUS_PERFCOUNTER2_MODE__COMPARE_MODE2__SHIFT = 0x00000004;
    constexpr unsigned int GUS_PERFCOUNTER2_MODE__COMPARE_MODE3__SHIFT = 0x00000006;
    constexpr unsigned int GUS_PERFCOUNTER2_MODE__COMPARE_VALUE0__SHIFT = 0x00000008;
    constexpr unsigned int GUS_PERFCOUNTER2_MODE__COMPARE_VALUE1__SHIFT = 0x0000000c;
    constexpr unsigned int GUS_PERFCOUNTER2_MODE__COMPARE_VALUE2__SHIFT = 0x00000010;
    constexpr unsigned int GUS_PERFCOUNTER2_MODE__COMPARE_VALUE3__SHIFT = 0x00000014;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GUS_PERFCOUNTER_HI__COMPARE_VALUE__SHIFT = 0x00000010;
    constexpr unsigned int GUS_PERFCOUNTER_HI__COUNTER_HI__SHIFT    = 0x00000000;
    constexpr unsigned int GUS_PERFCOUNTER_LO__COUNTER_LO__SHIFT    = 0x00000000;
    constexpr unsigned int GUS_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL__SHIFT = 0x00000019;
    constexpr unsigned int GUS_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY__SHIFT = 0x00000018;
    constexpr unsigned int GUS_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int GUS_PERFCOUNTER_RSLT_CNTL__START_TRIGGER__SHIFT = 0x00000008;
    constexpr unsigned int GUS_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE__SHIFT = 0x0000001a;
    constexpr unsigned int GUS_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER__SHIFT = 0x00000010;
    constexpr unsigned int PA_CL_ENHANCE__EN_32BIT_OBJPRIMID__SHIFT = 0x00000017;
    constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_SHD_OBJPRIM_ID__SHIFT = 0x0000001a;
    constexpr unsigned int PA_SC_ENHANCE_1__ALLOW_SCALE_LINE_WIDTH_PAD_WITH_BINNING__SHIFT = 0x00000011;
    constexpr unsigned int PA_SC_ENHANCE_1__DEBUG_PIXEL_PICKER_XY_UNPACK__SHIFT = 0x0000000c;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_SC_SEND_DB_VPZ_FOR_COMPOUND_INDEX_EN__SHIFT = 0x00000006;
    constexpr unsigned int PA_SC_FOV_WINDOW_LR__LEFT_EYE_FOV_LEFT__SHIFT = 0x00000000;
    constexpr unsigned int PA_SC_FOV_WINDOW_LR__LEFT_EYE_FOV_RIGHT__SHIFT = 0x00000008;
    constexpr unsigned int PA_SC_FOV_WINDOW_LR__RIGHT_EYE_FOV_LEFT__SHIFT = 0x00000010;
    constexpr unsigned int PA_SC_FOV_WINDOW_LR__RIGHT_EYE_FOV_RIGHT__SHIFT = 0x00000018;
    constexpr unsigned int PA_SC_FOV_WINDOW_TB__FOV_BOT__SHIFT      = 0x00000008;
    constexpr unsigned int PA_SC_FOV_WINDOW_TB__FOV_TOP__SHIFT      = 0x00000000;
    constexpr unsigned int PA_SC_HORIZ_GRID__BOT_HALF__SHIFT        = 0x00000010;
    constexpr unsigned int PA_SC_HORIZ_GRID__BOT_QTR__SHIFT         = 0x00000018;
    constexpr unsigned int PA_SC_HORIZ_GRID__TOP_HALF__SHIFT        = 0x00000008;
    constexpr unsigned int PA_SC_HORIZ_GRID__TOP_QTR__SHIFT         = 0x00000000;
    constexpr unsigned int PA_SC_LEFT_VERT_GRID__LEFT_HALF__SHIFT   = 0x00000008;
    constexpr unsigned int PA_SC_LEFT_VERT_GRID__LEFT_QTR__SHIFT    = 0x00000000;
    constexpr unsigned int PA_SC_LEFT_VERT_GRID__RIGHT_HALF__SHIFT  = 0x00000010;
    constexpr unsigned int PA_SC_LEFT_VERT_GRID__RIGHT_QTR__SHIFT   = 0x00000018;
    constexpr unsigned int PA_SC_MODE_CNTL_0__SCALE_LINE_WIDTH_PAD__SHIFT = 0x00000004;
    constexpr unsigned int PA_SC_RIGHT_VERT_GRID__LEFT_HALF__SHIFT  = 0x00000008;
    constexpr unsigned int PA_SC_RIGHT_VERT_GRID__LEFT_QTR__SHIFT   = 0x00000000;
    constexpr unsigned int PA_SC_RIGHT_VERT_GRID__RIGHT_HALF__SHIFT = 0x00000010;
    constexpr unsigned int PA_SC_RIGHT_VERT_GRID__RIGHT_QTR__SHIFT  = 0x00000018;
    constexpr unsigned int RLC_SPM_MC_CNTL__RESERVED__SHIFT         = 0x00000010;
    constexpr unsigned int RMI_CLOCK_CNTRL__DYN_CLK_RB1_BUSY_MASK__SHIFT = 0x00000014;
    constexpr unsigned int RMI_CLOCK_CNTRL__DYN_CLK_RB1_WAKEUP_MASK__SHIFT = 0x00000019;
    constexpr unsigned int RMI_GENERAL_CNTL__RB1_HARVEST_EN__SHIFT  = 0x00000014;
    constexpr unsigned int RMI_GENERAL_STATUS__RDREQ_CONSUMER_FIFO_1_BUSY__SHIFT = 0x00000011;
    constexpr unsigned int RMI_GENERAL_STATUS__WRREQ_CONSUMER_FIFO_1_BUSY__SHIFT = 0x00000010;
    constexpr unsigned int RMI_SPARE_1__SPARE_BIT_8__SHIFT          = 0x00000000;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG_1__XBAR_ARB_ROUND_ROBIN_WEIGHT_RB1_RD__SHIFT = 0x00000010;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG_1__XBAR_ARB_ROUND_ROBIN_WEIGHT_RB1_WR__SHIFT = 0x00000018;
    constexpr unsigned int RMI_XBAR_CONFIG__XBAR_EN_IN_RB1__SHIFT   = 0x0000000e;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__BARRIERS__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__LDS__SHIFT   = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__SGPR__SHIFT  = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__VGPR__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__WAVES__SHIFT = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__BARRIERS__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__LDS__SHIFT   = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__SGPR__SHIFT  = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__VGPR__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__WAVES__SHIFT = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__EN__SHIFT = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__QUEUE_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__TYPE_MASK__SHIFT = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__EN__SHIFT = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__QUEUE_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__TYPE_MASK__SHIFT = 0x00000001;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__DISPATCH_DRAW_EN__SHIFT = 0x00000018;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_0__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_0__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_0__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_0__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_0__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_0__RESERVED__SHIFT = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_1__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_1__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_1__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_1__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_1__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_1__RESERVED__SHIFT = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_2__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_2__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_2__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_2__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_2__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_2__RESERVED__SHIFT = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_3__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_3__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_3__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_3__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_3__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_3__RESERVED__SHIFT = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_0__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_0__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_0__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_0__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_0__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_0__RESERVED__SHIFT = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_1__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_1__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_1__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_1__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_1__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_1__RESERVED__SHIFT = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_2__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_2__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_2__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_2__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_2__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_2__RESERVED__SHIFT = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_3__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_3__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_3__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_3__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_3__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_3__RESERVED__SHIFT = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_0__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_0__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_0__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_0__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_0__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_0__RESERVED__SHIFT = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_1__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_1__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_1__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_1__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_1__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_1__RESERVED__SHIFT = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_2__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_2__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_2__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_2__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_2__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_2__RESERVED__SHIFT = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_3__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_3__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_3__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_3__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_3__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_3__RESERVED__SHIFT = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_0__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_0__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_0__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_0__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_0__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_0__RESERVED__SHIFT = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_1__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_1__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_1__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_1__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_1__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_1__RESERVED__SHIFT = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_2__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_2__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_2__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_2__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_2__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_2__RESERVED__SHIFT = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_3__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_3__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_3__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_3__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_3__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_3__RESERVED__SHIFT = 0x0000000e;
    constexpr unsigned int SPI_SYS_COMPUTE__PIPE__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SYS_WIF_CNTL__THRESHOLD__SHIFT       = 0x00000000;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS4__VALUE__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS5__VALUE__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS6__VALUE__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS7__VALUE__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_6__EN_WARN__SHIFT  = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_6__MAX_CNT__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_7__EN_WARN__SHIFT  = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_7__MAX_CNT__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_8__EN_WARN__SHIFT  = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_8__MAX_CNT__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_9__EN_WARN__SHIFT  = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_9__MAX_CNT__SHIFT  = 0x00000000;
    constexpr unsigned int SP_CONFIG__UNUSED__SHIFT                 = 0x00000008;
    constexpr unsigned int SQ_CONFIG__DEBUG_ONE_INST_CLAUSE__SHIFT  = 0x0000000a;
    constexpr unsigned int SQ_CONFIG__DEBUG_SINGLE_MEMOP__SHIFT     = 0x00000009;
    constexpr unsigned int SQ_WATCH0_CNTL__MODE__SHIFT              = 0x0000001d;
    constexpr unsigned int SQ_WATCH1_CNTL__MODE__SHIFT              = 0x0000001d;
    constexpr unsigned int SQ_WATCH2_CNTL__MODE__SHIFT              = 0x0000001d;
    constexpr unsigned int SQ_WATCH3_CNTL__MODE__SHIFT              = 0x0000001d;
    constexpr unsigned int SX_DEBUG_1__DEBUG_DATA__SHIFT            = 0x00000012;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERFCOUNTER_SELECT2__SHIFT = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERFCOUNTER_SELECT3__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERFCOUNTER_SELECT1__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERFCOUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERFCOUNTER_SELECT2__SHIFT = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERFCOUNTER_SELECT3__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERFCOUNTER_SELECT1__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERFCOUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERFCOUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERFCOUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int UTCL1_CTRL__RESERVED__SHIFT              = 0x0000000f;
    constexpr unsigned int UTCL1_UTCL0_INVREQ_DISABLE__UTCL1_UTCL0_INVREQ_DISABLE__SHIFT = 0x00000000;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_BUSY__SHIFT         = 0x00000000;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_GS_BUSY__SHIFT      = 0x00000007;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_HS_BUSY__SHIFT      = 0x00000008;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_OUT_BUSY__SHIFT     = 0x00000002;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_OUT_INDX_BUSY__SHIFT = 0x00000001;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_PI_BUSY__SHIFT      = 0x00000006;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_PRIMGEN_BUSY__SHIFT = 0x0000000a;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_PT_BUSY__SHIFT      = 0x00000003;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_TE11_BUSY__SHIFT    = 0x00000009;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_TE_BUSY__SHIFT      = 0x00000004;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_VR_BUSY__SHIFT      = 0x00000005;
    constexpr unsigned int VGT_DISPATCH_DRAW_INDEX__MATCH_INDEX__SHIFT = 0x00000000;
    constexpr unsigned int VGT_DRAW_INITIATOR__GRBM_SKEW_NO_DEC__SHIFT = 0x00000008;
    constexpr unsigned int VGT_DRAW_INITIATOR__UNROLLED_INST__SHIFT = 0x00000007;
    constexpr unsigned int VGT_SHADER_STAGES_EN__DISPATCH_DRAW_EN__SHIFT = 0x00000009;
    constexpr unsigned int VGT_SHADER_STAGES_EN__DIS_DEALLOC_ACCUM_0__SHIFT = 0x0000000a;
    constexpr unsigned int VGT_SHADER_STAGES_EN__DIS_DEALLOC_ACCUM_1__SHIFT = 0x0000000b;
    constexpr unsigned int WD_CNTL_STATUS__WD_ADC_BUSY__SHIFT       = 0x00000003;
    constexpr unsigned int WD_CNTL_STATUS__WD_BUSY__SHIFT           = 0x00000000;
    constexpr unsigned int WD_CNTL_STATUS__WD_SPL_DI_BUSY__SHIFT    = 0x00000002;
    constexpr unsigned int WD_CNTL_STATUS__WD_SPL_DMA_BUSY__SHIFT   = 0x00000001;
} // namespace Gfx101

namespace Gfx101Plus
{
    constexpr unsigned int CB_COLOR0_ATTRIB3__CMASK_PIPE_ALIGNED__SHIFT = 0x0000001a;
    constexpr unsigned int CB_COLOR0_ATTRIB3__DCC_PIPE_ALIGNED__SHIFT = 0x0000001e;
    constexpr unsigned int CB_COLOR1_ATTRIB3__CMASK_PIPE_ALIGNED__SHIFT = 0x0000001a;
    constexpr unsigned int CB_COLOR1_ATTRIB3__DCC_PIPE_ALIGNED__SHIFT = 0x0000001e;
    constexpr unsigned int CB_COLOR2_ATTRIB3__CMASK_PIPE_ALIGNED__SHIFT = 0x0000001a;
    constexpr unsigned int CB_COLOR2_ATTRIB3__DCC_PIPE_ALIGNED__SHIFT = 0x0000001e;
    constexpr unsigned int CB_COLOR3_ATTRIB3__CMASK_PIPE_ALIGNED__SHIFT = 0x0000001a;
    constexpr unsigned int CB_COLOR3_ATTRIB3__DCC_PIPE_ALIGNED__SHIFT = 0x0000001e;
    constexpr unsigned int CB_COLOR4_ATTRIB3__CMASK_PIPE_ALIGNED__SHIFT = 0x0000001a;
    constexpr unsigned int CB_COLOR4_ATTRIB3__DCC_PIPE_ALIGNED__SHIFT = 0x0000001e;
    constexpr unsigned int CB_COLOR5_ATTRIB3__CMASK_PIPE_ALIGNED__SHIFT = 0x0000001a;
    constexpr unsigned int CB_COLOR5_ATTRIB3__DCC_PIPE_ALIGNED__SHIFT = 0x0000001e;
    constexpr unsigned int CB_COLOR6_ATTRIB3__CMASK_PIPE_ALIGNED__SHIFT = 0x0000001a;
    constexpr unsigned int CB_COLOR6_ATTRIB3__DCC_PIPE_ALIGNED__SHIFT = 0x0000001e;
    constexpr unsigned int CB_COLOR7_ATTRIB3__CMASK_PIPE_ALIGNED__SHIFT = 0x0000001a;
    constexpr unsigned int CB_COLOR7_ATTRIB3__DCC_PIPE_ALIGNED__SHIFT = 0x0000001e;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_LQUAD_FGCG__SHIFT = 0x00000017;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_TILE_FGCG__SHIFT = 0x00000016;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__COLOR_BIG_PAGE__SHIFT = 0x0000001f;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__FMASK_BIG_PAGE__SHIFT = 0x0000001e;
    constexpr unsigned int COMPUTE_RELAUNCH2__IS_EVENT__SHIFT       = 0x0000001e;
    constexpr unsigned int COMPUTE_RELAUNCH2__IS_STATE__SHIFT       = 0x0000001f;
    constexpr unsigned int COMPUTE_RELAUNCH2__PAYLOAD__SHIFT        = 0x00000000;
    constexpr unsigned int COMPUTE_USER_ACCUM_0__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int COMPUTE_USER_ACCUM_1__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int COMPUTE_USER_ACCUM_2__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int COMPUTE_USER_ACCUM_3__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int CP_CE_DOORBELL_CONTROL__DOORBELL_BIF_DROP__SHIFT = 0x00000001;
    constexpr unsigned int CP_CE_DOORBELL_CONTROL__DOORBELL_EN__SHIFT = 0x0000001e;
    constexpr unsigned int CP_CE_DOORBELL_CONTROL__DOORBELL_HIT__SHIFT = 0x0000001f;
    constexpr unsigned int CP_CE_DOORBELL_CONTROL__DOORBELL_OFFSET__SHIFT = 0x00000002;
    constexpr unsigned int CP_CE_JT_STAT__JT_LOADED__SHIFT          = 0x00000000;
    constexpr unsigned int CP_CE_JT_STAT__WR_MASK__SHIFT            = 0x00000010;
    constexpr unsigned int CP_DEBUG_2__CNTX_DONE_COPY_STATE_DISABLE__SHIFT = 0x0000000f;
    constexpr unsigned int CP_DEBUG_2__NOP_DISCARD_DISABLE__SHIFT   = 0x00000010;
    constexpr unsigned int CP_GFX_HPD_STATUS0__ENABLE_OVERIDE_QUEUEID__SHIFT = 0x0000001d;
    constexpr unsigned int CP_GFX_HPD_STATUS0__FORCE_MAPPED_QUEUE__SHIFT = 0x00000010;
    constexpr unsigned int CP_GFX_HPD_STATUS0__OVERIDE_QUEUEID__SHIFT = 0x0000001e;
    constexpr unsigned int CP_GFX_HQD_CE_BASE_HI__RB_BASE_HI__SHIFT = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_CE_BASE__RB_BASE__SHIFT       = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_CE_CNTL__CACHE_POLICY__SHIFT  = 0x00000018;
    constexpr unsigned int CP_GFX_HQD_CE_CNTL__MIN_AVAILSZ__SHIFT   = 0x00000014;
    constexpr unsigned int CP_GFX_HQD_CE_CNTL__MIN_IB_AVAILSZ__SHIFT = 0x00000016;
    constexpr unsigned int CP_GFX_HQD_CE_CNTL__RB_BLKSZ__SHIFT      = 0x00000008;
    constexpr unsigned int CP_GFX_HQD_CE_CNTL__RB_BUFSZ__SHIFT      = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_CE_CNTL__RB_EXE__SHIFT        = 0x0000001c;
    constexpr unsigned int CP_GFX_HQD_CE_CNTL__RB_NO_UPDATE__SHIFT  = 0x0000001b;
    constexpr unsigned int CP_GFX_HQD_CE_CNTL__RB_RPTR_WR_ENA__SHIFT = 0x0000001f;
    constexpr unsigned int CP_GFX_HQD_CE_CNTL__RB_VOLATILE__SHIFT   = 0x0000001a;
    constexpr unsigned int CP_GFX_HQD_CE_CSMD_RPTR__RB_RPTR__SHIFT  = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_CE_OFFSET__DISABLE_RB_OFFSET__SHIFT = 0x0000001f;
    constexpr unsigned int CP_GFX_HQD_CE_OFFSET__RB_OFFSET__SHIFT   = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_CE_RPTR_ADDR_HI__RB_RPTR_ADDR_HI__SHIFT = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_CE_RPTR_ADDR__RB_RPTR_ADDR__SHIFT = 0x00000002;
    constexpr unsigned int CP_GFX_HQD_CE_RPTR_WR__RB_RPTR_WR__SHIFT = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_CE_RPTR__RB_RPTR__SHIFT       = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_CE_WPTR_HI__RB_WPTR__SHIFT    = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_CE_WPTR_POLL_ADDR_HI__RB_WPTR_POLL_ADDR_HI__SHIFT = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_CE_WPTR_POLL_ADDR_LO__RB_WPTR_POLL_ADDR_LO__SHIFT = 0x00000002;
    constexpr unsigned int CP_GFX_HQD_CE_WPTR__RB_WPTR__SHIFT       = 0x00000000;
    constexpr unsigned int CP_GFX_HQD_CNTL__CE_HQD_NEQ_RB_HQD__SHIFT = 0x0000001e;
    constexpr unsigned int CP_GFX_HQD_CNTL__KMD_QUEUE__SHIFT        = 0x0000001d;
    constexpr unsigned int CP_MEC_JT_STAT__JT_LOADED__SHIFT         = 0x00000000;
    constexpr unsigned int CP_MEC_JT_STAT__WR_MASK__SHIFT           = 0x00000010;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL4__DOORBELL_EN__SHIFT = 0x0000001e;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL4__DOORBELL_HIT__SHIFT = 0x0000001f;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL4__DOORBELL_OFFSET__SHIFT = 0x00000002;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL5__DOORBELL_EN__SHIFT = 0x0000001e;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL5__DOORBELL_HIT__SHIFT = 0x0000001f;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL5__DOORBELL_OFFSET__SHIFT = 0x00000002;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL6__DOORBELL_EN__SHIFT = 0x0000001e;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL6__DOORBELL_HIT__SHIFT = 0x0000001f;
    constexpr unsigned int CP_MES_DOORBELL_CONTROL6__DOORBELL_OFFSET__SHIFT = 0x00000002;
    constexpr unsigned int CP_MES_GP0_HI__M_RET_ADDR__SHIFT         = 0x00000000;
    constexpr unsigned int CP_MES_GP0_LO__DATA__SHIFT               = 0x00000001;
    constexpr unsigned int CP_MES_GP0_LO__PG_VIRT_HALTED__SHIFT     = 0x00000000;
    constexpr unsigned int CP_MES_GP1_HI__RD_WR_SELECT_HI__SHIFT    = 0x00000000;
    constexpr unsigned int CP_MES_GP1_LO__RD_WR_SELECT_LO__SHIFT    = 0x00000000;
    constexpr unsigned int CP_MES_GP2_HI__STACK_PNTR_HI__SHIFT      = 0x00000000;
    constexpr unsigned int CP_MES_GP2_LO__STACK_PNTR_LO__SHIFT      = 0x00000000;
    constexpr unsigned int CP_MES_GP3_HI__DATA__SHIFT               = 0x00000000;
    constexpr unsigned int CP_MES_GP3_LO__DATA__SHIFT               = 0x00000000;
    constexpr unsigned int CP_MES_GP4_HI__DATA__SHIFT               = 0x00000000;
    constexpr unsigned int CP_MES_GP4_LO__DATA__SHIFT               = 0x00000000;
    constexpr unsigned int CP_MES_GP5_HI__M_RET_ADDR__SHIFT         = 0x00000000;
    constexpr unsigned int CP_MES_GP5_LO__DATA__SHIFT               = 0x00000001;
    constexpr unsigned int CP_MES_GP5_LO__PG_VIRT_HALTED__SHIFT     = 0x00000000;
    constexpr unsigned int CP_MES_GP6_HI__RD_WR_SELECT_HI__SHIFT    = 0x00000000;
    constexpr unsigned int CP_MES_GP6_LO__RD_WR_SELECT_LO__SHIFT    = 0x00000000;
    constexpr unsigned int CP_MES_GP7_HI__STACK_PNTR_HI__SHIFT      = 0x00000000;
    constexpr unsigned int CP_MES_GP7_LO__STACK_PNTR_LO__SHIFT      = 0x00000000;
    constexpr unsigned int CP_MES_GP8_HI__DATA__SHIFT               = 0x00000000;
    constexpr unsigned int CP_MES_GP8_LO__DATA__SHIFT               = 0x00000000;
    constexpr unsigned int CP_MES_GP9_HI__DATA__SHIFT               = 0x00000000;
    constexpr unsigned int CP_MES_GP9_LO__DATA__SHIFT               = 0x00000000;
    constexpr unsigned int CP_PFP_JT_STAT__JT_LOADED__SHIFT         = 0x00000000;
    constexpr unsigned int CP_PFP_JT_STAT__WR_MASK__SHIFT           = 0x00000010;
    constexpr unsigned int CP_PQ_STATUS__DOORBELL_UPDATED_MODE__SHIFT = 0x00000003;
    constexpr unsigned int CP_RB0_CNTL__CE_HQD_NEQ_RB_HQD__SHIFT    = 0x0000001e;
    constexpr unsigned int CP_RB1_CNTL__CE_HQD_NEQ_RB_HQD__SHIFT    = 0x0000001e;
    constexpr unsigned int CP_RB1_CNTL__KMD_QUEUE__SHIFT            = 0x0000001d;
    constexpr unsigned int CP_RB2_CNTL__CE_HQD_NEQ_RB_HQD__SHIFT    = 0x0000001e;
    constexpr unsigned int CP_RB2_CNTL__KMD_QUEUE__SHIFT            = 0x0000001d;
    constexpr unsigned int CP_RB_CNTL__CE_HQD_NEQ_RB_HQD__SHIFT     = 0x0000001e;
    constexpr unsigned int CP_RB_CNTL__KMD_QUEUE__SHIFT             = 0x0000001d;
    constexpr unsigned int CP_VMID_RESET__PIPE0_QUEUES__SHIFT       = 0x00000010;
    constexpr unsigned int CP_VMID_RESET__PIPE1_QUEUES__SHIFT       = 0x00000018;
    constexpr unsigned int DB_DEBUG3__DISABLE_RELOAD_CONTEXT_DRAW_DATA__SHIFT = 0x00000001;
    constexpr unsigned int DB_DFSM_CONFIG__CAM_WATERMARK__SHIFT     = 0x00000010;
    constexpr unsigned int DB_DFSM_CONFIG__OUTPUT_WATCHDOG__SHIFT   = 0x00000018;
    constexpr unsigned int DB_DFSM_CONFIG__SQUAD_WATERMARK__SHIFT   = 0x00000004;
    constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_CB_RMIRET_OVERRIDE__SHIFT = 0x00000006;
    constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_SC_TILE_OVERRIDE__SHIFT = 0x00000005;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__S_BIG_PAGE__SHIFT = 0x00000019;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__Z_BIG_PAGE__SHIFT = 0x00000018;
    constexpr unsigned int GCR_GENERAL_CNTL__ENABLE_16K_UTCL2_REQ__SHIFT = 0x0000000f;
    constexpr unsigned int GC_THROTTLE_CTRL1__PCC_FP_PROGRAM_STEP_EN__SHIFT = 0x00000000;
    constexpr unsigned int GC_THROTTLE_CTRL1__PCC_PROGRAM_MAX_STEP__SHIFT = 0x00000005;
    constexpr unsigned int GC_THROTTLE_CTRL1__PCC_PROGRAM_MIN_STEP__SHIFT = 0x00000001;
    constexpr unsigned int GC_THROTTLE_CTRL1__PCC_PROGRAM_UPWARDS_STEP_SIZE__SHIFT = 0x0000000a;
    constexpr unsigned int GC_THROTTLE_CTRL1__PWRBRK_FP_PROGRAM_STEP_EN__SHIFT = 0x0000000d;
    constexpr unsigned int GC_THROTTLE_CTRL1__PWRBRK_PROGRAM_MAX_STEP__SHIFT = 0x00000012;
    constexpr unsigned int GC_THROTTLE_CTRL1__PWRBRK_PROGRAM_MIN_STEP__SHIFT = 0x0000000e;
    constexpr unsigned int GC_THROTTLE_CTRL1__PWRBRK_PROGRAM_UPWARDS_STEP_SIZE__SHIFT = 0x00000017;
    constexpr unsigned int GC_THROTTLE_CTRL__THROTTLE_CTRL_CLK_EN_OVERRIDE__SHIFT = 0x0000001e;
    constexpr unsigned int GE_STATUS__PERFCOUNTER_STATUS__SHIFT     = 0x00000000;
    constexpr unsigned int GE_STATUS__THREAD_TRACE_STATUS__SHIFT    = 0x00000001;
    constexpr unsigned int GE_USER_VGPR_EN__EN_USER_VGPR1__SHIFT    = 0x00000000;
    constexpr unsigned int GE_USER_VGPR_EN__EN_USER_VGPR2__SHIFT    = 0x00000001;
    constexpr unsigned int GE_USER_VGPR_EN__EN_USER_VGPR3__SHIFT    = 0x00000002;
    constexpr unsigned int GRBM_IOV_READ_ERROR__IOV_ADDR__SHIFT     = 0x00000002;
    constexpr unsigned int GRBM_IOV_READ_ERROR__IOV_ERROR__SHIFT    = 0x0000001f;
    constexpr unsigned int GRBM_IOV_READ_ERROR__IOV_OP__SHIFT       = 0x0000001b;
    constexpr unsigned int GRBM_IOV_READ_ERROR__IOV_VFID__SHIFT     = 0x00000014;
    constexpr unsigned int GRBM_IOV_READ_ERROR__IOV_VF__SHIFT       = 0x0000001a;
    constexpr unsigned int PA_CL_ENHANCE__ECO_SPARE2__SHIFT         = 0x0000001d;
    constexpr unsigned int PA_CL_ENHANCE__ECO_SPARE3__SHIFT         = 0x0000001c;
    constexpr unsigned int PA_SC_ENHANCE_2__BREAK_WHEN_ONE_NULL_PRIM_BATCH__SHIFT = 0x0000001a;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_DFSM_FLUSH__SHIFT = 0x00000019;
    constexpr unsigned int PA_SC_ENHANCE_2__NULL_PRIM_BREAK_BATCH_LIMIT__SHIFT = 0x0000001b;
    constexpr unsigned int RLC_SPM_DEBUG__DATA0__SHIFT              = 0x00000000;
    constexpr unsigned int RLC_SPM_DEBUG__DATA1__SHIFT              = 0x00000001;
    constexpr unsigned int RLC_SPM_DEBUG__DATA2__SHIFT              = 0x00000002;
    constexpr unsigned int RLC_SPM_DEBUG__DATA3__SHIFT              = 0x00000003;
    constexpr unsigned int RLC_SPM_DEBUG__DATA4__SHIFT              = 0x00000004;
    constexpr unsigned int RLC_SPM_DEBUG__DATA5__SHIFT              = 0x00000005;
    constexpr unsigned int RLC_SPM_DEBUG__DATA6__SHIFT              = 0x00000006;
    constexpr unsigned int RLC_SPM_DEBUG__DATA7__SHIFT              = 0x00000007;
    constexpr unsigned int RLC_SPM_DEBUG__DATA8__SHIFT              = 0x00000008;
    constexpr unsigned int RLC_SPM_DEBUG__DATA9__SHIFT              = 0x00000009;
    constexpr unsigned int RLC_SPM_DEBUG__DATA10__SHIFT             = 0x0000000a;
    constexpr unsigned int RLC_SPM_DEBUG__DATA11__SHIFT             = 0x0000000b;
    constexpr unsigned int RLC_SPM_DEBUG__DATA12__SHIFT             = 0x0000000c;
    constexpr unsigned int RLC_SPM_DEBUG__DATA13__SHIFT             = 0x0000000d;
    constexpr unsigned int RLC_SPM_DEBUG__DATA14__SHIFT             = 0x0000000e;
    constexpr unsigned int RLC_SPM_DEBUG__DATA15__SHIFT             = 0x0000000f;
    constexpr unsigned int RLC_SPM_DEBUG__DATA16__SHIFT             = 0x00000010;
    constexpr unsigned int RLC_SPM_DEBUG__DATA17__SHIFT             = 0x00000011;
    constexpr unsigned int RLC_SPM_DEBUG__DATA18__SHIFT             = 0x00000012;
    constexpr unsigned int RLC_SPM_DEBUG__DATA19__SHIFT             = 0x00000013;
    constexpr unsigned int RLC_SPM_DEBUG__DATA20__SHIFT             = 0x00000014;
    constexpr unsigned int RLC_SPM_DEBUG__DATA21__SHIFT             = 0x00000015;
    constexpr unsigned int RLC_SPM_DEBUG__DATA22__SHIFT             = 0x00000016;
    constexpr unsigned int RLC_SPM_DEBUG__DATA23__SHIFT             = 0x00000017;
    constexpr unsigned int RLC_SPM_DEBUG__DATA24__SHIFT             = 0x00000018;
    constexpr unsigned int RLC_SPM_DEBUG__DATA25__SHIFT             = 0x00000019;
    constexpr unsigned int RLC_SPM_DEBUG__DATA26__SHIFT             = 0x0000001a;
    constexpr unsigned int RLC_SPM_DEBUG__DATA27__SHIFT             = 0x0000001b;
    constexpr unsigned int RLC_SPM_DEBUG__DATA28__SHIFT             = 0x0000001c;
    constexpr unsigned int RLC_SPM_DEBUG__DATA29__SHIFT             = 0x0000001d;
    constexpr unsigned int RLC_SPM_DEBUG__DATA30__SHIFT             = 0x0000001e;
    constexpr unsigned int RLC_SPM_DEBUG__DATA31__SHIFT             = 0x0000001f;
    constexpr unsigned int RLC_SPM_RING_WRPTR__PERFMON_RING_WRPTR__SHIFT = 0x00000005;
    constexpr unsigned int RLC_SPM_RING_WRPTR__RESERVED__SHIFT      = 0x00000000;
    constexpr unsigned int RLC_SPM_VIRT_CTRL__PauseSpmSamplingRequest__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_VIRT_STATUS__SpmSamplingPaused__SHIFT = 0x00000000;
    constexpr unsigned int RMI_SPARE_1__RMI_REORDER_DIS_BY_CID__SHIFT = 0x00000008;
    constexpr unsigned int RMI_SPARE__EARLY_WRITE_ACK_ENABLE_C_RW_NOA_RESOLVE_DIS__SHIFT = 0x00000004;
    constexpr unsigned int RMI_SPARE__NOFILL_RMI_CID_CC__SHIFT      = 0x00000008;
    constexpr unsigned int RMI_SPARE__NOFILL_RMI_CID_CM__SHIFT      = 0x0000000a;
    constexpr unsigned int RMI_SPARE__NOFILL_RMI_CID_DC__SHIFT      = 0x0000000b;
    constexpr unsigned int RMI_SPARE__NOFILL_RMI_CID_FC__SHIFT      = 0x00000009;
    constexpr unsigned int RMI_SPARE__NOFILL_RMI_CID_S__SHIFT       = 0x0000000d;
    constexpr unsigned int RMI_SPARE__NOFILL_RMI_CID_TILE__SHIFT    = 0x0000000e;
    constexpr unsigned int RMI_SPARE__NOFILL_RMI_CID_Z__SHIFT       = 0x0000000c;
    constexpr unsigned int RMI_SPARE__RMI_2_RB_REPEATER_FGCG_DISABLE__SHIFT = 0x00000003;
    constexpr unsigned int RMI_SPARE__RMI_REORDER_BYPASS_CHANNEL_DIS__SHIFT = 0x00000005;
    constexpr unsigned int RMI_SPARE__SPARE_BIT_15_0__SHIFT         = 0x0000000f;
    constexpr unsigned int RPB_DEINTRLV_COMBINE_CNTL__XPB_WRREQ_CRD__SHIFT = 0x00000006;
    constexpr unsigned int RPB_DF_SDPPORT_CNTL__DF_DATA_CRD__SHIFT  = 0x00000006;
    constexpr unsigned int RPB_DF_SDPPORT_CNTL__DF_HALT_THRESHOLD__SHIFT = 0x0000000c;
    constexpr unsigned int RPB_DF_SDPPORT_CNTL__DF_REQ_CRD__SHIFT   = 0x00000000;
    constexpr unsigned int RPB_VC_SWITCH_RDWR__XPB_RDREQ_CRD__SHIFT = 0x00000012;
    constexpr unsigned int SPI_CONFIG_CNTL_1__EN_USER_ACCUM__SHIFT  = 0x00000015;
    constexpr unsigned int SPI_DEBUG_CNTL_2__DISABLE_INTRA_PRIM_CONFLICT__SHIFT = 0x00000008;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_ESGS_0__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_ESGS_1__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_ESGS_2__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_ESGS_3__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_LSHS_0__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_LSHS_1__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_LSHS_2__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_LSHS_3__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_PS_0__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_PS_1__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_PS_2__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_PS_3__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_VS_0__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_VS_1__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_VS_2__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_VS_3__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_START_PHASE__PC_X_PHASE_SE0__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_START_PHASE__PC_X_PHASE_SE1__SHIFT   = 0x00000002;
    constexpr unsigned int SPI_START_PHASE__PC_X_PHASE_SE2__SHIFT   = 0x00000004;
    constexpr unsigned int SPI_START_PHASE__PC_X_PHASE_SE3__SHIFT   = 0x00000006;
    constexpr unsigned int SPI_USER_ACCUM_VMID_CNTL__EN_USER_ACCUM__SHIFT = 0x00000000;
    constexpr unsigned int SQC_MISC_CONFIG__SQC_SPI_TTRACE_FGCG_OVERRIDE__SHIFT = 0x00000005;
    constexpr unsigned int SQ_CONFIG__LDS_BUSY_HYSTERESIS_CNT__SHIFT = 0x0000000d;
    constexpr unsigned int SQ_CONFIG__SP_BUSY_HYSTERESIS_CNT__SHIFT = 0x0000000f;
    constexpr unsigned int SQ_CONFIG__TA_BUSY_HYSTERESIS_CNT__SHIFT = 0x0000001e;
    constexpr unsigned int SX_DEBUG_1__DISABLE_COL_VAL_READ_OPT__SHIFT = 0x00000011;
    constexpr unsigned int SX_DEBUG_1__DISABLE_REP_FGCG__SHIFT      = 0x0000000d;
    constexpr unsigned int TA_CNTL_AUX__ANISO_MAG_STEP_CLAMP__SHIFT = 0x00000008;
    constexpr unsigned int TA_CNTL_AUX__DERIV_ADJUST_DIS__SHIFT     = 0x00000004;
    constexpr unsigned int TD_CNTL__DISABLE_ROUND_TO_ZERO_FOR_LARGE_FLOAT_TO_SMALL_FLOAT__SHIFT = 0x00000016;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_MODE1_FILTER1_BYPASS__SHIFT = 0x00000017;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_MODE1_INTR_ON_ALLOC__SHIFT = 0x00000018;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_ONLY_MISS__SHIFT  = 0x00000009;
    constexpr unsigned int UTCL1_ALOG__UTCL1_ALOG_TRACK_SEGMENT_SIZE__SHIFT = 0x00000011;
    constexpr unsigned int VGT_GS_INSTANCE_CNT__EN_MAX_VERT_OUT_PER_GS_INSTANCE__SHIFT = 0x0000001f;
    constexpr unsigned int VGT_RESET_DEBUG__DISABLE_TE11_DIST_PIPE0__SHIFT = 0x00000003;
    constexpr unsigned int VGT_RESET_DEBUG__DISABLE_TE11_DIST_PIPE1__SHIFT = 0x00000004;
    constexpr unsigned int VGT_RESET_DEBUG__ENABLE_VMID_RESET_UTCL1__SHIFT = 0x00000005;
} // namespace Gfx101Plus

namespace Nv10
{
    constexpr unsigned int CB_HW_CONTROL_1__CC_CACHE_NUM_TAGS__SHIFT = 0x0000000b;
    constexpr unsigned int CB_HW_CONTROL_1__CM_TILE_FIFO_DEPTH__SHIFT = 0x00000011;
    constexpr unsigned int CB_HW_CONTROL_1__RMI_CREDITS__SHIFT      = 0x0000001a;
    constexpr unsigned int CB_HW_CONTROL_3__DISABLE_OVERWRITE_COMBINER_TARGET_MASK_VALIDATION__SHIFT = 0x00000008;
    constexpr unsigned int CH_ARB_CTRL__UC_IO_WR_PATH__SHIFT        = 0x00000003;
    constexpr unsigned int CP_HQD_PQ_CONTROL__ENDIAN_SWAP__SHIFT    = 0x00000010;
    constexpr unsigned int CP_RB0_CNTL__BUF_SWAP__SHIFT             = 0x00000010;
    constexpr unsigned int CP_RB_CNTL__BUF_SWAP__SHIFT              = 0x00000010;
    constexpr unsigned int CP_SD_CNTL__RMI_EN__SHIFT                = 0x00000008;
    constexpr unsigned int CP_STALLED_STAT1__RBIU_TO_MEMWR_NOT_RDY_TO_RCV__SHIFT = 0x00000004;
    constexpr unsigned int CP_STALLED_STAT1__RBIU_TO_SEM_NOT_RDY_TO_RCV__SHIFT = 0x00000002;
    constexpr unsigned int CP_STALLED_STAT2__EOPD_FIFO_NEEDS_SC_EOP_DONE__SHIFT = 0x00000015;
    constexpr unsigned int CP_STALLED_STAT2__EOPD_FIFO_NEEDS_WR_CONFIRM__SHIFT = 0x00000016;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE0__SHIFT = 0x00000000;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE1__SHIFT = 0x00000001;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE2__SHIFT = 0x00000002;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE3__SHIFT = 0x00000003;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE4__SHIFT = 0x00000004;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE5__SHIFT = 0x00000005;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE6__SHIFT = 0x00000006;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE7__SHIFT = 0x00000007;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE8__SHIFT = 0x00000008;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE9__SHIFT = 0x00000009;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE10__SHIFT = 0x0000000a;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE11__SHIFT = 0x0000000b;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE12__SHIFT = 0x0000000c;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE13__SHIFT = 0x0000000d;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE14__SHIFT = 0x0000000e;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE15__SHIFT = 0x0000000f;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE16__SHIFT = 0x00000010;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE17__SHIFT = 0x00000011;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE18__SHIFT = 0x00000012;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE19__SHIFT = 0x00000013;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE20__SHIFT = 0x00000014;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE21__SHIFT = 0x00000015;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE22__SHIFT = 0x00000016;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE23__SHIFT = 0x00000017;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE24__SHIFT = 0x00000018;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE25__SHIFT = 0x00000019;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE26__SHIFT = 0x0000001a;
    constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_1__SHIFT = 0x00000000;
    constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_2__SHIFT = 0x00000002;
    constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_3__SHIFT = 0x00000003;
    constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_4__SHIFT = 0x00000004;
    constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_5__SHIFT = 0x0000000a;
    constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_6__SHIFT = 0x00000011;
    constexpr unsigned int DB_RESERVED_REG_1__FIELD_1__SHIFT        = 0x00000000;
    constexpr unsigned int DB_RESERVED_REG_1__FIELD_2__SHIFT        = 0x0000000b;
    constexpr unsigned int DB_RESERVED_REG_2__FIELD_1__SHIFT        = 0x00000000;
    constexpr unsigned int DB_RESERVED_REG_2__FIELD_2__SHIFT        = 0x00000004;
    constexpr unsigned int DB_RESERVED_REG_2__FIELD_3__SHIFT        = 0x00000008;
    constexpr unsigned int DB_RESERVED_REG_2__FIELD_4__SHIFT        = 0x0000000d;
    constexpr unsigned int DB_RESERVED_REG_2__FIELD_5__SHIFT        = 0x0000000f;
    constexpr unsigned int DB_RESERVED_REG_2__FIELD_6__SHIFT        = 0x00000011;
    constexpr unsigned int DB_RESERVED_REG_2__FIELD_7__SHIFT        = 0x00000013;
    constexpr unsigned int DB_RESERVED_REG_2__FIELD_8__SHIFT        = 0x0000001c;
    constexpr unsigned int DB_RESERVED_REG_3__FIELD_1__SHIFT        = 0x00000000;
    constexpr unsigned int DB_STENCIL_INFO__RESERVED_FIELD_1__SHIFT = 0x0000000d;
    constexpr unsigned int DB_Z_INFO__RESERVED_FIELD_1__SHIFT       = 0x0000000d;
    constexpr unsigned int FORCE_SYMCLK_DISABLE__FORCE_SYMCLKA_DISABLE__SHIFT = 0x00000000;
    constexpr unsigned int FORCE_SYMCLK_DISABLE__FORCE_SYMCLKB_DISABLE__SHIFT = 0x00000001;
    constexpr unsigned int FORCE_SYMCLK_DISABLE__FORCE_SYMCLKC_DISABLE__SHIFT = 0x00000002;
    constexpr unsigned int FORCE_SYMCLK_DISABLE__FORCE_SYMCLKD_DISABLE__SHIFT = 0x00000003;
    constexpr unsigned int FORCE_SYMCLK_DISABLE__FORCE_SYMCLKE_DISABLE__SHIFT = 0x00000004;
    constexpr unsigned int FORCE_SYMCLK_DISABLE__FORCE_SYMCLKF_DISABLE__SHIFT = 0x00000005;
    constexpr unsigned int GB_MACROTILE_MODE0__BANK_HEIGHT__SHIFT   = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE0__BANK_WIDTH__SHIFT    = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE0__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE0__NUM_BANKS__SHIFT     = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE1__BANK_HEIGHT__SHIFT   = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE1__BANK_WIDTH__SHIFT    = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE1__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE1__NUM_BANKS__SHIFT     = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE2__BANK_HEIGHT__SHIFT   = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE2__BANK_WIDTH__SHIFT    = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE2__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE2__NUM_BANKS__SHIFT     = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE3__BANK_HEIGHT__SHIFT   = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE3__BANK_WIDTH__SHIFT    = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE3__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE3__NUM_BANKS__SHIFT     = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE4__BANK_HEIGHT__SHIFT   = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE4__BANK_WIDTH__SHIFT    = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE4__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE4__NUM_BANKS__SHIFT     = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE5__BANK_HEIGHT__SHIFT   = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE5__BANK_WIDTH__SHIFT    = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE5__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE5__NUM_BANKS__SHIFT     = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE6__BANK_HEIGHT__SHIFT   = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE6__BANK_WIDTH__SHIFT    = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE6__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE6__NUM_BANKS__SHIFT     = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE7__BANK_HEIGHT__SHIFT   = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE7__BANK_WIDTH__SHIFT    = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE7__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE7__NUM_BANKS__SHIFT     = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE8__BANK_HEIGHT__SHIFT   = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE8__BANK_WIDTH__SHIFT    = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE8__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE8__NUM_BANKS__SHIFT     = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE9__BANK_HEIGHT__SHIFT   = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE9__BANK_WIDTH__SHIFT    = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE9__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE9__NUM_BANKS__SHIFT     = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE10__BANK_HEIGHT__SHIFT  = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE10__BANK_WIDTH__SHIFT   = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE10__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE10__NUM_BANKS__SHIFT    = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE11__BANK_HEIGHT__SHIFT  = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE11__BANK_WIDTH__SHIFT   = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE11__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE11__NUM_BANKS__SHIFT    = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE12__BANK_HEIGHT__SHIFT  = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE12__BANK_WIDTH__SHIFT   = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE12__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE12__NUM_BANKS__SHIFT    = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE13__BANK_HEIGHT__SHIFT  = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE13__BANK_WIDTH__SHIFT   = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE13__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE13__NUM_BANKS__SHIFT    = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE14__BANK_HEIGHT__SHIFT  = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE14__BANK_WIDTH__SHIFT   = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE14__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE14__NUM_BANKS__SHIFT    = 0x00000006;
    constexpr unsigned int GB_MACROTILE_MODE15__BANK_HEIGHT__SHIFT  = 0x00000002;
    constexpr unsigned int GB_MACROTILE_MODE15__BANK_WIDTH__SHIFT   = 0x00000000;
    constexpr unsigned int GB_MACROTILE_MODE15__MACRO_TILE_ASPECT__SHIFT = 0x00000004;
    constexpr unsigned int GB_MACROTILE_MODE15__NUM_BANKS__SHIFT    = 0x00000006;
    constexpr unsigned int GB_TILE_MODE0__ARRAY_MODE__SHIFT         = 0x00000002;
    constexpr unsigned int GB_TILE_MODE0__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE0__PIPE_CONFIG__SHIFT        = 0x00000006;
    constexpr unsigned int GB_TILE_MODE0__SAMPLE_SPLIT__SHIFT       = 0x00000019;
    constexpr unsigned int GB_TILE_MODE0__TILE_SPLIT__SHIFT         = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE1__ARRAY_MODE__SHIFT         = 0x00000002;
    constexpr unsigned int GB_TILE_MODE1__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE1__PIPE_CONFIG__SHIFT        = 0x00000006;
    constexpr unsigned int GB_TILE_MODE1__SAMPLE_SPLIT__SHIFT       = 0x00000019;
    constexpr unsigned int GB_TILE_MODE1__TILE_SPLIT__SHIFT         = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE2__ARRAY_MODE__SHIFT         = 0x00000002;
    constexpr unsigned int GB_TILE_MODE2__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE2__PIPE_CONFIG__SHIFT        = 0x00000006;
    constexpr unsigned int GB_TILE_MODE2__SAMPLE_SPLIT__SHIFT       = 0x00000019;
    constexpr unsigned int GB_TILE_MODE2__TILE_SPLIT__SHIFT         = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE3__ARRAY_MODE__SHIFT         = 0x00000002;
    constexpr unsigned int GB_TILE_MODE3__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE3__PIPE_CONFIG__SHIFT        = 0x00000006;
    constexpr unsigned int GB_TILE_MODE3__SAMPLE_SPLIT__SHIFT       = 0x00000019;
    constexpr unsigned int GB_TILE_MODE3__TILE_SPLIT__SHIFT         = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE4__ARRAY_MODE__SHIFT         = 0x00000002;
    constexpr unsigned int GB_TILE_MODE4__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE4__PIPE_CONFIG__SHIFT        = 0x00000006;
    constexpr unsigned int GB_TILE_MODE4__SAMPLE_SPLIT__SHIFT       = 0x00000019;
    constexpr unsigned int GB_TILE_MODE4__TILE_SPLIT__SHIFT         = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE5__ARRAY_MODE__SHIFT         = 0x00000002;
    constexpr unsigned int GB_TILE_MODE5__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE5__PIPE_CONFIG__SHIFT        = 0x00000006;
    constexpr unsigned int GB_TILE_MODE5__SAMPLE_SPLIT__SHIFT       = 0x00000019;
    constexpr unsigned int GB_TILE_MODE5__TILE_SPLIT__SHIFT         = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE6__ARRAY_MODE__SHIFT         = 0x00000002;
    constexpr unsigned int GB_TILE_MODE6__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE6__PIPE_CONFIG__SHIFT        = 0x00000006;
    constexpr unsigned int GB_TILE_MODE6__SAMPLE_SPLIT__SHIFT       = 0x00000019;
    constexpr unsigned int GB_TILE_MODE6__TILE_SPLIT__SHIFT         = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE7__ARRAY_MODE__SHIFT         = 0x00000002;
    constexpr unsigned int GB_TILE_MODE7__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE7__PIPE_CONFIG__SHIFT        = 0x00000006;
    constexpr unsigned int GB_TILE_MODE7__SAMPLE_SPLIT__SHIFT       = 0x00000019;
    constexpr unsigned int GB_TILE_MODE7__TILE_SPLIT__SHIFT         = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE8__ARRAY_MODE__SHIFT         = 0x00000002;
    constexpr unsigned int GB_TILE_MODE8__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE8__PIPE_CONFIG__SHIFT        = 0x00000006;
    constexpr unsigned int GB_TILE_MODE8__SAMPLE_SPLIT__SHIFT       = 0x00000019;
    constexpr unsigned int GB_TILE_MODE8__TILE_SPLIT__SHIFT         = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE9__ARRAY_MODE__SHIFT         = 0x00000002;
    constexpr unsigned int GB_TILE_MODE9__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE9__PIPE_CONFIG__SHIFT        = 0x00000006;
    constexpr unsigned int GB_TILE_MODE9__SAMPLE_SPLIT__SHIFT       = 0x00000019;
    constexpr unsigned int GB_TILE_MODE9__TILE_SPLIT__SHIFT         = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE10__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE10__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE10__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE10__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE10__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE11__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE11__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE11__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE11__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE11__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE12__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE12__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE12__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE12__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE12__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE13__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE13__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE13__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE13__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE13__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE14__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE14__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE14__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE14__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE14__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE15__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE15__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE15__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE15__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE15__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE16__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE16__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE16__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE16__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE16__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE17__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE17__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE17__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE17__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE17__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE18__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE18__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE18__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE18__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE18__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE19__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE19__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE19__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE19__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE19__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE20__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE20__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE20__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE20__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE20__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE21__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE21__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE21__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE21__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE21__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE22__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE22__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE22__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE22__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE22__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE23__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE23__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE23__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE23__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE23__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE24__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE24__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE24__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE24__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE24__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE25__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE25__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE25__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE25__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE25__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE26__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE26__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE26__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE26__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE26__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE27__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE27__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE27__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE27__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE27__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE28__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE28__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE28__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE28__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE28__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE29__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE29__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE29__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE29__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE29__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE30__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE30__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE30__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE30__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE30__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GB_TILE_MODE31__ARRAY_MODE__SHIFT        = 0x00000002;
    constexpr unsigned int GB_TILE_MODE31__MICRO_TILE_MODE_NEW__SHIFT = 0x00000016;
    constexpr unsigned int GB_TILE_MODE31__PIPE_CONFIG__SHIFT       = 0x00000006;
    constexpr unsigned int GB_TILE_MODE31__SAMPLE_SPLIT__SHIFT      = 0x00000019;
    constexpr unsigned int GB_TILE_MODE31__TILE_SPLIT__SHIFT        = 0x0000000b;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER0_CFG__CLEAR__SHIFT = 0x0000001d;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER0_CFG__ENABLE__SHIFT = 0x0000001c;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER0_CFG__PERF_MODE__SHIFT = 0x00000018;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER0_CFG__PERF_SEL_END__SHIFT = 0x00000008;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER0_CFG__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER1_CFG__CLEAR__SHIFT = 0x0000001d;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER1_CFG__ENABLE__SHIFT = 0x0000001c;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER1_CFG__PERF_MODE__SHIFT = 0x00000018;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER1_CFG__PERF_SEL_END__SHIFT = 0x00000008;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER1_CFG__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_MODE__COMPARE_MODE0__SHIFT = 0x00000000;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_MODE__COMPARE_MODE1__SHIFT = 0x00000002;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_MODE__COMPARE_MODE2__SHIFT = 0x00000004;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_MODE__COMPARE_MODE3__SHIFT = 0x00000006;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_MODE__COMPARE_VALUE0__SHIFT = 0x00000008;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_MODE__COMPARE_VALUE1__SHIFT = 0x0000000c;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_MODE__COMPARE_VALUE2__SHIFT = 0x00000010;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_MODE__COMPARE_VALUE3__SHIFT = 0x00000014;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT = 0x0000001c;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT = 0x00000018;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT = 0x00000018;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_HI__COMPARE_VALUE__SHIFT = 0x00000010;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_HI__COUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_LO__COUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL__SHIFT = 0x00000019;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY__SHIFT = 0x00000018;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_RSLT_CNTL__START_TRIGGER__SHIFT = 0x00000008;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE__SHIFT = 0x0000001a;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_OVRD_LDS__OVRRD_VALUE__SHIFT      = 0x00000004;
    constexpr unsigned int GE_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT = 0x00000018;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT__PERF_MODE0__SHIFT = 0x00000018;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT__PERF_SEL0__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int GE_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT = 0x00000018;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT__PERF_MODE0__SHIFT = 0x00000018;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT__PERF_SEL0__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int GE_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT = 0x00000018;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT__PERF_MODE0__SHIFT = 0x00000018;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT__PERF_SEL0__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int GE_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT = 0x00000018;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT = 0x0000000a;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT = 0x00000014;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT__PERF_MODE0__SHIFT = 0x00000018;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT__PERF_SEL0__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT = 0x0000000a;
    constexpr unsigned int GE_PERFCOUNTER4_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER4_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER4_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER4_SELECT__PERF_SEL0__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER5_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER5_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER5_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER5_SELECT__PERF_SEL0__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER6_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER6_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER6_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER6_SELECT__PERF_SEL0__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER7_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER7_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER7_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER7_SELECT__PERF_SEL0__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER8_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER8_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER8_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER8_SELECT__PERF_SEL0__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER9_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER9_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER9_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER9_SELECT__PERF_SEL0__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER10_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER10_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER10_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER10_SELECT__PERF_SEL0__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER11_HI__PERFCOUNTER_HI__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER11_LO__PERFCOUNTER_LO__SHIFT = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER11_SELECT__PERF_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER11_SELECT__PERF_SEL0__SHIFT = 0x00000000;
    constexpr unsigned int GFX_GAP_PWROK__gfx_gap_pwrok__SHIFT      = 0x00000000;
    constexpr unsigned int GL1_DRAM_BURST_CTRL__GATHER_64B_IO_BURST_DISABLE__SHIFT = 0x00000005;
    constexpr unsigned int GL1_DRAM_BURST_CTRL__GATHER_64B_MEMORY_BURST_DISABLE__SHIFT = 0x00000004;
    constexpr unsigned int GRBM_PM_CNTL__PM_READY__SHIFT            = 0x00000000;
    constexpr unsigned int GRBM_PM_CNTL__PM_START__SHIFT            = 0x00000010;
    constexpr unsigned int GSL_SOURCE_SELECT__GSL0_READY_SOURCE_SEL__SHIFT = 0x00000000;
    constexpr unsigned int GSL_SOURCE_SELECT__GSL1_READY_SOURCE_SEL__SHIFT = 0x00000004;
    constexpr unsigned int GSL_SOURCE_SELECT__GSL2_READY_SOURCE_SEL__SHIFT = 0x00000008;
    constexpr unsigned int GSL_SOURCE_SELECT__GSL_TIMING_SYNC_SEL__SHIFT = 0x00000010;
    constexpr unsigned int PA_CL_CNTL_STATUS__UTC_FAULT_DETECTED__SHIFT = 0x00000000;
    constexpr unsigned int PA_CL_CNTL_STATUS__UTC_PRT_DETECTED__SHIFT = 0x00000002;
    constexpr unsigned int PA_CL_CNTL_STATUS__UTC_RETRY_DETECTED__SHIFT = 0x00000001;
    constexpr unsigned int PA_SC_ENHANCE_2__ECO_SPARE0__SHIFT       = 0x00000000;
    constexpr unsigned int PA_SC_ENHANCE_2__ECO_SPARE1__SHIFT       = 0x00000001;
    constexpr unsigned int PA_SC_ENHANCE_2__ECO_SPARE2__SHIFT       = 0x00000002;
    constexpr unsigned int PA_SC_ENHANCE_2__ECO_SPARE3__SHIFT       = 0x00000003;
    constexpr unsigned int PA_SC_ENHANCE_2__RSVD__SHIFT             = 0x0000001e;
    constexpr unsigned int PWROK_REFCLK_GAP_CYCLES__Pwrok_PostAssertion_clkgap_cycles__SHIFT = 0x00000008;
    constexpr unsigned int PWROK_REFCLK_GAP_CYCLES__Pwrok_PreAssertion_clkgap_cycles__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_ADDR__RESERVED__SHIFT = 0x00000009;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__RESERVED__SHIFT      = 0x0000000a;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeAccumDoneInt__SHIFT = 0x00000004;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeResetAccum__SHIFT = 0x00000005;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeSpmDoneInt__SHIFT = 0x00000003;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeStartSpm__SHIFT = 0x00000006;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__AutoAccumEn__SHIFT   = 0x00000001;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__AutoResetPerfmonDisable__SHIFT = 0x00000006;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__AutoSpmEn__SHIFT     = 0x00000002;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__Globals_LoadOverride__SHIFT = 0x00000003;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__RESERVED__SHIFT      = 0x00000007;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__SE0_LoadOverride__SHIFT = 0x00000004;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__SE1_LoadOverride__SHIFT = 0x00000005;
    constexpr unsigned int RLC_SPM_ACCUM_SAMPLES_REQUESTED__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__RESERVED__SHIFT    = 0x00000010;
    constexpr unsigned int RLC_SPM_ACCUM_THRESHOLD__RESERVED__SHIFT = 0x00000010;
    constexpr unsigned int RLC_SPM_MC_CNTL__RESERVED_2__SHIFT       = 0x0000000d;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_4_0__SHIFT        = 0x00000008;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_4_1__SHIFT        = 0x0000000c;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_16__SHIFT         = 0x00000000;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_17__SHIFT         = 0x00000001;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_18__SHIFT         = 0x00000002;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_19__SHIFT         = 0x00000003;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_20__SHIFT         = 0x00000004;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_21__SHIFT         = 0x00000005;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_22__SHIFT         = 0x00000006;
    constexpr unsigned int RMI_SPARE_2__SPARE_BIT_23__SHIFT         = 0x00000007;
    constexpr unsigned int RMI_SPARE__SPARE_BIT_6__SHIFT            = 0x00000006;
    constexpr unsigned int RPB_ATS_CNTL2__INVAL_COM_ROUTING_CODE__SHIFT = 0x0000000f;
    constexpr unsigned int RPB_ATS_CNTL2__PAGE_REQ_CMD__SHIFT       = 0x00000006;
    constexpr unsigned int RPB_ATS_CNTL2__PAGE_ROUTING_CODE__SHIFT  = 0x0000000c;
    constexpr unsigned int RPB_ATS_CNTL2__TRANS_CMD__SHIFT          = 0x00000000;
    constexpr unsigned int RPB_ATS_CNTL2__VENDOR_ID__SHIFT          = 0x00000012;
    constexpr unsigned int RPB_ATS_CNTL__ATCTR_SWITCH_NUM__SHIFT    = 0x0000000f;
    constexpr unsigned int RPB_ATS_CNTL__INVAL_COM_CMD__SHIFT       = 0x00000019;
    constexpr unsigned int RPB_BIF_CNTL2__NBIF_HST_COMPCLKCTL_EN__SHIFT = 0x00000000;
    constexpr unsigned int RPB_BIF_CNTL__ARB_MODE__SHIFT            = 0x00000010;
    constexpr unsigned int RPB_BIF_CNTL__DRAIN_VC_NUM__SHIFT        = 0x00000011;
    constexpr unsigned int RPB_BIF_CNTL__NBIF_DMA_ORIGCLKCTL_EN__SHIFT = 0x0000001f;
    constexpr unsigned int RPB_BIF_CNTL__PAGE_PRI_EN__SHIFT         = 0x0000001b;
    constexpr unsigned int RPB_BIF_CNTL__PARITY_CHECK_EN__SHIFT     = 0x0000001e;
    constexpr unsigned int RPB_BIF_CNTL__SWITCH_ENABLE__SHIFT       = 0x00000012;
    constexpr unsigned int RPB_BIF_CNTL__SWITCH_THRESHOLD__SHIFT    = 0x00000013;
    constexpr unsigned int RPB_BIF_CNTL__TR_PRI_EN__SHIFT           = 0x0000001c;
    constexpr unsigned int RPB_BIF_CNTL__VC0_CHAINED_OVERRIDE__SHIFT = 0x0000001d;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATC_INV_BLOCKLEVEL__SHIFT = 0x00000006;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATC_PAGE_BLOCKLEVEL__SHIFT = 0x00000004;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATC_TR_BLOCKLEVEL__SHIFT = 0x00000002;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATOMIC_BLOCKLEVEL_OVERRIDE_EN__SHIFT = 0x00000011;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATOMIC_BLOCKLEVEL_OVERRIDE__SHIFT = 0x0000000c;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_RD_BLOCKLEVEL_OVERRIDE_EN__SHIFT = 0x00000010;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_RD_BLOCKLEVEL_OVERRIDE__SHIFT = 0x0000000a;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_WR_BLOCKLEVEL_OVERRIDE_EN__SHIFT = 0x0000000f;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_WR_BLOCKLEVEL_OVERRIDE__SHIFT = 0x00000008;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__XPB_BLOCKLEVEL_OVERRIDE_EN__SHIFT = 0x0000000e;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_PAGE_PASSPW_OVERRIDE_EN__SHIFT = 0x0000000c;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_PAGE_PASSPW_OVERRIDE__SHIFT = 0x00000003;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_RSPPASSPW_OVERRIDE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_RSPPASSPW_OVERRIDE__SHIFT = 0x00000008;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_TR_PASSPW_OVERRIDE_EN__SHIFT = 0x0000000b;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_TR_PASSPW_OVERRIDE__SHIFT = 0x00000002;
    constexpr unsigned int RPB_PASSPW_CONF__ATOMIC_PASSPW_OVERRIDE__SHIFT = 0x00000009;
    constexpr unsigned int RPB_PASSPW_CONF__ATOMIC_RSPPASSPW_OVERRIDE__SHIFT = 0x0000000a;
    constexpr unsigned int RPB_PASSPW_CONF__RDRSP_PASSPW_OVERRIDE_EN__SHIFT = 0x00000011;
    constexpr unsigned int RPB_PASSPW_CONF__RDRSP_PASSPW_OVERRIDE__SHIFT = 0x00000010;
    constexpr unsigned int RPB_PASSPW_CONF__RD_PASSPW_OVERRIDE__SHIFT = 0x00000005;
    constexpr unsigned int RPB_PASSPW_CONF__RD_RSPPASSPW_OVERRIDE__SHIFT = 0x00000007;
    constexpr unsigned int RPB_PASSPW_CONF__WRRSP_PASSPW_OVERRIDE_EN__SHIFT = 0x0000000f;
    constexpr unsigned int RPB_PASSPW_CONF__WRRSP_PASSPW_OVERRIDE__SHIFT = 0x0000000e;
    constexpr unsigned int RPB_PASSPW_CONF__WR_PASSPW_OVERRIDE__SHIFT = 0x00000004;
    constexpr unsigned int RPB_PASSPW_CONF__WR_RSPPASSPW_OVERRIDE__SHIFT = 0x00000006;
    constexpr unsigned int RPB_TAG_CONF__RPB_ATS_PR__SHIFT          = 0x00000014;
    constexpr unsigned int RPB_TAG_CONF__RPB_ATS_TR__SHIFT          = 0x00000000;
    constexpr unsigned int RPB_TAG_CONF__RPB_IO_WR__SHIFT           = 0x0000000a;
    constexpr unsigned int SCRATCH_REGISTER0__ScratchPad0__SHIFT    = 0x00000000;
    constexpr unsigned int SCRATCH_REGISTER1__ScratchPad1__SHIFT    = 0x00000000;
    constexpr unsigned int SCRATCH_REGISTER2__ScratchPad2__SHIFT    = 0x00000000;
    constexpr unsigned int SCRATCH_REGISTER3__ScratchPad3__SHIFT    = 0x00000000;
    constexpr unsigned int SCRATCH_REGISTER4__ScratchPad4__SHIFT    = 0x00000000;
    constexpr unsigned int SCRATCH_REGISTER5__ScratchPad5__SHIFT    = 0x00000000;
    constexpr unsigned int SCRATCH_REGISTER6__ScratchPad6__SHIFT    = 0x00000000;
    constexpr unsigned int SCRATCH_REGISTER7__ScratchPad7__SHIFT    = 0x00000000;
    constexpr unsigned int SH_MEM_CONFIG__ILLEGAL_INST_CHECK_DISABLE__SHIFT = 0x00000011;
    constexpr unsigned int SH_MEM_CONFIG__NO_PREFETCH_ACROSS_PAGE__SHIFT = 0x00000010;
    constexpr unsigned int SH_MEM_CONFIG__RETRY_MODE__SHIFT         = 0x0000000c;
    constexpr unsigned int SOCCLK_CGTT_BLK_CTRL_REG__SOCCLK_TURN_OFF_DELAY__SHIFT = 0x00000004;
    constexpr unsigned int SOCCLK_CGTT_BLK_CTRL_REG__SOCCLK_TURN_ON_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int SOC_GAP_PWROK__soc_gap_pwrok__SHIFT      = 0x00000000;
    constexpr unsigned int SPI_CONFIG_CNTL_1_REMAP__RESERVED__SHIFT = 0x00000000;
    constexpr unsigned int SPI_CONFIG_CNTL_1__RESERVED__SHIFT       = 0x00000016;
    constexpr unsigned int SPI_CONFIG_CNTL_2_REMAP__RESERVED__SHIFT = 0x00000000;
    constexpr unsigned int SPI_CONFIG_CNTL_REMAP__RESERVED__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_CONFIG_CNTL__RSRC_MGMT_RESET__SHIFT  = 0x0000001a;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_4__COUNT__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_4__EVENTS__SHIFT = 0x00000010;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_5__COUNT__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_5__EVENTS__SHIFT = 0x00000010;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_6__COUNT__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_6__EVENTS__SHIFT = 0x00000010;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_7__COUNT__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_7__EVENTS__SHIFT = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__BARRIERS__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__LDS__SHIFT   = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__SGPR__SHIFT  = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__VGPR__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__WAVES__SHIFT = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__BARRIERS__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__LDS__SHIFT   = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__SGPR__SHIFT  = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__VGPR__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__WAVES__SHIFT = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__BARRIERS__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__LDS__SHIFT   = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__SGPR__SHIFT  = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__VGPR__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__WAVES__SHIFT = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__BARRIERS__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__LDS__SHIFT   = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__SGPR__SHIFT  = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__VGPR__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__WAVES__SHIFT = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_0__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_1__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_2__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_3__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_4__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_5__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_6__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_7__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_8__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_9__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__EN__SHIFT = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__QUEUE_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__TYPE_MASK__SHIFT = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__EN__SHIFT = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__QUEUE_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__TYPE_MASK__SHIFT = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__EN__SHIFT = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__QUEUE_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__TYPE_MASK__SHIFT = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__EN__SHIFT = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__QUEUE_MASK__SHIFT = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__TYPE_MASK__SHIFT = 0x00000001;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__CDBG_USER__SHIFT = 0x0000001e;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__CU_GROUP_ENABLE__SHIFT = 0x0000001a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__DEBUG_MODE__SHIFT = 0x00000016;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__DX10_CLAMP__SHIFT = 0x00000015;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__FLOAT_MODE__SHIFT = 0x0000000c;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__FP16_OVFL__SHIFT = 0x0000001f;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__IEEE_MODE__SHIFT = 0x00000017;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__PRIORITY__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__PRIV__SHIFT     = 0x00000014;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__SGPRS__SHIFT    = 0x00000006;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__VGPRS__SHIFT    = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__VGPR_COMP_CNT__SHIFT = 0x00000018;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__CDBG_USER__SHIFT = 0x0000001d;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__DEBUG_MODE__SHIFT = 0x00000016;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__DX10_CLAMP__SHIFT = 0x00000015;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__FLOAT_MODE__SHIFT = 0x0000000c;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__FP16_OVFL__SHIFT = 0x0000001e;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__IEEE_MODE__SHIFT = 0x00000017;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__PRIORITY__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__PRIV__SHIFT     = 0x00000014;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__SGPRS__SHIFT    = 0x00000006;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__VGPRS__SHIFT    = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__VGPR_COMP_CNT__SHIFT = 0x00000018;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_GS__EXCP_EN__SHIFT = 0x00000008;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_GS__LDS_SIZE__SHIFT = 0x00000014;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_GS__OC_LDS_EN__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_GS__SCRATCH_EN__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_GS__TRAP_PRESENT__SHIFT = 0x00000006;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_GS__USER_SGPR__SHIFT = 0x00000001;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_VS__EXCP_EN__SHIFT = 0x00000008;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_VS__LDS_SIZE__SHIFT = 0x00000014;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_VS__OC_LDS_EN__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_VS__SCRATCH_EN__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_VS__TRAP_PRESENT__SHIFT = 0x00000006;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_VS__USER_SGPR__SHIFT = 0x00000001;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES__EXCP_EN__SHIFT  = 0x00000008;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES__LDS_SIZE__SHIFT = 0x00000014;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES__OC_LDS_EN__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES__SCRATCH_EN__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES__TRAP_PRESENT__SHIFT = 0x00000006;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES__USER_SGPR__SHIFT = 0x00000001;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_ES__EXCP_EN__SHIFT = 0x00000010;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_ES__LDS_SIZE__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_ES__SCRATCH_EN__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_ES__TRAP_PRESENT__SHIFT = 0x00000006;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_ES__USER_SGPR__SHIFT = 0x00000001;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_HS__EXCP_EN__SHIFT = 0x00000010;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_HS__LDS_SIZE__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_HS__SCRATCH_EN__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_HS__TRAP_PRESENT__SHIFT = 0x00000006;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_HS__USER_SGPR__SHIFT = 0x00000001;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_VS__EXCP_EN__SHIFT = 0x00000010;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_VS__LDS_SIZE__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_VS__SCRATCH_EN__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_VS__TRAP_PRESENT__SHIFT = 0x00000006;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_VS__USER_SGPR__SHIFT = 0x00000001;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS__EXCP_EN__SHIFT  = 0x00000010;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS__LDS_SIZE__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS__SCRATCH_EN__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS__TRAP_PRESENT__SHIFT = 0x00000006;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS__USER_SGPR__SHIFT = 0x00000001;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_ES__CU_EN__SHIFT    = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_ES__GROUP_FIFO_DEPTH__SHIFT = 0x0000001a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_ES__LOCK_LOW_THRESHOLD__SHIFT = 0x00000016;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_ES__WAVE_LIMIT__SHIFT = 0x00000010;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_LS__CU_EN__SHIFT    = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_LS__GROUP_FIFO_DEPTH__SHIFT = 0x0000001a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_LS__LOCK_LOW_THRESHOLD__SHIFT = 0x00000016;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_LS__WAVE_LIMIT__SHIFT = 0x00000010;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_ESGS__GROUP_UPDATE_EN__SHIFT = 0x00000006;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_ESGS__PER_TYPE_WAVE_COUNT_COEFFICIENT__SHIFT = 0x00000010;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_ESGS__PER_TYPE_WAVE_COUNT_HIER_SELECT__SHIFT = 0x00000003;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_ESGS__TOTAL_WAVE_COUNT_COEFFICIENT__SHIFT = 0x00000008;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_ESGS__TOTAL_WAVE_COUNT_HIER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_LSHS__GROUP_UPDATE_EN__SHIFT = 0x00000006;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_LSHS__PER_TYPE_WAVE_COUNT_COEFFICIENT__SHIFT = 0x00000010;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_LSHS__PER_TYPE_WAVE_COUNT_HIER_SELECT__SHIFT = 0x00000003;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_LSHS__TOTAL_WAVE_COUNT_COEFFICIENT__SHIFT = 0x00000008;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_LSHS__TOTAL_WAVE_COUNT_HIER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_PS__GROUP_UPDATE_EN__SHIFT = 0x00000006;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_PS__PER_TYPE_WAVE_COUNT_COEFFICIENT__SHIFT = 0x00000010;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_PS__PER_TYPE_WAVE_COUNT_HIER_SELECT__SHIFT = 0x00000003;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_PS__TOTAL_WAVE_COUNT_COEFFICIENT__SHIFT = 0x00000008;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_PS__TOTAL_WAVE_COUNT_HIER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_VS__GROUP_UPDATE_EN__SHIFT = 0x00000006;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_VS__PER_TYPE_WAVE_COUNT_COEFFICIENT__SHIFT = 0x00000010;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_VS__PER_TYPE_WAVE_COUNT_HIER_SELECT__SHIFT = 0x00000003;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_VS__TOTAL_WAVE_COUNT_COEFFICIENT__SHIFT = 0x00000008;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_VS__TOTAL_WAVE_COUNT_HIER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_0__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_1__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_2__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_3__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_4__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_5__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_6__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_7__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_8__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_9__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_10__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_11__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_12__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_13__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_14__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_15__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_0__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_1__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_2__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_3__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_4__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_5__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_6__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_7__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_8__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_9__DATA__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_10__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_11__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_12__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_13__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_14__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_15__DATA__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_WAVE_LIMIT_CNTL_REMAP__RESERVED__SHIFT = 0x00000000;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__ES_GRP_VALUE__SHIFT = 0x00000011;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__LS_GRP_VALUE__SHIFT = 0x00000007;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_3__INT_SENT__SHIFT = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_3__MAX_CNT__SHIFT = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_5__INT_SENT__SHIFT = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_5__MAX_CNT__SHIFT = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_10__INT_SENT__SHIFT = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_10__MAX_CNT__SHIFT = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_12__INT_SENT__SHIFT = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_12__MAX_CNT__SHIFT = 0x00000000;
    constexpr unsigned int SP_CONFIG__CAC_COUNTER_OVERRIDE__SHIFT   = 0x00000005;
    constexpr unsigned int SP_CONFIG__DPMACC_MGCG_OVERRIDE__SHIFT   = 0x00000006;
    constexpr unsigned int SP_CONFIG__SMACC_MGCG_OVERRIDE__SHIFT    = 0x00000007;
    constexpr unsigned int SP_CONFIG__TRANS_MGCG_OVERRIDE__SHIFT    = 0x00000004;
    constexpr unsigned int SQC_CACHES__VOL__SHIFT                   = 0x00000004;
    constexpr unsigned int SQC_CACHES__WRITEBACK__SHIFT             = 0x00000003;
    constexpr unsigned int SQC_CONFIG__IDENTITY_HASH_BANK__SHIFT    = 0x00000009;
    constexpr unsigned int SQC_WRITEBACK__DIRTY__SHIFT              = 0x00000001;
    constexpr unsigned int SQC_WRITEBACK__DWB__SHIFT                = 0x00000000;
    constexpr unsigned int SQ_ARB_CONFIG__DISABLE_SECOND_TRY__SHIFT = 0x00000008;
    constexpr unsigned int SQ_CONFIG__OVERRIDE_LDS_IDX_BUSY__SHIFT  = 0x0000000b;
    constexpr unsigned int SQ_CONFIG__REPLAY_SLEEP_CNT__SHIFT       = 0x00000015;
    constexpr unsigned int SQ_PERFCOUNTER0_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER1_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER2_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER3_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER4_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER5_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER6_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER7_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER8_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER9_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER10_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER11_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER12_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER13_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER14_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER15_SELECT__SQC_BANK_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERFCOUNTER_SELECT1__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERFCOUNTER_SELECT1__SHIFT = 0x0000000a;
    constexpr unsigned int TA_CNTL_AUX__RESERVED__SHIFT             = 0x00000001;
    constexpr unsigned int TA_CNTL__FX_XNACK_CREDIT__SHIFT          = 0x00000000;
    constexpr unsigned int TD_POWER_CNTL__DISABLE_NOFILTER_FORMATTER_POWER_OPT__SHIFT = 0x00000008;
    constexpr unsigned int TD_POWER_CNTL__FORCE_NOFILTER_CLK_TO_CORE__SHIFT = 0x00000001;
    constexpr unsigned int TD_POWER_CNTL__FORCE_NOFILTER_D16_FORMATTERS_ON__SHIFT = 0x00000009;
    constexpr unsigned int TD_POWER_CNTL__FORCE_SAMPLER_CLK_TO_CORE__SHIFT = 0x00000000;
    constexpr unsigned int TD_POWER_CNTL__NOFILTER_CLK_VALID_DELAY__SHIFT = 0x00000005;
    constexpr unsigned int TD_POWER_CNTL__SAMPLER_CLK_VALID_DELAY__SHIFT = 0x00000002;
    constexpr unsigned int UTCL1_CTRL__UTCL1_MH_DISABLE_REQUEST_SQUASHING__SHIFT = 0x00000016;
    constexpr unsigned int UTCL1_CTRL__UTCL1_REDUCE_MH_CAM_SIZE__SHIFT = 0x0000001e;
    constexpr unsigned int UTCL1_CTRL__UTCL1_REDUCE_MH_CFIFO_SIZE__SHIFT = 0x0000001c;
    constexpr unsigned int VGT_ESGS_RING_SIZE_UMD__MEM_SIZE__SHIFT  = 0x00000000;
    constexpr unsigned int VGT_GSVS_RING_SIZE_UMD__MEM_SIZE__SHIFT  = 0x00000000;
    constexpr unsigned int VGT_HS_OFFCHIP_PARAM_UMD__OFFCHIP_BUFFERING__SHIFT = 0x00000000;
    constexpr unsigned int VGT_HS_OFFCHIP_PARAM_UMD__OFFCHIP_GRANULARITY__SHIFT = 0x00000009;
    constexpr unsigned int VGT_HS_OFFCHIP_PARAM__OFFCHIP_GRANULARITY__SHIFT = 0x00000009;
    constexpr unsigned int VGT_TF_MEMORY_BASE_HI_UMD__BASE_HI__SHIFT = 0x00000000;
    constexpr unsigned int VGT_TF_MEMORY_BASE_UMD__BASE__SHIFT      = 0x00000000;
    constexpr unsigned int VGT_TF_RING_SIZE_UMD__SIZE__SHIFT        = 0x00000000;
} // namespace Nv10

namespace Oss50
{
    constexpr unsigned int SDMA0_PERFCOUNTER0_RESULT__PERF_COUNT__SHIFT = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER1_RESULT__PERF_COUNT__SHIFT = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER_TAG_DELAY_RANGE__RANGE_HIGH__SHIFT = 0x0000000e;
    constexpr unsigned int SDMA0_PERFCOUNTER_TAG_DELAY_RANGE__RANGE_LOW__SHIFT = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER_TAG_DELAY_RANGE__SELECT_RW__SHIFT = 0x0000001c;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_CLEAR0__SHIFT   = 0x00000001;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_CLEAR1__SHIFT   = 0x0000000b;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_ENABLE0__SHIFT  = 0x00000000;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_ENABLE1__SHIFT  = 0x0000000a;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_SEL0__SHIFT     = 0x00000002;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_SEL1__SHIFT     = 0x0000000c;
    constexpr unsigned int SDMA1_PERFCOUNTER0_RESULT__PERF_COUNT__SHIFT = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER1_RESULT__PERF_COUNT__SHIFT = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER_TAG_DELAY_RANGE__RANGE_HIGH__SHIFT = 0x0000000e;
    constexpr unsigned int SDMA1_PERFCOUNTER_TAG_DELAY_RANGE__RANGE_LOW__SHIFT = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER_TAG_DELAY_RANGE__SELECT_RW__SHIFT = 0x0000001c;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_CLEAR0__SHIFT   = 0x00000001;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_CLEAR1__SHIFT   = 0x0000000b;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_ENABLE0__SHIFT  = 0x00000000;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_ENABLE1__SHIFT  = 0x0000000a;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_SEL0__SHIFT     = 0x00000002;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_SEL1__SHIFT     = 0x0000000c;
    constexpr unsigned int SDMA_PGFSM_CONFIG__FSM_ADDR__SHIFT       = 0x00000000;
    constexpr unsigned int SDMA_PGFSM_CONFIG__P1_SELECT__SHIFT      = 0x0000000a;
    constexpr unsigned int SDMA_PGFSM_CONFIG__P2_SELECT__SHIFT      = 0x0000000b;
    constexpr unsigned int SDMA_PGFSM_CONFIG__POWER_DOWN__SHIFT     = 0x00000008;
    constexpr unsigned int SDMA_PGFSM_CONFIG__POWER_UP__SHIFT       = 0x00000009;
    constexpr unsigned int SDMA_PGFSM_CONFIG__READ__SHIFT           = 0x0000000d;
    constexpr unsigned int SDMA_PGFSM_CONFIG__REG_ADDR__SHIFT       = 0x0000001c;
    constexpr unsigned int SDMA_PGFSM_CONFIG__SRBM_OVERRIDE__SHIFT  = 0x0000001b;
    constexpr unsigned int SDMA_PGFSM_CONFIG__WRITE__SHIFT          = 0x0000000c;
    constexpr unsigned int SDMA_PGFSM_READ__VALUE__SHIFT            = 0x00000000;
    constexpr unsigned int SDMA_PGFSM_WRITE__VALUE__SHIFT           = 0x00000000;
    constexpr unsigned int SDMA_POWER_GATING__PG_CNTL_STATUS__SHIFT = 0x00000004;
    constexpr unsigned int SDMA_POWER_GATING__SDMA0_POWER_OFF_CONDITION__SHIFT = 0x00000000;
    constexpr unsigned int SDMA_POWER_GATING__SDMA0_POWER_OFF_REQ__SHIFT = 0x00000002;
    constexpr unsigned int SDMA_POWER_GATING__SDMA0_POWER_ON_CONDITION__SHIFT = 0x00000001;
    constexpr unsigned int SDMA_POWER_GATING__SDMA0_POWER_ON_REQ__SHIFT = 0x00000003;
} // namespace Oss50

namespace Raven
{
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_alloc_opco_error__SHIFT = 0x00000002;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_dealloc_opco_error__SHIFT = 0x00000003;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_dec_error__SHIFT = 0x00000001;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_error_ds_address__SHIFT = 0x00000008;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_wrap_opco_error__SHIFT = 0x00000004;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_write_dis__SHIFT = 0x00000000;
    constexpr unsigned int alloc_DEBUG_DATA__Reserved0__SHIFT       = 0x00000005;
    constexpr unsigned int alloc_DEBUG_DATA__Reserved1__SHIFT       = 0x00000016;
    constexpr unsigned int GC_CAC_ACC_PG0__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
    constexpr unsigned int GC_CAC_OVRD_PG__OVRRD_SELECT__SHIFT      = 0x00000000;
    constexpr unsigned int GC_CAC_OVRD_PG__OVRRD_VALUE__SHIFT       = 0x00000010;
    constexpr unsigned int GC_CAC_PG_AGGR_LOWER__LKG_AGGR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_PG_AGGR_UPPER__LKG_AGGR_63_32__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_PG_0__WEIGHT_PG_SIG0__SHIFT = 0x00000000;
    constexpr unsigned int gws_DEBUG_DATA__credit_cnt__SHIFT        = 0x00000010;
    constexpr unsigned int gws_DEBUG_DATA__cur_reso_5to0__SHIFT     = 0x00000003;
    constexpr unsigned int gws_DEBUG_DATA__cur_reso_count__SHIFT    = 0x0000000f;
    constexpr unsigned int gws_DEBUG_DATA__Reserved0__SHIFT         = 0x00000018;
    constexpr unsigned int oa_wc0_DEBUG_DATA__credit_cnt__SHIFT     = 0x00000001;
    constexpr unsigned int oa_wc0_DEBUG_DATA__req__SHIFT            = 0x00000008;
    constexpr unsigned int oa_wc0_DEBUG_DATA__Reserved0__SHIFT      = 0x00000013;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy0__SHIFT    = 0x0000000b;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy1__SHIFT    = 0x0000000c;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy2__SHIFT    = 0x0000000d;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy3__SHIFT    = 0x0000000e;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy4__SHIFT    = 0x0000000f;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy5__SHIFT    = 0x00000010;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy6__SHIFT    = 0x00000011;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy7__SHIFT    = 0x00000012;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy__SHIFT     = 0x00000000;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe1_busy__SHIFT     = 0x00000001;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe2_busy__SHIFT     = 0x00000002;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe3_busy__SHIFT     = 0x00000003;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe4_busy__SHIFT     = 0x00000004;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe5_busy__SHIFT     = 0x00000005;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe6_busy__SHIFT     = 0x00000006;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe7_busy__SHIFT     = 0x00000007;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe8_busy__SHIFT     = 0x00000008;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe9_busy__SHIFT     = 0x00000009;
    constexpr unsigned int oa_wc1_DEBUG_DATA__Pipe10_busy__SHIFT    = 0x0000000a;
    constexpr unsigned int oa_wc1_DEBUG_DATA__Reserved0__SHIFT      = 0x00000013;
    constexpr unsigned int ord_app_DEBUG_DATA__fifo_busy__SHIFT     = 0x00000000;
    constexpr unsigned int ord_app_DEBUG_DATA__ord_busy__SHIFT      = 0x00000001;
    constexpr unsigned int ord_app_DEBUG_DATA__Reserved0__SHIFT     = 0x00000003;
    constexpr unsigned int ord_app_DEBUG_DATA__Reserved1__SHIFT     = 0x0000000c;
    constexpr unsigned int ord_app_DEBUG_DATA__sh0_cmd_fifo_empty__SHIFT = 0x00000004;
    constexpr unsigned int ord_app_DEBUG_DATA__sh0_data_fifo_empty__SHIFT = 0x00000008;
    constexpr unsigned int ord_app_DEBUG_DATA__sh1_cmd_fifo_empty__SHIFT = 0x00000005;
    constexpr unsigned int ord_app_DEBUG_DATA__sh1_data_fifo_empty__SHIFT = 0x00000009;
    constexpr unsigned int ord_app_DEBUG_DATA__sh2_cmd_fifo_empty__SHIFT = 0x00000006;
    constexpr unsigned int ord_app_DEBUG_DATA__sh2_data_fifo_empty__SHIFT = 0x0000000a;
    constexpr unsigned int ord_app_DEBUG_DATA__sh3_cmd_fifo_empty__SHIFT = 0x00000007;
    constexpr unsigned int ord_app_DEBUG_DATA__sh3_data_fifo_empty__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG00_0__ccgen_to_clipcc_fifo_empty__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG00_0__ccgen_to_clipcc_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG00_0__clipcode_fifo_fifo_empty__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG00_0__clipcode_fifo_full__SHIFT  = 0x0000000e;
    constexpr unsigned int PA_DEBUG00_0__clip_ga_bc_fifo_write__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG00_0__clip_to_ga_fifo_full__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG00_0__clip_to_ga_fifo_write__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG00_0__clip_to_outsm_fifo_empty__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG00_0__clip_to_outsm_fifo_full__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG00_0__clip_to_outsm_fifo_write__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG00_0__primic_to_clprim_fifo_empty__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG00_0__primic_to_clprim_fifo_full__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG00_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG00_0__su_clip_baryc_free__SHIFT  = 0x00000001;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clipp_fifo_empty__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clipp_fifo_full__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clipp_fifo_write__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clips_fifo_empty__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clips_fifo_full__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG00_0__vte_out_clip_fifo_fifo_empty__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG00_0__vte_out_clip_fifo_fifo_full__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG00_0__vte_out_orig_fifo_fifo_empty__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG00_0__vte_out_orig_fifo_fifo_full__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG00_0__vte_out_orig_fifo_fifo_write__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG00_1__available_positions__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG00_1__ccgen_to_clipcc_fifo_full__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG00_1__ccgen_to_clipcc_write__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG00_1__current_state__SHIFT       = 0x0000000d;
    constexpr unsigned int PA_DEBUG00_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG00_1__statevar_bits_vs_out_ccdist0_vec_ena__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG00_1__statevar_bits_vs_out_ccdist1_vec_ena__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG00_1__sx0_receive_fifo_empty__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG00_1__sx0_receive_fifo_full__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG00_1__sx0_receive_fifo_write__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG00_1__vertex_fifo_empty__SHIFT   = 0x0000000f;
    constexpr unsigned int PA_DEBUG00_1__vertex_fifo_entriesavailable__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG00_1__vertex_fifo_full__SHIFT    = 0x00000010;
    constexpr unsigned int PA_DEBUG00_1__vgt_to_ccgen_fifo_empty__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG00_1__vgt_to_ccgen_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG01_0__clip_extra_bc_valid__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG01_0__clip_ga_bc_fifo_write__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG01_0__clip_to_ga_fifo_write__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG01_0__clip_to_outsm_deallocate_slot__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG01_0__clip_to_outsm_null_primitive__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG01_0__clip_to_outsm_vertex_deallocate__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG01_0__clip_vert_vte_valid__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG01_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_fifo_fifo_advanceread__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_fifo_fifo_empty__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_rd_extra_bc_valid__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_rd_vertex_store_indx__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_rd_vte_naninf_kill__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG01_0__vte_positions_vte_clip_vte_naninf_kill_0__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG01_0__vte_positions_vte_clip_vte_naninf_kill_1__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG01_0__vte_positions_vte_clip_vte_naninf_kill_2__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG01_1__ALWAYS_ZERO__SHIFT         = 0x00000000;
    constexpr unsigned int PA_DEBUG01_1__clip_extra_bc_valid__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG01_1__clip_ga_bc_fifo_write__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG01_1__clip_to_ga_fifo_write__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG01_1__clip_to_outsm_vertex_deallocate__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG01_1__clip_vert_vte_valid__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG01_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_fifo_fifo_advanceread__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_fifo_fifo_empty__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_rd_extra_bc_valid__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_rd_vertex_store_indx__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_rd_vte_naninf_kill__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG02_0__clip_ga_bc_fifo_full__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG02_0__clip_ga_bc_fifo_write__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG02_0__clip_to_clipga_extra_bc_coords__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG02_0__clip_to_clipga_vte_naninf_kill__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG02_0__clip_to_ga_fifo_full__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG02_0__clip_to_ga_fifo_write__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_clipped_prim__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_end_of_packet__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_fifo_advanceread__SHIFT = 0x0000001e;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_fifo_empty__SHIFT = 0x0000001f;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_first_prim_of_slot__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_null_primitive__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_vertex_store_indx_0__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_vertex_store_indx_1__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_vertex_store_indx_2__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG02_1__clip_extra_bc_valid__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG02_1__clip_ga_bc_fifo_full__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG02_1__clip_ga_bc_fifo_write__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG02_1__clip_to_ga_fifo_full__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG02_1__clip_to_ga_fifo_write__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_clipped_prim__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_clip_seq_indx__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_fifo_advanceread__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_fifo_empty__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_null_primitive__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_vertex_store_indx_1__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_vertex_store_indx_2__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG02_1__clip_vert_vte_valid__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG02_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_clip_code_or__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_clip_primitive__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_deallocate_slot__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_end_of_packet__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_event_id__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_first_prim_of_slot__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_state_var_indx__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG03_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_clip_code_or__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_deallocate_slot__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_end_of_packet__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_event_id__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_first_prim_of_slot__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG03_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_param_cache_indx_0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_vertex_store_indx_0__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_vertex_store_indx_1__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_vertex_store_indx_2__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG04_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_param_cache_indx_0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_vertex_store_indx_0__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_vertex_store_indx_2__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG04_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_clip_code_or__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_clip_primitive__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_deallocate_slot__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_end_of_packet__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_event_id__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_first_prim_of_slot__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_state_var_indx__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG05_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_clip_code_or__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_deallocate_slot__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_end_of_packet__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_event_id__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_first_prim_of_slot__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG05_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_param_cache_indx_0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_vertex_store_indx_0__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_vertex_store_indx_1__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_vertex_store_indx_2__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG06_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_param_cache_indx_0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_vertex_store_indx_0__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_vertex_store_indx_2__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG06_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_clip_code_or__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_clip_primitive__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_deallocate_slot__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_end_of_packet__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_event_id__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_first_prim_of_slot__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_state_var_indx__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG07_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_clip_code_or__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_deallocate_slot__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_end_of_packet__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_event_id__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_first_prim_of_slot__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG07_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_param_cache_indx_0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_vertex_store_indx_0__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_vertex_store_indx_1__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_vertex_store_indx_2__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG08_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_param_cache_indx_0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_vertex_store_indx_0__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_vertex_store_indx_2__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG08_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_clip_code_or__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_clip_primitive__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_deallocate_slot__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_end_of_packet__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_event_id__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_first_prim_of_slot__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_state_var_indx__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG09_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_clip_code_or__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_deallocate_slot__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_end_of_packet__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_event_id__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_first_prim_of_slot__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG09_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_param_cache_indx_0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_vertex_store_indx_0__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_vertex_store_indx_1__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_vertex_store_indx_2__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG10_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_param_cache_indx_0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_vertex_store_indx_0__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_vertex_store_indx_2__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG11_0__clipsm0_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG11_0__clipsm0_clip_to_clipga_prim_valid__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG11_0__clipsm0_inc_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG11_0__clipsm1_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG11_0__clipsm1_clip_to_clipga_prim_valid__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG11_0__clipsm1_inc_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG11_0__clipsm2_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG11_0__clipsm2_clip_to_clipga_prim_valid__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG11_0__clipsm2_inc_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG11_0__clipsm3_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG11_0__clipsm3_clip_to_clipga_prim_valid__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG11_0__clipsm3_inc_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG11_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG11_1__clipsm0_clip_to_clipga_clip_primitive__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG11_1__clipsm0_clip_to_clipga_event__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG11_1__clipsm0_clip_to_clipga_prim_valid__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG11_1__clipsm0_inc_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG11_1__clipsm1_clip_to_clipga_clip_primitive__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG11_1__clipsm1_clip_to_clipga_event__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG11_1__clipsm1_clip_to_clipga_prim_valid__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG11_1__clipsm1_inc_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_clip_to_clipga_clip_primitive__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_clip_to_clipga_event__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_clip_to_clipga_prim_valid__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_inc_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_clip_to_clipga_clip_primitive__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_clip_to_clipga_event__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_clip_to_clipga_prim_valid__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_inc_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG11_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG12_0__clipsm0_clprim_to_clip_clip_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG12_0__clipsm0_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG12_0__clipsm1_clprim_to_clip_clip_primitive__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG12_0__clipsm1_clprim_to_clip_prim_valid__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG12_0__clipsm2_clprim_to_clip_clip_primitive__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG12_0__clipsm2_clprim_to_clip_prim_valid__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG12_0__clipsm3_clprim_to_clip_clip_primitive__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG12_0__clipsm3_clprim_to_clip_prim_valid__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_available_clip_verts__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_available_vte_out_clip__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_seq_indx_load__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_seq_indx_out__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_seq_indx_vert__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG12_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG12_1__ALWAYS_ZERO__SHIFT         = 0x00000000;
    constexpr unsigned int PA_DEBUG12_1__clipsm0_clprim_to_clip_clip_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG12_1__clipsm0_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG12_1__clipsm1_clprim_to_clip_clip_primitive__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG12_1__clipsm1_clprim_to_clip_prim_valid__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG12_1__clipsm2_clprim_to_clip_clip_primitive__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG12_1__clipsm2_clprim_to_clip_prim_valid__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG12_1__clipsm3_clprim_to_clip_clip_primitive__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG12_1__clipsm3_clprim_to_clip_prim_valid__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG12_1__clip_priority_available_clip_verts__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG12_1__clip_priority_available_vte_out_clip__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG12_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG13_0__ccgen_to_clipcc_fifo_empty__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG13_0__clipcc_vertex_store_indx__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG13_0__clipcode_fifo_fifo_empty__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG13_0__clip_priority_seq_indx_out_cnt__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_fifo_advanceread__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_fifo_contents__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_fifo_full__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_fifo_write__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_rd_clipsm_wait__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_rd_orig_vertices__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG13_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG13_0__vertval_bits_vertex_cc_next_valid__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG13_0__vte_out_orig_fifo_fifo_empty__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG13_1__clipcc_vertex_store_indx__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG13_1__clipcode_fifo_fifo_empty__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG13_1__clprim_clip_primitive__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG13_1__clprim_cull_primitive__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG13_1__clprim_in_back_state_var_indx__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG13_1__outsm_clr_fifo_advanceread__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG13_1__outsm_clr_fifo_contents__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG13_1__outsm_clr_fifo_full__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG13_1__outsm_clr_fifo_write__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG13_1__point_clip_candidate__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG13_1__prim_back_valid__SHIFT     = 0x00000007;
    constexpr unsigned int PA_DEBUG13_1__prim_nan_kill__SHIFT       = 0x00000004;
    constexpr unsigned int PA_DEBUG13_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG13_1__vertval_bits_vertex_cc_next_valid__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG13_1__vte_out_orig_fifo_fifo_empty__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_deallocate_slot__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_end_of_packet__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_event_id__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_event__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_first_prim_of_slot__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_vertex_store_indx_0__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_vertex_store_indx_1__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG14_0__outputclprimtoclip_null_primitive__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG14_0__prim_back_valid__SHIFT     = 0x00000017;
    constexpr unsigned int PA_DEBUG14_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_event_id__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_event__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_vertex_store_indx_0__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_vertex_store_indx_1__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_vertex_store_indx_2__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG14_1__prim_back_valid__SHIFT     = 0x00000017;
    constexpr unsigned int PA_DEBUG14_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG15_0__primic_to_clprim_fifo_vertex_store_indx_0__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG15_0__primic_to_clprim_fifo_vertex_store_indx_1__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG15_0__primic_to_clprim_fifo_vertex_store_indx_2__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG15_0__primic_to_clprim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG15_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG15_0__vertval_bits_vertex_vertex_store_msb__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG15_1__primic_to_clprim_fifo_vertex_store_indx_0__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG15_1__primic_to_clprim_fifo_vertex_store_indx_1__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG15_1__primic_to_clprim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG15_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG15_1__vertval_bits_vertex_vertex_store_msb__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG16_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG16_0__sm0_clip_to_clipga_clip_to_outsm_cnt_eq0__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG16_0__sm0_clip_to_outsm_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG16_0__sm0_clip_vert_cnt__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG16_0__sm0_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG16_0__sm0_current_state__SHIFT   = 0x0000000c;
    constexpr unsigned int PA_DEBUG16_0__sm0_highest_priority_seq__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG16_0__sm0_inv_to_clip_data_valid_0__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG16_0__sm0_inv_to_clip_data_valid_1__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG16_0__sm0_outputcliptoga_0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG16_0__sm0_vertex_clip_cnt__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG16_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG16_1__sm0_clip_to_clipga_clip_to_outsm_cnt_eq0__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG16_1__sm0_clip_to_outsm_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG16_1__sm0_clip_vert_cnt__SHIFT   = 0x00000008;
    constexpr unsigned int PA_DEBUG16_1__sm0_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG16_1__sm0_current_state__SHIFT   = 0x00000010;
    constexpr unsigned int PA_DEBUG16_1__sm0_highest_priority_seq__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG16_1__sm0_outputcliptoga_0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG16_1__sm0_prim_end_state__SHIFT  = 0x00000000;
    constexpr unsigned int PA_DEBUG16_1__sm0_ps_expand__SHIFT       = 0x00000007;
    constexpr unsigned int PA_DEBUG16_1__sm0_vertex_clip_cnt__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG17_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG17_0__sm1_clip_to_clipga_clip_to_outsm_cnt_eq0__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG17_0__sm1_clip_to_outsm_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG17_0__sm1_clip_vert_cnt__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG17_0__sm1_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG17_0__sm1_current_state__SHIFT   = 0x0000000c;
    constexpr unsigned int PA_DEBUG17_0__sm1_highest_priority_seq__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG17_0__sm1_inv_to_clip_data_valid_0__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG17_0__sm1_inv_to_clip_data_valid_1__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG17_0__sm1_outputcliptoga_0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG17_0__sm1_vertex_clip_cnt__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG17_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG17_1__sm1_clip_to_clipga_clip_to_outsm_cnt_eq0__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG17_1__sm1_clip_to_outsm_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG17_1__sm1_clip_vert_cnt__SHIFT   = 0x00000008;
    constexpr unsigned int PA_DEBUG17_1__sm1_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG17_1__sm1_current_state__SHIFT   = 0x00000010;
    constexpr unsigned int PA_DEBUG17_1__sm1_highest_priority_seq__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG17_1__sm1_outputcliptoga_0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG17_1__sm1_prim_end_state__SHIFT  = 0x00000000;
    constexpr unsigned int PA_DEBUG17_1__sm1_ps_expand__SHIFT       = 0x00000007;
    constexpr unsigned int PA_DEBUG17_1__sm1_vertex_clip_cnt__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG18_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG18_0__sm2_clip_to_clipga_clip_to_outsm_cnt_eq0__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG18_0__sm2_clip_to_outsm_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG18_0__sm2_clip_vert_cnt__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG18_0__sm2_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG18_0__sm2_current_state__SHIFT   = 0x0000000c;
    constexpr unsigned int PA_DEBUG18_0__sm2_highest_priority_seq__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG18_0__sm2_inv_to_clip_data_valid_0__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG18_0__sm2_inv_to_clip_data_valid_1__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG18_0__sm2_outputcliptoga_0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG18_0__sm2_vertex_clip_cnt__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG18_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG18_1__sm2_clip_to_clipga_clip_to_outsm_cnt_eq0__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG18_1__sm2_clip_to_outsm_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG18_1__sm2_clip_vert_cnt__SHIFT   = 0x00000008;
    constexpr unsigned int PA_DEBUG18_1__sm2_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG18_1__sm2_current_state__SHIFT   = 0x00000010;
    constexpr unsigned int PA_DEBUG18_1__sm2_highest_priority_seq__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG18_1__sm2_outputcliptoga_0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG18_1__sm2_prim_end_state__SHIFT  = 0x00000000;
    constexpr unsigned int PA_DEBUG18_1__sm2_ps_expand__SHIFT       = 0x00000007;
    constexpr unsigned int PA_DEBUG18_1__sm2_vertex_clip_cnt__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG19_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG19_0__sm3_clip_to_clipga_clip_to_outsm_cnt_eq0__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG19_0__sm3_clip_to_outsm_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG19_0__sm3_clip_vert_cnt__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG19_0__sm3_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG19_0__sm3_current_state__SHIFT   = 0x0000000c;
    constexpr unsigned int PA_DEBUG19_0__sm3_highest_priority_seq__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG19_0__sm3_inv_to_clip_data_valid_0__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG19_0__sm3_inv_to_clip_data_valid_1__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG19_0__sm3_outputcliptoga_0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG19_0__sm3_vertex_clip_cnt__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG19_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG19_1__sm3_clip_to_clipga_clip_to_outsm_cnt_eq0__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG19_1__sm3_clip_to_outsm_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG19_1__sm3_clip_vert_cnt__SHIFT   = 0x00000008;
    constexpr unsigned int PA_DEBUG19_1__sm3_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG19_1__sm3_current_state__SHIFT   = 0x00000010;
    constexpr unsigned int PA_DEBUG19_1__sm3_highest_priority_seq__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG19_1__sm3_outputcliptoga_0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG19_1__sm3_prim_end_state__SHIFT  = 0x00000000;
    constexpr unsigned int PA_DEBUG19_1__sm3_ps_expand__SHIFT       = 0x00000007;
    constexpr unsigned int PA_DEBUG19_1__sm3_vertex_clip_cnt__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG20_0__point_address__SHIFT       = 0x00000000;
    constexpr unsigned int PA_DEBUG20_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_advance__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_aux_inc__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_aux_sel__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_pci__SHIFT   = 0x00000008;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_req_mask__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_sp_id__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_state_var_indx__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG20_1__point_address__SHIFT       = 0x00000006;
    constexpr unsigned int PA_DEBUG20_1__position_address__SHIFT    = 0x00000000;
    constexpr unsigned int PA_DEBUG20_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_advance__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_aux_inc__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_aux_sel__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_pci__SHIFT   = 0x00000010;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_req_mask__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_sp_id__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_state_var_indx__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG21_0__aux_sel__SHIFT             = 0x0000000c;
    constexpr unsigned int PA_DEBUG21_0__pasx_req_cnt_0__SHIFT      = 0x00000014;
    constexpr unsigned int PA_DEBUG21_0__pasx_req_cnt_1__SHIFT      = 0x00000010;
    constexpr unsigned int PA_DEBUG21_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG21_0__statevar_bits_disable_sp__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG21_0__statevar_bits_vs_out_misc_vec_ena__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG21_0__sx_pending_fifo_contents__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG21_0__sx_receive_indx__SHIFT     = 0x00000000;
    constexpr unsigned int PA_DEBUG21_0__sx_to_pa_empty_0__SHIFT    = 0x0000000f;
    constexpr unsigned int PA_DEBUG21_0__sx_to_pa_empty_1__SHIFT    = 0x0000000e;
    constexpr unsigned int PA_DEBUG21_1__available_positions__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG21_1__pasx_req_cnt_0__SHIFT      = 0x00000014;
    constexpr unsigned int PA_DEBUG21_1__pasx_req_cnt_1__SHIFT      = 0x00000010;
    constexpr unsigned int PA_DEBUG21_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG21_1__statevar_bits_vs_out_misc_vec_ena__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG21_1__sx_pending_fifo_contents__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG21_1__sx_receive_indx__SHIFT     = 0x00000007;
    constexpr unsigned int PA_DEBUG22_0__req_active_verts_loaded__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG22_0__req_active_verts__SHIFT    = 0x00000008;
    constexpr unsigned int PA_DEBUG22_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG22_0__su_aux__SHIFT              = 0x00000000;
    constexpr unsigned int PA_DEBUG22_0__sx_request_indx__SHIFT     = 0x00000001;
    constexpr unsigned int PA_DEBUG22_0__vgt_to_ccgen_active_verts__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG22_0__vgt_to_ccgen_state_var_indx__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG22_1__param_cache_base__SHIFT    = 0x00000000;
    constexpr unsigned int PA_DEBUG22_1__req_active_verts_loaded__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG22_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG22_1__su_aux__SHIFT              = 0x00000007;
    constexpr unsigned int PA_DEBUG22_1__sx_request_indx__SHIFT     = 0x00000009;
    constexpr unsigned int PA_DEBUG22_1__vgt_to_ccgen_active_verts__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG22_1__vgt_to_ccgen_state_var_indx__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG23_0__ALWAYS_ZERO__SHIFT         = 0x00000006;
    constexpr unsigned int PA_DEBUG23_0__event_id_gated_1to0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG23_0__geom_busy__SHIFT           = 0x00000015;
    constexpr unsigned int PA_DEBUG23_0__geom_enable__SHIFT         = 0x0000000f;
    constexpr unsigned int PA_DEBUG23_0__ge_stallb__SHIFT           = 0x0000000e;
    constexpr unsigned int PA_DEBUG23_0__pfifo_busy__SHIFT          = 0x00000013;
    constexpr unsigned int PA_DEBUG23_0__pmode_state__SHIFT         = 0x00000008;
    constexpr unsigned int PA_DEBUG23_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG23_0__su_baryc_cntl_state__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG23_0__su_clip_baryc_free__SHIFT  = 0x00000010;
    constexpr unsigned int PA_DEBUG23_0__su_clip_rtr__SHIFT         = 0x00000012;
    constexpr unsigned int PA_DEBUG23_0__su_cntl_busy__SHIFT        = 0x00000014;
    constexpr unsigned int PA_DEBUG23_0__su_cntl_state__SHIFT       = 0x00000002;
    constexpr unsigned int PA_DEBUG24_0__cl_dyn_sclk_vld__SHIFT     = 0x00000007;
    constexpr unsigned int PA_DEBUG24_0__event_gated__SHIFT         = 0x00000004;
    constexpr unsigned int PA_DEBUG24_0__event_id_gated_5to2__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG24_0__pmode_prim_gated__SHIFT    = 0x00000005;
    constexpr unsigned int PA_DEBUG24_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG24_0__su_dyn_sclk_vld__SHIFT     = 0x00000006;
    constexpr unsigned int PA_DEBUG24_0__y_sort0_gated_23_8__SHIFT  = 0x00000008;
    constexpr unsigned int PA_DEBUG25_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG25_0__x_sort0_gated_23_8__SHIFT  = 0x00000000;
    constexpr unsigned int PA_DEBUG25_0__y_sort1_gated_15_8__SHIFT  = 0x00000010;
    constexpr unsigned int PA_DEBUG26_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG26_0__x_sort1_gated_23_8__SHIFT  = 0x00000008;
    constexpr unsigned int PA_DEBUG26_0__y_sort1_gated_23_16__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG27_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG27_0__x_sort2_gated_15_8__SHIFT  = 0x00000010;
    constexpr unsigned int PA_DEBUG27_0__y_sort2_gated_23_8__SHIFT  = 0x00000000;
    constexpr unsigned int PA_DEBUG28_0__attr_indx_sort0_gated__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG28_0__backfacing_gated__SHIFT    = 0x00000017;
    constexpr unsigned int PA_DEBUG28_0__null_prim_gated__SHIFT     = 0x00000016;
    constexpr unsigned int PA_DEBUG28_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG28_0__x_sort2_gated_23to16__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG29_0__attr_indx_sort2_gated_7to0__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG29_0__clipped_gated__SHIFT       = 0x00000003;
    constexpr unsigned int PA_DEBUG29_0__dealloc_slot_gated__SHIFT  = 0x00000004;
    constexpr unsigned int PA_DEBUG29_0__diamond_rule_gated__SHIFT  = 0x00000008;
    constexpr unsigned int PA_DEBUG29_0__eop_gated__SHIFT           = 0x0000000f;
    constexpr unsigned int PA_DEBUG29_0__fpov_gated__SHIFT          = 0x0000000d;
    constexpr unsigned int PA_DEBUG29_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG29_0__st_indx_gated__SHIFT       = 0x00000000;
    constexpr unsigned int PA_DEBUG29_0__type_gated__SHIFT          = 0x0000000a;
    constexpr unsigned int PA_DEBUG29_0__xmajor_gated__SHIFT        = 0x00000007;
    constexpr unsigned int PA_DEBUG30_0__attr_indx_sort1_gated__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG30_0__attr_indx_sort2_gated_13to8__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG30_0__pa_reg_sclk_vld__SHIFT     = 0x00000017;
    constexpr unsigned int PA_DEBUG30_0__provoking_vtx_gated__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG30_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG30_0__valid_prim_gated__SHIFT    = 0x00000016;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm0_clprim_to_clip_prim_valid__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm1_clprim_to_clip_prim_valid__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm2_clprim_to_clip_prim_valid__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm3_clprim_to_clip_prim_valid__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm_clip_to_outsm_fifo_write__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_outsm_clr_fifo_not_empty__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_primic_to_clprim_valid__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy__SHIFT        = 0x00000008;
    constexpr unsigned int PA_DEBUG31_0__PA0_SC0_send_q__SHIFT      = 0x00000003;
    constexpr unsigned int PA_DEBUG31_0__PA0_SC1_send_q__SHIFT      = 0x00000004;
    constexpr unsigned int PA_DEBUG31_0__PA_PA_pascDataOut_send0_q__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG31_0__PA_PA_pascDataOut_send1_q__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG31_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_geom_busy__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_hold_busy__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_pfifo_busy__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_su_cntl_busy__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_valid_prim_gated__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG31_0__su_busy__SHIFT             = 0x00000009;
    constexpr unsigned int PA_DEBUG31_0__VGT_PA_clipp_send_q__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG31_0__VGT_PA_clips_send_q__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG31_0__VGT_PA_clipv_send_q__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG31_0__vte_busy_debug_ib_busy__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG31_0__vte_busy_debug_veu_busy__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG31_0__vte_busy__SHIFT            = 0x00000007;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_ccgen_to_clipcc_fifo_busy__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_ccgen_to_clipcc_fifo_write__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipcode_fifo_fifo_busy__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipcode_fifo_fifo_write__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipsm0_current_state_not_empty__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipsm1_current_state_not_empty__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipsm2_current_state_not_empty__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipsm3_current_state_not_empty__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clip_to_ga_bc_busy__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clip_to_ga_fifo_write__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clip_to_outsm_fifo_busy__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clip_to_outsm_fifo_write__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_next_prim_back_valid__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_primic_to_clprim_fifo_not_empty__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_primic_to_clprim_fifo_write__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_prim_back_valid__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_sx_pending_fifo_not_empty__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vgt_to_clipp_fifo_busy__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vgt_to_clipp_fifo_write__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vgt_to_clips_fifo_busy__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vte_out_clip_fifo_fifo_busy__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vte_out_clip_fifo_fifo_write__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vte_out_orig_fifo_fifo_busy__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vte_out_orig_fifo_fifo_write__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG32_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG33_0__clipper_busy_debug_vgt_to_clips_fifo_write__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG33_0__PA_SE3SC_freeze__SHIFT     = 0x00000004;
    constexpr unsigned int PA_DEBUG33_0__Reserved0__SHIFT           = 0x00000005;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_busy__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_rtr_in__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_rtr_out__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_rts_in__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_rts_out__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_iclient_send_valid__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_iutcl1_send_ready__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_oclient_send_ready__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_outcl1_send_type__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_outcl1_send_valid__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_outcl1_send_vmid__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_tag__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG34_0__Reserved0__SHIFT           = 0x00000017;
    constexpr unsigned int PA_DEBUG34_1__ngg_utcl1_debug00__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_busy__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_empty__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_full__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_read__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_write__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_iclient_send_valid__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_iutcl1_send_ready__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_oclient_send_ready__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_outcl1_send_type__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_outcl1_send_valid__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_outcl1_send_vmid__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_tag__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG35_0__Reserved0__SHIFT           = 0x00000017;
    constexpr unsigned int PA_DEBUG35_1__ngg_utcl1_debug01__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_busy__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_empty__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_full__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_read__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_write__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_iclient_send_valid__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_iutcl1_send_ready__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_oclient_send_ready__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_outcl1_send_type__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_outcl1_send_valid__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_outcl1_send_vmid__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_tag__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG36_0__Reserved0__SHIFT           = 0x00000017;
    constexpr unsigned int PA_DEBUG36_1__ngg_utcl1_debug02__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_busy__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_drop__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_io__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_mtype__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_perf_cntr_en__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_rd_tmz_encr__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_snoop__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_space__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_tag__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_vmid__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_rtr_in__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_rtr_out__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_rts_in__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_rts_out__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG37_0__Reserved0__SHIFT           = 0x0000001a;
    constexpr unsigned int PA_DEBUG37_1__ngg_utcl1_debug03__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_busy__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_drop__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_io__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_mtype__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_perf_cntr_en__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_rd_tmz_encr__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_snoop__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_space__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_tag__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_vmid__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_rtr_in__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_rtr_out__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_rts_in__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_rts_out__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG38_0__Reserved0__SHIFT           = 0x0000001a;
    constexpr unsigned int PA_DEBUG38_1__ngg_utcl1_debug04__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_busy__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_drop__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_io__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_mtype__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_perf_cntr_en__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_rd_tmz_encr__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_snoop__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_space__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_tag__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_vmid__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_rtr_in__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_rtr_out__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_rts_in__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_rts_out__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG39_0__Reserved0__SHIFT           = 0x0000001a;
    constexpr unsigned int PA_DEBUG39_1__ngg_utcl1_debug05__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG40_0__ngg_debug_tc_request_arbiter_current_client_count__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG40_0__ngg_debug_tc_request_arbiter_istream0_client_rts__SHIFT = 0x0000001f;
    constexpr unsigned int PA_DEBUG40_0__ngg_debug_tc_request_arbiter_istream0_client_tag__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG40_0__ngg_debug_tc_request_arbiter_ostream0_client_rtr__SHIFT = 0x0000001e;
    constexpr unsigned int PA_DEBUG40_1__ngg_utcl1_debug06__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_credits__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_credit_count_overflow__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_credit_count_underflow__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_data_rd_ptr__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_data_wr_ptr__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_irdreq_free__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_irdret_vld__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_irts_in__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_obusy__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_ooutstanding_tc_requests_exist__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_ordreq_clken__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_ordreq_send__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_ortr_in__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_outstanding_tc_requests__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_reg_valid0__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_reg_valid1__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG41_0__Reserved0__SHIFT           = 0x0000001d;
    constexpr unsigned int PA_DEBUG41_1__ngg_utcl1_debug07__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_current_dword_pointer__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_current_sideband_event_bit_set__SHIFT = 0x00000018;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_current_sideband_is_object_id__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_current_state__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_have_available_sideband_tokens__SHIFT = 0x00000019;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_itc_return_empty__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_pending_subgroup_count_not_zero__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_pending_subgroup_count_range__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_sideband_tokens_not_max_value__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_sideband_tokens_overflow__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_sideband_tokens_underflow__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_valid_dword_count__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_wait_counter_busy__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG42_0__Reserved0__SHIFT           = 0x0000001a;
    constexpr unsigned int PA_DEBUG42_1__ngg_utcl1_debug08__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_current_state__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_osideband_active__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_ovmid__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_sideband_pop_bit_fifo_busy__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_sideband_pop_bit_fifo_empty__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_sideband_pop_bit_fifo_full__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_vmid_fifo_busy__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_vmid_fifo_empty__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_vmid_fifo_full__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG43_0__Reserved0__SHIFT           = 0x0000000c;
    constexpr unsigned int PA_DEBUG43_1__ngg_utcl1_debug09__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents0_overflow__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents0_underflow__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents0__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents1_overflow__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents1_underflow__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents1__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG44_0__Reserved0__SHIFT           = 0x00000014;
    constexpr unsigned int PA_DEBUG44_1__ngg_utcl1_debug10__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_current_fetch_state__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_current_receive_finalt_dword_pointer__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_current_receive_first_dword_pointer__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_current_receive_state__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_final_receive_cacheline_this_subgroup__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_final_receive_dword_of_subgroup__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_have_available_index_tokens__SHIFT = 0x0000001d;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_receive_fifo_busy__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_receive_fifo_empty__SHIFT = 0x0000001b;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_receive_fifo_full__SHIFT = 0x0000001c;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_tokens_overflow__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_tokens_underflow__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_tokens__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_prim_indices_fifo_busy__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_sideband_data_context_id_bits__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_sideband_data_eop_bit__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_sideband_data_event_bit__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG45_0__Reserved0__SHIFT           = 0x0000001e;
    constexpr unsigned int PA_DEBUG45_1__ngg_utcl1_debug11__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_active_pos_req_fosg__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_another_pos_fetch__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_current_state__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_end_prev_diff__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_end_start_diff__SHIFT = 0x00000019;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_have_available_position_tokens__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_ifetch_to_primic_p_fifo_full__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_ifetch_to_primic_s_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_ipa_to_wd_dealloc_index_full__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_iposreq_to_posrtn_s_fifo_full__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_iposreq_to_posrtn_v_fifo_full__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_packer_object_id_valid__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_packer_sideband_valid__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_position_tokens_overflow__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_position_tokens_underflow__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_prev_pos_cacheline_valid__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_prev_select_end_cacheline_address__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_busy__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_final_prim__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_first_prim__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_miss_count__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_null_prim__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_prim_valid__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_start_prev_diff__SHIFT = 0x00000018;
    constexpr unsigned int PA_DEBUG46_0__Reserved0__SHIFT           = 0x0000001a;
    constexpr unsigned int PA_DEBUG46_1__ngg_utcl1_debug12__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_current_state__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_iinput_sideband_valid__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_eop_bit__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_event_bit__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_event_id__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_event_second_cycle__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_state_id__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_stream_id__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_output_prim_empty__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_prim_fifo_busy__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_prim_fifo_full__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_sideband_fifo_busy__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_sideband_fifo_empty__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_sideband_fifo_full__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG47_0__Reserved0__SHIFT           = 0x00000016;
    constexpr unsigned int PA_DEBUG47_1__ngg_utcl1_debug13__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_active_pos_return_cache_pos_index__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_active_pos_return_first_vert__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_active_pos_return_state__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_cache_pos_index__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_ifetch_to_sxif_fifo_full__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_ipa_to_wd_dealloc_position_full__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_itc_return_empty__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_oposreq_to_posrtn_s_fifo_full__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_oposreq_to_posrtn_v_fifo_full__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_posreq_to_posrtn_s_fifo_busy__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_posreq_to_posrtn_s_fifo_empty__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_posreq_to_posrtn_v_fifo_busy__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_posreq_to_posrtn_v_fifo_empty__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG48_0__Reserved0__SHIFT           = 0x00000010;
    constexpr unsigned int PA_DEBUG48_1__ngg_utcl1_debug14__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_crawler_busy__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_memreg0_busy__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_memreg1_busy__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_memreg2_busy__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_oreturn_empty_stream0__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_oreturn_empty_stream1__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_oreturn_empty_stream2__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_return_data_read_reg_full_stream0__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_return_data_read_reg_full_stream1__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_return_data_read_reg_full_stream2__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG49_0__Reserved0__SHIFT           = 0x0000000a;
    constexpr unsigned int PA_DEBUG49_1__ngg_utcl1_debug15__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_encountered_error_writing_to_busy_location_stream0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_encountered_error_writing_to_busy_location_stream1__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_encountered_error_writing_to_busy_location_stream2__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_memory_data_valid_stream0_count__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_memory_data_valid_stream1_count__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_memory_data_valid_stream2_count__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_obusy__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG50_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG50_1__ngg_utcl1_debug16__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_amount__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_fifo_busy__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_index_full__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_position_full__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_state_var_index__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_type__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_pa_to_wd_dealloc_fifo_empty__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_pa_to_wd_dealloc_fifo_read__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG51_0__Reserved0__SHIFT           = 0x00000014;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_all_clean__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_current_state__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iindex_requester_idle__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iindex_utcl1_return_busy__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iindex_utcl1_send_busy__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_ioutstanding_tc_requests_exist__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iposition_requester_idle__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iposition_utcl1_return_busy__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iposition_utcl1_send_busy__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_isideband_requester_idle__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_isideband_utcl1_return_busy__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_isideband_utcl1_send_busy__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iutcl1_busy__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_oclean__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_vmid_count__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG52_0__Reserved0__SHIFT           = 0x00000014;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_index_tokens_overflow__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_index_tokens_underflow__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_position_tokens_overflow__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_position_tokens_underflow__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sbmem_contents0_overflow__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sbmem_contents0_underflow__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sbmem_contents1_overflow__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sbmem_contents1_underflow__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sideband_tokens_overflow__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sideband_tokens_underflow__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_tc_credit_count_overflow__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_tc_credit_count_underflow__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_writing_to_busy_location_stream0__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_writing_to_busy_location_stream1__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_writing_to_busy_location_stream2__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG53_0__Reserved0__SHIFT           = 0x0000000f;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_index_receive_fifo_full__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_pa_to_wd_dealloc_index_full__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_pa_to_wd_dealloc_position_full__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_posreq_to_posrtn_s_fifo_full__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_posreq_to_posrtn_v_fifo_full__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_prim_fifo_full__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_prim_indices_fifo_full__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_return_data_full_stream0__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_return_data_full_stream1__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_return_data_full_stream2__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_sbmem_full__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_sideband_fifo_full__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_sideband_pop_bit_fifo_full__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_vmid_fifo_full__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG54_0__Reserved0__SHIFT           = 0x0000000e;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_index_receive_fifo_empty__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_pa_to_wd_dealloc_fifo_empty__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_posreq_to_posrtn_s_fifo_empty__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_posreq_to_posrtn_v_fifo_empty__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_prim_fifo_empty__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_prim_indices_fifo_empty__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_return_data_empty_stream0__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_return_data_empty_stream1__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_return_data_empty_stream2__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_sbmem_empty__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_sideband_fifo_empty__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_sideband_pop_bit_fifo_empty__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_vmid_fifo_empty__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG55_0__Reserved0__SHIFT           = 0x0000000d;
    constexpr unsigned int rbuf_DEBUG_DATA__pixel_addr_mask__SHIFT  = 0x00000002;
    constexpr unsigned int rbuf_DEBUG_DATA__Reserved0__SHIFT        = 0x00000018;
    constexpr unsigned int RLC_SPM_DEBUG_SELECT__RLC_DBG_FIFO_CNTL__SHIFT = 0x0000000d;
    constexpr unsigned int RLC_SPM_DEBUG_SELECT__RLC_MC_FIFO_CNTL__SHIFT = 0x0000000c;
    constexpr unsigned int RLC_SPM_DEBUG_SELECT__RLC_SPM_DEBUG_MODE_DUAL__SHIFT = 0x0000000e;
    constexpr unsigned int RLC_SPM_PERFMON_CNTL__RESERVED1__SHIFT   = 0x00000002;
    constexpr unsigned int RLC_SPM_PERFMON_CNTL__RLC_DBG_STRM_EN__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_PERFMON_CNTL__RLC_DBG_STRM_EXT_SAMPLE__SHIFT = 0x00000001;
    constexpr unsigned int wbuf_DEBUG_DATA__cstate_3to0__SHIFT      = 0x0000000d;
    constexpr unsigned int wbuf_DEBUG_DATA__Reserved0__SHIFT        = 0x00000000;
    constexpr unsigned int wbuf_DEBUG_DATA__Reserved1__SHIFT        = 0x00000016;
    constexpr unsigned int wbuf_DEBUG_DATA__wr_pixel_ptr_nxt__SHIFT = 0x00000007;
    constexpr unsigned int WD_DEBUG_REG7__SE1VGT_WD_thdgrp_send_in__SHIFT = 0x00000004;
    constexpr unsigned int WD_DEBUG_REG7__se1_thdgrp_eop__SHIFT     = 0x00000017;
    constexpr unsigned int WD_DEBUG_REG7__se1_thdgrp_is_event__SHIFT = 0x00000016;
    constexpr unsigned int WD_DEBUG_REG7__te11_arb_state_q__SHIFT   = 0x00000010;
    constexpr unsigned int WD_DEBUG_REG7__wd_arb_se1_input_fifo_empty__SHIFT = 0x00000006;
    constexpr unsigned int WD_DEBUG_REG7__wd_arb_se1_input_fifo_full__SHIFT = 0x00000007;
    constexpr unsigned int WD_DEBUG_REG7__wd_arb_se1_input_fifo_re__SHIFT = 0x00000005;
} // namespace Raven

namespace Rv1x
{
    constexpr unsigned int GC_CAC_ACC_BCI1__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU3__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU4__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
    constexpr unsigned int GC_CAC_OVRD_BCI__OVRRD_VALUE__SHIFT      = 0x00000002;
    constexpr unsigned int GC_CAC_WEIGHT_BCI_0__WEIGHT_BCI_SIG1__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_PG_0__unused__SHIFT        = 0x00000010;
    constexpr unsigned int IA_DEBUG_REG0__SPARE0__SHIFT             = 0x00000004;
    constexpr unsigned int IA_DEBUG_REG0__SPARE1__SHIFT             = 0x00000009;
    constexpr unsigned int IA_DEBUG_REG0__SPARE2__SHIFT             = 0x0000000e;
    constexpr unsigned int IA_DEBUG_REG0__SPARE3__SHIFT             = 0x0000001a;
    constexpr unsigned int IA_DEBUG_REG0__SPARE4__SHIFT             = 0x0000001b;
    constexpr unsigned int IA_DEBUG_REG0__SPARE5__SHIFT             = 0x0000001e;
    constexpr unsigned int IA_DEBUG_REG9__SPARE0__SHIFT             = 0x0000000e;
    constexpr unsigned int IA_DEBUG_REG9__SPARE1__SHIFT             = 0x0000000f;
    constexpr unsigned int PWR_OVERRIDE__VDDCR_CPU_OVERRIDE__SHIFT  = 0x00000000;
    constexpr unsigned int RMI_CLOCK_CNTRL__DYN_CLK_RB1_BUSY_MASK__SHIFT = 0x00000014;
    constexpr unsigned int RMI_CLOCK_CNTRL__DYN_CLK_RB1_WAKEUP_MASK__SHIFT = 0x00000019;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_BREAK_LOB_ON_IDLEIN__SHIFT = 0x00000011;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_MODE__SHIFT   = 0x0000001e;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_STALL_TIMER_OVERRIDE__SHIFT = 0x00000014;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_STALL_TIMER_START_VALUE__SHIFT = 0x00000016;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_STALL__SHIFT  = 0x00000010;
    constexpr unsigned int RMI_GENERAL_CNTL1__TCIW1_64B_RD_STALL_MODE__SHIFT = 0x00000006;
    constexpr unsigned int RMI_GENERAL_CNTL1__UTCL1_PROBE1_RR_ARB_BURST_HINT_EN__SHIFT = 0x0000000c;
    constexpr unsigned int RMI_GENERAL_CNTL__RB1_HARVEST_EN__SHIFT  = 0x00000014;
    constexpr unsigned int RMI_GENERAL_CNTL__SKID_FIFO_1_OVERFLOW_ERROR_MASK__SHIFT = 0x0000001c;
    constexpr unsigned int RMI_GENERAL_CNTL__SKID_FIFO_1_UNDERFLOW_ERROR_MASK__SHIFT = 0x0000001d;
    constexpr unsigned int RMI_GENERAL_STATUS__RDREQ_CONSUMER_FIFO_1_BUSY__SHIFT = 0x00000011;
    constexpr unsigned int RMI_GENERAL_STATUS__SKID_FIFO_1_OVERFLOW_ERROR__SHIFT = 0x00000003;
    constexpr unsigned int RMI_GENERAL_STATUS__SKID_FIFO_1_UNDERFLOW_ERROR__SHIFT = 0x00000004;
    constexpr unsigned int RMI_GENERAL_STATUS__TCIW1_PRT_FIFO_BUSY__SHIFT = 0x0000000d;
    constexpr unsigned int RMI_GENERAL_STATUS__TCIW_FRMTR1_BUSY__SHIFT = 0x0000000e;
    constexpr unsigned int RMI_GENERAL_STATUS__TCIW_RTN_FRMTR1_BUSY__SHIFT = 0x0000000f;
    constexpr unsigned int RMI_GENERAL_STATUS__UTC_PROBE1_BUSY__SHIFT = 0x00000012;
    constexpr unsigned int RMI_GENERAL_STATUS__WRREQ_CONSUMER_FIFO_1_BUSY__SHIFT = 0x00000010;
    constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_EVENT_WINDOW_MASK1__SHIFT = 0x00000008;
    constexpr unsigned int RMI_PROBE_POP_LOGIC_CNTL__EXT_LAT_FIFO_1_MAX_DEPTH__SHIFT = 0x0000000a;
    constexpr unsigned int RMI_PROBE_POP_LOGIC_CNTL__XLAT_COMBINE1_DIS__SHIFT = 0x00000011;
    constexpr unsigned int RMI_SCOREBOARD_CNTL__COMPLETE_RB1_FLUSH__SHIFT = 0x00000002;
    constexpr unsigned int RMI_SCOREBOARD_CNTL__REQ_IN_RE_EN_AFTER_FLUSH_RB1__SHIFT = 0x00000003;
    constexpr unsigned int RMI_SCOREBOARD_CNTL__TIME_STAMP_FLUSH_RB1__SHIFT = 0x00000004;
    constexpr unsigned int RMI_SCOREBOARD_STATUS1__COM_FLUSH_IN_PROG_RB1__SHIFT = 0x0000001d;
    constexpr unsigned int RMI_SCOREBOARD_STATUS1__RUNNING_CNT_OVERFLOW_RB1__SHIFT = 0x0000001c;
    constexpr unsigned int RMI_SCOREBOARD_STATUS1__RUNNING_CNT_RB1__SHIFT = 0x0000000f;
    constexpr unsigned int RMI_SCOREBOARD_STATUS1__RUNNING_CNT_UNDERFLOW_RB1__SHIFT = 0x0000001b;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__COM_FLUSH_DONE_RB1__SHIFT = 0x0000001a;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__SNAPSHOT_CNT_RB1__SHIFT = 0x0000000d;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__SNAPSHOT_CNT_UNDERFLOW_RB1__SHIFT = 0x00000019;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__TIME_STAMP_FLUSH_DONE_RB1__SHIFT = 0x0000001f;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__TIME_STAMP_FLUSH_IN_PROG_RB1__SHIFT = 0x0000001d;
    constexpr unsigned int RMI_SUBBLOCK_STATUS0__UTC_EXT_LAT_HID_FIFO_EMPTY_PROBE1__SHIFT = 0x00000011;
    constexpr unsigned int RMI_SUBBLOCK_STATUS0__UTC_EXT_LAT_HID_FIFO_FULL_PROBE1__SHIFT = 0x00000010;
    constexpr unsigned int RMI_SUBBLOCK_STATUS0__UTC_EXT_LAT_HID_FIFO_NUM_USED_PROBE1__SHIFT = 0x00000009;
    constexpr unsigned int RMI_SUBBLOCK_STATUS1__SKID_FIFO_1_FREE_SPACE__SHIFT = 0x0000000a;
    constexpr unsigned int RMI_SUBBLOCK_STATUS1__TCIW1_INFLIGHT_CNT__SHIFT = 0x00000014;
    constexpr unsigned int RMI_SUBBLOCK_STATUS2__PRT_FIFO_1_NUM_USED__SHIFT = 0x00000009;
    constexpr unsigned int RMI_SUBBLOCK_STATUS3__SKID_FIFO_1_FREE_SPACE_TOTAL__SHIFT = 0x0000000a;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__ALL_FAULT_RET1_DATA__SHIFT = 0x0000001f;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__RMI_IN1_REORDER_DIS__SHIFT = 0x0000001d;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__SKID_FIFO_1_FREE_SPACE_DELTA_UPDATE__SHIFT = 0x0000001b;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__SKID_FIFO_1_FREE_SPACE_DELTA__SHIFT = 0x00000013;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__TCIW1_MAX_ALLOWED_INFLIGHT_REQ__SHIFT = 0x00000009;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__TCIW1_REQ_SAFE_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__WR_COMBINE1_DIS_AT_LAST_OF_BURST__SHIFT = 0x0000001e;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__WR_COMBINE1_DIS_OVERRIDE__SHIFT = 0x00000000;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__WR_COMBINE1_TIME_OUT_WINDOW__SHIFT = 0x00000001;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG_1__XBAR_ARB_ROUND_ROBIN_WEIGHT_RB1_RD__SHIFT = 0x00000010;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG_1__XBAR_ARB_ROUND_ROBIN_WEIGHT_RB1_WR__SHIFT = 0x00000018;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_BREAK_LOB_ON_IDLEIN__SHIFT = 0x00000014;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_BREAK_LOB_ON_WEIGHTEDRR__SHIFT = 0x00000012;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_MODE__SHIFT = 0x00000010;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_STALL_TIMER_OVERRIDE__SHIFT = 0x00000016;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_STALL_TIMER_START_VALUE__SHIFT = 0x00000018;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_STALL__SHIFT = 0x00000013;
    constexpr unsigned int RMI_XBAR_CONFIG__XBAR_EN_IN_RB1__SHIFT   = 0x0000000e;
    constexpr unsigned int RPB_ATS_CNTL2__INVAL_COM_ROUTING_CODE__SHIFT = 0x0000000f;
    constexpr unsigned int RPB_ATS_CNTL2__PAGE_REQ_CMD__SHIFT       = 0x00000006;
    constexpr unsigned int RPB_ATS_CNTL2__PAGE_ROUTING_CODE__SHIFT  = 0x0000000c;
    constexpr unsigned int RPB_ATS_CNTL2__TRANS_CMD__SHIFT          = 0x00000000;
    constexpr unsigned int RPB_ATS_CNTL2__VENDOR_ID__SHIFT          = 0x00000012;
    constexpr unsigned int RPB_ATS_CNTL__ATCTR_SWITCH_NUM__SHIFT    = 0x0000000f;
    constexpr unsigned int RPB_ATS_CNTL__INVAL_COM_CMD__SHIFT       = 0x00000019;
    constexpr unsigned int RPB_BIF_CNTL__ARB_MODE__SHIFT            = 0x00000010;
    constexpr unsigned int RPB_BIF_CNTL__DRAIN_VC_NUM__SHIFT        = 0x00000011;
    constexpr unsigned int RPB_BIF_CNTL__PAGE_PRI_EN__SHIFT         = 0x0000001b;
    constexpr unsigned int RPB_BIF_CNTL__PARITY_CHECK_EN__SHIFT     = 0x0000001e;
    constexpr unsigned int RPB_BIF_CNTL__SWITCH_ENABLE__SHIFT       = 0x00000012;
    constexpr unsigned int RPB_BIF_CNTL__SWITCH_THRESHOLD__SHIFT    = 0x00000013;
    constexpr unsigned int RPB_BIF_CNTL__TR_PRI_EN__SHIFT           = 0x0000001c;
    constexpr unsigned int RPB_BIF_CNTL__VC0_CHAINED_OVERRIDE__SHIFT = 0x0000001d;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATC_INV_BLOCKLEVEL__SHIFT = 0x00000006;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATC_PAGE_BLOCKLEVEL__SHIFT = 0x00000004;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATC_TR_BLOCKLEVEL__SHIFT = 0x00000002;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATOMIC_BLOCKLEVEL_OVERRIDE_EN__SHIFT = 0x00000011;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATOMIC_BLOCKLEVEL_OVERRIDE__SHIFT = 0x0000000c;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_RD_BLOCKLEVEL_OVERRIDE_EN__SHIFT = 0x00000010;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_RD_BLOCKLEVEL_OVERRIDE__SHIFT = 0x0000000a;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_WR_BLOCKLEVEL_OVERRIDE_EN__SHIFT = 0x0000000f;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_WR_BLOCKLEVEL_OVERRIDE__SHIFT = 0x00000008;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__XPB_BLOCKLEVEL_OVERRIDE_EN__SHIFT = 0x0000000e;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_PAGE_PASSPW_OVERRIDE_EN__SHIFT = 0x0000000c;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_PAGE_PASSPW_OVERRIDE__SHIFT = 0x00000003;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_RSPPASSPW_OVERRIDE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_RSPPASSPW_OVERRIDE__SHIFT = 0x00000008;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_TR_PASSPW_OVERRIDE_EN__SHIFT = 0x0000000b;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_TR_PASSPW_OVERRIDE__SHIFT = 0x00000002;
    constexpr unsigned int RPB_PASSPW_CONF__ATOMIC_PASSPW_OVERRIDE__SHIFT = 0x00000009;
    constexpr unsigned int RPB_PASSPW_CONF__ATOMIC_RSPPASSPW_OVERRIDE__SHIFT = 0x0000000a;
    constexpr unsigned int RPB_PASSPW_CONF__RDRSP_PASSPW_OVERRIDE_EN__SHIFT = 0x00000011;
    constexpr unsigned int RPB_PASSPW_CONF__RDRSP_PASSPW_OVERRIDE__SHIFT = 0x00000010;
    constexpr unsigned int RPB_PASSPW_CONF__RD_PASSPW_OVERRIDE__SHIFT = 0x00000005;
    constexpr unsigned int RPB_PASSPW_CONF__RD_RSPPASSPW_OVERRIDE__SHIFT = 0x00000007;
    constexpr unsigned int RPB_PASSPW_CONF__WRRSP_PASSPW_OVERRIDE_EN__SHIFT = 0x0000000f;
    constexpr unsigned int RPB_PASSPW_CONF__WRRSP_PASSPW_OVERRIDE__SHIFT = 0x0000000e;
    constexpr unsigned int RPB_PASSPW_CONF__WR_PASSPW_OVERRIDE__SHIFT = 0x00000004;
    constexpr unsigned int RPB_PASSPW_CONF__WR_RSPPASSPW_OVERRIDE__SHIFT = 0x00000006;
    constexpr unsigned int RPB_TAG_CONF__RPB_ATS_TR__SHIFT          = 0x00000000;
    constexpr unsigned int VGT_DEBUG_REG0__SPARE0__SHIFT            = 0x0000001f;
    constexpr unsigned int VGT_DEBUG_REG0__SPARE1__SHIFT            = 0x0000001c;
    constexpr unsigned int VGT_DEBUG_REG0__SPARE2__SHIFT            = 0x00000019;
    constexpr unsigned int VGT_DEBUG_REG0__SPARE3__SHIFT            = 0x00000014;
    constexpr unsigned int VGT_DEBUG_REG0__SPARE4__SHIFT            = 0x00000007;
    constexpr unsigned int VGT_DEBUG_REG0__SPARE5__SHIFT            = 0x00000006;
    constexpr unsigned int VGT_DEBUG_REG1__SPARE0__SHIFT            = 0x00000009;
    constexpr unsigned int VGT_DEBUG_REG1__SPARE1__SHIFT            = 0x00000008;
    constexpr unsigned int VGT_DEBUG_REG1__SPARE2__SHIFT            = 0x00000007;
    constexpr unsigned int VGT_DEBUG_REG1__SPARE3__SHIFT            = 0x00000006;
    constexpr unsigned int VGT_DEBUG_REG1__SPARE4__SHIFT            = 0x00000005;
    constexpr unsigned int VGT_DEBUG_REG1__SPARE5__SHIFT            = 0x00000004;
    constexpr unsigned int VGT_DEBUG_REG2__SPARE__SHIFT             = 0x0000001d;
    constexpr unsigned int VGT_DEBUG_REG4__SPARE__SHIFT             = 0x0000001f;
    constexpr unsigned int VGT_DEBUG_REG5__SPARE1__SHIFT            = 0x00000018;
    constexpr unsigned int VGT_DEBUG_REG5__SPARE2__SHIFT            = 0x00000010;
    constexpr unsigned int VGT_DEBUG_REG5__SPARE3__SHIFT            = 0x00000008;
    constexpr unsigned int VGT_DEBUG_REG5__SPARE4__SHIFT            = 0x00000000;
    constexpr unsigned int VGT_DEBUG_REG7__SPARE__SHIFT             = 0x00000005;
    constexpr unsigned int VGT_DEBUG_REG9__SPARE0__SHIFT            = 0x0000001e;
    constexpr unsigned int VGT_DEBUG_REG10__SPARE2__SHIFT           = 0x00000009;
    constexpr unsigned int VGT_DEBUG_REG11__SPARE0__SHIFT           = 0x00000012;
    constexpr unsigned int VGT_DEBUG_REG11__SPARE1__SHIFT           = 0x00000005;
    constexpr unsigned int VGT_DEBUG_REG12__SPARE0__SHIFT           = 0x0000001f;
    constexpr unsigned int VGT_DEBUG_REG13__SPARE0__SHIFT           = 0x0000001a;
    constexpr unsigned int VGT_DEBUG_REG13__SPARE1__SHIFT           = 0x00000019;
    constexpr unsigned int VGT_DEBUG_REG14__SPARE0__SHIFT           = 0x0000001e;
    constexpr unsigned int VGT_DEBUG_REG14__SPARE1__SHIFT           = 0x0000001c;
    constexpr unsigned int VGT_DEBUG_REG14__SPARE2__SHIFT           = 0x0000000c;
    constexpr unsigned int VGT_DEBUG_REG14__SPARE3__SHIFT           = 0x00000000;
    constexpr unsigned int VGT_DEBUG_REG14__SPARE__SHIFT            = 0x00000016;
    constexpr unsigned int VGT_DEBUG_REG23__SPARE__SHIFT            = 0x00000018;
    constexpr unsigned int VGT_DEBUG_REG30__SPARE__SHIFT            = 0x00000013;
    constexpr unsigned int VGT_DEBUG_REG32__SPARE__SHIFT            = 0x0000001c;
    constexpr unsigned int WD_DEBUG_REG0__SPARE3__SHIFT             = 0x00000010;
    constexpr unsigned int WD_DEBUG_REG1__SPARE0__SHIFT             = 0x00000008;
    constexpr unsigned int WD_DEBUG_REG2__SPARE0__SHIFT             = 0x00000008;
    constexpr unsigned int WD_DEBUG_REG3__SPARE0__SHIFT             = 0x00000001;
    constexpr unsigned int WD_DEBUG_REG3__SPARE1__SHIFT             = 0x00000017;
    constexpr unsigned int WD_DEBUG_REG5__SPARE0__SHIFT             = 0x00000001;
    constexpr unsigned int WD_DEBUG_REG5__SPARE1__SHIFT             = 0x00000017;
    constexpr unsigned int WD_DEBUG_REG7__SPARE1__SHIFT             = 0x00000008;
    constexpr unsigned int WD_DEBUG_REG7__SPARE2__SHIFT             = 0x0000000c;
    constexpr unsigned int WD_DEBUG_REG7__SPARE5__SHIFT             = 0x00000013;
    constexpr unsigned int WD_DEBUG_REG9__SPARE0__SHIFT             = 0x0000000b;
    constexpr unsigned int WD_DEBUG_REG9__SPARE1__SHIFT             = 0x0000001b;
    constexpr unsigned int WD_DEBUG_REG9__SPARE2__SHIFT             = 0x0000001c;
} // namespace Rv1x

namespace Rv2x
{
    constexpr unsigned int GC_CAC_CNTL__CAC_ENABLE__SHIFT           = 0x00000000;
    constexpr unsigned int GC_CAC_OVRD_BCI__OVRRD_VALUE__SHIFT      = 0x00000001;
    constexpr unsigned int GC_CAC_WEIGHT_CU_0__WEIGHT_CU_SIG1__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_CU_1__WEIGHT_CU_SIG2__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_CU_1__WEIGHT_CU_SIG3__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_SXRB_0__WEIGHT_SXRB_SIG1__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_UTCL2_ATCL2_2__WEIGHT_UTCL2_ATCL2_SIG5__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_UTCL2_VML2_2__WEIGHT_UTCL2_VML2_SIG5__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_UTCL2_WALKER_2__WEIGHT_UTCL2_WALKER_SIG5__SHIFT = 0x00000010;
    constexpr unsigned int IA_DEBUG_REG0__dma_grp_pipe1_valid__SHIFT = 0x0000000c;
    constexpr unsigned int IA_DEBUG_REG0__grp_dma_pipe1_read__SHIFT = 0x0000000d;
    constexpr unsigned int IA_DEBUG_REG0__RESERVED0__SHIFT          = 0x00000004;
    constexpr unsigned int IA_DEBUG_REG0__RESERVED1__SHIFT          = 0x00000009;
    constexpr unsigned int IA_DEBUG_REG0__RESERVED2__SHIFT          = 0x0000000e;
    constexpr unsigned int IA_DEBUG_REG0__RESERVED3__SHIFT          = 0x0000001a;
    constexpr unsigned int IA_DEBUG_REG0__RESERVED4__SHIFT          = 0x0000001b;
    constexpr unsigned int IA_DEBUG_REG0__RESERVED5__SHIFT          = 0x0000001e;
    constexpr unsigned int IA_DEBUG_REG0__RESERVED6__SHIFT          = 0x0000001f;
    constexpr unsigned int IA_DEBUG_REG0__tcarb_busy__SHIFT         = 0x00000007;
    constexpr unsigned int IA_DEBUG_REG1__RESERVED0__SHIFT          = 0x00000007;
    constexpr unsigned int IA_DEBUG_REG9__prim_counter_q_11_0__SHIFT = 0x00000014;
    constexpr unsigned int IA_DEBUG_REG9__RESERVED0__SHIFT          = 0x0000000e;
    constexpr unsigned int IA_DEBUG_REG9__RESERVED1__SHIFT          = 0x0000000f;
    constexpr unsigned int IA_DEBUG_REG10__RESERVED0__SHIFT         = 0x00000000;
    constexpr unsigned int IA_DEBUG_REG11__RESERVED0__SHIFT         = 0x00000000;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_fragment_size__SHIFT = 0x00000010;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_io_steer__SHIFT = 0x0000000f;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_memlog__SHIFT = 0x0000000b;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_mtype__SHIFT = 0x00000009;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_nack__SHIFT = 0x00000007;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_no_pte__SHIFT = 0x0000000c;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_perms_granted__SHIFT = 0x00000016;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_perms_requested__SHIFT = 0x00000019;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_physical_address_1_0__SHIFT = 0x0000001e;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_pte_tmz__SHIFT = 0x0000000d;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_snoop__SHIFT = 0x0000001c;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_spa__SHIFT = 0x0000000e;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_tag__SHIFT = 0x00000000;
    constexpr unsigned int IA_DEBUG_REG12__iUTCL2_IA_ret_valid__SHIFT = 0x0000001d;
    constexpr unsigned int IA_DEBUG_REG13__iUTCL2_IA_ret_physical_address_33_2__SHIFT = 0x0000001e;
    constexpr unsigned int IA_DEBUG_REG14__IA_UTCL2_req_data__SHIFT = 0x00000002;
    constexpr unsigned int IA_DEBUG_REG14__IA_UTCL2_req_send__SHIFT = 0x00000013;
    constexpr unsigned int IA_DEBUG_REG14__iUTCL2_IA_ret_physical_address_35_34__SHIFT = 0x00000000;
    constexpr unsigned int IA_DEBUG_REG14__qIA_UTCL2_req_free__SHIFT = 0x00000012;
    constexpr unsigned int IA_DEBUG_REG14__qUtcL2XferCycle_eq_0__SHIFT = 0x00000014;
    constexpr unsigned int IA_DEBUG_REG14__RESERVED0__SHIFT         = 0x00000015;
    constexpr unsigned int IA_DEBUG_REG15__IAUtcL2Cnt__SHIFT        = 0x00000002;
    constexpr unsigned int IA_DEBUG_REG15__IAUtcL2iuPostArbFifo_Empty__SHIFT = 0x00000000;
    constexpr unsigned int IA_DEBUG_REG15__IAUtcL2iuPostArbFifo_Full__SHIFT = 0x00000001;
    constexpr unsigned int IA_DEBUG_REG15__IAUtcL2OutCnt__SHIFT     = 0x00000008;
    constexpr unsigned int IA_DEBUG_REG15__iUTCL10_UTCL2IU_req_rts__SHIFT = 0x00000011;
    constexpr unsigned int IA_DEBUG_REG15__NewCycleXfer__SHIFT      = 0x00000018;
    constexpr unsigned int IA_DEBUG_REG15__qUtcL2XferCycle__SHIFT   = 0x0000000e;
    constexpr unsigned int IA_DEBUG_REG15__qXferId__SHIFT           = 0x00000015;
    constexpr unsigned int IA_DEBUG_REG15__RESERVED0__SHIFT         = 0x00000019;
    constexpr unsigned int IA_DEBUG_REG15__XferId__SHIFT            = 0x00000012;
    constexpr unsigned int IA_DEBUG_REG16__busy__SHIFT              = 0x0000000d;
    constexpr unsigned int IA_DEBUG_REG16__CLIENT_UTCL1_req0_ready__SHIFT = 0x0000001e;
    constexpr unsigned int IA_DEBUG_REG16__CLIENT_UTCL1_req0_valid__SHIFT = 0x0000001f;
    constexpr unsigned int IA_DEBUG_REG16__cpf_ia_invreq_clean_out__SHIFT = 0x00000012;
    constexpr unsigned int IA_DEBUG_REG16__cpf_ia_invreq_flushtype_in__SHIFT = 0x00000013;
    constexpr unsigned int IA_DEBUG_REG16__cpf_ia_invreq_start_in__SHIFT = 0x00000014;
    constexpr unsigned int IA_DEBUG_REG16__IA_UTCL2_inv_ack__SHIFT  = 0x00000015;
    constexpr unsigned int IA_DEBUG_REG16__IA_UTCL2_req_free__SHIFT = 0x0000001a;
    constexpr unsigned int IA_DEBUG_REG16__IA_UTCL2_req_send__SHIFT = 0x0000001b;
    constexpr unsigned int IA_DEBUG_REG16__outstanding_tc_accesses_8_0__SHIFT = 0x00000000;
    constexpr unsigned int IA_DEBUG_REG16__req0_valid_hold1__SHIFT  = 0x0000000a;
    constexpr unsigned int IA_DEBUG_REG16__req0_valid_hold2__SHIFT  = 0x00000009;
    constexpr unsigned int IA_DEBUG_REG16__TC_IA_rdret_valid__SHIFT = 0x00000011;
    constexpr unsigned int IA_DEBUG_REG16__UTCL1_CLIENT_ret0_ready__SHIFT = 0x0000001c;
    constexpr unsigned int IA_DEBUG_REG16__UTCL1_CLIENT_ret0_valid__SHIFT = 0x0000001d;
    constexpr unsigned int IA_DEBUG_REG16__utcl2iu_busy__SHIFT      = 0x0000000b;
    constexpr unsigned int IA_DEBUG_REG16__UTCL2IU_UTCL1_ret_nack__SHIFT = 0x0000000e;
    constexpr unsigned int IA_DEBUG_REG16__UTCL2IU_UTCL1_ret_valid__SHIFT = 0x00000010;
    constexpr unsigned int IA_DEBUG_REG16__UTCL2_IA_inv_valid__SHIFT = 0x00000016;
    constexpr unsigned int IA_DEBUG_REG16__UTCL2_IA_ret_valid__SHIFT = 0x00000019;
    constexpr unsigned int IA_DEBUG_REG16__UTCL2_IA_ret_xnack__SHIFT = 0x00000017;
    constexpr unsigned int IA_DEBUG_REG16__utcl10_busy__SHIFT       = 0x0000000c;
    constexpr unsigned int PWR_OVERRIDE__VDDCR_CPU_OVERRIDE__SHIFT  = 0x00000000;
    constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_ADDR__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__RESERVED__SHIFT      = 0x0000000a;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeAccumDoneInt__SHIFT = 0x00000004;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeResetAccum__SHIFT = 0x00000005;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeSpmDoneInt__SHIFT = 0x00000003;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeStartSpm__SHIFT = 0x00000006;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__AutoAccumEn__SHIFT   = 0x00000001;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__AutoResetPerfmonDisable__SHIFT = 0x00000005;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__AutoSpmEn__SHIFT     = 0x00000002;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__Globals_LoadOverride__SHIFT = 0x00000003;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__RESERVED__SHIFT      = 0x00000006;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__SE0_LoadOverride__SHIFT = 0x00000004;
    constexpr unsigned int RLC_SPM_ACCUM_SAMPLES_REQUESTED__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__RESERVED__SHIFT    = 0x00000010;
    constexpr unsigned int RLC_SPM_ACCUM_THRESHOLD__RESERVED__SHIFT = 0x00000010;
    constexpr unsigned int RPB_ATS_CNTL2__INVAL_COM_ROUTING_CODE__SHIFT = 0x0000000f;
    constexpr unsigned int RPB_ATS_CNTL2__PAGE_REQ_CMD__SHIFT       = 0x00000006;
    constexpr unsigned int RPB_ATS_CNTL2__PAGE_ROUTING_CODE__SHIFT  = 0x0000000c;
    constexpr unsigned int RPB_ATS_CNTL2__TRANS_CMD__SHIFT          = 0x00000000;
    constexpr unsigned int RPB_ATS_CNTL2__VENDOR_ID__SHIFT          = 0x00000012;
    constexpr unsigned int RPB_ATS_CNTL__ATCTR_SWITCH_NUM__SHIFT    = 0x0000000f;
    constexpr unsigned int RPB_ATS_CNTL__INVAL_COM_CMD__SHIFT       = 0x00000019;
    constexpr unsigned int RPB_BIF_CNTL__ARB_MODE__SHIFT            = 0x00000010;
    constexpr unsigned int RPB_BIF_CNTL__DRAIN_VC_NUM__SHIFT        = 0x00000011;
    constexpr unsigned int RPB_BIF_CNTL__PAGE_PRI_EN__SHIFT         = 0x0000001b;
    constexpr unsigned int RPB_BIF_CNTL__PARITY_CHECK_EN__SHIFT     = 0x0000001e;
    constexpr unsigned int RPB_BIF_CNTL__SWITCH_ENABLE__SHIFT       = 0x00000012;
    constexpr unsigned int RPB_BIF_CNTL__SWITCH_THRESHOLD__SHIFT    = 0x00000013;
    constexpr unsigned int RPB_BIF_CNTL__TR_PRI_EN__SHIFT           = 0x0000001c;
    constexpr unsigned int RPB_BIF_CNTL__VC0_CHAINED_OVERRIDE__SHIFT = 0x0000001d;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATC_INV_BLOCKLEVEL__SHIFT = 0x00000006;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATC_PAGE_BLOCKLEVEL__SHIFT = 0x00000004;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATC_TR_BLOCKLEVEL__SHIFT = 0x00000002;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATOMIC_BLOCKLEVEL_OVERRIDE_EN__SHIFT = 0x00000011;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATOMIC_BLOCKLEVEL_OVERRIDE__SHIFT = 0x0000000c;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_RD_BLOCKLEVEL_OVERRIDE_EN__SHIFT = 0x00000010;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_RD_BLOCKLEVEL_OVERRIDE__SHIFT = 0x0000000a;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_WR_BLOCKLEVEL_OVERRIDE_EN__SHIFT = 0x0000000f;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_WR_BLOCKLEVEL_OVERRIDE__SHIFT = 0x00000008;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__XPB_BLOCKLEVEL_OVERRIDE_EN__SHIFT = 0x0000000e;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_PAGE_PASSPW_OVERRIDE_EN__SHIFT = 0x0000000c;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_PAGE_PASSPW_OVERRIDE__SHIFT = 0x00000003;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_RSPPASSPW_OVERRIDE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_RSPPASSPW_OVERRIDE__SHIFT = 0x00000008;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_TR_PASSPW_OVERRIDE_EN__SHIFT = 0x0000000b;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_TR_PASSPW_OVERRIDE__SHIFT = 0x00000002;
    constexpr unsigned int RPB_PASSPW_CONF__ATOMIC_PASSPW_OVERRIDE__SHIFT = 0x00000009;
    constexpr unsigned int RPB_PASSPW_CONF__ATOMIC_RSPPASSPW_OVERRIDE__SHIFT = 0x0000000a;
    constexpr unsigned int RPB_PASSPW_CONF__RDRSP_PASSPW_OVERRIDE_EN__SHIFT = 0x00000011;
    constexpr unsigned int RPB_PASSPW_CONF__RDRSP_PASSPW_OVERRIDE__SHIFT = 0x00000010;
    constexpr unsigned int RPB_PASSPW_CONF__RD_PASSPW_OVERRIDE__SHIFT = 0x00000005;
    constexpr unsigned int RPB_PASSPW_CONF__RD_RSPPASSPW_OVERRIDE__SHIFT = 0x00000007;
    constexpr unsigned int RPB_PASSPW_CONF__WRRSP_PASSPW_OVERRIDE_EN__SHIFT = 0x0000000f;
    constexpr unsigned int RPB_PASSPW_CONF__WRRSP_PASSPW_OVERRIDE__SHIFT = 0x0000000e;
    constexpr unsigned int RPB_PASSPW_CONF__WR_PASSPW_OVERRIDE__SHIFT = 0x00000004;
    constexpr unsigned int RPB_PASSPW_CONF__WR_RSPPASSPW_OVERRIDE__SHIFT = 0x00000006;
    constexpr unsigned int RPB_TAG_CONF__RPB_ATS_PR__SHIFT          = 0x00000010;
    constexpr unsigned int RPB_TAG_CONF__RPB_ATS_TR__SHIFT          = 0x00000000;
    constexpr unsigned int RPB_TAG_CONF__RPB_IO_WR__SHIFT           = 0x00000008;
    constexpr unsigned int SQ_CONFIG__UNUSED__SHIFT                 = 0x00000000;
    constexpr unsigned int VGT_DEBUG_REG0__frmt_pg_busy__SHIFT      = 0x00000012;
    constexpr unsigned int VGT_DEBUG_REG0__RESERVED0__SHIFT         = 0x00000001;
    constexpr unsigned int VGT_DEBUG_REG0__RESERVED1__SHIFT         = 0x00000003;
    constexpr unsigned int VGT_DEBUG_REG0__RESERVED2__SHIFT         = 0x00000014;
    constexpr unsigned int VGT_DEBUG_REG0__RESERVED3__SHIFT         = 0x0000001f;
    constexpr unsigned int VGT_DEBUG_REG0__sclk_tell_vid__SHIFT     = 0x0000001c;
    constexpr unsigned int VGT_DEBUG_REG0__tell_clk_busy__SHIFT     = 0x00000019;
    constexpr unsigned int VGT_DEBUG_REG1__RESERVED0__SHIFT         = 0x00000000;
    constexpr unsigned int VGT_DEBUG_REG1__RESERVED1__SHIFT         = 0x0000000e;
    constexpr unsigned int VGT_DEBUG_REG1__RESERVED2__SHIFT         = 0x00000011;
    constexpr unsigned int VGT_DEBUG_REG1__RESERVED3__SHIFT         = 0x00000013;
    constexpr unsigned int VGT_DEBUG_REG1__RESERVED4__SHIFT         = 0x00000015;
    constexpr unsigned int VGT_DEBUG_REG1__RESERVED5__SHIFT         = 0x00000017;
    constexpr unsigned int VGT_DEBUG_REG1__RESERVED6__SHIFT         = 0x00000019;
    constexpr unsigned int VGT_DEBUG_REG2__grpModBusy_q__SHIFT      = 0x00000007;
    constexpr unsigned int VGT_DEBUG_REG2__hsTgFifoEmpty__SHIFT     = 0x0000000b;
    constexpr unsigned int VGT_DEBUG_REG2__hsTgFifoFull__SHIFT      = 0x00000011;
    constexpr unsigned int VGT_DEBUG_REG2__hs_busy_q__SHIFT         = 0x00000000;
    constexpr unsigned int VGT_DEBUG_REG2__hs_noif_busy_q__SHIFT    = 0x00000001;
    constexpr unsigned int VGT_DEBUG_REG2__int_VGT_WD_packet_send_q__SHIFT = 0x00000006;
    constexpr unsigned int VGT_DEBUG_REG2__lsVertIfBusy_0_q__SHIFT  = 0x00000003;
    constexpr unsigned int VGT_DEBUG_REG2__not_VGT_WD_thdgrp_rtr__SHIFT = 0x00000013;
    constexpr unsigned int VGT_DEBUG_REG2__RESERVED0__SHIFT         = 0x00000004;
    constexpr unsigned int VGT_DEBUG_REG2__RESERVED1__SHIFT         = 0x00000009;
    constexpr unsigned int VGT_DEBUG_REG2__RESERVED2__SHIFT         = 0x0000000d;
    constexpr unsigned int VGT_DEBUG_REG2__RESERVED3__SHIFT         = 0x0000000f;
    constexpr unsigned int VGT_DEBUG_REG2__RESERVED4__SHIFT         = 0x0000001b;
    constexpr unsigned int VGT_DEBUG_REG2__tfmmIsBusy_q__SHIFT      = 0x00000002;
    constexpr unsigned int VGT_DEBUG_REG4__hsTgSendFlush__SHIFT     = 0x0000001d;
    constexpr unsigned int VGT_DEBUG_REG4__RESERVED0__SHIFT         = 0x0000001f;
    constexpr unsigned int VGT_DEBUG_REG5__hsTgCreditCnt_0__SHIFT   = 0x00000003;
    constexpr unsigned int VGT_DEBUG_REG5__RESERVED0__SHIFT         = 0x00000000;
    constexpr unsigned int VGT_DEBUG_REG5__RESERVED1__SHIFT         = 0x00000008;
    constexpr unsigned int VGT_DEBUG_REG5__RESERVED2__SHIFT         = 0x00000010;
    constexpr unsigned int VGT_DEBUG_REG5__RESERVED3__SHIFT         = 0x00000013;
    constexpr unsigned int VGT_DEBUG_REG5__RESERVED4__SHIFT         = 0x00000018;
    constexpr unsigned int VGT_DEBUG_REG7__RESERVED0__SHIFT         = 0x00000005;
    constexpr unsigned int VGT_DEBUG_REG9__RESERVED0__SHIFT         = 0x00000007;
    constexpr unsigned int VGT_DEBUG_REG9__RESERVED1__SHIFT         = 0x00000017;
    constexpr unsigned int VGT_DEBUG_REG9__RESERVED2__SHIFT         = 0x00000019;
    constexpr unsigned int VGT_DEBUG_REG9__RESERVED3__SHIFT         = 0x0000001e;
    constexpr unsigned int VGT_DEBUG_REG9__RESERVED4__SHIFT         = 0x0000001f;
    constexpr unsigned int VGT_DEBUG_REG10__num_es_waves_r3__SHIFT  = 0x00000019;
    constexpr unsigned int VGT_DEBUG_REG10__num_gs_waves_r3__SHIFT  = 0x00000017;
    constexpr unsigned int VGT_DEBUG_REG10__RESERVED0__SHIFT        = 0x00000009;
    constexpr unsigned int VGT_DEBUG_REG10__RESERVED1__SHIFT        = 0x0000001c;
    constexpr unsigned int VGT_DEBUG_REG11__RESERVED0__SHIFT        = 0x00000003;
    constexpr unsigned int VGT_DEBUG_REG11__RESERVED1__SHIFT        = 0x00000005;
    constexpr unsigned int VGT_DEBUG_REG11__RESERVED2__SHIFT        = 0x00000007;
    constexpr unsigned int VGT_DEBUG_REG11__RESERVED3__SHIFT        = 0x0000000f;
    constexpr unsigned int VGT_DEBUG_REG11__RESERVED4__SHIFT        = 0x00000012;
    constexpr unsigned int VGT_DEBUG_REG11__RESERVED5__SHIFT        = 0x00000014;
    constexpr unsigned int VGT_DEBUG_REG11__RESERVED6__SHIFT        = 0x00000018;
    constexpr unsigned int VGT_DEBUG_REG11__RESERVED7__SHIFT        = 0x0000001b;
    constexpr unsigned int VGT_DEBUG_REG11__RESERVED8__SHIFT        = 0x0000001e;
    constexpr unsigned int VGT_DEBUG_REG11__VGT_SPI_gssubgrp_rtr__SHIFT = 0x0000000e;
    constexpr unsigned int VGT_DEBUG_REG12__RESERVED0__SHIFT        = 0x0000001e;
    constexpr unsigned int VGT_DEBUG_REG12__RESERVED1__SHIFT        = 0x0000001f;
    constexpr unsigned int VGT_DEBUG_REG13__RESERVED0__SHIFT        = 0x00000018;
    constexpr unsigned int VGT_DEBUG_REG13__RESERVED1__SHIFT        = 0x00000019;
    constexpr unsigned int VGT_DEBUG_REG13__RESERVED2__SHIFT        = 0x0000001a;
    constexpr unsigned int VGT_DEBUG_REG14__RESERVED0__SHIFT        = 0x00000000;
    constexpr unsigned int VGT_DEBUG_REG14__RESERVED1__SHIFT        = 0x00000006;
    constexpr unsigned int VGT_DEBUG_REG14__RESERVED2__SHIFT        = 0x0000000a;
    constexpr unsigned int VGT_DEBUG_REG14__RESERVED3__SHIFT        = 0x0000000c;
    constexpr unsigned int VGT_DEBUG_REG15__active_sm_q_4_0__SHIFT  = 0x00000005;
    constexpr unsigned int VGT_DEBUG_REG15__cntr_tbl_wrptr_q_4_0__SHIFT = 0x0000000f;
    constexpr unsigned int VGT_DEBUG_REG15__entry_rdptr_q_4_0__SHIFT = 0x0000000a;
    constexpr unsigned int VGT_DEBUG_REG15__RESERVED0__SHIFT        = 0x00000014;
    constexpr unsigned int VGT_DEBUG_REG15__RESERVED1__SHIFT        = 0x0000001d;
    constexpr unsigned int VGT_DEBUG_REG16__RESERVED0__SHIFT        = 0x00000017;
    constexpr unsigned int VGT_DEBUG_REG23__frmt_pg_busy__SHIFT     = 0x00000018;
    constexpr unsigned int VGT_DEBUG_REG23__RESERVED__SHIFT         = 0x00000019;
    constexpr unsigned int VGT_DEBUG_REG30__eopg_p2__SHIFT          = 0x0000001b;
    constexpr unsigned int VGT_DEBUG_REG30__eop_p1_q__SHIFT         = 0x0000001c;
    constexpr unsigned int VGT_DEBUG_REG30__esvert_fifo_full__SHIFT = 0x00000016;
    constexpr unsigned int VGT_DEBUG_REG30__eswave_fifo_full__SHIFT = 0x00000019;
    constexpr unsigned int VGT_DEBUG_REG30__event_flag_p1_q__SHIFT  = 0x0000001d;
    constexpr unsigned int VGT_DEBUG_REG30__gsinvoc_fifo_full__SHIFT = 0x0000001a;
    constexpr unsigned int VGT_DEBUG_REG30__gsprim_fifo_full__SHIFT = 0x00000017;
    constexpr unsigned int VGT_DEBUG_REG30__gswave_fifo_full__SHIFT = 0x00000018;
    constexpr unsigned int VGT_DEBUG_REG30__non_pg_perfcounter_start__SHIFT = 0x00000013;
    constexpr unsigned int VGT_DEBUG_REG30__non_pg_perfcounter_stop__SHIFT = 0x00000014;
    constexpr unsigned int VGT_DEBUG_REG30__ordered_id_mode_p1_q__SHIFT = 0x0000001e;
    constexpr unsigned int VGT_DEBUG_REG30__te_vert_fifo_re__SHIFT  = 0x0000001f;
    constexpr unsigned int VGT_DEBUG_REG32__su_output_fifo_empty__SHIFT = 0x0000001e;
    constexpr unsigned int VGT_DEBUG_REG32__su_output_fifo_full__SHIFT = 0x0000001f;
    constexpr unsigned int VGT_DEBUG_REG35__RESERVED0__SHIFT        = 0x00000000;
    constexpr unsigned int WD_DEBUG_REG0__RESERVED0__SHIFT          = 0x00000010;
    constexpr unsigned int WD_DEBUG_REG1__reg_xfer_valid__SHIFT     = 0x00000008;
    constexpr unsigned int WD_DEBUG_REG2__p1_grbm_fifo_rdata_reg_id_4_0__SHIFT = 0x0000000c;
    constexpr unsigned int WD_DEBUG_REG2__p1_grbm_fifo_rdata_state_2_0__SHIFT = 0x00000011;
    constexpr unsigned int WD_DEBUG_REG2__p1_reg_xfer_valid__SHIFT  = 0x00000008;
    constexpr unsigned int WD_DEBUG_REG3__RESERVED0__SHIFT          = 0x00000001;
    constexpr unsigned int WD_DEBUG_REG3__RESERVED1__SHIFT          = 0x0000000b;
    constexpr unsigned int WD_DEBUG_REG3__RESERVED2__SHIFT          = 0x00000017;
    constexpr unsigned int WD_DEBUG_REG5__RESERVED0__SHIFT          = 0x00000001;
    constexpr unsigned int WD_DEBUG_REG5__RESERVED1__SHIFT          = 0x0000000b;
    constexpr unsigned int WD_DEBUG_REG5__RESERVED2__SHIFT          = 0x00000017;
    constexpr unsigned int WD_DEBUG_REG7__SE2VGT_WD_thdgrp_send_in__SHIFT = 0x00000008;
    constexpr unsigned int WD_DEBUG_REG7__se2_thdgrp_eop__SHIFT     = 0x00000019;
    constexpr unsigned int WD_DEBUG_REG7__se2_thdgrp_is_event__SHIFT = 0x00000018;
    constexpr unsigned int WD_DEBUG_REG7__SE3VGT_WD_thdgrp_send_in__SHIFT = 0x0000000c;
    constexpr unsigned int WD_DEBUG_REG7__se3_thdgrp_eop__SHIFT     = 0x0000001b;
    constexpr unsigned int WD_DEBUG_REG7__se3_thdgrp_is_event__SHIFT = 0x0000001a;
    constexpr unsigned int WD_DEBUG_REG7__wd_arb_se2_input_fifo_empty__SHIFT = 0x0000000a;
    constexpr unsigned int WD_DEBUG_REG7__wd_arb_se2_input_fifo_full__SHIFT = 0x0000000b;
    constexpr unsigned int WD_DEBUG_REG7__wd_arb_se2_input_fifo_re__SHIFT = 0x00000009;
    constexpr unsigned int WD_DEBUG_REG7__wd_arb_se3_input_fifo_empty__SHIFT = 0x0000000e;
    constexpr unsigned int WD_DEBUG_REG7__wd_arb_se3_input_fifo_full__SHIFT = 0x0000000f;
    constexpr unsigned int WD_DEBUG_REG7__wd_arb_se3_input_fifo_re__SHIFT = 0x0000000d;
    constexpr unsigned int WD_DEBUG_REG9__event_flag_p0_q_or_null_flags_p0_q__SHIFT = 0x00000003;
    constexpr unsigned int WD_DEBUG_REG9__RESERVED0__SHIFT          = 0x0000000b;
    constexpr unsigned int WD_DEBUG_REG9__RESERVED1__SHIFT          = 0x00000018;
    constexpr unsigned int WD_DEBUG_REG9__RESERVED2__SHIFT          = 0x0000001b;
    constexpr unsigned int WD_DEBUG_REG9__RESERVED3__SHIFT          = 0x0000001c;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_fragment_size__SHIFT = 0x00000010;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_io_steer__SHIFT = 0x0000000f;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_memlog__SHIFT = 0x0000000b;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_mtype__SHIFT = 0x00000009;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_nack__SHIFT = 0x00000007;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_no_pte__SHIFT = 0x0000000c;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_perms_granted__SHIFT = 0x00000016;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_perms_requested__SHIFT = 0x00000019;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_physical_address_1_0__SHIFT = 0x0000001e;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_pte_tmz__SHIFT = 0x0000000d;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_snoop__SHIFT = 0x0000001c;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_spa__SHIFT = 0x0000000e;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_tag__SHIFT = 0x00000000;
    constexpr unsigned int WD_DEBUG_REG14__iUTCL2_WD_ret_valid__SHIFT = 0x0000001d;
    constexpr unsigned int WD_DEBUG_REG15__iUTCL2_WD_ret_physical_address_33_2__SHIFT = 0x00000000;
    constexpr unsigned int WD_DEBUG_REG16__iUTCL2_WD_ret_physical_address_35_34__SHIFT = 0x00000000;
    constexpr unsigned int WD_DEBUG_REG16__qUtcL2XferCycle__SHIFT   = 0x00000014;
    constexpr unsigned int WD_DEBUG_REG16__qWD_UTCL2_req_free__SHIFT = 0x00000012;
    constexpr unsigned int WD_DEBUG_REG16__RESERVED0__SHIFT         = 0x00000015;
    constexpr unsigned int WD_DEBUG_REG16__WD_UTCL2_req_data__SHIFT = 0x00000002;
    constexpr unsigned int WD_DEBUG_REG16__WD_UTCL2_req_send__SHIFT = 0x00000013;
    constexpr unsigned int WD_DEBUG_REG17__iUTCL10_UTCL2IU_req_rts__SHIFT = 0x00000011;
    constexpr unsigned int WD_DEBUG_REG17__iUTCL11_UTCL2IU_req_rts__SHIFT = 0x00000012;
    constexpr unsigned int WD_DEBUG_REG17__NewCycleXfer__SHIFT      = 0x00000018;
    constexpr unsigned int WD_DEBUG_REG17__qUtcL2XferCycle__SHIFT   = 0x0000000e;
    constexpr unsigned int WD_DEBUG_REG17__qXferId__SHIFT           = 0x00000015;
    constexpr unsigned int WD_DEBUG_REG17__RESERVED0__SHIFT         = 0x00000019;
    constexpr unsigned int WD_DEBUG_REG17__WDUtcL2Cnt__SHIFT        = 0x00000002;
    constexpr unsigned int WD_DEBUG_REG17__WDUtcL2iuPostArbFifo_Empty__SHIFT = 0x00000000;
    constexpr unsigned int WD_DEBUG_REG17__WDUtcL2iuPostArbFifo_Full__SHIFT = 0x00000001;
    constexpr unsigned int WD_DEBUG_REG17__WDUtcL2OutCnt__SHIFT     = 0x00000008;
    constexpr unsigned int WD_DEBUG_REG17__XferId__SHIFT            = 0x00000013;
    constexpr unsigned int WD_DEBUG_REG18__busy__SHIFT              = 0x00000009;
    constexpr unsigned int WD_DEBUG_REG18__CLIENT_UTCL1_req0_ready__SHIFT = 0x0000001e;
    constexpr unsigned int WD_DEBUG_REG18__CLIENT_UTCL1_req0_valid__SHIFT = 0x0000001f;
    constexpr unsigned int WD_DEBUG_REG18__CLIENT_UTCL1_req1_ready__SHIFT = 0x0000001a;
    constexpr unsigned int WD_DEBUG_REG18__CLIENT_UTCL1_req1_valid__SHIFT = 0x0000001b;
    constexpr unsigned int WD_DEBUG_REG18__cpf_wd_invreq_clean_out__SHIFT = 0x0000000e;
    constexpr unsigned int WD_DEBUG_REG18__cpf_wd_invreq_flushtype_in__SHIFT = 0x0000000f;
    constexpr unsigned int WD_DEBUG_REG18__cpf_wd_invreq_start_in__SHIFT = 0x00000010;
    constexpr unsigned int WD_DEBUG_REG18__outstanding_tc_accesses_2_0__SHIFT = 0x00000000;
    constexpr unsigned int WD_DEBUG_REG18__TC_WD_ret_valid__SHIFT   = 0x0000000d;
    constexpr unsigned int WD_DEBUG_REG18__UTCL1_CLIENT_ret0_ready__SHIFT = 0x0000001c;
    constexpr unsigned int WD_DEBUG_REG18__UTCL1_CLIENT_ret0_valid__SHIFT = 0x0000001d;
    constexpr unsigned int WD_DEBUG_REG18__UTCL1_CLIENT_ret1_ready__SHIFT = 0x00000018;
    constexpr unsigned int WD_DEBUG_REG18__UTCL1_CLIENT_ret1_valid__SHIFT = 0x00000019;
    constexpr unsigned int WD_DEBUG_REG18__utcl2iu_busy__SHIFT      = 0x00000003;
    constexpr unsigned int WD_DEBUG_REG18__UTCL2IU_UTCL1_ret_nack__SHIFT = 0x0000000a;
    constexpr unsigned int WD_DEBUG_REG18__UTCL2IU_UTCL1_ret_valid__SHIFT = 0x0000000c;
    constexpr unsigned int WD_DEBUG_REG18__UTCL2_WD_inv_valid__SHIFT = 0x00000012;
    constexpr unsigned int WD_DEBUG_REG18__UTCL2_WD_ret_valid__SHIFT = 0x00000015;
    constexpr unsigned int WD_DEBUG_REG18__UTCL2_WD_ret_xnack__SHIFT = 0x00000013;
    constexpr unsigned int WD_DEBUG_REG18__utcl10_se0_busy__SHIFT   = 0x00000008;
    constexpr unsigned int WD_DEBUG_REG18__utcl10_se1_busy__SHIFT   = 0x00000007;
    constexpr unsigned int WD_DEBUG_REG18__utcl10_se2_busy__SHIFT   = 0x00000006;
    constexpr unsigned int WD_DEBUG_REG18__utcl10_se3_busy__SHIFT   = 0x00000005;
    constexpr unsigned int WD_DEBUG_REG18__utcl11_busy__SHIFT       = 0x00000004;
    constexpr unsigned int WD_DEBUG_REG18__WD_UTCL2_inv_ack__SHIFT  = 0x00000011;
    constexpr unsigned int WD_DEBUG_REG18__WD_UTCL2_req_free__SHIFT = 0x00000016;
    constexpr unsigned int WD_DEBUG_REG18__WD_UTCL2_req_send__SHIFT = 0x00000017;
    constexpr unsigned int WD_DEBUG_REG19__dispatch_draw_mode_p4__SHIFT = 0x0000001d;
    constexpr unsigned int WD_DEBUG_REG19__dma_dummy_req_p3_q__SHIFT = 0x0000001c;
    constexpr unsigned int WD_DEBUG_REG19__dma_issue_p2__SHIFT      = 0x0000001f;
    constexpr unsigned int WD_DEBUG_REG19__dma_out_of_range_p3_q__SHIFT = 0x0000001e;
    constexpr unsigned int WD_DEBUG_REG19__dma_primgroup_size__SHIFT = 0x00000000;
    constexpr unsigned int WD_DEBUG_REG19__dma_wd_switch_on_eop__SHIFT = 0x00000014;
    constexpr unsigned int WD_DEBUG_REG19__RESERVED0__SHIFT         = 0x00000010;
    constexpr unsigned int WD_DEBUG_REG19__RESERVED1__SHIFT         = 0x00000015;
    constexpr unsigned int WD_DEBUG_REG20__reg_state_or_event_data_p2_15_0__SHIFT = 0x00000000;
    constexpr unsigned int WD_DEBUG_REG20__reg_state_or_event_data_p2_16__SHIFT = 0x00000010;
    constexpr unsigned int WD_DEBUG_REG20__reg_state_or_event_data_p2_17__SHIFT = 0x00000011;
    constexpr unsigned int WD_DEBUG_REG20__reg_state_or_event_data_p2_18__SHIFT = 0x00000012;
    constexpr unsigned int WD_DEBUG_REG20__reg_state_or_event_data_p2_19__SHIFT = 0x00000013;
    constexpr unsigned int WD_DEBUG_REG20__reg_state_or_event_data_p2_20__SHIFT = 0x00000014;
    constexpr unsigned int WD_DEBUG_REG20__reg_state_or_event_data_p2_21__SHIFT = 0x00000015;
    constexpr unsigned int WD_DEBUG_REG20__reg_state_or_event_data_p2_22__SHIFT = 0x00000016;
    constexpr unsigned int WD_DEBUG_REG20__reg_state_or_event_data_p2_23__SHIFT = 0x00000017;
    constexpr unsigned int WD_DEBUG_REG20__reg_state_or_event_data_p2_31_24__SHIFT = 0x00000018;
    constexpr unsigned int WD_DEBUG_REG21__hp_dispatch_draw_mode_p4__SHIFT = 0x0000001d;
    constexpr unsigned int WD_DEBUG_REG21__hp_dma_dummy_req_p3_q__SHIFT = 0x0000001c;
    constexpr unsigned int WD_DEBUG_REG21__hp_dma_issue_p2__SHIFT   = 0x0000001f;
    constexpr unsigned int WD_DEBUG_REG21__hp_dma_out_of_range_p3_q__SHIFT = 0x0000001e;
    constexpr unsigned int WD_DEBUG_REG21__hp_dma_primgroup_size__SHIFT = 0x00000000;
    constexpr unsigned int WD_DEBUG_REG21__hp_dma_wd_switch_on_eop__SHIFT = 0x00000014;
    constexpr unsigned int WD_DEBUG_REG21__RESERVED0__SHIFT         = 0x00000010;
    constexpr unsigned int WD_DEBUG_REG21__RESERVED1__SHIFT         = 0x00000015;
} // namespace Rv2x

namespace Vega
{
    constexpr unsigned int GC_CAC_ACC_BCI1__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU3__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU4__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
    constexpr unsigned int GC_CAC_OVRD_BCI__OVRRD_VALUE__SHIFT      = 0x00000002;
    constexpr unsigned int GC_CAC_WEIGHT_BCI_0__WEIGHT_BCI_SIG1__SHIFT = 0x00000010;
    constexpr unsigned int IA_DEBUG_REG0__SPARE0__SHIFT             = 0x00000004;
    constexpr unsigned int IA_DEBUG_REG0__SPARE1__SHIFT             = 0x00000009;
    constexpr unsigned int IA_DEBUG_REG0__SPARE2__SHIFT             = 0x0000000e;
    constexpr unsigned int IA_DEBUG_REG0__SPARE3__SHIFT             = 0x0000001a;
    constexpr unsigned int IA_DEBUG_REG0__SPARE4__SHIFT             = 0x0000001b;
    constexpr unsigned int IA_DEBUG_REG0__SPARE5__SHIFT             = 0x0000001e;
    constexpr unsigned int IA_DEBUG_REG9__SPARE0__SHIFT             = 0x0000000e;
    constexpr unsigned int IA_DEBUG_REG9__SPARE1__SHIFT             = 0x0000000f;
    constexpr unsigned int RLC_SPM_PERFMON_CNTL__RESERVED1__SHIFT   = 0x00000000;
    constexpr unsigned int RMI_CLOCK_CNTRL__DYN_CLK_RB1_BUSY_MASK__SHIFT = 0x00000014;
    constexpr unsigned int RMI_CLOCK_CNTRL__DYN_CLK_RB1_WAKEUP_MASK__SHIFT = 0x00000019;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_BREAK_LOB_ON_IDLEIN__SHIFT = 0x00000011;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_MODE__SHIFT   = 0x0000001e;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_STALL_TIMER_OVERRIDE__SHIFT = 0x00000014;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_STALL_TIMER_START_VALUE__SHIFT = 0x00000016;
    constexpr unsigned int RMI_DEMUX_CNTL__DEMUX_ARB1_STALL__SHIFT  = 0x00000010;
    constexpr unsigned int RMI_GENERAL_CNTL1__TCIW1_64B_RD_STALL_MODE__SHIFT = 0x00000006;
    constexpr unsigned int RMI_GENERAL_CNTL1__UTCL1_PROBE1_RR_ARB_BURST_HINT_EN__SHIFT = 0x0000000c;
    constexpr unsigned int RMI_GENERAL_CNTL__RB1_HARVEST_EN__SHIFT  = 0x00000014;
    constexpr unsigned int RMI_GENERAL_CNTL__SKID_FIFO_1_OVERFLOW_ERROR_MASK__SHIFT = 0x0000001c;
    constexpr unsigned int RMI_GENERAL_CNTL__SKID_FIFO_1_UNDERFLOW_ERROR_MASK__SHIFT = 0x0000001d;
    constexpr unsigned int RMI_GENERAL_STATUS__RDREQ_CONSUMER_FIFO_1_BUSY__SHIFT = 0x00000011;
    constexpr unsigned int RMI_GENERAL_STATUS__SKID_FIFO_1_OVERFLOW_ERROR__SHIFT = 0x00000003;
    constexpr unsigned int RMI_GENERAL_STATUS__SKID_FIFO_1_UNDERFLOW_ERROR__SHIFT = 0x00000004;
    constexpr unsigned int RMI_GENERAL_STATUS__TCIW1_PRT_FIFO_BUSY__SHIFT = 0x0000000d;
    constexpr unsigned int RMI_GENERAL_STATUS__TCIW_FRMTR1_BUSY__SHIFT = 0x0000000e;
    constexpr unsigned int RMI_GENERAL_STATUS__TCIW_RTN_FRMTR1_BUSY__SHIFT = 0x0000000f;
    constexpr unsigned int RMI_GENERAL_STATUS__UTC_PROBE1_BUSY__SHIFT = 0x00000012;
    constexpr unsigned int RMI_GENERAL_STATUS__WRREQ_CONSUMER_FIFO_1_BUSY__SHIFT = 0x00000010;
    constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_EVENT_WINDOW_MASK1__SHIFT = 0x00000008;
    constexpr unsigned int RMI_PROBE_POP_LOGIC_CNTL__EXT_LAT_FIFO_1_MAX_DEPTH__SHIFT = 0x0000000a;
    constexpr unsigned int RMI_PROBE_POP_LOGIC_CNTL__XLAT_COMBINE1_DIS__SHIFT = 0x00000011;
    constexpr unsigned int RMI_SCOREBOARD_CNTL__COMPLETE_RB1_FLUSH__SHIFT = 0x00000002;
    constexpr unsigned int RMI_SCOREBOARD_CNTL__REQ_IN_RE_EN_AFTER_FLUSH_RB1__SHIFT = 0x00000003;
    constexpr unsigned int RMI_SCOREBOARD_CNTL__TIME_STAMP_FLUSH_RB1__SHIFT = 0x00000004;
    constexpr unsigned int RMI_SCOREBOARD_STATUS1__COM_FLUSH_IN_PROG_RB1__SHIFT = 0x0000001d;
    constexpr unsigned int RMI_SCOREBOARD_STATUS1__RUNNING_CNT_OVERFLOW_RB1__SHIFT = 0x0000001c;
    constexpr unsigned int RMI_SCOREBOARD_STATUS1__RUNNING_CNT_RB1__SHIFT = 0x0000000f;
    constexpr unsigned int RMI_SCOREBOARD_STATUS1__RUNNING_CNT_UNDERFLOW_RB1__SHIFT = 0x0000001b;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__COM_FLUSH_DONE_RB1__SHIFT = 0x0000001a;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__SNAPSHOT_CNT_RB1__SHIFT = 0x0000000d;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__SNAPSHOT_CNT_UNDERFLOW_RB1__SHIFT = 0x00000019;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__TIME_STAMP_FLUSH_DONE_RB1__SHIFT = 0x0000001f;
    constexpr unsigned int RMI_SCOREBOARD_STATUS2__TIME_STAMP_FLUSH_IN_PROG_RB1__SHIFT = 0x0000001d;
    constexpr unsigned int RMI_SUBBLOCK_STATUS0__UTC_EXT_LAT_HID_FIFO_EMPTY_PROBE1__SHIFT = 0x00000011;
    constexpr unsigned int RMI_SUBBLOCK_STATUS0__UTC_EXT_LAT_HID_FIFO_FULL_PROBE1__SHIFT = 0x00000010;
    constexpr unsigned int RMI_SUBBLOCK_STATUS0__UTC_EXT_LAT_HID_FIFO_NUM_USED_PROBE1__SHIFT = 0x00000009;
    constexpr unsigned int RMI_SUBBLOCK_STATUS1__SKID_FIFO_1_FREE_SPACE__SHIFT = 0x0000000a;
    constexpr unsigned int RMI_SUBBLOCK_STATUS1__TCIW1_INFLIGHT_CNT__SHIFT = 0x00000014;
    constexpr unsigned int RMI_SUBBLOCK_STATUS2__PRT_FIFO_1_NUM_USED__SHIFT = 0x00000009;
    constexpr unsigned int RMI_SUBBLOCK_STATUS3__SKID_FIFO_1_FREE_SPACE_TOTAL__SHIFT = 0x0000000a;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__ALL_FAULT_RET1_DATA__SHIFT = 0x0000001f;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__RMI_IN1_REORDER_DIS__SHIFT = 0x0000001d;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__SKID_FIFO_1_FREE_SPACE_DELTA_UPDATE__SHIFT = 0x0000001b;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__SKID_FIFO_1_FREE_SPACE_DELTA__SHIFT = 0x00000013;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__TCIW1_MAX_ALLOWED_INFLIGHT_REQ__SHIFT = 0x00000009;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__TCIW1_REQ_SAFE_MODE__SHIFT = 0x0000001c;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__WR_COMBINE1_DIS_AT_LAST_OF_BURST__SHIFT = 0x0000001e;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__WR_COMBINE1_DIS_OVERRIDE__SHIFT = 0x00000000;
    constexpr unsigned int RMI_TCIW_FORMATTER1_CNTL__WR_COMBINE1_TIME_OUT_WINDOW__SHIFT = 0x00000001;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG_1__XBAR_ARB_ROUND_ROBIN_WEIGHT_RB1_RD__SHIFT = 0x00000010;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG_1__XBAR_ARB_ROUND_ROBIN_WEIGHT_RB1_WR__SHIFT = 0x00000018;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_BREAK_LOB_ON_IDLEIN__SHIFT = 0x00000014;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_BREAK_LOB_ON_WEIGHTEDRR__SHIFT = 0x00000012;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_MODE__SHIFT = 0x00000010;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_STALL_TIMER_OVERRIDE__SHIFT = 0x00000016;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_STALL_TIMER_START_VALUE__SHIFT = 0x00000018;
    constexpr unsigned int RMI_XBAR_ARBITER_CONFIG__XBAR_ARB1_STALL__SHIFT = 0x00000013;
    constexpr unsigned int RMI_XBAR_CONFIG__XBAR_EN_IN_RB1__SHIFT   = 0x0000000e;
    constexpr unsigned int RPB_ATS_CNTL2__INVAL_COM_ROUTING_CODE__SHIFT = 0x0000000f;
    constexpr unsigned int RPB_ATS_CNTL2__PAGE_REQ_CMD__SHIFT       = 0x00000006;
    constexpr unsigned int RPB_ATS_CNTL2__PAGE_ROUTING_CODE__SHIFT  = 0x0000000c;
    constexpr unsigned int RPB_ATS_CNTL2__TRANS_CMD__SHIFT          = 0x00000000;
    constexpr unsigned int RPB_ATS_CNTL2__VENDOR_ID__SHIFT          = 0x00000012;
    constexpr unsigned int RPB_ATS_CNTL__ATCTR_SWITCH_NUM__SHIFT    = 0x0000000f;
    constexpr unsigned int RPB_ATS_CNTL__INVAL_COM_CMD__SHIFT       = 0x00000019;
    constexpr unsigned int RPB_BIF_CNTL__ARB_MODE__SHIFT            = 0x00000010;
    constexpr unsigned int RPB_BIF_CNTL__DRAIN_VC_NUM__SHIFT        = 0x00000011;
    constexpr unsigned int RPB_BIF_CNTL__PAGE_PRI_EN__SHIFT         = 0x0000001b;
    constexpr unsigned int RPB_BIF_CNTL__PARITY_CHECK_EN__SHIFT     = 0x0000001e;
    constexpr unsigned int RPB_BIF_CNTL__SWITCH_ENABLE__SHIFT       = 0x00000012;
    constexpr unsigned int RPB_BIF_CNTL__SWITCH_THRESHOLD__SHIFT    = 0x00000013;
    constexpr unsigned int RPB_BIF_CNTL__TR_PRI_EN__SHIFT           = 0x0000001c;
    constexpr unsigned int RPB_BIF_CNTL__VC0_CHAINED_OVERRIDE__SHIFT = 0x0000001d;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATC_INV_BLOCKLEVEL__SHIFT = 0x00000006;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATC_PAGE_BLOCKLEVEL__SHIFT = 0x00000004;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATC_TR_BLOCKLEVEL__SHIFT = 0x00000002;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATOMIC_BLOCKLEVEL_OVERRIDE_EN__SHIFT = 0x00000011;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__ATOMIC_BLOCKLEVEL_OVERRIDE__SHIFT = 0x0000000c;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_RD_BLOCKLEVEL_OVERRIDE_EN__SHIFT = 0x00000010;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_RD_BLOCKLEVEL_OVERRIDE__SHIFT = 0x0000000a;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_WR_BLOCKLEVEL_OVERRIDE_EN__SHIFT = 0x0000000f;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__IO_WR_BLOCKLEVEL_OVERRIDE__SHIFT = 0x00000008;
    constexpr unsigned int RPB_BLOCKLEVEL_CONF__XPB_BLOCKLEVEL_OVERRIDE_EN__SHIFT = 0x0000000e;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_PAGE_PASSPW_OVERRIDE_EN__SHIFT = 0x0000000c;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_PAGE_PASSPW_OVERRIDE__SHIFT = 0x00000003;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_RSPPASSPW_OVERRIDE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_RSPPASSPW_OVERRIDE__SHIFT = 0x00000008;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_TR_PASSPW_OVERRIDE_EN__SHIFT = 0x0000000b;
    constexpr unsigned int RPB_PASSPW_CONF__ATC_TR_PASSPW_OVERRIDE__SHIFT = 0x00000002;
    constexpr unsigned int RPB_PASSPW_CONF__ATOMIC_PASSPW_OVERRIDE__SHIFT = 0x00000009;
    constexpr unsigned int RPB_PASSPW_CONF__ATOMIC_RSPPASSPW_OVERRIDE__SHIFT = 0x0000000a;
    constexpr unsigned int RPB_PASSPW_CONF__RDRSP_PASSPW_OVERRIDE_EN__SHIFT = 0x00000011;
    constexpr unsigned int RPB_PASSPW_CONF__RDRSP_PASSPW_OVERRIDE__SHIFT = 0x00000010;
    constexpr unsigned int RPB_PASSPW_CONF__RD_PASSPW_OVERRIDE__SHIFT = 0x00000005;
    constexpr unsigned int RPB_PASSPW_CONF__RD_RSPPASSPW_OVERRIDE__SHIFT = 0x00000007;
    constexpr unsigned int RPB_PASSPW_CONF__WRRSP_PASSPW_OVERRIDE_EN__SHIFT = 0x0000000f;
    constexpr unsigned int RPB_PASSPW_CONF__WRRSP_PASSPW_OVERRIDE__SHIFT = 0x0000000e;
    constexpr unsigned int RPB_PASSPW_CONF__WR_PASSPW_OVERRIDE__SHIFT = 0x00000004;
    constexpr unsigned int RPB_PASSPW_CONF__WR_RSPPASSPW_OVERRIDE__SHIFT = 0x00000006;
    constexpr unsigned int RPB_TAG_CONF__RPB_ATS_TR__SHIFT          = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER0_RESULT__PERF_COUNT__SHIFT = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER1_RESULT__PERF_COUNT__SHIFT = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER_TAG_DELAY_RANGE__RANGE_HIGH__SHIFT = 0x0000000e;
    constexpr unsigned int SDMA1_PERFCOUNTER_TAG_DELAY_RANGE__RANGE_LOW__SHIFT = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER_TAG_DELAY_RANGE__SELECT_RW__SHIFT = 0x0000001c;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_CLEAR0__SHIFT   = 0x00000001;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_CLEAR1__SHIFT   = 0x0000000b;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_ENABLE0__SHIFT  = 0x00000000;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_ENABLE1__SHIFT  = 0x0000000a;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_SEL0__SHIFT     = 0x00000002;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_SEL1__SHIFT     = 0x0000000c;
    constexpr unsigned int VGT_DEBUG_REG0__SPARE0__SHIFT            = 0x0000001f;
    constexpr unsigned int VGT_DEBUG_REG0__SPARE1__SHIFT            = 0x0000001c;
    constexpr unsigned int VGT_DEBUG_REG0__SPARE2__SHIFT            = 0x00000019;
    constexpr unsigned int VGT_DEBUG_REG0__SPARE3__SHIFT            = 0x00000014;
    constexpr unsigned int VGT_DEBUG_REG0__SPARE4__SHIFT            = 0x00000007;
    constexpr unsigned int VGT_DEBUG_REG0__SPARE5__SHIFT            = 0x00000006;
    constexpr unsigned int VGT_DEBUG_REG1__SPARE0__SHIFT            = 0x00000009;
    constexpr unsigned int VGT_DEBUG_REG1__SPARE1__SHIFT            = 0x00000008;
    constexpr unsigned int VGT_DEBUG_REG1__SPARE2__SHIFT            = 0x00000007;
    constexpr unsigned int VGT_DEBUG_REG1__SPARE3__SHIFT            = 0x00000006;
    constexpr unsigned int VGT_DEBUG_REG1__SPARE4__SHIFT            = 0x00000005;
    constexpr unsigned int VGT_DEBUG_REG1__SPARE5__SHIFT            = 0x00000004;
    constexpr unsigned int VGT_DEBUG_REG2__SPARE__SHIFT             = 0x0000001d;
    constexpr unsigned int VGT_DEBUG_REG4__SPARE__SHIFT             = 0x0000001f;
    constexpr unsigned int VGT_DEBUG_REG5__SPARE1__SHIFT            = 0x00000018;
    constexpr unsigned int VGT_DEBUG_REG5__SPARE2__SHIFT            = 0x00000010;
    constexpr unsigned int VGT_DEBUG_REG5__SPARE3__SHIFT            = 0x00000008;
    constexpr unsigned int VGT_DEBUG_REG5__SPARE4__SHIFT            = 0x00000000;
    constexpr unsigned int VGT_DEBUG_REG7__SPARE__SHIFT             = 0x00000005;
    constexpr unsigned int VGT_DEBUG_REG9__SPARE0__SHIFT            = 0x0000001e;
    constexpr unsigned int VGT_DEBUG_REG10__SPARE2__SHIFT           = 0x00000009;
    constexpr unsigned int VGT_DEBUG_REG11__SPARE0__SHIFT           = 0x00000012;
    constexpr unsigned int VGT_DEBUG_REG11__SPARE1__SHIFT           = 0x00000005;
    constexpr unsigned int VGT_DEBUG_REG12__SPARE0__SHIFT           = 0x0000001f;
    constexpr unsigned int VGT_DEBUG_REG13__SPARE0__SHIFT           = 0x0000001a;
    constexpr unsigned int VGT_DEBUG_REG13__SPARE1__SHIFT           = 0x00000019;
    constexpr unsigned int VGT_DEBUG_REG14__SPARE0__SHIFT           = 0x0000001e;
    constexpr unsigned int VGT_DEBUG_REG14__SPARE1__SHIFT           = 0x0000001c;
    constexpr unsigned int VGT_DEBUG_REG14__SPARE2__SHIFT           = 0x0000000c;
    constexpr unsigned int VGT_DEBUG_REG14__SPARE3__SHIFT           = 0x00000000;
    constexpr unsigned int VGT_DEBUG_REG14__SPARE__SHIFT            = 0x00000016;
    constexpr unsigned int VGT_DEBUG_REG23__SPARE__SHIFT            = 0x00000018;
    constexpr unsigned int VGT_DEBUG_REG30__SPARE__SHIFT            = 0x00000013;
    constexpr unsigned int VGT_DEBUG_REG32__SPARE__SHIFT            = 0x0000001c;
    constexpr unsigned int WD_DEBUG_REG0__SPARE3__SHIFT             = 0x00000010;
    constexpr unsigned int WD_DEBUG_REG1__SPARE0__SHIFT             = 0x00000008;
    constexpr unsigned int WD_DEBUG_REG2__SPARE0__SHIFT             = 0x00000008;
    constexpr unsigned int WD_DEBUG_REG3__SPARE0__SHIFT             = 0x00000001;
    constexpr unsigned int WD_DEBUG_REG3__SPARE1__SHIFT             = 0x00000017;
    constexpr unsigned int WD_DEBUG_REG5__SPARE0__SHIFT             = 0x00000001;
    constexpr unsigned int WD_DEBUG_REG5__SPARE1__SHIFT             = 0x00000017;
    constexpr unsigned int WD_DEBUG_REG7__SPARE0__SHIFT             = 0x00000004;
    constexpr unsigned int WD_DEBUG_REG7__SPARE1__SHIFT             = 0x00000008;
    constexpr unsigned int WD_DEBUG_REG7__SPARE2__SHIFT             = 0x0000000c;
    constexpr unsigned int WD_DEBUG_REG7__SPARE3__SHIFT             = 0x00000010;
    constexpr unsigned int WD_DEBUG_REG7__SPARE4__SHIFT             = 0x00000016;
    constexpr unsigned int WD_DEBUG_REG9__SPARE0__SHIFT             = 0x0000000b;
    constexpr unsigned int WD_DEBUG_REG9__SPARE1__SHIFT             = 0x0000001b;
    constexpr unsigned int WD_DEBUG_REG9__SPARE2__SHIFT             = 0x0000001c;
} // namespace Vega

namespace Vg10
{
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_alloc_opco_error__SHIFT = 0x00000002;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_dealloc_opco_error__SHIFT = 0x00000003;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_dec_error__SHIFT = 0x00000001;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_error_ds_address__SHIFT = 0x00000008;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_wrap_opco_error__SHIFT = 0x00000004;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_write_dis__SHIFT = 0x00000000;
    constexpr unsigned int alloc_DEBUG_DATA__Reserved0__SHIFT       = 0x00000005;
    constexpr unsigned int alloc_DEBUG_DATA__Reserved1__SHIFT       = 0x00000016;
    constexpr unsigned int GC_CAC_ACC_CBR0__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CBR1__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CBR2__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CBR3__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU11__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU12__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU13__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU14__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU15__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_DBR0__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_DBR1__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_DBR2__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_DBR3__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_OVRD_CBR__OVRRD_SELECT__SHIFT     = 0x00000000;
    constexpr unsigned int GC_CAC_OVRD_CBR__OVRRD_VALUE__SHIFT      = 0x00000004;
    constexpr unsigned int GC_CAC_OVRD_DBR__OVRRD_SELECT__SHIFT     = 0x00000000;
    constexpr unsigned int GC_CAC_OVRD_DBR__OVRRD_VALUE__SHIFT      = 0x00000004;
    constexpr unsigned int GC_CAC_WEIGHT_CBR_0__WEIGHT_CBR_SIG0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_CBR_0__WEIGHT_CBR_SIG1__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_CBR_1__WEIGHT_CBR_SIG2__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_CBR_1__WEIGHT_CBR_SIG3__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_CU_6__WEIGHT_CU_SIG12__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_CU_6__WEIGHT_CU_SIG13__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_CU_7__WEIGHT_CU_SIG14__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_CU_7__WEIGHT_CU_SIG15__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_DBR_0__WEIGHT_DBR_SIG0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_DBR_0__WEIGHT_DBR_SIG1__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_DBR_1__WEIGHT_DBR_SIG2__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_DBR_1__WEIGHT_DBR_SIG3__SHIFT = 0x00000010;
    constexpr unsigned int GC_DIDT_WEIGHT_1__DBR_WEIGHT__SHIFT      = 0x00000000;
    constexpr unsigned int gws_DEBUG_DATA__credit_cnt__SHIFT        = 0x00000010;
    constexpr unsigned int gws_DEBUG_DATA__cur_reso_5to0__SHIFT     = 0x00000003;
    constexpr unsigned int gws_DEBUG_DATA__cur_reso_count__SHIFT    = 0x0000000f;
    constexpr unsigned int gws_DEBUG_DATA__Reserved0__SHIFT         = 0x00000018;
    constexpr unsigned int oa_wc0_DEBUG_DATA__credit_cnt__SHIFT     = 0x00000001;
    constexpr unsigned int oa_wc0_DEBUG_DATA__req__SHIFT            = 0x00000008;
    constexpr unsigned int oa_wc0_DEBUG_DATA__Reserved0__SHIFT      = 0x00000013;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy0__SHIFT    = 0x0000000b;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy1__SHIFT    = 0x0000000c;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy2__SHIFT    = 0x0000000d;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy3__SHIFT    = 0x0000000e;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy4__SHIFT    = 0x0000000f;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy5__SHIFT    = 0x00000010;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy6__SHIFT    = 0x00000011;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy7__SHIFT    = 0x00000012;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy__SHIFT     = 0x00000000;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe1_busy__SHIFT     = 0x00000001;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe2_busy__SHIFT     = 0x00000002;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe3_busy__SHIFT     = 0x00000003;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe4_busy__SHIFT     = 0x00000004;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe5_busy__SHIFT     = 0x00000005;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe6_busy__SHIFT     = 0x00000006;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe7_busy__SHIFT     = 0x00000007;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe8_busy__SHIFT     = 0x00000008;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe9_busy__SHIFT     = 0x00000009;
    constexpr unsigned int oa_wc1_DEBUG_DATA__Pipe10_busy__SHIFT    = 0x0000000a;
    constexpr unsigned int oa_wc1_DEBUG_DATA__Reserved0__SHIFT      = 0x00000013;
    constexpr unsigned int ord_app_DEBUG_DATA__fifo_busy__SHIFT     = 0x00000000;
    constexpr unsigned int ord_app_DEBUG_DATA__ord_busy__SHIFT      = 0x00000001;
    constexpr unsigned int ord_app_DEBUG_DATA__Reserved0__SHIFT     = 0x00000003;
    constexpr unsigned int ord_app_DEBUG_DATA__Reserved1__SHIFT     = 0x0000000c;
    constexpr unsigned int ord_app_DEBUG_DATA__sh0_cmd_fifo_empty__SHIFT = 0x00000004;
    constexpr unsigned int ord_app_DEBUG_DATA__sh0_data_fifo_empty__SHIFT = 0x00000008;
    constexpr unsigned int ord_app_DEBUG_DATA__sh1_cmd_fifo_empty__SHIFT = 0x00000005;
    constexpr unsigned int ord_app_DEBUG_DATA__sh1_data_fifo_empty__SHIFT = 0x00000009;
    constexpr unsigned int ord_app_DEBUG_DATA__sh2_cmd_fifo_empty__SHIFT = 0x00000006;
    constexpr unsigned int ord_app_DEBUG_DATA__sh2_data_fifo_empty__SHIFT = 0x0000000a;
    constexpr unsigned int ord_app_DEBUG_DATA__sh3_cmd_fifo_empty__SHIFT = 0x00000007;
    constexpr unsigned int ord_app_DEBUG_DATA__sh3_data_fifo_empty__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG00_0__ccgen_to_clipcc_fifo_empty__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG00_0__ccgen_to_clipcc_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG00_0__clipcode_fifo_fifo_empty__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG00_0__clipcode_fifo_full__SHIFT  = 0x0000000e;
    constexpr unsigned int PA_DEBUG00_0__clip_ga_bc_fifo_write__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG00_0__clip_to_ga_fifo_full__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG00_0__clip_to_ga_fifo_write__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG00_0__clip_to_outsm_fifo_empty__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG00_0__clip_to_outsm_fifo_full__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG00_0__clip_to_outsm_fifo_write__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG00_0__primic_to_clprim_fifo_empty__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG00_0__primic_to_clprim_fifo_full__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG00_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG00_0__su_clip_baryc_free__SHIFT  = 0x00000001;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clipp_fifo_empty__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clipp_fifo_full__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clipp_fifo_write__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clips_fifo_empty__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clips_fifo_full__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG00_0__vte_out_clip_fifo_fifo_empty__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG00_0__vte_out_clip_fifo_fifo_full__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG00_0__vte_out_orig_fifo_fifo_empty__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG00_0__vte_out_orig_fifo_fifo_full__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG00_0__vte_out_orig_fifo_fifo_write__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG00_1__available_positions__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG00_1__ccgen_to_clipcc_fifo_full__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG00_1__ccgen_to_clipcc_write__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG00_1__current_state__SHIFT       = 0x0000000d;
    constexpr unsigned int PA_DEBUG00_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG00_1__statevar_bits_vs_out_ccdist0_vec_ena__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG00_1__statevar_bits_vs_out_ccdist1_vec_ena__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG00_1__sx0_receive_fifo_empty__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG00_1__sx0_receive_fifo_full__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG00_1__sx0_receive_fifo_write__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG00_1__vertex_fifo_empty__SHIFT   = 0x0000000f;
    constexpr unsigned int PA_DEBUG00_1__vertex_fifo_entriesavailable__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG00_1__vertex_fifo_full__SHIFT    = 0x00000010;
    constexpr unsigned int PA_DEBUG00_1__vgt_to_ccgen_fifo_empty__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG00_1__vgt_to_ccgen_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG01_0__clip_extra_bc_valid__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG01_0__clip_ga_bc_fifo_write__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG01_0__clip_to_ga_fifo_write__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG01_0__clip_to_outsm_deallocate_slot__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG01_0__clip_to_outsm_null_primitive__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG01_0__clip_to_outsm_vertex_deallocate__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG01_0__clip_vert_vte_valid__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG01_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_fifo_fifo_advanceread__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_fifo_fifo_empty__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_rd_extra_bc_valid__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_rd_vertex_store_indx__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_rd_vte_naninf_kill__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG01_0__vte_positions_vte_clip_vte_naninf_kill_0__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG01_0__vte_positions_vte_clip_vte_naninf_kill_1__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG01_0__vte_positions_vte_clip_vte_naninf_kill_2__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG01_1__ALWAYS_ZERO__SHIFT         = 0x00000000;
    constexpr unsigned int PA_DEBUG01_1__clip_extra_bc_valid__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG01_1__clip_ga_bc_fifo_write__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG01_1__clip_to_ga_fifo_write__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG01_1__clip_to_outsm_vertex_deallocate__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG01_1__clip_vert_vte_valid__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG01_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_fifo_fifo_advanceread__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_fifo_fifo_empty__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_rd_extra_bc_valid__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_rd_vertex_store_indx__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_rd_vte_naninf_kill__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG02_0__clip_ga_bc_fifo_full__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG02_0__clip_ga_bc_fifo_write__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG02_0__clip_to_clipga_extra_bc_coords__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG02_0__clip_to_clipga_vte_naninf_kill__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG02_0__clip_to_ga_fifo_full__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG02_0__clip_to_ga_fifo_write__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_clipped_prim__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_end_of_packet__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_fifo_advanceread__SHIFT = 0x0000001e;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_fifo_empty__SHIFT = 0x0000001f;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_first_prim_of_slot__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_null_primitive__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_vertex_store_indx_0__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_vertex_store_indx_1__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_vertex_store_indx_2__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG02_1__clip_extra_bc_valid__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG02_1__clip_ga_bc_fifo_full__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG02_1__clip_ga_bc_fifo_write__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG02_1__clip_to_ga_fifo_full__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG02_1__clip_to_ga_fifo_write__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_clipped_prim__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_clip_seq_indx__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_fifo_advanceread__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_fifo_empty__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_null_primitive__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_vertex_store_indx_1__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_vertex_store_indx_2__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG02_1__clip_vert_vte_valid__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG02_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_clip_code_or__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_clip_primitive__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_deallocate_slot__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_end_of_packet__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_event_id__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_first_prim_of_slot__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_state_var_indx__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG03_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_clip_code_or__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_deallocate_slot__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_end_of_packet__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_event_id__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_first_prim_of_slot__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG03_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_param_cache_indx_0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_vertex_store_indx_0__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_vertex_store_indx_1__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_vertex_store_indx_2__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG04_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_param_cache_indx_0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_vertex_store_indx_0__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_vertex_store_indx_2__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG04_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_clip_code_or__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_clip_primitive__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_deallocate_slot__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_end_of_packet__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_event_id__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_first_prim_of_slot__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_state_var_indx__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG05_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_clip_code_or__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_deallocate_slot__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_end_of_packet__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_event_id__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_first_prim_of_slot__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG05_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_param_cache_indx_0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_vertex_store_indx_0__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_vertex_store_indx_1__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_vertex_store_indx_2__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG06_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_param_cache_indx_0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_vertex_store_indx_0__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_vertex_store_indx_2__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG06_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_clip_code_or__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_clip_primitive__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_deallocate_slot__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_end_of_packet__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_event_id__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_first_prim_of_slot__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_state_var_indx__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG07_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_clip_code_or__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_deallocate_slot__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_end_of_packet__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_event_id__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_first_prim_of_slot__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG07_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_param_cache_indx_0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_vertex_store_indx_0__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_vertex_store_indx_1__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_vertex_store_indx_2__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG08_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_param_cache_indx_0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_vertex_store_indx_0__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_vertex_store_indx_2__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG08_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_clip_code_or__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_clip_primitive__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_deallocate_slot__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_end_of_packet__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_event_id__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_first_prim_of_slot__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_state_var_indx__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG09_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_clip_code_or__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_deallocate_slot__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_end_of_packet__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_event_id__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_first_prim_of_slot__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG09_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_param_cache_indx_0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_vertex_store_indx_0__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_vertex_store_indx_1__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_vertex_store_indx_2__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG10_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_param_cache_indx_0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_vertex_store_indx_0__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_vertex_store_indx_2__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG11_0__clipsm0_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG11_0__clipsm0_clip_to_clipga_prim_valid__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG11_0__clipsm0_inc_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG11_0__clipsm1_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG11_0__clipsm1_clip_to_clipga_prim_valid__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG11_0__clipsm1_inc_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG11_0__clipsm2_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG11_0__clipsm2_clip_to_clipga_prim_valid__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG11_0__clipsm2_inc_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG11_0__clipsm3_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG11_0__clipsm3_clip_to_clipga_prim_valid__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG11_0__clipsm3_inc_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG11_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG11_1__clipsm0_clip_to_clipga_clip_primitive__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG11_1__clipsm0_clip_to_clipga_event__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG11_1__clipsm0_clip_to_clipga_prim_valid__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG11_1__clipsm0_inc_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG11_1__clipsm1_clip_to_clipga_clip_primitive__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG11_1__clipsm1_clip_to_clipga_event__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG11_1__clipsm1_clip_to_clipga_prim_valid__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG11_1__clipsm1_inc_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_clip_to_clipga_clip_primitive__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_clip_to_clipga_event__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_clip_to_clipga_prim_valid__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_inc_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_clip_to_clipga_clip_primitive__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_clip_to_clipga_event__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_clip_to_clipga_prim_valid__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_inc_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG11_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG12_0__clipsm0_clprim_to_clip_clip_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG12_0__clipsm0_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG12_0__clipsm1_clprim_to_clip_clip_primitive__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG12_0__clipsm1_clprim_to_clip_prim_valid__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG12_0__clipsm2_clprim_to_clip_clip_primitive__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG12_0__clipsm2_clprim_to_clip_prim_valid__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG12_0__clipsm3_clprim_to_clip_clip_primitive__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG12_0__clipsm3_clprim_to_clip_prim_valid__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_available_clip_verts__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_available_vte_out_clip__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_seq_indx_load__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_seq_indx_out__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_seq_indx_vert__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG12_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG12_1__ALWAYS_ZERO__SHIFT         = 0x00000000;
    constexpr unsigned int PA_DEBUG12_1__clipsm0_clprim_to_clip_clip_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG12_1__clipsm0_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG12_1__clipsm1_clprim_to_clip_clip_primitive__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG12_1__clipsm1_clprim_to_clip_prim_valid__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG12_1__clipsm2_clprim_to_clip_clip_primitive__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG12_1__clipsm2_clprim_to_clip_prim_valid__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG12_1__clipsm3_clprim_to_clip_clip_primitive__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG12_1__clipsm3_clprim_to_clip_prim_valid__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG12_1__clip_priority_available_clip_verts__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG12_1__clip_priority_available_vte_out_clip__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG12_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG13_0__ccgen_to_clipcc_fifo_empty__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG13_0__clipcc_vertex_store_indx__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG13_0__clipcode_fifo_fifo_empty__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG13_0__clip_priority_seq_indx_out_cnt__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_fifo_advanceread__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_fifo_contents__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_fifo_full__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_fifo_write__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_rd_clipsm_wait__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_rd_orig_vertices__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG13_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG13_0__vertval_bits_vertex_cc_next_valid__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG13_0__vte_out_orig_fifo_fifo_empty__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG13_1__clipcc_vertex_store_indx__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG13_1__clipcode_fifo_fifo_empty__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG13_1__clprim_clip_primitive__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG13_1__clprim_cull_primitive__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG13_1__clprim_in_back_state_var_indx__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG13_1__outsm_clr_fifo_advanceread__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG13_1__outsm_clr_fifo_contents__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG13_1__outsm_clr_fifo_full__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG13_1__outsm_clr_fifo_write__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG13_1__point_clip_candidate__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG13_1__prim_back_valid__SHIFT     = 0x00000007;
    constexpr unsigned int PA_DEBUG13_1__prim_nan_kill__SHIFT       = 0x00000004;
    constexpr unsigned int PA_DEBUG13_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG13_1__vertval_bits_vertex_cc_next_valid__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG13_1__vte_out_orig_fifo_fifo_empty__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_deallocate_slot__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_end_of_packet__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_event_id__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_event__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_first_prim_of_slot__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_vertex_store_indx_0__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_vertex_store_indx_1__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG14_0__outputclprimtoclip_null_primitive__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG14_0__prim_back_valid__SHIFT     = 0x00000017;
    constexpr unsigned int PA_DEBUG14_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_event_id__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_event__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_vertex_store_indx_0__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_vertex_store_indx_1__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_vertex_store_indx_2__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG14_1__prim_back_valid__SHIFT     = 0x00000017;
    constexpr unsigned int PA_DEBUG14_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG15_0__primic_to_clprim_fifo_vertex_store_indx_0__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG15_0__primic_to_clprim_fifo_vertex_store_indx_1__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG15_0__primic_to_clprim_fifo_vertex_store_indx_2__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG15_0__primic_to_clprim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG15_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG15_0__vertval_bits_vertex_vertex_store_msb__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG15_1__primic_to_clprim_fifo_vertex_store_indx_0__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG15_1__primic_to_clprim_fifo_vertex_store_indx_1__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG15_1__primic_to_clprim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG15_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG15_1__vertval_bits_vertex_vertex_store_msb__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG16_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG16_0__sm0_clip_to_clipga_clip_to_outsm_cnt_eq0__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG16_0__sm0_clip_to_outsm_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG16_0__sm0_clip_vert_cnt__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG16_0__sm0_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG16_0__sm0_current_state__SHIFT   = 0x0000000c;
    constexpr unsigned int PA_DEBUG16_0__sm0_highest_priority_seq__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG16_0__sm0_inv_to_clip_data_valid_0__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG16_0__sm0_inv_to_clip_data_valid_1__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG16_0__sm0_outputcliptoga_0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG16_0__sm0_vertex_clip_cnt__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG16_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG16_1__sm0_clip_to_clipga_clip_to_outsm_cnt_eq0__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG16_1__sm0_clip_to_outsm_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG16_1__sm0_clip_vert_cnt__SHIFT   = 0x00000008;
    constexpr unsigned int PA_DEBUG16_1__sm0_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG16_1__sm0_current_state__SHIFT   = 0x00000010;
    constexpr unsigned int PA_DEBUG16_1__sm0_highest_priority_seq__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG16_1__sm0_outputcliptoga_0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG16_1__sm0_prim_end_state__SHIFT  = 0x00000000;
    constexpr unsigned int PA_DEBUG16_1__sm0_ps_expand__SHIFT       = 0x00000007;
    constexpr unsigned int PA_DEBUG16_1__sm0_vertex_clip_cnt__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG17_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG17_0__sm1_clip_to_clipga_clip_to_outsm_cnt_eq0__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG17_0__sm1_clip_to_outsm_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG17_0__sm1_clip_vert_cnt__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG17_0__sm1_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG17_0__sm1_current_state__SHIFT   = 0x0000000c;
    constexpr unsigned int PA_DEBUG17_0__sm1_highest_priority_seq__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG17_0__sm1_inv_to_clip_data_valid_0__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG17_0__sm1_inv_to_clip_data_valid_1__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG17_0__sm1_outputcliptoga_0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG17_0__sm1_vertex_clip_cnt__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG17_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG17_1__sm1_clip_to_clipga_clip_to_outsm_cnt_eq0__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG17_1__sm1_clip_to_outsm_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG17_1__sm1_clip_vert_cnt__SHIFT   = 0x00000008;
    constexpr unsigned int PA_DEBUG17_1__sm1_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG17_1__sm1_current_state__SHIFT   = 0x00000010;
    constexpr unsigned int PA_DEBUG17_1__sm1_highest_priority_seq__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG17_1__sm1_outputcliptoga_0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG17_1__sm1_prim_end_state__SHIFT  = 0x00000000;
    constexpr unsigned int PA_DEBUG17_1__sm1_ps_expand__SHIFT       = 0x00000007;
    constexpr unsigned int PA_DEBUG17_1__sm1_vertex_clip_cnt__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG18_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG18_0__sm2_clip_to_clipga_clip_to_outsm_cnt_eq0__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG18_0__sm2_clip_to_outsm_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG18_0__sm2_clip_vert_cnt__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG18_0__sm2_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG18_0__sm2_current_state__SHIFT   = 0x0000000c;
    constexpr unsigned int PA_DEBUG18_0__sm2_highest_priority_seq__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG18_0__sm2_inv_to_clip_data_valid_0__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG18_0__sm2_inv_to_clip_data_valid_1__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG18_0__sm2_outputcliptoga_0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG18_0__sm2_vertex_clip_cnt__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG18_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG18_1__sm2_clip_to_clipga_clip_to_outsm_cnt_eq0__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG18_1__sm2_clip_to_outsm_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG18_1__sm2_clip_vert_cnt__SHIFT   = 0x00000008;
    constexpr unsigned int PA_DEBUG18_1__sm2_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG18_1__sm2_current_state__SHIFT   = 0x00000010;
    constexpr unsigned int PA_DEBUG18_1__sm2_highest_priority_seq__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG18_1__sm2_outputcliptoga_0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG18_1__sm2_prim_end_state__SHIFT  = 0x00000000;
    constexpr unsigned int PA_DEBUG18_1__sm2_ps_expand__SHIFT       = 0x00000007;
    constexpr unsigned int PA_DEBUG18_1__sm2_vertex_clip_cnt__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG19_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG19_0__sm3_clip_to_clipga_clip_to_outsm_cnt_eq0__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG19_0__sm3_clip_to_outsm_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG19_0__sm3_clip_vert_cnt__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG19_0__sm3_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG19_0__sm3_current_state__SHIFT   = 0x0000000c;
    constexpr unsigned int PA_DEBUG19_0__sm3_highest_priority_seq__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG19_0__sm3_inv_to_clip_data_valid_0__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG19_0__sm3_inv_to_clip_data_valid_1__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG19_0__sm3_outputcliptoga_0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG19_0__sm3_vertex_clip_cnt__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG19_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG19_1__sm3_clip_to_clipga_clip_to_outsm_cnt_eq0__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG19_1__sm3_clip_to_outsm_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG19_1__sm3_clip_vert_cnt__SHIFT   = 0x00000008;
    constexpr unsigned int PA_DEBUG19_1__sm3_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG19_1__sm3_current_state__SHIFT   = 0x00000010;
    constexpr unsigned int PA_DEBUG19_1__sm3_highest_priority_seq__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG19_1__sm3_outputcliptoga_0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG19_1__sm3_prim_end_state__SHIFT  = 0x00000000;
    constexpr unsigned int PA_DEBUG19_1__sm3_ps_expand__SHIFT       = 0x00000007;
    constexpr unsigned int PA_DEBUG19_1__sm3_vertex_clip_cnt__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG20_0__point_address__SHIFT       = 0x00000000;
    constexpr unsigned int PA_DEBUG20_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_advance__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_aux_inc__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_aux_sel__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_pci__SHIFT   = 0x00000008;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_req_mask__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_sp_id__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_state_var_indx__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG20_1__point_address__SHIFT       = 0x00000006;
    constexpr unsigned int PA_DEBUG20_1__position_address__SHIFT    = 0x00000000;
    constexpr unsigned int PA_DEBUG20_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_advance__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_aux_inc__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_aux_sel__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_pci__SHIFT   = 0x00000010;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_req_mask__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_sp_id__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_state_var_indx__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG21_0__aux_sel__SHIFT             = 0x0000000c;
    constexpr unsigned int PA_DEBUG21_0__pasx_req_cnt_0__SHIFT      = 0x00000014;
    constexpr unsigned int PA_DEBUG21_0__pasx_req_cnt_1__SHIFT      = 0x00000010;
    constexpr unsigned int PA_DEBUG21_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG21_0__statevar_bits_disable_sp__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG21_0__statevar_bits_vs_out_misc_vec_ena__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG21_0__sx_pending_fifo_contents__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG21_0__sx_receive_indx__SHIFT     = 0x00000000;
    constexpr unsigned int PA_DEBUG21_0__sx_to_pa_empty_0__SHIFT    = 0x0000000f;
    constexpr unsigned int PA_DEBUG21_0__sx_to_pa_empty_1__SHIFT    = 0x0000000e;
    constexpr unsigned int PA_DEBUG21_1__available_positions__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG21_1__pasx_req_cnt_0__SHIFT      = 0x00000014;
    constexpr unsigned int PA_DEBUG21_1__pasx_req_cnt_1__SHIFT      = 0x00000010;
    constexpr unsigned int PA_DEBUG21_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG21_1__statevar_bits_vs_out_misc_vec_ena__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG21_1__sx_pending_fifo_contents__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG21_1__sx_receive_indx__SHIFT     = 0x00000007;
    constexpr unsigned int PA_DEBUG22_0__req_active_verts_loaded__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG22_0__req_active_verts__SHIFT    = 0x00000008;
    constexpr unsigned int PA_DEBUG22_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG22_0__su_aux__SHIFT              = 0x00000000;
    constexpr unsigned int PA_DEBUG22_0__sx_request_indx__SHIFT     = 0x00000001;
    constexpr unsigned int PA_DEBUG22_0__vgt_to_ccgen_active_verts__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG22_0__vgt_to_ccgen_state_var_indx__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG22_1__param_cache_base__SHIFT    = 0x00000000;
    constexpr unsigned int PA_DEBUG22_1__req_active_verts_loaded__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG22_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG22_1__su_aux__SHIFT              = 0x00000007;
    constexpr unsigned int PA_DEBUG22_1__sx_request_indx__SHIFT     = 0x00000009;
    constexpr unsigned int PA_DEBUG22_1__vgt_to_ccgen_active_verts__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG22_1__vgt_to_ccgen_state_var_indx__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG23_0__ALWAYS_ZERO__SHIFT         = 0x00000006;
    constexpr unsigned int PA_DEBUG23_0__event_id_gated_1to0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG23_0__geom_busy__SHIFT           = 0x00000015;
    constexpr unsigned int PA_DEBUG23_0__geom_enable__SHIFT         = 0x0000000f;
    constexpr unsigned int PA_DEBUG23_0__ge_stallb__SHIFT           = 0x0000000e;
    constexpr unsigned int PA_DEBUG23_0__pfifo_busy__SHIFT          = 0x00000013;
    constexpr unsigned int PA_DEBUG23_0__pmode_state__SHIFT         = 0x00000008;
    constexpr unsigned int PA_DEBUG23_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG23_0__su_baryc_cntl_state__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG23_0__su_clip_baryc_free__SHIFT  = 0x00000010;
    constexpr unsigned int PA_DEBUG23_0__su_clip_rtr__SHIFT         = 0x00000012;
    constexpr unsigned int PA_DEBUG23_0__su_cntl_busy__SHIFT        = 0x00000014;
    constexpr unsigned int PA_DEBUG23_0__su_cntl_state__SHIFT       = 0x00000002;
    constexpr unsigned int PA_DEBUG24_0__cl_dyn_sclk_vld__SHIFT     = 0x00000007;
    constexpr unsigned int PA_DEBUG24_0__event_gated__SHIFT         = 0x00000004;
    constexpr unsigned int PA_DEBUG24_0__event_id_gated_5to2__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG24_0__pmode_prim_gated__SHIFT    = 0x00000005;
    constexpr unsigned int PA_DEBUG24_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG24_0__su_dyn_sclk_vld__SHIFT     = 0x00000006;
    constexpr unsigned int PA_DEBUG24_0__y_sort0_gated_23_8__SHIFT  = 0x00000008;
    constexpr unsigned int PA_DEBUG25_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG25_0__x_sort0_gated_23_8__SHIFT  = 0x00000000;
    constexpr unsigned int PA_DEBUG25_0__y_sort1_gated_15_8__SHIFT  = 0x00000010;
    constexpr unsigned int PA_DEBUG26_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG26_0__x_sort1_gated_23_8__SHIFT  = 0x00000008;
    constexpr unsigned int PA_DEBUG26_0__y_sort1_gated_23_16__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG27_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG27_0__x_sort2_gated_15_8__SHIFT  = 0x00000010;
    constexpr unsigned int PA_DEBUG27_0__y_sort2_gated_23_8__SHIFT  = 0x00000000;
    constexpr unsigned int PA_DEBUG28_0__attr_indx_sort0_gated__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG28_0__backfacing_gated__SHIFT    = 0x00000017;
    constexpr unsigned int PA_DEBUG28_0__null_prim_gated__SHIFT     = 0x00000016;
    constexpr unsigned int PA_DEBUG28_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG28_0__x_sort2_gated_23to16__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG29_0__attr_indx_sort2_gated_7to0__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG29_0__clipped_gated__SHIFT       = 0x00000003;
    constexpr unsigned int PA_DEBUG29_0__dealloc_slot_gated__SHIFT  = 0x00000004;
    constexpr unsigned int PA_DEBUG29_0__diamond_rule_gated__SHIFT  = 0x00000008;
    constexpr unsigned int PA_DEBUG29_0__eop_gated__SHIFT           = 0x0000000f;
    constexpr unsigned int PA_DEBUG29_0__fpov_gated__SHIFT          = 0x0000000d;
    constexpr unsigned int PA_DEBUG29_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG29_0__st_indx_gated__SHIFT       = 0x00000000;
    constexpr unsigned int PA_DEBUG29_0__type_gated__SHIFT          = 0x0000000a;
    constexpr unsigned int PA_DEBUG29_0__xmajor_gated__SHIFT        = 0x00000007;
    constexpr unsigned int PA_DEBUG30_0__attr_indx_sort1_gated__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG30_0__attr_indx_sort2_gated_13to8__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG30_0__pa_reg_sclk_vld__SHIFT     = 0x00000017;
    constexpr unsigned int PA_DEBUG30_0__provoking_vtx_gated__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG30_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG30_0__valid_prim_gated__SHIFT    = 0x00000016;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm0_clprim_to_clip_prim_valid__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm1_clprim_to_clip_prim_valid__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm2_clprim_to_clip_prim_valid__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm3_clprim_to_clip_prim_valid__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm_clip_to_outsm_fifo_write__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_outsm_clr_fifo_not_empty__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_primic_to_clprim_valid__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy__SHIFT        = 0x00000008;
    constexpr unsigned int PA_DEBUG31_0__PA0_SC0_send_q__SHIFT      = 0x00000003;
    constexpr unsigned int PA_DEBUG31_0__PA0_SC1_send_q__SHIFT      = 0x00000004;
    constexpr unsigned int PA_DEBUG31_0__PA_PA_pascDataOut_send0_q__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG31_0__PA_PA_pascDataOut_send1_q__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG31_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_geom_busy__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_hold_busy__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_pfifo_busy__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_su_cntl_busy__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_valid_prim_gated__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG31_0__su_busy__SHIFT             = 0x00000009;
    constexpr unsigned int PA_DEBUG31_0__VGT_PA_clipp_send_q__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG31_0__VGT_PA_clips_send_q__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG31_0__VGT_PA_clipv_send_q__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG31_0__vte_busy_debug_ib_busy__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG31_0__vte_busy_debug_veu_busy__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG31_0__vte_busy__SHIFT            = 0x00000007;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_ccgen_to_clipcc_fifo_busy__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_ccgen_to_clipcc_fifo_write__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipcode_fifo_fifo_busy__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipcode_fifo_fifo_write__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipsm0_current_state_not_empty__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipsm1_current_state_not_empty__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipsm2_current_state_not_empty__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipsm3_current_state_not_empty__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clip_to_ga_bc_busy__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clip_to_ga_fifo_write__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clip_to_outsm_fifo_busy__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clip_to_outsm_fifo_write__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_next_prim_back_valid__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_primic_to_clprim_fifo_not_empty__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_primic_to_clprim_fifo_write__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_prim_back_valid__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_sx_pending_fifo_not_empty__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vgt_to_clipp_fifo_busy__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vgt_to_clipp_fifo_write__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vgt_to_clips_fifo_busy__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vte_out_clip_fifo_fifo_busy__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vte_out_clip_fifo_fifo_write__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vte_out_orig_fifo_fifo_busy__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vte_out_orig_fifo_fifo_write__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG32_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG33_0__clipper_busy_debug_vgt_to_clips_fifo_write__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG33_0__PA_SE3SC_freeze__SHIFT     = 0x00000004;
    constexpr unsigned int PA_DEBUG33_0__Reserved0__SHIFT           = 0x00000005;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_busy__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_rtr_in__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_rtr_out__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_rts_in__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_rts_out__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_iclient_send_valid__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_iutcl1_send_ready__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_oclient_send_ready__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_outcl1_send_type__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_outcl1_send_valid__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_outcl1_send_vmid__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_tag__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG34_0__Reserved0__SHIFT           = 0x00000017;
    constexpr unsigned int PA_DEBUG34_1__ngg_utcl1_debug00__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_busy__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_empty__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_full__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_read__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_write__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_iclient_send_valid__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_iutcl1_send_ready__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_oclient_send_ready__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_outcl1_send_type__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_outcl1_send_valid__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_outcl1_send_vmid__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_tag__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG35_0__Reserved0__SHIFT           = 0x00000017;
    constexpr unsigned int PA_DEBUG35_1__ngg_utcl1_debug01__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_busy__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_empty__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_full__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_read__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_write__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_iclient_send_valid__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_iutcl1_send_ready__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_oclient_send_ready__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_outcl1_send_type__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_outcl1_send_valid__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_outcl1_send_vmid__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_tag__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG36_0__Reserved0__SHIFT           = 0x00000017;
    constexpr unsigned int PA_DEBUG36_1__ngg_utcl1_debug02__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_busy__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_drop__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_io__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_mtype__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_perf_cntr_en__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_rd_tmz_encr__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_snoop__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_space__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_tag__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_vmid__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_rtr_in__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_rtr_out__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_rts_in__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_rts_out__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG37_0__Reserved0__SHIFT           = 0x0000001a;
    constexpr unsigned int PA_DEBUG37_1__ngg_utcl1_debug03__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_busy__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_drop__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_io__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_mtype__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_perf_cntr_en__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_rd_tmz_encr__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_snoop__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_space__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_tag__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_vmid__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_rtr_in__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_rtr_out__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_rts_in__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_rts_out__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG38_0__Reserved0__SHIFT           = 0x0000001a;
    constexpr unsigned int PA_DEBUG38_1__ngg_utcl1_debug04__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_busy__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_drop__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_io__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_mtype__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_perf_cntr_en__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_rd_tmz_encr__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_snoop__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_space__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_tag__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_vmid__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_rtr_in__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_rtr_out__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_rts_in__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_rts_out__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG39_0__Reserved0__SHIFT           = 0x0000001a;
    constexpr unsigned int PA_DEBUG39_1__ngg_utcl1_debug05__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG40_0__ngg_debug_tc_request_arbiter_current_client_count__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG40_0__ngg_debug_tc_request_arbiter_istream0_client_rts__SHIFT = 0x0000001f;
    constexpr unsigned int PA_DEBUG40_0__ngg_debug_tc_request_arbiter_istream0_client_tag__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG40_0__ngg_debug_tc_request_arbiter_ostream0_client_rtr__SHIFT = 0x0000001e;
    constexpr unsigned int PA_DEBUG40_1__ngg_utcl1_debug06__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_credits__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_credit_count_overflow__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_credit_count_underflow__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_data_rd_ptr__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_data_wr_ptr__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_irdreq_free__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_irdret_vld__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_irts_in__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_obusy__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_ooutstanding_tc_requests_exist__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_ordreq_clken__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_ordreq_send__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_ortr_in__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_outstanding_tc_requests__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_reg_valid0__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_reg_valid1__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG41_0__Reserved0__SHIFT           = 0x0000001d;
    constexpr unsigned int PA_DEBUG41_1__ngg_utcl1_debug07__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_current_dword_pointer__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_current_sideband_event_bit_set__SHIFT = 0x00000018;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_current_sideband_is_object_id__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_current_state__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_have_available_sideband_tokens__SHIFT = 0x00000019;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_itc_return_empty__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_pending_subgroup_count_not_zero__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_pending_subgroup_count_range__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_sideband_tokens_not_max_value__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_sideband_tokens_overflow__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_sideband_tokens_underflow__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_valid_dword_count__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_wait_counter_busy__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG42_0__Reserved0__SHIFT           = 0x0000001a;
    constexpr unsigned int PA_DEBUG42_1__ngg_utcl1_debug08__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_current_state__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_osideband_active__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_ovmid__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_sideband_pop_bit_fifo_busy__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_sideband_pop_bit_fifo_empty__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_sideband_pop_bit_fifo_full__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_vmid_fifo_busy__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_vmid_fifo_empty__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_vmid_fifo_full__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG43_0__Reserved0__SHIFT           = 0x0000000c;
    constexpr unsigned int PA_DEBUG43_1__ngg_utcl1_debug09__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents0_overflow__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents0_underflow__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents0__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents1_overflow__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents1_underflow__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents1__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG44_0__Reserved0__SHIFT           = 0x00000014;
    constexpr unsigned int PA_DEBUG44_1__ngg_utcl1_debug10__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_current_fetch_state__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_current_receive_finalt_dword_pointer__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_current_receive_first_dword_pointer__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_current_receive_state__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_final_receive_cacheline_this_subgroup__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_final_receive_dword_of_subgroup__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_have_available_index_tokens__SHIFT = 0x0000001d;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_receive_fifo_busy__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_receive_fifo_empty__SHIFT = 0x0000001b;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_receive_fifo_full__SHIFT = 0x0000001c;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_tokens_overflow__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_tokens_underflow__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_tokens__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_prim_indices_fifo_busy__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_sideband_data_context_id_bits__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_sideband_data_eop_bit__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_sideband_data_event_bit__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG45_0__Reserved0__SHIFT           = 0x0000001e;
    constexpr unsigned int PA_DEBUG45_1__ngg_utcl1_debug11__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_active_pos_req_fosg__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_another_pos_fetch__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_current_state__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_end_prev_diff__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_end_start_diff__SHIFT = 0x00000019;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_have_available_position_tokens__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_ifetch_to_primic_p_fifo_full__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_ifetch_to_primic_s_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_ipa_to_wd_dealloc_index_full__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_iposreq_to_posrtn_s_fifo_full__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_iposreq_to_posrtn_v_fifo_full__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_packer_object_id_valid__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_packer_sideband_valid__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_position_tokens_overflow__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_position_tokens_underflow__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_prev_pos_cacheline_valid__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_prev_select_end_cacheline_address__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_busy__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_final_prim__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_first_prim__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_miss_count__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_null_prim__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_prim_valid__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_start_prev_diff__SHIFT = 0x00000018;
    constexpr unsigned int PA_DEBUG46_0__Reserved0__SHIFT           = 0x0000001a;
    constexpr unsigned int PA_DEBUG46_1__ngg_utcl1_debug12__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_current_state__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_iinput_sideband_valid__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_eop_bit__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_event_bit__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_event_id__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_event_second_cycle__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_state_id__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_stream_id__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_output_prim_empty__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_prim_fifo_busy__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_prim_fifo_full__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_sideband_fifo_busy__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_sideband_fifo_empty__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_sideband_fifo_full__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG47_0__Reserved0__SHIFT           = 0x00000016;
    constexpr unsigned int PA_DEBUG47_1__ngg_utcl1_debug13__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_active_pos_return_cache_pos_index__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_active_pos_return_first_vert__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_active_pos_return_state__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_cache_pos_index__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_ifetch_to_sxif_fifo_full__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_ipa_to_wd_dealloc_position_full__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_itc_return_empty__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_oposreq_to_posrtn_s_fifo_full__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_oposreq_to_posrtn_v_fifo_full__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_posreq_to_posrtn_s_fifo_busy__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_posreq_to_posrtn_s_fifo_empty__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_posreq_to_posrtn_v_fifo_busy__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_posreq_to_posrtn_v_fifo_empty__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG48_0__Reserved0__SHIFT           = 0x00000010;
    constexpr unsigned int PA_DEBUG48_1__ngg_utcl1_debug14__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_crawler_busy__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_memreg0_busy__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_memreg1_busy__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_memreg2_busy__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_oreturn_empty_stream0__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_oreturn_empty_stream1__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_oreturn_empty_stream2__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_return_data_read_reg_full_stream0__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_return_data_read_reg_full_stream1__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_return_data_read_reg_full_stream2__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG49_0__Reserved0__SHIFT           = 0x0000000a;
    constexpr unsigned int PA_DEBUG49_1__ngg_utcl1_debug15__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_encountered_error_writing_to_busy_location_stream0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_encountered_error_writing_to_busy_location_stream1__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_encountered_error_writing_to_busy_location_stream2__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_memory_data_valid_stream0_count__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_memory_data_valid_stream1_count__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_memory_data_valid_stream2_count__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_obusy__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG50_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG50_1__ngg_utcl1_debug16__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_amount__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_fifo_busy__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_index_full__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_position_full__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_state_var_index__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_type__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_pa_to_wd_dealloc_fifo_empty__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_pa_to_wd_dealloc_fifo_read__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG51_0__Reserved0__SHIFT           = 0x00000014;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_all_clean__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_current_state__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iindex_requester_idle__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iindex_utcl1_return_busy__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iindex_utcl1_send_busy__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_ioutstanding_tc_requests_exist__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iposition_requester_idle__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iposition_utcl1_return_busy__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iposition_utcl1_send_busy__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_isideband_requester_idle__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_isideband_utcl1_return_busy__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_isideband_utcl1_send_busy__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iutcl1_busy__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_oclean__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_vmid_count__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG52_0__Reserved0__SHIFT           = 0x00000014;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_index_tokens_overflow__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_index_tokens_underflow__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_position_tokens_overflow__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_position_tokens_underflow__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sbmem_contents0_overflow__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sbmem_contents0_underflow__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sbmem_contents1_overflow__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sbmem_contents1_underflow__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sideband_tokens_overflow__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sideband_tokens_underflow__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_tc_credit_count_overflow__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_tc_credit_count_underflow__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_writing_to_busy_location_stream0__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_writing_to_busy_location_stream1__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_writing_to_busy_location_stream2__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG53_0__Reserved0__SHIFT           = 0x0000000f;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_index_receive_fifo_full__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_pa_to_wd_dealloc_index_full__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_pa_to_wd_dealloc_position_full__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_posreq_to_posrtn_s_fifo_full__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_posreq_to_posrtn_v_fifo_full__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_prim_fifo_full__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_prim_indices_fifo_full__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_return_data_full_stream0__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_return_data_full_stream1__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_return_data_full_stream2__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_sbmem_full__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_sideband_fifo_full__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_sideband_pop_bit_fifo_full__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_vmid_fifo_full__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG54_0__Reserved0__SHIFT           = 0x0000000e;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_index_receive_fifo_empty__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_pa_to_wd_dealloc_fifo_empty__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_posreq_to_posrtn_s_fifo_empty__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_posreq_to_posrtn_v_fifo_empty__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_prim_fifo_empty__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_prim_indices_fifo_empty__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_return_data_empty_stream0__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_return_data_empty_stream1__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_return_data_empty_stream2__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_sbmem_empty__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_sideband_fifo_empty__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_sideband_pop_bit_fifo_empty__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_vmid_fifo_empty__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG55_0__Reserved0__SHIFT           = 0x0000000d;
    constexpr unsigned int rbuf_DEBUG_DATA__pixel_addr_mask__SHIFT  = 0x00000002;
    constexpr unsigned int rbuf_DEBUG_DATA__Reserved0__SHIFT        = 0x00000018;
    constexpr unsigned int RLC_SPM_CBR0_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_CBR0_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_CBR1_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_CBR1_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_DBR0_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_DBR0_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_DBR1_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_DBR1_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int wbuf_DEBUG_DATA__cstate_3to0__SHIFT      = 0x0000000d;
    constexpr unsigned int wbuf_DEBUG_DATA__Reserved0__SHIFT        = 0x00000000;
    constexpr unsigned int wbuf_DEBUG_DATA__Reserved1__SHIFT        = 0x00000016;
    constexpr unsigned int wbuf_DEBUG_DATA__wr_pixel_ptr_nxt__SHIFT = 0x00000007;
} // namespace Vg10

namespace Vg10_Vg12
{
    constexpr unsigned int RPB_EA_QUEUE_WR__READ_QUEUE__SHIFT       = 0x00000008;
    constexpr unsigned int RPB_EA_QUEUE_WR__UPDATE__SHIFT           = 0x0000000b;
    constexpr unsigned int RPB_EA_QUEUE_WR__WRITE_QUEUE__SHIFT      = 0x00000005;
} // namespace Vg10_Vg12

namespace Vg10_Vg12_Rv1x
{
    constexpr unsigned int RPB_TAG_CONF__RPB_ATS_PR__SHIFT          = 0x00000010;
    constexpr unsigned int RPB_TAG_CONF__RPB_IO_WR__SHIFT           = 0x00000008;
    constexpr unsigned int SQ_CONFIG__UNUSED__SHIFT                 = 0x00000000;
} // namespace Vg10_Vg12_Rv1x

namespace Vg12
{
    constexpr unsigned int DB_DEBUG4__DISABLE_8PPC_OBJPRIMID_WHEN_NO_SHADER_EXPORTS__SHIFT = 0x0000001e;
    constexpr unsigned int GC_CAC_CNTL__CAC_FORCE_DISABLE__SHIFT    = 0x00000000;
    constexpr unsigned int GC_CAC_INDEX_AUTO_INCR_EN__GC_CAC_INDEX_AUTO_INCR_EN__SHIFT = 0x00000000;
    constexpr unsigned int GC_EDC_CTRL__EDC_THROTTLE_PATTERN_BIT_NUMS__SHIFT = 0x0000000c;
    constexpr unsigned int GC_EDC_CTRL__GC_EDC_ONLY_MODE__SHIFT     = 0x0000000b;
    constexpr unsigned int GC_EDC_CTRL__PCC_THROTTLE_PATTERN_BIT_NUMS__SHIFT = 0x00000010;
    constexpr unsigned int GC_EDC_CTRL__RELEASE_STEP_INTERVAL__SHIFT = 0x00000014;
    constexpr unsigned int GC_EDC_PERF_COUNTER__EDC_PERF_COUNTER__SHIFT = 0x00000000;
    constexpr unsigned int GC_EDC_STATUS__THROTTLE_PATTERN_INDEX__SHIFT = 0x0000001a;
    constexpr unsigned int GC_THROTTLE_CTRL__GC_EDC_OVERRIDE__SHIFT = 0x00000004;
    constexpr unsigned int GC_THROTTLE_CTRL__GC_EDC_PERF_COUNTER_EN__SHIFT = 0x00000008;
    constexpr unsigned int GC_THROTTLE_CTRL__GC_EDC_STALL_EN__SHIFT = 0x00000001;
    constexpr unsigned int GC_THROTTLE_CTRL__INST_THROT_DECR__SHIFT = 0x0000001f;
    constexpr unsigned int GC_THROTTLE_CTRL__INST_THROT_INCR__SHIFT = 0x0000001e;
    constexpr unsigned int GC_THROTTLE_CTRL__PATTERN_MODE__SHIFT    = 0x00000003;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_FIXED_PATTERN_MAX__SHIFT = 0x00000019;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_FIXED_PATTERN_MIN__SHIFT = 0x00000014;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_OVERRIDE__SHIFT    = 0x00000007;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_PERF_COUNTER_EN__SHIFT = 0x00000009;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_STALL_EN__SHIFT    = 0x00000002;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_THROT_INCR_STEP_INTERVAL__SHIFT = 0x0000000a;
    constexpr unsigned int GC_THROTTLE_CTRL__THROTTLE_CTRL_SW_RST__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_PF__SHIFT = 0x0000001f;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF0__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF1__SHIFT = 0x00000001;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF2__SHIFT = 0x00000002;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF3__SHIFT = 0x00000003;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF4__SHIFT = 0x00000004;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF5__SHIFT = 0x00000005;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF6__SHIFT = 0x00000006;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF7__SHIFT = 0x00000007;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF8__SHIFT = 0x00000008;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF9__SHIFT = 0x00000009;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF10__SHIFT = 0x0000000a;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF11__SHIFT = 0x0000000b;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF12__SHIFT = 0x0000000c;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF13__SHIFT = 0x0000000d;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF14__SHIFT = 0x0000000e;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF15__SHIFT = 0x0000000f;
    constexpr unsigned int MC_VM_XGMI_LFB_CNTL__PF_LFB_REGION__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_XGMI_LFB_CNTL__PF_MAX_REGION__SHIFT = 0x00000003;
    constexpr unsigned int MC_VM_XGMI_LFB_SIZE__PF_LFB_SIZE__SHIFT  = 0x00000000;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_SC_SEND_DB_VPZ_FOR_COMPOUND_INDEX_EN__SHIFT = 0x00000006;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_SC_SEND_DB_VPZ_FOR_EN_PIPELINE_PRIMID__SHIFT = 0x00000007;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_0__SHIFT       = 0x00000000;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_1__SHIFT       = 0x00000001;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_2__SHIFT       = 0x00000002;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_3__SHIFT       = 0x00000003;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_4__SHIFT       = 0x00000004;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_5__SHIFT       = 0x00000005;
    constexpr unsigned int PA_SC_ENHANCE_2__RSVD__SHIFT             = 0x00000008;
    constexpr unsigned int PA_STATE_STEREO_X__STEREO_X_OFFSET__SHIFT = 0x00000000;
    constexpr unsigned int PA_STEREO_CNTL__EN_STEREO__SHIFT         = 0x00000000;
    constexpr unsigned int PA_STEREO_CNTL__RT_SLICE_MODE__SHIFT     = 0x00000005;
    constexpr unsigned int PA_STEREO_CNTL__RT_SLICE_OFFSET__SHIFT   = 0x00000008;
    constexpr unsigned int PA_STEREO_CNTL__STEREO_MODE__SHIFT       = 0x00000001;
    constexpr unsigned int PA_STEREO_CNTL__VP_ID_MODE__SHIFT        = 0x0000000a;
    constexpr unsigned int PA_STEREO_CNTL__VP_ID_OFFSET__SHIFT      = 0x0000000d;
    constexpr unsigned int VML2_MEM_ECC_CNTL__DED_COUNT__SHIFT      = 0x00000016;
    constexpr unsigned int VML2_MEM_ECC_CNTL__DSM_IRRITATOR_DATA__SHIFT = 0x0000000e;
    constexpr unsigned int VML2_MEM_ECC_CNTL__ENABLE_ERROR_INJECT__SHIFT = 0x00000011;
    constexpr unsigned int VML2_MEM_ECC_CNTL__ENABLE_SINGLE_WRITE__SHIFT = 0x00000010;
    constexpr unsigned int VML2_MEM_ECC_CNTL__INDEX__SHIFT          = 0x00000000;
    constexpr unsigned int VML2_MEM_ECC_CNTL__INJECT_DELAY__SHIFT   = 0x00000008;
    constexpr unsigned int VML2_MEM_ECC_CNTL__SEC_COUNT__SHIFT      = 0x00000014;
    constexpr unsigned int VML2_MEM_ECC_CNTL__SELECT_INJECT_DELAY__SHIFT = 0x00000013;
    constexpr unsigned int VML2_MEM_ECC_CNTL__WRITE_COUNTERS__SHIFT = 0x00000018;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__DED_COUNT__SHIFT = 0x00000016;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__DSM_IRRITATOR_DATA__SHIFT = 0x0000000e;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__ENABLE_ERROR_INJECT__SHIFT = 0x00000011;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__ENABLE_SINGLE_WRITE__SHIFT = 0x00000010;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__INDEX__SHIFT   = 0x00000000;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__INJECT_DELAY__SHIFT = 0x00000008;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__SEC_COUNT__SHIFT = 0x00000014;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__SELECT_INJECT_DELAY__SHIFT = 0x00000013;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__WRITE_COUNTERS__SHIFT = 0x00000018;
} // namespace Vg12

namespace Vg20
{
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_alloc_opco_error__SHIFT = 0x00000002;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_dealloc_opco_error__SHIFT = 0x00000003;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_dec_error__SHIFT = 0x00000001;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_error_ds_address__SHIFT = 0x00000008;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_wrap_opco_error__SHIFT = 0x00000004;
    constexpr unsigned int alloc_DEBUG_DATA__GDS_DEBUG_REG5_write_dis__SHIFT = 0x00000000;
    constexpr unsigned int alloc_DEBUG_DATA__Reserved0__SHIFT       = 0x00000005;
    constexpr unsigned int alloc_DEBUG_DATA__Reserved1__SHIFT       = 0x00000016;
    constexpr unsigned int CP_ECC_DMA_FIRST_OCCURRENCE__CLIENT__SHIFT = 0x00000004;
    constexpr unsigned int CP_ECC_DMA_FIRST_OCCURRENCE__INTERFACE__SHIFT = 0x00000000;
    constexpr unsigned int CP_ECC_DMA_FIRST_OCCURRENCE__ME__SHIFT   = 0x00000008;
    constexpr unsigned int CP_ECC_DMA_FIRST_OCCURRENCE__PIPE__SHIFT = 0x0000000a;
    constexpr unsigned int CP_ECC_DMA_FIRST_OCCURRENCE__QUEUE__SHIFT = 0x0000000c;
    constexpr unsigned int CP_ECC_DMA_FIRST_OCCURRENCE__VMID__SHIFT = 0x00000010;
    constexpr unsigned int CP_EDC_FUE_CNTL__CP_FUE_FLAG__SHIFT      = 0x00000010;
    constexpr unsigned int CP_EDC_FUE_CNTL__CP_FUE_MASK__SHIFT      = 0x00000000;
    constexpr unsigned int CP_EDC_FUE_CNTL__GDS_FUE_FLAG__SHIFT     = 0x00000012;
    constexpr unsigned int CP_EDC_FUE_CNTL__GDS_FUE_MASK__SHIFT     = 0x00000002;
    constexpr unsigned int CP_EDC_FUE_CNTL__SPI_FUE_FLAG__SHIFT     = 0x00000011;
    constexpr unsigned int CP_EDC_FUE_CNTL__SPI_FUE_MASK__SHIFT     = 0x00000001;
    constexpr unsigned int CP_EDC_FUE_CNTL__TCA_FUE_FLAG__SHIFT     = 0x00000015;
    constexpr unsigned int CP_EDC_FUE_CNTL__TCA_FUE_MASK__SHIFT     = 0x00000005;
    constexpr unsigned int CP_EDC_FUE_CNTL__TCC_FUE_FLAG__SHIFT     = 0x00000016;
    constexpr unsigned int CP_EDC_FUE_CNTL__TCC_FUE_MASK__SHIFT     = 0x00000006;
    constexpr unsigned int CP_EDC_FUE_CNTL__TC_CPG_FUE_FLAG__SHIFT  = 0x00000014;
    constexpr unsigned int CP_EDC_FUE_CNTL__TC_CPG_FUE_MASK__SHIFT  = 0x00000004;
    constexpr unsigned int CP_EDC_FUE_CNTL__TC_RLC_FUE_FLAG__SHIFT  = 0x00000013;
    constexpr unsigned int CP_EDC_FUE_CNTL__TC_RLC_FUE_MASK__SHIFT  = 0x00000003;
    constexpr unsigned int CP_EDC_FUE_CNTL__UTCL2_FUE_FLAG__SHIFT   = 0x00000017;
    constexpr unsigned int CP_EDC_FUE_CNTL__UTCL2_FUE_MASK__SHIFT   = 0x00000007;
    constexpr unsigned int DB_DEBUG4__DISABLE_8PPC_OBJPRIMID_WHEN_NO_SHADER_EXPORTS__SHIFT = 0x0000001e;
    constexpr unsigned int GC_CAC_ACC_CBR0__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CBR1__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CBR2__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CBR3__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU5__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU6__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU7__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU8__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU9__ACCUMULATOR_31_0__SHIFT  = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU10__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU11__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU12__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU13__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU14__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_CU15__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_DBR0__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_DBR1__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_DBR2__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_ACC_DBR3__ACCUMULATOR_31_0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_CNTL__CAC_FORCE_DISABLE__SHIFT    = 0x00000000;
    constexpr unsigned int GC_CAC_INDEX_AUTO_INCR_EN__GC_CAC_INDEX_AUTO_INCR_EN__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_OVRD_CBR__OVRRD_SELECT__SHIFT     = 0x00000000;
    constexpr unsigned int GC_CAC_OVRD_CBR__OVRRD_VALUE__SHIFT      = 0x00000004;
    constexpr unsigned int GC_CAC_OVRD_DBR__OVRRD_SELECT__SHIFT     = 0x00000000;
    constexpr unsigned int GC_CAC_OVRD_DBR__OVRRD_VALUE__SHIFT      = 0x00000004;
    constexpr unsigned int GC_CAC_WEIGHT_CBR_0__WEIGHT_CBR_SIG0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_CBR_0__WEIGHT_CBR_SIG1__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_CBR_1__WEIGHT_CBR_SIG2__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_CBR_1__WEIGHT_CBR_SIG3__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_DBR_0__WEIGHT_DBR_SIG0__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_DBR_0__WEIGHT_DBR_SIG1__SHIFT = 0x00000010;
    constexpr unsigned int GC_CAC_WEIGHT_DBR_1__WEIGHT_DBR_SIG2__SHIFT = 0x00000000;
    constexpr unsigned int GC_CAC_WEIGHT_DBR_1__WEIGHT_DBR_SIG3__SHIFT = 0x00000010;
    constexpr unsigned int GC_DIDT_CTRL0__DIDT_PSM_SELECTION__SHIFT = 0x00000009;
    constexpr unsigned int GC_DIDT_WEIGHT_1__DBR_WEIGHT__SHIFT      = 0x00000000;
    constexpr unsigned int GC_EDC_CTRL__EDC_PSM_SELECTION__SHIFT    = 0x0000000a;
    constexpr unsigned int GC_EDC_CTRL__EDC_THROTTLE_PATTERN_BIT_NUMS__SHIFT = 0x0000000c;
    constexpr unsigned int GC_EDC_CTRL__GC_EDC_ONLY_MODE__SHIFT     = 0x0000000b;
    constexpr unsigned int GC_EDC_CTRL__PCC_THROTTLE_PATTERN_BIT_NUMS__SHIFT = 0x00000010;
    constexpr unsigned int GC_EDC_CTRL__RELEASE_STEP_INTERVAL__SHIFT = 0x00000014;
    constexpr unsigned int GC_EDC_PERF_COUNTER__EDC_PERF_COUNTER__SHIFT = 0x00000000;
    constexpr unsigned int GC_EDC_STATUS__THROTTLE_PATTERN_INDEX__SHIFT = 0x0000001a;
    constexpr unsigned int GC_THROTTLE_CTRL__GC_EDC_OVERRIDE__SHIFT = 0x00000004;
    constexpr unsigned int GC_THROTTLE_CTRL__GC_EDC_PERF_COUNTER_EN__SHIFT = 0x00000008;
    constexpr unsigned int GC_THROTTLE_CTRL__GC_EDC_STALL_EN__SHIFT = 0x00000001;
    constexpr unsigned int GC_THROTTLE_CTRL__INST_THROT_DECR__SHIFT = 0x0000001f;
    constexpr unsigned int GC_THROTTLE_CTRL__INST_THROT_INCR__SHIFT = 0x0000001e;
    constexpr unsigned int GC_THROTTLE_CTRL__PATTERN_MODE__SHIFT    = 0x00000003;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_FIXED_PATTERN_MAX__SHIFT = 0x00000019;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_FIXED_PATTERN_MIN__SHIFT = 0x00000014;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_OVERRIDE__SHIFT    = 0x00000007;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_PERF_COUNTER_EN__SHIFT = 0x00000009;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_STALL_EN__SHIFT    = 0x00000002;
    constexpr unsigned int GC_THROTTLE_CTRL__PCC_THROT_INCR_STEP_INTERVAL__SHIFT = 0x0000000a;
    constexpr unsigned int GC_THROTTLE_CTRL__THROTTLE_CTRL_SW_RST__SHIFT = 0x00000000;
    constexpr unsigned int gws_DEBUG_DATA__credit_cnt__SHIFT        = 0x00000010;
    constexpr unsigned int gws_DEBUG_DATA__cur_reso_5to0__SHIFT     = 0x00000003;
    constexpr unsigned int gws_DEBUG_DATA__cur_reso_count__SHIFT    = 0x0000000f;
    constexpr unsigned int gws_DEBUG_DATA__Reserved0__SHIFT         = 0x00000018;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_PF__SHIFT = 0x0000001f;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF0__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF1__SHIFT = 0x00000001;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF2__SHIFT = 0x00000002;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF3__SHIFT = 0x00000003;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF4__SHIFT = 0x00000004;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF5__SHIFT = 0x00000005;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF6__SHIFT = 0x00000006;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF7__SHIFT = 0x00000007;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF8__SHIFT = 0x00000008;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF9__SHIFT = 0x00000009;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF10__SHIFT = 0x0000000a;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF11__SHIFT = 0x0000000b;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF12__SHIFT = 0x0000000c;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF13__SHIFT = 0x0000000d;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF14__SHIFT = 0x0000000e;
    constexpr unsigned int MC_VM_XGMI_GPUIOV_ENABLE__ENABLE_VF15__SHIFT = 0x0000000f;
    constexpr unsigned int MC_VM_XGMI_LFB_CNTL__PF_LFB_REGION__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_XGMI_LFB_CNTL__PF_MAX_REGION__SHIFT = 0x00000004;
    constexpr unsigned int MC_VM_XGMI_LFB_SIZE__PF_LFB_SIZE__SHIFT  = 0x00000000;
    constexpr unsigned int oa_wc0_DEBUG_DATA__credit_cnt__SHIFT     = 0x00000001;
    constexpr unsigned int oa_wc0_DEBUG_DATA__req__SHIFT            = 0x00000008;
    constexpr unsigned int oa_wc0_DEBUG_DATA__Reserved0__SHIFT      = 0x00000013;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy0__SHIFT    = 0x0000000b;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy1__SHIFT    = 0x0000000c;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy2__SHIFT    = 0x0000000d;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy3__SHIFT    = 0x0000000e;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy4__SHIFT    = 0x0000000f;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy5__SHIFT    = 0x00000010;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy6__SHIFT    = 0x00000011;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy7__SHIFT    = 0x00000012;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe0_busy__SHIFT     = 0x00000000;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe1_busy__SHIFT     = 0x00000001;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe2_busy__SHIFT     = 0x00000002;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe3_busy__SHIFT     = 0x00000003;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe4_busy__SHIFT     = 0x00000004;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe5_busy__SHIFT     = 0x00000005;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe6_busy__SHIFT     = 0x00000006;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe7_busy__SHIFT     = 0x00000007;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe8_busy__SHIFT     = 0x00000008;
    constexpr unsigned int oa_wc1_DEBUG_DATA__pipe9_busy__SHIFT     = 0x00000009;
    constexpr unsigned int oa_wc1_DEBUG_DATA__Pipe10_busy__SHIFT    = 0x0000000a;
    constexpr unsigned int oa_wc1_DEBUG_DATA__Reserved0__SHIFT      = 0x00000013;
    constexpr unsigned int ord_app_DEBUG_DATA__fifo_busy__SHIFT     = 0x00000000;
    constexpr unsigned int ord_app_DEBUG_DATA__ord_busy__SHIFT      = 0x00000001;
    constexpr unsigned int ord_app_DEBUG_DATA__Reserved0__SHIFT     = 0x00000003;
    constexpr unsigned int ord_app_DEBUG_DATA__Reserved1__SHIFT     = 0x0000000c;
    constexpr unsigned int ord_app_DEBUG_DATA__sh0_cmd_fifo_empty__SHIFT = 0x00000004;
    constexpr unsigned int ord_app_DEBUG_DATA__sh0_data_fifo_empty__SHIFT = 0x00000008;
    constexpr unsigned int ord_app_DEBUG_DATA__sh1_cmd_fifo_empty__SHIFT = 0x00000005;
    constexpr unsigned int ord_app_DEBUG_DATA__sh1_data_fifo_empty__SHIFT = 0x00000009;
    constexpr unsigned int ord_app_DEBUG_DATA__sh2_cmd_fifo_empty__SHIFT = 0x00000006;
    constexpr unsigned int ord_app_DEBUG_DATA__sh2_data_fifo_empty__SHIFT = 0x0000000a;
    constexpr unsigned int ord_app_DEBUG_DATA__sh3_cmd_fifo_empty__SHIFT = 0x00000007;
    constexpr unsigned int ord_app_DEBUG_DATA__sh3_data_fifo_empty__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG00_0__ccgen_to_clipcc_fifo_empty__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG00_0__ccgen_to_clipcc_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG00_0__clipcode_fifo_fifo_empty__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG00_0__clipcode_fifo_full__SHIFT  = 0x0000000e;
    constexpr unsigned int PA_DEBUG00_0__clip_ga_bc_fifo_write__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG00_0__clip_to_ga_fifo_full__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG00_0__clip_to_ga_fifo_write__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG00_0__clip_to_outsm_fifo_empty__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG00_0__clip_to_outsm_fifo_full__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG00_0__clip_to_outsm_fifo_write__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG00_0__primic_to_clprim_fifo_empty__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG00_0__primic_to_clprim_fifo_full__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG00_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG00_0__su_clip_baryc_free__SHIFT  = 0x00000001;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clipp_fifo_empty__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clipp_fifo_full__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clipp_fifo_write__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clips_fifo_empty__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG00_0__vgt_to_clips_fifo_full__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG00_0__vte_out_clip_fifo_fifo_empty__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG00_0__vte_out_clip_fifo_fifo_full__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG00_0__vte_out_orig_fifo_fifo_empty__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG00_0__vte_out_orig_fifo_fifo_full__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG00_0__vte_out_orig_fifo_fifo_write__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG00_1__available_positions__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG00_1__ccgen_to_clipcc_fifo_full__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG00_1__ccgen_to_clipcc_write__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG00_1__current_state__SHIFT       = 0x0000000d;
    constexpr unsigned int PA_DEBUG00_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG00_1__statevar_bits_vs_out_ccdist0_vec_ena__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG00_1__statevar_bits_vs_out_ccdist1_vec_ena__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG00_1__sx0_receive_fifo_empty__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG00_1__sx0_receive_fifo_full__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG00_1__sx0_receive_fifo_write__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG00_1__vertex_fifo_empty__SHIFT   = 0x0000000f;
    constexpr unsigned int PA_DEBUG00_1__vertex_fifo_entriesavailable__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG00_1__vertex_fifo_full__SHIFT    = 0x00000010;
    constexpr unsigned int PA_DEBUG00_1__vgt_to_ccgen_fifo_empty__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG00_1__vgt_to_ccgen_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG01_0__clip_extra_bc_valid__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG01_0__clip_ga_bc_fifo_write__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG01_0__clip_to_ga_fifo_write__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG01_0__clip_to_outsm_deallocate_slot__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG01_0__clip_to_outsm_null_primitive__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG01_0__clip_to_outsm_vertex_deallocate__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG01_0__clip_vert_vte_valid__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG01_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_fifo_fifo_advanceread__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_fifo_fifo_empty__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_rd_extra_bc_valid__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_rd_vertex_store_indx__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG01_0__vte_out_clip_rd_vte_naninf_kill__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG01_0__vte_positions_vte_clip_vte_naninf_kill_0__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG01_0__vte_positions_vte_clip_vte_naninf_kill_1__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG01_0__vte_positions_vte_clip_vte_naninf_kill_2__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG01_1__ALWAYS_ZERO__SHIFT         = 0x00000000;
    constexpr unsigned int PA_DEBUG01_1__clip_extra_bc_valid__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG01_1__clip_ga_bc_fifo_write__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG01_1__clip_to_ga_fifo_write__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG01_1__clip_to_outsm_vertex_deallocate__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG01_1__clip_vert_vte_valid__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG01_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_fifo_fifo_advanceread__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_fifo_fifo_empty__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_rd_extra_bc_valid__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_rd_vertex_store_indx__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG01_1__vte_out_clip_rd_vte_naninf_kill__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG02_0__clip_ga_bc_fifo_full__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG02_0__clip_ga_bc_fifo_write__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG02_0__clip_to_clipga_extra_bc_coords__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG02_0__clip_to_clipga_vte_naninf_kill__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG02_0__clip_to_ga_fifo_full__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG02_0__clip_to_ga_fifo_write__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_clipped_prim__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_end_of_packet__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_fifo_advanceread__SHIFT = 0x0000001e;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_fifo_empty__SHIFT = 0x0000001f;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_first_prim_of_slot__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_null_primitive__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_vertex_store_indx_0__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_vertex_store_indx_1__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG02_0__clip_to_outsm_vertex_store_indx_2__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG02_1__clip_extra_bc_valid__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG02_1__clip_ga_bc_fifo_full__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG02_1__clip_ga_bc_fifo_write__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG02_1__clip_to_ga_fifo_full__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG02_1__clip_to_ga_fifo_write__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_clipped_prim__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_clip_seq_indx__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_fifo_advanceread__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_fifo_empty__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_null_primitive__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_vertex_store_indx_1__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG02_1__clip_to_outsm_vertex_store_indx_2__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG02_1__clip_vert_vte_valid__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG02_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_clip_code_or__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_clip_primitive__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_deallocate_slot__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_end_of_packet__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_event_id__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_first_prim_of_slot__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG03_0__clipsm0_clprim_to_clip_state_var_indx__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG03_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_clip_code_or__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_deallocate_slot__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_end_of_packet__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_event_id__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_first_prim_of_slot__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG03_1__clipsm0_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG03_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_param_cache_indx_0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_vertex_store_indx_0__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_vertex_store_indx_1__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG04_0__clipsm0_clprim_to_clip_vertex_store_indx_2__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG04_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_param_cache_indx_0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_vertex_store_indx_0__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG04_1__clipsm0_clprim_to_clip_vertex_store_indx_2__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG04_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_clip_code_or__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_clip_primitive__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_deallocate_slot__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_end_of_packet__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_event_id__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_first_prim_of_slot__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG05_0__clipsm1_clprim_to_clip_state_var_indx__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG05_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_clip_code_or__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_deallocate_slot__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_end_of_packet__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_event_id__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_first_prim_of_slot__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG05_1__clipsm1_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG05_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_param_cache_indx_0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_vertex_store_indx_0__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_vertex_store_indx_1__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG06_0__clipsm1_clprim_to_clip_vertex_store_indx_2__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG06_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_param_cache_indx_0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_vertex_store_indx_0__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG06_1__clipsm1_clprim_to_clip_vertex_store_indx_2__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG06_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_clip_code_or__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_clip_primitive__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_deallocate_slot__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_end_of_packet__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_event_id__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_first_prim_of_slot__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG07_0__clipsm2_clprim_to_clip_state_var_indx__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG07_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_clip_code_or__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_deallocate_slot__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_end_of_packet__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_event_id__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_first_prim_of_slot__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG07_1__clipsm2_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG07_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_param_cache_indx_0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_vertex_store_indx_0__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_vertex_store_indx_1__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG08_0__clipsm2_clprim_to_clip_vertex_store_indx_2__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG08_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_param_cache_indx_0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_vertex_store_indx_0__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG08_1__clipsm2_clprim_to_clip_vertex_store_indx_2__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG08_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_clip_code_or__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_clip_primitive__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_deallocate_slot__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_end_of_packet__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_event_id__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_first_prim_of_slot__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG09_0__clipsm3_clprim_to_clip_state_var_indx__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG09_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_clip_code_or__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_deallocate_slot__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_end_of_packet__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_event_id__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_first_prim_of_slot__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG09_1__clipsm3_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG09_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_param_cache_indx_0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_vertex_store_indx_0__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_vertex_store_indx_1__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG10_0__clipsm3_clprim_to_clip_vertex_store_indx_2__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG10_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_event__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_null_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_param_cache_indx_0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_vertex_store_indx_0__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG10_1__clipsm3_clprim_to_clip_vertex_store_indx_2__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG11_0__clipsm0_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG11_0__clipsm0_clip_to_clipga_prim_valid__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG11_0__clipsm0_inc_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG11_0__clipsm1_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG11_0__clipsm1_clip_to_clipga_prim_valid__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG11_0__clipsm1_inc_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG11_0__clipsm2_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG11_0__clipsm2_clip_to_clipga_prim_valid__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG11_0__clipsm2_inc_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG11_0__clipsm3_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG11_0__clipsm3_clip_to_clipga_prim_valid__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG11_0__clipsm3_inc_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG11_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG11_1__clipsm0_clip_to_clipga_clip_primitive__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG11_1__clipsm0_clip_to_clipga_event__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG11_1__clipsm0_clip_to_clipga_prim_valid__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG11_1__clipsm0_inc_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG11_1__clipsm1_clip_to_clipga_clip_primitive__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG11_1__clipsm1_clip_to_clipga_event__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG11_1__clipsm1_clip_to_clipga_prim_valid__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG11_1__clipsm1_inc_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_clip_to_clipga_clip_primitive__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_clip_to_clipga_event__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_clip_to_clipga_prim_valid__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG11_1__clipsm2_inc_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_clip_to_clipga_clip_primitive__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_clip_to_clipga_event__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_clip_to_clipga_prim_valid__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG11_1__clipsm3_inc_clip_to_clipga_clip_to_outsm_cnt__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG11_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG12_0__clipsm0_clprim_to_clip_clip_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG12_0__clipsm0_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG12_0__clipsm1_clprim_to_clip_clip_primitive__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG12_0__clipsm1_clprim_to_clip_prim_valid__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG12_0__clipsm2_clprim_to_clip_clip_primitive__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG12_0__clipsm2_clprim_to_clip_prim_valid__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG12_0__clipsm3_clprim_to_clip_clip_primitive__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG12_0__clipsm3_clprim_to_clip_prim_valid__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_available_clip_verts__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_available_vte_out_clip__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_seq_indx_load__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_seq_indx_out__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG12_0__clip_priority_seq_indx_vert__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG12_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG12_1__ALWAYS_ZERO__SHIFT         = 0x00000000;
    constexpr unsigned int PA_DEBUG12_1__clipsm0_clprim_to_clip_clip_primitive__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG12_1__clipsm0_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG12_1__clipsm1_clprim_to_clip_clip_primitive__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG12_1__clipsm1_clprim_to_clip_prim_valid__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG12_1__clipsm2_clprim_to_clip_clip_primitive__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG12_1__clipsm2_clprim_to_clip_prim_valid__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG12_1__clipsm3_clprim_to_clip_clip_primitive__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG12_1__clipsm3_clprim_to_clip_prim_valid__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG12_1__clip_priority_available_clip_verts__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG12_1__clip_priority_available_vte_out_clip__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG12_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG13_0__ccgen_to_clipcc_fifo_empty__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG13_0__clipcc_vertex_store_indx__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG13_0__clipcode_fifo_fifo_empty__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG13_0__clip_priority_seq_indx_out_cnt__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_fifo_advanceread__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_fifo_contents__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_fifo_full__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_fifo_write__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_rd_clipsm_wait__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG13_0__outsm_clr_rd_orig_vertices__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG13_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG13_0__vertval_bits_vertex_cc_next_valid__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG13_0__vte_out_orig_fifo_fifo_empty__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG13_1__clipcc_vertex_store_indx__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG13_1__clipcode_fifo_fifo_empty__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG13_1__clprim_clip_primitive__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG13_1__clprim_cull_primitive__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG13_1__clprim_in_back_state_var_indx__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG13_1__outsm_clr_fifo_advanceread__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG13_1__outsm_clr_fifo_contents__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG13_1__outsm_clr_fifo_full__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG13_1__outsm_clr_fifo_write__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG13_1__point_clip_candidate__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG13_1__prim_back_valid__SHIFT     = 0x00000007;
    constexpr unsigned int PA_DEBUG13_1__prim_nan_kill__SHIFT       = 0x00000004;
    constexpr unsigned int PA_DEBUG13_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG13_1__vertval_bits_vertex_cc_next_valid__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG13_1__vte_out_orig_fifo_fifo_empty__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_deallocate_slot__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_end_of_packet__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_event_id__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_event__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_first_prim_of_slot__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_vertex_store_indx_0__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG14_0__clprim_in_back_vertex_store_indx_1__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG14_0__outputclprimtoclip_null_primitive__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG14_0__prim_back_valid__SHIFT     = 0x00000017;
    constexpr unsigned int PA_DEBUG14_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_event_id__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_event__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_vertex_store_indx_0__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_vertex_store_indx_1__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG14_1__clprim_in_back_vertex_store_indx_2__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG14_1__prim_back_valid__SHIFT     = 0x00000017;
    constexpr unsigned int PA_DEBUG14_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG15_0__primic_to_clprim_fifo_vertex_store_indx_0__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG15_0__primic_to_clprim_fifo_vertex_store_indx_1__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG15_0__primic_to_clprim_fifo_vertex_store_indx_2__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG15_0__primic_to_clprim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG15_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG15_0__vertval_bits_vertex_vertex_store_msb__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG15_1__primic_to_clprim_fifo_vertex_store_indx_0__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG15_1__primic_to_clprim_fifo_vertex_store_indx_1__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG15_1__primic_to_clprim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG15_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG15_1__vertval_bits_vertex_vertex_store_msb__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG16_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG16_0__sm0_clip_to_clipga_clip_to_outsm_cnt_eq0__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG16_0__sm0_clip_to_outsm_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG16_0__sm0_clip_vert_cnt__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG16_0__sm0_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG16_0__sm0_current_state__SHIFT   = 0x0000000c;
    constexpr unsigned int PA_DEBUG16_0__sm0_highest_priority_seq__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG16_0__sm0_inv_to_clip_data_valid_0__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG16_0__sm0_inv_to_clip_data_valid_1__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG16_0__sm0_outputcliptoga_0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG16_0__sm0_vertex_clip_cnt__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG16_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG16_1__sm0_clip_to_clipga_clip_to_outsm_cnt_eq0__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG16_1__sm0_clip_to_outsm_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG16_1__sm0_clip_vert_cnt__SHIFT   = 0x00000008;
    constexpr unsigned int PA_DEBUG16_1__sm0_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG16_1__sm0_current_state__SHIFT   = 0x00000010;
    constexpr unsigned int PA_DEBUG16_1__sm0_highest_priority_seq__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG16_1__sm0_outputcliptoga_0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG16_1__sm0_prim_end_state__SHIFT  = 0x00000000;
    constexpr unsigned int PA_DEBUG16_1__sm0_ps_expand__SHIFT       = 0x00000007;
    constexpr unsigned int PA_DEBUG16_1__sm0_vertex_clip_cnt__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG17_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG17_0__sm1_clip_to_clipga_clip_to_outsm_cnt_eq0__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG17_0__sm1_clip_to_outsm_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG17_0__sm1_clip_vert_cnt__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG17_0__sm1_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG17_0__sm1_current_state__SHIFT   = 0x0000000c;
    constexpr unsigned int PA_DEBUG17_0__sm1_highest_priority_seq__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG17_0__sm1_inv_to_clip_data_valid_0__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG17_0__sm1_inv_to_clip_data_valid_1__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG17_0__sm1_outputcliptoga_0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG17_0__sm1_vertex_clip_cnt__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG17_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG17_1__sm1_clip_to_clipga_clip_to_outsm_cnt_eq0__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG17_1__sm1_clip_to_outsm_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG17_1__sm1_clip_vert_cnt__SHIFT   = 0x00000008;
    constexpr unsigned int PA_DEBUG17_1__sm1_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG17_1__sm1_current_state__SHIFT   = 0x00000010;
    constexpr unsigned int PA_DEBUG17_1__sm1_highest_priority_seq__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG17_1__sm1_outputcliptoga_0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG17_1__sm1_prim_end_state__SHIFT  = 0x00000000;
    constexpr unsigned int PA_DEBUG17_1__sm1_ps_expand__SHIFT       = 0x00000007;
    constexpr unsigned int PA_DEBUG17_1__sm1_vertex_clip_cnt__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG18_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG18_0__sm2_clip_to_clipga_clip_to_outsm_cnt_eq0__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG18_0__sm2_clip_to_outsm_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG18_0__sm2_clip_vert_cnt__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG18_0__sm2_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG18_0__sm2_current_state__SHIFT   = 0x0000000c;
    constexpr unsigned int PA_DEBUG18_0__sm2_highest_priority_seq__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG18_0__sm2_inv_to_clip_data_valid_0__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG18_0__sm2_inv_to_clip_data_valid_1__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG18_0__sm2_outputcliptoga_0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG18_0__sm2_vertex_clip_cnt__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG18_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG18_1__sm2_clip_to_clipga_clip_to_outsm_cnt_eq0__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG18_1__sm2_clip_to_outsm_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG18_1__sm2_clip_vert_cnt__SHIFT   = 0x00000008;
    constexpr unsigned int PA_DEBUG18_1__sm2_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG18_1__sm2_current_state__SHIFT   = 0x00000010;
    constexpr unsigned int PA_DEBUG18_1__sm2_highest_priority_seq__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG18_1__sm2_outputcliptoga_0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG18_1__sm2_prim_end_state__SHIFT  = 0x00000000;
    constexpr unsigned int PA_DEBUG18_1__sm2_ps_expand__SHIFT       = 0x00000007;
    constexpr unsigned int PA_DEBUG18_1__sm2_vertex_clip_cnt__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG19_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG19_0__sm3_clip_to_clipga_clip_to_outsm_cnt_eq0__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG19_0__sm3_clip_to_outsm_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG19_0__sm3_clip_vert_cnt__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG19_0__sm3_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG19_0__sm3_current_state__SHIFT   = 0x0000000c;
    constexpr unsigned int PA_DEBUG19_0__sm3_highest_priority_seq__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG19_0__sm3_inv_to_clip_data_valid_0__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG19_0__sm3_inv_to_clip_data_valid_1__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG19_0__sm3_outputcliptoga_0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG19_0__sm3_vertex_clip_cnt__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG19_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG19_1__sm3_clip_to_clipga_clip_to_outsm_cnt_eq0__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG19_1__sm3_clip_to_outsm_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG19_1__sm3_clip_vert_cnt__SHIFT   = 0x00000008;
    constexpr unsigned int PA_DEBUG19_1__sm3_clprim_to_clip_prim_valid__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG19_1__sm3_current_state__SHIFT   = 0x00000010;
    constexpr unsigned int PA_DEBUG19_1__sm3_highest_priority_seq__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG19_1__sm3_outputcliptoga_0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG19_1__sm3_prim_end_state__SHIFT  = 0x00000000;
    constexpr unsigned int PA_DEBUG19_1__sm3_ps_expand__SHIFT       = 0x00000007;
    constexpr unsigned int PA_DEBUG19_1__sm3_vertex_clip_cnt__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG20_0__point_address__SHIFT       = 0x00000000;
    constexpr unsigned int PA_DEBUG20_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_advance__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_aux_inc__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_aux_sel__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_pci__SHIFT   = 0x00000008;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_req_mask__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_sp_id__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG20_0__sx_pending_rd_state_var_indx__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG20_1__point_address__SHIFT       = 0x00000006;
    constexpr unsigned int PA_DEBUG20_1__position_address__SHIFT    = 0x00000000;
    constexpr unsigned int PA_DEBUG20_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_advance__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_aux_inc__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_aux_sel__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_pci__SHIFT   = 0x00000010;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_req_mask__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_sp_id__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG20_1__sx_pending_rd_state_var_indx__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG21_0__aux_sel__SHIFT             = 0x0000000c;
    constexpr unsigned int PA_DEBUG21_0__pasx_req_cnt_0__SHIFT      = 0x00000014;
    constexpr unsigned int PA_DEBUG21_0__pasx_req_cnt_1__SHIFT      = 0x00000010;
    constexpr unsigned int PA_DEBUG21_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG21_0__statevar_bits_disable_sp__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG21_0__statevar_bits_vs_out_misc_vec_ena__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG21_0__sx_pending_fifo_contents__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG21_0__sx_receive_indx__SHIFT     = 0x00000000;
    constexpr unsigned int PA_DEBUG21_0__sx_to_pa_empty_0__SHIFT    = 0x0000000f;
    constexpr unsigned int PA_DEBUG21_0__sx_to_pa_empty_1__SHIFT    = 0x0000000e;
    constexpr unsigned int PA_DEBUG21_1__available_positions__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG21_1__pasx_req_cnt_0__SHIFT      = 0x00000014;
    constexpr unsigned int PA_DEBUG21_1__pasx_req_cnt_1__SHIFT      = 0x00000010;
    constexpr unsigned int PA_DEBUG21_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG21_1__statevar_bits_vs_out_misc_vec_ena__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG21_1__sx_pending_fifo_contents__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG21_1__sx_receive_indx__SHIFT     = 0x00000007;
    constexpr unsigned int PA_DEBUG22_0__req_active_verts_loaded__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG22_0__req_active_verts__SHIFT    = 0x00000008;
    constexpr unsigned int PA_DEBUG22_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG22_0__su_aux__SHIFT              = 0x00000000;
    constexpr unsigned int PA_DEBUG22_0__sx_request_indx__SHIFT     = 0x00000001;
    constexpr unsigned int PA_DEBUG22_0__vgt_to_ccgen_active_verts__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG22_0__vgt_to_ccgen_state_var_indx__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG22_1__param_cache_base__SHIFT    = 0x00000000;
    constexpr unsigned int PA_DEBUG22_1__req_active_verts_loaded__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG22_1__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG22_1__su_aux__SHIFT              = 0x00000007;
    constexpr unsigned int PA_DEBUG22_1__sx_request_indx__SHIFT     = 0x00000009;
    constexpr unsigned int PA_DEBUG22_1__vgt_to_ccgen_active_verts__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG22_1__vgt_to_ccgen_state_var_indx__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG23_0__ALWAYS_ZERO__SHIFT         = 0x00000006;
    constexpr unsigned int PA_DEBUG23_0__event_id_gated_1to0__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG23_0__geom_busy__SHIFT           = 0x00000015;
    constexpr unsigned int PA_DEBUG23_0__geom_enable__SHIFT         = 0x0000000f;
    constexpr unsigned int PA_DEBUG23_0__ge_stallb__SHIFT           = 0x0000000e;
    constexpr unsigned int PA_DEBUG23_0__pfifo_busy__SHIFT          = 0x00000013;
    constexpr unsigned int PA_DEBUG23_0__pmode_state__SHIFT         = 0x00000008;
    constexpr unsigned int PA_DEBUG23_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG23_0__su_baryc_cntl_state__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG23_0__su_clip_baryc_free__SHIFT  = 0x00000010;
    constexpr unsigned int PA_DEBUG23_0__su_clip_rtr__SHIFT         = 0x00000012;
    constexpr unsigned int PA_DEBUG23_0__su_cntl_busy__SHIFT        = 0x00000014;
    constexpr unsigned int PA_DEBUG23_0__su_cntl_state__SHIFT       = 0x00000002;
    constexpr unsigned int PA_DEBUG24_0__cl_dyn_sclk_vld__SHIFT     = 0x00000007;
    constexpr unsigned int PA_DEBUG24_0__event_gated__SHIFT         = 0x00000004;
    constexpr unsigned int PA_DEBUG24_0__event_id_gated_5to2__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG24_0__pmode_prim_gated__SHIFT    = 0x00000005;
    constexpr unsigned int PA_DEBUG24_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG24_0__su_dyn_sclk_vld__SHIFT     = 0x00000006;
    constexpr unsigned int PA_DEBUG24_0__y_sort0_gated_23_8__SHIFT  = 0x00000008;
    constexpr unsigned int PA_DEBUG25_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG25_0__x_sort0_gated_23_8__SHIFT  = 0x00000000;
    constexpr unsigned int PA_DEBUG25_0__y_sort1_gated_15_8__SHIFT  = 0x00000010;
    constexpr unsigned int PA_DEBUG26_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG26_0__x_sort1_gated_23_8__SHIFT  = 0x00000008;
    constexpr unsigned int PA_DEBUG26_0__y_sort1_gated_23_16__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG27_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG27_0__x_sort2_gated_15_8__SHIFT  = 0x00000010;
    constexpr unsigned int PA_DEBUG27_0__y_sort2_gated_23_8__SHIFT  = 0x00000000;
    constexpr unsigned int PA_DEBUG28_0__attr_indx_sort0_gated__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG28_0__backfacing_gated__SHIFT    = 0x00000017;
    constexpr unsigned int PA_DEBUG28_0__null_prim_gated__SHIFT     = 0x00000016;
    constexpr unsigned int PA_DEBUG28_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG28_0__x_sort2_gated_23to16__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG29_0__attr_indx_sort2_gated_7to0__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG29_0__clipped_gated__SHIFT       = 0x00000003;
    constexpr unsigned int PA_DEBUG29_0__dealloc_slot_gated__SHIFT  = 0x00000004;
    constexpr unsigned int PA_DEBUG29_0__diamond_rule_gated__SHIFT  = 0x00000008;
    constexpr unsigned int PA_DEBUG29_0__eop_gated__SHIFT           = 0x0000000f;
    constexpr unsigned int PA_DEBUG29_0__fpov_gated__SHIFT          = 0x0000000d;
    constexpr unsigned int PA_DEBUG29_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG29_0__st_indx_gated__SHIFT       = 0x00000000;
    constexpr unsigned int PA_DEBUG29_0__type_gated__SHIFT          = 0x0000000a;
    constexpr unsigned int PA_DEBUG29_0__xmajor_gated__SHIFT        = 0x00000007;
    constexpr unsigned int PA_DEBUG30_0__attr_indx_sort1_gated__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG30_0__attr_indx_sort2_gated_13to8__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG30_0__pa_reg_sclk_vld__SHIFT     = 0x00000017;
    constexpr unsigned int PA_DEBUG30_0__provoking_vtx_gated__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG30_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG30_0__valid_prim_gated__SHIFT    = 0x00000016;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm0_clprim_to_clip_prim_valid__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm1_clprim_to_clip_prim_valid__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm2_clprim_to_clip_prim_valid__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm3_clprim_to_clip_prim_valid__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_clipsm_clip_to_outsm_fifo_write__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_outsm_clr_fifo_not_empty__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy_debug_primic_to_clprim_valid__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG31_0__clipper_busy__SHIFT        = 0x00000008;
    constexpr unsigned int PA_DEBUG31_0__PA0_SC0_send_q__SHIFT      = 0x00000003;
    constexpr unsigned int PA_DEBUG31_0__PA0_SC1_send_q__SHIFT      = 0x00000004;
    constexpr unsigned int PA_DEBUG31_0__PA_PA_pascDataOut_send0_q__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG31_0__PA_PA_pascDataOut_send1_q__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG31_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_geom_busy__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_hold_busy__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_pfifo_busy__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_su_cntl_busy__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG31_0__su_busy_debug_valid_prim_gated__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG31_0__su_busy__SHIFT             = 0x00000009;
    constexpr unsigned int PA_DEBUG31_0__VGT_PA_clipp_send_q__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG31_0__VGT_PA_clips_send_q__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG31_0__VGT_PA_clipv_send_q__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG31_0__vte_busy_debug_ib_busy__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG31_0__vte_busy_debug_veu_busy__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG31_0__vte_busy__SHIFT            = 0x00000007;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_ccgen_to_clipcc_fifo_busy__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_ccgen_to_clipcc_fifo_write__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipcode_fifo_fifo_busy__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipcode_fifo_fifo_write__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipsm0_current_state_not_empty__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipsm1_current_state_not_empty__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipsm2_current_state_not_empty__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clipsm3_current_state_not_empty__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clip_to_ga_bc_busy__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clip_to_ga_fifo_write__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clip_to_outsm_fifo_busy__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_clip_to_outsm_fifo_write__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_next_prim_back_valid__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_primic_to_clprim_fifo_not_empty__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_primic_to_clprim_fifo_write__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_prim_back_valid__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_sx_pending_fifo_not_empty__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vgt_to_clipp_fifo_busy__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vgt_to_clipp_fifo_write__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vgt_to_clips_fifo_busy__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vte_out_clip_fifo_fifo_busy__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vte_out_clip_fifo_fifo_write__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vte_out_orig_fifo_fifo_busy__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG32_0__clipper_busy_debug_vte_out_orig_fifo_fifo_write__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG32_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG33_0__clipper_busy_debug_vgt_to_clips_fifo_write__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG33_0__PA_SE3SC_freeze__SHIFT     = 0x00000004;
    constexpr unsigned int PA_DEBUG33_0__Reserved0__SHIFT           = 0x00000005;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_busy__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_rtr_in__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_rtr_out__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_rts_in__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_client_send_reg_rts_out__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_iclient_send_valid__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_iutcl1_send_ready__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_oclient_send_ready__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_outcl1_send_type__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_outcl1_send_valid__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_outcl1_send_vmid__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG34_0__ngg_sideband_utc_driver_tag__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG34_0__Reserved0__SHIFT           = 0x00000017;
    constexpr unsigned int PA_DEBUG34_1__ngg_utcl1_debug00__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_busy__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_empty__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_full__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_read__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_client_send_fifo_write__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_iclient_send_valid__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_iutcl1_send_ready__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_oclient_send_ready__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_outcl1_send_type__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_outcl1_send_valid__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_outcl1_send_vmid__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG35_0__ngg_index_utc_driver_tag__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG35_0__Reserved0__SHIFT           = 0x00000017;
    constexpr unsigned int PA_DEBUG35_1__ngg_utcl1_debug01__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_busy__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_empty__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_full__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_read__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_client_send_fifo_write__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_iclient_send_valid__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_iutcl1_send_ready__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_oclient_send_ready__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_outcl1_send_type__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_outcl1_send_valid__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_outcl1_send_vmid__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG36_0__ngg_position_utc_driver_tag__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG36_0__Reserved0__SHIFT           = 0x00000017;
    constexpr unsigned int PA_DEBUG36_1__ngg_utcl1_debug02__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_busy__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_drop__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_io__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_mtype__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_perf_cntr_en__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_rd_tmz_encr__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_snoop__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_space__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_tag__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_dataout_vmid__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_rtr_in__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_rtr_out__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_rts_in__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG37_0__ngg_debug_sideband_utc_receiver_output_reg_rts_out__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG37_0__Reserved0__SHIFT           = 0x0000001a;
    constexpr unsigned int PA_DEBUG37_1__ngg_utcl1_debug03__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_busy__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_drop__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_io__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_mtype__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_perf_cntr_en__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_rd_tmz_encr__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_snoop__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_space__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_tag__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_dataout_vmid__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_rtr_in__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_rtr_out__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_rts_in__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG38_0__ngg_debug_index_utc_receiver_output_reg_rts_out__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG38_0__Reserved0__SHIFT           = 0x0000001a;
    constexpr unsigned int PA_DEBUG38_1__ngg_utcl1_debug04__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_busy__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_drop__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_io__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_mtype__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_perf_cntr_en__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_rd_tmz_encr__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_snoop__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_space__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_tag__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_dataout_vmid__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_rtr_in__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_rtr_out__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_rts_in__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG39_0__ngg_debug_position_utc_receiver_output_reg_rts_out__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG39_0__Reserved0__SHIFT           = 0x0000001a;
    constexpr unsigned int PA_DEBUG39_1__ngg_utcl1_debug05__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG40_0__ngg_debug_tc_request_arbiter_current_client_count__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG40_0__ngg_debug_tc_request_arbiter_istream0_client_rts__SHIFT = 0x0000001f;
    constexpr unsigned int PA_DEBUG40_0__ngg_debug_tc_request_arbiter_istream0_client_tag__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG40_0__ngg_debug_tc_request_arbiter_ostream0_client_rtr__SHIFT = 0x0000001e;
    constexpr unsigned int PA_DEBUG40_1__ngg_utcl1_debug06__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_credits__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_credit_count_overflow__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_credit_count_underflow__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_data_rd_ptr__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_data_wr_ptr__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_irdreq_free__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_irdret_vld__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_irts_in__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_obusy__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_ooutstanding_tc_requests_exist__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_ordreq_clken__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_ordreq_send__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_ortr_in__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_outstanding_tc_requests__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_reg_valid0__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG41_0__ngg_debug_tc_if_reg_valid1__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG41_0__Reserved0__SHIFT           = 0x0000001d;
    constexpr unsigned int PA_DEBUG41_1__ngg_utcl1_debug07__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_current_dword_pointer__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_current_sideband_event_bit_set__SHIFT = 0x00000018;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_current_sideband_is_object_id__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_current_state__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_have_available_sideband_tokens__SHIFT = 0x00000019;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_itc_return_empty__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_pending_subgroup_count_not_zero__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_pending_subgroup_count_range__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_sideband_tokens_not_max_value__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_sideband_tokens_overflow__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_sideband_tokens_underflow__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_valid_dword_count__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG42_0__ngg_debug_sideband_wait_counter_busy__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG42_0__Reserved0__SHIFT           = 0x0000001a;
    constexpr unsigned int PA_DEBUG42_1__ngg_utcl1_debug08__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_current_state__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_osideband_active__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_ovmid__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_sideband_pop_bit_fifo_busy__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_sideband_pop_bit_fifo_empty__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_sideband_pop_bit_fifo_full__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_vmid_fifo_busy__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_vmid_fifo_empty__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG43_0__ngg_debug_sideband_wdif_vmid_fifo_full__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG43_0__Reserved0__SHIFT           = 0x0000000c;
    constexpr unsigned int PA_DEBUG43_1__ngg_utcl1_debug09__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents0_overflow__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents0_underflow__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents0__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents1_overflow__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents1_underflow__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG44_0__ngg_debug_sideband_memory_contents1__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG44_0__Reserved0__SHIFT           = 0x00000014;
    constexpr unsigned int PA_DEBUG44_1__ngg_utcl1_debug10__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_current_fetch_state__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_current_receive_finalt_dword_pointer__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_current_receive_first_dword_pointer__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_current_receive_state__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_final_receive_cacheline_this_subgroup__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_final_receive_dword_of_subgroup__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_have_available_index_tokens__SHIFT = 0x0000001d;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_receive_fifo_busy__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_receive_fifo_empty__SHIFT = 0x0000001b;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_receive_fifo_full__SHIFT = 0x0000001c;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_tokens_overflow__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_tokens_underflow__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_index_tokens__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_prim_indices_fifo_busy__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_sideband_data_context_id_bits__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_sideband_data_eop_bit__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG45_0__ngg_debug_index_sideband_data_event_bit__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG45_0__Reserved0__SHIFT           = 0x0000001e;
    constexpr unsigned int PA_DEBUG45_1__ngg_utcl1_debug11__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_active_pos_req_fosg__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_another_pos_fetch__SHIFT = 0x00000016;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_current_state__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_end_prev_diff__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_end_start_diff__SHIFT = 0x00000019;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_have_available_position_tokens__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_ifetch_to_primic_p_fifo_full__SHIFT = 0x00000015;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_ifetch_to_primic_s_fifo_full__SHIFT = 0x00000014;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_ipa_to_wd_dealloc_index_full__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_iposreq_to_posrtn_s_fifo_full__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_iposreq_to_posrtn_v_fifo_full__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_packer_object_id_valid__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_packer_sideband_valid__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_position_tokens_overflow__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_position_tokens_underflow__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_prev_pos_cacheline_valid__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_prev_select_end_cacheline_address__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_busy__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_final_prim__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_first_prim__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_miss_count__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_null_prim__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_reuse_prim_valid__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG46_0__ngg_debug_position_request_start_prev_diff__SHIFT = 0x00000018;
    constexpr unsigned int PA_DEBUG46_0__Reserved0__SHIFT           = 0x0000001a;
    constexpr unsigned int PA_DEBUG46_1__ngg_utcl1_debug12__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_current_state__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_iinput_sideband_valid__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_eop_bit__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_event_bit__SHIFT = 0x00000012;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_event_id__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_event_second_cycle__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_state_id__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_input_sideband_dword_stream_id__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_output_prim_empty__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_prim_fifo_busy__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_prim_fifo_full__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_sideband_fifo_busy__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_sideband_fifo_empty__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG47_0__ngg_debug_position_reuse_sideband_fifo_full__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG47_0__Reserved0__SHIFT           = 0x00000016;
    constexpr unsigned int PA_DEBUG47_1__ngg_utcl1_debug13__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_active_pos_return_cache_pos_index__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_active_pos_return_first_vert__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_active_pos_return_state__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_cache_pos_index__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_ifetch_to_sxif_fifo_full__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_ipa_to_wd_dealloc_position_full__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_itc_return_empty__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_oposreq_to_posrtn_s_fifo_full__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_oposreq_to_posrtn_v_fifo_full__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_posreq_to_posrtn_s_fifo_busy__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_posreq_to_posrtn_s_fifo_empty__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_posreq_to_posrtn_v_fifo_busy__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG48_0__ngg_debug_position_return_posreq_to_posrtn_v_fifo_empty__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG48_0__Reserved0__SHIFT           = 0x00000010;
    constexpr unsigned int PA_DEBUG48_1__ngg_utcl1_debug14__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_crawler_busy__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_memreg0_busy__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_memreg1_busy__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_memreg2_busy__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_oreturn_empty_stream0__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_oreturn_empty_stream1__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_oreturn_empty_stream2__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_return_data_read_reg_full_stream0__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_return_data_read_reg_full_stream1__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG49_0__ngg_debug_tc_return_if_return_data_read_reg_full_stream2__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG49_0__Reserved0__SHIFT           = 0x0000000a;
    constexpr unsigned int PA_DEBUG49_1__ngg_utcl1_debug15__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_encountered_error_writing_to_busy_location_stream0__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_encountered_error_writing_to_busy_location_stream1__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_encountered_error_writing_to_busy_location_stream2__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_memory_data_valid_stream0_count__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_memory_data_valid_stream1_count__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_memory_data_valid_stream2_count__SHIFT = 0x0000000f;
    constexpr unsigned int PA_DEBUG50_0__ngg_debug_return_crawler_obusy__SHIFT = 0x00000017;
    constexpr unsigned int PA_DEBUG50_0__Reserved0__SHIFT           = 0x00000018;
    constexpr unsigned int PA_DEBUG50_1__ngg_utcl1_debug16__SHIFT   = 0x00000000;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_amount__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_fifo_busy__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_index_full__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_position_full__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_state_var_index__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_opa_to_wd_dealloc_type__SHIFT = 0x00000013;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_pa_to_wd_dealloc_fifo_empty__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG51_0__ngg_debug_wd_dealloc_pa_to_wd_dealloc_fifo_read__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG51_0__Reserved0__SHIFT           = 0x00000014;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_all_clean__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_current_state__SHIFT = 0x00000011;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iindex_requester_idle__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iindex_utcl1_return_busy__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iindex_utcl1_send_busy__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_ioutstanding_tc_requests_exist__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iposition_requester_idle__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iposition_utcl1_return_busy__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iposition_utcl1_send_busy__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_isideband_requester_idle__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_isideband_utcl1_return_busy__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_isideband_utcl1_send_busy__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_iutcl1_busy__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_oclean__SHIFT = 0x00000010;
    constexpr unsigned int PA_DEBUG52_0__ngg_debug_shootdown_control_vmid_count__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG52_0__Reserved0__SHIFT           = 0x00000014;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_index_tokens_overflow__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_index_tokens_underflow__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_position_tokens_overflow__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_position_tokens_underflow__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sbmem_contents0_overflow__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sbmem_contents0_underflow__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sbmem_contents1_overflow__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sbmem_contents1_underflow__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sideband_tokens_overflow__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_sideband_tokens_underflow__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_tc_credit_count_overflow__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_tc_credit_count_underflow__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_writing_to_busy_location_stream0__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_writing_to_busy_location_stream1__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG53_0__ngg_debug_fatal_events_status_fatal_writing_to_busy_location_stream2__SHIFT = 0x0000000e;
    constexpr unsigned int PA_DEBUG53_0__Reserved0__SHIFT           = 0x0000000f;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_index_receive_fifo_full__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_pa_to_wd_dealloc_index_full__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_pa_to_wd_dealloc_position_full__SHIFT = 0x0000000d;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_posreq_to_posrtn_s_fifo_full__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_posreq_to_posrtn_v_fifo_full__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_prim_fifo_full__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_prim_indices_fifo_full__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_return_data_full_stream0__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_return_data_full_stream1__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_return_data_full_stream2__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_sbmem_full__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_sideband_fifo_full__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_sideband_pop_bit_fifo_full__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG54_0__ngg_debug_fifo_full_status_fifo_vmid_fifo_full__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG54_0__Reserved0__SHIFT           = 0x0000000e;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_index_receive_fifo_empty__SHIFT = 0x00000003;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_pa_to_wd_dealloc_fifo_empty__SHIFT = 0x0000000c;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_posreq_to_posrtn_s_fifo_empty__SHIFT = 0x00000008;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_posreq_to_posrtn_v_fifo_empty__SHIFT = 0x00000007;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_prim_fifo_empty__SHIFT = 0x00000005;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_prim_indices_fifo_empty__SHIFT = 0x00000004;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_return_data_empty_stream0__SHIFT = 0x00000009;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_return_data_empty_stream1__SHIFT = 0x0000000a;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_return_data_empty_stream2__SHIFT = 0x0000000b;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_sbmem_empty__SHIFT = 0x00000002;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_sideband_fifo_empty__SHIFT = 0x00000006;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_sideband_pop_bit_fifo_empty__SHIFT = 0x00000000;
    constexpr unsigned int PA_DEBUG55_0__ngg_debug_fifo_empty_status_fifo_vmid_fifo_empty__SHIFT = 0x00000001;
    constexpr unsigned int PA_DEBUG55_0__Reserved0__SHIFT           = 0x0000000d;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_SC_SEND_DB_VPZ_FOR_COMPOUND_INDEX_EN__SHIFT = 0x00000006;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_SC_SEND_DB_VPZ_FOR_EN_PIPELINE_PRIMID__SHIFT = 0x00000007;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_0__SHIFT       = 0x00000000;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_1__SHIFT       = 0x00000001;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_2__SHIFT       = 0x00000002;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_3__SHIFT       = 0x00000003;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_4__SHIFT       = 0x00000004;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_5__SHIFT       = 0x00000005;
    constexpr unsigned int PA_SC_ENHANCE_2__RSVD__SHIFT             = 0x00000008;
    constexpr unsigned int PA_STATE_STEREO_X__STEREO_X_OFFSET__SHIFT = 0x00000000;
    constexpr unsigned int PA_STEREO_CNTL__EN_STEREO__SHIFT         = 0x00000000;
    constexpr unsigned int PA_STEREO_CNTL__RT_SLICE_MODE__SHIFT     = 0x00000005;
    constexpr unsigned int PA_STEREO_CNTL__RT_SLICE_OFFSET__SHIFT   = 0x00000008;
    constexpr unsigned int PA_STEREO_CNTL__STEREO_MODE__SHIFT       = 0x00000001;
    constexpr unsigned int PA_STEREO_CNTL__VP_ID_MODE__SHIFT        = 0x0000000a;
    constexpr unsigned int PA_STEREO_CNTL__VP_ID_OFFSET__SHIFT      = 0x0000000d;
    constexpr unsigned int rbuf_DEBUG_DATA__pixel_addr_mask__SHIFT  = 0x00000002;
    constexpr unsigned int rbuf_DEBUG_DATA__Reserved0__SHIFT        = 0x00000018;
    constexpr unsigned int RLC_SPM_CBR0_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_CBR0_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_CBR1_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_CBR1_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_DBR0_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_DBR0_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_DBR1_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_DBR1_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RPB_EA_QUEUE_WR__READ_QUEUE__SHIFT       = 0x00000009;
    constexpr unsigned int RPB_EA_QUEUE_WR__UPDATE__SHIFT           = 0x0000000c;
    constexpr unsigned int RPB_EA_QUEUE_WR__WRITE_QUEUE__SHIFT      = 0x00000006;
    constexpr unsigned int RPB_TAG_CONF__RPB_ATS_PR__SHIFT          = 0x00000014;
    constexpr unsigned int RPB_TAG_CONF__RPB_IO_WR__SHIFT           = 0x0000000a;
    constexpr unsigned int SQ_CONFIG__DISABLE_BARRIER_WAITCNT__SHIFT = 0x00000000;
    constexpr unsigned int SQ_CONFIG__UNUSED__SHIFT                 = 0x00000001;
    constexpr unsigned int TA_DSM_CNTL2__TA_FL_LFIFO_ENABLE_ERROR_INJECT__SHIFT = 0x00000006;
    constexpr unsigned int TA_DSM_CNTL2__TA_FL_LFIFO_SELECT_INJECT_DELAY__SHIFT = 0x00000008;
    constexpr unsigned int TA_DSM_CNTL2__TA_FS_AFIFO_ENABLE_ERROR_INJECT__SHIFT = 0x00000003;
    constexpr unsigned int TA_DSM_CNTL2__TA_FS_AFIFO_SELECT_INJECT_DELAY__SHIFT = 0x00000005;
    constexpr unsigned int TA_DSM_CNTL2__TA_FS_CFIFO_ENABLE_ERROR_INJECT__SHIFT = 0x0000000c;
    constexpr unsigned int TA_DSM_CNTL2__TA_FS_CFIFO_SELECT_INJECT_DELAY__SHIFT = 0x0000000e;
    constexpr unsigned int TA_DSM_CNTL2__TA_FS_DFIFO_ENABLE_ERROR_INJECT__SHIFT = 0x00000000;
    constexpr unsigned int TA_DSM_CNTL2__TA_FS_DFIFO_SELECT_INJECT_DELAY__SHIFT = 0x00000002;
    constexpr unsigned int TA_DSM_CNTL2__TA_FX_LFIFO_ENABLE_ERROR_INJECT__SHIFT = 0x00000009;
    constexpr unsigned int TA_DSM_CNTL2__TA_FX_LFIFO_SELECT_INJECT_DELAY__SHIFT = 0x0000000b;
    constexpr unsigned int TA_DSM_CNTL2__TA_INJECT_DELAY__SHIFT     = 0x0000001a;
    constexpr unsigned int TA_DSM_CNTL__TA_FL_LFIFO_DSM_IRRITATOR_DATA__SHIFT = 0x00000006;
    constexpr unsigned int TA_DSM_CNTL__TA_FL_LFIFO_ENABLE_SINGLE_WRITE__SHIFT = 0x00000008;
    constexpr unsigned int TA_DSM_CNTL__TA_FS_AFIFO_DSM_IRRITATOR_DATA__SHIFT = 0x00000003;
    constexpr unsigned int TA_DSM_CNTL__TA_FS_AFIFO_ENABLE_SINGLE_WRITE__SHIFT = 0x00000005;
    constexpr unsigned int TA_DSM_CNTL__TA_FS_CFIFO_DSM_IRRITATOR_DATA__SHIFT = 0x0000000c;
    constexpr unsigned int TA_DSM_CNTL__TA_FS_CFIFO_ENABLE_SINGLE_WRITE__SHIFT = 0x0000000e;
    constexpr unsigned int TA_DSM_CNTL__TA_FS_DFIFO_DSM_IRRITATOR_DATA__SHIFT = 0x00000000;
    constexpr unsigned int TA_DSM_CNTL__TA_FS_DFIFO_ENABLE_SINGLE_WRITE__SHIFT = 0x00000002;
    constexpr unsigned int TA_DSM_CNTL__TA_FX_LFIFO_DSM_IRRITATOR_DATA__SHIFT = 0x00000009;
    constexpr unsigned int TA_DSM_CNTL__TA_FX_LFIFO_ENABLE_SINGLE_WRITE__SHIFT = 0x0000000b;
    constexpr unsigned int TA_EDC_CNT__TA_FL_LFIFO_SED_COUNT__SHIFT = 0x00000006;
    constexpr unsigned int TA_EDC_CNT__TA_FS_AFIFO_SED_COUNT__SHIFT = 0x00000004;
    constexpr unsigned int TA_EDC_CNT__TA_FS_CFIFO_SED_COUNT__SHIFT = 0x0000000a;
    constexpr unsigned int TA_EDC_CNT__TA_FS_DFIFO_DED_COUNT__SHIFT = 0x00000002;
    constexpr unsigned int TA_EDC_CNT__TA_FS_DFIFO_SEC_COUNT__SHIFT = 0x00000000;
    constexpr unsigned int TA_EDC_CNT__TA_FX_LFIFO_SED_COUNT__SHIFT = 0x00000008;
    constexpr unsigned int TCI_DSM_CNTL2__TCI_INJECT_DELAY__SHIFT   = 0x0000001a;
    constexpr unsigned int TCI_DSM_CNTL2__WRITE_RAM_ENABLE_ERROR_INJECT__SHIFT = 0x00000000;
    constexpr unsigned int TCI_DSM_CNTL2__WRITE_RAM_SELECT_INJECT_DELAY__SHIFT = 0x00000002;
    constexpr unsigned int TCI_DSM_CNTL__WRITE_RAM_IRRITATOR_DATA_SEL__SHIFT = 0x00000000;
    constexpr unsigned int TCI_DSM_CNTL__WRITE_RAM_IRRITATOR_SINGLE_WRITE__SHIFT = 0x00000002;
    constexpr unsigned int TCI_EDC_CNT__WRITE_RAM_SED_COUNT__SHIFT  = 0x00000000;
    constexpr unsigned int TD_EDC_CNT__CS_FIFO_SED_COUNT__SHIFT     = 0x00000008;
    constexpr unsigned int TD_EDC_CNT__SS_FIFO_HI_DED_COUNT__SHIFT  = 0x00000006;
    constexpr unsigned int TD_EDC_CNT__SS_FIFO_HI_SEC_COUNT__SHIFT  = 0x00000004;
    constexpr unsigned int TD_EDC_CNT__SS_FIFO_LO_DED_COUNT__SHIFT  = 0x00000002;
    constexpr unsigned int TD_EDC_CNT__SS_FIFO_LO_SEC_COUNT__SHIFT  = 0x00000000;
    constexpr unsigned int VML2_MEM_ECC_CNTL__DED_COUNT__SHIFT      = 0x0000000e;
    constexpr unsigned int VML2_MEM_ECC_CNTL__DSM_IRRITATOR_DATA__SHIFT = 0x00000006;
    constexpr unsigned int VML2_MEM_ECC_CNTL__ENABLE_ERROR_INJECT__SHIFT = 0x00000009;
    constexpr unsigned int VML2_MEM_ECC_CNTL__ENABLE_SINGLE_WRITE__SHIFT = 0x00000008;
    constexpr unsigned int VML2_MEM_ECC_CNTL__INJECT_DELAY__SHIFT   = 0x00000000;
    constexpr unsigned int VML2_MEM_ECC_CNTL__SEC_COUNT__SHIFT      = 0x0000000c;
    constexpr unsigned int VML2_MEM_ECC_CNTL__SELECT_INJECT_DELAY__SHIFT = 0x0000000b;
    constexpr unsigned int VML2_MEM_ECC_CNTL__TEST_FUE__SHIFT       = 0x00000011;
    constexpr unsigned int VML2_MEM_ECC_CNTL__WRITE_COUNTERS__SHIFT = 0x00000010;
    constexpr unsigned int VML2_MEM_ECC_INDEX__INDEX__SHIFT         = 0x00000000;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__DED_COUNT__SHIFT = 0x0000000e;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__DSM_IRRITATOR_DATA__SHIFT = 0x00000006;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__ENABLE_ERROR_INJECT__SHIFT = 0x00000009;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__ENABLE_SINGLE_WRITE__SHIFT = 0x00000008;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__INJECT_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__SEC_COUNT__SHIFT = 0x0000000c;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__SELECT_INJECT_DELAY__SHIFT = 0x0000000b;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__TEST_FUE__SHIFT = 0x00000011;
    constexpr unsigned int VML2_WALKER_MEM_ECC_CNTL__WRITE_COUNTERS__SHIFT = 0x00000010;
    constexpr unsigned int VML2_WALKER_MEM_ECC_INDEX__INDEX__SHIFT  = 0x00000000;
    constexpr unsigned int wbuf_DEBUG_DATA__cstate_3to0__SHIFT      = 0x0000000d;
    constexpr unsigned int wbuf_DEBUG_DATA__Reserved0__SHIFT        = 0x00000000;
    constexpr unsigned int wbuf_DEBUG_DATA__Reserved1__SHIFT        = 0x00000016;
    constexpr unsigned int wbuf_DEBUG_DATA__wr_pixel_ptr_nxt__SHIFT = 0x00000007;
} // namespace Vg20

